import { ApiDataSource, ApiDataSourceOptions } from './api-data-source';
import { Observable } from 'rxjs';
export interface BreadcrumbPartial {
    title: string;
    href?: string;
}
export interface ApiDataSourceWithBreadcrumbsOptions<RESPONSE_MODEL, DATA, REQUEST_MODEL> extends ApiDataSourceOptions<RESPONSE_MODEL, DATA, REQUEST_MODEL> {
    breadcrumbs: {
        loading: () => BreadcrumbPartial[];
        success: (result: DATA) => BreadcrumbPartial[];
        error?: (error: Error) => BreadcrumbPartial[];
        errorLabels?: {
            accessDenied: () => string;
            loadingFailed: () => string;
        };
    };
}
export declare class ApiDataSourceWithBreadcrumbs<REQUEST_MODEL, DATA, RESPONSE_MODEL = unknown, SERVICE = unknown, K extends keyof SERVICE = keyof SERVICE> extends ApiDataSource<REQUEST_MODEL, DATA, RESPONSE_MODEL, SERVICE, K> {
    readonly service: SERVICE;
    readonly methodName: K;
    protected breadcrumbMappers: any;
    protected readonly _breadcrumbAppendix$: Observable<any>;
    get breadCrumbAppendix$(): Observable<any>;
    constructor(service: SERVICE, methodName: K, options?: ApiDataSourceWithBreadcrumbsOptions<RESPONSE_MODEL, DATA, REQUEST_MODEL>);
    private defaultBreadcrumbErrorMapper;
}
//# sourceMappingURL=api-data-source-with-breadcrumbs.d.ts.map