import { ApiDataSource, ApiDataSourceOptions } from './api-data-source';
export interface ApiPollingDataSourceRequestOptions<DATA, ERROR = Error> {
    success?: (mappedResponse?: DATA) => boolean;
    error?: (error: ERROR) => boolean;
    timeout?: number;
}
export interface ApiPollingDataSourceOptions<RESPONSE_MODEL, DATA, REQUEST_MODEL> extends ApiDataSourceOptions<RESPONSE_MODEL, DATA, REQUEST_MODEL> {
    pollInterval: number;
}
export declare class ApiPollingDataSource<REQUEST_MODEL, DATA, RESPONSE_MODEL = unknown, SERVICE = unknown, K extends keyof SERVICE = keyof SERVICE> extends ApiDataSource<REQUEST_MODEL, DATA, RESPONSE_MODEL, SERVICE> {
    private readonly pollInterval;
    private interval;
    constructor(service: SERVICE, methodName: K, options?: ApiPollingDataSourceOptions<RESPONSE_MODEL, DATA, REQUEST_MODEL>);
    /**
     * Function will poll request until success or error callback returns true to complete
     */
    poll(model?: REQUEST_MODEL, options?: ApiPollingDataSourceRequestOptions<DATA>): void;
    private wrapHandler;
}
//# sourceMappingURL=api-polling-data-source.d.ts.map