import { BehaviorSubject, Observable } from 'rxjs';
/**
 * The base interface for DataSources
 *
 * @typeParam REQ_MODEL - Type of the model used to request data. Defaults to void.
 * @typeParam DATA - Type of the data the DataSource provides.
 * @typeParam ERR - Type of the error emitted. Defaults to Error
 */
export interface DataSourceBase<REQ_MODEL, DATA, ERR extends Error = Error> {
    readonly loading$: BehaviorSubject<boolean>;
    readonly result$: BehaviorSubject<DATA>;
    readonly error$: BehaviorSubject<ERR>;
    request(model: REQ_MODEL): Observable<DATA>;
}
//# sourceMappingURL=data-source-base.d.ts.map