import { DataSourceFactoryOptions, DataSourceOptions, MappableDataSourceFactoryOptions } from './data-source-options';
import { AbstractDataSource } from './abstract-data-source';
import { RequestMethod } from './types';
/**
 * I have to put this here
 *
 * @typeParam RESPONSE - Type of the provided response.
 * @typeParam DATA - Type of the data the DataSource provides. Defaults to the `RESPONSE`.
 * @typeParam REQ_MODEL - Type of the model used to request data. Defaults to `void`.
 */
export declare class DataSource<RESPONSE, DATA = RESPONSE, REQ_MODEL = void, OPTIONS extends DataSourceOptions<RESPONSE, DATA, REQ_MODEL> = DataSourceOptions<RESPONSE, DATA, REQ_MODEL>> extends AbstractDataSource<RESPONSE, DATA, REQ_MODEL, OPTIONS> {
    protected readonly options: OPTIONS;
    /**
     * Method to request data/results.
     */
    protected get requestMethod(): RequestMethod<REQ_MODEL, RESPONSE>;
    constructor(options: OPTIONS);
    static create<R, D, RM = void>(options: MappableDataSourceFactoryOptions<R, D, RM>): DataSource<R, D, RM>;
    static create<R, RM = void>(options: DataSourceFactoryOptions<R, RM>): DataSource<R, R, RM>;
}
//# sourceMappingURL=data-source.d.ts.map