import { OpUnitType } from 'dayjs';
export declare class DateUtil {
    static getMonthNames(format: 'long' | 'short' | 'narrow', locale: string): string[];
    static getWeekdayNames(format: 'long' | 'short' | 'narrow', locale?: string): string[];
    static getDate(dateString: string): Date;
    static isDateInvalid(dateString: string): boolean;
    static datesHaveSameDay(dateTimeOne: string, dateTimeTwo: string): boolean;
    static isDateBetweenTodayAndMonths(date: Date, months: number): boolean;
    static getNumberOfDaysBetween(date: Date): number;
    static getDateWithoutTimezoneOffset(date: Date): Date;
    static enableCustomParseFormatForDayJs(): void;
    static getTodayAddingYears(years: number): Date;
    static getStartOfDay(date: Date): Date;
    static getEndOfDay(date: Date): Date;
    static getStartOf(date: Date, unit: OpUnitType, weekStart?: number): Date;
    static getEndOf(date: Date, unit: OpUnitType, weekStart?: number): Date;
    static parseDate(value: string, allowedFormats: string[]): Date;
    static validateLocaleFormat(locale: string): string;
    static getHoursBetweenDates(startDate: Date, endDate: Date): number;
    static isDateWithin24Hours(dateString: string): boolean;
    static isToday(dateString: string): boolean;
    static hasPassed(dateString: string): boolean;
}
//# sourceMappingURL=date.util.d.ts.map