import { ChangeDetectorRef, ElementRef, OnDestroy, OnInit } from '@angular/core';
import { Subject } from 'rxjs';
import { LayoutService } from '../../services/layout.service';
import { BreakpointKey, ComponentBreakpointDefinition } from '../../types/breakpoints';
import * as i0 from "@angular/core";
export declare class ComponentBreakpointsDirective implements OnInit, OnDestroy {
    private readonly element;
    private readonly layoutService;
    private readonly cdr;
    sieCoreComponentBreakpoints: ComponentBreakpointDefinition;
    componentViewportChanged: Subject<BreakpointKey>;
    viewportClass: string;
    private resizeSubscription;
    private viewport;
    private previousViewport;
    constructor(element: ElementRef, layoutService: LayoutService, cdr: ChangeDetectorRef);
    private static getViewportClassName;
    ngOnInit(): void;
    ngOnDestroy(): void;
    private getComponentViewport;
    static ɵfac: i0.ɵɵFactoryDeclaration<ComponentBreakpointsDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<ComponentBreakpointsDirective, "[sieCoreComponentBreakpoints]", never, { "sieCoreComponentBreakpoints": { "alias": "sieCoreComponentBreakpoints"; "required": false; }; }, { "componentViewportChanged": "componentViewportChanged"; }, never, never, false, never>;
}
//# sourceMappingURL=component-breakpoints.directive.d.ts.map