import { Observable, Subject } from 'rxjs';
import { InternalBusEvent } from './internal-bus-event';
import { EventBusChannelConfig } from './event-bus-channel-config';
import { BusEvent } from './bus-event';
import * as i0 from "@angular/core";
export declare class EventBus<C extends EventBusChannelConfig = EventBusChannelConfig> {
    readonly events$: Subject<InternalBusEvent<unknown, unknown>>;
    emit<CH extends keyof C & string>(channel: CH, payload: C[CH]['data'], response?: (res: C[CH]['response']) => void): void;
    on$<CH extends keyof C & string>(channel?: CH): Observable<BusEvent<C[CH]['data'], C[CH]['response']>>;
    complete(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<EventBus<any>, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<EventBus<any>>;
}
//# sourceMappingURL=event-bus.d.ts.map