export interface ToggleableFeaturesItemConfig<F extends string = string> {
    name: F;
    enabled: boolean;
}
export type ToggleableFeaturesBulkConfig<F extends string = string> = ToggleableFeaturesItemConfig<F>[];
export declare class ToggleableFeatures<F extends string = string> {
    get enabledFeatures(): Set<F>;
    private featureWhitelist;
    constructor(featureConfig?: ToggleableFeaturesBulkConfig<F>);
    enableFeature(featureName: F): void;
    disableFeature(featureName: F): void;
    bulkConfig(featureConfig: ToggleableFeaturesBulkConfig<F>): void;
    clear(): void;
    isEnabled(featureName: F): boolean;
    intersect(toggleableFeatures: ToggleableFeatures<F>): void;
    mergeAndIntersect(toggleableFeatures: ToggleableFeatures<F>, featuresToIntersect: F[]): void;
}
//# sourceMappingURL=toggleable-features.d.ts.map