export type MinErrorMessageFactory = (opts: {
    min: number;
    actual: number;
}) => string;
export type MaxErrorMessageFactory = (opts: {
    max: number;
    actual: number;
}) => string;
export type LengthErrorMessageFactory = (opts: {
    requiredLength: number;
    actualLength: number;
}) => string;
export type PatternErrorMessageFactory = (opts: {
    requiredPattern: number;
    actualValue: number;
}) => string;
export interface ControlErrorMessages {
    min?: string | MinErrorMessageFactory;
    max?: string | MaxErrorMessageFactory;
    required?: string;
    email?: string;
    minlength?: string | LengthErrorMessageFactory;
    maxlength?: string | LengthErrorMessageFactory;
    pattern?: string | PatternErrorMessageFactory;
}
//# sourceMappingURL=control-error-messages.d.ts.map