import { RegionAndLanguageApiModel } from '../region-and-language-api.model';
import { AppRegion } from './app-region';
import { Locale } from '../services/locale.service';
export declare class Region {
    regions: AppRegion[];
    private static readonly visibleRolloutStatuses;
    private static readonly permittedRolloutStatuses;
    currentRegion: AppRegion;
    get defaultRegion(): AppRegion;
    private readonly _defaultRegion;
    constructor(regions?: AppRegion[]);
    static createRegions(regionLanguagesResponse: RegionAndLanguageApiModel): Region;
    private static isVisibleRolloutStatus;
    private static isPermittedRolloutStatus;
    translateRegionNames(translateCallback: (regionCode: string) => string): void;
    translateLanguageNames(translateCallback: (languageCode: string) => string): void;
    sortRegions(): void;
    sortLanguages(): void;
    setFlags(setFlagCallback: (flagSvgName: string) => string): void;
    getSupportedRegionByCode(regionCode: string): AppRegion;
    isRegionSupported(regionCode: string): boolean;
    getDefaultLocale(): Locale;
    private moveGlobalToFront;
}
//# sourceMappingURL=region.d.ts.map