export type PageSizeOptions = number[];
export interface PaginationOptions {
    pageSize?: number;
    pageSizeOptions: PageSizeOptions;
    totalEntries?: number;
    startPage?: number;
    activePage?: number;
}
export declare abstract class BaseListPagination {
    get pageSize(): number;
    set pageSize(value: number);
    get defaultPageSize(): number;
    get activePage(): number;
    set activePage(value: number);
    get startPage(): number;
    set startPage(value: number);
    get totalEntries(): number;
    set totalEntries(value: number);
    get totalPages(): number;
    set totalPages(value: number);
    get pageSizeOptionIndex(): number;
    set pageSizeOptionIndex(value: number);
    get pageSizeOptions(): PageSizeOptions;
    set pageSizeOptions(value: PageSizeOptions);
    private _activePage;
    private _startPage;
    private _totalEntries;
    private _totalPages;
    private _pageSizeOptions;
    private _pageSizeOptionIndex;
    constructor(options?: PaginationOptions);
    calculateTotalPages(): void;
    resetActiveToStartPage(): void;
}
//# sourceMappingURL=base-list-pagination.d.ts.map