import { PipeTransform } from '@angular/core';
import { LocaleService } from '../locale/services/locale.service';
import { Observable } from 'rxjs';
import * as i0 from "@angular/core";
declare abstract class LocalizedRouteBase {
    protected readonly localeService: LocaleService;
    protected constructor(localeService: LocaleService);
    protected getLocale(fallbackLocale?: string): string;
}
declare type LocalizedRouteCommands = string[] | string;
export declare class LocalizedRoutePipe implements PipeTransform {
    private readonly localeService;
    constructor(localeService: LocaleService);
    transform(commands: LocalizedRouteCommands): LocalizedRouteCommands;
    private getLocale;
    static ɵfac: i0.ɵɵFactoryDeclaration<LocalizedRoutePipe, never>;
    static ɵpipe: i0.ɵɵPipeDeclaration<LocalizedRoutePipe, "localizedRoute", true>;
}
export declare class LocalizedRouteObservablePipe extends LocalizedRouteBase implements PipeTransform {
    protected readonly localeService: LocaleService;
    constructor(localeService: LocaleService);
    transform(commands: LocalizedRouteCommands): Observable<LocalizedRouteCommands>;
    static ɵfac: i0.ɵɵFactoryDeclaration<LocalizedRouteObservablePipe, never>;
    static ɵpipe: i0.ɵɵPipeDeclaration<LocalizedRouteObservablePipe, "localizedRoute$", true>;
}
export {};
//# sourceMappingURL=localized-route.pipe.d.ts.map