import { ChangeDetectorRef, ElementRef, QueryList } from '@angular/core';
import { LayoutService } from '../services/layout.service';
import * as i0 from "@angular/core";
export interface SelectableItems {
    selectableItems: QueryList<ElementRef>;
}
export declare abstract class SelectableWithUnderlineDirective implements SelectableItems {
    cd: ChangeDetectorRef;
    layoutService: LayoutService;
    set closeable(value: boolean);
    get closeable(): boolean;
    selectableItems: QueryList<ElementRef>;
    focusedItemIndex: number;
    underlineStyle: {
        width: string;
        left: string;
    };
    set activeItemIndex(value: number);
    get activeItemIndex(): number;
    protected _activeItemIndex: number;
    protected keyboardNavigation: boolean;
    private _closeable;
    private previousActiveItemIndex;
    protected constructor(cd: ChangeDetectorRef, layoutService: LayoutService);
    focusIn(): void;
    focusOut(): void;
    mouseEnterItem(index: number): void;
    mouseLeftContainer(moveUnderline?: boolean): void;
    moveUnderlineToItem(index: number, force?: boolean): void;
    itemClicked(index: number, event?: Event): void;
    activeItemChanged(): void;
    protected getFocusableIndex(newIndex: number): number;
    static ɵfac: i0.ɵɵFactoryDeclaration<SelectableWithUnderlineDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<SelectableWithUnderlineDirective, never, never, { "closeable": { "alias": "closeable"; "required": false; }; }, {}, never, never, false, never>;
}
//# sourceMappingURL=selectable-with-underline.d.ts.map