import { NavigationExtras, Router, RouterEvent, UrlTree } from '@angular/router';
import { LocaleService } from '../locale/services/locale.service';
import { Observable } from 'rxjs';
import { AppInitService } from '../app/init/app-init.service';
import { UrlService } from './url.service';
import * as i0 from "@angular/core";
export declare class RouterService {
    private readonly router;
    private readonly localeService;
    private readonly appInit;
    private readonly urlService;
    /**
     * Exposing an observable router event. Emitted on Navigation End if the SPA is initialized.
     * In case of the SPA not yet initialized while the Navigation End was emitted, it will be done so as soon
     * as the SPA is initialized.
     */
    readonly initializedNavigationEnd$: Observable<RouterEvent>;
    constructor(router: Router, localeService: LocaleService, appInit: AppInitService, urlService: UrlService);
    getLastRouteSegment(): string;
    getLastSegment(url: string): string;
    getLocalizedRoute(commands: unknown[], navigationExtras?: NavigationExtras, fallbackLocale?: string): string;
    getLocalizedRouteUrlTree(commands: unknown[], navigationExtras?: NavigationExtras, fallbackLocale?: string): UrlTree;
    navigateToLocalizedRoute(commands: unknown[], navigationExtras?: NavigationExtras, fallbackLocale?: string): Promise<boolean>;
    navigateByLocalizedUrl(path: string, fallbackLocale?: string): Promise<boolean>;
    navigateToInternalUrl(href: string): Promise<boolean>;
    private getLocale;
    static ɵfac: i0.ɵɵFactoryDeclaration<RouterService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<RouterService>;
}
//# sourceMappingURL=router.service.d.ts.map