import { RendererFactory2 } from '@angular/core';
import { Observable } from 'rxjs';
import * as i0 from "@angular/core";
export declare enum ScriptState {
    Loading = 0,
    Loaded = 1
}
interface ScriptConfig {
    type: 'css' | 'js';
    async?: boolean;
}
export declare class ScriptService {
    private readonly document;
    private readonly renderer;
    private readonly scriptStates;
    constructor(rendererFactory: RendererFactory2, document: Document);
    appendScript(url: string, config?: ScriptConfig): HTMLScriptElement;
    appendUniqueScript(url: string, config: ScriptConfig): Observable<ScriptState>;
    appendUniqueScriptAsPromise(url: string, config?: ScriptConfig): Promise<void>;
    static ɵfac: i0.ɵɵFactoryDeclaration<ScriptService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<ScriptService>;
}
export {};
//# sourceMappingURL=script.service.d.ts.map