import { Subject } from 'rxjs';
import { PlainObject } from '../types';
import * as i0 from "@angular/core";
export interface TrackingCategory {
    [key: string]: string | number | Array<unknown>;
}
export interface TrackingEvent {
    categories: PlainObject<TrackingCategory>;
}
export interface CustomTrackingEvent {
    action: string;
    data?: PlainObject<unknown>;
    clickTarget?: HTMLElement | EventTarget;
}
interface TrackingListener {
    observer: (event: TrackingEvent) => void;
    keys: string[];
}
export declare class TrackingService {
    listeners: TrackingListener[];
    categories: PlainObject<TrackingCategory>;
    parts: PlainObject<TrackingCategory>;
    readonly directCustomTracking$: Subject<CustomTrackingEvent>;
    clearListeners(): void;
    clearCategories(): void;
    clearParts(): void;
    subscribeForTrackingData(keys: string[], observer: (event: TrackingEvent) => void): void;
    pushCustomEvent(event: CustomTrackingEvent): void;
    pushPartOfData(categoryName: string, part: number, amountOfParts: number, category: TrackingCategory): boolean;
    pushData(categoryName: string, category: TrackingCategory): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<TrackingService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<TrackingService>;
}
export {};
//# sourceMappingURL=tracking.service.d.ts.map