import { Params } from '@angular/router';
import { Locale } from '../locale/services/locale.service';
import { AppRoutes } from '../types/app-routes.enum';
import { PlainObject } from '../types/plain-object.type';
import * as i0 from "@angular/core";
export declare class UrlService {
    static readonly URL_PATH_SEPARATOR = "/";
    static readonly URL_PARAMETER_START_SEPARATOR = "?";
    private readonly VALID_URL_LOCALE_REGEXP;
    private readonly location;
    static getQueryParams(paramsStr: string): Params;
    getCurrentQueryParams(): Params;
    createUrlFromPath(path: string): URL;
    getQueryParamsFromPath(path: string): Params;
    isAuthCallbackUrl(): boolean;
    isSilentAuthCallbackUrl(): boolean;
    isUrl(url: string, route: AppRoutes): boolean;
    isInternalUrl(url: string): boolean;
    isLocalizedUrl(url: string): boolean;
    isChatbotUrl(): boolean;
    getUrlPathnameAndParams(url: string): string;
    getLocaleFromCurrentUrl(): Locale;
    getLocaleFromUrl(url: string): Locale;
    getUrlLocale(locale: Locale): string;
    getDefaultUrl(locale: Locale): string;
    getPathWithLocale(locale: Locale, path: string): string;
    getRouteWithLocale(locale: Locale, route: AppRoutes): string;
    getUrlWithLocale(url: string, parameters: string, locale: Locale, withParams?: boolean): string;
    splitUrlIntoPathAndSearch(url: string): {
        path: string;
        search: string;
    };
    stripUrlParameters(url: string): string;
    getCurrentUrlWithLocale(locale: Locale, withParams?: boolean): string;
    getCurrentHref(): string;
    getCurrentQueryParamsAsArray(): PlainObject[];
    private isValidUrlLocale;
    static ɵfac: i0.ɵɵFactoryDeclaration<UrlService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<UrlService>;
}
//# sourceMappingURL=url.service.d.ts.map