import { SieWindowMessageEvent, SieWindowMessageType } from './sie-window-message-event';
export interface ReceivedSieWindowMessage<T> {
    id: string;
    channel: string;
    payload: T;
    source?: Window;
}
export interface SendableSieWindowMessage<T> {
    channel: string;
    payload: T;
    target: Window;
}
export declare class SieWindowMessage<T = unknown, R = unknown> {
    readonly id: string;
    readonly channel: string;
    readonly type: SieWindowMessageType;
    get payload(): T;
    get ackChannel(): string | undefined;
    get responseChannel(): string | undefined;
    private readonly _payload;
    readonly source?: Window;
    readonly target?: Window;
    private readonly messageTypeChannelSuffixMapping;
    private acknowledged;
    private responded;
    constructor(options: ReceivedSieWindowMessage<T>);
    constructor(options: SendableSieWindowMessage<T>);
    static isSieWindowMessageEvent<T>(message: SieWindowMessageEvent<T>): boolean;
    static fromWindowMessageEvent<P>(event: SieWindowMessageEvent<P>): SieWindowMessage<P>;
    send(): void;
    acknowledge(): void;
    respond(response: R): void;
}
//# sourceMappingURL=sie-window-message.d.ts.map