import { BusEvent, EventBus, EventBusTypes } from '../../events/bus';
import { SieWindowMessage } from './sie-window-message';
import { Observable } from 'rxjs';
import * as i0 from "@angular/core";
export interface WindowMessageEventBusChannelConfig {
    '': EventBusTypes<SieWindowMessage, unknown>;
    '*': EventBusTypes<SieWindowMessage, unknown>;
    [key: string]: EventBusTypes<SieWindowMessage, unknown>;
}
export interface WindowMessagingPostOptions<C extends WindowMessageEventBusChannelConfig, CH extends keyof C & string> {
    target: Window;
    channel: CH;
    payload?: C[CH]['data']['payload'];
}
export interface WindowMessagingPostWithResponseOptions<C extends WindowMessageEventBusChannelConfig, CH extends keyof C & string> extends WindowMessagingPostOptions<C, CH> {
    response: (res: C[CH]['response']) => void;
    responseError: (error: Error) => void;
    responseTimeout?: number;
}
export declare class WindowMessagingService<C extends WindowMessageEventBusChannelConfig = WindowMessageEventBusChannelConfig> extends EventBus<C> {
    private readonly ackTimeout;
    private readonly ackTimeoutError;
    private readonly defaultResponseTimout;
    private readonly responseTimeoutError;
    constructor();
    private listen;
    postMessage<CH extends keyof C & string>(options: WindowMessagingPostOptions<C, CH>): Promise<void>;
    postMessage<CH extends keyof C & string>(options: WindowMessagingPostWithResponseOptions<C, CH>): Promise<void>;
    on$<CH extends keyof C & string>(channel?: CH, window?: Window): Observable<BusEvent<C[CH]['data'], C[CH]['response']>>;
    private isSameOrigin;
    static ɵfac: i0.ɵɵFactoryDeclaration<WindowMessagingService<any>, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<WindowMessagingService<any>>;
}
//# sourceMappingURL=window-messaging.service.d.ts.map