import { ParamMap } from '@angular/router';
import { UrlParamValidatorWithHandler } from './validation/url-param-validator.type';
declare type UrlParametersConstructor<T extends UrlParameters> = new (params: ParamMap) => T;
export declare abstract class UrlParameters<Keys extends string = string> {
    queryParams: ParamMap;
    get hasValidationFixes(): boolean;
    get keys(): string[];
    protected params: Map<string, string>;
    protected defaults: Map<Keys, string>;
    protected order: Keys[];
    protected parameterWhiteList: Array<string>;
    protected validators: Map<Keys, Array<UrlParamValidatorWithHandler<Keys>>>;
    protected caseInsensitive: Keys[];
    protected _hasValidationFixes: boolean;
    constructor(urlParameters: ParamMap);
    static createCaseInsensitive<T extends UrlParameters>(this: UrlParametersConstructor<T>, params: ParamMap): T;
    refresh(urlParameters: ParamMap): void;
    private refreshParams;
    get(key: string): string;
    setDefault(key: Keys, value: string): UrlParameters<Keys>;
    addValue(key: string, value: string, canHaveMultipleValues: boolean): void;
    replaceValue(key: string, value: string): void;
    removeValue(key: string, value: string, canHaveMultipleValues: boolean): void;
    hasParameterWithExactThisValues(key: string, values: Array<string>): boolean;
    validate(): void;
    sort(): boolean;
    removeUnknownParams(): boolean;
    toUrlParamsObject(): {
        [key: string]: string;
    };
    sanitizeCaseInsensitiveKeys(): void;
    protected fallbackToDefault(key: Keys): boolean;
    private parameterValueExists;
    private parameterExists;
}
export {};
//# sourceMappingURL=url-parameters.d.ts.map