import * as i0 from '@angular/core';
import { Injectable, Inject, Component, ChangeDetectionStrategy, Optional, Input, Output, HostBinding, NgModule } from '@angular/core';
import { BehaviorSubject, Subject } from 'rxjs';
import { DOCUMENT } from '@angular/common';
import { DomUtil } from '@siemens/core';

/**
 * Enumeration to define all possible icons. Each icon is backed via a mapping to an svg file.
 */
var SieIcon;
(function (SieIcon) {
    SieIcon["AcknowledgeEvents"] = "AcknowledgeEvents";
    SieIcon["Add"] = "Add";
    SieIcon["Advanced"] = "Advanced";
    SieIcon["AdvancedFilled"] = "AdvancedFilled";
    SieIcon["Apps"] = "Apps";
    SieIcon["ArrowDoubleLeft"] = "ArrowDoubleLeft";
    SieIcon["ArrowDoubleRight"] = "ArrowDoubleRight";
    SieIcon["ArrowDown"] = "ArrowDown";
    SieIcon["ArrowLeft"] = "ArrowLeft";
    SieIcon["ArrowRight"] = "ArrowRight";
    SieIcon["ArrowToTop"] = "ArrowToTop";
    SieIcon["ArrowUp"] = "ArrowUp";
    SieIcon["Attach"] = "Attach";
    SieIcon["AudioDescription1"] = "AudioDescription1";
    SieIcon["AudioDescription2"] = "AudioDescription2";
    SieIcon["Badge"] = "Badge";
    SieIcon["BadgeCreateBeginner"] = "BadgeCreateBeginner";
    SieIcon["BadgeCreateBronze"] = "BadgeCreateBronze";
    SieIcon["BadgeCreateGold"] = "BadgeCreateGold";
    SieIcon["BadgeCreateSilver"] = "BadgeCreateSilver";
    SieIcon["BadgePlaceholder"] = "BadgePlaceholder";
    SieIcon["BadgeRateBeginner"] = "BadgeRateBeginner";
    SieIcon["BadgeRateBronze"] = "BadgeRateBronze";
    SieIcon["BadgeRateGold"] = "BadgeRateGold";
    SieIcon["BadgeRateSilver"] = "BadgeRateSilver";
    SieIcon["BadgeReadBeginner"] = "BadgeReadBeginner";
    SieIcon["BadgeReadBronze"] = "BadgeReadBronze";
    SieIcon["BadgeReadGold"] = "BadgeReadGold";
    SieIcon["BadgeReadSilver"] = "BadgeReadSilver";
    SieIcon["BadgeReportBeginner"] = "BadgeReportBeginner";
    SieIcon["BadgeReportBronze"] = "BadgeReportBronze";
    SieIcon["BadgeReportGold"] = "BadgeReportGold";
    SieIcon["BadgeReportSilver"] = "BadgeReportSilver";
    SieIcon["BarChart"] = "BarChart";
    SieIcon["BiliBili"] = "BiliBili";
    SieIcon["BrowseAll"] = "BrowseAll";
    SieIcon["Buildings"] = "Buildings";
    SieIcon["Calendar"] = "Calendar";
    SieIcon["Capacity"] = "Capacity";
    SieIcon["Cax"] = "Cax";
    SieIcon["Chat"] = "Chat";
    SieIcon["Chat2"] = "Chat2";
    SieIcon["ChatbotButton"] = "ChatbotButton";
    SieIcon["ChatbotButtonActive"] = "ChatbotButtonActive";
    SieIcon["ChatbotButtonDisabled"] = "ChatbotButtonDisabled";
    SieIcon["ChatbotButtonHover"] = "ChatbotButtonHover";
    SieIcon["ChatbotButtonVariantB"] = "ChatbotButtonVariantB";
    SieIcon["ChatbotButtonVariantBActive"] = "ChatbotButtonVariantBActive";
    SieIcon["ChatbotButtonVariantBHover"] = "ChatbotButtonVariantBHover";
    SieIcon["ChatbotButtonVariantBWithLines"] = "ChatbotButtonVariantBWithLines";
    SieIcon["ChatbotButtonNew"] = "ChatbotButtonNew";
    SieIcon["ChatbotButtonNewActive"] = "ChatbotButtonNewActive";
    SieIcon["ChatbotButtonNewDisabled"] = "ChatbotButtonNewDisabled";
    SieIcon["ChatbotButtonNewHover"] = "ChatbotButtonNewHover";
    SieIcon["CheckMark"] = "CheckMark";
    SieIcon["CheckMarkBenefits"] = "CheckMarkBenefits";
    SieIcon["CheckMarkSmall"] = "CheckMarkSmall";
    SieIcon["Clock"] = "Clock";
    SieIcon["Close"] = "Close";
    SieIcon["CloseSmall"] = "CloseSmall";
    SieIcon["Configure"] = "Configure";
    SieIcon["Control"] = "Control";
    SieIcon["Copy"] = "Copy";
    SieIcon["Crown"] = "Crown";
    SieIcon["CrownFilled"] = "CrownFilled";
    SieIcon["Cut"] = "Cut";
    SieIcon["DCSEmptyState"] = "DCSEmptyState";
    SieIcon["Delete"] = "Delete";
    SieIcon["Diamond"] = "Diamond";
    SieIcon["Down"] = "Down";
    SieIcon["DiamondFilled"] = "DiamondFilled";
    SieIcon["Dislike"] = "Dislike";
    SieIcon["Doc"] = "Doc";
    SieIcon["DocLabel"] = "DocLabel";
    SieIcon["DocumentSuccess"] = "DocumentSuccess";
    SieIcon["DocumentSuccessFilled"] = "DocumentSuccessFilled";
    SieIcon["Documentation"] = "Documentation";
    SieIcon["Download"] = "Download";
    SieIcon["Drag"] = "Drag";
    SieIcon["DragLines"] = "DragLines";
    SieIcon["Dropdown"] = "Dropdown";
    SieIcon["DropdownLarge"] = "DropdownLarge";
    SieIcon["Edit"] = "Edit";
    SieIcon["Email"] = "Email";
    SieIcon["ErrorFilled"] = "ErrorFilled";
    SieIcon["Etim"] = "Etim";
    SieIcon["Explore"] = "Explore";
    SieIcon["ExploreFilled"] = "ExploreFilled";
    SieIcon["Ext"] = "Ext";
    SieIcon["Facebook"] = "Facebook";
    SieIcon["File"] = "File";
    SieIcon["Filter"] = "Filter";
    SieIcon["Folder"] = "Folder";
    SieIcon["FolderNew"] = "FolderNew";
    SieIcon["FolderOpen"] = "FolderOpen";
    SieIcon["Forum"] = "Forum";
    SieIcon["Fullscreen"] = "Fullscreen";
    SieIcon["FullscreenExit"] = "FullscreenExit";
    SieIcon["Globe"] = "Globe";
    SieIcon["Heart"] = "Heart";
    SieIcon["HeartFilled"] = "HeartFilled";
    SieIcon["History"] = "History";
    SieIcon["Home"] = "Home";
    SieIcon["HomeSmall"] = "HomeSmall";
    SieIcon["HourGlass"] = "HourGlass";
    SieIcon["Image"] = "Image";
    SieIcon["Information"] = "Information";
    SieIcon["InformationFilled"] = "InformationFilled";
    SieIcon["InformationPackage"] = "InformationPackage";
    SieIcon["Instagram"] = "Instagram";
    SieIcon["InteractionClick"] = "InteractionClick";
    SieIcon["InteractionTouch"] = "InteractionTouch";
    SieIcon["LevelUp"] = "LevelUp";
    SieIcon["Lightbulb"] = "Lightbulb";
    SieIcon["Like"] = "Like";
    SieIcon["LikeFilled"] = "LikeFilled";
    SieIcon["LineChart"] = "LineChart";
    SieIcon["Link"] = "Link";
    SieIcon["Linkedin"] = "Linkedin";
    SieIcon["LocationPin"] = "LocationPin";
    SieIcon["LockSmall"] = "LockSmall";
    SieIcon["Locked"] = "Locked";
    SieIcon["LogIn"] = "LogIn";
    SieIcon["LogOut"] = "LogOut";
    SieIcon["Left"] = "Left";
    SieIcon["Maximize"] = "Maximize";
    SieIcon["Menu"] = "Menu";
    SieIcon["Microphone"] = "Microphone";
    SieIcon["Minimize"] = "Minimize";
    SieIcon["Minus"] = "Minus";
    SieIcon["Monitor"] = "Monitor";
    SieIcon["More"] = "More";
    SieIcon["MoreHorizontal"] = "MoreHorizontal";
    SieIcon["NavigationLeft"] = "NavigationLeft";
    SieIcon["NavigationRight"] = "NavigationRight";
    SieIcon["Newton_productCatalogue"] = "Newton_productCatalogue";
    SieIcon["NoAccess"] = "NoAccess";
    SieIcon["NotGenerated"] = "NotGenerated";
    SieIcon["Notification"] = "Notification";
    SieIcon["NotificationFilled"] = "NotificationFilled";
    SieIcon["Optimize"] = "Optimize";
    SieIcon["Paste"] = "Paste";
    SieIcon["Pause"] = "Pause";
    SieIcon["Pdf"] = "Pdf";
    SieIcon["PeopleGroup"] = "PeopleGroup";
    SieIcon["PeopleGroupFilled"] = "PeopleGroupFilled";
    SieIcon["Phone"] = "Phone";
    SieIcon["Picture"] = "Picture";
    SieIcon["PieChartSmall"] = "PieChartSmall";
    SieIcon["Pin"] = "Pin";
    SieIcon["Plant"] = "Plant";
    SieIcon["Play"] = "Play";
    SieIcon["Plus"] = "Plus";
    SieIcon["PlusSmall"] = "PlusSmall";
    SieIcon["Ppt"] = "Ppt";
    SieIcon["Print"] = "Print";
    SieIcon["Question"] = "Question";
    SieIcon["Quotation"] = "Quotation";
    SieIcon["QuotationGradient"] = "QuotationGradient";
    SieIcon["Redo"] = "Redo";
    SieIcon["Refresh"] = "Refresh";
    SieIcon["Region"] = "Region";
    SieIcon["RemoveAccess"] = "RemoveAccess";
    SieIcon["Reply"] = "Reply";
    SieIcon["Reset"] = "Reset";
    SieIcon["Right"] = "Right";
    SieIcon["Search"] = "Search";
    SieIcon["SearchSmall"] = "SearchSmall";
    SieIcon["Send"] = "Send";
    SieIcon["Service"] = "Service";
    SieIcon["Settings"] = "Settings";
    SieIcon["Share"] = "Share";
    SieIcon["Shipping"] = "Shipping";
    SieIcon["ShoppingCart"] = "ShoppingCart";
    SieIcon["Shuffle"] = "Shuffle";
    SieIcon["SidePanelClose"] = "SidePanelClose";
    SieIcon["SidePanelOpen"] = "SidePanelOpen";
    SieIcon["SieLogoPetrolRgb"] = "SieLogoPetrolRgb";
    SieIcon["SieLogoWhiteRgb"] = "SieLogoWhiteRgb";
    SieIcon["SieShape1stLevelMovingForward"] = "SieShape1stLevelMovingForward";
    SieIcon["SieLogoBlackRgb"] = "SieLogoBlackRgb";
    SieIcon["SiePortalEmptyStatePendingInvitations"] = "SiePortalEmptyStatePendingInvitations";
    SieIcon["Sieportal2dDrawings"] = "Sieportal2dDrawings";
    SieIcon["Sieportal3dDrawings"] = "Sieportal3dDrawings";
    SieIcon["SieportalAddFile"] = "SieportalAddFile";
    SieIcon["SieportalAltText"] = "SieportalAltText";
    SieIcon["SieportalApplicationExamples"] = "SieportalApplicationExamples";
    SieIcon["SieportalArrowBig"] = "SieportalArrowBig";
    SieIcon["SieportalBadgeError"] = "SieportalBadgeError";
    SieIcon["SieportalBadgeInfo"] = "SieportalBadgeInfo";
    SieIcon["SieportalBadgeSuccess"] = "SieportalBadgeSuccess";
    SieIcon["SieportalBadgeWarning"] = "SieportalBadgeWarning";
    SieIcon["SieportalBookmarkFilled"] = "SieportalBookmarkFilled";
    SieIcon["SieportalBookmarkOutline"] = "SieportalBookmarkOutline";
    SieIcon["SieportalCatalogue"] = "SieportalCatalogue";
    SieIcon["SieportalCharacteristics"] = "SieportalCharacteristics";
    SieIcon["SieportalCircuit"] = "SieportalCircuit";
    SieIcon["SieportalClockLoad"] = "SieportalClockLoad";
    SieIcon["SieportalCommonArticle"] = "SieportalCommonArticle";
    SieIcon["SieportalCompatibility"] = "SieportalCompatibility";
    SieIcon["SieportalConnection"] = "SieportalConnection";
    SieIcon["SieportalDataHub"] = "SieportalDataHub";
    SieIcon["SieportalDataHubAdd"] = "SieportalDataHubAdd";
    SieIcon["SieportalDocumentNew"] = "SieportalDocumentNew";
    SieIcon["SieportalDocumentTemplate"] = "SieportalDocumentTemplate";
    SieIcon["SiePortalDownloadArchiveSoftware"] = "SiePortalDownloadArchiveSoftware";
    SieIcon["SieportalEPlan"] = "SieportalEPlan";
    SieIcon["SieportalEducation"] = "SieportalEducation";
    SieIcon["SieportalEducationFilled"] = "SieportalEducationFilled";
    SieIcon["SieportalElearning"] = "SieportalElearning";
    SieIcon["SieportalEmptyState404Simple"] = "SieportalEmptyState404Simple";
    SieIcon["SieportalEmptyStateCards"] = "SieportalEmptyStateCards";
    SieIcon["SieportalEmptyStateCardsArrow"] = "SieportalEmptyStateCardsArrow";
    SieIcon["SieportalEmptyStateCardsHappy"] = "SieportalEmptyStateCardsHappy";
    SieIcon["SieportalEmptyStateCardsWaiting"] = "SieportalEmptyStateCardsWaiting";
    SieIcon["SieportalEmptyStateContents"] = "SieportalEmptyStateContents";
    SieIcon["SieportalEmptyStateContractUnavailable"] = "SieportalEmptyStateContractUnavailable";
    SieIcon["SieportalEmptyStateDiagram"] = "SieportalEmptyStateDiagram";
    SieIcon["SieportalEmptyStateDiagramSmall"] = "SieportalEmptyStateDiagramSmall";
    SieIcon["SieportalEmptyStateDownload"] = "SieportalEmptyStateDownload";
    SieIcon["SieportalEmptyStateErrorAccount"] = "SieportalEmptyStateErrorAccount";
    SieIcon["SieportalEmptyStateFavorites"] = "SieportalEmptyStateFavorites";
    SieIcon["SieportalEmptyStateIllustrationInviteUsersError"] = "SieportalEmptyStateIllustrationInviteUsersError";
    SieIcon["SieportalEmptyStateJointControllerAgreementNotAllowed"] = "SieportalEmptyStateJointControllerAgreementNotAllowed";
    SieIcon["SieportalEmptyStateMaintenanceDates"] = "SieportalEmptyStateMaintenanceDates";
    SieIcon["SieportalEmptyStateNoAccount"] = "SieportalEmptyStateNoAccount";
    SieIcon["SieportalEmptyStateNoBusinessProfile"] = "SieportalEmptyStateNoBusinessProfile";
    SieIcon["SieportalEmptyStateNoContractsFound"] = "SieportalEmptyStateNoContractsFound";
    SieIcon["SieportalEmptyStateNoConversation"] = "SieportalEmptyStateNoConversation";
    SieIcon["SieportalEmptyStateNoConversations"] = "SieportalEmptyStateNoConversations";
    SieIcon["SieportalEmptyStateNoData"] = "SieportalEmptyStateNoData";
    SieIcon["SieportalEmptyStateNoDataSmall"] = "SieportalEmptyStateNoDataSmall";
    SieIcon["SieportalEmptyStateNoQuery"] = "SieportalEmptyStateNoQuery";
    SieIcon["SieportalEmptyStateNoSearchResults"] = "SieportalEmptyStateNoSearchResults";
    SieIcon["SieportalEmptyStateNotification"] = "SieportalEmptyStateNotification";
    SieIcon["SieportalEmptyStatePackage"] = "SieportalEmptyStatePackage";
    SieIcon["SieportalEmptyStatePackageShare"] = "SieportalEmptyStatePackageShare";
    SieIcon["SieportalEmptyStatePeoplePicker"] = "SieportalEmptyStatePeoplePicker";
    SieIcon["SieportalEmptyStatePlatformPromotion"] = "SieportalEmptyStatePlatformPromotion";
    SieIcon["SieportalEmptyStateRecentlyViewed"] = "SieportalEmptyStateRecentlyViewed";
    SieIcon["SieportalEmptyStateRecommendation"] = "SieportalEmptyStateRecommendation";
    SieIcon["SieportalEmptyStateSearches"] = "SieportalEmptyStateSearches";
    SieIcon["SieportalEmptyStateSnoozedNotifications"] = "SieportalEmptyStateSnoozedNotifications";
    SieIcon["SieportalEmptyStateTable"] = "SieportalEmptyStateTable";
    SieIcon["SieportalEmptyStateUserPermissions"] = "SieportalEmptyStateUserPermissions";
    SieIcon["SieportalEmptyStateWizardProduct"] = "SieportalEmptyStateWizardProduct";
    SieIcon["SieportalEmptyStateTechnicalData"] = "SieportalEmptyStateTechnicalData";
    SieIcon["SieportalExtHeaderWithBorderTag"] = "SieportalExtHeaderWithBorderTag";
    SieIcon["SieportalExtHeaderWithDarkBorderTag"] = "SieportalExtHeaderWithDarkBorderTag";
    SieIcon["SieportalExtHeaderWithoutBorderTag"] = "SieportalExtHeaderWithoutBorderTag";
    SieIcon["SieportalExtIdleWithBorderTag"] = "SieportalExtIdleWithBorderTag";
    SieIcon["SieportalExtIdleWithoutBorderTag"] = "SieportalExtIdleWithoutBorderTag";
    SieIcon["SieportalExtMiniWithBorderTag"] = "SieportalExtMiniWithBorderTag";
    SieIcon["SieportalExtMiniWithoutBorderTag"] = "SieportalExtMiniWithoutBorderTag";
    SieIcon["SieportalFeedback"] = "SieportalFeedback";
    SieIcon["SieportalHelp"] = "SieportalHelp";
    SieIcon["SieportalHidePassword"] = "SieportalHidePassword";
    SieIcon["SieportalIntExtHeaderWithBorderTag"] = "SieportalIntExtHeaderWithBorderTag";
    SieIcon["SieportalIntExtHeaderWithDarkBorderTag"] = "SieportalIntExtHeaderWithDarkBorderTag";
    SieIcon["SieportalIntExtHeaderWithoutBorderTag"] = "SieportalIntExtHeaderWithoutBorderTag";
    SieIcon["SieportalIntExtIdleWithBorderTag"] = "SieportalIntExtIdleWithBorderTag";
    SieIcon["SieportalIntExtIdleWithoutBorderTag"] = "SieportalIntExtIdleWithoutBorderTag";
    SieIcon["SieportalIntExtMiniWithBorderTag"] = "SieportalIntExtMiniWithBorderTag";
    SieIcon["SieportalIntExtMiniWithoutBorderTag"] = "SieportalIntExtMiniWithoutBorderTag";
    SieIcon["SieportalIntHeaderWithBorderTag"] = "SieportalIntHeaderWithBorderTag";
    SieIcon["SieportalIntHeaderWithDarkBorderTag"] = "SieportalIntHeaderWithDarkBorderTag";
    SieIcon["SieportalIntHeaderWithoutBorderTag"] = "SieportalIntHeaderWithoutBorderTag";
    SieIcon["SieportalIntIdleWithBorderTag"] = "SieportalIntIdleWithBorderTag";
    SieIcon["SieportalIntIdleWithoutBorderTag"] = "SieportalIntIdleWithoutBorderTag";
    SieIcon["SieportalIntMiniWithBorderTag"] = "SieportalIntMiniWithBorderTag";
    SieIcon["SieportalIntMiniWithoutBorderTag"] = "SieportalIntMiniWithoutBorderTag";
    SieIcon["SieportalMaintenanceError"] = "SieportalMaintenanceError";
    SieIcon["SieportalMobileApps"] = "SieportalMobileApps";
    SieIcon["SieportalMorePortrait"] = "SieportalMorePortrait";
    SieIcon["SieportalNone"] = "SieportalNone";
    SieIcon["SieportalOnSiteHelp"] = "SieportalOnSiteHelp";
    SieIcon["SieportalOrder"] = "SieportalOrder";
    SieIcon["SieportalOrdering"] = "SieportalOrdering";
    SieIcon["SieportalOrderlist"] = "SieportalOrderlist";
    SieIcon["SieportalOrderlistAdd"] = "SieportalOrderlistAdd";
    SieIcon["SieportalOtp"] = "SieportalOtp";
    SieIcon["SieportalPackage"] = "SieportalPackage";
    SieIcon["SieportalPlaceholderCertificate"] = "SieportalPlaceholderCertificate";
    SieIcon["SieportalPlaceholderProduct"] = "SieportalPlaceholderProduct";
    SieIcon["SieportalPlaceholderService"] = "SieportalPlaceholderService";
    SieIcon["SieportalPlaceholderVideo"] = "SieportalPlaceholderVideo";
    SieIcon["SieportalPlatinumFilled"] = "SieportalPlatinumFilled";
    SieIcon["SieportalProductCluster"] = "SieportalProductCluster";
    SieIcon["SieportalProductNote"] = "SieportalProductNote";
    SieIcon["SieportalQuotation"] = "SieportalQuotation";
    SieIcon["SieportalRepair"] = "SieportalRepair";
    SieIcon["SieportalSave"] = "SieportalSave";
    SieIcon["SieportalSend"] = "SieportalSend";
    SieIcon["SieportalShowPassword"] = "SieportalShowPassword";
    SieIcon["SieportalSmartcard"] = "SieportalSmartcard";
    SieIcon["SieportalSoftPki"] = "SieportalSoftPki";
    SieIcon["SieportalSparesWeb"] = "SieportalSparesWeb";
    SieIcon["SieportalStarFull"] = "SieportalStarFull";
    SieIcon["SieportalStarHalfOutline"] = "SieportalStarHalfOutline";
    SieIcon["SieportalStarOutline"] = "SieportalStarOutline";
    SieIcon["SieportalStatusPackageAboutToExpire9Days"] = "SieportalStatusPackageAboutToExpire9Days";
    SieIcon["SieportalStatusPackageExpired"] = "SieportalStatusPackageExpired";
    SieIcon["SieportalStatusPackageGenationFailed"] = "SieportalStatusPackageGenationFailed";
    SieIcon["SieportalStatusPackageGenerated"] = "SieportalStatusPackageGenerated";
    SieIcon["SieportalStatusPackageGeneratedWithErrors"] = "SieportalStatusPackageGeneratedWithErrors";
    SieIcon["SieportalStatusPackageGenerating"] = "SieportalStatusPackageGenerating";
    SieIcon["SieportalStatusPackageNotGenerated"] = "SieportalStatusPackageNotGenerated";
    SieIcon["SieportalSupportRequest"] = "SieportalSupportRequest";
    SieIcon["SieportalTag"] = "SieportalTag";
    SieIcon["SieportalTechnicalData"] = "SieportalTechnicalData";
    SieIcon["SieportalThumbnailEddieEngineer"] = "SieportalThumbnailEddieEngineer";
    SieIcon["SieportalThumbnailMajaManager"] = "SieportalThumbnailMajaManager";
    SieIcon["SieportalThumbnailOliOperations"] = "SieportalThumbnailOliOperations";
    SieIcon["SieportalThumbnailPriyaPurchaser"] = "SieportalThumbnailPriyaPurchaser";
    SieIcon["SieportalThumbsDown"] = "SieportalThumbsDown";
    SieIcon["SieportalThumbsUp"] = "SieportalThumbsUp";
    SieIcon["SieportalTopicPage"] = "SieportalTopicPage";
    SieIcon["SieportalUpload"] = "SieportalUpload";
    SieIcon["SieportalWindows"] = "SieportalWindows";
    SieIcon["SieportalX"] = "SieportalX";
    SieIcon["SieShape1LevelMovingForward"] = "SieShape1LevelMovingForward";
    SieIcon["Skip"] = "Skip";
    SieIcon["SkipBack"] = "SkipBack";
    SieIcon["SocialFeed"] = "SocialFeed";
    SieIcon["Sort"] = "Sort";
    SieIcon["SortAscending"] = "SortAscending";
    SieIcon["SortDescending"] = "SortDescending";
    SieIcon["SortDown"] = "SortDown";
    SieIcon["SortUp"] = "SortUp";
    SieIcon["SortUpDown"] = "SortUpDown";
    SieIcon["Stop"] = "Stop";
    SieIcon["SuccessFilled"] = "SuccessFilled";
    SieIcon["Suggestions"] = "Suggestions";
    SieIcon["Support"] = "Support";
    SieIcon["TextBold"] = "TextBold";
    SieIcon["TextBulleted"] = "TextBulleted";
    SieIcon["TextDecrease"] = "TextDecrease";
    SieIcon["TextEmoji"] = "TextEmoji";
    SieIcon["TextGif"] = "TextGif";
    SieIcon["TextIncrease"] = "TextIncrease";
    SieIcon["TextItalic"] = "TextItalic";
    SieIcon["TextNumbered"] = "TextNumbered";
    SieIcon["TextStrikeThrough"] = "TextStrikeThrough";
    SieIcon["TextUnderline"] = "TextUnderline";
    SieIcon["Tickets"] = "Tickets";
    SieIcon["Twitter"] = "Twitter";
    SieIcon["TwitterOld"] = "TwitterOld";
    SieIcon["Txt"] = "Txt";
    SieIcon["Undo"] = "Undo";
    SieIcon["Unlocked"] = "Unlocked";
    SieIcon["UserAccount"] = "UserAccount";
    SieIcon["UserFilled"] = "UserFilled";
    SieIcon["Utilisation"] = "Utilisation";
    SieIcon["Up"] = "Up";
    SieIcon["Video"] = "Video";
    SieIcon["VolumeLoud"] = "VolumeLoud";
    SieIcon["VolumeMute"] = "VolumeMute";
    SieIcon["VolumeQuiet"] = "VolumeQuiet";
    SieIcon["Warning"] = "Warning";
    SieIcon["WarningFilled"] = "WarningFilled";
    SieIcon["Weibo"] = "Weibo";
    SieIcon["Weight"] = "Weight";
    SieIcon["Xls"] = "Xls";
    SieIcon["Yammer"] = "Yammer";
    SieIcon["Youtube"] = "Youtube";
    SieIcon["ZoomIn"] = "ZoomIn";
    SieIcon["ZoomOut"] = "ZoomOut";
})(SieIcon || (SieIcon = {}));
/** @ignore */
const SIE_ICONS = new Map([
    [SieIcon.AcknowledgeEvents, 'acknowledge-events.svg'],
    [SieIcon.Add, 'add.svg'],
    [SieIcon.Advanced, 'advanced.svg'],
    [SieIcon.AdvancedFilled, 'advanced-filled.svg'],
    [SieIcon.Apps, 'apps.svg'],
    [SieIcon.ArrowDoubleLeft, 'arrow-double-left.svg'],
    [SieIcon.ArrowDoubleRight, 'arrow-double-right.svg'],
    [SieIcon.ArrowDown, 'arrow-down.svg'],
    [SieIcon.ArrowLeft, 'arrow-left.svg'],
    [SieIcon.ArrowRight, 'arrow-right.svg'],
    [SieIcon.ArrowToTop, 'arrow-to-top.svg'],
    [SieIcon.ArrowUp, 'arrow-up.svg'],
    [SieIcon.Attach, 'attach.svg'],
    [SieIcon.AudioDescription1, 'audio-description-1.svg'],
    [SieIcon.AudioDescription2, 'audio-description-2.svg'],
    [SieIcon.Badge, 'badge.svg'],
    [SieIcon.BadgeCreateBeginner, 'badge-create-beginner.svg'],
    [SieIcon.BadgeCreateBronze, 'badge-create-bronze.svg'],
    [SieIcon.BadgeCreateGold, 'badge-create-gold.svg'],
    [SieIcon.BadgeCreateSilver, 'badge-create-silver.svg'],
    [SieIcon.BadgePlaceholder, 'badge-placeholder.svg'],
    [SieIcon.BadgeRateBeginner, 'badge-rate-beginner.svg'],
    [SieIcon.BadgeRateBronze, 'badge-rate-bronze.svg'],
    [SieIcon.BadgeRateGold, 'badge-rate-gold.svg'],
    [SieIcon.BadgeRateSilver, 'badge-rate-silver.svg'],
    [SieIcon.BadgeReadBeginner, 'badge-read-beginner.svg'],
    [SieIcon.BadgeReadBronze, 'badge-read-bronze.svg'],
    [SieIcon.BadgeReadGold, 'badge-read-gold.svg'],
    [SieIcon.BadgeReadSilver, 'badge-read-silver.svg'],
    [SieIcon.BadgeReportBeginner, 'badge-report-beginner.svg'],
    [SieIcon.BadgeReportBronze, 'badge-report-bronze.svg'],
    [SieIcon.BadgeReportGold, 'badge-report-gold.svg'],
    [SieIcon.BadgeReportSilver, 'badge-report-silver.svg'],
    [SieIcon.BarChart, 'bar-chart.svg'],
    [SieIcon.BiliBili, 'bilibili.svg'],
    [SieIcon.BrowseAll, 'browse-all.svg'],
    [SieIcon.Buildings, 'buildings.svg'],
    [SieIcon.Calendar, 'calendar.svg'],
    [SieIcon.Capacity, 'capacity.svg'],
    [SieIcon.Cax, 'cax.svg'],
    [SieIcon.Chat, 'chat.svg'],
    [SieIcon.Chat2, 'chat-2.svg'],
    [SieIcon.ChatbotButton, 'chatbot-button.svg'],
    [SieIcon.ChatbotButtonActive, 'chatbot-button-active.svg'],
    [SieIcon.ChatbotButtonDisabled, 'chatbot-button-disabled.svg'],
    [SieIcon.ChatbotButtonHover, 'chatbot-button-hover.svg'],
    [SieIcon.ChatbotButtonVariantB, 'chatbot-button-variant-b.svg'],
    [SieIcon.ChatbotButtonVariantBActive, 'chatbot-button-variant-b-active.svg'],
    [SieIcon.ChatbotButtonVariantBHover, 'chatbot-button-variant-b-hover.svg'],
    [SieIcon.ChatbotButtonVariantBWithLines, 'chatbot-button-variant-b-with-line-animation.svg'],
    [SieIcon.ChatbotButtonNew, 'chatbot-button_new.svg'],
    [SieIcon.ChatbotButtonNewActive, 'chatbot-button_new-active.svg'],
    [SieIcon.ChatbotButtonNewDisabled, 'chatbot-button_new-disabled.svg'],
    [SieIcon.ChatbotButtonNewHover, 'chatbot-button_new-hover.svg'],
    [SieIcon.CheckMark, 'check-mark.svg'],
    [SieIcon.CheckMarkBenefits, 'check-mark-benefits.svg'],
    [SieIcon.CheckMarkSmall, 'check-mark-small.svg'],
    [SieIcon.Clock, 'clock.svg'],
    [SieIcon.Close, 'close.svg'],
    [SieIcon.CloseSmall, 'close-small.svg'],
    [SieIcon.Configure, 'configure.svg'],
    [SieIcon.Control, 'control.svg'],
    [SieIcon.Copy, 'copy.svg'],
    [SieIcon.Crown, 'crown.svg'],
    [SieIcon.CrownFilled, 'crown-filled.svg'],
    [SieIcon.Cut, 'cut.svg'],
    [SieIcon.DCSEmptyState, 'dcs-empty-state.svg'],
    [SieIcon.Delete, 'delete.svg'],
    [SieIcon.Down, 'down.svg'],
    [SieIcon.Diamond, 'diamond.svg'],
    [SieIcon.DiamondFilled, 'diamond-filled.svg'],
    [SieIcon.Dislike, 'dislike.svg'],
    [SieIcon.Doc, 'doc.svg'],
    [SieIcon.DocLabel, 'doc-label.svg'],
    [SieIcon.DocumentSuccess, 'document-success.svg'],
    [SieIcon.DocumentSuccessFilled, 'document-success-filled.svg'],
    [SieIcon.Documentation, 'documentation.svg'],
    [SieIcon.Download, 'download.svg'],
    [SieIcon.Drag, 'drag.svg'],
    [SieIcon.DragLines, 'drag-lines.svg'],
    [SieIcon.Dropdown, 'dropdown.svg'],
    [SieIcon.DropdownLarge, 'dropdown-large.svg'],
    [SieIcon.Edit, 'edit.svg'],
    [SieIcon.Email, 'email.svg'],
    [SieIcon.Etim, 'etim.svg'],
    [SieIcon.ErrorFilled, 'error-filled.svg'],
    [SieIcon.Explore, 'explore.svg'],
    [SieIcon.ExploreFilled, 'explore-filled.svg'],
    [SieIcon.Ext, 'ext.svg'],
    [SieIcon.Facebook, 'facebook.svg'],
    [SieIcon.File, 'file.svg'],
    [SieIcon.Filter, 'filter.svg'],
    [SieIcon.Folder, 'folder.svg'],
    [SieIcon.FolderNew, 'folder-new.svg'],
    [SieIcon.FolderOpen, 'folder-open.svg'],
    [SieIcon.Forum, 'forum.svg'],
    [SieIcon.Fullscreen, 'fullscreen.svg'],
    [SieIcon.FullscreenExit, 'fullscreen-exit.svg'],
    [SieIcon.Globe, 'globe.svg'],
    [SieIcon.Heart, 'heart.svg'],
    [SieIcon.HeartFilled, 'heart-filled.svg'],
    [SieIcon.History, 'history.svg'],
    [SieIcon.Home, 'home.svg'],
    [SieIcon.HomeSmall, 'home-small.svg'],
    [SieIcon.HourGlass, 'hourglass.svg'],
    [SieIcon.Image, 'image.svg'],
    [SieIcon.Information, 'information.svg'],
    [SieIcon.InformationFilled, 'information-filled.svg'],
    [SieIcon.InformationPackage, 'information-package.svg'],
    [SieIcon.Instagram, 'instagram.svg'],
    [SieIcon.InteractionClick, 'interaction-click.svg'],
    [SieIcon.InteractionTouch, 'interaction-touch.svg'],
    [SieIcon.LevelUp, 'level-up.svg'],
    [SieIcon.Lightbulb, 'lightbulb.svg'],
    [SieIcon.Like, 'like.svg'],
    [SieIcon.LikeFilled, 'like-filled.svg'],
    [SieIcon.LineChart, 'line-chart.svg'],
    [SieIcon.Link, 'link.svg'],
    [SieIcon.Linkedin, 'linkedIn.svg'],
    [SieIcon.LocationPin, 'location-pin.svg'],
    [SieIcon.LockSmall, 'lock-small.svg'],
    [SieIcon.Locked, 'locked.svg'],
    [SieIcon.LogIn, 'login.svg'],
    [SieIcon.LogOut, 'log-out.svg'],
    [SieIcon.Left, 'left.svg'],
    [SieIcon.Maximize, 'maximize.svg'],
    [SieIcon.Menu, 'menu.svg'],
    [SieIcon.Microphone, 'microphone.svg'],
    [SieIcon.Minimize, 'minimize.svg'],
    [SieIcon.Minus, 'minus.svg'],
    [SieIcon.Monitor, 'monitor.svg'],
    [SieIcon.More, 'more.svg'],
    [SieIcon.MoreHorizontal, 'more-horizontal.svg'],
    [SieIcon.NavigationLeft, 'navigation-left.svg'],
    [SieIcon.NavigationRight, 'navigation-right.svg'],
    [SieIcon.Newton_productCatalogue, 'sieportal-catalogue.svg'],
    [SieIcon.NoAccess, 'no-access.svg'],
    [SieIcon.RemoveAccess, 'remove-access.svg'],
    [SieIcon.NotGenerated, 'not-generated.svg'],
    [SieIcon.Notification, 'notification.svg'],
    [SieIcon.NotificationFilled, 'notification-filled.svg'],
    [SieIcon.Optimize, 'optimize.svg'],
    [SieIcon.Paste, 'paste.svg'],
    [SieIcon.Pause, 'pause.svg'],
    [SieIcon.Pdf, 'pdf.svg'],
    [SieIcon.PeopleGroup, 'people-group.svg'],
    [SieIcon.PeopleGroupFilled, 'people-group-filled.svg'],
    [SieIcon.Phone, 'phone.svg'],
    [SieIcon.Picture, 'picture.svg'],
    [SieIcon.PieChartSmall, 'pie-chart-small.svg'],
    [SieIcon.Pin, 'pin.svg'],
    [SieIcon.Plant, 'plant.svg'],
    [SieIcon.Play, 'play.svg'],
    [SieIcon.Plus, 'plus.svg'],
    [SieIcon.PlusSmall, 'plus-small.svg'],
    [SieIcon.Ppt, 'ppt.svg'],
    [SieIcon.Print, 'print.svg'],
    [SieIcon.Question, 'question.svg'],
    [SieIcon.Quotation, 'quotation.svg'],
    [SieIcon.QuotationGradient, 'quotation-gradient.svg'],
    [SieIcon.Redo, 'redo.svg'],
    [SieIcon.Refresh, 'refresh.svg'],
    [SieIcon.Region, 'region.svg'],
    [SieIcon.Reply, 'reply.svg'],
    [SieIcon.Reset, 'reset.svg'],
    [SieIcon.Right, 'right.svg'],
    [SieIcon.Search, 'search.svg'],
    [SieIcon.SearchSmall, 'search-small.svg'],
    [SieIcon.Send, 'send.svg'],
    [SieIcon.Service, 'service.svg'],
    [SieIcon.Settings, 'settings.svg'],
    [SieIcon.Share, 'share.svg'],
    [SieIcon.Shipping, 'shipping.svg'],
    [SieIcon.ShoppingCart, 'shopping-cart.svg'],
    [SieIcon.Shuffle, 'shuffle.svg'],
    [SieIcon.SidePanelClose, 'sidepanel-close.svg'],
    [SieIcon.SidePanelOpen, 'sidepanel-open.svg'],
    [SieIcon.SieLogoPetrolRgb, 'sie-logo-petrol-rgb.svg'],
    [SieIcon.SieLogoWhiteRgb, 'sie-logo-white-rgb.svg'],
    [SieIcon.SieShape1stLevelMovingForward, 'sie-shape-1st-level-moving-forward.svg'],
    [SieIcon.SieLogoBlackRgb, 'sie-logo-black-rgb.svg'],
    [SieIcon.SiePortalEmptyStatePendingInvitations, 'sieportal-empty-state-pending-invitations.svg'],
    [SieIcon.SieportalEmptyStateRecentlyViewed, 'sieportal-empty-state-recently-viewed.svg'],
    [SieIcon.Sieportal2dDrawings, 'sieportal-2d-drawings.svg'],
    [SieIcon.Sieportal3dDrawings, 'sieportal-3d-drawings.svg'],
    [SieIcon.SieportalAddFile, 'sieportal-addfile.svg'],
    [SieIcon.SieportalAltText, 'sieportal-alt-text.svg'],
    [SieIcon.SieportalApplicationExamples, 'sieportal-application-examples.svg'],
    [SieIcon.SieportalArrowBig, 'sieportal-arrow-big.svg'],
    [SieIcon.SieportalBadgeError, 'sieportal-badge-error.svg'],
    [SieIcon.SieportalBadgeInfo, 'sieportal-badge-information.svg'],
    [SieIcon.SieportalBadgeSuccess, 'sieportal-badge-success.svg'],
    [SieIcon.SieportalBadgeWarning, 'sieportal-badge-warning.svg'],
    [SieIcon.SieportalBookmarkFilled, 'sieportal-bookmark-filled.svg'],
    [SieIcon.SieportalBookmarkOutline, 'sieportal-bookmark-outline.svg'],
    [SieIcon.SieportalCatalogue, 'sieportal-catalogue.svg'],
    [SieIcon.SieportalCharacteristics, 'sieportal-characteristics.svg'],
    [SieIcon.SieportalCircuit, 'sieportal-circuit.svg'],
    [SieIcon.SieportalClockLoad, 'sieportal-clock-load.svg'],
    [SieIcon.SieportalCommonArticle, 'sieportal-common-article.svg'],
    [SieIcon.SieportalCompatibility, 'sieportal-compatibility.svg'],
    [SieIcon.SieportalConnection, 'sieportal-connection.svg'],
    [SieIcon.SieportalDataHub, 'sieportal-data-hub.svg'],
    [SieIcon.SieportalDataHubAdd, 'sieportal-data-hub-add.svg'],
    [SieIcon.SieportalDocumentNew, 'sieportal-document-new.svg'],
    [SieIcon.SieportalDocumentTemplate, 'sieportal-document-template.svg'],
    [SieIcon.SiePortalDownloadArchiveSoftware, 'sieportal-download-archive-software.svg'],
    [SieIcon.SieportalEPlan, 'sieportal-eplan.svg'],
    [SieIcon.SieportalEducation, 'sieportal-education.svg'],
    [SieIcon.SieportalEducationFilled, 'sieportal-education-filled.svg'],
    [SieIcon.SieportalElearning, 'sieportal-elearning.svg'],
    [SieIcon.SieportalEmptyState404Simple, 'sieportal-empty-state-404-simple.svg'],
    [SieIcon.SieportalEmptyStateCards, 'sieportal-empty-state-cards.svg'],
    [SieIcon.SieportalEmptyStateCardsArrow, 'sieportal-empty-state-cards-arrow.svg'],
    [SieIcon.SieportalEmptyStateCardsHappy, 'sieportal-empty-state-cards-happy.svg'],
    [SieIcon.SieportalEmptyStateCardsWaiting, 'sieportal-empty-state-cards-waiting.svg'],
    [SieIcon.SieportalEmptyStateContents, 'sieportal-empty-state-contents.svg'],
    [SieIcon.SieportalEmptyStateContractUnavailable, 'sieportal-empty-state-contract-unavailable.svg'],
    [SieIcon.SieportalEmptyStateDiagram, 'sieportal-empty-state-diagram.svg'],
    [SieIcon.SieportalEmptyStateDiagramSmall, 'sieportal-empty-state-diagram-small.svg'],
    [SieIcon.SieportalEmptyStateDownload, 'sieportal-empty-state-download.svg'],
    [SieIcon.SieportalEmptyStateErrorAccount, 'sieportal-empty-state-error-account.svg'],
    [SieIcon.SieportalEmptyStateFavorites, 'sieportal-empty-state-favorites.svg'],
    [
        SieIcon.SieportalEmptyStateIllustrationInviteUsersError,
        'sieportal-empty-state-illustration-invite-users-error.svg'
    ],
    [
        SieIcon.SieportalEmptyStateJointControllerAgreementNotAllowed,
        'sieportal-empty-state-joint-controller-agreement-not-allowed.svg'
    ],
    [SieIcon.SieportalEmptyStateMaintenanceDates, 'sieportal-empty-state-maintenance-dates.svg'],
    [SieIcon.SieportalEmptyStateNoAccount, 'sieportal-empty-state-no-account.svg'],
    [SieIcon.SieportalEmptyStateNoBusinessProfile, 'sieportal-empty-state-no-business-profile.svg'],
    [SieIcon.SieportalEmptyStateNoContractsFound, 'sieportal-empty-state-contract-unavailable.svg'],
    [SieIcon.SieportalEmptyStateNoConversation, 'sieportal-empty-state-no-conversation.svg'],
    [SieIcon.SieportalEmptyStateNoConversations, 'sieportal-empty-state-no-conversations.svg'],
    [SieIcon.SieportalEmptyStateNoData, 'sieportal-empty-state-no-data.svg'],
    [SieIcon.SieportalEmptyStateNoDataSmall, 'sieportal-empty-state-no-data-small.svg'],
    [SieIcon.SieportalEmptyStateNoQuery, 'sieportal-empty-state-no-query.svg'],
    [SieIcon.SieportalEmptyStateNoSearchResults, 'sieportal-empty-state-no-search-results.svg'],
    [SieIcon.SieportalEmptyStateNotification, 'sieportal-empty-state-notification.svg'],
    [SieIcon.SieportalEmptyStatePackage, 'sieportal-empty-state-package.svg'],
    [SieIcon.SieportalEmptyStatePackageShare, 'sieportal-empty-state-package-share.svg'],
    [SieIcon.SieportalEmptyStatePeoplePicker, 'sieportal-empty-state-people-picker.svg'],
    [SieIcon.SieportalEmptyStatePlatformPromotion, 'sieportal-empty-state-platform-promotion.svg'],
    [SieIcon.SieportalEmptyStateRecentlyViewed, 'sieportal-empty-state-recently-viewed.svg'],
    [SieIcon.SieportalEmptyStateRecommendation, 'sieportal-empty-state-recommendation.svg'],
    [SieIcon.SieportalEmptyStateSearches, 'sieportal-empty-state-searches.svg'],
    [SieIcon.SieportalEmptyStateSnoozedNotifications, 'sieportal-empty-state-snoozed-notifications.svg'],
    [SieIcon.SieportalEmptyStateTable, 'sieportal-empty-state-table.svg'],
    [SieIcon.SieportalEmptyStateUserPermissions, 'sieportal-empty-state-user-permissions.svg'],
    [SieIcon.SieportalEmptyStateWizardProduct, 'sieportal-empty-state-wizard-product.svg'],
    [SieIcon.SieportalEmptyStateTechnicalData, 'sieportal-emptystate-technical-data.svg'],
    [SieIcon.SieportalExtHeaderWithBorderTag, 'ext-header-with-border.svg'],
    [SieIcon.SieportalExtHeaderWithDarkBorderTag, 'ext-header-with-dark-border.svg'],
    [SieIcon.SieportalExtHeaderWithoutBorderTag, 'ext-header-without-border.svg'],
    [SieIcon.SieportalExtIdleWithBorderTag, 'ext-idle-with-border.svg'],
    [SieIcon.SieportalExtIdleWithoutBorderTag, 'ext-idle-without-border.svg'],
    [SieIcon.SieportalExtMiniWithBorderTag, 'ext-mini-with-border.svg'],
    [SieIcon.SieportalExtMiniWithoutBorderTag, 'ext-mini-without-border.svg'],
    [SieIcon.SieportalFeedback, 'sieportal-feedback.svg'],
    [SieIcon.SieportalHelp, 'sieportal-help.svg'],
    [SieIcon.SieportalHidePassword, 'sieportal-hide-password.svg'],
    [SieIcon.SieportalIntExtHeaderWithBorderTag, 'int-ext-header-with-border.svg'],
    [SieIcon.SieportalIntExtHeaderWithDarkBorderTag, 'intext-header-with-dark-border.svg'],
    [SieIcon.SieportalIntExtHeaderWithoutBorderTag, 'int-ext-header-without-border.svg'],
    [SieIcon.SieportalIntExtIdleWithBorderTag, 'int-ext-idle-with-border.svg'],
    [SieIcon.SieportalIntExtIdleWithoutBorderTag, 'int-ext-idle-without-border.svg'],
    [SieIcon.SieportalIntExtMiniWithBorderTag, 'int-ext-mini-with-border.svg'],
    [SieIcon.SieportalIntExtMiniWithoutBorderTag, 'int-ext-mini-without-border.svg'],
    [SieIcon.SieportalIntHeaderWithBorderTag, 'int-header-with-border.svg'],
    [SieIcon.SieportalIntHeaderWithDarkBorderTag, 'int-header-with-dark-border.svg'],
    [SieIcon.SieportalIntHeaderWithoutBorderTag, 'int-header-without-border.svg'],
    [SieIcon.SieportalIntIdleWithBorderTag, 'int-idle-with-border.svg'],
    [SieIcon.SieportalIntIdleWithoutBorderTag, 'int-idle-without-border.svg'],
    [SieIcon.SieportalIntMiniWithBorderTag, 'int-mini-with-border.svg'],
    [SieIcon.SieportalIntMiniWithoutBorderTag, 'int-mini-without-border.svg'],
    [SieIcon.SieportalMaintenanceError, 'sieportal-maintenance-error.svg'],
    [SieIcon.SieportalMobileApps, 'sieportal-mobile-apps.svg'],
    [SieIcon.SieportalMorePortrait, 'sieportal-more-portrait.svg'],
    [SieIcon.SieportalNone, 'sieportal-none.svg'],
    [SieIcon.SieportalOnSiteHelp, 'sieportal-on-site-help.svg'],
    [SieIcon.SieportalOrder, 'sieportal-order.svg'],
    [SieIcon.SieportalOrdering, 'sieportal-ordering.svg'],
    [SieIcon.SieportalOrderlist, 'sieportal-orderlist.svg'],
    [SieIcon.SieportalOrderlistAdd, 'sieportal-orderlist-add.svg'],
    [SieIcon.SieportalOtp, 'sieportal-otp.svg'],
    [SieIcon.SieportalPackage, 'sieportal-package.svg'],
    [SieIcon.SieportalPlaceholderCertificate, 'sieportal-placeholder-certificate.svg'],
    [SieIcon.SieportalPlaceholderProduct, 'sieportal-placeholder-product.svg'],
    [SieIcon.SieportalPlaceholderService, 'sieportal-placeholder-service.svg'],
    [SieIcon.SieportalPlaceholderVideo, 'sieportal-placeholder-video.svg'],
    [SieIcon.SieportalPlatinumFilled, 'sieportal-platinum-filled.svg'],
    [SieIcon.SieportalProductCluster, 'sieportal-product-cluster.svg'],
    [SieIcon.SieportalProductNote, 'sieportal-product-note.svg'],
    [SieIcon.SieportalQuotation, 'sieportal-quotation.svg'],
    [SieIcon.SieportalRepair, 'sieportal-repair.svg'],
    [SieIcon.SieportalSave, 'sieportal-save.svg'],
    [SieIcon.SieportalSend, 'sieportal-send.svg'],
    [SieIcon.SieportalShowPassword, 'sieportal-show-password.svg'],
    [SieIcon.SieportalSmartcard, 'sieportal-smartcard.svg'],
    [SieIcon.SieportalSoftPki, 'sieportal-soft-pki.svg'],
    [SieIcon.SieportalSparesWeb, 'sieportal-spares-web.svg'],
    [SieIcon.SieportalStarFull, 'sieportal-star-full.svg'],
    [SieIcon.SieportalStarFull, 'sieportal-star-full.svg'],
    [SieIcon.SieportalStarHalfOutline, 'sieportal-star-half-outline.svg'],
    [SieIcon.SieportalStarOutline, 'sieportal-star-outline.svg'],
    [SieIcon.SieportalStatusPackageAboutToExpire9Days, 'sieportal-status-package-abouttoexpire-9days.svg'],
    [SieIcon.SieportalStatusPackageExpired, 'sieportal-status-package-expired.svg'],
    [SieIcon.SieportalStatusPackageGenationFailed, 'sieportal-status-package-genationfailed.svg'],
    [SieIcon.SieportalStatusPackageGenerated, 'sieportal-status-package-generated.svg'],
    [SieIcon.SieportalStatusPackageGeneratedWithErrors, 'sieportal-status-package-generatedwitherrors.svg'],
    [SieIcon.SieportalStatusPackageGenerating, 'sieportal-status-package-generating.svg'],
    [SieIcon.SieportalStatusPackageNotGenerated, 'sieportal-status-package-notgenerated.svg'],
    [SieIcon.SieportalSupportRequest, 'sieportal-support-request.svg'],
    [SieIcon.SieportalTag, 'sieportal-tag.svg'],
    [SieIcon.SieportalTechnicalData, 'sieportal-technical-data.svg'],
    [SieIcon.SieportalThumbnailEddieEngineer, 'sieportal-thumbnail-eddie-engineer.svg'],
    [SieIcon.SieportalThumbnailMajaManager, 'sieportal-thumbnail-maja-manager.svg'],
    [SieIcon.SieportalThumbnailOliOperations, 'sieportal-thumbnail-oli-operations.svg'],
    [SieIcon.SieportalThumbnailPriyaPurchaser, 'sieportal-thumbnail-priya-purchaser.svg'],
    [SieIcon.SieportalThumbsDown, 'sieportal-thumbs-down.svg'],
    [SieIcon.SieportalThumbsUp, 'sieportal-thumbs-up.svg'],
    [SieIcon.SieportalTopicPage, 'sieportal-topic-page.svg'],
    [SieIcon.SieportalUpload, 'sieportal-upload.svg'],
    [SieIcon.SieportalWindows, 'sieportal-windows.svg'],
    [SieIcon.SieportalX, 'sieportal-x.svg'],
    [SieIcon.SieShape1LevelMovingForward, 'sie-shape-1st-level-moving-forward.svg'],
    [SieIcon.Skip, 'skip.svg'],
    [SieIcon.SkipBack, 'skip-back.svg'],
    [SieIcon.SocialFeed, 'social-feed.svg'],
    [SieIcon.Sort, 'sort.svg'],
    [SieIcon.SortAscending, 'sort-ascending.svg'],
    [SieIcon.SortDescending, 'sort-descending.svg'],
    [SieIcon.SortDown, 'sort-down.svg'],
    [SieIcon.SortUp, 'sort-up.svg'],
    [SieIcon.SortUpDown, 'sort-up-down.svg'],
    [SieIcon.Stop, 'stop.svg'],
    [SieIcon.SuccessFilled, 'success-filled.svg'],
    [SieIcon.Suggestions, 'suggestions.svg'],
    [SieIcon.Support, 'support.svg'],
    [SieIcon.TextBold, 'text-bold.svg'],
    [SieIcon.TextBulleted, 'text-bulleted.svg'],
    [SieIcon.TextDecrease, 'text-decrease.svg'],
    [SieIcon.TextEmoji, 'text-emoji.svg'],
    [SieIcon.TextGif, 'text-gif.svg'],
    [SieIcon.TextIncrease, 'text-increase.svg'],
    [SieIcon.TextItalic, 'text-italic.svg'],
    [SieIcon.TextNumbered, 'text-numbered.svg'],
    [SieIcon.TextStrikeThrough, 'text-strikethrough.svg'],
    [SieIcon.TextUnderline, 'text-underline.svg'],
    [SieIcon.Tickets, 'tickets.svg'],
    [SieIcon.Twitter, 'twitter.svg'],
    [SieIcon.TwitterOld, 'twitter-old.svg'],
    [SieIcon.Txt, 'txt.svg'],
    [SieIcon.Undo, 'undo.svg'],
    [SieIcon.Unlocked, 'unlocked.svg'],
    [SieIcon.UserAccount, 'user-account.svg'],
    [SieIcon.UserFilled, 'user-filled.svg'],
    [SieIcon.Utilisation, 'utilisation.svg'],
    [SieIcon.Up, 'up.svg'],
    [SieIcon.Video, 'video.svg'],
    [SieIcon.VolumeLoud, 'volume-loud.svg'],
    [SieIcon.VolumeMute, 'volume-mute.svg'],
    [SieIcon.VolumeQuiet, 'volume-quiet.svg'],
    [SieIcon.Warning, 'warning.svg'],
    [SieIcon.WarningFilled, 'warning-filled.svg'],
    [SieIcon.Weibo, 'weibo.svg'],
    [SieIcon.Weight, 'weight.svg'],
    [SieIcon.Xls, 'xls.svg'],
    [SieIcon.Yammer, 'yammer.svg'],
    [SieIcon.Youtube, 'youtube.svg'],
    [SieIcon.ZoomIn, 'zoom-in.svg'],
    [SieIcon.ZoomOut, 'zoom-out.svg']
]);

var SieIconRegisterStatus;
(function (SieIconRegisterStatus) {
    SieIconRegisterStatus[SieIconRegisterStatus["Requested"] = 0] = "Requested";
    SieIconRegisterStatus[SieIconRegisterStatus["AlreadyRegistered"] = 1] = "AlreadyRegistered";
    SieIconRegisterStatus[SieIconRegisterStatus["BuiltInNotFound"] = 2] = "BuiltInNotFound";
    SieIconRegisterStatus[SieIconRegisterStatus["BuiltInNamingConflict"] = 3] = "BuiltInNamingConflict";
})(SieIconRegisterStatus || (SieIconRegisterStatus = {}));

const SIE_ICONS_PATH = 'SIE_ICONS_PATH';

class SieIconLoaderService {
    load(assetUrl) {
        return fetch(assetUrl)
            .then(response => {
            if (response.status === 404) {
                throw new Error('Asset not found.');
            }
            return response;
        })
            .then(response => response.text());
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: SieIconLoaderService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: SieIconLoaderService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: SieIconLoaderService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }] });

/**
 * Service responsible for resolving the static asset for a given icon name.
 */
class SieIconRegistryService {
    constructor(iconsPath, iconLoaderService) {
        this.iconsPath = iconsPath;
        this.iconLoaderService = iconLoaderService;
        this.sieIcon = SieIcon;
        this.registry = new Map();
    }
    register(uniqueId, assetNameOrUrl, fallbackIcon) {
        if (this.registry.has(uniqueId)) {
            return SieIconRegisterStatus.AlreadyRegistered;
        }
        let assetUrl;
        if (arguments.length === 1) {
            // Overload #1
            if (!SIE_ICONS.has(uniqueId)) {
                // eslint-disable-next-line no-console
                console.warn(`${uniqueId} does not exist.`);
                return SieIconRegisterStatus.BuiltInNotFound;
            }
            assetUrl = this.getInternalIconPath(uniqueId);
        }
        else {
            // Overload #2
            if (SIE_ICONS.has(uniqueId)) {
                // eslint-disable-next-line no-console
                console.warn(`Cannot use '${uniqueId}' to register icon as it's an built in identifier.`);
                return SieIconRegisterStatus.BuiltInNamingConflict;
            }
            assetUrl = assetNameOrUrl;
        }
        this.registry.set(uniqueId, new BehaviorSubject(null));
        this.loadAsset(assetUrl, uniqueId, fallbackIcon).then(response => {
            this.registry.get(uniqueId).next(response);
        });
        return SieIconRegisterStatus.Requested;
    }
    getIcon(uniqueId) {
        return this.registry.get(uniqueId);
    }
    getInternalIconPath(iconName) {
        return `${this.iconsPath}/${SIE_ICONS.get(iconName)}`;
    }
    loadAsset(assetUrl, uniqueId, fallbackIcon) {
        return this.iconLoaderService.load(assetUrl).catch(() => {
            if (fallbackIcon) {
                this.register(fallbackIcon);
                const fallbackSub = this.registry.get(fallbackIcon)?.subscribe(icon => {
                    if (icon) {
                        this.registry.get(uniqueId).next(icon);
                        fallbackSub.unsubscribe();
                    }
                });
            }
            return '';
        });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: SieIconRegistryService, deps: [{ token: SIE_ICONS_PATH }, { token: SieIconLoaderService }], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: SieIconRegistryService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: SieIconRegistryService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: undefined, decorators: [{
                    type: Inject,
                    args: [SIE_ICONS_PATH]
                }] }, { type: SieIconLoaderService }]; } });

const injectPrefix = 'svg-';
class SieIconSanitizerService {
    constructor() {
        this.iconCounter = 0;
    }
    cleanSvg(svgContent) {
        const cleanedSvgContent = svgContent
            .replace(/id="(.*)"/g, `id="${injectPrefix}${this.iconCounter}-$1"`)
            .replace(/xlink:href="#(.*)"/g, `xlink:href="#${injectPrefix}${this.iconCounter}-$1"`)
            .replace(/mask="url\(#(.*)\)"/g, `mask="url(#${injectPrefix}${this.iconCounter}-$1)"`)
            .replace(/fill="url\(#(.*)\)"/g, `fill="url(#${injectPrefix}${this.iconCounter}-$1)"`);
        this.iconCounter++;
        return cleanedSvgContent;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: SieIconSanitizerService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: SieIconSanitizerService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: SieIconSanitizerService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }] });

/**
 * # Icon component
 * Component to display icons. It can take icon names and take care about resolving the static asset in the background.
 *
 * ## Code example
 * @example ```html
 * <sie-icon [name]="'Home'"></sie-icon>
 * ```
 */
class SieIconsComponent {
    set name(iconName) {
        const iconSub = this.iconReg.getIcon(iconName);
        this.className = 'icon-' + (iconName ? iconName.replace(/[^0-9a-zA-Z]+/, '-') : '');
        if (iconSub) {
            this.iconSub = iconSub.subscribe(iconString => this.updateIcon(iconString));
        }
    }
    set svgClass(value) {
        this._svgClass = value;
        this.setSvgClass();
    }
    get svgIcon() {
        return this._svgIcon;
    }
    constructor(element, iconReg, document, sanitizerService) {
        this.element = element;
        this.iconReg = iconReg;
        this.document = document;
        this.sanitizerService = sanitizerService;
        this.inheritSize = false;
        this.iconChanged = new Subject();
    }
    ngOnDestroy() {
        if (this.iconSub) {
            this.iconSub.unsubscribe();
        }
    }
    updateIcon(svgContent) {
        if (!svgContent) {
            return;
        }
        if (this._svgIcon) {
            this.element.nativeElement.removeChild(this._svgIcon);
        }
        const cleanSvg = this.sanitizerService.cleanSvg(svgContent);
        this._svgIcon = this.svgElementFromString(cleanSvg);
        this.setSvgClass();
        if (this.inheritSize) {
            this.setSvgStyles();
        }
        this.element.nativeElement.appendChild(this._svgIcon);
        this.magic(DomUtil.applyNgContentToChildren(this.element.nativeElement));
        this.iconChanged.next();
    }
    magic(input) {
        return input;
    }
    svgElementFromString(svgContent) {
        const div = this.document.createElement('DIV');
        div.innerHTML = svgContent;
        return div.querySelector('svg') || this.document.createElementNS('http://www.w3.org/2000/svg', 'path');
    }
    setSvgClass() {
        if (this._svgClass && this._svgIcon) {
            this._svgIcon.classList.add(this._svgClass);
        }
    }
    setSvgStyles() {
        this._svgIcon.style.width = 'inherit';
        this._svgIcon.style.height = 'inherit';
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: SieIconsComponent, deps: [{ token: i0.ElementRef }, { token: SieIconRegistryService }, { token: DOCUMENT, optional: true }, { token: SieIconSanitizerService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: SieIconsComponent, selector: "sie-icon", inputs: { name: "name", svgClass: "svgClass", inheritSize: "inheritSize" }, outputs: { iconChanged: "iconChanged" }, host: { properties: { "class": "this.className" } }, ngImport: i0, template: ` <ng-content></ng-content> `, isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: SieIconsComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'sie-icon',
                    template: ` <ng-content></ng-content> `,
                    changeDetection: ChangeDetectionStrategy.OnPush
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: SieIconRegistryService }, { type: Document, decorators: [{
                    type: Optional
                }, {
                    type: Inject,
                    args: [DOCUMENT]
                }] }, { type: SieIconSanitizerService }]; }, propDecorators: { name: [{
                type: Input
            }], svgClass: [{
                type: Input
            }], inheritSize: [{
                type: Input
            }], iconChanged: [{
                type: Output
            }], className: [{
                type: HostBinding,
                args: ['class']
            }] } });

/**
 * # Icon Module
 * Module for handling the icons throughout the components. This module needs to be configured in the root module to define the entry point for the static assets.
 *
 * ## Module Content
 * - {@link SieIconsComponent}
 * - {@link SieIconRegistryService}
 * - {@link SieIcon}
 *
 * ## Module configuration
 * @example
 * ```ts
 * @NgModule({
 *   imports: [
 *     SieIconsModule.forRoot(),
 *     ...
 *   ],
 *   ...
 * })
 * ```
 * For an alternative asset path configuration checkout {@link SieIconsConfiguration} which can be passed to the `forRoot` method.
 */
class SieIconsModule {
    static forRoot(config) {
        const providers = [
            {
                provide: SIE_ICONS_PATH,
                useValue: config?.assetPath || '/assets/sie-icons'
            },
            {
                provide: SieIconLoaderService,
                useClass: config?.loader || SieIconLoaderService
            },
            SieIconRegistryService
        ];
        return {
            ngModule: SieIconsModule,
            providers
        };
    }
    static forChild() {
        return {
            ngModule: SieIconsModule,
            providers: [
                {
                    provide: SieIconRegistryService,
                    useExisting: SieIconRegistryService
                },
                {
                    provide: SieIconLoaderService,
                    useClass: SieIconLoaderService
                }
            ]
        };
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: SieIconsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: SieIconsModule, declarations: [SieIconsComponent], exports: [SieIconsComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: SieIconsModule }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: SieIconsModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [SieIconsComponent],
                    exports: [SieIconsComponent]
                }]
        }] });

class SieIconRegistryMockService {
    constructor() {
        this.sieIcon = SieIcon;
        this.registry = new Map([
            [SieIcon.UserAccount, new BehaviorSubject(mockUserAccountIcon)],
            [SieIcon.ArrowDown, new BehaviorSubject(mockArrowDownSmallIcon)]
        ]);
        this.iconsPath = '/assets/sie-icons';
    }
    register(uniqueId, _assetNameOrUrl) {
        if (this.registry.has(uniqueId)) {
            return;
        }
        this.registry.set(uniqueId, new BehaviorSubject(mockIcon));
    }
    getIcon(uniqueId) {
        return this.registry.get(uniqueId);
    }
    getInternalIconPath(iconName) {
        return `${this.iconsPath}/${SIE_ICONS.get(iconName)}`;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: SieIconRegistryMockService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: SieIconRegistryMockService }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: SieIconRegistryMockService, decorators: [{
            type: Injectable
        }] });
const mockUserAccountIcon = `<svg version="1.1" xmlns="http://www.w3.org/2000/svg" width="32" height="32" viewBox="0 0 32 32">
<title>user-account</title>
<path d="M16 13.5c2.738 0 4.587-2.1 4.587-5.25s-1.863-5.25-4.588-5.25c-2.737 0-4.6 2.1-4.6 5.25 0.012 3.15 1.863 5.25 4.6 5.25z"></path>
<path d="M26 20.125c-0.038-2.225-1.325-3.75-3.225-3.875v0l-3.438-0.238c0 0 0 0 0 0l-3.338 3.325-3.338-3.338c0 0 0 0 0 0v0l-3.438 0.237c-1.9 0.137-3.175 1.663-3.225 3.887 0 0 0 0 0 0 0 0.887 0 5.575 0 9.875h20c0-4.3 0-8.988 0-9.875 0 0.012 0 0 0 0z"></path>
</svg>`;
const mockArrowDownSmallIcon = `<svg version="1.1" xmlns="http://www.w3.org/2000/svg" width="32" height="32" viewBox="0 0 32 32">
<path d="M16 26l16-16.003-3.404-3.404-12.596 10.938-12.619-10.911-3.381 3.383 16 15.998z"></path>
</svg>`;
const mockIcon = `<svg version="1.1" xmlns="http://www.w3.org/2000/svg" width="32" height="32" viewBox="0 0 32 32">
    <title>check-mark</title>
    <path d="M28.688 3.95l3.313 3.3-20.8 20.8-11.2-11.2 3.313-3.3 7.162 6.225z"></path>
</svg>`;
const mockSieIconRegistryProvider = {
    provide: SieIconRegistryService,
    useClass: SieIconRegistryMockService
};

/*
 * Public API Surface of sie-icons
 */

/**
 * Generated bundle index. Do not edit.
 */

export { SIE_ICONS, SIE_ICONS_PATH, SieIcon, SieIconLoaderService, SieIconRegistryMockService, SieIconRegistryService, SieIconsComponent, SieIconsModule, mockArrowDownSmallIcon, mockIcon, mockSieIconRegistryProvider, mockUserAccountIcon };
//# sourceMappingURL=siemens-icons.mjs.map
