import { BehaviorSubject } from 'rxjs';
import { SieIconRegisterStatus } from './sie-icon-register-status.enum';
import { SieIcon } from './sie-icons.icons';
import { SieIconLoaderService } from './sie-icon-loader.service';
import * as i0 from "@angular/core";
/**
 * Service responsible for resolving the static asset for a given icon name.
 */
export declare class SieIconRegistryService {
    private readonly iconsPath;
    private readonly iconLoaderService;
    readonly sieIcon: typeof SieIcon;
    private readonly registry;
    constructor(iconsPath: string, iconLoaderService: SieIconLoaderService);
    register(uniqueId: SieIcon): SieIconRegisterStatus;
    register(uniqueId: string, url: string, fallbackIcon?: SieIcon): SieIconRegisterStatus;
    getIcon(uniqueId: string): BehaviorSubject<string>;
    getInternalIconPath(iconName: SieIcon): string;
    private loadAsset;
    static ɵfac: i0.ɵɵFactoryDeclaration<SieIconRegistryService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<SieIconRegistryService>;
}
//# sourceMappingURL=sie-icon-registry.service.d.ts.map