import { ElementRef, OnDestroy } from '@angular/core';
import { Subject } from 'rxjs';
import { SieIconRegistryService } from './sie-icon-registry.service';
import { SieIcon } from './sie-icons.icons';
import { SieIconSanitizerService } from './sie-icon-sanitizer.service';
import * as i0 from "@angular/core";
/**
 * # Icon component
 * Component to display icons. It can take icon names and take care about resolving the static asset in the background.
 *
 * ## Code example
 * @example ```html
 * <sie-icon [name]="'Home'"></sie-icon>
 * ```
 */
export declare class SieIconsComponent implements OnDestroy {
    private readonly element;
    private readonly iconReg;
    private readonly document;
    private readonly sanitizerService;
    set name(iconName: SieIcon | string);
    set svgClass(value: string);
    inheritSize: boolean;
    readonly iconChanged: Subject<void>;
    get svgIcon(): SVGElement;
    private className;
    private iconSub;
    private _svgIcon;
    private _svgClass;
    constructor(element: ElementRef, iconReg: SieIconRegistryService, document: Document, sanitizerService: SieIconSanitizerService);
    ngOnDestroy(): void;
    private updateIcon;
    private magic;
    private svgElementFromString;
    private setSvgClass;
    private setSvgStyles;
    static ɵfac: i0.ɵɵFactoryDeclaration<SieIconsComponent, [null, null, { optional: true; }, null]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<SieIconsComponent, "sie-icon", never, { "name": { "alias": "name"; "required": false; }; "svgClass": { "alias": "svgClass"; "required": false; }; "inheritSize": { "alias": "inheritSize"; "required": false; }; }, { "iconChanged": "iconChanged"; }, never, ["*"], false, never>;
}
//# sourceMappingURL=sie-icons.component.d.ts.map