import { ModuleWithProviders } from '@angular/core';
import { SieIconsConfiguration } from './sie-icons-configuration.model';
import * as i0 from "@angular/core";
import * as i1 from "./sie-icons.component";
/**
 * # Icon Module
 * Module for handling the icons throughout the components. This module needs to be configured in the root module to define the entry point for the static assets.
 *
 * ## Module Content
 * - {@link SieIconsComponent}
 * - {@link SieIconRegistryService}
 * - {@link SieIcon}
 *
 * ## Module configuration
 * @example
 * ```ts
 * @NgModule({
 *   imports: [
 *     SieIconsModule.forRoot(),
 *     ...
 *   ],
 *   ...
 * })
 * ```
 * For an alternative asset path configuration checkout {@link SieIconsConfiguration} which can be passed to the `forRoot` method.
 */
export declare class SieIconsModule {
    static forRoot(config?: SieIconsConfiguration): ModuleWithProviders<SieIconsModule>;
    static forChild(): ModuleWithProviders<SieIconsModule>;
    static ɵfac: i0.ɵɵFactoryDeclaration<SieIconsModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<SieIconsModule, [typeof i1.SieIconsComponent], never, [typeof i1.SieIconsComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<SieIconsModule>;
}
//# sourceMappingURL=sie-icons.module.d.ts.map