import * as i0 from "@angular/core";
export declare class CdkOverlayService {
    private readonly document;
    constructor(document: Document);
    isOverlayActive(): boolean;
    addOverlayOnTopModifier(): void;
    removeOverlayOnTopModifier(): void;
    /**
     * The `ngx-smart-modal` component implemented a focus trap
     * https://github.com/maximelafarie/ngx-smart-modal/blob/master/src/ngx-smart-modal/src/services/ngx-smart-modal.service.ts#L486 that is
     * that is incompatible with the cdk overlay component as the element is created outside the modal container
     * https://github.com/angular/components/blob/main/src/cdk/overlay/overlay-container.ts#L81.
     *
     */
    deactivateModalFocusTrap(): void;
    /**
     * Reverts the effect from `deactivateModalFocusTrap`
     * @see CdkOverlayService#deactivateModalFocusTrap
     */
    reactivateModalFocusTrap(): void;
    getOverlay(): Element;
    static ɵfac: i0.ɵɵFactoryDeclaration<CdkOverlayService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<CdkOverlayService>;
}
//# sourceMappingURL=cdk-overlay.service.d.ts.map