import * as i0 from "@angular/core";
/**
 * This service is used for components that are preventing that key-up event for certain keys
 * is prevented after key-down.
 * This is useful for components like the following to prevent that Escape key closes the modal
 *  - dropdown
 *  - menu-button
 *  - date picker
 *  - date range picker
 */
export declare class UiEventPropagationService {
    protected preventPropagation: boolean;
    startPrevention(): void;
    stopPrevention(): void;
    handleEvent(event: KeyboardEvent): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<UiEventPropagationService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<UiEventPropagationService>;
}
//# sourceMappingURL=ui-event-propagation.service.d.ts.map