import { UiBaseRouterDirective } from './ui-base-router.directive';
import { UiNestedListComponent } from '../../ui-nested-list/ui-nested-list.component';
import { Router } from '@angular/router';
import { UiNestedListLinkItemClicked } from '../../ui-nested-list/ui-nested-list.model';
import * as i0 from "@angular/core";
/**
 * # Nested List Router Directive
 *
 * Extends {@link UiNestedListComponent} to provide routing functionality
 *
 * When clicking an item the corresponding `item.itemLink` attribute is used from the corresponding object
 * {@link UiNestedListLinkItemClicked item}.
 *
 * ## Code example
 * @example ```html
 * <sie-ui-nested-list
 *   sieUiRouted
 *   [nestedListItems]="nestedListItems"
 *   ...
 * ></sie-ui-nested-list>
 * ```
 */
export declare class UiNestedListComponentRouterDirective extends UiBaseRouterDirective<UiNestedListComponent, UiNestedListLinkItemClicked> {
    component: UiNestedListComponent;
    router: Router;
    constructor(component: UiNestedListComponent, router: Router);
    protected preventDefault(event: UiNestedListLinkItemClicked): void;
    protected extractRoute(event: UiNestedListLinkItemClicked): string;
    static ɵfac: i0.ɵɵFactoryDeclaration<UiNestedListComponentRouterDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<UiNestedListComponentRouterDirective, "sie-ui-nested-list[sieUiRouted]", never, {}, {}, never, never, false, never>;
}
//# sourceMappingURL=ui-nested-list-component-router.directive.d.ts.map