import { UiBaseRouterDirective } from './ui-base-router.directive';
import { Router } from '@angular/router';
import { UiOnPageBreadcrumbComponent } from '../../ui-on-page-breadcrumb/ui-on-page-breadcrumb.component';
import { UiBreadcrumbModel } from '../../ui-breadcrumb/ui-breadcrumb.model';
import * as i0 from "@angular/core";
/**
 * # Breadcrumb Router Directive
 *
 * Extends {@link UiOnPageBreadcrumbComponent} to provide routing functionality
 *
 * When clicking an item the corresponding `href` attribute is used from the corresponding object
 * {@link UiBreadcrumbModel item}.
 *
 * ## Code example
 * @example ```html
 * <sie-ui-on-page-breadcrumb
 *   sieUiRouted
 *   [breadcrumbs]="breadcrumbs"
 * ></sie-ui-on-page-breadcrumb>
 * ```
 */
export declare class UiOnPageBreadcrumbComponentRouterDirective extends UiBaseRouterDirective<UiOnPageBreadcrumbComponent, UiBreadcrumbModel> {
    component: UiOnPageBreadcrumbComponent;
    router: Router;
    constructor(component: UiOnPageBreadcrumbComponent, router: Router);
    protected extractRoute(event: UiBreadcrumbModel): string;
    static ɵfac: i0.ɵɵFactoryDeclaration<UiOnPageBreadcrumbComponentRouterDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<UiOnPageBreadcrumbComponentRouterDirective, "sie-ui-on-page-breadcrumb[sieUiRouted]", never, {}, {}, never, never, false, never>;
}
//# sourceMappingURL=ui-on-page-breadcrumb-component-router.directive.d.ts.map