import { PopoverSize } from '../../ui-popover/ui-popover.types';
/**
 * Type of the hint to be displayed
 * - `inline`: Hint is displayed next to the component
 * - `tooltip`: Hint is displayed on hover
 */
export type HintType = 'inline' | 'tooltip';
/**
 * Type for defining a hint to be displayed
 */
export interface HintModel {
    /**
     * Hint text
     */
    content: string;
    /**
     * {@link HintType Type} of hint
     */
    type?: HintType;
    /**
     * {@link PopoverSize Size} of the hint when type = `tooltip`
     */
    size?: PopoverSize;
}
//# sourceMappingURL=hint.model.d.ts.map