import { UiAccordionChanges, UiAccordionItem, UiNewAccordionItem } from '../ui-accordion-types';
import { ViewContainerRef } from '@angular/core';
import { UiAccordionComponentService } from './ui-accordion.component.service';
import { UiAccordionComponent } from './ui-accordion.component';
import { UiDomManipulationService } from '../../shared/services/webcomponents/ui-dom-manipulation.service';
export interface UiAccordionTransformedDomItem {
    headline: string;
    subHeadline: string;
    id: string;
    showTopBorder: boolean;
    headlineBold: boolean;
    icon: string;
    open: boolean;
    customHeaderContent: boolean;
}
export interface UiAccordionTransformedDomItemHeader {
    parentId: string;
}
/**
 * Implementation for web component export
 */
export declare class UiAccordionElementsService implements UiAccordionComponentService<UiAccordionItem, UiAccordionComponent> {
    private readonly domManipulationService;
    private static convertDomItem;
    private static convertDomItemHeader;
    private static checkIndex;
    constructor(domManipulationService: UiDomManipulationService);
    init(component: UiAccordionComponent): void;
    removeAll(component: UiAccordionComponent): void;
    removeItemAt(component: UiAccordionComponent, index: number): void;
    toggleItemAt(component: UiAccordionComponent, index: number): void;
    createNewItem(component: UiAccordionComponent, item: UiNewAccordionItem): void;
    updateItem(component: UiAccordionComponent, index: number, changes: UiAccordionChanges): void;
    renderChild(viewContainer: ViewContainerRef, item: UiAccordionItem): void;
}
//# sourceMappingURL=ui-accordion.component.service.elements.d.ts.map