import { UiButtonModel } from '../ui-button/base/ui-button.model';
import { UiDropdownModel } from '../ui-dropdown/ui-dropdown.model';
export interface ActionsModel extends UiDropdownModel {
    /**
     * Minimum number of selected items to enable/disable action
     */
    minValue?: number;
    /**
     * Maximum number of selected items to enable/disable action
     */
    maxValue?: number;
    /**
     * Label for requirements which have to be met to execute action
     */
    requirementsLabel?: string;
    /**
     * Label for the value in the dropdown options
     */
    valueLabel?: string;
}
export interface ActionBarModel {
    /**
     * Text for the action (label on the left side of the action bar)
     */
    actionText: string;
    /**
     * Array of {@link UiButtonModel buttons} which are available in action bar
     */
    buttonGroup: Array<UiButtonModel>;
    /**
     * Array of {@link ActionsModel actions} which are available in dropdown
     */
    dropdownActions?: Array<ActionsModel>;
}
/**
 * Type of action bar mode:
 * - `page`
 * - `bulkAction`
 */
export type UiActionBarMode = 'page' | 'bulkAction';
//# sourceMappingURL=ui-action-bar.model.d.ts.map