import { SieIcon } from '@siemens/icons';
/**
 * Badge type:
 * - `dot` -> badge acts as a regular dot, the given status indicates the colour, check {@link BadgeStatus}
 * - `icon` -> badge contains an icon, the `status` attribute defines the look, check {@link BadgeIcon}
 * - `counter` -> badge acts as a number display, the `number` attribute defines the used number
 */
export type BadgeType = 'dot' | 'icon' | 'counter';
/**
 * The status is a mapping for the color used in badge mode
 */
export type BadgeStatus = 'success' | 'warning' | 'error' | 'info';
/**
 * Icon used when badge is in icon mode
 */
export type BadgeIcon = SieIcon.SuccessFilled | SieIcon.WarningFilled | SieIcon.ErrorFilled | SieIcon.InformationFilled;
/** @ignore */
export declare const BADGE_ICON_MAPPING: {
    [key in BadgeStatus]: BadgeIcon;
};
//# sourceMappingURL=ui-badge.types.d.ts.map