import { ChangeDetectorRef, OnInit } from '@angular/core';
import { Subject } from 'rxjs';
import { LayoutService } from '@siemens/core';
import { UiButtonClickModel, UiButtonModel } from '../ui-button/base/ui-button.model';
import * as i0 from "@angular/core";
export type ButtonGroupAlignment = 'left' | 'center' | 'right' | 'space-between';
export type ButtonGroupDirection = 'column' | 'row';
export declare class UiButtonGroupComponent implements OnInit {
    private readonly layoutService;
    private readonly cdr;
    buttons: UiButtonModel[];
    fullWidthOnViewportS: boolean;
    wrapButtons: boolean;
    direction: ButtonGroupDirection;
    flexDirection: ButtonGroupDirection;
    fullWidth: boolean;
    set buttonAlignmentClass(alignment: ButtonGroupAlignment);
    buttonClick: Subject<UiButtonClickModel>;
    _buttonAlignmentClass: string;
    model: UiButtonModel;
    private readonly subscription;
    constructor(layoutService: LayoutService, cdr: ChangeDetectorRef);
    ngOnInit(): void;
    onClick(event: Event, button: UiButtonModel): void;
    updateView(): void;
    private subscribeToBreakpointChange;
    private checkBreakpoint;
    private getButtonAlignment;
    getSafeModel(button: UiButtonModel): UiButtonModel;
    static ɵfac: i0.ɵɵFactoryDeclaration<UiButtonGroupComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<UiButtonGroupComponent, "sie-ui-button-group", never, { "buttons": { "alias": "buttons"; "required": false; }; "fullWidthOnViewportS": { "alias": "fullWidthOnViewportS"; "required": false; }; "wrapButtons": { "alias": "wrapButtons"; "required": false; }; "direction": { "alias": "direction"; "required": false; }; "flexDirection": { "alias": "flexDirection"; "required": false; }; "fullWidth": { "alias": "fullWidth"; "required": false; }; "buttonAlignmentClass": { "alias": "buttonAlignmentClass"; "required": false; }; }, { "buttonClick": "buttonClick"; }, never, never, false, never>;
}
//# sourceMappingURL=ui-button-group.component.d.ts.map