import { SieIcon } from '@siemens/icons';
/**
 * Possible types of the button.
 */
export type UiButtonType = 'button' | 'button-submit' | 'link';
/**
 * Possible theme types of the button.
 */
export type UiButtonThemeType = 'main' | 'icon' | 'un-contained';
/**
 * Possible variants of the button.
 */
export type UiButtonVariant = 'primary' | 'secondary' | 'tertiary' | 'icon-with-label' | 'icon-menu' | 'icon-un-contained' | 'icon-contained';
/**
 * Possible positions of where the button can be placed.
 */
export type UiButtonPosition = 'header' | 'content';
/**
 * Possible prominence of the button (used only with the icon buttons).
 */
export type UiButtonProminence = 'secondary' | 'tertiary';
/**
 * Possible positions of where the icon can be placed within button.
 */
export type UiButtonIconPosition = 'leading' | 'trailing';
/** @ignore */
export declare class UiButtonTypes {
    static UiButtonIconMapping: {
        [key: string]: SieIcon;
    };
}
//# sourceMappingURL=ui-button.types.d.ts.map