import { ChangeDetectorRef, EventEmitter, OnChanges, OnDestroy, OnInit, SimpleChanges } from '@angular/core';
import { UiCardEventModel } from './ui-card-event.model';
import { UiButtonClickModel } from '../../ui-button/base/ui-button.model';
import { BreakpointKey, LayoutService } from '@siemens/core';
import { Subject } from 'rxjs';
import { SieIconRegistryService } from '@siemens/icons';
import * as i0 from "@angular/core";
export declare class UiCardEventComponent implements OnInit, OnChanges, OnDestroy {
    layoutService: LayoutService;
    cdr: ChangeDetectorRef;
    readonly iconReg: SieIconRegistryService;
    /**
     * Main source of {@link UiCardEventModel card data}.
     */
    item: UiCardEventModel;
    /**
     * Defines if container-queries or media-queries are used for the card styling
     * @default false
     */
    containerStyled: boolean;
    /**
     * When container-styled used provides container viewport to child
     * @default ''
     */
    viewportContainer: BreakpointKey;
    /**
     * {@link UiCardEventModel Event} triggered when card is clicked
     */
    cardClicked: EventEmitter<UiCardEventModel>;
    /**
     * {@link UiButtonClickModel Event} triggered when the button is clicked.
     */
    buttonClick: Subject<UiButtonClickModel>;
    /** @ignore */
    imageUrl: string;
    /** @ignore */
    breakpointSActive: boolean;
    /** @ignore */
    smallViewport: boolean;
    /** @ignore */
    mediumViewport: boolean;
    private readonly subscription;
    constructor(layoutService: LayoutService, cdr: ChangeDetectorRef, iconReg: SieIconRegistryService);
    /** @ignore */
    ngOnInit(): void;
    /** @ignore */
    ngOnChanges(changes: SimpleChanges): void;
    /** @ignore */
    ngOnDestroy(): void;
    private checkBreakpoint;
    private updateObservables;
    private updateViewportVars;
    /** @ignore */
    onButtonClick(event: Event): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<UiCardEventComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<UiCardEventComponent, "sie-ui-card-event", never, { "item": { "alias": "item"; "required": false; }; "containerStyled": { "alias": "containerStyled"; "required": false; }; "viewportContainer": { "alias": "viewportContainer"; "required": false; }; }, { "cardClicked": "cardClicked"; "buttonClick": "buttonClick"; }, never, never, false, never>;
    static ngAcceptInputType_containerStyled: unknown;
}
//# sourceMappingURL=ui-card-event.component.d.ts.map