import { UiButtonModel } from '../../ui-button/base/ui-button.model';
import { UiPictureModel } from '../../ui-picture/ui-picture.model';
import { UiRouteButtonModel } from '../../ui-route-button/ui-route-button.model';
import { UiModalButtonModel } from '../../ui-modal-button/ui-modal-button.model';
import { UiBaseCardModel, UiVisualizationTypeCard } from '../ui-cards.model';
export interface UiCardPortraitModel extends UiBaseCardModel, UiVisualizationTypeCard {
    /**
     * Defines the category of the item and displays it as a label inside a tag.
     */
    visualTag?: string;
    /**
     * Defines the type of the card (used to determine the placeholder for the image if used).
     */
    itemType?: string;
    /**
     * Defines the {@link UiPictureModel picture data}.
     */
    picture?: UiPictureModel;
    /**
     * Defines the description (copy text).
     */
    description?: string;
    /**
     * Defines the list of benefits.
     */
    benefits?: string[];
    /**
     * Defines the button data. For possible values checkout: {@link UiModalButtonModel modal button model},
     * {@link UiRouteButtonModel route button model} or {@link UiButtonModel button model}.
     */
    button?: UiModalButtonModel | UiRouteButtonModel | UiButtonModel;
    /**
     * Defines if the price should be shown.
     */
    showPrice?: boolean;
    /**
     * Defines the MLFB of the item.
     */
    mlfb?: string;
}
//# sourceMappingURL=ui-card-portrait.model.d.ts.map