import { EventEmitter, OnInit } from '@angular/core';
import { LocaleString, ThemeVariant } from '@siemens/core';
import { SieIcon, SieIconRegistryService } from '@siemens/icons';
import { UiChildActionEventModel } from '../../shared/models/child-action-event.model';
import { UiMenuButtonModel } from '../../ui-menu-button/ui-menu-button.model';
import { UiCardSupportMaterialModel } from './ui-card-support-material.model';
import * as i0 from "@angular/core";
export declare class UiCardSupportMaterialComponent implements OnInit {
    readonly iconReg: SieIconRegistryService;
    item: UiCardSupportMaterialModel;
    menuButtonScreenReaderText: string;
    theme: ThemeVariant;
    target?: string;
    /**
     * Locale being used for formatting purposes
     */
    locale: LocaleString;
    /**
     * Defines if container-queries or media-queries are used for the card styling
     * @default false
     */
    containerStyled: boolean;
    cardChildActionClicked: EventEmitter<UiChildActionEventModel>;
    cardClicked: EventEmitter<UiCardSupportMaterialModel>;
    iconName: SieIcon;
    constructor(iconReg: SieIconRegistryService);
    ngOnInit(): void;
    navigateLink(href: string): void;
    /** @ignore */
    onCardClicked(item: UiCardSupportMaterialModel): void;
    dropdownOptionSelected(button: UiMenuButtonModel, item: UiCardSupportMaterialModel): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<UiCardSupportMaterialComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<UiCardSupportMaterialComponent, "sie-ui-card-support-material", never, { "item": { "alias": "item"; "required": false; }; "menuButtonScreenReaderText": { "alias": "menuButtonScreenReaderText"; "required": false; }; "theme": { "alias": "theme"; "required": false; }; "target": { "alias": "target"; "required": false; }; "locale": { "alias": "locale"; "required": false; }; "containerStyled": { "alias": "containerStyled"; "required": false; }; }, { "cardChildActionClicked": "cardChildActionClicked"; "cardClicked": "cardClicked"; }, never, never, false, never>;
    static ngAcceptInputType_containerStyled: unknown;
}
//# sourceMappingURL=ui-card-support-material.component.d.ts.map