export declare const CARDS_ARRANGEMENT_CONFIG: ArrangementConfig;
export declare const CARDS_ARRANGEMENT_CONFIG_CONTAINER: ArrangementConfig;
export type Orientation = 'landscape' | 'portrait';
export declare const ContainerBreakpointsLandscape: {
    [key in string]: [number, number];
};
export declare const ContainerBreakpointsPortrait: {
    [key in string]: [number, number];
};
export type ViewportSetting = {
    itemsPerPage: number;
    rows: number;
    cols: number;
    titleMaxLines?: number;
    showMedia?: boolean;
};
export type CarouselObject = {
    itemsPerRow: number;
    titleMaxLines?: number;
    showMedia?: boolean;
};
interface OrientationBreakpointConfig {
    [breakpointQuery: string]: CarouselObject;
}
interface OrientationContainerBreakpointConfig {
    [breakpointkey: string]: CarouselObject;
}
export interface ArrangementConfig {
    landscape: OrientationBreakpointConfig | OrientationContainerBreakpointConfig;
    portrait: OrientationBreakpointConfig | OrientationBreakpointConfig;
}
export declare const SMALL_BREAKPOINT_ROW_COUNT = 1;
export declare const LARGE_BREAKPOINT_ROW_COUNT = 2;
export {};
//# sourceMappingURL=ui-cards-arrangement.constants.d.ts.map