import { EventEmitter, OnChanges, OnDestroy, OnInit, SimpleChanges } from '@angular/core';
import { BreakpointKey, ElementResizeDirective, LayoutService, LocaleString, ThemeVariant } from '@siemens/core';
import { UiCardArrangementItem } from '../ui-card-arrangement-item.type';
import { UiButtonClickModel } from '../../ui-button/base/ui-button.model';
import { Observable, Subject } from 'rxjs';
import { Orientation, ViewportSetting } from '../ui-cards-arrangement/ui-cards-arrangement.constants';
import { UiChildActionEventModel } from '../../shared/models/child-action-event.model';
import { UiLinkClickedEventModel } from '../../shared/models/ui-navigation-model';
import * as i0 from "@angular/core";
import * as i1 from "@siemens/core";
export declare class UiCardsContainerComponent implements OnInit, OnChanges, OnDestroy {
    private readonly layoutService;
    private readonly resizeDirective;
    items: UiCardArrangementItem[][];
    orientation: Orientation;
    viewportSettings: ViewportSetting;
    theme: ThemeVariant;
    slideIndex: number;
    menuButtonScreenReaderText: string;
    /**
     * Defines if container-queries or media-queries are used for the cards container styling
     * @default false
     */
    containerStyled: boolean;
    /**
     * Locale being used for formatting purposes
     */
    locale: LocaleString;
    buttonClick: Subject<UiButtonClickModel>;
    childActionClicked: EventEmitter<UiChildActionEventModel>;
    linkClicked: EventEmitter<UiLinkClickedEventModel>;
    cardClicked: EventEmitter<UiCardArrangementItem>;
    containerWidth: Observable<number>;
    cardHeight$: Observable<number>;
    viewportContainer$: Observable<BreakpointKey>;
    private readonly subscriptions;
    /** @ignore */
    containerCssClass: boolean;
    constructor(layoutService: LayoutService, resizeDirective: ElementResizeDirective);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
    onButtonClick(event: UiButtonClickModel): void;
    onChildActionSelected(event: UiChildActionEventModel): void;
    onLinkClicked(event: UiLinkClickedEventModel): void;
    onCardClicked(item: UiCardArrangementItem): void;
    private listenToSizeChange;
    private getCardHeightForBreakpoint;
    static ɵfac: i0.ɵɵFactoryDeclaration<UiCardsContainerComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<UiCardsContainerComponent, "sie-ui-cards-container", never, { "items": { "alias": "items"; "required": false; }; "orientation": { "alias": "orientation"; "required": false; }; "viewportSettings": { "alias": "viewportSettings"; "required": false; }; "theme": { "alias": "theme"; "required": false; }; "slideIndex": { "alias": "slideIndex"; "required": false; }; "menuButtonScreenReaderText": { "alias": "menuButtonScreenReaderText"; "required": false; }; "containerStyled": { "alias": "containerStyled"; "required": false; }; "locale": { "alias": "locale"; "required": false; }; }, { "buttonClick": "buttonClick"; "childActionClicked": "childActionClicked"; "linkClicked": "linkClicked"; "cardClicked": "cardClicked"; "containerWidth": "containerWidth"; }, never, never, false, [{ directive: typeof i1.ElementResizeDirective; inputs: {}; outputs: {}; }]>;
    static ngAcceptInputType_containerStyled: unknown;
}
//# sourceMappingURL=ui-cards-container.component.d.ts.map