import { EventEmitter, OnInit } from '@angular/core';
import { ThemeVariant } from '@siemens/core';
import { PaginationEventModel } from './pagination-event.model';
import * as i0 from "@angular/core";
export declare class BasePaginationDirective implements OnInit {
    /**
     * Defines a list of the ids of the dots that will be shown in the thermometer or dot-pagination.
     * @default empty array
     */
    ids: Array<string>;
    /**
     * Defines the id of the currently selected dot.
     */
    selectedIndex: number;
    /**
     * {@link ThemeVariant Theme} of the dot-pagination or thermometer.
     */
    theme: ThemeVariant;
    /**
     * {@link PaginationEventModel Event} triggered when the selection of the dot in the thermometer or pagination is changed.
     */
    idChanged: EventEmitter<PaginationEventModel>;
    /** @ignore */
    ngOnInit(): void;
    /** @ignore */
    onClick(newIndex: number): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<BasePaginationDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<BasePaginationDirective, never, never, { "ids": { "alias": "ids"; "required": false; }; "selectedIndex": { "alias": "selectedIndex"; "required": false; }; "theme": { "alias": "theme"; "required": false; }; }, { "idChanged": "idChanged"; }, never, never, false, never>;
}
//# sourceMappingURL=base-pagination.directive.d.ts.map