import { OnInit } from '@angular/core';
import { BasePaginationDirective } from '../base-pagination.directive';
import * as i0 from "@angular/core";
/**
 * # Dot Pagination Component
 *
 * Dot Pagination is used on the carousel component when the auto play option is turned off,
 * in order to browse manually through the slides or to use it to navigate to the specific slides we want.
 *
 * ## Component variations
 *
 * There are no variations.
 *
 * ## Content
 *
 * The dot pagination component does not accept any content.
 *
 * ## Code example
 * @example
 * ```html
 * <sie-ui-dot-pagination
 *   [ids]="['1', '2', '3']"
 *   [selectedIndex]="1"
 *   [theme]="'light'"
 * ></sie-ui-dot-pagination>
 * ```
 */
export declare class UiDotPaginationComponent extends BasePaginationDirective implements OnInit {
    /** @ignore */
    smallViewport: boolean;
    /** @ignore */
    readonly maxItemsForSmallDots = 20;
    /** @ignore */
    ngOnInit(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<UiDotPaginationComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<UiDotPaginationComponent, "sie-ui-dot-pagination", never, { "smallViewport": { "alias": "smallViewport"; "required": false; }; }, {}, never, never, false, never>;
}
//# sourceMappingURL=ui-dot-pagination.component.d.ts.map