import { OnInit } from '@angular/core';
import { Direction } from '@siemens/core';
import { BasePaginationDirective } from '../base-pagination.directive';
import * as i0 from "@angular/core";
/**
 * # Thermometer Component
 *
 * Thermometer is used on the carousel component when the auto play option is turned on,
 * in order to browse through the slides or to use it to navigate to the specific slides we want.
 *
 * ## Component variations
 *
 * There are no variations.
 *
 * ## Content
 *
 * The thermometer component does not accept any content.
 *
 * ## Code example
 * @example
 * ```html
 * <sie-ui-thermometer
 *   [ids]="['1', '2', '3']"
 *   [selectedIndex]="1"
 *   [pauseAnimation]="false"
 * ></sie-ui-thermometer>
 * ```
 */
export declare class UiThermometerComponent extends BasePaginationDirective implements OnInit {
    /**
     * Defines in which direction slides will be changed in the carousel.
     * @default 'ltr'
     */
    direction: Direction;
    /**
     * Duration of the animation.
     * @default 10000
     */
    duration: number;
    /**
     * Defines if the animation should be paused.
     * @default false
     */
    pauseAnimation: boolean;
    constructor();
    /** @ignore */
    ngOnInit(): void;
    /** @ignore */
    animationDone(): void;
    /** @ignore */
    onClick(newIndex: number): void;
    private setNextElement;
    static ɵfac: i0.ɵɵFactoryDeclaration<UiThermometerComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<UiThermometerComponent, "sie-ui-thermometer", never, { "direction": { "alias": "direction"; "required": false; }; "duration": { "alias": "duration"; "required": false; }; "pauseAnimation": { "alias": "pauseAnimation"; "required": false; }; }, {}, never, never, false, never>;
}
//# sourceMappingURL=ui-thermometer.component.d.ts.map