import { UiComponentType } from '../shared/services/webcomponents/ui-dom-manipulation.service';
export interface UiBaseCarouselItem {
    /**
     * Defines what identifier does the carousel item have.
     */
    id: string;
}
export type UiCarouselType = 'dots' | 'thermometer';
/**
 * Defines type of each item in the carousel.
 */
export interface UiCarouselItem extends UiBaseCarouselItem, UiComponentType {
}
/**
 * Enumeration to define indexes of position of the slides in the carousel (previous slide, current slide and next slide).
 */
export declare enum SlideGroup {
    /**
     * Index of the previous slide.
     */
    DuplicatesBefore = 0,
    /**
     * Index of the current slide.
     */
    RealSlides = 1,
    /**
     * Index of the next slide.
     */
    DuplicatesAfter = 2
}
export interface UiCarouselScreenReader {
    /**
     * Optional screen reader text for play button
     */
    playButtonText?: string;
    /**
     * Optional screen reader text for pause button
     */
    pauseButtonText?: string;
    /**
     * Optional screen reader text for previous button
     */
    previousButtonText?: string;
    /**
     * Optional screen reader text for next button
     */
    nextButtonText?: string;
    /**
     * Optional screen reader text for title of a slide (e.g. Slide 1 of 10)
     */
    slideNumberText?: string;
    /**
     * Optional screen reader text for controls header
     */
    controlsHeaderText?: string;
}
//# sourceMappingURL=ui-carousel.types.d.ts.map