import { AfterViewInit, ChangeDetectorRef, ElementRef, EventEmitter, OnChanges, SimpleChanges } from '@angular/core';
import { DateFormatService, DateParserService, LayoutService } from '@siemens/core';
import { SieIconRegistryService } from '@siemens/icons';
import { MatDatepicker, MatDatepickerInputEvent } from '@angular/material/datepicker';
import { UiDatePickerBaseDirective } from '../base/ui-date-picker-base.directive';
import { DateAdapter } from '@angular/material/core';
import { UiEventPropagationService } from '../../services/ui-event-propagation.service';
import * as i0 from "@angular/core";
export declare class UiDatePickerComponent extends UiDatePickerBaseDirective<MatDatepicker<Date>> implements AfterViewInit, OnChanges {
    readonly iconReg: SieIconRegistryService;
    readonly layoutService: LayoutService;
    protected dateParser: DateParserService;
    protected dateFormatService: DateFormatService;
    protected cdr: ChangeDetectorRef;
    protected dateAdapter: DateAdapter<Date>;
    readonly eventPropagationService: UiEventPropagationService;
    set date(value: Date);
    get date(): Date;
    customFilterErrorMessage: string;
    dateChange: EventEmitter<Date>;
    datepicker: MatDatepicker<Date>;
    inputField: ElementRef<HTMLInputElement>;
    get hasValue(): boolean;
    get fieldValue(): string;
    set fieldValue(value: string);
    private _fieldValue;
    /**
     * The actual date value that will be emitted
     */
    private currentDateSelection;
    get currentCalendarSelection(): Date;
    set currentCalendarSelection(date: Date);
    private _currentCalendarSelection;
    constructor(iconReg: SieIconRegistryService, layoutService: LayoutService, dateParser: DateParserService, dateFormatService: DateFormatService, cdr: ChangeDetectorRef, dateAdapter: DateAdapter<Date>, eventPropagationService: UiEventPropagationService);
    dateChanged(event: MatDatepickerInputEvent<Date>): void;
    ngAfterViewInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    onCalendarOpen(): void;
    onCalendarClose(): void;
    focusOverlay(): void;
    onFocus(): void;
    onKeyup(event: KeyboardEvent): void;
    onFieldBlur(event: Event): void;
    onInputFieldKeyup(event: KeyboardEvent): void;
    onIconClick(): void;
    focusInputField(): void;
    private updatePlaceholder;
    private updateField;
    protected isValidRequired(): boolean;
    protected isValidRange(): boolean;
    protected onLocaleUpdated(): void;
    protected hasValidValue(): boolean;
    validateDate(): void;
    private customFilter;
    private getFieldDate;
    writeValue(value: Date): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<UiDatePickerComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<UiDatePickerComponent, "sie-ui-date-picker", never, { "date": { "alias": "date"; "required": false; }; "customFilterErrorMessage": { "alias": "customFilterErrorMessage"; "required": false; }; }, { "dateChange": "dateChange"; }, never, never, false, never>;
}
//# sourceMappingURL=ui-date-picker.component.d.ts.map