import { AfterViewInit, ChangeDetectorRef, ElementRef, EventEmitter, OnChanges, OnDestroy, OnInit, SimpleChanges } from '@angular/core';
import { UiDatePickerBaseDirective } from '../base/ui-date-picker-base.directive';
import { MatDatepickerInputEvent, MatDateRangePicker } from '@angular/material/datepicker';
import { SieIconRegistryService } from '@siemens/icons';
import { DateFormatService, DateParserService, LayoutService } from '@siemens/core';
import { MatFormField } from '@angular/material/form-field';
import { UntypedFormGroup } from '@angular/forms';
import { UiDateRangeModel } from './ui-date-range.model';
import { DateAdapter } from '@angular/material/core';
import { UiEventPropagationService } from '../../services/ui-event-propagation.service';
import * as i0 from "@angular/core";
export declare class UiDateRangePickerComponent extends UiDatePickerBaseDirective<MatDateRangePicker<Date>> implements AfterViewInit, OnChanges, OnInit, OnDestroy {
    readonly iconReg: SieIconRegistryService;
    readonly layoutService: LayoutService;
    protected dateParser: DateParserService;
    protected dateFormatService: DateFormatService;
    protected cdr: ChangeDetectorRef;
    protected dateAdapter: DateAdapter<Date>;
    readonly eventPropagationService: UiEventPropagationService;
    set startDate(value: Date);
    get startDate(): Date;
    set endDate(value: Date);
    get endDate(): Date;
    endDateChange: EventEmitter<Date>;
    startDateChange: EventEmitter<Date>;
    dateRangeSelected: EventEmitter<UiDateRangeModel>;
    get hasValue(): boolean;
    endDateErrorMessage: string;
    customFilterStartDateErrorMessage: string;
    customFilterEndDateErrorMessage: string;
    customFilterRangeErrorMessage: string;
    startInputField: ElementRef<HTMLInputElement>;
    endInputField: ElementRef<HTMLInputElement>;
    datepicker: MatDateRangePicker<Date>;
    formField: MatFormField;
    get startDateFieldValue(): string;
    set startDateFieldValue(value: string);
    get endDateFieldValue(): string;
    set endDateFieldValue(value: string);
    get startDatePlaceholder(): string;
    set startDatePlaceholder(value: string);
    get endDatePlaceholder(): string;
    set endDatePlaceholder(value: string);
    get currentCalendarStartDateSelection(): Date;
    get currentCalendarEndDateSelection(): Date;
    /**
     * The actual date values that will be emitted
     */
    private currentStartDateSelection;
    private currentEndDateSelection;
    private _currentCalendarStartDateSelection;
    private _currentCalendarEndDateSelection;
    private _startDateFieldValue;
    private _endDateFieldValue;
    private _startDatePlaceholder;
    private _endDatePlaceholder;
    private additionalValidationRequired;
    private inputTabbed;
    currentCalendarRange: UntypedFormGroup;
    private readonly dateRangeSelectionChangeSubscription;
    constructor(iconReg: SieIconRegistryService, layoutService: LayoutService, dateParser: DateParserService, dateFormatService: DateFormatService, cdr: ChangeDetectorRef, dateAdapter: DateAdapter<Date>, eventPropagationService: UiEventPropagationService);
    ngOnInit(): void;
    ngOnDestroy(): void;
    ngAfterViewInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    onCalendarClose(): void;
    onCalendarOpen(): void;
    dateChanged(event: MatDatepickerInputEvent<Date>): void;
    onFocus(): void;
    onTab(event: KeyboardEvent): void;
    onInputFieldKeyup(event: KeyboardEvent): void;
    onFieldBlur(event: Event): void;
    onIconClick(): void;
    focusInputField(): void;
    validateDate(): void;
    protected isValidRequired(): boolean;
    protected isValidRange(): boolean;
    protected isValidEndDate(): boolean;
    private validateCustomFilterStart;
    private validateCustomFilterEnd;
    private validateCustomFilterRange;
    protected hasValidValue(): boolean;
    private updateField;
    private updatePlaceholder;
    private getFieldDate;
    protected onLocaleUpdated(): void;
    writeValue(obj: UiDateRangeModel): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<UiDateRangePickerComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<UiDateRangePickerComponent, "sie-ui-date-range-picker", never, { "startDate": { "alias": "startDate"; "required": false; }; "endDate": { "alias": "endDate"; "required": false; }; "endDateErrorMessage": { "alias": "endDateErrorMessage"; "required": false; }; "customFilterStartDateErrorMessage": { "alias": "customFilterStartDateErrorMessage"; "required": false; }; "customFilterEndDateErrorMessage": { "alias": "customFilterEndDateErrorMessage"; "required": false; }; "customFilterRangeErrorMessage": { "alias": "customFilterRangeErrorMessage"; "required": false; }; }, { "endDateChange": "endDateChange"; "startDateChange": "startDateChange"; "dateRangeSelected": "dateRangeSelected"; }, never, never, false, never>;
}
//# sourceMappingURL=ui-date-range-picker.component.d.ts.map