/**
 * Donut Chart variant:
 * - `distribution` -> donut chart displays only secondary label
 * - `progress` -> donut chart displays both primary and secondary label
 */
export type UiDonutChartVariant = 'distribution' | 'progress';
export interface UiDonutPartial {
    /**
     * Defines the partial percentage number.
     */
    percentage: number;
    /**
     * Defines the partial color.
     */
    color?: string;
}
export interface UiDonatSegment {
    /**
     * Defines the length of dashes in the stroke of SVG.
     */
    strokeDashArray: string;
    /**
     * Defines the location along an SVG path where the dash of a stroke will begin.
     */
    strokeDashOffset: string;
    /**
     * Defines the segment color.
     */
    color: string;
}
//# sourceMappingURL=ui-donut-chart.types.d.ts.map