/**
 * Possible variants of Drop Zone component.
 * - `default` -> The default drop zone
 * - `invisible` -> It will hide the component but preserve functionality if `fileDropElement` is provided
 */
export type DropZoneVariant = 'default' | 'invisible';
/**
 * Possible alignments of thumbnails.
 * - `vertical` -> The default alignment
 * - `horizontal` -> It will align the thumbnails horizontal
 */
export type ThumbnailAlignment = 'vertical' | 'horizontal';
/**
 * @enum {string}
 * Possible statuses of Drop Zone component.
 */
export declare enum UiDropZoneStatus {
    Default = "default",
    Uploading = "uploading",
    Invalid = "invalid",
    InvalidNumberOfFiles = "invalidNumberOfFiles",
    Error = "error",
    Success = "success",
    Dragover = "dragover",
    Disabled = "disabled"
}
//# sourceMappingURL=ui-drop-zone.types.d.ts.map