import { ElementRef } from '@angular/core';
import { ThemeVariant } from '@siemens/core';
import { UiDropdownOptionType } from '../ui-dropdown-menu/ui-dropdown-menu.model';
import * as i0 from "@angular/core";
/**
 * # Dropdown Menu Component
 * The Dropdown Menu Component is the overlay of the {@link UiDropdownComponent }
 * and therefore a part of the component that cannot be used separately.
 */
export declare class UiDropdownMenuComponent {
    readonly elementRef: ElementRef;
    /**
     * Defines the {@link ThemeVariant theme} of dropdown
     * @default 'light'
     */
    theme: ThemeVariant;
    /**
     * Defines dropdown option type {@link UiDropdownOptionType}
     * @default 'menu'
     */
    type: UiDropdownOptionType;
    /**
     * Defines if menu should be positioned at the bottom
     * @default true
     */
    menuPositionedBottom: boolean;
    constructor(elementRef: ElementRef);
    static ɵfac: i0.ɵɵFactoryDeclaration<UiDropdownMenuComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<UiDropdownMenuComponent, "sie-ui-dropdown-menu", never, { "theme": { "alias": "theme"; "required": false; }; "type": { "alias": "type"; "required": false; }; "menuPositionedBottom": { "alias": "menuPositionedBottom"; "required": false; }; }, {}, never, ["[content]", "[footer]"], false, never>;
}
//# sourceMappingURL=ui-dropdown-menu.component.d.ts.map