import { SieIcon } from '@siemens/icons';
import { PlainObject } from '@siemens/core';
import { BehaviorSubject } from 'rxjs';
export interface UiDropdownMenuModel {
    /** Label of option */
    label: string;
    /** @ignore */
    labelAppendix$?: BehaviorSubject<string>;
    /** Value of the option. Used in conjunction with `selectedValue` to set one option as selected by default. */
    value: string;
    /** Boolean to set disabled state */
    disabled?: boolean;
    /** Additional data attributes */
    dataAttributes?: PlainObject;
    /** Icon inside the dropdown {@link SieIcon} */
    icon?: SieIcon;
}
/**
 * Defines dropdown option type
 */
export type UiDropdownOptionType = 'dropdown-contained' | 'dropdown-un-contained' | 'menu';
/**
 * Defines style of dropdown options menu
 */
export type UiDropdownSelectionType = 'single' | 'multiple';
//# sourceMappingURL=ui-dropdown-menu.model.d.ts.map