export declare enum ArrowDirection {
    Up = 0,
    Down = 1
}
interface DisableOption {
    disabled?: boolean;
}
/**
 * This service is used to handle data and display parameters for the ui-dropdown component.
 */
export declare class UiDropdownService {
    /** @ignore */
    static getDirectionForKey(e: KeyboardEvent): ArrowDirection | null;
    /**
     * This method finds and returns the first selectable item in a dropdown
     * @param {index} index  - index of current item
     * @param {direction} direction  - {@link ArrowDirection}
     * @param {options} options  - {@link DisableOption}
     * @returns {index}
     */
    static nextSelectableIndexForKey(index: number, direction: ArrowDirection, options: DisableOption[]): number;
    /** @ignore */
    static allDisabled(options: DisableOption[]): boolean;
}
export {};
//# sourceMappingURL=ui-dropdown.service.d.ts.map