import { ChangeDetectorRef, AfterViewInit, EventEmitter, OnInit, OnDestroy } from '@angular/core';
import { SieIconRegistryService } from '@siemens/icons';
import { UiModalComponent } from '../ui-modals';
import { Observable, Subject } from 'rxjs';
import { ActivatedRoute } from '@angular/router';
import { LocaleService } from '@siemens/core';
import { DomSanitizer, SafeUrl } from '@angular/platform-browser';
import { AnimationEvent } from '@angular/animations';
import * as i0 from "@angular/core";
export declare class UiFeedbackFormComponent implements OnInit, AfterViewInit, OnDestroy {
    private readonly cdr;
    readonly iconReg: SieIconRegistryService;
    private readonly localeService;
    private readonly activatedRoute;
    private readonly sanitizer;
    private animationStateThumbsUp;
    private animationStateThumbsDown;
    private animationStateCircle;
    private readonly subscriptions;
    playAnimation: boolean;
    _feedbackFormUrl: SafeUrl;
    set feedbackFormUrl(feedbackFormUrl: string);
    screenReaderCloseIcon: string;
    tooltipText: string;
    buttonScreenReaderText: string;
    animationDelayMS: number;
    animationStopExpirationDate: Date;
    openDialog$: Observable<boolean>;
    animatePopover: Subject<boolean>;
    clicked: EventEmitter<boolean>;
    animationSeen: EventEmitter<boolean>;
    modalClosed: EventEmitter<void>;
    feedbackModal: UiModalComponent;
    constructor(cdr: ChangeDetectorRef, iconReg: SieIconRegistryService, localeService: LocaleService, activatedRoute: ActivatedRoute, sanitizer: DomSanitizer);
    get animationCircle(): string;
    get animationThumbsUp(): string;
    get animationThumbsDown(): string;
    ngOnInit(): void;
    ngOnDestroy(): void;
    ngAfterViewInit(): void;
    onAnimationDone(e: AnimationEvent): void;
    onClick(): void;
    onModalClose(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<UiFeedbackFormComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<UiFeedbackFormComponent, "sie-ui-feedback-form", never, { "feedbackFormUrl": { "alias": "feedbackFormUrl"; "required": false; }; "screenReaderCloseIcon": { "alias": "screenReaderCloseIcon"; "required": false; }; "tooltipText": { "alias": "tooltipText"; "required": false; }; "buttonScreenReaderText": { "alias": "buttonScreenReaderText"; "required": false; }; "animationDelayMS": { "alias": "animationDelayMS"; "required": false; }; "animationStopExpirationDate": { "alias": "animationStopExpirationDate"; "required": false; }; "openDialog$": { "alias": "openDialog$"; "required": false; }; }, { "animatePopover": "animatePopover"; "clicked": "clicked"; "animationSeen": "animationSeen"; "modalClosed": "modalClosed"; }, never, never, false, never>;
}
//# sourceMappingURL=ui-feedback-form.component.d.ts.map