import { ChangeDetectorRef, OnDestroy, OnInit } from '@angular/core';
import { LayoutService } from '@siemens/core';
import { Subject } from 'rxjs';
import { SieIconRegistryService } from '@siemens/icons';
import { UiFilterHeaderModel, UiFilterHeaderTagGroupModel } from './ui-filter-header.model';
import { UiFilterChangesModel } from '../ui-filter/ui-filter.model';
import * as i0 from "@angular/core";
export declare class UiFilterHeaderComponent implements OnInit, OnDestroy {
    private readonly cdr;
    layoutService: LayoutService;
    iconReg: SieIconRegistryService;
    listLabelScreenReaderText: string;
    showAllButton: boolean;
    showAllButtonText: string;
    resetAllButton: boolean;
    resetAllButtonText: string;
    set filterHeaderInformation(filterHeaderInformation: UiFilterHeaderModel);
    get filterHeaderInformation(): UiFilterHeaderModel;
    filterChangedEvent: Subject<UiFilterChangesModel>;
    private _filterHeaderInformation;
    private filterChanges;
    private readonly subscriptions;
    constructor(cdr: ChangeDetectorRef, layoutService: LayoutService, iconReg: SieIconRegistryService);
    ngOnInit(): void;
    ngOnDestroy(): void;
    onTagSelectionChange(id: string, tagGroup: UiFilterHeaderTagGroupModel): void;
    resetAllFilters(): void;
    private emitDebouncedEvent;
    static ɵfac: i0.ɵɵFactoryDeclaration<UiFilterHeaderComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<UiFilterHeaderComponent, "sie-ui-filter-header", never, { "listLabelScreenReaderText": { "alias": "listLabelScreenReaderText"; "required": false; }; "showAllButton": { "alias": "showAllButton"; "required": false; }; "showAllButtonText": { "alias": "showAllButtonText"; "required": false; }; "resetAllButton": { "alias": "resetAllButton"; "required": false; }; "resetAllButtonText": { "alias": "resetAllButtonText"; "required": false; }; "filterHeaderInformation": { "alias": "filterHeaderInformation"; "required": false; }; }, { "filterChangedEvent": "filterChangedEvent"; }, never, never, false, never>;
}
//# sourceMappingURL=ui-filter-header.component.d.ts.map