import { ChangeDetectorRef, EventEmitter, OnDestroy } from '@angular/core';
import { SieIcon } from '@siemens/icons';
import { NgForm } from '@angular/forms';
import { BehaviorSubject } from 'rxjs';
import { UiButtonGroupComponent } from '../ui-button-group/ui-button-group.component';
import { ModalSizes, UiModalComponent } from '../ui-modals/ui-modal/ui-modal.component';
import { UiButtonClickModel, UiButtonModel } from '../ui-button/base/ui-button.model';
import { LayoutService } from '@siemens/core';
import * as i0 from "@angular/core";
export declare class UiFormModalComponent implements OnDestroy {
    private readonly cdr;
    readonly layoutService: LayoutService;
    modal: UiModalComponent;
    buttonGroup: UiButtonGroupComponent;
    size: ModalSizes;
    form: NgForm;
    modalId?: string;
    headline?: string;
    errorHeadline?: string;
    errorContent?: string;
    saveButtonLabel: string;
    enableSaveButtonOnUnchangedForm: boolean;
    saveButtonIcon?: SieIcon;
    hasAdditionalButton: boolean;
    hasFooterContent: boolean;
    stickyFooter: boolean;
    disabled?: boolean;
    cancelButtonLabel: string;
    closable: boolean;
    errorSpacing: 'l' | 'm';
    set hasFooter(value: boolean);
    get hasFooter(): boolean;
    preventCloseOnSave: boolean;
    preventingCloseOnSave$: BehaviorSubject<boolean>;
    loading: boolean;
    errorState: boolean;
    customLoadingTemplate: boolean;
    private _hasFooter;
    private subscriptions;
    save: EventEmitter<UiButtonClickModel>;
    closed: EventEmitter<void>;
    closedFinished: EventEmitter<void>;
    constructor(cdr: ChangeDetectorRef, layoutService: LayoutService);
    ngOnDestroy(): void;
    openModal(initialFormValue?: unknown): void;
    initializeForm(initialFormValue?: unknown): void;
    openModalWithCustomLoading(initialFormValue?: unknown): void;
    onButtonClick(event: UiButtonClickModel): void;
    setSaveButtonState(data: Partial<UiButtonModel>): void;
    formReady(): void;
    private onFormChanged;
    startSave(): void;
    cancelSave(): void;
    saveSuccessful(): void;
    saveUnsuccessful(disabled?: boolean, errorState?: boolean): void;
    showLoadingState(customLoading?: boolean): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<UiFormModalComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<UiFormModalComponent, "sie-ui-form-modal", never, { "size": { "alias": "size"; "required": false; }; "form": { "alias": "form"; "required": false; }; "modalId": { "alias": "modalId"; "required": false; }; "headline": { "alias": "headline"; "required": false; }; "errorHeadline": { "alias": "errorHeadline"; "required": false; }; "errorContent": { "alias": "errorContent"; "required": false; }; "saveButtonLabel": { "alias": "saveButtonLabel"; "required": false; }; "enableSaveButtonOnUnchangedForm": { "alias": "enableSaveButtonOnUnchangedForm"; "required": false; }; "saveButtonIcon": { "alias": "saveButtonIcon"; "required": false; }; "hasAdditionalButton": { "alias": "hasAdditionalButton"; "required": false; }; "hasFooterContent": { "alias": "hasFooterContent"; "required": false; }; "stickyFooter": { "alias": "stickyFooter"; "required": false; }; "disabled": { "alias": "disabled"; "required": false; }; "cancelButtonLabel": { "alias": "cancelButtonLabel"; "required": false; }; "closable": { "alias": "closable"; "required": false; }; "errorSpacing": { "alias": "errorSpacing"; "required": false; }; "hasFooter": { "alias": "hasFooter"; "required": false; }; "preventCloseOnSave": { "alias": "preventCloseOnSave"; "required": false; }; }, { "save": "save"; "closed": "closed"; "closedFinished": "closedFinished"; }, never, ["[loading-content]", "*", "[slot=footer-content]", "[slot=single-button]"], false, never>;
}
//# sourceMappingURL=ui-form-modal.component.d.ts.map