import { AfterViewInit, ChangeDetectorRef, ElementRef, EventEmitter, OnChanges, OnDestroy, OnInit, SimpleChanges } from '@angular/core';
import { LayoutService, LocaleService } from '@siemens/core';
import { SieIconRegistryService } from '@siemens/icons';
import { BehaviorSubject } from 'rxjs';
import { UiHeaderQuoteModeModel } from './ui-header.model';
import * as i0 from "@angular/core";
export declare class UiHeaderComponent implements OnInit, OnDestroy, AfterViewInit, OnChanges {
    private readonly cdr;
    readonly layoutService: LayoutService;
    readonly iconReg: SieIconRegistryService;
    readonly localeService: LocaleService;
    messageBoxComponentContainer: ElementRef;
    homeUrl: string;
    isMinimized: boolean;
    isNavigationOverlayOpen: boolean;
    shouldScrollInOverlay: boolean;
    isLoggedIn: boolean;
    platformName: string;
    logoNameSR: string;
    maintenanceMessage: string;
    regionalMessage: string;
    screenReaderCloseIcon: string;
    quoteMode: UiHeaderQuoteModeModel;
    quoteModeDismiss: EventEmitter<void>;
    regionalMessageClosed: EventEmitter<void>;
    private breakpointChangeSub;
    contentHeight$: BehaviorSubject<string>;
    messageBoxHeight$: BehaviorSubject<string>;
    isMinimizedAfterAnimation: boolean;
    headerHeightValue: string;
    constructor(cdr: ChangeDetectorRef, layoutService: LayoutService, iconReg: SieIconRegistryService, localeService: LocaleService);
    ngOnInit(): void;
    ngOnDestroy(): void;
    ngAfterViewInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    onAnimationEvent(): void;
    calculateHeaderHeight(): void;
    onMaintenanceMessageClose(): void;
    onRegionalMessageClose(): void;
    onQuotesMessageDismiss(): void;
    private debouncedCheckNavigationPosition;
    private checkNavigationPosition;
    static ɵfac: i0.ɵɵFactoryDeclaration<UiHeaderComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<UiHeaderComponent, "sie-ui-header", never, { "homeUrl": { "alias": "homeUrl"; "required": false; }; "isMinimized": { "alias": "isMinimized"; "required": false; }; "isNavigationOverlayOpen": { "alias": "isNavigationOverlayOpen"; "required": false; }; "shouldScrollInOverlay": { "alias": "shouldScrollInOverlay"; "required": false; }; "isLoggedIn": { "alias": "isLoggedIn"; "required": false; }; "platformName": { "alias": "platformName"; "required": false; }; "logoNameSR": { "alias": "logoNameSR"; "required": false; }; "maintenanceMessage": { "alias": "maintenanceMessage"; "required": false; }; "regionalMessage": { "alias": "regionalMessage"; "required": false; }; "screenReaderCloseIcon": { "alias": "screenReaderCloseIcon"; "required": false; }; "quoteMode": { "alias": "quoteMode"; "required": false; }; }, { "quoteModeDismiss": "quoteModeDismiss"; "regionalMessageClosed": "regionalMessageClosed"; }, never, ["[main-navigation]", "[header-search]", "[header-quick-access]"], false, never>;
}
//# sourceMappingURL=ui-header.component.d.ts.map