import { ChangeDetectorRef } from '@angular/core';
import { InputBaseDirective } from '../ui-input-base.directive';
import { SieIcon, SieIconRegistryService } from '@siemens/icons';
import * as i0 from "@angular/core";
/**
 * # Password Input Component
 *
 * Text input allows users to prompt passwords
 *
 * ## Component variations
 * - Standard variation
 *
 * ## Content
 *
 * The Password input component does not accept any content.
 *
 * ## Code example
 * @example ```html
 * <sie-ui-password-input
 *   label="New password"
 *   [hint]="{ content: 'Please at least a character, a digit and minimum one special characters for your password!' }"
 *   validationPattern="^(?=.*[a-z])(?=.*[A-Z])(?=.*\d)[A-Za-z\d@$!%*?&]{8,}$"
 *   placeholder="New password (placeholder)"
 * ></sie-ui-password-input>
 * ```
 */
export declare class UiPasswordInputComponent extends InputBaseDirective {
    readonly iconReg: SieIconRegistryService;
    readonly cdr: ChangeDetectorRef;
    /** @ignore */
    iconName: SieIcon;
    constructor(iconReg: SieIconRegistryService, cdr: ChangeDetectorRef);
    /** @ignore */
    toggleInputType(e: Event, element: HTMLInputElement): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<UiPasswordInputComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<UiPasswordInputComponent, "sie-ui-password-input", never, {}, {}, never, never, false, never>;
}
//# sourceMappingURL=ui-password-input.component.d.ts.map