import { ChangeDetectorRef } from '@angular/core';
import { InputBaseDirective } from '../ui-input-base.directive';
import { UiTextInputType } from '../ui-input.model';
import { SieIconRegistryService } from '@siemens/icons';
import * as i0 from "@angular/core";
/**
 * # Text Input Component
 *
 * Text input allows users to add free text input.
 *
 * ## Component variations
 * - Standard variation
 * - Condensed variation
 *
 * ## Content
 *
 * The Text input component does not accept any content.
 *
 * ## Code example
 * @example ```html
 * <sie-ui-text-input label="Headline" placeholder="Put in the headline you want"></sie-ui-text-input>
 * ```
 */
export declare class UiTextInputComponent extends InputBaseDirective {
    readonly cdr: ChangeDetectorRef;
    readonly iconReg: SieIconRegistryService;
    constructor(cdr: ChangeDetectorRef, iconReg: SieIconRegistryService);
    /**
     * Defines which type the input component should use
     * @default 'text'
     */
    inputType: UiTextInputType;
    /** @ignore */
    placeholderIcon: boolean;
    static ɵfac: i0.ɵɵFactoryDeclaration<UiTextInputComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<UiTextInputComponent, "sie-ui-text-input", never, { "inputType": { "alias": "inputType"; "required": false; }; "placeholderIcon": { "alias": "placeholderIcon"; "required": false; }; }, {}, never, never, false, never>;
}
//# sourceMappingURL=ui-text-input.component.d.ts.map