import { ChangeDetectorRef } from '@angular/core';
import { InputBaseDirective } from '../ui-input-base.directive';
import * as i0 from "@angular/core";
/**
 * # Textarea Input Component
 *
 * Textarea allow users to add free text input. It is used when multi-line input is expected (e.g. descriptions).
 *
 * ## Component variations
 * - Standard variation
 * - Condensed variation
 *
 * ## Content
 *
 * The Textarea component does not accept any content.
 *
 * ## Code example
 * @example ```html
 * <sie-ui-textarea label="Reply" placeholder="Put in your message that you want to reply"></sie-ui-textarea>
 * ```
 */
export declare class UiTextareaComponent extends InputBaseDirective {
    readonly cdr: ChangeDetectorRef;
    constructor(cdr: ChangeDetectorRef);
    static ɵfac: i0.ɵɵFactoryDeclaration<UiTextareaComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<UiTextareaComponent, "sie-ui-textarea", never, {}, {}, never, never, false, never>;
}
//# sourceMappingURL=ui-textarea.component.d.ts.map