import { Subject } from 'rxjs';
import { ChangeDetectorRef, OnInit } from '@angular/core';
import { SieIcon, SieIconRegistryService } from '@siemens/icons';
import { AppRegion } from '@siemens/core';
import { UiRegionLanguageSelectModel } from '../ui-language-selector.model';
import { UiLanguageSelectorService } from '../ui-language-selector.service';
import * as i0 from "@angular/core";
export declare class UiLanguageSelectorItemComponent implements OnInit {
    readonly iconReg: SieIconRegistryService;
    private readonly uiLanguageSelectorService;
    cdr: ChangeDetectorRef;
    languageSelectorItem: AppRegion;
    isCurrentRegion: boolean;
    highlightText: string;
    regionLanguageSelected: Subject<UiRegionLanguageSelectModel>;
    isHovered: boolean;
    isLanguageHovered: boolean;
    globeIconName: SieIcon;
    constructor(iconReg: SieIconRegistryService, uiLanguageSelectorService: UiLanguageSelectorService, cdr: ChangeDetectorRef);
    ngOnInit(): void;
    onRegionLanguageSelect(event: Event, language: string, region: string): void;
    mouseEnter(isLanguageHovered?: boolean): void;
    mouseLeave(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<UiLanguageSelectorItemComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<UiLanguageSelectorItemComponent, "sie-ui-language-selector-item", never, { "languageSelectorItem": { "alias": "languageSelectorItem"; "required": false; }; "isCurrentRegion": { "alias": "isCurrentRegion"; "required": false; }; "highlightText": { "alias": "highlightText"; "required": false; }; }, { "regionLanguageSelected": "regionLanguageSelected"; }, never, never, false, never>;
}
//# sourceMappingURL=ui-language-selector-item.component.d.ts.map