import { Subject } from 'rxjs';
import { OnDestroy } from '@angular/core';
import { SieIconRegistryService } from '@siemens/icons';
import { AppRegion, LocaleService } from '@siemens/core';
import { UiRegionLanguageSelectModel } from './ui-language-selector.model';
import * as i0 from "@angular/core";
export declare class UiLanguageSelectorComponent implements OnDestroy {
    readonly iconReg: SieIconRegistryService;
    readonly localeService: LocaleService;
    currentRegion: AppRegion;
    languageSelectorItems: Array<AppRegion>;
    currentRegionTitle: string;
    changeRegionTitle: string;
    searchRegionPlaceholder: string;
    regionLanguageSelected: Subject<UiRegionLanguageSelectModel>;
    triggerSearchRegionChange: Subject<string>;
    triggerResetFilteredRegions: Subject<boolean>;
    highlightText: string;
    constructor(iconReg: SieIconRegistryService, localeService: LocaleService);
    ngOnDestroy(): void;
    onRegionLanguageSelect(event: UiRegionLanguageSelectModel): void;
    onSearchRegionChange(searchTerm: string): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<UiLanguageSelectorComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<UiLanguageSelectorComponent, "sie-ui-language-selector", never, { "currentRegion": { "alias": "currentRegion"; "required": false; }; "languageSelectorItems": { "alias": "languageSelectorItems"; "required": false; }; "currentRegionTitle": { "alias": "currentRegionTitle"; "required": false; }; "changeRegionTitle": { "alias": "changeRegionTitle"; "required": false; }; "searchRegionPlaceholder": { "alias": "searchRegionPlaceholder"; "required": false; }; }, { "regionLanguageSelected": "regionLanguageSelected"; "triggerSearchRegionChange": "triggerSearchRegionChange"; "triggerResetFilteredRegions": "triggerResetFilteredRegions"; }, never, never, false, never>;
}
//# sourceMappingURL=ui-language-selector.component.d.ts.map