import { ChangeDetectorRef, EventEmitter, OnInit } from '@angular/core';
import { LayoutService } from '@siemens/core';
import { SieIconRegistryService } from '@siemens/icons';
import { Subject } from 'rxjs';
import { UiDropdownModel } from '../ui-dropdown';
import * as i0 from "@angular/core";
export declare class UiListNavigatorHeaderComponent implements OnInit {
    protected cdr: ChangeDetectorRef;
    layoutService: LayoutService;
    iconReg: SieIconRegistryService;
    totalResultsCount: number;
    totalResultsCountText: string;
    noResultsText: string;
    loadingResultsText: string;
    activePage: number;
    filterButtonName: string;
    sortByLabel: string;
    sortByOptions: Array<UiDropdownModel>;
    sortBySelectedOptionId: string;
    showFilterSlot: boolean;
    showFilterButton: boolean;
    showOptions: boolean;
    showExtendAll: boolean;
    showBulkSelect: boolean;
    showOptionsHint: boolean;
    showGeneralHint: boolean;
    generalHint: string;
    loading: boolean;
    spellingCorrectionFirstLabel: string;
    spellingCorrectionSecondLabel: string;
    spellingCorrectionSearchTerm: string;
    selectAllParameters: {
        label: string;
        value: boolean;
        indeterminate: boolean;
    };
    filterButtonClicked: Subject<void>;
    spellCheckLinkClicked: Subject<void>;
    selectAllClicked: Subject<boolean>;
    selectedSortOption: EventEmitter<string>;
    constructor(cdr: ChangeDetectorRef, layoutService: LayoutService, iconReg: SieIconRegistryService);
    ngOnInit(): void;
    onButtonClick(): void;
    onSortChanged(event: string): void;
    onSpellCheckHintClicked(event: Event): void;
    onChangeSelectAll(state: boolean): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<UiListNavigatorHeaderComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<UiListNavigatorHeaderComponent, "sie-ui-list-navigator-header", never, { "totalResultsCount": { "alias": "totalResultsCount"; "required": false; }; "totalResultsCountText": { "alias": "totalResultsCountText"; "required": false; }; "noResultsText": { "alias": "noResultsText"; "required": false; }; "loadingResultsText": { "alias": "loadingResultsText"; "required": false; }; "activePage": { "alias": "activePage"; "required": false; }; "filterButtonName": { "alias": "filterButtonName"; "required": false; }; "sortByLabel": { "alias": "sortByLabel"; "required": false; }; "sortByOptions": { "alias": "sortByOptions"; "required": false; }; "sortBySelectedOptionId": { "alias": "sortBySelectedOptionId"; "required": false; }; "showFilterSlot": { "alias": "showFilterSlot"; "required": false; }; "showFilterButton": { "alias": "showFilterButton"; "required": false; }; "showOptions": { "alias": "showOptions"; "required": false; }; "showExtendAll": { "alias": "showExtendAll"; "required": false; }; "showBulkSelect": { "alias": "showBulkSelect"; "required": false; }; "showOptionsHint": { "alias": "showOptionsHint"; "required": false; }; "showGeneralHint": { "alias": "showGeneralHint"; "required": false; }; "generalHint": { "alias": "generalHint"; "required": false; }; "loading": { "alias": "loading"; "required": false; }; "spellingCorrectionFirstLabel": { "alias": "spellingCorrectionFirstLabel"; "required": false; }; "spellingCorrectionSecondLabel": { "alias": "spellingCorrectionSecondLabel"; "required": false; }; "spellingCorrectionSearchTerm": { "alias": "spellingCorrectionSearchTerm"; "required": false; }; "selectAllParameters": { "alias": "selectAllParameters"; "required": false; }; }, { "filterButtonClicked": "filterButtonClicked"; "spellCheckLinkClicked": "spellCheckLinkClicked"; "selectAllClicked": "selectAllClicked"; "selectedSortOption": "selectedSortOption"; }, never, ["[ShowOptionsHint]", "[ExclusiveContentContainer]", "[SearchFilterHeader]", "[ShowOptionsButton]"], false, never>;
}
//# sourceMappingURL=ui-list-navigator-header.component.d.ts.map