import { Subject } from 'rxjs';
import { ChangeDetectorRef, OnInit } from '@angular/core';
import { UiDropdownModel } from '../../ui-dropdown/ui-dropdown.model';
import { SieIconRegistryService } from '@siemens/icons';
import { BreakpointKey, ComponentBreakpointDefinition } from '@siemens/core';
import { PaginationType } from '../ui-list-navigator-inputs';
import { PaginationSize } from '../../ui-pagination/ui-pagination.types';
import * as i0 from "@angular/core";
export declare class UiListNavigatorFooterComponent implements OnInit {
    readonly iconReg: SieIconRegistryService;
    private readonly cdr;
    showItemPerPageSelector: boolean;
    showBackToTopButton: boolean;
    showPagination: boolean;
    paginationType: PaginationType;
    paginationSize: PaginationSize;
    itemsPerPageText: string;
    backToTopButtonScreenReaderText: string;
    activePage: number;
    limitOfItemsToRender: number;
    resultLimitReachedTooltipLabel: string;
    resultLimitReachedMessageBoxHeadline: string;
    resultLimitReachedMessageBoxMessage: string;
    paginationScreenReader: {
        label: string;
        currentActivePage: string;
        switchToPage: string;
        switchToNextPage: string;
        switchToPreviousPage: string;
    };
    set itemsPerPageOptions(itemsPerPageOptions: number[]);
    get itemsPerPageOptions(): number[];
    set currentItemsPerPageOption(currentItemsPerPageOption: string);
    get currentItemsPerPageOption(): string;
    set totalResultsCount(totalResultsCount: number);
    get totalResultsCount(): number;
    /**
     * Sets the pagination dropdown overlay in top position.
     */
    paginationOverlayOnTop: boolean;
    pageSelected: Subject<number>;
    backToTopClicked: Subject<void>;
    itemsPerPageChanged: Subject<number>;
    readonly componentViewports: ComponentBreakpointDefinition;
    itemsPerPage: UiDropdownModel[];
    totalPages: number;
    breakpoint: BreakpointKey;
    resultLimitReached: boolean;
    private _currentItemsPerPageOption;
    private _itemsPerPageOptions;
    private _totalResultsCount;
    constructor(iconReg: SieIconRegistryService, cdr: ChangeDetectorRef);
    ngOnInit(): void;
    setBreakpoint(breakpoint: BreakpointKey): void;
    updateItemsPerPage(value: string): void;
    onPageSelection(page: number): void;
    private updateFooterInformation;
    static ɵfac: i0.ɵɵFactoryDeclaration<UiListNavigatorFooterComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<UiListNavigatorFooterComponent, "sie-ui-list-navigator-footer", never, { "showItemPerPageSelector": { "alias": "showItemPerPageSelector"; "required": false; }; "showBackToTopButton": { "alias": "showBackToTopButton"; "required": false; }; "showPagination": { "alias": "showPagination"; "required": false; }; "paginationType": { "alias": "paginationType"; "required": false; }; "paginationSize": { "alias": "paginationSize"; "required": false; }; "itemsPerPageText": { "alias": "itemsPerPageText"; "required": false; }; "backToTopButtonScreenReaderText": { "alias": "backToTopButtonScreenReaderText"; "required": false; }; "activePage": { "alias": "activePage"; "required": false; }; "limitOfItemsToRender": { "alias": "limitOfItemsToRender"; "required": false; }; "resultLimitReachedTooltipLabel": { "alias": "resultLimitReachedTooltipLabel"; "required": false; }; "resultLimitReachedMessageBoxHeadline": { "alias": "resultLimitReachedMessageBoxHeadline"; "required": false; }; "resultLimitReachedMessageBoxMessage": { "alias": "resultLimitReachedMessageBoxMessage"; "required": false; }; "paginationScreenReader": { "alias": "paginationScreenReader"; "required": false; }; "itemsPerPageOptions": { "alias": "itemsPerPageOptions"; "required": false; }; "currentItemsPerPageOption": { "alias": "currentItemsPerPageOption"; "required": false; }; "totalResultsCount": { "alias": "totalResultsCount"; "required": false; }; "paginationOverlayOnTop": { "alias": "paginationOverlayOnTop"; "required": false; }; }, { "pageSelected": "pageSelected"; "backToTopClicked": "backToTopClicked"; "itemsPerPageChanged": "itemsPerPageChanged"; }, never, never, false, never>;
}
//# sourceMappingURL=ui-list-navigator-footer.component.d.ts.map