import { Type } from '@angular/core';
import { PlainObject } from '@siemens/core';
/**
 * Possible pagination types
 */
export declare type PaginationType = 'default' | 'infinite';
export interface UiListNavigatorInputs<ItemData> {
    itemComponents: Type<any>[];
    itemData: ItemData[];
    bulkMode: boolean;
    loading: boolean;
    emptyStateHeadline: string;
    emptyStateText: string;
}
/**
 * Defines additional data attributes which are attached to result list and footer sections
 */
export interface UiListDataAttributeWrapper {
    /**
     * Defines data attributes for div class="list__results"
     * possible value: { 'data-ste-component': 'resultlist' }
     */
    resultAttributes?: PlainObject;
    /**
     * Defines data attributes for div class="navigator-footer"
     */
    footerAttributes?: PlainObject;
}
/**
 * Defines screen reader text inputs for pagination
 */
export interface UiPaginationScreenReaderInputs {
    /**
     * Text for pagination label
     */
    label: string;
    /**
     * Text for current active page
     */
    currentActivePage: string;
    /**
     * Text for switch to page button
     */
    switchToPage: string;
    /**
     * Text for switch to next button page
     */
    switchToNextPage: string;
    /**
     * Text for switch to previous page button
     */
    switchToPreviousPage: string;
}
//# sourceMappingURL=ui-list-navigator-inputs.d.ts.map