import { ChangeDetectorRef, OnChanges, OnDestroy, SimpleChanges, Type } from '@angular/core';
import { Observable, Subject } from 'rxjs';
import { UIListItemAppearance, UIListItemType } from '../ui-list.types';
import { UiAdvancedListItemSelectionChangeData, UiListItemDirective, UiListItemEvent } from '../ui-list-item/ui-list-item.directive';
import { UiListItemComponent } from '../ui-list-item/ui-list-item.component';
import * as i0 from "@angular/core";
export declare class UiDynamicListItemComponent implements OnDestroy, OnChanges {
    protected cdr: ChangeDetectorRef;
    itemHost: UiListItemDirective<any>;
    get component(): any;
    set component(component: Type<any>);
    private _component;
    itemData: any;
    loading: boolean;
    loadingChildren: boolean;
    loadingMore: boolean;
    itemType: UIListItemType;
    itemAppearance: UIListItemAppearance;
    condensed: boolean;
    bulkMode: boolean;
    dismissable: boolean;
    isSelected$: Observable<Array<string>>;
    expandableButtonMore: string;
    expandableButtonLess: string;
    trackHover: boolean;
    index: number;
    showCatalogConfigureProducts: boolean;
    showStatusIndicator: boolean;
    selectionChanged: Subject<UiAdvancedListItemSelectionChangeData>;
    itemEvent: Subject<UiListItemEvent<unknown, import("@siemens/core").PlainObject>>;
    listItemComponent: UiListItemComponent;
    get classes(): string;
    get concreteComponent(): any;
    private _componentRef;
    constructor(cdr: ChangeDetectorRef);
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
    updateView(): void;
    private createComponent;
    private setListWideDefaultsToInstance;
    static ɵfac: i0.ɵɵFactoryDeclaration<UiDynamicListItemComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<UiDynamicListItemComponent, "li[sie-ui-dynamic-list-item]", never, { "component": { "alias": "component"; "required": false; }; "itemData": { "alias": "itemData"; "required": false; }; "loading": { "alias": "loading"; "required": false; }; "loadingChildren": { "alias": "loadingChildren"; "required": false; }; "loadingMore": { "alias": "loadingMore"; "required": false; }; "itemType": { "alias": "itemType"; "required": false; }; "itemAppearance": { "alias": "itemAppearance"; "required": false; }; "condensed": { "alias": "condensed"; "required": false; }; "bulkMode": { "alias": "bulkMode"; "required": false; }; "dismissable": { "alias": "dismissable"; "required": false; }; "isSelected$": { "alias": "isSelected$"; "required": false; }; "expandableButtonMore": { "alias": "expandableButtonMore"; "required": false; }; "expandableButtonLess": { "alias": "expandableButtonLess"; "required": false; }; "trackHover": { "alias": "trackHover"; "required": false; }; "index": { "alias": "index"; "required": false; }; "showCatalogConfigureProducts": { "alias": "showCatalogConfigureProducts"; "required": false; }; "showStatusIndicator": { "alias": "showStatusIndicator"; "required": false; }; }, { "selectionChanged": "selectionChanged"; "itemEvent": "itemEvent"; }, never, never, false, never>;
}
//# sourceMappingURL=ui-dynamic-list-item.component.d.ts.map