import { ChangeDetectorRef, OnChanges, SimpleChanges } from '@angular/core';
import { LayoutService } from '@siemens/core';
import { UiListItemDirective } from './ui-list-item.directive';
import { SieIconRegistryService } from '@siemens/icons';
import { AnimationEvent } from '@angular/animations';
import * as i0 from "@angular/core";
export declare class UiListItemComponent extends UiListItemDirective implements OnChanges {
    readonly iconReg: SieIconRegistryService;
    protected readonly cdr: ChangeDetectorRef;
    private readonly layoutService;
    /** @ignore */
    static nextUniqueCheckboxId: number;
    private isHovering;
    /** @ignore */
    uniqueCheckboxId: number;
    /** @ignore */
    get hoverClass(): boolean;
    /** @ignore */
    get classes(): string;
    /** @ignore */
    onMouseEnter(): void;
    /** @ignore */
    onMouseLeave(): void;
    constructor(iconReg: SieIconRegistryService, cdr: ChangeDetectorRef, layoutService: LayoutService);
    /** @ignore */
    itemSelectionChanged(selectionState: boolean): void;
    /** @ignore */
    ngOnChanges(changes: SimpleChanges): void;
    /** @ignore */
    updateView(): void;
    /** @ignore */
    setSelectedState(): boolean;
    private isSelectedOrHoverInBulkMode;
    /** @ignore */
    setStatusBar(): boolean;
    private setStatusState;
    onFadeInFadeOutAnimationDone(event: AnimationEvent): void;
    onDeleteButtonClick(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<UiListItemComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<UiListItemComponent, "sie-ui-list-item", never, {}, {}, never, ["*"], false, never>;
}
//# sourceMappingURL=ui-list-item.component.d.ts.map