import { UIListItemReadStatus, UIListItemStatus } from '../ui-list.types';
import { Observable } from 'rxjs';
import { PlainObject } from '@siemens/core';
import { Type } from '@angular/core';
export interface UiListItemModel {
    /**
     * 	Defines id of every list element
     */
    id: string;
    /**
     * Adds special style for list item depending on the value of {@link UIListItemStatus}
     */
    status?: UIListItemStatus;
    /**
     * Defines {@link UIListItemReadStatus} for list item depending on the value
     */
    readStatus?: UIListItemReadStatus;
    /**
     * Defines if the list item is selected by default
     */
    isSelected?: boolean;
    /**
     * Adds additional attributes to the list item (e.g.: for tracking)
     */
    dataAttributes?: PlainObject;
    /**
     * Defines item component type
     */
    itemComponent?: Type<any>;
    /** @ignore */
    hidden$?: Observable<boolean>;
    /**
     * Can be used to add additional styling to the list item
     */
    style?: PlainObject;
    /**
     * Defines if list-item should be hidden in the print preview
     */
    hideInPrintPreview?: boolean;
}
//# sourceMappingURL=ui-list-item.model.d.ts.map