import { ChangeDetectorRef, OnChanges, SimpleChanges, ViewContainerRef } from '@angular/core';
import { PlainObject } from '@siemens/core';
import { Subject } from 'rxjs';
import { UiAdvancedListItemSelectionChangeData, UiListItemEvent } from '../ui-list-item/ui-list-item.directive';
import { UiListItemModel } from '../ui-list-item/ui-list-item.model';
import { UIListItemAppearance, UIListItemType } from '../ui-list.types';
import * as i0 from "@angular/core";
export declare abstract class UiStaticListItemDirective<ItemModel extends UiListItemModel = UiListItemModel, AED = PlainObject> implements OnChanges {
    protected cdr: ChangeDetectorRef;
    viewContainerRef?: ViewContainerRef;
    static isStaticComponent: boolean;
    itemType: UIListItemType;
    itemAppearance: UIListItemAppearance;
    connectedComponent: UiStaticListItemDirective;
    set itemData(itemData: ItemModel);
    get itemData(): ItemModel;
    selectionChanged: Subject<UiAdvancedListItemSelectionChangeData>;
    itemEvent: Subject<UiListItemEvent<ItemModel, AED>>;
    _itemData: ItemModel;
    protected constructor(cdr: ChangeDetectorRef, viewContainerRef?: ViewContainerRef);
    ngOnChanges(_changes: SimpleChanges): void;
    headerContentAvailable(): boolean;
    static ɵfac: i0.ɵɵFactoryDeclaration<UiStaticListItemDirective<any, any>, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<UiStaticListItemDirective<any, any>, never, never, { "itemType": { "alias": "itemType"; "required": false; }; "itemAppearance": { "alias": "itemAppearance"; "required": false; }; "connectedComponent": { "alias": "connectedComponent"; "required": false; }; "itemData": { "alias": "itemData"; "required": false; }; }, { "selectionChanged": "selectionChanged"; "itemEvent": "itemEvent"; }, never, never, false, never>;
}
//# sourceMappingURL=ui.static.list-item.directive.d.ts.map