import { SieIcon } from '@siemens/icons';
/**
 * Different types of message box
 */
export type MessageBoxType = 'standard' | 'condensed';
/**
 * Different variants of message box deciding which icon will be shown inside
 */
export type MessageBoxVariant = 'info' | 'success' | 'warning' | 'error';
/**
 * Defines how the layout of the message box will be composed
 */
export type MessageBoxElementLayout = 'standard-layout' | 'top-button' | 'inline-button';
/**
 * Icons used for each variant respectively
 */
export type MessageBoxIcon = SieIcon.InformationFilled | SieIcon.SuccessFilled | SieIcon.WarningFilled | SieIcon.ErrorFilled;
/** @ignore */
export declare const MSG_BOX_ICON_MAPPING: {
    [key in MessageBoxVariant]: MessageBoxIcon;
};
/** @ignore */
export declare const MSG_BOX_GRADIENT_COLOR: {
    [key in MessageBoxVariant]: string;
};
/** @ignore */
export declare const MSG_BOX_TRUNCATION_LINES: {
    [key in string]: number;
};
//# sourceMappingURL=ui-message-box.types.d.ts.map