import { NgxSmartModalComponent } from 'ngx-smart-modal';
import { Subscription } from 'rxjs';
import { LayoutService } from '@siemens/core';
import { AfterViewInit, ChangeDetectorRef, ElementRef, EventEmitter, OnDestroy, OnInit, Renderer2, ViewContainerRef } from '@angular/core';
import { UiModalComponentService } from './ui-modal-component.service';
import { CdkOverlayService } from '../services/cdk-overlay.service';
import * as i0 from "@angular/core";
export declare abstract class UiBaseModalComponent extends NgxSmartModalComponent implements AfterViewInit, OnInit, OnDestroy {
    private readonly layoutService;
    private readonly modalComponentService;
    private readonly renderer;
    protected readonly cdr: ChangeDetectorRef;
    private readonly vcr;
    private readonly elRef;
    protected cdkOverlayService: CdkOverlayService;
    protected subscriptions: Subscription;
    /**
     * Event triggered when the video modal is closed
     */
    modalClosed: EventEmitter<void>;
    private _modalId;
    protected constructor(layoutService: LayoutService, modalComponentService: UiModalComponentService, renderer: Renderer2, cdr: ChangeDetectorRef, vcr: ViewContainerRef, elRef: ElementRef, _document: Document, _platformId: object, cdkOverlayService: CdkOverlayService);
    /** @ignore */
    ngOnInit(): void;
    /**
     * @param value Defines whether the modal has a close button available
     */
    set modalClosable(value: boolean);
    get modalClosable(): boolean;
    /**
     * @param value Defines whether the modal can be dismissed by clicking on the backdrop
     */
    set modalDismissable(value: boolean);
    get modalDismissable(): boolean;
    /**
     * @param value Defines whether the modal can be closed by pressing the ESC key
     */
    set modalEscapable(value: boolean);
    get modalEscapable(): boolean;
    /** @ignore */
    ngAfterViewInit(): void;
    /** @ignore */
    ngOnDestroy(): void;
    /**
     * @param modalId Opens the modal instance with the selected modal id
     * @returns `NgxSmartModalComponent` the modal component
     */
    openDialog(modalId: string): NgxSmartModalComponent;
    /**
     * The method that opens the modal
     * @returns `NgxSmartModalComponent` the modal component
     */
    open(): NgxSmartModalComponent;
    /**
     * The method that closes the modal
     * @returns `NgxSmartModalComponent` the modal component
     */
    close(): NgxSmartModalComponent;
    private beforeClose;
    static ɵfac: i0.ɵɵFactoryDeclaration<UiBaseModalComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<UiBaseModalComponent, "ng-component", never, { "modalClosable": { "alias": "modalClosable"; "required": false; }; "modalDismissable": { "alias": "modalDismissable"; "required": false; }; "modalEscapable": { "alias": "modalEscapable"; "required": false; }; }, { "modalClosed": "modalClosed"; }, never, never, false, never>;
}
//# sourceMappingURL=ui-base-modal.component.d.ts.map