import { SieIconRegistryService } from '@siemens/icons';
import { Subject } from 'rxjs';
import { UiButtonModel } from '../ui-button';
import { UiConfirmationModalModel } from './ui-modal.model';
import { UiModalComponent } from './ui-modal/ui-modal.component';
import * as i0 from "@angular/core";
/**
 * Directive used to handle the confirmation modal and language change modal
 */
export declare abstract class UiConfirmationModalBaseDirective {
    protected readonly iconReg: SieIconRegistryService;
    /** @ignore */
    buttons: UiButtonModel[];
    /**
     * Event triggered when the interaction with a modal is done and the modal closes
     */
    modalInteractionDone: Subject<void>;
    constructor(iconReg: SieIconRegistryService);
    protected createButtons(data: UiConfirmationModalModel): void;
    protected subscribeToClose(modal: UiModalComponent): void;
    private addButton;
    static ɵfac: i0.ɵɵFactoryDeclaration<UiConfirmationModalBaseDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<UiConfirmationModalBaseDirective, never, never, {}, { "modalInteractionDone": "modalInteractionDone"; }, never, never, false, never>;
}
//# sourceMappingURL=ui-confirmation-modal.base.directive.d.ts.map