import { Subject } from 'rxjs';
import { ChangeDetectorRef, ElementRef } from '@angular/core';
import { NestedListType, UiNestedListLinkItemClicked, UiNestedListModel } from './ui-nested-list.model';
import { SieIconRegistryService } from '@siemens/icons';
import * as i0 from "@angular/core";
export declare class UiNestedListComponent {
    iconReg: SieIconRegistryService;
    private readonly cdr;
    readonly hostElement: ElementRef;
    nestedListType: NestedListType;
    nestedListItems: Array<UiNestedListModel>;
    /** @ignore internal use only */
    root: boolean;
    /** @ignore internal use only */
    hierarchyLevel: number;
    headerColumnOneTitle: string;
    headerColumnTwoTitle: string;
    headerColumnThreeTitle: string;
    /** @ignore internal use only */
    selectedNodeId: number;
    nestedListItemExpanded: Subject<UiNestedListModel>;
    nestedListItemSelected: Subject<UiNestedListModel>;
    linkItemClicked: Subject<UiNestedListLinkItemClicked>;
    set foldersLoading(value: boolean);
    get foldersLoading(): boolean;
    set showFolder(value: boolean);
    get showFolder(): boolean;
    set hasHeader(value: boolean);
    get hasHeader(): boolean;
    set borderVisible(value: boolean);
    get borderVisible(): boolean;
    set completeRowHover(value: boolean);
    get completeRowHover(): boolean;
    set truncateFolders(value: boolean);
    get truncateFolders(): boolean;
    set truncateLinks(value: boolean);
    get truncateLinks(): boolean;
    private _foldersLoading;
    private _hasHeader;
    private _borderVisible;
    private _completeRowHover;
    private _truncateFolders;
    private _truncateLinks;
    private _showFolder;
    constructor(iconReg: SieIconRegistryService, cdr: ChangeDetectorRef, hostElement: ElementRef);
    onItemExpanded(nestedListItem: UiNestedListModel, index: number): void;
    onItemSelectionChanged(nestedListItem: UiNestedListModel): void;
    onLinkItemClicked(itemClicked: UiNestedListLinkItemClicked): void;
    reloadComponent(): void;
    selectNode(nodeId: number): void;
    private expandTree;
    static ɵfac: i0.ɵɵFactoryDeclaration<UiNestedListComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<UiNestedListComponent, "sie-ui-nested-list", never, { "nestedListType": { "alias": "nestedListType"; "required": false; }; "nestedListItems": { "alias": "nestedListItems"; "required": false; }; "root": { "alias": "root"; "required": false; }; "hierarchyLevel": { "alias": "hierarchyLevel"; "required": false; }; "headerColumnOneTitle": { "alias": "headerColumnOneTitle"; "required": false; }; "headerColumnTwoTitle": { "alias": "headerColumnTwoTitle"; "required": false; }; "headerColumnThreeTitle": { "alias": "headerColumnThreeTitle"; "required": false; }; "selectedNodeId": { "alias": "selectedNodeId"; "required": false; }; "foldersLoading": { "alias": "foldersLoading"; "required": false; }; "showFolder": { "alias": "showFolder"; "required": false; }; "hasHeader": { "alias": "hasHeader"; "required": false; }; "borderVisible": { "alias": "borderVisible"; "required": false; }; "completeRowHover": { "alias": "completeRowHover"; "required": false; }; "truncateFolders": { "alias": "truncateFolders"; "required": false; }; "truncateLinks": { "alias": "truncateLinks"; "required": false; }; }, { "nestedListItemExpanded": "nestedListItemExpanded"; "nestedListItemSelected": "nestedListItemSelected"; "linkItemClicked": "linkItemClicked"; }, never, never, false, never>;
}
//# sourceMappingURL=ui-nested-list.component.d.ts.map