/**
 * Picture mode types:
 * - `cover`
 * - `contain`
 * - `string`
 */
export type PictureMode = 'cover' | 'contain' | string;
export interface UiPictureModel {
    /**
     * URL of the small picture variation (displayed on mobile screen)
     */
    urlSmall?: string;
    /**
     * URL of the medium picture variation (displayed on tablet screen)
     */
    urlMedium?: string;
    /**
     * URL of the large picture variation (displayed on desktop screen)
     */
    urlLarge?: string;
    /**
     * Defines the alternate text on the picture
     */
    altText?: string;
    /**
     * Defines {@link PictureMode Mode} how the picture should fit in the container
     */
    mode?: PictureMode;
    /**
     * Defines the caption text
     */
    caption?: string;
}
//# sourceMappingURL=ui-picture.model.d.ts.map