import { UiDropdownMenuModel } from '../ui-dropdown-menu';
export interface UiMallUserSettingsInformationModel {
    userSettings: UiMallUserSettingsModel;
    companyName: string;
    countryCode: string;
    salesforceRegionId: string;
    primarySapAccountId: string;
    sapAccountId: string;
    language?: string;
    displayModeProjectNumber?: string;
    isMallUser: boolean;
    userRoles?: Array<string>;
    currencies: Array<UiMallCurrencyModel>;
    defaultCurrency: string;
    alternativeBuyingOptions: boolean;
}
export interface UiMallUserSettingsModel {
    allowProductComparison: boolean;
    allowSearchResultOptions: boolean;
    allowSearchHistory: boolean;
    enableCAXDataInSearch: boolean;
    allowAvailability: boolean;
    allowSwitchAccount: boolean;
    showListPriceInGuestCatalog: boolean;
    isListPriceShown: boolean;
    isCustomerPriceShown: boolean;
    timezone?: UiMallUserSettingsConfigModel;
    defaultLanguage?: UiMallUserSettingsConfigModel;
    numberFormat?: UiMallUserSettingsConfigModel;
    dateFormat?: UiMallUserSettingsConfigModel;
    itemsPerPage?: number;
    showOrderAndReturnsLink: boolean;
}
export interface UiMallUserSettingsConfigModel {
    name?: string;
    value?: string;
}
export interface UiMallCurrencyModel extends UiDropdownMenuModel {
    currencyCode: string;
    currencyDescription: string;
}
//# sourceMappingURL=ui-profile-menu-user-settings.model.d.ts.map