import { ProgressStepPosition } from './ui-progress-step.types';
/**
 * @enum {string} Possible status for the step's status. Used to determine the icon being displayed within a step
 */
export type ProgressStepState = 'active' | 'enabled' | 'disabled';
export type ProgressStepSubState = 'completed' | 'warning' | 'error';
/**
 * Model for progress step used inside {@link UiProgressTrackerComponent}
 */
export interface ProgressStep {
    /**
     * {@link ProgressStepState State} of step
     */
    state: ProgressStepState;
    /**
     * {@link ProgressStepSubState sub state} additionally to state
     */
    subState?: ProgressStepSubState;
    /**
     * Optional label to be displayed within a step
     */
    label?: string;
    /**
     * Optional sub label to be displayed underneath the label
     */
    value?: string;
    /**
     * @ignore
     */
    position?: ProgressStepPosition;
}
//# sourceMappingURL=ui-progress-step.model.d.ts.map