import { PlainObject } from '@siemens/core';
import { UiButtonModel } from '../ui-button/base/ui-button.model';
import { LinkModel } from '../ui-link/ui-link.model';
import { UiPictureModel } from '../ui-picture/ui-picture.model';
export type PromotionExpandableType = 'product' | 'service' | 'event' | 'topic';
export interface PromotionExpandableModel {
    uuid: string;
    type: PromotionExpandableType;
    title: string;
    subtitle?: string;
    benefits?: string[];
    copy: string;
    links?: LinkModel[];
    image?: UiPictureModel;
    primaryImage?: UiPictureModel;
    secondaryImage?: UiPictureModel;
    date?: string;
    location?: string;
    buttons: UiButtonModel[];
    disclaimer?: string;
    isExpandable?: boolean;
    dataAttributes?: PlainObject;
    isInterstitial: boolean;
    isPromotionExpandableClosed: boolean;
    screenReaderCloseIcon: string;
}
//# sourceMappingURL=ui-promotion-expandable-model.d.ts.map