import { SieIcon } from '@siemens/icons';
import { BehaviorSubject } from 'rxjs';
/**
 * Model type defining a radio button item
 */
export interface UiRadioButtonModel {
    /**
     * Mandatory and unique identifier. Used in `selectedId` input on the component to define selected radio button
     */
    id: string;
    /** @ignore */
    labelTranslateKey?: string;
    /**
     * Label of the radio button
     */
    label?: string;
    /** @ignore */
    labelAppendix$?: BehaviorSubject<string>;
    /**
     * {@link SieIcon Icons} displayed next to label
     */
    icons?: SieIcon[];
    /**
     * Disable single radio button item
     */
    disabled?: boolean;
    /**
     * Defines the radion button additional content
     */
    hasAdditionalContent?: boolean;
}
//# sourceMappingURL=ui-radio-button.model.d.ts.map