import { LayoutService } from '@siemens/core';
import { EventEmitter, OnInit, ViewContainerRef } from '@angular/core';
import { ReplyFormData, UiReplyFormModel } from './ui-reply-form.model';
import { UiReplyFormStatus } from './ui-reply-form.types';
import { SieIconRegistryService } from '@siemens/icons';
import { Subject } from 'rxjs';
import { UiDropZoneComponent } from '../ui-drop-zone/ui-drop-zone.component';
import { UiDropZoneFile } from '../ui-drop-zone';
import { UiModalService } from '../ui-modals';
import { UiTextareaComponent } from '../ui-input/ui-textarea';
import * as i0 from "@angular/core";
export declare class UiReplyFormComponent implements OnInit {
    readonly iconReg: SieIconRegistryService;
    readonly container: ViewContainerRef;
    readonly layoutService: LayoutService;
    private readonly uiModalService;
    dropZoneComponent: UiDropZoneComponent;
    textAreaComponent: UiTextareaComponent;
    status: UiReplyFormStatus;
    playAnimation: Subject<boolean>;
    textAreaValue: string;
    customError: {
        headline: string;
        description: string;
    };
    set fadeInAnimation(value: boolean);
    get fadeInAnimation(): boolean;
    set config(config: UiReplyFormModel);
    get config(): UiReplyFormModel;
    submitButtonClicked: EventEmitter<ReplyFormData>;
    cancelButtonClicked: EventEmitter<void>;
    editDraftButtonClicked: EventEmitter<void>;
    files: File[];
    fileValidationError: boolean;
    toggleAnimationState: 'hide' | 'show' | 'visible';
    textareaValid: boolean;
    private _fadeInAnimation;
    private _config;
    constructor(iconReg: SieIconRegistryService, container: ViewContainerRef, layoutService: LayoutService, uiModalService: UiModalService);
    ngOnInit(): void;
    triggerFadeInAnimation(): void;
    onSubmitForm(): void;
    onCancel(): void;
    onFilesChanged(files: UiDropZoneFile[]): void;
    private cancelConfirmed;
    static ɵfac: i0.ɵɵFactoryDeclaration<UiReplyFormComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<UiReplyFormComponent, "sie-ui-reply-form[config]", never, { "status": { "alias": "status"; "required": false; }; "playAnimation": { "alias": "playAnimation"; "required": false; }; "textAreaValue": { "alias": "textAreaValue"; "required": false; }; "customError": { "alias": "customError"; "required": false; }; "fadeInAnimation": { "alias": "fadeInAnimation"; "required": false; }; "config": { "alias": "config"; "required": false; }; }, { "submitButtonClicked": "submitButtonClicked"; "cancelButtonClicked": "cancelButtonClicked"; "editDraftButtonClicked": "editDraftButtonClicked"; }, never, never, false, never>;
}
//# sourceMappingURL=ui-reply-form.component.d.ts.map