import { SieIcon } from '@siemens/icons';
/** Defines the component type */
export type UiRichSnippetType = 'content' | 'link';
/** Defines the component variance */
export type UiRichSnippetVariant = 'standard' | 'no-border';
/** Defines on which position should be secondary metadata displayed */
export type UiRichSnippetSecondaryMetaPosition = 'top' | 'bottom';
/** Defines size of the skeleton */
export type UiRichSnippetSkeletonSize = 'normal' | 'small';
export interface UiRichSnippetModel {
    /** The title of the component */
    title?: string;
    /** The main description of the component */
    primaryMeta?: string;
    /** The supplement description of the component */
    secondaryMeta?: string;
    /** {@link SieIcon Icon} next to the secondary meta information */
    secondaryMetaIcon?: SieIcon;
    /** The image inside the component */
    image?: string;
    /** Alternative text for the image */
    imageAltText?: string;
    /** {@link SieIcon Icon} that will be shown instead of image */
    placeholderIcon?: SieIcon;
    /** Target link that should be opened by clicking on the component */
    url?: string;
    /** Defined if the target link should be opened in the same or new tab */
    target?: string;
}
/** @ignore */
export declare const RICH_SNIPPET_PRIMARY_META_TRUNCATION_LINES_DEFAULT = 2;
/** @ignore */
export declare const RICH_SNIPPET_PRIMARY_META_TRUNCATION_LINES: {
    [key in string]: number;
};
//# sourceMappingURL=ui-rich-snippet.model.d.ts.map