import { Subject } from 'rxjs';
import { UiBreadcrumbModel } from '../ui-breadcrumb';
import { UiSaasLandingPageLayoutDataAttributes, UiSaaSLandingPageVariant } from './ui-saas-landing-page-layout.model';
import * as i0 from "@angular/core";
export declare class UiSaasLandingPageLayoutComponent {
    /**
     * Switches between a header with grey background and without one.
     */
    headerVariant: UiSaaSLandingPageVariant;
    /**
     * Array of breadcrumb models, optimally coming from the BreadcrumbService.
     */
    breadCrumbs: UiBreadcrumbModel[];
    /**
     * Human-readable headline.
     */
    headline: string;
    /**
     * Human-readable sub-headline.
     */
    subHeadline: string;
    /**
     * Show skeleton for all sections.
     */
    loading: boolean;
    /**
     * Show skeleton only for the breadcrumbs.
     */
    breadCrumbsLoading: boolean;
    /**
     * Show skeleton only for the headline.
     */
    headlineLoading: boolean;
    /**
     * Show skeleton only for the sub-headline.
     */
    subHeadlineLoading: boolean;
    /**
     * Defines data attributes added to the sections defined in the interface.
     */
    dataAttributes: UiSaasLandingPageLayoutDataAttributes;
    /**
     * Use container class to prevent content going out of bounds on XXL+ screens
     */
    contentContainerClass: boolean;
    /**
     * Text used for screen reader when encountering the home icon in breadcrumbs
     */
    screenReaderBreadcrumbHomeButton: string;
    /**
     * checking the heading size
     */
    headlineFontSize: 'h1' | 'h2';
    /**
     * Emitted when a breadcrumb is clicked.
     */
    breadcrumbClicked: Subject<UiBreadcrumbModel>;
    static ɵfac: i0.ɵɵFactoryDeclaration<UiSaasLandingPageLayoutComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<UiSaasLandingPageLayoutComponent, "sie-ui-saas-landing-page-layout", never, { "headerVariant": { "alias": "headerVariant"; "required": false; }; "breadCrumbs": { "alias": "breadCrumbs"; "required": false; }; "headline": { "alias": "headline"; "required": false; }; "subHeadline": { "alias": "subHeadline"; "required": false; }; "loading": { "alias": "loading"; "required": false; }; "breadCrumbsLoading": { "alias": "breadCrumbsLoading"; "required": false; }; "headlineLoading": { "alias": "headlineLoading"; "required": false; }; "subHeadlineLoading": { "alias": "subHeadlineLoading"; "required": false; }; "dataAttributes": { "alias": "dataAttributes"; "required": false; }; "contentContainerClass": { "alias": "contentContainerClass"; "required": false; }; "screenReaderBreadcrumbHomeButton": { "alias": "screenReaderBreadcrumbHomeButton"; "required": false; }; "headlineFontSize": { "alias": "headlineFontSize"; "required": false; }; }, { "breadcrumbClicked": "breadcrumbClicked"; }, never, ["[header]", "[content]"], false, never>;
}
//# sourceMappingURL=ui-saas-landing-page-layout.component.d.ts.map