import { AfterViewInit, ChangeDetectorRef, ElementRef, EventEmitter, OnDestroy } from '@angular/core';
import { SieIcon, SieIconRegistryService } from '@siemens/icons';
import { LayoutService } from '@siemens/core';
import * as i0 from "@angular/core";
export declare class UiSidePanelWrapperComponent implements AfterViewInit, OnDestroy {
    private readonly iconReg;
    private readonly layoutService;
    private readonly cdr;
    private readonly document;
    private readonly elementRef;
    toggleSidePanelScreenReaderText: string;
    position: 'left' | 'right' | 'left-right';
    set sidePanelOpenedIcon(value: SieIcon);
    set sidePanelClosedIcon(value: SieIcon);
    get openLeft(): boolean;
    set openLeft(value: boolean);
    get openRight(): boolean;
    set openRight(value: boolean);
    get disabled(): boolean;
    set disabled(value: boolean);
    get hidden(): boolean;
    set hidden(value: boolean);
    toggled: EventEmitter<boolean>;
    _sidePanelOpenedIcon: SieIcon;
    _sidePanelClosedIcon: SieIcon;
    private _wrapper;
    private _openLeft;
    private _openRight;
    private _disabled;
    private _hidden;
    private smallViewport;
    private readonly subscriptions;
    constructor(iconReg: SieIconRegistryService, layoutService: LayoutService, cdr: ChangeDetectorRef, document: Document, elementRef: ElementRef);
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    toggleSidePanelLeft(): void;
    toggleSidePanelRight(): void;
    onWidthChangeLeft(newWidth: number): void;
    onWidthChangeRight(newWidth: number): void;
    private toggleDisableScrolling;
    private closeSidePanelOnResizeSmallViewport;
    private setSidePanelValues;
    private updateSidePanelCssVars;
    private getPaddingValues;
    static ɵfac: i0.ɵɵFactoryDeclaration<UiSidePanelWrapperComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<UiSidePanelWrapperComponent, "sie-ui-side-panel-wrapper", never, { "toggleSidePanelScreenReaderText": { "alias": "toggleSidePanelScreenReaderText"; "required": false; }; "position": { "alias": "position"; "required": false; }; "sidePanelOpenedIcon": { "alias": "sidePanelOpenedIcon"; "required": false; }; "sidePanelClosedIcon": { "alias": "sidePanelClosedIcon"; "required": false; }; "openLeft": { "alias": "openLeft"; "required": false; }; "openRight": { "alias": "openRight"; "required": false; }; "disabled": { "alias": "disabled"; "required": false; }; "hidden": { "alias": "hidden"; "required": false; }; }, { "toggled": "toggled"; }, never, ["[sidePanel]", "[content]", "[sidePanelRight]"], false, never>;
}
//# sourceMappingURL=ui-side-panel-wrapper.component.d.ts.map