import { UiTableModel } from './ui-table.model';
import * as i0 from "@angular/core";
/**
 * # Table component
 *
 * Tables are used to present information and relationship between data in a two-dimensional view.
 *
 * ## Component variations
 *
 * There are no variations
 *
 * ## Content
 *
 * The table component does not accept any content.
 *
 * ## Code example
 * ```html
 * <sie-ui-table [table]="tableContent"></sie-ui-table>
 * ```
 *
 * Table data example:
 * ```js
 * tableContent = {
 *   width: '800px',
 *   tHead: {
 *     rows: [{cells: [{value: 'I am a thead cell'}]}]
 *   },
 *   tBodies: [
 *     {
 *       rows: [{cells: [{value: 'I am a tbody cell'}]}]
 *     }
 *   ],
 *   tFoot: {
 *     rows: [
 *       {
 *         cells: [{value: 'I am a tfoot cell'}]
 *       }
 *     ]
 *   }
 * };
 * ```
 *
 * ### Builder
 * Table model can be build with the {@link UiTableBuilder table builder}
 */
export declare class UiTableComponent {
    get table(): UiTableModel;
    /**
     * @param table Defines displayed table data
     */
    set table(table: UiTableModel);
    private _table;
    static ɵfac: i0.ɵɵFactoryDeclaration<UiTableComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<UiTableComponent, "sie-ui-table", never, { "table": { "alias": "table"; "required": false; }; }, {}, never, never, false, never>;
}
//# sourceMappingURL=ui-table.component.d.ts.map