import { UiButtonModel } from '../ui-button/base/ui-button.model';
import { UiPictureModel } from '../ui-picture/ui-picture.model';
import { UiRouteButtonModel } from '../ui-route-button/ui-route-button.model';
import { UiModalButtonModel } from '../ui-modal-button/ui-modal-button.model';
import { PlainObject } from '@siemens/core';
import { UiDropdownMenuModel } from '../ui-dropdown-menu/ui-dropdown-menu.model';
export interface UiTeaserModel {
    /**
     * Defines the type of the item.
     */
    visualizationType?: string;
    title?: string;
    subTitle?: string;
    /**
     * Defines the content type of the item (event)
     */
    contentType?: string;
    /**
     * The list of benefits.
     */
    benefits?: Array<string>;
    /**
     * {@link UiPictureModel Image} to be displayed for different viewports.
     */
    picture?: UiPictureModel;
    /**
     * Text that is displayed as a tag above the teaser. `visualTag` is available only in Ad Teaser component.
     */
    visualTag?: string;
    /**
     * Defines the category of the item.
     */
    category?: string;
    /**
     * Defines the label of the link on the component.
     */
    linkLabel?: string;
    /**
     * The URL for the link.
     */
    linkTarget?: string;
    /**
     * Defines type of the link.
     */
    linkType?: string;
    /**
     * List of the buttons to be added to the teaser. For possible values checkout: {@link UiModalButtonModel modal button model},
     * {@link UiRouteButtonModel route button model} or {@link UiButtonModel button model}.
     */
    buttons?: Array<UiModalButtonModel | UiRouteButtonModel | UiButtonModel>;
    /**
     * Add additional attributes to the button component (e.g.: for tracking).
     */
    dataAttributes?: PlainObject;
    /**
     * Available {@link UiDropdownMenuModel list of actions} in the dropdown (when you click the options button).
     * `childActions` is used only in AdTeaser component
     */
    childActions?: UiDropdownMenuModel[];
}
//# sourceMappingURL=ui-teaser.model.d.ts.map