import { PlainObject } from '@siemens/core';
import { SieIcon } from '@siemens/icons';
import { UiNavigationModel } from '../shared/models/ui-navigation-model';
export interface UiTileButtonGroupModel {
    /**
     * Defines the id of a single tile button
     */
    id?: string;
    /**
     * The title of the single tile button
     */
    title: string;
    /**
     * The icon that is shown inside a tile button
     */
    icon: SieIcon;
    /**
     * Link that the click on the tile button leads to
     * See {@link UiNavigationModel}
     */
    link: UiNavigationModel;
    /**
     * Defines the tooltip to be shown when tile button gets hovered
     */
    toolTipValue?: string;
    /**
     * Additional attributes that are added to the tile button (e.g.: for tracking)
     * @example Possible values:
     * ```json
     * { 'data-ste-component': 'value', 'data-ste': 'value' }
     * ```
     */
    dataAttributes?: PlainObject;
}
//# sourceMappingURL=ui-tile-button-group.model.d.ts.map