/**
 * Type of the toast message, determines the icon displayed next to the headline
 */
export type UiToastType = 'neutral' | 'success' | 'warning' | 'error';
/**
 * @enum {string}
 * Entrance animation possibilities of the toast
 */
export declare enum UiToastEntranceAnimation {
    SlideIn = "slideIn",
    SlideMobileIn = "slideMobileIn",
    FadeIn = "fadeIn",
    Idle = "idle"
}
/**
 * @enum {string}
 * Exit animation possibilities of the toast
 */
export declare enum UiToastExitAnimation {
    SlideOut = "slideOut",
    SlideMobileOut = "slideMobileOut",
    FadeOut = "fadeOut",
    Idle = "idle"
}
/**
 * Animations types of the toast
 */
export declare enum UiToastAnimationType {
    Entrance = 0,
    Exit = 1
}
/**
 * Element targets that can get animated
 */
export declare enum UiToastAnimationTarget {
    Height = 0,
    Opacity = 1
}
/** @ignore */
export declare const UI_TOAST_ANIMATIONS: {
    mobile: {
        initialHeight: UiToastExitAnimation;
        initialOpacity: UiToastEntranceAnimation;
        entrance: UiToastEntranceAnimation[];
        exit: UiToastExitAnimation[];
    };
    desktop: {
        initialHeight: UiToastExitAnimation;
        initialOpacity: UiToastEntranceAnimation;
        entrance: UiToastEntranceAnimation[];
        exit: UiToastExitAnimation[];
    };
};
//# sourceMappingURL=ui-toast.types.d.ts.map