import { UiTreeNodeModel } from './ui-tree-node.model';
export declare class UiTreeListService {
    /**
     * find the path to a specific node id, that means if you have a node id from the 3 level of the tree this
     * will return an array of all the parents [parentLevel1, parentLevel2, node]
     * @param currentPathToNode = path to a node
     * @param nodes = the whole tree
     * @param id = id of the node where you want the path too
     */
    static getPathToNode(currentPathToNode: Array<UiTreeNodeModel>, nodes: Array<UiTreeNodeModel>, id: string): Array<UiTreeNodeModel>;
    static getNode(nodes: Array<UiTreeNodeModel>, id: string): UiTreeNodeModel;
    static updateSelection(nodes: Array<UiTreeNodeModel>, selectedNodes: Array<string>): void;
    /**
     * Adds or removes the item from `selectedNodes` array
     * @param selectedNodes list of selected nodes
     * @param id id that should be added/removed
     * @param add whether to add or remove the item
     */
    static updateSelectedNodes(selectedNodes: Array<string>, id: string, add: boolean): void;
    static updateNodeAndChildren(node: UiTreeNodeModel, selection: boolean, selectedNodes: Array<string>): void;
    static updateNodeParents(node: UiTreeNodeModel, nodes: Array<UiTreeNodeModel>, selectedNodes: Array<string>): void;
    static isNodeIndeterminate(node: UiTreeNodeModel): boolean;
    static getAliasNode(nodes: Array<UiTreeNodeModel>, aliasId: string, checkedAliasIds: Array<string>): UiTreeNodeModel;
    static getPathToNodeFromWholeTree(parents: Array<UiTreeNodeModel>, nodes: Array<UiTreeNodeModel>, id: string): Array<UiTreeNodeModel>;
}
//# sourceMappingURL=ui-tree-list.service.d.ts.map