import { SieIcon } from '@siemens/icons';
import { HintModel } from '../shared/models/hint.model';
import { BehaviorSubject } from 'rxjs';
export declare type UiTreeFolderTypes = 'Parent' | 'Company' | 'Location' | 'System' | 'Product' | 'Component' | 'Folder' | 'Equipment' | 'MyProduct';
export interface UiTreeNodeModel {
    /**
     * Defines the id of the node element
     */
    id: string;
    /**
     * Defines the content (label) of the node element
     */
    label: string;
    /** @ignore */
    labelAppendix$?: BehaviorSubject<string>;
    /**
     * Defines the children of the node element
     */
    children?: Array<UiTreeNodeModel>;
    /**
     * Defines a connection to another node in the tree
     */
    aliasId?: string;
    /**
     * Sets the {@link SieIcon icon} to be displayed next to the node label
     */
    icons?: SieIcon[];
    /**
     * Defines whether the node is selected or not
     */
    selected?: boolean;
    /**
     * Defines the input {@link HintModel hint}
     */
    inputHint?: HintModel;
}
export interface UiSiePortalContentTreeModel extends UiTreeNodeModel {
    isSipsManual?: boolean;
    pdfLink?: string;
    fileUrl?: string;
    children?: Array<UiSiePortalContentTreeModel>;
}
export interface UiFolderTreeModel extends UiTreeNodeModel {
    requestSearch: boolean;
    folderType: UiTreeFolderTypes;
    children?: Array<UiFolderTreeModel>;
}
//# sourceMappingURL=ui-tree-node.model.d.ts.map