import { BehaviorSubject } from 'rxjs';
export interface UiTreeNavigationModel {
    /**
     * Defines the id of the node element
     */
    itemId: number;
    /**
     * Defines the content (label) of the node element
     */
    itemTitle: string;
    /**
     * Defines whether the node element can be expanded or not
     */
    expandable?: boolean;
    /**
     * Defines the children of the node element
     */
    children$?: BehaviorSubject<UiTreeNavigationModel[]>;
    /**
     * Defines if the children of the node element are being loaded
     */
    childrenLoading$?: BehaviorSubject<boolean>;
    /**
     * Defines that node element is not interactable
     */
    textOnly?: boolean;
    /**
     * Defines whether the node is expanded or not
     */
    expanded?: boolean;
}
//# sourceMappingURL=ui-tree-navigation.model.d.ts.map