import { ThemeVariant } from '@siemens/core';
import * as i0 from "@angular/core";
/**
 * # Underline Tooltip component
 *
 * Underline tooltips are used to create dynamic components which utilize tooltips by using sieCoreAddTooltip directive.
 *
 * ## Content
 *
 * The sie-ui-underline-tooltip component doesn't accept any content.
 *
 * ## Code example
 * @example
 * Template:
 * ```html
 * Standard link:
 * <sie-ui-underline-tooltip
 *   text="example text"
 *   tooltipText="example tooltip text"
 * >
 * </sie-ui-underline-tooltip>
 * ```
 */
export declare class UiUnderlineTooltipComponent {
    text: string;
    tooltipText: string;
    theme: ThemeVariant;
    static ɵfac: i0.ɵɵFactoryDeclaration<UiUnderlineTooltipComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<UiUnderlineTooltipComponent, "sie-ui-underline-tooltip", never, { "text": { "alias": "text"; "required": false; }; "tooltipText": { "alias": "tooltipText"; "required": false; }; "theme": { "alias": "theme"; "required": false; }; }, {}, never, never, false, never>;
}
//# sourceMappingURL=ui-underline-tooltip.component.d.ts.map