import { AfterViewInit, ChangeDetectorRef, ElementRef } from '@angular/core';
import { Subject } from 'rxjs';
import { SieIcon, SieIconRegistryService } from '@siemens/icons';
import { UiVerticalProgressTrackerItemStatus } from '../ui-vertical-progress-tracker-types';
import * as i0 from "@angular/core";
export declare class UiVerticalProgressTrackerItemComponent implements AfterViewInit {
    private readonly iconReg;
    private readonly cdr;
    stepHeader: ElementRef;
    label: string;
    index: number;
    last: number;
    selectedValue: string;
    displaySelectedValue: boolean;
    disabled: boolean;
    open: boolean;
    set status(value: UiVerticalProgressTrackerItemStatus);
    get status(): UiVerticalProgressTrackerItemStatus;
    nextStepStatus: string;
    nextStepOpen: boolean;
    initialItemIndex: Subject<number>;
    itemClicked: Subject<number>;
    iconName?: SieIcon;
    private _status;
    constructor(iconReg: SieIconRegistryService, cdr: ChangeDetectorRef);
    animationRunning: boolean;
    ngAfterViewInit(): void;
    toggleAndEmitItemClicked(): void;
    onToggle(): void;
    onAnimationEvent(): void;
    private emitInitialItemIndex;
    static ɵfac: i0.ɵɵFactoryDeclaration<UiVerticalProgressTrackerItemComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<UiVerticalProgressTrackerItemComponent, "sie-ui-vertical-progress-tracker-item", never, { "label": { "alias": "label"; "required": false; }; "index": { "alias": "index"; "required": false; }; "last": { "alias": "last"; "required": false; }; "selectedValue": { "alias": "selectedValue"; "required": false; }; "displaySelectedValue": { "alias": "displaySelectedValue"; "required": false; }; "disabled": { "alias": "disabled"; "required": false; }; "open": { "alias": "open"; "required": false; }; "status": { "alias": "status"; "required": false; }; "nextStepStatus": { "alias": "nextStepStatus"; "required": false; }; "nextStepOpen": { "alias": "nextStepOpen"; "required": false; }; }, { "initialItemIndex": "initialItemIndex"; "itemClicked": "itemClicked"; }, never, ["*"], false, never>;
}
//# sourceMappingURL=ui-vertical-progress-tracker-item.component.d.ts.map