import { UiBaseVerticalProgressTrackerItem, UiVerticalProgressTrackerItemStatus } from '../ui-vertical-progress-tracker-types';
import { TemplateRef } from '@angular/core';
import * as i0 from "@angular/core";
/**
 * Directive used to display items within a vertical progress tracker and for setting their parameter values
 */
export declare class UiVerticalProgressTrackerItemDirective implements UiBaseVerticalProgressTrackerItem {
    templateRef: TemplateRef<unknown>;
    constructor(templateRef: TemplateRef<unknown>);
    /**
     * Defines the {@link UiVerticalProgressTrackerItemStatus status} of the vertical progress tracker item
     */
    status: UiVerticalProgressTrackerItemStatus;
    /**
     * Defines the label of the vertical progress tracker item
     */
    label: string;
    /**
     * Defines the selected value in a particular step of the vertical progress tracker item
     */
    selectedValue: string;
    /**
     * @param value defines should vertical progress tracker item be opened
     * @default false
     */
    set open(value: boolean);
    get open(): boolean;
    private _open;
    static ɵfac: i0.ɵɵFactoryDeclaration<UiVerticalProgressTrackerItemDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<UiVerticalProgressTrackerItemDirective, "[sieUiVerticalProgressTrackerItem]", never, { "status": { "alias": "status"; "required": false; }; "label": { "alias": "label"; "required": false; }; "selectedValue": { "alias": "selectedValue"; "required": false; }; "open": { "alias": "open"; "required": false; }; }, {}, never, never, false, never>;
}
//# sourceMappingURL=ui-vertical-progress-tracker-item.directive.d.ts.map