import { UiComponentType } from '../shared/services/webcomponents/ui-dom-manipulation.service';
import { SieIcon } from '@siemens/icons';
/**
 * Defines possible vertical progress tracker item status
 */
export type UiVerticalProgressTrackerItemStatus = 'idle' | 'disabled' | 'active' | 'completed' | 'error' | 'warning';
/** @ignore */
export interface UiBaseVerticalProgressTrackerItem {
    status?: UiVerticalProgressTrackerItemStatus;
    label?: string;
    selectedValue: string;
    open?: boolean;
}
/**
 * Icon used with appropriate status
 */
export type StatusIcon = SieIcon.SuccessFilled | SieIcon.WarningFilled | SieIcon.ErrorFilled;
/** @ignore */
export declare const STEP_ICON_MAPPING: {
    [key in UiVerticalProgressTrackerItemStatus]?: StatusIcon;
};
/** @ignore */
export interface UiVerticalProgressTrackerItem extends UiBaseVerticalProgressTrackerItem, UiComponentType {
}
/** @ignore */
export type ElementWithDataAttributes = HTMLOrSVGElement & InnerHTML;
//# sourceMappingURL=ui-vertical-progress-tracker-types.d.ts.map