import { AfterViewInit, ElementRef, EventEmitter, OnDestroy, QueryList } from '@angular/core';
import { UiWizardStepDirective } from '../ui-wizard-step/ui-wizard-step.directive';
import { BehaviorSubject } from 'rxjs';
import { UiProgressTrackerComponent } from '../../ui-progress-tracker/ui-progress-tracker.component';
import { ProgressStep, ProgressStepState, ProgressStepSubState } from '../../ui-progress-tracker/ui-progress-step/ui-progress-step.model';
import * as i0 from "@angular/core";
export declare class UiWizardComponent implements AfterViewInit, OnDestroy {
    steps: QueryList<UiWizardStepDirective>;
    uiProgressTrackerComponent: UiProgressTrackerComponent;
    wizardContent: ElementRef;
    previousButtonLabel: string;
    nextButtonLabel: string;
    progressStepSelected: EventEmitter<number>;
    stepIndex: number;
    progressTrackerStepsData$: BehaviorSubject<ProgressStep[]>;
    private readonly subscription;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    private initialStepsSetup;
    refreshData(index: number, data: Partial<ProgressStep>): void;
    goToNextStep(state?: ProgressStepState): void;
    goToPrevStep(currentState?: ProgressStepState, previousSubState?: ProgressStepSubState): void;
    private stepExists;
    static ɵfac: i0.ɵɵFactoryDeclaration<UiWizardComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<UiWizardComponent, "sie-ui-wizard", never, { "previousButtonLabel": { "alias": "previousButtonLabel"; "required": false; }; "nextButtonLabel": { "alias": "nextButtonLabel"; "required": false; }; }, { "progressStepSelected": "progressStepSelected"; }, ["steps"], ["[header]"], false, never>;
}
//# sourceMappingURL=ui-wizard.component.d.ts.map