import * as i0 from '@angular/core';
import { Directive, NgModule, Injectable, Inject, Input, HostBinding, Output, inject, InjectionToken, Pipe, Component, ChangeDetectionStrategy, getPlatform } from '@angular/core';
import * as i1$3 from '@angular/common';
import { DOCUMENT, CommonModule } from '@angular/common';
import { Subject, BehaviorSubject, fromEvent, interval, Subscription, lastValueFrom, timeout, throwError, retry, combineLatest, of } from 'rxjs';
import { map, distinctUntilChanged, debounce, debounceTime, shareReplay, filter, finalize, tap, timeoutWith, retry as retry$1, take } from 'rxjs/operators';
import { GridBreakpointsXsQuery, GridBreakpointsSQuery, GridBreakpointsMQuery, GridBreakpointsLQuery, GridBreakpointsXlQuery, GridBreakpointsXxlQuery, GridBreakpointsXsMax, GridBreakpointsSMax, GridBreakpointsMMin, GridBreakpointsMMax, GridBreakpointsLMin, GridBreakpointsLMax, GridBreakpointsXlMin, GridBreakpointsXlMax, GridBreakpointsXxlMin, ComponentHeaderHeightMin, ComponentHeaderHeightS, ComponentHeaderHeightL, GridMarginS, GridMarginL, GridMarginXl, ColorInteractionFormHoverLightOnLight } from '@siemens/styles';
import * as i1 from '@angular/cdk/layout';
import * as i1$1 from '@angular/common/http';
import { HttpHeaders, HttpContextToken } from '@angular/common/http';
import * as dayjs from 'dayjs';
import dayjs__default from 'dayjs';
import customParseFormat from 'dayjs/plugin/customParseFormat';
import en from 'dayjs/locale/en';
import { __decorate } from 'tslib';
import { coerceNumberProperty, coerceArray, coerceBooleanProperty } from '@angular/cdk/coercion';
import * as i3 from 'ngx-cookie-service';
import * as i1$2 from '@angular/router';
import { NavigationEnd, ActivatedRoute } from '@angular/router';
import utf8 from 'utf8';

class AddTooltipDirective {
    constructor(el) {
        this.el = el;
        this.elem = el.nativeElement;
    }
    ngAfterViewInit() {
        if (!this.elem.title) {
            this.elem.title = this.elem.innerText?.trim();
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: AddTooltipDirective, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: AddTooltipDirective, selector: "[sieCoreAddTooltip]", ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: AddTooltipDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[sieCoreAddTooltip]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; } });

class AddTooltipModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: AddTooltipModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: AddTooltipModule, declarations: [AddTooltipDirective], exports: [AddTooltipDirective] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: AddTooltipModule }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: AddTooltipModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [AddTooltipDirective],
                    imports: [],
                    exports: [AddTooltipDirective]
                }]
        }] });

const Breakpoints = {
    XS: GridBreakpointsXsQuery,
    S: GridBreakpointsSQuery,
    M: GridBreakpointsMQuery,
    L: GridBreakpointsLQuery,
    XL: GridBreakpointsXlQuery,
    XXL: GridBreakpointsXxlQuery
};
const ContainerBreakpoints = {
    XS: ['0px', GridBreakpointsXsMax],
    S: ['360px', GridBreakpointsSMax],
    M: [GridBreakpointsMMin, GridBreakpointsMMax],
    L: [GridBreakpointsLMin, GridBreakpointsLMax],
    XL: [GridBreakpointsXlMin, GridBreakpointsXlMax],
    XXL: [GridBreakpointsXxlMin, 'Infinity']
};

var SearchScopes;
(function (SearchScopes) {
    SearchScopes["Catalog"] = "catalog";
    SearchScopes["KnowledgeBase"] = "knowledgebase";
    SearchScopes["Forum"] = "forum";
})(SearchScopes || (SearchScopes = {}));

var CatalogSearchType;
(function (CatalogSearchType) {
    CatalogSearchType["Products"] = "products";
    CatalogSearchType["Categories"] = "categories";
    CatalogSearchType["Documents"] = "documents";
    CatalogSearchType["Services"] = "services";
})(CatalogSearchType || (CatalogSearchType = {}));
var KnowledgeBaseSearchType;
(function (KnowledgeBaseSearchType) {
    KnowledgeBaseSearchType["SiePortalContent"] = "siePortal";
    KnowledgeBaseSearchType["LocalChinaContent"] = "localChina";
})(KnowledgeBaseSearchType || (KnowledgeBaseSearchType = {}));

var AppRoutes;
(function (AppRoutes) {
    AppRoutes["Administration"] = "administration";
    AppRoutes["Home"] = "home";
    AppRoutes["Search"] = "search";
    AppRoutes["UserProfile"] = "user-profile";
    AppRoutes["PersonalAndCompanyData"] = "personal-and-company-data";
    AppRoutes["LoginData"] = "login-data";
    AppRoutes["DataPrivacyAndTermsOfUse"] = "data-privacy-and-terms-of-use";
    AppRoutes["Preferences"] = "preferences";
    AppRoutes["Playground"] = "playground";
    AppRoutes["ContentPreview"] = "contentpreview";
    AppRoutes["SaasPlayground"] = "saasplayground";
    AppRoutes["MySiePortal"] = "mysieportal";
    AppRoutes["IBase"] = "ibase";
    AppRoutes["IBaseDetails"] = "equipment";
    AppRoutes["IBaseSiteDetails"] = "site";
    AppRoutes["IBaseSubequipment"] = "subequipment";
    AppRoutes["Users"] = "users";
    AppRoutes["IBasePermissions"] = "installed-base-permissions";
    AppRoutes["MyConversations"] = "my-conversations";
    AppRoutes["MyConversationsDetails"] = "conversation";
    AppRoutes["Contracts"] = "contracts";
    AppRoutes["ContractsDetail"] = "contract";
    AppRoutes["ContractsDetailItems"] = "item";
    AppRoutes["AuthCallback"] = "auth-callback";
    AppRoutes["SilentAuthCallback"] = "silent-auth-callback";
    AppRoutes["Error"] = "error";
    AppRoutes["Maintenance"] = "maintenance";
    AppRoutes["Chatbot"] = "chatbot";
    AppRoutes["Support"] = "support";
    AppRoutes["ProductsServices"] = "products-services";
    AppRoutes["ProductsServicesDetails"] = "pdp";
    AppRoutes["OneMD4C"] = "onemd4c";
    AppRoutes["Cart"] = "cart";
    AppRoutes["Checkout"] = "checkout";
    AppRoutes["OrderConfirmation"] = "order-confirmation";
})(AppRoutes || (AppRoutes = {}));

var Direction;
(function (Direction) {
    Direction["Ltr"] = "ltr";
    Direction["Rtl"] = "rtl";
})(Direction || (Direction = {}));

class Viewport {
    constructor(value) {
        this.value = value;
        this.breakpointKeys = Object.keys(Breakpoints);
        this.viewportIndex = this.getViewportIndex(value);
    }
    is(viewport) {
        return viewport === this.value;
    }
    isIn(...viewports) {
        return viewports.includes(this.value);
    }
    not(viewport) {
        return viewport !== this.value;
    }
    notIn(...viewports) {
        return !viewports.includes(this.value);
    }
    gt(viewport) {
        return this.viewportIndex > this.getViewportIndex(viewport);
    }
    gte(viewport) {
        return this.viewportIndex >= this.getViewportIndex(viewport);
    }
    lt(viewport) {
        return this.viewportIndex < this.getViewportIndex(viewport);
    }
    lte(viewport) {
        return this.viewportIndex <= this.getViewportIndex(viewport);
    }
    getViewportIndex(viewport) {
        return this.breakpointKeys.indexOf(viewport);
    }
}

const INITIAL_RESIZE_EVENT = {
    start: false,
    event: null
};
const SCROLL_BEHAVIOUR_CONFIG = { behavior: 'smooth' };
class LayoutService {
    get scrollOffset() {
        return parseInt(ComponentHeaderHeightMin, 10) + this.messageboxHeight;
    }
    get scrollPosition$() {
        return this.scrollPositionSubscription$;
    }
    get currentBreakpoint() {
        return this._currentBreakpoint;
    }
    get currentViewport() {
        return Object.keys(Breakpoints).find(key => Breakpoints[key] === this.currentBreakpoint);
    }
    get isTouchDevice() {
        return this._isTouchDevice;
    }
    constructor(document, breakpointObserver) {
        this.document = document;
        this.breakpointObserver = breakpointObserver;
        this.headerHeight$ = new Subject();
        this.resizeEvent = new Subject();
        this.resizeEventWithInitial$ = new BehaviorSubject(INITIAL_RESIZE_EVENT);
        this.breakPointChangedEvent = new Subject();
        this.printModeEnabled = false;
        this.expandForPrintPreview$ = new BehaviorSubject(false);
        this.screenHeight$ = this.resizeEventWithInitial$.pipe(map(() => {
            return window.innerHeight;
        }));
        this.screenHeightPx$ = this.screenHeight$.pipe(map(height => `${height}px`));
        this.messageboxHeight = 0;
        this.currentBreakpoint$ = new BehaviorSubject(null);
        this.currentViewPort$ = this.currentBreakpoint$.pipe(map(currentBreakpoint => {
            return Object.keys(Breakpoints).find(key => Breakpoints[key] === currentBreakpoint);
        }));
        this.currentViewportObj$ = this.currentViewPort$.pipe(map(currentViewport => {
            return new Viewport(currentViewport);
        }));
        this.emitResizeStart = false;
        this.resizeStartEmitted = false;
        this.disabledScrollCounter = 0;
        this.defaultDebounceTime = 250;
        this.listenToBreakpointChanges();
        this.windowWrapper = document.defaultView;
        this.resizeObservable$ = this.saveFromEvent(this.windowWrapper, 'resize');
        this.scrollObservable$ = this.saveFromEvent(this.windowWrapper, 'scroll');
        this.scrollPositionSubscription$ = this.subscribeToScroll();
        this.subscribeToResize().subscribe(event => {
            this.resizeEvent.next(event);
            this.resizeEventWithInitial$.next(event);
        });
        this.detectTouchDevice();
    }
    isBreakpoint(...breakpointQuery) {
        return breakpointQuery.includes(this._currentBreakpoint);
    }
    isViewport(...breakpointKey) {
        return breakpointKey.some(key => this._currentBreakpoint === Breakpoints[key]);
    }
    isViewport$(...breakpointKey) {
        return this.currentViewPort$.pipe(map(currentViewport => breakpointKey.some(key => currentViewport === key)));
    }
    getGridGutter() {
        return parseInt(getComputedStyle(this.document.documentElement).getPropertyValue('--grid-gutter'), 10);
    }
    saveFromEvent(target, event) {
        return fromEvent(target, event);
    }
    disableScroll() {
        this.disabledScrollCounter++;
        this.checkScrollbar();
        this.setScrollbar();
    }
    enableScroll() {
        if (this.disabledScrollCounter > 0) {
            this.disabledScrollCounter--;
        }
        if (this.disabledScrollCounter === 0) {
            this.resetScrollbar();
        }
    }
    scrollToTop() {
        window.scrollTo({ top: 0, ...SCROLL_BEHAVIOUR_CONFIG });
    }
    scrollToTopOnElement(selector) {
        const element = this.document.querySelector(selector);
        element.scrollTo({ top: 0, ...SCROLL_BEHAVIOUR_CONFIG });
    }
    scrollToElementId(id, additionalOffset = 0) {
        const element = window.document.getElementById(id);
        this.scrollToNativeElement(element, additionalOffset);
    }
    scrollToElementRef(elementRef, additionalOffset = 0) {
        this.scrollToNativeElement(elementRef.nativeElement, additionalOffset);
    }
    scrollToNativeElement(element, additionalOffset = 0) {
        const elementPosition = element?.getBoundingClientRect();
        if (elementPosition) {
            this.scrollToElementPosition(elementPosition, additionalOffset);
        }
    }
    /**
     * Scrolls to position taking header into consideration.
     */
    scrollTo(position) {
        window.scrollTo({
            top: position - parseInt(ComponentHeaderHeightMin, 10),
            ...SCROLL_BEHAVIOUR_CONFIG
        });
    }
    scrollToVerticalMiddle(element) {
        const headerHeight = parseInt(ComponentHeaderHeightMin, 10);
        const absoluteElementTop = this.getElementPosition(element) + headerHeight;
        const windowHeightHalf = window.innerHeight / 2 - headerHeight;
        this.scrollTo(absoluteElementTop - windowHeightHalf);
    }
    scrollToElementPosition(elementPosition, additionalOffset = 0) {
        window.scrollTo({
            top: elementPosition.top + window.scrollY - this.scrollOffset + additionalOffset,
            ...SCROLL_BEHAVIOUR_CONFIG
        });
    }
    getElementPosition(element) {
        return element.getBoundingClientRect().top + window.scrollY - this.messageboxHeight;
    }
    shouldExpandHeader(scrollPosition) {
        // take the correct header height depending on the viewport
        if (this.isViewport('XS', 'S', 'M')) {
            return (scrollPosition <= parseInt(ComponentHeaderHeightS, 10) - parseInt(ComponentHeaderHeightMin, 10) &&
                !document.querySelector('html').classList.contains('cdk-global-scrollblock'));
        }
        // otherwise it's breakpoint L or larger
        return scrollPosition <= parseInt(ComponentHeaderHeightL, 10) - parseInt(ComponentHeaderHeightMin, 10);
    }
    setGlobalCSSProperties() {
        this.checkScrollbar();
        this.document.documentElement.style.setProperty('--scrollbar-width', `${this._scrollbarWidth}px`);
    }
    getViewportWidth() {
        return window.innerWidth - this.getScrollbarWidth();
    }
    getElementWidth(el) {
        return el.nativeElement.getBoundingClientRect().width;
    }
    getGridMargin() {
        return parseInt(this.getGridMarginDefinition(), 10);
    }
    getBreakpointKeyForValue(value) {
        if (value) {
            for (const [key, range] of Object.entries(ContainerBreakpoints)) {
                const [start, end] = range;
                if (value >= parseFloat(start) && value <= parseFloat(end)) {
                    return key;
                }
            }
        }
        return null;
    }
    getGridMarginDefinition() {
        if (this.isViewport('XS', 'S', 'M')) {
            return GridMarginS;
        }
        else if (this.isViewport('L')) {
            return GridMarginL;
        }
        else {
            return GridMarginXl;
        }
    }
    getContainerWidth() {
        const bothSidesMultiplier = 2;
        const gridMargin = bothSidesMultiplier * this.getGridMargin();
        return this.getViewportWidth() - gridMargin;
    }
    subscribeToScroll() {
        return this.scrollObservable$.pipe(map(() => this.windowWrapper.pageYOffset), distinctUntilChanged());
    }
    subscribeToResize() {
        // debounce -> first event will be fired immediately
        // second event when user has stopped resizing
        return this.resizeObservable$.pipe(debounce(() => {
            let intervalTime;
            if (this.resizeStartEmitted) {
                intervalTime = this.defaultDebounceTime;
            }
            else {
                intervalTime = 0;
                this.emitResizeStart = true;
            }
            return interval(intervalTime);
        }), map((originalEvent) => {
            const startValue = this.emitResizeStart;
            if (this.emitResizeStart) {
                this.resizeStartEmitted = true;
                this.emitResizeStart = false;
            }
            else {
                this.resizeStartEmitted = false;
            }
            return {
                start: startValue,
                event: originalEvent
            };
        }));
    }
    listenToBreakpointChanges() {
        this.breakpointObserver
            .observe([Breakpoints.XS, Breakpoints.S, Breakpoints.M, Breakpoints.L, Breakpoints.XL, Breakpoints.XXL])
            .subscribe(result => {
            let breakpoint = null;
            Object.keys(result.breakpoints).forEach(key => {
                if (result.breakpoints[key]) {
                    breakpoint = key;
                }
            });
            if (this.printModeEnabled) {
                breakpoint = Breakpoints.XXL;
            }
            this._currentBreakpoint = breakpoint;
            this.currentBreakpoint$.next(breakpoint);
            this.breakPointChangedEvent.next(breakpoint);
        });
    }
    detectTouchDevice() {
        try {
            document.createEvent('TouchEvent');
            this._isTouchDevice = true;
        }
        catch (e) {
            this._isTouchDevice = false;
        }
    }
    checkScrollbar() {
        const rect = this.document.body.getBoundingClientRect();
        this._isBodyOverflowing = Math.round(rect.left + rect.right) <= window.innerWidth;
        this._scrollbarWidth = this.getScrollbarWidth();
    }
    getScrollbarWidth() {
        const scrollDiv = this.document.createElement('div');
        scrollDiv.className = 'scrollbar-measure';
        this.document.body.appendChild(scrollDiv);
        const scrollbarWidth = scrollDiv.getBoundingClientRect().width - scrollDiv.clientWidth;
        this.document.body.removeChild(scrollDiv);
        return scrollbarWidth;
    }
    setScrollbar() {
        if (this._isBodyOverflowing) {
            this.document.body.classList.add('dialog-open');
            if (!this.isTouchDevice) {
                // add padding right on body
                this.document.body.style.paddingRight = `${this._scrollbarWidth}px`;
                // add padding on header
                const header = this.document.querySelector('.header');
                if (header) {
                    header.style.paddingRight = `${this._scrollbarWidth}px`;
                }
            }
        }
    }
    resetScrollbar() {
        this.document.body.classList.remove('dialog-open');
        if (!this.isTouchDevice) {
            // restore padding on the body
            this.document.body.style.paddingRight = '';
            // restore padding on header
            const header = this.document.querySelector('.header');
            if (header) {
                header.style.paddingRight = '';
            }
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: LayoutService, deps: [{ token: DOCUMENT }, { token: i1.BreakpointObserver }], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: LayoutService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: LayoutService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: Document, decorators: [{
                    type: Inject,
                    args: [DOCUMENT]
                }] }, { type: i1.BreakpointObserver }]; } });

const TRUNCATION_MULTI_LINE_CLASS_NAME = 'truncation-multi-line';
const TRUNCATION_SINGLE_LINE_CLASS_NAME = 'truncation-single-line';
class AddTruncationAndTooltipDirective {
    set maxNumberOfLinesToShow(value) {
        this._maxNumberOfLinesToShow = value;
        this.setNumberOfLines();
    }
    get maxNumberOfLinesToShow() {
        return this._maxNumberOfLinesToShow;
    }
    constructor(elementRef, renderer, layoutService) {
        this.elementRef = elementRef;
        this.renderer = renderer;
        this.layoutService = layoutService;
        this._maxNumberOfLinesToShow = 1;
    }
    ngOnInit() {
        this.textElement = this.elementRef.nativeElement;
        this.setNumberOfLines();
    }
    ngAfterViewInit() {
        this.registerTooltipListener();
    }
    ngOnDestroy() {
        if (this.tooltipUnlistener) {
            this.tooltipUnlistener();
        }
    }
    setTooltipText() {
        if (this.textElement) {
            this.textElement.title = this.textElement.textContent;
        }
    }
    removeTooltipText() {
        if (this.textElement.title) {
            this.textElement.removeAttribute('title');
        }
    }
    elementTruncated() {
        return (this.textElement.clientWidth < this.textElement.scrollWidth ||
            this.textElement.clientHeight < this.textElement.scrollHeight);
    }
    addOrRemoveTooltip() {
        if (this.elementTruncated()) {
            this.setTooltipText();
        }
        else {
            this.removeTooltipText();
        }
    }
    setNumberOfLines() {
        if (this.textElement) {
            this.textElement.style.webkitLineClamp = '' + this.maxNumberOfLinesToShow;
            if (this.maxNumberOfLinesToShow > 1) {
                this.textElement.classList.add(TRUNCATION_MULTI_LINE_CLASS_NAME);
                this.textElement.classList.remove(TRUNCATION_SINGLE_LINE_CLASS_NAME);
            }
            else {
                this.textElement.classList.add(TRUNCATION_SINGLE_LINE_CLASS_NAME);
                this.textElement.classList.remove(TRUNCATION_MULTI_LINE_CLASS_NAME);
            }
        }
    }
    registerTooltipListener() {
        if (this.textElement && !this.layoutService.isTouchDevice) {
            this.tooltipUnlistener = this.renderer.listen(this.textElement, 'mouseenter', this.addOrRemoveTooltip.bind(this));
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: AddTruncationAndTooltipDirective, deps: [{ token: i0.ElementRef }, { token: i0.Renderer2 }, { token: LayoutService }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: AddTruncationAndTooltipDirective, selector: "[sieCoreAddTruncationAndTooltip]", inputs: { maxNumberOfLinesToShow: "maxNumberOfLinesToShow" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: AddTruncationAndTooltipDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[sieCoreAddTruncationAndTooltip]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: i0.Renderer2 }, { type: LayoutService }]; }, propDecorators: { maxNumberOfLinesToShow: [{
                type: Input
            }] } });

class AddTruncationAndTooltipModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: AddTruncationAndTooltipModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: AddTruncationAndTooltipModule, declarations: [AddTruncationAndTooltipDirective], exports: [AddTruncationAndTooltipDirective] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: AddTruncationAndTooltipModule }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: AddTruncationAndTooltipModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [AddTruncationAndTooltipDirective],
                    imports: [],
                    exports: [AddTruncationAndTooltipDirective]
                }]
        }] });

class AnchorButtonDirective {
    constructor() {
        this.disabled = false;
        this.role = 'button';
    }
    get tabindex() {
        return this.disabled ? '-1' : '0';
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: AnchorButtonDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: AnchorButtonDirective, selector: "[sieCoreAnchorButton]", inputs: { disabled: "disabled" }, host: { properties: { "attr.role": "this.role", "attr.tabindex": "this.tabindex" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: AnchorButtonDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[sieCoreAnchorButton]'
                }]
        }], propDecorators: { disabled: [{
                type: Input
            }], role: [{
                type: HostBinding,
                args: ['attr.role']
            }], tabindex: [{
                type: HostBinding,
                args: ['attr.tabindex']
            }] } });

class AnchorButtonModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: AnchorButtonModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: AnchorButtonModule, declarations: [AnchorButtonDirective], imports: [CommonModule], exports: [AnchorButtonDirective] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: AnchorButtonModule, imports: [CommonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: AnchorButtonModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [AnchorButtonDirective],
                    imports: [CommonModule],
                    exports: [AnchorButtonDirective]
                }]
        }] });

class AttributeDirective {
    constructor(hostElement, renderer) {
        this.hostElement = hostElement;
        this.renderer = renderer;
    }
    ngOnChanges(changes) {
        if (changes.sieCoreAttributes && this.sieCoreAttributes) {
            for (const attributeName in this.sieCoreAttributes) {
                if (this.sieCoreAttributes.hasOwnProperty(attributeName)) {
                    const attributeValue = this.sieCoreAttributes[attributeName];
                    if (attributeValue !== null && attributeValue !== undefined) {
                        this.renderer.setAttribute(this.hostElement.nativeElement, attributeName, attributeValue);
                    }
                    else {
                        this.renderer.removeAttribute(this.hostElement.nativeElement, attributeName);
                    }
                }
            }
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: AttributeDirective, deps: [{ token: i0.ElementRef }, { token: i0.Renderer2 }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: AttributeDirective, selector: "[sieCoreAttributes]", inputs: { sieCoreAttributes: "sieCoreAttributes" }, usesOnChanges: true, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: AttributeDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[sieCoreAttributes]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: i0.Renderer2 }]; }, propDecorators: { sieCoreAttributes: [{
                type: Input
            }] } });

class AttributeModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: AttributeModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: AttributeModule, declarations: [AttributeDirective], exports: [AttributeDirective] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: AttributeModule }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: AttributeModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [AttributeDirective],
                    exports: [AttributeDirective]
                }]
        }] });

class TruncateDirective {
    constructor(el) {
        this.el = el;
        this.truncationElements = [];
        this.alwaysVisibleElements = [];
        this.truncationGroups = [];
        this.maxPriorityValue = -1;
        this.loggingActivated = false;
        this.lastWindowWidth = Number.MAX_VALUE;
    }
    ngAfterViewInit() {
        requestAnimationFrame(() => {
            this.findTruncationElements([this.el.nativeElement]);
            if (this.truncationElements.length > 0) {
                this.calculateTruncationForElements();
                const resizeObservable = fromEvent(window, 'resize');
                const resizeEventDebounceTime = 500;
                this.resizeSubscription$ = resizeObservable.pipe(debounceTime(resizeEventDebounceTime)).subscribe(() => {
                    if (this.lastWindowWidth < window.innerWidth) {
                        this.setTruncatedElementsVisible();
                    }
                    this.lastWindowWidth = window.innerWidth;
                    requestAnimationFrame(() => this.calculateTruncationForElements());
                });
            }
        });
    }
    ngOnDestroy() {
        if (this.resizeSubscription$) {
            this.resizeSubscription$.unsubscribe();
        }
    }
    calculateTruncationForElements() {
        const containerStyle = getComputedStyle(this.el.nativeElement);
        const containerPaddingTop = parseInt(containerStyle.getPropertyValue('padding-top').replace('px', ''), 10);
        const containerPaddingBottom = parseInt(containerStyle.getPropertyValue('padding-bottom').replace('px', ''), 10);
        const containerHeight = this.el.nativeElement.clientHeight;
        // deep copy
        const clonedGroups = JSON.parse(JSON.stringify(this.truncationGroups));
        if (!isNaN(containerHeight) && containerHeight > 0) {
            const heightOfAlwaysVisibleElements = this.getHeightOfAlwaysVisibleElements();
            const heightLeftForTruncation = containerHeight - containerPaddingTop - containerPaddingBottom - heightOfAlwaysVisibleElements;
            this.log([
                'START containerHeight:',
                containerHeight,
                'heightOfAlwaysVisibleElements:',
                heightOfAlwaysVisibleElements,
                'heightLeftForTruncation:',
                heightLeftForTruncation
            ].toString());
            requestAnimationFrame(() => {
                this.truncateElementsEachFrame(heightLeftForTruncation, 0, null, clonedGroups);
            });
        }
        else {
            // wait until the element is properly rendered and has an height other than 0
            const observer = new ResizeObserver(() => {
                this.calculateTruncationForElements();
                observer.disconnect();
            });
            observer.observe(this.el.nativeElement);
        }
    }
    truncateElementsEachFrame(heightLeftForTruncation, counter, elementBefore, clonedGroups) {
        if (elementBefore) {
            heightLeftForTruncation -= elementBefore.offsetHeight;
            if (elementBefore.dataset.truncateGroupName) {
                const group = this.getGroupByName(elementBefore.dataset.truncateGroupName, clonedGroups);
                if (group) {
                    // how many lines are needed by the element
                    const styles = getComputedStyle(elementBefore);
                    const lineHeightRaw = styles.getPropertyValue('line-height');
                    const lineHeightNumber = parseFloat(lineHeightRaw.split('p')[0]);
                    const visibleLines = Math.floor(elementBefore.offsetHeight / lineHeightNumber);
                    group.maxLinesPerGroup -= visibleLines;
                }
            }
        }
        const nextTruncationElement = this.getNextTruncationElement(counter);
        const truncationElement = nextTruncationElement.truncationElement;
        counter = nextTruncationElement.counter;
        if (truncationElement) {
            // calculate truncation
            const styles = getComputedStyle(truncationElement);
            const lineHeightRaw = styles.getPropertyValue('line-height');
            const lineHeightNumber = parseFloat(lineHeightRaw.split('p')[0]);
            const marginTop = parseFloat(styles.getPropertyValue('margin-top').split('p')[0]);
            const marginBottom = parseFloat(styles.getPropertyValue('margin-bottom').split('p')[0]);
            this.log([
                'heightLeftForTruncation(before) ',
                heightLeftForTruncation,
                ' - marginTop',
                marginTop,
                ' - marginBottom',
                marginBottom
            ].toString());
            heightLeftForTruncation -= marginTop + marginBottom;
            this.log('heightLeftForTruncation ' + heightLeftForTruncation + ' lineHeightNumber ' + lineHeightNumber);
            let visibleLines = Math.floor(heightLeftForTruncation / lineHeightNumber);
            // check group settings and update maxLinesPerGroup
            if (truncationElement.dataset.truncateGroupName) {
                const group = this.getGroupByName(truncationElement.dataset.truncateGroupName, clonedGroups);
                if (group) {
                    if (group.limitedTroughGroup && visibleLines > group.maxLinesPerGroup) {
                        visibleLines = group.maxLinesPerGroup;
                    }
                    if (group.maxLinesPerItem !== -1 && visibleLines > group.maxLinesPerItem) {
                        visibleLines = group.maxLinesPerItem;
                    }
                    if (group.maxLinesPerGroup !== -1 && visibleLines > group.maxLinesPerGroup) {
                        visibleLines = group.maxLinesPerGroup;
                    }
                }
            }
            if (visibleLines > 0) {
                truncationElement.setAttribute('style', '-webkit-line-clamp: ' +
                    visibleLines +
                    '; overflow: hidden; -webkit-box-orient: vertical; display: -webkit-box;');
            }
            else {
                truncationElement.setAttribute('style', 'display: none');
            }
        }
        if (counter < this.maxPriorityValue) {
            requestAnimationFrame(() => {
                this.truncateElementsEachFrame(heightLeftForTruncation, counter, truncationElement, clonedGroups);
            });
        }
    }
    findTruncationElements(children) {
        if (children && children.length) {
            const length = children.length;
            for (let i = 0; i < length; i++) {
                const child = children[i];
                if (child.dataset.truncateLog === 'true') {
                    this.loggingActivated = true;
                }
                if (child.dataset.truncateGroupName) {
                    let truncateMaxLinesPerItem = null;
                    if (child.dataset.truncateMaxLinesPerItem) {
                        truncateMaxLinesPerItem = parseInt(child.dataset.truncateMaxLinesPerItem, 10);
                    }
                    let truncateLimitedTroughGroup = false;
                    if (child.dataset.truncateLimitedTroughGroup) {
                        truncateLimitedTroughGroup = child.dataset.truncateLimitedTroughGroup === 'true';
                    }
                    let truncateMaxLinesPerGroup = null;
                    if (child.dataset.truncateMaxLinesPerGroup) {
                        truncateMaxLinesPerGroup = parseInt(child.dataset.truncateMaxLinesPerGroup, 10);
                    }
                    this.addOrUpdateGroup(child.dataset.truncateGroupName, truncateMaxLinesPerGroup, truncateMaxLinesPerItem, truncateLimitedTroughGroup);
                }
                if (child.dataset.truncatePrio) {
                    const truncatePriority = parseInt(child.dataset.truncatePrio, 10);
                    if (truncatePriority > this.maxPriorityValue) {
                        this.maxPriorityValue = truncatePriority;
                    }
                    this.truncationElements.push(child);
                }
                else if (child.dataset.truncateAlwaysVisible) {
                    this.alwaysVisibleElements.push(child);
                }
                else {
                    this.findTruncationElements(child.children);
                }
            }
        }
    }
    addOrUpdateGroup(name, maxLinesPerGroup, maxLinesPerItem, limitedTroughGroup) {
        const group = this.getGroupByName(name, this.truncationGroups);
        if (group) {
            if (maxLinesPerItem !== null) {
                group.maxLinesPerItem = maxLinesPerItem;
            }
            if (maxLinesPerGroup !== null) {
                group.maxLinesPerGroup = maxLinesPerGroup;
            }
        }
        else {
            this.truncationGroups.push({
                limitedTroughGroup,
                name,
                maxLinesPerGroup: maxLinesPerGroup ? maxLinesPerGroup : -1,
                maxLinesPerItem: maxLinesPerItem ? maxLinesPerItem : -1
            });
        }
    }
    getGroupByName(name, group) {
        let result = null;
        group.forEach(groupItem => {
            if (groupItem.name === name) {
                result = groupItem;
            }
        });
        return result;
    }
    getNextTruncationElement(counter) {
        let truncationElement = null;
        do {
            counter++;
            this.truncationElements.forEach(element => {
                if (element.dataset.truncatePrio === '' + counter) {
                    truncationElement = element;
                }
            });
        } while (truncationElement === null && counter <= this.maxPriorityValue);
        this.log(['getNextTruncationElement found item with prio:', counter].toString());
        return { counter, truncationElement };
    }
    getHeightOfAlwaysVisibleElements() {
        let height = 0;
        if (this.alwaysVisibleElements.length) {
            this.alwaysVisibleElements.forEach(element => {
                height += element.clientHeight;
                const styles = getComputedStyle(element);
                const marginTop = parseFloat(styles.getPropertyValue('margin-top').split('p')[0]);
                const marginBottom = parseFloat(styles.getPropertyValue('margin-bottom').split('p')[0]);
                height += marginTop + marginBottom;
            });
        }
        return height;
    }
    log(info) {
        if (this.loggingActivated) {
            // eslint-disable-next-line no-console
            console.log(info);
        }
    }
    setTruncatedElementsVisible() {
        this.truncationElements.forEach(te => {
            te.setAttribute('style', 'display: block;');
        });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: TruncateDirective, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: TruncateDirective, selector: "[sieCoreTruncate]", ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: TruncateDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[sieCoreTruncate]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; } });

class TruncateModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: TruncateModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: TruncateModule, declarations: [TruncateDirective], exports: [TruncateDirective] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: TruncateModule }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: TruncateModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [TruncateDirective],
                    imports: [],
                    exports: [TruncateDirective]
                }]
        }] });

class ComponentBreakpointsDirective {
    constructor(element, layoutService, cdr) {
        this.element = element;
        this.layoutService = layoutService;
        this.cdr = cdr;
        this.componentViewportChanged = new Subject();
        this.viewportClass = ComponentBreakpointsDirective.getViewportClassName();
    }
    static getViewportClassName(viewport = 'S') {
        return 'component-viewport--' + viewport;
    }
    ngOnInit() {
        // for the initial loading of the component we need the observer to wait for angulars first proper resize event
        const observer = new ResizeObserver(() => {
            this.getComponentViewport();
            observer.disconnect();
        });
        observer.observe(this.element.nativeElement);
        // for everything else we can rely on the layout service
        this.resizeSubscription = this.layoutService.resizeEvent.subscribe(() => this.getComponentViewport());
    }
    ngOnDestroy() {
        this.resizeSubscription?.unsubscribe();
    }
    getComponentViewport() {
        const componentWidth = this.element.nativeElement.getBoundingClientRect().width;
        // return if no component width is available yet, this can happen when the site is resized
        if (!componentWidth) {
            return;
        }
        // otherwise do the calculation
        for (const [viewportKey, viewportWidth] of this.sieCoreComponentBreakpoints) {
            if (componentWidth >= viewportWidth) {
                this.viewport = viewportKey;
                this.viewportClass = ComponentBreakpointsDirective.getViewportClassName(this.viewport);
            }
        }
        if (this.viewport !== this.previousViewport) {
            this.componentViewportChanged.next(this.viewport);
            this.cdr.detectChanges();
            this.previousViewport = this.viewport;
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: ComponentBreakpointsDirective, deps: [{ token: i0.ElementRef }, { token: LayoutService }, { token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: ComponentBreakpointsDirective, selector: "[sieCoreComponentBreakpoints]", inputs: { sieCoreComponentBreakpoints: "sieCoreComponentBreakpoints" }, outputs: { componentViewportChanged: "componentViewportChanged" }, host: { properties: { "class": "this.viewportClass" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: ComponentBreakpointsDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[sieCoreComponentBreakpoints]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: LayoutService }, { type: i0.ChangeDetectorRef }]; }, propDecorators: { sieCoreComponentBreakpoints: [{
                type: Input
            }], componentViewportChanged: [{
                type: Output
            }], viewportClass: [{
                type: HostBinding,
                args: ['class']
            }] } });

class ComponentBreakpointsModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: ComponentBreakpointsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: ComponentBreakpointsModule, declarations: [ComponentBreakpointsDirective], imports: [CommonModule], exports: [ComponentBreakpointsDirective] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: ComponentBreakpointsModule, imports: [CommonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: ComponentBreakpointsModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [ComponentBreakpointsDirective],
                    imports: [CommonModule],
                    exports: [ComponentBreakpointsDirective]
                }]
        }] });

class HideIfEmptyDirective {
    set sieCoreHideIfEmpty(value) {
        this._sieCoreHideIfEmpty = value;
    }
    get visibility() {
        return this._sieCoreHideIfEmpty?.every(element => !element.children.length) ? 'none' : null;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: HideIfEmptyDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: HideIfEmptyDirective, selector: "[sieCoreHideIfEmpty]", inputs: { sieCoreHideIfEmpty: "sieCoreHideIfEmpty" }, host: { properties: { "style.display": "this.visibility" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: HideIfEmptyDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[sieCoreHideIfEmpty]'
                }]
        }], propDecorators: { sieCoreHideIfEmpty: [{
                type: Input
            }], visibility: [{
                type: HostBinding,
                args: ['style.display']
            }] } });

class HideIfEmptyModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: HideIfEmptyModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: HideIfEmptyModule, declarations: [HideIfEmptyDirective], exports: [HideIfEmptyDirective] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: HideIfEmptyModule }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: HideIfEmptyModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [HideIfEmptyDirective],
                    exports: [HideIfEmptyDirective]
                }]
        }] });

/**
 * # Highlight Directive
 *
 * Directive is meant to be used on the elements that we want to highlight through, e.g. search suggestions.
 * It needs a reference, such as a search term, in order to highlight it in the suggestions.
 *
 * ## Code example
 * @example
 * Template:
 * ```html
 * <span
 *  sieCoreHighlight
 *  [reference]="searchTermToHighlight"
 *  [highlightStartOnly]="false"
 *  [highlightBackgroundColor]="true"
 *  >{{ searchSuggestionText }}
 * </span>
 * ```
 */
class HighlightDirective {
    constructor(el) {
        this.el = el;
        /**
         * If false the referenced string will be bold.
         */
        this.inverted = false;
        /**
         * Whether to highlight only matches at the start of the string or anywhere.
         */
        this.highlightStartOnly = true;
        /**
         * Whether also show highlight background color
         */
        this.highlightBackgroundColor = false;
        this.active = false;
    }
    static escapeRegex(searchTerm) {
        // All of these should be escaped: \ ^ $ * + ? . ( ) | { } [ ]
        return searchTerm?.replace(/[.*+?^${}()|[\]\\]/g, '\\$&');
    }
    /** @ignore */
    ngOnChanges() {
        if (this.reference || this.active || this.inverted) {
            this.active = true;
            this.highlight();
        }
    }
    /** @ignore */
    ngAfterContentInit() {
        this.originalText = this.el.nativeElement.innerText;
        if (this.active) {
            this.highlight();
        }
    }
    highlight() {
        if (!this.originalText) {
            return;
        }
        this.highlightedText = this.highlightText();
        this.el.nativeElement.innerHTML = this.highlightedText;
    }
    highlightText() {
        if (this.reference || this.inverted) {
            const safeRegexString = HighlightDirective.escapeRegex(this.reference.trim());
            const regexString = this.highlightStartOnly ? `(^${safeRegexString})(.+)` : `(${safeRegexString})(.?)`;
            const regex = new RegExp(regexString, 'gi');
            return this.originalText.replace(regex, (_, p1, p2) => {
                return this.getHighlightString(p1, p2);
            });
        }
        else {
            return this.originalText;
        }
    }
    getHighlightString(p1, p2) {
        if (this.inverted) {
            return this.highlightBackgroundColor
                ? `${p1}<span style="background-color:${ColorInteractionFormHoverLightOnLight}">${p2}</span>`
                : `${p1}<b>${p2}</b>`;
        }
        else {
            return this.highlightBackgroundColor
                ? `<span style="background-color:${ColorInteractionFormHoverLightOnLight}">${p1}</span>${p2}`
                : `<b>${p1}</b>${p2}`;
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: HighlightDirective, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: HighlightDirective, selector: "[sieCoreHighlight]", inputs: { reference: "reference", inverted: "inverted", highlightStartOnly: "highlightStartOnly", highlightBackgroundColor: "highlightBackgroundColor" }, usesOnChanges: true, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: HighlightDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[sieCoreHighlight]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; }, propDecorators: { reference: [{
                type: Input
            }], inverted: [{
                type: Input
            }], highlightStartOnly: [{
                type: Input
            }], highlightBackgroundColor: [{
                type: Input
            }] } });

/**
 * # Highlight Module
 * - {@link HighlightDirective}
 *
 * ## Module peer dependencies
 * - {@link CommonModule}
 */
class HighlightModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: HighlightModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: HighlightModule, declarations: [HighlightDirective], imports: [CommonModule], exports: [HighlightDirective] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: HighlightModule, imports: [CommonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: HighlightModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [HighlightDirective],
                    imports: [CommonModule],
                    exports: [HighlightDirective]
                }]
        }] });

class CalcViewHeightDirective {
    constructor(elementRef, layoutService) {
        this.elementRef = elementRef;
        this.layoutService = layoutService;
        this.sieCoreCalcViewHeightEnabled = true;
        this.subscriptions = new Subscription();
        this.breakpoints = [
            { name: 'S', vh: 100, offset: 0 },
            { name: 'M', vh: 100, offset: 0 },
            { name: 'L', vh: 100, offset: 0 },
            { name: 'XL', vh: 100, offset: 0 },
            { name: 'XXL', vh: 100, offset: 0 }
        ];
        this.elementRef = elementRef;
    }
    ngOnInit() {
        if (this.sieCoreCalcViewHeightEnabled) {
            if (this.sieCoreCalcViewHeightBreakpoints) {
                this.breakpoints = this.sieCoreCalcViewHeightBreakpoints;
            }
            this.calcViewHeight();
            this.subscriptions.add(this.layoutService.resizeEvent.subscribe(() => {
                this.calcViewHeight();
            }));
        }
    }
    ngOnDestroy() {
        this.subscriptions.unsubscribe();
    }
    getCurrentVhBreakpoint() {
        const filtered_breakpoints = this.breakpoints.filter(bp => bp.name === this.layoutService.currentViewport);
        return filtered_breakpoints[0];
    }
    calcViewHeight() {
        const breakpoint = this.getCurrentVhBreakpoint();
        //update and set height Style for breakpoint
        this.elementRef.nativeElement.style.setProperty('height', breakpoint ? `calc(var(--vh, 1vh) * ${breakpoint.vh})` : '');
        //update and set ViewHeight property
        if (breakpoint) {
            const calculated_height = window.innerHeight - breakpoint.offset;
            const vh = calculated_height * 0.01;
            this.elementRef.nativeElement.style.setProperty('--vh', `${vh}px`);
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: CalcViewHeightDirective, deps: [{ token: i0.ElementRef }, { token: LayoutService }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: CalcViewHeightDirective, selector: "[sieCoreCalcViewHeight]", inputs: { sieCoreCalcViewHeightBreakpoints: "sieCoreCalcViewHeightBreakpoints", sieCoreCalcViewHeightEnabled: "sieCoreCalcViewHeightEnabled" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: CalcViewHeightDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[sieCoreCalcViewHeight]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: LayoutService }]; }, propDecorators: { sieCoreCalcViewHeightBreakpoints: [{
                type: Input
            }], sieCoreCalcViewHeightEnabled: [{
                type: Input
            }] } });

class CalcViewHeightModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: CalcViewHeightModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: CalcViewHeightModule, declarations: [CalcViewHeightDirective], exports: [CalcViewHeightDirective] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: CalcViewHeightModule }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: CalcViewHeightModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [CalcViewHeightDirective],
                    exports: [CalcViewHeightDirective]
                }]
        }] });

const ADD_HOVER_EVENTS_TIMEOUT = 250;
class AdvancedHoverEffectDirective {
    set hoverEffectLink(hoverEffectLink) {
        if (this._hoverEffectLink !== hoverEffectLink) {
            this._hoverEffectLink = hoverEffectLink;
            // wait till content underneath is rendered
            setTimeout(() => {
                this.addHoverEvents();
            }, ADD_HOVER_EVENTS_TIMEOUT);
        }
    }
    get hoverEffectLink() {
        return this._hoverEffectLink;
    }
    set hoverEffectAdditionalDataLoaded(hoverEffectAdditionalDataLoaded) {
        if (hoverEffectAdditionalDataLoaded) {
            setTimeout(() => {
                this.addHoverEvents();
            }, ADD_HOVER_EVENTS_TIMEOUT);
        }
    }
    constructor(el, renderer) {
        this.el = el;
        this.renderer = renderer;
    }
    addHoverEvents() {
        this.el.nativeElement.querySelectorAll(`a[href="${this.hoverEffectLink}"]`).forEach((item) => {
            item.addEventListener('mouseenter', () => this.renderer.addClass(this.el.nativeElement, 'advanced-hover'));
            item.addEventListener('mouseleave', () => this.renderer.removeClass(this.el.nativeElement, 'advanced-hover'));
        });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: AdvancedHoverEffectDirective, deps: [{ token: i0.ElementRef }, { token: i0.Renderer2 }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: AdvancedHoverEffectDirective, selector: "[sieCoreAdvancedHoverEffect]", inputs: { hoverEffectLink: "hoverEffectLink", hoverEffectAdditionalDataLoaded: "hoverEffectAdditionalDataLoaded" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: AdvancedHoverEffectDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[sieCoreAdvancedHoverEffect]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: i0.Renderer2 }]; }, propDecorators: { hoverEffectLink: [{
                type: Input
            }], hoverEffectAdditionalDataLoaded: [{
                type: Input
            }] } });

class AdvancedHoverEffectModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: AdvancedHoverEffectModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: AdvancedHoverEffectModule, declarations: [AdvancedHoverEffectDirective], exports: [AdvancedHoverEffectDirective] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: AdvancedHoverEffectModule }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: AdvancedHoverEffectModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [AdvancedHoverEffectDirective],
                    exports: [AdvancedHoverEffectDirective]
                }]
        }] });

class DataAttributeDirective {
    constructor(elementRef) {
        this.elementRef = elementRef;
    }
    ngAfterViewInit() {
        this.elementRef.nativeElement.dataset[this.dataAttrName] = this.dataAttrValue;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: DataAttributeDirective, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: DataAttributeDirective, selector: "[sieCoreDataAttribute]", inputs: { dataAttrName: "dataAttrName", dataAttrValue: "dataAttrValue" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: DataAttributeDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[sieCoreDataAttribute]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; }, propDecorators: { dataAttrName: [{
                type: Input
            }], dataAttrValue: [{
                type: Input
            }] } });

class DataAttributeModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: DataAttributeModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: DataAttributeModule, declarations: [DataAttributeDirective], exports: [DataAttributeDirective] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: DataAttributeModule }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: DataAttributeModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [DataAttributeDirective],
                    exports: [DataAttributeDirective]
                }]
        }] });

class InViewDirective {
    set rootMargin(value) {
        this._rootMargin = value;
        this.updateObserver();
    }
    constructor(elementRef) {
        this.elementRef = elementRef;
        this._rootMargin = '0px';
        this.threshold = [0.8, 1];
        this.inView = new Subject();
    }
    ngOnInit() {
        this.initializeObserver();
        this.observe();
    }
    handleIntersection(entries) {
        entries.forEach(entry => {
            if (entry.isIntersecting) {
                this.inView.next(true);
            }
            else {
                this.inView.next(false);
            }
        });
    }
    initializeObserver() {
        const options = {
            rootMargin: this._rootMargin,
            threshold: this.threshold
        };
        this._observer = new IntersectionObserver(entries => {
            this.handleIntersection(entries);
        }, options);
    }
    observe() {
        if (this._observer && this.elementRef.nativeElement) {
            this._observer.observe(this.elementRef.nativeElement);
        }
    }
    unobserve() {
        if (this._observer && this.elementRef.nativeElement) {
            this._observer.unobserve(this.elementRef.nativeElement);
        }
    }
    updateObserver() {
        if (this._observer) {
            this._observer.disconnect();
            this.initializeObserver();
            this.observe();
        }
    }
    ngOnDestroy() {
        this.unobserve();
        this._observer.disconnect();
        this.inView.complete();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: InViewDirective, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: InViewDirective, selector: "[sieCoreInView]", inputs: { threshold: ["sieCoreInView", "threshold"], rootMargin: "rootMargin" }, outputs: { inView: "inView" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: InViewDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[sieCoreInView]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; }, propDecorators: { threshold: [{
                type: Input,
                args: ['sieCoreInView']
            }], rootMargin: [{
                type: Input
            }], inView: [{
                type: Output
            }] } });

class InViewModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: InViewModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: InViewModule, declarations: [InViewDirective], imports: [CommonModule], exports: [InViewDirective] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: InViewModule, imports: [CommonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: InViewModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [InViewDirective],
                    imports: [CommonModule],
                    exports: [InViewDirective]
                }]
        }] });

class IntersectionObserverDirective {
    constructor(elementRef, zone) {
        this.elementRef = elementRef;
        this.zone = zone;
        this.elementIsVisible = new Subject();
        this.elementRef = elementRef;
        this.zone = zone;
        this.observer = null;
    }
    ngOnDestroy() {
        this.observer?.disconnect();
        this.observer = null;
    }
    ngOnInit() {
        this.zone.runOutsideAngular(() => {
            this.observer = new IntersectionObserver(entries => {
                entries.forEach(entry => {
                    if (entry.isIntersecting) {
                        this.elementIsVisible.next(true);
                        this.observer.disconnect();
                    }
                });
            });
            this.observer.observe(this.elementRef.nativeElement);
        });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: IntersectionObserverDirective, deps: [{ token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: IntersectionObserverDirective, selector: "[sieCoreIntersectionObserver]", outputs: { elementIsVisible: "elementIsVisible" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: IntersectionObserverDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[sieCoreIntersectionObserver]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: i0.NgZone }]; }, propDecorators: { elementIsVisible: [{
                type: Output
            }] } });

class IntersectionObserverModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: IntersectionObserverModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: IntersectionObserverModule, declarations: [IntersectionObserverDirective], imports: [CommonModule], exports: [IntersectionObserverDirective] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: IntersectionObserverModule, imports: [CommonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: IntersectionObserverModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [IntersectionObserverDirective],
                    imports: [CommonModule],
                    exports: [IntersectionObserverDirective]
                }]
        }] });

class RefreshSpaService {
    constructor() {
        this.refreshSPAEvent = new Subject();
    }
    refreshManual(reasons) {
        this.refreshSPAEvent.next(reasons);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: RefreshSpaService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: RefreshSpaService, providedIn: 'platform' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: RefreshSpaService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'platform'
                }]
        }] });

class RefreshComponentDirective {
    constructor(refreshReasons = []) {
        this.refreshReasons = refreshReasons;
        this.refreshSubscription = new Subscription();
        this.refreshSpaService = inject(RefreshSpaService);
        this.refreshSubscription.add(this.refreshSpaService.refreshSPAEvent.subscribe(reasons => {
            let reasonFound = false;
            for (let i = 0; i < reasons.length; i++) {
                if (this.refreshReasons.some(r => r === reasons[i])) {
                    reasonFound = true;
                }
                if (reasonFound) {
                    break;
                }
            }
            if (reasonFound) {
                this.refresh(reasons);
            }
        }));
    }
    ngOnDestroy() {
        this.refreshSubscription.unsubscribe();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: RefreshComponentDirective, deps: [{ token: Array }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: RefreshComponentDirective, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: RefreshComponentDirective, decorators: [{
            type: Directive
        }], ctorParameters: function () { return [{ type: Array }]; } });

class ElementResizeDirective {
    constructor(el, layoutService) {
        this.el = el;
        this.layoutService = layoutService;
        this.heightChange = new Subject();
        this.sizeChange = new Subject();
        this.height = new BehaviorSubject(null);
        this.width = new BehaviorSubject(null);
        this.widthPx = this.width.pipe(map(width => `${width}px`));
        this.breakpointKey = this.width.pipe(map(width => this.layoutService.getBreakpointKeyForValue(width)));
    }
    ngOnInit() {
        this.observer = new ResizeObserver(() => this.onResize());
        this.observer.observe(this.el.nativeElement);
    }
    ngOnDestroy() {
        this.observer.disconnect();
    }
    onResize() {
        this.sizeChange.next(0);
        this.height.next(this.el.nativeElement.offsetHeight);
        this.width.next(this.el.nativeElement.offsetWidth);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: ElementResizeDirective, deps: [{ token: i0.ElementRef }, { token: LayoutService }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: ElementResizeDirective, isStandalone: true, selector: "[sieCoreElementResize]", outputs: { heightChange: "heightChange", sizeChange: "sizeChange", height: "height", width: "width", widthPx: "widthPx", breakpointKey: "breakpointKey" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: ElementResizeDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[sieCoreElementResize]',
                    standalone: true
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: LayoutService }]; }, propDecorators: { heightChange: [{
                type: Output
            }], sizeChange: [{
                type: Output
            }], height: [{
                type: Output
            }], width: [{
                type: Output
            }], widthPx: [{
                type: Output
            }], breakpointKey: [{
                type: Output
            }] } });

class RepeatDirective {
    set sieCoreRepeat(times) {
        this.createView(times);
    }
    constructor(templateRef, viewContainer) {
        this.templateRef = templateRef;
        this.viewContainer = viewContainer;
    }
    createView(times) {
        this.viewContainer.clear();
        for (let i = 0; i < times; i++) {
            this.viewContainer.createEmbeddedView(this.templateRef, {
                index: i
            });
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: RepeatDirective, deps: [{ token: i0.TemplateRef }, { token: i0.ViewContainerRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: RepeatDirective, isStandalone: true, selector: "[sieCoreRepeat]", inputs: { sieCoreRepeat: "sieCoreRepeat" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: RepeatDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[sieCoreRepeat]',
                    standalone: true
                }]
        }], ctorParameters: function () { return [{ type: i0.TemplateRef }, { type: i0.ViewContainerRef }]; }, propDecorators: { sieCoreRepeat: [{
                type: Input
            }] } });

class LanguageNotProvidedError extends Error {
    constructor(message) {
        super(message);
        Object.setPrototypeOf(this, LanguageNotProvidedError.prototype);
    }
}

class LanguageNotSupportedError extends Error {
    constructor(region, message = 'Language not supported.') {
        super(message);
        this.region = region;
        Object.setPrototypeOf(this, LanguageNotSupportedError.prototype);
    }
}

class RegionNotProvidedError extends Error {
    constructor(message) {
        super(message);
        Object.setPrototypeOf(this, RegionNotProvidedError.prototype);
    }
}

class RegionNotSupportedError extends Error {
    constructor(languageCode, message) {
        super(message);
        this.languageCode = languageCode;
        Object.setPrototypeOf(this, RegionNotSupportedError.prototype);
    }
}

class JwtDecoderError extends Error {
    constructor(message) {
        super(message);
        Object.setPrototypeOf(this, JwtDecoderError.prototype);
    }
}

class RegionLanguageFileInvalidError extends Error {
    constructor(message) {
        super(message);
        Object.setPrototypeOf(this, RegionLanguageFileInvalidError.prototype);
    }
}

class SiemensError extends Error {
    constructor(code, message, logId) {
        super(message);
        Object.setPrototypeOf(this, SiemensError.prototype);
        this.timestamp = new Date();
        this.code = code;
        this.logId = logId;
    }
}

function getPropertyDynamically(object, path) {
    let pathSegments;
    if (path instanceof DynamicPropPath) {
        pathSegments = path.get().split(/\.|\[|\]\.?/);
    }
    else {
        pathSegments = path.split(/\.|\[|\]\.?/);
    }
    let current = object;
    for (let i = 0; i < pathSegments.length; i++) {
        const pathSegment = pathSegments[i];
        const numericSegment = parseInt(pathSegment, 10);
        if (!pathSegment || !current) {
            break;
        }
        current = current[isNaN(numericSegment) ? pathSegment : numericSegment];
    }
    return current;
}
class DynamicPropPath {
    constructor(path) {
        this.path = path;
    }
    get() {
        return this.path;
    }
}

class ArrayUtil {
    static is(array) {
        return new ArrayComparator(array);
    }
    static mapToStrings(array) {
        return array.map(item => item.toString());
    }
    static fromEnum(enumm) {
        return Object.keys(enumm)
            .map(key => enumm[key])
            .filter(key => isNaN(key));
    }
    static generate(length, mapFn) {
        const mappingFn = mapFn !== undefined ? mapFn : i => i;
        return Array.from({ length }, (_, i) => mappingFn(i));
    }
    static last(array) {
        if (!array?.length) {
            return undefined;
        }
        return array[array.length - 1];
    }
    static lastIndex(array) {
        return array.length - 1;
    }
    static moveToIndex(array, newIndex, compareFn) {
        const elementIndex = array.findIndex(compareFn);
        if (elementIndex >= 0) {
            const tmpElement = array[elementIndex];
            array.splice(elementIndex, 1);
            array.splice(newIndex, 0, tmpElement);
            return true;
        }
        return false;
    }
    static getPriorityBasedOnKey(array, key) {
        const priority = array.indexOf(key);
        if (priority < 0) {
            return array.length;
        }
        return priority;
    }
    static findByAttribute(array, field, value) {
        if (array) {
            return array.find(el => el && el[field] === value);
        }
        return undefined;
    }
    static wrapElementOrNull(value) {
        if (value) {
            return [value];
        }
        return null;
    }
    static replaceOrAddWithSameKey(array, field, element, expectedKey) {
        const index = array.findIndex(el => el[field] === expectedKey);
        if (index >= 0) {
            array[index] = element;
        }
        else {
            array.push(element);
        }
    }
    static limit(array, limit) {
        return array?.slice(0, Math.min(limit, array?.length)) ?? [];
    }
    static defaultIfEmpty(array, fallback) {
        if (!!array?.length) {
            return array;
        }
        return fallback;
    }
}
class ArrayComparator {
    constructor(array) {
        this.array = array;
    }
    /**
     * Comparator function which checks if the given array items have the same order as in the array it's compared against.
     * The function ignores missing and additional items. If items that are within both arrays are in the same order it will yield `true`.
     *
     * @example
     * // returns true
     * ArrayUtil.is([1,2,3]).ofSameItemOrderAs([1,2,3,4,5]);
     *
     * // returns false
     * ArrayUtil.is([1,3,2]).ofSameItemOrderAs([1,2,3,4,5]);
     */
    ofSameItemOrderAs(compareArray) {
        const array = this.array.length >= compareArray.length ? this.array : compareArray;
        const subArray = this.array.length < compareArray.length ? this.array : compareArray;
        return subArray.every((v, i) => v === array[i]);
    }
    containingAllItemsOf(compareArray) {
        return compareArray.every(arrayItem => this.array.includes(arrayItem));
    }
}
/**
 * Get an item by ID from an arbitrary array where the items contain an `id` field
 *
 * @param array Array of items which have at least `id` field
 * @param id Id to be matched
 * @return Item found or `undefined`
 */
const getItemForId = (array, id) => {
    return ArrayUtil.findByAttribute(array, 'id', id);
};
const sortArrayWithPriority = (array, priorities, sortByPropPath = '') => {
    const priorityMap = new Map(priorities.map((priority, i) => [priority, i - priorities.length]));
    return array.sort((a, b) => (priorityMap.get(getPropertyDynamically(a, sortByPropPath)) || 0) -
        (priorityMap.get(getPropertyDynamically(b, sortByPropPath)) || 0));
};
const sortArrayBasedOnKey = (priority, result) => {
    return result.sort((a, b) => {
        const aPriority = ArrayUtil.getPriorityBasedOnKey(priority, a.key);
        const bPriority = ArrayUtil.getPriorityBasedOnKey(priority, b.key);
        return aPriority - bPriority;
    });
};
const sortArrayByParameter = (result, p) => {
    return result.sort((a, b) => a[p] - b[p]);
};

class StringUtil {
    static capitalize(value) {
        return value.charAt(0).toUpperCase() + value.slice(1);
    }
    static unCapitalize(value) {
        return value.charAt(0).toLowerCase() + value.slice(1);
    }
    static hash(value) {
        let hash = 0, i, chr;
        if (value.length === 0) {
            return hash;
        }
        for (i = 0; i < value.length; i++) {
            chr = value.charCodeAt(i);
            hash = (hash << 5) - hash + chr;
        }
        return hash;
    }
    static truncate(value, maxLength) {
        return value?.length > maxLength ? value?.substring(0, maxLength) + '...' : value;
    }
    static equalsIgnoreCase(value, other) {
        if (value === other) {
            return true;
        }
        if (!value || !other) {
            return false;
        }
        return value.toLowerCase() === other.toLowerCase();
    }
}

var TemplatingStrategy;
(function (TemplatingStrategy) {
    TemplatingStrategy[TemplatingStrategy["AngleBrackets"] = 0] = "AngleBrackets";
    TemplatingStrategy[TemplatingStrategy["CurlyBrackets"] = 1] = "CurlyBrackets";
})(TemplatingStrategy || (TemplatingStrategy = {}));
function getSearchRegex(key, strategy) {
    if (strategy === TemplatingStrategy.AngleBrackets) {
        return new RegExp(`\<${key}\>`, 'gi');
    }
    else {
        return new RegExp(`\{\{${key}\}\}`, 'gi');
    }
}
function populateTemplate(templateString, values, strategy = TemplatingStrategy.CurlyBrackets) {
    let parsed = templateString;
    for (const key in values) {
        if (values.hasOwnProperty(key)) {
            parsed = parsed.replace(getSearchRegex(key, strategy), values[key]);
        }
    }
    return parsed;
}

class AppRegion {
    get languages() {
        return this._languages;
    }
    get defaultLanguage() {
        return this._defaultLanguage;
    }
    get urlCode() {
        return this.code.toLowerCase();
    }
    constructor(code, name, supported, flagSvgName, rolloutStatus, isDefault = false, disableGuidedTour = false, disableSupportPage = false, disableMySiePortal = false, regionUrl = null) {
        this.name = name;
        this.supported = supported;
        this.flagSvgName = flagSvgName;
        this.rolloutStatus = rolloutStatus;
        this.isDefault = isDefault;
        this.disableGuidedTour = disableGuidedTour;
        this.disableSupportPage = disableSupportPage;
        this.disableMySiePortal = disableMySiePortal;
        this._languages = [];
        this.code = code.toLowerCase();
        this.regionUrl = regionUrl ?? '/' + code;
    }
    addLanguage(language) {
        this._languages.push(language);
        if (language.isDefault) {
            this._defaultLanguage = language;
        }
    }
    getLanguageByCode(languageCode) {
        const language = this._languages.find(languageItem => StringUtil.equalsIgnoreCase(languageItem.code, languageCode));
        if (!language) {
            throw new LanguageNotSupportedError(this, `${languageCode} not supported`);
        }
        return language;
    }
    getLocaleWithDefaultLanguage() {
        return {
            region: this.urlCode,
            language: this._defaultLanguage.urlCode
        };
    }
    moveLanguageToFront(languageCode) {
        ArrayUtil.moveToIndex(this.languages, 0, language => language.code === languageCode);
    }
    hasLanguage(code) {
        return this.languages.some(appLanguage => appLanguage.code === code);
    }
}

class AppLanguage {
    get urlCode() {
        return this.code.toLowerCase();
    }
    constructor(code, name, isDefault = false) {
        this.code = code;
        this.name = name;
        this.isDefault = isDefault;
    }
}

const GLOBAL_REGION_CODE = 'WW';
class Region {
    static { this.visibleRolloutStatuses = ['pilotRollout', 'globalRollout', 'notRollout']; }
    static { this.permittedRolloutStatuses = ['pilotRollout', 'globalRollout']; }
    get defaultRegion() {
        return this._defaultRegion;
    }
    constructor(regions = []) {
        this.regions = regions;
        this._defaultRegion = regions.find(region => region.isDefault);
    }
    static createRegions(regionLanguagesResponse) {
        const supportedRegions = [];
        regionLanguagesResponse.localizations.forEach(apiRegion => {
            if (!this.isVisibleRolloutStatus(apiRegion.rolloutSiep)) {
                return;
            }
            const region = new AppRegion(apiRegion.region, '', this.isPermittedRolloutStatus(apiRegion.rolloutSiep), apiRegion.flag.toLowerCase(), apiRegion.rolloutSiep, !!apiRegion.default, apiRegion.disableGuidedTour, apiRegion.disableSupportPage, apiRegion.disableMySiePortal, apiRegion.regionurl);
            apiRegion.languages.forEach(apiLanguage => {
                const language = new AppLanguage(apiLanguage.key, '', !!apiLanguage.default);
                region.addLanguage(language);
            });
            supportedRegions.push(region);
        });
        return new Region(supportedRegions);
    }
    static isVisibleRolloutStatus(rolloutStatus) {
        return this.visibleRolloutStatuses.includes(rolloutStatus);
    }
    static isPermittedRolloutStatus(rolloutStatus) {
        return this.permittedRolloutStatuses.includes(rolloutStatus);
    }
    translateRegionNames(translateCallback) {
        this.regions.forEach(region => {
            region.name = translateCallback(region.code);
        });
    }
    translateLanguageNames(translateCallback) {
        this.regions.forEach(region => {
            region.languages.forEach(language => {
                language.name = translateCallback(language.code);
            });
        });
    }
    sortRegions() {
        this.regions.sort((a, b) => a.name.localeCompare(b.name));
        this.moveGlobalToFront();
    }
    sortLanguages() {
        this.regions.forEach(region => {
            region.languages.sort((a, b) => a.name.localeCompare(b.name));
            region.moveLanguageToFront(region.defaultLanguage.code);
        });
    }
    setFlags(setFlagCallback) {
        this.regions.forEach(region => {
            region.flag = setFlagCallback(region.flagSvgName);
        });
    }
    getSupportedRegionByCode(regionCode) {
        const region = regionCode && this.regions.find(appRegion => appRegion.code === regionCode.toLowerCase() && appRegion.supported);
        if (!region) {
            throw new RegionNotSupportedError(regionCode, `Region ${regionCode} not supported.`);
        }
        return region;
    }
    isRegionSupported(regionCode) {
        try {
            this.getSupportedRegionByCode(regionCode);
            return true;
        }
        catch (error) {
            return false;
        }
    }
    getDefaultLocale() {
        const region = this._defaultRegion;
        return {
            region: region.urlCode,
            language: region.defaultLanguage.urlCode
        };
    }
    moveGlobalToFront() {
        ArrayUtil.moveToIndex(this.regions, 0, region => region.code === GLOBAL_REGION_CODE.toLowerCase());
    }
}

const CONSOLE = 'CONSOLE';
const LOGGER_CONFIG = new InjectionToken('LoggerConfig');
const REGION_LANGUAGE_CONFIG_URL = 'REGION_LANGUAGE_CONFIG_URL';
const LOCATION = new InjectionToken('LOCATION');

const fakeLocation = {
    get href() {
        return 'https://localhost/';
    },
    get protocol() {
        return 'https:';
    },
    get hostname() {
        return 'localhost';
    },
    get pathname() {
        return '/';
    }
};
const mockLocationProvider = () => {
    return {
        provide: LOCATION,
        useValue: fakeLocation
    };
};

class LocaleConfigLoaderService {
    constructor(http, regionAndLanguageConfigUrl) {
        this.http = http;
        this.regionAndLanguageConfigUrl = regionAndLanguageConfigUrl;
    }
    getRegionsAndLanguages() {
        if (!this.regionAndLanguageObservable) {
            const headers = new HttpHeaders({
                'Cache-Control': 'no-cache, no-store, must-revalidate, post-check=0, pre-check=0',
                Pragma: 'no-cache',
                Expires: '0'
            });
            this.regionAndLanguageObservable = this.http
                .get(this.regionAndLanguageConfigUrl, { headers })
                .pipe(shareReplay(1));
        }
        return lastValueFrom(this.regionAndLanguageObservable);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: LocaleConfigLoaderService, deps: [{ token: i1$1.HttpClient }, { token: REGION_LANGUAGE_CONFIG_URL }], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: LocaleConfigLoaderService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: LocaleConfigLoaderService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: i1$1.HttpClient }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [REGION_LANGUAGE_CONFIG_URL]
                }] }]; } });

class UrlService {
    constructor() {
        this.VALID_URL_LOCALE_REGEXP = new RegExp('^[A-Za-z0-9]+-[A-Za-z0-9]+$');
        this.location = inject(LOCATION, { optional: true }) ?? location;
    }
    static { this.URL_PATH_SEPARATOR = '/'; }
    static { this.URL_PARAMETER_START_SEPARATOR = '?'; }
    static getQueryParams(paramsStr) {
        const params = {};
        const queryParams = new URLSearchParams(paramsStr);
        queryParams.forEach((value, key) => {
            params[key] = value;
        });
        return params;
    }
    getCurrentQueryParams() {
        const url = new URL(this.location.href);
        return UrlService.getQueryParams(url.search);
    }
    createUrlFromPath(path) {
        return new URL(this.location.protocol + this.location.hostname + (this.location.port ? ':' + this.location.port : '') + path);
    }
    getQueryParamsFromPath(path) {
        const url = this.createUrlFromPath(path);
        return UrlService.getQueryParams(url.search);
    }
    isAuthCallbackUrl() {
        return this.isUrl(this.location.pathname, AppRoutes.AuthCallback);
    }
    isSilentAuthCallbackUrl() {
        return this.isUrl(this.location.pathname, AppRoutes.SilentAuthCallback);
    }
    isUrl(url, route) {
        return url.includes(route);
    }
    isInternalUrl(url) {
        let urlObject;
        try {
            urlObject = new URL(url);
        }
        catch (error) {
            return true;
        }
        return urlObject?.hostname === this.location.hostname && urlObject?.port === this.location.port;
    }
    isLocalizedUrl(url) {
        const urlObject = new URL(url, `${this.location.protocol}${this.location.hostname}`);
        const localeSegment = urlObject.pathname.split(UrlService.URL_PATH_SEPARATOR)[1];
        return localeSegment && this.isValidUrlLocale(localeSegment);
    }
    isChatbotUrl() {
        return this.isUrl(this.location.pathname, AppRoutes.Chatbot);
    }
    getUrlPathnameAndParams(url) {
        const urlObject = new URL(url, `${this.location.protocol}${this.location.hostname}`);
        return `${urlObject.pathname}${urlObject.search}`;
    }
    getLocaleFromCurrentUrl() {
        return this.getLocaleFromUrl(this.location.pathname);
    }
    getLocaleFromUrl(url) {
        const localeSegment = url.split(UrlService.URL_PATH_SEPARATOR)[1];
        if (!localeSegment || !this.isValidUrlLocale(localeSegment)) {
            throw new RegionNotProvidedError('No region provided in url.');
        }
        const [urlLanguage, urlRegion] = localeSegment.split('-');
        return {
            language: urlLanguage,
            region: urlRegion
        };
    }
    getUrlLocale(locale) {
        return locale.language + '-' + locale.region;
    }
    getDefaultUrl(locale) {
        return this.getRouteWithLocale(locale, AppRoutes.Home);
    }
    getPathWithLocale(locale, path) {
        return `/${this.getUrlLocale(locale)}${path}`;
    }
    getRouteWithLocale(locale, route) {
        return `/${this.getUrlLocale(locale)}/${route}`;
    }
    getUrlWithLocale(url, parameters, locale, withParams = false) {
        const pathSegments = url.split(UrlService.URL_PATH_SEPARATOR);
        const localeSegment = pathSegments[1];
        if (pathSegments.length === 2 && !pathSegments[1]) {
            // empty path, return default landing page
            return this.getDefaultUrl(locale);
        }
        if (this.isValidUrlLocale(localeSegment)) {
            // url has locale on index [1], replace it
            pathSegments.splice(1, 1, this.getUrlLocale(locale));
        }
        else {
            // url doesn't have locale, insert it
            pathSegments.splice(1, 0, this.getUrlLocale(locale));
        }
        return withParams && parameters
            ? pathSegments.join(UrlService.URL_PATH_SEPARATOR) + UrlService.URL_PARAMETER_START_SEPARATOR + parameters
            : pathSegments.join(UrlService.URL_PATH_SEPARATOR);
    }
    splitUrlIntoPathAndSearch(url) {
        const indexOfParameterSeparator = url.indexOf(UrlService.URL_PARAMETER_START_SEPARATOR);
        if (indexOfParameterSeparator >= 0) {
            return {
                path: url.slice(0, indexOfParameterSeparator),
                search: url.slice(indexOfParameterSeparator + 1, url.length)
            };
        }
        else {
            return { path: url, search: null };
        }
    }
    stripUrlParameters(url) {
        return url.split(UrlService.URL_PARAMETER_START_SEPARATOR)[0];
    }
    getCurrentUrlWithLocale(locale, withParams = false) {
        return this.getUrlWithLocale(this.location.pathname, this.location.search, locale, withParams);
    }
    getCurrentHref() {
        return this.location.href;
    }
    getCurrentQueryParamsAsArray() {
        const params = this.getCurrentQueryParams();
        return Object.entries(params).map(([key, value]) => ({
            [key]: value
        }));
    }
    isValidUrlLocale(urlLocale) {
        return this.VALID_URL_LOCALE_REGEXP.test(urlLocale);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UrlService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UrlService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UrlService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }] });

const DEFAULT_LANGUAGE = 'en';
const DEFAULT_LOCALE_STRING = 'en-ww';
const DEFAULT_FALLBACK_REGION = 'ww';
var LocaleDiff;
(function (LocaleDiff) {
    LocaleDiff[LocaleDiff["None"] = 0] = "None";
    LocaleDiff[LocaleDiff["Language"] = 1] = "Language";
    LocaleDiff[LocaleDiff["Region"] = 2] = "Region";
})(LocaleDiff || (LocaleDiff = {}));
class LocaleService {
    get locale() {
        return this.locale$.value;
    }
    set locale(value) {
        this.locale$.next(value);
        if (value !== null) {
            this.isoValidLocaleString$.next(this.getIsoValidLocaleString());
        }
    }
    get regions() {
        return this._regions;
    }
    get filteredRegions() {
        return this._filteredRegions;
    }
    get homeLink() {
        return `/${this.getLocaleString()}/home`;
    }
    constructor(document, configLoader, urlService) {
        this.document = document;
        this.configLoader = configLoader;
        this.urlService = urlService;
        this.initialized = false;
        this.locale$ = new BehaviorSubject(null);
        this.isoValidLocaleString$ = new BehaviorSubject(DEFAULT_LOCALE_STRING);
    }
    initializeLanguageAndCheckUrl(path = null) {
        return new Promise((resolve, reject) => {
            this.getRegionsAndLanguages()
                .then(() => {
                this.setLocaleFromUrl(path);
                resolve();
            })
                .catch(error => {
                reject(error);
            });
        });
    }
    getTranslationName() {
        // calinga uses the ISO 3166-2: first two letters of the language in lowercase, first two letters of the region in uppercase.
        return this.locale.region === DEFAULT_FALLBACK_REGION
            ? this.locale.language
            : `${this.locale.language}-${this.getRegionUppercase()}`;
    }
    toTranslationName(urlLocale) {
        const [language, region] = urlLocale.split('-');
        return region === DEFAULT_FALLBACK_REGION ? language : `${language}-${region.toUpperCase()}`;
    }
    getLocaleString() {
        return this.urlService.getUrlLocale(this.locale);
    }
    /**
     * @returns safe iso language code with region part (e.g. de-de)
     */
    getIsoValidLocaleString() {
        const hasDigits = /\d/;
        if (hasDigits.test(this.locale.region) || hasDigits.test(this.locale.language)) {
            return DEFAULT_LOCALE_STRING;
        }
        else {
            return this.getLocaleString();
        }
    }
    setLocaleFromUrl(path = null) {
        let locale;
        if (path) {
            locale = this.urlService.getLocaleFromUrl(path);
        }
        else {
            locale = this.urlService.getLocaleFromCurrentUrl();
        }
        return this.updateLocale(locale.region, locale.language);
    }
    updateLocale(region, language) {
        const appRegion = this.regions.getSupportedRegionByCode(region);
        const appLanguage = appRegion.getLanguageByCode(language);
        this.locale = {
            region: appRegion.urlCode,
            language: appLanguage.urlCode
        };
        this.initialized = true;
        this.document.documentElement.lang = `${this.locale.language}-${this.locale.region}`;
        return null;
    }
    setDefaultLocale() {
        this.locale = this._regions.getDefaultLocale();
    }
    updateCurrentRegion() {
        this._regions.currentRegion = this._regions.getSupportedRegionByCode(this.locale.region);
    }
    getRegionsAndLanguages() {
        if (this._regions) {
            return Promise.resolve();
        }
        else {
            return this.configLoader
                .getRegionsAndLanguages()
                .then(regLangConfig => {
                this._regions = Region.createRegions(regLangConfig);
                const { defaultRegion } = this._regions;
                if (!defaultRegion || !defaultRegion.defaultLanguage || !defaultRegion.supported) {
                    throw new RegionLanguageFileInvalidError('invalid region language configuration');
                }
                this._filteredRegions = this._regions;
            })
                .catch(error => {
                this._regions = Region.createRegions({
                    localizations: [
                        {
                            default: true,
                            region: DEFAULT_FALLBACK_REGION,
                            languages: [
                                {
                                    key: DEFAULT_LANGUAGE,
                                    default: true
                                }
                            ],
                            flag: 'globe.svg',
                            rolloutSiep: 'pilotRollout'
                        }
                    ]
                });
                this._filteredRegions = this._regions;
                throw error;
            });
        }
    }
    filterRegions(searchTerm) {
        if (searchTerm.trim() !== '' && this.regionTranslations) {
            const filtered = this.regionTranslations.filterBy(searchTerm).regionCodes();
            this.updateFilteredRegions(filtered);
        }
        else {
            this.resetFilteredRegions();
        }
    }
    resetFilteredRegions() {
        this._filteredRegions = this._regions;
    }
    getRegionUppercase() {
        return this.locale.region.toUpperCase();
    }
    getLocaleDifference(locale) {
        if (locale.region !== this.locale.region) {
            return LocaleDiff.Region;
        }
        if (locale.language !== this.locale.language) {
            return LocaleDiff.Language;
        }
        return LocaleDiff.None;
    }
    updateFilteredRegions(filtered) {
        const filteredRegions = [];
        filtered.forEach(region => {
            const commonRegion = this.regions.regions.find(appRegion => appRegion.code === region.toLowerCase());
            commonRegion && filteredRegions.push(commonRegion);
        });
        const newRegions = { ...this.regions };
        newRegions.regions = filteredRegions;
        this._filteredRegions = newRegions;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: LocaleService, deps: [{ token: DOCUMENT }, { token: LocaleConfigLoaderService }, { token: UrlService }], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: LocaleService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: LocaleService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: Document, decorators: [{
                    type: Inject,
                    args: [DOCUMENT]
                }] }, { type: LocaleConfigLoaderService }, { type: UrlService }]; } });

class LocaleAwareNumberFormatService {
    constructor(localeService) {
        this.localeService = localeService;
    }
    format(value, options) {
        const localeString = this.localeService.getIsoValidLocaleString();
        return new Intl.NumberFormat(localeString, options).format(value);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: LocaleAwareNumberFormatService, deps: [{ token: LocaleService }], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: LocaleAwareNumberFormatService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: LocaleAwareNumberFormatService, decorators: [{
            type: Injectable,
            args: [{ providedIn: 'root' }]
        }], ctorParameters: function () { return [{ type: LocaleService }]; } });

class LocalNumberPipe {
    constructor(localeAwareNumberFormatService) {
        this.localeAwareNumberFormatService = localeAwareNumberFormatService;
    }
    transform(value, options) {
        return this.localeAwareNumberFormatService.format(value, options);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: LocalNumberPipe, deps: [{ token: LocaleAwareNumberFormatService }], target: i0.ɵɵFactoryTarget.Pipe }); }
    static { this.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: LocalNumberPipe, name: "localNumber" }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: LocalNumberPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'localNumber'
                }]
        }], ctorParameters: function () { return [{ type: LocaleAwareNumberFormatService }]; } });

const MILLISECONDS_IN_SECOND = 1000;
const SECONDS_IN_MINUTE = 60;
const MINUTES_IN_HOUR = 60;
const HOURS_IN_DAY = 24;
const MS_IN_MINUTE = 60000;
const MS_IN_HOUR = 3600000;
const MS_IN_DAY = 86400000;
const MONTHS_IN_YEAR = 12;
const MAX_DAYS_IN_MONTH = 31;
const DAYS_IN_WEEK = 7;
var TimeMeasurement;
(function (TimeMeasurement) {
    TimeMeasurement["Millisecond"] = "ms";
    TimeMeasurement["Second"] = "s";
    TimeMeasurement["Minute"] = "m";
    TimeMeasurement["Hour"] = "h";
    TimeMeasurement["Day"] = "d";
})(TimeMeasurement || (TimeMeasurement = {}));

class DateUtil {
    static getMonthNames(format, locale) {
        // If no specific date provided it can happen that it is a date greater than 28 and Feb will jump to Mar
        const SAFE_DATE = {
            DAY: 1,
            MONTH: 1,
            YEAR: 2021
        };
        const date = new Date(SAFE_DATE.YEAR, SAFE_DATE.MONTH, SAFE_DATE.DAY);
        return ArrayUtil.generate(MONTHS_IN_YEAR, index => {
            date.setMonth(index);
            return date.toLocaleDateString(locale, { month: format });
        });
    }
    static getWeekdayNames(format, locale) {
        const SUNDAY_DATE = {
            DAY: 30,
            MONTH: 4,
            YEAR: 2021
        };
        const sundayDate = new Date(SUNDAY_DATE.YEAR, SUNDAY_DATE.MONTH, SUNDAY_DATE.DAY);
        const dateNames = [];
        for (let i = 0; i < DAYS_IN_WEEK; i++) {
            dateNames.push(sundayDate.toLocaleDateString(locale, { weekday: format }));
            sundayDate.setDate(sundayDate.getDate() + 1);
        }
        return dateNames;
    }
    static getDate(dateString) {
        if (this.isDateInvalid(dateString)) {
            return null;
        }
        return new Date(dateString);
    }
    static isDateInvalid(dateString) {
        return isNaN(Date.parse(dateString));
    }
    static datesHaveSameDay(dateTimeOne, dateTimeTwo) {
        if (this.isDateInvalid(dateTimeOne) || this.isDateInvalid(dateTimeTwo)) {
            return false;
        }
        const dateOne = new Date(dateTimeOne);
        const dateTwo = new Date(dateTimeTwo);
        return (dateOne.getFullYear() === dateTwo.getFullYear() &&
            dateOne.getMonth() === dateTwo.getMonth() &&
            dateOne.getDate() === dateTwo.getDate());
    }
    static isDateBetweenTodayAndMonths(date, months) {
        const today = new Date().getTime();
        const referenceDate = new Date();
        referenceDate.setMonth(referenceDate.getMonth() + months);
        const timeToCheck = date.getTime();
        let lowerDate, higherDate, result;
        if (today < referenceDate.getTime()) {
            lowerDate = today;
            higherDate = referenceDate.getTime();
            result = lowerDate < timeToCheck && higherDate >= timeToCheck;
        }
        else {
            lowerDate = referenceDate.getTime();
            higherDate = today;
            result = lowerDate <= timeToCheck && higherDate > timeToCheck;
        }
        return result;
    }
    static getNumberOfDaysBetween(date) {
        const currentDate = new Date();
        // using UTC date because of summer and wintertime changes
        const currentUTCDate = Date.UTC(currentDate.getFullYear(), currentDate.getMonth(), currentDate.getDate());
        const dateUTCToCompare = Date.UTC(date.getFullYear(), date.getMonth(), date.getDate());
        return Math.ceil(Math.abs(currentUTCDate - dateUTCToCompare) / MS_IN_DAY);
    }
    static getDateWithoutTimezoneOffset(date) {
        const dateToModify = new Date(date);
        dateToModify.setMinutes(date.getMinutes() - date.getTimezoneOffset());
        return dateToModify;
    }
    static enableCustomParseFormatForDayJs() {
        dayjs__default.extend(customParseFormat);
    }
    static getTodayAddingYears(years) {
        return dayjs__default().add(years, 'y').toDate();
    }
    static getStartOfDay(date) {
        return dayjs__default(date).startOf('day').toDate();
    }
    static getEndOfDay(date) {
        return dayjs__default(date).endOf('day').toDate();
    }
    static getStartOf(date, unit, weekStart = 1) {
        return dayjs__default(date)
            .locale({ ...en, weekStart })
            .startOf(unit)
            .toDate();
    }
    static getEndOf(date, unit, weekStart = 1) {
        return dayjs__default(date)
            .locale({ ...en, weekStart })
            .endOf(unit)
            .toDate();
    }
    static parseDate(value, allowedFormats) {
        const parsedDate = dayjs__default(value, allowedFormats, true);
        return parsedDate.isValid() ? parsedDate.toDate() : null;
    }
    static validateLocaleFormat(locale) {
        const hasDigits = /\d/;
        if (hasDigits.test(locale)) {
            const paths = locale.split('-');
            if (hasDigits.test(paths[0])) {
                paths[0] = 'en';
            }
            if (hasDigits.test(paths[1])) {
                paths[1] = 'us';
            }
            locale = `${paths[0]}-${paths[1]}`;
        }
        return locale;
    }
    static getHoursBetweenDates(startDate, endDate) {
        const msBetweenDates = Math.abs(startDate.getTime() - endDate.getTime());
        return msBetweenDates / MS_IN_HOUR;
    }
    static isDateWithin24Hours(dateString) {
        if (this.isDateInvalid(dateString)) {
            return false;
        }
        return this.getHoursBetweenDates(new Date(dateString), new Date()) < HOURS_IN_DAY;
    }
    static isToday(dateString) {
        if (this.isDateInvalid(dateString)) {
            return false;
        }
        return new Date().toLocaleDateString() === new Date(dateString).toLocaleDateString();
    }
    static hasPassed(dateString) {
        if (this.isDateInvalid(dateString)) {
            return false;
        }
        return new Date() > new Date(dateString);
    }
}

const DEFAULT_DATE_FORMAT = {
    year: 'numeric',
    month: '2-digit',
    day: '2-digit'
};
class DateFormatService {
    formatDate(value, locale, format, type = 'date') {
        locale = DateUtil.validateLocaleFormat(locale);
        if (!value) {
            return '';
        }
        const date = new Date(value);
        switch (type) {
            case 'date':
                return date.toLocaleDateString(locale, format || DEFAULT_DATE_FORMAT);
            case 'time':
                return date.toLocaleTimeString(locale, format);
            default:
                return date.toLocaleTimeString(locale, format || DEFAULT_DATE_FORMAT);
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: DateFormatService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: DateFormatService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: DateFormatService, decorators: [{
            type: Injectable,
            args: [{ providedIn: 'root' }]
        }] });

class LocaleAwareDateFormatService {
    constructor(localeService, dateFormatService) {
        this.localeService = localeService;
        this.dateFormatService = dateFormatService;
    }
    formatDate(value, format, type = 'date') {
        const locale = this.localeService.getIsoValidLocaleString();
        return this.dateFormatService.formatDate(value, locale, format, type);
    }
    formatDateByUserFormat(date, format, isMallUser) {
        if (isMallUser) {
            return dayjs__default(date).format(format);
        }
        else {
            return this.formatDate(new Date(date));
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: LocaleAwareDateFormatService, deps: [{ token: LocaleService }, { token: DateFormatService }], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: LocaleAwareDateFormatService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: LocaleAwareDateFormatService, decorators: [{
            type: Injectable,
            args: [{ providedIn: 'root' }]
        }], ctorParameters: function () { return [{ type: LocaleService }, { type: DateFormatService }]; } });

class LocalDatePipe {
    constructor(localeAwareDateFormatService) {
        this.localeAwareDateFormatService = localeAwareDateFormatService;
    }
    transform(value, format, type = 'date') {
        return this.localeAwareDateFormatService.formatDate(value, format, type);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: LocalDatePipe, deps: [{ token: LocaleAwareDateFormatService }], target: i0.ɵɵFactoryTarget.Pipe }); }
    static { this.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: LocalDatePipe, name: "localDate" }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: LocalDatePipe, decorators: [{
            type: Pipe,
            args: [{ name: 'localDate' }]
        }], ctorParameters: function () { return [{ type: LocaleAwareDateFormatService }]; } });

class ViewportPipe {
    transform(viewport, method, ...comparisonViewport) {
        if (method === 'isIn' || method === 'notIn') {
            return viewport[method](...comparisonViewport);
        }
        else {
            return viewport[method](comparisonViewport[0]);
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: ViewportPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe }); }
    static { this.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: ViewportPipe, name: "viewport" }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: ViewportPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'viewport'
                }]
        }] });

class DatePipe {
    constructor(dateFormatService) {
        this.dateFormatService = dateFormatService;
    }
    transform(value, locale, format, type = 'date') {
        return this.dateFormatService.formatDate(value, locale, format, type);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: DatePipe, deps: [{ token: DateFormatService }], target: i0.ɵɵFactoryTarget.Pipe }); }
    static { this.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: DatePipe, name: "sieDate" }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: DatePipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'sieDate'
                }]
        }], ctorParameters: function () { return [{ type: DateFormatService }]; } });

class NumberPipe {
    transform(value, locale) {
        return new Intl.NumberFormat(locale).format(value);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: NumberPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe }); }
    static { this.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: NumberPipe, name: "sieNumber" }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: NumberPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'sieNumber'
                }]
        }] });

class TruncatePipe {
    transform(value, length) {
        return value.substring(0, length) + (length < value.length ? '...' : '');
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: TruncatePipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe }); }
    static { this.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: TruncatePipe, name: "truncate" }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: TruncatePipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'truncate'
                }]
        }] });

class BlobDownloadPipe {
    transform(value) {
        this.revokeHref();
        if (value) {
            this.href = window.URL.createObjectURL(value);
        }
        return this.href;
    }
    ngOnDestroy() {
        this.revokeHref();
    }
    revokeHref() {
        if (this.href) {
            window.URL.revokeObjectURL(this.href);
        }
        this.href = null;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: BlobDownloadPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe }); }
    static { this.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: BlobDownloadPipe, name: "sieBlobDownload" }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: BlobDownloadPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'sieBlobDownload'
                }]
        }] });

class SieCorePipesModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: SieCorePipesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: SieCorePipesModule, declarations: [LocalNumberPipe, LocalDatePipe, ViewportPipe, DatePipe, NumberPipe, TruncatePipe, BlobDownloadPipe], exports: [LocalNumberPipe, LocalDatePipe, ViewportPipe, DatePipe, NumberPipe, TruncatePipe, BlobDownloadPipe] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: SieCorePipesModule }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: SieCorePipesModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [LocalNumberPipe, LocalDatePipe, ViewportPipe, DatePipe, NumberPipe, TruncatePipe, BlobDownloadPipe],
                    exports: [LocalNumberPipe, LocalDatePipe, ViewportPipe, DatePipe, NumberPipe, TruncatePipe, BlobDownloadPipe]
                }]
        }] });

class IsArrayPipe {
    transform(value) {
        return Array.isArray(value);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: IsArrayPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe }); }
    static { this.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: IsArrayPipe, isStandalone: true, name: "isArray" }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: IsArrayPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'isArray',
                    standalone: true
                }]
        }] });

class LocalizedRouteBase {
    constructor(localeService) {
        this.localeService = localeService;
    }
    getLocale(fallbackLocale = DEFAULT_LOCALE_STRING) {
        return this.localeService.locale ? this.localeService.getLocaleString() : fallbackLocale;
    }
}
class LocalizedRoutePipe {
    constructor(localeService) {
        this.localeService = localeService;
    }
    transform(commands) {
        if (Array.isArray(commands)) {
            return ['/', this.getLocale(), ...commands];
        }
        else {
            return `/${this.getLocale()}/${commands}`;
        }
    }
    getLocale(fallbackLocale = DEFAULT_LOCALE_STRING) {
        return this.localeService.locale ? this.localeService.getLocaleString() : fallbackLocale;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: LocalizedRoutePipe, deps: [{ token: LocaleService }], target: i0.ɵɵFactoryTarget.Pipe }); }
    static { this.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: LocalizedRoutePipe, isStandalone: true, name: "localizedRoute" }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: LocalizedRoutePipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'localizedRoute',
                    standalone: true
                }]
        }], ctorParameters: function () { return [{ type: LocaleService }]; } });
class LocalizedRouteObservablePipe extends LocalizedRouteBase {
    constructor(localeService) {
        super(localeService);
        this.localeService = localeService;
    }
    transform(commands) {
        return this.localeService.locale$.pipe(map(() => {
            if (Array.isArray(commands)) {
                return ['/', this.getLocale(), ...commands];
            }
            else {
                return `/${this.getLocale()}/${commands}`;
            }
        }));
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: LocalizedRouteObservablePipe, deps: [{ token: LocaleService }], target: i0.ɵɵFactoryTarget.Pipe }); }
    static { this.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: LocalizedRouteObservablePipe, isStandalone: true, name: "localizedRoute$" }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: LocalizedRouteObservablePipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'localizedRoute$',
                    standalone: true
                }]
        }], ctorParameters: function () { return [{ type: LocaleService }]; } });

class GenerateArrayPipe {
    transform(length) {
        return ArrayUtil.generate(length);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: GenerateArrayPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe }); }
    static { this.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: GenerateArrayPipe, isStandalone: true, name: "generateArray" }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: GenerateArrayPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'generateArray',
                    standalone: true
                }]
        }] });

class SieCoreModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: SieCoreModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: SieCoreModule, imports: [AddTooltipModule, TruncateModule, SieCorePipesModule, DataAttributeModule] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: SieCoreModule, imports: [AddTooltipModule, TruncateModule, SieCorePipesModule, DataAttributeModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: SieCoreModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [AddTooltipModule, TruncateModule, SieCorePipesModule, DataAttributeModule]
                }]
        }] });

class ApiDataSourceNameRegistry {
    /**
     * Keeping the constructor private prevents manual instantiation.
     */
    // eslint-disable-next-line @typescript-eslint/no-empty-function
    constructor() {
        this.names = new Set();
    }
    static getInstance() {
        if (!this.instance) {
            this.instance = new ApiDataSourceNameRegistry();
        }
        return this.instance;
    }
    register(name) {
        if (this.names.has(name)) {
            throw new Error(`Trying to name DataSource: "${name}". Data Source names must be unique application-wide.`);
        }
        this.names.add(name);
        return name;
    }
    delete(name) {
        this.names.delete(name);
    }
    clear() {
        this.names.clear();
    }
}

const cacheRegister$ = new Subject();
class DataCacheService {
    constructor() {
        this.CONTEXT_HASH_STORAGE_KEY = `${CACHE_KEY_PREFIX}.contextHash`;
        this.localStorageExclusionList = [];
        this.caches = [];
        this.contextHash = +localStorage.getItem(this.CONTEXT_HASH_STORAGE_KEY);
        cacheRegister$.subscribe(cache => this.caches.push(cache));
    }
    clearAllCaches() {
        this.clear(localStorage, this.localStorageExclusionList);
        this.clear(sessionStorage, []);
        this.caches.forEach(cache => cache.clear());
    }
    notifyContextHashChange(value) {
        if (this.contextHash !== value) {
            this.clearAllCaches();
            this.contextHash = value;
            localStorage.setItem(this.CONTEXT_HASH_STORAGE_KEY, `${value}`);
        }
    }
    clear(storage, exclude) {
        for (const key in storage) {
            if (key.startsWith(CACHE_KEY_PREFIX) && !exclude.includes(key)) {
                storage.removeItem(key);
            }
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: DataCacheService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: DataCacheService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: DataCacheService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return []; } });

const CACHE_KEY_PREFIX = 'sieportal.cache';
function getCacheId(id) {
    return `${CACHE_KEY_PREFIX}.${id}`;
}
class AbstractDataCache {
    /**
     * Number of cached entries.
     */
    get size() {
        return this.cache.size;
    }
    /**
     * @param id Unique identifier for the instance.
     * @param expirationInMinutes Expiration time in minutes.
     */
    constructor(id, expirationInMinutes, contextAware = true) {
        this.id = getCacheId(id);
        this.expiration = expirationInMinutes;
        this.expirationMs = expirationInMinutes * MS_IN_MINUTE;
        if (contextAware) {
            cacheRegister$.next(this);
        }
    }
    get(key) {
        const record = this.cache.get(key);
        if (record && this.cacheRecordExpired(record)) {
            this.delete(key);
            return void 0;
        }
        return record;
    }
    set(key, data) {
        this.cache.set(key, {
            expiration: this.getExpirationTime(),
            data
        });
    }
    /**
     * This function will update an existing entry and prolong the expiration time.
     * In case of an expired entry no previous data will be lost.
     *
     * @param key the cache key
     * @param data the delta change which will be appended to the existing data
     */
    upsert(key, data) {
        const existingRecord = this.cache.get(key);
        this.cache.set(key, {
            expiration: this.getExpirationTime(),
            data: {
                ...existingRecord?.data,
                ...data
            }
        });
    }
    has(key) {
        return this.cache.has(key);
    }
    delete(key) {
        return this.cache.delete(key);
    }
    clear() {
        this.cache.clear();
    }
    expired(key) {
        const record = this.cache.get(key);
        if (record) {
            return this.cacheRecordExpired(record);
        }
        return true;
    }
    getExpirationTime() {
        return Date.now() + this.expirationMs;
    }
    cacheRecordExpired(record) {
        const expirationTime = record.expiration;
        const now = Date.now();
        return expirationTime <= now;
    }
}

class StorageMap extends Map {
    constructor(storageKey, storage) {
        super();
        this.storageKey = storageKey;
        this.storage = storage;
        this.readFromStorage();
    }
    set(key, value) {
        super.set(key, value);
        this.writeToStorage();
        return this;
    }
    delete(key) {
        const returnValue = super.delete(key);
        this.writeToStorage();
        return returnValue;
    }
    clear() {
        super.clear();
        this.writeToStorage();
    }
    readFromStorage() {
        const storageObject = JSON.parse(this.storage.getItem(this.storageKey) || '[]');
        super.clear();
        storageObject.forEach(([key, value]) => {
            super.set(key, value);
        });
    }
    writeToStorage() {
        const entries = Array.from(this);
        this.storage.setItem(this.storageKey, JSON.stringify(entries));
    }
}

class DataStorageCache extends AbstractDataCache {
    constructor(id, expiration, storage, contextAware = true) {
        super(id, expiration, contextAware);
        this.storage = storage;
        this.cache = new StorageMap(this.id, this.storage);
    }
}

function dataSourceCacheKey(request) {
    return StringUtil.hash(JSON.stringify(request) || '');
}

const DATA_SOURCE_STORAGE_CACHE_PREFIX = 'datasource';
function getDatasourceCacheId(id) {
    return `${DATA_SOURCE_STORAGE_CACHE_PREFIX}.${id}`;
}
class DataSourceStorageCache extends DataStorageCache {
    constructor(id, expiration, storage) {
        super(getDatasourceCacheId(id), expiration, storage);
    }
    key(request) {
        return dataSourceCacheKey(request);
    }
}

class DataMemoryCache extends AbstractDataCache {
    constructor() {
        super(...arguments);
        this.cache = new Map();
    }
}

class DataSourceMemoryCache extends DataMemoryCache {
    key(request) {
        return dataSourceCacheKey(request);
    }
}

const TIMEOUT_ERROR_MESSAGE = 'TIMEOUT_ERROR';
var ApiDataSourceCachingStrategy;
(function (ApiDataSourceCachingStrategy) {
    ApiDataSourceCachingStrategy[ApiDataSourceCachingStrategy["Memory"] = 0] = "Memory";
    ApiDataSourceCachingStrategy[ApiDataSourceCachingStrategy["LocalStorage"] = 1] = "LocalStorage";
    ApiDataSourceCachingStrategy[ApiDataSourceCachingStrategy["SessionStorage"] = 2] = "SessionStorage";
})(ApiDataSourceCachingStrategy || (ApiDataSourceCachingStrategy = {}));
class ApiDataSource {
    /**
     * Indicates whether the request is initiated and in progress.
     */
    get loading$() {
        return this._loading$;
    }
    get loading() {
        return this._loading$.value;
    }
    /**
     * Stream of request results. Conditionally mapped if a mapping function is provided.
     */
    get result$() {
        return this._result$;
    }
    get result() {
        return this._result$.value;
    }
    /**
     * Stream of errors.
     */
    get error$() {
        return this._error$;
    }
    get error() {
        return this._error$.value;
    }
    get lastRequestModel() {
        return this._lastRequestModel;
    }
    constructor(service, methodName, options) {
        this.service = service;
        this.methodName = methodName;
        this.options = options;
        /**
         * Defines the amount of time after which the request times out.
         */
        this.timeout = 0;
        /**
         * Defines the amount of times the request should be retried before failing.
         */
        this.retry = 0;
        /**
         * Default initial values used for the exposed observables.
         */
        this.defaultInitialValues = {
            loading: false,
            result: null,
            error: null
        };
        // Initialize values
        const { loading, result, error } = this.getInitialValues();
        this._loading$ = new BehaviorSubject(loading);
        this._result$ = new BehaviorSubject(result);
        this._error$ = new BehaviorSubject(error);
        if (options) {
            const { name, timeout: timeoutOption, map } = options;
            if (name) {
                this.name = ApiDataSourceNameRegistry.getInstance().register(name);
            }
            this.timeout = timeoutOption ?? 0;
            this.mappingFn = map;
            this.setUpCaching();
        }
    }
    request(model, options) {
        this._lastRequestModel = model;
        this.lastRequestOptions = options;
        this._loading$.next(true);
        this._result$.next(null);
        this._error$.next(null);
        this.requestSubscription?.unsubscribe();
        this.requestSubscription = new Subscription();
        if (this.cache && this.respondFromCache(model, options)) {
            return;
        }
        this.requestSubscription.add(
        // eslint-disable-next-line
        this.service[this.methodName](model)
            .pipe(...this.getRequestPipes(options))
            .subscribe((response) => {
            this.writeToCache(model, response);
            this.onSuccess(response, model, options?.success);
        }, (error) => this.onError(error, options?.error)));
    }
    requestPromise(model) {
        return new Promise((resolve, reject) => {
            this.request(model, {
                success: mappedResponse => resolve(mappedResponse),
                error: error => reject(error)
            });
        });
    }
    cancel() {
        this.requestSubscription?.unsubscribe();
        this._loading$.next(false);
        this._result$.next(null);
        this._error$.next(null);
    }
    retryRequest() {
        if (this.loading$.value) {
            return;
        }
        this.request(this._lastRequestModel, this.lastRequestOptions);
    }
    clearCache() {
        this.cache?.clear();
    }
    writeToCache(model, response) {
        if (!this.cache) {
            return;
        }
        const cacheKey = this.cache.key(model);
        this.cache?.set(cacheKey, response);
    }
    respondFromCache(model, options) {
        const cachedResponse = this.cache.get(this.cache.key(model));
        if (cachedResponse) {
            this.onSuccess(cachedResponse.data, model, options?.success);
        }
        return !!cachedResponse;
    }
    getInitialValues() {
        const initialValues = this.options?.initialValues;
        return !!initialValues
            ? {
                loading: initialValues.loading ?? this.defaultInitialValues.loading,
                result: initialValues.result || this.defaultInitialValues.result,
                error: initialValues.error || this.defaultInitialValues.error
            }
            : this.defaultInitialValues;
    }
    onSuccess(response, requestModel, successCallback) {
        this.requestSubscription.unsubscribe();
        this._error$.next(null);
        this._result$.next(this.mapResponse(response, requestModel));
        if (successCallback) {
            successCallback(this._result$.value);
        }
        this._loading$.next(false);
    }
    onError(error, errorCallback) {
        this.requestSubscription.unsubscribe();
        this._error$.next(error);
        this._result$.next(null);
        if (errorCallback) {
            errorCallback(error);
        }
        this._loading$.next(false);
    }
    mapResponse(response, request) {
        return this.mappingFn ? this.mappingFn(response, request) : response;
    }
    getRequestPipes(options) {
        const pipes = [];
        if (options?.timeout ?? this.timeout) {
            pipes.push(timeout({ each: this.timeout, with: () => throwError(() => new Error(TIMEOUT_ERROR_MESSAGE)) }));
        }
        if (this.retry) {
            pipes.push(retry(this.retry));
        }
        return pipes;
    }
    setUpCaching() {
        const options = this.options?.cache;
        if (!options) {
            return;
        }
        switch (options.strategy) {
            case ApiDataSourceCachingStrategy.LocalStorage:
                this.cache = new DataSourceStorageCache(this.name, options.expiration, localStorage);
                break;
            case ApiDataSourceCachingStrategy.SessionStorage:
                this.cache = new DataSourceStorageCache(this.name, options.expiration, sessionStorage);
                break;
            default:
                this.cache = new DataSourceMemoryCache(this.name, options.expiration);
        }
    }
}

class ApiDataSourceWithBreadcrumbs extends ApiDataSource {
    get breadCrumbAppendix$() {
        return this._breadcrumbAppendix$;
    }
    constructor(service, methodName, options) {
        super(service, methodName, options);
        this.service = service;
        this.methodName = methodName;
        this._breadcrumbAppendix$ = combineLatest([this.loading$, this.result$, this.error$], (loading, result, error) => {
            if (loading) {
                return this.breadcrumbMappers.loading();
            }
            if (error) {
                const errorMapper = this.breadcrumbMappers.error;
                return errorMapper ? this.breadcrumbMappers.error(error) : this.defaultBreadcrumbErrorMapper(error);
            }
            return this.breadcrumbMappers.success(result);
        });
        this.breadcrumbMappers = options.breadcrumbs;
    }
    defaultBreadcrumbErrorMapper(error) {
        return [
            {
                title: error.status === 403 /* HttpStatusCode.Forbidden */
                    ? this.breadcrumbMappers.errorLabels.accessDenied()
                    : this.breadcrumbMappers.errorLabels.loadingFailed()
            }
        ];
    }
}

class BaseListPagination {
    get pageSize() {
        return this.defaultPageSize;
    }
    set pageSize(value) {
        const optionIndex = this.pageSizeOptions.findIndex(option => option === value);
        if (optionIndex >= 0) {
            this.pageSizeOptionIndex = optionIndex;
            this.calculateTotalPages();
        }
    }
    get defaultPageSize() {
        return this.pageSizeOptions[this._pageSizeOptionIndex];
    }
    get activePage() {
        return this._activePage;
    }
    set activePage(value) {
        // Validate
        if (value >= this.startPage && value <= this._totalPages) {
            this._activePage = value;
        }
    }
    get startPage() {
        return this._startPage;
    }
    set startPage(value) {
        this._startPage = value;
    }
    get totalEntries() {
        return this._totalEntries;
    }
    set totalEntries(value) {
        this._totalEntries = value;
        this.calculateTotalPages();
    }
    get totalPages() {
        return this._totalPages;
    }
    set totalPages(value) {
        this._totalPages = value;
    }
    get pageSizeOptionIndex() {
        return this._pageSizeOptionIndex;
    }
    set pageSizeOptionIndex(value) {
        this._pageSizeOptionIndex = value;
    }
    get pageSizeOptions() {
        return this._pageSizeOptions;
    }
    set pageSizeOptions(value) {
        this._pageSizeOptions = value;
    }
    constructor(options) {
        this._pageSizeOptions = [];
        this._pageSizeOptionIndex = 0;
        this._pageSizeOptions = options.pageSizeOptions;
        this._startPage = options?.startPage ?? 1;
        this._totalEntries = options?.totalEntries;
        this.calculateTotalPages();
        if (options?.pageSize) {
            this.pageSize = options.pageSize;
        }
        this._activePage = options?.activePage || this.startPage;
    }
    calculateTotalPages() {
        if (!this.totalEntries || !this.defaultPageSize) {
            return;
        }
        this._totalPages = Math.ceil(this.totalEntries / this.defaultPageSize);
    }
    resetActiveToStartPage() {
        this._activePage = this.startPage;
    }
}

class InfiniteListPaginationImpl extends BaseListPagination {
    get startPage() {
        return 0;
    }
    get pageSize() {
        return 0;
    }
    set pageSize(_n) {
        // ignored
    }
    canLoadMoreEntries() {
        return this.activePage < this.totalPages;
    }
    requestDone(requestAll) {
        if (requestAll) {
            this.activePage = this.totalPages;
        }
        else {
            this.activePage++;
        }
    }
}

var ApiInfiniteListDataSourceOffsetStrategy;
(function (ApiInfiniteListDataSourceOffsetStrategy) {
    ApiInfiniteListDataSourceOffsetStrategy[ApiInfiniteListDataSourceOffsetStrategy["Index"] = 0] = "Index";
    ApiInfiniteListDataSourceOffsetStrategy[ApiInfiniteListDataSourceOffsetStrategy["Page"] = 1] = "Page";
})(ApiInfiniteListDataSourceOffsetStrategy || (ApiInfiniteListDataSourceOffsetStrategy = {}));
class ApiInfiniteListDataSource extends ApiDataSource {
    /**
     * Overriding original result$ to be able to merge old and new results.
     */
    get result$() {
        return this._listResult;
    }
    /**
     * Indicates whether the list is loaded initially.
     */
    get loading$() {
        return this.initiallyLoading$;
    }
    constructor(service, methodName, options) {
        super(service, methodName, {
            ...options,
            initialValues: {
                result: []
            }
        });
        this._listResult = new BehaviorSubject([]);
        this.initiallyLoading$ = new BehaviorSubject(false);
        this.initialLoad$ = new BehaviorSubject(true);
        /**
         * Indicates whether more items are loaded.
         */
        this.loadingMore$ = new BehaviorSubject(false);
        this.allItemsLoaded$ = new BehaviorSubject(false);
        this.loadMoreError$ = combineLatest([this.error$, this.initialLoad$]).pipe(map(([error, initialLoad]) => {
            return (!initialLoad && error) || null;
        }));
        this.offsetKey = 'offset';
        this.limitKey = 'limit';
        this.pagination = options?.paginationInstance || new InfiniteListPaginationImpl(options?.pagination);
        if (options?.offsetKey) {
            this.offsetKey = options.offsetKey;
        }
        if (options?.limitKey) {
            this.limitKey = options.limitKey;
        }
    }
    request(model, options) {
        this.initiallyLoading$.next(true); // must be done first before changing the result/error etc.
        this.result$.next([]);
        this.initialLoad$.next(true);
        this.doRequest(model, options, this.initiallyLoading$);
    }
    requestMore(model, options) {
        if (this.pagination.canLoadMoreEntries()) {
            this.initialLoad$.next(false);
            this.doRequest(model, options, this.loadingMore$);
        }
    }
    requestAll(model) {
        return new Promise((resolve, reject) => {
            if (this.pagination.canLoadMoreEntries()) {
                this.initialLoad$.next(false);
                this.doRequest(model, {
                    success: () => {
                        resolve();
                    },
                    error: () => reject()
                }, this.loadingMore$, true);
            }
            else {
                resolve();
            }
        });
    }
    cancel() {
        // do not fiddle around with the list result, initially loading and pagination when canceling the request
        super.cancel();
        this.loadingMore$.next(false);
    }
    cancelAndResetList() {
        this.cancel();
        this.allItemsLoaded$.next(false);
        this._listResult.next([]);
        this.pagination.totalEntries = 0;
        this.pagination.activePage = 0;
        this.initiallyLoading$.next(false);
        this.initialLoad$.next(true);
    }
    restoreFromCache(data, pagination) {
        if (data && pagination) {
            this.pagination.totalEntries = pagination.totalEntries;
            this.pagination.activePage = pagination.activePage - 1;
            this.result$.next(data);
            this.loading$.next(false);
            this.updateActivePage(false);
        }
    }
    doRequest(model, options, loader, requestAll = false) {
        loader.next(true);
        if (this.initiallyLoading$.value) {
            this.pagination.resetActiveToStartPage();
        }
        model = {
            ...model,
            ...this.getPaginationParameters()
        };
        if (requestAll) {
            model[this.limitKey] = this.pagination.totalEntries;
        }
        super.request(model, {
            ...options,
            success: value => {
                this.updateActivePage(requestAll);
                options?.success(value);
                loader.next(false);
            },
            error: error => {
                options?.error(error);
                loader.next(false);
            }
        });
    }
    mapResponse(response, request) {
        if (response?.count) {
            this.pagination.totalEntries = response.count;
        }
        const mappedNewData = super.mapResponse(response, request);
        this._listResult.next([...this._listResult.value, ...mappedNewData]);
        return mappedNewData;
    }
    getPaginationParameters() {
        return {
            [this.offsetKey]: this.pagination.activePage,
            [this.limitKey]: this.pagination.defaultPageSize
        };
    }
    updateActivePage(requestAll) {
        this.pagination.requestDone(requestAll);
        this.allItemsLoaded$.next(!this.pagination.canLoadMoreEntries());
    }
}

class ApiPollingDataSource extends ApiDataSource {
    constructor(service, methodName, options) {
        super(service, methodName, options);
        this.pollInterval = options.pollInterval;
    }
    /**
     * Function will poll request until success or error callback returns true to complete
     */
    poll(model, options) {
        const innerOptions = {
            ...options,
            success: this.wrapHandler(options.success),
            error: this.wrapHandler(options.error)
        };
        clearInterval(this.interval);
        this.interval = setInterval(() => super.request(model, innerOptions), this.pollInterval);
    }
    wrapHandler(originalHandler) {
        if (!originalHandler) {
            return null;
        }
        return (response) => {
            const endPolling = originalHandler(response);
            if (endPolling) {
                clearInterval(this.interval);
            }
        };
    }
}

/**
 * Used for SiePortal's {@link ErrorInterceptor} interceptor to disable error handling
 *
 * @default `false` -> Default is that error is <strong>NOT</strong> ignored.
 */
const ERROR_INTERCEPTOR_IGNORE_ERROR = new HttpContextToken(() => false);

function apiDataSourceMock() {
    return {
        request: () => null,
        requestPromise: () => null,
        cancel: () => null,
        cancelAndResetList: () => null,
        clearCache: () => null,
        retryRequest: () => null,
        result$: new BehaviorSubject(null),
        error$: new BehaviorSubject(null),
        loading$: new BehaviorSubject(null)
    };
}
function apiDataSourceMockProvider(datasource) {
    return {
        provide: datasource,
        useValue: apiDataSourceMock()
    };
}
function apiInfiniteDataSourceMock() {
    const initialLoad$ = new BehaviorSubject(true);
    const dataSource = apiDataSourceMock();
    return {
        ...dataSource,
        allItemsLoaded$: new BehaviorSubject(false),
        initialLoad$,
        loadingMore$: new BehaviorSubject(false),
        loadMoreError$: combineLatest([dataSource.error$, initialLoad$], (error, initialLoad) => {
            return (!initialLoad && error) || null;
        }),
        restoreFromCache: () => null,
        pagination: {
            totalEntries: 1,
            activePage: 1,
            defaultPageSize: 20,
            canLoadMoreEntries: () => false
        }
    };
}

function ApiMock(klass) {
    return function (target) {
        Object.getOwnPropertyNames(klass.prototype).forEach(methodName => {
            const subject = new Subject();
            target.prototype[methodName] = () => subject;
        });
        ApiDataSourceNameRegistry.getInstance().clear();
    };
}
function apiServiceMockProvider(apiService) {
    let MockApiService = class MockApiService {
    };
    MockApiService = __decorate([
        ApiMock(apiService)
    ], MockApiService);
    return {
        provide: apiService,
        useClass: MockApiService
    };
}

const notNull = (value) => value !== null;
const nonNullArray = (array) => !array.some(value => value === null);
const someNotNullArray = (array) => array.some(value => value !== null);
const notNullFilter = filter(notNull);
const nonNullArrayFilter = filter(nonNullArray);
const someNotNullArrayFilter = filter(someNotNullArray);
const definedOnly = (arg) => arg !== null && arg !== undefined;

const mapBoolean = map((value) => !!value);

class ApiDataSourceTestWrapper {
    constructor(dataSource) {
        this.dataSource = dataSource;
        this.sub = new Subscription();
        this.loadingSubject = 'loading$';
        this.service = dataSource.service;
        this.methodName = dataSource.methodName;
    }
    withRequestMore() {
        this.loadingSubject = 'loadingMore$';
        return this;
    }
    respond(response, callback) {
        return new Promise(resolve => {
            const responseSubject = this.subscribeToResponseEnd(callback, resolve);
            responseSubject.next(response);
        });
    }
    respondWithError(error, callback) {
        return new Promise(resolve => {
            const responseSubject = this.subscribeToResponseEnd(callback, resolve);
            responseSubject.error(error);
        });
    }
    subscribeToResponseEnd(callback, promiseResolve) {
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        const responseSubject = this.service[this.methodName]();
        this.sub.add(this.dataSource[this.loadingSubject].pipe(filter(notNull)).subscribe(loading => {
            if (!loading) {
                this.sub.unsubscribe();
                callback && callback();
                promiseResolve(this);
            }
        }));
        return responseSubject;
    }
}

class AppInitService {
    constructor() {
        this._isInitialized$ = new BehaviorSubject(false);
        this.isInitialized$ = this._isInitialized$.asObservable();
    }
    get isInitialized() {
        return this._isInitialized$.value;
    }
    /**
     * Temporary exposing a method to indicate app init until the complete init handling is moved to this service.
     */
    complete() {
        this._isInitialized$.next(true);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: AppInitService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: AppInitService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: AppInitService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }] });

class CircularArray {
    constructor() {
        this.selectedIndex = null;
    }
    set(array) {
        this.array = array;
        this.selectedIndex = null;
    }
    previousIndex() {
        if (!this.array) {
            return;
        }
        if (!this.selectedIndex) {
            this.selectedIndex = ArrayUtil.lastIndex(this.array);
        }
        else {
            this.selectedIndex--;
        }
        return this.selectedIndex;
    }
    nextIndex() {
        if (!this.array) {
            return;
        }
        if (this.selectedIndex === null || this.selectedIndex === ArrayUtil.lastIndex(this.array)) {
            this.selectedIndex = 0;
        }
        else {
            this.selectedIndex++;
        }
        return this.selectedIndex;
    }
    reset() {
        this.selectedIndex = null;
    }
    select(index) {
        if (index >= 0 && index < this.array.length) {
            this.selectedIndex = index;
        }
    }
    getSelectedIndex() {
        return this.selectedIndex;
    }
}

const leaveNumbersAndCommaRegex = /[^0-9,]/g;
class CoerceNumberArrayService {
    static clearString(s) {
        const filteredString = s.replace(leaveNumbersAndCommaRegex, '');
        return filteredString.split(',').filter(element => element.trim() !== '');
    }
    mapAndCoerceArrayElements(array) {
        return array.map(element => coerceNumberProperty(element));
    }
    coerceNumberArray(value) {
        if (!value) {
            return [];
        }
        const coercedToArray = coerceArray(value);
        let result = [];
        for (const element of coercedToArray) {
            if (typeof element === 'string') {
                const clearedString = CoerceNumberArrayService.clearString(element);
                result = result.concat(this.mapAndCoerceArrayElements(clearedString));
            }
            else if (element) {
                result.push(element);
            }
        }
        return result;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: CoerceNumberArrayService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: CoerceNumberArrayService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: CoerceNumberArrayService, decorators: [{
            type: Injectable,
            args: [{ providedIn: 'root' }]
        }] });

class SieUserProfile {
    constructor() {
        this.initials = '';
        this.firstName = '';
        this.lastName = '';
        this.fullName = '';
        this.email = '';
    }
    setLastLoginFromString(lastLogin) {
        const lastLoginAsString = lastLogin;
        if (!lastLoginAsString) {
            this.lastLogin = null;
            return;
        }
        const saneLastLoginAsString = lastLoginAsString.replace(' ', '');
        this.lastLogin = new Date(Date.parse(saneLastLoginAsString));
    }
}

class SieUser {
    constructor() {
        this.profile = new SieUserProfile();
    }
}

var CookieEventChannel;
(function (CookieEventChannel) {
    CookieEventChannel["CookieChanged"] = "cookieChanged";
})(CookieEventChannel || (CookieEventChannel = {}));

class CounterMap extends Map {
    increment(key) {
        if (!this.has(key)) {
            this.set(key, 0);
        }
        this.set(key, this.get(key) + 1);
    }
    decrement(key) {
        if (!this.has(key)) {
            this.set(key, 0);
            return;
        }
        this.set(key, Math.max(this.get(key) - 1, 0));
    }
    hasAny(key) {
        return this.get(key) > 0;
    }
    get(key) {
        if (!this.has(key)) {
            this.set(key, 0);
        }
        return super.get(key);
    }
}

class HandlerCombiner {
    constructor(handlerCalls, handler) {
        this.handlerCalls = handlerCalls;
        this.handler = handler;
        this.onReset = new Subject();
        this.timesCalled = 0;
    }
    call() {
        if (++this.timesCalled === this.handlerCalls) {
            this.handler();
            this.reset();
        }
    }
    reset() {
        this.timesCalled = 0;
        this.onReset.next();
    }
}

var KeyboardKey;
(function (KeyboardKey) {
    KeyboardKey["ArrowDown"] = "ArrowDown";
    KeyboardKey["ArrowUp"] = "ArrowUp";
    KeyboardKey["ArrowLeft"] = "ArrowLeft";
    KeyboardKey["ArrowRight"] = "ArrowRight";
    KeyboardKey["Backspace"] = "Backspace";
    KeyboardKey["Escape"] = "Escape";
    KeyboardKey["Enter"] = "Enter";
    KeyboardKey["Space"] = "Space";
    KeyboardKey["Tab"] = "Tab";
    KeyboardKey["Period"] = "Period";
    KeyboardKey["Comma"] = "Comma";
})(KeyboardKey || (KeyboardKey = {}));
const specialKeyMappings = new Map([
    [' ', KeyboardKey.Space],
    ['.', KeyboardKey.Period],
    [',', KeyboardKey.Comma],
    ['Down', KeyboardKey.ArrowDown],
    ['Up', KeyboardKey.ArrowUp],
    ['Left', KeyboardKey.ArrowLeft],
    ['Right', KeyboardKey.ArrowRight],
    ['Esc', KeyboardKey.Escape]
]);
class KeyboardEventUtil {
    static is(eventKey) {
        const mappedKey = this.toKeyboardKey(eventKey);
        return new KeyboardKeyComparator(mappedKey);
    }
    static toKeyboardKey(key) {
        return specialKeyMappings.get(key) || key;
    }
}
class KeyboardKeyComparator {
    constructor(eventKey) {
        this.eventKey = eventKey;
    }
    equalToKey(...keyboardKeys) {
        return keyboardKeys.some(keyboardKey => keyboardKey === this.eventKey);
    }
    numeric() {
        const numberRegex = new RegExp('\\d');
        return numberRegex.test(this.eventKey);
    }
}

// @types/hammerjs did not really work, thus here we have this replacement
const mockPanEventCoords = (input) => {
    return {
        center: {
            ...input
        }
    };
};
const mockPanEvent = (input) => {
    return {
        ...input
    };
};

class BusEvent {
    constructor(data, respond = () => undefined) {
        this.data = data;
        this.respond = respond;
    }
}

class InternalBusEvent {
    constructor(channel, data, respond = () => undefined) {
        this.channel = channel;
        this.data = data;
        this.respond = respond;
    }
    shouldEmitToChannel(channel) {
        const wildcards = ['*', '', undefined];
        return this.channel === channel || wildcards.includes(channel);
    }
    toBusEvent() {
        return new BusEvent(this.data, this.respond);
    }
}

class EventBus {
    constructor() {
        this.events$ = new Subject();
    }
    emit(channel, payload, response) {
        this.events$.next(new InternalBusEvent(channel, payload, response));
    }
    on$(channel) {
        return this.events$.pipe(filter(e => e.shouldEmitToChannel(channel)), map(e => e.toBusEvent()));
    }
    complete() {
        this.events$.complete();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: EventBus, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: EventBus, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: EventBus, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }] });

class OutsideAngularService {
    interval(timeout, callFunction) {
        // run outside Angular
        const setIntervalValue = '__zone_symbol__setInterval';
        const setInterval = window[setIntervalValue];
        return setInterval(() => {
            callFunction();
        }, timeout);
    }
    clearInterval(interval) {
        // run outside Angular
        const clearIntervalValue = '__zone_symbol__clearInterval';
        const clearInterval = window[clearIntervalValue];
        clearInterval(interval);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: OutsideAngularService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: OutsideAngularService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: OutsideAngularService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }] });

class CookieObserverService {
    constructor(eventBus, outsideAngularService, cookieService) {
        this.eventBus = eventBus;
        this.outsideAngularService = outsideAngularService;
        this.cookieService = cookieService;
        this.INTERVAL = 2000;
        this.cookiesToObserve = new Set();
        this.cookieValues = new Map();
        this.subscriberCounter = new CounterMap();
        this.runInterval();
    }
    observe(cookieName, next) {
        this.cookiesToObserve.add(cookieName);
        this.subscriberCounter.increment(cookieName);
        const cookieChangeSub = this.eventBus
            .on$(CookieEventChannel.CookieChanged)
            .pipe(filter(change => change.data.name === cookieName), finalize(() => {
            this.subscriberCounter.decrement(cookieName);
            if (!this.subscriberCounter.hasAny(cookieName)) {
                this.cookiesToObserve.delete(cookieName);
            }
        }))
            .subscribe(next);
        if (!this.intervalRef) {
            // If interval was previously stopped, re-run it.
            this.runInterval();
        }
        return cookieChangeSub;
    }
    updateCurrentValue(cookieName) {
        const currentValue = this.cookieService.get(cookieName) || undefined;
        this.cookieValues.set(cookieName, currentValue);
    }
    runInterval() {
        this.intervalRef = this.outsideAngularService.interval(this.INTERVAL, this.tick.bind(this));
    }
    tick() {
        // If no cookies are being observed clear the interval.
        if (!this.cookiesToObserve.size) {
            this.outsideAngularService.clearInterval(this.intervalRef);
            return;
        }
        this.cookiesToObserve.forEach(name => {
            // Cookie service returns an empty string for a non-existing cookie.
            const currentValue = this.cookieService.get(name) || undefined;
            const previousValue = this.cookieValues.get(name);
            if (previousValue !== currentValue) {
                const cookieChange = {
                    name,
                    previousValue,
                    currentValue
                };
                this.cookieValues.set(name, currentValue);
                this.eventBus.emit(CookieEventChannel.CookieChanged, cookieChange);
            }
        });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: CookieObserverService, deps: [{ token: EventBus }, { token: OutsideAngularService }, { token: i3.CookieService }], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: CookieObserverService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: CookieObserverService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: EventBus }, { type: OutsideAngularService }, { type: i3.CookieService }]; } });

let idCounter = 0;
const getUniqueID = (prefix, separator = '-') => {
    if (prefix) {
        return prefix + separator + idCounter++;
    }
    else {
        return '' + idCounter++;
    }
};
const resetIdCounter = () => {
    idCounter = 0;
};

const extensionToMimeType = new Map([
    ['jpg', 'image/jpeg'],
    ['jpe', 'image/jpeg'],
    ['jif', 'image/jpeg'],
    ['jpeg', 'image/jpeg'],
    ['jfif', 'image/jpeg'],
    ['png', 'image/png'],
    ['svg', 'image/svg+xml'],
    ['gif', 'image/gif'],
    ['webp', 'image/webp'],
    ['pdf', 'application/pdf'],
    ['ppt', 'application/vnd.ms-powerpoint'],
    ['doc', 'application/msword'],
    ['dot', 'application/msword'],
    ['xls', 'application/vnd.ms-excel'],
    ['pptx', 'application/vnd.openxmlformats-officedocument.presentationml.presentation'],
    ['xlsx', 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet'],
    ['docx', 'application/vnd.openxmlformats-officedocument.wordprocessingml.document'],
    ['txt', 'text/plain'],
    ['csv', 'text/csv'],
    ['bin', 'application/octet-stream'],
    ['gz', 'application/gzip'],
    ['zip', 'application/zip'],
    ['rar', 'application/vnd.rar'],
    ['7z', 'application/x-7z-compressed'],
    ['rtf', 'application/rtf'],
    ['odp', 'application/vnd.oasis.opendocument.presentation'],
    ['odt', 'application/vnd.oasis.opendocument.text'],
    ['ods', 'application/vnd.oasis.opendocument.spreadsheet'],
    ['mp4', 'video/mp4'],
    ['mpeg', 'video/mpeg'],
    ['webm', 'video/webm'],
    ['avi', 'video/avi'],
    ['exe', 'application/octet-stream'],
    ['msg', 'application/vnd.ms-outlook'],
    ['html', 'text/html'],
    ['htm', 'text/html'],
    ['htx', 'text/html'],
    ['shtm', 'text/html'],
    ['shtml', 'text/html'],
    ['acgi', 'text/html'],
    ['ehtml', 'text/html'],
    ['htt', 'text/webviewhtml'],
    ['json', 'application/json'],
    ['mht', 'message/rfc822'],
    ['mhtm', 'message/rfc822'],
    ['mhtml', 'message/rfc822'],
    ['mov', 'video/quicktime'],
    ['mp3', 'audio/mpeg'],
    ['mpg', 'video/mpeg'],
    ['pot', 'application/vnd.ms-powerpoint'],
    ['pps', 'application/vnd.ms-powerpoint'],
    ['svgz', 'image/svg+xml'],
    ['swf', 'application/x-shockwave-flash'],
    ['wav', 'audio/wav'],
    ['wma', 'audio/x-ms-wma'],
    ['wmv', 'audio/x-ms-wmv'],
    ['xhtml', 'application/xhtml+xml'],
    ['xhtm', 'application/xhtml+xml'],
    ['xht', 'application/xhtml+xml'],
    ['xlt', 'application/vnd.ms-excel'],
    ['xml', 'application/xml']
]);
/**
 * @param filename
 * @returns mimetype for extension or filename
 */
const getMimeType = (filename) => {
    if (!filename) {
        return null;
    }
    const index = filename.lastIndexOf('.');
    const extension = index < 0 ? filename : filename.substring(index + 1, filename.length);
    return extensionToMimeType.get(extension.toLowerCase());
};
const getBase64ContentType = (filename) => {
    return getMimeType(filename) ?? 'application/octet-stream';
};

var DataSourceCachingStrategy;
(function (DataSourceCachingStrategy) {
    DataSourceCachingStrategy[DataSourceCachingStrategy["Memory"] = 0] = "Memory";
    DataSourceCachingStrategy[DataSourceCachingStrategy["LocalStorage"] = 1] = "LocalStorage";
    DataSourceCachingStrategy[DataSourceCachingStrategy["SessionStorage"] = 2] = "SessionStorage";
})(DataSourceCachingStrategy || (DataSourceCachingStrategy = {}));

class CacheResponse {
    get exists() {
        return this.response !== undefined;
    }
    constructor(response) {
        this.response = response;
    }
}
/**
 * Abstract implementation for plain DataSources.
 */
class AbstractDataSource {
    /**
     * Indicates whether the request is initiated and in progress.
     */
    get loading$() {
        return this._loading$;
    }
    /**
     * Stream of request results. Conditionally mapped if a mapping function is provided.
     */
    get result$() {
        return this._result$;
    }
    /**
     * Stream of errors.
     */
    get error$() {
        return this._error$;
    }
    /**
     * Application wide unique DataSource name.
     */
    get name() {
        return this.options?.name;
    }
    /**
     * Method to request data/results. Not implemented because it can be an injected dependency in Injectables.
     */
    get requestMethod() {
        throw 'requestMethod not implemented.';
    }
    /**
     * Response mapping function.
     */
    get map() {
        return this.options?.map;
    }
    /**
     * Timeout after the request will fail if not resolved.
     */
    get timeout() {
        return this.options?.timeout ?? 0;
    }
    /**
     * Number of times to retry the request.
     */
    get retry() {
        return this.options?.retry ?? 0;
    }
    constructor(options) {
        this.options = options;
        /**
         * Default initial values used for the exposed observables.
         */
        this.defaultInitialValues = {
            initialLoading: false,
            initialResult: null,
            initialError: null
        };
        // Initialize values
        const { initialLoading, initialResult, initialError } = this.getInitialValues();
        this._loading$ = new BehaviorSubject(initialLoading);
        this._result$ = new BehaviorSubject(initialResult);
        this._error$ = new BehaviorSubject(initialError);
        if (options) {
            if (options.name) {
                ApiDataSourceNameRegistry.getInstance().register(options.name);
            }
            this.setUpCache();
        }
    }
    /**
     * Triggers the request for retrieving data.
     */
    request(model) {
        this.cancelRequest();
        this.endLoading();
        let requestObservable;
        const cachedResponse = this.respondFromCache(model);
        if (cachedResponse.exists) {
            requestObservable = of(cachedResponse.response);
        }
        else {
            requestObservable = this.requestMethod(model);
        }
        const reqObservablePiped = requestObservable.pipe.apply(requestObservable, [
            ...this.getRequestPipes(),
            map((res) => {
                if (!cachedResponse.exists) {
                    this.writeToCache(model, res);
                }
                return this.mapResponse(res);
            }),
            tap((data) => {
                this.success(data);
            }),
            shareReplay({ bufferSize: 1, refCount: true })
        ]);
        const reqObservableSubscription = reqObservablePiped.subscribe({
            complete: () => this.requestComplete(),
            error: err => {
                this.error(err);
            }
        });
        this.requestSubscription.add(reqObservableSubscription);
        return reqObservablePiped;
    }
    /**
     * Cancels the ongoing request.
     */
    cancelRequest() {
        this.requestSubscription?.unsubscribe();
        this.requestSubscription = new Subscription();
        this.endLoading();
    }
    /**
     * Resets the DataSource to it's initial state.
     *
     * @param toDefault - If the DS has initial values provided it will reset to them. If toDefault is set to true, this
     * will be overriden and default DS values will be used.
     */
    reset(toDefault = false) {
        this.requestSubscription.unsubscribe();
        const resetValues = toDefault ? this.defaultInitialValues : this.getInitialValues();
        this._loading$.next(resetValues.initialLoading);
        this._result$.next(resetValues.initialResult);
        this._error$.next(resetValues.initialError);
    }
    /**
     * It unsubscribes from any ongoing request and completes all exposed observables.
     */
    complete() {
        this.requestSubscription.unsubscribe();
        this._loading$.complete();
        this._result$.complete();
        this._error$.complete();
    }
    getInitialValues() {
        return {
            initialLoading: this.options?.initial?.loading || this.defaultInitialValues.initialLoading,
            initialResult: this.options?.initial?.data || this.defaultInitialValues.initialResult,
            initialError: this.options?.initial?.error || this.defaultInitialValues.initialError
        };
    }
    startLoading() {
        this._loading$.next(true);
        this._result$.next(null);
        this._error$.next(null);
    }
    endLoading() {
        this._loading$.next(false);
    }
    respondFromCache(model) {
        const cachedResponse = this.cache?.get(this.cache.key(model));
        return new CacheResponse(cachedResponse?.data);
    }
    writeToCache(model, response) {
        if (!this.cache) {
            return;
        }
        const cacheKey = this.cache.key(model);
        this.cache.set(cacheKey, response);
    }
    getRequestPipes() {
        const pipes = [];
        if (this.timeout) {
            pipes.push(timeoutWith(this.timeout, throwError(new Error(TIMEOUT_ERROR_MESSAGE))));
        }
        if (this.retry) {
            pipes.push(retry$1(this.retry));
        }
        return pipes;
    }
    mapResponse(response) {
        return this.map ? this.map(response) : response;
    }
    success(data) {
        this.requestSubscription.unsubscribe();
        this.error$.next(null);
        this._result$.next(data);
        this._loading$.next(false);
    }
    error(error) {
        this.requestSubscription.unsubscribe();
        this.error$.next(error);
        this._result$.next(null);
        this._loading$.next(false);
    }
    requestComplete() {
        // To be overridden.
    }
    setUpCache() {
        const options = this.options?.cache;
        if (!options) {
            return;
        }
        switch (options.strategy) {
            case DataSourceCachingStrategy.LocalStorage:
                this.cache = new DataSourceStorageCache(this.name, options.expiration, localStorage);
                break;
            case DataSourceCachingStrategy.SessionStorage:
                this.cache = new DataSourceStorageCache(this.name, options.expiration, sessionStorage);
                break;
            default:
                this.cache = new DataSourceMemoryCache(this.name, options.expiration);
        }
    }
}

/**
 * I have to put this here
 *
 * @typeParam RESPONSE - Type of the provided response.
 * @typeParam DATA - Type of the data the DataSource provides. Defaults to the `RESPONSE`.
 * @typeParam REQ_MODEL - Type of the model used to request data. Defaults to `void`.
 */
class DataSource extends AbstractDataSource {
    /**
     * Method to request data/results.
     */
    get requestMethod() {
        return this.options.request;
    }
    constructor(options) {
        super(options);
        this.options = options;
    }
    static create(options) {
        return new DataSource(options);
    }
}

const FILTER_UPDATE_DELAY = 20;
const DEFAULT_DEBOUNCE_DELAY = 300;
function Debounce(delay = DEFAULT_DEBOUNCE_DELAY) {
    return (_target, _propertyKey, descriptor) => {
        const timeoutKey = Symbol();
        const original = descriptor.value;
        descriptor.value = function (...args) {
            clearTimeout(this[timeoutKey]);
            this[timeoutKey] = setTimeout(() => original.apply(this, args), delay);
        };
        return descriptor;
    };
}

const ON_CHANGES_HANDLERS_METADATA_KEY = 'ON_CHANGES_HANDLERS';
const ON_CHANGES_GROUP_METADATA_KEY = 'ON_CHANGES_GROUPS';

class ChangeHandler {
    constructor(trigger, handler, parameters) {
        this.trigger = trigger;
        this.handler = handler;
        this.parameters = parameters;
    }
}

class ChangeGroup {
    constructor(name) {
        this.name = name;
        this.triggers = [];
        this.handlers = [];
    }
}

function getHandlersMap(target) {
    let handlersMap = Reflect.get(target, ON_CHANGES_HANDLERS_METADATA_KEY);
    if (!handlersMap) {
        handlersMap = new Map();
        Reflect.set(target, ON_CHANGES_HANDLERS_METADATA_KEY, handlersMap);
    }
    return handlersMap;
}
function getChangeGroupsMap(target) {
    if (!Reflect.has(target, ON_CHANGES_GROUP_METADATA_KEY)) {
        Reflect.set(target, ON_CHANGES_GROUP_METADATA_KEY, new Map());
    }
    return Reflect.get(target, ON_CHANGES_GROUP_METADATA_KEY);
}
function getChangeGroup(target, groupName) {
    const changeGroups = getChangeGroupsMap(target);
    if (!changeGroups.has(groupName)) {
        changeGroups.set(groupName, new ChangeGroup(groupName));
    }
    return changeGroups.get(groupName);
}
function getHandlersForInputChange(target, inputName) {
    return getHandlersMap(target)?.get(inputName) || [];
}
function setHandlerForInputChange(target, inputName, handlerName, parameters) {
    const handlersMap = getHandlersMap(target);
    if (!handlersMap.has(inputName)) {
        handlersMap.set(inputName, []);
    }
    const handlers = handlersMap.get(inputName);
    handlers.push(new ChangeHandler(inputName, handlerName, parameters || []));
}
function setHandlerForGroup(target, groupName, handlerName) {
    const changeGroup = getChangeGroup(target, groupName);
    changeGroup.handlers.push(handlerName);
}
function setTriggerForGroup(target, groupName, inputName) {
    const changeGroup = getChangeGroup(target, groupName);
    changeGroup.triggers.push(inputName);
}
function getChangeGroupsHandlersForInputChange(target, changedInputs) {
    const changeGroups = getChangeGroupsMap(target);
    const handlers = [];
    changeGroups.forEach(group => {
        if (group.triggers.some(trigger => changedInputs.includes(trigger))) {
            handlers.push(...group.handlers);
        }
    });
    return Array.from(new Set(handlers));
}

var OnChangesExecutionStrategy;
(function (OnChangesExecutionStrategy) {
    OnChangesExecutionStrategy[OnChangesExecutionStrategy["HandlerFirst"] = 0] = "HandlerFirst";
    OnChangesExecutionStrategy[OnChangesExecutionStrategy["GroupFirst"] = 1] = "GroupFirst";
})(OnChangesExecutionStrategy || (OnChangesExecutionStrategy = {}));
function OnChange(options) {
    return function (target) {
        const originalMethod = target.prototype.ngOnChanges;
        target.prototype.ngOnChanges = function (changes) {
            const changedInputs = Object.keys(changes);
            // Handlers
            const handlersToCall = [];
            changedInputs.forEach(inputName => {
                handlersToCall.push(...getHandlersForInputChange(this, inputName));
            });
            if (options?.handlerExecutionPriority) {
                sortArrayWithPriority(handlersToCall, options.handlerExecutionPriority, 'handler');
            }
            // Group handlers
            const groupHandlersToCall = getChangeGroupsHandlersForInputChange(this, changedInputs);
            if (options?.groupHandlerExecutionPriority) {
                sortArrayWithPriority(groupHandlersToCall, options.groupHandlerExecutionPriority);
            }
            // Execution strategy
            let execution;
            if (options?.executionStrategy === OnChangesExecutionStrategy.GroupFirst) {
                execution = [groupHandlersToCall, handlersToCall];
            }
            else {
                execution = [handlersToCall, groupHandlersToCall];
            }
            execution.forEach(execArray => {
                execArray.forEach(changeHandler => {
                    if (changeHandler instanceof ChangeHandler) {
                        const parameters = changeHandler.parameters.map(param => {
                            if (param === '$value') {
                                return this[changeHandler.trigger];
                            }
                            return param;
                        });
                        Reflect.apply(this[changeHandler.handler], this, parameters);
                    }
                    else {
                        Reflect.apply(this[changeHandler], this, []);
                    }
                });
            });
            originalMethod?.apply(this, changes);
        };
    };
}

function OnChangesHandler(inputName, parameters) {
    return function (target, methodName) {
        setHandlerForInputChange(target, inputName, methodName, parameters);
    };
}

function OnChangesGroup(...groupNames) {
    return function (target, key) {
        groupNames.forEach(groupName => {
            setTriggerForGroup(target, groupName, key);
        });
    };
}

function OnChangesGroupHandler(...groupNames) {
    return function (target, methodName) {
        groupNames.forEach(groupName => {
            setHandlerForGroup(target, groupName, methodName);
        });
    };
}

var DatePart;
(function (DatePart) {
    DatePart["Day"] = "day";
    DatePart["Month"] = "month";
    DatePart["Year"] = "year";
})(DatePart || (DatePart = {}));
class DateParserService {
    constructor() {
        this.separators = ['\\. ', ' ', '\\.', '\\/', '\\-'];
        this.separatorRegex = new RegExp(this.separators.join('|'), 'gi');
    }
    getDateFormatForLocale(locale) {
        locale = DateUtil.validateLocaleFormat(locale);
        const day = 1;
        const month = 2;
        const year = 2000;
        const referenceDate = new Date(year, month - 1, day);
        const referenceDateString = referenceDate.toLocaleDateString(locale);
        const separator = this.getSeparator(referenceDateString);
        const endsWithSeparator = referenceDateString.endsWith(separator.trim());
        const format = [];
        const placeholder = [];
        const order = [];
        const formatTerminator = () => (endsWithSeparator ? separator.trim() : '');
        if (separator) {
            const dateParts = referenceDateString.split(separator).map(part => +part);
            format[dateParts.indexOf(day)] = 'DD';
            placeholder[dateParts.indexOf(day)] = 'DD';
            order[dateParts.indexOf(day)] = DatePart.Day;
            format[dateParts.indexOf(month)] = 'MM';
            placeholder[dateParts.indexOf(month)] = 'MM';
            order[dateParts.indexOf(month)] = DatePart.Month;
            format[dateParts.indexOf(year)] = 'YYYY';
            placeholder[dateParts.indexOf(year)] = 'YYYY';
            order[dateParts.indexOf(year)] = DatePart.Year;
            return {
                value: format.join(separator) + formatTerminator(),
                order,
                separator: separator,
                placeholder: placeholder.join(separator)
            };
        }
    }
    getSeparator(dateString) {
        const separator = new Set(dateString.match(this.separatorRegex) || []);
        if (separator.size > 1) {
            throw new Error('Multiple separators.');
        }
        return separator.values().next().value;
    }
    getPlaceholderForValue(dateString, locale) {
        const dateFormat = this.getDateFormatForLocale(locale);
        const fieldParts = dateString.split(dateFormat.separator);
        const placeHolderParts = dateFormat.placeholder.split(dateFormat.separator);
        const newPlaceholderParts = [];
        for (let i = 0; i < placeHolderParts.length; i++) {
            const fieldPart = fieldParts[i];
            const placeholderPart = placeHolderParts[i];
            if (fieldPart) {
                // if any part is not valid with the locale format return empty placeholder
                if (!this.isValidFieldPartByType(fieldParts[i], dateFormat.order[i])) {
                    return '';
                }
                let newFieldPart;
                // if next part exists ("" is valid but falsy) do not fill in placeholder, could cause (6M/1D/YYYY)
                if (fieldParts[i + 1] !== undefined) {
                    newFieldPart = fieldPart;
                }
                else {
                    newFieldPart = fieldPart + placeholderPart.slice(fieldPart.length);
                }
                newPlaceholderParts.push(newFieldPart);
            }
            else {
                // 01// situation
                if (fieldParts[i + 1] !== undefined) {
                    return '';
                }
                // separator is preceding but part not entered yet
                newPlaceholderParts.push(placeHolderParts[i]);
            }
        }
        return newPlaceholderParts.join(dateFormat.separator);
    }
    canAppendSeparator(dateString, locale) {
        const dateFormat = this.getDateFormatForLocale(locale);
        const parsedDate = dayjs(dateString, dateFormat.value);
        if (!parsedDate.isValid()) {
            return false;
        }
        const fieldParts = dateString.split(dateFormat.separator);
        const lastPart = ArrayUtil.last(fieldParts);
        const placeHolderParts = dateFormat.placeholder.split(dateFormat.separator);
        return (fieldParts.length !== placeHolderParts.length &&
            lastPart.length === placeHolderParts[fieldParts.length - 1]?.length);
    }
    isValidFieldPartByType(fieldPart, datePart) {
        const numericFieldPart = this.parseNumber(fieldPart);
        if (isNaN(numericFieldPart)) {
            return false;
        }
        switch (datePart) {
            case DatePart.Day:
                return numericFieldPart <= MAX_DAYS_IN_MONTH;
            case DatePart.Month:
                return numericFieldPart <= MONTHS_IN_YEAR;
            case DatePart.Year:
                return true;
            default:
                return false;
        }
    }
    /**
     * Checks if a string is a number. Parse int will parse out the number even if non-numeric characters are included in
     * the string.
     */
    parseNumber(numberString) {
        const numberRegex = new RegExp('^\\d+$');
        if (numberRegex.test(numberString)) {
            return parseInt(numberString, 10);
        }
        else {
            return NaN;
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: DateParserService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: DateParserService }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: DateParserService, decorators: [{
            type: Injectable
        }] });

class LocaleAwareDateFormatServiceMock {
    formatDate() {
        //
    }
    formatDateByUserFormat() {
        //
    }
}
const localeAwareDateFormatServiceMockProvider = {
    provide: LocaleAwareDateFormatService,
    useClass: LocaleAwareDateFormatServiceMock
};

class BreakpointUtil {
    static activeBreakpoint(breakpointObject) {
        let breakpoint = null;
        Object.keys(breakpointObject).forEach(key => {
            if (breakpointObject[key] === true) {
                breakpoint = key;
            }
        });
        return breakpoint;
    }
}

/* eslint-disable no-console */
// eslint-disable-next-line @typescript-eslint/no-explicit-any,@typescript-eslint/explicit-module-boundary-types
function Log(target, functionName, descriptor) {
    const originalMethod = descriptor.value;
    descriptor.value = function (...args) {
        console.group(`${target.constructor.name}.${functionName}()`);
        console.log('%cArguments:', 'font-weight: bold;', ...args);
        console.group('Function logs');
        const result = originalMethod.apply(this, args);
        console.groupEnd();
        console.log('%c=> ', 'font-weight: bold;', result);
        console.groupEnd();
        return result;
    };
    return descriptor;
}

class LoggerService {
    constructor(console, config) {
        this.console = console;
        this.config = config;
        this._logInProduction = false;
    }
    logForProduction() {
        const clonedLoggerService = Object.create(this);
        clonedLoggerService._logInProduction = true;
        return clonedLoggerService;
    }
    error(...args) {
        this.call('error', args);
    }
    info(...args) {
        this.call('info', args);
    }
    log(...args) {
        this.call('log', args);
    }
    warn(...args) {
        this.call('warn', args);
    }
    logEnabled() {
        return !this.config.production || this._logInProduction;
    }
    call(fn, args) {
        if (this.logEnabled()) {
            this.console[fn].apply(null, args);
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: LoggerService, deps: [{ token: CONSOLE }, { token: LOGGER_CONFIG }], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: LoggerService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: LoggerService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: undefined, decorators: [{
                    type: Inject,
                    args: [CONSOLE]
                }] }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [LOGGER_CONFIG]
                }] }]; } });

class NoopConsole {
    assert() {
        // no implementation
    }
    clear() {
        // no implementation
    }
    count() {
        // no implementation
    }
    countReset() {
        // no implementation
    }
    debug() {
        // no implementation
    }
    dir() {
        // no implementation
    }
    dirxml() {
        // no implementation
    }
    error(..._data) {
        // no implementation
    }
    exception() {
        // no implementation
    }
    group() {
        // no implementation
    }
    groupCollapsed() {
        // no implementation
    }
    groupEnd() {
        // no implementation
    }
    info(..._data) {
        // no implementation
    }
    log(..._data) {
        // no implementation
    }
    profile() {
        // no implementation
    }
    profileEnd() {
        // no implementation
    }
    table() {
        // no implementation
    }
    time() {
        // no implementation
    }
    timeEnd() {
        // no implementation
    }
    timeLog() {
        // no implementation
    }
    timeStamp() {
        // no implementation
    }
    trace() {
        // no implementation
    }
    warn(..._data) {
        // no implementation
    }
}

const consoleFactory = () => {
    return console || new NoopConsole();
};
const consoleProvider = {
    provide: CONSOLE,
    useFactory: consoleFactory
};

const defaultConfig$1 = {
    production: true
};
class LoggerModule {
    static forRoot(config = defaultConfig$1) {
        return {
            ngModule: LoggerModule,
            providers: [
                {
                    provide: LOGGER_CONFIG,
                    useValue: config
                },
                consoleProvider,
                LoggerService
            ]
        };
    }
    static forChild() {
        return {
            ngModule: LoggerModule,
            providers: [LoggerService]
        };
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: LoggerModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: LoggerModule }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: LoggerModule }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: LoggerModule, decorators: [{
            type: NgModule
        }] });

const TAB_INDEX_ATTR = 'tabindex';
const TAB_INDEX_NOT_SELECTABLE = '-1';
const NG_CONTENT_ATTR_PREFIX = '_ngcontent';
class DomUtil {
    static getFocusableChildren(element) {
        return element.querySelectorAll(`button, [href], input, select, textarea, [tabindex]:not([tabindex="${TAB_INDEX_NOT_SELECTABLE}"])`);
    }
    static getFirstFocusableChild(element) {
        return this.getFocusableChildren(element)[0];
    }
    static disableFocusForChildren(element) {
        this.getFocusableChildren(element).forEach((child) => {
            child.setAttribute(TAB_INDEX_ATTR, TAB_INDEX_NOT_SELECTABLE);
        });
    }
    static enableFocusForChildren(element) {
        this.getFocusableChildren(element).forEach((child) => {
            child.removeAttribute(TAB_INDEX_ATTR);
        });
    }
    static applyNgContentToChildren(element) {
        const attributes = element.attributes;
        for (let i = 0; i < attributes.length; i++) {
            const attribute = attributes.item(i);
            if (attribute.name.startsWith(NG_CONTENT_ATTR_PREFIX)) {
                this.setNgContentAttribute(element, attribute.name);
                break;
            }
        }
    }
    static cleanHtmlElement(element, allowedTags) {
        const childNodes = Array.from(element.childNodes);
        for (const childNode of childNodes) {
            if (childNode.nodeType === Node.TEXT_NODE) {
                continue;
            }
            const childElement = childNode;
            this.cleanHtmlElement(childElement, allowedTags);
            if (!allowedTags.has(childElement.tagName.toLowerCase())) {
                childElement.replaceWith(...Array.from(childElement.childNodes));
            }
        }
    }
    static setNgContentAttribute(parent, attributeName) {
        parent.setAttribute(attributeName, '');
        parent.childNodes.forEach(child => {
            if (child instanceof Element) {
                this.setNgContentAttribute(child, attributeName);
            }
        });
    }
}

class DownloadUtil {
    static downloadBlob(content, filename) {
        const downloadLink = document.createElement('a');
        downloadLink.href = window.URL.createObjectURL(content);
        downloadLink.setAttribute('download', filename);
        downloadLink.style.display = 'none';
        document.body.appendChild(downloadLink);
        downloadLink.click();
        window.URL.revokeObjectURL(downloadLink.href);
        downloadLink.remove();
    }
}

class ToggleableFeatures {
    get enabledFeatures() {
        return new Set(this.featureWhitelist);
    }
    constructor(featureConfig) {
        this.featureWhitelist = new Set();
        if (featureConfig) {
            this.bulkConfig(featureConfig);
        }
    }
    enableFeature(featureName) {
        this.featureWhitelist.add(featureName);
    }
    disableFeature(featureName) {
        this.featureWhitelist.delete(featureName);
    }
    bulkConfig(featureConfig) {
        featureConfig.forEach(({ name, enabled }) => {
            if (enabled) {
                this.enableFeature(name);
            }
            else {
                this.disableFeature(name);
            }
        });
    }
    clear() {
        this.featureWhitelist.clear();
    }
    isEnabled(featureName) {
        return this.featureWhitelist.has(featureName);
    }
    intersect(toggleableFeatures) {
        this.featureWhitelist = new Set([...toggleableFeatures.enabledFeatures].filter(feature => this.featureWhitelist.has(feature)));
    }
    mergeAndIntersect(toggleableFeatures, featuresToIntersect) {
        const merged = new Set([...this.featureWhitelist, ...toggleableFeatures.enabledFeatures]);
        merged.forEach(feature => {
            const considerForIntersect = (featureName) => featuresToIntersect.includes(featureName);
            const enabledInBoth = (feature) => this.featureWhitelist.has(feature) && toggleableFeatures.enabledFeatures.has(feature);
            if (considerForIntersect(feature) && !enabledInBoth(feature)) {
                merged.delete(feature);
            }
        });
        this.featureWhitelist = merged;
    }
}

class FeatureToggleService {
    constructor() {
        this.ready$ = new BehaviorSubject(false);
        this.features = new ToggleableFeatures();
    }
    listToFeatureChanges(feature) {
        return this.ready$.pipe(filter(ready => ready), map(() => this.features.isEnabled(feature)), distinctUntilChanged());
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: FeatureToggleService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: FeatureToggleService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: FeatureToggleService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }] });

class RouterService {
    constructor(router, localeService, appInit, urlService) {
        this.router = router;
        this.localeService = localeService;
        this.appInit = appInit;
        this.urlService = urlService;
        /**
         * Exposing an observable router event. Emitted on Navigation End if the SPA is initialized.
         * In case of the SPA not yet initialized while the Navigation End was emitted, it will be done so as soon
         * as the SPA is initialized.
         */
        this.initializedNavigationEnd$ = combineLatest([
            this.router.events.pipe(filter(event => event instanceof NavigationEnd)),
            this.appInit.isInitialized$
        ]).pipe(filter(([_, isInitialized]) => isInitialized && !this.urlService.isChatbotUrl()), map(([navigationEnd]) => navigationEnd));
    }
    getLastRouteSegment() {
        return this.getLastSegment(this.router.url);
    }
    getLastSegment(url) {
        return this.urlService.createUrlFromPath(url).pathname.split('/').pop();
    }
    getLocalizedRoute(commands, navigationExtras, fallbackLocale = DEFAULT_LOCALE_STRING) {
        return this.getLocalizedRouteUrlTree(commands, navigationExtras, fallbackLocale).toString();
    }
    getLocalizedRouteUrlTree(commands, navigationExtras, fallbackLocale = DEFAULT_LOCALE_STRING) {
        const locale = this.getLocale(fallbackLocale);
        return this.router.createUrlTree([locale, ...commands], navigationExtras);
    }
    navigateToLocalizedRoute(commands, navigationExtras, fallbackLocale = DEFAULT_LOCALE_STRING) {
        const locale = this.getLocale(fallbackLocale);
        return this.router.navigate([locale, ...commands], navigationExtras);
    }
    navigateByLocalizedUrl(path, fallbackLocale = DEFAULT_LOCALE_STRING) {
        const locale = this.getLocale(fallbackLocale);
        return this.router.navigateByUrl(`/${locale}${path}`);
    }
    navigateToInternalUrl(href) {
        const internalUrl = this.urlService.getUrlPathnameAndParams(href);
        const isLocalizedUrl = this.urlService.isLocalizedUrl(internalUrl);
        if (isLocalizedUrl) {
            return this.router.navigateByUrl(internalUrl);
        }
        else {
            return this.navigateByLocalizedUrl(internalUrl);
        }
    }
    getLocale(fallbackLocale = DEFAULT_LOCALE_STRING) {
        return this.localeService.locale ? this.localeService.getLocaleString() : fallbackLocale;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: RouterService, deps: [{ token: i1$2.Router }, { token: LocaleService }, { token: AppInitService }, { token: UrlService }], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: RouterService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: RouterService, decorators: [{
            type: Injectable,
            args: [{ providedIn: 'root' }]
        }], ctorParameters: function () { return [{ type: i1$2.Router }, { type: LocaleService }, { type: AppInitService }, { type: UrlService }]; } });

class FeatureToggleGuard {
    constructor(localeService, featureToggleService, routerService) {
        this.localeService = localeService;
        this.featureToggleService = featureToggleService;
        this.routerService = routerService;
    }
    canActivate(route) {
        const routeData = route.data;
        return combineLatest([this.featureToggleService.ready$, this.localeService.locale$]).pipe(filter(([ready]) => ready), map(() => {
            if (routeData?.featureName) {
                const decision = this.featureToggleService.features.isEnabled(routeData.featureName);
                if (!decision) {
                    return this.routerService.getLocalizedRouteUrlTree([AppRoutes.Home]);
                }
                return decision;
            }
            return false;
        }));
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: FeatureToggleGuard, deps: [{ token: LocaleService }, { token: FeatureToggleService }, { token: RouterService }], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: FeatureToggleGuard, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: FeatureToggleGuard, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: LocaleService }, { type: FeatureToggleService }, { type: RouterService }]; } });

const SAAS_PARAM = 'saas';
const SAAS_PARAM_DEACTIVATION_VALUE = 'false';
const SAAS_SESSION_ATTRIBUTE = 'SiePortal.saas';
class SaasFeatureToggleService {
    constructor(document, urlService) {
        this.document = document;
        this.urlService = urlService;
    }
    initialize(path) {
        this.scanUrlForSaasParameter(path);
    }
    scanUrlForSaasParameter(path) {
        sessionStorage.removeItem(SAAS_SESSION_ATTRIBUTE);
        let url;
        if (path) {
            url = this.urlService.createUrlFromPath(path);
        }
        else {
            url = new URL(this.document.defaultView.location.href);
        }
        if (url.searchParams.get(SAAS_PARAM) === SAAS_PARAM_DEACTIVATION_VALUE) {
            sessionStorage.setItem(SAAS_SESSION_ATTRIBUTE, SAAS_PARAM_DEACTIVATION_VALUE);
        }
    }
    canActivate() {
        const saasActiveValue = sessionStorage.getItem(SAAS_SESSION_ATTRIBUTE);
        return saasActiveValue !== 'false';
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: SaasFeatureToggleService, deps: [{ token: DOCUMENT }, { token: UrlService }], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: SaasFeatureToggleService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: SaasFeatureToggleService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: Document, decorators: [{
                    type: Inject,
                    args: [DOCUMENT]
                }] }, { type: UrlService }]; } });

class SaasFeatureToggleGuard {
    constructor(saasFeatureToggleService, routerService) {
        this.saasFeatureToggleService = saasFeatureToggleService;
        this.routerService = routerService;
    }
    canActivate() {
        const decision = this.saasFeatureToggleService.canActivate();
        if (!decision) {
            return this.routerService.getLocalizedRouteUrlTree([AppRoutes.Home], { queryParams: { saas: 'false' } });
        }
        return decision;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: SaasFeatureToggleGuard, deps: [{ token: SaasFeatureToggleService }, { token: RouterService }], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: SaasFeatureToggleGuard, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: SaasFeatureToggleGuard, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: SaasFeatureToggleService }, { type: RouterService }]; } });

class SaasFeatureToggleModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: SaasFeatureToggleModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: SaasFeatureToggleModule }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: SaasFeatureToggleModule, providers: [SaasFeatureToggleService] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: SaasFeatureToggleModule, decorators: [{
            type: NgModule,
            args: [{
                    providers: [SaasFeatureToggleService]
                }]
        }] });

const PLAYGROUND_PARAM = 'playground';
const PLAYGROUND_ENV_PARAM = 'environment';
const PLAYGROUND_ACTIVATION_VALUE = 'true';
const PLAYGROUND_ENV_SESSION_ATTRIBUTE = 'SiePortal.playground-environment';
class PlaygroundFeatureToggleService {
    constructor(document, urlService) {
        this.document = document;
        this.urlService = urlService;
    }
    initialize(path) {
        this.scanUrlForPlaygroundParameter(path);
    }
    getPlaygroundEnvironment() {
        return sessionStorage.getItem(PLAYGROUND_ENV_SESSION_ATTRIBUTE);
    }
    scanUrlForPlaygroundParameter(path) {
        let url;
        if (path) {
            url = this.urlService.createUrlFromPath(path);
        }
        else {
            url = new URL(this.document.defaultView.location.href);
        }
        if (url.searchParams.has(PLAYGROUND_PARAM)) {
            sessionStorage.removeItem(PLAYGROUND_ENV_SESSION_ATTRIBUTE);
            const playgroundParameter = url.searchParams.get(PLAYGROUND_PARAM);
            const playgroundEnvParameter = url.searchParams.get(PLAYGROUND_ENV_PARAM);
            if (playgroundParameter === PLAYGROUND_ACTIVATION_VALUE) {
                sessionStorage.setItem(PLAYGROUND_ENV_SESSION_ATTRIBUTE, playgroundEnvParameter);
            }
        }
    }
    playgroundActivated() {
        const playgroundActiveValue = sessionStorage.getItem(PLAYGROUND_ENV_SESSION_ATTRIBUTE);
        return playgroundActiveValue !== null;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: PlaygroundFeatureToggleService, deps: [{ token: DOCUMENT }, { token: UrlService }], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: PlaygroundFeatureToggleService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: PlaygroundFeatureToggleService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: Document, decorators: [{
                    type: Inject,
                    args: [DOCUMENT]
                }] }, { type: UrlService }]; } });

var FeatureName;
(function (FeatureName) {
    FeatureName["SearchQuoteCart"] = "SearchQuoteCart";
    FeatureName["MySupportSaveLoadFilters"] = "mySupportSaveLoadFilters";
    FeatureName["ApiErrorToastMessage"] = "ApiErrorToastMessage";
    FeatureName["SieportalMyConversations"] = "myConversationEnabled";
    FeatureName["SieportalIBase"] = "installedBaseEnabled";
    FeatureName["SieportalContracts"] = "mysieportalContracts";
    FeatureName["FieldServiceRequests"] = "fieldServiceRequestsEnabled";
    FeatureName["Chatbot"] = "chatbotEnabled";
    FeatureName["CommerceEnabled"] = "commerceEnabled";
    FeatureName["DisableFeedbackWithChatbot"] = "disableFeedbackWithChatbot";
    FeatureName["InstalledBaseUserManagementEnabled"] = "installedBaseUserManagementEnabled";
    FeatureName["InstalledBasePermissionsEnabled"] = "installedBasePermissionsEnabled";
    FeatureName["InstalledBasePermissionsUsersTabEnabled"] = "installedBasePermissionsUsersTabEnabled";
    FeatureName["InteractionStudio"] = "interactionStudioEnabled";
    FeatureName["SearchCatalogConfigureLink"] = "SearchCatalogConfigureLink";
    FeatureName["OneHomePromotionExpandable"] = "OneHomePromotionExpandable";
    FeatureName["NavigationViewSwitchEnabled"] = "navigationViewSwitchEnabled";
    FeatureName["InteractionStudioUnknownUserTracking"] = "unknownUserTrackingEnabled";
    FeatureName["InteractionStudioKnownUserTracking"] = "knownUserTrackingEnabled";
    FeatureName["InteractionStudioCarouselCampaign"] = "carouselCampaignEnabled";
    FeatureName["InteractionStudioSupportMaterialCampaign"] = "supportMaterialCampaignEnabled";
    FeatureName["InteractionStudioPromotionalExpandableCampaign"] = "promotionalExpandableCampaignEnabled";
    FeatureName["MyConversationSieSalesCccEnabled"] = "myConversationSieSalesCccEnabled";
    FeatureName["MyConversationDuveWebEnabled"] = "myConversationDuveWebEnabled";
    FeatureName["MyConversationsReplyEmailEnabled"] = "myConversationReplyEnabled";
    FeatureName["MyConversationDuveWebReplyEnabled"] = "myConversationDuveWebReplyEnabled";
    FeatureName["SearchKnowledgeBaseMyProductsFilter"] = "SearchKnowledgeBaseMyProductsFilter";
    FeatureName["UserProfileDataPrivacyTab"] = "UserProfileDataPrivacyTab";
    FeatureName["UserProfileLoginDataTab"] = "UserProfileLoginDataTab";
    FeatureName["UserProfilePersonalAndCompanyData"] = "UserProfilePersonalAndCompanyData";
    FeatureName["MyConversationsExportCaseEnabled"] = "myConversationExportCaseEnabled";
    FeatureName["NavigationLanguageToggleEnabled"] = "navigationLanguageToggleEnabled";
    FeatureName["ProductSearchCampaignEnabled"] = "productSearchCampaignEnabled";
    FeatureName["IBaseCampaignEnabled"] = "iBaseCampaignEnabled";
    FeatureName["ChatBotCampaingEnabled"] = "chatBotCampaignEnabled";
    FeatureName["TemporaryImplementationToggleEnabled"] = "temporaryImplementationToggleEnabled";
    FeatureName["UserProfilePersonalInformationEdit"] = "UserProfilePersonalInformationEdit";
    FeatureName["UserProfileSupportNotificationEdit"] = "UserProfileSupportNotificationEdit";
    FeatureName["UserProfileBusinessInformationEdit"] = "UserProfileBusinessInformationEdit";
    FeatureName["SearchAddtomyFavorites"] = "SearchAddtomyFavorites";
    FeatureName["SearchAddtomyDocumentation"] = "SearchAddtomyDocumentation";
    FeatureName["MysieportalEnabled"] = "MysieportalEnabled";
    FeatureName["SupportPage"] = "SupportPage";
    FeatureName["SearchAddtomyDocumentationLimit"] = "SearchAddtomyDocumentationLimit";
    FeatureName["SearchGlobalFlyoutIdentifiedProduct"] = "SearchGlobalFlyoutIdentifiedProduct";
    FeatureName["SearchGlobalFlyoutIdentifiedProductOnlyForUS"] = "SearchGlobalFlyoutIdentifiedProductOnlyForUS";
    FeatureName["MySiePortalCampaignEnabled"] = "mySiePortalCampaignEnabled";
    FeatureName["SupportPageCampaignEnabled"] = "supportPageCampaignEnabled";
    FeatureName["ForumCampaignEnabled"] = "forumCampaignEnabled";
    FeatureName["SpiceConfiguratorCampaignEnabled"] = "spiceConfiguratorCampaignEnabled";
    FeatureName["SearchAutomaticATPCheck"] = "SearchAutomaticATPCheck";
    FeatureName["ServiceContractsDetailsAttachmentsListEnabled"] = "servicecontractsDetailsAttachmentslistEnabled";
    FeatureName["ServiceContractsDetailsUsageRegionalContractEnabled"] = "servicecontractsDetailsUsageRegionalcontractEnabled";
    FeatureName["ServiceContractsDetailsUsageTscoContractEnabled"] = "servicecontractsDetailsUsageTscocontractEnabled";
    FeatureName["ServiceContractsDetailsRegionalContractItemsListEnabled"] = "servicecontractsDetailsRegionalcontractitemslistEnabled";
    FeatureName["ServiceContractsOverviewSearchEnabled"] = "servicecontractsOverviewSearchEnabled";
    FeatureName["ContractsFilterByEndCustomerEnabled"] = "contractsFilterByEndCustomerEnabled";
    FeatureName["ContractsFilterByCountryEnabled"] = "contractsFilterByCountryEnabled";
    FeatureName["ServiceContractsItemDetailsEnabled"] = "servicecontractsItemDetailsEnabled";
    FeatureName["ProductsServicesPage"] = "ProductsServicesPageEnabled";
    FeatureName["SolutionWizardEnabled"] = "SolutionWizardEnabled";
    FeatureName["SupportStatusbar"] = "SupportStatusbar";
    FeatureName["PdpPageEnabled"] = "pdpPageEnabled";
    FeatureName["ZeroTrustInMyProfile"] = "ZeroTrustInMyProfile";
    FeatureName["OneMD4CMFEEnabled"] = "OneMD4CMFEEnabled";
    FeatureName["ZeroTrust"] = "ZeroTrust";
    FeatureName["ZeroTrustSso"] = "ZeroTrustSso";
})(FeatureName || (FeatureName = {}));

// Feature Toggle

function isFunction(obj) {
    return typeof obj === 'function';
}

class Base64Decoder {
    static decode(data) {
        let result = '';
        if (data) {
            const characterSet = this.expandCharacterSetRange('A-Za-z0-9+/=').join('');
            const output = [];
            let chr1, chr2, chr3, enc1, enc2, enc3, enc4, i = 0;
            while (i < data.length) {
                enc1 = characterSet.indexOf(data.charAt(i++) || null);
                enc2 = characterSet.indexOf(data.charAt(i++) || null);
                enc3 = characterSet.indexOf(data.charAt(i++) || null);
                enc4 = characterSet.indexOf(data.charAt(i++) || null);
                chr1 = (enc1 << 2) | (enc2 >> 4);
                chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
                chr3 = ((enc3 & 3) << 6) | enc4;
                if (chr1 >= 0 && chr1 < 256) {
                    output.push(chr1);
                }
                if (chr2 >= 0 && chr2 < 256 && enc3 !== 64) {
                    output.push(chr2);
                }
                if (chr3 >= 0 && chr3 < 256 && enc4 !== 64) {
                    output.push(chr3);
                }
            }
            result = this.byteArrayToUtf8(output);
        }
        return result;
    }
    static byteArrayToUtf8(byteArray) {
        const str = this.byteArrayToChars(byteArray);
        try {
            return utf8.decode(str);
        }
        catch (err) {
            return str;
        }
    }
    static byteArrayToChars(byteArray) {
        if (!byteArray) {
            return '';
        }
        let str = '';
        for (let i = 0; i < byteArray.length;) {
            str += String.fromCharCode(byteArray[i++]);
        }
        return str;
    }
    static expandCharacterSetRange(characterSet) {
        const characters = [];
        for (let i = 0; i < characterSet.length; i++) {
            if (i < characterSet.length - 2 && characterSet[i + 1] === '-' && characterSet[i] !== '\\') {
                const start = this.ord(characterSet[i]), end = this.ord(characterSet[i + 2]);
                for (let j = start; j <= end; j++) {
                    characters.push(this.chr(j));
                }
                i += 2;
            }
            else if (i < characterSet.length - 2 && characterSet[i] === '\\' && characterSet[i + 1] === '-') {
                characters.push('-');
                i++;
            }
            else {
                characters.push(characterSet[i]);
            }
        }
        return characters;
    }
    static ord(c) {
        if (c.length === 2) {
            const high = c.charCodeAt(0);
            const low = c.charCodeAt(1);
            if (high >= 0xd800 && high < 0xdc00 && low >= 0xdc00 && low < 0xe000) {
                return (high - 0xd800) * 0x400 + low - 0xdc00 + 0x10000;
            }
        }
        return c.charCodeAt(0);
    }
    static chr(o) {
        if (o > 0xffff) {
            o -= 0x10000;
            const high = String.fromCharCode(((o >>> 10) & 0x3ff) | 0xd800);
            o = 0xdc00 | (o & 0x3ff);
            return high + String.fromCharCode(o);
        }
        return String.fromCharCode(o);
    }
}

class JwtDecoder {
    constructor(token) {
        const [_header, payload, _signature] = token.split('.');
        try {
            this.payload = JSON.parse(Base64Decoder.decode(payload));
        }
        catch (error) {
            throw new JwtDecoderError(error.message);
        }
    }
}

class LazyComponentComponent {
    constructor(element) {
        this.element = element;
        this._isIntersecting$ = new BehaviorSubject(false);
        this.isIntersecting$ = this._isIntersecting$.asObservable();
    }
    ngAfterViewInit() {
        const options = {
            rootMargin: this.rootMargins,
            threshold: 0
        };
        this.observer = new IntersectionObserver(this.intersectionCallback.bind(this), options);
        this.observer.observe(this.element.nativeElement);
    }
    ngOnDestroy() {
        this.observer?.disconnect();
    }
    intersectionCallback(entries, _observer) {
        if (entries[0].isIntersecting) {
            this._isIntersecting$.next(true);
            this.observer?.disconnect();
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: LazyComponentComponent, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: LazyComponentComponent, selector: "sie-core-lazy-component", inputs: { rootMargins: "rootMargins", baseHeight: "baseHeight" }, host: { properties: { "style.--base-height": "this.baseHeight" } }, ngImport: i0, template: "<ng-container *ngIf=\"isIntersecting$ | async\">\n  <ng-content></ng-content>\n</ng-container>\n", styles: [":host{display:block;height:var(--base-height)}\n"], dependencies: [{ kind: "directive", type: i1$3.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "pipe", type: i1$3.AsyncPipe, name: "async" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: LazyComponentComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-core-lazy-component', changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-container *ngIf=\"isIntersecting$ | async\">\n  <ng-content></ng-content>\n</ng-container>\n", styles: [":host{display:block;height:var(--base-height)}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; }, propDecorators: { rootMargins: [{
                type: Input
            }], baseHeight: [{
                type: HostBinding,
                args: ['style.--base-height']
            }, {
                type: Input
            }] } });

class LazyComponentDirective {
    constructor(view, template) {
        this.view = view;
        this.template = template;
        this.sieCoreLazyComponentDisabled = false;
    }
    ngAfterViewInit() {
        if (this.sieCoreLazyComponentDisabled) {
            this.createEmbeddedView();
            return;
        }
        const component = this.view.createComponent(LazyComponentComponent);
        component.setInput('rootMargins', this.sieCoreLazyComponent);
        component.setInput('baseHeight', this.sieCoreLazyComponentBase);
        this.sieCoreLazyComponentCdr.detectChanges();
        component.instance.isIntersecting$
            .pipe(filter(isIntersecting => isIntersecting), take(1))
            .subscribe(() => {
            this.createEmbeddedView();
        });
    }
    createEmbeddedView() {
        this.view.clear();
        requestAnimationFrame(() => {
            this.view.createEmbeddedView(this.template);
            this.sieCoreLazyComponentCdr?.detectChanges();
        });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: LazyComponentDirective, deps: [{ token: i0.ViewContainerRef }, { token: i0.TemplateRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: LazyComponentDirective, selector: "[sieCoreLazyComponent]", inputs: { sieCoreLazyComponent: "sieCoreLazyComponent", sieCoreLazyComponentCdr: "sieCoreLazyComponentCdr", sieCoreLazyComponentBase: "sieCoreLazyComponentBase", sieCoreLazyComponentDisabled: "sieCoreLazyComponentDisabled" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: LazyComponentDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[sieCoreLazyComponent]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ViewContainerRef }, { type: i0.TemplateRef }]; }, propDecorators: { sieCoreLazyComponent: [{
                type: Input
            }], sieCoreLazyComponentCdr: [{
                type: Input
            }], sieCoreLazyComponentBase: [{
                type: Input
            }], sieCoreLazyComponentDisabled: [{
                type: Input
            }] } });

class LazyComponentModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: LazyComponentModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: LazyComponentModule, declarations: [LazyComponentComponent, LazyComponentDirective], imports: [CommonModule], exports: [LazyComponentComponent, LazyComponentDirective] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: LazyComponentModule, imports: [CommonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: LazyComponentModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [LazyComponentComponent, LazyComponentDirective],
                    imports: [CommonModule],
                    exports: [LazyComponentComponent, LazyComponentDirective]
                }]
        }] });

class LinkUtil {
    static is(link) {
        return new LinkComparator(link);
    }
}
class LinkComparator {
    constructor(link) {
        this.link = link;
    }
    anExternalLink() {
        return ['http:', 'https:', '//'].some(linkIdentifier => this.link.startsWith(linkIdentifier));
    }
}

class ListIntersectionObserverDirective {
    constructor() {
        this.mapping = new Map();
        const rootMarginMultiplier = 3;
        const rootMargin = window.innerHeight * rootMarginMultiplier + 'px';
        this.observer = new IntersectionObserver(entries => {
            for (const entry of entries) {
                const callback = this.mapping.get(entry.target);
                callback && requestAnimationFrame(() => callback(entry.isIntersecting));
            }
        }, {
            rootMargin: `${rootMargin} 0px ${rootMargin} 0px`
        });
    }
    ngOnDestroy() {
        this.mapping.clear();
        this.observer.disconnect();
    }
    add(element, callback) {
        this.mapping.set(element, callback);
        this.observer.observe(element);
    }
    remove(element) {
        this.mapping.delete(element);
        this.observer.unobserve(element);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: ListIntersectionObserverDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: ListIntersectionObserverDirective, selector: "[sieCoreListIntersectionObserver]", ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: ListIntersectionObserverDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[sieCoreListIntersectionObserver]'
                }]
        }], ctorParameters: function () { return []; } });

class ListItemIntersectionObserverDirective {
    constructor(parent, element) {
        this.parent = parent;
        this.element = element;
        this.isIntersecting$ = new BehaviorSubject(false);
        this.height = '49px';
        this.height$ = new BehaviorSubject(this.height);
    }
    ngOnInit() {
        // Only set the input value on init.
        if (this.initialHeight) {
            requestAnimationFrame(() => {
                this.height = this.initialHeight;
                this.height$.next(this.height);
                this.initialHeight = null;
            });
        }
        this.parent.add(this.element.nativeElement, (isIntersecting) => {
            this.height = this.element.nativeElement.offsetHeight + 'px';
            if (!isIntersecting) {
                this.height$.next(this.height);
            }
            else {
                this.height$.next(null);
            }
            this.isIntersecting$.next(isIntersecting);
        });
    }
    ngOnDestroy() {
        this.parent.remove(this.element.nativeElement);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: ListItemIntersectionObserverDirective, deps: [{ token: ListIntersectionObserverDirective }, { token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: ListItemIntersectionObserverDirective, selector: "[sieCoreListItemIntersectionObserver]", inputs: { initialHeight: "initialHeight" }, exportAs: ["intersection"], ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: ListItemIntersectionObserverDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[sieCoreListItemIntersectionObserver]',
                    exportAs: 'intersection'
                }]
        }], ctorParameters: function () { return [{ type: ListIntersectionObserverDirective }, { type: i0.ElementRef }]; }, propDecorators: { initialHeight: [{
                type: Input
            }] } });

class ListDirectivesModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: ListDirectivesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: ListDirectivesModule, declarations: [ListIntersectionObserverDirective, ListItemIntersectionObserverDirective], exports: [ListIntersectionObserverDirective, ListItemIntersectionObserverDirective] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: ListDirectivesModule }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: ListDirectivesModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [ListIntersectionObserverDirective, ListItemIntersectionObserverDirective],
                    exports: [ListIntersectionObserverDirective, ListItemIntersectionObserverDirective]
                }]
        }] });

class RangeRatio {
    constructor(min, max, refMin, refMax) {
        this.min = min;
        this.max = max;
        this.refMin = refMin;
        this.refMax = refMax;
        this.range = max - min;
        this.refRange = refMax - refMin;
    }
    getForRef(value) {
        return ((value - this.min) / this.range) * this.refRange + this.refMin;
    }
}

/**
 * Utility function to check if a certain number is in a certain range. If not then provide a fallback
 * for the lower bound and one for the upper bound
 *
 * @param n Number to be checked
 * @param start Range start
 * @param end Range end
 * @param lowerFallback Fallback to be used when n < start (defaults to start)
 * @param upperFallback Fallback to be used when n > end (defaults to end)
 */
function safeRange(n, start, end, lowerFallback = start, upperFallback = end) {
    if (n < start) {
        return lowerFallback;
    }
    if (n > end) {
        return upperFallback;
    }
    return n;
}
const EVEN_ODD_MODULO = 2;
/**
 * Utility function to check if a number is even.
 *
 * @param number Number to be checked
 */
function isEven(number) {
    return !(number % EVEN_ODD_MODULO);
}
/**
 * Utility function to check if a number is odd.
 *
 * @param number Number to be checked
 */
function isOdd(number) {
    return !!(number % EVEN_ODD_MODULO);
}
function round(number, precision) {
    const multiplied = +`${number}e+${precision}`;
    return +`${Math.round(multiplied)}e-${precision}`;
}

const DEFAULT_PERCENTAGE_PRECISION = 2;
function percent(value, of, precision = DEFAULT_PERCENTAGE_PRECISION) {
    const percentageMultiplier = 100;
    const percentage = (value / of) * percentageMultiplier;
    return round(percentage, precision);
}

class PageMetadataService {
    constructor(activatedRoute) {
        this.activatedRoute = activatedRoute;
    }
    getAll() {
        let metadata = {};
        let route = this.activatedRoute.pathFromRoot[0];
        do {
            if (route.component) {
                const componentMetadata = Reflect.get(route.component, 'metadata');
                metadata = {
                    ...metadata,
                    ...componentMetadata
                };
            }
            route = route.children[0];
        } while (route);
        return metadata;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: PageMetadataService, deps: [{ token: i1$2.ActivatedRoute }], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: PageMetadataService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: PageMetadataService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: i1$2.ActivatedRoute }]; } });

function Metadata(metadata) {
    return function (target) {
        Reflect.set(target, 'metadata', metadata);
    };
}

const NATIVE_METHOD_METADATA_KEY = 'NATIVE_METHODS';
function Native() {
    return function (target, key) {
        const nativeMethods = Reflect.get(target, NATIVE_METHOD_METADATA_KEY);
        if (nativeMethods && Array.isArray(nativeMethods)) {
            nativeMethods.push(key);
            Reflect.set(target, NATIVE_METHOD_METADATA_KEY, nativeMethods);
        }
        else {
            Reflect.set(target, NATIVE_METHOD_METADATA_KEY, [key]);
        }
    };
}

const deepCopy = (object) => {
    return JSON.parse(JSON.stringify(object));
};

class NativeService {
    expose(component) {
        const nativeMethods = Reflect.get(component, NATIVE_METHOD_METADATA_KEY);
        const nativeElement = component.hostElement.nativeElement;
        nativeMethods.forEach(methodName => {
            if (typeof component[methodName] === 'function') {
                nativeElement[methodName] = component[methodName].bind(component);
            }
            else {
                Object.defineProperty(nativeElement, methodName, {
                    get: () => deepCopy(component[methodName])
                });
            }
        });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: NativeService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: NativeService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: NativeService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }] });

/**
 * Checks for equality of an object or primitive (boolean, number, etc.) to another, ignores order of attributes.
 * The order of elements inside arrays are considered.
 */
const deepEquals = (obj1, obj2) => {
    if (obj1 === obj2) {
        return true;
    }
    if (isNonNullObject(obj1) && isNonNullObject(obj2)) {
        const obj1Keys = Object.keys(obj1);
        const obj2Keys = Object.keys(obj2);
        return obj1Keys.length === obj2Keys.length && obj1Keys.every(key => deepEquals(obj1[key], obj2[key]));
    }
    return false;
};
const isNonNullObject = (object) => {
    return object !== null && typeof object === 'object';
};

function isObject(value) {
    return !!(value && typeof value === 'object' && !Array.isArray(value));
}

function objectStripper(object, strip = [null, undefined]) {
    const stripped = {};
    Object.keys(object).forEach(key => {
        if (!strip.includes(object[key])) {
            stripped[key] = object[key];
        }
    });
    return stripped;
}

function findRecursive(arrayOfObjects, matchingProperty, matchValue, childrenProperty) {
    if (!Array.isArray(arrayOfObjects)) {
        return null;
    }
    for (const obj of arrayOfObjects) {
        if (obj[matchingProperty] === matchValue) {
            return obj;
        }
        else {
            const childrenResult = findRecursive(obj[childrenProperty], matchingProperty, matchValue, childrenProperty);
            if (childrenResult) {
                return childrenResult;
            }
        }
    }
    return null;
}

function searchInObject(searchTerm, obj, keys = []) {
    let searchKeys;
    if (!keys.length) {
        searchKeys = Object.keys(obj);
    }
    else {
        searchKeys = keys;
    }
    return searchKeys.some(key => obj[key].toLowerCase().includes(searchTerm.toLowerCase()));
}

function getDeltaChanges(current, previous) {
    return Object.keys(current).reduce((obj, key) => {
        const value = current[key];
        if (value !== previous[key]) {
            obj[key] = value;
        }
        return obj;
    }, {});
}
function modifyObjectsProperty(value, propertyKey, replaceWith) {
    if (value.hasOwnProperty(propertyKey)) {
        value[replaceWith] = value[propertyKey];
        delete value[propertyKey];
    }
}

function replaceNull(item, replaceWith = '') {
    Object.keys(item).forEach(key => {
        if (item.hasOwnProperty(key) && item[key] === null) {
            item[key] = replaceWith;
        }
    });
    return item;
}

class ObjectHistory {
    constructor() {
        this.history = [];
    }
    add(object, removalPredicate) {
        if (removalPredicate) {
            this.remove(removalPredicate);
        }
        else {
            this.remove(object);
        }
        this.history.push(object);
    }
    remove(objectOrPredicate) {
        let index = -1;
        if (isFunction(objectOrPredicate)) {
            index = this.history.findIndex(objectOrPredicate);
        }
        else {
            index = this.history.findIndex(historyObject => historyObject === objectOrPredicate);
        }
        if (index >= 0) {
            this.history.splice(index, 1);
        }
    }
    has(objectOrPredicate) {
        if (isFunction(objectOrPredicate)) {
            return this.history.some(objectOrPredicate);
        }
        else {
            return this.history.some(historyObject => historyObject === objectOrPredicate);
        }
    }
    get() {
        return this.history;
    }
    getReversed() {
        return this.history.reverse();
    }
    getCurrent() {
        return ArrayUtil.last(this.history);
    }
}

const PAGINATION = {
    ITEMS_PER_PAGE: {
        FIVE: 5,
        TEN: 10,
        FIFTEEN: 15,
        TWENTY: 20,
        TWENTY_FIVE: 25,
        FIFTY: 50,
        HUNDRED: 100,
        MAX: 9999
    }
};

class DefaultListPagination extends BaseListPagination {
}

class PaginationPageSizeService {
    constructor(layoutService) {
        this.layoutService = layoutService;
    }
    getPageSizeOptions(config) {
        let pageSizeOptions = [];
        if (config) {
            if (Array.isArray(config)) {
                // Configuration for overload #1
                pageSizeOptions = deepCopy(config);
            }
            else if (typeof config === 'object') {
                // Configuration for overload #2
                const typedConfig = config;
                Object.keys(Breakpoints).forEach((viewport, index, keys) => {
                    config[viewport] = config[viewport] || config[keys[index - 1]];
                });
                pageSizeOptions = typedConfig[this.layoutService.currentViewport];
            }
        }
        else {
            throw new Error('PaginationPageSizeProvider misconfiguration.');
        }
        return pageSizeOptions;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: PaginationPageSizeService, deps: [{ token: LayoutService }], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: PaginationPageSizeService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: PaginationPageSizeService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: LayoutService }]; } });

var RefreshReasonEnum;
(function (RefreshReasonEnum) {
    RefreshReasonEnum["BeforeLanguageChange"] = "beforeLanguageChange";
    RefreshReasonEnum["LanguageChange"] = "languageChange";
    RefreshReasonEnum["AccountSwitch"] = "accountSwitch";
    RefreshReasonEnum["NetworkSwitch"] = "networkSwitch";
    RefreshReasonEnum["CurrencySwitch"] = "currencySwitch";
    RefreshReasonEnum["QuoteModeSwitch"] = "quoteModeSwitch";
    RefreshReasonEnum["ProjectNumberSwitch"] = "projectNumberSwitch";
    RefreshReasonEnum["AuthChange"] = "authChange";
    RefreshReasonEnum["SearchSavedFilterOpened"] = "searchSavedFilterOpened";
    RefreshReasonEnum["SessionExpired"] = "sessionExpired";
})(RefreshReasonEnum || (RefreshReasonEnum = {}));

const COMPONENT_REFRESH_METHODS_KEY = 'sieCoreRefreshMethods';
function Refreshable() {
    return function (target) {
        let self;
        let refreshSubscription;
        // Hook into `ngOnInit` because it is the only way to get a reference to the instance which is needed to invoke
        // decorated methods with the proper scope
        const originalInitMethod = target.prototype.ngOnInit;
        target.prototype.ngOnInit = function () {
            const refreshService = getPlatform()?.injector.get(RefreshSpaService);
            refreshSubscription?.unsubscribe();
            refreshSubscription = refreshService.refreshSPAEvent.subscribe(reasons => {
                const toInvoke = new Set();
                const refreshReasonMethods = Reflect.get(self, COMPONENT_REFRESH_METHODS_KEY);
                reasons.forEach(reason => {
                    const reasonMethods = refreshReasonMethods.get(reason) || [];
                    reasonMethods.forEach((method) => {
                        toInvoke.add(self[method]);
                    });
                });
                toInvoke.forEach(method => {
                    method.call(self, reasons);
                });
            });
            // eslint-disable-next-line @typescript-eslint/no-this-alias
            self = this;
            originalInitMethod?.apply(self);
        };
        const originalMethod = target.prototype.ngOnDestroy;
        target.prototype.ngOnDestroy = function () {
            self = null;
            refreshSubscription.unsubscribe();
            originalMethod?.apply(this);
        };
    };
}

function RefreshOn(...methodReasons) {
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    return function (target, propertyKey) {
        const reasonsMethodMap = Reflect.get(target, COMPONENT_REFRESH_METHODS_KEY) || new Map();
        methodReasons.forEach(reason => {
            const methods = reasonsMethodMap.get(reason) || [];
            methods.push(propertyKey);
            reasonsMethodMap.set(reason, methods);
        });
        Reflect.set(target, COMPONENT_REFRESH_METHODS_KEY, reasonsMethodMap);
    };
}

class SelectableWithUnderlineDirective {
    set closeable(value) {
        this._closeable = coerceBooleanProperty(value);
    }
    get closeable() {
        return this._closeable;
    }
    set activeItemIndex(value) {
        this.previousActiveItemIndex = this.activeItemIndex;
        this._activeItemIndex = value;
        if (this.previousActiveItemIndex !== value) {
            this.activeItemChanged();
        }
    }
    get activeItemIndex() {
        return this._activeItemIndex;
    }
    constructor(cd, layoutService) {
        this.cd = cd;
        this.layoutService = layoutService;
        this.focusedItemIndex = 0;
        this.underlineStyle = {
            width: '0',
            left: '0'
        };
        this._activeItemIndex = 0;
        this.keyboardNavigation = false;
        this._closeable = false;
        this.previousActiveItemIndex = this.activeItemIndex;
    }
    focusIn() {
        this.keyboardNavigation = true;
    }
    focusOut() {
        this.keyboardNavigation = false;
    }
    mouseEnterItem(index) {
        this.moveUnderlineToItem(index);
    }
    mouseLeftContainer(moveUnderline = true) {
        this.focusedItemIndex = this.activeItemIndex;
        if (moveUnderline && this.activeItemIndex >= 0) {
            this.moveUnderlineToItem(this.activeItemIndex);
        }
        else {
            this.moveUnderlineToItem(this.activeItemIndex, true);
        }
    }
    moveUnderlineToItem(index, force = false) {
        if (!force && this.layoutService.currentViewport === 'S') {
            return;
        }
        if (index >= 0 && this.selectableItems?.length) {
            requestAnimationFrame(() => {
                this.focusedItemIndex = index;
                const activeItem = this.selectableItems.toArray()[index].nativeElement;
                const { offsetLeft } = activeItem.parentElement;
                this.underlineStyle.width = `${activeItem.getBoundingClientRect().width}px`;
                this.underlineStyle.left = `${activeItem.offsetLeft - offsetLeft}px`;
                this.cd.detectChanges();
            });
        }
        else {
            this.underlineStyle.width = '0';
            this.underlineStyle.left = '0';
        }
        this.cd.detectChanges();
    }
    itemClicked(index, event) {
        event?.preventDefault();
        this.activeItemIndex = this.focusedItemIndex = this.closeable && index === this.activeItemIndex ? -1 : index;
        this.moveUnderlineToItem(this.activeItemIndex, true);
        this.cd.detectChanges();
    }
    activeItemChanged() {
        // not implemented for now
    }
    getFocusableIndex(newIndex) {
        if (newIndex > this.selectableItems.length - 1) {
            return 0;
        }
        else if (newIndex < 0) {
            return this.selectableItems.length - 1;
        }
        else {
            return newIndex;
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: SelectableWithUnderlineDirective, deps: [{ token: i0.ChangeDetectorRef }, { token: LayoutService }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: SelectableWithUnderlineDirective, inputs: { closeable: "closeable" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: SelectableWithUnderlineDirective, decorators: [{
            type: Directive
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: LayoutService }]; }, propDecorators: { closeable: [{
                type: Input
            }] } });

class AttachmentService {
    async downloadAttachment(url) {
        // use of angular HttpClient is not possible here as this service is used inside web components
        return fetch(url).then(res => res.blob());
    }
    getAttachmentBlob(attachmentName, blob) {
        if (attachmentName && blob) {
            const contentType = getBase64ContentType(attachmentName);
            return this.base64toBlob(blob, contentType);
        }
        return null;
    }
    getAttachmentBlobAsString(attachmentName, blob) {
        const mimeType = getBase64ContentType(attachmentName);
        return `data:${mimeType};base64, ${blob}`;
    }
    base64toBlob(base64Data, contentType) {
        const sliceSize = 1024;
        const byteCharacters = atob(base64Data);
        const bytesLength = byteCharacters.length;
        const slicesCount = Math.ceil(bytesLength / sliceSize);
        const byteArrays = ArrayUtil.generate(slicesCount, sliceIndex => {
            const begin = sliceIndex * sliceSize;
            const patchSize = Math.min(sliceSize, bytesLength - begin);
            const bytes = new Uint8Array(patchSize);
            for (let i = 0; i < patchSize; i++) {
                bytes[i] = byteCharacters[begin + i].charCodeAt(0);
            }
            return new Uint8Array(bytes);
        });
        return new Blob(byteArrays, { type: contentType });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: AttachmentService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: AttachmentService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: AttachmentService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }] });

class MockLayoutService extends LayoutService {
    constructor(document, breakpointObserver) {
        super(document, breakpointObserver);
        this.document = document;
        this.breakpointObserver = breakpointObserver;
        this.resizeEvent = new Subject();
    }
    set currentBreakpoint(breakpoint) {
        this._currentBreakpoint = Breakpoints[breakpoint];
        this.breakPointChangedEvent.next(breakpoint);
    }
    get currentBreakpoint() {
        return this._currentBreakpoint;
    }
    shouldExpandHeader(scrollPosition) {
        return scrollPosition <= parseInt('120', 10) - parseInt('50', 10);
    }
    disableScroll() {
        // don't do anything in the mock
    }
    enableScroll() {
        // don't do anything in the mock
    }
    getViewportWidth() {
        return window.innerWidth;
    }
    scrollToElementId(_id, _additionalOffset = 0) {
        //
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: MockLayoutService, deps: [{ token: DOCUMENT }, { token: i1.BreakpointObserver }], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: MockLayoutService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: MockLayoutService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: Document, decorators: [{
                    type: Inject,
                    args: [DOCUMENT]
                }] }, { type: i1.BreakpointObserver }]; } });
const mockLayoutServiceProvider = {
    provide: LayoutService,
    useClass: MockLayoutService
};

class LocaleConfigLoaderMock {
    getRegionsAndLanguages() {
        return new Promise(resolve => {
            resolve({
                localizations: [
                    {
                        default: true,
                        region: DEFAULT_FALLBACK_REGION,
                        languages: [{ key: DEFAULT_LANGUAGE, default: true }],
                        flag: '',
                        rolloutSiep: 'pilotRollout'
                    },
                    {
                        region: 'DE',
                        languages: [{ key: DEFAULT_LANGUAGE, default: true }],
                        flag: '',
                        rolloutSiep: 'pilotRollout'
                    }
                ]
            });
        });
    }
}

class RegionTranslations {
    constructor(regionTranslations) {
        this.regionTranslations = regionTranslations;
    }
    filterBy(searchTerm) {
        return new RegionTranslations(this.regionTranslations.filter(regionTranslation => {
            return regionTranslation.translations.some(translation => {
                return translation.toLowerCase().startsWith(searchTerm.toLowerCase().trim());
            });
        }));
    }
    regionCodes() {
        return this.regionTranslations.map(regionTranslation => regionTranslation.region);
    }
}

class LocaleUtil {
    /**
     * Safe function that converts SPA specific locale (e.g. `en-us`) to locale that is understood by Intl lib
     * @param locale string (e.g. `en-us`)
     * @return returns converted locale otherwise if pattern is not applicable or the given locale is null the initial value will be returned
     */
    static convertLocale(locale) {
        if (locale) {
            const regex = /([a-z]{2})-([a-z]{2})/;
            const match = locale.match(regex);
            if (match) {
                return `${match[1]}-${match[2].toUpperCase()}`;
            }
        }
        return locale;
    }
}

const DEFAULT_LOCALE = {
    language: DEFAULT_LANGUAGE,
    region: DEFAULT_FALLBACK_REGION
};
const DEFAULT_REGION = {
    currentRegion: {
        code: 'ww',
        flag: 'Globe',
        flagSvgName: 'globe.svg',
        isDefault: true,
        name: 'Global',
        rolloutStatus: 'pilotRollout',
        supported: true
    },
    getSupportedRegionByCode: (regionCode) => {
        if (regionCode === 'ERROR') {
            throw new RegionNotSupportedError(regionCode, 'Region not supported.');
        }
        else {
            const region = new AppRegion('ww', 'Global', true, 'globe.svg', 'rollout');
            region.addLanguage(new AppLanguage('en', 'English', true));
            region.addLanguage(new AppLanguage('de', 'Deutsch', false));
            return region;
        }
    },
    isRegionSupported: (_regionCode) => {
        return 'ww';
    }
};
class LocaleServiceMock extends LocaleService {
    constructor(initialLocale, configLoader, urlService) {
        super(document, configLoader, urlService);
        this.initialLocale = initialLocale;
        this.locale = initialLocale;
    }
    setLocale(locale = DEFAULT_LOCALE) {
        this.locale = locale;
    }
    get regions() {
        return DEFAULT_REGION;
    }
    initializeLanguageAndCheckUrl() {
        return Promise.resolve();
    }
}
function mockLocaleServiceProvider(locale = DEFAULT_LOCALE) {
    return {
        provide: LocaleService,
        useFactory: (urlService) => {
            const configLoader = new LocaleConfigLoaderMock();
            const localeMock = new LocaleServiceMock(locale, configLoader, urlService);
            localeMock.setLocale(locale);
            return localeMock;
        },
        deps: [UrlService]
    };
}

class MockOutsideAngularService {
    interval() {
        // only for testing purposes
    }
    clearInterval() {
        // only for testing purposes
    }
}
const mockOutsideAngularServiceProvider = {
    provide: OutsideAngularService,
    useClass: MockOutsideAngularService
};

var ScriptState;
(function (ScriptState) {
    ScriptState[ScriptState["Loading"] = 0] = "Loading";
    ScriptState[ScriptState["Loaded"] = 1] = "Loaded";
})(ScriptState || (ScriptState = {}));
const defaultConfig = {
    type: 'js',
    async: false
};
class ScriptService {
    constructor(rendererFactory, document) {
        this.document = document;
        this.scriptStates = new Map();
        this.renderer = rendererFactory.createRenderer(null, null);
    }
    appendScript(url, config) {
        const merged_config = { ...defaultConfig, ...config };
        let scriptTag;
        switch (merged_config.type) {
            case 'js':
                scriptTag = this.renderer.createElement('script');
                scriptTag.type = 'text/javascript';
                scriptTag.async = merged_config.async;
                scriptTag.src = url;
                this.renderer.appendChild(this.document.body, scriptTag);
                break;
            case 'css':
                scriptTag = this.renderer.createElement('link');
                scriptTag.href = url;
                scriptTag.rel = 'stylesheet';
                this.renderer.appendChild(this.document.head, scriptTag);
                break;
            default:
            // No action taken as all necessary actions are handled
        }
        return scriptTag;
    }
    appendUniqueScript(url, config) {
        let currentSubject = this.scriptStates.get(url);
        if (!currentSubject) {
            const scriptTag = this.appendScript(url, config);
            currentSubject = new BehaviorSubject(ScriptState.Loading);
            this.scriptStates.set(url, currentSubject);
            scriptTag.onload = () => {
                currentSubject.next(ScriptState.Loaded);
            };
            scriptTag.onerror = e => {
                currentSubject.error(e);
            };
        }
        return currentSubject;
    }
    appendUniqueScriptAsPromise(url, config) {
        const merged_config = { ...defaultConfig, ...config };
        return new Promise((resolve, reject) => {
            const sub = this.appendUniqueScript(url, merged_config).subscribe({
                next: state => {
                    if (state === ScriptState.Loaded) {
                        resolve();
                    }
                },
                error: error => reject(error),
                complete: () => sub.unsubscribe()
            });
        });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: ScriptService, deps: [{ token: i0.RendererFactory2 }, { token: DOCUMENT }], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: ScriptService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: ScriptService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: i0.RendererFactory2 }, { type: Document, decorators: [{
                    type: Inject,
                    args: [DOCUMENT]
                }] }]; } });

class TrackingService {
    constructor() {
        this.listeners = [];
        this.categories = {};
        this.parts = {};
        this.directCustomTracking$ = new Subject();
    }
    clearListeners() {
        this.listeners = [];
    }
    clearCategories() {
        this.categories = {};
        this.clearParts();
    }
    clearParts() {
        this.parts = {};
    }
    subscribeForTrackingData(keys, observer) {
        this.listeners.push({
            keys,
            observer
        });
    }
    pushCustomEvent(event) {
        this.directCustomTracking$.next(event);
    }
    pushPartOfData(categoryName, part, amountOfParts, category) {
        this.parts[categoryName + part] = category;
        let i;
        let allPartsAdded = true;
        let combinedObject = {};
        for (i = 1; i <= amountOfParts; i++) {
            const partObject = this.parts[categoryName + i];
            if (!partObject) {
                allPartsAdded = false;
                break;
            }
            else {
                combinedObject = { ...partObject, ...combinedObject };
            }
        }
        if (allPartsAdded) {
            this.pushData(categoryName, combinedObject);
        }
        return allPartsAdded;
    }
    pushData(categoryName, category) {
        this.categories[categoryName] = category;
        for (const listener of this.listeners) {
            let completed = true;
            for (const requiredCategory of listener.keys) {
                if (this.categories[requiredCategory] === undefined) {
                    completed = false;
                    break;
                }
            }
            if (completed) {
                const categories = {};
                for (const requiredCategory of listener.keys) {
                    categories[requiredCategory] = this.categories[requiredCategory];
                }
                listener.observer({
                    categories
                });
            }
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: TrackingService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: TrackingService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: TrackingService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }] });

class RouterServiceMock {
    getLastRouteSegment() {
        return '';
    }
    getLastSegment() {
        return '';
    }
    getLocalizedRoute(commands, navigationExtras) {
        let route = commands.join('/');
        const params = navigationExtras?.queryParams;
        if (!!params) {
            const keys = Object.keys(params);
            route = route + '?' + keys.map(k => k + '=' + params[k]).join('&');
        }
        return route;
    }
    getLocalizedRouteUrlTree() {
        return null;
    }
    navigateToLocalizedRoute() {
        return Promise.resolve(true);
    }
    navigateByLocalizedUrl() {
        return Promise.resolve(true);
    }
    navigateToInternalUrl() {
        return Promise.resolve(true);
    }
}
const mockRouterServiceProvider = {
    provide: RouterService,
    useClass: RouterServiceMock
};

class MockActivatedRouteService {
    constructor() {
        this.queryParamMap = {
            subscribe() {
                return of();
            }
        };
        this.paramMap = {
            subscribe() {
                return of();
            }
        };
        this.snapshot = {
            queryParamMap: {
                get() {
                    return {};
                },
                has() {
                    return {};
                }
            }
        };
    }
}
const mockActivatedRoute = {
    provide: ActivatedRoute,
    useClass: MockActivatedRouteService
};

class TrackingServiceMock {
    pushData(_categoryName, _category) {
        // do nothing
    }
    pushPartOfData(_categoryName, _part, _amountOfParts, _category) {
        // do nothing
    }
}

var SieWindowMessageType;
(function (SieWindowMessageType) {
    SieWindowMessageType["Message"] = "Message";
    SieWindowMessageType["Ack"] = "Ack";
    SieWindowMessageType["Response"] = "Response";
})(SieWindowMessageType || (SieWindowMessageType = {}));

class SieWindowMessage {
    get payload() {
        if (this._payload === undefined) {
            return this._payload;
        }
        return deepCopy(this._payload);
    }
    get ackChannel() {
        if (this.type !== SieWindowMessageType.Message) {
            return;
        }
        return this.channel + this.messageTypeChannelSuffixMapping.get(SieWindowMessageType.Ack);
    }
    get responseChannel() {
        if (this.type !== SieWindowMessageType.Message) {
            return;
        }
        return this.channel + this.messageTypeChannelSuffixMapping.get(SieWindowMessageType.Response);
    }
    constructor(options) {
        this.messageTypeChannelSuffixMapping = new Map([
            [SieWindowMessageType.Ack, 'Ack'],
            [SieWindowMessageType.Response, 'Response'],
            [SieWindowMessageType.Message, '']
        ]);
        this.acknowledged = false;
        this.responded = false;
        const id = options.id;
        this.id = id || getUniqueID();
        this.channel = options.channel;
        this._payload = options.payload;
        this.source = options.source;
        this.target = options.target;
        for (const [type, suffix] of this.messageTypeChannelSuffixMapping) {
            if (this.channel.endsWith(suffix)) {
                this.type = type;
                break;
            }
        }
    }
    static isSieWindowMessageEvent(message) {
        return message.data?.sieWindowMessage;
    }
    static fromWindowMessageEvent(event) {
        const eventPayload = event.data.payload;
        return new SieWindowMessage({
            id: eventPayload.id,
            channel: eventPayload.channel,
            payload: eventPayload.payload,
            source: event.source
        });
    }
    send() {
        if (!this.target) {
            throw new Error('Received messages cannot be sent. Did you mean to respond?');
        }
        this.target.postMessage({
            sieWindowMessage: true,
            type: SieWindowMessageType.Message,
            payload: {
                id: this.id,
                channel: this.channel,
                payload: this.payload
            }
        });
    }
    acknowledge() {
        if (this.type !== SieWindowMessageType.Message) {
            return;
        }
        if (this.acknowledged) {
            throw new Error('Message is already acknowledged.');
        }
        this.acknowledged = true;
        this.source.postMessage({
            sieWindowMessage: true,
            type: SieWindowMessageType.Ack,
            payload: {
                id: this.id,
                channel: this.ackChannel,
                payload: true
            }
        });
    }
    respond(response) {
        if (this.responded) {
            throw new Error('Message is already responded to.');
        }
        this.responded = true;
        this.source.postMessage({
            sieWindowMessage: true,
            type: SieWindowMessageType.Response,
            payload: {
                id: this.id,
                channel: this.responseChannel,
                payload: response
            }
        });
    }
}

class WindowMessagingService extends EventBus {
    constructor() {
        super();
        // ACK Config
        this.ackTimeout = 1000;
        this.ackTimeoutError = 'Message acknowledgement timed out.';
        // Response Config
        this.defaultResponseTimout = 6000;
        this.responseTimeoutError = 'Message response timed out.';
        this.listen();
    }
    listen() {
        window.addEventListener('message', (message) => {
            if (SieWindowMessage.isSieWindowMessageEvent(message) && this.isSameOrigin(message.origin)) {
                const sieMessage = SieWindowMessage.fromWindowMessageEvent(message);
                sieMessage.acknowledge();
                this.emit(sieMessage.channel, sieMessage);
            }
        });
    }
    async postMessage(options) {
        return new Promise((resolve, reject) => {
            const sieMessage = new SieWindowMessage({
                channel: options.channel,
                payload: options.payload,
                target: options.target
            });
            // Acknowledgement
            this.on$(sieMessage.ackChannel)
                .pipe(timeoutWith(this.ackTimeout, throwError(new Error(this.ackTimeoutError))), filter(busEvent => busEvent.data.id === sieMessage.id), take(1))
                .subscribe({
                next: () => {
                    resolve();
                },
                error: error => {
                    reject(error);
                }
            });
            const responseOptions = options;
            if (responseOptions.response) {
                this.on$(sieMessage.responseChannel)
                    .pipe(timeoutWith(responseOptions.responseTimeout || this.defaultResponseTimout, throwError(new Error(this.responseTimeoutError))), filter(busEvent => busEvent.data.id === sieMessage.id), take(1))
                    .subscribe({
                    next: busEvent => {
                        responseOptions.response(busEvent.data.payload);
                    },
                    error: error => {
                        responseOptions.responseError && responseOptions.responseError(error);
                    }
                });
            }
            sieMessage.send();
        });
    }
    on$(channel, window) {
        const on$ = super.on$(channel);
        if (window) {
            return on$.pipe(filter(e => e.data.source === window));
        }
        return on$;
    }
    isSameOrigin(origin) {
        return origin === location.origin;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: WindowMessagingService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: WindowMessagingService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: WindowMessagingService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return []; } });

class WindowMessagingServiceMock extends EventBus {
    constructor() {
        super(...arguments);
        this.waitForResponse = true;
        this.storedObservers = new Map();
    }
    async postMessage(options) {
        return new Promise(resolve => {
            const subject = this.storedObservers.get(options.channel);
            if (subject) {
                const sieMessage = new SieWindowMessage({
                    channel: options.channel,
                    payload: options.payload,
                    target: options.target
                });
                if (this.waitForResponse) {
                    sieMessage.respond = () => resolve();
                    subject.next({ data: sieMessage, respond: () => null });
                    return;
                }
                else {
                    sieMessage.respond = () => null;
                    subject.next({ data: sieMessage, respond: () => null });
                }
            }
            resolve();
        });
    }
    on$(channel, _window) {
        const subject = new Subject();
        this.storedObservers.set(channel, subject);
        return subject.asObservable();
    }
}
const windowMessagingServiceMockProvider = {
    provide: WindowMessagingService,
    useClass: WindowMessagingServiceMock
};

class LoggerServiceMock {
    logForProduction() {
        // only for testing purposes
    }
    error() {
        // only for testing purposes
    }
    info() {
        // only for testing purposes
    }
    log() {
        // only for testing purposes
    }
    warn() {
        // only for testing purposes
    }
    logEnabled() {
        return true;
    }
}
const loggerServiceMockProvider = { provide: LoggerService, useClass: LoggerServiceMock };

class Timer {
    constructor(fn, duration, startImmediately = true) {
        this.isPaused = true;
        this.callbackFn = fn;
        this.remaining = this.duration = duration;
        if (startImmediately) {
            this.resume();
        }
    }
    resume() {
        if (!this.isPaused) {
            return;
        }
        this.startTime = Date.now();
        clearTimeout(this.timer);
        this.timer = setTimeout(() => {
            this.callbackFn();
        }, this.remaining);
        this.isPaused = false;
    }
    pause() {
        this.remaining -= Date.now() - this.startTime;
        clearTimeout(this.timer);
        this.isPaused = true;
    }
    reset() {
        clearTimeout(this.timer);
        this.isPaused = true;
        this.remaining = this.duration;
        this.resume();
    }
    clear() {
        clearTimeout(this.timer);
    }
}

class UrlValidationError extends Error {
}
class UrlValidationErrors extends Error {
    constructor(errors) {
        super();
        this.errors = errors;
    }
}

class UrlParameters {
    get hasValidationFixes() {
        return this._hasValidationFixes;
    }
    get keys() {
        return [...this.params.keys()];
    }
    constructor(urlParameters) {
        this.params = new Map();
        this.defaults = new Map();
        this.order = [];
        this.parameterWhiteList = [];
        this.validators = new Map();
        this.caseInsensitive = [];
        this._hasValidationFixes = false;
        this.refreshParams(urlParameters);
    }
    static createCaseInsensitive(params) {
        const instance = new this(params);
        instance.sanitizeCaseInsensitiveKeys();
        return instance;
    }
    refresh(urlParameters) {
        this.refreshParams(urlParameters);
    }
    refreshParams(urlParameters) {
        this.params.clear();
        this.queryParams = urlParameters;
        urlParameters.keys.forEach(urlParameterKey => {
            this.params.set(urlParameterKey, urlParameters.get(urlParameterKey));
        });
    }
    get(key) {
        return this.params.get(key);
    }
    setDefault(key, value) {
        this.defaults.set(key, value);
        return this;
    }
    addValue(key, value, canHaveMultipleValues) {
        if (canHaveMultipleValues) {
            if (!this.parameterValueExists(key, value)) {
                this.replaceValue(key, (this.params.get(key) ? this.params.get(key) + ',' : '') + value);
            }
        }
        else {
            this.replaceValue(key, value);
        }
    }
    replaceValue(key, value) {
        this.params.set(key, value);
    }
    removeValue(key, value, canHaveMultipleValues) {
        if (canHaveMultipleValues) {
            if (this.parameterValueExists(key, value)) {
                const values = this.params.get(key)?.split(',');
                if (values.length === 1) {
                    this.params.delete(key);
                }
                else {
                    values.splice(values.indexOf(value), 1);
                    this.replaceValue(key, values.toString());
                }
            }
        }
        else {
            this.params.delete(key);
        }
    }
    hasParameterWithExactThisValues(key, values) {
        if (values && values.length > 0) {
            return values.every(value => this.parameterValueExists(key, value));
        }
        else {
            return this.parameterExists(key);
        }
    }
    validate() {
        const errors = [];
        this.validators.forEach((configs, key) => {
            const keyAsString = key;
            configs.forEach(config => {
                const output = config.validator(key, this.params.get(keyAsString), this.params);
                if (output instanceof UrlValidationError) {
                    if (config.handler && config.handler.call(this, key)) {
                        this._hasValidationFixes = true;
                        return;
                    }
                    errors.push(output);
                }
            });
        });
        if (errors.length) {
            throw new UrlValidationErrors(errors);
        }
    }
    sort() {
        if (!this.order.length) {
            return false;
        }
        const newOrder = new Map();
        this.order.forEach(param => {
            const paramString = param;
            if (this.params.has(paramString)) {
                newOrder.set(paramString, this.params.get(paramString));
            }
        });
        this.params.forEach((value, key) => {
            if (!newOrder.has(key)) {
                newOrder.set(key, value);
            }
        });
        const orderChanged = !ArrayUtil.is([...newOrder.keys()]).ofSameItemOrderAs([...this.params.keys()]);
        this.params = newOrder;
        return orderChanged;
    }
    removeUnknownParams() {
        let removedParams = false;
        this.params.forEach((_, key) => {
            if (!this.parameterWhiteList.find(parameter => parameter === key) &&
                !this.order.find(parameter => parameter === key)) {
                removedParams = true;
                this.params.delete(key);
            }
        });
        return removedParams;
    }
    toUrlParamsObject() {
        const paramObject = {};
        this.params.forEach((value, key) => {
            paramObject[key] = value;
        });
        return paramObject;
    }
    sanitizeCaseInsensitiveKeys() {
        const keyEqualsInsensitiveKey = (key, insensitiveKey) => key !== insensitiveKey && insensitiveKey.toLowerCase() === key.toLowerCase();
        this.params.forEach((value, key) => {
            const matchingKey = this.caseInsensitive.find(insensitiveKey => keyEqualsInsensitiveKey(key, insensitiveKey));
            if (matchingKey) {
                this.params.set(matchingKey, value);
                this.params.delete(key);
                this._hasValidationFixes = true;
            }
        });
    }
    fallbackToDefault(key) {
        const defaultValue = this.defaults.get(key);
        if (defaultValue || defaultValue === '') {
            this.params.set(key, defaultValue);
            return true;
        }
        return false;
    }
    parameterValueExists(key, value) {
        const values = this.params.get(key)?.split(',');
        return values?.indexOf(value + '') >= 0;
    }
    parameterExists(key) {
        return !!this.params.get(key);
    }
}

class UrlParamRequiredError extends UrlValidationError {
    constructor(message) {
        super(message);
    }
}
const urlParamRequiredValidator = (key, value) => {
    return value === undefined ? new UrlParamRequiredError(`${key} is required.`) : true;
};

class UrlParamValueNotAllowedError extends UrlValidationError {
    constructor(message) {
        super(message);
    }
}
const urlParamOptionsValidator = (options) => {
    return (key, value) => {
        return options.includes(value) || new UrlParamValueNotAllowedError(`Value "${value}" not allowed for ${key}`);
    };
};

class UrlParamIsNaNError extends UrlValidationError {
    constructor(message) {
        super(message);
    }
}
const urlParamNumberValidator = (key, value) => {
    return !isNaN(+value) || new UrlParamIsNaNError(`${key} must be a number`);
};

class UrlParamNotEmptyValidatorError extends UrlValidationError {
    constructor(message) {
        super(message);
    }
}
const urlParamNotEmptyValidator = (key, value) => {
    return value === '' ? new UrlParamNotEmptyValidatorError(`${key}-value is empty.`) : true;
};

const AUTH_TOKEN_EVENT_NAME = 'sieportalauthchange';
const AUTH_TOKEN_ATTR_NAME = 'siePortal.token';
const GB_BEACON_LOADING_EVENT_NAME = 'sieportalgbloading';
const GB_BEACON_LOADED_EVENT_NAME = 'sieportalgbloaded';
const GB_BEACON_STATUS_ATTR_NAME = 'siePortal.gb.beacon.status';
const FEATURE_TOGGLE_CHANGE_EVENT_NAME = 'sieportalfeaturetoggleupdate';
const REQUEST_TRACKING_STATUS_ATTR_NAME = 'siePortal.adobe.tracking.status';
const REQUEST_TRACKING_SCRIPT = 'sieportalrequesttrackingscript';
const TRACKING_SCRIPT_LOADED = 'sieportaltrackingscriptloaded';
class MfeIntegrationService {
    updateAuthToken(authInfo) {
        const event = new CustomEvent(AUTH_TOKEN_EVENT_NAME, {
            detail: authInfo
        });
        sessionStorage.setItem(AUTH_TOKEN_ATTR_NAME, JSON.stringify(authInfo));
        document.dispatchEvent(event);
    }
    clearGbState() {
        sessionStorage.removeItem(GB_BEACON_STATUS_ATTR_NAME);
    }
    updateGbLoadingState() {
        sessionStorage.setItem(GB_BEACON_STATUS_ATTR_NAME, 'loading');
        const event = new CustomEvent(GB_BEACON_LOADING_EVENT_NAME);
        document.dispatchEvent(event);
    }
    updateGbLoadedState() {
        sessionStorage.setItem(GB_BEACON_STATUS_ATTR_NAME, 'loaded');
        const event = new CustomEvent(GB_BEACON_LOADED_EVENT_NAME);
        document.dispatchEvent(event);
    }
    dispatchFeatureToggleChange() {
        const event = new CustomEvent(FEATURE_TOGGLE_CHANGE_EVENT_NAME);
        document.dispatchEvent(event);
    }
    trackingScriptRequestedEvent() {
        sessionStorage.removeItem(REQUEST_TRACKING_STATUS_ATTR_NAME);
        return fromEvent(document, REQUEST_TRACKING_SCRIPT);
    }
    trackingScriptRequested() {
        sessionStorage.setItem(REQUEST_TRACKING_STATUS_ATTR_NAME, 'requested');
    }
    trackingScriptLoaded() {
        sessionStorage.setItem(REQUEST_TRACKING_STATUS_ATTR_NAME, 'loaded');
        const event = new CustomEvent(TRACKING_SCRIPT_LOADED);
        document.dispatchEvent(event);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: MfeIntegrationService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: MfeIntegrationService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: MfeIntegrationService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }] });

/*
 * Public API Surface of sie-core
 */

/**
 * Generated bundle index. Do not edit.
 */

export { AbstractDataCache, AbstractDataSource, AddTooltipDirective, AddTooltipModule, AddTruncationAndTooltipDirective, AddTruncationAndTooltipModule, AdvancedHoverEffectDirective, AdvancedHoverEffectModule, AnchorButtonDirective, AnchorButtonModule, ApiDataSource, ApiDataSourceCachingStrategy, ApiDataSourceNameRegistry, ApiDataSourceTestWrapper, ApiDataSourceWithBreadcrumbs, ApiInfiniteListDataSource, ApiPollingDataSource, AppInitService, AppLanguage, AppRegion, AppRoutes, ArrayComparator, ArrayUtil, AttachmentService, AttributeDirective, AttributeModule, BaseListPagination, BlobDownloadPipe, BreakpointUtil, Breakpoints, BusEvent, CACHE_KEY_PREFIX, CONSOLE, CalcViewHeightDirective, CalcViewHeightModule, CatalogSearchType, CircularArray, CoerceNumberArrayService, ComponentBreakpointsDirective, ComponentBreakpointsModule, ContainerBreakpoints, CookieEventChannel, CookieObserverService, DAYS_IN_WEEK, DEFAULT_DATE_FORMAT, DEFAULT_FALLBACK_REGION, DEFAULT_LANGUAGE, DEFAULT_LOCALE, DEFAULT_LOCALE_STRING, DEFAULT_REGION, DataAttributeDirective, DataAttributeModule, DataCacheService, DataMemoryCache, DataSource, DataStorageCache, DateFormatService, DateParserService, DatePart, DatePipe, DateUtil, Debounce, DefaultListPagination, Direction, DomUtil, DownloadUtil, DynamicPropPath, ERROR_INTERCEPTOR_IGNORE_ERROR, ElementResizeDirective, EventBus, FILTER_UPDATE_DELAY, FeatureName, FeatureToggleGuard, FeatureToggleService, GenerateArrayPipe, HOURS_IN_DAY, HandlerCombiner, HideIfEmptyDirective, HideIfEmptyModule, HighlightDirective, HighlightModule, INITIAL_RESIZE_EVENT, InViewDirective, InViewModule, InfiniteListPaginationImpl, IntersectionObserverDirective, IntersectionObserverModule, IsArrayPipe, JwtDecoder, JwtDecoderError, KeyboardEventUtil, KeyboardKey, KeyboardKeyComparator, KnowledgeBaseSearchType, LOCATION, LOGGER_CONFIG, LanguageNotProvidedError, LanguageNotSupportedError, LayoutService, LazyComponentComponent, LazyComponentDirective, LazyComponentModule, LinkComparator, LinkUtil, ListDirectivesModule, ListIntersectionObserverDirective, ListItemIntersectionObserverDirective, LocalDatePipe, LocalNumberPipe, LocaleAwareDateFormatService, LocaleAwareDateFormatServiceMock, LocaleAwareNumberFormatService, LocaleDiff, LocaleService, LocaleServiceMock, LocaleUtil, LocalizedRouteObservablePipe, LocalizedRoutePipe, Log, LoggerModule, LoggerService, LoggerServiceMock, MAX_DAYS_IN_MONTH, MILLISECONDS_IN_SECOND, MINUTES_IN_HOUR, MONTHS_IN_YEAR, MS_IN_DAY, MS_IN_HOUR, MS_IN_MINUTE, Metadata, MfeIntegrationService, MockActivatedRouteService, MockLayoutService, MockOutsideAngularService, Native, NativeService, NumberPipe, ObjectHistory, OnChange, OnChangesExecutionStrategy, OnChangesGroup, OnChangesGroupHandler, OnChangesHandler, OutsideAngularService, PAGINATION, PageMetadataService, PaginationPageSizeService, PlaygroundFeatureToggleService, REGION_LANGUAGE_CONFIG_URL, RangeRatio, RefreshComponentDirective, RefreshOn, RefreshReasonEnum, RefreshSpaService, Refreshable, RegionLanguageFileInvalidError, RegionNotProvidedError, RegionNotSupportedError, RegionTranslations, RepeatDirective, RouterService, SAAS_SESSION_ATTRIBUTE, SECONDS_IN_MINUTE, SaasFeatureToggleGuard, SaasFeatureToggleModule, SaasFeatureToggleService, ScriptService, ScriptState, SearchScopes, SelectableWithUnderlineDirective, SieCoreModule, SieCorePipesModule, SieUser, SieUserProfile, SieWindowMessage, SieWindowMessageType, SiemensError, StringUtil, TIMEOUT_ERROR_MESSAGE, TemplatingStrategy, TimeMeasurement, Timer, ToggleableFeatures, TrackingService, TrackingServiceMock, TruncateDirective, TruncateModule, TruncatePipe, UrlParamIsNaNError, UrlParamNotEmptyValidatorError, UrlParamRequiredError, UrlParamValueNotAllowedError, UrlParameters, UrlService, UrlValidationError, UrlValidationErrors, ViewportPipe, WindowMessagingService, WindowMessagingServiceMock, apiDataSourceMock, apiDataSourceMockProvider, apiInfiniteDataSourceMock, apiServiceMockProvider, cacheRegister$, deepCopy, deepEquals, definedOnly, findRecursive, getBase64ContentType, getCacheId, getDatasourceCacheId, getDeltaChanges, getItemForId, getMimeType, getPropertyDynamically, getUniqueID, isEven, isFunction, isNonNullObject, isObject, isOdd, localeAwareDateFormatServiceMockProvider, loggerServiceMockProvider, mapBoolean, mockActivatedRoute, mockLayoutServiceProvider, mockLocaleServiceProvider, mockLocationProvider, mockOutsideAngularServiceProvider, mockPanEvent, mockPanEventCoords, mockRouterServiceProvider, modifyObjectsProperty, nonNullArray, nonNullArrayFilter, notNull, notNullFilter, objectStripper, percent, populateTemplate, replaceNull, resetIdCounter, round, safeRange, searchInObject, someNotNullArray, someNotNullArrayFilter, sortArrayBasedOnKey, sortArrayByParameter, sortArrayWithPriority, urlParamNotEmptyValidator, urlParamNumberValidator, urlParamOptionsValidator, urlParamRequiredValidator, windowMessagingServiceMockProvider };
//# sourceMappingURL=siemens-core.mjs.map
