import * as i1 from '@siemens/icons';
import { SieIcon, SieIconsModule, SIE_ICONS } from '@siemens/icons';
import * as i0 from '@angular/core';
import { Component, ChangeDetectionStrategy, Input, Output, HostListener, Directive, NgModule, EventEmitter, ViewChild, HostBinding, ViewContainerRef, Optional, Inject, QueryList, ContentChildren, Injectable, booleanAttribute, ViewChildren, InjectionToken, forwardRef, ViewEncapsulation, Pipe, PLATFORM_ID, ElementRef, SkipSelf, numberAttribute, ContentChild } from '@angular/core';
import * as i4 from '@angular/animations';
import { trigger, state, style, transition, group, animate, keyframes, sequence, query } from '@angular/animations';
import { createPopper } from '@popperjs/core';
import * as i2$2 from 'rxjs';
import { Subject, Subscription, map, fromEvent, of, from, BehaviorSubject, distinctUntilChanged, filter as filter$1, combineLatest } from 'rxjs';
import * as i2 from '@angular/common';
import { CommonModule, DOCUMENT } from '@angular/common';
import { coerceBooleanProperty, coerceNumberProperty, coerceStringArray } from '@angular/cdk/coercion';
import * as i1$1 from '@siemens/core';
import { DataAttributeModule, Debounce, FILTER_UPDATE_DELAY, AddTooltipModule, AttributeModule, ComponentBreakpointsModule, Breakpoints, AddTruncationAndTooltipModule, HighlightModule, deepCopy, Direction, populateTemplate, TemplatingStrategy, DomUtil, ElementResizeDirective, RangeRatio, HandlerCombiner, KeyboardEventUtil, KeyboardKey, getUniqueID, safeRange, SieCorePipesModule, SelectableWithUnderlineDirective, AnchorButtonModule, ArrayUtil, StringUtil, RepeatDirective, AdvancedHoverEffectModule, IntersectionObserverModule, OnChangesGroup, OnChangesGroupHandler, OnChange, TruncateModule, InViewModule, CalcViewHeightModule, BreakpointUtil, CircularArray, getMimeType, Timer, Native, DateUtil, LocaleUtil, DateParserService, DateFormatService, searchInObject } from '@siemens/core';
import { __decorate } from 'tslib';
import { ComponentButtonsMainSpinnerSpacing, ComponentButtonsMainMaxWidth, EasingStandardProductive, AnimationDurationFast, ColorSupportive1OnLight, ColorSupportive1OnDark, ColorSupportive2OnLight, ColorSupportive2OnDark, ColorSupportive3OnLight, ColorSupportive3OnDark, ColorSupportive4OnLight, ColorSupportive4OnDark, ComponentAccountIdentifierColorBackgroundGreen1, ComponentAccountIdentifierColorBackgroundGreen2, ComponentAccountIdentifierColorBackgroundBlue1, ComponentAccountIdentifierColorBackgroundBlue2, ComponentAccountIdentifierColorBackgroundBlue3, ComponentAccountIdentifierColorBackgroundDarkBlue, ComponentAccountIdentifierColorBackgroundPurple1, ComponentAccountIdentifierColorBackgroundPurple2, ComponentAccountIdentifierColorBackgroundPink1, ComponentAccountIdentifierColorBackgroundPink2, ComponentAccountIdentifierColorBackgroundOrange, ComponentAccountIdentifierColorBackgroundRed, ComponentCarouselGutterS, ComponentCarouselGutterL, EasingStandardExpressive, EasingEntranceProductive, EasingExitProductive, ComponentDropdownOffsetLeftGteM, AnimationDurationNormal, ColorBackground1, ComponentTruncationVarMargin, ComponentTruncationVarGradientColor, ColorFunctionalInformationLight, ColorFunctionalSuccessLight, ColorFunctionalWarningLight, ColorFunctionalErrorLight, ColorBackground1RgbList, ColorBackground3RgbList, ComponentTabsGradientWidthContainedS, ComponentTabsGradientWidthContainedL, ComponentTabsGradientWidthUnContained, ComponentTabsVarBackgroundColor, ComponentTeaserOverlay, ComponentCarouselBreakpointsSQuery, ComponentCarouselBreakpointsMQuery, ComponentCarouselBreakpointsLandscapeLQuery, ComponentCarouselBreakpointsLandscapeXlQuery, ComponentCarouselBreakpointsLQuery, ComponentCarouselBreakpointsXlQuery, ComponentCardsLandscapeMaxWidthS, ComponentCardsLandscapeMaxWidthL, ComponentCardsPortraitMaxWidth, ComponentHeaderHeightMin, AnimationDurationSlow, ComponentHeaderHeightS, ComponentHeaderHeightL, EasingEntranceExpressive, EasingExitExpressive, ComponentDatepickerWidthVarName, ComponentDatepickerKeyboardNavClassName } from '@siemens/styles';
import * as i6 from '@angular/cdk/a11y';
import { A11yModule } from '@angular/cdk/a11y';
import * as i3 from '@angular/forms';
import { NG_VALUE_ACCESSOR, NG_VALIDATORS, FormsModule, UntypedFormGroup, UntypedFormControl } from '@angular/forms';
import * as i10 from '@angular/cdk/overlay';
import { OverlayModule, Overlay, CdkConnectedOverlay, CdkOverlayOrigin } from '@angular/cdk/overlay';
import { concatMap, delay, repeat, filter, map as map$1, debounceTime } from 'rxjs/operators';
import { NgxSmartModalComponent } from 'ngx-smart-modal';
import * as i2$1 from '@angular/router';
import { NavigationEnd, RouterModule } from '@angular/router';
import * as i4$1 from '@angular/platform-browser';
import * as i1$2 from '@angular/cdk/layout';
import * as i7$1 from '@angular/material/datepicker';
import { MAT_SINGLE_DATE_SELECTION_MODEL_PROVIDER, MatDatepicker, MatCalendar, MatDatepickerModule, MatStartDate, MatEndDate, MAT_RANGE_DATE_SELECTION_MODEL_PROVIDER, MatDateRangePicker } from '@angular/material/datepicker';
import * as i3$1 from '@angular/material/core';
import { NativeDateAdapter, MAT_DATE_LOCALE, DateAdapter, MAT_DATE_FORMATS, MatNativeDateModule } from '@angular/material/core';
import * as i7 from '@angular/material/form-field';
import { MatFormFieldModule, MatFormField } from '@angular/material/form-field';
import * as i8 from '@angular/material/input';
import { MatInputModule } from '@angular/material/input';
import * as i1$3 from '@angular/cdk/platform';

class UIConstants {
    static { this.COCKPIT_CATEGORY_ICONS = {
        order: SieIcon.SieportalOrder,
        service: SieIcon.Service,
        quote: SieIcon.SieportalTag
    }; }
    static { this.QUERY_PARAMS = {
        MODAL_ID: 'modalId',
        TOAST_ID: 'tstmsg'
    }; }
    static { this.FLAG_ICONS_PATH = '/assets/sie-icons/flags/'; }
    static { this.SESSION_NAME_MAINTENANCE_BOX = 'maintenance-box'; }
    static { this.SESSION_NAME_REGIONAL_BOX = 'regional-box'; }
    static { this.SESSION_NAME_QUOTES_BOX = 'quotes-box'; }
    static { this.COUNT_LIMIT = 1000; }
    static { this.COUNT_EXCEEDED_PLACEHOLDER = '999+'; }
    static { this.TILE_BUTTONS_MIN = 2; }
    static { this.TILE_BUTTONS_MAX = 8; }
    static { this.SWITCH_BUTTON_MIN = 2; }
    static { this.SWITCH_BUTTON_MAX = 3; }
}

const togglePopoverAnimation = trigger('togglePopover', [
    state('show', style({
        opacity: 1,
        transform: 'translateX(0)'
    })),
    state('hide', style({
        opacity: 0,
        transform: 'translateX(40px)'
    })),
    transition('show => hide', [
        group([
            animate('300ms cubic-bezier(0.4, 0, 1, 1)', style({ opacity: '0' })),
            animate('300ms cubic-bezier(0.4, 0, 1, 1)', style({ transform: 'translateX(-10px)' }))
        ])
    ]),
    transition('hide => show', [
        group([
            animate('250ms cubic-bezier(0, 0, 0.3, 1)', style({ opacity: '1' })),
            animate('400ms cubic-bezier(0, 0, 0.3, 1)', style({ transform: 'translateX(0)' }))
        ])
    ])
]);

/**
 * # Popover Component
 *
 * Popover support users in understanding specific elements within a page on a detailed level.
 *
 * ## Component variations
 *
 * The popover component has no variations.
 *
 * ## Content
 *
 * The popover component is able to take any content by using `sieUiPopover` directive.
 *
 * ## Code example
 * @example
 *  ```html
 * <button sieUiPopover content="Please provide your feedback here!" popoverSize="l" popoverLightTheme="true">
 *   Tooltip white
 * </button>
 *
 * <button sieUiPopover popoverSize="s" [popoverTemplate]="popoverTemplate">Tooltip</button>
 * <ng-template #popoverTemplate>
 *   <p>
 *     Lorem ipsum dolor sit ame consetetur sadipscing elit, sed diam nonumy eirmod tempor invidunt ut labore et
 *     <sie-ui-link href="https://www.siemens.com" target="_blank" variant="inline">Click me!</sie-ui-link> dolore
 *     magna aliquyam.
 *   </p>
 *   <sie-ui-picture [model]="pictureItem"></sie-ui-picture>
 * </ng-template>
 * ```
 *
 * ```ts
 * pictureItem: UiPictureModel = {
 *   urlSmall:
 *    'https://assets.new.siemens.com/siemens/assets/api/uuid:b74b4f94-fe72-4745-9ace-ccd68ea46831/width:1920/quality:HIGH/IM2018110010PD_LAY02.jpg',
 *   urlMedium:
 *    'https://assets.new.siemens.com/siemens/assets/api/uuid:b74b4f94-fe72-4745-9ace-ccd68ea46831/width:1280/quality:MEDIUM/IM2018110010PD_LAY02.jpg',
 *   urlLarge:
 *    'https://assets.new.siemens.com/siemens/assets/api/uuid:b74b4f94-fe72-4745-9ace-ccd68ea46831/width:640/quality:LOW/IM2018110010PD_LAY02.jpg',
 *   altText: 'Alternative text',
 *   mode: 'cover',
 *   caption: 'Lorem ipsum dolor sit amet'
 * };
 * ```
 */
class UiPopoverComponent {
    /**
     * Content that is displayed in richtext within the popover
     */
    set content(value) {
        this._content = value;
        this.cdr.detectChanges();
    }
    get content() {
        return this._content;
    }
    constructor(el, cdr) {
        this.el = el;
        this.cdr = cdr;
        /**
         * Defines if the theme of the popover is light
         * @default false
         */
        this.lightTheme = false;
        /**
         * Emitted when component is hovered
         * @default true
         */
        this.isHovered = new Subject();
        /**
         * Emitted when animation is done
         * @default false
         */
        this.isAnimationDone = new Subject();
        this.popoverAnimationState = 'hide';
    }
    /** @ignore */
    get animationState() {
        return this.popoverAnimationState;
    }
    /** @ignore */
    ngOnInit() {
        this.initializePopper();
        this.animation ? this.triggerPopoverAnimation() : (this.popoverAnimationState = 'visible');
        this.cdr.detectChanges();
    }
    /** @ignore */
    ngOnDestroy() {
        this.el.nativeElement.style.display = 'none'; // necessary because angular sometimes takes time to actually clean up the component from HTML
        this.popper?.destroy();
    }
    onMouseEnter() {
        this.isHovered.next(true);
    }
    onMouseLeave() {
        this.isHovered.next(false);
    }
    initializePopper() {
        this.popper = createPopper(this.host, this.el.nativeElement);
        this.popper
            .setOptions({
            placement: this.placement,
            modifiers: [
                { name: 'eventListeners', enabled: true },
                {
                    name: 'offset',
                    options: {
                        offset: [0, 12]
                    }
                },
                {
                    name: 'flip',
                    options: {
                        fallbackPlacements: ['right', 'bottom', 'left']
                    }
                }
            ]
        })
            .then(() => {
            this.cdr.detectChanges();
        });
    }
    triggerPopoverAnimation() {
        if (this.playAnimation) {
            this.playAnimation.subscribe(animate => {
                if (animate) {
                    this.popoverAnimationState = 'show';
                }
                this.cdr.detectChanges();
            });
        }
        else {
            this.popoverAnimationState = 'show';
        }
        this.cdr.detectChanges();
    }
    /** @ignore */
    onAnimationDone(animationChanged) {
        if (this.animation && animationChanged.toState === 'show') {
            setTimeout(() => {
                this.popoverAnimationState = 'hide';
                this.isAnimationDone.next(true);
                this.cdr.detectChanges();
            }, this.animationHideAfterTimeoutMS);
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiPopoverComponent, deps: [{ token: i0.ElementRef }, { token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiPopoverComponent, selector: "sie-ui-popover", inputs: { content: "content", popoverTemplate: "popoverTemplate", host: "host", size: "size", placement: "placement", animation: "animation", animationHideAfterTimeoutMS: "animationHideAfterTimeoutMS", playAnimation: "playAnimation", lightTheme: "lightTheme" }, outputs: { isHovered: "isHovered", isAnimationDone: "isAnimationDone" }, host: { listeners: { "mouseenter": "onMouseEnter()", "mouseleave": "onMouseLeave()" } }, ngImport: i0, template: "<div\n  [@togglePopover]=\"animationState\"\n  (@togglePopover.done)=\"onAnimationDone($event)\"\n  class=\"popover popover--{{ size }}\"\n  [ngClass]=\"{ 'popover--light': lightTheme }\"\n>\n  <div class=\"popover-arrow\" data-popper-arrow></div>\n  <span *ngIf=\"content\" class=\"richtext\" [ngClass]=\"{ dark: !lightTheme }\" [innerHTML]=\"content\"></span>\n  <ng-template *ngIf=\"!content\" [ngTemplateOutlet]=\"popoverTemplate\"></ng-template>\n</div>\n", styles: [".popover{font-size:.75rem;font-weight:400;line-height:1rem;color:#fff;background-color:#000028;padding:8px;word-break:break-word;white-space:break-spaces;border-radius:4px}.popover--light{background-color:#fff;color:#000}.popover--xs{width:100px}.popover--s{width:160px}.popover--l{width:328px}.popover-arrow,.popover-arrow:before{position:absolute;width:10px;height:10px;background:inherit;text-align:left}.popover-arrow{visibility:hidden}.popover-arrow:before{visibility:visible;content:\"\";transform:rotate(45deg)}:host{z-index:99}:host[data-popper-placement^=top] .popover-arrow{bottom:-5px}:host[data-popper-placement^=bottom] .popover-arrow{top:-5px}:host[data-popper-placement^=left] .popover-arrow{right:-5px}:host[data-popper-placement^=right] .popover-arrow{left:-5px}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }], animations: [togglePopoverAnimation], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiPopoverComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-popover', animations: [togglePopoverAnimation], changeDetection: ChangeDetectionStrategy.OnPush, template: "<div\n  [@togglePopover]=\"animationState\"\n  (@togglePopover.done)=\"onAnimationDone($event)\"\n  class=\"popover popover--{{ size }}\"\n  [ngClass]=\"{ 'popover--light': lightTheme }\"\n>\n  <div class=\"popover-arrow\" data-popper-arrow></div>\n  <span *ngIf=\"content\" class=\"richtext\" [ngClass]=\"{ dark: !lightTheme }\" [innerHTML]=\"content\"></span>\n  <ng-template *ngIf=\"!content\" [ngTemplateOutlet]=\"popoverTemplate\"></ng-template>\n</div>\n", styles: [".popover{font-size:.75rem;font-weight:400;line-height:1rem;color:#fff;background-color:#000028;padding:8px;word-break:break-word;white-space:break-spaces;border-radius:4px}.popover--light{background-color:#fff;color:#000}.popover--xs{width:100px}.popover--s{width:160px}.popover--l{width:328px}.popover-arrow,.popover-arrow:before{position:absolute;width:10px;height:10px;background:inherit;text-align:left}.popover-arrow{visibility:hidden}.popover-arrow:before{visibility:visible;content:\"\";transform:rotate(45deg)}:host{z-index:99}:host[data-popper-placement^=top] .popover-arrow{bottom:-5px}:host[data-popper-placement^=bottom] .popover-arrow{top:-5px}:host[data-popper-placement^=left] .popover-arrow{right:-5px}:host[data-popper-placement^=right] .popover-arrow{left:-5px}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: i0.ChangeDetectorRef }]; }, propDecorators: { content: [{
                type: Input
            }], popoverTemplate: [{
                type: Input
            }], host: [{
                type: Input
            }], size: [{
                type: Input
            }], placement: [{
                type: Input
            }], animation: [{
                type: Input
            }], animationHideAfterTimeoutMS: [{
                type: Input
            }], playAnimation: [{
                type: Input
            }], lightTheme: [{
                type: Input
            }], isHovered: [{
                type: Output
            }], isAnimationDone: [{
                type: Output
            }], onMouseEnter: [{
                type: HostListener,
                args: ['mouseenter']
            }], onMouseLeave: [{
                type: HostListener,
                args: ['mouseleave']
            }] } });

/**
 * This directive is used to display the popover
 */
class UiPopoverDirective {
    /**
     * Content that is displayed in richtext within the popover
     */
    set content(value) {
        if (this.componentRef) {
            this.componentRef.instance.content = value;
        }
        this._content = value;
    }
    get content() {
        return this._content;
    }
    constructor(element, vcr) {
        this.element = element;
        this.vcr = vcr;
        /**
         * Defines {@link PopoverSize size} of the popover
         * @default 'l'
         */
        this.popoverSize = 'l';
        /**
         * Defines {@link PopoverPlacement placement} of the popover
         * @default 'top'
         */
        this.popoverPlacement = 'top';
        /**
         * Defines if popover has animation
         * @default false
         */
        this.popoverAnimation = false;
        /**
         * Defines the timeout when the animation will hide the popover if it is active
         * @default 3000
         */
        this.popoverAnimationHideAfterTimeoutMS = 3000;
        /**
         * Defines if the theme of the popover is light
         * @default false
         */
        this.popoverLightTheme = false;
    }
    openOnMouseEnter() {
        if (!this.popoverAnimation && (this.content || this.popoverTemplate)) {
            this.openPopover();
            this.popoverStateListener();
        }
    }
    closeOnMouseLeave() {
        if (!this.popoverAnimation) {
            this.closePopover();
        }
    }
    popoverStateListener() {
        this.hoveredSubscription?.unsubscribe();
        this.hoveredSubscription = this.componentRef.instance.isHovered.subscribe(isHovered => {
            if (isHovered && (this.content || this.popoverTemplate)) {
                this.openPopover();
            }
            else {
                clearTimeout(this.popoverTimeout);
                this.closePopover();
            }
        });
    }
    openPopover() {
        clearTimeout(this.popoverTimeout);
        if (this.componentRef) {
            return;
        }
        this.componentRef = this.vcr.createComponent(UiPopoverComponent);
        this.componentRef.instance.content = this.content;
        this.componentRef.instance.popoverTemplate = this.popoverTemplate;
        this.componentRef.instance.size = this.popoverSize;
        this.componentRef.instance.placement = this.popoverPlacement;
        this.componentRef.instance.lightTheme = this.popoverLightTheme;
        this.componentRef.instance.animation = this.popoverAnimation;
        this.componentRef.instance.playAnimation = this.popoverPlayAnimation;
        this.componentRef.instance.animationHideAfterTimeoutMS = this.popoverAnimationHideAfterTimeoutMS;
        this.componentRef.instance.host = this.element.nativeElement;
        this.componentRef.instance.isAnimationDone.subscribe(isAnimationDone => isAnimationDone && this.closePopover());
    }
    closePopover() {
        this.popoverTimeout = setTimeout(() => {
            this.destroy();
        }, this.popoverAnimation ? 500 : 250);
    }
    destroy() {
        if (this.componentRef) {
            this.hoveredSubscription?.unsubscribe();
            this.componentRef.instance.isAnimationDone.unsubscribe();
            this.componentRef.destroy();
            this.componentRef = null;
        }
    }
    /** @ignore */
    ngOnInit() {
        if (this.popoverAnimation && (this.content || this.popoverTemplate)) {
            this.openPopover();
        }
    }
    /** @ignore */
    ngOnDestroy() {
        this.destroy();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiPopoverDirective, deps: [{ token: i0.ElementRef }, { token: i0.ViewContainerRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: UiPopoverDirective, selector: "[sieUiPopover]", inputs: { content: "content", popoverTemplate: "popoverTemplate", popoverSize: "popoverSize", popoverPlacement: "popoverPlacement", popoverAnimation: "popoverAnimation", popoverPlayAnimation: "popoverPlayAnimation", popoverAnimationHideAfterTimeoutMS: "popoverAnimationHideAfterTimeoutMS", popoverLightTheme: "popoverLightTheme" }, host: { listeners: { "mouseenter": "openOnMouseEnter()", "mouseleave": "closeOnMouseLeave()" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiPopoverDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[sieUiPopover]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: i0.ViewContainerRef }]; }, propDecorators: { content: [{
                type: Input
            }], popoverTemplate: [{
                type: Input
            }], popoverSize: [{
                type: Input
            }], popoverPlacement: [{
                type: Input
            }], popoverAnimation: [{
                type: Input
            }], popoverPlayAnimation: [{
                type: Input
            }], popoverAnimationHideAfterTimeoutMS: [{
                type: Input
            }], popoverLightTheme: [{
                type: Input
            }], openOnMouseEnter: [{
                type: HostListener,
                args: ['mouseenter']
            }], closeOnMouseLeave: [{
                type: HostListener,
                args: ['mouseleave']
            }] } });

/**
 * # Underline Tooltip component
 *
 * Underline tooltips are used to create dynamic components which utilize tooltips by using sieCoreAddTooltip directive.
 *
 * ## Content
 *
 * The sie-ui-underline-tooltip component doesn't accept any content.
 *
 * ## Code example
 * @example
 * Template:
 * ```html
 * Standard link:
 * <sie-ui-underline-tooltip
 *   text="example text"
 *   tooltipText="example tooltip text"
 * >
 * </sie-ui-underline-tooltip>
 * ```
 */
class UiUnderlineTooltipComponent {
    constructor() {
        this.theme = 'light';
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiUnderlineTooltipComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiUnderlineTooltipComponent, selector: "sie-ui-underline-tooltip", inputs: { text: "text", tooltipText: "tooltipText", theme: "theme" }, ngImport: i0, template: "<u\n  class=\"underline__dotted\"\n  sieUiPopover\n  [content]=\"tooltipText\"\n  [popoverLightTheme]=\"theme === 'dark'\"\n  popoverSize=\"s\"\n  >{{ text }}</u\n>\n", styles: [".underline__dotted{border-bottom:1px dotted;text-decoration:none}\n"], dependencies: [{ kind: "directive", type: UiPopoverDirective, selector: "[sieUiPopover]", inputs: ["content", "popoverTemplate", "popoverSize", "popoverPlacement", "popoverAnimation", "popoverPlayAnimation", "popoverAnimationHideAfterTimeoutMS", "popoverLightTheme"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiUnderlineTooltipComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-underline-tooltip', changeDetection: ChangeDetectionStrategy.OnPush, template: "<u\n  class=\"underline__dotted\"\n  sieUiPopover\n  [content]=\"tooltipText\"\n  [popoverLightTheme]=\"theme === 'dark'\"\n  popoverSize=\"s\"\n  >{{ text }}</u\n>\n", styles: [".underline__dotted{border-bottom:1px dotted;text-decoration:none}\n"] }]
        }], propDecorators: { text: [{
                type: Input
            }], tooltipText: [{
                type: Input
            }], theme: [{
                type: Input
            }] } });

/**
 * # Popover Module
 * - {@link UiPopoverComponent}
 * - {@link UiPopoverDirective}
 */
class UiPopoverModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiPopoverModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiPopoverModule, declarations: [UiPopoverComponent, UiPopoverDirective], imports: [CommonModule], exports: [UiPopoverComponent, UiPopoverDirective] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiPopoverModule, imports: [CommonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiPopoverModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiPopoverComponent, UiPopoverDirective],
                    imports: [CommonModule],
                    exports: [UiPopoverComponent, UiPopoverDirective]
                }]
        }] });

class UiUnderlineTooltipModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiUnderlineTooltipModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiUnderlineTooltipModule, declarations: [UiUnderlineTooltipComponent], imports: [UiPopoverModule], exports: [UiUnderlineTooltipComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiUnderlineTooltipModule, imports: [UiPopoverModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiUnderlineTooltipModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiUnderlineTooltipComponent],
                    imports: [UiPopoverModule],
                    exports: [UiUnderlineTooltipComponent]
                }]
        }] });

/**
 * # Tag component
 *
 * Tags are used to highlight a status or a category of a particular item with a keyword. They allow quick recognition and navigation.
 *
 * ## Component variations
 *
 * - Non-interactive tag
 * - Interactive tag
 * - Status tag
 * - Interactive without icon tag
 *
 * ## Content
 *
 * The label of the tag component can be any valid markup.
 *
 * ## Code example
 * @example ```html
 * <sie-ui-tag [tagId]="'industrial-software'" (selected)="onTagSelected($event)" (unselected)="onTagUnselected($event)">Industrial Software</sie-ui-tag>
 * <sie-ui-tag mode="noninteractive" [tagId]="'industrial-software'">Industrial Software</sie-ui-tag>
 * <sie-ui-tag status="success">Industrial Software</sie-ui-tag>
 * ```
 */
class UiTagComponent {
    /**
     * @param value Defines if the tag is disabled
     * @default false
     */
    set disabled(value) {
        this._disabled = coerceBooleanProperty(value);
    }
    get disabled() {
        return this._disabled;
    }
    /**
     * @param value Removes top border radius when used as status tag
     * @default false
     */
    set croppedTop(value) {
        this._croppedTop = coerceBooleanProperty(value);
    }
    get croppedTop() {
        return this._croppedTop;
    }
    /**
     * @param value Defines if the tag should have a smaller size of interactive tags
     * @default false
     */
    set condensed(value) {
        this._condensed = coerceBooleanProperty(value);
    }
    get condensed() {
        return this._condensed;
    }
    /**
     * @param value Defines if the tag should change mode when in 'interactive-without-icon' variation or be linkable
     * @default false
     */
    set linkable(value) {
        this._linkable = coerceBooleanProperty(value);
    }
    get linkable() {
        return this._linkable;
    }
    constructor(iconReg) {
        this.iconReg = iconReg;
        /**
         * Current {@link UiTagMode Mode} of the tag
         * @default 'unselected'
         */
        this.mode = 'unselected';
        /**
         * When the tag is interactive and becomes selected. Payload is {@link UiTagComponent.tagId}
         */
        this.selected = new EventEmitter();
        /**
         * When the tag is interactive and becomes unselected. Payload is {@link UiTagComponent.tagId}
         */
        this.unselected = new EventEmitter();
        /**
         * When the tag is interactive and removable, and when it's removed. Payload is {@link UiTagComponent.tagId}
         */
        this.removed = new EventEmitter();
        /**
         * When the tag is clicked. Payload is {@link UiTagComponent.tagId}
         */
        this.clicked = new EventEmitter();
        this._disabled = false;
        this._condensed = false;
        this._croppedTop = false;
        this._linkable = false;
        this.interactiveWithoutIcon = false;
        /** @ignore */
        this.iconReferenceByMode = {
            noninteractive: null,
            'interactive-without-icon': null,
            selected: SieIcon.CheckMarkSmall,
            unselected: SieIcon.PlusSmall,
            removable: SieIcon.CloseSmall
        };
        iconReg.register(SieIcon.CheckMarkSmall);
        iconReg.register(SieIcon.PlusSmall);
        iconReg.register(SieIcon.CloseSmall);
    }
    ngOnChanges(changes) {
        if (changes.hasOwnProperty('mode')) {
            this.isModeInteractiveWithoutIcon();
        }
    }
    /** @ignore */
    clickHandler() {
        if (this.disabled) {
            return;
        }
        if (this.interactiveWithoutIcon) {
            this.toggleInteractiveWithoutIconMode();
        }
        else {
            this.toggleMode();
        }
        this.emitClickEvent();
    }
    emitClickEvent() {
        this.clicked.emit(this.tagId);
        if (this.mode === 'selected') {
            this.selected.emit(this.tagId);
        }
        else if (this.mode === 'unselected') {
            this.unselected.emit(this.tagId);
        }
        else if (this.mode === 'removable') {
            this.removed.emit(this.tagId);
        }
    }
    toggleMode() {
        if (this.mode === 'selected') {
            this.mode = 'unselected';
        }
        else if (this.mode === 'unselected') {
            this.mode = 'selected';
        }
    }
    toggleInteractiveWithoutIconMode() {
        if (this.mode === 'interactive-without-icon' && !this.linkable) {
            this.mode = 'selected';
        }
        else {
            this.mode = 'interactive-without-icon';
        }
    }
    isModeInteractiveWithoutIcon() {
        this.interactiveWithoutIcon = this.mode === 'interactive-without-icon';
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTagComponent, deps: [{ token: i1.SieIconRegistryService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiTagComponent, selector: "sie-ui-tag", inputs: { mode: "mode", theme: "theme", status: "status", tagId: "tagId", dataAttrName: "dataAttrName", dataAttrValue: "dataAttrValue", disabled: "disabled", croppedTop: "croppedTop", condensed: "condensed", linkable: "linkable", removeButtonAriaLabel: "removeButtonAriaLabel" }, outputs: { selected: "selected", unselected: "unselected", removed: "removed", clicked: "clicked" }, viewQueries: [{ propertyName: "tagButton", first: true, predicate: ["tagButton"], descendants: true }], usesOnChanges: true, ngImport: i0, template: "<div class=\"tag-container\">\n  <span\n    *ngIf=\"status || mode === 'noninteractive'; else interactiveTag\"\n    [ngClass]=\"[\n      'tag',\n      theme ? 'theme-' + theme : '',\n      status ? 'status status-' + status : '',\n      mode === 'noninteractive' ? 'noninteractive mode-' + mode : '',\n      croppedTop ? 'cropped-top' : '',\n      disabled ? 'disabled' : ''\n    ]\"\n    [attr.tabindex]=\"disabled || status ? -1 : 0\"\n  >\n    <ng-container *ngTemplateOutlet=\"copyText\"></ng-container>\n  </span>\n  <ng-template #interactiveTag>\n    <button\n      type=\"button\"\n      [attr.aria-label]=\"removeButtonAriaLabel\"\n      [ngClass]=\"[\n        'tag interactive',\n        theme ? 'theme-' + theme : '',\n        mode ? 'mode-' + mode : '',\n        condensed ? 'condensed' : ''\n      ]\"\n      [disabled]=\"disabled\"\n      (click)=\"clickHandler()\"\n      #tagButton\n    >\n      <ng-container *ngTemplateOutlet=\"copyText\"></ng-container>\n      <span *ngIf=\"mode !== 'interactive-without-icon'\" class=\"tag__icon__container\" aria-hidden=\"true\">\n        <sie-icon class=\"tag__icon\" [name]=\"iconReferenceByMode[mode]\"></sie-icon>\n      </span>\n    </button>\n  </ng-template>\n</div>\n<ng-template #copyText>\n  <span class=\"tag__text\" [dataAttrName]=\"dataAttrName\" [dataAttrValue]=\"dataAttrValue\" sieCoreDataAttribute>\n    <ng-content></ng-content>\n  </span>\n</ng-template>\n", styles: [".tag:focus{outline:0}.tag-container{display:flex;align-items:center}.tag{display:flex;align-items:center;justify-content:space-between;text-align:center;min-width:54px;max-width:328px;height:32px;padding:0 12px;border-radius:16px;background:transparent;cursor:default}.tag__icon__container{display:flex;margin-left:6px}.tag__icon{width:16px;height:16px;display:flex;align-items:center;fill:currentColor}.tag__icon svg{fill:currentColor;width:inherit;height:inherit}.tag__icon svg g{fill:currentColor;width:inherit;height:inherit}.tag__icon svg text{font-family:Siemens Sans,sans-serif}.tag__text{font-size:1rem;font-weight:400;line-height:1.5rem;white-space:nowrap;overflow:hidden;text-overflow:ellipsis;position:relative;width:100%}.tag.condensed{height:24px;padding:0 10px;border-radius:14px}.tag.condensed .tag__text{font-size:.875rem;font-weight:400;line-height:1.25rem}.tag.mode-unselected,.tag.mode-interactive-without-icon{border:1px solid #007993;color:#007993;fill:#007993}.tag.mode-unselected:hover,.tag.mode-unselected:active,.tag.mode-interactive-without-icon:hover,.tag.mode-interactive-without-icon:active{background-color:#c2ffee;border:1px solid #00646e;color:#33747a;fill:#33747a;cursor:pointer}.tag.mode-unselected.theme-dark,.tag.mode-interactive-without-icon.theme-dark{background-color:#000028;border:1px solid #0cc;color:#0cc;fill:#0cc}.tag.mode-unselected.theme-dark:hover,.tag.mode-unselected.theme-dark:active,.tag.mode-interactive-without-icon.theme-dark:hover,.tag.mode-interactive-without-icon.theme-dark:active{background-color:#001f39;border:1px solid #00ffb9;color:#00ffb9;fill:#00ffb9}.tag.mode-noninteractive,.tag.mode-selected,.tag.mode-removable{border:1px solid #33747a;background-color:#33747a;color:#fff;fill:#fff}.tag.mode-noninteractive.theme-dark,.tag.mode-selected.theme-dark,.tag.mode-removable.theme-dark{color:#000028;fill:#000028;border:1px solid #00ffb9;background-color:#00ffb9}@media print{.tag.mode-noninteractive,.tag.mode-selected,.tag.mode-removable{background-color:unset;border-color:#9999a9;color:#000028}}.tag.mode-selected:hover,.tag.mode-selected:active,.tag.mode-removable:hover,.tag.mode-removable:active{color:#33747a;fill:#33747a;background-color:#c2ffee;border:1px solid #00646e;cursor:pointer}.tag.mode-selected.theme-dark:hover,.tag.mode-selected.theme-dark:active,.tag.mode-removable.theme-dark:hover,.tag.mode-removable.theme-dark:active{color:#00ffb9;fill:#00ffb9;background-color:#001f39;border:1px solid #00ffb9}.tag:focus{position:relative}.tag:focus:before{content:\"\";position:absolute;inset:-4px;z-index:1;border:1px solid #1491eb;border-radius:18px}.tag:focus-visible:before{content:\"\";position:absolute;inset:-4px;z-index:1;border:1px solid #1491eb;border-radius:18px}.tag.mode-noninteractive:focus:before,.tag.mode-noninteractive:focus-visible:before{border:none}.tag.status{height:24px;padding:0 10px;border-radius:14px}.tag.status-error{background:#ef0137;color:#fff}.tag.status-warning{background:#ffd732;color:#fff}.tag.status-success{background:#00af52;color:#fff}.tag.status-neutral{background:#7d8099;color:#fff}.tag.status-category-a{background:#005159;color:#fff}.tag.status-category-a.theme-dark{background:#00d7a0}.tag.status-category-b{background:#ec6602;color:#fff}.tag.status-category-b.theme-dark{background:#ff9000}.tag.status-category-c{background:#00557c;color:#fff}.tag.status-category-c.theme-dark{background:#00bedc}.tag.status-category-d{background:#500078;color:#fff}.tag.status-category-d.theme-dark{background:#aa32be}.tag.status-category-e{background:#f3f3f0;color:#000028}.tag.status.cropped-top{border-top-left-radius:0;border-top-right-radius:0}.tag.status .tag__text{font-size:.875rem;font-weight:400;line-height:1.25rem}.tag.disabled.mode-noninteractive,.tag.disabled.mode-selected,.tag.disabled.mode-removable,.tag:disabled.mode-noninteractive,.tag:disabled.mode-selected,.tag:disabled.mode-removable{color:#ebebee;fill:#ebebee;background-color:#b3b3be;border:1px solid #b3b3be}.tag.disabled.mode-noninteractive.theme-dark,.tag.disabled.mode-selected.theme-dark,.tag.disabled.mode-removable.theme-dark,.tag:disabled.mode-noninteractive.theme-dark,.tag:disabled.mode-selected.theme-dark,.tag:disabled.mode-removable.theme-dark{color:#b3b3be;fill:#b3b3be;background-color:#737389;border:1px solid #737389}.tag.disabled.mode-unselected,.tag.disabled.mode-interactive-without-icon,.tag:disabled.mode-unselected,.tag:disabled.mode-interactive-without-icon{color:#b3b3be;fill:#b3b3be;background-color:transparent;border:1px solid #b3b3be}.tag.disabled.mode-unselected.theme-dark,.tag.disabled.mode-interactive-without-icon.theme-dark,.tag:disabled.mode-unselected.theme-dark,.tag:disabled.mode-interactive-without-icon.theme-dark{color:#b3b3be;fill:#b3b3be;background-color:transparent;border:1px solid #b3b3be}.tag.disabled.mode-selected,.tag.disabled.mode-removable,.tag.disabled.mode-unselected,.tag.disabled.mode-interactive-without-icon,.tag:disabled.mode-selected,.tag:disabled.mode-removable,.tag:disabled.mode-unselected,.tag:disabled.mode-interactive-without-icon{cursor:not-allowed}.tag:focus:not(:focus-visible):before{border:none}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "directive", type: i1$1.DataAttributeDirective, selector: "[sieCoreDataAttribute]", inputs: ["dataAttrName", "dataAttrValue"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTagComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-tag', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"tag-container\">\n  <span\n    *ngIf=\"status || mode === 'noninteractive'; else interactiveTag\"\n    [ngClass]=\"[\n      'tag',\n      theme ? 'theme-' + theme : '',\n      status ? 'status status-' + status : '',\n      mode === 'noninteractive' ? 'noninteractive mode-' + mode : '',\n      croppedTop ? 'cropped-top' : '',\n      disabled ? 'disabled' : ''\n    ]\"\n    [attr.tabindex]=\"disabled || status ? -1 : 0\"\n  >\n    <ng-container *ngTemplateOutlet=\"copyText\"></ng-container>\n  </span>\n  <ng-template #interactiveTag>\n    <button\n      type=\"button\"\n      [attr.aria-label]=\"removeButtonAriaLabel\"\n      [ngClass]=\"[\n        'tag interactive',\n        theme ? 'theme-' + theme : '',\n        mode ? 'mode-' + mode : '',\n        condensed ? 'condensed' : ''\n      ]\"\n      [disabled]=\"disabled\"\n      (click)=\"clickHandler()\"\n      #tagButton\n    >\n      <ng-container *ngTemplateOutlet=\"copyText\"></ng-container>\n      <span *ngIf=\"mode !== 'interactive-without-icon'\" class=\"tag__icon__container\" aria-hidden=\"true\">\n        <sie-icon class=\"tag__icon\" [name]=\"iconReferenceByMode[mode]\"></sie-icon>\n      </span>\n    </button>\n  </ng-template>\n</div>\n<ng-template #copyText>\n  <span class=\"tag__text\" [dataAttrName]=\"dataAttrName\" [dataAttrValue]=\"dataAttrValue\" sieCoreDataAttribute>\n    <ng-content></ng-content>\n  </span>\n</ng-template>\n", styles: [".tag:focus{outline:0}.tag-container{display:flex;align-items:center}.tag{display:flex;align-items:center;justify-content:space-between;text-align:center;min-width:54px;max-width:328px;height:32px;padding:0 12px;border-radius:16px;background:transparent;cursor:default}.tag__icon__container{display:flex;margin-left:6px}.tag__icon{width:16px;height:16px;display:flex;align-items:center;fill:currentColor}.tag__icon svg{fill:currentColor;width:inherit;height:inherit}.tag__icon svg g{fill:currentColor;width:inherit;height:inherit}.tag__icon svg text{font-family:Siemens Sans,sans-serif}.tag__text{font-size:1rem;font-weight:400;line-height:1.5rem;white-space:nowrap;overflow:hidden;text-overflow:ellipsis;position:relative;width:100%}.tag.condensed{height:24px;padding:0 10px;border-radius:14px}.tag.condensed .tag__text{font-size:.875rem;font-weight:400;line-height:1.25rem}.tag.mode-unselected,.tag.mode-interactive-without-icon{border:1px solid #007993;color:#007993;fill:#007993}.tag.mode-unselected:hover,.tag.mode-unselected:active,.tag.mode-interactive-without-icon:hover,.tag.mode-interactive-without-icon:active{background-color:#c2ffee;border:1px solid #00646e;color:#33747a;fill:#33747a;cursor:pointer}.tag.mode-unselected.theme-dark,.tag.mode-interactive-without-icon.theme-dark{background-color:#000028;border:1px solid #0cc;color:#0cc;fill:#0cc}.tag.mode-unselected.theme-dark:hover,.tag.mode-unselected.theme-dark:active,.tag.mode-interactive-without-icon.theme-dark:hover,.tag.mode-interactive-without-icon.theme-dark:active{background-color:#001f39;border:1px solid #00ffb9;color:#00ffb9;fill:#00ffb9}.tag.mode-noninteractive,.tag.mode-selected,.tag.mode-removable{border:1px solid #33747a;background-color:#33747a;color:#fff;fill:#fff}.tag.mode-noninteractive.theme-dark,.tag.mode-selected.theme-dark,.tag.mode-removable.theme-dark{color:#000028;fill:#000028;border:1px solid #00ffb9;background-color:#00ffb9}@media print{.tag.mode-noninteractive,.tag.mode-selected,.tag.mode-removable{background-color:unset;border-color:#9999a9;color:#000028}}.tag.mode-selected:hover,.tag.mode-selected:active,.tag.mode-removable:hover,.tag.mode-removable:active{color:#33747a;fill:#33747a;background-color:#c2ffee;border:1px solid #00646e;cursor:pointer}.tag.mode-selected.theme-dark:hover,.tag.mode-selected.theme-dark:active,.tag.mode-removable.theme-dark:hover,.tag.mode-removable.theme-dark:active{color:#00ffb9;fill:#00ffb9;background-color:#001f39;border:1px solid #00ffb9}.tag:focus{position:relative}.tag:focus:before{content:\"\";position:absolute;inset:-4px;z-index:1;border:1px solid #1491eb;border-radius:18px}.tag:focus-visible:before{content:\"\";position:absolute;inset:-4px;z-index:1;border:1px solid #1491eb;border-radius:18px}.tag.mode-noninteractive:focus:before,.tag.mode-noninteractive:focus-visible:before{border:none}.tag.status{height:24px;padding:0 10px;border-radius:14px}.tag.status-error{background:#ef0137;color:#fff}.tag.status-warning{background:#ffd732;color:#fff}.tag.status-success{background:#00af52;color:#fff}.tag.status-neutral{background:#7d8099;color:#fff}.tag.status-category-a{background:#005159;color:#fff}.tag.status-category-a.theme-dark{background:#00d7a0}.tag.status-category-b{background:#ec6602;color:#fff}.tag.status-category-b.theme-dark{background:#ff9000}.tag.status-category-c{background:#00557c;color:#fff}.tag.status-category-c.theme-dark{background:#00bedc}.tag.status-category-d{background:#500078;color:#fff}.tag.status-category-d.theme-dark{background:#aa32be}.tag.status-category-e{background:#f3f3f0;color:#000028}.tag.status.cropped-top{border-top-left-radius:0;border-top-right-radius:0}.tag.status .tag__text{font-size:.875rem;font-weight:400;line-height:1.25rem}.tag.disabled.mode-noninteractive,.tag.disabled.mode-selected,.tag.disabled.mode-removable,.tag:disabled.mode-noninteractive,.tag:disabled.mode-selected,.tag:disabled.mode-removable{color:#ebebee;fill:#ebebee;background-color:#b3b3be;border:1px solid #b3b3be}.tag.disabled.mode-noninteractive.theme-dark,.tag.disabled.mode-selected.theme-dark,.tag.disabled.mode-removable.theme-dark,.tag:disabled.mode-noninteractive.theme-dark,.tag:disabled.mode-selected.theme-dark,.tag:disabled.mode-removable.theme-dark{color:#b3b3be;fill:#b3b3be;background-color:#737389;border:1px solid #737389}.tag.disabled.mode-unselected,.tag.disabled.mode-interactive-without-icon,.tag:disabled.mode-unselected,.tag:disabled.mode-interactive-without-icon{color:#b3b3be;fill:#b3b3be;background-color:transparent;border:1px solid #b3b3be}.tag.disabled.mode-unselected.theme-dark,.tag.disabled.mode-interactive-without-icon.theme-dark,.tag:disabled.mode-unselected.theme-dark,.tag:disabled.mode-interactive-without-icon.theme-dark{color:#b3b3be;fill:#b3b3be;background-color:transparent;border:1px solid #b3b3be}.tag.disabled.mode-selected,.tag.disabled.mode-removable,.tag.disabled.mode-unselected,.tag.disabled.mode-interactive-without-icon,.tag:disabled.mode-selected,.tag:disabled.mode-removable,.tag:disabled.mode-unselected,.tag:disabled.mode-interactive-without-icon{cursor:not-allowed}.tag:focus:not(:focus-visible):before{border:none}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }]; }, propDecorators: { tagButton: [{
                type: ViewChild,
                args: ['tagButton']
            }], mode: [{
                type: Input
            }], theme: [{
                type: Input
            }], status: [{
                type: Input
            }], tagId: [{
                type: Input
            }], dataAttrName: [{
                type: Input
            }], dataAttrValue: [{
                type: Input
            }], disabled: [{
                type: Input
            }], croppedTop: [{
                type: Input
            }], condensed: [{
                type: Input
            }], linkable: [{
                type: Input
            }], removeButtonAriaLabel: [{
                type: Input
            }], selected: [{
                type: Output
            }], unselected: [{
                type: Output
            }], removed: [{
                type: Output
            }], clicked: [{
                type: Output
            }] } });

/**
 * # Tag Module
 * - {@link UiTagComponent}
 *
 * ## Module peer dependencies
 * - {@link SieIconsModule}
 */
class UiTagModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTagModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiTagModule, declarations: [UiTagComponent], imports: [CommonModule, SieIconsModule, DataAttributeModule], exports: [UiTagComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTagModule, imports: [CommonModule, SieIconsModule, DataAttributeModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTagModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiTagComponent],
                    imports: [CommonModule, SieIconsModule, DataAttributeModule],
                    exports: [UiTagComponent]
                }]
        }] });

/**
 * @enum {string}
 * Spinner size types
 * - `xs` extra small size
 * - `s` small size
 * - `m` medium size
 * - `l` large size
 */
var UiSpinnerSize;
(function (UiSpinnerSize) {
    UiSpinnerSize["extraSmall"] = "xs";
    UiSpinnerSize["small"] = "s";
    UiSpinnerSize["medium"] = "m";
    UiSpinnerSize["large"] = "l";
})(UiSpinnerSize || (UiSpinnerSize = {}));
/** @ignore */
const PROGRESS_SPINNER_DEFAULT_STROKE = 4;
/** @ignore */
const PROGRESS_SPINNER_MAX_PERCENTAGE = 100;
/** @ignore */
const PROGRESS_SPINNER_STROKE_SIZE = {
    s: 3,
    m: 4,
    l: 4
};
/** @ignore */
const PROGRESS_SPINNER_SIZE = {
    s: 24,
    m: 32,
    l: 64
};

class UiBaseButtonDirective {
    /**
     * @param buttonType Defines the {@link UiButtonType type of the button}.
     * @default 'button'
     */
    set buttonType(buttonType) {
        this._buttonType = buttonType;
        this.isButton = buttonType !== 'link';
    }
    get buttonType() {
        return this._buttonType;
    }
    /**
     * @param value Defines if the button has increased size.
     * @default false
     */
    set increasedSize(value) {
        this._increasedSize = coerceBooleanProperty(value);
    }
    get increasedSize() {
        return this._increasedSize;
    }
    /**
     * @param value Defines if the line break should be disabled.
     * @default true
     */
    set disableLineBreak(value) {
        if (this.themeType === 'un-contained') {
            this._disableLineBreak = true;
        }
        else {
            this._disableLineBreak = coerceBooleanProperty(value);
        }
    }
    get disableLineBreak() {
        return this._disableLineBreak;
    }
    /**
     * @param value Defines if the button is disabled.
     * @default false
     */
    set disabled(value) {
        this._disabled = coerceBooleanProperty(value);
    }
    get disabled() {
        return this._disabled;
    }
    /**
     * @param value Defines if the button has a badge.
     * @default false
     */
    set badge(value) {
        this._badge = coerceBooleanProperty(value);
    }
    get badge() {
        return this._badge;
    }
    /**
     * @param value Defines the numeral value inside the badge (applicable only if the badge is set to true).
     */
    set badgeNumber(value) {
        this._badgeNumber = coerceNumberProperty(value);
    }
    get badgeNumber() {
        return this._badgeNumber;
    }
    /**
     * @param value Defines if the text inside the button is bold.
     * @default true
     */
    set bold(value) {
        this._bold = coerceBooleanProperty(value);
    }
    get bold() {
        return this._bold;
    }
    /**
     * @param value Defines if the button is focusable.
     * @default true
     */
    set focusable(value) {
        this._focusable = coerceBooleanProperty(value);
    }
    get focusable() {
        return this._focusable;
    }
    /**
     * @param value Defines if the hovering over button is disabled.
     * @default false
     */
    set hoverDisabled(value) {
        this._hoverDisabled = coerceBooleanProperty(value);
    }
    get hoverDisabled() {
        return this._hoverDisabled;
    }
    /**
     * @param value Add additional attributes to the button component (e.g.: for tracking).
     */
    set dataAttributes(value) {
        this._dataAttributes = value;
    }
    get dataAttributes() {
        return this._dataAttributes;
    }
    /**
     * @param fullWidth Defines if the button has full width.
     * @default false
     */
    set fullWidth(fullWidth) {
        this._fullWidth = coerceBooleanProperty(fullWidth);
    }
    get fullWidth() {
        return this._fullWidth;
    }
    /**
     * @param withSpinner Defines if the button should have a spinner.
     * @default false
     */
    set withSpinner(withSpinner) {
        this._withSpinner = coerceBooleanProperty(withSpinner);
        this.setSpinnerDimensions();
    }
    get withSpinner() {
        return this._withSpinner;
    }
    /**
     * @param icon Defines which icon should be shown inside the button.
     */
    set icon(icon) {
        if (icon) {
            this.iconReg.register(icon);
        }
        this._icon = icon;
    }
    get icon() {
        return this._icon;
    }
    /**
     * @param iconSecondary Adds secondary icon after the button text.
     */
    set iconSecondary(iconSecondary) {
        if (iconSecondary) {
            this.iconReg.register(iconSecondary);
        }
        this._iconSecondary = iconSecondary;
    }
    get iconSecondary() {
        return this._iconSecondary;
    }
    /**
     * @param showSpinner Defines if the spinner should be shown.
     * @default false
     */
    set showSpinner(showSpinner) {
        this._showSpinner = coerceBooleanProperty(showSpinner) && this._withSpinner;
        if (this._showSpinner) {
            this._spinnerAnimating = true;
            this._shouldFadeOutText = true;
        }
    }
    get showSpinner() {
        return this._showSpinner;
    }
    constructor(cdr, iconReg) {
        this.cdr = cdr;
        this.iconReg = iconReg;
        /**
         * Defines where the link should be opened if the button type is `link`.
         * @default '_self'
         */
        this.target = '_self';
        /**
         * Defines the {@link UiButtonThemeType theme type} of the button.
         * @default 'main'
         */
        this.themeType = 'main';
        /**
         * Defines the {@link UiButtonVariant variant} of the button.
         * @default 'primary'
         */
        this.variant = 'primary';
        /**
         * Defines the {@link UiButtonPosition position} of where the button is placed.
         * @default 'content'
         */
        this.position = 'content';
        /**
         * Defines on which {@link ThemeVariant background} the button is placed.
         * @default 'light'
         */
        this.background = 'light';
        /**
         * Defines the {@link UiButtonIconPosition position of the icon} within the button.
         * @default 'leading'
         */
        this.iconPosition = 'leading';
        /**
         * Sets the screen reader text for the icon.
         * @default ''
         */
        this.iconScreenReaderText = '';
        /**
         * Sets the custom css class on the button element. To add multiple classes provide the string with the whitespace
         * between classes, e.g.: `class-a class-b`.
         * @default ''
         */
        this.cssClass = '';
        /**
         * Allows for the secondary icon to rotate on the button click.
         * @default false
         */
        this.isSecondaryIconRotated = false;
        /**
         * Event triggered when the button is clicked.
         */
        this.clicked = new Subject();
        /**
         * Event triggered when the button is focused.
         */
        this.focused = new Subject();
        /**
         * Event triggered when the button is blurred.
         */
        this.blurred = new Subject();
        /** @ignore */
        this.isButton = true;
        /** @ignore */
        this.dimensionsSet = false;
        this.viewInitialized = false;
        this._withSpinner = false;
        this._showSpinner = false;
        this._spinnerAnimating = false;
        this._shouldFadeOutText = false;
        this._fullWidth = false;
        this._buttonType = 'button';
        this._increasedSize = false;
        this._disableLineBreak = true;
        this._disabled = false;
        this._badge = false;
        this._bold = true;
        this._focusable = true;
        this._hoverDisabled = false;
    }
    /**
     * Readonly property containing information if the spinner on the button is animating.
     */
    get spinnerAnimating() {
        return this._spinnerAnimating;
    }
    /**
     * Readonly property containing information if the text on the button should fade out.
     */
    get shouldFadeOutText() {
        return this._shouldFadeOutText;
    }
    /**
     * Readonly property containing information on the width of the button with active spinner.
     */
    get buttonWithSpinnerWidth() {
        return this._buttonWithSpinnerWidth;
    }
    /** @ignore */
    get spinnerSize() {
        return UiSpinnerSize.small;
    }
    /** @ignore */
    ngAfterViewInit() {
        this.viewInitialized = true;
        if (!this.dimensionsSet) {
            this.setSpinnerDimensions();
            this.dimensionsSet = true;
        }
    }
    /** @ignore */
    onClick(event) {
        this.clicked.next(event);
    }
    /**
     * Focuses the button.
     */
    focusButton() {
        this.buttonElement.nativeElement.focus();
    }
    /** @ignore */
    onFocus(event) {
        this.focused.next(event);
    }
    /** @ignore */
    onBlur(event) {
        this.blurred.next(event);
    }
    /** @ignore */
    onAnimationEnd() {
        this._spinnerAnimating = false;
        this.cdr.detectChanges();
    }
    setSpinnerDimensions() {
        if (this.viewInitialized && this._withSpinner && this.themeType !== 'icon') {
            this._buttonWithSpinnerWidth =
                this.buttonElement.nativeElement.offsetWidth + parseFloat(ComponentButtonsMainSpinnerSpacing);
            this._shouldFadeOutText = this.buttonWithSpinnerWidth > parseFloat(ComponentButtonsMainMaxWidth);
        }
        else {
            this._buttonWithSpinnerWidth = null;
            this._shouldFadeOutText = false;
        }
    }
    /** @ignore */
    getIconClasses() {
        return [];
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiBaseButtonDirective, deps: [{ token: i0.ChangeDetectorRef }, { token: i1.SieIconRegistryService }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: UiBaseButtonDirective, inputs: { link: "link", target: "target", themeType: "themeType", variant: "variant", position: "position", background: "background", prominence: "prominence", iconPosition: "iconPosition", iconScreenReaderText: "iconScreenReaderText", cssClass: "cssClass", isSecondaryIconRotated: "isSecondaryIconRotated", buttonType: "buttonType", increasedSize: "increasedSize", disableLineBreak: "disableLineBreak", disabled: "disabled", badge: "badge", badgeNumber: "badgeNumber", bold: "bold", focusable: "focusable", hoverDisabled: "hoverDisabled", dataAttributes: "dataAttributes", fullWidth: "fullWidth", withSpinner: "withSpinner", icon: "icon", iconSecondary: "iconSecondary", showSpinner: "showSpinner" }, outputs: { clicked: "clicked", focused: "focused", blurred: "blurred" }, host: { properties: { "class.full-width": "this.fullWidth" } }, viewQueries: [{ propertyName: "buttonElement", first: true, predicate: ["uiButton"], descendants: true }], ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiBaseButtonDirective, decorators: [{
            type: Directive
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i1.SieIconRegistryService }]; }, propDecorators: { buttonElement: [{
                type: ViewChild,
                args: ['uiButton']
            }], link: [{
                type: Input
            }], target: [{
                type: Input
            }], themeType: [{
                type: Input
            }], variant: [{
                type: Input
            }], position: [{
                type: Input
            }], background: [{
                type: Input
            }], prominence: [{
                type: Input
            }], iconPosition: [{
                type: Input
            }], iconScreenReaderText: [{
                type: Input
            }], cssClass: [{
                type: Input
            }], isSecondaryIconRotated: [{
                type: Input
            }], buttonType: [{
                type: Input
            }], increasedSize: [{
                type: Input
            }], disableLineBreak: [{
                type: Input
            }], disabled: [{
                type: Input
            }], badge: [{
                type: Input
            }], badgeNumber: [{
                type: Input
            }], bold: [{
                type: Input
            }], focusable: [{
                type: Input
            }], hoverDisabled: [{
                type: Input
            }], dataAttributes: [{
                type: Input
            }], fullWidth: [{
                type: HostBinding,
                args: ['class.full-width']
            }, {
                type: Input
            }], withSpinner: [{
                type: Input
            }], icon: [{
                type: Input
            }], iconSecondary: [{
                type: Input
            }], showSpinner: [{
                type: Input
            }], clicked: [{
                type: Output
            }], focused: [{
                type: Output
            }], blurred: [{
                type: Output
            }] } });

/**
 * # Spinner Component
 *
 * Spinner is used to indicate the processing of a user action.
 *
 * ## Component variations
 *
 * There are no variations
 *
 * ## Content
 *
 * The spinner component does not accept any content.
 *
 * ## Code example
 *
 * @example ```html
 * <sie-ui-spinner
 *  [active]="true"
 *  [message]="'Loading...'"
 *  [size]="'m'"
 *  (animationEnded)="closeSpinner()"
 * ></sie-ui-spinner>
 * ```
 */
class UiSpinnerComponent {
    constructor() {
        /**
         * Defines {@link UiSpinnerSize size} of spinner
         * @default 's'
         */
        this.size = UiSpinnerSize.small;
        /**
         * Triggered when the animation of the spinner ended
         */
        this.animationEnded = new Subject();
        this._overlayOnTop = true;
        this._active = false;
        this._animationIsRunning = false;
    }
    /**
     * @param overlayOnTop Indication whether a spinner's overlay should be covering the whole page (default) or just the container
     * @default true
     */
    set overlayOnTop(value) {
        this._overlayOnTop = coerceBooleanProperty(value);
    }
    get overlayOnTop() {
        return this._overlayOnTop;
    }
    /**
     * @param overlay indication whether a spinner is positioned inside an overlay
     * @default false
     */
    set overlay(overlay) {
        this._overlay = coerceBooleanProperty(overlay);
    }
    get overlay() {
        return this._overlay;
    }
    /**
     * @param active whether a spinner should be visible or not
     * @default false
     */
    set active(active) {
        this._active = coerceBooleanProperty(active);
        if (active) {
            this._animationIsRunning = true;
        }
    }
    get active() {
        return this._active;
    }
    /**
     * Defines whether the animation is still running or not
     */
    get animationIsRunning() {
        return this._animationIsRunning;
    }
    /** @ignore */
    onAnimationEnd(event) {
        if (event.animationName.toLowerCase().includes('fadeout')) {
            this._animationIsRunning = false;
            this.animationEnded.next();
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiSpinnerComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiSpinnerComponent, selector: "sie-ui-spinner", inputs: { size: "size", message: "message", overlayOnTop: "overlayOnTop", overlay: "overlay", active: "active" }, outputs: { animationEnded: "animationEnded" }, ngImport: i0, template: "<ng-container *ngIf=\"active || animationIsRunning\">\n  <div class=\"spinner-wrapper\" *ngIf=\"overlay; else spinner\" [ngClass]=\"{ 'overlay-on-top': overlayOnTop }\">\n    <ng-template [ngTemplateOutlet]=\"spinner\"></ng-template>\n  </div>\n</ng-container>\n\n<ng-template #spinner>\n  <div\n    class=\"spinner\"\n    [class.sp-fade-in]=\"active && animationIsRunning\"\n    [class.sp-fade-out]=\"!active && animationIsRunning\"\n    (animationend)=\"onAnimationEnd($event)\"\n  >\n    <div class=\"sp sp-circle\" [ngClass]=\"'sp-' + size\"></div>\n    <span *ngIf=\"message\" class=\"message\">{{ message }}</span>\n  </div>\n</ng-template>\n", styles: [".spinner{display:inline-block;vertical-align:middle;text-align:center}.spinner .sp{clear:both;margin:auto}.spinner .sp-xs{width:14px;height:14px}.spinner .sp-s{width:24px;height:24px}.spinner .sp-m{width:32px;height:32px}.spinner .sp-l{width:64px;height:64px}.spinner .sp-circle{border:4px solid #ccccd4;border-top-color:#00557c;border-radius:50%;animation:sp-circle-rotation 1s infinite linear}.spinner .sp-circle.sp-xs{border-width:2px}.spinner .sp-circle.sp-s{border-width:3px}.spinner-wrapper{position:absolute;top:0;left:0;width:100%;height:100%;display:flex;align-items:center;justify-content:center;background:rgba(255,255,255,.95);z-index:900}.spinner-wrapper.overlay-on-top{z-index:1000}.spinner .message{font-size:.875rem;font-weight:400;line-height:1.25rem}.sp-fade-in{animation:fadein .25s cubic-bezier(0,0,.38,.9)}.sp-fade-out{animation:fadeout .25s cubic-bezier(.35,0,1,.9)}@keyframes sp-circle-rotation{0%{transform:rotate(0)}to{transform:rotate(359deg)}}@keyframes fadein{0%{opacity:0}to{opacity:1}}@keyframes fadeout{0%{opacity:1}to{opacity:0}}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiSpinnerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-spinner', changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-container *ngIf=\"active || animationIsRunning\">\n  <div class=\"spinner-wrapper\" *ngIf=\"overlay; else spinner\" [ngClass]=\"{ 'overlay-on-top': overlayOnTop }\">\n    <ng-template [ngTemplateOutlet]=\"spinner\"></ng-template>\n  </div>\n</ng-container>\n\n<ng-template #spinner>\n  <div\n    class=\"spinner\"\n    [class.sp-fade-in]=\"active && animationIsRunning\"\n    [class.sp-fade-out]=\"!active && animationIsRunning\"\n    (animationend)=\"onAnimationEnd($event)\"\n  >\n    <div class=\"sp sp-circle\" [ngClass]=\"'sp-' + size\"></div>\n    <span *ngIf=\"message\" class=\"message\">{{ message }}</span>\n  </div>\n</ng-template>\n", styles: [".spinner{display:inline-block;vertical-align:middle;text-align:center}.spinner .sp{clear:both;margin:auto}.spinner .sp-xs{width:14px;height:14px}.spinner .sp-s{width:24px;height:24px}.spinner .sp-m{width:32px;height:32px}.spinner .sp-l{width:64px;height:64px}.spinner .sp-circle{border:4px solid #ccccd4;border-top-color:#00557c;border-radius:50%;animation:sp-circle-rotation 1s infinite linear}.spinner .sp-circle.sp-xs{border-width:2px}.spinner .sp-circle.sp-s{border-width:3px}.spinner-wrapper{position:absolute;top:0;left:0;width:100%;height:100%;display:flex;align-items:center;justify-content:center;background:rgba(255,255,255,.95);z-index:900}.spinner-wrapper.overlay-on-top{z-index:1000}.spinner .message{font-size:.875rem;font-weight:400;line-height:1.25rem}.sp-fade-in{animation:fadein .25s cubic-bezier(0,0,.38,.9)}.sp-fade-out{animation:fadeout .25s cubic-bezier(.35,0,1,.9)}@keyframes sp-circle-rotation{0%{transform:rotate(0)}to{transform:rotate(359deg)}}@keyframes fadein{0%{opacity:0}to{opacity:1}}@keyframes fadeout{0%{opacity:1}to{opacity:0}}\n"] }]
        }], propDecorators: { size: [{
                type: Input
            }], message: [{
                type: Input
            }], overlayOnTop: [{
                type: Input
            }], overlay: [{
                type: Input
            }], active: [{
                type: Input
            }], animationEnded: [{
                type: Output
            }] } });

/** @ignore */
const digitChangeAnimation = trigger('digitChange', [
    transition('* => true', [
        animate('.2s ' + EasingStandardProductive, keyframes([style({ width: '{{width}}px' }), style({ width: '*' })]))
    ])
]);

/** @ignore */
const BADGE_ICON_MAPPING = {
    success: SieIcon.SuccessFilled,
    warning: SieIcon.WarningFilled,
    error: SieIcon.ErrorFilled,
    info: SieIcon.InformationFilled
};

/**
 * # Badge component
 *
 * Badges are used to notify the user about the change in a status of item.
 *
 * ## Component variations
 *
 * - Dot badge
 * - Icon badge
 * - Number badge
 *
 * ## Content
 *
 * The badge component does not accept any content.
 *
 * ## Code example
 * @example ```html
 * <sie-ui-badge [type]="'dot'" [status]="'error'" [mode]="'light'"></sie-ui-badge>
 * <sie-ui-badge [type]="'icon'" [status]="'success'"></sie-ui-badge>
 * <sie-ui-badge [type]="'counter'" [number]="9"></sie-ui-badge>
 * ```
 */
class UiBadgeComponent {
    /**
     * @param num Present the current value for the badge. Parameter is applicable only when type = `counter`.
     */
    set number(num) {
        this._number = coerceNumberProperty(num);
        const newValue = this.getNewValue(this._number);
        if (!this.value) {
            this.value = newValue;
        }
        else if (this.value && this.value !== newValue) {
            // not the initial value anymore
            this.initialValue = false;
            // store the old value
            this.oldValue = this.value;
            // temporarily remove current value (fade it out)
            this.value = '';
            // set new and check digit change
            this.value = newValue;
            this.checkDigitChange();
        }
        this.hide = false;
    }
    get number() {
        return this._number;
    }
    /**
     * @param value When it is true a border is applied for the badge. Parameter is applicable only when type = `counter`.
     * @default false
     */
    set addOutline(value) {
        this._addOutline = coerceBooleanProperty(value);
    }
    get addOutline() {
        return this._addOutline;
    }
    /**
     * @param value  When it is true the background is changed for the badge. Parameter is applicable only when type = `counter`.
     * @default false
     */
    set highlighted(value) {
        this._highlighted = coerceBooleanProperty(value);
    }
    get highlighted() {
        return this._highlighted;
    }
    /**
     * @param status Defines the {@link BadgeStatus} of the badge. Parameter is applicable only when type = `icon`.
     */
    set status(status) {
        if (status) {
            this._status = status;
            this._icon = BADGE_ICON_MAPPING[status];
            this.iconReg.register(this._icon);
        }
    }
    get status() {
        return this._status;
    }
    get iconName() {
        return this._icon;
    }
    constructor(iconReg) {
        this.iconReg = iconReg;
        /**
         * {@link ThemeVariant Theme} of the badge.
         * @default 'light'
         */
        this.mode = 'light';
        /** @ignore */
        this.oldValue = '';
        /** @ignore */
        this.initialValue = true;
        /** @ignore */
        this.hide = false;
        /** @ignore */
        this.digitChange = false;
        this._addOutline = false;
        this._highlighted = false;
        iconReg.register(SieIcon.ArrowUp);
        iconReg.register(SieIcon.ArrowDown);
        iconReg.register(SieIcon.ArrowRight);
    }
    /** @ignore */
    onAnimationEnd(event) {
        if (event.animationName.toLowerCase().includes('disappear')) {
            this.hide = true;
        }
        else if (event.animationName.toLowerCase().includes('fadeout') && this.oldValue !== '') {
            this.oldValue = '';
        }
    }
    /** @ignore */
    onDigitChange() {
        this.digitChange = false;
    }
    checkDigitChange() {
        this.widthBeforeDigitChange = this.badge?.nativeElement.getBoundingClientRect().width;
        requestAnimationFrame(() => {
            this.digitChange = this.oldValue && this.value.length !== this.oldValue.length;
        });
    }
    getNewValue(num) {
        // max number display
        if (num >= UIConstants.COUNT_LIMIT) {
            return UIConstants.COUNT_EXCEEDED_PLACEHOLDER;
        }
        // min number display
        else if (num >= 1) {
            return num.toString();
        }
        return '';
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiBadgeComponent, deps: [{ token: i1.SieIconRegistryService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiBadgeComponent, selector: "sie-ui-badge", inputs: { mode: "mode", type: "type", number: "number", addOutline: "addOutline", highlighted: "highlighted", status: "status" }, viewQueries: [{ propertyName: "badge", first: true, predicate: ["badge"], descendants: true }], ngImport: i0, template: "<span\n  *ngIf=\"type !== 'counter'; else counter\"\n  class=\"badge appear\"\n  [ngClass]=\"['badge--' + type, mode ? mode : '', status ? status : '']\"\n>\n  <sie-icon *ngIf=\"type === 'icon'\" svgClass=\"badge--icon__svg\" [name]=\"iconName\"></sie-icon>\n</span>\n\n<ng-template #counter>\n  <span\n    *ngIf=\"!hide\"\n    #badge\n    class=\"badge\"\n    [@digitChange]=\"{ value: digitChange, params: { width: widthBeforeDigitChange } }\"\n    (@digitChange.done)=\"onDigitChange()\"\n    [ngClass]=\"[\n      'badge--' + this.type,\n      mode,\n      value !== '' ? 'appear' : 'disappear',\n      addOutline ? 'outline' : '',\n      highlighted ? 'highlighted' : ''\n    ]\"\n    (animationend)=\"onAnimationEnd($event)\"\n  >\n    <span *ngIf=\"oldValue\" class=\"badge--counter__number fade-out\">{{ oldValue }}</span>\n    <span\n      *ngIf=\"!oldValue\"\n      class=\"badge--counter__number\"\n      [ngClass]=\"{\n        'fade-out': value === '',\n        'fade-in-initial': initialValue,\n        'fade-in': !initialValue\n      }\"\n      >{{ value }}</span\n    >\n  </span>\n</ng-template>\n", styles: [".badge{display:inline-flex;align-items:center;margin-left:4px}.badge.appear{animation:appear .1s cubic-bezier(0,0,.38,.9)}.badge.disappear{animation:disappear .1s cubic-bezier(.35,0,1,.9)}.badge--dot{width:8px;height:8px;border-radius:50%}.badge--dot.error{background:#ef0137}.badge--dot.warning{background:#ff9000}.badge--dot.success{background:#00af52}.badge--dot.info{background:#00557c}.badge--dot.dark.info{background:#e0f1f4}.badge--icon.error{color:#ef0137}.badge--icon.warning{color:#ff9000}.badge--icon.success{color:#00af52}.badge--icon.info{color:#00557c}.badge--icon__svg{width:16px;height:16px;display:flex;align-items:center;fill:currentColor}.badge--icon__svg svg{fill:currentColor;width:inherit;height:inherit}.badge--icon__svg svg g{fill:currentColor;width:inherit;height:inherit}.badge--icon__svg svg text{font-family:Siemens Sans,sans-serif}.badge--counter{padding:0 4px;border-radius:7px;min-width:14px;height:14px;background-color:#7d8099;color:#fff}.badge--counter.outline{outline:1px solid #fff}.badge--counter__number{font-size:.6875rem;font-weight:700;line-height:.9375rem;letter-spacing:.0125rem;letter-spacing:.2px;text-align:center}.badge--counter__number.fade-in{animation:fadein .24s cubic-bezier(0,0,.38,.9)}.badge--counter__number.fade-in-initial{animation:fadein-initial .2s cubic-bezier(0,0,.38,.9)}.badge--counter__number.fade-out{animation:fadeout .1s cubic-bezier(.2,0,.38,.9)}.badge--counter.appear{animation:appear .15s cubic-bezier(0,0,.38,.9)}.badge--counter.disappear{animation:disappear .15s cubic-bezier(.35,0,1,.9)}.badge--counter.dark{background-color:#e5e5e9;color:#000028}.badge--counter.highlighted{background-color:#33747a}@keyframes fadein{0%,58%{opacity:0}to{opacity:1}}@keyframes fadein-initial{0%,50%{opacity:0}to{opacity:1}}@keyframes fadeout{0%{opacity:1}to{opacity:0}}@keyframes appear{0%{transform:scale(0)}to{transform:scale(1)}}@keyframes disappear{0%{transform:scale(1)}to{transform:scale(0)}}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }], animations: [digitChangeAnimation], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiBadgeComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-badge', changeDetection: ChangeDetectionStrategy.OnPush, animations: [digitChangeAnimation], template: "<span\n  *ngIf=\"type !== 'counter'; else counter\"\n  class=\"badge appear\"\n  [ngClass]=\"['badge--' + type, mode ? mode : '', status ? status : '']\"\n>\n  <sie-icon *ngIf=\"type === 'icon'\" svgClass=\"badge--icon__svg\" [name]=\"iconName\"></sie-icon>\n</span>\n\n<ng-template #counter>\n  <span\n    *ngIf=\"!hide\"\n    #badge\n    class=\"badge\"\n    [@digitChange]=\"{ value: digitChange, params: { width: widthBeforeDigitChange } }\"\n    (@digitChange.done)=\"onDigitChange()\"\n    [ngClass]=\"[\n      'badge--' + this.type,\n      mode,\n      value !== '' ? 'appear' : 'disappear',\n      addOutline ? 'outline' : '',\n      highlighted ? 'highlighted' : ''\n    ]\"\n    (animationend)=\"onAnimationEnd($event)\"\n  >\n    <span *ngIf=\"oldValue\" class=\"badge--counter__number fade-out\">{{ oldValue }}</span>\n    <span\n      *ngIf=\"!oldValue\"\n      class=\"badge--counter__number\"\n      [ngClass]=\"{\n        'fade-out': value === '',\n        'fade-in-initial': initialValue,\n        'fade-in': !initialValue\n      }\"\n      >{{ value }}</span\n    >\n  </span>\n</ng-template>\n", styles: [".badge{display:inline-flex;align-items:center;margin-left:4px}.badge.appear{animation:appear .1s cubic-bezier(0,0,.38,.9)}.badge.disappear{animation:disappear .1s cubic-bezier(.35,0,1,.9)}.badge--dot{width:8px;height:8px;border-radius:50%}.badge--dot.error{background:#ef0137}.badge--dot.warning{background:#ff9000}.badge--dot.success{background:#00af52}.badge--dot.info{background:#00557c}.badge--dot.dark.info{background:#e0f1f4}.badge--icon.error{color:#ef0137}.badge--icon.warning{color:#ff9000}.badge--icon.success{color:#00af52}.badge--icon.info{color:#00557c}.badge--icon__svg{width:16px;height:16px;display:flex;align-items:center;fill:currentColor}.badge--icon__svg svg{fill:currentColor;width:inherit;height:inherit}.badge--icon__svg svg g{fill:currentColor;width:inherit;height:inherit}.badge--icon__svg svg text{font-family:Siemens Sans,sans-serif}.badge--counter{padding:0 4px;border-radius:7px;min-width:14px;height:14px;background-color:#7d8099;color:#fff}.badge--counter.outline{outline:1px solid #fff}.badge--counter__number{font-size:.6875rem;font-weight:700;line-height:.9375rem;letter-spacing:.0125rem;letter-spacing:.2px;text-align:center}.badge--counter__number.fade-in{animation:fadein .24s cubic-bezier(0,0,.38,.9)}.badge--counter__number.fade-in-initial{animation:fadein-initial .2s cubic-bezier(0,0,.38,.9)}.badge--counter__number.fade-out{animation:fadeout .1s cubic-bezier(.2,0,.38,.9)}.badge--counter.appear{animation:appear .15s cubic-bezier(0,0,.38,.9)}.badge--counter.disappear{animation:disappear .15s cubic-bezier(.35,0,1,.9)}.badge--counter.dark{background-color:#e5e5e9;color:#000028}.badge--counter.highlighted{background-color:#33747a}@keyframes fadein{0%,58%{opacity:0}to{opacity:1}}@keyframes fadein-initial{0%,50%{opacity:0}to{opacity:1}}@keyframes fadeout{0%{opacity:1}to{opacity:0}}@keyframes appear{0%{transform:scale(0)}to{transform:scale(1)}}@keyframes disappear{0%{transform:scale(1)}to{transform:scale(0)}}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }]; }, propDecorators: { badge: [{
                type: ViewChild,
                args: ['badge']
            }], mode: [{
                type: Input
            }], type: [{
                type: Input
            }], number: [{
                type: Input
            }], addOutline: [{
                type: Input
            }], highlighted: [{
                type: Input
            }], status: [{
                type: Input
            }] } });

/**
 * # Button component
 *
 * Buttons are used to trigger some kind of action such as submitting, deleting, showing or hiding the content.
 * They can also act as a link where they can get us to another page.
 *
 * ## Component variations
 *
 * Button type:
 * - button
 * - submit
 * - link
 *
 * Theme type:
 * - main (primary, secondary, tertiary)
 * - icon
 * - uncontained
 *
 * Additionally, there are variations with and without the spinner.
 *
 * ## Content
 *
 * The label of the button component can be any valid markup.
 * It will not be considered if button is of `icon` theme type.
 *
 * ## Code example
 * @example ```html
 * <h2>Regular button</h2>
 * <sie-ui-button>Primary Button</sie-ui-button>
 *
 * <h2>Icon button</h2>
 * <sie-ui-button
 *  theme-type="icon"
 *  variant="icon-un-contained"
 *  position="content"
 *  [icon]="'ShoppingCart'"
 *  background="dark"
 * ></sie-ui-button>
 *
 * <h2>Uncontained button</h2>
 * <sie-ui-button theme-type="un-contained">Uncontained Button</sie-ui-button>
 * ```
 */
class UiButtonComponent extends UiBaseButtonDirective {
    constructor(cdr, iconReg) {
        super(cdr, iconReg);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiButtonComponent, deps: [{ token: i0.ChangeDetectorRef }, { token: i1.SieIconRegistryService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiButtonComponent, selector: "sie-ui-button", usesInheritance: true, ngImport: i0, template: "<!-- BUTTON -->\n<ng-container *ngIf=\"isButton\">\n  <button\n    class=\"general-button\"\n    #uiButton\n    [sieCoreAttributes]=\"dataAttributes\"\n    [ngClass]=\"[\n      cssClass,\n      'type-' + themeType,\n      'variant-' + variant,\n      'bg-' + background,\n      'position-' + position,\n      prominence ? 'prominence-' + prominence : '',\n      fullWidth ? 'general-button--width' : 'general-button--max-width',\n      withSpinner ? 'with-spinner' : '',\n      showSpinner ? 'spinner-active' : '',\n      spinnerAnimating ? 'fade-appearance' : '',\n      shouldFadeOutText ? 'fade-text' : '',\n      !bold ? 'not-bold' : '',\n      increasedSize ? 'increased-size' : '',\n      hoverDisabled ? 'hover-disabled' : '',\n      disableLineBreak && !fullWidth ? 'disable-line-break-max-width' : ''\n    ]\"\n    [class.open]=\"isSecondaryIconRotated\"\n    [type]=\"this.buttonType.endsWith('submit') ? 'submit' : 'button'\"\n    (click)=\"onClick($event)\"\n    (focus)=\"onFocus($event)\"\n    [tabIndex]=\"this.focusable ? 0 : -1\"\n    (blur)=\"onBlur($event)\"\n    [disabled]=\"disabled || showSpinner ? 'disabled' : null\"\n    [ngStyle]=\"withSpinner && !fullWidth && !dimensionsSet ? { width: buttonWithSpinnerWidth + 'px' } : ''\"\n  >\n    <ng-container *ngTemplateOutlet=\"contentField\"></ng-container>\n  </button>\n</ng-container>\n\n<!-- EXTERNAL BUTTON (siemens internal and external links) --><a\n  *ngIf=\"!isButton\"\n  #uiButton\n  [sieCoreAttributes]=\"dataAttributes\"\n  [href]=\"link\"\n  [target]=\"target\"\n  class=\"general-button\"\n  rel=\"noopener\"\n  (click)=\"onClick($event)\"\n  [ngClass]=\"[\n    'type-' + themeType,\n    'variant-' + variant,\n    'bg-' + background,\n    'position-' + position,\n    prominence ? 'prominence-' + prominence : '',\n    cssClass,\n    disabled ? 'disabled' : '',\n    fullWidth ? 'general-button--width' : 'general-button--max-width',\n    withSpinner ? 'with-spinner' : '',\n    showSpinner ? 'spinner-active' : '',\n    spinnerAnimating ? 'fade-appearance' : '',\n    shouldFadeOutText ? 'fade-text' : ''\n  ]\"\n>\n  <ng-container *ngTemplateOutlet=\"contentField\"></ng-container>\n</a>\n\n<!-- CONTENT -->\n<ng-template #contentField>\n  <span class=\"general-button__body\" [ngClass]=\"{ 'has-spinner': withSpinner, 'has-secondary-icon': iconSecondary }\">\n    <sie-ui-badge\n      *ngIf=\"badge\"\n      class=\"general-button__badge\"\n      type=\"counter\"\n      [number]=\"badgeNumber\"\n      addOutline\n    ></sie-ui-badge>\n    <span class=\"general-button__label\">\n      <ng-container *ngIf=\"icon && iconPosition === 'leading'\">\n        <sie-icon [name]=\"icon\" class=\"general-button__icon\" [ngClass]=\"getIconClasses()\" aria-hidden=\"true\"></sie-icon>\n        <span *ngIf=\"iconScreenReaderText\" class=\"visually-hidden\">{{ iconScreenReaderText }}</span>\n      </ng-container>\n      <span class=\"general-button__label-content\" [ngClass]=\"{ 'disable-line-break': disableLineBreak }\"\n        ><ng-content></ng-content\n      ></span>\n      <ng-container *ngIf=\"icon && iconPosition === 'trailing'\">\n        <sie-icon [name]=\"icon\" class=\"general-button__icon\" [ngClass]=\"getIconClasses()\"></sie-icon>\n      </ng-container>\n      <ng-container *ngIf=\"iconSecondary\">\n        <sie-icon\n          [name]=\"iconSecondary\"\n          class=\"general-button__icon secondary-icon\"\n          [ngClass]=\"getIconClasses()\"\n          [class.open]=\"isSecondaryIconRotated\"\n        ></sie-icon>\n      </ng-container>\n      <ng-container *ngIf=\"showSpinner || spinnerAnimating\">\n        <div\n          class=\"general-button__spinner-wrapper\"\n          [ngClass]=\"{\n            'sp-fade-in': showSpinner,\n            'fade-out-text': shouldFadeOutText\n          }\"\n        >\n          <sie-ui-spinner\n            [size]=\"spinnerSize\"\n            [active]=\"showSpinner\"\n            (animationEnded)=\"onAnimationEnd()\"\n          ></sie-ui-spinner>\n        </div>\n      </ng-container>\n    </span>\n  </span>\n</ng-template>\n", styles: [":host .general-button{outline:none;outline-offset:0}@media (pointer: fine){:host .general-button{position:relative}:host .general-button:focus{outline:1px solid #1491eb;outline-offset:2px}:host .general-button:focus:not(:focus-visible){outline:0}:host .general-button:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}:host{display:inline-flex;position:relative;--icon-size-default: 24px;--btn-height-default: 48px;--btn-width-default: auto;outline:0}:host(.full-width){width:100%}.general-button.type-icon.variant-icon-contained .general-button__icon,.general-button.type-icon.variant-icon-un-contained .general-button__icon,.general-button.type-icon.variant-icon-menu .general-button__icon{margin:0}.increased-size.general-button.type-icon.variant-icon-contained.position-content,.increased-size.general-button.type-icon.variant-icon-contained.position-header,.increased-size.general-button.type-icon.variant-icon-un-contained,.increased-size.general-button.type-icon.variant-icon-with-label.position-content,.increased-size.general-button.type-icon.variant-icon-with-label.position-header,.increased-size.general-button{--btn-height-default: 56px;--icon-size-default: 28px;min-width:56px}.general-button{font-size:1rem;font-weight:900;line-height:1.5rem;--icon-size: var(--icon-size-custom, var(--icon-size-default));--btn-width: var(--btn-width-custom, var(--btn-width-default));--btn-height: var(--btn-height-custom, var(--btn-height-default));-webkit-user-drag:none;display:inline-flex;flex:1 1 0;align-items:center;justify-content:center;border-width:0;text-align:left;text-decoration:none;cursor:pointer;line-height:var(--icon-size);width:var(--btn-width);height:var(--btn-height)}@media print{.general-button{-webkit-print-color-adjust:exact;print-color-adjust:exact}}.general-button.disable-line-break-max-width{max-width:260px}.general-button__body{position:relative;display:flex;align-items:center;margin-right:0;transition:margin-right 1s ease-in-out}.general-button__body.has-spinner{position:static}.general-button__body.has-secondary-icon{width:100%}@media (max-width: 639.78px){.general-button__body.has-secondary-icon{width:100%}.general-button__body.has-secondary-icon .secondary-icon{position:absolute;right:0}}.general-button__body.has-secondary-icon>span{width:100%}.general-button__body.has-secondary-icon .secondary-icon{margin-left:auto}.general-button__badge{position:absolute;top:-10px;right:0;transform:translate(50%)}.general-button__icon{height:var(--icon-size);display:flex;align-items:center;fill:currentColor;align-self:flex-start;margin-top:-1px;margin-right:6px;width:var(--icon-size)}.general-button__icon svg{fill:currentColor;width:inherit;height:inherit}.general-button__icon svg g{fill:currentColor;width:inherit;height:inherit}.general-button__icon svg text{font-family:Siemens Sans,sans-serif}.general-button__label-content+.general-button__icon{margin-right:0;margin-left:6px}.general-button__icon.secondary-icon svg{transition:transform .12s cubic-bezier(.4,0,.3,1)}.general-button__icon.secondary-icon.open svg{transform:translateZ(0) rotate(180deg)}.general-button__label{display:inline-flex;max-height:40px;word-break:break-word;align-items:center;max-width:228px}.general-button__label-content{display:-webkit-box;-webkit-box-orient:vertical;-webkit-line-clamp:2;overflow:hidden;line-height:initial;text-overflow:ellipsis}.general-button__label-content:empty{display:none}.general-button__label-content.disable-line-break{display:block;white-space:nowrap}.general-button__spinner-wrapper{height:100%;position:absolute;display:flex;justify-content:flex-end;align-items:center;min-width:76px;right:16px;top:0}.general-button__spinner-wrapper.sp-fade-in{animation:fadein 1s linear}.bg-light.spinner-active .general-button__spinner-wrapper.fade-out-text{background:linear-gradient(270deg,#b3b3be 19.14%,rgba(179,179,190,0) 100%)}.bg-dark.spinner-active .general-button__spinner-wrapper.fade-out-text{background:linear-gradient(270deg,#737389 19.14%,rgba(115,115,137,0) 100%)}.bg-light.spinner-active.variant-tertiary .general-button__spinner-wrapper.fade-out-text{background:linear-gradient(270deg,#fff 19.14%,rgba(255,255,255,0) 100%)}.bg-dark.spinner-active.variant-tertiary .general-button__spinner-wrapper.fade-out-text{background:linear-gradient(270deg,#000028 19.14%,rgba(0,0,40,0) 100%)}.general-button--max-width{max-width:260px}.general-button--width{width:100%}.general-button:disabled{cursor:not-allowed}.general-button.type-main{--icon-size-default: 20px;display:flex;align-items:center;min-width:96px;min-height:48px;max-height:56px;padding:6px 16px}.general-button.type-main.fade-appearance{transition-property:border-color,background-color,color,fill;transition-duration:.25s;transition-timing-function:cubic-bezier(.2,0,.38,.9)}.general-button.type-main.fade-appearance .general-button__body{transition:margin-right .25s cubic-bezier(.2,0,.38,.9)}.general-button.type-main.variant-primary.bg-light{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, linear-gradient(90deg, #00ffb9 0%, #00e6dc 100%));background:var(--btn-bg)}@media (hover: hover){.general-button.type-main.variant-primary.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-main.variant-primary.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c5ffef);background:var(--btn-bg)}}.general-button.type-main.variant-primary.bg-light:disabled,.general-button.type-main.variant-primary.bg-light.disabled{--btn-bg: var(--btn-bg-custom, #b3b3be);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #ebebee);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-main.variant-primary.bg-dark{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, linear-gradient(90deg, #00ffb9 0%, #00e6dc 100%));background:var(--btn-bg)}@media (hover: hover){.general-button.type-main.variant-primary.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-main.variant-primary.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c5ffef);background:var(--btn-bg)}}.general-button.type-main.variant-primary.bg-dark:disabled,.general-button.type-main.variant-primary.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, #737389);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-main.variant-secondary.bg-light{--btn-color: var(--btn-color-custom, #fff);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, #007993);background:var(--btn-bg)}@media (hover: hover){.general-button.type-main.variant-secondary.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-main.variant-secondary.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #33747a);background:var(--btn-bg)}}.general-button.type-main.variant-secondary.bg-light:disabled,.general-button.type-main.variant-secondary.bg-light.disabled{--btn-bg: var(--btn-bg-custom, #b3b3be);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #ebebee);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-main.variant-secondary.bg-dark{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, #0cc);background:var(--btn-bg)}@media (hover: hover){.general-button.type-main.variant-secondary.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-main.variant-secondary.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #00ffb9);background:var(--btn-bg)}}.general-button.type-main.variant-secondary.bg-dark:disabled,.general-button.type-main.variant-secondary.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, #737389);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-main.variant-tertiary.bg-light{--btn-color: var(--btn-color-custom, #007993);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);border:1px solid #007993;border-radius:0}@media (hover: hover){.general-button.type-main.variant-tertiary.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-main.variant-tertiary.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c2ffee);background:var(--btn-bg);border:1px solid #33747a;border-radius:0;--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-main.variant-tertiary.bg-light:disabled,.general-button.type-main.variant-tertiary.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);border:1px solid #b3b3be;border-radius:0;--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-main.variant-tertiary.bg-dark{--btn-color: var(--btn-color-custom, #0cc);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, rgba(0, 0, 40, .4));background:var(--btn-bg);border:1px solid #0cc;border-radius:0}@media (hover: hover){.general-button.type-main.variant-tertiary.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-main.variant-tertiary.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #001f39);background:var(--btn-bg);border:1px solid #00ffb9;border-radius:0;--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-main.variant-tertiary.bg-dark:disabled,.general-button.type-main.variant-tertiary.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);border:1px solid #b3b3be;border-radius:0;--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-main.with-spinner{overflow:hidden}.general-button.type-main.with-spinner .general-button__label{transition:min-width 1s ease-in-out;min-width:100%}.general-button.type-main.spinner-active{max-width:260px}.general-button.type-main.spinner-active.general-button--width{max-width:100%}.general-button.type-main.spinner-active:not(.fade-text) .general-button__label{min-width:calc(100% + 40px)}.general-button.type-main.spinner-active:not(.fade-text) .general-button__body{padding:0;margin-right:40px}.general-button.type-icon{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}.general-button.type-icon .general-button__spinner-wrapper{min-width:100%;right:0;display:flex;justify-content:center}.general-button.type-icon .general-button__icon svg{opacity:1;transition:opacity .3s ease-in-out}.general-button.type-icon.spinner-active .general-button__icon{opacity:0}.general-button.type-icon.variant-icon-with-label{padding:0 8px}.general-button.type-icon.variant-icon-with-label.position-header{--btn-height-default: 44px;font-size:1.125rem;font-weight:400;line-height:1.5rem}.general-button.type-icon.variant-icon-with-label.position-header.m-black{font-size:1.125rem;font-weight:900;line-height:1.5rem}.general-button.type-icon.variant-icon-with-label.position-header.bg-light{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-with-label.position-header.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-with-label.position-header.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-with-label.position-header.bg-light:disabled,.general-button.type-icon.variant-icon-with-label.position-header.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-with-label.position-header.bg-dark{--btn-color: var(--btn-color-custom, #fff);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-with-label.position-header.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-with-label.position-header.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-with-label.position-header.bg-dark:disabled,.general-button.type-icon.variant-icon-with-label.position-header.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-with-label.position-content{--icon-size-default: 20px;--btn-height-default: 48px}.general-button.type-icon.variant-icon-with-label.position-content.bg-light{--btn-color: var(--btn-color-custom, #007993);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-with-label.position-content.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-with-label.position-content.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c2ffee);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-with-label.position-content.bg-light:disabled,.general-button.type-icon.variant-icon-with-label.position-content.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-with-label.position-content.bg-dark{--btn-color: var(--btn-color-custom, #0cc);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-with-label.position-content.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-with-label.position-content.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #001f39);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-with-label.position-content.bg-dark:disabled,.general-button.type-icon.variant-icon-with-label.position-content.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-menu{--btn-height-default: 44px;min-width:44px;letter-spacing:-.5px}.general-button.type-icon.variant-icon-menu.bg-light{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-menu.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-menu.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-menu.bg-light:disabled,.general-button.type-icon.variant-icon-menu.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-menu.bg-dark{--btn-color: var(--btn-color-custom, #fff);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-menu.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-menu.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-menu.bg-dark:disabled,.general-button.type-icon.variant-icon-menu.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-menu .general-button__label-content{margin-left:16px;font-size:1rem;font-weight:900;line-height:1.5rem}.general-button.type-icon.variant-icon-menu .general-button__icon{margin-top:-1px}.general-button.type-icon.variant-icon-un-contained{--btn-width-default: 44px;--btn-height-default: 44px}.general-button.type-icon.variant-icon-un-contained.position-header.bg-light{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-un-contained.position-header.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-un-contained.position-header.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-un-contained.position-header.bg-light:disabled,.general-button.type-icon.variant-icon-un-contained.position-header.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-un-contained.position-header.bg-dark{--btn-color: var(--btn-color-custom, #fff);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-un-contained.position-header.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-un-contained.position-header.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-un-contained.position-header.bg-dark:disabled,.general-button.type-icon.variant-icon-un-contained.position-header.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-un-contained.position-content.bg-light{--btn-color: var(--btn-color-custom, #4c4c68);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-un-contained.position-content.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-un-contained.position-content.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-un-contained.position-content.bg-light:disabled,.general-button.type-icon.variant-icon-un-contained.position-content.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-un-contained.position-content.bg-dark{--btn-color: var(--btn-color-custom, #e5e5e9);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-un-contained.position-content.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-un-contained.position-content.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-un-contained.position-content.bg-dark:disabled,.general-button.type-icon.variant-icon-un-contained.position-content.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-un-contained.position-content.to-top-button{--btn-color: var(--btn-color-custom, #007993);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-un-contained.position-content:focus{color:var(--btn-focus-color-custom, #33747a)}.general-button.type-icon.variant-icon-contained.position-header{--btn-width-default: 40px;--btn-height-default: 40px}.general-button.type-icon.variant-icon-contained.position-header.bg-light{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, linear-gradient(90deg, #00ffb9 0%, #00e6dc 100%));background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-contained.position-header.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-contained.position-header.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #00646e);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #fff);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-contained.position-header.bg-light:disabled,.general-button.type-icon.variant-icon-contained.position-header.bg-light.disabled{--btn-bg: var(--btn-bg-custom, #b3b3be);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #ebebee);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-contained.position-header.bg-dark{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, linear-gradient(90deg, #00ffb9 0%, #00e6dc 100%));background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-contained.position-header.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-contained.position-header.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c5ffef);background:var(--btn-bg)}}.general-button.type-icon.variant-icon-contained.position-header.bg-dark:disabled,.general-button.type-icon.variant-icon-contained.position-header.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, #737389);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-contained.position-content{--btn-width-default: 48px;--btn-height-default: 48px}.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-light{--btn-color: var(--btn-color-custom, #fff);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, #007993);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #33747a);background:var(--btn-bg)}}.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-light:disabled,.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-light.disabled{--btn-bg: var(--btn-bg-custom, #b3b3be);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #ebebee);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-dark{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, #0cc);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #00ffb9);background:var(--btn-bg)}}.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-dark:disabled,.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, #737389);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-light{--btn-color: var(--btn-color-custom, #007993);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, rgba(255, 255, 255, .6));background:var(--btn-bg);border:1px solid #007993;border-radius:0}@media (hover: hover){.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c2ffee);background:var(--btn-bg);border:1px solid #33747a;border-radius:0;--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-light:disabled,.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-light.disabled{--btn-bg: var(--btn-bg-custom, rgba(255, 255, 255, .6));background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-dark{--btn-color: var(--btn-color-custom, #0cc);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, rgba(0, 0, 40, .4));background:var(--btn-bg);border:1px solid #0cc;border-radius:0}@media (hover: hover){.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #001f39);background:var(--btn-bg);border:1px solid #00ffb9;border-radius:0;--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-dark:disabled,.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, rgba(0, 0, 40, .4));background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-un-contained{padding:0 8px;margin-left:-8px;min-width:96px}.general-button.type-un-contained.bg-light{--btn-color: var(--btn-color-custom, #007993);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-un-contained.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-un-contained.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c2ffee);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-un-contained.bg-light:disabled,.general-button.type-un-contained.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-un-contained.bg-dark{--btn-color: var(--btn-color-custom, #0cc);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-un-contained.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-un-contained.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #001f39);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-un-contained.bg-dark:disabled,.general-button.type-un-contained.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-un-contained.position-content{--icon-size-default: 20px}.general-button.type-un-contained.open{background-color:#c2ffee;color:#33747a}.general-button.not-bold{font-size:1rem;font-weight:400;line-height:1.5rem}@keyframes fadein{0%{opacity:0}to{opacity:1}}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: i2.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "component", type: UiSpinnerComponent, selector: "sie-ui-spinner", inputs: ["size", "message", "overlayOnTop", "overlay", "active"], outputs: ["animationEnded"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "component", type: UiBadgeComponent, selector: "sie-ui-badge", inputs: ["mode", "type", "number", "addOutline", "highlighted", "status"] }, { kind: "directive", type: i1$1.AttributeDirective, selector: "[sieCoreAttributes]", inputs: ["sieCoreAttributes"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiButtonComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-button', changeDetection: ChangeDetectionStrategy.OnPush, template: "<!-- BUTTON -->\n<ng-container *ngIf=\"isButton\">\n  <button\n    class=\"general-button\"\n    #uiButton\n    [sieCoreAttributes]=\"dataAttributes\"\n    [ngClass]=\"[\n      cssClass,\n      'type-' + themeType,\n      'variant-' + variant,\n      'bg-' + background,\n      'position-' + position,\n      prominence ? 'prominence-' + prominence : '',\n      fullWidth ? 'general-button--width' : 'general-button--max-width',\n      withSpinner ? 'with-spinner' : '',\n      showSpinner ? 'spinner-active' : '',\n      spinnerAnimating ? 'fade-appearance' : '',\n      shouldFadeOutText ? 'fade-text' : '',\n      !bold ? 'not-bold' : '',\n      increasedSize ? 'increased-size' : '',\n      hoverDisabled ? 'hover-disabled' : '',\n      disableLineBreak && !fullWidth ? 'disable-line-break-max-width' : ''\n    ]\"\n    [class.open]=\"isSecondaryIconRotated\"\n    [type]=\"this.buttonType.endsWith('submit') ? 'submit' : 'button'\"\n    (click)=\"onClick($event)\"\n    (focus)=\"onFocus($event)\"\n    [tabIndex]=\"this.focusable ? 0 : -1\"\n    (blur)=\"onBlur($event)\"\n    [disabled]=\"disabled || showSpinner ? 'disabled' : null\"\n    [ngStyle]=\"withSpinner && !fullWidth && !dimensionsSet ? { width: buttonWithSpinnerWidth + 'px' } : ''\"\n  >\n    <ng-container *ngTemplateOutlet=\"contentField\"></ng-container>\n  </button>\n</ng-container>\n\n<!-- EXTERNAL BUTTON (siemens internal and external links) --><a\n  *ngIf=\"!isButton\"\n  #uiButton\n  [sieCoreAttributes]=\"dataAttributes\"\n  [href]=\"link\"\n  [target]=\"target\"\n  class=\"general-button\"\n  rel=\"noopener\"\n  (click)=\"onClick($event)\"\n  [ngClass]=\"[\n    'type-' + themeType,\n    'variant-' + variant,\n    'bg-' + background,\n    'position-' + position,\n    prominence ? 'prominence-' + prominence : '',\n    cssClass,\n    disabled ? 'disabled' : '',\n    fullWidth ? 'general-button--width' : 'general-button--max-width',\n    withSpinner ? 'with-spinner' : '',\n    showSpinner ? 'spinner-active' : '',\n    spinnerAnimating ? 'fade-appearance' : '',\n    shouldFadeOutText ? 'fade-text' : ''\n  ]\"\n>\n  <ng-container *ngTemplateOutlet=\"contentField\"></ng-container>\n</a>\n\n<!-- CONTENT -->\n<ng-template #contentField>\n  <span class=\"general-button__body\" [ngClass]=\"{ 'has-spinner': withSpinner, 'has-secondary-icon': iconSecondary }\">\n    <sie-ui-badge\n      *ngIf=\"badge\"\n      class=\"general-button__badge\"\n      type=\"counter\"\n      [number]=\"badgeNumber\"\n      addOutline\n    ></sie-ui-badge>\n    <span class=\"general-button__label\">\n      <ng-container *ngIf=\"icon && iconPosition === 'leading'\">\n        <sie-icon [name]=\"icon\" class=\"general-button__icon\" [ngClass]=\"getIconClasses()\" aria-hidden=\"true\"></sie-icon>\n        <span *ngIf=\"iconScreenReaderText\" class=\"visually-hidden\">{{ iconScreenReaderText }}</span>\n      </ng-container>\n      <span class=\"general-button__label-content\" [ngClass]=\"{ 'disable-line-break': disableLineBreak }\"\n        ><ng-content></ng-content\n      ></span>\n      <ng-container *ngIf=\"icon && iconPosition === 'trailing'\">\n        <sie-icon [name]=\"icon\" class=\"general-button__icon\" [ngClass]=\"getIconClasses()\"></sie-icon>\n      </ng-container>\n      <ng-container *ngIf=\"iconSecondary\">\n        <sie-icon\n          [name]=\"iconSecondary\"\n          class=\"general-button__icon secondary-icon\"\n          [ngClass]=\"getIconClasses()\"\n          [class.open]=\"isSecondaryIconRotated\"\n        ></sie-icon>\n      </ng-container>\n      <ng-container *ngIf=\"showSpinner || spinnerAnimating\">\n        <div\n          class=\"general-button__spinner-wrapper\"\n          [ngClass]=\"{\n            'sp-fade-in': showSpinner,\n            'fade-out-text': shouldFadeOutText\n          }\"\n        >\n          <sie-ui-spinner\n            [size]=\"spinnerSize\"\n            [active]=\"showSpinner\"\n            (animationEnded)=\"onAnimationEnd()\"\n          ></sie-ui-spinner>\n        </div>\n      </ng-container>\n    </span>\n  </span>\n</ng-template>\n", styles: [":host .general-button{outline:none;outline-offset:0}@media (pointer: fine){:host .general-button{position:relative}:host .general-button:focus{outline:1px solid #1491eb;outline-offset:2px}:host .general-button:focus:not(:focus-visible){outline:0}:host .general-button:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}:host{display:inline-flex;position:relative;--icon-size-default: 24px;--btn-height-default: 48px;--btn-width-default: auto;outline:0}:host(.full-width){width:100%}.general-button.type-icon.variant-icon-contained .general-button__icon,.general-button.type-icon.variant-icon-un-contained .general-button__icon,.general-button.type-icon.variant-icon-menu .general-button__icon{margin:0}.increased-size.general-button.type-icon.variant-icon-contained.position-content,.increased-size.general-button.type-icon.variant-icon-contained.position-header,.increased-size.general-button.type-icon.variant-icon-un-contained,.increased-size.general-button.type-icon.variant-icon-with-label.position-content,.increased-size.general-button.type-icon.variant-icon-with-label.position-header,.increased-size.general-button{--btn-height-default: 56px;--icon-size-default: 28px;min-width:56px}.general-button{font-size:1rem;font-weight:900;line-height:1.5rem;--icon-size: var(--icon-size-custom, var(--icon-size-default));--btn-width: var(--btn-width-custom, var(--btn-width-default));--btn-height: var(--btn-height-custom, var(--btn-height-default));-webkit-user-drag:none;display:inline-flex;flex:1 1 0;align-items:center;justify-content:center;border-width:0;text-align:left;text-decoration:none;cursor:pointer;line-height:var(--icon-size);width:var(--btn-width);height:var(--btn-height)}@media print{.general-button{-webkit-print-color-adjust:exact;print-color-adjust:exact}}.general-button.disable-line-break-max-width{max-width:260px}.general-button__body{position:relative;display:flex;align-items:center;margin-right:0;transition:margin-right 1s ease-in-out}.general-button__body.has-spinner{position:static}.general-button__body.has-secondary-icon{width:100%}@media (max-width: 639.78px){.general-button__body.has-secondary-icon{width:100%}.general-button__body.has-secondary-icon .secondary-icon{position:absolute;right:0}}.general-button__body.has-secondary-icon>span{width:100%}.general-button__body.has-secondary-icon .secondary-icon{margin-left:auto}.general-button__badge{position:absolute;top:-10px;right:0;transform:translate(50%)}.general-button__icon{height:var(--icon-size);display:flex;align-items:center;fill:currentColor;align-self:flex-start;margin-top:-1px;margin-right:6px;width:var(--icon-size)}.general-button__icon svg{fill:currentColor;width:inherit;height:inherit}.general-button__icon svg g{fill:currentColor;width:inherit;height:inherit}.general-button__icon svg text{font-family:Siemens Sans,sans-serif}.general-button__label-content+.general-button__icon{margin-right:0;margin-left:6px}.general-button__icon.secondary-icon svg{transition:transform .12s cubic-bezier(.4,0,.3,1)}.general-button__icon.secondary-icon.open svg{transform:translateZ(0) rotate(180deg)}.general-button__label{display:inline-flex;max-height:40px;word-break:break-word;align-items:center;max-width:228px}.general-button__label-content{display:-webkit-box;-webkit-box-orient:vertical;-webkit-line-clamp:2;overflow:hidden;line-height:initial;text-overflow:ellipsis}.general-button__label-content:empty{display:none}.general-button__label-content.disable-line-break{display:block;white-space:nowrap}.general-button__spinner-wrapper{height:100%;position:absolute;display:flex;justify-content:flex-end;align-items:center;min-width:76px;right:16px;top:0}.general-button__spinner-wrapper.sp-fade-in{animation:fadein 1s linear}.bg-light.spinner-active .general-button__spinner-wrapper.fade-out-text{background:linear-gradient(270deg,#b3b3be 19.14%,rgba(179,179,190,0) 100%)}.bg-dark.spinner-active .general-button__spinner-wrapper.fade-out-text{background:linear-gradient(270deg,#737389 19.14%,rgba(115,115,137,0) 100%)}.bg-light.spinner-active.variant-tertiary .general-button__spinner-wrapper.fade-out-text{background:linear-gradient(270deg,#fff 19.14%,rgba(255,255,255,0) 100%)}.bg-dark.spinner-active.variant-tertiary .general-button__spinner-wrapper.fade-out-text{background:linear-gradient(270deg,#000028 19.14%,rgba(0,0,40,0) 100%)}.general-button--max-width{max-width:260px}.general-button--width{width:100%}.general-button:disabled{cursor:not-allowed}.general-button.type-main{--icon-size-default: 20px;display:flex;align-items:center;min-width:96px;min-height:48px;max-height:56px;padding:6px 16px}.general-button.type-main.fade-appearance{transition-property:border-color,background-color,color,fill;transition-duration:.25s;transition-timing-function:cubic-bezier(.2,0,.38,.9)}.general-button.type-main.fade-appearance .general-button__body{transition:margin-right .25s cubic-bezier(.2,0,.38,.9)}.general-button.type-main.variant-primary.bg-light{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, linear-gradient(90deg, #00ffb9 0%, #00e6dc 100%));background:var(--btn-bg)}@media (hover: hover){.general-button.type-main.variant-primary.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-main.variant-primary.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c5ffef);background:var(--btn-bg)}}.general-button.type-main.variant-primary.bg-light:disabled,.general-button.type-main.variant-primary.bg-light.disabled{--btn-bg: var(--btn-bg-custom, #b3b3be);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #ebebee);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-main.variant-primary.bg-dark{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, linear-gradient(90deg, #00ffb9 0%, #00e6dc 100%));background:var(--btn-bg)}@media (hover: hover){.general-button.type-main.variant-primary.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-main.variant-primary.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c5ffef);background:var(--btn-bg)}}.general-button.type-main.variant-primary.bg-dark:disabled,.general-button.type-main.variant-primary.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, #737389);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-main.variant-secondary.bg-light{--btn-color: var(--btn-color-custom, #fff);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, #007993);background:var(--btn-bg)}@media (hover: hover){.general-button.type-main.variant-secondary.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-main.variant-secondary.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #33747a);background:var(--btn-bg)}}.general-button.type-main.variant-secondary.bg-light:disabled,.general-button.type-main.variant-secondary.bg-light.disabled{--btn-bg: var(--btn-bg-custom, #b3b3be);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #ebebee);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-main.variant-secondary.bg-dark{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, #0cc);background:var(--btn-bg)}@media (hover: hover){.general-button.type-main.variant-secondary.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-main.variant-secondary.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #00ffb9);background:var(--btn-bg)}}.general-button.type-main.variant-secondary.bg-dark:disabled,.general-button.type-main.variant-secondary.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, #737389);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-main.variant-tertiary.bg-light{--btn-color: var(--btn-color-custom, #007993);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);border:1px solid #007993;border-radius:0}@media (hover: hover){.general-button.type-main.variant-tertiary.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-main.variant-tertiary.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c2ffee);background:var(--btn-bg);border:1px solid #33747a;border-radius:0;--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-main.variant-tertiary.bg-light:disabled,.general-button.type-main.variant-tertiary.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);border:1px solid #b3b3be;border-radius:0;--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-main.variant-tertiary.bg-dark{--btn-color: var(--btn-color-custom, #0cc);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, rgba(0, 0, 40, .4));background:var(--btn-bg);border:1px solid #0cc;border-radius:0}@media (hover: hover){.general-button.type-main.variant-tertiary.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-main.variant-tertiary.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #001f39);background:var(--btn-bg);border:1px solid #00ffb9;border-radius:0;--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-main.variant-tertiary.bg-dark:disabled,.general-button.type-main.variant-tertiary.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);border:1px solid #b3b3be;border-radius:0;--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-main.with-spinner{overflow:hidden}.general-button.type-main.with-spinner .general-button__label{transition:min-width 1s ease-in-out;min-width:100%}.general-button.type-main.spinner-active{max-width:260px}.general-button.type-main.spinner-active.general-button--width{max-width:100%}.general-button.type-main.spinner-active:not(.fade-text) .general-button__label{min-width:calc(100% + 40px)}.general-button.type-main.spinner-active:not(.fade-text) .general-button__body{padding:0;margin-right:40px}.general-button.type-icon{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}.general-button.type-icon .general-button__spinner-wrapper{min-width:100%;right:0;display:flex;justify-content:center}.general-button.type-icon .general-button__icon svg{opacity:1;transition:opacity .3s ease-in-out}.general-button.type-icon.spinner-active .general-button__icon{opacity:0}.general-button.type-icon.variant-icon-with-label{padding:0 8px}.general-button.type-icon.variant-icon-with-label.position-header{--btn-height-default: 44px;font-size:1.125rem;font-weight:400;line-height:1.5rem}.general-button.type-icon.variant-icon-with-label.position-header.m-black{font-size:1.125rem;font-weight:900;line-height:1.5rem}.general-button.type-icon.variant-icon-with-label.position-header.bg-light{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-with-label.position-header.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-with-label.position-header.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-with-label.position-header.bg-light:disabled,.general-button.type-icon.variant-icon-with-label.position-header.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-with-label.position-header.bg-dark{--btn-color: var(--btn-color-custom, #fff);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-with-label.position-header.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-with-label.position-header.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-with-label.position-header.bg-dark:disabled,.general-button.type-icon.variant-icon-with-label.position-header.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-with-label.position-content{--icon-size-default: 20px;--btn-height-default: 48px}.general-button.type-icon.variant-icon-with-label.position-content.bg-light{--btn-color: var(--btn-color-custom, #007993);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-with-label.position-content.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-with-label.position-content.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c2ffee);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-with-label.position-content.bg-light:disabled,.general-button.type-icon.variant-icon-with-label.position-content.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-with-label.position-content.bg-dark{--btn-color: var(--btn-color-custom, #0cc);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-with-label.position-content.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-with-label.position-content.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #001f39);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-with-label.position-content.bg-dark:disabled,.general-button.type-icon.variant-icon-with-label.position-content.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-menu{--btn-height-default: 44px;min-width:44px;letter-spacing:-.5px}.general-button.type-icon.variant-icon-menu.bg-light{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-menu.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-menu.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-menu.bg-light:disabled,.general-button.type-icon.variant-icon-menu.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-menu.bg-dark{--btn-color: var(--btn-color-custom, #fff);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-menu.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-menu.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-menu.bg-dark:disabled,.general-button.type-icon.variant-icon-menu.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-menu .general-button__label-content{margin-left:16px;font-size:1rem;font-weight:900;line-height:1.5rem}.general-button.type-icon.variant-icon-menu .general-button__icon{margin-top:-1px}.general-button.type-icon.variant-icon-un-contained{--btn-width-default: 44px;--btn-height-default: 44px}.general-button.type-icon.variant-icon-un-contained.position-header.bg-light{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-un-contained.position-header.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-un-contained.position-header.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-un-contained.position-header.bg-light:disabled,.general-button.type-icon.variant-icon-un-contained.position-header.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-un-contained.position-header.bg-dark{--btn-color: var(--btn-color-custom, #fff);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-un-contained.position-header.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-un-contained.position-header.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-un-contained.position-header.bg-dark:disabled,.general-button.type-icon.variant-icon-un-contained.position-header.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-un-contained.position-content.bg-light{--btn-color: var(--btn-color-custom, #4c4c68);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-un-contained.position-content.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-un-contained.position-content.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-un-contained.position-content.bg-light:disabled,.general-button.type-icon.variant-icon-un-contained.position-content.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-un-contained.position-content.bg-dark{--btn-color: var(--btn-color-custom, #e5e5e9);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-un-contained.position-content.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-un-contained.position-content.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-un-contained.position-content.bg-dark:disabled,.general-button.type-icon.variant-icon-un-contained.position-content.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-un-contained.position-content.to-top-button{--btn-color: var(--btn-color-custom, #007993);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-un-contained.position-content:focus{color:var(--btn-focus-color-custom, #33747a)}.general-button.type-icon.variant-icon-contained.position-header{--btn-width-default: 40px;--btn-height-default: 40px}.general-button.type-icon.variant-icon-contained.position-header.bg-light{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, linear-gradient(90deg, #00ffb9 0%, #00e6dc 100%));background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-contained.position-header.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-contained.position-header.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #00646e);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #fff);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-contained.position-header.bg-light:disabled,.general-button.type-icon.variant-icon-contained.position-header.bg-light.disabled{--btn-bg: var(--btn-bg-custom, #b3b3be);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #ebebee);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-contained.position-header.bg-dark{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, linear-gradient(90deg, #00ffb9 0%, #00e6dc 100%));background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-contained.position-header.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-contained.position-header.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c5ffef);background:var(--btn-bg)}}.general-button.type-icon.variant-icon-contained.position-header.bg-dark:disabled,.general-button.type-icon.variant-icon-contained.position-header.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, #737389);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-contained.position-content{--btn-width-default: 48px;--btn-height-default: 48px}.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-light{--btn-color: var(--btn-color-custom, #fff);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, #007993);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #33747a);background:var(--btn-bg)}}.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-light:disabled,.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-light.disabled{--btn-bg: var(--btn-bg-custom, #b3b3be);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #ebebee);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-dark{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, #0cc);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #00ffb9);background:var(--btn-bg)}}.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-dark:disabled,.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, #737389);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-light{--btn-color: var(--btn-color-custom, #007993);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, rgba(255, 255, 255, .6));background:var(--btn-bg);border:1px solid #007993;border-radius:0}@media (hover: hover){.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c2ffee);background:var(--btn-bg);border:1px solid #33747a;border-radius:0;--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-light:disabled,.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-light.disabled{--btn-bg: var(--btn-bg-custom, rgba(255, 255, 255, .6));background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-dark{--btn-color: var(--btn-color-custom, #0cc);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, rgba(0, 0, 40, .4));background:var(--btn-bg);border:1px solid #0cc;border-radius:0}@media (hover: hover){.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #001f39);background:var(--btn-bg);border:1px solid #00ffb9;border-radius:0;--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-dark:disabled,.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, rgba(0, 0, 40, .4));background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-un-contained{padding:0 8px;margin-left:-8px;min-width:96px}.general-button.type-un-contained.bg-light{--btn-color: var(--btn-color-custom, #007993);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-un-contained.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-un-contained.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c2ffee);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-un-contained.bg-light:disabled,.general-button.type-un-contained.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-un-contained.bg-dark{--btn-color: var(--btn-color-custom, #0cc);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-un-contained.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-un-contained.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #001f39);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-un-contained.bg-dark:disabled,.general-button.type-un-contained.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-un-contained.position-content{--icon-size-default: 20px}.general-button.type-un-contained.open{background-color:#c2ffee;color:#33747a}.general-button.not-bold{font-size:1rem;font-weight:400;line-height:1.5rem}@keyframes fadein{0%{opacity:0}to{opacity:1}}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i1.SieIconRegistryService }]; } });

class UiFilterHeaderComponent {
    set filterHeaderInformation(filterHeaderInformation) {
        // sort
        if (filterHeaderInformation?.tagGroups) {
            filterHeaderInformation.tagGroups.sort((a, b) => a.order - b.order);
            filterHeaderInformation.tagGroups.forEach(tagGroup => {
                tagGroup.tags.sort((a, b) => a.order - b.order);
            });
        }
        this._filterHeaderInformation = filterHeaderInformation;
        this.cdr.detectChanges();
    }
    get filterHeaderInformation() {
        return this._filterHeaderInformation;
    }
    constructor(cdr, layoutService, iconReg) {
        this.cdr = cdr;
        this.layoutService = layoutService;
        this.iconReg = iconReg;
        this.listLabelScreenReaderText = '';
        this.showAllButton = false;
        this.resetAllButton = false;
        this.filterChangedEvent = new Subject();
        this._filterHeaderInformation = null;
        this.filterChanges = null;
        this.subscriptions = new Subscription();
        iconReg.register(SieIcon.Filter);
    }
    ngOnInit() {
        this.subscriptions.add(this.layoutService.resizeEvent.subscribe(() => {
            this.cdr.detectChanges();
        }));
    }
    ngOnDestroy() {
        this.subscriptions.unsubscribe();
    }
    onTagSelectionChange(id, tagGroup) {
        if (!this.filterChanges) {
            this.filterChanges = { params: [] };
        }
        let filterChange = this.filterChanges.params.find(param => param.id === tagGroup.parameterName);
        if (!filterChange) {
            filterChange = {
                subFiltersToBeRemoved: tagGroup.subFilters,
                id: tagGroup.parameterName,
                changes: []
            };
            this.filterChanges.params.push(filterChange);
        }
        filterChange.changes.push({ value: id, remove: true, canHaveMultipleValues: true });
        tagGroup.tags = tagGroup.tags.filter(tag => tag.id !== id);
        this.cdr.detectChanges();
        this.emitDebouncedEvent();
    }
    resetAllFilters() {
        this.filterChanges = { resetAll: true };
        this.filterChangedEvent.next(this.filterChanges);
        this.filterChanges = null;
    }
    emitDebouncedEvent() {
        this.filterChangedEvent.next(this.filterChanges);
        this.filterChanges = null;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiFilterHeaderComponent, deps: [{ token: i0.ChangeDetectorRef }, { token: i1$1.LayoutService }, { token: i1.SieIconRegistryService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiFilterHeaderComponent, selector: "sie-ui-filter-header", inputs: { listLabelScreenReaderText: "listLabelScreenReaderText", showAllButton: "showAllButton", showAllButtonText: "showAllButtonText", resetAllButton: "resetAllButton", resetAllButtonText: "resetAllButtonText", filterHeaderInformation: "filterHeaderInformation" }, outputs: { filterChangedEvent: "filterChangedEvent" }, ngImport: i0, template: "<ul\n  *ngIf=\"filterHeaderInformation?.tagGroups?.length || showAllButton\"\n  class=\"filter-list\"\n  [attr.aria-label]=\"listLabelScreenReaderText\"\n  role=\"group\"\n>\n  <li class=\"filter-list__item\" *ngIf=\"!filterHeaderInformation?.tagGroups?.length && showAllButton\">\n    <sie-ui-tag [tagId]=\"1\" [mode]=\"'noninteractive'\" sieCoreAddTooltip>{{ showAllButtonText }}</sie-ui-tag>\n  </li>\n  <ng-container *ngIf=\"filterHeaderInformation?.tagGroups?.length\">\n    <ng-container *ngFor=\"let tagGroup of filterHeaderInformation.tagGroups\">\n      <li class=\"filter-list__item\" *ngFor=\"let tag of tagGroup.tags\">\n        <sie-ui-tag\n          [mode]=\"tag.mode\"\n          [tagId]=\"tag.id\"\n          [removeButtonAriaLabel]=\"tag.removeButtonAriaLabel\"\n          (removed)=\"onTagSelectionChange($event, tagGroup)\"\n          sieCoreAddTooltip\n        >\n          {{ tag.label }}\n        </sie-ui-tag>\n      </li>\n    </ng-container>\n    <li class=\"filter-list__item\" *ngIf=\"resetAllButton\">\n      <sie-ui-button\n        class=\"filter-list__reset-button\"\n        [icon]=\"iconReg.sieIcon.Reset\"\n        variant=\"tertiary\"\n        themeType=\"un-contained\"\n        (clicked)=\"resetAllFilters()\"\n        >{{ resetAllButtonText }}</sie-ui-button\n      >\n    </li>\n  </ng-container>\n</ul>\n", styles: [".filter-list{list-style:none;margin:-8px 0 0;padding:0}.filter-list__item{display:inline-flex;margin-right:8px;margin-top:8px}.filter-list__reset-button{top:4px;left:20px}.filter-button{margin:2px 0}@media (min-width: 1024px){.filter-button{margin:4px 0}}\n"], dependencies: [{ kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: UiTagComponent, selector: "sie-ui-tag", inputs: ["mode", "theme", "status", "tagId", "dataAttrName", "dataAttrValue", "disabled", "croppedTop", "condensed", "linkable", "removeButtonAriaLabel"], outputs: ["selected", "unselected", "removed", "clicked"] }, { kind: "component", type: UiButtonComponent, selector: "sie-ui-button" }, { kind: "directive", type: i1$1.AddTooltipDirective, selector: "[sieCoreAddTooltip]" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
__decorate([
    Debounce(FILTER_UPDATE_DELAY)
], UiFilterHeaderComponent.prototype, "emitDebouncedEvent", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiFilterHeaderComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-filter-header', changeDetection: ChangeDetectionStrategy.OnPush, template: "<ul\n  *ngIf=\"filterHeaderInformation?.tagGroups?.length || showAllButton\"\n  class=\"filter-list\"\n  [attr.aria-label]=\"listLabelScreenReaderText\"\n  role=\"group\"\n>\n  <li class=\"filter-list__item\" *ngIf=\"!filterHeaderInformation?.tagGroups?.length && showAllButton\">\n    <sie-ui-tag [tagId]=\"1\" [mode]=\"'noninteractive'\" sieCoreAddTooltip>{{ showAllButtonText }}</sie-ui-tag>\n  </li>\n  <ng-container *ngIf=\"filterHeaderInformation?.tagGroups?.length\">\n    <ng-container *ngFor=\"let tagGroup of filterHeaderInformation.tagGroups\">\n      <li class=\"filter-list__item\" *ngFor=\"let tag of tagGroup.tags\">\n        <sie-ui-tag\n          [mode]=\"tag.mode\"\n          [tagId]=\"tag.id\"\n          [removeButtonAriaLabel]=\"tag.removeButtonAriaLabel\"\n          (removed)=\"onTagSelectionChange($event, tagGroup)\"\n          sieCoreAddTooltip\n        >\n          {{ tag.label }}\n        </sie-ui-tag>\n      </li>\n    </ng-container>\n    <li class=\"filter-list__item\" *ngIf=\"resetAllButton\">\n      <sie-ui-button\n        class=\"filter-list__reset-button\"\n        [icon]=\"iconReg.sieIcon.Reset\"\n        variant=\"tertiary\"\n        themeType=\"un-contained\"\n        (clicked)=\"resetAllFilters()\"\n        >{{ resetAllButtonText }}</sie-ui-button\n      >\n    </li>\n  </ng-container>\n</ul>\n", styles: [".filter-list{list-style:none;margin:-8px 0 0;padding:0}.filter-list__item{display:inline-flex;margin-right:8px;margin-top:8px}.filter-list__reset-button{top:4px;left:20px}.filter-button{margin:2px 0}@media (min-width: 1024px){.filter-button{margin:4px 0}}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i1$1.LayoutService }, { type: i1.SieIconRegistryService }]; }, propDecorators: { listLabelScreenReaderText: [{
                type: Input
            }], showAllButton: [{
                type: Input
            }], showAllButtonText: [{
                type: Input
            }], resetAllButton: [{
                type: Input
            }], resetAllButtonText: [{
                type: Input
            }], filterHeaderInformation: [{
                type: Input
            }], filterChangedEvent: [{
                type: Output
            }], emitDebouncedEvent: [] } });

/**
 * # Spinner Module
 * - {@link UiSpinnerComponent}
 */
class UiSpinnerModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiSpinnerModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiSpinnerModule, declarations: [UiSpinnerComponent], imports: [CommonModule], exports: [UiSpinnerComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiSpinnerModule, imports: [CommonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiSpinnerModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiSpinnerComponent],
                    imports: [CommonModule],
                    exports: [UiSpinnerComponent]
                }]
        }] });

/**
 * # Badge Module
 * - {@link UiBadgeComponent}
 *
 * ## Module peer dependencies
 * - `@angular/platform-browser/animations/BrowserAnimationsModule`: This module is needed for the digit change animation on the badge component.
 * - {@link SieIconsModule}
 */
class UiBadgeModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiBadgeModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiBadgeModule, declarations: [UiBadgeComponent], imports: [CommonModule, SieIconsModule], exports: [UiBadgeComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiBadgeModule, imports: [CommonModule, SieIconsModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiBadgeModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiBadgeComponent],
                    imports: [CommonModule, SieIconsModule],
                    exports: [UiBadgeComponent]
                }]
        }] });

/**
 * Specialized version of sie-ui-button that only toggles two states expanded and collapsed and rotates the icon with a transformation
 */
class UiExpandButtonComponent extends UiBaseButtonDirective {
    constructor(cdr, iconReg) {
        super(cdr, iconReg);
        this.expanded = true;
        this.themeType = 'icon';
        this.variant = 'icon-un-contained';
        this.icon = iconReg.sieIcon.ArrowUp;
    }
    onClick(event) {
        super.onClick(event);
        this.expanded = !this.expanded;
    }
    getIconClasses() {
        return this.expanded ? 'expanded' : 'collapsed';
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiExpandButtonComponent, deps: [{ token: i0.ChangeDetectorRef }, { token: i1.SieIconRegistryService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiExpandButtonComponent, selector: "sie-ui-expand-button", inputs: { expanded: "expanded" }, usesInheritance: true, ngImport: i0, template: "<!-- BUTTON -->\n<ng-container *ngIf=\"isButton\">\n  <button\n    class=\"general-button\"\n    #uiButton\n    [sieCoreAttributes]=\"dataAttributes\"\n    [ngClass]=\"[\n      cssClass,\n      'type-' + themeType,\n      'variant-' + variant,\n      'bg-' + background,\n      'position-' + position,\n      prominence ? 'prominence-' + prominence : '',\n      fullWidth ? 'general-button--width' : 'general-button--max-width',\n      withSpinner ? 'with-spinner' : '',\n      showSpinner ? 'spinner-active' : '',\n      spinnerAnimating ? 'fade-appearance' : '',\n      shouldFadeOutText ? 'fade-text' : '',\n      !bold ? 'not-bold' : '',\n      increasedSize ? 'increased-size' : '',\n      hoverDisabled ? 'hover-disabled' : '',\n      disableLineBreak && !fullWidth ? 'disable-line-break-max-width' : ''\n    ]\"\n    [class.open]=\"isSecondaryIconRotated\"\n    [type]=\"this.buttonType.endsWith('submit') ? 'submit' : 'button'\"\n    (click)=\"onClick($event)\"\n    (focus)=\"onFocus($event)\"\n    [tabIndex]=\"this.focusable ? 0 : -1\"\n    (blur)=\"onBlur($event)\"\n    [disabled]=\"disabled || showSpinner ? 'disabled' : null\"\n    [ngStyle]=\"withSpinner && !fullWidth && !dimensionsSet ? { width: buttonWithSpinnerWidth + 'px' } : ''\"\n  >\n    <ng-container *ngTemplateOutlet=\"contentField\"></ng-container>\n  </button>\n</ng-container>\n\n<!-- EXTERNAL BUTTON (siemens internal and external links) --><a\n  *ngIf=\"!isButton\"\n  #uiButton\n  [sieCoreAttributes]=\"dataAttributes\"\n  [href]=\"link\"\n  [target]=\"target\"\n  class=\"general-button\"\n  rel=\"noopener\"\n  (click)=\"onClick($event)\"\n  [ngClass]=\"[\n    'type-' + themeType,\n    'variant-' + variant,\n    'bg-' + background,\n    'position-' + position,\n    prominence ? 'prominence-' + prominence : '',\n    cssClass,\n    disabled ? 'disabled' : '',\n    fullWidth ? 'general-button--width' : 'general-button--max-width',\n    withSpinner ? 'with-spinner' : '',\n    showSpinner ? 'spinner-active' : '',\n    spinnerAnimating ? 'fade-appearance' : '',\n    shouldFadeOutText ? 'fade-text' : ''\n  ]\"\n>\n  <ng-container *ngTemplateOutlet=\"contentField\"></ng-container>\n</a>\n\n<!-- CONTENT -->\n<ng-template #contentField>\n  <span class=\"general-button__body\" [ngClass]=\"{ 'has-spinner': withSpinner, 'has-secondary-icon': iconSecondary }\">\n    <sie-ui-badge\n      *ngIf=\"badge\"\n      class=\"general-button__badge\"\n      type=\"counter\"\n      [number]=\"badgeNumber\"\n      addOutline\n    ></sie-ui-badge>\n    <span class=\"general-button__label\">\n      <ng-container *ngIf=\"icon && iconPosition === 'leading'\">\n        <sie-icon [name]=\"icon\" class=\"general-button__icon\" [ngClass]=\"getIconClasses()\" aria-hidden=\"true\"></sie-icon>\n        <span *ngIf=\"iconScreenReaderText\" class=\"visually-hidden\">{{ iconScreenReaderText }}</span>\n      </ng-container>\n      <span class=\"general-button__label-content\" [ngClass]=\"{ 'disable-line-break': disableLineBreak }\"\n        ><ng-content></ng-content\n      ></span>\n      <ng-container *ngIf=\"icon && iconPosition === 'trailing'\">\n        <sie-icon [name]=\"icon\" class=\"general-button__icon\" [ngClass]=\"getIconClasses()\"></sie-icon>\n      </ng-container>\n      <ng-container *ngIf=\"iconSecondary\">\n        <sie-icon\n          [name]=\"iconSecondary\"\n          class=\"general-button__icon secondary-icon\"\n          [ngClass]=\"getIconClasses()\"\n          [class.open]=\"isSecondaryIconRotated\"\n        ></sie-icon>\n      </ng-container>\n      <ng-container *ngIf=\"showSpinner || spinnerAnimating\">\n        <div\n          class=\"general-button__spinner-wrapper\"\n          [ngClass]=\"{\n            'sp-fade-in': showSpinner,\n            'fade-out-text': shouldFadeOutText\n          }\"\n        >\n          <sie-ui-spinner\n            [size]=\"spinnerSize\"\n            [active]=\"showSpinner\"\n            (animationEnded)=\"onAnimationEnd()\"\n          ></sie-ui-spinner>\n        </div>\n      </ng-container>\n    </span>\n  </span>\n</ng-template>\n", styles: [":host .general-button{outline:none;outline-offset:0}@media (pointer: fine){:host .general-button{position:relative}:host .general-button:focus{outline:1px solid #1491eb;outline-offset:2px}:host .general-button:focus:not(:focus-visible){outline:0}:host .general-button:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}:host{display:inline-flex;position:relative;--icon-size-default: 24px;--btn-height-default: 48px;--btn-width-default: auto;outline:0}:host(.full-width){width:100%}.general-button.type-icon.variant-icon-contained .general-button__icon,.general-button.type-icon.variant-icon-un-contained .general-button__icon,.general-button.type-icon.variant-icon-menu .general-button__icon{margin:0}.increased-size.general-button.type-icon.variant-icon-contained.position-content,.increased-size.general-button.type-icon.variant-icon-contained.position-header,.increased-size.general-button.type-icon.variant-icon-un-contained,.increased-size.general-button.type-icon.variant-icon-with-label.position-content,.increased-size.general-button.type-icon.variant-icon-with-label.position-header,.increased-size.general-button{--btn-height-default: 56px;--icon-size-default: 28px;min-width:56px}.general-button{font-size:1rem;font-weight:900;line-height:1.5rem;--icon-size: var(--icon-size-custom, var(--icon-size-default));--btn-width: var(--btn-width-custom, var(--btn-width-default));--btn-height: var(--btn-height-custom, var(--btn-height-default));-webkit-user-drag:none;display:inline-flex;flex:1 1 0;align-items:center;justify-content:center;border-width:0;text-align:left;text-decoration:none;cursor:pointer;line-height:var(--icon-size);width:var(--btn-width);height:var(--btn-height)}@media print{.general-button{-webkit-print-color-adjust:exact;print-color-adjust:exact}}.general-button.disable-line-break-max-width{max-width:260px}.general-button__body{position:relative;display:flex;align-items:center;margin-right:0;transition:margin-right 1s ease-in-out}.general-button__body.has-spinner{position:static}.general-button__body.has-secondary-icon{width:100%}@media (max-width: 639.78px){.general-button__body.has-secondary-icon{width:100%}.general-button__body.has-secondary-icon .secondary-icon{position:absolute;right:0}}.general-button__body.has-secondary-icon>span{width:100%}.general-button__body.has-secondary-icon .secondary-icon{margin-left:auto}.general-button__badge{position:absolute;top:-10px;right:0;transform:translate(50%)}.general-button__icon{height:var(--icon-size);display:flex;align-items:center;fill:currentColor;align-self:flex-start;margin-top:-1px;margin-right:6px;width:var(--icon-size)}.general-button__icon svg{fill:currentColor;width:inherit;height:inherit}.general-button__icon svg g{fill:currentColor;width:inherit;height:inherit}.general-button__icon svg text{font-family:Siemens Sans,sans-serif}.general-button__label-content+.general-button__icon{margin-right:0;margin-left:6px}.general-button__icon.secondary-icon svg{transition:transform .12s cubic-bezier(.4,0,.3,1)}.general-button__icon.secondary-icon.open svg{transform:translateZ(0) rotate(180deg)}.general-button__label{display:inline-flex;max-height:40px;word-break:break-word;align-items:center;max-width:228px}.general-button__label-content{display:-webkit-box;-webkit-box-orient:vertical;-webkit-line-clamp:2;overflow:hidden;line-height:initial;text-overflow:ellipsis}.general-button__label-content:empty{display:none}.general-button__label-content.disable-line-break{display:block;white-space:nowrap}.general-button__spinner-wrapper{height:100%;position:absolute;display:flex;justify-content:flex-end;align-items:center;min-width:76px;right:16px;top:0}.general-button__spinner-wrapper.sp-fade-in{animation:fadein 1s linear}.bg-light.spinner-active .general-button__spinner-wrapper.fade-out-text{background:linear-gradient(270deg,#b3b3be 19.14%,rgba(179,179,190,0) 100%)}.bg-dark.spinner-active .general-button__spinner-wrapper.fade-out-text{background:linear-gradient(270deg,#737389 19.14%,rgba(115,115,137,0) 100%)}.bg-light.spinner-active.variant-tertiary .general-button__spinner-wrapper.fade-out-text{background:linear-gradient(270deg,#fff 19.14%,rgba(255,255,255,0) 100%)}.bg-dark.spinner-active.variant-tertiary .general-button__spinner-wrapper.fade-out-text{background:linear-gradient(270deg,#000028 19.14%,rgba(0,0,40,0) 100%)}.general-button--max-width{max-width:260px}.general-button--width{width:100%}.general-button:disabled{cursor:not-allowed}.general-button.type-main{--icon-size-default: 20px;display:flex;align-items:center;min-width:96px;min-height:48px;max-height:56px;padding:6px 16px}.general-button.type-main.fade-appearance{transition-property:border-color,background-color,color,fill;transition-duration:.25s;transition-timing-function:cubic-bezier(.2,0,.38,.9)}.general-button.type-main.fade-appearance .general-button__body{transition:margin-right .25s cubic-bezier(.2,0,.38,.9)}.general-button.type-main.variant-primary.bg-light{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, linear-gradient(90deg, #00ffb9 0%, #00e6dc 100%));background:var(--btn-bg)}@media (hover: hover){.general-button.type-main.variant-primary.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-main.variant-primary.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c5ffef);background:var(--btn-bg)}}.general-button.type-main.variant-primary.bg-light:disabled,.general-button.type-main.variant-primary.bg-light.disabled{--btn-bg: var(--btn-bg-custom, #b3b3be);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #ebebee);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-main.variant-primary.bg-dark{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, linear-gradient(90deg, #00ffb9 0%, #00e6dc 100%));background:var(--btn-bg)}@media (hover: hover){.general-button.type-main.variant-primary.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-main.variant-primary.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c5ffef);background:var(--btn-bg)}}.general-button.type-main.variant-primary.bg-dark:disabled,.general-button.type-main.variant-primary.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, #737389);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-main.variant-secondary.bg-light{--btn-color: var(--btn-color-custom, #fff);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, #007993);background:var(--btn-bg)}@media (hover: hover){.general-button.type-main.variant-secondary.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-main.variant-secondary.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #33747a);background:var(--btn-bg)}}.general-button.type-main.variant-secondary.bg-light:disabled,.general-button.type-main.variant-secondary.bg-light.disabled{--btn-bg: var(--btn-bg-custom, #b3b3be);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #ebebee);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-main.variant-secondary.bg-dark{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, #0cc);background:var(--btn-bg)}@media (hover: hover){.general-button.type-main.variant-secondary.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-main.variant-secondary.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #00ffb9);background:var(--btn-bg)}}.general-button.type-main.variant-secondary.bg-dark:disabled,.general-button.type-main.variant-secondary.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, #737389);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-main.variant-tertiary.bg-light{--btn-color: var(--btn-color-custom, #007993);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);border:1px solid #007993;border-radius:0}@media (hover: hover){.general-button.type-main.variant-tertiary.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-main.variant-tertiary.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c2ffee);background:var(--btn-bg);border:1px solid #33747a;border-radius:0;--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-main.variant-tertiary.bg-light:disabled,.general-button.type-main.variant-tertiary.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);border:1px solid #b3b3be;border-radius:0;--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-main.variant-tertiary.bg-dark{--btn-color: var(--btn-color-custom, #0cc);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, rgba(0, 0, 40, .4));background:var(--btn-bg);border:1px solid #0cc;border-radius:0}@media (hover: hover){.general-button.type-main.variant-tertiary.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-main.variant-tertiary.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #001f39);background:var(--btn-bg);border:1px solid #00ffb9;border-radius:0;--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-main.variant-tertiary.bg-dark:disabled,.general-button.type-main.variant-tertiary.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);border:1px solid #b3b3be;border-radius:0;--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-main.with-spinner{overflow:hidden}.general-button.type-main.with-spinner .general-button__label{transition:min-width 1s ease-in-out;min-width:100%}.general-button.type-main.spinner-active{max-width:260px}.general-button.type-main.spinner-active.general-button--width{max-width:100%}.general-button.type-main.spinner-active:not(.fade-text) .general-button__label{min-width:calc(100% + 40px)}.general-button.type-main.spinner-active:not(.fade-text) .general-button__body{padding:0;margin-right:40px}.general-button.type-icon{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}.general-button.type-icon .general-button__spinner-wrapper{min-width:100%;right:0;display:flex;justify-content:center}.general-button.type-icon .general-button__icon svg{opacity:1;transition:opacity .3s ease-in-out}.general-button.type-icon.spinner-active .general-button__icon{opacity:0}.general-button.type-icon.variant-icon-with-label{padding:0 8px}.general-button.type-icon.variant-icon-with-label.position-header{--btn-height-default: 44px;font-size:1.125rem;font-weight:400;line-height:1.5rem}.general-button.type-icon.variant-icon-with-label.position-header.m-black{font-size:1.125rem;font-weight:900;line-height:1.5rem}.general-button.type-icon.variant-icon-with-label.position-header.bg-light{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-with-label.position-header.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-with-label.position-header.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-with-label.position-header.bg-light:disabled,.general-button.type-icon.variant-icon-with-label.position-header.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-with-label.position-header.bg-dark{--btn-color: var(--btn-color-custom, #fff);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-with-label.position-header.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-with-label.position-header.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-with-label.position-header.bg-dark:disabled,.general-button.type-icon.variant-icon-with-label.position-header.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-with-label.position-content{--icon-size-default: 20px;--btn-height-default: 48px}.general-button.type-icon.variant-icon-with-label.position-content.bg-light{--btn-color: var(--btn-color-custom, #007993);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-with-label.position-content.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-with-label.position-content.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c2ffee);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-with-label.position-content.bg-light:disabled,.general-button.type-icon.variant-icon-with-label.position-content.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-with-label.position-content.bg-dark{--btn-color: var(--btn-color-custom, #0cc);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-with-label.position-content.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-with-label.position-content.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #001f39);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-with-label.position-content.bg-dark:disabled,.general-button.type-icon.variant-icon-with-label.position-content.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-menu{--btn-height-default: 44px;min-width:44px;letter-spacing:-.5px}.general-button.type-icon.variant-icon-menu.bg-light{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-menu.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-menu.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-menu.bg-light:disabled,.general-button.type-icon.variant-icon-menu.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-menu.bg-dark{--btn-color: var(--btn-color-custom, #fff);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-menu.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-menu.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-menu.bg-dark:disabled,.general-button.type-icon.variant-icon-menu.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-menu .general-button__label-content{margin-left:16px;font-size:1rem;font-weight:900;line-height:1.5rem}.general-button.type-icon.variant-icon-menu .general-button__icon{margin-top:-1px}.general-button.type-icon.variant-icon-un-contained{--btn-width-default: 44px;--btn-height-default: 44px}.general-button.type-icon.variant-icon-un-contained.position-header.bg-light{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-un-contained.position-header.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-un-contained.position-header.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-un-contained.position-header.bg-light:disabled,.general-button.type-icon.variant-icon-un-contained.position-header.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-un-contained.position-header.bg-dark{--btn-color: var(--btn-color-custom, #fff);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-un-contained.position-header.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-un-contained.position-header.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-un-contained.position-header.bg-dark:disabled,.general-button.type-icon.variant-icon-un-contained.position-header.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-un-contained.position-content.bg-light{--btn-color: var(--btn-color-custom, #4c4c68);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-un-contained.position-content.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-un-contained.position-content.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-un-contained.position-content.bg-light:disabled,.general-button.type-icon.variant-icon-un-contained.position-content.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-un-contained.position-content.bg-dark{--btn-color: var(--btn-color-custom, #e5e5e9);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-un-contained.position-content.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-un-contained.position-content.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-un-contained.position-content.bg-dark:disabled,.general-button.type-icon.variant-icon-un-contained.position-content.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-un-contained.position-content.to-top-button{--btn-color: var(--btn-color-custom, #007993);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-un-contained.position-content:focus{color:var(--btn-focus-color-custom, #33747a)}.general-button.type-icon.variant-icon-contained.position-header{--btn-width-default: 40px;--btn-height-default: 40px}.general-button.type-icon.variant-icon-contained.position-header.bg-light{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, linear-gradient(90deg, #00ffb9 0%, #00e6dc 100%));background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-contained.position-header.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-contained.position-header.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #00646e);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #fff);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-contained.position-header.bg-light:disabled,.general-button.type-icon.variant-icon-contained.position-header.bg-light.disabled{--btn-bg: var(--btn-bg-custom, #b3b3be);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #ebebee);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-contained.position-header.bg-dark{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, linear-gradient(90deg, #00ffb9 0%, #00e6dc 100%));background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-contained.position-header.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-contained.position-header.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c5ffef);background:var(--btn-bg)}}.general-button.type-icon.variant-icon-contained.position-header.bg-dark:disabled,.general-button.type-icon.variant-icon-contained.position-header.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, #737389);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-contained.position-content{--btn-width-default: 48px;--btn-height-default: 48px}.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-light{--btn-color: var(--btn-color-custom, #fff);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, #007993);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #33747a);background:var(--btn-bg)}}.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-light:disabled,.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-light.disabled{--btn-bg: var(--btn-bg-custom, #b3b3be);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #ebebee);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-dark{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, #0cc);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #00ffb9);background:var(--btn-bg)}}.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-dark:disabled,.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, #737389);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-light{--btn-color: var(--btn-color-custom, #007993);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, rgba(255, 255, 255, .6));background:var(--btn-bg);border:1px solid #007993;border-radius:0}@media (hover: hover){.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c2ffee);background:var(--btn-bg);border:1px solid #33747a;border-radius:0;--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-light:disabled,.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-light.disabled{--btn-bg: var(--btn-bg-custom, rgba(255, 255, 255, .6));background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-dark{--btn-color: var(--btn-color-custom, #0cc);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, rgba(0, 0, 40, .4));background:var(--btn-bg);border:1px solid #0cc;border-radius:0}@media (hover: hover){.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #001f39);background:var(--btn-bg);border:1px solid #00ffb9;border-radius:0;--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-dark:disabled,.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, rgba(0, 0, 40, .4));background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-un-contained{padding:0 8px;margin-left:-8px;min-width:96px}.general-button.type-un-contained.bg-light{--btn-color: var(--btn-color-custom, #007993);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-un-contained.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-un-contained.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c2ffee);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-un-contained.bg-light:disabled,.general-button.type-un-contained.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-un-contained.bg-dark{--btn-color: var(--btn-color-custom, #0cc);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-un-contained.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-un-contained.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #001f39);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-un-contained.bg-dark:disabled,.general-button.type-un-contained.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-un-contained.position-content{--icon-size-default: 20px}.general-button.type-un-contained.open{background-color:#c2ffee;color:#33747a}.general-button.not-bold{font-size:1rem;font-weight:400;line-height:1.5rem}@keyframes fadein{0%{opacity:0}to{opacity:1}}\n", ".general-button.type-icon .general-button__icon svg{transition:transform .5s cubic-bezier(.2,0,.38,.9)}.general-button.type-icon .general-button__icon.collapsed svg{transform:rotate(-180deg)}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: i2.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "component", type: UiSpinnerComponent, selector: "sie-ui-spinner", inputs: ["size", "message", "overlayOnTop", "overlay", "active"], outputs: ["animationEnded"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "component", type: UiBadgeComponent, selector: "sie-ui-badge", inputs: ["mode", "type", "number", "addOutline", "highlighted", "status"] }, { kind: "directive", type: i1$1.AttributeDirective, selector: "[sieCoreAttributes]", inputs: ["sieCoreAttributes"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiExpandButtonComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-expand-button', changeDetection: ChangeDetectionStrategy.OnPush, template: "<!-- BUTTON -->\n<ng-container *ngIf=\"isButton\">\n  <button\n    class=\"general-button\"\n    #uiButton\n    [sieCoreAttributes]=\"dataAttributes\"\n    [ngClass]=\"[\n      cssClass,\n      'type-' + themeType,\n      'variant-' + variant,\n      'bg-' + background,\n      'position-' + position,\n      prominence ? 'prominence-' + prominence : '',\n      fullWidth ? 'general-button--width' : 'general-button--max-width',\n      withSpinner ? 'with-spinner' : '',\n      showSpinner ? 'spinner-active' : '',\n      spinnerAnimating ? 'fade-appearance' : '',\n      shouldFadeOutText ? 'fade-text' : '',\n      !bold ? 'not-bold' : '',\n      increasedSize ? 'increased-size' : '',\n      hoverDisabled ? 'hover-disabled' : '',\n      disableLineBreak && !fullWidth ? 'disable-line-break-max-width' : ''\n    ]\"\n    [class.open]=\"isSecondaryIconRotated\"\n    [type]=\"this.buttonType.endsWith('submit') ? 'submit' : 'button'\"\n    (click)=\"onClick($event)\"\n    (focus)=\"onFocus($event)\"\n    [tabIndex]=\"this.focusable ? 0 : -1\"\n    (blur)=\"onBlur($event)\"\n    [disabled]=\"disabled || showSpinner ? 'disabled' : null\"\n    [ngStyle]=\"withSpinner && !fullWidth && !dimensionsSet ? { width: buttonWithSpinnerWidth + 'px' } : ''\"\n  >\n    <ng-container *ngTemplateOutlet=\"contentField\"></ng-container>\n  </button>\n</ng-container>\n\n<!-- EXTERNAL BUTTON (siemens internal and external links) --><a\n  *ngIf=\"!isButton\"\n  #uiButton\n  [sieCoreAttributes]=\"dataAttributes\"\n  [href]=\"link\"\n  [target]=\"target\"\n  class=\"general-button\"\n  rel=\"noopener\"\n  (click)=\"onClick($event)\"\n  [ngClass]=\"[\n    'type-' + themeType,\n    'variant-' + variant,\n    'bg-' + background,\n    'position-' + position,\n    prominence ? 'prominence-' + prominence : '',\n    cssClass,\n    disabled ? 'disabled' : '',\n    fullWidth ? 'general-button--width' : 'general-button--max-width',\n    withSpinner ? 'with-spinner' : '',\n    showSpinner ? 'spinner-active' : '',\n    spinnerAnimating ? 'fade-appearance' : '',\n    shouldFadeOutText ? 'fade-text' : ''\n  ]\"\n>\n  <ng-container *ngTemplateOutlet=\"contentField\"></ng-container>\n</a>\n\n<!-- CONTENT -->\n<ng-template #contentField>\n  <span class=\"general-button__body\" [ngClass]=\"{ 'has-spinner': withSpinner, 'has-secondary-icon': iconSecondary }\">\n    <sie-ui-badge\n      *ngIf=\"badge\"\n      class=\"general-button__badge\"\n      type=\"counter\"\n      [number]=\"badgeNumber\"\n      addOutline\n    ></sie-ui-badge>\n    <span class=\"general-button__label\">\n      <ng-container *ngIf=\"icon && iconPosition === 'leading'\">\n        <sie-icon [name]=\"icon\" class=\"general-button__icon\" [ngClass]=\"getIconClasses()\" aria-hidden=\"true\"></sie-icon>\n        <span *ngIf=\"iconScreenReaderText\" class=\"visually-hidden\">{{ iconScreenReaderText }}</span>\n      </ng-container>\n      <span class=\"general-button__label-content\" [ngClass]=\"{ 'disable-line-break': disableLineBreak }\"\n        ><ng-content></ng-content\n      ></span>\n      <ng-container *ngIf=\"icon && iconPosition === 'trailing'\">\n        <sie-icon [name]=\"icon\" class=\"general-button__icon\" [ngClass]=\"getIconClasses()\"></sie-icon>\n      </ng-container>\n      <ng-container *ngIf=\"iconSecondary\">\n        <sie-icon\n          [name]=\"iconSecondary\"\n          class=\"general-button__icon secondary-icon\"\n          [ngClass]=\"getIconClasses()\"\n          [class.open]=\"isSecondaryIconRotated\"\n        ></sie-icon>\n      </ng-container>\n      <ng-container *ngIf=\"showSpinner || spinnerAnimating\">\n        <div\n          class=\"general-button__spinner-wrapper\"\n          [ngClass]=\"{\n            'sp-fade-in': showSpinner,\n            'fade-out-text': shouldFadeOutText\n          }\"\n        >\n          <sie-ui-spinner\n            [size]=\"spinnerSize\"\n            [active]=\"showSpinner\"\n            (animationEnded)=\"onAnimationEnd()\"\n          ></sie-ui-spinner>\n        </div>\n      </ng-container>\n    </span>\n  </span>\n</ng-template>\n", styles: [":host .general-button{outline:none;outline-offset:0}@media (pointer: fine){:host .general-button{position:relative}:host .general-button:focus{outline:1px solid #1491eb;outline-offset:2px}:host .general-button:focus:not(:focus-visible){outline:0}:host .general-button:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}:host{display:inline-flex;position:relative;--icon-size-default: 24px;--btn-height-default: 48px;--btn-width-default: auto;outline:0}:host(.full-width){width:100%}.general-button.type-icon.variant-icon-contained .general-button__icon,.general-button.type-icon.variant-icon-un-contained .general-button__icon,.general-button.type-icon.variant-icon-menu .general-button__icon{margin:0}.increased-size.general-button.type-icon.variant-icon-contained.position-content,.increased-size.general-button.type-icon.variant-icon-contained.position-header,.increased-size.general-button.type-icon.variant-icon-un-contained,.increased-size.general-button.type-icon.variant-icon-with-label.position-content,.increased-size.general-button.type-icon.variant-icon-with-label.position-header,.increased-size.general-button{--btn-height-default: 56px;--icon-size-default: 28px;min-width:56px}.general-button{font-size:1rem;font-weight:900;line-height:1.5rem;--icon-size: var(--icon-size-custom, var(--icon-size-default));--btn-width: var(--btn-width-custom, var(--btn-width-default));--btn-height: var(--btn-height-custom, var(--btn-height-default));-webkit-user-drag:none;display:inline-flex;flex:1 1 0;align-items:center;justify-content:center;border-width:0;text-align:left;text-decoration:none;cursor:pointer;line-height:var(--icon-size);width:var(--btn-width);height:var(--btn-height)}@media print{.general-button{-webkit-print-color-adjust:exact;print-color-adjust:exact}}.general-button.disable-line-break-max-width{max-width:260px}.general-button__body{position:relative;display:flex;align-items:center;margin-right:0;transition:margin-right 1s ease-in-out}.general-button__body.has-spinner{position:static}.general-button__body.has-secondary-icon{width:100%}@media (max-width: 639.78px){.general-button__body.has-secondary-icon{width:100%}.general-button__body.has-secondary-icon .secondary-icon{position:absolute;right:0}}.general-button__body.has-secondary-icon>span{width:100%}.general-button__body.has-secondary-icon .secondary-icon{margin-left:auto}.general-button__badge{position:absolute;top:-10px;right:0;transform:translate(50%)}.general-button__icon{height:var(--icon-size);display:flex;align-items:center;fill:currentColor;align-self:flex-start;margin-top:-1px;margin-right:6px;width:var(--icon-size)}.general-button__icon svg{fill:currentColor;width:inherit;height:inherit}.general-button__icon svg g{fill:currentColor;width:inherit;height:inherit}.general-button__icon svg text{font-family:Siemens Sans,sans-serif}.general-button__label-content+.general-button__icon{margin-right:0;margin-left:6px}.general-button__icon.secondary-icon svg{transition:transform .12s cubic-bezier(.4,0,.3,1)}.general-button__icon.secondary-icon.open svg{transform:translateZ(0) rotate(180deg)}.general-button__label{display:inline-flex;max-height:40px;word-break:break-word;align-items:center;max-width:228px}.general-button__label-content{display:-webkit-box;-webkit-box-orient:vertical;-webkit-line-clamp:2;overflow:hidden;line-height:initial;text-overflow:ellipsis}.general-button__label-content:empty{display:none}.general-button__label-content.disable-line-break{display:block;white-space:nowrap}.general-button__spinner-wrapper{height:100%;position:absolute;display:flex;justify-content:flex-end;align-items:center;min-width:76px;right:16px;top:0}.general-button__spinner-wrapper.sp-fade-in{animation:fadein 1s linear}.bg-light.spinner-active .general-button__spinner-wrapper.fade-out-text{background:linear-gradient(270deg,#b3b3be 19.14%,rgba(179,179,190,0) 100%)}.bg-dark.spinner-active .general-button__spinner-wrapper.fade-out-text{background:linear-gradient(270deg,#737389 19.14%,rgba(115,115,137,0) 100%)}.bg-light.spinner-active.variant-tertiary .general-button__spinner-wrapper.fade-out-text{background:linear-gradient(270deg,#fff 19.14%,rgba(255,255,255,0) 100%)}.bg-dark.spinner-active.variant-tertiary .general-button__spinner-wrapper.fade-out-text{background:linear-gradient(270deg,#000028 19.14%,rgba(0,0,40,0) 100%)}.general-button--max-width{max-width:260px}.general-button--width{width:100%}.general-button:disabled{cursor:not-allowed}.general-button.type-main{--icon-size-default: 20px;display:flex;align-items:center;min-width:96px;min-height:48px;max-height:56px;padding:6px 16px}.general-button.type-main.fade-appearance{transition-property:border-color,background-color,color,fill;transition-duration:.25s;transition-timing-function:cubic-bezier(.2,0,.38,.9)}.general-button.type-main.fade-appearance .general-button__body{transition:margin-right .25s cubic-bezier(.2,0,.38,.9)}.general-button.type-main.variant-primary.bg-light{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, linear-gradient(90deg, #00ffb9 0%, #00e6dc 100%));background:var(--btn-bg)}@media (hover: hover){.general-button.type-main.variant-primary.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-main.variant-primary.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c5ffef);background:var(--btn-bg)}}.general-button.type-main.variant-primary.bg-light:disabled,.general-button.type-main.variant-primary.bg-light.disabled{--btn-bg: var(--btn-bg-custom, #b3b3be);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #ebebee);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-main.variant-primary.bg-dark{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, linear-gradient(90deg, #00ffb9 0%, #00e6dc 100%));background:var(--btn-bg)}@media (hover: hover){.general-button.type-main.variant-primary.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-main.variant-primary.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c5ffef);background:var(--btn-bg)}}.general-button.type-main.variant-primary.bg-dark:disabled,.general-button.type-main.variant-primary.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, #737389);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-main.variant-secondary.bg-light{--btn-color: var(--btn-color-custom, #fff);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, #007993);background:var(--btn-bg)}@media (hover: hover){.general-button.type-main.variant-secondary.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-main.variant-secondary.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #33747a);background:var(--btn-bg)}}.general-button.type-main.variant-secondary.bg-light:disabled,.general-button.type-main.variant-secondary.bg-light.disabled{--btn-bg: var(--btn-bg-custom, #b3b3be);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #ebebee);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-main.variant-secondary.bg-dark{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, #0cc);background:var(--btn-bg)}@media (hover: hover){.general-button.type-main.variant-secondary.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-main.variant-secondary.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #00ffb9);background:var(--btn-bg)}}.general-button.type-main.variant-secondary.bg-dark:disabled,.general-button.type-main.variant-secondary.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, #737389);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-main.variant-tertiary.bg-light{--btn-color: var(--btn-color-custom, #007993);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);border:1px solid #007993;border-radius:0}@media (hover: hover){.general-button.type-main.variant-tertiary.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-main.variant-tertiary.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c2ffee);background:var(--btn-bg);border:1px solid #33747a;border-radius:0;--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-main.variant-tertiary.bg-light:disabled,.general-button.type-main.variant-tertiary.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);border:1px solid #b3b3be;border-radius:0;--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-main.variant-tertiary.bg-dark{--btn-color: var(--btn-color-custom, #0cc);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, rgba(0, 0, 40, .4));background:var(--btn-bg);border:1px solid #0cc;border-radius:0}@media (hover: hover){.general-button.type-main.variant-tertiary.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-main.variant-tertiary.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #001f39);background:var(--btn-bg);border:1px solid #00ffb9;border-radius:0;--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-main.variant-tertiary.bg-dark:disabled,.general-button.type-main.variant-tertiary.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);border:1px solid #b3b3be;border-radius:0;--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-main.with-spinner{overflow:hidden}.general-button.type-main.with-spinner .general-button__label{transition:min-width 1s ease-in-out;min-width:100%}.general-button.type-main.spinner-active{max-width:260px}.general-button.type-main.spinner-active.general-button--width{max-width:100%}.general-button.type-main.spinner-active:not(.fade-text) .general-button__label{min-width:calc(100% + 40px)}.general-button.type-main.spinner-active:not(.fade-text) .general-button__body{padding:0;margin-right:40px}.general-button.type-icon{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}.general-button.type-icon .general-button__spinner-wrapper{min-width:100%;right:0;display:flex;justify-content:center}.general-button.type-icon .general-button__icon svg{opacity:1;transition:opacity .3s ease-in-out}.general-button.type-icon.spinner-active .general-button__icon{opacity:0}.general-button.type-icon.variant-icon-with-label{padding:0 8px}.general-button.type-icon.variant-icon-with-label.position-header{--btn-height-default: 44px;font-size:1.125rem;font-weight:400;line-height:1.5rem}.general-button.type-icon.variant-icon-with-label.position-header.m-black{font-size:1.125rem;font-weight:900;line-height:1.5rem}.general-button.type-icon.variant-icon-with-label.position-header.bg-light{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-with-label.position-header.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-with-label.position-header.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-with-label.position-header.bg-light:disabled,.general-button.type-icon.variant-icon-with-label.position-header.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-with-label.position-header.bg-dark{--btn-color: var(--btn-color-custom, #fff);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-with-label.position-header.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-with-label.position-header.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-with-label.position-header.bg-dark:disabled,.general-button.type-icon.variant-icon-with-label.position-header.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-with-label.position-content{--icon-size-default: 20px;--btn-height-default: 48px}.general-button.type-icon.variant-icon-with-label.position-content.bg-light{--btn-color: var(--btn-color-custom, #007993);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-with-label.position-content.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-with-label.position-content.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c2ffee);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-with-label.position-content.bg-light:disabled,.general-button.type-icon.variant-icon-with-label.position-content.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-with-label.position-content.bg-dark{--btn-color: var(--btn-color-custom, #0cc);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-with-label.position-content.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-with-label.position-content.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #001f39);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-with-label.position-content.bg-dark:disabled,.general-button.type-icon.variant-icon-with-label.position-content.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-menu{--btn-height-default: 44px;min-width:44px;letter-spacing:-.5px}.general-button.type-icon.variant-icon-menu.bg-light{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-menu.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-menu.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-menu.bg-light:disabled,.general-button.type-icon.variant-icon-menu.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-menu.bg-dark{--btn-color: var(--btn-color-custom, #fff);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-menu.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-menu.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-menu.bg-dark:disabled,.general-button.type-icon.variant-icon-menu.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-menu .general-button__label-content{margin-left:16px;font-size:1rem;font-weight:900;line-height:1.5rem}.general-button.type-icon.variant-icon-menu .general-button__icon{margin-top:-1px}.general-button.type-icon.variant-icon-un-contained{--btn-width-default: 44px;--btn-height-default: 44px}.general-button.type-icon.variant-icon-un-contained.position-header.bg-light{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-un-contained.position-header.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-un-contained.position-header.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-un-contained.position-header.bg-light:disabled,.general-button.type-icon.variant-icon-un-contained.position-header.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-un-contained.position-header.bg-dark{--btn-color: var(--btn-color-custom, #fff);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-un-contained.position-header.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-un-contained.position-header.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-un-contained.position-header.bg-dark:disabled,.general-button.type-icon.variant-icon-un-contained.position-header.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-un-contained.position-content.bg-light{--btn-color: var(--btn-color-custom, #4c4c68);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-un-contained.position-content.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-un-contained.position-content.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-un-contained.position-content.bg-light:disabled,.general-button.type-icon.variant-icon-un-contained.position-content.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-un-contained.position-content.bg-dark{--btn-color: var(--btn-color-custom, #e5e5e9);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-un-contained.position-content.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-un-contained.position-content.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-un-contained.position-content.bg-dark:disabled,.general-button.type-icon.variant-icon-un-contained.position-content.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-un-contained.position-content.to-top-button{--btn-color: var(--btn-color-custom, #007993);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-un-contained.position-content:focus{color:var(--btn-focus-color-custom, #33747a)}.general-button.type-icon.variant-icon-contained.position-header{--btn-width-default: 40px;--btn-height-default: 40px}.general-button.type-icon.variant-icon-contained.position-header.bg-light{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, linear-gradient(90deg, #00ffb9 0%, #00e6dc 100%));background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-contained.position-header.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-contained.position-header.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #00646e);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #fff);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-contained.position-header.bg-light:disabled,.general-button.type-icon.variant-icon-contained.position-header.bg-light.disabled{--btn-bg: var(--btn-bg-custom, #b3b3be);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #ebebee);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-contained.position-header.bg-dark{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, linear-gradient(90deg, #00ffb9 0%, #00e6dc 100%));background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-contained.position-header.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-contained.position-header.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c5ffef);background:var(--btn-bg)}}.general-button.type-icon.variant-icon-contained.position-header.bg-dark:disabled,.general-button.type-icon.variant-icon-contained.position-header.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, #737389);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-contained.position-content{--btn-width-default: 48px;--btn-height-default: 48px}.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-light{--btn-color: var(--btn-color-custom, #fff);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, #007993);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #33747a);background:var(--btn-bg)}}.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-light:disabled,.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-light.disabled{--btn-bg: var(--btn-bg-custom, #b3b3be);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #ebebee);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-dark{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, #0cc);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #00ffb9);background:var(--btn-bg)}}.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-dark:disabled,.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, #737389);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-light{--btn-color: var(--btn-color-custom, #007993);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, rgba(255, 255, 255, .6));background:var(--btn-bg);border:1px solid #007993;border-radius:0}@media (hover: hover){.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c2ffee);background:var(--btn-bg);border:1px solid #33747a;border-radius:0;--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-light:disabled,.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-light.disabled{--btn-bg: var(--btn-bg-custom, rgba(255, 255, 255, .6));background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-dark{--btn-color: var(--btn-color-custom, #0cc);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, rgba(0, 0, 40, .4));background:var(--btn-bg);border:1px solid #0cc;border-radius:0}@media (hover: hover){.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #001f39);background:var(--btn-bg);border:1px solid #00ffb9;border-radius:0;--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-dark:disabled,.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, rgba(0, 0, 40, .4));background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-un-contained{padding:0 8px;margin-left:-8px;min-width:96px}.general-button.type-un-contained.bg-light{--btn-color: var(--btn-color-custom, #007993);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-un-contained.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-un-contained.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c2ffee);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-un-contained.bg-light:disabled,.general-button.type-un-contained.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-un-contained.bg-dark{--btn-color: var(--btn-color-custom, #0cc);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-un-contained.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-un-contained.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #001f39);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-un-contained.bg-dark:disabled,.general-button.type-un-contained.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-un-contained.position-content{--icon-size-default: 20px}.general-button.type-un-contained.open{background-color:#c2ffee;color:#33747a}.general-button.not-bold{font-size:1rem;font-weight:400;line-height:1.5rem}@keyframes fadein{0%{opacity:0}to{opacity:1}}\n", ".general-button.type-icon .general-button__icon svg{transition:transform .5s cubic-bezier(.2,0,.38,.9)}.general-button.type-icon .general-button__icon.collapsed svg{transform:rotate(-180deg)}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i1.SieIconRegistryService }]; }, propDecorators: { expanded: [{
                type: Input
            }] } });

const UI_BUTTON_WRAPPER_EXTENSIONS = 'UI_BUTTON_WRAPPER_EXTENSIONS';

class UiButtonWrapperComponent {
    constructor(renderer, cdr, extensions) {
        this.renderer = renderer;
        this.cdr = cdr;
        this.extensions = extensions;
        this.clicked = new Subject();
    }
    ngOnInit() {
        if (this.model && Object.keys(this.model).length) {
            if (this.model['modalInformation'] !== null && this.model['modalInformation'] !== undefined) {
                this.type = 'modal';
            }
            else if (this.model['route']) {
                this.type = 'route';
            }
            else {
                this.type = 'button';
            }
        }
    }
    ngAfterViewInit() {
        if (this.type && this.type !== 'button') {
            const componentType = this.extensions?.[this.type];
            if (!componentType) {
                this.type = 'button';
                this.cdr.detectChanges();
                return;
            }
            const innerText = this.renderer.createText(this.model.label);
            const newElem = this.item.createComponent(componentType, {
                projectableNodes: [[innerText]]
            });
            if (this.model.id) {
                newElem.location.nativeElement.id = this.model.id;
            }
            newElem.instance.link = this.model.link;
            newElem.instance.buttonType = this.model.buttonType;
            newElem.instance.variant = this.model.variant;
            newElem.instance.background = this.model.background;
            newElem.instance.icon = this.model.icon;
            newElem.instance.iconPosition = this.model.iconPosition;
            newElem.instance.cssClass = this.model.cssClass || '';
            newElem.instance.disabled = this.model.disabled;
            newElem.instance.dataAttributes = this.model.dataAttributes;
            newElem.instance.fullWidth = this.model.fullWidth;
            newElem.instance.disableLineBreak = this.model.disableLineBreak;
            newElem.instance.target = this.model.target;
            newElem.instance.clicked.subscribe(event => {
                this.onClick(event);
            });
            newElem.instance.applyExtraData(this.model);
            newElem.hostView.detectChanges();
        }
    }
    onClick(event) {
        this.clicked.next(event);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiButtonWrapperComponent, deps: [{ token: i0.Renderer2 }, { token: i0.ChangeDetectorRef }, { token: UI_BUTTON_WRAPPER_EXTENSIONS, optional: true }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiButtonWrapperComponent, selector: "sie-ui-button-wrapper", inputs: { model: "model" }, outputs: { clicked: "clicked" }, viewQueries: [{ propertyName: "item", first: true, predicate: ["extensionSlot"], descendants: true, read: ViewContainerRef }], ngImport: i0, template: "<sie-ui-button\n  *ngIf=\"type === 'button'\"\n  [attr.id]=\"model.id ? model.id : null\"\n  [link]=\"model.link\"\n  [buttonType]=\"model.buttonType\"\n  [variant]=\"model.variant\"\n  [background]=\"model.background\"\n  [icon]=\"model.icon\"\n  [iconPosition]=\"model.iconPosition\"\n  [cssClass]=\"model.cssClass || ''\"\n  [disabled]=\"model.disabled\"\n  [fullWidth]=\"model.fullWidth\"\n  [dataAttributes]=\"model.dataAttributes\"\n  [disableLineBreak]=\"model.disableLineBreak || false\"\n  [target]=\"model.target || '_self'\"\n  (clicked)=\"onClick($event)\"\n  [withSpinner]=\"model.withSpinner || false\"\n  [showSpinner]=\"model.showSpinner || false\"\n  [themeType]=\"model.themeType || 'main'\"\n  >{{ model.label }}</sie-ui-button\n>\n\n<ng-container #extensionSlot></ng-container>\n", dependencies: [{ kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: UiButtonComponent, selector: "sie-ui-button" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiButtonWrapperComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-button-wrapper', changeDetection: ChangeDetectionStrategy.OnPush, template: "<sie-ui-button\n  *ngIf=\"type === 'button'\"\n  [attr.id]=\"model.id ? model.id : null\"\n  [link]=\"model.link\"\n  [buttonType]=\"model.buttonType\"\n  [variant]=\"model.variant\"\n  [background]=\"model.background\"\n  [icon]=\"model.icon\"\n  [iconPosition]=\"model.iconPosition\"\n  [cssClass]=\"model.cssClass || ''\"\n  [disabled]=\"model.disabled\"\n  [fullWidth]=\"model.fullWidth\"\n  [dataAttributes]=\"model.dataAttributes\"\n  [disableLineBreak]=\"model.disableLineBreak || false\"\n  [target]=\"model.target || '_self'\"\n  (clicked)=\"onClick($event)\"\n  [withSpinner]=\"model.withSpinner || false\"\n  [showSpinner]=\"model.showSpinner || false\"\n  [themeType]=\"model.themeType || 'main'\"\n  >{{ model.label }}</sie-ui-button\n>\n\n<ng-container #extensionSlot></ng-container>\n" }]
        }], ctorParameters: function () { return [{ type: i0.Renderer2 }, { type: i0.ChangeDetectorRef }, { type: undefined, decorators: [{
                    type: Optional
                }, {
                    type: Inject,
                    args: [UI_BUTTON_WRAPPER_EXTENSIONS]
                }] }]; }, propDecorators: { model: [{
                type: Input
            }], clicked: [{
                type: Output
            }], item: [{
                type: ViewChild,
                args: ['extensionSlot', { read: ViewContainerRef }]
            }] } });

/**
 * # Button Module
 * - {@link UiButtonComponent}
 *
 * ## Module peer dependencies
 * - {@link SieIconsModule}: the package is optional depends on the button `theme-type`,
 *   it is required when the type is `icon`.
 */
class UiButtonModule {
    static withWrapperConfig(config) {
        return {
            ngModule: UiButtonModule,
            providers: [
                {
                    provide: UI_BUTTON_WRAPPER_EXTENSIONS,
                    useValue: config,
                    multi: true
                }
            ]
        };
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiButtonModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiButtonModule, declarations: [UiButtonComponent, UiExpandButtonComponent, UiButtonWrapperComponent], imports: [CommonModule, UiSpinnerModule, SieIconsModule, AddTooltipModule, UiBadgeModule, AttributeModule], exports: [UiButtonComponent, UiExpandButtonComponent, UiButtonWrapperComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiButtonModule, imports: [CommonModule, UiSpinnerModule, SieIconsModule, AddTooltipModule, UiBadgeModule, AttributeModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiButtonModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiButtonComponent, UiExpandButtonComponent, UiButtonWrapperComponent],
                    exports: [UiButtonComponent, UiExpandButtonComponent, UiButtonWrapperComponent],
                    imports: [CommonModule, UiSpinnerModule, SieIconsModule, AddTooltipModule, UiBadgeModule, AttributeModule]
                }]
        }] });

class UiFilterHeaderModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiFilterHeaderModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiFilterHeaderModule, declarations: [UiFilterHeaderComponent], imports: [CommonModule, UiTagModule, UiButtonModule, AddTooltipModule], exports: [UiFilterHeaderComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiFilterHeaderModule, imports: [CommonModule, UiTagModule, UiButtonModule, AddTooltipModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiFilterHeaderModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiFilterHeaderComponent],
                    imports: [CommonModule, UiTagModule, UiButtonModule, AddTooltipModule],
                    exports: [UiFilterHeaderComponent]
                }]
        }] });

/**
 * This directive is used to display items within an accordion and for setting their parameter values.
 */
class UiAccordionItemDirective {
    /**
     * @param value Defines if the top border on accordion item should be shown.
     * @default false
     */
    set showTopBorder(value) {
        this._showTopBorder = coerceBooleanProperty(value);
    }
    get showTopBorder() {
        return this._showTopBorder;
    }
    /**
     * @param value Defines the look of the headline: regular or bold (enhanced, bigger)
     * @default false
     */
    set headlineBold(value) {
        this._headlineBold = coerceBooleanProperty(value);
    }
    get headlineBold() {
        return this._headlineBold;
    }
    /**
     * @param icon {@link SieIcon Icon} Defines optional custom icon at the beggining of headline
     */
    set icon(icon) {
        if (icon) {
            this.iconReg.register(icon);
            this._icon = icon;
        }
    }
    get icon() {
        return this._icon;
    }
    /**
     * @param value Defines if the accordion item should be expanded.
     * @default false
     */
    set open(value) {
        this._open = coerceBooleanProperty(value);
    }
    get open() {
        return this._open;
    }
    constructor(templateRef, iconReg) {
        this.templateRef = templateRef;
        this.iconReg = iconReg;
        /**
         * Defines optional subheadline shown below headline in open and closed state
         */
        this.subHeadline = '';
        this._headlineBold = false;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiAccordionItemDirective, deps: [{ token: i0.TemplateRef }, { token: i1.SieIconRegistryService }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: UiAccordionItemDirective, selector: "[sieUiAccordionItem]", inputs: { headline: "headline", subHeadline: "subHeadline", id: "id", showTopBorder: "showTopBorder", headlineBold: "headlineBold", icon: "icon", open: "open" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiAccordionItemDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[sieUiAccordionItem]'
                }]
        }], ctorParameters: function () { return [{ type: i0.TemplateRef }, { type: i1.SieIconRegistryService }]; }, propDecorators: { headline: [{
                type: Input
            }], subHeadline: [{
                type: Input
            }], id: [{
                type: Input
            }], showTopBorder: [{
                type: Input
            }], headlineBold: [{
                type: Input
            }], icon: [{
                type: Input
            }], open: [{
                type: Input
            }] } });

// injection token
const UI_ACCORDION_WEB_COMPONENT_SERVICE = 'UI_ACCORDION_WEB_COMPONENT_SERVICE';

/**
 * This directive is used to display custom content inside accordion item`s header.
 */
class UiAccordionItemHeaderDirective {
    constructor(templateRef) {
        this.templateRef = templateRef;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiAccordionItemHeaderDirective, deps: [{ token: i0.TemplateRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: UiAccordionItemHeaderDirective, selector: "[sieUiAccordionItemHeader]", inputs: { parentId: "parentId" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiAccordionItemHeaderDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[sieUiAccordionItemHeader]'
                }]
        }], ctorParameters: function () { return [{ type: i0.TemplateRef }]; }, propDecorators: { parentId: [{
                type: Input
            }] } });

const toggleAnimationTiming1$1 = AnimationDurationFast + ' ' + EasingStandardProductive;
const toggleAnimationTiming2 = '10ms';
const toggleItemAnimation = trigger('toggleItem', [
    state('closed', style({ opacity: 0, height: '0' })),
    state('opened', style({ opacity: 1, height: '*' })),
    transition('* => closed', sequence([
        animate(toggleAnimationTiming2, style({
            opacity: 0
        })),
        animate(toggleAnimationTiming1$1, style({
            height: '0'
        }))
    ])),
    transition('* => opened', sequence([
        animate(toggleAnimationTiming1$1, style({
            height: '*'
        })),
        animate(toggleAnimationTiming2, style({
            opacity: 1
        }))
    ]))
]);

/**
 * # Accordion Item Component
 *
 * The accordion item represents each individual item within the accordion component
 * (although the accordion item component can be used independently,
 * always use it in combination with the accordion component).
 *
 * ## Component variations
 *
 * There are no variations.
 *
 * ## Content
 *
 * The content of the accordion item component can be any valid markup.
 *
 * ## Code example
 * @example
 * Template:
 * ```html
 * <sie-ui-accordion-item
 *   *ngFor="let item of accordionItems"
 *   [headline]="item.headline"
 *   [subHeadline]="item.subHeadline"
 *   [showTopBorder]="item.showTopBorder"
 *   [headlineBold]="item.headlineBold"
 *   [icon]="item.icon"
 *   [id]="item.id"
 *   [open]="item.open"
 * >
 *   <div>{{ item.html }}</div>
 * </sie-ui-accordion-item>
 * ```
 *
 * Accordion item data example:
 * ```js
 *  accordionItems = [
 *   {
 *     headline: 'Headline',
 *     subHeadline: 'Sub Headline',
 *     showTopBorder: true,
 *     icon: SieIcon.Information,
 *     id: 'test-id',
 *     open: false,
 *     html: 'Lorem ipsum dolor sit amet, consetetur sadipscing elitr'
 *   },
 *   {
 *     headline: 'Headline 2',
 *     showTopBorder: true,
 *     headlineBold: true,
 *     id: 'test-id-2',
 *     open: true,
 *     html: 'Hello World!'
 *   }
 * ];
 * ```
 */
class UiAccordionItemComponent {
    /**
     * @param value Defines if the top border on accordion item should be shown.
     * @default false
     */
    set showTopBorder(value) {
        this._showTopBorder = coerceBooleanProperty(value);
    }
    get showTopBorder() {
        return this._showTopBorder;
    }
    /**
     * @param value defines the look of the headline: regular or bold (enhanced, bigger)
     * @default false
     */
    set headlineBold(value) {
        this._headlineBold = coerceBooleanProperty(value);
    }
    get headlineBold() {
        return this._headlineBold;
    }
    /**
     * @param icon {@link SieIcon Icon} Defines optional custom icon before the headline
     */
    set icon(icon) {
        if (icon) {
            this.iconReg.register(icon);
            this._icon = icon;
        }
    }
    get icon() {
        return this._icon;
    }
    /**
     * @param open Defines if the accordion item should be expanded by default.
     * @default false
     */
    set open(open) {
        if (open !== undefined) {
            this._open = open;
        }
    }
    get open() {
        return this._open;
    }
    /**
     * @param value Defines if the accordion should display custom header content or not. It becomes true once header
     * content for the item is correctly provided.
     * @default false
     */
    set customHeaderContent(value) {
        this._customHeaderContent = coerceBooleanProperty(value);
    }
    get customHeaderContent() {
        return this._customHeaderContent;
    }
    constructor(iconReg, cdr) {
        this.iconReg = iconReg;
        this.cdr = cdr;
        /**
         * Defines optional subheadline shown below headline in open and closed state
         */
        this.subHeadline = '';
        /**
         * Event triggered when the accordion item is clicked.
         */
        this.clicked = new Subject();
        /** @ignore */
        this.componentViewports = new Map([
            ['S', 0],
            ['L', 361]
        ]);
        /** @ignore */
        this.hoverActive = false;
        /** @ignore */
        this.animationRunning = false;
        /** @ignore */
        this.userAction = false;
        this._showTopBorder = false;
        this._open = false;
        this._headlineBold = false;
        this._customHeaderContent = false;
        iconReg.register(SieIcon.ArrowDown);
    }
    /** @ignore */
    setBreakpoint(breakpoint) {
        this.breakpoint = breakpoint;
        this.cdr.detectChanges();
    }
    /** @ignore */
    onToggle() {
        if (this.animationRunning) {
            return;
        }
        this.userAction = true;
        this.animationRunning = true;
        this.open = !this.open;
    }
    /** @ignore */
    mouseEnter() {
        this.hoverActive = true;
    }
    /** @ignore */
    mouseLeave() {
        this.hoverActive = false;
    }
    /** @ignore */
    onAnimationEvent() {
        this.animationRunning = false;
        if (this.userAction) {
            this.userAction = false;
            this.clicked.next(this.open);
        }
    }
    stopHeaderPropagation(event) {
        event.stopPropagation();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiAccordionItemComponent, deps: [{ token: i1.SieIconRegistryService }, { token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiAccordionItemComponent, selector: "sie-ui-accordion-item", inputs: { headline: "headline", subHeadline: "subHeadline", id: "id", showTopBorder: "showTopBorder", headlineBold: "headlineBold", icon: "icon", open: "open", customHeaderContent: "customHeaderContent" }, outputs: { clicked: "clicked" }, viewQueries: [{ propertyName: "accordionBody", first: true, predicate: ["accordionBody"], descendants: true }, { propertyName: "accordionItem", first: true, predicate: ["accordionItem"], descendants: true }], ngImport: i0, template: "<div\n  #accordionItem\n  class=\"accordion-item\"\n  [ngClass]=\"{\n    'active-hover': hoverActive,\n    'accordion-item--with-top-border': showTopBorder,\n    'accordion-item--custom-header-content': customHeaderContent\n  }\"\n  [sieCoreComponentBreakpoints]=\"componentViewports\"\n  (componentViewportChanged)=\"setBreakpoint($event)\"\n>\n  <div\n    class=\"accordion-item__header\"\n    [class.accordion-item__header--with-subheadline]=\"subHeadline\"\n    tabindex=\"0\"\n    (click)=\"onToggle()\"\n    (keydown.enter)=\"onToggle()\"\n    (mouseenter)=\"mouseEnter()\"\n    (mouseleave)=\"mouseLeave()\"\n    role=\"tab\"\n    [id]=\"id\"\n  >\n    <div class=\"accordion-item__header__content\" [class.headline-bold]=\"headlineBold\">\n      <sie-icon *ngIf=\"icon\" class=\"accordion-item__header__custom-icon\" [name]=\"icon\" aria-hidden=\"true\"></sie-icon>\n      <div class=\"accordion-item__header__headline-wrapper\">\n        <span class=\"accordion-item__header__headline\">{{ headline }}</span>\n        <span *ngIf=\"subHeadline\" class=\"accordion-item__header__subheadline\">{{ subHeadline }}</span>\n      </div>\n\n      <div\n        *ngIf=\"open && customHeaderContent\"\n        class=\"custom-header-content\"\n        (click)=\"stopHeaderPropagation($event)\"\n        (keydown.enter)=\"stopHeaderPropagation($event)\"\n      >\n        <ng-content select=\"[headerSlot]\"></ng-content>\n      </div>\n    </div>\n    <div\n      class=\"accordion-item__header__icon-wrapper\"\n      [ngClass]=\"{ open: open }\"\n      role=\"button\"\n      [attr.aria-expanded]=\"open\"\n      [attr.aria-controls]=\"'collapse-' + id\"\n    >\n      <sie-icon [name]=\"iconReg.sieIcon.ArrowDown\" class=\"accordion-item__header__icon\"></sie-icon>\n    </div>\n  </div>\n  <div\n    #accordionBody\n    [ngClass]=\"[open ? 'opened' : 'closed']\"\n    [@toggleItem]=\"[open ? 'opened' : 'closed']\"\n    (@toggleItem.done)=\"onAnimationEvent()\"\n    class=\"accordion-item__body\"\n    role=\"tabpanel\"\n    [attr.aria-expanded]=\"open\"\n    [attr.aria-labelledby]=\"id\"\n    [id]=\"'collapse-' + id\"\n  >\n    <ng-container *ngIf=\"open || (!open && animationRunning)\">\n      <ng-content></ng-content>\n    </ng-container>\n  </div>\n</div>\n", styles: [".accordion-item__header{outline:none;outline-offset:0}@media (pointer: fine){.accordion-item__header{position:relative}.accordion-item__header:focus{outline:1px solid #1491eb;outline-offset:2px}.accordion-item__header:focus:not(:focus-visible){outline:0}.accordion-item__header:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}.accordion-item{border-bottom:1px solid #ccccd4;container:accordion-item/inline-size}.accordion-item--with-top-border{margin-top:-1px;border-top:1px solid #ccccd4}.accordion-item__header{display:flex;justify-content:space-between;align-items:center;padding:16px 12px 16px 16px;word-break:break-all}.accordion-item__header--with-subheadline{padding-top:8px;padding-bottom:8px}.component-viewport--S .accordion-item__header{padding:16px 0}.accordion-item__header__content{max-width:100%;display:flex;align-items:center;color:#007993}@media (min-width: 640px){.accordion-item__header__content{max-width:calc(calc(100vw - 208px)/12 * 8 + 112px)}}@media (min-width: 1024px){.accordion-item__header__content{max-width:calc(calc(100vw - 376px)/12 * 8 + 168px)}}@media (min-width: 1440px){.accordion-item__header__content{max-width:calc(calc(100vw - 456px)/12 * 8 + 168px)}}@media (min-width: 1920px){.accordion-item__header__content{max-width:1144px}}.accordion-item__header__content.headline-bold{color:#000028}.accordion-item__header__headline{display:-webkit-box;-webkit-box-orient:vertical;-webkit-line-clamp:2;text-overflow:ellipsis;overflow:hidden}.headline-bold .accordion-item__header__headline{font-size:1.25rem;font-weight:700;line-height:1.625rem}.accordion-item__header__subheadline{font-size:.75rem;font-weight:400;line-height:1rem;display:block;color:#000028}.accordion-item__header__custom-icon{width:24px;height:24px;display:flex;align-items:center;fill:currentColor;margin-right:10px}.accordion-item__header__custom-icon svg{fill:currentColor;width:inherit;height:inherit}.accordion-item__header__custom-icon svg g{fill:currentColor;width:inherit;height:inherit}.accordion-item__header__custom-icon svg text{font-family:Siemens Sans,sans-serif}.headline-bold .accordion-item__header__custom-icon{margin-right:12px}.accordion-item__header__icon{width:24px;height:24px;display:flex;align-items:center;fill:currentColor}.accordion-item__header__icon svg{fill:currentColor;width:inherit;height:inherit}.accordion-item__header__icon svg g{fill:currentColor;width:inherit;height:inherit}.accordion-item__header__icon svg text{font-family:Siemens Sans,sans-serif}.accordion-item__header__icon-wrapper{margin-left:12px;color:#007993;flex-shrink:0}.component-viewport--S .accordion-item__header__icon-wrapper{position:relative;right:-5px;margin-left:16px}.accordion-item__header__icon svg{transition:transform .25s cubic-bezier(.2,0,.38,.9)}.open .accordion-item__header__icon svg{--translateValue: 0;transform:translate3d(var(--translateValue),var(--translateValue),var(--translateValue)) rotate(180deg)}.accordion-item__body{padding:0 16px}.component-viewport--S .accordion-item__body{padding:0}.accordion-item__body.opened{margin-bottom:24px}.accordion-item__body:hover{cursor:auto}.accordion-item--custom-header-content .accordion-item__header{display:flex;align-items:flex-start}@container accordion-item (min-width: 608px){.accordion-item--custom-header-content .accordion-item__header{padding-top:12px}}.accordion-item--custom-header-content .accordion-item__header .custom-header-content{display:flex;margin-left:auto;align-self:flex-start;flex-direction:row;align-items:center}@container accordion-item (max-width: 607px){.accordion-item--custom-header-content .accordion-item__header .custom-header-content{flex:1 1 calc(100% - 40px);margin-top:11px;margin-left:0}}@container accordion-item (max-width: 607px){.accordion-item--custom-header-content .accordion-item__header sie-icon{display:flex;flex:0 1 24px}}@container accordion-item (min-width: 608px){.accordion-item--custom-header-content .accordion-item__header__icon-wrapper{position:relative;top:6px}}.accordion-item--custom-header-content .accordion-item__header__headline-wrapper{word-break:normal;display:flex;flex-direction:column;flex:1 1 calc(100% - 36px)}@container accordion-item (min-width: 608px){.accordion-item--custom-header-content .accordion-item__header__headline-wrapper{margin:4px 16px 0 0}}.accordion-item--custom-header-content .accordion-item__header__content{display:flex;flex-wrap:wrap;overflow:hidden}@container accordion-item (min-width: 608px){.accordion-item--custom-header-content .accordion-item__header__content{width:100%;max-width:100%;display:flex;flex-direction:row;flex-wrap:nowrap}}.accordion-item.active-hover{cursor:pointer;margin-top:-1px;border-bottom:1px solid #33747a;border-top:1px solid #33747a}.accordion-item.active-hover .accordion-item__header__content,.accordion-item.active-hover .accordion-item__header__icon-wrapper{color:#33747a}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "directive", type: i1$1.ComponentBreakpointsDirective, selector: "[sieCoreComponentBreakpoints]", inputs: ["sieCoreComponentBreakpoints"], outputs: ["componentViewportChanged"] }], animations: [toggleItemAnimation], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiAccordionItemComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-accordion-item', animations: [toggleItemAnimation], changeDetection: ChangeDetectionStrategy.OnPush, template: "<div\n  #accordionItem\n  class=\"accordion-item\"\n  [ngClass]=\"{\n    'active-hover': hoverActive,\n    'accordion-item--with-top-border': showTopBorder,\n    'accordion-item--custom-header-content': customHeaderContent\n  }\"\n  [sieCoreComponentBreakpoints]=\"componentViewports\"\n  (componentViewportChanged)=\"setBreakpoint($event)\"\n>\n  <div\n    class=\"accordion-item__header\"\n    [class.accordion-item__header--with-subheadline]=\"subHeadline\"\n    tabindex=\"0\"\n    (click)=\"onToggle()\"\n    (keydown.enter)=\"onToggle()\"\n    (mouseenter)=\"mouseEnter()\"\n    (mouseleave)=\"mouseLeave()\"\n    role=\"tab\"\n    [id]=\"id\"\n  >\n    <div class=\"accordion-item__header__content\" [class.headline-bold]=\"headlineBold\">\n      <sie-icon *ngIf=\"icon\" class=\"accordion-item__header__custom-icon\" [name]=\"icon\" aria-hidden=\"true\"></sie-icon>\n      <div class=\"accordion-item__header__headline-wrapper\">\n        <span class=\"accordion-item__header__headline\">{{ headline }}</span>\n        <span *ngIf=\"subHeadline\" class=\"accordion-item__header__subheadline\">{{ subHeadline }}</span>\n      </div>\n\n      <div\n        *ngIf=\"open && customHeaderContent\"\n        class=\"custom-header-content\"\n        (click)=\"stopHeaderPropagation($event)\"\n        (keydown.enter)=\"stopHeaderPropagation($event)\"\n      >\n        <ng-content select=\"[headerSlot]\"></ng-content>\n      </div>\n    </div>\n    <div\n      class=\"accordion-item__header__icon-wrapper\"\n      [ngClass]=\"{ open: open }\"\n      role=\"button\"\n      [attr.aria-expanded]=\"open\"\n      [attr.aria-controls]=\"'collapse-' + id\"\n    >\n      <sie-icon [name]=\"iconReg.sieIcon.ArrowDown\" class=\"accordion-item__header__icon\"></sie-icon>\n    </div>\n  </div>\n  <div\n    #accordionBody\n    [ngClass]=\"[open ? 'opened' : 'closed']\"\n    [@toggleItem]=\"[open ? 'opened' : 'closed']\"\n    (@toggleItem.done)=\"onAnimationEvent()\"\n    class=\"accordion-item__body\"\n    role=\"tabpanel\"\n    [attr.aria-expanded]=\"open\"\n    [attr.aria-labelledby]=\"id\"\n    [id]=\"'collapse-' + id\"\n  >\n    <ng-container *ngIf=\"open || (!open && animationRunning)\">\n      <ng-content></ng-content>\n    </ng-container>\n  </div>\n</div>\n", styles: [".accordion-item__header{outline:none;outline-offset:0}@media (pointer: fine){.accordion-item__header{position:relative}.accordion-item__header:focus{outline:1px solid #1491eb;outline-offset:2px}.accordion-item__header:focus:not(:focus-visible){outline:0}.accordion-item__header:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}.accordion-item{border-bottom:1px solid #ccccd4;container:accordion-item/inline-size}.accordion-item--with-top-border{margin-top:-1px;border-top:1px solid #ccccd4}.accordion-item__header{display:flex;justify-content:space-between;align-items:center;padding:16px 12px 16px 16px;word-break:break-all}.accordion-item__header--with-subheadline{padding-top:8px;padding-bottom:8px}.component-viewport--S .accordion-item__header{padding:16px 0}.accordion-item__header__content{max-width:100%;display:flex;align-items:center;color:#007993}@media (min-width: 640px){.accordion-item__header__content{max-width:calc(calc(100vw - 208px)/12 * 8 + 112px)}}@media (min-width: 1024px){.accordion-item__header__content{max-width:calc(calc(100vw - 376px)/12 * 8 + 168px)}}@media (min-width: 1440px){.accordion-item__header__content{max-width:calc(calc(100vw - 456px)/12 * 8 + 168px)}}@media (min-width: 1920px){.accordion-item__header__content{max-width:1144px}}.accordion-item__header__content.headline-bold{color:#000028}.accordion-item__header__headline{display:-webkit-box;-webkit-box-orient:vertical;-webkit-line-clamp:2;text-overflow:ellipsis;overflow:hidden}.headline-bold .accordion-item__header__headline{font-size:1.25rem;font-weight:700;line-height:1.625rem}.accordion-item__header__subheadline{font-size:.75rem;font-weight:400;line-height:1rem;display:block;color:#000028}.accordion-item__header__custom-icon{width:24px;height:24px;display:flex;align-items:center;fill:currentColor;margin-right:10px}.accordion-item__header__custom-icon svg{fill:currentColor;width:inherit;height:inherit}.accordion-item__header__custom-icon svg g{fill:currentColor;width:inherit;height:inherit}.accordion-item__header__custom-icon svg text{font-family:Siemens Sans,sans-serif}.headline-bold .accordion-item__header__custom-icon{margin-right:12px}.accordion-item__header__icon{width:24px;height:24px;display:flex;align-items:center;fill:currentColor}.accordion-item__header__icon svg{fill:currentColor;width:inherit;height:inherit}.accordion-item__header__icon svg g{fill:currentColor;width:inherit;height:inherit}.accordion-item__header__icon svg text{font-family:Siemens Sans,sans-serif}.accordion-item__header__icon-wrapper{margin-left:12px;color:#007993;flex-shrink:0}.component-viewport--S .accordion-item__header__icon-wrapper{position:relative;right:-5px;margin-left:16px}.accordion-item__header__icon svg{transition:transform .25s cubic-bezier(.2,0,.38,.9)}.open .accordion-item__header__icon svg{--translateValue: 0;transform:translate3d(var(--translateValue),var(--translateValue),var(--translateValue)) rotate(180deg)}.accordion-item__body{padding:0 16px}.component-viewport--S .accordion-item__body{padding:0}.accordion-item__body.opened{margin-bottom:24px}.accordion-item__body:hover{cursor:auto}.accordion-item--custom-header-content .accordion-item__header{display:flex;align-items:flex-start}@container accordion-item (min-width: 608px){.accordion-item--custom-header-content .accordion-item__header{padding-top:12px}}.accordion-item--custom-header-content .accordion-item__header .custom-header-content{display:flex;margin-left:auto;align-self:flex-start;flex-direction:row;align-items:center}@container accordion-item (max-width: 607px){.accordion-item--custom-header-content .accordion-item__header .custom-header-content{flex:1 1 calc(100% - 40px);margin-top:11px;margin-left:0}}@container accordion-item (max-width: 607px){.accordion-item--custom-header-content .accordion-item__header sie-icon{display:flex;flex:0 1 24px}}@container accordion-item (min-width: 608px){.accordion-item--custom-header-content .accordion-item__header__icon-wrapper{position:relative;top:6px}}.accordion-item--custom-header-content .accordion-item__header__headline-wrapper{word-break:normal;display:flex;flex-direction:column;flex:1 1 calc(100% - 36px)}@container accordion-item (min-width: 608px){.accordion-item--custom-header-content .accordion-item__header__headline-wrapper{margin:4px 16px 0 0}}.accordion-item--custom-header-content .accordion-item__header__content{display:flex;flex-wrap:wrap;overflow:hidden}@container accordion-item (min-width: 608px){.accordion-item--custom-header-content .accordion-item__header__content{width:100%;max-width:100%;display:flex;flex-direction:row;flex-wrap:nowrap}}.accordion-item.active-hover{cursor:pointer;margin-top:-1px;border-bottom:1px solid #33747a;border-top:1px solid #33747a}.accordion-item.active-hover .accordion-item__header__content,.accordion-item.active-hover .accordion-item__header__icon-wrapper{color:#33747a}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }, { type: i0.ChangeDetectorRef }]; }, propDecorators: { headline: [{
                type: Input
            }], subHeadline: [{
                type: Input
            }], id: [{
                type: Input
            }], showTopBorder: [{
                type: Input
            }], headlineBold: [{
                type: Input
            }], icon: [{
                type: Input
            }], open: [{
                type: Input
            }], customHeaderContent: [{
                type: Input
            }], clicked: [{
                type: Output
            }], accordionBody: [{
                type: ViewChild,
                args: ['accordionBody']
            }], accordionItem: [{
                type: ViewChild,
                args: ['accordionItem']
            }] } });

/**
 * This directive is used in conjunction with the accordion component to set the item
 * to be rendered inside the accordion.
 */
class UiAccordionRenderDirective {
    /**
     * @param item Sets item that needs to be rendered inside the accordion.
     */
    set itemToRender(item) {
        this.uiAccordionComponentService.renderChild(this.viewContainer, item);
    }
    constructor(viewContainer, uiAccordionComponentService) {
        this.viewContainer = viewContainer;
        this.uiAccordionComponentService = uiAccordionComponentService;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiAccordionRenderDirective, deps: [{ token: i0.ViewContainerRef }, { token: UI_ACCORDION_WEB_COMPONENT_SERVICE }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: UiAccordionRenderDirective, selector: "[sieUiAccordionRender]", inputs: { itemToRender: "itemToRender" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiAccordionRenderDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[sieUiAccordionRender]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ViewContainerRef }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [UI_ACCORDION_WEB_COMPONENT_SERVICE]
                }] }]; }, propDecorators: { itemToRender: [{
                type: Input
            }] } });

/**
 * # Accordion component
 *
 * Accordions are used to structure content under several accordion items that can be collapsed and expanded.
 *
 * ## Component variations
 *
 * There are no variations.
 *
 * ## Content
 *
 * The content of accordion items can be passed as child elements with using `UiAccordionItemDirective`.
 * Custom content of accordion item`s header can be passed as child element using `UiAccordionItemHeaderDirective`.
 * In order to display custom header content, header`s parentId must match the id of an accordion item we want to adapt.
 *
 * See the example below.
 *
 * ## Code example
 * @example
 *  ```html
 * <sie-ui-accordion>
 *   <ng-template sieUiAccordionItemHeader parentId="first">
 *      <sie-ui-button>custom content</sie-ui-button>
 *   </ng-template>
 *   <ng-template sieUiAccordionItem id="first" headline="Headline 1"> Item 1</ng-template>
 *   <ng-template sieUiAccordionItem headline="This accordion item is set to be opened by default" [open]="true">
 *      Item 2
 *   </ng-template>
 *   <ng-template
 *     sieUiAccordionItem
 *     headline="Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt"
 *   >
 *     Item 3
 *   </ng-template>
 * </sie-ui-accordion>
 * ```
 */
class UiAccordionComponent {
    constructor(cdr, uiAccordionComponentService) {
        this.cdr = cdr;
        this.uiAccordionComponentService = uiAccordionComponentService;
        /**
         * {@link UiAccordionExpandEvent Event} triggered when a different accordion item is selected.
         */
        this.expandedChange = new Subject();
        /** @ignore */
        this.headerSlots = [];
        this.subscriptions = new Subscription();
    }
    /** @ignore */
    ngAfterViewInit() {
        if (this.items instanceof QueryList) {
            this.subscriptions.add(this.items?.changes.subscribe(() => {
                this.updateView();
            }));
        }
        this.uiAccordionComponentService.init(this);
        this.matchItemAndHeaderIds();
    }
    /** @ignore */
    ngOnDestroy() {
        this.subscriptions.unsubscribe();
    }
    /** @ignore */
    itemClicked(open, index) {
        this.expandedChange.next({ open, index });
    }
    /**
     * Triggers the change detection of the component.
     */
    updateView() {
        this.cdr.detectChanges();
    }
    /** @ignore */
    matchItemAndHeaderIds() {
        const headers = this.extractArray(this.headers);
        const items = this.extractArray(this.items);
        this.headerSlots = items.map(item => headers.find(header => item.id === header.parentId));
    }
    extractArray(elements) {
        if (elements instanceof QueryList) {
            return elements.toArray();
        }
        else {
            return elements;
        }
    }
    // the following are only applicable for web components
    // to alter the structure after creation
    /** @ignore Use only intended in web components */
    removeItems() {
        this.uiAccordionComponentService.removeAll(this);
    }
    /** @ignore Use only intended in web components */
    removeItemAt(index) {
        this.uiAccordionComponentService.removeItemAt(this, index);
    }
    /** @ignore Use only intended in web components */
    toggleItemAt(index) {
        this.uiAccordionComponentService.toggleItemAt(this, index);
        this.cdr.detectChanges();
    }
    /** @ignore Use only intended in web components */
    set newItem(item) {
        this.uiAccordionComponentService.createNewItem(this, item);
    }
    /** @ignore Use only intended in web components */
    updateItem(index, changes) {
        this.uiAccordionComponentService.updateItem(this, index, changes);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiAccordionComponent, deps: [{ token: i0.ChangeDetectorRef }, { token: UI_ACCORDION_WEB_COMPONENT_SERVICE }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiAccordionComponent, selector: "sie-ui-accordion", inputs: { removeItems: "removeItems", removeItemAt: "removeItemAt", toggleItemAt: "toggleItemAt", newItem: "newItem", updateItem: "updateItem" }, outputs: { expandedChange: "expandedChange" }, queries: [{ propertyName: "items", predicate: UiAccordionItemDirective }, { propertyName: "headers", predicate: UiAccordionItemHeaderDirective }], viewQueries: [{ propertyName: "elementsRef", first: true, predicate: ["elements"], descendants: true }], ngImport: i0, template: "<div #elements class=\"accordion-container\">\n  <ng-content select=\".item\"></ng-content>\n  <ng-content select=\".header\"></ng-content>\n</div>\n\n<div class=\"accordion\" role=\"tablist\" aria-multiselectable=\"true\">\n  <sie-ui-accordion-item\n    *ngFor=\"let item of items; let index = index\"\n    [headline]=\"item.headline\"\n    [subHeadline]=\"item.subHeadline\"\n    [showTopBorder]=\"item.showTopBorder\"\n    [headlineBold]=\"item.headlineBold\"\n    [icon]=\"item.icon\"\n    [id]=\"item.id\"\n    [open]=\"item.open\"\n    [customHeaderContent]=\"!!headerSlots[index]\"\n    (clicked)=\"itemClicked($event, index)\"\n  >\n    <div *ngIf=\"headerSlots[index]\" sieUiAccordionRender headerSlot [itemToRender]=\"headerSlots[index]\"></div>\n    <div sieUiAccordionRender [itemToRender]=\"item\"></div>\n  </sie-ui-accordion-item>\n</div>\n", styles: [".accordion{border-top:1px solid #ccccd4}.accordion-container{display:none}\n"], dependencies: [{ kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: UiAccordionItemComponent, selector: "sie-ui-accordion-item", inputs: ["headline", "subHeadline", "id", "showTopBorder", "headlineBold", "icon", "open", "customHeaderContent"], outputs: ["clicked"] }, { kind: "directive", type: UiAccordionRenderDirective, selector: "[sieUiAccordionRender]", inputs: ["itemToRender"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiAccordionComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-accordion', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div #elements class=\"accordion-container\">\n  <ng-content select=\".item\"></ng-content>\n  <ng-content select=\".header\"></ng-content>\n</div>\n\n<div class=\"accordion\" role=\"tablist\" aria-multiselectable=\"true\">\n  <sie-ui-accordion-item\n    *ngFor=\"let item of items; let index = index\"\n    [headline]=\"item.headline\"\n    [subHeadline]=\"item.subHeadline\"\n    [showTopBorder]=\"item.showTopBorder\"\n    [headlineBold]=\"item.headlineBold\"\n    [icon]=\"item.icon\"\n    [id]=\"item.id\"\n    [open]=\"item.open\"\n    [customHeaderContent]=\"!!headerSlots[index]\"\n    (clicked)=\"itemClicked($event, index)\"\n  >\n    <div *ngIf=\"headerSlots[index]\" sieUiAccordionRender headerSlot [itemToRender]=\"headerSlots[index]\"></div>\n    <div sieUiAccordionRender [itemToRender]=\"item\"></div>\n  </sie-ui-accordion-item>\n</div>\n", styles: [".accordion{border-top:1px solid #ccccd4}.accordion-container{display:none}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [UI_ACCORDION_WEB_COMPONENT_SERVICE]
                }] }]; }, propDecorators: { items: [{
                type: ContentChildren,
                args: [UiAccordionItemDirective]
            }], headers: [{
                type: ContentChildren,
                args: [UiAccordionItemHeaderDirective]
            }], expandedChange: [{
                type: Output
            }], elementsRef: [{
                type: ViewChild,
                args: ['elements']
            }], removeItems: [{
                type: Input
            }], removeItemAt: [{
                type: Input
            }], toggleItemAt: [{
                type: Input
            }], newItem: [{
                type: Input
            }], updateItem: [{
                type: Input
            }] } });

/**
 * # Accordion Item Module
 * - {@link UiAccordionItemComponent}
 *
 * ## Module peer dependencies
 * - `@angular/platform-browser/animations/BrowserAnimationsModule`: This module is needed for the animation of
 *    expanding or collapsing accordion item.
 * - {@link SieIconsModule}
 */
class UiAccordionItemModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiAccordionItemModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiAccordionItemModule, declarations: [UiAccordionItemComponent], imports: [CommonModule, SieIconsModule, ComponentBreakpointsModule], exports: [UiAccordionItemComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiAccordionItemModule, imports: [CommonModule, SieIconsModule, ComponentBreakpointsModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiAccordionItemModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiAccordionItemComponent],
                    imports: [CommonModule, SieIconsModule, ComponentBreakpointsModule],
                    exports: [UiAccordionItemComponent]
                }]
        }] });

/**
 * Implementation for Angular environment that is doing nothing
 */
class UiAccordionNgService {
    init() {
        // don't do anything here
    }
    createNewItem() {
        // don't do anything here
    }
    removeAll() {
        // don't do anything here
    }
    removeItemAt() {
        // don't do anything here
    }
    toggleItemAt() {
        // don't do anything here
    }
    updateItem() {
        // don't do anything here
    }
    renderChild(viewContainer, item) {
        viewContainer.createEmbeddedView(item.templateRef);
    }
}

/**
 * Implementation for web component export
 */
class UiAccordionElementsService {
    static convertDomItem(element) {
        const headline = element.dataset['headline'];
        const subHeadline = element.dataset['subHeadline'];
        const id = element.dataset['id'];
        const showTopBorder = element.dataset['showTopBorder'] === 'true';
        const headlineBold = element.dataset['headlineBold'] === 'true';
        const icon = element.dataset['icon'];
        const open = element.dataset['open'] === 'true';
        const customHeaderContent = element.dataset['customHeaderContent'] === 'true';
        return { headline, subHeadline, showTopBorder, headlineBold, icon, open, id, customHeaderContent };
    }
    static convertDomItemHeader(element) {
        const parentId = element.dataset['parentId'];
        return { parentId };
    }
    static checkIndex(index, component) {
        return index >= 0 && index < component.items.length;
    }
    constructor(domManipulationService) {
        this.domManipulationService = domManipulationService;
    }
    init(component) {
        component.items = this.domManipulationService.getDomItemsAndCleanupDom(component, '.item', UiAccordionElementsService.convertDomItem);
        component.headers = this.domManipulationService.getDomItemsAndCleanupDom(component, '.header', UiAccordionElementsService.convertDomItemHeader);
        component.updateView();
    }
    removeAll(component) {
        component.items = [];
        component.updateView();
    }
    removeItemAt(component, index) {
        if (component.items instanceof Array && UiAccordionElementsService.checkIndex(index, component)) {
            component.items.splice(index, 1);
            component.updateView();
        }
    }
    toggleItemAt(component, index) {
        if (component.items instanceof Array && UiAccordionElementsService.checkIndex(index, component)) {
            component.items[index].open = !component.items[index].open;
        }
    }
    createNewItem(component, item) {
        if (component.items instanceof Array) {
            const element = document.createElement('div');
            element.innerHTML = item.html;
            component.items.push({
                ...item,
                element
            });
            component.updateView();
        }
    }
    updateItem(component, index, changes) {
        if (component.items instanceof Array && UiAccordionElementsService.checkIndex(index, component)) {
            if (changes.headline) {
                component.items[index].headline = changes.headline;
            }
            if (changes.subHeadline) {
                component.items[index].subHeadline = changes.subHeadline;
            }
            if (changes.id) {
                component.items[index].id = changes.id;
            }
            if (changes.headlineBold) {
                component.items[index].headlineBold = changes.headlineBold;
            }
            if (changes.icon) {
                component.items[index].icon = changes.icon;
            }
            if (changes.html) {
                component.items[index].element.innerHTML = changes.html;
            }
            component.updateView();
        }
    }
    renderChild(viewContainer, item) {
        if (item.element) {
            viewContainer.element.nativeElement.appendChild(item.element);
        }
    }
}

class UiDomManipulationService {
    getDomItemsAndCleanupDom(component, selector, mapper) {
        const elements = component.elementsRef.nativeElement.querySelectorAll(selector);
        component.elementsRef.nativeElement.remove();
        const elementArray = Array.from(elements);
        return elementArray.map(element => ({
            ...mapper(element),
            element
        }));
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDomManipulationService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDomManipulationService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDomManipulationService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }] });

/**
 * # Accordion Module
 * - {@link UiAccordionComponent}
 * - {@link UiAccordionItemDirective}
 * - {@link UiAccordionItemHeaderDirective}
 *
 * ## Module peer dependencies
 * - `@angular/platform-browser/animations/BrowserAnimationsModule`: This module is needed for the animation of
 *    expanding or collapsing accordion item.
 * - {@link SieIconsModule}
 */
class UiAccordionModule {
    /** @ignore */
    static forWebComponent() {
        const providers = [
            {
                provide: UI_ACCORDION_WEB_COMPONENT_SERVICE,
                useClass: UiAccordionElementsService,
                deps: [UiDomManipulationService]
            }
        ];
        return {
            ngModule: UiAccordionModule,
            providers
        };
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiAccordionModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiAccordionModule, declarations: [UiAccordionComponent,
            UiAccordionItemDirective,
            UiAccordionItemHeaderDirective,
            UiAccordionRenderDirective], imports: [CommonModule, UiAccordionItemModule], exports: [UiAccordionComponent, UiAccordionItemDirective, UiAccordionItemHeaderDirective] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiAccordionModule, providers: [
            {
                provide: UI_ACCORDION_WEB_COMPONENT_SERVICE,
                useClass: UiAccordionNgService
            }
        ], imports: [CommonModule, UiAccordionItemModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiAccordionModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        UiAccordionComponent,
                        UiAccordionItemDirective,
                        UiAccordionItemHeaderDirective,
                        UiAccordionRenderDirective
                    ],
                    providers: [
                        {
                            provide: UI_ACCORDION_WEB_COMPONENT_SERVICE,
                            useClass: UiAccordionNgService
                        }
                    ],
                    imports: [CommonModule, UiAccordionItemModule],
                    exports: [UiAccordionComponent, UiAccordionItemDirective, UiAccordionItemHeaderDirective]
                }]
        }] });

class UiColorHashService {
    constructor() {
        this.colors = [
            ColorSupportive1OnLight,
            ColorSupportive1OnDark,
            ColorSupportive2OnLight,
            ColorSupportive2OnDark,
            ColorSupportive3OnLight,
            ColorSupportive3OnDark,
            ColorSupportive4OnLight,
            ColorSupportive4OnDark,
            ComponentAccountIdentifierColorBackgroundGreen1,
            ComponentAccountIdentifierColorBackgroundGreen2,
            ComponentAccountIdentifierColorBackgroundBlue1,
            ComponentAccountIdentifierColorBackgroundBlue2,
            ComponentAccountIdentifierColorBackgroundBlue3,
            ComponentAccountIdentifierColorBackgroundDarkBlue,
            ComponentAccountIdentifierColorBackgroundPurple1,
            ComponentAccountIdentifierColorBackgroundPurple2,
            ComponentAccountIdentifierColorBackgroundPink1,
            ComponentAccountIdentifierColorBackgroundPink2,
            ComponentAccountIdentifierColorBackgroundOrange,
            ComponentAccountIdentifierColorBackgroundRed
        ];
    }
    getHashAsColor(value = '') {
        const index = this.hash(value);
        return this.colors[index];
    }
    hash(value) {
        let hash = 0;
        for (let i = 0; i < value.length; i++) {
            hash += value.charCodeAt(i);
        }
        return hash % this.colors.length;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiColorHashService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiColorHashService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiColorHashService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return []; } });

/**
 * # Picture Component
 * Images are used as a part of a content item’s representation (functional), e.g. showing product images, diagrams etc.
 * or part of the brand expression (emotional), e.g. showing mood images.
 *
 * ## Component variations
 *
 * - With caption
 * - Without caption
 *
 * ## Content
 * The picture component does not accept any content.
 *
 * ## Code example
 * @example
 *  ```html
 * <sie-ui-picture
 *  ratio="16-9"
 *  [model]="pictureData"
 *  [context]="'services'"
 *  [shouldHaveOutline]="false"
 * ></sie-ui-picture>
 * ```
 *
 * ```ts
 * const pictureData = {
 *  urlSmall:'https://test-image/width:640/quality:low/Energy-Manager-MindSphere-App-v2.tif',
 *  urlMedium:'https://test-image/width:1280/quality:medium/Energy-Manager-MindSphere-App-v2.tif',
 *  urlLarge:'https://test-image/width:1920/quality:high/Energy-Manager-MindSphere-App-v2.tif',
 *  altText: 'In case the image does not load..',
 *  mode: 'cover',
 *  caption:'Lorem ipsum dolor sit amet, consetetur sadipscing elitra.'
 * };
 * ```
 */
class UiPictureComponent {
    get context() {
        return this._context;
    }
    /**
     * @param context {@link ImageContext Context} sets the correct icon to display when the picture is not loaded
     */
    set context(context) {
        this._context = context;
        this.placeholderImage = this.contextPlaceholder.get(context);
    }
    /**
     * @param value whether the picture have a visible caption or not
     * @default false
     */
    set caption(value) {
        this._caption = coerceBooleanProperty(value);
    }
    get caption() {
        return this._caption;
    }
    /**
     * @param value sets outline on the fallback picture
     * @default false
     */
    set shouldHaveOutline(value) {
        this._shouldHaveOutline = coerceBooleanProperty(value);
    }
    get shouldHaveOutline() {
        return this._shouldHaveOutline;
    }
    constructor(iconReg) {
        this.iconReg = iconReg;
        /**
         * Event triggered when image fails to load
         */
        this.failedToLoadImg = new EventEmitter();
        /** @ignore */
        this.Breakpoints = Breakpoints;
        /** @ignore */
        this.failedToLoad = false;
        this._context = null;
        this._caption = false;
        this._shouldHaveOutline = false;
        this.contextPlaceholder = new Map([
            ['product', this.iconReg.getInternalIconPath(SieIcon.SieportalPlaceholderProduct)],
            ['services', this.iconReg.getInternalIconPath(SieIcon.SieportalPlaceholderService)],
            ['certificate', this.iconReg.getInternalIconPath(SieIcon.SieportalPlaceholderCertificate)]
        ]);
    }
    /** @ignore */
    onLoadError() {
        this.failedToLoad = true;
        this.failedToLoadImg.emit(true);
        this.iconReg.register(SieIcon.SieportalAltText);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiPictureComponent, deps: [{ token: i1.SieIconRegistryService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiPictureComponent, selector: "sie-ui-picture", inputs: { model: "model", size: "size", ratio: "ratio", notLoadedLabel: "notLoadedLabel", theme: "theme", context: "context", caption: "caption", shouldHaveOutline: "shouldHaveOutline" }, outputs: { failedToLoadImg: "failedToLoadImg" }, ngImport: i0, template: "<figure class=\"figure\" [ngClass]=\"[size ? 'size-' + size : '', '' + theme]\">\n  <picture *ngIf=\"model && !failedToLoad; else fallback\" [ngClass]=\"[ratio ? 'ratio-' + ratio : '']\" class=\"picture\">\n    <source *ngIf=\"model.urlSmall\" [media]=\"Breakpoints.S\" [srcset]=\"model.urlSmall\" />\n    <source *ngIf=\"model.urlMedium\" [media]=\"Breakpoints.M\" [srcset]=\"model.urlMedium\" />\n    <source *ngIf=\"model.urlLarge\" [media]=\"Breakpoints.L\" [srcset]=\"model.urlLarge\" />\n    <source *ngIf=\"model.urlLarge\" [media]=\"Breakpoints.XL\" [srcset]=\"model.urlLarge\" />\n    <img\n      loading=\"lazy\"\n      [ngClass]=\"[model.mode ? 'fit--' + model.mode : 'fit--cover']\"\n      [src]=\"model.urlLarge\"\n      [alt]=\"model.altText\"\n      (error)=\"onLoadError()\"\n    />\n  </picture>\n  <figcaption *ngIf=\"model.caption && caption\" class=\"caption-text\">{{ model.caption }}</figcaption>\n</figure>\n\n<ng-template class=\"container\" #fallback>\n  <div\n    *ngIf=\"!placeholderImage\"\n    [ngClass]=\"[ratio ? 'ratio-' + ratio : '', shouldHaveOutline ? 'broken-image-outline' : '']\"\n    class=\"broken-image-wrapper\"\n  >\n    <div class=\"broken-image\" [ngClass]=\"{ 'broken-image--with-ratio': ratio }\">\n      <sie-icon class=\"broken-image__icon\" [name]=\"iconReg.sieIcon.SieportalAltText\"></sie-icon>\n      <p class=\"broken-image__text\">\n        {{ notLoadedLabel }}\n        <br *ngIf=\"model.altText && notLoadedLabel\" />\n        {{ model.altText }}\n      </p>\n    </div>\n  </div>\n\n  <picture *ngIf=\"placeholderImage\" [ngClass]=\"[ratio ? 'ratio-' + ratio : '']\" class=\"picture placeholder-bg\">\n    <img loading=\"lazy\" class=\"placeholder-image\" [attr.src]=\"placeholderImage\" [alt]=\"model.altText\" />\n  </picture>\n</ng-template>\n", styles: [".figure{position:relative;margin:0;height:100%;display:flex;flex-direction:column}.figure .caption-text{font-size:.875rem;font-weight:400;line-height:1.25rem;max-width:100%;margin-top:8px;color:#4c4c68}@media (min-width: 640px){.figure .caption-text{max-width:calc(calc(100vw - 208px)/12 * 8 + 112px)}}@media (min-width: 1024px){.figure .caption-text{max-width:calc(calc(100vw - 376px)/12 * 8 + 168px)}}@media (min-width: 1440px){.figure .caption-text{max-width:calc(calc(100vw - 456px)/12 * 8 + 168px)}}@media (min-width: 1920px){.figure .caption-text{max-width:1144px}}.figure.dark .caption-text{color:#ccccd4}img{width:100%;height:100%}img.fit--cover{object-fit:cover}img.fit--contain{object-fit:contain}@media all and (-ms-high-contrast: none),(-ms-high-contrast: active){img.fit--contain{position:absolute;top:50%;left:50%;transform:translate(-50%,-50%);height:100%;width:auto}}.picture,.broken-image-wrapper{width:100%;height:100%}.picture.placeholder-bg,.broken-image-wrapper.placeholder-bg{background:#e5e5e9}.picture.ratio-16-9,.picture.ratio-4-3,.picture.ratio-3-4,.broken-image-wrapper.ratio-16-9,.broken-image-wrapper.ratio-4-3,.broken-image-wrapper.ratio-3-4{display:block;width:100%;height:0;overflow:hidden;position:relative}.picture.ratio-16-9 img,.picture.ratio-4-3 img,.picture.ratio-3-4 img,.broken-image-wrapper.ratio-16-9 img,.broken-image-wrapper.ratio-4-3 img,.broken-image-wrapper.ratio-3-4 img{position:absolute}.picture.ratio-16-9,.broken-image-wrapper.ratio-16-9{padding-bottom:56.25%}.picture.ratio-4-3,.broken-image-wrapper.ratio-4-3{padding-bottom:75%}.picture.ratio-3-4,.broken-image-wrapper.ratio-3-4{padding-bottom:133.33%}.picture.broken-image-outline,.broken-image-wrapper.broken-image-outline{outline:1px solid #b3b3be}.broken-image{display:flex;align-items:center;justify-content:center;flex-direction:column;width:100%}.broken-image--with-ratio{position:absolute;top:50%;left:50%;transform:translate(-50%,-50%)}.broken-image__icon{margin-bottom:8px;width:16px;height:18px;display:flex;align-items:center;fill:currentColor}.broken-image__icon svg{fill:currentColor;width:inherit;height:inherit}.broken-image__icon svg g{fill:currentColor;width:inherit;height:inherit}.broken-image__icon svg text{font-family:Siemens Sans,sans-serif}.broken-image__text{font-size:1rem;font-weight:400;line-height:1.5rem;display:-webkit-box;color:#9999a9;text-align:center;max-width:320px;overflow:hidden;text-overflow:ellipsis}.placeholder-image{position:absolute;top:50%;left:50%;transform:translate(-50%,-50%);width:98px;height:102px;filter:invert(52%) sepia(8%) saturate(844%) hue-rotate(196deg) brightness(96%) contrast(88%)}.figure.size-xxs .placeholder-image{width:70px;height:75px}.size-xxs{width:calc(calc(100vw - 208px)/12 * 2 + 16px)}@media (min-width: 1024px){.size-xxs{width:calc(calc(100vw - 376px)/12 * 2 + 24px)}}@media (min-width: 1440px){.size-xxs{width:calc(calc(100vw - 456px)/12 * 2 + 24px)}}@media (min-width: 1920px){.size-xxs{width:268px}}.size-xs{width:calc((100vw - 208px)/4 + 32px)}@media (min-width: 1024px){.size-xs{width:calc((100vw - 376px)/4 + 48px)}}@media (min-width: 1440px){.size-xs{width:calc((100vw - 456px)/4 + 48px)}}@media (min-width: 1920px){.size-xs{width:414px}}.size-s{width:calc(calc(100vw - 208px)/12 * 4 + 48px)}@media (min-width: 1024px){.size-s{width:calc(calc(100vw - 376px)/12 * 4 + 72px)}}@media (min-width: 1440px){.size-s{width:calc(calc(100vw - 456px)/12 * 4 + 72px)}}@media (min-width: 1920px){.size-s{width:560px}}.size-m{width:calc((100vw - 208px)/2 + 80px)}@media (min-width: 1024px){.size-m{width:calc((100vw - 376px)/2 + 120px)}}@media (min-width: 1440px){.size-m{width:calc((100vw - 456px)/2 + 120px)}}@media (min-width: 1920px){.size-m{width:852px}}.size-l{width:calc(calc(100vw - 208px)/12 * 8 + 112px)}@media (min-width: 1024px){.size-l{width:calc(calc(100vw - 376px)/12 * 8 + 168px)}}@media (min-width: 1440px){.size-l{width:calc(calc(100vw - 456px)/12 * 8 + 168px)}}@media (min-width: 1920px){.size-l{width:1144px}}.size-xl{width:calc((100vw - 208px)*.75 + 128px)}@media (min-width: 1024px){.size-xl{width:calc((100vw - 376px)*.75 + 192px)}}@media (min-width: 1440px){.size-xl{width:calc((100vw - 456px)*.75 + 192px)}}@media (min-width: 1920px){.size-xl{width:1290px}}.size-xxl{width:calc((100vw - 208px)*1 + 176px)}@media (min-width: 1024px){.size-xxl{width:calc((100vw - 376px)*1 + 264px)}}@media (min-width: 1440px){.size-xxl{width:calc((100vw - 456px)*1 + 264px)}}@media (min-width: 1920px){.size-xxl{width:1728px}}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiPictureComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-picture', changeDetection: ChangeDetectionStrategy.OnPush, template: "<figure class=\"figure\" [ngClass]=\"[size ? 'size-' + size : '', '' + theme]\">\n  <picture *ngIf=\"model && !failedToLoad; else fallback\" [ngClass]=\"[ratio ? 'ratio-' + ratio : '']\" class=\"picture\">\n    <source *ngIf=\"model.urlSmall\" [media]=\"Breakpoints.S\" [srcset]=\"model.urlSmall\" />\n    <source *ngIf=\"model.urlMedium\" [media]=\"Breakpoints.M\" [srcset]=\"model.urlMedium\" />\n    <source *ngIf=\"model.urlLarge\" [media]=\"Breakpoints.L\" [srcset]=\"model.urlLarge\" />\n    <source *ngIf=\"model.urlLarge\" [media]=\"Breakpoints.XL\" [srcset]=\"model.urlLarge\" />\n    <img\n      loading=\"lazy\"\n      [ngClass]=\"[model.mode ? 'fit--' + model.mode : 'fit--cover']\"\n      [src]=\"model.urlLarge\"\n      [alt]=\"model.altText\"\n      (error)=\"onLoadError()\"\n    />\n  </picture>\n  <figcaption *ngIf=\"model.caption && caption\" class=\"caption-text\">{{ model.caption }}</figcaption>\n</figure>\n\n<ng-template class=\"container\" #fallback>\n  <div\n    *ngIf=\"!placeholderImage\"\n    [ngClass]=\"[ratio ? 'ratio-' + ratio : '', shouldHaveOutline ? 'broken-image-outline' : '']\"\n    class=\"broken-image-wrapper\"\n  >\n    <div class=\"broken-image\" [ngClass]=\"{ 'broken-image--with-ratio': ratio }\">\n      <sie-icon class=\"broken-image__icon\" [name]=\"iconReg.sieIcon.SieportalAltText\"></sie-icon>\n      <p class=\"broken-image__text\">\n        {{ notLoadedLabel }}\n        <br *ngIf=\"model.altText && notLoadedLabel\" />\n        {{ model.altText }}\n      </p>\n    </div>\n  </div>\n\n  <picture *ngIf=\"placeholderImage\" [ngClass]=\"[ratio ? 'ratio-' + ratio : '']\" class=\"picture placeholder-bg\">\n    <img loading=\"lazy\" class=\"placeholder-image\" [attr.src]=\"placeholderImage\" [alt]=\"model.altText\" />\n  </picture>\n</ng-template>\n", styles: [".figure{position:relative;margin:0;height:100%;display:flex;flex-direction:column}.figure .caption-text{font-size:.875rem;font-weight:400;line-height:1.25rem;max-width:100%;margin-top:8px;color:#4c4c68}@media (min-width: 640px){.figure .caption-text{max-width:calc(calc(100vw - 208px)/12 * 8 + 112px)}}@media (min-width: 1024px){.figure .caption-text{max-width:calc(calc(100vw - 376px)/12 * 8 + 168px)}}@media (min-width: 1440px){.figure .caption-text{max-width:calc(calc(100vw - 456px)/12 * 8 + 168px)}}@media (min-width: 1920px){.figure .caption-text{max-width:1144px}}.figure.dark .caption-text{color:#ccccd4}img{width:100%;height:100%}img.fit--cover{object-fit:cover}img.fit--contain{object-fit:contain}@media all and (-ms-high-contrast: none),(-ms-high-contrast: active){img.fit--contain{position:absolute;top:50%;left:50%;transform:translate(-50%,-50%);height:100%;width:auto}}.picture,.broken-image-wrapper{width:100%;height:100%}.picture.placeholder-bg,.broken-image-wrapper.placeholder-bg{background:#e5e5e9}.picture.ratio-16-9,.picture.ratio-4-3,.picture.ratio-3-4,.broken-image-wrapper.ratio-16-9,.broken-image-wrapper.ratio-4-3,.broken-image-wrapper.ratio-3-4{display:block;width:100%;height:0;overflow:hidden;position:relative}.picture.ratio-16-9 img,.picture.ratio-4-3 img,.picture.ratio-3-4 img,.broken-image-wrapper.ratio-16-9 img,.broken-image-wrapper.ratio-4-3 img,.broken-image-wrapper.ratio-3-4 img{position:absolute}.picture.ratio-16-9,.broken-image-wrapper.ratio-16-9{padding-bottom:56.25%}.picture.ratio-4-3,.broken-image-wrapper.ratio-4-3{padding-bottom:75%}.picture.ratio-3-4,.broken-image-wrapper.ratio-3-4{padding-bottom:133.33%}.picture.broken-image-outline,.broken-image-wrapper.broken-image-outline{outline:1px solid #b3b3be}.broken-image{display:flex;align-items:center;justify-content:center;flex-direction:column;width:100%}.broken-image--with-ratio{position:absolute;top:50%;left:50%;transform:translate(-50%,-50%)}.broken-image__icon{margin-bottom:8px;width:16px;height:18px;display:flex;align-items:center;fill:currentColor}.broken-image__icon svg{fill:currentColor;width:inherit;height:inherit}.broken-image__icon svg g{fill:currentColor;width:inherit;height:inherit}.broken-image__icon svg text{font-family:Siemens Sans,sans-serif}.broken-image__text{font-size:1rem;font-weight:400;line-height:1.5rem;display:-webkit-box;color:#9999a9;text-align:center;max-width:320px;overflow:hidden;text-overflow:ellipsis}.placeholder-image{position:absolute;top:50%;left:50%;transform:translate(-50%,-50%);width:98px;height:102px;filter:invert(52%) sepia(8%) saturate(844%) hue-rotate(196deg) brightness(96%) contrast(88%)}.figure.size-xxs .placeholder-image{width:70px;height:75px}.size-xxs{width:calc(calc(100vw - 208px)/12 * 2 + 16px)}@media (min-width: 1024px){.size-xxs{width:calc(calc(100vw - 376px)/12 * 2 + 24px)}}@media (min-width: 1440px){.size-xxs{width:calc(calc(100vw - 456px)/12 * 2 + 24px)}}@media (min-width: 1920px){.size-xxs{width:268px}}.size-xs{width:calc((100vw - 208px)/4 + 32px)}@media (min-width: 1024px){.size-xs{width:calc((100vw - 376px)/4 + 48px)}}@media (min-width: 1440px){.size-xs{width:calc((100vw - 456px)/4 + 48px)}}@media (min-width: 1920px){.size-xs{width:414px}}.size-s{width:calc(calc(100vw - 208px)/12 * 4 + 48px)}@media (min-width: 1024px){.size-s{width:calc(calc(100vw - 376px)/12 * 4 + 72px)}}@media (min-width: 1440px){.size-s{width:calc(calc(100vw - 456px)/12 * 4 + 72px)}}@media (min-width: 1920px){.size-s{width:560px}}.size-m{width:calc((100vw - 208px)/2 + 80px)}@media (min-width: 1024px){.size-m{width:calc((100vw - 376px)/2 + 120px)}}@media (min-width: 1440px){.size-m{width:calc((100vw - 456px)/2 + 120px)}}@media (min-width: 1920px){.size-m{width:852px}}.size-l{width:calc(calc(100vw - 208px)/12 * 8 + 112px)}@media (min-width: 1024px){.size-l{width:calc(calc(100vw - 376px)/12 * 8 + 168px)}}@media (min-width: 1440px){.size-l{width:calc(calc(100vw - 456px)/12 * 8 + 168px)}}@media (min-width: 1920px){.size-l{width:1144px}}.size-xl{width:calc((100vw - 208px)*.75 + 128px)}@media (min-width: 1024px){.size-xl{width:calc((100vw - 376px)*.75 + 192px)}}@media (min-width: 1440px){.size-xl{width:calc((100vw - 456px)*.75 + 192px)}}@media (min-width: 1920px){.size-xl{width:1290px}}.size-xxl{width:calc((100vw - 208px)*1 + 176px)}@media (min-width: 1024px){.size-xxl{width:calc((100vw - 376px)*1 + 264px)}}@media (min-width: 1440px){.size-xxl{width:calc((100vw - 456px)*1 + 264px)}}@media (min-width: 1920px){.size-xxl{width:1728px}}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }]; }, propDecorators: { model: [{
                type: Input
            }], size: [{
                type: Input
            }], ratio: [{
                type: Input
            }], notLoadedLabel: [{
                type: Input
            }], theme: [{
                type: Input
            }], context: [{
                type: Input
            }], caption: [{
                type: Input
            }], shouldHaveOutline: [{
                type: Input
            }], failedToLoadImg: [{
                type: Output
            }] } });

class UiLabelBadgeComponent {
    constructor() {
        this.variant = 'info';
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiLabelBadgeComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiLabelBadgeComponent, selector: "sie-ui-label-badge", inputs: { label: "label", variant: "variant" }, host: { properties: { "class": "this.variant" } }, ngImport: i0, template: "<span>{{ label }}</span>\n", styles: [":host{font-size:.75rem;font-weight:400;line-height:1rem;color:#fff;fill:#fff;display:inline-block;padding:0 4px;border-radius:2px;white-space:nowrap;vertical-align:middle;margin-top:-4px}:host.info{background-color:#0087be}:host.error{background-color:#ef0137}\n"], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiLabelBadgeComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-label-badge', changeDetection: ChangeDetectionStrategy.OnPush, template: "<span>{{ label }}</span>\n", styles: [":host{font-size:.75rem;font-weight:400;line-height:1rem;color:#fff;fill:#fff;display:inline-block;padding:0 4px;border-radius:2px;white-space:nowrap;vertical-align:middle;margin-top:-4px}:host.info{background-color:#0087be}:host.error{background-color:#ef0137}\n"] }]
        }], propDecorators: { label: [{
                type: Input
            }], variant: [{
                type: HostBinding,
                args: ['class']
            }, {
                type: Input
            }] } });

/**
 * # Account Identifier component
 *
 * Account identifier identifies a particular user in their current (pre-/post-)login context.
 *
 * ## Component variations
 *
 * - avatar (displays only avatar)
 * - name (displays name and avatar)
 * - name-primary (displays name, primary meta, and avatar)
 * - name-action (displays name, secondary meta as action and avatar) - M - XL size only
 * - primary-secondary (displays primary and secondary meta, and avatar) - XS size only
 * - name-primary-secondary (displays name, primary and secondary meta, and avatar) - M - XL size only
 * - name-primary-action (displays name, primary, secondary meta as action and avatar) - M - XL size only
 *
 * ## Content
 *
 * The account identifier component does not accept any content.
 *
 * ## Code example
 * @example ```html
 * <h1>Avatar</h1>
 * <sie-ui-account-identifier
 *   size="xs"
 *   mode="dark"
 *   variant="avatar"
 *   initials="BZ"
 *   name="Benno Zerr"
 *   primaryMetaData="Primary meta information"
 *   secondaryMetaData="Secondary meta information"
 *   avatarImage="https://..."
 * ></sie-ui-account-identifier>
 *
 * <h1>Regular Account Identifier with name and action</h1>
 * <sie-ui-account-identifier
 *   size="l"
 *   mode="light"
 *   variant="name-primary-action"
 *   initials="ML"
 *   name="Maximilian Leutheusser-Schnarrenberger"
 *   primary-meta-data="Primary meta information"
 *   greetings="Welcome back Maximilian Leutheusser-Schnarrenberger!"
 *   link-text="Edit Profile"
 * >
 * </sie-ui-account-identifier>
 * ```
 */
class UiAccountIdentifierComponent {
    /**
     * @param networkIcon Sets the icon that represents the current network used (given by the user rights from API)
     */
    set networkIcon(networkIcon) {
        if (networkIcon) {
            this.iconReg.register(networkIcon);
        }
        this._networkIcon = networkIcon;
    }
    get networkIcon() {
        return this._networkIcon;
    }
    /**
     * @param value Defines which {@link UiAccountIdHashingOption attribute} should be used for color hashing to determine the background color
     */
    set forHashing(value) {
        this._forHashing = value;
        if (this._forHashing !== '') {
            this.setColorHashingOption();
        }
    }
    get forHashing() {
        return this._forHashing;
    }
    /**
     * @param disabled Defines whether the component has a disabled style or not
     * @default false
     */
    set disabled(disabled) {
        this._disabled = coerceBooleanProperty(disabled);
    }
    get disabled() {
        return this._disabled;
    }
    /**
     * @param interactable Defines if the component is interactable or not
     * @default false
     */
    set interactable(interactable) {
        this._interactable = coerceBooleanProperty(interactable);
    }
    get interactable() {
        return this._interactable;
    }
    constructor(iconReg, colorHashService) {
        this.iconReg = iconReg;
        this.colorHashService = colorHashService;
        /**
         * Defines the {@link UiAccountIdSize Size} of the component
         * @default 'xs'
         */
        this.size = 'xs';
        /**
         * Defines the {@link ThemeVariant Mode} of the component
         * @default 'light'
         */
        this.mode = 'light';
        /**
         * Defines which elements of the component should be shown. Checkout {@link UiAccountIdVariant} for possible combinations.
         * @default 'avatar'
         */
        this.variant = 'avatar';
        /**
         * Defines the activity {@link UiAccountStatus status} of the user
         * @default 'neutral'
         */
        this.status = 'neutral';
        /**
         * Event emitter when the action link is clicked
         */
        this.actionLinkClicked = new Subject();
        /** @ignore */
        this.nameVisible = false;
        /** @ignore */
        this.primaryVisible = false;
        /** @ignore */
        this.secondaryVisible = false;
        /** @ignore */
        this.actionVisible = false;
        /** @ignore */
        this.hashedColor = '';
        /** @ignore */
        this.imgFailedToLoad = false;
        this._disabled = false;
        this._interactable = false;
        this._forHashing = '';
        this.nameVisibility = [
            'name',
            'name-primary',
            'name-primary-secondary',
            'name-action',
            'name-primary-action'
        ];
        this.primaryMetaVisibility = [
            'name-primary',
            'name-primary-secondary',
            'primary-secondary',
            'name-primary-action'
        ];
        this.secondaryMetaVisibility = ['name-primary-secondary', 'primary-secondary'];
        this.actionVisibility = ['name-action', 'name-primary-action'];
        iconReg.register(SieIcon.Edit);
    }
    /** @ignore */
    ngOnChanges(changes) {
        if (changes.hasOwnProperty('variant')) {
            this.setVisibility();
        }
        if (changes.hasOwnProperty('forHashing') || changes.hasOwnProperty('disabled')) {
            this.setColorHashingOption();
        }
    }
    /** @ignore */
    hasAction() {
        return (this.linkText && this.linkText !== '') || this.interactable;
    }
    /** @ignore */
    onClickActionLink(event) {
        event.preventDefault();
        this.actionLinkClicked.next(event);
    }
    /** @ignore */
    loadInitials(isImageLoaded) {
        this.imgFailedToLoad = isImageLoaded;
    }
    setVisibility() {
        this.nameVisible = this.nameVisibility.includes(this.variant);
        this.primaryVisible = this.primaryMetaVisibility.includes(this.variant);
        this.secondaryVisible = this.secondaryMetaVisibility.includes(this.variant);
        this.actionVisible = this.actionVisibility.includes(this.variant);
    }
    setColorHashingOption() {
        if (this.disabled) {
            this.hashedColor = '';
            return;
        }
        const value = this.getValueToHash();
        if (value) {
            this.hashedColor = this.colorHashService.getHashAsColor(value);
        }
    }
    getValueToHash() {
        if (this._forHashing) {
            return this[this._forHashing];
        }
        else {
            return undefined;
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiAccountIdentifierComponent, deps: [{ token: i1.SieIconRegistryService }, { token: UiColorHashService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiAccountIdentifierComponent, selector: "sie-ui-account-identifier", inputs: { size: "size", mode: "mode", variant: "variant", status: "status", name: "name", initials: "initials", primaryMetaData: "primaryMetaData", secondaryMetaData: "secondaryMetaData", linkText: "linkText", greetings: "greetings", searchHighlight: "searchHighlight", avatarImage: "avatarImage", badgeData: "badgeData", networkIcon: "networkIcon", forHashing: "forHashing", disabled: "disabled", interactable: "interactable" }, outputs: { actionLinkClicked: "actionLinkClicked" }, usesOnChanges: true, ngImport: i0, template: "<div\n  class=\"account-identifier\"\n  [ngClass]=\"[\n    'account-identifier--' + size,\n    mode,\n    variant === 'name' ? 'name' : '',\n    hasAction() ? 'has-action' : '',\n    disabled ? 'disabled' : ''\n  ]\"\n>\n  <div class=\"account-identifier__initials-container\" [ngStyle]=\"{ 'background-color': hashedColor }\">\n    <sie-ui-picture\n      *ngIf=\"avatarImage && !imgFailedToLoad\"\n      class=\"account-identifier__avatar\"\n      [model]=\"{ urlLarge: avatarImage, altText: name }\"\n      (failedToLoadImg)=\"loadInitials($event)\"\n    ></sie-ui-picture>\n    <span *ngIf=\"!avatarImage || imgFailedToLoad\" class=\"account-identifier__initials\">{{ initials }}</span>\n    <span *ngIf=\"status === 'online'\" class=\"account-identifier__status-dot\"></span>\n  </div>\n  <sie-icon *ngIf=\"networkIcon\" [name]=\"networkIcon\" class=\"account-identifier__icon\"></sie-icon>\n  <div\n    class=\"account-identifier__text-container\"\n    *ngIf=\"nameVisible || primaryVisible || secondaryVisible || actionVisible\"\n  >\n    <span class=\"account-identifier__name\" *ngIf=\"nameVisible\">\n      <span\n        class=\"text-content\"\n        sieCoreHighlight\n        [highlightStartOnly]=\"false\"\n        [highlightBackgroundColor]=\"true\"\n        [reference]=\"searchHighlight\"\n        >{{ greetings ? greetings : name }}</span\n      >\n      <ng-content select=\"[customNameAppendix]\"></ng-content>\n      <sie-ui-label-badge\n        class=\"badge\"\n        *ngIf=\"!!badgeData?.label\"\n        [label]=\"badgeData.label\"\n        [variant]=\"badgeData.variant\"\n      ></sie-ui-label-badge>\n    </span>\n    <div class=\"account-identifier__meta-container\" *ngIf=\"primaryVisible || secondaryVisible || actionVisible\">\n      <span\n        class=\"account-identifier__meta--primary\"\n        *ngIf=\"primaryVisible\"\n        sieCoreAddTruncationAndTooltip\n        sieCoreHighlight\n        [highlightStartOnly]=\"false\"\n        [highlightBackgroundColor]=\"true\"\n        [reference]=\"searchHighlight\"\n        >{{ primaryMetaData }}</span\n      >\n      <span class=\"account-identifier__meta--secondary\" *ngIf=\"secondaryVisible\" sieCoreAddTruncationAndTooltip>{{\n        secondaryMetaData\n      }}</span>\n      <div class=\"guided-tour-step3\"></div>\n      <a\n        *ngIf=\"linkText && actionVisible\"\n        class=\"account-identifier__meta--link\"\n        rel=\"noopener\"\n        href=\"#\"\n        (click)=\"onClickActionLink($event)\"\n      >\n        <sie-icon class=\"account-identifier__meta-icon\" [name]=\"iconReg.sieIcon.Edit\"></sie-icon>\n        {{ linkText }}\n      </a>\n    </div>\n  </div>\n</div>\n", styles: [".account-identifier__meta--link{outline:none;outline-offset:0}@media (pointer: fine){.account-identifier__meta--link{position:relative}.account-identifier__meta--link:focus{outline:1px solid #1491eb;outline-offset:2px}.account-identifier__meta--link:focus:not(:focus-visible){outline:0}.account-identifier__meta--link:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}:host{width:100%}.account-identifier{display:flex;justify-content:flex-start;align-items:center}.account-identifier__name{word-break:break-word}.account-identifier__name .text-content:has(+.badge){margin-right:4px}.account-identifier--xs.has-action:active:not(:disabled):not(.hover-disabled),.account-identifier--xs.has-action:hover:not(:disabled):not(.hover-disabled),.account-identifier--s.has-action:active:not(:disabled):not(.hover-disabled),.account-identifier--s.has-action:hover:not(:disabled):not(.hover-disabled){cursor:pointer}.account-identifier--xs.has-action:active:not(:disabled):not(.hover-disabled) .account-identifier__initials-container,.account-identifier--xs.has-action:hover:not(:disabled):not(.hover-disabled) .account-identifier__initials-container,.account-identifier--s.has-action:active:not(:disabled):not(.hover-disabled) .account-identifier__initials-container,.account-identifier--s.has-action:hover:not(:disabled):not(.hover-disabled) .account-identifier__initials-container{position:relative}.account-identifier--xs.has-action:active:not(:disabled):not(.hover-disabled) .account-identifier__initials-container:before,.account-identifier--xs.has-action:hover:not(:disabled):not(.hover-disabled) .account-identifier__initials-container:before,.account-identifier--s.has-action:active:not(:disabled):not(.hover-disabled) .account-identifier__initials-container:before,.account-identifier--s.has-action:hover:not(:disabled):not(.hover-disabled) .account-identifier__initials-container:before{content:\"\";position:absolute;inset:-4px;z-index:1;border:2px solid #e5e5e9;border-radius:50%}.account-identifier--xs.dark.has-action:active:not(:disabled):not(.hover-disabled),.account-identifier--xs.dark.has-action:hover:not(:disabled):not(.hover-disabled),.account-identifier--s.dark.has-action:active:not(:disabled):not(.hover-disabled),.account-identifier--s.dark.has-action:hover:not(:disabled):not(.hover-disabled){cursor:pointer}.account-identifier--xs.dark.has-action:active:not(:disabled):not(.hover-disabled) .account-identifier__initials-container,.account-identifier--xs.dark.has-action:hover:not(:disabled):not(.hover-disabled) .account-identifier__initials-container,.account-identifier--s.dark.has-action:active:not(:disabled):not(.hover-disabled) .account-identifier__initials-container,.account-identifier--s.dark.has-action:hover:not(:disabled):not(.hover-disabled) .account-identifier__initials-container{position:relative}.account-identifier--xs.dark.has-action:active:not(:disabled):not(.hover-disabled) .account-identifier__initials-container:before,.account-identifier--xs.dark.has-action:hover:not(:disabled):not(.hover-disabled) .account-identifier__initials-container:before,.account-identifier--s.dark.has-action:active:not(:disabled):not(.hover-disabled) .account-identifier__initials-container:before,.account-identifier--s.dark.has-action:hover:not(:disabled):not(.hover-disabled) .account-identifier__initials-container:before{content:\"\";position:absolute;inset:-4px;z-index:1;border:2px solid #4c4c68;border-radius:50%}.account-identifier--m.has-action:active:not(:disabled):not(.hover-disabled),.account-identifier--m.has-action:hover:not(:disabled):not(.hover-disabled){cursor:pointer}.account-identifier--m.has-action:active:not(:disabled):not(.hover-disabled) .account-identifier__initials-container,.account-identifier--m.has-action:hover:not(:disabled):not(.hover-disabled) .account-identifier__initials-container{position:relative}.account-identifier--m.has-action:active:not(:disabled):not(.hover-disabled) .account-identifier__initials-container:before,.account-identifier--m.has-action:hover:not(:disabled):not(.hover-disabled) .account-identifier__initials-container:before{content:\"\";position:absolute;inset:-6px;z-index:1;border:2px solid #e5e5e9;border-radius:50%}.account-identifier--m.dark.has-action:active:not(:disabled):not(.hover-disabled),.account-identifier--m.dark.has-action:hover:not(:disabled):not(.hover-disabled){cursor:pointer}.account-identifier--m.dark.has-action:active:not(:disabled):not(.hover-disabled) .account-identifier__initials-container,.account-identifier--m.dark.has-action:hover:not(:disabled):not(.hover-disabled) .account-identifier__initials-container{position:relative}.account-identifier--m.dark.has-action:active:not(:disabled):not(.hover-disabled) .account-identifier__initials-container:before,.account-identifier--m.dark.has-action:hover:not(:disabled):not(.hover-disabled) .account-identifier__initials-container:before{content:\"\";position:absolute;inset:-6px;z-index:1;border:2px solid #4c4c68;border-radius:50%}.account-identifier--l.has-action:active:not(:disabled):not(.hover-disabled),.account-identifier--l.has-action:hover:not(:disabled):not(.hover-disabled),.account-identifier--xl.has-action:active:not(:disabled):not(.hover-disabled),.account-identifier--xl.has-action:hover:not(:disabled):not(.hover-disabled){cursor:pointer}.account-identifier--l.has-action:active:not(:disabled):not(.hover-disabled) .account-identifier__initials-container,.account-identifier--l.has-action:hover:not(:disabled):not(.hover-disabled) .account-identifier__initials-container,.account-identifier--xl.has-action:active:not(:disabled):not(.hover-disabled) .account-identifier__initials-container,.account-identifier--xl.has-action:hover:not(:disabled):not(.hover-disabled) .account-identifier__initials-container{position:relative}.account-identifier--l.has-action:active:not(:disabled):not(.hover-disabled) .account-identifier__initials-container:before,.account-identifier--l.has-action:hover:not(:disabled):not(.hover-disabled) .account-identifier__initials-container:before,.account-identifier--xl.has-action:active:not(:disabled):not(.hover-disabled) .account-identifier__initials-container:before,.account-identifier--xl.has-action:hover:not(:disabled):not(.hover-disabled) .account-identifier__initials-container:before{content:\"\";position:absolute;inset:-6px;z-index:1;border:3px solid #e5e5e9;border-radius:50%}.account-identifier--l.dark.has-action:active:not(:disabled):not(.hover-disabled),.account-identifier--l.dark.has-action:hover:not(:disabled):not(.hover-disabled),.account-identifier--xl.dark.has-action:active:not(:disabled):not(.hover-disabled),.account-identifier--xl.dark.has-action:hover:not(:disabled):not(.hover-disabled){cursor:pointer}.account-identifier--l.dark.has-action:active:not(:disabled):not(.hover-disabled) .account-identifier__initials-container,.account-identifier--l.dark.has-action:hover:not(:disabled):not(.hover-disabled) .account-identifier__initials-container,.account-identifier--xl.dark.has-action:active:not(:disabled):not(.hover-disabled) .account-identifier__initials-container,.account-identifier--xl.dark.has-action:hover:not(:disabled):not(.hover-disabled) .account-identifier__initials-container{position:relative}.account-identifier--l.dark.has-action:active:not(:disabled):not(.hover-disabled) .account-identifier__initials-container:before,.account-identifier--l.dark.has-action:hover:not(:disabled):not(.hover-disabled) .account-identifier__initials-container:before,.account-identifier--xl.dark.has-action:active:not(:disabled):not(.hover-disabled) .account-identifier__initials-container:before,.account-identifier--xl.dark.has-action:hover:not(:disabled):not(.hover-disabled) .account-identifier__initials-container:before{content:\"\";position:absolute;inset:-6px;z-index:1;border:3px solid #4c4c68;border-radius:50%}.account-identifier__initials-container{align-self:flex-start;position:relative;border-radius:50%;background-color:#00557c}.dark .account-identifier__initials-container{background-color:#00bedc}.account-identifier--xs .account-identifier__initials-container{margin-top:2px;background-color:#9999a9}.account-identifier--l .account-identifier__initials-container{margin-top:5px}.account-identifier--xs.dark .account-identifier__initials-container{background-color:#ccccd4}.account-identifier--xs.name .account-identifier__initials-container{top:0}.account-identifier__initials{display:flex;justify-content:center;align-items:center;flex-shrink:0;color:#fff}.account-identifier__icon{width:19px;height:12px;display:flex;align-items:center;fill:currentColor;color:#fff;position:relative;margin-left:-8px;top:10px;z-index:1}.account-identifier__icon svg{fill:currentColor;width:inherit;height:inherit}.account-identifier__icon svg g{fill:currentColor;width:inherit;height:inherit}.account-identifier__icon svg text{font-family:Siemens Sans,sans-serif}.account-identifier--xs .account-identifier__initials{font-size:.6875rem;font-weight:700;line-height:.9375rem;letter-spacing:.0125rem;width:24px;height:24px;line-height:15px;letter-spacing:.2px}.account-identifier--s .account-identifier__initials{font-size:.75rem;font-weight:700;line-height:1rem;width:32px;height:32px}.account-identifier--m .account-identifier__initials{font-size:1rem;line-height:1.5rem;width:48px;height:48px;font-weight:700}.account-identifier--l .account-identifier__initials{font-size:1.625rem;line-height:2.25rem;width:64px;height:64px;font-weight:700}.account-identifier--xl .account-identifier__initials{font-size:2rem;line-height:32px;width:88px;height:88px;font-weight:700}.account-identifier__avatar{display:block;border-radius:50%;overflow:hidden}.account-identifier--xs .account-identifier__avatar{width:24px;height:24px}.account-identifier--s .account-identifier__avatar{width:32px;height:32px}.account-identifier--m .account-identifier__avatar{width:48px;height:48px}.account-identifier--l .account-identifier__avatar{width:64px;height:64px}.account-identifier--xl .account-identifier__avatar{width:88px;height:88px}.account-identifier__status-dot{z-index:1;position:absolute;right:-3px;bottom:-3px;border-style:solid;border-color:#fff;border-radius:50%;background-color:#00af52}.account-identifier--xs .account-identifier__status-dot{right:-1px;bottom:-1px;width:8px;height:8px;border-width:1px}.account-identifier--s .account-identifier__status-dot{width:12px;height:12px;border-width:2px}.account-identifier--m .account-identifier__status-dot{width:18px;height:18px;border-width:3px}.account-identifier--l .account-identifier__status-dot{width:22px;height:22px;border-width:3px}.account-identifier--xl .account-identifier__status-dot{width:28px;height:28px;border-width:4px}.account-identifier.dark .account-identifier__status-dot{border-color:#000028}.account-identifier--xs.dark .account-identifier__initials{color:#000028}.account-identifier--xs .account-identifier__name{font-size:.6875rem;font-weight:700;line-height:.9375rem;letter-spacing:.0125rem;line-height:13px}.account-identifier--s .account-identifier__name{font-size:.75rem;font-weight:700;line-height:1rem}.account-identifier--m .account-identifier__name{font-size:1rem;font-weight:700;line-height:1.5rem;line-height:22px;margin-bottom:1px}.account-identifier--l .account-identifier__name{font-size:1.25rem;font-weight:700;line-height:1.625rem;margin-bottom:2px}.account-identifier--xl .account-identifier__name{font-size:1.625rem;font-weight:700;line-height:2.25rem;margin-bottom:1px}.account-identifier.dark .account-identifier__name{color:#fff}.account-identifier__meta--primary,.account-identifier__meta--secondary{white-space:nowrap;overflow:hidden;text-overflow:ellipsis;width:100%;text-align:left;color:#4c4c68}.account-identifier__meta--link{color:#4c4c68;fill:#4c4c68;text-decoration:none}.account-identifier__meta-icon{width:16px;height:16px;display:flex;align-items:center;fill:currentColor;display:inline-block}.account-identifier__meta-icon svg{fill:currentColor;width:inherit;height:inherit}.account-identifier__meta-icon svg g{fill:currentColor;width:inherit;height:inherit}.account-identifier__meta-icon svg text{font-family:Siemens Sans,sans-serif}.account-identifier__meta-icon svg{position:relative}.account-identifier--xs .account-identifier__meta--primary,.account-identifier--xs .account-identifier__meta--secondary,.account-identifier--xs .account-identifier__meta--link{font-size:.6875rem;font-weight:400;line-height:.9375rem;line-height:15px}.account-identifier--s .account-identifier__meta--primary,.account-identifier--s .account-identifier__meta--secondary,.account-identifier--s .account-identifier__meta--link,.account-identifier--m .account-identifier__meta--primary,.account-identifier--m .account-identifier__meta--secondary,.account-identifier--m .account-identifier__meta--link{font-size:.75rem;font-weight:400;line-height:1rem}.account-identifier--l .account-identifier__meta--primary,.account-identifier--l .account-identifier__meta--secondary,.account-identifier--l .account-identifier__meta--link{font-size:.875rem;font-weight:400;line-height:1.25rem}.account-identifier.dark .account-identifier__meta--primary,.account-identifier.dark .account-identifier__meta--secondary{color:#ccccd4}.account-identifier.dark .account-identifier__meta--link{color:#ccccd4;fill:#ccccd4}.account-identifier__text-container{display:flex;justify-content:flex-start;align-self:center;flex-direction:column;overflow:hidden;padding:0 0 4px 4px;margin:0 0 -4px -4px}.account-identifier--xs .account-identifier__text-container,.account-identifier--s .account-identifier__text-container{margin-left:4px}.account-identifier--l .account-identifier__text-container,.account-identifier--m .account-identifier__text-container{margin-left:8px}.account-identifier--xl .account-identifier__text-container{margin-left:12px}.account-identifier__meta-container{display:flex;flex-direction:column;align-items:flex-start}.account-identifier__name+.account-identifier__meta-container{margin-top:2px}.account-identifier--m .account-identifier__name+.account-identifier__meta-container{margin-top:0}.account-identifier__link{width:auto}.account-identifier.disabled .account-identifier__name,.account-identifier.disabled .account-identifier__meta--primary,.account-identifier.disabled .account-identifier__meta--secondary,.account-identifier.disabled .account-identifier__meta--link{color:#b3b3be}.account-identifier.disabled .account-identifier__initials-container{background:#b3b3be}.guided-tour-step3{height:10px;width:10px;left:145px;position:absolute;bottom:7px}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "directive", type: i1$1.AddTruncationAndTooltipDirective, selector: "[sieCoreAddTruncationAndTooltip]", inputs: ["maxNumberOfLinesToShow"] }, { kind: "directive", type: i1$1.HighlightDirective, selector: "[sieCoreHighlight]", inputs: ["reference", "inverted", "highlightStartOnly", "highlightBackgroundColor"] }, { kind: "component", type: UiPictureComponent, selector: "sie-ui-picture", inputs: ["model", "size", "ratio", "notLoadedLabel", "theme", "context", "caption", "shouldHaveOutline"], outputs: ["failedToLoadImg"] }, { kind: "component", type: UiLabelBadgeComponent, selector: "sie-ui-label-badge", inputs: ["label", "variant"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiAccountIdentifierComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-account-identifier', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div\n  class=\"account-identifier\"\n  [ngClass]=\"[\n    'account-identifier--' + size,\n    mode,\n    variant === 'name' ? 'name' : '',\n    hasAction() ? 'has-action' : '',\n    disabled ? 'disabled' : ''\n  ]\"\n>\n  <div class=\"account-identifier__initials-container\" [ngStyle]=\"{ 'background-color': hashedColor }\">\n    <sie-ui-picture\n      *ngIf=\"avatarImage && !imgFailedToLoad\"\n      class=\"account-identifier__avatar\"\n      [model]=\"{ urlLarge: avatarImage, altText: name }\"\n      (failedToLoadImg)=\"loadInitials($event)\"\n    ></sie-ui-picture>\n    <span *ngIf=\"!avatarImage || imgFailedToLoad\" class=\"account-identifier__initials\">{{ initials }}</span>\n    <span *ngIf=\"status === 'online'\" class=\"account-identifier__status-dot\"></span>\n  </div>\n  <sie-icon *ngIf=\"networkIcon\" [name]=\"networkIcon\" class=\"account-identifier__icon\"></sie-icon>\n  <div\n    class=\"account-identifier__text-container\"\n    *ngIf=\"nameVisible || primaryVisible || secondaryVisible || actionVisible\"\n  >\n    <span class=\"account-identifier__name\" *ngIf=\"nameVisible\">\n      <span\n        class=\"text-content\"\n        sieCoreHighlight\n        [highlightStartOnly]=\"false\"\n        [highlightBackgroundColor]=\"true\"\n        [reference]=\"searchHighlight\"\n        >{{ greetings ? greetings : name }}</span\n      >\n      <ng-content select=\"[customNameAppendix]\"></ng-content>\n      <sie-ui-label-badge\n        class=\"badge\"\n        *ngIf=\"!!badgeData?.label\"\n        [label]=\"badgeData.label\"\n        [variant]=\"badgeData.variant\"\n      ></sie-ui-label-badge>\n    </span>\n    <div class=\"account-identifier__meta-container\" *ngIf=\"primaryVisible || secondaryVisible || actionVisible\">\n      <span\n        class=\"account-identifier__meta--primary\"\n        *ngIf=\"primaryVisible\"\n        sieCoreAddTruncationAndTooltip\n        sieCoreHighlight\n        [highlightStartOnly]=\"false\"\n        [highlightBackgroundColor]=\"true\"\n        [reference]=\"searchHighlight\"\n        >{{ primaryMetaData }}</span\n      >\n      <span class=\"account-identifier__meta--secondary\" *ngIf=\"secondaryVisible\" sieCoreAddTruncationAndTooltip>{{\n        secondaryMetaData\n      }}</span>\n      <div class=\"guided-tour-step3\"></div>\n      <a\n        *ngIf=\"linkText && actionVisible\"\n        class=\"account-identifier__meta--link\"\n        rel=\"noopener\"\n        href=\"#\"\n        (click)=\"onClickActionLink($event)\"\n      >\n        <sie-icon class=\"account-identifier__meta-icon\" [name]=\"iconReg.sieIcon.Edit\"></sie-icon>\n        {{ linkText }}\n      </a>\n    </div>\n  </div>\n</div>\n", styles: [".account-identifier__meta--link{outline:none;outline-offset:0}@media (pointer: fine){.account-identifier__meta--link{position:relative}.account-identifier__meta--link:focus{outline:1px solid #1491eb;outline-offset:2px}.account-identifier__meta--link:focus:not(:focus-visible){outline:0}.account-identifier__meta--link:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}:host{width:100%}.account-identifier{display:flex;justify-content:flex-start;align-items:center}.account-identifier__name{word-break:break-word}.account-identifier__name .text-content:has(+.badge){margin-right:4px}.account-identifier--xs.has-action:active:not(:disabled):not(.hover-disabled),.account-identifier--xs.has-action:hover:not(:disabled):not(.hover-disabled),.account-identifier--s.has-action:active:not(:disabled):not(.hover-disabled),.account-identifier--s.has-action:hover:not(:disabled):not(.hover-disabled){cursor:pointer}.account-identifier--xs.has-action:active:not(:disabled):not(.hover-disabled) .account-identifier__initials-container,.account-identifier--xs.has-action:hover:not(:disabled):not(.hover-disabled) .account-identifier__initials-container,.account-identifier--s.has-action:active:not(:disabled):not(.hover-disabled) .account-identifier__initials-container,.account-identifier--s.has-action:hover:not(:disabled):not(.hover-disabled) .account-identifier__initials-container{position:relative}.account-identifier--xs.has-action:active:not(:disabled):not(.hover-disabled) .account-identifier__initials-container:before,.account-identifier--xs.has-action:hover:not(:disabled):not(.hover-disabled) .account-identifier__initials-container:before,.account-identifier--s.has-action:active:not(:disabled):not(.hover-disabled) .account-identifier__initials-container:before,.account-identifier--s.has-action:hover:not(:disabled):not(.hover-disabled) .account-identifier__initials-container:before{content:\"\";position:absolute;inset:-4px;z-index:1;border:2px solid #e5e5e9;border-radius:50%}.account-identifier--xs.dark.has-action:active:not(:disabled):not(.hover-disabled),.account-identifier--xs.dark.has-action:hover:not(:disabled):not(.hover-disabled),.account-identifier--s.dark.has-action:active:not(:disabled):not(.hover-disabled),.account-identifier--s.dark.has-action:hover:not(:disabled):not(.hover-disabled){cursor:pointer}.account-identifier--xs.dark.has-action:active:not(:disabled):not(.hover-disabled) .account-identifier__initials-container,.account-identifier--xs.dark.has-action:hover:not(:disabled):not(.hover-disabled) .account-identifier__initials-container,.account-identifier--s.dark.has-action:active:not(:disabled):not(.hover-disabled) .account-identifier__initials-container,.account-identifier--s.dark.has-action:hover:not(:disabled):not(.hover-disabled) .account-identifier__initials-container{position:relative}.account-identifier--xs.dark.has-action:active:not(:disabled):not(.hover-disabled) .account-identifier__initials-container:before,.account-identifier--xs.dark.has-action:hover:not(:disabled):not(.hover-disabled) .account-identifier__initials-container:before,.account-identifier--s.dark.has-action:active:not(:disabled):not(.hover-disabled) .account-identifier__initials-container:before,.account-identifier--s.dark.has-action:hover:not(:disabled):not(.hover-disabled) .account-identifier__initials-container:before{content:\"\";position:absolute;inset:-4px;z-index:1;border:2px solid #4c4c68;border-radius:50%}.account-identifier--m.has-action:active:not(:disabled):not(.hover-disabled),.account-identifier--m.has-action:hover:not(:disabled):not(.hover-disabled){cursor:pointer}.account-identifier--m.has-action:active:not(:disabled):not(.hover-disabled) .account-identifier__initials-container,.account-identifier--m.has-action:hover:not(:disabled):not(.hover-disabled) .account-identifier__initials-container{position:relative}.account-identifier--m.has-action:active:not(:disabled):not(.hover-disabled) .account-identifier__initials-container:before,.account-identifier--m.has-action:hover:not(:disabled):not(.hover-disabled) .account-identifier__initials-container:before{content:\"\";position:absolute;inset:-6px;z-index:1;border:2px solid #e5e5e9;border-radius:50%}.account-identifier--m.dark.has-action:active:not(:disabled):not(.hover-disabled),.account-identifier--m.dark.has-action:hover:not(:disabled):not(.hover-disabled){cursor:pointer}.account-identifier--m.dark.has-action:active:not(:disabled):not(.hover-disabled) .account-identifier__initials-container,.account-identifier--m.dark.has-action:hover:not(:disabled):not(.hover-disabled) .account-identifier__initials-container{position:relative}.account-identifier--m.dark.has-action:active:not(:disabled):not(.hover-disabled) .account-identifier__initials-container:before,.account-identifier--m.dark.has-action:hover:not(:disabled):not(.hover-disabled) .account-identifier__initials-container:before{content:\"\";position:absolute;inset:-6px;z-index:1;border:2px solid #4c4c68;border-radius:50%}.account-identifier--l.has-action:active:not(:disabled):not(.hover-disabled),.account-identifier--l.has-action:hover:not(:disabled):not(.hover-disabled),.account-identifier--xl.has-action:active:not(:disabled):not(.hover-disabled),.account-identifier--xl.has-action:hover:not(:disabled):not(.hover-disabled){cursor:pointer}.account-identifier--l.has-action:active:not(:disabled):not(.hover-disabled) .account-identifier__initials-container,.account-identifier--l.has-action:hover:not(:disabled):not(.hover-disabled) .account-identifier__initials-container,.account-identifier--xl.has-action:active:not(:disabled):not(.hover-disabled) .account-identifier__initials-container,.account-identifier--xl.has-action:hover:not(:disabled):not(.hover-disabled) .account-identifier__initials-container{position:relative}.account-identifier--l.has-action:active:not(:disabled):not(.hover-disabled) .account-identifier__initials-container:before,.account-identifier--l.has-action:hover:not(:disabled):not(.hover-disabled) .account-identifier__initials-container:before,.account-identifier--xl.has-action:active:not(:disabled):not(.hover-disabled) .account-identifier__initials-container:before,.account-identifier--xl.has-action:hover:not(:disabled):not(.hover-disabled) .account-identifier__initials-container:before{content:\"\";position:absolute;inset:-6px;z-index:1;border:3px solid #e5e5e9;border-radius:50%}.account-identifier--l.dark.has-action:active:not(:disabled):not(.hover-disabled),.account-identifier--l.dark.has-action:hover:not(:disabled):not(.hover-disabled),.account-identifier--xl.dark.has-action:active:not(:disabled):not(.hover-disabled),.account-identifier--xl.dark.has-action:hover:not(:disabled):not(.hover-disabled){cursor:pointer}.account-identifier--l.dark.has-action:active:not(:disabled):not(.hover-disabled) .account-identifier__initials-container,.account-identifier--l.dark.has-action:hover:not(:disabled):not(.hover-disabled) .account-identifier__initials-container,.account-identifier--xl.dark.has-action:active:not(:disabled):not(.hover-disabled) .account-identifier__initials-container,.account-identifier--xl.dark.has-action:hover:not(:disabled):not(.hover-disabled) .account-identifier__initials-container{position:relative}.account-identifier--l.dark.has-action:active:not(:disabled):not(.hover-disabled) .account-identifier__initials-container:before,.account-identifier--l.dark.has-action:hover:not(:disabled):not(.hover-disabled) .account-identifier__initials-container:before,.account-identifier--xl.dark.has-action:active:not(:disabled):not(.hover-disabled) .account-identifier__initials-container:before,.account-identifier--xl.dark.has-action:hover:not(:disabled):not(.hover-disabled) .account-identifier__initials-container:before{content:\"\";position:absolute;inset:-6px;z-index:1;border:3px solid #4c4c68;border-radius:50%}.account-identifier__initials-container{align-self:flex-start;position:relative;border-radius:50%;background-color:#00557c}.dark .account-identifier__initials-container{background-color:#00bedc}.account-identifier--xs .account-identifier__initials-container{margin-top:2px;background-color:#9999a9}.account-identifier--l .account-identifier__initials-container{margin-top:5px}.account-identifier--xs.dark .account-identifier__initials-container{background-color:#ccccd4}.account-identifier--xs.name .account-identifier__initials-container{top:0}.account-identifier__initials{display:flex;justify-content:center;align-items:center;flex-shrink:0;color:#fff}.account-identifier__icon{width:19px;height:12px;display:flex;align-items:center;fill:currentColor;color:#fff;position:relative;margin-left:-8px;top:10px;z-index:1}.account-identifier__icon svg{fill:currentColor;width:inherit;height:inherit}.account-identifier__icon svg g{fill:currentColor;width:inherit;height:inherit}.account-identifier__icon svg text{font-family:Siemens Sans,sans-serif}.account-identifier--xs .account-identifier__initials{font-size:.6875rem;font-weight:700;line-height:.9375rem;letter-spacing:.0125rem;width:24px;height:24px;line-height:15px;letter-spacing:.2px}.account-identifier--s .account-identifier__initials{font-size:.75rem;font-weight:700;line-height:1rem;width:32px;height:32px}.account-identifier--m .account-identifier__initials{font-size:1rem;line-height:1.5rem;width:48px;height:48px;font-weight:700}.account-identifier--l .account-identifier__initials{font-size:1.625rem;line-height:2.25rem;width:64px;height:64px;font-weight:700}.account-identifier--xl .account-identifier__initials{font-size:2rem;line-height:32px;width:88px;height:88px;font-weight:700}.account-identifier__avatar{display:block;border-radius:50%;overflow:hidden}.account-identifier--xs .account-identifier__avatar{width:24px;height:24px}.account-identifier--s .account-identifier__avatar{width:32px;height:32px}.account-identifier--m .account-identifier__avatar{width:48px;height:48px}.account-identifier--l .account-identifier__avatar{width:64px;height:64px}.account-identifier--xl .account-identifier__avatar{width:88px;height:88px}.account-identifier__status-dot{z-index:1;position:absolute;right:-3px;bottom:-3px;border-style:solid;border-color:#fff;border-radius:50%;background-color:#00af52}.account-identifier--xs .account-identifier__status-dot{right:-1px;bottom:-1px;width:8px;height:8px;border-width:1px}.account-identifier--s .account-identifier__status-dot{width:12px;height:12px;border-width:2px}.account-identifier--m .account-identifier__status-dot{width:18px;height:18px;border-width:3px}.account-identifier--l .account-identifier__status-dot{width:22px;height:22px;border-width:3px}.account-identifier--xl .account-identifier__status-dot{width:28px;height:28px;border-width:4px}.account-identifier.dark .account-identifier__status-dot{border-color:#000028}.account-identifier--xs.dark .account-identifier__initials{color:#000028}.account-identifier--xs .account-identifier__name{font-size:.6875rem;font-weight:700;line-height:.9375rem;letter-spacing:.0125rem;line-height:13px}.account-identifier--s .account-identifier__name{font-size:.75rem;font-weight:700;line-height:1rem}.account-identifier--m .account-identifier__name{font-size:1rem;font-weight:700;line-height:1.5rem;line-height:22px;margin-bottom:1px}.account-identifier--l .account-identifier__name{font-size:1.25rem;font-weight:700;line-height:1.625rem;margin-bottom:2px}.account-identifier--xl .account-identifier__name{font-size:1.625rem;font-weight:700;line-height:2.25rem;margin-bottom:1px}.account-identifier.dark .account-identifier__name{color:#fff}.account-identifier__meta--primary,.account-identifier__meta--secondary{white-space:nowrap;overflow:hidden;text-overflow:ellipsis;width:100%;text-align:left;color:#4c4c68}.account-identifier__meta--link{color:#4c4c68;fill:#4c4c68;text-decoration:none}.account-identifier__meta-icon{width:16px;height:16px;display:flex;align-items:center;fill:currentColor;display:inline-block}.account-identifier__meta-icon svg{fill:currentColor;width:inherit;height:inherit}.account-identifier__meta-icon svg g{fill:currentColor;width:inherit;height:inherit}.account-identifier__meta-icon svg text{font-family:Siemens Sans,sans-serif}.account-identifier__meta-icon svg{position:relative}.account-identifier--xs .account-identifier__meta--primary,.account-identifier--xs .account-identifier__meta--secondary,.account-identifier--xs .account-identifier__meta--link{font-size:.6875rem;font-weight:400;line-height:.9375rem;line-height:15px}.account-identifier--s .account-identifier__meta--primary,.account-identifier--s .account-identifier__meta--secondary,.account-identifier--s .account-identifier__meta--link,.account-identifier--m .account-identifier__meta--primary,.account-identifier--m .account-identifier__meta--secondary,.account-identifier--m .account-identifier__meta--link{font-size:.75rem;font-weight:400;line-height:1rem}.account-identifier--l .account-identifier__meta--primary,.account-identifier--l .account-identifier__meta--secondary,.account-identifier--l .account-identifier__meta--link{font-size:.875rem;font-weight:400;line-height:1.25rem}.account-identifier.dark .account-identifier__meta--primary,.account-identifier.dark .account-identifier__meta--secondary{color:#ccccd4}.account-identifier.dark .account-identifier__meta--link{color:#ccccd4;fill:#ccccd4}.account-identifier__text-container{display:flex;justify-content:flex-start;align-self:center;flex-direction:column;overflow:hidden;padding:0 0 4px 4px;margin:0 0 -4px -4px}.account-identifier--xs .account-identifier__text-container,.account-identifier--s .account-identifier__text-container{margin-left:4px}.account-identifier--l .account-identifier__text-container,.account-identifier--m .account-identifier__text-container{margin-left:8px}.account-identifier--xl .account-identifier__text-container{margin-left:12px}.account-identifier__meta-container{display:flex;flex-direction:column;align-items:flex-start}.account-identifier__name+.account-identifier__meta-container{margin-top:2px}.account-identifier--m .account-identifier__name+.account-identifier__meta-container{margin-top:0}.account-identifier__link{width:auto}.account-identifier.disabled .account-identifier__name,.account-identifier.disabled .account-identifier__meta--primary,.account-identifier.disabled .account-identifier__meta--secondary,.account-identifier.disabled .account-identifier__meta--link{color:#b3b3be}.account-identifier.disabled .account-identifier__initials-container{background:#b3b3be}.guided-tour-step3{height:10px;width:10px;left:145px;position:absolute;bottom:7px}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }, { type: UiColorHashService }]; }, propDecorators: { size: [{
                type: Input
            }], mode: [{
                type: Input
            }], variant: [{
                type: Input
            }], status: [{
                type: Input
            }], name: [{
                type: Input
            }], initials: [{
                type: Input
            }], primaryMetaData: [{
                type: Input
            }], secondaryMetaData: [{
                type: Input
            }], linkText: [{
                type: Input
            }], greetings: [{
                type: Input
            }], searchHighlight: [{
                type: Input
            }], avatarImage: [{
                type: Input
            }], badgeData: [{
                type: Input
            }], networkIcon: [{
                type: Input
            }], forHashing: [{
                type: Input
            }], disabled: [{
                type: Input
            }], interactable: [{
                type: Input
            }], actionLinkClicked: [{
                type: Output
            }] } });

/**
 * # Picture Module
 * - {@link UiPictureComponent}
 *
 * ## Module peer dependencies
 * - {@link SieIconsModule}
 */
class UiPictureModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiPictureModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiPictureModule, declarations: [UiPictureComponent], imports: [CommonModule, SieIconsModule], exports: [UiPictureComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiPictureModule, imports: [CommonModule, SieIconsModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiPictureModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiPictureComponent],
                    imports: [CommonModule, SieIconsModule],
                    exports: [UiPictureComponent]
                }]
        }] });

class UiLabelBadgeModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiLabelBadgeModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiLabelBadgeModule, declarations: [UiLabelBadgeComponent], imports: [CommonModule], exports: [UiLabelBadgeComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiLabelBadgeModule, imports: [CommonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiLabelBadgeModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiLabelBadgeComponent],
                    imports: [CommonModule],
                    exports: [UiLabelBadgeComponent]
                }]
        }] });

/**
 * # Account Identifier Module
 * - {@link UiAccountIdentifierComponent}
 *
 * ## Module peer dependencies
 * - {@link SieIconsModule}
 */
class UiAccountIdentifierModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiAccountIdentifierModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiAccountIdentifierModule, declarations: [UiAccountIdentifierComponent], imports: [CommonModule,
            SieIconsModule,
            AddTruncationAndTooltipModule,
            HighlightModule,
            UiPictureModule,
            UiLabelBadgeModule], exports: [UiAccountIdentifierComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiAccountIdentifierModule, imports: [CommonModule,
            SieIconsModule,
            AddTruncationAndTooltipModule,
            HighlightModule,
            UiPictureModule,
            UiLabelBadgeModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiAccountIdentifierModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiAccountIdentifierComponent],
                    imports: [
                        CommonModule,
                        SieIconsModule,
                        AddTruncationAndTooltipModule,
                        HighlightModule,
                        UiPictureModule,
                        UiLabelBadgeModule
                    ],
                    exports: [UiAccountIdentifierComponent]
                }]
        }] });

class UiButtonGroupComponent {
    set buttonAlignmentClass(alignment) {
        this._buttonAlignmentClass = alignment;
    }
    constructor(layoutService, cdr) {
        this.layoutService = layoutService;
        this.cdr = cdr;
        this.buttons = [];
        this.wrapButtons = false;
        this.direction = 'column';
        this.flexDirection = 'row';
        this.fullWidth = false;
        this.buttonClick = new Subject();
        this.subscription = new Subscription();
    }
    ngOnInit() {
        this.subscribeToBreakpointChange();
        if (!this._buttonAlignmentClass) {
            this._buttonAlignmentClass = this.getButtonAlignment();
        }
    }
    onClick(event, button) {
        this.buttonClick.next({ button, event });
    }
    updateView() {
        this.cdr.detectChanges();
    }
    subscribeToBreakpointChange() {
        this.subscription.add(this.layoutService.breakPointChangedEvent.subscribe(() => {
            this.checkBreakpoint();
        }));
    }
    checkBreakpoint() {
        if (this.buttons) {
            // deep copy so that buttons are re-rendered (=> host of button has to be updated)
            this.buttons = deepCopy(this.buttons);
            this.cdr.detectChanges();
        }
    }
    getButtonAlignment() {
        return this.buttons && this.buttons.length > 1 ? 'center' : 'left';
    }
    getSafeModel(button) {
        return {
            ...button,
            buttonType: button.buttonType || 'button',
            iconPosition: button.iconPosition || 'leading',
            fullWidth: this.fullWidth || (this.direction === 'column' && (this.fullWidthOnViewportS || this.buttons.length > 1)),
            cssClass: button.cssClass || '',
            variant: button.variant || 'primary',
            background: button.background || 'light'
        };
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiButtonGroupComponent, deps: [{ token: i1$1.LayoutService }, { token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiButtonGroupComponent, selector: "sie-ui-button-group", inputs: { buttons: "buttons", fullWidthOnViewportS: "fullWidthOnViewportS", wrapButtons: "wrapButtons", direction: "direction", flexDirection: "flexDirection", fullWidth: "fullWidth", buttonAlignmentClass: "buttonAlignmentClass" }, outputs: { buttonClick: "buttonClick" }, host: { properties: { "class.full-width": "this.fullWidth" } }, ngImport: i0, template: "<div class=\"button-group\">\n  <ul\n    class=\"button-group__list {{ _buttonAlignmentClass }} {{ wrapButtons ? 'wrap' : '' }} direction-{{ direction }}\"\n    [style.--flex-direction]=\"flexDirection\"\n  >\n    <li *ngFor=\"let button of buttons; let i = index\" [ngClass]=\"{ column: direction === 'column' }\">\n      <sie-ui-button-wrapper\n        [model]=\"getSafeModel(button)\"\n        (clicked)=\"onClick($event, button)\"\n        sieCoreAddTooltip\n      ></sie-ui-button-wrapper>\n    </li>\n  </ul>\n</div>\n", styles: ["@media (max-width: 639.78px){:host{width:100%}}:host.full-width{max-width:100%}.button-group__list{list-style:none;margin:0;padding:0;display:flex;width:100%;gap:8px}.button-group__list.wrap{flex-wrap:wrap}.button-group__list.center{justify-content:center}.button-group__list.left{justify-content:flex-start}.button-group__list.right{justify-content:flex-end}.button-group__list.space-between{justify-content:space-between}.button-group__list.direction-column{flex-direction:column}@media (min-width: 401px){.button-group__list.direction-column{flex-direction:var(--flex-direction, row)}}.button-group__list.direction-row{flex-direction:row}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "component", type: UiButtonWrapperComponent, selector: "sie-ui-button-wrapper", inputs: ["model"], outputs: ["clicked"] }, { kind: "directive", type: i1$1.AddTooltipDirective, selector: "[sieCoreAddTooltip]" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiButtonGroupComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-button-group', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"button-group\">\n  <ul\n    class=\"button-group__list {{ _buttonAlignmentClass }} {{ wrapButtons ? 'wrap' : '' }} direction-{{ direction }}\"\n    [style.--flex-direction]=\"flexDirection\"\n  >\n    <li *ngFor=\"let button of buttons; let i = index\" [ngClass]=\"{ column: direction === 'column' }\">\n      <sie-ui-button-wrapper\n        [model]=\"getSafeModel(button)\"\n        (clicked)=\"onClick($event, button)\"\n        sieCoreAddTooltip\n      ></sie-ui-button-wrapper>\n    </li>\n  </ul>\n</div>\n", styles: ["@media (max-width: 639.78px){:host{width:100%}}:host.full-width{max-width:100%}.button-group__list{list-style:none;margin:0;padding:0;display:flex;width:100%;gap:8px}.button-group__list.wrap{flex-wrap:wrap}.button-group__list.center{justify-content:center}.button-group__list.left{justify-content:flex-start}.button-group__list.right{justify-content:flex-end}.button-group__list.space-between{justify-content:space-between}.button-group__list.direction-column{flex-direction:column}@media (min-width: 401px){.button-group__list.direction-column{flex-direction:var(--flex-direction, row)}}.button-group__list.direction-row{flex-direction:row}\n"] }]
        }], ctorParameters: function () { return [{ type: i1$1.LayoutService }, { type: i0.ChangeDetectorRef }]; }, propDecorators: { buttons: [{
                type: Input
            }], fullWidthOnViewportS: [{
                type: Input
            }], wrapButtons: [{
                type: Input
            }], direction: [{
                type: Input
            }], flexDirection: [{
                type: Input
            }], fullWidth: [{
                type: HostBinding,
                args: ['class.full-width']
            }, {
                type: Input
            }], buttonAlignmentClass: [{
                type: Input
            }], buttonClick: [{
                type: Output
            }] } });

class UiButtonGroupModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiButtonGroupModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiButtonGroupModule, declarations: [UiButtonGroupComponent], imports: [CommonModule, UiButtonModule, AddTooltipModule], exports: [UiButtonGroupComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiButtonGroupModule, imports: [CommonModule, UiButtonModule, AddTooltipModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiButtonGroupModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiButtonGroupComponent],
                    imports: [CommonModule, UiButtonModule, AddTooltipModule],
                    exports: [UiButtonGroupComponent]
                }]
        }] });

/** @ignore */
class UiButtonTypes {
    static { this.UiButtonIconMapping = {
        buy: SieIcon.ShoppingCart,
        play: SieIcon.Play,
        getTicket: SieIcon.Tickets,
        addEvent: SieIcon.Calendar,
        delete: SieIcon.Delete,
        learnMore: null,
        signUp: SieIcon.UserAccount,
        userCircle: SieIcon.UserAccount,
        search: SieIcon.Search,
        more: SieIcon.More,
        morePortrait: SieIcon.SieportalMorePortrait,
        info: SieIcon.Information,
        infoCircle: SieIcon.Information,
        menu: SieIcon.Menu,
        close: SieIcon.Close,
        download: SieIcon.Download,
        arrowToTop: SieIcon.ArrowToTop
    }; }
}

/** @ignore */
let nextId = 0;
class UiCarouselSlideDirective {
    constructor(templateRef) {
        this.templateRef = templateRef;
        /**
         * Defines the id of the carousel item (slide).
         * @default auto incremented index
         */
        this.id = `carousel-slide-${nextId++}`;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCarouselSlideDirective, deps: [{ token: i0.TemplateRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: UiCarouselSlideDirective, selector: "[sieUiCarouselSlide]", inputs: { id: "id" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCarouselSlideDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[sieUiCarouselSlide]'
                }]
        }], ctorParameters: function () { return [{ type: i0.TemplateRef }]; }, propDecorators: { id: [{
                type: Input
            }] } });

/**
 * Enumeration to define indexes of position of the slides in the carousel (previous slide, current slide and next slide).
 */
var SlideGroup;
(function (SlideGroup) {
    /**
     * Index of the previous slide.
     */
    SlideGroup[SlideGroup["DuplicatesBefore"] = 0] = "DuplicatesBefore";
    /**
     * Index of the current slide.
     */
    SlideGroup[SlideGroup["RealSlides"] = 1] = "RealSlides";
    /**
     * Index of the next slide.
     */
    SlideGroup[SlideGroup["DuplicatesAfter"] = 2] = "DuplicatesAfter";
})(SlideGroup || (SlideGroup = {}));

const UI_CAROUSEL_WEB_COMPONENT_SERVICE = 'UI_CAROUSEL_WEB_COMPONENT_SERVICE';

class RunInZoneService {
    constructor(_zone) {
        this._zone = _zone;
    }
    runInTheZone(func) {
        this._zone.run(func);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: RunInZoneService, deps: [{ token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: RunInZoneService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: RunInZoneService, decorators: [{
            type: Injectable,
            args: [{ providedIn: 'root' }]
        }], ctorParameters: function () { return [{ type: i0.NgZone }]; } });

class RunInZoneModule {
    constructor(injector) {
        RunInZoneModule.injector = injector;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: RunInZoneModule, deps: [{ token: i0.Injector }], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: RunInZoneModule }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: RunInZoneModule, providers: [RunInZoneService] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: RunInZoneModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [],
                    imports: [],
                    providers: [RunInZoneService]
                }]
        }], ctorParameters: function () { return [{ type: i0.Injector }]; } });

const RunInZone = function (_target, _functionName, descriptor) {
    const originalMethod = descriptor.value;
    descriptor.value = function (...args) {
        const service = RunInZoneModule.injector.get(RunInZoneService);
        service.runInTheZone(() => {
            originalMethod.apply(this, args);
        });
    };
    return descriptor;
};

let idCounter = 0;
class UiCarouselElementsService {
    static convertDomItem(element) {
        const idAttribute = element.dataset['id'];
        const id = idAttribute ? idAttribute : `slide_${idCounter++}`;
        return { id };
    }
    constructor(domManipulationService) {
        this.domManipulationService = domManipulationService;
    }
    init(component) {
        component.slides = this.domManipulationService.getDomItemsAndCleanupDom(component, '.item', UiCarouselElementsService.convertDomItem);
    }
    getSlideIds(component) {
        if (component.slides instanceof Array) {
            return component.slides.map(slide => slide.id);
        }
        return [];
    }
    getSlidesForGroup(component, groupIndex) {
        if (component.slides instanceof Array) {
            switch (groupIndex) {
                case SlideGroup.DuplicatesBefore:
                    return component.slides.slice(component.duplicateSlidesCount * -1);
                case SlideGroup.RealSlides:
                    return component.slides;
                case SlideGroup.DuplicatesAfter:
                    return component.slides.slice(0, component.duplicateSlidesCount);
                default:
                // No action taken as all necessary actions are handled
            }
        }
    }
    renderChild(viewContainer, item, duplicate) {
        if (item?.element) {
            let elementToBeAppended = item.element;
            if (duplicate) {
                elementToBeAppended = item.element.cloneNode(true);
            }
            viewContainer.element.nativeElement.after(elementToBeAppended);
        }
    }
}

/**
 * Service reponsible of selection of carousel gutter depending on the viewport.
 */
class UiCarouselService {
    constructor(layoutService) {
        this.layoutService = layoutService;
    }
    getCarouselGutter() {
        const gutter = this.layoutService.isViewport('S', 'M') ? ComponentCarouselGutterS : ComponentCarouselGutterL;
        return parseInt(gutter, 10);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCarouselService, deps: [{ token: i1$1.LayoutService }], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCarouselService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCarouselService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: i1$1.LayoutService }]; } });

class BasePaginationDirective {
    constructor() {
        /**
         * Defines a list of the ids of the dots that will be shown in the thermometer or dot-pagination.
         * @default empty array
         */
        this.ids = [];
        /**
         * {@link PaginationEventModel Event} triggered when the selection of the dot in the thermometer or pagination is changed.
         */
        this.idChanged = new EventEmitter();
    }
    /** @ignore */
    ngOnInit() {
        if (this.ids.length > 0 && !this.selectedIndex) {
            this.selectedIndex = 0;
        }
    }
    /** @ignore */
    onClick(newIndex) {
        this.selectedIndex = newIndex;
        this.idChanged.emit({ index: this.selectedIndex, manual: true });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: BasePaginationDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: BasePaginationDirective, inputs: { ids: "ids", selectedIndex: "selectedIndex", theme: "theme" }, outputs: { idChanged: "idChanged" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: BasePaginationDirective, decorators: [{
            type: Directive
        }], propDecorators: { ids: [{
                type: Input
            }], selectedIndex: [{
                type: Input
            }], theme: [{
                type: Input
            }], idChanged: [{
                type: Output
            }] } });

const DEFAULT_MAX_ITEMS_FOR_SMALL_DOTS = 20;
/**
 * # Dot Pagination Component
 *
 * Dot Pagination is used on the carousel component when the auto play option is turned off,
 * in order to browse manually through the slides or to use it to navigate to the specific slides we want.
 *
 * ## Component variations
 *
 * There are no variations.
 *
 * ## Content
 *
 * The dot pagination component does not accept any content.
 *
 * ## Code example
 * @example
 * ```html
 * <sie-ui-dot-pagination
 *   [ids]="['1', '2', '3']"
 *   [selectedIndex]="1"
 *   [theme]="'light'"
 * ></sie-ui-dot-pagination>
 * ```
 */
class UiDotPaginationComponent extends BasePaginationDirective {
    constructor() {
        super(...arguments);
        /** @ignore */
        this.smallViewport = false;
        /** @ignore */
        this.maxItemsForSmallDots = DEFAULT_MAX_ITEMS_FOR_SMALL_DOTS;
    }
    /** @ignore */
    ngOnInit() {
        super.ngOnInit();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDotPaginationComponent, deps: null, target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiDotPaginationComponent, selector: "sie-ui-dot-pagination", inputs: { smallViewport: "smallViewport" }, usesInheritance: true, ngImport: i0, template: "<div *ngIf=\"ids && ids.length > 1\" class=\"pagination\">\n  <ng-container *ngFor=\"let id of ids; let index = index\">\n    <button\n      (click)=\"onClick(index)\"\n      [ngClass]=\"[\n        index === selectedIndex ? 'active' : '',\n        ids.length > maxItemsForSmallDots && smallViewport ? 'small' : '',\n        theme\n      ]\"\n      class=\"pagination__dot\"\n      type=\"button\"\n      [attr.aria-controls]=\"id\"\n    >\n      <span class=\"visually-hidden\">Show slide {{ index + 1 }} of {{ ids.length }}</span>\n    </button>\n  </ng-container>\n</div>\n", styles: [".pagination__dot{outline:none;outline-offset:0}@media (pointer: fine){.pagination__dot{position:relative}.pagination__dot:focus{outline:1px solid #1491eb;outline-offset:2px}.pagination__dot:focus:not(:focus-visible){outline:0}.pagination__dot:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}.pagination{display:flex;align-items:center;justify-content:center;padding:2px}.pagination__dot{position:relative;flex-shrink:0;width:10px;height:10px;padding:0;margin:0 5px;border:none;background:rgba(0,0,40,.35);border-radius:50%;cursor:pointer}.pagination__dot.active{background:#000028}.pagination__dot:hover{background:#00646e}.pagination__dot.small{margin:0 2.5px}.pagination__dot.dark{background:rgba(255,255,255,.35)}.pagination__dot.dark.active{background:#fff}.pagination__dot.dark:hover{background:#00ffb9}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDotPaginationComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-dot-pagination', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div *ngIf=\"ids && ids.length > 1\" class=\"pagination\">\n  <ng-container *ngFor=\"let id of ids; let index = index\">\n    <button\n      (click)=\"onClick(index)\"\n      [ngClass]=\"[\n        index === selectedIndex ? 'active' : '',\n        ids.length > maxItemsForSmallDots && smallViewport ? 'small' : '',\n        theme\n      ]\"\n      class=\"pagination__dot\"\n      type=\"button\"\n      [attr.aria-controls]=\"id\"\n    >\n      <span class=\"visually-hidden\">Show slide {{ index + 1 }} of {{ ids.length }}</span>\n    </button>\n  </ng-container>\n</div>\n", styles: [".pagination__dot{outline:none;outline-offset:0}@media (pointer: fine){.pagination__dot{position:relative}.pagination__dot:focus{outline:1px solid #1491eb;outline-offset:2px}.pagination__dot:focus:not(:focus-visible){outline:0}.pagination__dot:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}.pagination{display:flex;align-items:center;justify-content:center;padding:2px}.pagination__dot{position:relative;flex-shrink:0;width:10px;height:10px;padding:0;margin:0 5px;border:none;background:rgba(0,0,40,.35);border-radius:50%;cursor:pointer}.pagination__dot.active{background:#000028}.pagination__dot:hover{background:#00646e}.pagination__dot.small{margin:0 2.5px}.pagination__dot.dark{background:rgba(255,255,255,.35)}.pagination__dot.dark.active{background:#fff}.pagination__dot.dark:hover{background:#00ffb9}\n"] }]
        }], propDecorators: { smallViewport: [{
                type: Input
            }] } });

/**
 * # Thermometer Component
 *
 * Thermometer is used on the carousel component when the auto play option is turned on,
 * in order to browse through the slides or to use it to navigate to the specific slides we want.
 *
 * ## Component variations
 *
 * There are no variations.
 *
 * ## Content
 *
 * The thermometer component does not accept any content.
 *
 * ## Code example
 * @example
 * ```html
 * <sie-ui-thermometer
 *   [ids]="['1', '2', '3']"
 *   [selectedIndex]="1"
 *   [pauseAnimation]="false"
 * ></sie-ui-thermometer>
 * ```
 */
class UiThermometerComponent extends BasePaginationDirective {
    constructor() {
        super();
        /**
         * Defines in which direction slides will be changed in the carousel.
         * @default 'ltr'
         */
        this.direction = Direction.Ltr;
        /**
         * Duration of the animation.
         * @default 10000
         */
        this.duration = 10000;
        /**
         * Defines if the animation should be paused.
         * @default false
         */
        this.pauseAnimation = false;
    }
    /** @ignore */
    ngOnInit() {
        if (this.ids.length > 0 && !this.selectedIndex) {
            this.selectedIndex = 0;
        }
    }
    /** @ignore */
    animationDone() {
        this.setNextElement();
    }
    /** @ignore */
    onClick(newIndex) {
        this.selectedIndex = newIndex;
        this.idChanged.emit({ index: this.selectedIndex, manual: true });
    }
    setNextElement() {
        if (this.selectedIndex === this.ids.length - 1) {
            this.selectedIndex = 0;
        }
        else {
            this.selectedIndex++;
        }
        this.idChanged.emit({ index: this.selectedIndex, manual: false });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiThermometerComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiThermometerComponent, selector: "sie-ui-thermometer", inputs: { direction: "direction", duration: "duration", pauseAnimation: "pauseAnimation" }, usesInheritance: true, ngImport: i0, template: "<div *ngIf=\"ids && ids.length > 1\" class=\"thermometer\" [dir]=\"direction\">\n  <ng-container *ngFor=\"let id of ids; let index = index\">\n    <button\n      (click)=\"onClick(index)\"\n      [ngClass]=\"[\n        index === selectedIndex ? 'active' : '',\n        index === selectedIndex ? 'animate' : '',\n        ids.length - 2 === index && ids.length - 1 === selectedIndex ? 'animate--last' : '',\n        theme\n      ]\"\n      class=\"thermometer__dot\"\n      type=\"button\"\n      [attr.aria-controls]=\"id\"\n    >\n      <span class=\"visually-hidden\">Show slide {{ index + 1 }} of {{ ids.length }}</span>\n    </button>\n    <span\n      *ngIf=\"index !== ids.length - 1\"\n      [ngClass]=\"[pauseAnimation ? 'paused' : '', theme]\"\n      [ngStyle]=\"{ 'animation-duration': duration + 'ms' }\"\n      class=\"timeline\"\n      (animationend)=\"animationDone()\"\n    ></span>\n  </ng-container>\n</div>\n", styles: [".thermometer__dot{outline:none;outline-offset:0}@media (pointer: fine){.thermometer__dot{position:relative}.thermometer__dot:focus{outline:1px solid #1491eb;outline-offset:2px}.thermometer__dot:focus:not(:focus-visible){outline:0}.thermometer__dot:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}.thermometer{display:flex;align-items:center;justify-content:center;margin:0 auto}.thermometer__dot{position:relative;min-width:10px;max-width:10px;flex-shrink:0;width:10px;height:10px;padding:0;border:2px solid rgba(0,0,40,.25);background:0;border-radius:50%;cursor:pointer}.thermometer__dot:before,.thermometer__dot:after{content:\"\";position:absolute;left:3px;transform-origin:0 0;transform:translate3d(-50%,-50%,0);border:1px solid transparent;border-radius:50%}.thermometer__dot:before{width:24px;height:24px}.thermometer__dot:after{width:34px;height:34px}.thermometer__dot:hover:before,.thermometer__dot:focus:before{animation:rotating 3s linear infinite}.thermometer__dot:hover:after,.thermometer__dot:focus:after{animation:rotating 3s linear reverse infinite}.thermometer__dot.dark{border:2px solid rgba(255,255,255,.25)}.thermometer__dot.dark:hover:before,.thermometer__dot.dark:focus:before{border-color:#ffffff4d;border-top-color:transparent}.thermometer__dot.dark:hover:after,.thermometer__dot.dark:focus:after{border-color:#ffffff4d;border-top-color:transparent;border-bottom-color:transparent}.thermometer__dot.dark.active{border:2px solid white}.thermometer__dot.dark.active:before{background:rgba(255,255,255,.15);border:1px solid rgba(255,255,255,.25)}.thermometer__dot.light{border:2px solid rgba(0,0,40,.25)}.thermometer__dot.light:hover:before,.thermometer__dot.light:focus:before{border-color:#0000284d;border-top-color:transparent}.thermometer__dot.light:hover:after,.thermometer__dot.light:focus:after{border-color:#0000284d;border-top-color:transparent;border-bottom-color:transparent}.thermometer__dot.light.active{border:2px solid #000028}.thermometer__dot.light.active:before{background:rgba(0,0,40,.15);border:1px solid rgba(0,0,40,.25)}.thermometer .timeline{position:relative;width:97px;max-width:97px;flex-grow:1;height:1px;background:rgba(0,0,40,.35);animation-duration:10s}.thermometer .timeline.dark{background:rgba(255,255,255,.35)}.thermometer .timeline.dark:after{background:#fff}.thermometer .timeline:after{content:\"\";position:absolute;left:0;width:0;height:1px;background:#000028}.thermometer__dot.animate+.timeline:after{animation:fill-width linear forwards;animation-duration:inherit}.thermometer__dot.animate--last+.timeline:after{animation:unfill-width linear both;animation-duration:inherit}.thermometer .timeline.paused:after{animation-play-state:paused}[dir=rtl] .timeline{transform:scale(-1)}@keyframes rotating{0%{transform:rotate(0) translate3d(-50%,-50%,0)}to{transform:rotate(360deg) translate3d(-50%,-50%,0)}}@keyframes fill-width{0%{width:0}to{width:100%}}@keyframes unfill-width{0%{left:0;width:100%}to{left:100%;width:0}}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiThermometerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-thermometer', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div *ngIf=\"ids && ids.length > 1\" class=\"thermometer\" [dir]=\"direction\">\n  <ng-container *ngFor=\"let id of ids; let index = index\">\n    <button\n      (click)=\"onClick(index)\"\n      [ngClass]=\"[\n        index === selectedIndex ? 'active' : '',\n        index === selectedIndex ? 'animate' : '',\n        ids.length - 2 === index && ids.length - 1 === selectedIndex ? 'animate--last' : '',\n        theme\n      ]\"\n      class=\"thermometer__dot\"\n      type=\"button\"\n      [attr.aria-controls]=\"id\"\n    >\n      <span class=\"visually-hidden\">Show slide {{ index + 1 }} of {{ ids.length }}</span>\n    </button>\n    <span\n      *ngIf=\"index !== ids.length - 1\"\n      [ngClass]=\"[pauseAnimation ? 'paused' : '', theme]\"\n      [ngStyle]=\"{ 'animation-duration': duration + 'ms' }\"\n      class=\"timeline\"\n      (animationend)=\"animationDone()\"\n    ></span>\n  </ng-container>\n</div>\n", styles: [".thermometer__dot{outline:none;outline-offset:0}@media (pointer: fine){.thermometer__dot{position:relative}.thermometer__dot:focus{outline:1px solid #1491eb;outline-offset:2px}.thermometer__dot:focus:not(:focus-visible){outline:0}.thermometer__dot:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}.thermometer{display:flex;align-items:center;justify-content:center;margin:0 auto}.thermometer__dot{position:relative;min-width:10px;max-width:10px;flex-shrink:0;width:10px;height:10px;padding:0;border:2px solid rgba(0,0,40,.25);background:0;border-radius:50%;cursor:pointer}.thermometer__dot:before,.thermometer__dot:after{content:\"\";position:absolute;left:3px;transform-origin:0 0;transform:translate3d(-50%,-50%,0);border:1px solid transparent;border-radius:50%}.thermometer__dot:before{width:24px;height:24px}.thermometer__dot:after{width:34px;height:34px}.thermometer__dot:hover:before,.thermometer__dot:focus:before{animation:rotating 3s linear infinite}.thermometer__dot:hover:after,.thermometer__dot:focus:after{animation:rotating 3s linear reverse infinite}.thermometer__dot.dark{border:2px solid rgba(255,255,255,.25)}.thermometer__dot.dark:hover:before,.thermometer__dot.dark:focus:before{border-color:#ffffff4d;border-top-color:transparent}.thermometer__dot.dark:hover:after,.thermometer__dot.dark:focus:after{border-color:#ffffff4d;border-top-color:transparent;border-bottom-color:transparent}.thermometer__dot.dark.active{border:2px solid white}.thermometer__dot.dark.active:before{background:rgba(255,255,255,.15);border:1px solid rgba(255,255,255,.25)}.thermometer__dot.light{border:2px solid rgba(0,0,40,.25)}.thermometer__dot.light:hover:before,.thermometer__dot.light:focus:before{border-color:#0000284d;border-top-color:transparent}.thermometer__dot.light:hover:after,.thermometer__dot.light:focus:after{border-color:#0000284d;border-top-color:transparent;border-bottom-color:transparent}.thermometer__dot.light.active{border:2px solid #000028}.thermometer__dot.light.active:before{background:rgba(0,0,40,.15);border:1px solid rgba(0,0,40,.25)}.thermometer .timeline{position:relative;width:97px;max-width:97px;flex-grow:1;height:1px;background:rgba(0,0,40,.35);animation-duration:10s}.thermometer .timeline.dark{background:rgba(255,255,255,.35)}.thermometer .timeline.dark:after{background:#fff}.thermometer .timeline:after{content:\"\";position:absolute;left:0;width:0;height:1px;background:#000028}.thermometer__dot.animate+.timeline:after{animation:fill-width linear forwards;animation-duration:inherit}.thermometer__dot.animate--last+.timeline:after{animation:unfill-width linear both;animation-duration:inherit}.thermometer .timeline.paused:after{animation-play-state:paused}[dir=rtl] .timeline{transform:scale(-1)}@keyframes rotating{0%{transform:rotate(0) translate3d(-50%,-50%,0)}to{transform:rotate(360deg) translate3d(-50%,-50%,0)}}@keyframes fill-width{0%{width:0}to{width:100%}}@keyframes unfill-width{0%{left:0;width:100%}to{left:100%;width:0}}\n"] }]
        }], ctorParameters: function () { return []; }, propDecorators: { direction: [{
                type: Input
            }], duration: [{
                type: Input
            }], pauseAnimation: [{
                type: Input
            }] } });

class UiCarouselItemRenderDirective {
    set itemToRender(data) {
        this.uiCarouselComponentService.renderChild(this.viewContainer, data.item, data.duplicate);
    }
    constructor(viewContainer, uiCarouselComponentService) {
        this.viewContainer = viewContainer;
        this.uiCarouselComponentService = uiCarouselComponentService;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCarouselItemRenderDirective, deps: [{ token: i0.ViewContainerRef }, { token: UI_CAROUSEL_WEB_COMPONENT_SERVICE }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: UiCarouselItemRenderDirective, selector: "[sieUiCarouselRender]", inputs: { itemToRender: "itemToRender" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCarouselItemRenderDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[sieUiCarouselRender]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ViewContainerRef }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [UI_CAROUSEL_WEB_COMPONENT_SERVICE]
                }] }]; }, propDecorators: { itemToRender: [{
                type: Input
            }] } });

/**
 * # Carousel component
 *
 * Provide access to an overflowing number of items of a kind in a paginated area.
 *
 * ## Component variations
 *
 * - Regular carousel
 * - Cut off version
 *
 * ## Content
 *
 * Next to the parameters, the content can be passed as child elements with using `UiCarouselSlideDirective`.
 * See the example below.
 *
 * ## Code example
 * @example
 * Template:
 * ```html
 *  <sie-ui-carousel [type]="'thermometer'" [theme]="'dark'" [cutOff]="false">
 *    <ng-container *ngFor="let slide of carouselSlides">
 *       <ng-template sieUiCarouselSlide>
 *         <sie-ui-teaser [teaserData]="slide"></sie-ui-teaser>
 *       </ng-template>
 *     </ng-container>
 *  </sie-ui-carousel>
 * ```
 *
 * Carousel items data example:
 * ```js
 * carouselSlides = [
 *  {
 *   id: 1,
 *   visualizationType: 'stage-full-width-teaser',
 *   title: '1111Headline Lorem ipsum Headline Lorem ipsum 12345678',
 *   subTitle: 'Subheadline consetetur sadipscing elitr, sed diam nonumy eirmod tempor aliquayam',
 *   buttons: [
 *    {
 *      id: 'cta1',
 *      label: 'Details',
 *      link: 'https://www.siemens.com',
 *      buttonType: 'link',
 *      variant: 'primary',
 *      background: 'dark'
 *    }
 *  ],
 *   picture: {
 *    urlSmall: 'https://picsum.photos/id/33/500/500',
 *    urlMedium: 'https://picsum.photos/id/33/1000/500',
 *    urlLarge: 'https://picsum.photos/id/33/2000/500'
 *    }
 *  }
 * ];
 * ```
 */
class UiCarouselComponent {
    /**
     * @param value Set the number of the current displayed slide in component.
     * @default 0
     */
    set currentSlide(value) {
        const valueShiftForEvenGroups = value + this.slides.length - this._duplicateSlidesCount;
        this.destroyPlayer();
        this._currentSlide = value;
        this.currentGroup = this.getGroupForSlide(value);
        this.currentRealSlideIndex = valueShiftForEvenGroups % this.slides.length;
    }
    get currentSlide() {
        return this._currentSlide;
    }
    /** @ignore */
    get duplicateSlidesCount() {
        return this._duplicateSlidesCount;
    }
    constructor(layoutService, carouselService, iconReg, animationBuilder, elementRef, cd, resizeDirective, uiCarouselComponentService) {
        this.layoutService = layoutService;
        this.carouselService = carouselService;
        this.iconReg = iconReg;
        this.animationBuilder = animationBuilder;
        this.elementRef = elementRef;
        this.cd = cd;
        this.resizeDirective = resizeDirective;
        this.uiCarouselComponentService = uiCarouselComponentService;
        /**
         * The {@link Direction direction} of the carousel (only available in combination with autoplay feature).
         * @default 'ltr'
         */
        this.dir = Direction.Ltr;
        /**
         * The {@link ThemeVariant theme} that is used for the component.
         * @default 'light'
         */
        this.theme = 'light';
        /**
         * The {@link UiCarouselType Type of carousel} that is used to determine pagination.
         * @default 'dots'
         */
        this.type = 'dots';
        /**
         * Defines if container-queries or media-queries are used for the carousel styling
         * @default false
         */
        this.containerStyled = false;
        /**
         * Defines whether this carousel will be rendered in the cut-off version.
         * NOTE: if cutOff is enabled containerStyled doesn't work
         * @default false
         */
        this.cutOff = false;
        /**
         * Defines whether this carousel will pause autoplay feature.
         * @default false
         */
        this.pauseAutoplay = false;
        this._duplicateSlidesCount = 1;
        this.slideCount = 0;
        this._currentSlide = 0;
        this.subscriptions = new Subscription();
        /** @ignore */
        this.autoPlay = true;
        /** @ignore */
        this.SlideGroup = SlideGroup;
        /** @ignore */
        this.slideIds = [];
        /** @ignore */
        this.currentGroup = 0;
        /** @ignore */
        this.currentRealSlideIndex = 0;
        /** @ignore */
        this.inlineTranslate = 'translateX(0)';
        /** @ignore */
        this.isSliding = false;
        /** @ignore */
        this.invalidPanStartEventTriggered = false;
        /** @ignore */
        this.isPanning = false;
        /** @ignore */
        this.cutOffHovered = null;
        /** @ignore */
        this.realCutOff = this.cutOff;
        iconReg.register(SieIcon.ArrowLeft);
        iconReg.register(SieIcon.ArrowRight);
        iconReg.register(SieIcon.Pause);
        iconReg.register(SieIcon.Play);
    }
    /** @ignore */
    ngAfterViewInit() {
        if (this.slides instanceof QueryList) {
            this.subscriptions.add(this.slides.changes.subscribe(() => {
                this.resetCarousel();
            }));
        }
        this.listenToSizeChange();
        if (this.pauseAutoplay) {
            this.autoPlay = false;
        }
        this.uiCarouselComponentService.init(this);
        this.resetCarousel();
    }
    /** @ignore */
    ngOnDestroy() {
        this.subscriptions.unsubscribe();
    }
    /** @ignore */
    getSlidesForGroup(groupIndex) {
        return this.uiCarouselComponentService.getSlidesForGroup(this, groupIndex);
    }
    /** @ignore */
    goToSlide(event) {
        if (this.isSliding || event.index === this.currentRealSlideIndex) {
            return;
        }
        if (event.manual) {
            this.currentSlide = event.index + this._duplicateSlidesCount;
            this.playAnimation();
        }
        else {
            this.goToNext();
        }
    }
    /**
     * This method is exposed to web components and not suggested to be used inside of the SiePortal
     * @param index Navigates to slide at index.
     */
    goToSlideAt(index) {
        if (index < 0 || index >= this.slides.length) {
            return;
        }
        this.goToSlide({ index: index, manual: true });
    }
    /**
     * Navigates to previous slide.
     */
    goToPrevious() {
        if (!this.isSliding) {
            this.currentSlide = this.getPreviousIndex(this.currentSlide);
            this.playAnimation();
        }
    }
    /**
     * Navigates to next slide.
     */
    goToNext() {
        if (!this.isSliding) {
            this.currentSlide = this.getNextIndex(this.currentSlide);
            this.playAnimation();
        }
    }
    /** @ignore */
    updateSlidingState(isSliding) {
        this.setPauseAutoplay(isSliding);
        this.isSliding = isSliding;
    }
    // when scrolling starts, the panStart will be triggered witch x = 0, but no panEnd ->
    // if you start then a new pan no panStart will be triggered, so we check onPan if a invalidPanStartEventTriggered
    /** @ignore */
    onPanStart(event) {
        if (this.slides.length > 1) {
            if (event.center.x > 0) {
                this.panStartCurrentSlide = this.currentSlide;
                this.panStartPosition = event.center.x;
                this.isPanning = true;
            }
            else {
                this.invalidPanStartEventTriggered = true;
            }
        }
    }
    /** @ignore */
    onPan(event) {
        if (event.center.x === 0 && event.center.y === 0) {
            this.forcePanEnd();
        }
        else if (this.slides.length > 1) {
            if (this.invalidPanStartEventTriggered) {
                this.panStartCurrentSlide = this.currentSlide;
                this.panStartPosition = event.center.x;
                this.invalidPanStartEventTriggered = false;
            }
            if (this.panStartPosition && event.center.x > 0 && this.panStartPosition !== event.center.x) {
                this.updateSlidingState(true);
                this.inlineTranslate = `translateX(${this.calculateTranslate()}) translateX(${(this.panStartPosition - event.center.x) * -1}px)`;
            }
        }
    }
    /** @ignore */
    onPanEnd(event) {
        if (this.slides.length > 1) {
            const panDifference = this.panStartPosition - event.center.x;
            this.updateSlidingState(false);
            const panningOffset = 0.25; // 25 Panning Offset %
            const minOffset = this.elementRef.nativeElement.firstChild.offsetWidth * panningOffset;
            if (panDifference < 0 && panDifference < minOffset * -1) {
                this.goToPrevious();
            }
            else if (panDifference > 0 && panDifference > minOffset) {
                this.goToNext();
            }
            else {
                this.playAnimation();
            }
            if (!this.autoPlay) {
                this.setPauseAutoplay(true);
            }
            this.panStartPosition = null;
            this.panStartCurrentSlide = null;
            this.isPanning = false;
        }
    }
    forcePanEnd() {
        this.playAnimation();
        this.panStartPosition = null;
        this.panStartCurrentSlide = null;
        this.isPanning = false;
    }
    /** @ignore */
    slideVisibility(group, index) {
        // if it's active slide
        let shouldBeVisible = this.isSliding || (group === SlideGroup.RealSlides && index === this.currentRealSlideIndex);
        if (this.realCutOff) {
            shouldBeVisible = shouldBeVisible || this.isPreviousSlide(group, index) || this.isNextSlide(group, index);
        }
        return shouldBeVisible ? 'visible' : 'hidden';
    }
    /** @ignore */
    isPreviousSlide(group, index) {
        return ((group === SlideGroup.DuplicatesBefore && index === this.currentRealSlideIndex) ||
            (group === SlideGroup.RealSlides && index === this.currentRealSlideIndex - 1));
    }
    /** @ignore */
    isNextSlide(group, index) {
        return ((group === SlideGroup.DuplicatesAfter && this.currentRealSlideIndex === this.slideCount - 3) ||
            (group === SlideGroup.RealSlides && index === this.currentRealSlideIndex + 1));
    }
    /** @ignore */
    toggleCutOffSlideStyle(direction) {
        if (this.realCutOff) {
            this.cutOffHovered = this.cutOffHovered === direction ? null : direction;
        }
    }
    /** @ignore */
    checkIfRealCutOff() {
        // should not behave like cutoff in case of 1 slide or XXL breakpoint
        this.realCutOff = this.cutOff && this.slides.length > 1 && !this.layoutService.isViewport('XXL');
        this.cd.detectChanges();
    }
    /**
     * Toggles the carousel autoplay pause.
     */
    toggleCarouselPause() {
        this.autoPlay = !this.autoPlay;
        this.setPauseAutoplay(!this.autoPlay);
    }
    getScreenReaderText(index, count) {
        if (this.screenReader?.slideNumberText) {
            return populateTemplate(this.screenReader.slideNumberText, { SLIDE_NUMBER: (index + 1).toString(), NUMBER_OF_SLIDES: count.toString() }, TemplatingStrategy.AngleBrackets);
        }
        return '';
    }
    destroyPlayer() {
        if (this.player) {
            this.player.destroy();
            this.player = null;
        }
    }
    playAnimation() {
        this.destroyPlayer();
        if (this.autoPlay) {
            const animation = this.animationBuilder.build([
                style({
                    transform: '*'
                }),
                animate(`.8s ${EasingStandardExpressive}`, style({
                    transform: `translateX(${this.calculateTranslate()})`
                }))
            ]);
            this.player = animation.create(this.carouselUl.nativeElement);
            this.updateSlidingState(true);
            this.player.play();
            this.player.onDone(() => {
                if (this.player) {
                    this.player.destroy();
                    this.player = null;
                }
                this.updateSlidingState(false);
                this.jumpToInnerSlide();
                // if it changes while slide animation (by clicking on pause button)
                if (!this.autoPlay) {
                    this.setPauseAutoplay(true);
                }
            });
        }
        else {
            this.jumpToInnerSlide();
        }
    }
    /** @ignore */
    resetCarousel() {
        this.slideCount = this.slides.length + this._duplicateSlidesCount * 2;
        this.currentSlide = this._duplicateSlidesCount;
        if (this.cutOff) {
            this.cd.detectChanges();
            this.updateSlideForCutoffVersion();
        }
        this.slideIds = this.uiCarouselComponentService.getSlideIds(this);
        this.jumpToInnerSlide();
        this.cd.detectChanges();
    }
    jumpToInnerSlide() {
        if (this.currentGroup !== SlideGroup.RealSlides) {
            this.currentSlide = this.getInnerSlideIndex();
        }
        this.inlineTranslate = `translateX(${this.calculateTranslate()})`;
        this.handleSlideFocus();
    }
    updateSlideForCutoffVersion() {
        this.checkIfRealCutOff();
        this.calculateSlideWidth();
        this.resizeControlsForCutoffVersion();
    }
    calculateSlideWidth() {
        const slide = this.carouselUl?.nativeElement.querySelector(`.carousel__slide`);
        const slideStyle = window.getComputedStyle(slide);
        this.slideWidth = parseFloat(slideStyle.getPropertyValue('width'));
        this.cutOffSpacing = this.calculateCutOffSpacing();
    }
    resizeControlsForCutoffVersion() {
        this.carouselButtons.forEach(item => {
            item.nativeElement.style.width = `${this.cutOffSpacing - this.carouselService.getCarouselGutter()}px`;
        });
    }
    calculateCutOffSpacing() {
        // calculate the offset based on slide width
        let offset = (this.elementRef.nativeElement.offsetWidth - this.slideWidth + this.carouselService.getCarouselGutter()) / 2;
        // offset should not be less than the grid margin
        if (offset < this.layoutService.getGridMargin()) {
            offset = this.layoutService.getGridMargin();
        }
        return offset;
    }
    getInnerSlideIndex() {
        return this.currentRealSlideIndex + this._duplicateSlidesCount;
    }
    getGroupForSlide(index) {
        return index < this._duplicateSlidesCount
            ? SlideGroup.DuplicatesBefore
            : index >= this.slides.length + this._duplicateSlidesCount
                ? SlideGroup.DuplicatesAfter
                : SlideGroup.RealSlides;
    }
    getPreviousIndex(index) {
        return index > 0 ? index - 1 : this.slideCount - 1;
    }
    getNextIndex(index) {
        return index < this.slideCount - 1 ? index + 1 : 0;
    }
    setPauseAutoplay(pause) {
        if (this.pauseAutoplay !== pause) {
            this.pauseAutoplay = pause;
            this.cd.markForCheck();
        }
    }
    calculateTranslate() {
        if (this.cutOff) {
            this.calculateSlideWidth();
            return `${this.currentSlide * -this.slideWidth + this.cutOffSpacing}px`;
        }
        return `${this.currentSlide * -100}%`;
    }
    handleSlideFocus() {
        // focus should be handled only in case of real cutoff. otherwise it's handled by visibility
        if (this.realCutOff) {
            // disable for all duplicates
            for (const group of [SlideGroup.DuplicatesBefore, SlideGroup.DuplicatesAfter]) {
                this.getSlidesForGroup(group).forEach((_slide, index) => {
                    DomUtil.disableFocusForChildren(this.elementRef.nativeElement.querySelector(`.slide-${index}-${group}`));
                });
            }
            // for real slides enable current, disable all others
            this.getSlidesForGroup(SlideGroup.RealSlides).forEach((slide, index) => {
                if (this.currentRealSlideIndex === index) {
                    DomUtil.enableFocusForChildren(this.elementRef.nativeElement.querySelector(`#${slide.id}`));
                }
                else {
                    DomUtil.disableFocusForChildren(this.elementRef.nativeElement.querySelector(`#${slide.id}`));
                }
            });
        }
    }
    listenToSizeChange() {
        if (this.containerStyled) {
            this.smallViewport$ = this.resizeDirective.breakpointKey.pipe(map(key => ['S', 'XS'].includes(key)));
            this.viewportContainer$ = this.resizeDirective.breakpointKey.pipe(map(key => key));
        }
        else {
            this.smallViewport$ = this.layoutService.currentViewPort$.pipe(map(key => ['S', 'XS'].includes(key)));
            this.viewportContainer$ = null;
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCarouselComponent, deps: [{ token: i1$1.LayoutService }, { token: UiCarouselService }, { token: i1.SieIconRegistryService }, { token: i4.AnimationBuilder }, { token: i0.ElementRef }, { token: i0.ChangeDetectorRef }, { token: i1$1.ElementResizeDirective }, { token: UI_CAROUSEL_WEB_COMPONENT_SERVICE }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiCarouselComponent, selector: "sie-ui-carousel", inputs: { dir: "dir", theme: "theme", type: "type", screenReader: "screenReader", containerStyled: ["containerStyled", "containerStyled", booleanAttribute], cutOff: ["cutOff", "cutOff", booleanAttribute], pauseAutoplay: ["pauseAutoplay", "pauseAutoplay", booleanAttribute] }, queries: [{ propertyName: "slides", predicate: UiCarouselSlideDirective }], viewQueries: [{ propertyName: "carouselUl", first: true, predicate: ["carouselUl"], descendants: true }, { propertyName: "elementsRef", first: true, predicate: ["elements"], descendants: true }, { propertyName: "carouselButtons", predicate: ["carouselButton"], descendants: true }], hostDirectives: [{ directive: i1$1.ElementResizeDirective }], ngImport: i0, template: "<div\n  class=\"carousel\"\n  [ngClass]=\"{\n    'carousel--cutoff': cutOff,\n    scrollable: slides.length > 1,\n    'carousel-container-style': containerStyled,\n    'container-layout': containerStyled\n  }\"\n  *ngIf=\"slides.length\"\n  (pan)=\"onPan($event)\"\n  (panend)=\"onPanEnd($event)\"\n  (panstart)=\"onPanStart($event)\"\n>\n  <fieldset class=\"carousel__controls\" *ngIf=\"slides.length > 1\">\n    <legend class=\"visually-hidden\">{{ screenReader?.controlsHeaderText }}</legend>\n    <div class=\"carousel__buttons\">\n      <div *ngIf=\"type === 'thermometer'\" class=\"carousel__autoplay-btn\">\n        <div class=\"autoplay-container\">\n          <div class=\"autoplay-container__button-wrapper\">\n            <button class=\"autoplay-container__button-wrapper__button\" (click)=\"toggleCarouselPause()\">\n              <ng-container *ngIf=\"autoPlay; else pause\">\n                <sie-icon [name]=\"iconReg.sieIcon.Pause\"></sie-icon>\n                <span class=\"visually-hidden\">{{ screenReader?.pauseButtonText }}</span>\n              </ng-container>\n\n              <ng-template #pause>\n                <sie-icon [name]=\"iconReg.sieIcon.Play\"></sie-icon>\n                <span class=\"visually-hidden\">{{ screenReader?.playButtonText }}</span>\n              </ng-template>\n            </button>\n          </div>\n\n          <sie-ui-thermometer\n            *ngIf=\"type === 'thermometer'\"\n            [ids]=\"slideIds\"\n            [selectedIndex]=\"currentRealSlideIndex\"\n            [pauseAnimation]=\"pauseAutoplay\"\n            [theme]=\"theme\"\n            [direction]=\"dir\"\n            (idChanged)=\"goToSlide($event)\"\n          >\n          </sie-ui-thermometer>\n        </div>\n      </div>\n\n      <button\n        *ngIf=\"!layoutService.isTouchDevice\"\n        type=\"button\"\n        [disabled]=\"isSliding\"\n        class=\"carousel__button carousel__prev\"\n        (mouseenter)=\"toggleCutOffSlideStyle('previous')\"\n        (mouseleave)=\"toggleCutOffSlideStyle()\"\n        (click)=\"goToPrevious()\"\n        #carouselButton\n      >\n        <span class=\"carousel__button__content\" [ngClass]=\"{ dark: theme === 'dark' }\">\n          <span class=\"carousel__icon-container carousel__icon-container-left\">\n            <sie-icon class=\"carousel__control-icon\" [name]=\"iconReg.sieIcon.ArrowLeft\"></sie-icon>\n          </span>\n          <span class=\"visually-hidden\">{{ screenReader?.previousButtonText }}</span>\n        </span>\n      </button>\n      <button\n        *ngIf=\"!layoutService.isTouchDevice\"\n        type=\"button\"\n        [disabled]=\"isSliding\"\n        class=\"carousel__button carousel__next\"\n        [ngClass]=\"{ dark: theme === 'dark' }\"\n        (mouseenter)=\"toggleCutOffSlideStyle('next')\"\n        (mouseleave)=\"toggleCutOffSlideStyle()\"\n        (click)=\"goToNext()\"\n        #carouselButton\n      >\n        <span class=\"carousel__button__content\" [ngClass]=\"{ dark: theme === 'dark' }\">\n          <span class=\"carousel__icon-container carousel__icon-container-right\">\n            <sie-icon class=\"carousel__control-icon\" [name]=\"iconReg.sieIcon.ArrowRight\"></sie-icon>\n          </span>\n          <span class=\"visually-hidden\">{{ screenReader?.nextButtonText }}</span>\n        </span>\n      </button>\n    </div>\n\n    <sie-ui-dot-pagination\n      *ngIf=\"type === 'dots'\"\n      [ids]=\"slideIds\"\n      [selectedIndex]=\"currentRealSlideIndex\"\n      [theme]=\"theme\"\n      [smallViewport]=\"smallViewport$ | async\"\n      (idChanged)=\"goToSlide($event)\"\n      class=\"carousel__pagination\"\n    >\n    </sie-ui-dot-pagination>\n  </fieldset>\n\n  <ul [ngStyle]=\"{ transform: inlineTranslate }\" class=\"carousel__stage\" role=\"tablist\" #carouselUl>\n    <ng-container *ngFor=\"let group of [0, 1, 2]\">\n      <li\n        *ngFor=\"let slide of getSlidesForGroup(group); index as i; count as c\"\n        [attr.aria-hidden]=\"group !== SlideGroup.RealSlides\"\n        [attr.id]=\"group === SlideGroup.RealSlides ? slide.id : null\"\n        [ngStyle]=\"{\n          visibility: slideVisibility(group, i)\n        }\"\n        [ngClass]=\"{\n          'carousel__slide--panning': isPanning,\n          previous: isPreviousSlide(group, i),\n          next: isNextSlide(group, i),\n          active: group === SlideGroup.RealSlides && i === currentRealSlideIndex,\n          hovered:\n            (cutOffHovered === 'previous' && isPreviousSlide(group, i)) ||\n            (cutOffHovered === 'next' && isNextSlide(group, i))\n        }\"\n        class=\"carousel__slide slide-{{ i }}-{{ group }}\"\n        role=\"tab\"\n      >\n        <span class=\"visually-hidden\">{{ getScreenReaderText(i, c) }}</span>\n        <div *ngIf=\"cutOff\" role=\"tabpanel\" class=\"carousel__slide__container\">\n          <ng-container [ngTemplateOutlet]=\"carouselSlideContent\"></ng-container>\n        </div>\n        <ng-container *ngIf=\"!cutOff\" [ngTemplateOutlet]=\"carouselSlideContent\"></ng-container>\n\n        <ng-template #carouselSlideContent>\n          <ng-container\n            sieUiCarouselRender\n            [itemToRender]=\"{ item: slide, duplicate: group !== SlideGroup.RealSlides }\"\n          >\n          </ng-container>\n        </ng-template>\n      </li>\n    </ng-container>\n  </ul>\n</div>\n\n<div #elements class=\"carousel-container\">\n  <ng-content select=\".item\"></ng-content>\n</div>\n", styles: [".carousel__button:focus{outline:0}.carousel .autoplay-container__button-wrapper__button{outline:none;outline-offset:0}@media (pointer: fine){.carousel .autoplay-container__button-wrapper__button{position:relative}.carousel .autoplay-container__button-wrapper__button:focus{outline:1px solid #1491eb;outline-offset:2px}.carousel .autoplay-container__button-wrapper__button:focus:not(:focus-visible){outline:0}.carousel .autoplay-container__button-wrapper__button:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}:host{display:block}.carousel-container-style{container:carousel-container/inline-size}.carousel__button{position:absolute;top:var(--arrowButtonsPositionTop, 50%);transform:translateY(-50%)}.carousel__button{width:48px;height:48px;z-index:1;display:none;border:0;color:#fff;justify-content:center;align-items:center}.carousel:hover .carousel__button{display:flex}.carousel-container{display:none}.carousel{display:flex;overflow:hidden;position:relative;flex-direction:column}.carousel__controls{border:0;padding:0}.carousel__stage{transition-timing-function:cubic-bezier(.4,0,.3,1);list-style:none;margin:0;padding:0;position:relative;display:flex;height:100%}.carousel__slide{display:flex;width:100%;flex-basis:100%;flex-shrink:0;flex-direction:column;align-items:center;justify-content:flex-start}.carousel__slide--panning{pointer-events:none}.carousel__slide>.container{height:100%}.carousel__button{padding:0;cursor:pointer;background-color:transparent}.carousel__button__content{display:flex;width:40px;height:40px;color:#fff;background-color:#007993;border-radius:50%;box-shadow:0 4px 6px #0000001a,0 2px 2px #00000014}.carousel__button__content.dark{color:#000028;background-color:#0cc}.carousel--cutoff .carousel__button{top:0;height:calc(100% - 38px);transform:none}.carousel__button:hover .carousel__button__content{background-color:#00646e}.carousel__button:hover .carousel__button__content.dark{background-color:#00ffb9}.carousel__button:disabled{pointer-events:none;cursor:none}.carousel__button:disabled .carousel__button__content{color:#ebebee;background-color:#b3b3be}.carousel__button:disabled .carousel__button__content.dark{color:#b3b3be;background-color:#737389}.carousel__button:focus .carousel__button__content{position:relative}.carousel__button:focus .carousel__button__content:before{content:\"\";position:absolute;inset:-4px;z-index:1;border:1px solid #1491eb;border-radius:50%}.carousel__button:focus-visible .carousel__button__content:before{content:\"\";position:absolute;inset:-4px;z-index:1;border:1px solid #1491eb;border-radius:50%}.carousel__button:focus:not(:focus-visible) .carousel__button__content:before{border:none}.carousel--cutoff .carousel__prev{left:0;padding-left:24px;min-width:68px;justify-content:flex-start}@media (min-width: 1024px){.carousel--cutoff .carousel__prev{padding-left:8px;min-width:52px}}@media (min-width: 1440px){.carousel--cutoff .carousel__prev{padding-left:16px;min-width:60px}}.carousel--cutoff .carousel__next{right:0;padding-right:24px;min-width:68px;justify-content:flex-end}@media (min-width: 1024px){.carousel--cutoff .carousel__next{padding-right:8px;min-width:52px}}@media (min-width: 1440px){.carousel--cutoff .carousel__next{padding-right:16px;min-width:60px}}.carousel__pause{position:absolute;left:8px;bottom:8px;z-index:2}.carousel__thermometer,.carousel__autoplay-btn,.carousel__pagination{position:absolute;right:0;bottom:20px;left:0;z-index:1}.carousel__thermometer{bottom:32px}.carousel__icon-container{display:flex;height:100%;width:100%;flex-direction:row;justify-content:center;align-items:center}.carousel__icon-container-left{padding-right:2px}.carousel__icon-container-right{padding-left:2px}.carousel__control-icon{width:32px;height:32px;display:flex;align-items:center;fill:currentColor}.carousel__control-icon svg{fill:currentColor;width:inherit;height:inherit}.carousel__control-icon svg g{fill:currentColor;width:inherit;height:inherit}.carousel__control-icon svg text{font-family:Siemens Sans,sans-serif}.carousel--cutoff.scrollable{padding-bottom:38px}.carousel--cutoff .previous,.carousel--cutoff .next{opacity:.6;transition:opacity .25s cubic-bezier(.4,0,.3,1)}.carousel--cutoff .previous.hovered,.carousel--cutoff .next.hovered{opacity:1}@media (min-width: 1920px){.carousel--cutoff .carousel__buttons{height:100%;position:absolute;left:0;right:0;margin:0 auto;max-width:1880px}.carousel--cutoff .carousel__button{width:auto!important}}.carousel--cutoff .carousel__slide{max-width:calc((100vw - 32px - var(--scrollbar-width)) + 8px);padding:0 4px;width:auto;flex-basis:auto}@media (min-width: 640px){.carousel--cutoff .carousel__slide{max-width:calc((100vw - 32px - var(--scrollbar-width)) + 8px)}}@media (min-width: 1024px){.carousel--cutoff .carousel__slide{max-width:calc((100vw - 112px - var(--scrollbar-width)) + 24px)}}@media (min-width: 1440px){.carousel--cutoff .carousel__slide{max-width:calc((100vw - 192px - var(--scrollbar-width)) + 24px)}}@media (min-width: 1024px){.carousel--cutoff .carousel__slide{padding:0 12px}}.carousel--cutoff .carousel__slide__container{width:100%;height:100%}.carousel--cutoff .carousel__stage{margin:0 -4px}@media (min-width: 1024px){.carousel--cutoff .carousel__stage{margin:0 -12px}}.carousel--cutoff .carousel__pagination{bottom:2px}.carousel--cutoff .carousel__thermometer{bottom:66px}.carousel .autoplay-container{display:flex;justify-content:center;align-items:center;flex-wrap:wrap;height:max-content;gap:16px}.carousel .autoplay-container__button-wrapper{display:flex;justify-content:center;align-items:center;height:28px;width:28px}.carousel .autoplay-container__button-wrapper__button{display:flex;justify-content:center;align-items:center;background-color:#ffffff40;border:1px solid rgba(255,255,255,.25);border-radius:50%;width:24px;height:24px;padding:0}.carousel .autoplay-container__button-wrapper__button:hover{width:28px;height:28px}.carousel .autoplay-container__button-wrapper__button sie-icon{color:#fff;fill:#fff;width:16px;height:16px;display:flex;align-items:center}.carousel .autoplay-container sie-ui-thermometer{max-width:100%}@media (min-width: 1024px){.carousel:not(.container-layout) .carousel__button{display:flex}}.carousel:not(.container-layout) .carousel__prev{left:20px}@media (min-width: 1024px){.carousel:not(.container-layout) .carousel__prev{left:4px}}@media (min-width: 1440px){.carousel:not(.container-layout) .carousel__prev{left:12px}}.carousel:not(.container-layout) .carousel__next{right:20px}@media (min-width: 1024px){.carousel:not(.container-layout) .carousel__next{right:4px}}@media (min-width: 1440px){.carousel:not(.container-layout) .carousel__next{right:12px}}@container carousel-container (min-width: 1024px){.carousel.container-layout .carousel__button{display:flex}}.carousel.container-layout .carousel__prev{left:20px}@container carousel-container (min-width: 1024px){.carousel.container-layout .carousel__prev{left:4px}}@container carousel-container (min-width: 1440px){.carousel.container-layout .carousel__prev{left:12px}}.carousel.container-layout .carousel__next{right:20px}@container carousel-container (min-width: 1024px){.carousel.container-layout .carousel__next{right:4px}}@container carousel-container (min-width: 1440px){.carousel.container-layout .carousel__next{right:12px}}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: i2.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "component", type: UiDotPaginationComponent, selector: "sie-ui-dot-pagination", inputs: ["smallViewport"] }, { kind: "component", type: UiThermometerComponent, selector: "sie-ui-thermometer", inputs: ["direction", "duration", "pauseAnimation"] }, { kind: "directive", type: UiCarouselItemRenderDirective, selector: "[sieUiCarouselRender]", inputs: ["itemToRender"] }, { kind: "pipe", type: i2.AsyncPipe, name: "async" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
__decorate([
    RunInZone
], UiCarouselComponent.prototype, "goToSlideAt", null);
__decorate([
    RunInZone
], UiCarouselComponent.prototype, "goToPrevious", null);
__decorate([
    RunInZone
], UiCarouselComponent.prototype, "goToNext", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCarouselComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-carousel', changeDetection: ChangeDetectionStrategy.OnPush, hostDirectives: [
                        {
                            directive: ElementResizeDirective
                        }
                    ], template: "<div\n  class=\"carousel\"\n  [ngClass]=\"{\n    'carousel--cutoff': cutOff,\n    scrollable: slides.length > 1,\n    'carousel-container-style': containerStyled,\n    'container-layout': containerStyled\n  }\"\n  *ngIf=\"slides.length\"\n  (pan)=\"onPan($event)\"\n  (panend)=\"onPanEnd($event)\"\n  (panstart)=\"onPanStart($event)\"\n>\n  <fieldset class=\"carousel__controls\" *ngIf=\"slides.length > 1\">\n    <legend class=\"visually-hidden\">{{ screenReader?.controlsHeaderText }}</legend>\n    <div class=\"carousel__buttons\">\n      <div *ngIf=\"type === 'thermometer'\" class=\"carousel__autoplay-btn\">\n        <div class=\"autoplay-container\">\n          <div class=\"autoplay-container__button-wrapper\">\n            <button class=\"autoplay-container__button-wrapper__button\" (click)=\"toggleCarouselPause()\">\n              <ng-container *ngIf=\"autoPlay; else pause\">\n                <sie-icon [name]=\"iconReg.sieIcon.Pause\"></sie-icon>\n                <span class=\"visually-hidden\">{{ screenReader?.pauseButtonText }}</span>\n              </ng-container>\n\n              <ng-template #pause>\n                <sie-icon [name]=\"iconReg.sieIcon.Play\"></sie-icon>\n                <span class=\"visually-hidden\">{{ screenReader?.playButtonText }}</span>\n              </ng-template>\n            </button>\n          </div>\n\n          <sie-ui-thermometer\n            *ngIf=\"type === 'thermometer'\"\n            [ids]=\"slideIds\"\n            [selectedIndex]=\"currentRealSlideIndex\"\n            [pauseAnimation]=\"pauseAutoplay\"\n            [theme]=\"theme\"\n            [direction]=\"dir\"\n            (idChanged)=\"goToSlide($event)\"\n          >\n          </sie-ui-thermometer>\n        </div>\n      </div>\n\n      <button\n        *ngIf=\"!layoutService.isTouchDevice\"\n        type=\"button\"\n        [disabled]=\"isSliding\"\n        class=\"carousel__button carousel__prev\"\n        (mouseenter)=\"toggleCutOffSlideStyle('previous')\"\n        (mouseleave)=\"toggleCutOffSlideStyle()\"\n        (click)=\"goToPrevious()\"\n        #carouselButton\n      >\n        <span class=\"carousel__button__content\" [ngClass]=\"{ dark: theme === 'dark' }\">\n          <span class=\"carousel__icon-container carousel__icon-container-left\">\n            <sie-icon class=\"carousel__control-icon\" [name]=\"iconReg.sieIcon.ArrowLeft\"></sie-icon>\n          </span>\n          <span class=\"visually-hidden\">{{ screenReader?.previousButtonText }}</span>\n        </span>\n      </button>\n      <button\n        *ngIf=\"!layoutService.isTouchDevice\"\n        type=\"button\"\n        [disabled]=\"isSliding\"\n        class=\"carousel__button carousel__next\"\n        [ngClass]=\"{ dark: theme === 'dark' }\"\n        (mouseenter)=\"toggleCutOffSlideStyle('next')\"\n        (mouseleave)=\"toggleCutOffSlideStyle()\"\n        (click)=\"goToNext()\"\n        #carouselButton\n      >\n        <span class=\"carousel__button__content\" [ngClass]=\"{ dark: theme === 'dark' }\">\n          <span class=\"carousel__icon-container carousel__icon-container-right\">\n            <sie-icon class=\"carousel__control-icon\" [name]=\"iconReg.sieIcon.ArrowRight\"></sie-icon>\n          </span>\n          <span class=\"visually-hidden\">{{ screenReader?.nextButtonText }}</span>\n        </span>\n      </button>\n    </div>\n\n    <sie-ui-dot-pagination\n      *ngIf=\"type === 'dots'\"\n      [ids]=\"slideIds\"\n      [selectedIndex]=\"currentRealSlideIndex\"\n      [theme]=\"theme\"\n      [smallViewport]=\"smallViewport$ | async\"\n      (idChanged)=\"goToSlide($event)\"\n      class=\"carousel__pagination\"\n    >\n    </sie-ui-dot-pagination>\n  </fieldset>\n\n  <ul [ngStyle]=\"{ transform: inlineTranslate }\" class=\"carousel__stage\" role=\"tablist\" #carouselUl>\n    <ng-container *ngFor=\"let group of [0, 1, 2]\">\n      <li\n        *ngFor=\"let slide of getSlidesForGroup(group); index as i; count as c\"\n        [attr.aria-hidden]=\"group !== SlideGroup.RealSlides\"\n        [attr.id]=\"group === SlideGroup.RealSlides ? slide.id : null\"\n        [ngStyle]=\"{\n          visibility: slideVisibility(group, i)\n        }\"\n        [ngClass]=\"{\n          'carousel__slide--panning': isPanning,\n          previous: isPreviousSlide(group, i),\n          next: isNextSlide(group, i),\n          active: group === SlideGroup.RealSlides && i === currentRealSlideIndex,\n          hovered:\n            (cutOffHovered === 'previous' && isPreviousSlide(group, i)) ||\n            (cutOffHovered === 'next' && isNextSlide(group, i))\n        }\"\n        class=\"carousel__slide slide-{{ i }}-{{ group }}\"\n        role=\"tab\"\n      >\n        <span class=\"visually-hidden\">{{ getScreenReaderText(i, c) }}</span>\n        <div *ngIf=\"cutOff\" role=\"tabpanel\" class=\"carousel__slide__container\">\n          <ng-container [ngTemplateOutlet]=\"carouselSlideContent\"></ng-container>\n        </div>\n        <ng-container *ngIf=\"!cutOff\" [ngTemplateOutlet]=\"carouselSlideContent\"></ng-container>\n\n        <ng-template #carouselSlideContent>\n          <ng-container\n            sieUiCarouselRender\n            [itemToRender]=\"{ item: slide, duplicate: group !== SlideGroup.RealSlides }\"\n          >\n          </ng-container>\n        </ng-template>\n      </li>\n    </ng-container>\n  </ul>\n</div>\n\n<div #elements class=\"carousel-container\">\n  <ng-content select=\".item\"></ng-content>\n</div>\n", styles: [".carousel__button:focus{outline:0}.carousel .autoplay-container__button-wrapper__button{outline:none;outline-offset:0}@media (pointer: fine){.carousel .autoplay-container__button-wrapper__button{position:relative}.carousel .autoplay-container__button-wrapper__button:focus{outline:1px solid #1491eb;outline-offset:2px}.carousel .autoplay-container__button-wrapper__button:focus:not(:focus-visible){outline:0}.carousel .autoplay-container__button-wrapper__button:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}:host{display:block}.carousel-container-style{container:carousel-container/inline-size}.carousel__button{position:absolute;top:var(--arrowButtonsPositionTop, 50%);transform:translateY(-50%)}.carousel__button{width:48px;height:48px;z-index:1;display:none;border:0;color:#fff;justify-content:center;align-items:center}.carousel:hover .carousel__button{display:flex}.carousel-container{display:none}.carousel{display:flex;overflow:hidden;position:relative;flex-direction:column}.carousel__controls{border:0;padding:0}.carousel__stage{transition-timing-function:cubic-bezier(.4,0,.3,1);list-style:none;margin:0;padding:0;position:relative;display:flex;height:100%}.carousel__slide{display:flex;width:100%;flex-basis:100%;flex-shrink:0;flex-direction:column;align-items:center;justify-content:flex-start}.carousel__slide--panning{pointer-events:none}.carousel__slide>.container{height:100%}.carousel__button{padding:0;cursor:pointer;background-color:transparent}.carousel__button__content{display:flex;width:40px;height:40px;color:#fff;background-color:#007993;border-radius:50%;box-shadow:0 4px 6px #0000001a,0 2px 2px #00000014}.carousel__button__content.dark{color:#000028;background-color:#0cc}.carousel--cutoff .carousel__button{top:0;height:calc(100% - 38px);transform:none}.carousel__button:hover .carousel__button__content{background-color:#00646e}.carousel__button:hover .carousel__button__content.dark{background-color:#00ffb9}.carousel__button:disabled{pointer-events:none;cursor:none}.carousel__button:disabled .carousel__button__content{color:#ebebee;background-color:#b3b3be}.carousel__button:disabled .carousel__button__content.dark{color:#b3b3be;background-color:#737389}.carousel__button:focus .carousel__button__content{position:relative}.carousel__button:focus .carousel__button__content:before{content:\"\";position:absolute;inset:-4px;z-index:1;border:1px solid #1491eb;border-radius:50%}.carousel__button:focus-visible .carousel__button__content:before{content:\"\";position:absolute;inset:-4px;z-index:1;border:1px solid #1491eb;border-radius:50%}.carousel__button:focus:not(:focus-visible) .carousel__button__content:before{border:none}.carousel--cutoff .carousel__prev{left:0;padding-left:24px;min-width:68px;justify-content:flex-start}@media (min-width: 1024px){.carousel--cutoff .carousel__prev{padding-left:8px;min-width:52px}}@media (min-width: 1440px){.carousel--cutoff .carousel__prev{padding-left:16px;min-width:60px}}.carousel--cutoff .carousel__next{right:0;padding-right:24px;min-width:68px;justify-content:flex-end}@media (min-width: 1024px){.carousel--cutoff .carousel__next{padding-right:8px;min-width:52px}}@media (min-width: 1440px){.carousel--cutoff .carousel__next{padding-right:16px;min-width:60px}}.carousel__pause{position:absolute;left:8px;bottom:8px;z-index:2}.carousel__thermometer,.carousel__autoplay-btn,.carousel__pagination{position:absolute;right:0;bottom:20px;left:0;z-index:1}.carousel__thermometer{bottom:32px}.carousel__icon-container{display:flex;height:100%;width:100%;flex-direction:row;justify-content:center;align-items:center}.carousel__icon-container-left{padding-right:2px}.carousel__icon-container-right{padding-left:2px}.carousel__control-icon{width:32px;height:32px;display:flex;align-items:center;fill:currentColor}.carousel__control-icon svg{fill:currentColor;width:inherit;height:inherit}.carousel__control-icon svg g{fill:currentColor;width:inherit;height:inherit}.carousel__control-icon svg text{font-family:Siemens Sans,sans-serif}.carousel--cutoff.scrollable{padding-bottom:38px}.carousel--cutoff .previous,.carousel--cutoff .next{opacity:.6;transition:opacity .25s cubic-bezier(.4,0,.3,1)}.carousel--cutoff .previous.hovered,.carousel--cutoff .next.hovered{opacity:1}@media (min-width: 1920px){.carousel--cutoff .carousel__buttons{height:100%;position:absolute;left:0;right:0;margin:0 auto;max-width:1880px}.carousel--cutoff .carousel__button{width:auto!important}}.carousel--cutoff .carousel__slide{max-width:calc((100vw - 32px - var(--scrollbar-width)) + 8px);padding:0 4px;width:auto;flex-basis:auto}@media (min-width: 640px){.carousel--cutoff .carousel__slide{max-width:calc((100vw - 32px - var(--scrollbar-width)) + 8px)}}@media (min-width: 1024px){.carousel--cutoff .carousel__slide{max-width:calc((100vw - 112px - var(--scrollbar-width)) + 24px)}}@media (min-width: 1440px){.carousel--cutoff .carousel__slide{max-width:calc((100vw - 192px - var(--scrollbar-width)) + 24px)}}@media (min-width: 1024px){.carousel--cutoff .carousel__slide{padding:0 12px}}.carousel--cutoff .carousel__slide__container{width:100%;height:100%}.carousel--cutoff .carousel__stage{margin:0 -4px}@media (min-width: 1024px){.carousel--cutoff .carousel__stage{margin:0 -12px}}.carousel--cutoff .carousel__pagination{bottom:2px}.carousel--cutoff .carousel__thermometer{bottom:66px}.carousel .autoplay-container{display:flex;justify-content:center;align-items:center;flex-wrap:wrap;height:max-content;gap:16px}.carousel .autoplay-container__button-wrapper{display:flex;justify-content:center;align-items:center;height:28px;width:28px}.carousel .autoplay-container__button-wrapper__button{display:flex;justify-content:center;align-items:center;background-color:#ffffff40;border:1px solid rgba(255,255,255,.25);border-radius:50%;width:24px;height:24px;padding:0}.carousel .autoplay-container__button-wrapper__button:hover{width:28px;height:28px}.carousel .autoplay-container__button-wrapper__button sie-icon{color:#fff;fill:#fff;width:16px;height:16px;display:flex;align-items:center}.carousel .autoplay-container sie-ui-thermometer{max-width:100%}@media (min-width: 1024px){.carousel:not(.container-layout) .carousel__button{display:flex}}.carousel:not(.container-layout) .carousel__prev{left:20px}@media (min-width: 1024px){.carousel:not(.container-layout) .carousel__prev{left:4px}}@media (min-width: 1440px){.carousel:not(.container-layout) .carousel__prev{left:12px}}.carousel:not(.container-layout) .carousel__next{right:20px}@media (min-width: 1024px){.carousel:not(.container-layout) .carousel__next{right:4px}}@media (min-width: 1440px){.carousel:not(.container-layout) .carousel__next{right:12px}}@container carousel-container (min-width: 1024px){.carousel.container-layout .carousel__button{display:flex}}.carousel.container-layout .carousel__prev{left:20px}@container carousel-container (min-width: 1024px){.carousel.container-layout .carousel__prev{left:4px}}@container carousel-container (min-width: 1440px){.carousel.container-layout .carousel__prev{left:12px}}.carousel.container-layout .carousel__next{right:20px}@container carousel-container (min-width: 1024px){.carousel.container-layout .carousel__next{right:4px}}@container carousel-container (min-width: 1440px){.carousel.container-layout .carousel__next{right:12px}}\n"] }]
        }], ctorParameters: function () { return [{ type: i1$1.LayoutService }, { type: UiCarouselService }, { type: i1.SieIconRegistryService }, { type: i4.AnimationBuilder }, { type: i0.ElementRef }, { type: i0.ChangeDetectorRef }, { type: i1$1.ElementResizeDirective }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [UI_CAROUSEL_WEB_COMPONENT_SERVICE]
                }] }]; }, propDecorators: { carouselUl: [{
                type: ViewChild,
                args: ['carouselUl']
            }], carouselButtons: [{
                type: ViewChildren,
                args: ['carouselButton']
            }], elementsRef: [{
                type: ViewChild,
                args: ['elements']
            }], slides: [{
                type: ContentChildren,
                args: [UiCarouselSlideDirective]
            }], dir: [{
                type: Input
            }], theme: [{
                type: Input
            }], type: [{
                type: Input
            }], screenReader: [{
                type: Input
            }], containerStyled: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], cutOff: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], pauseAutoplay: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], goToSlideAt: [], goToPrevious: [], goToNext: [] } });
/** @ignore */
class UiCarouselWebComponent extends UiCarouselComponent {
    constructor(layoutService, carouselService, iconReg, animationBuilder, elementRef, cd, resizeDirective, uiCarouselComponentService) {
        super(layoutService, carouselService, iconReg, animationBuilder, elementRef, cd, resizeDirective, uiCarouselComponentService);
        this.iconReg = iconReg;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCarouselWebComponent, deps: [{ token: i1$1.LayoutService }, { token: UiCarouselService }, { token: i1.SieIconRegistryService }, { token: i4.AnimationBuilder }, { token: i0.ElementRef }, { token: i0.ChangeDetectorRef }, { token: i1$1.ElementResizeDirective }, { token: UI_CAROUSEL_WEB_COMPONENT_SERVICE }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiCarouselWebComponent, selector: "sie-ui-carousel-webcomponent-donotuseit", providers: [
            {
                provide: UI_CAROUSEL_WEB_COMPONENT_SERVICE,
                useClass: UiCarouselElementsService,
                deps: [UiDomManipulationService]
            }
        ], usesInheritance: true, hostDirectives: [{ directive: i1$1.ElementResizeDirective }], ngImport: i0, template: "<div\n  class=\"carousel\"\n  [ngClass]=\"{\n    'carousel--cutoff': cutOff,\n    scrollable: slides.length > 1,\n    'carousel-container-style': containerStyled,\n    'container-layout': containerStyled\n  }\"\n  *ngIf=\"slides.length\"\n  (pan)=\"onPan($event)\"\n  (panend)=\"onPanEnd($event)\"\n  (panstart)=\"onPanStart($event)\"\n>\n  <fieldset class=\"carousel__controls\" *ngIf=\"slides.length > 1\">\n    <legend class=\"visually-hidden\">{{ screenReader?.controlsHeaderText }}</legend>\n    <div class=\"carousel__buttons\">\n      <div *ngIf=\"type === 'thermometer'\" class=\"carousel__autoplay-btn\">\n        <div class=\"autoplay-container\">\n          <div class=\"autoplay-container__button-wrapper\">\n            <button class=\"autoplay-container__button-wrapper__button\" (click)=\"toggleCarouselPause()\">\n              <ng-container *ngIf=\"autoPlay; else pause\">\n                <sie-icon [name]=\"iconReg.sieIcon.Pause\"></sie-icon>\n                <span class=\"visually-hidden\">{{ screenReader?.pauseButtonText }}</span>\n              </ng-container>\n\n              <ng-template #pause>\n                <sie-icon [name]=\"iconReg.sieIcon.Play\"></sie-icon>\n                <span class=\"visually-hidden\">{{ screenReader?.playButtonText }}</span>\n              </ng-template>\n            </button>\n          </div>\n\n          <sie-ui-thermometer\n            *ngIf=\"type === 'thermometer'\"\n            [ids]=\"slideIds\"\n            [selectedIndex]=\"currentRealSlideIndex\"\n            [pauseAnimation]=\"pauseAutoplay\"\n            [theme]=\"theme\"\n            [direction]=\"dir\"\n            (idChanged)=\"goToSlide($event)\"\n          >\n          </sie-ui-thermometer>\n        </div>\n      </div>\n\n      <button\n        *ngIf=\"!layoutService.isTouchDevice\"\n        type=\"button\"\n        [disabled]=\"isSliding\"\n        class=\"carousel__button carousel__prev\"\n        (mouseenter)=\"toggleCutOffSlideStyle('previous')\"\n        (mouseleave)=\"toggleCutOffSlideStyle()\"\n        (click)=\"goToPrevious()\"\n        #carouselButton\n      >\n        <span class=\"carousel__button__content\" [ngClass]=\"{ dark: theme === 'dark' }\">\n          <span class=\"carousel__icon-container carousel__icon-container-left\">\n            <sie-icon class=\"carousel__control-icon\" [name]=\"iconReg.sieIcon.ArrowLeft\"></sie-icon>\n          </span>\n          <span class=\"visually-hidden\">{{ screenReader?.previousButtonText }}</span>\n        </span>\n      </button>\n      <button\n        *ngIf=\"!layoutService.isTouchDevice\"\n        type=\"button\"\n        [disabled]=\"isSliding\"\n        class=\"carousel__button carousel__next\"\n        [ngClass]=\"{ dark: theme === 'dark' }\"\n        (mouseenter)=\"toggleCutOffSlideStyle('next')\"\n        (mouseleave)=\"toggleCutOffSlideStyle()\"\n        (click)=\"goToNext()\"\n        #carouselButton\n      >\n        <span class=\"carousel__button__content\" [ngClass]=\"{ dark: theme === 'dark' }\">\n          <span class=\"carousel__icon-container carousel__icon-container-right\">\n            <sie-icon class=\"carousel__control-icon\" [name]=\"iconReg.sieIcon.ArrowRight\"></sie-icon>\n          </span>\n          <span class=\"visually-hidden\">{{ screenReader?.nextButtonText }}</span>\n        </span>\n      </button>\n    </div>\n\n    <sie-ui-dot-pagination\n      *ngIf=\"type === 'dots'\"\n      [ids]=\"slideIds\"\n      [selectedIndex]=\"currentRealSlideIndex\"\n      [theme]=\"theme\"\n      [smallViewport]=\"smallViewport$ | async\"\n      (idChanged)=\"goToSlide($event)\"\n      class=\"carousel__pagination\"\n    >\n    </sie-ui-dot-pagination>\n  </fieldset>\n\n  <ul [ngStyle]=\"{ transform: inlineTranslate }\" class=\"carousel__stage\" role=\"tablist\" #carouselUl>\n    <ng-container *ngFor=\"let group of [0, 1, 2]\">\n      <li\n        *ngFor=\"let slide of getSlidesForGroup(group); index as i; count as c\"\n        [attr.aria-hidden]=\"group !== SlideGroup.RealSlides\"\n        [attr.id]=\"group === SlideGroup.RealSlides ? slide.id : null\"\n        [ngStyle]=\"{\n          visibility: slideVisibility(group, i)\n        }\"\n        [ngClass]=\"{\n          'carousel__slide--panning': isPanning,\n          previous: isPreviousSlide(group, i),\n          next: isNextSlide(group, i),\n          active: group === SlideGroup.RealSlides && i === currentRealSlideIndex,\n          hovered:\n            (cutOffHovered === 'previous' && isPreviousSlide(group, i)) ||\n            (cutOffHovered === 'next' && isNextSlide(group, i))\n        }\"\n        class=\"carousel__slide slide-{{ i }}-{{ group }}\"\n        role=\"tab\"\n      >\n        <span class=\"visually-hidden\">{{ getScreenReaderText(i, c) }}</span>\n        <div *ngIf=\"cutOff\" role=\"tabpanel\" class=\"carousel__slide__container\">\n          <ng-container [ngTemplateOutlet]=\"carouselSlideContent\"></ng-container>\n        </div>\n        <ng-container *ngIf=\"!cutOff\" [ngTemplateOutlet]=\"carouselSlideContent\"></ng-container>\n\n        <ng-template #carouselSlideContent>\n          <ng-container\n            sieUiCarouselRender\n            [itemToRender]=\"{ item: slide, duplicate: group !== SlideGroup.RealSlides }\"\n          >\n          </ng-container>\n        </ng-template>\n      </li>\n    </ng-container>\n  </ul>\n</div>\n\n<div #elements class=\"carousel-container\">\n  <ng-content select=\".item\"></ng-content>\n</div>\n", styles: [".carousel__button:focus{outline:0}.carousel .autoplay-container__button-wrapper__button{outline:none;outline-offset:0}@media (pointer: fine){.carousel .autoplay-container__button-wrapper__button{position:relative}.carousel .autoplay-container__button-wrapper__button:focus{outline:1px solid #1491eb;outline-offset:2px}.carousel .autoplay-container__button-wrapper__button:focus:not(:focus-visible){outline:0}.carousel .autoplay-container__button-wrapper__button:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}:host{display:block}.carousel-container-style{container:carousel-container/inline-size}.carousel__button{position:absolute;top:var(--arrowButtonsPositionTop, 50%);transform:translateY(-50%)}.carousel__button{width:48px;height:48px;z-index:1;display:none;border:0;color:#fff;justify-content:center;align-items:center}.carousel:hover .carousel__button{display:flex}.carousel-container{display:none}.carousel{display:flex;overflow:hidden;position:relative;flex-direction:column}.carousel__controls{border:0;padding:0}.carousel__stage{transition-timing-function:cubic-bezier(.4,0,.3,1);list-style:none;margin:0;padding:0;position:relative;display:flex;height:100%}.carousel__slide{display:flex;width:100%;flex-basis:100%;flex-shrink:0;flex-direction:column;align-items:center;justify-content:flex-start}.carousel__slide--panning{pointer-events:none}.carousel__slide>.container{height:100%}.carousel__button{padding:0;cursor:pointer;background-color:transparent}.carousel__button__content{display:flex;width:40px;height:40px;color:#fff;background-color:#007993;border-radius:50%;box-shadow:0 4px 6px #0000001a,0 2px 2px #00000014}.carousel__button__content.dark{color:#000028;background-color:#0cc}.carousel--cutoff .carousel__button{top:0;height:calc(100% - 38px);transform:none}.carousel__button:hover .carousel__button__content{background-color:#00646e}.carousel__button:hover .carousel__button__content.dark{background-color:#00ffb9}.carousel__button:disabled{pointer-events:none;cursor:none}.carousel__button:disabled .carousel__button__content{color:#ebebee;background-color:#b3b3be}.carousel__button:disabled .carousel__button__content.dark{color:#b3b3be;background-color:#737389}.carousel__button:focus .carousel__button__content{position:relative}.carousel__button:focus .carousel__button__content:before{content:\"\";position:absolute;inset:-4px;z-index:1;border:1px solid #1491eb;border-radius:50%}.carousel__button:focus-visible .carousel__button__content:before{content:\"\";position:absolute;inset:-4px;z-index:1;border:1px solid #1491eb;border-radius:50%}.carousel__button:focus:not(:focus-visible) .carousel__button__content:before{border:none}.carousel--cutoff .carousel__prev{left:0;padding-left:24px;min-width:68px;justify-content:flex-start}@media (min-width: 1024px){.carousel--cutoff .carousel__prev{padding-left:8px;min-width:52px}}@media (min-width: 1440px){.carousel--cutoff .carousel__prev{padding-left:16px;min-width:60px}}.carousel--cutoff .carousel__next{right:0;padding-right:24px;min-width:68px;justify-content:flex-end}@media (min-width: 1024px){.carousel--cutoff .carousel__next{padding-right:8px;min-width:52px}}@media (min-width: 1440px){.carousel--cutoff .carousel__next{padding-right:16px;min-width:60px}}.carousel__pause{position:absolute;left:8px;bottom:8px;z-index:2}.carousel__thermometer,.carousel__autoplay-btn,.carousel__pagination{position:absolute;right:0;bottom:20px;left:0;z-index:1}.carousel__thermometer{bottom:32px}.carousel__icon-container{display:flex;height:100%;width:100%;flex-direction:row;justify-content:center;align-items:center}.carousel__icon-container-left{padding-right:2px}.carousel__icon-container-right{padding-left:2px}.carousel__control-icon{width:32px;height:32px;display:flex;align-items:center;fill:currentColor}.carousel__control-icon svg{fill:currentColor;width:inherit;height:inherit}.carousel__control-icon svg g{fill:currentColor;width:inherit;height:inherit}.carousel__control-icon svg text{font-family:Siemens Sans,sans-serif}.carousel--cutoff.scrollable{padding-bottom:38px}.carousel--cutoff .previous,.carousel--cutoff .next{opacity:.6;transition:opacity .25s cubic-bezier(.4,0,.3,1)}.carousel--cutoff .previous.hovered,.carousel--cutoff .next.hovered{opacity:1}@media (min-width: 1920px){.carousel--cutoff .carousel__buttons{height:100%;position:absolute;left:0;right:0;margin:0 auto;max-width:1880px}.carousel--cutoff .carousel__button{width:auto!important}}.carousel--cutoff .carousel__slide{max-width:calc((100vw - 32px - var(--scrollbar-width)) + 8px);padding:0 4px;width:auto;flex-basis:auto}@media (min-width: 640px){.carousel--cutoff .carousel__slide{max-width:calc((100vw - 32px - var(--scrollbar-width)) + 8px)}}@media (min-width: 1024px){.carousel--cutoff .carousel__slide{max-width:calc((100vw - 112px - var(--scrollbar-width)) + 24px)}}@media (min-width: 1440px){.carousel--cutoff .carousel__slide{max-width:calc((100vw - 192px - var(--scrollbar-width)) + 24px)}}@media (min-width: 1024px){.carousel--cutoff .carousel__slide{padding:0 12px}}.carousel--cutoff .carousel__slide__container{width:100%;height:100%}.carousel--cutoff .carousel__stage{margin:0 -4px}@media (min-width: 1024px){.carousel--cutoff .carousel__stage{margin:0 -12px}}.carousel--cutoff .carousel__pagination{bottom:2px}.carousel--cutoff .carousel__thermometer{bottom:66px}.carousel .autoplay-container{display:flex;justify-content:center;align-items:center;flex-wrap:wrap;height:max-content;gap:16px}.carousel .autoplay-container__button-wrapper{display:flex;justify-content:center;align-items:center;height:28px;width:28px}.carousel .autoplay-container__button-wrapper__button{display:flex;justify-content:center;align-items:center;background-color:#ffffff40;border:1px solid rgba(255,255,255,.25);border-radius:50%;width:24px;height:24px;padding:0}.carousel .autoplay-container__button-wrapper__button:hover{width:28px;height:28px}.carousel .autoplay-container__button-wrapper__button sie-icon{color:#fff;fill:#fff;width:16px;height:16px;display:flex;align-items:center}.carousel .autoplay-container sie-ui-thermometer{max-width:100%}@media (min-width: 1024px){.carousel:not(.container-layout) .carousel__button{display:flex}}.carousel:not(.container-layout) .carousel__prev{left:20px}@media (min-width: 1024px){.carousel:not(.container-layout) .carousel__prev{left:4px}}@media (min-width: 1440px){.carousel:not(.container-layout) .carousel__prev{left:12px}}.carousel:not(.container-layout) .carousel__next{right:20px}@media (min-width: 1024px){.carousel:not(.container-layout) .carousel__next{right:4px}}@media (min-width: 1440px){.carousel:not(.container-layout) .carousel__next{right:12px}}@container carousel-container (min-width: 1024px){.carousel.container-layout .carousel__button{display:flex}}.carousel.container-layout .carousel__prev{left:20px}@container carousel-container (min-width: 1024px){.carousel.container-layout .carousel__prev{left:4px}}@container carousel-container (min-width: 1440px){.carousel.container-layout .carousel__prev{left:12px}}.carousel.container-layout .carousel__next{right:20px}@container carousel-container (min-width: 1024px){.carousel.container-layout .carousel__next{right:4px}}@container carousel-container (min-width: 1440px){.carousel.container-layout .carousel__next{right:12px}}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: i2.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "component", type: UiDotPaginationComponent, selector: "sie-ui-dot-pagination", inputs: ["smallViewport"] }, { kind: "component", type: UiThermometerComponent, selector: "sie-ui-thermometer", inputs: ["direction", "duration", "pauseAnimation"] }, { kind: "directive", type: UiCarouselItemRenderDirective, selector: "[sieUiCarouselRender]", inputs: ["itemToRender"] }, { kind: "pipe", type: i2.AsyncPipe, name: "async" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCarouselWebComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-carousel-webcomponent-donotuseit', changeDetection: ChangeDetectionStrategy.OnPush, hostDirectives: [
                        {
                            directive: ElementResizeDirective
                        }
                    ], providers: [
                        {
                            provide: UI_CAROUSEL_WEB_COMPONENT_SERVICE,
                            useClass: UiCarouselElementsService,
                            deps: [UiDomManipulationService]
                        }
                    ], template: "<div\n  class=\"carousel\"\n  [ngClass]=\"{\n    'carousel--cutoff': cutOff,\n    scrollable: slides.length > 1,\n    'carousel-container-style': containerStyled,\n    'container-layout': containerStyled\n  }\"\n  *ngIf=\"slides.length\"\n  (pan)=\"onPan($event)\"\n  (panend)=\"onPanEnd($event)\"\n  (panstart)=\"onPanStart($event)\"\n>\n  <fieldset class=\"carousel__controls\" *ngIf=\"slides.length > 1\">\n    <legend class=\"visually-hidden\">{{ screenReader?.controlsHeaderText }}</legend>\n    <div class=\"carousel__buttons\">\n      <div *ngIf=\"type === 'thermometer'\" class=\"carousel__autoplay-btn\">\n        <div class=\"autoplay-container\">\n          <div class=\"autoplay-container__button-wrapper\">\n            <button class=\"autoplay-container__button-wrapper__button\" (click)=\"toggleCarouselPause()\">\n              <ng-container *ngIf=\"autoPlay; else pause\">\n                <sie-icon [name]=\"iconReg.sieIcon.Pause\"></sie-icon>\n                <span class=\"visually-hidden\">{{ screenReader?.pauseButtonText }}</span>\n              </ng-container>\n\n              <ng-template #pause>\n                <sie-icon [name]=\"iconReg.sieIcon.Play\"></sie-icon>\n                <span class=\"visually-hidden\">{{ screenReader?.playButtonText }}</span>\n              </ng-template>\n            </button>\n          </div>\n\n          <sie-ui-thermometer\n            *ngIf=\"type === 'thermometer'\"\n            [ids]=\"slideIds\"\n            [selectedIndex]=\"currentRealSlideIndex\"\n            [pauseAnimation]=\"pauseAutoplay\"\n            [theme]=\"theme\"\n            [direction]=\"dir\"\n            (idChanged)=\"goToSlide($event)\"\n          >\n          </sie-ui-thermometer>\n        </div>\n      </div>\n\n      <button\n        *ngIf=\"!layoutService.isTouchDevice\"\n        type=\"button\"\n        [disabled]=\"isSliding\"\n        class=\"carousel__button carousel__prev\"\n        (mouseenter)=\"toggleCutOffSlideStyle('previous')\"\n        (mouseleave)=\"toggleCutOffSlideStyle()\"\n        (click)=\"goToPrevious()\"\n        #carouselButton\n      >\n        <span class=\"carousel__button__content\" [ngClass]=\"{ dark: theme === 'dark' }\">\n          <span class=\"carousel__icon-container carousel__icon-container-left\">\n            <sie-icon class=\"carousel__control-icon\" [name]=\"iconReg.sieIcon.ArrowLeft\"></sie-icon>\n          </span>\n          <span class=\"visually-hidden\">{{ screenReader?.previousButtonText }}</span>\n        </span>\n      </button>\n      <button\n        *ngIf=\"!layoutService.isTouchDevice\"\n        type=\"button\"\n        [disabled]=\"isSliding\"\n        class=\"carousel__button carousel__next\"\n        [ngClass]=\"{ dark: theme === 'dark' }\"\n        (mouseenter)=\"toggleCutOffSlideStyle('next')\"\n        (mouseleave)=\"toggleCutOffSlideStyle()\"\n        (click)=\"goToNext()\"\n        #carouselButton\n      >\n        <span class=\"carousel__button__content\" [ngClass]=\"{ dark: theme === 'dark' }\">\n          <span class=\"carousel__icon-container carousel__icon-container-right\">\n            <sie-icon class=\"carousel__control-icon\" [name]=\"iconReg.sieIcon.ArrowRight\"></sie-icon>\n          </span>\n          <span class=\"visually-hidden\">{{ screenReader?.nextButtonText }}</span>\n        </span>\n      </button>\n    </div>\n\n    <sie-ui-dot-pagination\n      *ngIf=\"type === 'dots'\"\n      [ids]=\"slideIds\"\n      [selectedIndex]=\"currentRealSlideIndex\"\n      [theme]=\"theme\"\n      [smallViewport]=\"smallViewport$ | async\"\n      (idChanged)=\"goToSlide($event)\"\n      class=\"carousel__pagination\"\n    >\n    </sie-ui-dot-pagination>\n  </fieldset>\n\n  <ul [ngStyle]=\"{ transform: inlineTranslate }\" class=\"carousel__stage\" role=\"tablist\" #carouselUl>\n    <ng-container *ngFor=\"let group of [0, 1, 2]\">\n      <li\n        *ngFor=\"let slide of getSlidesForGroup(group); index as i; count as c\"\n        [attr.aria-hidden]=\"group !== SlideGroup.RealSlides\"\n        [attr.id]=\"group === SlideGroup.RealSlides ? slide.id : null\"\n        [ngStyle]=\"{\n          visibility: slideVisibility(group, i)\n        }\"\n        [ngClass]=\"{\n          'carousel__slide--panning': isPanning,\n          previous: isPreviousSlide(group, i),\n          next: isNextSlide(group, i),\n          active: group === SlideGroup.RealSlides && i === currentRealSlideIndex,\n          hovered:\n            (cutOffHovered === 'previous' && isPreviousSlide(group, i)) ||\n            (cutOffHovered === 'next' && isNextSlide(group, i))\n        }\"\n        class=\"carousel__slide slide-{{ i }}-{{ group }}\"\n        role=\"tab\"\n      >\n        <span class=\"visually-hidden\">{{ getScreenReaderText(i, c) }}</span>\n        <div *ngIf=\"cutOff\" role=\"tabpanel\" class=\"carousel__slide__container\">\n          <ng-container [ngTemplateOutlet]=\"carouselSlideContent\"></ng-container>\n        </div>\n        <ng-container *ngIf=\"!cutOff\" [ngTemplateOutlet]=\"carouselSlideContent\"></ng-container>\n\n        <ng-template #carouselSlideContent>\n          <ng-container\n            sieUiCarouselRender\n            [itemToRender]=\"{ item: slide, duplicate: group !== SlideGroup.RealSlides }\"\n          >\n          </ng-container>\n        </ng-template>\n      </li>\n    </ng-container>\n  </ul>\n</div>\n\n<div #elements class=\"carousel-container\">\n  <ng-content select=\".item\"></ng-content>\n</div>\n", styles: [".carousel__button:focus{outline:0}.carousel .autoplay-container__button-wrapper__button{outline:none;outline-offset:0}@media (pointer: fine){.carousel .autoplay-container__button-wrapper__button{position:relative}.carousel .autoplay-container__button-wrapper__button:focus{outline:1px solid #1491eb;outline-offset:2px}.carousel .autoplay-container__button-wrapper__button:focus:not(:focus-visible){outline:0}.carousel .autoplay-container__button-wrapper__button:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}:host{display:block}.carousel-container-style{container:carousel-container/inline-size}.carousel__button{position:absolute;top:var(--arrowButtonsPositionTop, 50%);transform:translateY(-50%)}.carousel__button{width:48px;height:48px;z-index:1;display:none;border:0;color:#fff;justify-content:center;align-items:center}.carousel:hover .carousel__button{display:flex}.carousel-container{display:none}.carousel{display:flex;overflow:hidden;position:relative;flex-direction:column}.carousel__controls{border:0;padding:0}.carousel__stage{transition-timing-function:cubic-bezier(.4,0,.3,1);list-style:none;margin:0;padding:0;position:relative;display:flex;height:100%}.carousel__slide{display:flex;width:100%;flex-basis:100%;flex-shrink:0;flex-direction:column;align-items:center;justify-content:flex-start}.carousel__slide--panning{pointer-events:none}.carousel__slide>.container{height:100%}.carousel__button{padding:0;cursor:pointer;background-color:transparent}.carousel__button__content{display:flex;width:40px;height:40px;color:#fff;background-color:#007993;border-radius:50%;box-shadow:0 4px 6px #0000001a,0 2px 2px #00000014}.carousel__button__content.dark{color:#000028;background-color:#0cc}.carousel--cutoff .carousel__button{top:0;height:calc(100% - 38px);transform:none}.carousel__button:hover .carousel__button__content{background-color:#00646e}.carousel__button:hover .carousel__button__content.dark{background-color:#00ffb9}.carousel__button:disabled{pointer-events:none;cursor:none}.carousel__button:disabled .carousel__button__content{color:#ebebee;background-color:#b3b3be}.carousel__button:disabled .carousel__button__content.dark{color:#b3b3be;background-color:#737389}.carousel__button:focus .carousel__button__content{position:relative}.carousel__button:focus .carousel__button__content:before{content:\"\";position:absolute;inset:-4px;z-index:1;border:1px solid #1491eb;border-radius:50%}.carousel__button:focus-visible .carousel__button__content:before{content:\"\";position:absolute;inset:-4px;z-index:1;border:1px solid #1491eb;border-radius:50%}.carousel__button:focus:not(:focus-visible) .carousel__button__content:before{border:none}.carousel--cutoff .carousel__prev{left:0;padding-left:24px;min-width:68px;justify-content:flex-start}@media (min-width: 1024px){.carousel--cutoff .carousel__prev{padding-left:8px;min-width:52px}}@media (min-width: 1440px){.carousel--cutoff .carousel__prev{padding-left:16px;min-width:60px}}.carousel--cutoff .carousel__next{right:0;padding-right:24px;min-width:68px;justify-content:flex-end}@media (min-width: 1024px){.carousel--cutoff .carousel__next{padding-right:8px;min-width:52px}}@media (min-width: 1440px){.carousel--cutoff .carousel__next{padding-right:16px;min-width:60px}}.carousel__pause{position:absolute;left:8px;bottom:8px;z-index:2}.carousel__thermometer,.carousel__autoplay-btn,.carousel__pagination{position:absolute;right:0;bottom:20px;left:0;z-index:1}.carousel__thermometer{bottom:32px}.carousel__icon-container{display:flex;height:100%;width:100%;flex-direction:row;justify-content:center;align-items:center}.carousel__icon-container-left{padding-right:2px}.carousel__icon-container-right{padding-left:2px}.carousel__control-icon{width:32px;height:32px;display:flex;align-items:center;fill:currentColor}.carousel__control-icon svg{fill:currentColor;width:inherit;height:inherit}.carousel__control-icon svg g{fill:currentColor;width:inherit;height:inherit}.carousel__control-icon svg text{font-family:Siemens Sans,sans-serif}.carousel--cutoff.scrollable{padding-bottom:38px}.carousel--cutoff .previous,.carousel--cutoff .next{opacity:.6;transition:opacity .25s cubic-bezier(.4,0,.3,1)}.carousel--cutoff .previous.hovered,.carousel--cutoff .next.hovered{opacity:1}@media (min-width: 1920px){.carousel--cutoff .carousel__buttons{height:100%;position:absolute;left:0;right:0;margin:0 auto;max-width:1880px}.carousel--cutoff .carousel__button{width:auto!important}}.carousel--cutoff .carousel__slide{max-width:calc((100vw - 32px - var(--scrollbar-width)) + 8px);padding:0 4px;width:auto;flex-basis:auto}@media (min-width: 640px){.carousel--cutoff .carousel__slide{max-width:calc((100vw - 32px - var(--scrollbar-width)) + 8px)}}@media (min-width: 1024px){.carousel--cutoff .carousel__slide{max-width:calc((100vw - 112px - var(--scrollbar-width)) + 24px)}}@media (min-width: 1440px){.carousel--cutoff .carousel__slide{max-width:calc((100vw - 192px - var(--scrollbar-width)) + 24px)}}@media (min-width: 1024px){.carousel--cutoff .carousel__slide{padding:0 12px}}.carousel--cutoff .carousel__slide__container{width:100%;height:100%}.carousel--cutoff .carousel__stage{margin:0 -4px}@media (min-width: 1024px){.carousel--cutoff .carousel__stage{margin:0 -12px}}.carousel--cutoff .carousel__pagination{bottom:2px}.carousel--cutoff .carousel__thermometer{bottom:66px}.carousel .autoplay-container{display:flex;justify-content:center;align-items:center;flex-wrap:wrap;height:max-content;gap:16px}.carousel .autoplay-container__button-wrapper{display:flex;justify-content:center;align-items:center;height:28px;width:28px}.carousel .autoplay-container__button-wrapper__button{display:flex;justify-content:center;align-items:center;background-color:#ffffff40;border:1px solid rgba(255,255,255,.25);border-radius:50%;width:24px;height:24px;padding:0}.carousel .autoplay-container__button-wrapper__button:hover{width:28px;height:28px}.carousel .autoplay-container__button-wrapper__button sie-icon{color:#fff;fill:#fff;width:16px;height:16px;display:flex;align-items:center}.carousel .autoplay-container sie-ui-thermometer{max-width:100%}@media (min-width: 1024px){.carousel:not(.container-layout) .carousel__button{display:flex}}.carousel:not(.container-layout) .carousel__prev{left:20px}@media (min-width: 1024px){.carousel:not(.container-layout) .carousel__prev{left:4px}}@media (min-width: 1440px){.carousel:not(.container-layout) .carousel__prev{left:12px}}.carousel:not(.container-layout) .carousel__next{right:20px}@media (min-width: 1024px){.carousel:not(.container-layout) .carousel__next{right:4px}}@media (min-width: 1440px){.carousel:not(.container-layout) .carousel__next{right:12px}}@container carousel-container (min-width: 1024px){.carousel.container-layout .carousel__button{display:flex}}.carousel.container-layout .carousel__prev{left:20px}@container carousel-container (min-width: 1024px){.carousel.container-layout .carousel__prev{left:4px}}@container carousel-container (min-width: 1440px){.carousel.container-layout .carousel__prev{left:12px}}.carousel.container-layout .carousel__next{right:20px}@container carousel-container (min-width: 1024px){.carousel.container-layout .carousel__next{right:4px}}@container carousel-container (min-width: 1440px){.carousel.container-layout .carousel__next{right:12px}}\n"] }]
        }], ctorParameters: function () { return [{ type: i1$1.LayoutService }, { type: UiCarouselService }, { type: i1.SieIconRegistryService }, { type: i4.AnimationBuilder }, { type: i0.ElementRef }, { type: i0.ChangeDetectorRef }, { type: i1$1.ElementResizeDirective }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [UI_CAROUSEL_WEB_COMPONENT_SERVICE]
                }] }]; } });

class UiCarouselNgService {
    init() {
        // don't do anything here
    }
    getSlideIds(component) {
        if (component.slides instanceof QueryList) {
            return component.slides.map(slide => slide.id);
        }
        return [];
    }
    getSlidesForGroup(component, groupIndex) {
        if (component.slides instanceof QueryList) {
            switch (groupIndex) {
                case SlideGroup.DuplicatesBefore:
                    return component.slides.toArray().slice(component.duplicateSlidesCount * -1);
                case SlideGroup.RealSlides:
                    return component.slides.toArray();
                case SlideGroup.DuplicatesAfter:
                    return component.slides.toArray().slice(0, component.duplicateSlidesCount);
                default:
                // No action taken as all necessary actions are handled
            }
        }
    }
    renderChild(viewContainer, item) {
        if (item?.templateRef) {
            viewContainer.createEmbeddedView(item.templateRef);
        }
    }
}

/**
 * # Carousel Module
 * - {@link UiCarouselComponent}
 *
 * ## Module peer dependencies
 * - {@link SieIconsModule}: used for ArrowLeft/ArrowRight icons on the carousel component.
 * - `@angular/platform-browser/animations/BrowserAnimationsModule`: This module is needed to define an animation
 *    inside the carousel for changing slides.
 * - `@angular/platform-browser/HammerModule`: This module is used as a support library for panning
 *    the elements on the carousel.
 */
class UiCarouselModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCarouselModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiCarouselModule, declarations: [UiCarouselComponent,
            UiCarouselWebComponent,
            UiDotPaginationComponent,
            UiThermometerComponent,
            UiCarouselSlideDirective,
            UiCarouselItemRenderDirective], imports: [CommonModule, SieIconsModule, RunInZoneModule], exports: [UiCarouselComponent,
            UiCarouselWebComponent,
            UiThermometerComponent,
            UiDotPaginationComponent,
            UiCarouselSlideDirective] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCarouselModule, providers: [
            {
                provide: UI_CAROUSEL_WEB_COMPONENT_SERVICE,
                useClass: UiCarouselNgService,
                deps: [UiDomManipulationService]
            }
        ], imports: [CommonModule, SieIconsModule, RunInZoneModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCarouselModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        UiCarouselComponent,
                        UiCarouselWebComponent,
                        UiDotPaginationComponent,
                        UiThermometerComponent,
                        UiCarouselSlideDirective,
                        UiCarouselItemRenderDirective
                    ],
                    imports: [CommonModule, SieIconsModule, RunInZoneModule],
                    providers: [
                        {
                            provide: UI_CAROUSEL_WEB_COMPONENT_SERVICE,
                            useClass: UiCarouselNgService,
                            deps: [UiDomManipulationService]
                        }
                    ],
                    exports: [
                        UiCarouselComponent,
                        UiCarouselWebComponent,
                        UiThermometerComponent,
                        UiDotPaginationComponent,
                        UiCarouselSlideDirective
                    ]
                }]
        }] });

/**
 * # Link component
 *
 * Links are used to connect two or more contexts (e.g. pages or sections).
 * It could be a standard link or could be an in-line link that is embedded in a paragraph.
 *
 * ## Component variations
 *
 * - Standard link/icon link
 * - Inline link
 *
 * ## Content
 *
 * The label of the link component can be any valid markup.
 *
 * ## Code example
 * @example
 * Template:
 * ```html
 * Standard link:
 * <sie-ui-link
 *   background="light-neutral"
 *   secondaryLabel="Secondary label with long line of text, long enough for truncation."
 *   href="https://www.siemens.com"
 * >
 *   Neutral link component gets truncated after two lines of text, let's see it
 * </sie-ui-link>
 *
 * Inline link:
 * <p>
 *   Medium sized link with inline link variant:
 *   <sie-ui-link href="https://www.siemens.com" variant="inline">
 *     Lorem Ipsum One line
 *   </sie-ui-link>. And some more content
 * </p>
 * ```
 */
class UiLinkComponent {
    /**
     * @param disabled Defines if the link is disabled.
     * @default false
     */
    set disabled(disabled) {
        this._disabled = coerceBooleanProperty(disabled);
    }
    get disabled() {
        return this._disabled;
    }
    /** @ignore */
    get validInlineBlock() {
        return this.variant === 'inline';
    }
    /**
     * @param disableVisitedStyle Defines if the links visited style should be disabled.
     * @default false
     */
    set disableVisitedStyle(disableVisitedStyle) {
        this._disableVisitedStyle = coerceBooleanProperty(disableVisitedStyle);
    }
    get disableVisitedStyle() {
        return this._disableVisitedStyle;
    }
    /**
     * @param hasMarginTop Defines if the link should have a margin top set.
     * @default false
     */
    set hasMarginTop(hasMarginTop) {
        this._hasMarginTop = coerceBooleanProperty(hasMarginTop);
    }
    get hasMarginTop() {
        return this._hasMarginTop;
    }
    /**
     * @param offsetIcon Defines if the link's icon should have a negative offset set.
     * @default false
     */
    set offsetIcon(offsetIcon) {
        this._offsetIcon = coerceBooleanProperty(offsetIcon);
    }
    get offsetIcon() {
        return this._offsetIcon;
    }
    /**
     * @param truncate Defines whether the content inside the link should be truncated.
     * @default true
     */
    set truncate(truncate) {
        this._truncate = coerceBooleanProperty(truncate);
    }
    get truncate() {
        return this._truncate;
    }
    /**
     * @param inLinkList Defines if the link is placed within the link list.
     * If so, the padding around the link would be set to a lower value, to appear condensed.
     * @default false
     */
    set inLinkList(inLinkList) {
        this._inLinkList = coerceBooleanProperty(inLinkList);
    }
    get inLinkList() {
        return this._inLinkList;
    }
    /**
     * @param trailingIcon Defines the {@link SieIcon icon} in the trailing position.
     */
    set trailingIcon(trailingIcon) {
        this._trailingIcon = trailingIcon;
        if (trailingIcon) {
            this.iconReg.register(trailingIcon);
        }
    }
    get trailingIcon() {
        return this._trailingIcon;
    }
    /**
     * @param icon Defines which {@link SieIcon icon} should be shown inside the link.
     * If not provided, the `ArrowRight` icon is used by default
     */
    set icon(icon) {
        this._icon = icon;
        if (icon) {
            this.iconReg.register(icon);
        }
    }
    get icon() {
        return this._icon;
    }
    constructor(iconReg) {
        this.iconReg = iconReg;
        /**
         * Sets the custom css class on the anchor element.
         * To add multiple classes provide the string with the whitespace between classes, e.g.: `class-a class-b`.
         * @default ''
         */
        this.cssClass = '';
        /**
         * Defines the {@link LinkSize size} of the link.
         * @default ''
         */
        this.size = '';
        /**
         * Defines where the link should be opened.
         * @default '_self'
         */
        this.target = '_self';
        /**
         * Defines the {@link LinkVariant variation} of the link.
         * @default 'icon-link'
         */
        this.variant = 'icon-link';
        /**
         * Defines on which {@link LinkBackground background} the link is placed.
         * @default 'light'
         */
        this.background = 'light';
        /**
         * Defines the actual {@link LinkType type} of HTML element.
         * @default 'link'
         */
        this.type = 'link';
        /**
         * Sets the browser tooltip value
         */
        this.tooltip = '';
        /**
         * Sets the button type when the link is of type `button`. Possible values submit | reset | button.
         */
        this.buttonType = 'submit';
        /**
         * Event triggered when the link is of type `button` and is clicked.
         */
        this.clicked = new Subject();
        this._disableVisitedStyle = false;
        this._hasMarginTop = false;
        this._offsetIcon = false;
        this._truncate = true;
        this._inLinkList = false;
        this._disabled = false;
    }
    /** @ignore */
    ngOnInit() {
        if (this.variant === 'icon-link' && this.icon === undefined) {
            this.icon = SieIcon.ArrowRight;
        }
    }
    /** Focuses the link. */
    focus() {
        this.link.nativeElement.focus();
    }
    /** @ignore */
    onClick(event) {
        this.clicked.next(event);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiLinkComponent, deps: [{ token: i1.SieIconRegistryService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiLinkComponent, selector: "sie-ui-link", inputs: { disabled: "disabled", disableVisitedStyle: "disableVisitedStyle", hasMarginTop: "hasMarginTop", offsetIcon: "offsetIcon", truncate: "truncate", inLinkList: "inLinkList", trailingIcon: "trailingIcon", icon: "icon", cssClass: "cssClass", href: "href", size: "size", target: "target", variant: "variant", background: "background", type: "type", reference: "reference", screenReaderText: "screenReaderText", secondaryLabel: "secondaryLabel", download: "download", dataAttributes: "dataAttributes", tooltip: "tooltip", buttonType: "buttonType" }, outputs: { clicked: "clicked" }, host: { properties: { "class.disabled": "this.disabled", "class.--inline-block": "this.validInlineBlock" } }, viewQueries: [{ propertyName: "link", first: true, predicate: ["link"], descendants: true }], ngImport: i0, template: "<ng-container *ngIf=\"this.type === 'link'; else buttonLink\">\n  <ng-container *ngIf=\"this.variant === 'icon-link'; else inlineLink\">\n    <a\n      [href]=\"href\"\n      class=\"lib-link\"\n      [ngClass]=\"[\n        'variant-' + variant,\n        'bg-' + background,\n        disableVisitedStyle ? '' : 'visited',\n        disabled ? 'disabled' : '',\n        icon === iconReg.sieIcon.ArrowRight ? 'standard-icon' : 'custom-icon',\n        hasMarginTop ? 'margin-top' : '',\n        offsetIcon ? 'offset-icon' : '',\n        inLinkList ? 'in-link-list' : '',\n        secondaryLabel ? 'two-labels' : '',\n        size,\n        cssClass\n      ]\"\n      [target]=\"target || '_self'\"\n      [tabIndex]=\"disabled ? -1 : 0\"\n      [attr.download]=\"download || null\"\n      (click)=\"onClick($event)\"\n      rel=\"noopener\"\n      #link\n    >\n      <span *ngIf=\"icon\" class=\"link__icon__wrapper\">\n        <sie-icon svgClass=\"link__icon\" [name]=\"icon\"></sie-icon>\n      </span>\n      <ng-container *ngTemplateOutlet=\"screenReaderField\"></ng-container>\n      <ng-container *ngTemplateOutlet=\"contentField\"></ng-container>\n    </a>\n  </ng-container>\n\n  <ng-template #inlineLink>\n    <a\n      [href]=\"href\"\n      class=\"lib-link\"\n      [ngClass]=\"[\n        'variant-' + variant,\n        'bg-' + background,\n        disableVisitedStyle ? '' : 'visited',\n        disabled ? 'disabled' : '',\n        size,\n        cssClass\n      ]\"\n      [target]=\"target || '_self'\"\n      [tabIndex]=\"disabled ? -1 : 0\"\n      [attr.download]=\"download || null\"\n      (click)=\"onClick($event)\"\n      rel=\"noopener\"\n      #link\n    >\n      <ng-container *ngTemplateOutlet=\"screenReaderField\"></ng-container>\n      <ng-container *ngTemplateOutlet=\"contentField\"></ng-container>\n    </a>\n  </ng-template>\n</ng-container>\n\n<ng-template #buttonLink>\n  <button\n    class=\"lib-link button-link\"\n    [ngClass]=\"[\n      'variant-' + variant,\n      'bg-' + background,\n      disableVisitedStyle ? '' : 'visited',\n      disabled ? 'disabled' : '',\n      icon ? 'custom-icon' : 'standard-icon',\n      offsetIcon ? 'offset-icon' : '',\n      secondaryLabel ? 'two-labels' : '',\n      size,\n      cssClass\n    ]\"\n    (click)=\"onClick($event)\"\n    [tabIndex]=\"disabled ? -1 : 0\"\n    [type]=\"buttonType\"\n  >\n    <span *ngIf=\"variant !== 'inline'\" class=\"link__icon__wrapper\">\n      <sie-icon svgClass=\"link__icon\" [name]=\"icon || iconReg.sieIcon.ArrowRight\"></sie-icon>\n    </span>\n    <ng-container *ngTemplateOutlet=\"screenReaderField\"></ng-container>\n    <ng-container *ngTemplateOutlet=\"contentField\"></ng-container>\n  </button>\n</ng-template>\n\n<ng-template #screenReaderField>\n  <span *ngIf=\"screenReaderText && screenReaderText.length > 0\" class=\"visually-hidden\">{{ screenReaderText }}</span>\n</ng-template>\n\n<ng-template #contentField>\n  <div class=\"label-wrapper\">\n    <div\n      class=\"primary-label\"\n      [ngClass]=\"{ truncate: truncate }\"\n      sieCoreAddTooltip\n      [title]=\"tooltip\"\n      sieCoreHighlight\n      [sieCoreAttributes]=\"dataAttributes\"\n      [reference]=\"reference\"\n      [highlightStartOnly]=\"false\"\n    >\n      <ng-content></ng-content>\n      <span class=\"link__icon__wrapper trailing\" *ngIf=\"trailingIcon\">\n        <sie-icon svgClass=\"link__icon\" [name]=\"trailingIcon\"></sie-icon>\n      </span>\n    </div>\n    <ng-container *ngIf=\"secondaryLabel\">\n      <div class=\"secondary-label\" [ngClass]=\"{ truncate: truncate }\">{{ secondaryLabel }}</div>\n    </ng-container>\n  </div>\n</ng-template>\n", styles: [":host .lib-link{outline:none;outline-offset:0}@media (pointer: fine){:host .lib-link{position:relative}:host .lib-link:focus{outline:1px solid #1491eb;outline-offset:2px}:host .lib-link:focus:not(:focus-visible){outline:0}:host .lib-link:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}:host{display:inline-flex;position:relative;width:100%}:host(.--inline-block){display:inline;width:inherit}:host(.disabled){cursor:not-allowed}.lib-link{display:inline-flex;position:relative;max-width:100%;background:none;border:0;cursor:pointer}.lib-link.disabled{pointer-events:none}.lib-link.standard-icon .link__icon,.lib-link.custom-icon .link__icon{position:relative;top:-1px}.lib-link.custom-icon .link__icon__wrapper{position:relative;margin-right:6px}.lib-link.custom-icon .link__icon{width:20px;height:20px;display:flex;align-items:center;fill:currentColor}.lib-link.custom-icon .link__icon svg{fill:currentColor;width:inherit;height:inherit}.lib-link.custom-icon .link__icon svg g{fill:currentColor;width:inherit;height:inherit}.lib-link.custom-icon .link__icon svg text{font-family:Siemens Sans,sans-serif}.lib-link.standard-icon.sm .link__icon{width:20px;height:20px;display:flex;align-items:center;fill:currentColor}.lib-link.standard-icon.sm .link__icon svg{fill:currentColor;width:inherit;height:inherit}.lib-link.standard-icon.sm .link__icon svg g{fill:currentColor;width:inherit;height:inherit}.lib-link.standard-icon.sm .link__icon svg text{font-family:Siemens Sans,sans-serif}.lib-link.standard-icon.xs .link__icon{width:16px;height:16px;display:flex;align-items:center;fill:currentColor}.lib-link.standard-icon.xs .link__icon svg{fill:currentColor;width:inherit;height:inherit}.lib-link.standard-icon.xs .link__icon svg g{fill:currentColor;width:inherit;height:inherit}.lib-link.standard-icon.xs .link__icon svg text{font-family:Siemens Sans,sans-serif}.lib-link.standard-icon.xxs .link__icon{width:14px;height:14px;display:flex;align-items:center;fill:currentColor}.lib-link.standard-icon.xxs .link__icon svg{fill:currentColor;width:inherit;height:inherit}.lib-link.standard-icon.xxs .link__icon svg g{fill:currentColor;width:inherit;height:inherit}.lib-link.standard-icon.xxs .link__icon svg text{font-family:Siemens Sans,sans-serif}.lib-link.nested-list-link,.lib-link.tree-link{font-size:.875rem;line-height:1.25rem}.lib-link.nested-list-link:focus-visible,.lib-link.tree-link:focus-visible{outline-offset:-1px}.lib-link.nested-list-link .link__icon__wrapper,.lib-link.tree-link .link__icon__wrapper{margin-right:4px}.lib-link.nested-list-link .link__icon__wrapper svg,.lib-link.tree-link .link__icon__wrapper svg{width:16px;height:16px;display:flex;align-items:center;fill:currentColor;display:inline-flex}.lib-link.nested-list-link .link__icon__wrapper svg svg,.lib-link.tree-link .link__icon__wrapper svg svg{fill:currentColor;width:inherit;height:inherit}.lib-link.nested-list-link .link__icon__wrapper svg svg g,.lib-link.tree-link .link__icon__wrapper svg svg g{fill:currentColor;width:inherit;height:inherit}.lib-link.nested-list-link .link__icon__wrapper svg svg text,.lib-link.tree-link .link__icon__wrapper svg svg text{font-family:Siemens Sans,sans-serif}@media (pointer: coarse){.lib-link.nested-list-link,.lib-link.tree-link{font-size:1rem;font-weight:400;line-height:1.5rem}.lib-link.nested-list-link .link__icon__wrapper,.lib-link.tree-link .link__icon__wrapper{margin-right:6px}.lib-link.nested-list-link .link__icon__wrapper svg,.lib-link.tree-link .link__icon__wrapper svg{width:20px;height:20px;display:flex;align-items:center;fill:currentColor;display:inline-flex}.lib-link.nested-list-link .link__icon__wrapper svg svg,.lib-link.tree-link .link__icon__wrapper svg svg{fill:currentColor;width:inherit;height:inherit}.lib-link.nested-list-link .link__icon__wrapper svg svg g,.lib-link.tree-link .link__icon__wrapper svg svg g{fill:currentColor;width:inherit;height:inherit}.lib-link.nested-list-link .link__icon__wrapper svg svg text,.lib-link.tree-link .link__icon__wrapper svg svg text{font-family:Siemens Sans,sans-serif}}.lib-link.custom-icon.sm .link__icon__wrapper{margin-right:4px}.lib-link.custom-icon.sm .link__icon{width:16px;height:16px;display:flex;align-items:center;fill:currentColor}.lib-link.custom-icon.sm .link__icon svg{fill:currentColor;width:inherit;height:inherit}.lib-link.custom-icon.sm .link__icon svg g{fill:currentColor;width:inherit;height:inherit}.lib-link.custom-icon.sm .link__icon svg text{font-family:Siemens Sans,sans-serif}.lib-link.custom-icon.xs .link__icon__wrapper{margin-right:4px}.lib-link.custom-icon.xs .link__icon{width:14px;height:14px;display:flex;align-items:center;fill:currentColor}.lib-link.custom-icon.xs .link__icon svg{fill:currentColor;width:inherit;height:inherit}.lib-link.custom-icon.xs .link__icon svg g{fill:currentColor;width:inherit;height:inherit}.lib-link.custom-icon.xs .link__icon svg text{font-family:Siemens Sans,sans-serif}.lib-link.custom-icon.xxs .link__icon__wrapper{margin-right:4px}.lib-link.custom-icon.xxs .link__icon{width:14px;height:14px;display:flex;align-items:center;fill:currentColor}.lib-link.custom-icon.xxs .link__icon svg{fill:currentColor;width:inherit;height:inherit}.lib-link.custom-icon.xxs .link__icon svg g{fill:currentColor;width:inherit;height:inherit}.lib-link.custom-icon.xxs .link__icon svg text{font-family:Siemens Sans,sans-serif}.lib-link.sm{font-size:.875rem;font-weight:400;line-height:1.25rem}.lib-link.xs{font-size:.75rem;font-weight:400;line-height:1rem}.lib-link.xxs{font-size:.6875rem;font-weight:400;line-height:.9375rem}.lib-link.bg-light{color:#007993;fill:#007993}.lib-link.bg-light:active:not(:disabled):not(.hover-disabled),.lib-link.bg-light:hover:not(:disabled):not(.hover-disabled){color:#33747a;fill:#33747a}.lib-link.bg-light.visited:visited{color:#66afbe;fill:#66afbe}.lib-link.bg-light.visited:active:not(:disabled):not(.hover-disabled),.lib-link.bg-light.visited:hover:not(:disabled):not(.hover-disabled){color:#33747a;fill:#33747a}.lib-link.bg-light.visited.disabled,.lib-link.bg-light.disabled{color:#b3b3be;fill:#b3b3be}.lib-link.bg-light.nested-list-link,.lib-link.bg-light.tree-link{color:#000028;fill:#000028}.lib-link.bg-light.nested-list-link:active:not(:disabled):not(.hover-disabled),.lib-link.bg-light.nested-list-link:hover:not(:disabled):not(.hover-disabled),.lib-link.bg-light.tree-link:active:not(:disabled):not(.hover-disabled),.lib-link.bg-light.tree-link:hover:not(:disabled):not(.hover-disabled){color:#005159;fill:#00646e}.lib-link.bg-light.nested-list-link:hover,.lib-link.bg-light.tree-link:hover{color:#005159;fill:#00646e}.lib-link.bg-light.nested-list-link.visited:visited,.lib-link.bg-light.tree-link.visited:visited{color:#000028;fill:#000028}.lib-link.bg-light.nested-list-link.visited:active:not(:disabled):not(.hover-disabled),.lib-link.bg-light.nested-list-link.visited:hover:not(:disabled):not(.hover-disabled),.lib-link.bg-light.tree-link.visited:active:not(:disabled):not(.hover-disabled),.lib-link.bg-light.tree-link.visited:hover:not(:disabled):not(.hover-disabled){color:#005159;fill:#00646e}.lib-link.bg-dark{color:#0cc;fill:#0cc}.lib-link.bg-dark:active:not(:disabled):not(.hover-disabled),.lib-link.bg-dark:hover:not(:disabled):not(.hover-disabled){color:#00ffb9;fill:#00ffb9}.lib-link.bg-dark.visited:visited{color:#0098a6;fill:#0098a6}.lib-link.bg-dark.visited:active:not(:disabled):not(.hover-disabled),.lib-link.bg-dark.visited:hover:not(:disabled):not(.hover-disabled){color:#00ffb9;fill:#00ffb9}.lib-link.bg-dark.visited.disabled,.lib-link.bg-dark.disabled{color:#737389;fill:#737389}.lib-link.bg-dark-alt{color:#fff;fill:#fff;text-decoration:none}.lib-link.bg-dark-alt:active:not(:disabled):not(.hover-disabled),.lib-link.bg-dark-alt:hover:not(:disabled):not(.hover-disabled){color:#00ffb9;fill:#00ffb9}.lib-link.bg-dark-white{color:#fff;fill:#fff}.lib-link.bg-dark-white.visited:visited{color:#ccccd4;fill:#ccccd4}.lib-link.bg-dark-white.visited:active:not(:disabled):not(.hover-disabled),.lib-link.bg-dark-white.visited:hover:not(:disabled):not(.hover-disabled){color:#fff;fill:#fff}.lib-link.bg-dark-white.visited.disabled,.lib-link.bg-dark-white.disabled{color:#737389;fill:#737389}.lib-link.bg-light-neutral:active:not(:disabled):not(.hover-disabled) .primary-label,.lib-link.bg-light-neutral:active:not(:disabled):not(.hover-disabled) .secondary-label,.lib-link.bg-light-neutral:hover:not(:disabled):not(.hover-disabled) .primary-label,.lib-link.bg-light-neutral:hover:not(:disabled):not(.hover-disabled) .secondary-label,.lib-link.bg-dark-neutral:active:not(:disabled):not(.hover-disabled) .primary-label,.lib-link.bg-dark-neutral:active:not(:disabled):not(.hover-disabled) .secondary-label,.lib-link.bg-dark-neutral:hover:not(:disabled):not(.hover-disabled) .primary-label,.lib-link.bg-dark-neutral:hover:not(:disabled):not(.hover-disabled) .secondary-label{text-decoration:underline}.lib-link.bg-light-neutral.visited:visited,.lib-link.bg-dark-neutral.visited:visited{color:#9999a9;fill:#9999a9}.lib-link.bg-light-neutral{color:#737389;fill:#737389}.lib-link.bg-light-neutral:active:not(:disabled):not(.hover-disabled),.lib-link.bg-light-neutral:hover:not(:disabled):not(.hover-disabled){color:#00646e;fill:#00646e}.lib-link.bg-light-neutral.visited.disabled,.lib-link.bg-light-neutral.disabled{color:#b3b3be;fill:#b3b3be}.lib-link.bg-dark-neutral{color:#ccccd4;fill:#ccccd4}.lib-link.bg-dark-neutral:active:not(:disabled):not(.hover-disabled),.lib-link.bg-dark-neutral:hover:not(:disabled):not(.hover-disabled){color:#00ffb9;fill:#00ffb9}.lib-link.bg-dark-neutral.visited.disabled,.lib-link.bg-dark-neutral.disabled{color:#737389;fill:#737389}.lib-link.variant-icon-link{text-decoration:none}.lib-link.variant-icon-link:active:not(:disabled):not(.hover-disabled),.lib-link.variant-icon-link:hover:not(:disabled):not(.hover-disabled){text-decoration:underline}.lib-link.variant-inline{text-decoration:underline}.lib-link.variant-inline.bg-dark-alt{text-decoration:none}.lib-link.two-labels .primary-label{font-weight:700}.lib-link.two-labels .primary-label.truncate{display:-webkit-box;-webkit-box-orient:vertical;-webkit-line-clamp:2;white-space:initial}.lib-link.two-labels .secondary-label{font-size:.875rem;padding-top:2.5px}.lib-link.no-padding{padding:0}.lib-link.auto-width{width:auto}.lib-link.bold{font-weight:700}.lib-link.margin-top{margin-top:10px}.lib-link.margin-top.sm{margin-top:8px}.lib-link.margin-top.xs,.lib-link.margin-top.xxs{margin-top:2px}.lib-link.button-link{text-align:left;padding:0}.lib-link.standard-icon.offset-icon .link__icon,.lib-link.custom-icon.offset-icon .link__icon{margin-left:-8px}.lib-link.in-link-list{padding:3px 0}.lib-link .label-wrapper{min-width:0}.lib-link .link__icon__wrapper.trailing{margin-left:8px;margin-right:0}.truncate{white-space:nowrap;overflow:hidden;text-overflow:ellipsis}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "directive", type: i1$1.HighlightDirective, selector: "[sieCoreHighlight]", inputs: ["reference", "inverted", "highlightStartOnly", "highlightBackgroundColor"] }, { kind: "directive", type: i1$1.AddTooltipDirective, selector: "[sieCoreAddTooltip]" }, { kind: "directive", type: i1$1.AttributeDirective, selector: "[sieCoreAttributes]", inputs: ["sieCoreAttributes"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiLinkComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-link', changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-container *ngIf=\"this.type === 'link'; else buttonLink\">\n  <ng-container *ngIf=\"this.variant === 'icon-link'; else inlineLink\">\n    <a\n      [href]=\"href\"\n      class=\"lib-link\"\n      [ngClass]=\"[\n        'variant-' + variant,\n        'bg-' + background,\n        disableVisitedStyle ? '' : 'visited',\n        disabled ? 'disabled' : '',\n        icon === iconReg.sieIcon.ArrowRight ? 'standard-icon' : 'custom-icon',\n        hasMarginTop ? 'margin-top' : '',\n        offsetIcon ? 'offset-icon' : '',\n        inLinkList ? 'in-link-list' : '',\n        secondaryLabel ? 'two-labels' : '',\n        size,\n        cssClass\n      ]\"\n      [target]=\"target || '_self'\"\n      [tabIndex]=\"disabled ? -1 : 0\"\n      [attr.download]=\"download || null\"\n      (click)=\"onClick($event)\"\n      rel=\"noopener\"\n      #link\n    >\n      <span *ngIf=\"icon\" class=\"link__icon__wrapper\">\n        <sie-icon svgClass=\"link__icon\" [name]=\"icon\"></sie-icon>\n      </span>\n      <ng-container *ngTemplateOutlet=\"screenReaderField\"></ng-container>\n      <ng-container *ngTemplateOutlet=\"contentField\"></ng-container>\n    </a>\n  </ng-container>\n\n  <ng-template #inlineLink>\n    <a\n      [href]=\"href\"\n      class=\"lib-link\"\n      [ngClass]=\"[\n        'variant-' + variant,\n        'bg-' + background,\n        disableVisitedStyle ? '' : 'visited',\n        disabled ? 'disabled' : '',\n        size,\n        cssClass\n      ]\"\n      [target]=\"target || '_self'\"\n      [tabIndex]=\"disabled ? -1 : 0\"\n      [attr.download]=\"download || null\"\n      (click)=\"onClick($event)\"\n      rel=\"noopener\"\n      #link\n    >\n      <ng-container *ngTemplateOutlet=\"screenReaderField\"></ng-container>\n      <ng-container *ngTemplateOutlet=\"contentField\"></ng-container>\n    </a>\n  </ng-template>\n</ng-container>\n\n<ng-template #buttonLink>\n  <button\n    class=\"lib-link button-link\"\n    [ngClass]=\"[\n      'variant-' + variant,\n      'bg-' + background,\n      disableVisitedStyle ? '' : 'visited',\n      disabled ? 'disabled' : '',\n      icon ? 'custom-icon' : 'standard-icon',\n      offsetIcon ? 'offset-icon' : '',\n      secondaryLabel ? 'two-labels' : '',\n      size,\n      cssClass\n    ]\"\n    (click)=\"onClick($event)\"\n    [tabIndex]=\"disabled ? -1 : 0\"\n    [type]=\"buttonType\"\n  >\n    <span *ngIf=\"variant !== 'inline'\" class=\"link__icon__wrapper\">\n      <sie-icon svgClass=\"link__icon\" [name]=\"icon || iconReg.sieIcon.ArrowRight\"></sie-icon>\n    </span>\n    <ng-container *ngTemplateOutlet=\"screenReaderField\"></ng-container>\n    <ng-container *ngTemplateOutlet=\"contentField\"></ng-container>\n  </button>\n</ng-template>\n\n<ng-template #screenReaderField>\n  <span *ngIf=\"screenReaderText && screenReaderText.length > 0\" class=\"visually-hidden\">{{ screenReaderText }}</span>\n</ng-template>\n\n<ng-template #contentField>\n  <div class=\"label-wrapper\">\n    <div\n      class=\"primary-label\"\n      [ngClass]=\"{ truncate: truncate }\"\n      sieCoreAddTooltip\n      [title]=\"tooltip\"\n      sieCoreHighlight\n      [sieCoreAttributes]=\"dataAttributes\"\n      [reference]=\"reference\"\n      [highlightStartOnly]=\"false\"\n    >\n      <ng-content></ng-content>\n      <span class=\"link__icon__wrapper trailing\" *ngIf=\"trailingIcon\">\n        <sie-icon svgClass=\"link__icon\" [name]=\"trailingIcon\"></sie-icon>\n      </span>\n    </div>\n    <ng-container *ngIf=\"secondaryLabel\">\n      <div class=\"secondary-label\" [ngClass]=\"{ truncate: truncate }\">{{ secondaryLabel }}</div>\n    </ng-container>\n  </div>\n</ng-template>\n", styles: [":host .lib-link{outline:none;outline-offset:0}@media (pointer: fine){:host .lib-link{position:relative}:host .lib-link:focus{outline:1px solid #1491eb;outline-offset:2px}:host .lib-link:focus:not(:focus-visible){outline:0}:host .lib-link:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}:host{display:inline-flex;position:relative;width:100%}:host(.--inline-block){display:inline;width:inherit}:host(.disabled){cursor:not-allowed}.lib-link{display:inline-flex;position:relative;max-width:100%;background:none;border:0;cursor:pointer}.lib-link.disabled{pointer-events:none}.lib-link.standard-icon .link__icon,.lib-link.custom-icon .link__icon{position:relative;top:-1px}.lib-link.custom-icon .link__icon__wrapper{position:relative;margin-right:6px}.lib-link.custom-icon .link__icon{width:20px;height:20px;display:flex;align-items:center;fill:currentColor}.lib-link.custom-icon .link__icon svg{fill:currentColor;width:inherit;height:inherit}.lib-link.custom-icon .link__icon svg g{fill:currentColor;width:inherit;height:inherit}.lib-link.custom-icon .link__icon svg text{font-family:Siemens Sans,sans-serif}.lib-link.standard-icon.sm .link__icon{width:20px;height:20px;display:flex;align-items:center;fill:currentColor}.lib-link.standard-icon.sm .link__icon svg{fill:currentColor;width:inherit;height:inherit}.lib-link.standard-icon.sm .link__icon svg g{fill:currentColor;width:inherit;height:inherit}.lib-link.standard-icon.sm .link__icon svg text{font-family:Siemens Sans,sans-serif}.lib-link.standard-icon.xs .link__icon{width:16px;height:16px;display:flex;align-items:center;fill:currentColor}.lib-link.standard-icon.xs .link__icon svg{fill:currentColor;width:inherit;height:inherit}.lib-link.standard-icon.xs .link__icon svg g{fill:currentColor;width:inherit;height:inherit}.lib-link.standard-icon.xs .link__icon svg text{font-family:Siemens Sans,sans-serif}.lib-link.standard-icon.xxs .link__icon{width:14px;height:14px;display:flex;align-items:center;fill:currentColor}.lib-link.standard-icon.xxs .link__icon svg{fill:currentColor;width:inherit;height:inherit}.lib-link.standard-icon.xxs .link__icon svg g{fill:currentColor;width:inherit;height:inherit}.lib-link.standard-icon.xxs .link__icon svg text{font-family:Siemens Sans,sans-serif}.lib-link.nested-list-link,.lib-link.tree-link{font-size:.875rem;line-height:1.25rem}.lib-link.nested-list-link:focus-visible,.lib-link.tree-link:focus-visible{outline-offset:-1px}.lib-link.nested-list-link .link__icon__wrapper,.lib-link.tree-link .link__icon__wrapper{margin-right:4px}.lib-link.nested-list-link .link__icon__wrapper svg,.lib-link.tree-link .link__icon__wrapper svg{width:16px;height:16px;display:flex;align-items:center;fill:currentColor;display:inline-flex}.lib-link.nested-list-link .link__icon__wrapper svg svg,.lib-link.tree-link .link__icon__wrapper svg svg{fill:currentColor;width:inherit;height:inherit}.lib-link.nested-list-link .link__icon__wrapper svg svg g,.lib-link.tree-link .link__icon__wrapper svg svg g{fill:currentColor;width:inherit;height:inherit}.lib-link.nested-list-link .link__icon__wrapper svg svg text,.lib-link.tree-link .link__icon__wrapper svg svg text{font-family:Siemens Sans,sans-serif}@media (pointer: coarse){.lib-link.nested-list-link,.lib-link.tree-link{font-size:1rem;font-weight:400;line-height:1.5rem}.lib-link.nested-list-link .link__icon__wrapper,.lib-link.tree-link .link__icon__wrapper{margin-right:6px}.lib-link.nested-list-link .link__icon__wrapper svg,.lib-link.tree-link .link__icon__wrapper svg{width:20px;height:20px;display:flex;align-items:center;fill:currentColor;display:inline-flex}.lib-link.nested-list-link .link__icon__wrapper svg svg,.lib-link.tree-link .link__icon__wrapper svg svg{fill:currentColor;width:inherit;height:inherit}.lib-link.nested-list-link .link__icon__wrapper svg svg g,.lib-link.tree-link .link__icon__wrapper svg svg g{fill:currentColor;width:inherit;height:inherit}.lib-link.nested-list-link .link__icon__wrapper svg svg text,.lib-link.tree-link .link__icon__wrapper svg svg text{font-family:Siemens Sans,sans-serif}}.lib-link.custom-icon.sm .link__icon__wrapper{margin-right:4px}.lib-link.custom-icon.sm .link__icon{width:16px;height:16px;display:flex;align-items:center;fill:currentColor}.lib-link.custom-icon.sm .link__icon svg{fill:currentColor;width:inherit;height:inherit}.lib-link.custom-icon.sm .link__icon svg g{fill:currentColor;width:inherit;height:inherit}.lib-link.custom-icon.sm .link__icon svg text{font-family:Siemens Sans,sans-serif}.lib-link.custom-icon.xs .link__icon__wrapper{margin-right:4px}.lib-link.custom-icon.xs .link__icon{width:14px;height:14px;display:flex;align-items:center;fill:currentColor}.lib-link.custom-icon.xs .link__icon svg{fill:currentColor;width:inherit;height:inherit}.lib-link.custom-icon.xs .link__icon svg g{fill:currentColor;width:inherit;height:inherit}.lib-link.custom-icon.xs .link__icon svg text{font-family:Siemens Sans,sans-serif}.lib-link.custom-icon.xxs .link__icon__wrapper{margin-right:4px}.lib-link.custom-icon.xxs .link__icon{width:14px;height:14px;display:flex;align-items:center;fill:currentColor}.lib-link.custom-icon.xxs .link__icon svg{fill:currentColor;width:inherit;height:inherit}.lib-link.custom-icon.xxs .link__icon svg g{fill:currentColor;width:inherit;height:inherit}.lib-link.custom-icon.xxs .link__icon svg text{font-family:Siemens Sans,sans-serif}.lib-link.sm{font-size:.875rem;font-weight:400;line-height:1.25rem}.lib-link.xs{font-size:.75rem;font-weight:400;line-height:1rem}.lib-link.xxs{font-size:.6875rem;font-weight:400;line-height:.9375rem}.lib-link.bg-light{color:#007993;fill:#007993}.lib-link.bg-light:active:not(:disabled):not(.hover-disabled),.lib-link.bg-light:hover:not(:disabled):not(.hover-disabled){color:#33747a;fill:#33747a}.lib-link.bg-light.visited:visited{color:#66afbe;fill:#66afbe}.lib-link.bg-light.visited:active:not(:disabled):not(.hover-disabled),.lib-link.bg-light.visited:hover:not(:disabled):not(.hover-disabled){color:#33747a;fill:#33747a}.lib-link.bg-light.visited.disabled,.lib-link.bg-light.disabled{color:#b3b3be;fill:#b3b3be}.lib-link.bg-light.nested-list-link,.lib-link.bg-light.tree-link{color:#000028;fill:#000028}.lib-link.bg-light.nested-list-link:active:not(:disabled):not(.hover-disabled),.lib-link.bg-light.nested-list-link:hover:not(:disabled):not(.hover-disabled),.lib-link.bg-light.tree-link:active:not(:disabled):not(.hover-disabled),.lib-link.bg-light.tree-link:hover:not(:disabled):not(.hover-disabled){color:#005159;fill:#00646e}.lib-link.bg-light.nested-list-link:hover,.lib-link.bg-light.tree-link:hover{color:#005159;fill:#00646e}.lib-link.bg-light.nested-list-link.visited:visited,.lib-link.bg-light.tree-link.visited:visited{color:#000028;fill:#000028}.lib-link.bg-light.nested-list-link.visited:active:not(:disabled):not(.hover-disabled),.lib-link.bg-light.nested-list-link.visited:hover:not(:disabled):not(.hover-disabled),.lib-link.bg-light.tree-link.visited:active:not(:disabled):not(.hover-disabled),.lib-link.bg-light.tree-link.visited:hover:not(:disabled):not(.hover-disabled){color:#005159;fill:#00646e}.lib-link.bg-dark{color:#0cc;fill:#0cc}.lib-link.bg-dark:active:not(:disabled):not(.hover-disabled),.lib-link.bg-dark:hover:not(:disabled):not(.hover-disabled){color:#00ffb9;fill:#00ffb9}.lib-link.bg-dark.visited:visited{color:#0098a6;fill:#0098a6}.lib-link.bg-dark.visited:active:not(:disabled):not(.hover-disabled),.lib-link.bg-dark.visited:hover:not(:disabled):not(.hover-disabled){color:#00ffb9;fill:#00ffb9}.lib-link.bg-dark.visited.disabled,.lib-link.bg-dark.disabled{color:#737389;fill:#737389}.lib-link.bg-dark-alt{color:#fff;fill:#fff;text-decoration:none}.lib-link.bg-dark-alt:active:not(:disabled):not(.hover-disabled),.lib-link.bg-dark-alt:hover:not(:disabled):not(.hover-disabled){color:#00ffb9;fill:#00ffb9}.lib-link.bg-dark-white{color:#fff;fill:#fff}.lib-link.bg-dark-white.visited:visited{color:#ccccd4;fill:#ccccd4}.lib-link.bg-dark-white.visited:active:not(:disabled):not(.hover-disabled),.lib-link.bg-dark-white.visited:hover:not(:disabled):not(.hover-disabled){color:#fff;fill:#fff}.lib-link.bg-dark-white.visited.disabled,.lib-link.bg-dark-white.disabled{color:#737389;fill:#737389}.lib-link.bg-light-neutral:active:not(:disabled):not(.hover-disabled) .primary-label,.lib-link.bg-light-neutral:active:not(:disabled):not(.hover-disabled) .secondary-label,.lib-link.bg-light-neutral:hover:not(:disabled):not(.hover-disabled) .primary-label,.lib-link.bg-light-neutral:hover:not(:disabled):not(.hover-disabled) .secondary-label,.lib-link.bg-dark-neutral:active:not(:disabled):not(.hover-disabled) .primary-label,.lib-link.bg-dark-neutral:active:not(:disabled):not(.hover-disabled) .secondary-label,.lib-link.bg-dark-neutral:hover:not(:disabled):not(.hover-disabled) .primary-label,.lib-link.bg-dark-neutral:hover:not(:disabled):not(.hover-disabled) .secondary-label{text-decoration:underline}.lib-link.bg-light-neutral.visited:visited,.lib-link.bg-dark-neutral.visited:visited{color:#9999a9;fill:#9999a9}.lib-link.bg-light-neutral{color:#737389;fill:#737389}.lib-link.bg-light-neutral:active:not(:disabled):not(.hover-disabled),.lib-link.bg-light-neutral:hover:not(:disabled):not(.hover-disabled){color:#00646e;fill:#00646e}.lib-link.bg-light-neutral.visited.disabled,.lib-link.bg-light-neutral.disabled{color:#b3b3be;fill:#b3b3be}.lib-link.bg-dark-neutral{color:#ccccd4;fill:#ccccd4}.lib-link.bg-dark-neutral:active:not(:disabled):not(.hover-disabled),.lib-link.bg-dark-neutral:hover:not(:disabled):not(.hover-disabled){color:#00ffb9;fill:#00ffb9}.lib-link.bg-dark-neutral.visited.disabled,.lib-link.bg-dark-neutral.disabled{color:#737389;fill:#737389}.lib-link.variant-icon-link{text-decoration:none}.lib-link.variant-icon-link:active:not(:disabled):not(.hover-disabled),.lib-link.variant-icon-link:hover:not(:disabled):not(.hover-disabled){text-decoration:underline}.lib-link.variant-inline{text-decoration:underline}.lib-link.variant-inline.bg-dark-alt{text-decoration:none}.lib-link.two-labels .primary-label{font-weight:700}.lib-link.two-labels .primary-label.truncate{display:-webkit-box;-webkit-box-orient:vertical;-webkit-line-clamp:2;white-space:initial}.lib-link.two-labels .secondary-label{font-size:.875rem;padding-top:2.5px}.lib-link.no-padding{padding:0}.lib-link.auto-width{width:auto}.lib-link.bold{font-weight:700}.lib-link.margin-top{margin-top:10px}.lib-link.margin-top.sm{margin-top:8px}.lib-link.margin-top.xs,.lib-link.margin-top.xxs{margin-top:2px}.lib-link.button-link{text-align:left;padding:0}.lib-link.standard-icon.offset-icon .link__icon,.lib-link.custom-icon.offset-icon .link__icon{margin-left:-8px}.lib-link.in-link-list{padding:3px 0}.lib-link .label-wrapper{min-width:0}.lib-link .link__icon__wrapper.trailing{margin-left:8px;margin-right:0}.truncate{white-space:nowrap;overflow:hidden;text-overflow:ellipsis}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }]; }, propDecorators: { link: [{
                type: ViewChild,
                args: ['link']
            }], disabled: [{
                type: HostBinding,
                args: ['class.disabled']
            }, {
                type: Input
            }], validInlineBlock: [{
                type: HostBinding,
                args: ['class.--inline-block']
            }], disableVisitedStyle: [{
                type: Input
            }], hasMarginTop: [{
                type: Input
            }], offsetIcon: [{
                type: Input
            }], truncate: [{
                type: Input
            }], inLinkList: [{
                type: Input
            }], trailingIcon: [{
                type: Input
            }], icon: [{
                type: Input
            }], cssClass: [{
                type: Input
            }], href: [{
                type: Input
            }], size: [{
                type: Input
            }], target: [{
                type: Input
            }], variant: [{
                type: Input
            }], background: [{
                type: Input
            }], type: [{
                type: Input
            }], reference: [{
                type: Input
            }], screenReaderText: [{
                type: Input
            }], secondaryLabel: [{
                type: Input
            }], download: [{
                type: Input
            }], dataAttributes: [{
                type: Input
            }], tooltip: [{
                type: Input
            }], buttonType: [{
                type: Input
            }], clicked: [{
                type: Output
            }] } });

class UiContactComponent {
    constructor() {
        this._contactData = [];
    }
    set contactData(data) {
        this._contactData = data;
    }
    get contactData() {
        return this._contactData;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiContactComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiContactComponent, selector: "sie-ui-contact", inputs: { contactData: "contactData", contentDescription: "contentDescription" }, viewQueries: [{ propertyName: "accordionComponent", first: true, predicate: ["accordionComponent"], descendants: true }], ngImport: i0, template: "<div class=\"contact-content\">\n  <p *ngIf=\"contentDescription\" class=\"contact-content-description\">\n    {{ contentDescription }}\n  </p>\n  <sie-ui-accordion #accordionComponent>\n    <ng-template\n      sieUiAccordionItem\n      *ngFor=\"let contact of contactData\"\n      [headline]=\"contact.title\"\n      [id]=\"contact.id\"\n      [open]=\"contact.open\"\n    >\n      <div *ngFor=\"let item of contact.content; let index = index\" class=\"contact-content-item\">\n        <h5 *ngIf=\"item.type === 'bold' && item.text !== ''\" class=\"contact-content-item-title\">\n          {{ item.text }}\n        </h5>\n        <p *ngIf=\"item.type === 'normal' && item.text !== ''\" class=\"contact-content-item-description\">\n          {{ item.text }}\n        </p>\n        <sie-ui-link\n          *ngIf=\"item.type === 'link' && item.url !== '' && item.text !== ''\"\n          [icon]=\"item.icon\"\n          [href]=\"item.url\"\n          [target]=\"item.target\"\n          cssClass=\"contact-link\"\n        >\n          {{ item.text }}\n        </sie-ui-link>\n        <h5\n          *ngIf=\"item.type === 'name' && item.text !== ''\"\n          [class.first]=\"index === 1\"\n          class=\"contact-content-item-name\"\n        >\n          {{ item.text }}\n        </h5>\n      </div>\n    </ng-template>\n  </sie-ui-accordion>\n</div>\n", styles: [".contact-content{margin-top:24px;padding-bottom:56px}.contact-content-description{margin-bottom:20px}.contact-content-item-title{margin:24px 0 8px}.contact-content-item-description{margin-bottom:8px}.contact-content-item-name{display:inline-block;margin:24px 0 0}.contact-content-item-name.first{margin-top:16px}.contact-content-item:first-child .contact-content-item-title{margin-top:0}.contact-content-item ::ng-deep .contact-link{padding:4px 0}\n"], dependencies: [{ kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: UiAccordionComponent, selector: "sie-ui-accordion", inputs: ["removeItems", "removeItemAt", "toggleItemAt", "newItem", "updateItem"], outputs: ["expandedChange"] }, { kind: "directive", type: UiAccordionItemDirective, selector: "[sieUiAccordionItem]", inputs: ["headline", "subHeadline", "id", "showTopBorder", "headlineBold", "icon", "open"] }, { kind: "component", type: UiLinkComponent, selector: "sie-ui-link", inputs: ["disabled", "disableVisitedStyle", "hasMarginTop", "offsetIcon", "truncate", "inLinkList", "trailingIcon", "icon", "cssClass", "href", "size", "target", "variant", "background", "type", "reference", "screenReaderText", "secondaryLabel", "download", "dataAttributes", "tooltip", "buttonType"], outputs: ["clicked"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiContactComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-contact', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"contact-content\">\n  <p *ngIf=\"contentDescription\" class=\"contact-content-description\">\n    {{ contentDescription }}\n  </p>\n  <sie-ui-accordion #accordionComponent>\n    <ng-template\n      sieUiAccordionItem\n      *ngFor=\"let contact of contactData\"\n      [headline]=\"contact.title\"\n      [id]=\"contact.id\"\n      [open]=\"contact.open\"\n    >\n      <div *ngFor=\"let item of contact.content; let index = index\" class=\"contact-content-item\">\n        <h5 *ngIf=\"item.type === 'bold' && item.text !== ''\" class=\"contact-content-item-title\">\n          {{ item.text }}\n        </h5>\n        <p *ngIf=\"item.type === 'normal' && item.text !== ''\" class=\"contact-content-item-description\">\n          {{ item.text }}\n        </p>\n        <sie-ui-link\n          *ngIf=\"item.type === 'link' && item.url !== '' && item.text !== ''\"\n          [icon]=\"item.icon\"\n          [href]=\"item.url\"\n          [target]=\"item.target\"\n          cssClass=\"contact-link\"\n        >\n          {{ item.text }}\n        </sie-ui-link>\n        <h5\n          *ngIf=\"item.type === 'name' && item.text !== ''\"\n          [class.first]=\"index === 1\"\n          class=\"contact-content-item-name\"\n        >\n          {{ item.text }}\n        </h5>\n      </div>\n    </ng-template>\n  </sie-ui-accordion>\n</div>\n", styles: [".contact-content{margin-top:24px;padding-bottom:56px}.contact-content-description{margin-bottom:20px}.contact-content-item-title{margin:24px 0 8px}.contact-content-item-description{margin-bottom:8px}.contact-content-item-name{display:inline-block;margin:24px 0 0}.contact-content-item-name.first{margin-top:16px}.contact-content-item:first-child .contact-content-item-title{margin-top:0}.contact-content-item ::ng-deep .contact-link{padding:4px 0}\n"] }]
        }], propDecorators: { accordionComponent: [{
                type: ViewChild,
                args: ['accordionComponent']
            }], contactData: [{
                type: Input
            }], contentDescription: [{
                type: Input
            }] } });

/**
 * # Link Module
 * - {@link UiLinkComponent}
 *
 * ## Module peer dependencies
 * - {@link SieIconsModule}
 */
class UiLinkModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiLinkModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiLinkModule, declarations: [UiLinkComponent], imports: [CommonModule, SieIconsModule, HighlightModule, AddTooltipModule, AttributeModule], exports: [UiLinkComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiLinkModule, imports: [CommonModule, SieIconsModule, HighlightModule, AddTooltipModule, AttributeModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiLinkModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiLinkComponent],
                    imports: [CommonModule, SieIconsModule, HighlightModule, AddTooltipModule, AttributeModule],
                    exports: [UiLinkComponent]
                }]
        }] });

class UiContactModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiContactModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiContactModule, declarations: [UiContactComponent], imports: [CommonModule, SieIconsModule, UiAccordionModule, UiLinkModule], exports: [UiContactComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiContactModule, imports: [CommonModule, SieIconsModule, UiAccordionModule, UiLinkModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiContactModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiContactComponent],
                    imports: [CommonModule, SieIconsModule, UiAccordionModule, UiLinkModule],
                    exports: [UiContactComponent]
                }]
        }] });

class UiScrollData {
    constructor(scrollObject) {
        Object.assign(this, scrollObject);
    }
}
var UiScrollDirection;
(function (UiScrollDirection) {
    UiScrollDirection[UiScrollDirection["Up"] = 0] = "Up";
    UiScrollDirection[UiScrollDirection["Down"] = 1] = "Down";
})(UiScrollDirection || (UiScrollDirection = {}));

class UiScrollableComponent {
    constructor(elementRef) {
        this.elementRef = elementRef;
        this.padding = '0';
        this.scrolled = new Subject();
        this.previousScrollTop = 0;
    }
    onScroll(event) {
        const target = event.target;
        const currentScrollTop = target.scrollTop;
        this.scrolled.next(new UiScrollData({
            direction: currentScrollTop > this.previousScrollTop ? UiScrollDirection.Down : UiScrollDirection.Up,
            scrollTop: currentScrollTop,
            previousScrollTop: this.previousScrollTop,
            scrollHeight: target.scrollHeight
        }));
        this.previousScrollTop = currentScrollTop;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiScrollableComponent, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiScrollableComponent, selector: "sie-ui-scrollable", inputs: { padding: "padding" }, outputs: { scrolled: "scrolled" }, host: { listeners: { "scroll": "onScroll($event)" }, properties: { "style.padding": "this.padding" } }, ngImport: i0, template: "<ng-content></ng-content>\n", styles: [":host{display:flex;flex-direction:column;overflow-y:auto}\n"], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiScrollableComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-scrollable', changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>\n", styles: [":host{display:flex;flex-direction:column;overflow-y:auto}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; }, propDecorators: { padding: [{
                type: HostBinding,
                args: ['style.padding']
            }, {
                type: Input
            }], scrolled: [{
                type: Output
            }], onScroll: [{
                type: HostListener,
                args: ['scroll', ['$event']]
            }] } });

class UiScrollableModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiScrollableModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiScrollableModule, declarations: [UiScrollableComponent], imports: [CommonModule], exports: [UiScrollableComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiScrollableModule, imports: [CommonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiScrollableModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiScrollableComponent],
                    imports: [CommonModule],
                    exports: [UiScrollableComponent]
                }]
        }] });

/**
 * Possible headline animations during scrolling
 */
var UiDrawerAnimationType;
(function (UiDrawerAnimationType) {
    /**
     * The headline is moved a bit up during scrolling
     */
    UiDrawerAnimationType["Transform"] = "transform";
    /**
     * The headline becomes invisible during scrolling
     */
    UiDrawerAnimationType["Opacity"] = "opacity";
})(UiDrawerAnimationType || (UiDrawerAnimationType = {}));

const DrawerWidthCssVariable = '--drawer-width';
/**
 * # Drawer component
 *
 * Provide temporary access to contents on-demand which go beyond current page content.
 *
 * ## Component variations
 *
 * There are two scrolling animations on the drawer headline:
 * - transform
 * - opacity
 *
 * ## Content
 *
 * The content of the drawer component can be any valid markup.
 *
 * ## Code example
 * @example
 * Template:
 * ```html
 * <sie-ui-drawer (opening)="contactDrawerOpening()" (closed)="contactDrawerClosed()" [headline]="'Find your contact'">
 *   <!-- Add content here that you want to keep in the drawer -->
 * </sie-ui-drawer>
 * <button (click)="openContactDrawer()">Open Contact Drawer</button>
 * ```
 *
 * Component code:
 * ```ts
 * @Component(...)
 * export class HeaderComponent {
 *   @ViewChild(UiDrawerComponent) contactDrawer: UiDrawerComponent;
 *
 *   contactDrawerOpening(): void {
 *     console.log('Drawer is about to be opened');
 *   }
 *
 *   contactDrawerClosed(): void {
 *     console.log('Contact drawer was closed');
 *   }
 *
 *   openContactDrawer(): void {
 *     this.contactDrawer.open();
 *   }
 * }
 * ```
 */
class UiDrawerComponent {
    constructor(document, cdr, layoutService, iconReg, elementRef) {
        this.document = document;
        this.cdr = cdr;
        this.layoutService = layoutService;
        this.iconReg = iconReg;
        this.elementRef = elementRef;
        /**
         * Type of {@link UiDrawerAnimationType scrolling animation} for the headline
         * @default 'transform'
         */
        this.headlineAnimationType = UiDrawerAnimationType.Transform;
        /**
         * Event triggered when the drawer starts opening
         */
        this.opening = new Subject();
        /**
         * Event triggered when the drawer is opened
         */
        this.opened = new Subject();
        /**
         * Event when the drawer starts closing
         */
        this.closing = new Subject();
        /**
         * Event when the drawer is closed
         */
        this.closed = new Subject();
        /** @ignore */
        this.uiDrawerAnimationType = UiDrawerAnimationType;
        /** @ignore */
        this.contentPadding = '0 16px';
        this.headlineAnimationDistance = 31;
        this.headlineShadowOpacityMax = 0.2;
        this.headlineOpacityRange = new RangeRatio(0, this.headlineAnimationDistance, 0, 1);
        this.headlineShadowOpacityRange = new RangeRatio(0, this.headlineAnimationDistance, 0, this.headlineShadowOpacityMax);
        this.headerShadowOpacity = 0;
        this.isCloseable = true;
        this._isOpen = false;
        this._isAnimating = false;
        this.handlerCombiner = new HandlerCombiner(2, () => (this._isAnimating = false));
        this.subscriptions = new Subscription();
        this._isScrolled = false;
        this._headlineOpacity = 0;
        this._headlineTranslate = this.headlineAnimationDistance;
        this.iconReg.register(SieIcon.Close);
    }
    /**
     * Readonly property containing information if the drawer is open
     */
    get isOpen() {
        return this._isOpen;
    }
    /**
     * Readonly property containing information if the drawer is currently animating
     */
    get isAnimating() {
        return this._isAnimating;
    }
    /**
     * Readonly property containing information if the drawer is "scrolled" (not scroll top)
     */
    get isScrolled() {
        return this._isScrolled;
    }
    /**
     * Readonly property containing information if the drawer's headline is transparent
     */
    get headlineOpacity() {
        return this._headlineOpacity;
    }
    /** @ignore */
    get headlineTranslate() {
        return `translateY(${this._headlineTranslate}px)`;
    }
    /** @ignore */
    get headerShadow() {
        return `0 5px 6px 0 rgba(10, 20, 25, ${this.headerShadowOpacity})`;
    }
    /** @ignore */
    ngOnInit() {
        this.subscribeToCombinerReset();
        this.subscribeToScreenResize();
    }
    /** @ignore */
    ngOnDestroy() {
        if (this.onCombinerResetSub) {
            this.onCombinerResetSub.unsubscribe();
        }
        this.subscriptions.unsubscribe();
        this.optionsSubscriptions?.unsubscribe();
    }
    /**
     * Opens the drawer
     */
    open(options) {
        this.handleOptions(options);
        this.opening.next();
        this.setState(true);
        this.subscribeToEscapeKeyDown();
        this.closeButton.focusButton();
    }
    /**
     * Closes the drawer
     */
    close() {
        if (this.isOpen && this.isCloseable) {
            this.optionsSubscriptions?.unsubscribe();
            this.optionsSubscriptions = null;
            this.closing.next();
            this.setState(false);
            this.escapeKeyDownSub.unsubscribe();
            this.resetToDefaults();
        }
    }
    /**
     * Toggles the drawer
     */
    toggle() {
        if (this.isOpen) {
            this.close();
        }
        else {
            this.open();
        }
    }
    /** @ignore */
    onAnimationEnd() {
        this.handlerCombiner.call();
    }
    /** @ignore */
    onScroll(scrollData) {
        if (this.isOpen) {
            this._isScrolled = scrollData.scrollTop !== 0;
            if (scrollData.scrollTop < this.headlineAnimationDistance) {
                this._headlineOpacity = this.headlineOpacityRange.getForRef(scrollData.scrollTop);
                this.headerShadowOpacity = this.headlineShadowOpacityRange.getForRef(scrollData.scrollTop);
                this._headlineTranslate = this.headlineAnimationDistance - scrollData.scrollTop;
            }
            else {
                this._headlineOpacity = 1;
                this.headerShadowOpacity = this.headlineShadowOpacityMax;
                this._headlineTranslate = 0;
            }
        }
    }
    setState(isOpen) {
        this._isOpen = isOpen;
        this._isAnimating = true;
        this.cdr.detectChanges();
    }
    subscribeToCombinerReset() {
        this.onCombinerResetSub = this.handlerCombiner.onReset.subscribe(() => {
            this.emitStateChangeFinished();
        });
    }
    subscribeToEscapeKeyDown() {
        this.escapeKeyDownSub = fromEvent(this.document, 'keydown').subscribe((keyboardEvent) => {
            if (KeyboardEventUtil.is(keyboardEvent.key).equalToKey(KeyboardKey.Escape)) {
                this.close();
            }
        });
    }
    emitStateChangeFinished() {
        if (this.isOpen) {
            this.opened.next();
            this.scrollbarExists();
        }
        else {
            this.closed.next();
        }
    }
    resetToDefaults() {
        this._headlineOpacity = 0;
        this.headerShadowOpacity = 0;
        this._headlineTranslate = this.headlineAnimationDistance;
    }
    subscribeToScreenResize() {
        this.subscriptions.add(this.layoutService.resizeEvent.subscribe(() => {
            this.scrollbarExists();
        }));
    }
    scrollbarExists() {
        const scrollbarExists = this.scrollableContent?.elementRef.nativeElement.scrollHeight >
            this.scrollableContent?.elementRef.nativeElement.clientHeight;
        if (scrollbarExists) {
            this.contentPadding = '0 1px 0 16px';
        }
        else {
            this.contentPadding = '0 16px';
        }
        this.cdr.markForCheck();
    }
    handleOptions(options) {
        const element = this.elementRef.nativeElement;
        element.style.removeProperty(DrawerWidthCssVariable); // reset variables here to avoid component "jumping"
        if (!options) {
            return;
        }
        this.optionsSubscriptions = new Subscription();
        if (!!options.width) {
            element.style.setProperty(DrawerWidthCssVariable, options.width);
        }
        this.subscribeToOption(options.width$, width => element.style.setProperty(DrawerWidthCssVariable, width));
        this.subscribeToOption(options.closable$, value => (this.isCloseable = value));
    }
    subscribeToOption(observable, callback) {
        if (!!observable) {
            this.optionsSubscriptions.add(observable.subscribe(callback));
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDrawerComponent, deps: [{ token: DOCUMENT }, { token: i0.ChangeDetectorRef }, { token: i1$1.LayoutService }, { token: i1.SieIconRegistryService }, { token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiDrawerComponent, selector: "sie-ui-drawer", inputs: { headlineAnimationType: "headlineAnimationType", headline: "headline" }, outputs: { opening: "opening", opened: "opened", closing: "closing", closed: "closed" }, viewQueries: [{ propertyName: "closeButton", first: true, predicate: ["closeButton"], descendants: true }, { propertyName: "scrollableContent", first: true, predicate: ["scrollableContent"], descendants: true }], ngImport: i0, template: "<div class=\"drawer\" [ngClass]=\"{ open: isOpen, 'drawer--visible': isOpen || isAnimating }\">\n  <div class=\"drawer__backdrop\" (animationend)=\"onAnimationEnd()\" (click)=\"close()\"></div>\n  <div *ngIf=\"isOpen || isAnimating\" class=\"drawer__content\" (animationend)=\"onAnimationEnd()\" cdkTrapFocus>\n    <div class=\"drawer__close-btn\">\n      <sie-ui-button\n        themeType=\"icon\"\n        variant=\"icon-un-contained\"\n        background=\"light\"\n        [icon]=\"iconReg.sieIcon.Close\"\n        (clicked)=\"close()\"\n        #closeButton\n      ></sie-ui-button>\n    </div>\n    <header\n      *ngIf=\"headline\"\n      class=\"drawer__header\"\n      [ngClass]=\"{ 'is-scrolled': isScrolled }\"\n      [ngStyle]=\"{ 'box-shadow': headerShadow }\"\n    >\n      <h5\n        class=\"drawer__title\"\n        *ngIf=\"headlineAnimationType === uiDrawerAnimationType.Transform\"\n        [ngStyle]=\"{ transform: headlineTranslate }\"\n        sieCoreAddTruncationAndTooltip\n      >\n        {{ headline }}\n      </h5>\n      <h5\n        *ngIf=\"headlineAnimationType === uiDrawerAnimationType.Opacity\"\n        [ngStyle]=\"{ opacity: headlineOpacity }\"\n        sieCoreAddTruncationAndTooltip\n      >\n        {{ headline }}\n      </h5>\n    </header>\n    <sie-ui-scrollable\n      class=\"drawer__scrollable\"\n      (scrolled)=\"onScroll($event)\"\n      [padding]=\"contentPadding\"\n      #scrollableContent\n    >\n      <h5 *ngIf=\"headline\" aria-hidden=\"true\" class=\"drawer__headline\" sieCoreAddTruncationAndTooltip>\n        {{ headline }}\n      </h5>\n      <ng-content></ng-content>\n    </sie-ui-scrollable>\n    <ng-content select=\"[slot=drawer-footer-content]\"></ng-content>\n  </div>\n</div>\n", styles: ["::-webkit-scrollbar-thumb{background-clip:padding-box;background-color:#737389}::-webkit-scrollbar-button{display:none}::-webkit-scrollbar-corner{background-color:transparent}::-webkit-scrollbar{width:16px;height:8px}:host{scrollbar-color:#737389 #fff}:host .dark,:host.dark{scrollbar-color:#ccccd4 #000028}::-webkit-scrollbar-thumb:vertical{border-left:8px solid transparent;border-right:4px solid transparent}::-webkit-scrollbar-thumb:horizontal{border-top:4px solid transparent}::-webkit-scrollbar-track:vertical{border-left:8px solid #fff;background:#ccccd4;border-right:4px solid #fff}::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #ccccd4}.dark::-webkit-scrollbar-thumb,.dark ::-webkit-scrollbar-thumb{background-color:#ccccd4}.dark::-webkit-scrollbar-track:vertical,.dark ::-webkit-scrollbar-track:vertical{background:#737389;border-right:4px solid #000028;border-left:8px solid #000028}.dark::-webkit-scrollbar-track:horizontal,.dark ::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #737389}.drawer{inset:0;position:fixed;height:0;visibility:hidden;z-index:999}.drawer--visible{height:auto;visibility:visible}.drawer__backdrop{inset:0;position:absolute;background-color:transparent;animation-name:hide-backdrop;animation-duration:.3s;animation-timing-function:linear}.open .drawer__backdrop{background-color:#0009;animation-name:show-backdrop;animation-duration:.3s;animation-timing-function:linear}.drawer__header{height:48px;padding:15px 16px 0}.drawer__title{max-width:280px}@media (min-width: 640px){.drawer__title{max-width:560px}}@media (min-width: 1024px){.drawer__title{max-width:528px}}.drawer__content{position:absolute;display:flex;flex-direction:column;top:0;right:0;bottom:0;width:var(--drawer-width, 360px);background-color:#fff;box-shadow:-2px 0 2px #0000000f,-4px 0 8px #0000001f;transform:translate(100%);animation-name:slide-out-drawer;animation-duration:.32s;animation-timing-function:cubic-bezier(.4,0,1,1)}.open .drawer__content{transform:translate(0);animation-name:slide-in-drawer;animation-duration:.32s;animation-timing-function:cubic-bezier(0,0,.3,1)}.drawer__scrollable{flex:1}.drawer__close-btn{position:absolute;top:2px;right:7px;z-index:1}.drawer__headline{line-height:20px;margin-bottom:8px;max-width:280px}@keyframes show-backdrop{0%{background-color:transparent}to{background-color:#0009}}@keyframes hide-backdrop{0%{background-color:#0009}to{background-color:transparent}}@keyframes slide-in-drawer{0%{transform:translate(100%)}to{transform:translate(0)}}@keyframes slide-out-drawer{0%{transform:translate(0)}to{transform:translate(100%)}}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "component", type: UiButtonComponent, selector: "sie-ui-button" }, { kind: "component", type: UiScrollableComponent, selector: "sie-ui-scrollable", inputs: ["padding"], outputs: ["scrolled"] }, { kind: "directive", type: i6.CdkTrapFocus, selector: "[cdkTrapFocus]", inputs: ["cdkTrapFocus", "cdkTrapFocusAutoCapture"], exportAs: ["cdkTrapFocus"] }, { kind: "directive", type: i1$1.AddTruncationAndTooltipDirective, selector: "[sieCoreAddTruncationAndTooltip]", inputs: ["maxNumberOfLinesToShow"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
__decorate([
    RunInZone
], UiDrawerComponent.prototype, "open", null);
__decorate([
    RunInZone
], UiDrawerComponent.prototype, "close", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDrawerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-drawer', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"drawer\" [ngClass]=\"{ open: isOpen, 'drawer--visible': isOpen || isAnimating }\">\n  <div class=\"drawer__backdrop\" (animationend)=\"onAnimationEnd()\" (click)=\"close()\"></div>\n  <div *ngIf=\"isOpen || isAnimating\" class=\"drawer__content\" (animationend)=\"onAnimationEnd()\" cdkTrapFocus>\n    <div class=\"drawer__close-btn\">\n      <sie-ui-button\n        themeType=\"icon\"\n        variant=\"icon-un-contained\"\n        background=\"light\"\n        [icon]=\"iconReg.sieIcon.Close\"\n        (clicked)=\"close()\"\n        #closeButton\n      ></sie-ui-button>\n    </div>\n    <header\n      *ngIf=\"headline\"\n      class=\"drawer__header\"\n      [ngClass]=\"{ 'is-scrolled': isScrolled }\"\n      [ngStyle]=\"{ 'box-shadow': headerShadow }\"\n    >\n      <h5\n        class=\"drawer__title\"\n        *ngIf=\"headlineAnimationType === uiDrawerAnimationType.Transform\"\n        [ngStyle]=\"{ transform: headlineTranslate }\"\n        sieCoreAddTruncationAndTooltip\n      >\n        {{ headline }}\n      </h5>\n      <h5\n        *ngIf=\"headlineAnimationType === uiDrawerAnimationType.Opacity\"\n        [ngStyle]=\"{ opacity: headlineOpacity }\"\n        sieCoreAddTruncationAndTooltip\n      >\n        {{ headline }}\n      </h5>\n    </header>\n    <sie-ui-scrollable\n      class=\"drawer__scrollable\"\n      (scrolled)=\"onScroll($event)\"\n      [padding]=\"contentPadding\"\n      #scrollableContent\n    >\n      <h5 *ngIf=\"headline\" aria-hidden=\"true\" class=\"drawer__headline\" sieCoreAddTruncationAndTooltip>\n        {{ headline }}\n      </h5>\n      <ng-content></ng-content>\n    </sie-ui-scrollable>\n    <ng-content select=\"[slot=drawer-footer-content]\"></ng-content>\n  </div>\n</div>\n", styles: ["::-webkit-scrollbar-thumb{background-clip:padding-box;background-color:#737389}::-webkit-scrollbar-button{display:none}::-webkit-scrollbar-corner{background-color:transparent}::-webkit-scrollbar{width:16px;height:8px}:host{scrollbar-color:#737389 #fff}:host .dark,:host.dark{scrollbar-color:#ccccd4 #000028}::-webkit-scrollbar-thumb:vertical{border-left:8px solid transparent;border-right:4px solid transparent}::-webkit-scrollbar-thumb:horizontal{border-top:4px solid transparent}::-webkit-scrollbar-track:vertical{border-left:8px solid #fff;background:#ccccd4;border-right:4px solid #fff}::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #ccccd4}.dark::-webkit-scrollbar-thumb,.dark ::-webkit-scrollbar-thumb{background-color:#ccccd4}.dark::-webkit-scrollbar-track:vertical,.dark ::-webkit-scrollbar-track:vertical{background:#737389;border-right:4px solid #000028;border-left:8px solid #000028}.dark::-webkit-scrollbar-track:horizontal,.dark ::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #737389}.drawer{inset:0;position:fixed;height:0;visibility:hidden;z-index:999}.drawer--visible{height:auto;visibility:visible}.drawer__backdrop{inset:0;position:absolute;background-color:transparent;animation-name:hide-backdrop;animation-duration:.3s;animation-timing-function:linear}.open .drawer__backdrop{background-color:#0009;animation-name:show-backdrop;animation-duration:.3s;animation-timing-function:linear}.drawer__header{height:48px;padding:15px 16px 0}.drawer__title{max-width:280px}@media (min-width: 640px){.drawer__title{max-width:560px}}@media (min-width: 1024px){.drawer__title{max-width:528px}}.drawer__content{position:absolute;display:flex;flex-direction:column;top:0;right:0;bottom:0;width:var(--drawer-width, 360px);background-color:#fff;box-shadow:-2px 0 2px #0000000f,-4px 0 8px #0000001f;transform:translate(100%);animation-name:slide-out-drawer;animation-duration:.32s;animation-timing-function:cubic-bezier(.4,0,1,1)}.open .drawer__content{transform:translate(0);animation-name:slide-in-drawer;animation-duration:.32s;animation-timing-function:cubic-bezier(0,0,.3,1)}.drawer__scrollable{flex:1}.drawer__close-btn{position:absolute;top:2px;right:7px;z-index:1}.drawer__headline{line-height:20px;margin-bottom:8px;max-width:280px}@keyframes show-backdrop{0%{background-color:transparent}to{background-color:#0009}}@keyframes hide-backdrop{0%{background-color:#0009}to{background-color:transparent}}@keyframes slide-in-drawer{0%{transform:translate(100%)}to{transform:translate(0)}}@keyframes slide-out-drawer{0%{transform:translate(0)}to{transform:translate(100%)}}\n"] }]
        }], ctorParameters: function () { return [{ type: Document, decorators: [{
                    type: Inject,
                    args: [DOCUMENT]
                }] }, { type: i0.ChangeDetectorRef }, { type: i1$1.LayoutService }, { type: i1.SieIconRegistryService }, { type: i0.ElementRef }]; }, propDecorators: { headlineAnimationType: [{
                type: Input
            }], headline: [{
                type: Input
            }], opening: [{
                type: Output
            }], opened: [{
                type: Output
            }], closing: [{
                type: Output
            }], closed: [{
                type: Output
            }], closeButton: [{
                type: ViewChild,
                args: ['closeButton']
            }], scrollableContent: [{
                type: ViewChild,
                args: ['scrollableContent']
            }], open: [], close: [] } });

/**
 * # Drawer Module
 * - {@link UiDrawerComponent}
 *
 * ## Module peer dependencies
 * - {@link SieIconsModule}
 */
class UiDrawerModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDrawerModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiDrawerModule, declarations: [UiDrawerComponent], imports: [CommonModule,
            SieIconsModule,
            UiButtonModule,
            UiScrollableModule,
            A11yModule,
            RunInZoneModule,
            AddTruncationAndTooltipModule], exports: [UiDrawerComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDrawerModule, imports: [CommonModule,
            SieIconsModule,
            UiButtonModule,
            UiScrollableModule,
            A11yModule,
            RunInZoneModule,
            AddTruncationAndTooltipModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDrawerModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiDrawerComponent],
                    imports: [
                        CommonModule,
                        SieIconsModule,
                        UiButtonModule,
                        UiScrollableModule,
                        A11yModule,
                        RunInZoneModule,
                        AddTruncationAndTooltipModule
                    ],
                    exports: [UiDrawerComponent]
                }]
        }] });

const openAnimationTiming = '80ms ' + EasingEntranceProductive;
const closeAnimationTiming = '80ms ' + EasingExitProductive;
const createDropdownAnimation = (openTiming = openAnimationTiming, closeTiming = closeAnimationTiming) => trigger('openClose', [
    transition(':enter', [
        animate(openTiming, keyframes([style({ height: '0', opacity: 0 }), style({ height: '*', opacity: 1 })]))
    ]),
    transition(':leave', [
        animate(closeTiming, keyframes([style({ height: '*', opacity: 1 }), style({ height: '0', opacity: 0 })]))
    ])
]);

var ArrowDirection;
(function (ArrowDirection) {
    ArrowDirection[ArrowDirection["Up"] = 0] = "Up";
    ArrowDirection[ArrowDirection["Down"] = 1] = "Down";
})(ArrowDirection || (ArrowDirection = {}));
/**
 * This service is used to handle data and display parameters for the ui-dropdown component.
 */
class UiDropdownService {
    /** @ignore */
    static getDirectionForKey(e) {
        if (e.key === 'ArrowDown') {
            return ArrowDirection.Down;
        }
        else if (e.key === 'ArrowUp') {
            return ArrowDirection.Up;
        }
        return null;
    }
    /**
     * This method finds and returns the first selectable item in a dropdown
     * @param {index} index  - index of current item
     * @param {direction} direction  - {@link ArrowDirection}
     * @param {options} options  - {@link DisableOption}
     * @returns {index}
     */
    static nextSelectableIndexForKey(index, direction, options) {
        const length = options.length;
        if (this.allDisabled(options)) {
            return index;
        }
        do {
            if (direction === ArrowDirection.Down) {
                index++;
                if (index === length) {
                    index = 0;
                }
            }
            else {
                index--;
                if (index < 0) {
                    index = length - 1;
                }
            }
        } while (options[index].disabled);
        return index;
    }
    /** @ignore */
    static allDisabled(options) {
        return options.every(e => e.disabled);
    }
}

/**
 * # Dropdown Menu Component
 * The Dropdown Menu Component is the overlay of the {@link UiDropdownComponent }
 * and therefore a part of the component that cannot be used separately.
 */
class UiDropdownMenuComponent {
    constructor(elementRef) {
        this.elementRef = elementRef;
        /**
         * Defines the {@link ThemeVariant theme} of dropdown
         * @default 'light'
         */
        this.theme = 'light';
        /**
         * Defines dropdown option type {@link UiDropdownOptionType}
         * @default 'menu'
         */
        this.type = 'menu';
        /**
         * Defines if menu should be positioned at the bottom
         * @default true
         */
        this.menuPositionedBottom = true;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDropdownMenuComponent, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiDropdownMenuComponent, selector: "sie-ui-dropdown-menu", inputs: { theme: "theme", type: "type", menuPositionedBottom: "menuPositionedBottom" }, ngImport: i0, template: "<div\n  class=\"dropdown__menu\"\n  [ngClass]=\"[theme, type]\"\n  [class.bottom]=\"menuPositionedBottom\"\n  [class.top]=\"!menuPositionedBottom\"\n>\n  <ng-content select=\"[content]\"></ng-content>\n  <ng-content select=\"[footer]\"></ng-content>\n</div>\n", styles: [":host{display:block;width:100%;--ui-dropdown-menu-padding: 4px 0 10px 0}.dropdown__menu{overflow-y:hidden;height:100%;font-size:1rem;font-weight:400;line-height:1.5rem;background-color:#fff;border:1px solid #ccccd4;box-shadow:0 2px 2px #0000000f,0 4px 8px #0000001f;padding:var(--ui-dropdown-menu-padding)}.dropdown__menu.dark{background-color:#001f39;box-shadow:0 2px 2px #0000000f,0 4px 8px #0000001f}.dropdown__menu.dropdown-contained{border-top-color:#00d7a0}.dropdown__menu.dropdown-contained.dark{border:unset;border-top:1px solid #00ffb9}.dropdown__menu.dropdown-contained.top{border-top-color:#ccccd4}.dropdown__menu.dropdown-contained.bottom,.dropdown__menu.dropdown-contained.dark.top{border-top-color:transparent}@media (max-width: 639.78px){.dropdown__menu.dropdown-un-contained{max-width:328px}}.dropdown__menu.dropdown-un-contained.top{border-top-color:#ccccd4}.dropdown__menu.dropdown-un-contained.dark.top{border-top-color:transparent}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDropdownMenuComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-dropdown-menu', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div\n  class=\"dropdown__menu\"\n  [ngClass]=\"[theme, type]\"\n  [class.bottom]=\"menuPositionedBottom\"\n  [class.top]=\"!menuPositionedBottom\"\n>\n  <ng-content select=\"[content]\"></ng-content>\n  <ng-content select=\"[footer]\"></ng-content>\n</div>\n", styles: [":host{display:block;width:100%;--ui-dropdown-menu-padding: 4px 0 10px 0}.dropdown__menu{overflow-y:hidden;height:100%;font-size:1rem;font-weight:400;line-height:1.5rem;background-color:#fff;border:1px solid #ccccd4;box-shadow:0 2px 2px #0000000f,0 4px 8px #0000001f;padding:var(--ui-dropdown-menu-padding)}.dropdown__menu.dark{background-color:#001f39;box-shadow:0 2px 2px #0000000f,0 4px 8px #0000001f}.dropdown__menu.dropdown-contained{border-top-color:#00d7a0}.dropdown__menu.dropdown-contained.dark{border:unset;border-top:1px solid #00ffb9}.dropdown__menu.dropdown-contained.top{border-top-color:#ccccd4}.dropdown__menu.dropdown-contained.bottom,.dropdown__menu.dropdown-contained.dark.top{border-top-color:transparent}@media (max-width: 639.78px){.dropdown__menu.dropdown-un-contained{max-width:328px}}.dropdown__menu.dropdown-un-contained.top{border-top-color:#ccccd4}.dropdown__menu.dropdown-un-contained.dark.top{border-top-color:transparent}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; }, propDecorators: { theme: [{
                type: Input
            }], type: [{
                type: Input
            }], menuPositionedBottom: [{
                type: Input
            }] } });

/**
 * This service is used for components that are preventing that key-up event for certain keys
 * is prevented after key-down.
 * This is useful for components like the following to prevent that Escape key closes the modal
 *  - dropdown
 *  - menu-button
 *  - date picker
 *  - date range picker
 */
class UiEventPropagationService {
    constructor() {
        this.preventPropagation = false;
    }
    startPrevention() {
        this.preventPropagation = true;
    }
    stopPrevention() {
        this.preventPropagation = false;
    }
    handleEvent(event) {
        if (this.preventPropagation) {
            event.preventDefault();
            event.stopPropagation();
            this.preventPropagation = false;
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiEventPropagationService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiEventPropagationService }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiEventPropagationService, decorators: [{
            type: Injectable
        }] });

const OVERLAY_SELECTOR = '.cdk-overlay-container';
const OVERLAY_ON_TOP_MODIFIER = 'cdk-overlay-container--on-top';
const preventModalFocusTrapInOverlayListener = (e) => {
    if (e.key === 'Tab' && document.activeElement.closest(OVERLAY_SELECTOR)) {
        e.stopImmediatePropagation();
    }
};
class CdkOverlayService {
    constructor(document) {
        this.document = document;
    }
    isOverlayActive() {
        const cdkOverlay = document.querySelector(OVERLAY_SELECTOR);
        return (cdkOverlay?.children?.length ?? 0) > 0;
    }
    addOverlayOnTopModifier() {
        const overlayElement = document.querySelector(OVERLAY_SELECTOR);
        if (!overlayElement?.classList.contains(OVERLAY_ON_TOP_MODIFIER)) {
            overlayElement?.classList.add(OVERLAY_ON_TOP_MODIFIER);
        }
    }
    removeOverlayOnTopModifier() {
        const overlayElement = document.querySelector(OVERLAY_SELECTOR);
        overlayElement?.classList.remove(OVERLAY_ON_TOP_MODIFIER);
    }
    /**
     * The `ngx-smart-modal` component implemented a focus trap
     * https://github.com/maximelafarie/ngx-smart-modal/blob/master/src/ngx-smart-modal/src/services/ngx-smart-modal.service.ts#L486 that is
     * that is incompatible with the cdk overlay component as the element is created outside the modal container
     * https://github.com/angular/components/blob/main/src/cdk/overlay/overlay-container.ts#L81.
     *
     */
    deactivateModalFocusTrap() {
        this.document.addEventListener('keydown', preventModalFocusTrapInOverlayListener);
    }
    /**
     * Reverts the effect from `deactivateModalFocusTrap`
     * @see CdkOverlayService#deactivateModalFocusTrap
     */
    reactivateModalFocusTrap() {
        this.document.removeEventListener('keydown', preventModalFocusTrapInOverlayListener);
    }
    getOverlay() {
        return document.querySelector('.cdk-overlay-container');
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: CdkOverlayService, deps: [{ token: DOCUMENT }], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: CdkOverlayService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: CdkOverlayService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: Document, decorators: [{
                    type: Inject,
                    args: [DOCUMENT]
                }] }]; } });

/**
 * Overlay offset for uncontained dropdown flyout.
 */
const CDK_OVERLAY_OFFSET_X = -16;
const FOCUS_CLOSE_TIMEOUT = 150;
const MAX_ITEMS = 8;
/**
 * This directive is used to handle data and display parameters for the ui-dropdown component.
 */
class UiDropdownBaseDirective {
    /**
     * @param value Defines content of each dropdown item option.
     */
    set options(value) {
        this._options = value || [];
    }
    get options() {
        return this._options;
    }
    /**
     * @param value Sets the disabled state to the dropdown.
     * @default false
     */
    set disabled(value) {
        this._disabled = coerceBooleanProperty(value);
    }
    get disabled() {
        return this._disabled;
    }
    /**
     * @param value enables reset icon styles and functionality
     * @default false
     */
    set clearInputEnabled(value) {
        this._clearInput = coerceBooleanProperty(value);
    }
    get clearInputEnabled() {
        return this._clearInput;
    }
    /**
     * Sets the dropdown overlay in top position.
     */
    set overlayOnTop(value) {
        this._overlayOnTop = coerceBooleanProperty(value);
    }
    get overlayOnTop() {
        return this._overlayOnTop;
    }
    /**
     * @param value Sets the space in front of the input text.
     */
    set displayIconSpace(value) {
        this._displayIconSpace = coerceBooleanProperty(value);
    }
    get displayIconSpace() {
        return this._displayIconSpace;
    }
    /** @ignore */
    get menuOpen() {
        return this._menuOpen;
    }
    /** @ignore */
    set menuOpen(value) {
        if (this._menuOpen !== value) {
            this.dropdownMenuOpened.next(value);
        }
        this._menuOpen = value;
    }
    constructor(cdr, elementRef, eventPropagationService, cdkOverlayService) {
        this.cdr = cdr;
        this.elementRef = elementRef;
        this.eventPropagationService = eventPropagationService;
        this.cdkOverlayService = cdkOverlayService;
        this._options = [];
        this._disabled = false;
        /**
         * Defines the {@link ThemeVariant Mode} of the component.
         * @default 'light'
         */
        this.theme = 'light';
        /**
         * Defines the text used by screen readers for the reset icon
         * @default '' (empty string)
         */
        this.clearInputIconScreenReaderText = '';
        /**
         * Event triggered when the dropdown menu is opened
         */
        this.dropdownMenuOpened = new Subject();
        /**
         * Event triggered when the reset input icon is clicked.
         */
        this.clearInput = new EventEmitter();
        this._clearInput = false;
        /** @ignore */
        this.menuPositionedBottom = true;
        this._menuOpen = false;
    }
    /** @ignore */
    focusIn() {
        if (this.disabled) {
            return;
        }
        clearTimeout(this.focusOutTimer);
    }
    /** @ignore */
    focusOut() {
        if (this.disabled) {
            return;
        }
        this.focusOutTimer = setTimeout(() => {
            this.closeOverlay();
        }, FOCUS_CLOSE_TIMEOUT);
    }
    /** @ignore */
    handleEscape(event) {
        if (this.menuOpen) {
            event.stopPropagation();
        }
        this.closeOverlay(true);
    }
    /** Closes the dropdown overlay. */
    closeOverlay(focusDropdownButton = false) {
        if (this._overlayOnTop && this.menuOpen) {
            this.cdkOverlayService.removeOverlayOnTopModifier();
        }
        this.menuOpen = false;
        this.cdr.detectChanges();
        if (focusDropdownButton) {
            this.dropDownRendering.nativeElement.firstElementChild.focus();
        }
    }
    /** @ignore */
    toggleDropDown(event) {
        event?.preventDefault();
        if (this.disabled) {
            return;
        }
        this.calculateOverlayPaneWidth();
        if (this.menuOpen) {
            this.closeOverlay();
        }
        else {
            this.openOverlay();
        }
    }
    /** Opens the dropdown overlay. */
    openOverlay() {
        this.menuOpen = true;
        this.eventPropagationService.startPrevention();
        this.calculateOverlayPaneHeight();
        this.calculateOverlayPaneWidth();
        requestAnimationFrame(() => {
            this.recalculatePositions();
            if (this._overlayOnTop) {
                this.cdkOverlayService.addOverlayOnTopModifier();
            }
        });
    }
    calculateOverlayPaneWidth() {
        this.dropdownWidth = this.elementRef.nativeElement.offsetWidth;
    }
    calculateOverlayPaneHeight() {
        const optionHeight = 32;
        const padding = 14;
        // Initially we set the pane height to 256px as it is the max height for the dropdown menu and covers the cases for 8 and more options
        let dropdownMaxHeight = 256;
        // If we have less than 8 items we get the initial height of the dropdown menu by calculating the size of a single list item times the amount of items
        // Add the padding of the dropdown menu to it
        if (this.options?.length < MAX_ITEMS) {
            dropdownMaxHeight = this.options.length * optionHeight + padding;
        }
        // and set the height for the overlay pane
        this.overlayPaneHeight = dropdownMaxHeight;
    }
    /** @ignore */
    recalculatePositions() {
        this.determineHorizontalMenuAlignment();
        this.determineVerticalMenuAlignment();
        this.cdr.markForCheck();
    }
    /** @ignore */
    onArrowDownOnButton(event) {
        event.preventDefault();
        if (this.menuOpen) {
            // simulate the opening of first item (from position -1 to 0)
            this.focusElement(UiDropdownService.nextSelectableIndexForKey(-1, ArrowDirection.Down, this._options));
        }
        else {
            this.openOverlay();
        }
    }
    /** @param index Focuses the dropdown item. */
    focusElement(index) {
        const nativeEl = this.elementRef.nativeElement;
        const newEl = nativeEl.querySelector(`[data-index="${index}"]`);
        if (!this.isDisabled(index) && newEl !== null) {
            newEl.focus();
        }
    }
    /** @ignore */
    isDisabled(index) {
        return this._options[index]?.disabled;
    }
    onResetButtonClicked(selector) {
        this.clearInput.emit();
        this.focusInputField(selector);
        this.toggleDropDown();
    }
    focusInputField(selector) {
        const nativeEl = this.dropDownRendering.nativeElement;
        const newEl = nativeEl.querySelector(selector);
        if (newEl !== null) {
            newEl.focus();
        }
    }
    determineVerticalMenuAlignment() {
        this.cdr.detectChanges();
        let dropdownRectValues;
        const dropdownList = this.dropDownMenu?.elementRef.nativeElement.querySelector('.dropdown__list');
        const comboboxContent = this.dropDownMenu?.elementRef.nativeElement.querySelector('.combobox__content');
        const complexDropdownContent = this.dropDownMenu?.elementRef.nativeElement.querySelector('.complex__dropdown__content');
        if (dropdownList) {
            this.calculateVerticalMenuAlignment(dropdownList);
            dropdownRectValues = this.calculateVerticalMenuAlignment(dropdownList);
        }
        else if (comboboxContent) {
            this.calculateVerticalMenuAlignment(comboboxContent);
            dropdownRectValues = this.calculateVerticalMenuAlignment(comboboxContent);
        }
        else if (complexDropdownContent) {
            this.calculateVerticalMenuAlignment(complexDropdownContent);
            dropdownRectValues = this.calculateVerticalMenuAlignment(complexDropdownContent);
        }
        this.menuPositionedBottom = true;
        if (dropdownRectValues?.availableBottomSpace <= 0) {
            if (dropdownRectValues.availableTopSpace <= 0) {
                if (dropdownList) {
                    dropdownList.style.maxHeight = `${dropdownRectValues.maxHeight}px`;
                }
            }
            else {
                this.menuPositionedBottom = false;
                this.dropDownMenu.elementRef.nativeElement.style.top = `${-dropdownRectValues.dropDownMenuHeight}px`;
                if (complexDropdownContent) {
                    const footerHeight = 60;
                    this.dropDownMenu.elementRef.nativeElement.style.top = `${-dropdownRectValues.dropDownMenuHeight - footerHeight}px`;
                }
            }
        }
    }
    calculateVerticalMenuAlignment(element) {
        const margins = 16;
        const windowHeight = window.innerHeight;
        const dropdownTopPosition = element.getBoundingClientRect().top + margins;
        const dropDownMenuHeight = element.offsetHeight + margins;
        const availableTopSpace = this.dropDownRendering.nativeElement.getBoundingClientRect().top - dropDownMenuHeight;
        const maxHeight = windowHeight - dropdownTopPosition;
        let availableBottomSpace = windowHeight - element.getBoundingClientRect().bottom;
        if (!this.menuPositionedBottom) {
            availableBottomSpace = 0;
        }
        return { availableBottomSpace, availableTopSpace, maxHeight, dropDownMenuHeight };
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDropdownBaseDirective, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: UiEventPropagationService }, { token: CdkOverlayService }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: UiDropdownBaseDirective, inputs: { options: "options", disabled: "disabled", theme: "theme", screenReaderText: "screenReaderText", clearInputEnabled: "clearInputEnabled", clearInputIconScreenReaderText: "clearInputIconScreenReaderText", overlayOnTop: "overlayOnTop", displayIconSpace: "displayIconSpace" }, outputs: { dropdownMenuOpened: "dropdownMenuOpened", clearInput: "clearInput" }, viewQueries: [{ propertyName: "dropDownRendering", first: true, predicate: ["dropDownRendering"], descendants: true }, { propertyName: "dropDownElement", first: true, predicate: ["dropDownElement"], descendants: true }, { propertyName: "dropDownMenu", first: true, predicate: UiDropdownMenuComponent, descendants: true }], ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDropdownBaseDirective, decorators: [{
            type: Directive
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: UiEventPropagationService }, { type: CdkOverlayService }]; }, propDecorators: { dropDownRendering: [{
                type: ViewChild,
                args: ['dropDownRendering']
            }], dropDownElement: [{
                type: ViewChild,
                args: ['dropDownElement']
            }], dropDownMenu: [{
                type: ViewChild,
                args: [UiDropdownMenuComponent]
            }], options: [{
                type: Input
            }], disabled: [{
                type: Input
            }], theme: [{
                type: Input
            }], screenReaderText: [{
                type: Input
            }], clearInputEnabled: [{
                type: Input
            }], clearInputIconScreenReaderText: [{
                type: Input
            }], overlayOnTop: [{
                type: Input
            }], displayIconSpace: [{
                type: Input
            }], dropdownMenuOpened: [{
                type: Output
            }], clearInput: [{
                type: Output
            }] } });

/**
 * Base class to be derived from form controls to inherit common used attributes
 */
class FormControlDirective {
    constructor() {
        /**
         * {@link ThemeVariant Theme} of the component
         * @default 'light'
         */
        this.theme = 'light';
        /**
         * Used to add custom css classes to the component
         * @default '' empty string (does not apply any styles)
         */
        this.customClass = '';
        this._disabled = false;
        this._readonly = false;
        this._invalid = false;
        this._hint = null;
    }
    /**
     * @param value Removes functionality (click events, expanding capability) from the component and changes heading
     * color when set to true
     * @default false
     */
    set disabled(value) {
        this._disabled = coerceBooleanProperty(value);
    }
    get disabled() {
        return this._disabled;
    }
    /**
     * @param value Sets state of the component as readonly
     * @default false
     */
    set readonly(value) {
        this._readonly = coerceBooleanProperty(value);
    }
    get readonly() {
        return this._readonly;
    }
    /**
     * @param value Sets state of the component as invalid and adds style changes
     * @default false
     */
    set invalid(value) {
        this._invalid = coerceBooleanProperty(value);
    }
    get invalid() {
        return this._invalid;
    }
    /**
     * @param hint Defines the {@link HintModel hint } on the element
     */
    set hint(hint) {
        setDefaultsForHint(hint);
        this._hint = hint;
    }
    get hint() {
        return this._hint;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: FormControlDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: FormControlDirective, inputs: { theme: "theme", id: "id", name: "name", label: "label", placeholder: "placeholder", errorMessage: "errorMessage", customClass: "customClass", disabled: "disabled", readonly: "readonly", invalid: "invalid", hint: "hint" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: FormControlDirective, decorators: [{
            type: Directive
        }], propDecorators: { theme: [{
                type: Input
            }], id: [{
                type: Input
            }], name: [{
                type: Input
            }], label: [{
                type: Input
            }], placeholder: [{
                type: Input
            }], errorMessage: [{
                type: Input
            }], customClass: [{
                type: Input
            }], disabled: [{
                type: Input
            }], readonly: [{
                type: Input
            }], invalid: [{
                type: Input
            }], hint: [{
                type: Input
            }] } });
/** @ignore */
const setDefaultsForHint = (hint) => {
    if (hint) {
        if (!hint.type) {
            hint.type = 'inline';
        }
        if (!hint.size) {
            hint.size = 's';
        }
    }
};

const disarmed = () => {
    /* do nothing */
};
/**
 * Base class to be derived from form controls to inherit attributes from {@link FormControlDirective} and
 * Angular form control default behaviour.
 */
class NgFormControlDirective extends FormControlDirective {
    constructor() {
        super(...arguments);
        /**
         * Helper variable to store if the control has been touched
         */
        this.touched = false;
        /**
         * Used from derived component to report that internal state/value has changed
         */
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        this.onChange = disarmed;
        /**
         * Used from derived component to report that control has been touched
         */
        this.onTouched = disarmed;
        /**
         * Used from derived component to report that validator has been changed
         */
        this.onValidatorChanged = disarmed;
    }
    /**
     * Concrete implementation of {@link ControlValueAccessor ControlValueAccessor.registerOnChange} method allowing
     * changing `onChange` function
     * @param fn callback function
     */
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    registerOnChange(fn) {
        this.onChange = fn;
    }
    /**
     * Concrete implementation of {@link ControlValueAccessor ControlValueAccessor.registerOnTouched} method allowing
     * changing `onTouched` function
     * @param fn callback function
     */
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    /**
     * Concrete implementation of {@link ControlValueAccessor ControlValueAccessor.setDisabledState} method allowing
     * setting/removing the component's disabled state
     * @param disabled whether the component shall be enabled or disabled
     */
    setDisabledState(disabled) {
        this.disabled = disabled;
    }
    /**
     * Helper method to mark that component has been touched
     */
    markAsTouched() {
        if (!this.touched) {
            this.onTouched();
            this.touched = true;
        }
    }
    /**
     * Concrete implementation of {@link ControlValueAccessor ControlValueAccessor.registerOnValidatorChange} method
     * allowing changing `onValidatorChanged` function
     * @param fn callback function
     */
    registerOnValidatorChange(fn) {
        this.onValidatorChanged = fn;
    }
    /**
     * Concrete implementation that wraps abstract `validateInternal` method
     * @param control Concrete access to {@link AbstractControl form control object}
     * @return checkout {@link Validator}
     */
    validate(control) {
        this.invalid = false;
        const result = this.validateInternal(control);
        if (result) {
            this.invalid = true;
        }
        return result;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: NgFormControlDirective, deps: null, target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: NgFormControlDirective, usesInheritance: true, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: NgFormControlDirective, decorators: [{
            type: Directive
        }] });

class PointerDeviceService {
    /**
     * On some spots in the SPA click events don't go through since other `pointerdown` events seem to overlap the event.
     * By simply ignoring the event the original click event goes through.
     * @param event Event to be prevented in order to let click events go through
     */
    static avoidPointerDownCollision(event) {
        event.preventDefault();
    }
}

/**
 * # Richtext Component
 * Rich text instantiates typographic styles. It is always used when text containing
 * multiple lines and formats is shown on the page. Rich text can have regular or bold style.
 * They can be used within any defined copy styles but not with the headlines.
 *
 * ## Component variations
 *
 * - Light theme text
 * - Dark theme text
 *
 * ## Content
 *
 * The Richtext component does not accept any content.
 *
 * ## Code example
 * @example
 * Template:
 * ```html
 * <sie-ui-richtext [content]="content" [theme]="'dark'"></sie-ui-richtext>
 * ```
 */
class UiRichtextComponent {
    /**
     * Defines content of the Richtext component.
     */
    set content(value) {
        if (value) {
            const regex = /<u popover="([^"]+)">([^<]+)<\/u>/g;
            value = value.replace(regex, '<u class="popover-placeholder" title="$1">$2</u>');
        }
        this._content = value;
    }
    get content() {
        return this._content;
    }
    constructor(renderer, document, el, vcRef, cdr) {
        this.renderer = renderer;
        this.document = document;
        this.el = el;
        this.vcRef = vcRef;
        this.cdr = cdr;
        /**
         * Defines {@link ThemeVariant Variant} theme of the Richtext component.
         * @default 'light'
         */
        this.theme = 'light';
    }
    /** @ignore */
    ngAfterViewInit() {
        const el = this.el.nativeElement;
        if (!!this.whiteListedTags?.size) {
            DomUtil.cleanHtmlElement(el.firstElementChild, this.whiteListedTags);
        }
        // don't take the anchors which are added with sie-ui-links component through the ng-content
        const anchors = Array.from(el.querySelectorAll('a:not(.lib-link)'));
        for (const elem of anchors) {
            const newElem = this.createLink(`${elem.innerText}`, elem.href, elem.target);
            this.renderer.insertBefore(elem.parentElement, newElem, elem);
            this.renderer.removeChild(elem.parentElement, elem);
        }
        const dottedUnderlineElements = Array.from(el.querySelectorAll('u.popover-placeholder'));
        for (const elem of dottedUnderlineElements) {
            const newComponent = this.createUnderlineWithTooltip(`${elem.innerText}`, `${elem.getAttribute('title')}`);
            this.renderer.insertBefore(elem.parentElement, newComponent.location.nativeElement, elem);
            this.renderer.removeChild(elem.parentElement, elem);
            newComponent.hostView.detectChanges();
        }
        this.cdr.detectChanges();
    }
    /** @ignore */
    createLink(innerText, linkSource, target) {
        const anchorTag = document.createElement('a');
        anchorTag.innerText = innerText;
        anchorTag.href = linkSource;
        anchorTag.target = target;
        return anchorTag;
    }
    createUnderlineWithTooltip(text, tooltipText) {
        const component = this.vcRef.createComponent(UiUnderlineTooltipComponent);
        component.instance.text = text;
        component.instance.tooltipText = tooltipText;
        component.instance.theme = this.theme;
        return component;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiRichtextComponent, deps: [{ token: i0.Renderer2 }, { token: DOCUMENT }, { token: i0.ElementRef }, { token: i0.ViewContainerRef }, { token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiRichtextComponent, selector: "sie-ui-richtext", inputs: { content: "content", theme: "theme", whiteListedTags: "whiteListedTags" }, ngImport: i0, template: "<span *ngIf=\"content\" class=\"richtext\" [ngClass]=\"{ dark: theme === 'dark' }\" [innerHTML]=\"content\"></span>\n<ng-content></ng-content>\n", styles: [":host{display:block}.richtext:after{content:\" \"}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiRichtextComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-richtext', changeDetection: ChangeDetectionStrategy.OnPush, template: "<span *ngIf=\"content\" class=\"richtext\" [ngClass]=\"{ dark: theme === 'dark' }\" [innerHTML]=\"content\"></span>\n<ng-content></ng-content>\n", styles: [":host{display:block}.richtext:after{content:\" \"}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.Renderer2 }, { type: Document, decorators: [{
                    type: Inject,
                    args: [DOCUMENT]
                }] }, { type: i0.ElementRef }, { type: i0.ViewContainerRef }, { type: i0.ChangeDetectorRef }]; }, propDecorators: { content: [{
                type: Input
            }], theme: [{
                type: Input
            }], whiteListedTags: [{
                type: Input
            }] } });

/**
 * # Checkbox component
 *
 * Checkboxes are part of a form, allowing us to select or deselect a given option. Similarly, the Checkbox Group allows
 * us to choose between listed options.
 *
 * ## Component variations
 *
 * - standard (when `label` value (with or without `icons` value) is defined)
 * - condensed (when no `label`, except for the readonly state, nor `icons` value is defined)
 *
 * ## Content
 *
 * The checkbox component does not accept any content.
 *
 * ## Code example
 * @example ```html
 * <sie-ui-checkbox label="click me" [(value)]="active"></sie-ui-checkbox>
 *
 * Status: {{ active }}
 * ```
 */
class UiCheckboxComponent extends NgFormControlDirective {
    set checkboxElement(checkboxInput) {
        if (checkboxInput && this.checkboxIdToFocus && this.id === this.checkboxIdToFocus) {
            checkboxInput.nativeElement.focus({ preventScroll: true });
        }
    }
    /**
     * @param indeterminate Defines if the checkbox is indeterminate or not
     * @default false
     */
    set indeterminate(indeterminate) {
        this._indeterminate = coerceBooleanProperty(indeterminate);
    }
    get indeterminate() {
        return this._indeterminate;
    }
    /**
     * @param value Defines the value of the checkbox (used instead of checked)
     * @default false
     */
    set value(value) {
        this._value = coerceBooleanProperty(value);
    }
    get value() {
        return this._value;
    }
    /**
     * @param active Defines the checkbox is active or not (Active state defines a visual difference to non-active ones)
     * @default false
     */
    set active(active) {
        this._active = coerceBooleanProperty(active);
    }
    get active() {
        return this._active;
    }
    /**
     *  @param required Defines if the checkbox is required or not
     *  @default false
     */
    set required(required) {
        this._required = coerceBooleanProperty(required);
    }
    get required() {
        return this._required;
    }
    /**
     * @param icons Defines the {@link SieIcon icons} to be displayed next to the checkbox
     */
    set icons(icons) {
        this._icons = coerceStringArray(icons);
        if (this._icons) {
            this._icons.forEach(icon => {
                this.iconReg.register(icon);
            });
        }
    }
    get icons() {
        return this._icons;
    }
    constructor(iconReg) {
        super();
        this.iconReg = iconReg;
        /**
         * Event triggered when the checkbox is clicked.
         */
        this.valueChange = new EventEmitter();
        this._indeterminate = false;
        this._value = false;
        this._active = false;
        this._required = false;
        iconReg.register(SieIcon.CheckMark);
        iconReg.register(SieIcon.Information);
    }
    /** @ignore */
    onCheck(checkBoxState) {
        this.valueChange.emit(checkBoxState);
        this.onChange(checkBoxState);
        this.markAsTouched();
    }
    /** @ignore */
    validateInternal() {
        return null;
    }
    /** @ignore */
    writeValue(checked) {
        this.value = checked;
    }
    /**
     * Sets the focus to the checkbox input field.
     */
    focus() {
        this.checkboxElement.nativeElement.focus();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCheckboxComponent, deps: [{ token: i1.SieIconRegistryService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiCheckboxComponent, selector: "sie-ui-checkbox", inputs: { id: "id", checkboxIdToFocus: "checkboxIdToFocus", indeterminate: "indeterminate", value: "value", active: "active", required: "required", icons: "icons", labelAppendix$: "labelAppendix$" }, outputs: { valueChange: "valueChange" }, providers: [
            {
                provide: NG_VALUE_ACCESSOR,
                multi: true,
                useExisting: UiCheckboxComponent
            },
            {
                provide: NG_VALIDATORS,
                multi: true,
                useExisting: UiCheckboxComponent
            }
        ], viewQueries: [{ propertyName: "checkboxElement", first: true, predicate: ["checkboxInput"], descendants: true }], usesInheritance: true, ngImport: i0, template: "<div *ngIf=\"!readonly; else readOnly\" [ngClass]=\"[disabled ? 'disabled' : '']\" class=\"checkbox__wrapper\">\n  <label [for]=\"name + '_' + id\">\n    <input\n      [(ngModel)]=\"value\"\n      (ngModelChange)=\"onCheck($event)\"\n      [disabled]=\"disabled\"\n      [id]=\"name + '_' + id\"\n      [name]=\"name\"\n      [required]=\"required\"\n      class=\"checkbox__input\"\n      type=\"checkbox\"\n      #checkboxInput\n    />\n    <span class=\"checkbox__inner-wrapper\">\n      <span\n        [ngClass]=\"[active ? 'active' : '', disabled ? 'disabled' : '', invalid && !disabled ? 'invalid' : '']\"\n        class=\"checkbox\"\n      >\n        <span class=\"checkbox__checkmark\">\n          <sie-icon\n            *ngIf=\"value; else indeterminateIcon\"\n            class=\"checkbox__checkmark__icon\"\n            [name]=\"iconReg.sieIcon.CheckMark\"\n          ></sie-icon>\n        </span>\n      </span>\n    </span>\n    <span *ngIf=\"label || (labelAppendix$ | async) || icons\" [ngClass]=\"{ invalid: invalid }\" class=\"checkbox__label\"\n      ><span *ngIf=\"label || (labelAppendix$ | async)\" class=\"checkbox__label__text\"\n        >{{ label }}{{ labelAppendix$ | async }}<ng-container *ngIf=\"required\">*</ng-container></span\n      >\n      <ng-content select=\"[slot=label-content]\"></ng-content>\n      <span *ngIf=\"icons\"\n        ><sie-icon *ngFor=\"let icon of icons\" [name]=\"icon\" class=\"checkbox__label__icon\"></sie-icon\n      ></span>\n      <span *ngIf=\"hint?.type === 'tooltip' && hint?.content\">\n        <sie-icon\n          class=\"checkbox__label__tooltip-icon\"\n          sieUiPopover\n          [popoverSize]=\"hint?.size ? hint?.size : 's'\"\n          [content]=\"hint?.content\"\n          [name]=\"iconReg.sieIcon.Information\"\n        ></sie-icon>\n      </span>\n    </span>\n  </label>\n  <sie-ui-richtext *ngIf=\"hint?.type === 'inline' && hint?.content\" [content]=\"hint.content\"></sie-ui-richtext>\n</div>\n<ng-template #indeterminateIcon>\n  <div *ngIf=\"indeterminate\" class=\"checkbox__checkmark__indeterminate\"></div>\n</ng-template>\n<ng-template #readOnly>\n  <div class=\"checkbox__readonly\">\n    <div class=\"checkbox__readonly__checkmark\" [ngClass]=\"{ standard: !indeterminate }\">\n      <span\n        *ngIf=\"!readOnlyCheckmarkIcon; else readOnlyCheckmarkIcon\"\n        class=\"checkbox__readonly__inner__checkmark\"\n      ></span>\n    </div>\n    <span *ngIf=\"label || (labelAppendix$ | async) || icons\" class=\"checkbox__readonly__label\"\n      ><span *ngIf=\"label || (labelAppendix$ | async)\" class=\"checkbox__readonly__label__text\"\n        >{{ label }}{{ labelAppendix$ | async }}</span\n      ><span *ngIf=\"icons\"\n        ><sie-icon *ngFor=\"let icon of icons\" [name]=\"icon\" class=\"checkbox__label__icon\"></sie-icon\n      ></span>\n      <span *ngIf=\"hint?.type === 'tooltip' && hint?.content\">\n        <sie-icon\n          class=\"checkbox__label__tooltip-icon\"\n          sieUiPopover\n          [popoverSize]=\"hint?.size ? hint?.size : 's'\"\n          [content]=\"hint?.content\"\n          [name]=\"iconReg.sieIcon.Information\"\n        ></sie-icon>\n      </span>\n    </span>\n  </div>\n  <sie-ui-richtext\n    class=\"checkbox__readonly__inline-hint\"\n    *ngIf=\"hint?.type === 'inline' && hint?.content\"\n    [content]=\"hint.content\"\n  ></sie-ui-richtext>\n</ng-template>\n<ng-template #readOnlyCheckmarkIcon>\n  <sie-icon\n    *ngIf=\"!this.indeterminate; else indeterminateIcon\"\n    class=\"checkbox__readonly__checkmark__icon\"\n    [name]=\"iconReg.sieIcon.CheckMark\"\n  ></sie-icon>\n</ng-template>\n", styles: [".checkbox__input:focus,.checkbox__input:focus-visible{outline:0}.checkbox{position:absolute;top:0;left:0;height:20px;width:20px;background-color:#fff;display:flex;justify-content:center;align-items:center}.checkbox__checkmark{position:absolute;display:flex}.checkbox__checkmark__indeterminate{display:flex;background-color:#00646e;width:14px;height:14px}.checkbox:after,.checkbox:before{content:\"\";position:absolute;display:none}.checkbox:before{display:block;top:0;left:0;width:20px;height:20px;background-color:#ebf7f8;border:1px solid #4c4c68}.checkbox__label{color:#000028;word-break:break-word}.checkbox__label.invalid{color:#ef0137}.checkbox__label__text{margin-right:8px}.checkbox__label__tooltip-icon{color:#4c4c68}.checkbox__label__icon,.checkbox__label__tooltip-icon{width:auto;height:24px;display:flex;align-items:center;fill:currentColor;display:inline-block;margin-right:8px}.checkbox__label__icon svg,.checkbox__label__tooltip-icon svg{fill:currentColor;width:inherit;height:inherit}.checkbox__label__icon svg g,.checkbox__label__tooltip-icon svg g{fill:currentColor;width:inherit;height:inherit}.checkbox__label__icon svg text,.checkbox__label__tooltip-icon svg text{font-family:Siemens Sans,sans-serif}.checkbox__label__icon svg,.checkbox__label__tooltip-icon svg{max-width:30px}.checkbox__input{position:absolute;opacity:0}.checkbox__input~.checkbox__inner-wrapper{width:20px;height:20px;min-width:20px;position:relative;display:inline-block;align-self:flex-start;margin-top:1px;margin-right:8px}.checkbox__input~.checkbox__inner-wrapper .checkbox:not(.active):before{border-color:#4c4c68}.checkbox__input~.checkbox__inner-wrapper .checkbox.active:before{border-color:#00646e}.checkbox__input~.checkbox__inner-wrapper .checkbox.invalid:before{border-color:#ef0137}.checkbox__input~.checkbox__inner-wrapper .checkbox:after{background-color:#00183b}.checkbox__input~.checkbox__inner-wrapper .checkbox.disabled:before{border-color:#b3b3be}.checkbox__input:focus~.checkbox__inner-wrapper:before{content:\"\";position:absolute;inset:-3px;z-index:1;border:1px solid #1491eb;border-radius:0}.checkbox__input:focus-visible~.checkbox__inner-wrapper:before{content:\"\";position:absolute;inset:-3px;z-index:1;border:1px solid #1491eb;border-radius:0}.checkbox__input:checked~.checkbox__inner-wrapper .checkbox__checkmark__icon{color:#00646e;width:14px;height:14px;display:flex;align-items:center;fill:currentColor}.checkbox__input:checked~.checkbox__inner-wrapper .checkbox__checkmark__icon svg{fill:currentColor;width:inherit;height:inherit}.checkbox__input:checked~.checkbox__inner-wrapper .checkbox__checkmark__icon svg g{fill:currentColor;width:inherit;height:inherit}.checkbox__input:checked~.checkbox__inner-wrapper .checkbox__checkmark__icon svg text{font-family:Siemens Sans,sans-serif}.checkbox__input:checked~.checkbox__inner-wrapper .checkbox:after{display:block}.checkbox__input:checked~.checkbox__inner-wrapper .checkbox.disabled .checkbox__checkmark__icon{color:#b3b3be}.checkbox__input:checked~.checkbox__inner-wrapper .checkbox.disabled .checkbox__checkmark__indeterminate{background-color:#b3b3be}.checkbox__input:checked~.checkbox__inner-wrapper .checkbox:not(.disabled):before{border-color:#33747a}.checkbox__input:focus:not(:focus-visible)~.checkbox__inner-wrapper:before{border:none}.checkbox__input:not(:disabled):active~.checkbox__inner-wrapper .checkbox:not(.invalid):before{border-color:#33747a}.checkbox__wrapper{position:relative}.checkbox__wrapper sie-ui-richtext{display:flex;width:100%;color:#4c4c68;font-size:.75rem;font-weight:400;line-height:1rem}.checkbox__wrapper label{display:flex;cursor:pointer;align-items:center}.checkbox__wrapper:hover .checkbox__input:not(:disabled)~.checkbox__inner-wrapper .checkbox.dark:not(.invalid):after{background:#00ffb9}.checkbox__wrapper:hover .checkbox__input:not(:disabled)~.checkbox__inner-wrapper .checkbox:not(.invalid):before,.checkbox__wrapper:hover .checkbox__input:not(:checked):not(:disabled)~.checkbox__inner-wrapper .checkbox:not(.invalid):before{background:#d1fff2;border-color:#33747a}.checkbox__wrapper:hover .checkbox__input:not(:disabled)~.checkbox__inner-wrapper .checkbox.dark:not(.invalid):before,.checkbox__wrapper:hover .checkbox__input:not(:checked):not(:disabled)~.checkbox__inner-wrapper .checkbox.dark:not(.invalid):before{background:#001f39;border-color:#00ffb9}.checkbox__wrapper.disabled .checkbox__label{color:#737389}.checkbox__wrapper.disabled label{cursor:not-allowed}.checkbox__readonly{display:flex;align-items:flex-start}.checkbox__readonly__inline-hint{display:flex;width:100%;color:#4c4c68;font-size:.75rem;font-weight:400;line-height:1rem}.checkbox__readonly__tooltip-icon{color:#4c4c68;width:auto;height:24px;display:flex;align-items:center;fill:currentColor}.checkbox__readonly__tooltip-icon svg{fill:currentColor;width:inherit;height:inherit}.checkbox__readonly__tooltip-icon svg g{fill:currentColor;width:inherit;height:inherit}.checkbox__readonly__tooltip-icon svg text{font-family:Siemens Sans,sans-serif}.checkbox__readonly__label{color:#000028;margin-top:2px;word-break:break-word}.checkbox__readonly__label__text{margin-right:8px}.checkbox__readonly__checkmark{border:1px #4c4c68 solid;background-color:#ebf7f8;display:inline-flex;justify-content:center;height:20px;width:20px;margin-top:-1px;margin-right:8px;flex-shrink:0}.checkbox__readonly__checkmark__icon{color:#4c4c68;width:14px;height:14px;display:flex;align-items:center;fill:currentColor}.checkbox__readonly__checkmark__icon svg{fill:currentColor;width:inherit;height:inherit}.checkbox__readonly__checkmark__icon svg g{fill:currentColor;width:inherit;height:inherit}.checkbox__readonly__checkmark__icon svg text{font-family:Siemens Sans,sans-serif}.checkbox__readonly__checkmark.standard{margin-top:7px;background-color:inherit;border:0}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "directive", type: i3.CheckboxControlValueAccessor, selector: "input[type=checkbox][formControlName],input[type=checkbox][formControl],input[type=checkbox][ngModel]" }, { kind: "directive", type: i3.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i3.CheckboxRequiredValidator, selector: "input[type=checkbox][required][formControlName],input[type=checkbox][required][formControl],input[type=checkbox][required][ngModel]" }, { kind: "directive", type: i3.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "component", type: UiRichtextComponent, selector: "sie-ui-richtext", inputs: ["content", "theme", "whiteListedTags"] }, { kind: "directive", type: UiPopoverDirective, selector: "[sieUiPopover]", inputs: ["content", "popoverTemplate", "popoverSize", "popoverPlacement", "popoverAnimation", "popoverPlayAnimation", "popoverAnimationHideAfterTimeoutMS", "popoverLightTheme"] }, { kind: "pipe", type: i2.AsyncPipe, name: "async" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCheckboxComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-checkbox', changeDetection: ChangeDetectionStrategy.OnPush, providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            multi: true,
                            useExisting: UiCheckboxComponent
                        },
                        {
                            provide: NG_VALIDATORS,
                            multi: true,
                            useExisting: UiCheckboxComponent
                        }
                    ], template: "<div *ngIf=\"!readonly; else readOnly\" [ngClass]=\"[disabled ? 'disabled' : '']\" class=\"checkbox__wrapper\">\n  <label [for]=\"name + '_' + id\">\n    <input\n      [(ngModel)]=\"value\"\n      (ngModelChange)=\"onCheck($event)\"\n      [disabled]=\"disabled\"\n      [id]=\"name + '_' + id\"\n      [name]=\"name\"\n      [required]=\"required\"\n      class=\"checkbox__input\"\n      type=\"checkbox\"\n      #checkboxInput\n    />\n    <span class=\"checkbox__inner-wrapper\">\n      <span\n        [ngClass]=\"[active ? 'active' : '', disabled ? 'disabled' : '', invalid && !disabled ? 'invalid' : '']\"\n        class=\"checkbox\"\n      >\n        <span class=\"checkbox__checkmark\">\n          <sie-icon\n            *ngIf=\"value; else indeterminateIcon\"\n            class=\"checkbox__checkmark__icon\"\n            [name]=\"iconReg.sieIcon.CheckMark\"\n          ></sie-icon>\n        </span>\n      </span>\n    </span>\n    <span *ngIf=\"label || (labelAppendix$ | async) || icons\" [ngClass]=\"{ invalid: invalid }\" class=\"checkbox__label\"\n      ><span *ngIf=\"label || (labelAppendix$ | async)\" class=\"checkbox__label__text\"\n        >{{ label }}{{ labelAppendix$ | async }}<ng-container *ngIf=\"required\">*</ng-container></span\n      >\n      <ng-content select=\"[slot=label-content]\"></ng-content>\n      <span *ngIf=\"icons\"\n        ><sie-icon *ngFor=\"let icon of icons\" [name]=\"icon\" class=\"checkbox__label__icon\"></sie-icon\n      ></span>\n      <span *ngIf=\"hint?.type === 'tooltip' && hint?.content\">\n        <sie-icon\n          class=\"checkbox__label__tooltip-icon\"\n          sieUiPopover\n          [popoverSize]=\"hint?.size ? hint?.size : 's'\"\n          [content]=\"hint?.content\"\n          [name]=\"iconReg.sieIcon.Information\"\n        ></sie-icon>\n      </span>\n    </span>\n  </label>\n  <sie-ui-richtext *ngIf=\"hint?.type === 'inline' && hint?.content\" [content]=\"hint.content\"></sie-ui-richtext>\n</div>\n<ng-template #indeterminateIcon>\n  <div *ngIf=\"indeterminate\" class=\"checkbox__checkmark__indeterminate\"></div>\n</ng-template>\n<ng-template #readOnly>\n  <div class=\"checkbox__readonly\">\n    <div class=\"checkbox__readonly__checkmark\" [ngClass]=\"{ standard: !indeterminate }\">\n      <span\n        *ngIf=\"!readOnlyCheckmarkIcon; else readOnlyCheckmarkIcon\"\n        class=\"checkbox__readonly__inner__checkmark\"\n      ></span>\n    </div>\n    <span *ngIf=\"label || (labelAppendix$ | async) || icons\" class=\"checkbox__readonly__label\"\n      ><span *ngIf=\"label || (labelAppendix$ | async)\" class=\"checkbox__readonly__label__text\"\n        >{{ label }}{{ labelAppendix$ | async }}</span\n      ><span *ngIf=\"icons\"\n        ><sie-icon *ngFor=\"let icon of icons\" [name]=\"icon\" class=\"checkbox__label__icon\"></sie-icon\n      ></span>\n      <span *ngIf=\"hint?.type === 'tooltip' && hint?.content\">\n        <sie-icon\n          class=\"checkbox__label__tooltip-icon\"\n          sieUiPopover\n          [popoverSize]=\"hint?.size ? hint?.size : 's'\"\n          [content]=\"hint?.content\"\n          [name]=\"iconReg.sieIcon.Information\"\n        ></sie-icon>\n      </span>\n    </span>\n  </div>\n  <sie-ui-richtext\n    class=\"checkbox__readonly__inline-hint\"\n    *ngIf=\"hint?.type === 'inline' && hint?.content\"\n    [content]=\"hint.content\"\n  ></sie-ui-richtext>\n</ng-template>\n<ng-template #readOnlyCheckmarkIcon>\n  <sie-icon\n    *ngIf=\"!this.indeterminate; else indeterminateIcon\"\n    class=\"checkbox__readonly__checkmark__icon\"\n    [name]=\"iconReg.sieIcon.CheckMark\"\n  ></sie-icon>\n</ng-template>\n", styles: [".checkbox__input:focus,.checkbox__input:focus-visible{outline:0}.checkbox{position:absolute;top:0;left:0;height:20px;width:20px;background-color:#fff;display:flex;justify-content:center;align-items:center}.checkbox__checkmark{position:absolute;display:flex}.checkbox__checkmark__indeterminate{display:flex;background-color:#00646e;width:14px;height:14px}.checkbox:after,.checkbox:before{content:\"\";position:absolute;display:none}.checkbox:before{display:block;top:0;left:0;width:20px;height:20px;background-color:#ebf7f8;border:1px solid #4c4c68}.checkbox__label{color:#000028;word-break:break-word}.checkbox__label.invalid{color:#ef0137}.checkbox__label__text{margin-right:8px}.checkbox__label__tooltip-icon{color:#4c4c68}.checkbox__label__icon,.checkbox__label__tooltip-icon{width:auto;height:24px;display:flex;align-items:center;fill:currentColor;display:inline-block;margin-right:8px}.checkbox__label__icon svg,.checkbox__label__tooltip-icon svg{fill:currentColor;width:inherit;height:inherit}.checkbox__label__icon svg g,.checkbox__label__tooltip-icon svg g{fill:currentColor;width:inherit;height:inherit}.checkbox__label__icon svg text,.checkbox__label__tooltip-icon svg text{font-family:Siemens Sans,sans-serif}.checkbox__label__icon svg,.checkbox__label__tooltip-icon svg{max-width:30px}.checkbox__input{position:absolute;opacity:0}.checkbox__input~.checkbox__inner-wrapper{width:20px;height:20px;min-width:20px;position:relative;display:inline-block;align-self:flex-start;margin-top:1px;margin-right:8px}.checkbox__input~.checkbox__inner-wrapper .checkbox:not(.active):before{border-color:#4c4c68}.checkbox__input~.checkbox__inner-wrapper .checkbox.active:before{border-color:#00646e}.checkbox__input~.checkbox__inner-wrapper .checkbox.invalid:before{border-color:#ef0137}.checkbox__input~.checkbox__inner-wrapper .checkbox:after{background-color:#00183b}.checkbox__input~.checkbox__inner-wrapper .checkbox.disabled:before{border-color:#b3b3be}.checkbox__input:focus~.checkbox__inner-wrapper:before{content:\"\";position:absolute;inset:-3px;z-index:1;border:1px solid #1491eb;border-radius:0}.checkbox__input:focus-visible~.checkbox__inner-wrapper:before{content:\"\";position:absolute;inset:-3px;z-index:1;border:1px solid #1491eb;border-radius:0}.checkbox__input:checked~.checkbox__inner-wrapper .checkbox__checkmark__icon{color:#00646e;width:14px;height:14px;display:flex;align-items:center;fill:currentColor}.checkbox__input:checked~.checkbox__inner-wrapper .checkbox__checkmark__icon svg{fill:currentColor;width:inherit;height:inherit}.checkbox__input:checked~.checkbox__inner-wrapper .checkbox__checkmark__icon svg g{fill:currentColor;width:inherit;height:inherit}.checkbox__input:checked~.checkbox__inner-wrapper .checkbox__checkmark__icon svg text{font-family:Siemens Sans,sans-serif}.checkbox__input:checked~.checkbox__inner-wrapper .checkbox:after{display:block}.checkbox__input:checked~.checkbox__inner-wrapper .checkbox.disabled .checkbox__checkmark__icon{color:#b3b3be}.checkbox__input:checked~.checkbox__inner-wrapper .checkbox.disabled .checkbox__checkmark__indeterminate{background-color:#b3b3be}.checkbox__input:checked~.checkbox__inner-wrapper .checkbox:not(.disabled):before{border-color:#33747a}.checkbox__input:focus:not(:focus-visible)~.checkbox__inner-wrapper:before{border:none}.checkbox__input:not(:disabled):active~.checkbox__inner-wrapper .checkbox:not(.invalid):before{border-color:#33747a}.checkbox__wrapper{position:relative}.checkbox__wrapper sie-ui-richtext{display:flex;width:100%;color:#4c4c68;font-size:.75rem;font-weight:400;line-height:1rem}.checkbox__wrapper label{display:flex;cursor:pointer;align-items:center}.checkbox__wrapper:hover .checkbox__input:not(:disabled)~.checkbox__inner-wrapper .checkbox.dark:not(.invalid):after{background:#00ffb9}.checkbox__wrapper:hover .checkbox__input:not(:disabled)~.checkbox__inner-wrapper .checkbox:not(.invalid):before,.checkbox__wrapper:hover .checkbox__input:not(:checked):not(:disabled)~.checkbox__inner-wrapper .checkbox:not(.invalid):before{background:#d1fff2;border-color:#33747a}.checkbox__wrapper:hover .checkbox__input:not(:disabled)~.checkbox__inner-wrapper .checkbox.dark:not(.invalid):before,.checkbox__wrapper:hover .checkbox__input:not(:checked):not(:disabled)~.checkbox__inner-wrapper .checkbox.dark:not(.invalid):before{background:#001f39;border-color:#00ffb9}.checkbox__wrapper.disabled .checkbox__label{color:#737389}.checkbox__wrapper.disabled label{cursor:not-allowed}.checkbox__readonly{display:flex;align-items:flex-start}.checkbox__readonly__inline-hint{display:flex;width:100%;color:#4c4c68;font-size:.75rem;font-weight:400;line-height:1rem}.checkbox__readonly__tooltip-icon{color:#4c4c68;width:auto;height:24px;display:flex;align-items:center;fill:currentColor}.checkbox__readonly__tooltip-icon svg{fill:currentColor;width:inherit;height:inherit}.checkbox__readonly__tooltip-icon svg g{fill:currentColor;width:inherit;height:inherit}.checkbox__readonly__tooltip-icon svg text{font-family:Siemens Sans,sans-serif}.checkbox__readonly__label{color:#000028;margin-top:2px;word-break:break-word}.checkbox__readonly__label__text{margin-right:8px}.checkbox__readonly__checkmark{border:1px #4c4c68 solid;background-color:#ebf7f8;display:inline-flex;justify-content:center;height:20px;width:20px;margin-top:-1px;margin-right:8px;flex-shrink:0}.checkbox__readonly__checkmark__icon{color:#4c4c68;width:14px;height:14px;display:flex;align-items:center;fill:currentColor}.checkbox__readonly__checkmark__icon svg{fill:currentColor;width:inherit;height:inherit}.checkbox__readonly__checkmark__icon svg g{fill:currentColor;width:inherit;height:inherit}.checkbox__readonly__checkmark__icon svg text{font-family:Siemens Sans,sans-serif}.checkbox__readonly__checkmark.standard{margin-top:7px;background-color:inherit;border:0}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }]; }, propDecorators: { checkboxElement: [{
                type: ViewChild,
                args: ['checkboxInput']
            }], id: [{
                type: Input
            }], checkboxIdToFocus: [{
                type: Input
            }], valueChange: [{
                type: Output
            }], indeterminate: [{
                type: Input
            }], value: [{
                type: Input
            }], active: [{
                type: Input
            }], required: [{
                type: Input
            }], icons: [{
                type: Input
            }], labelAppendix$: [{
                type: Input
            }] } });

/** @ignore */
const DEFAULT_MAX_SIZE_FOR_SCROLLBAR = 9;
/**
 * # Dropdown options component
 * Defines options which are displayed in the {@link UiDropdownMenuComponent } and cannot be used separately.
 */
class UiDropdownOptionsComponent {
    get options() {
        return this._options;
    }
    /**
     * @param value array of options {@link UiDropdownMenuModel}
     */
    set options(value) {
        this._options = value;
        this.registerIconsFromOptions();
    }
    /**
     * @param value adds spacing to icon styling if value is true
     * @default false
     */
    set displayIconSpace(value) {
        this._displayIconSpace = coerceBooleanProperty(value);
    }
    get displayIconSpace() {
        return this._displayIconSpace;
    }
    constructor(elementRef, iconReg) {
        this.elementRef = elementRef;
        this.iconReg = iconReg;
        /**
         * Defines the dropdown option {@link ThemeVariant theme}
         * @default 'light'
         */
        this.theme = 'light';
        /**
         * Defines the style of the menu {@link UiDropdownSelectionType selectionType}
         * @default 'single'
         */
        this.selectionType = 'single';
        /**
         * Selected {@link UiDropdownMenuModel dropdown options} values
         */
        this.selectedValues = [];
        /**
         * Defines dropdown options type {@link UiDropdownOptionType}
         * @default 'menu'
         */
        this.type = 'menu';
        /**
         * Adds styling for disabled checkmark if set to true
         * @default false
         */
        this.checkmarkDisabled = false;
        /**
         * Defines if overlay is open or closed
         * @default false
         */
        this.open = false;
        /**
         * Aria label for dropdown option
         * @default ''
         */
        this.ariaLabel = '';
        /**
         * Event triggered when an option in dropdown is selected {@link UiDropdownMenuModel}, please update {@link selectedValues} after processing the event
         */
        this.optionSelected = new EventEmitter();
        /**
         * Event triggered when an option is discarded
         */
        this.optionDiscarded = new EventEmitter();
        /** @ignore */
        this.maxSizeForScrollbar = DEFAULT_MAX_SIZE_FOR_SCROLLBAR;
        this._displayIconSpace = false;
        this._selectionIndex = -1;
        this.avoidPointerDownCollision = PointerDeviceService.avoidPointerDownCollision;
    }
    /** @ignore */
    isDisabled(index) {
        return this._options[index]?.disabled;
    }
    /** @ignore */
    onArrowHandler(e) {
        const direction = UiDropdownService.getDirectionForKey(e);
        if (direction === null) {
            return;
        }
        e.preventDefault();
        this._selectionIndex = UiDropdownService.nextSelectableIndexForKey(this._selectionIndex, direction, this._options);
        if (this._selectionIndex >= 0) {
            this.focusElement(this._selectionIndex);
        }
    }
    /**
     * Method to check whether element is focused or not
     * @returns boolean if focused or not
     */
    isElementFocused() {
        return this._selectionIndex >= 0;
    }
    /** @ignore */
    itemSelected(event, selectedItem) {
        event.preventDefault();
        if (!selectedItem.disabled) {
            this.optionSelected.emit(selectedItem);
        }
    }
    /** @ignore */
    handleEscapeDown(event) {
        event.stopPropagation();
        this.optionDiscarded.emit();
    }
    focusElement(index) {
        const nativeEl = this.elementRef.nativeElement;
        const newEl = nativeEl.querySelector('[data-index="' + index + '"]');
        if (!this.isDisabled(index) && newEl !== null) {
            newEl.focus();
        }
    }
    registerIconsFromOptions() {
        if (this._options) {
            this._options
                .map(o => o.icon)
                .filter(i => i)
                .forEach(i => this.iconReg.register(i));
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDropdownOptionsComponent, deps: [{ token: i0.ElementRef }, { token: i1.SieIconRegistryService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiDropdownOptionsComponent, selector: "sie-ui-dropdown-options", inputs: { options: "options", theme: "theme", selectionType: "selectionType", selectedValues: "selectedValues", displayIconSpace: "displayIconSpace", type: "type", checkmarkDisabled: "checkmarkDisabled", open: "open", ariaLabel: "ariaLabel" }, outputs: { optionSelected: "optionSelected", optionDiscarded: "optionDiscarded" }, ngImport: i0, template: "<ul class=\"dropdown__list\" [ngClass]=\"theme\" role=\"listbox\" [attr.aria-expanded]=\"open\" [attr.aria-label]=\"ariaLabel\">\n  <li\n    *ngFor=\"let option of options; let i = index\"\n    [attr.tabindex]=\"option.disabled ? '-1' : '0'\"\n    class=\"dropdown__item\"\n    [class.has-scrollbar]=\"options?.length > maxSizeForScrollbar\"\n    [class.checkmark-disabled]=\"checkmarkDisabled\"\n    [ngClass]=\"theme\"\n    role=\"option\"\n    [attr.data-index]=\"i\"\n    [attr.data-value]=\"option.value\"\n    [class.disabled]=\"option.disabled\"\n    [attr.aria-selected]=\"selectedValues.includes(option.value)\"\n    (keydown.enter)=\"itemSelected($event, option)\"\n    (keydown.space)=\"itemSelected($event, option)\"\n    (keydown.escape)=\"handleEscapeDown($event)\"\n    (click)=\"itemSelected($event, option)\"\n    (pointerdown)=\"avoidPointerDownCollision($event)\"\n  >\n    <div class=\"dropdown__item-content-wrapper\">\n      <ng-container *ngIf=\"selectionType === 'multiple'\">\n        <sie-ui-checkbox\n          class=\"dropdown__item-checkbox\"\n          [value]=\"selectedValues.includes(option.value)\"\n          [disabled]=\"option.disabled\"\n          (click)=\"$event.preventDefault()\"\n        ></sie-ui-checkbox>\n      </ng-container>\n      <div\n        *ngIf=\"type === 'dropdown-un-contained' || type === 'menu'\"\n        [ngClass]=\"displayIconSpace || option.icon ? 'dropdown__item-icon' : ''\"\n      >\n        <sie-icon *ngIf=\"option.icon\" [name]=\"option.icon\"></sie-icon>\n      </div>\n      <span\n        class=\"list-item-text\"\n        [innerHTML]=\"option.label + '' + (option.labelAppendix$ ? (option.labelAppendix$ | async) : '')\"\n        [sieCoreAttributes]=\"option.dataAttributes\"\n      ></span>\n      <ng-container *ngIf=\"selectionType === 'single' && selectedValues.includes(option.value)\">\n        <sie-icon aria-hidden=\"true\" [name]=\"iconReg.sieIcon.CheckMark\" class=\"dropdown__item-checkmark\"></sie-icon>\n      </ng-container>\n    </div>\n  </li>\n</ul>\n", styles: ["::-webkit-scrollbar-thumb{background-clip:padding-box;background-color:#737389}::-webkit-scrollbar-button{display:none}::-webkit-scrollbar-corner{background-color:transparent}::-webkit-scrollbar{width:16px;height:8px}:host{scrollbar-color:#737389 #fff}:host .dark,:host.dark{scrollbar-color:#ccccd4 #001f39}::-webkit-scrollbar-thumb:vertical{border-left:8px solid transparent;border-right:4px solid transparent}::-webkit-scrollbar-thumb:horizontal{border-top:4px solid transparent}::-webkit-scrollbar-track:vertical{border-left:8px solid #fff;background:#ccccd4;border-right:4px solid #fff}::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #ccccd4}.dark::-webkit-scrollbar-thumb,.dark ::-webkit-scrollbar-thumb{background-color:#ccccd4}.dark::-webkit-scrollbar-track:vertical,.dark ::-webkit-scrollbar-track:vertical{background:#737389;border-right:4px solid #001f39;border-left:8px solid #001f39}.dark::-webkit-scrollbar-track:horizontal,.dark ::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #737389}.dropdown__list{list-style:none;margin:0;padding:0;max-height:256px;overflow-y:auto}.dropdown__item{padding:4px 56px 4px 16px;min-height:32px;display:flex;align-items:center;color:#000028;position:relative}.dropdown__item-content-wrapper{display:flex;align-items:flex-start}.dropdown__item-checkbox{margin:auto 0}.dropdown__item-icon{display:inline-flex;justify-content:center;align-items:center;min-width:27px;margin-right:8px;margin-top:2px}.dropdown__item-icon sie-icon{width:24px;height:24px;display:flex;align-items:center;fill:currentColor}.dropdown__item-icon sie-icon svg{fill:currentColor;width:inherit;height:inherit}.dropdown__item-icon sie-icon svg g{fill:currentColor;width:inherit;height:inherit}.dropdown__item-icon sie-icon svg text{font-family:Siemens Sans,sans-serif}.dropdown__item .list-item-text{margin-top:2px}.dropdown__item.disabled{cursor:not-allowed;color:#b3b3be}.dropdown__item.disabled .dropdown__item-content-wrapper{pointer-events:none}.dropdown__item-checkmark{width:16px;height:16px;display:flex;align-items:center;fill:currentColor;position:absolute;right:16px;top:9px}.dropdown__item-checkmark svg{fill:currentColor;width:inherit;height:inherit}.dropdown__item-checkmark svg g{fill:currentColor;width:inherit;height:inherit}.dropdown__item-checkmark svg text{font-family:Siemens Sans,sans-serif}.dropdown__item.dark{color:#fff}.dropdown__item.dark.disabled{color:#737389}.dropdown__item.checkmark-disabled{padding:4px 16px}.dropdown__item:focus:not(.disabled),.dropdown__item:hover:not(.disabled),.dropdown__item.focused{background-color:#62eec7;outline:0;cursor:pointer}.dropdown__item.dark:focus:not(.disabled),.dropdown__item.dark:hover:not(.disabled),.dropdown__item.dark.focused{background-color:#005159}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "directive", type: i1$1.AttributeDirective, selector: "[sieCoreAttributes]", inputs: ["sieCoreAttributes"] }, { kind: "component", type: UiCheckboxComponent, selector: "sie-ui-checkbox", inputs: ["id", "checkboxIdToFocus", "indeterminate", "value", "active", "required", "icons", "labelAppendix$"], outputs: ["valueChange"] }, { kind: "pipe", type: i2.AsyncPipe, name: "async" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDropdownOptionsComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-dropdown-options', changeDetection: ChangeDetectionStrategy.OnPush, template: "<ul class=\"dropdown__list\" [ngClass]=\"theme\" role=\"listbox\" [attr.aria-expanded]=\"open\" [attr.aria-label]=\"ariaLabel\">\n  <li\n    *ngFor=\"let option of options; let i = index\"\n    [attr.tabindex]=\"option.disabled ? '-1' : '0'\"\n    class=\"dropdown__item\"\n    [class.has-scrollbar]=\"options?.length > maxSizeForScrollbar\"\n    [class.checkmark-disabled]=\"checkmarkDisabled\"\n    [ngClass]=\"theme\"\n    role=\"option\"\n    [attr.data-index]=\"i\"\n    [attr.data-value]=\"option.value\"\n    [class.disabled]=\"option.disabled\"\n    [attr.aria-selected]=\"selectedValues.includes(option.value)\"\n    (keydown.enter)=\"itemSelected($event, option)\"\n    (keydown.space)=\"itemSelected($event, option)\"\n    (keydown.escape)=\"handleEscapeDown($event)\"\n    (click)=\"itemSelected($event, option)\"\n    (pointerdown)=\"avoidPointerDownCollision($event)\"\n  >\n    <div class=\"dropdown__item-content-wrapper\">\n      <ng-container *ngIf=\"selectionType === 'multiple'\">\n        <sie-ui-checkbox\n          class=\"dropdown__item-checkbox\"\n          [value]=\"selectedValues.includes(option.value)\"\n          [disabled]=\"option.disabled\"\n          (click)=\"$event.preventDefault()\"\n        ></sie-ui-checkbox>\n      </ng-container>\n      <div\n        *ngIf=\"type === 'dropdown-un-contained' || type === 'menu'\"\n        [ngClass]=\"displayIconSpace || option.icon ? 'dropdown__item-icon' : ''\"\n      >\n        <sie-icon *ngIf=\"option.icon\" [name]=\"option.icon\"></sie-icon>\n      </div>\n      <span\n        class=\"list-item-text\"\n        [innerHTML]=\"option.label + '' + (option.labelAppendix$ ? (option.labelAppendix$ | async) : '')\"\n        [sieCoreAttributes]=\"option.dataAttributes\"\n      ></span>\n      <ng-container *ngIf=\"selectionType === 'single' && selectedValues.includes(option.value)\">\n        <sie-icon aria-hidden=\"true\" [name]=\"iconReg.sieIcon.CheckMark\" class=\"dropdown__item-checkmark\"></sie-icon>\n      </ng-container>\n    </div>\n  </li>\n</ul>\n", styles: ["::-webkit-scrollbar-thumb{background-clip:padding-box;background-color:#737389}::-webkit-scrollbar-button{display:none}::-webkit-scrollbar-corner{background-color:transparent}::-webkit-scrollbar{width:16px;height:8px}:host{scrollbar-color:#737389 #fff}:host .dark,:host.dark{scrollbar-color:#ccccd4 #001f39}::-webkit-scrollbar-thumb:vertical{border-left:8px solid transparent;border-right:4px solid transparent}::-webkit-scrollbar-thumb:horizontal{border-top:4px solid transparent}::-webkit-scrollbar-track:vertical{border-left:8px solid #fff;background:#ccccd4;border-right:4px solid #fff}::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #ccccd4}.dark::-webkit-scrollbar-thumb,.dark ::-webkit-scrollbar-thumb{background-color:#ccccd4}.dark::-webkit-scrollbar-track:vertical,.dark ::-webkit-scrollbar-track:vertical{background:#737389;border-right:4px solid #001f39;border-left:8px solid #001f39}.dark::-webkit-scrollbar-track:horizontal,.dark ::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #737389}.dropdown__list{list-style:none;margin:0;padding:0;max-height:256px;overflow-y:auto}.dropdown__item{padding:4px 56px 4px 16px;min-height:32px;display:flex;align-items:center;color:#000028;position:relative}.dropdown__item-content-wrapper{display:flex;align-items:flex-start}.dropdown__item-checkbox{margin:auto 0}.dropdown__item-icon{display:inline-flex;justify-content:center;align-items:center;min-width:27px;margin-right:8px;margin-top:2px}.dropdown__item-icon sie-icon{width:24px;height:24px;display:flex;align-items:center;fill:currentColor}.dropdown__item-icon sie-icon svg{fill:currentColor;width:inherit;height:inherit}.dropdown__item-icon sie-icon svg g{fill:currentColor;width:inherit;height:inherit}.dropdown__item-icon sie-icon svg text{font-family:Siemens Sans,sans-serif}.dropdown__item .list-item-text{margin-top:2px}.dropdown__item.disabled{cursor:not-allowed;color:#b3b3be}.dropdown__item.disabled .dropdown__item-content-wrapper{pointer-events:none}.dropdown__item-checkmark{width:16px;height:16px;display:flex;align-items:center;fill:currentColor;position:absolute;right:16px;top:9px}.dropdown__item-checkmark svg{fill:currentColor;width:inherit;height:inherit}.dropdown__item-checkmark svg g{fill:currentColor;width:inherit;height:inherit}.dropdown__item-checkmark svg text{font-family:Siemens Sans,sans-serif}.dropdown__item.dark{color:#fff}.dropdown__item.dark.disabled{color:#737389}.dropdown__item.checkmark-disabled{padding:4px 16px}.dropdown__item:focus:not(.disabled),.dropdown__item:hover:not(.disabled),.dropdown__item.focused{background-color:#62eec7;outline:0;cursor:pointer}.dropdown__item.dark:focus:not(.disabled),.dropdown__item.dark:hover:not(.disabled),.dropdown__item.dark.focused{background-color:#005159}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: i1.SieIconRegistryService }]; }, propDecorators: { options: [{
                type: Input
            }], theme: [{
                type: Input
            }], selectionType: [{
                type: Input
            }], selectedValues: [{
                type: Input
            }], displayIconSpace: [{
                type: Input
            }], type: [{
                type: Input
            }], checkmarkDisabled: [{
                type: Input
            }], open: [{
                type: Input
            }], ariaLabel: [{
                type: Input
            }], optionSelected: [{
                type: Output
            }], optionDiscarded: [{
                type: Output
            }] } });

const FORM_COMPONENT_ACCESSOR = new InjectionToken('FORM_COMPONENT_ACCESSOR');

class UiReadonlyComponent {
    set icons(icons) {
        this._icons = icons;
        if (icons) {
            icons.forEach(icon => {
                this.iconReg.register(icon);
            });
        }
    }
    get icons() {
        return this._icons;
    }
    constructor(iconReg) {
        this.iconReg = iconReg;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiReadonlyComponent, deps: [{ token: i1.SieIconRegistryService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiReadonlyComponent, selector: "sie-ui-readonly", inputs: { value: "value", label: "label", displayValue: "displayValue", name: "name", theme: "theme", icons: "icons" }, ngImport: i0, template: "<div [ngClass]=\"theme\" class=\"readonly\">\n  <div class=\"readonly__item\">\n    <input [name]=\"name\" [value]=\"value\" type=\"hidden\" />\n    <span class=\"readonly__title\">{{ label }}</span>\n    <span class=\"readonly__label\"\n      ><span class=\"readonly__label__text\">{{ displayValue }}</span>\n      <span *ngIf=\"icons\"\n        ><sie-icon *ngFor=\"let icon of icons\" [name]=\"icon\" class=\"readonly__label__icon\"></sie-icon></span\n    ></span>\n  </div>\n</div>\n", styles: [".readonly__item{margin-bottom:13px}.readonly__title{font-size:.75rem;font-weight:400;line-height:1rem;display:block;color:#4c4c68}.readonly__label{display:block;color:#000028}.readonly__label__text{margin-right:8px}.readonly__label__icon{width:auto;height:20px;display:flex;align-items:center;fill:currentColor;display:inline-block;margin-right:8px}.readonly__label__icon svg{fill:currentColor;width:inherit;height:inherit}.readonly__label__icon svg g{fill:currentColor;width:inherit;height:inherit}.readonly__label__icon svg text{font-family:Siemens Sans,sans-serif}.readonly__label__icon svg{max-width:30px}.readonly.dark .readonly__title{color:#ccccd4}.readonly.dark .readonly__label{color:#fff}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiReadonlyComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-readonly', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div [ngClass]=\"theme\" class=\"readonly\">\n  <div class=\"readonly__item\">\n    <input [name]=\"name\" [value]=\"value\" type=\"hidden\" />\n    <span class=\"readonly__title\">{{ label }}</span>\n    <span class=\"readonly__label\"\n      ><span class=\"readonly__label__text\">{{ displayValue }}</span>\n      <span *ngIf=\"icons\"\n        ><sie-icon *ngFor=\"let icon of icons\" [name]=\"icon\" class=\"readonly__label__icon\"></sie-icon></span\n    ></span>\n  </div>\n</div>\n", styles: [".readonly__item{margin-bottom:13px}.readonly__title{font-size:.75rem;font-weight:400;line-height:1rem;display:block;color:#4c4c68}.readonly__label{display:block;color:#000028}.readonly__label__text{margin-right:8px}.readonly__label__icon{width:auto;height:20px;display:flex;align-items:center;fill:currentColor;display:inline-block;margin-right:8px}.readonly__label__icon svg{fill:currentColor;width:inherit;height:inherit}.readonly__label__icon svg g{fill:currentColor;width:inherit;height:inherit}.readonly__label__icon svg text{font-family:Siemens Sans,sans-serif}.readonly__label__icon svg{max-width:30px}.readonly.dark .readonly__title{color:#ccccd4}.readonly.dark .readonly__label{color:#fff}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }]; }, propDecorators: { value: [{
                type: Input
            }], label: [{
                type: Input
            }], displayValue: [{
                type: Input
            }], name: [{
                type: Input
            }], theme: [{
                type: Input
            }], icons: [{
                type: Input
            }] } });

/**
 * # Icon Button component
 *
 * Icon Buttons are used to trigger some kind of action such as submitting, deleting, showing or hiding the content.
 *
 * ## Component variations
 *
 * Button type: 'button'
 *
 * ## Content
 *
 * The Icon Button component does not accept any content.
 *
 * ## Code example
 * @example ```html
 * <sie-ui-icon-button
 *  [theme]="'dark'"
 *  [disabled]="true"
 *  [icon]="'ShoppingCart'"
 *  [iconScreenReaderText]="'Shopping cart icon'"
 * ></sie-ui-icon-button>
 * ```
 */
class UiIconButtonComponent {
    /**
     * @param icon Defines which {@link SieIcon icon} should be displayed inside the button.
     * @default SieIcon.CloseSmall close icon
     */
    set icon(icon) {
        if (icon) {
            this.iconReg.register(icon);
        }
        this._icon = icon;
    }
    get icon() {
        return this._icon;
    }
    constructor(iconReg) {
        this.iconReg = iconReg;
        /**
         * Defines {@link ThemeVariant Variant} theme
         * @default 'light'
         */
        this.theme = 'light';
        /**
         * Defines if icon-button is displayed in disable state
         * @default false
         */
        this.disabled = false;
        /**
         * Defines for the hover state whether coloured styling should be applied
         * @default false
         */
        this.hoverColored = false;
        /**
         * Event triggered when the button is clicked.
         */
        this.clicked = new EventEmitter();
        this._icon = SieIcon.CloseSmall;
        this.iconReg.register(SieIcon.CloseSmall);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiIconButtonComponent, deps: [{ token: i1.SieIconRegistryService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiIconButtonComponent, selector: "sie-ui-icon-button", inputs: { theme: "theme", disabled: "disabled", hoverColored: "hoverColored", iconScreenReaderText: "iconScreenReaderText", icon: "icon" }, outputs: { clicked: "clicked" }, ngImport: i0, template: "<button\n  class=\"icon-button\"\n  [ngClass]=\"['bg-' + theme, hoverColored ? 'hover-colored' : '']\"\n  [type]=\"'button'\"\n  [disabled]=\"disabled ? 'disabled' : ''\"\n  (click)=\"clicked.next($event)\"\n  (keyup.enter)=\"clicked.next($event)\"\n>\n  <sie-icon class=\"icon-button__icon\" [name]=\"icon\" aria-hidden=\"true\"></sie-icon>\n  <span *ngIf=\"iconScreenReaderText\" class=\"visually-hidden\">{{ iconScreenReaderText }}</span>\n</button>\n", styles: [".icon-button:focus,.icon-button:focus-visible{outline:0}.icon-button{display:inline-flex;align-items:center;background:transparent;border:none;padding:0;cursor:pointer}.icon-button.bg-light{color:#4c4c68;fill:#4c4c68}.icon-button.bg-light.hover-colored:hover{color:#33747a;fill:#33747a}.icon-button.bg-light:disabled{color:#b3b3be;fill:#b3b3be}.icon-button.bg-dark,.icon-button.bg-dark:hover{color:#ccccd4;fill:#ccccd4}.icon-button.bg-dark:disabled{color:#4c4c68;fill:#4c4c68}.icon-button:disabled{cursor:not-allowed}.icon-button:focus:before,.icon-button:focus-visible:before{content:\"\";position:absolute;inset:-2px -2px 5px;z-index:1;border:1px solid #1491eb}.icon-button:focus:not(:focus-visible):before{border:none}.icon-button__icon{width:20px;height:20px;display:flex;align-items:center;fill:currentColor}.icon-button__icon svg{fill:currentColor;width:inherit;height:inherit}.icon-button__icon svg g{fill:currentColor;width:inherit;height:inherit}.icon-button__icon svg text{font-family:Siemens Sans,sans-serif}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiIconButtonComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-icon-button', changeDetection: ChangeDetectionStrategy.OnPush, template: "<button\n  class=\"icon-button\"\n  [ngClass]=\"['bg-' + theme, hoverColored ? 'hover-colored' : '']\"\n  [type]=\"'button'\"\n  [disabled]=\"disabled ? 'disabled' : ''\"\n  (click)=\"clicked.next($event)\"\n  (keyup.enter)=\"clicked.next($event)\"\n>\n  <sie-icon class=\"icon-button__icon\" [name]=\"icon\" aria-hidden=\"true\"></sie-icon>\n  <span *ngIf=\"iconScreenReaderText\" class=\"visually-hidden\">{{ iconScreenReaderText }}</span>\n</button>\n", styles: [".icon-button:focus,.icon-button:focus-visible{outline:0}.icon-button{display:inline-flex;align-items:center;background:transparent;border:none;padding:0;cursor:pointer}.icon-button.bg-light{color:#4c4c68;fill:#4c4c68}.icon-button.bg-light.hover-colored:hover{color:#33747a;fill:#33747a}.icon-button.bg-light:disabled{color:#b3b3be;fill:#b3b3be}.icon-button.bg-dark,.icon-button.bg-dark:hover{color:#ccccd4;fill:#ccccd4}.icon-button.bg-dark:disabled{color:#4c4c68;fill:#4c4c68}.icon-button:disabled{cursor:not-allowed}.icon-button:focus:before,.icon-button:focus-visible:before{content:\"\";position:absolute;inset:-2px -2px 5px;z-index:1;border:1px solid #1491eb}.icon-button:focus:not(:focus-visible):before{border:none}.icon-button__icon{width:20px;height:20px;display:flex;align-items:center;fill:currentColor}.icon-button__icon svg{fill:currentColor;width:inherit;height:inherit}.icon-button__icon svg g{fill:currentColor;width:inherit;height:inherit}.icon-button__icon svg text{font-family:Siemens Sans,sans-serif}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }]; }, propDecorators: { theme: [{
                type: Input
            }], disabled: [{
                type: Input
            }], hoverColored: [{
                type: Input
            }], iconScreenReaderText: [{
                type: Input
            }], icon: [{
                type: Input
            }], clicked: [{
                type: Output
            }] } });

class UiDropdownComponentFormControlDirective extends NgFormControlDirective {
    constructor(component) {
        super();
        this.component = component;
    }
    /** @ignore */
    validateInternal(control) {
        if (this.component.required &&
            (control.value === undefined || control.value === null || control.value.trim() === '')) {
            return {
                required: true
            };
        }
        return null;
    }
    /** @ignore */
    writeValue(value) {
        this.component.selectedValue = value;
    }
    set invalid(value) {
        this.component.invalid = value;
    }
}
/**
 * # Dropdown Component
 * Dropdowns provide a list of options out of which users can pick one. It is used when a list of multiple options must
 * be provided to the user, but are not shown open persistently.
 *
 * ## Component variations
 *
 * - Contained (on light)
 * - Uncontained (on light and on dark)
 * - Disabled
 * - Readonly
 * - Invalid
 * - Required
 *
 * ## Content
 * The dropdown component does not accept any content.
 *
 * ## Code example
 *
 * @example ```html
 *
 * <sie-ui-dropdown
 *  [options]="dropdownData.data"
 *  placeholder="Please select"
 *  [theme]="dropdownData.theme"
 *  [clearInputEnabled]="true">
 * </sie-ui-dropdown>
 * ```
 *
 * ```ts
 * const dropdownData = {
 *  data: [
 *    { value: null, label: '&lt;please select&gt;', disabled: false },
 *    { value: '1', label: 'Engineering', disabled: false, icon: 'SieportalIntIdleWithBorderTag' },
 *    {
 *      value: '2',
 *      label: 'Environmental Protection, Health & Safety',
 *      disabled: false,
 *      icon: 'SieportalExtIdleWithBorderTag'
 *    },
 *    { value: '3', label: 'General Management', disabled: false },
 *    { value: '4', label: 'Information Technology', disabled: false },
 *    { value: '5', label: 'Legal & Compliance', disabled: false },
 *    { value: '6', label: 'Maintenance & Operation', disabled: false },
 *    { value: '7', label: 'Manufacturing', disabled: false },
 *    { value: '8', label: 'Product Management', disabled: false },
 *    { value: '9', label: 'SCM-Procurement', disabled: false }
 *  ],
 *  selectedValue: null,
 *  customClass: 'dropdown--big',
 *  theme: 'light'
 * };
 * ```
 */
class UiDropdownComponent extends UiDropdownBaseDirective {
    get condensed() {
        return this._condensed;
    }
    /**
     * @param value manages a label on top of dropdown and dropdown height
     * @default false
     */
    set condensed(value) {
        this._condensed = coerceBooleanProperty(value);
    }
    get options() {
        return super.options;
    }
    /**
     * @param value defines dropdown content {@link UiDropdownModel}
     */
    set options(value) {
        super.options = value;
        this.updateSelectedItem();
    }
    /**
     * @param selectedValue Defines which option of the component is selected by default (controlled through `value` set in `options` input)
     */
    set selectedValue(selectedValue) {
        if (this._options) {
            this.selectedItem = this._options.find(option => option.value === selectedValue);
        }
        else {
            this.selectedItem = null;
        }
        this.updateTracking();
    }
    /**
     * @param value adds styles for required state to the placeholder when set to true
     * @default false
     */
    set required(value) {
        this._required = coerceBooleanProperty(value);
    }
    get required() {
        return this._required;
    }
    /**
     * @param value adds styles for readonly state to the placeholder when set to true
     * @default false
     */
    set readonly(value) {
        this._readonly = coerceBooleanProperty(value);
    }
    get readonly() {
        return this._readonly;
    }
    /**
     * @param value adds styles for invalid state when set to true
     * @default false
     */
    set invalid(value) {
        this._invalid = coerceBooleanProperty(value);
    }
    get invalid() {
        return this._invalid;
    }
    /**
     * @param hint  hint displayed at the dropdown {@link HintModel}
     */
    set hint(hint) {
        setDefaultsForHint(hint);
        this._hint = hint;
    }
    get hint() {
        return this._hint;
    }
    constructor(iconReg, eventPropagationService, elementRef, cdr, cdkOverlayService, layoutService) {
        super(cdr, elementRef, eventPropagationService, cdkOverlayService);
        this.iconReg = iconReg;
        this.eventPropagationService = eventPropagationService;
        this.elementRef = elementRef;
        this.cdr = cdr;
        this.cdkOverlayService = cdkOverlayService;
        this.layoutService = layoutService;
        /**
         * Defines dropdown type {@link DropdownType }
         * @default 'un-contained'
         */
        this.type = 'un-contained';
        /**
         * Used to add custom ccs classes to the dropdown
         * @default ''
         */
        this.customClass = '';
        /** @ignore SPA use only */
        this.marginBottomOnInvalidState = '20px';
        this._disabled = false;
        this._readonly = false;
        this._invalid = false;
        this._hint = null;
        // form control inputs end
        /**
         * Event triggered when a different option in dropdown is selected
         */
        this.selectionChanged = new EventEmitter();
        /** @ignore */
        this.selectedItem = null;
        /** @ignore */
        this.leftStyle = '0';
        /** @ignore */
        this.cdkOverlayOffsetX = CDK_OVERLAY_OFFSET_X;
        /** @ignore */
        this.trackingDataAttr = {};
        this.buffer = [];
        this._required = false;
        this._condensed = false;
        this._ngFormControlDirective = new UiDropdownComponentFormControlDirective(this);
        iconReg.register(SieIcon.Dropdown);
        iconReg.register(SieIcon.CheckMark);
    }
    /** @ignore */
    ngOnInit() {
        this.breakpointSubscription = this.layoutService.breakPointChangedEvent.subscribe(() => {
            if (this.menuOpen) {
                this.recalculatePositions();
            }
        });
    }
    /** @ignore */
    ngOnDestroy() {
        this.closeOverlay();
        if (this.breakpointSubscription) {
            this.breakpointSubscription.unsubscribe();
        }
    }
    /** @ignore */
    itemSelected(selectedItem) {
        if (!selectedItem.disabled) {
            this.selectedItem = selectedItem;
            this.selectionChanged.emit(this.selectedItem.value);
            this._ngFormControlDirective.markAsTouched();
            this._ngFormControlDirective.onChange(this.selectedItem.value);
            this.dispatchChangeEvent();
            this.closeOverlay(true);
            this.eventPropagationService.stopPrevention();
            this.updateTracking();
        }
    }
    /** @ignore */
    keydownSearch(event) {
        const key = event.key;
        const currentTime = Date.now();
        if (currentTime - this.lastKeyTime > 1000) {
            this.buffer = [];
        }
        this.buffer.push(key);
        const searchedValue = this.buffer.join('').toLocaleLowerCase();
        const foundIndex = this._options.findIndex(option => option.label.toLocaleLowerCase().startsWith(searchedValue));
        if (foundIndex >= 0) {
            this.focusElement(foundIndex);
        }
        this.lastKeyTime = currentTime;
    }
    determineHorizontalMenuAlignment() {
        if (this.type !== 'un-contained') {
            return;
        }
        this.cdr.detectChanges();
        const xPlusWidthOfOverlay = this.elementRef.nativeElement.getBoundingClientRect().left +
            this.dropDownMenu?.elementRef.nativeElement.offsetWidth +
            this.layoutService.getScrollbarWidth();
        const browserWidth = this.layoutService.isViewport('XS', 'S', 'M') ? window.outerWidth : window.innerWidth;
        let leftPosition = this.layoutService.isViewport('XS', 'S', 'M') ? '0' : '-' + ComponentDropdownOffsetLeftGteM;
        if (xPlusWidthOfOverlay > browserWidth) {
            leftPosition = '-' + (xPlusWidthOfOverlay - browserWidth) + 'px';
        }
        this.leftStyle = leftPosition;
    }
    updateSelectedItem() {
        if (this._options) {
            if (this.selectedItem) {
                this.selectedItem = this._options.find(option => option.value === this.selectedItem.value);
            }
        }
        else {
            this.selectedItem = null;
        }
    }
    updateTracking() {
        this.trackingDataAttr = {};
        if (this.selectedItem?.trackingAttributeName) {
            this.trackingDataAttr = { [this.selectedItem.trackingAttributeName]: this.selectedItem.trackingAttributeValue };
        }
    }
    /** @ignore */
    focusOut() {
        if (this.optionsComponent?.isElementFocused()) {
            return;
        }
        super.focusOut();
    }
    /** @ignore */
    onResetButtonClicked(selector) {
        this.selectedItem = null;
        super.onResetButtonClicked(selector ?? '.dropdown__button');
        this.dispatchChangeEvent();
    }
    // ControlValueAccessor impl begin
    /**
     * Concrete implementation of {@link ControlValueAccessor ControlValueAccessor.registerOnChange} method allowing
     * changing `onChange` function
     * @param fn callback function
     */
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    registerOnChange(fn) {
        this._ngFormControlDirective.registerOnChange(fn);
    }
    /**
     * Concrete implementation of {@link ControlValueAccessor ControlValueAccessor.registerOnTouched} method allowing
     * changing `onTouched` function
     * @param fn callback function
     */
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    registerOnTouched(fn) {
        this._ngFormControlDirective.registerOnTouched(fn);
    }
    /**
     * Concrete implementation of {@link ControlValueAccessor ControlValueAccessor.setDisabledState} method allowing
     * setting/removing the component's disabled state
     * @param disabled whether the component shall be enabled or disabled
     */
    setDisabledState(disabled) {
        this._ngFormControlDirective.setDisabledState(disabled);
        this._disabled = disabled;
    }
    /**
     * Method to be implemented allowing Angular's FormModule two-way binding the control
     * @param obj value to be set
     */
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    writeValue(obj) {
        this._ngFormControlDirective.writeValue(obj);
    }
    // ControlValueAccessor impl end
    /**
     * Concrete implementation of {@link ControlValueAccessor ControlValueAccessor.registerOnValidatorChange} method
     * allowing changing `onValidatorChanged` function
     * @param fn callback function
     */
    // Validator impl begin
    registerOnValidatorChange(fn) {
        this._ngFormControlDirective.registerOnValidatorChange(fn);
    }
    /**
     * Concrete implementation that wraps abstract `validateInternal` method
     * @param control Concrete access to {@link AbstractControl form control object}
     * @return checkout {@link Validator}
     */
    validate(control) {
        return this._ngFormControlDirective.validate(control);
    }
    // Validator impl end
    dispatchChangeEvent() {
        const event = new Event('change', { bubbles: true });
        this.elementRef.nativeElement.dispatchEvent(event);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDropdownComponent, deps: [{ token: i1.SieIconRegistryService }, { token: UiEventPropagationService }, { token: i0.ElementRef }, { token: i0.ChangeDetectorRef }, { token: CdkOverlayService }, { token: i1$1.LayoutService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiDropdownComponent, selector: "sie-ui-dropdown", inputs: { type: "type", condensed: "condensed", options: "options", selectedValue: "selectedValue", required: "required", id: "id", name: "name", label: "label", placeholder: "placeholder", errorMessage: "errorMessage", customClass: "customClass", readonly: "readonly", invalid: "invalid", hint: "hint", marginBottomOnInvalidState: "marginBottomOnInvalidState" }, outputs: { selectionChanged: "selectionChanged" }, providers: [
            {
                provide: NG_VALUE_ACCESSOR,
                multi: true,
                useExisting: UiDropdownComponent
            },
            {
                provide: NG_VALIDATORS,
                multi: true,
                useExisting: UiDropdownComponent
            },
            UiEventPropagationService,
            {
                provide: FORM_COMPONENT_ACCESSOR,
                useExisting: forwardRef(() => UiDropdownComponent)
            }
        ], viewQueries: [{ propertyName: "optionsComponent", first: true, predicate: UiDropdownOptionsComponent, descendants: true }], usesInheritance: true, ngImport: i0, template: "<div\n  *ngIf=\"condensed && type === 'contained' && !readonly && label\"\n  [ngClass]=\"label ? 'dropdown--condensed' : ''\"\n  [innerHTML]=\"required ? label + '*' : label\"\n></div>\n<div\n  *ngIf=\"!readonly; else readOnly\"\n  class=\"dropdown dropdown--{{ type }}\"\n  [ngClass]=\"customClass\"\n  [class.disabled]=\"disabled\"\n  [class.invalid]=\"invalid\"\n  [style.margin-bottom]=\"invalid ? marginBottomOnInvalidState : null\"\n  [class.selected]=\"selectedItem\"\n  (focusin)=\"focusIn()\"\n  (focusout)=\"focusOut()\"\n  (keydown)=\"keydownSearch($event)\"\n  #dropDownRendering\n>\n  <div [ngClass]=\"clearInputEnabled && selectedItem ? 'dropdown__wrapper' : ''\">\n    <div\n      class=\"dropdown__button\"\n      [attr.tabindex]=\"disabled ? -1 : 0\"\n      [attr.aria-haspopup]=\"'listbox'\"\n      [attr.aria-label]=\"selectedItem ? label + ' ' + selectedItem.label : ''\"\n      [attr.id]=\"id\"\n      (keydown.enter)=\"toggleDropDown()\"\n      (keydown.space)=\"toggleDropDown($event)\"\n      (keydown.arrowDown)=\"onArrowDownOnButton($event)\"\n      (keydown.escape)=\"handleEscape($event)\"\n      (keyup.escape)=\"eventPropagationService.handleEvent($event)\"\n      [ngClass]=\"{\n        open: menuOpen,\n        dark: theme === 'dark',\n        light: theme === 'light',\n        condensed: condensed\n      }\"\n      role=\"button\"\n      #dropDownElement\n      (click)=\"toggleDropDown()\"\n      type=\"button\"\n      cdkOverlayOrigin\n      #trigger=\"cdkOverlayOrigin\"\n    >\n      <span *ngIf=\"screenReaderText && screenReaderText.length > 0\" class=\"visually-hidden\">{{\n        screenReaderText\n      }}</span>\n      <ng-container *ngIf=\"type === 'un-contained'; else containedDropdown\">\n        <div class=\"selected-label__icon\" *ngIf=\"selectedItem?.icon\">\n          <sie-icon [name]=\"selectedItem.icon\" [ngClass]=\"clearInputEnabled && selectedItem ? 'reset' : ''\"></sie-icon>\n        </div>\n        <span\n          class=\"selected-label\"\n          aria-hidden=\"true\"\n          [innerHTML]=\"selectedItem ? selectedItem.label : placeholder\"\n          [sieCoreAttributes]=\"trackingDataAttr\"\n          [title]=\"selectedItem ? selectedItem.label : ''\"\n        ></span>\n      </ng-container>\n\n      <ng-template #containedDropdown>\n        <ng-container *ngIf=\"condensed; else containedLabels\">\n          <span\n            class=\"label\"\n            [ngClass]=\"{ itemSelected: selectedItem }\"\n            [innerHTML]=\"condensed && !selectedItem ? placeholder : ''\"\n          ></span>\n          <span class=\"selected-label-condensed\" [innerHTML]=\"selectedItem?.label\" [title]=\"selectedItem?.label\"></span>\n        </ng-container>\n        <ng-template #containedLabels>\n          <span\n            class=\"label\"\n            [ngClass]=\"{ itemSelected: selectedItem }\"\n            [innerHTML]=\"required ? placeholder + '*' : placeholder\"\n          ></span>\n          <span\n            *ngIf=\"!!selectedItem\"\n            class=\"selected-label\"\n            [ngClass]=\"{ 'no-placeholder': !placeholder }\"\n            [innerHTML]=\"\n              selectedItem.label + '' + (selectedItem.labelAppendix$ ? (selectedItem.labelAppendix$ | async) : '')\n            \"\n            [title]=\"\n              selectedItem.label + '' + (selectedItem.labelAppendix$ ? (selectedItem.labelAppendix$ | async) : '')\n            \"\n          ></span>\n        </ng-template>\n      </ng-template>\n      <sie-icon\n        class=\"dropdown__icon\"\n        aria-hidden=\"true\"\n        [name]=\"iconReg.sieIcon.Dropdown\"\n        [ngClass]=\"clearInputEnabled && selectedItem ? 'reset' : ''\"\n      ></sie-icon>\n    </div>\n    <sie-ui-icon-button\n      *ngIf=\"clearInputEnabled && !readonly && selectedItem\"\n      [ngClass]=\"{ condensed: condensed }\"\n      class=\"dropdown__reset-input\"\n      [disabled]=\"disabled\"\n      [theme]=\"theme\"\n      [iconScreenReaderText]=\"clearInputIconScreenReaderText\"\n      (clicked)=\"onResetButtonClicked()\"\n    ></sie-ui-icon-button>\n  </div>\n  <ng-template\n    cdkConnectedOverlay\n    cdkConnectedOverlayHasBackdrop\n    cdkConnectedOverlayBackdropClass=\"cdk-overlay-transparent-backdrop\"\n    [cdkConnectedOverlayOrigin]=\"trigger\"\n    [cdkConnectedOverlayOpen]=\"menuOpen\"\n    [cdkConnectedOverlayOffsetX]=\"type === 'un-contained' && cdkOverlayOffsetX\"\n    (overlayKeydown)=\"optionsComponent.onArrowHandler($event)\"\n    (backdropClick)=\"closeOverlay()\"\n    [cdkConnectedOverlayMinHeight]=\"overlayPaneHeight\"\n  >\n    <sie-ui-dropdown-menu\n      cdkTrapFocus\n      class=\"dropdown__menu\"\n      [@openClose]=\"menuOpen\"\n      [theme]=\"theme\"\n      [ngClass]=\"theme\"\n      [ngStyle]=\"{ left: leftStyle, width: type === 'contained' && dropdownWidth + 'px' }\"\n      [type]=\"type === 'un-contained' ? 'dropdown-un-contained' : 'dropdown-contained'\"\n      [menuPositionedBottom]=\"menuPositionedBottom\"\n    >\n      <sie-ui-dropdown-options\n        content\n        [open]=\"menuOpen\"\n        [ariaLabel]=\"label\"\n        [options]=\"options\"\n        [theme]=\"theme\"\n        [ngClass]=\"theme\"\n        [selectedValues]=\"selectedItem ? [selectedItem.value] : []\"\n        [displayIconSpace]=\"displayIconSpace\"\n        (optionDiscarded)=\"closeOverlay(true)\"\n        (optionSelected)=\"itemSelected($event)\"\n      ></sie-ui-dropdown-options>\n    </sie-ui-dropdown-menu>\n  </ng-template>\n  <div *ngIf=\"invalid\" class=\"dropdown__invalid\">\n    {{ errorMessage }}\n  </div>\n  <sie-ui-richtext\n    (focusin)=\"closeOverlay()\"\n    *ngIf=\"hint?.type === 'inline' && hint?.content\"\n    [content]=\"hint.content\"\n    class=\"dropdown__hint\"\n  ></sie-ui-richtext>\n</div>\n\n<ng-template #readOnly>\n  <sie-ui-readonly\n    *ngIf=\"selectedItem\"\n    [label]=\"condensed ? label : placeholder\"\n    [value]=\"selectedItem.value\"\n    [displayValue]=\"selectedItem.label\"\n    [name]=\"name\"\n    [theme]=\"theme\"\n  ></sie-ui-readonly>\n</ng-template>\n", styles: [".dropdown__button{outline:none;outline-offset:0}@media (pointer: fine){.dropdown__button{position:relative}.dropdown__button:focus{outline:1px solid #1491eb;outline-offset:2px}.dropdown__button:focus:not(:focus-visible){outline:0}.dropdown__button:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}:host{max-width:100%}.dropdown{display:inline-block;position:relative;text-align:left;max-width:100%}.dropdown--condensed{padding-bottom:8px}.dropdown--contained,.dropdown--contained .dropdown__menu{width:100%}.dropdown--contained .dropdown__button{--background-color: #ebf7f8;width:100%;height:56px;padding:0 16px;background-color:var(--background-color)}.dropdown--contained .dropdown__button:hover,.dropdown--contained .dropdown__button:focus,.dropdown--contained .dropdown__button.open{--background-color: #d1fff2}.dropdown--contained .dropdown__button.condensed{height:40px}.dropdown--contained .dropdown__reset-input{top:18px;right:40px}.dropdown--contained .dropdown__reset-input.condensed{top:10px}.dropdown--contained .dropdown__icon.reset{margin-left:44px}.dropdown--contained .dropdown__invalid{margin:4px 0 0 16px}.dropdown--contained.invalid .dropdown__button{--background-color: #fcccd7}.dropdown--contained.invalid .label.itemSelected{color:#ef0137}.dropdown--contained.disabled .label.itemSelected{color:#b3b3be}.dropdown--contained .label.itemSelected{font-size:.75rem;font-weight:400;line-height:1rem;color:#4c4c68;position:absolute;top:6px}.dropdown--contained .selected-label,.dropdown--contained .selected-label-condensed{overflow:hidden;text-overflow:ellipsis}.dropdown--contained .selected-label{margin-top:18px}.dropdown--contained .selected-label.no-placeholder{margin-top:0}.dropdown--un-contained.dropdown--big .dropdown__reset-input{top:0;right:32px}.dropdown--un-contained .dropdown__wrapper{display:inline-block;position:relative;max-width:100%}.dropdown--un-contained .dropdown__menu{width:max-content}.dropdown--un-contained .dropdown__button{height:28px}.dropdown--un-contained .dropdown__reset-input{top:4px;right:17px}.dropdown--un-contained .dropdown__icon.reset{margin-left:36px}.dropdown__icon{width:24px;height:24px;display:flex;align-items:center;fill:currentColor;color:var(--icon-color);margin-left:16px;margin-right:-7px}.dropdown__icon svg{fill:currentColor;width:inherit;height:inherit}.dropdown__icon svg g{fill:currentColor;width:inherit;height:inherit}.dropdown__icon svg text{font-family:Siemens Sans,sans-serif}.dropdown--big .dropdown__icon{margin-right:0}@media (min-width: 640px){.dropdown--big .dropdown__icon{width:32px;height:32px;display:flex;align-items:center;fill:currentColor}.dropdown--big .dropdown__icon svg{fill:currentColor;width:inherit;height:inherit}.dropdown--big .dropdown__icon svg g{fill:currentColor;width:inherit;height:inherit}.dropdown--big .dropdown__icon svg text{font-family:Siemens Sans,sans-serif}}@media (max-width: 639.78px){.dropdown--big .dropdown__icon{margin-left:8px}}.dropdown__icon svg{transition:transform .12s cubic-bezier(.4,0,.3,1)}.open .dropdown__icon svg{transform:translateZ(0) rotate(180deg)}.dropdown__button{--icon-color: #4c4c68;--text-color: #4c4c68;--border-color: #4c4c68;display:inline-flex;align-items:center;justify-content:space-between;position:relative;text-overflow:ellipsis;height:28px;max-width:100%;cursor:pointer;color:var(--text-color);border-bottom:1px solid var(--border-color);white-space:nowrap}.dropdown__button:hover,.dropdown__button:focus,.dropdown__button.open{--icon-color: #33747a;--text-color: #000028;--border-color: #00d7a0}.dropdown__button.dark{--icon-color: #ccccd4;--text-color: #ccccd4;--border-color: #ccccd4}.dropdown__button.dark:hover,.dropdown__button.dark:focus,.dropdown__button.dark.open{--icon-color: #00ffb9;--text-color: #fff;--border-color: #00ffb9}.dropdown__reset-input{position:absolute;cursor:pointer;z-index:2}.dropdown__invalid{font-size:.75rem;font-weight:400;line-height:1rem;color:#ef0137;margin-top:4px}.dropdown__hint{display:block;color:#4c4c68;margin-top:4px;font-size:.75rem;font-weight:400;line-height:1rem}.dropdown--big{font-size:1.25rem;line-height:1.625rem;font-weight:900;letter-spacing:-.03125rem}@media (min-width: 1024px){.dropdown--big{font-size:2rem;line-height:2.75rem;font-weight:900;letter-spacing:-.03125rem}}.dropdown--big .dropdown__button{margin:8px 0;border-bottom-width:2px}@media (min-width: 1024px){.dropdown--big .dropdown__button{margin:0;height:44px}}.dropdown--big .dropdown__menu{top:34px;min-width:328px;width:calc(100vw - 32px)}@media (min-width: 640px){.dropdown--big .dropdown__menu{width:calc(100% + 16px)}}@media (min-width: 1024px){.dropdown--big .dropdown__menu{top:42px}}.dropdown.disabled{cursor:not-allowed}.dropdown.disabled .dropdown__button{--icon-color: currentColor;--text-color: #b3b3be;--border-color: currentColor;border-bottom:none;pointer-events:none}.dropdown.disabled .dropdown__button.dark{--icon-color: #737389;--text-color: #737389;--border-color: #737389}.dropdown.invalid .dropdown__button{--border-color: #ef0137}.dropdown.selected:not(.disabled) .dropdown__button{--text-color: #000028}.dropdown.selected:not(.disabled) .dropdown__button.dark{--text-color: #fff}.dropdown.selected.dropdown.invalid .dropdown__button.dark{--text-color: #ccccd4}.selected-label{overflow:hidden;text-overflow:ellipsis}.selected-label__icon{display:inline-flex;justify-content:center;align-items:center;min-width:27px;margin-right:8px}.selected-label__icon sie-icon{width:24px;height:100%;display:flex;align-items:center;fill:currentColor}.selected-label__icon sie-icon svg{fill:currentColor;width:inherit;height:inherit}.selected-label__icon sie-icon svg g{fill:currentColor;width:inherit;height:inherit}.selected-label__icon sie-icon svg text{font-family:Siemens Sans,sans-serif}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "component", type: UiReadonlyComponent, selector: "sie-ui-readonly", inputs: ["value", "label", "displayValue", "name", "theme", "icons"] }, { kind: "directive", type: i1$1.AttributeDirective, selector: "[sieCoreAttributes]", inputs: ["sieCoreAttributes"] }, { kind: "component", type: UiRichtextComponent, selector: "sie-ui-richtext", inputs: ["content", "theme", "whiteListedTags"] }, { kind: "component", type: UiDropdownMenuComponent, selector: "sie-ui-dropdown-menu", inputs: ["theme", "type", "menuPositionedBottom"] }, { kind: "component", type: UiDropdownOptionsComponent, selector: "sie-ui-dropdown-options", inputs: ["options", "theme", "selectionType", "selectedValues", "displayIconSpace", "type", "checkmarkDisabled", "open", "ariaLabel"], outputs: ["optionSelected", "optionDiscarded"] }, { kind: "directive", type: i10.CdkConnectedOverlay, selector: "[cdk-connected-overlay], [connected-overlay], [cdkConnectedOverlay]", inputs: ["cdkConnectedOverlayOrigin", "cdkConnectedOverlayPositions", "cdkConnectedOverlayPositionStrategy", "cdkConnectedOverlayOffsetX", "cdkConnectedOverlayOffsetY", "cdkConnectedOverlayWidth", "cdkConnectedOverlayHeight", "cdkConnectedOverlayMinWidth", "cdkConnectedOverlayMinHeight", "cdkConnectedOverlayBackdropClass", "cdkConnectedOverlayPanelClass", "cdkConnectedOverlayViewportMargin", "cdkConnectedOverlayScrollStrategy", "cdkConnectedOverlayOpen", "cdkConnectedOverlayDisableClose", "cdkConnectedOverlayTransformOriginOn", "cdkConnectedOverlayHasBackdrop", "cdkConnectedOverlayLockPosition", "cdkConnectedOverlayFlexibleDimensions", "cdkConnectedOverlayGrowAfterOpen", "cdkConnectedOverlayPush"], outputs: ["backdropClick", "positionChange", "attach", "detach", "overlayKeydown", "overlayOutsideClick"], exportAs: ["cdkConnectedOverlay"] }, { kind: "directive", type: i10.CdkOverlayOrigin, selector: "[cdk-overlay-origin], [overlay-origin], [cdkOverlayOrigin]", exportAs: ["cdkOverlayOrigin"] }, { kind: "directive", type: i6.CdkTrapFocus, selector: "[cdkTrapFocus]", inputs: ["cdkTrapFocus", "cdkTrapFocusAutoCapture"], exportAs: ["cdkTrapFocus"] }, { kind: "component", type: UiIconButtonComponent, selector: "sie-ui-icon-button", inputs: ["theme", "disabled", "hoverColored", "iconScreenReaderText", "icon"], outputs: ["clicked"] }, { kind: "pipe", type: i2.AsyncPipe, name: "async" }], animations: [createDropdownAnimation()], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDropdownComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-dropdown', changeDetection: ChangeDetectionStrategy.OnPush, animations: [createDropdownAnimation()], providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            multi: true,
                            useExisting: UiDropdownComponent
                        },
                        {
                            provide: NG_VALIDATORS,
                            multi: true,
                            useExisting: UiDropdownComponent
                        },
                        UiEventPropagationService,
                        {
                            provide: FORM_COMPONENT_ACCESSOR,
                            useExisting: forwardRef(() => UiDropdownComponent)
                        }
                    ], template: "<div\n  *ngIf=\"condensed && type === 'contained' && !readonly && label\"\n  [ngClass]=\"label ? 'dropdown--condensed' : ''\"\n  [innerHTML]=\"required ? label + '*' : label\"\n></div>\n<div\n  *ngIf=\"!readonly; else readOnly\"\n  class=\"dropdown dropdown--{{ type }}\"\n  [ngClass]=\"customClass\"\n  [class.disabled]=\"disabled\"\n  [class.invalid]=\"invalid\"\n  [style.margin-bottom]=\"invalid ? marginBottomOnInvalidState : null\"\n  [class.selected]=\"selectedItem\"\n  (focusin)=\"focusIn()\"\n  (focusout)=\"focusOut()\"\n  (keydown)=\"keydownSearch($event)\"\n  #dropDownRendering\n>\n  <div [ngClass]=\"clearInputEnabled && selectedItem ? 'dropdown__wrapper' : ''\">\n    <div\n      class=\"dropdown__button\"\n      [attr.tabindex]=\"disabled ? -1 : 0\"\n      [attr.aria-haspopup]=\"'listbox'\"\n      [attr.aria-label]=\"selectedItem ? label + ' ' + selectedItem.label : ''\"\n      [attr.id]=\"id\"\n      (keydown.enter)=\"toggleDropDown()\"\n      (keydown.space)=\"toggleDropDown($event)\"\n      (keydown.arrowDown)=\"onArrowDownOnButton($event)\"\n      (keydown.escape)=\"handleEscape($event)\"\n      (keyup.escape)=\"eventPropagationService.handleEvent($event)\"\n      [ngClass]=\"{\n        open: menuOpen,\n        dark: theme === 'dark',\n        light: theme === 'light',\n        condensed: condensed\n      }\"\n      role=\"button\"\n      #dropDownElement\n      (click)=\"toggleDropDown()\"\n      type=\"button\"\n      cdkOverlayOrigin\n      #trigger=\"cdkOverlayOrigin\"\n    >\n      <span *ngIf=\"screenReaderText && screenReaderText.length > 0\" class=\"visually-hidden\">{{\n        screenReaderText\n      }}</span>\n      <ng-container *ngIf=\"type === 'un-contained'; else containedDropdown\">\n        <div class=\"selected-label__icon\" *ngIf=\"selectedItem?.icon\">\n          <sie-icon [name]=\"selectedItem.icon\" [ngClass]=\"clearInputEnabled && selectedItem ? 'reset' : ''\"></sie-icon>\n        </div>\n        <span\n          class=\"selected-label\"\n          aria-hidden=\"true\"\n          [innerHTML]=\"selectedItem ? selectedItem.label : placeholder\"\n          [sieCoreAttributes]=\"trackingDataAttr\"\n          [title]=\"selectedItem ? selectedItem.label : ''\"\n        ></span>\n      </ng-container>\n\n      <ng-template #containedDropdown>\n        <ng-container *ngIf=\"condensed; else containedLabels\">\n          <span\n            class=\"label\"\n            [ngClass]=\"{ itemSelected: selectedItem }\"\n            [innerHTML]=\"condensed && !selectedItem ? placeholder : ''\"\n          ></span>\n          <span class=\"selected-label-condensed\" [innerHTML]=\"selectedItem?.label\" [title]=\"selectedItem?.label\"></span>\n        </ng-container>\n        <ng-template #containedLabels>\n          <span\n            class=\"label\"\n            [ngClass]=\"{ itemSelected: selectedItem }\"\n            [innerHTML]=\"required ? placeholder + '*' : placeholder\"\n          ></span>\n          <span\n            *ngIf=\"!!selectedItem\"\n            class=\"selected-label\"\n            [ngClass]=\"{ 'no-placeholder': !placeholder }\"\n            [innerHTML]=\"\n              selectedItem.label + '' + (selectedItem.labelAppendix$ ? (selectedItem.labelAppendix$ | async) : '')\n            \"\n            [title]=\"\n              selectedItem.label + '' + (selectedItem.labelAppendix$ ? (selectedItem.labelAppendix$ | async) : '')\n            \"\n          ></span>\n        </ng-template>\n      </ng-template>\n      <sie-icon\n        class=\"dropdown__icon\"\n        aria-hidden=\"true\"\n        [name]=\"iconReg.sieIcon.Dropdown\"\n        [ngClass]=\"clearInputEnabled && selectedItem ? 'reset' : ''\"\n      ></sie-icon>\n    </div>\n    <sie-ui-icon-button\n      *ngIf=\"clearInputEnabled && !readonly && selectedItem\"\n      [ngClass]=\"{ condensed: condensed }\"\n      class=\"dropdown__reset-input\"\n      [disabled]=\"disabled\"\n      [theme]=\"theme\"\n      [iconScreenReaderText]=\"clearInputIconScreenReaderText\"\n      (clicked)=\"onResetButtonClicked()\"\n    ></sie-ui-icon-button>\n  </div>\n  <ng-template\n    cdkConnectedOverlay\n    cdkConnectedOverlayHasBackdrop\n    cdkConnectedOverlayBackdropClass=\"cdk-overlay-transparent-backdrop\"\n    [cdkConnectedOverlayOrigin]=\"trigger\"\n    [cdkConnectedOverlayOpen]=\"menuOpen\"\n    [cdkConnectedOverlayOffsetX]=\"type === 'un-contained' && cdkOverlayOffsetX\"\n    (overlayKeydown)=\"optionsComponent.onArrowHandler($event)\"\n    (backdropClick)=\"closeOverlay()\"\n    [cdkConnectedOverlayMinHeight]=\"overlayPaneHeight\"\n  >\n    <sie-ui-dropdown-menu\n      cdkTrapFocus\n      class=\"dropdown__menu\"\n      [@openClose]=\"menuOpen\"\n      [theme]=\"theme\"\n      [ngClass]=\"theme\"\n      [ngStyle]=\"{ left: leftStyle, width: type === 'contained' && dropdownWidth + 'px' }\"\n      [type]=\"type === 'un-contained' ? 'dropdown-un-contained' : 'dropdown-contained'\"\n      [menuPositionedBottom]=\"menuPositionedBottom\"\n    >\n      <sie-ui-dropdown-options\n        content\n        [open]=\"menuOpen\"\n        [ariaLabel]=\"label\"\n        [options]=\"options\"\n        [theme]=\"theme\"\n        [ngClass]=\"theme\"\n        [selectedValues]=\"selectedItem ? [selectedItem.value] : []\"\n        [displayIconSpace]=\"displayIconSpace\"\n        (optionDiscarded)=\"closeOverlay(true)\"\n        (optionSelected)=\"itemSelected($event)\"\n      ></sie-ui-dropdown-options>\n    </sie-ui-dropdown-menu>\n  </ng-template>\n  <div *ngIf=\"invalid\" class=\"dropdown__invalid\">\n    {{ errorMessage }}\n  </div>\n  <sie-ui-richtext\n    (focusin)=\"closeOverlay()\"\n    *ngIf=\"hint?.type === 'inline' && hint?.content\"\n    [content]=\"hint.content\"\n    class=\"dropdown__hint\"\n  ></sie-ui-richtext>\n</div>\n\n<ng-template #readOnly>\n  <sie-ui-readonly\n    *ngIf=\"selectedItem\"\n    [label]=\"condensed ? label : placeholder\"\n    [value]=\"selectedItem.value\"\n    [displayValue]=\"selectedItem.label\"\n    [name]=\"name\"\n    [theme]=\"theme\"\n  ></sie-ui-readonly>\n</ng-template>\n", styles: [".dropdown__button{outline:none;outline-offset:0}@media (pointer: fine){.dropdown__button{position:relative}.dropdown__button:focus{outline:1px solid #1491eb;outline-offset:2px}.dropdown__button:focus:not(:focus-visible){outline:0}.dropdown__button:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}:host{max-width:100%}.dropdown{display:inline-block;position:relative;text-align:left;max-width:100%}.dropdown--condensed{padding-bottom:8px}.dropdown--contained,.dropdown--contained .dropdown__menu{width:100%}.dropdown--contained .dropdown__button{--background-color: #ebf7f8;width:100%;height:56px;padding:0 16px;background-color:var(--background-color)}.dropdown--contained .dropdown__button:hover,.dropdown--contained .dropdown__button:focus,.dropdown--contained .dropdown__button.open{--background-color: #d1fff2}.dropdown--contained .dropdown__button.condensed{height:40px}.dropdown--contained .dropdown__reset-input{top:18px;right:40px}.dropdown--contained .dropdown__reset-input.condensed{top:10px}.dropdown--contained .dropdown__icon.reset{margin-left:44px}.dropdown--contained .dropdown__invalid{margin:4px 0 0 16px}.dropdown--contained.invalid .dropdown__button{--background-color: #fcccd7}.dropdown--contained.invalid .label.itemSelected{color:#ef0137}.dropdown--contained.disabled .label.itemSelected{color:#b3b3be}.dropdown--contained .label.itemSelected{font-size:.75rem;font-weight:400;line-height:1rem;color:#4c4c68;position:absolute;top:6px}.dropdown--contained .selected-label,.dropdown--contained .selected-label-condensed{overflow:hidden;text-overflow:ellipsis}.dropdown--contained .selected-label{margin-top:18px}.dropdown--contained .selected-label.no-placeholder{margin-top:0}.dropdown--un-contained.dropdown--big .dropdown__reset-input{top:0;right:32px}.dropdown--un-contained .dropdown__wrapper{display:inline-block;position:relative;max-width:100%}.dropdown--un-contained .dropdown__menu{width:max-content}.dropdown--un-contained .dropdown__button{height:28px}.dropdown--un-contained .dropdown__reset-input{top:4px;right:17px}.dropdown--un-contained .dropdown__icon.reset{margin-left:36px}.dropdown__icon{width:24px;height:24px;display:flex;align-items:center;fill:currentColor;color:var(--icon-color);margin-left:16px;margin-right:-7px}.dropdown__icon svg{fill:currentColor;width:inherit;height:inherit}.dropdown__icon svg g{fill:currentColor;width:inherit;height:inherit}.dropdown__icon svg text{font-family:Siemens Sans,sans-serif}.dropdown--big .dropdown__icon{margin-right:0}@media (min-width: 640px){.dropdown--big .dropdown__icon{width:32px;height:32px;display:flex;align-items:center;fill:currentColor}.dropdown--big .dropdown__icon svg{fill:currentColor;width:inherit;height:inherit}.dropdown--big .dropdown__icon svg g{fill:currentColor;width:inherit;height:inherit}.dropdown--big .dropdown__icon svg text{font-family:Siemens Sans,sans-serif}}@media (max-width: 639.78px){.dropdown--big .dropdown__icon{margin-left:8px}}.dropdown__icon svg{transition:transform .12s cubic-bezier(.4,0,.3,1)}.open .dropdown__icon svg{transform:translateZ(0) rotate(180deg)}.dropdown__button{--icon-color: #4c4c68;--text-color: #4c4c68;--border-color: #4c4c68;display:inline-flex;align-items:center;justify-content:space-between;position:relative;text-overflow:ellipsis;height:28px;max-width:100%;cursor:pointer;color:var(--text-color);border-bottom:1px solid var(--border-color);white-space:nowrap}.dropdown__button:hover,.dropdown__button:focus,.dropdown__button.open{--icon-color: #33747a;--text-color: #000028;--border-color: #00d7a0}.dropdown__button.dark{--icon-color: #ccccd4;--text-color: #ccccd4;--border-color: #ccccd4}.dropdown__button.dark:hover,.dropdown__button.dark:focus,.dropdown__button.dark.open{--icon-color: #00ffb9;--text-color: #fff;--border-color: #00ffb9}.dropdown__reset-input{position:absolute;cursor:pointer;z-index:2}.dropdown__invalid{font-size:.75rem;font-weight:400;line-height:1rem;color:#ef0137;margin-top:4px}.dropdown__hint{display:block;color:#4c4c68;margin-top:4px;font-size:.75rem;font-weight:400;line-height:1rem}.dropdown--big{font-size:1.25rem;line-height:1.625rem;font-weight:900;letter-spacing:-.03125rem}@media (min-width: 1024px){.dropdown--big{font-size:2rem;line-height:2.75rem;font-weight:900;letter-spacing:-.03125rem}}.dropdown--big .dropdown__button{margin:8px 0;border-bottom-width:2px}@media (min-width: 1024px){.dropdown--big .dropdown__button{margin:0;height:44px}}.dropdown--big .dropdown__menu{top:34px;min-width:328px;width:calc(100vw - 32px)}@media (min-width: 640px){.dropdown--big .dropdown__menu{width:calc(100% + 16px)}}@media (min-width: 1024px){.dropdown--big .dropdown__menu{top:42px}}.dropdown.disabled{cursor:not-allowed}.dropdown.disabled .dropdown__button{--icon-color: currentColor;--text-color: #b3b3be;--border-color: currentColor;border-bottom:none;pointer-events:none}.dropdown.disabled .dropdown__button.dark{--icon-color: #737389;--text-color: #737389;--border-color: #737389}.dropdown.invalid .dropdown__button{--border-color: #ef0137}.dropdown.selected:not(.disabled) .dropdown__button{--text-color: #000028}.dropdown.selected:not(.disabled) .dropdown__button.dark{--text-color: #fff}.dropdown.selected.dropdown.invalid .dropdown__button.dark{--text-color: #ccccd4}.selected-label{overflow:hidden;text-overflow:ellipsis}.selected-label__icon{display:inline-flex;justify-content:center;align-items:center;min-width:27px;margin-right:8px}.selected-label__icon sie-icon{width:24px;height:100%;display:flex;align-items:center;fill:currentColor}.selected-label__icon sie-icon svg{fill:currentColor;width:inherit;height:inherit}.selected-label__icon sie-icon svg g{fill:currentColor;width:inherit;height:inherit}.selected-label__icon sie-icon svg text{font-family:Siemens Sans,sans-serif}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }, { type: UiEventPropagationService }, { type: i0.ElementRef }, { type: i0.ChangeDetectorRef }, { type: CdkOverlayService }, { type: i1$1.LayoutService }]; }, propDecorators: { optionsComponent: [{
                type: ViewChild,
                args: [UiDropdownOptionsComponent]
            }], type: [{
                type: Input
            }], condensed: [{
                type: Input
            }], options: [{
                type: Input
            }], selectedValue: [{
                type: Input
            }], required: [{
                type: Input
            }], id: [{
                type: Input
            }], name: [{
                type: Input
            }], label: [{
                type: Input
            }], placeholder: [{
                type: Input
            }], errorMessage: [{
                type: Input
            }], customClass: [{
                type: Input
            }], readonly: [{
                type: Input
            }], invalid: [{
                type: Input
            }], hint: [{
                type: Input
            }], marginBottomOnInvalidState: [{
                type: Input
            }], selectionChanged: [{
                type: Output
            }] } });

class UiReadonlyModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiReadonlyModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiReadonlyModule, declarations: [UiReadonlyComponent], imports: [CommonModule, SieIconsModule], exports: [UiReadonlyComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiReadonlyModule, imports: [CommonModule, SieIconsModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiReadonlyModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiReadonlyComponent],
                    exports: [UiReadonlyComponent],
                    imports: [CommonModule, SieIconsModule]
                }]
        }] });

/**
 * # Richtext Module
 * - {@link UiRichtextComponent}
 */
class UiRichtextModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiRichtextModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiRichtextModule, declarations: [UiRichtextComponent], imports: [CommonModule, UiUnderlineTooltipModule], exports: [UiRichtextComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiRichtextModule, imports: [CommonModule, UiUnderlineTooltipModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiRichtextModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiRichtextComponent],
                    imports: [CommonModule, UiUnderlineTooltipModule],
                    exports: [UiRichtextComponent]
                }]
        }] });

/**
 * # Checkbox Group component
 *
 * Checkboxes are part of a form, allowing us to select or deselect a given option. Similarly, the Checkbox Group allows
 * us to choose between listed options.
 *
 * ## Component variations
 *
 * There are no variations as this component groups multiple checkboxes together
 *
 * ## Content
 *
 * The checkbox group component does not accept any content.
 *
 * ## Code example
 * @example ```html
 * <form #form="ngForm">
 *   <sie-ui-checkbox-group
 *     [items]="[
 *       {
 *         label: 'Option Label 1',
 *         hint: {
 *           content: 'help text here',
 *           type: 'tooltip'
 *         }
 *       }
 *     ]"
 *     [hint]="{
 *       content: 'Hint for the whole checkbox group (can only be inline!)',
 *       type: 'inline'
 *     }"
 *     required="true"
 *     label="Checkbox Group Label"
 *     name="checkboxGroup"
 *   ></sie-ui-checkbox-group>
 * </form>
 * ```
 */
class UiCheckboxGroupComponent extends NgFormControlDirective {
    /**
     * @param required Defines if the checkbox group is required or not (overrides the required flag of the checkbox items)
     * @default false
     */
    set required(required) {
        this._required = coerceBooleanProperty(required);
    }
    get required() {
        return this._required;
    }
    constructor(iconReg, cdr) {
        super();
        this.iconReg = iconReg;
        this.cdr = cdr;
        this._required = false;
        /**
         * Event fired when one of the checkbox items is selected or deselected. See {@link CheckboxChangedModel}
         */
        this.valueChange = new EventEmitter();
    }
    /** @ignore */
    ngOnInit() {
        this.items?.forEach(item => {
            item.icons?.forEach(icon => {
                this.iconReg.register(icon);
            });
        });
    }
    /** @ignore */
    onCheckboxChange(state, index, name) {
        this.valueChange.emit({ state, index, name });
        this.markAsTouched();
        this.onChange(this.items.filter(i => i.value).map(i => i.id));
    }
    /** @ignore */
    validateInternal() {
        return null;
    }
    /** @ignore */
    writeValue(ids) {
        if (ids) {
            this.items?.forEach(item => {
                item.value = ids?.indexOf(item.id) >= 0;
            });
            this.cdr.detectChanges();
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCheckboxGroupComponent, deps: [{ token: i1.SieIconRegistryService }, { token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiCheckboxGroupComponent, selector: "sie-ui-checkbox-group", inputs: { items: "items", required: "required" }, outputs: { valueChange: "valueChange" }, providers: [
            {
                provide: NG_VALUE_ACCESSOR,
                multi: true,
                useExisting: UiCheckboxGroupComponent
            },
            {
                provide: NG_VALIDATORS,
                multi: true,
                useExisting: UiCheckboxGroupComponent
            }
        ], usesInheritance: true, ngImport: i0, template: "<div *ngIf=\"items && items.length\" class=\"checkbox-group\" [ngClass]=\"{ invalid: invalid }\">\n  <header *ngIf=\"label\">\n    <span class=\"checkbox-group__label\" *ngIf=\"label\"\n      >{{ label }}<ng-container *ngIf=\"required\">*</ng-container>\n      <span *ngIf=\"hint?.type === 'tooltip' && hint?.content\">\n        <sie-icon\n          class=\"checkbox-group__tooltip-icon\"\n          sieUiPopover\n          [popoverSize]=\"hint?.size ? hint?.size : 's'\"\n          [content]=\"hint?.content\"\n          [name]=\"iconReg.sieIcon.Information\"\n        ></sie-icon>\n      </span>\n    </span>\n    <div class=\"checkbox-group__inline-hint\" *ngIf=\"hint?.type === 'inline' && hint?.content\">\n      <sie-ui-richtext [content]=\"hint.content\"></sie-ui-richtext>\n    </div>\n  </header>\n  <ul class=\"checkbox-group__list\">\n    <li class=\"checkbox-group__item\" *ngFor=\"let checkBox of items; let i = index\">\n      <sie-ui-checkbox\n        [hint]=\"{ content: checkBox.hint?.content, type: checkBox.hint?.type, size: checkBox.hint?.size }\"\n        [invalid]=\"invalid || checkBox.invalid\"\n        [readonly]=\"checkBox.readonly || readonly\"\n        [required]=\"checkBox.required && !required\"\n        [active]=\"checkBox.active\"\n        [label]=\"checkBox.label\"\n        [disabled]=\"checkBox.disabled\"\n        [labelAppendix$]=\"checkBox.labelAppendix$\"\n        [(value)]=\"checkBox.value\"\n        [indeterminate]=\"checkBox.indeterminate\"\n        (valueChange)=\"onCheckboxChange($event, i, name)\"\n        [id]=\"checkBox.id\"\n        [name]=\"name + '_' + i\"\n        [icons]=\"checkBox.icons\"\n      ></sie-ui-checkbox>\n    </li>\n  </ul>\n</div>\n", styles: [".checkbox-group__inline-hint{width:100%}.checkbox-group__tooltip-icon{margin-left:8px;color:#4c4c68;width:24px;height:24px;display:flex;align-items:center;fill:currentColor}.checkbox-group__tooltip-icon svg{fill:currentColor;width:inherit;height:inherit}.checkbox-group__tooltip-icon svg g{fill:currentColor;width:inherit;height:inherit}.checkbox-group__tooltip-icon svg text{font-family:Siemens Sans,sans-serif}.checkbox-group header{display:inline-flex;align-items:center;margin-bottom:14px;flex-wrap:wrap}.checkbox-group sie-ui-richtext{color:#4c4c68;font-size:.75rem;font-weight:400;line-height:1rem}.checkbox-group__list{list-style:none;margin:0;padding:0}.checkbox-group__item{margin-bottom:12px}.checkbox-group__item:last-child{margin-bottom:0}.checkbox-group__item>sie-ui-richtext{display:inline-flex;margin-top:2px}.checkbox-group.invalid>header>.checkbox-group__inline-hint>sie-ui-richtext{color:#ef0137}.checkbox-group__label{display:inline-block;word-break:break-word}.checkbox-group__label span{display:inline-block;position:relative;top:5px}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "component", type: UiRichtextComponent, selector: "sie-ui-richtext", inputs: ["content", "theme", "whiteListedTags"] }, { kind: "directive", type: UiPopoverDirective, selector: "[sieUiPopover]", inputs: ["content", "popoverTemplate", "popoverSize", "popoverPlacement", "popoverAnimation", "popoverPlayAnimation", "popoverAnimationHideAfterTimeoutMS", "popoverLightTheme"] }, { kind: "component", type: UiCheckboxComponent, selector: "sie-ui-checkbox", inputs: ["id", "checkboxIdToFocus", "indeterminate", "value", "active", "required", "icons", "labelAppendix$"], outputs: ["valueChange"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCheckboxGroupComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-checkbox-group', changeDetection: ChangeDetectionStrategy.OnPush, providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            multi: true,
                            useExisting: UiCheckboxGroupComponent
                        },
                        {
                            provide: NG_VALIDATORS,
                            multi: true,
                            useExisting: UiCheckboxGroupComponent
                        }
                    ], template: "<div *ngIf=\"items && items.length\" class=\"checkbox-group\" [ngClass]=\"{ invalid: invalid }\">\n  <header *ngIf=\"label\">\n    <span class=\"checkbox-group__label\" *ngIf=\"label\"\n      >{{ label }}<ng-container *ngIf=\"required\">*</ng-container>\n      <span *ngIf=\"hint?.type === 'tooltip' && hint?.content\">\n        <sie-icon\n          class=\"checkbox-group__tooltip-icon\"\n          sieUiPopover\n          [popoverSize]=\"hint?.size ? hint?.size : 's'\"\n          [content]=\"hint?.content\"\n          [name]=\"iconReg.sieIcon.Information\"\n        ></sie-icon>\n      </span>\n    </span>\n    <div class=\"checkbox-group__inline-hint\" *ngIf=\"hint?.type === 'inline' && hint?.content\">\n      <sie-ui-richtext [content]=\"hint.content\"></sie-ui-richtext>\n    </div>\n  </header>\n  <ul class=\"checkbox-group__list\">\n    <li class=\"checkbox-group__item\" *ngFor=\"let checkBox of items; let i = index\">\n      <sie-ui-checkbox\n        [hint]=\"{ content: checkBox.hint?.content, type: checkBox.hint?.type, size: checkBox.hint?.size }\"\n        [invalid]=\"invalid || checkBox.invalid\"\n        [readonly]=\"checkBox.readonly || readonly\"\n        [required]=\"checkBox.required && !required\"\n        [active]=\"checkBox.active\"\n        [label]=\"checkBox.label\"\n        [disabled]=\"checkBox.disabled\"\n        [labelAppendix$]=\"checkBox.labelAppendix$\"\n        [(value)]=\"checkBox.value\"\n        [indeterminate]=\"checkBox.indeterminate\"\n        (valueChange)=\"onCheckboxChange($event, i, name)\"\n        [id]=\"checkBox.id\"\n        [name]=\"name + '_' + i\"\n        [icons]=\"checkBox.icons\"\n      ></sie-ui-checkbox>\n    </li>\n  </ul>\n</div>\n", styles: [".checkbox-group__inline-hint{width:100%}.checkbox-group__tooltip-icon{margin-left:8px;color:#4c4c68;width:24px;height:24px;display:flex;align-items:center;fill:currentColor}.checkbox-group__tooltip-icon svg{fill:currentColor;width:inherit;height:inherit}.checkbox-group__tooltip-icon svg g{fill:currentColor;width:inherit;height:inherit}.checkbox-group__tooltip-icon svg text{font-family:Siemens Sans,sans-serif}.checkbox-group header{display:inline-flex;align-items:center;margin-bottom:14px;flex-wrap:wrap}.checkbox-group sie-ui-richtext{color:#4c4c68;font-size:.75rem;font-weight:400;line-height:1rem}.checkbox-group__list{list-style:none;margin:0;padding:0}.checkbox-group__item{margin-bottom:12px}.checkbox-group__item:last-child{margin-bottom:0}.checkbox-group__item>sie-ui-richtext{display:inline-flex;margin-top:2px}.checkbox-group.invalid>header>.checkbox-group__inline-hint>sie-ui-richtext{color:#ef0137}.checkbox-group__label{display:inline-block;word-break:break-word}.checkbox-group__label span{display:inline-block;position:relative;top:5px}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }, { type: i0.ChangeDetectorRef }]; }, propDecorators: { items: [{
                type: Input
            }], required: [{
                type: Input
            }], valueChange: [{
                type: Output
            }] } });

/**
 * # Checkbox Module
 * - {@link UiCheckboxComponent}
 * - {@link UiCheckboxGroupComponent}
 *
 * ## Module peer dependencies
 * - {@link SieIconsModule}
 * - `@angular/platform-browser/animations/BrowserAnimationsModule`: This module is needed to run the animations on the checkbox
 * - `@angular/forms/FormsModule`: Enables data binding for Angular forms
 */
class UiCheckboxModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCheckboxModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiCheckboxModule, declarations: [UiCheckboxComponent, UiCheckboxGroupComponent], imports: [CommonModule, SieIconsModule, FormsModule, UiRichtextModule, UiPopoverModule], exports: [UiCheckboxComponent, UiCheckboxGroupComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCheckboxModule, imports: [CommonModule, SieIconsModule, FormsModule, UiRichtextModule, UiPopoverModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCheckboxModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiCheckboxComponent, UiCheckboxGroupComponent],
                    exports: [UiCheckboxComponent, UiCheckboxGroupComponent],
                    imports: [CommonModule, SieIconsModule, FormsModule, UiRichtextModule, UiPopoverModule]
                }]
        }] });

/**
 * # DropDown Options Module
 * - {@link UiDropdownOptionsComponent}
 *
 * ## Module peer dependencies
 * Requires the following to work properly:
 * - {@link SieIconsModule}
 */
class UiDropdownOptionsModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDropdownOptionsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiDropdownOptionsModule, declarations: [UiDropdownOptionsComponent], imports: [CommonModule, SieIconsModule, AttributeModule, UiCheckboxModule], exports: [UiDropdownOptionsComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDropdownOptionsModule, imports: [CommonModule, SieIconsModule, AttributeModule, UiCheckboxModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDropdownOptionsModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiDropdownOptionsComponent],
                    exports: [UiDropdownOptionsComponent],
                    imports: [CommonModule, SieIconsModule, AttributeModule, UiCheckboxModule]
                }]
        }] });

/**
 * # DropDown Menu Module
 * - {@link UiDropdownMenuComponent}
 *
 * ## Module peer dependencies
 * Requires the following to work properly:
 * - {@link SieIconsModule}
 */
class UiDropdownMenuModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDropdownMenuModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiDropdownMenuModule, declarations: [UiDropdownMenuComponent], imports: [CommonModule, SieIconsModule, AttributeModule, UiDropdownOptionsModule, UiButtonModule], exports: [UiDropdownMenuComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDropdownMenuModule, imports: [CommonModule, SieIconsModule, AttributeModule, UiDropdownOptionsModule, UiButtonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDropdownMenuModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiDropdownMenuComponent],
                    exports: [UiDropdownMenuComponent],
                    imports: [CommonModule, SieIconsModule, AttributeModule, UiDropdownOptionsModule, UiButtonModule]
                }]
        }] });

/**
 * # Icon Button Module
 * - {@link UiIconButtonComponent}
 *
 * ## Module peer dependencies
 * - {@link SieIconsModule}
 */
class UiIconButtonModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiIconButtonModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiIconButtonModule, declarations: [UiIconButtonComponent], imports: [CommonModule, SieIconsModule], exports: [UiIconButtonComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiIconButtonModule, imports: [CommonModule, SieIconsModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiIconButtonModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiIconButtonComponent],
                    exports: [UiIconButtonComponent],
                    imports: [CommonModule, SieIconsModule]
                }]
        }] });

/**
 * # DropDown Module
 * - {@link UiDropdownComponent}
 *
 * ## Module peer dependencies
 * Requires the following to work properly:
 * - {@link SieIconsModule}
 * - `@angular/platform-browser/animations/BrowserAnimationsModule`:
 * This module is needed for the transition animation of the dropdown component
 */
class UiDropdownModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDropdownModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiDropdownModule, declarations: [UiDropdownComponent], imports: [CommonModule,
            SieIconsModule,
            UiReadonlyModule,
            AttributeModule,
            UiRichtextModule,
            UiDropdownMenuModule,
            UiDropdownOptionsModule,
            OverlayModule,
            A11yModule,
            UiIconButtonModule], exports: [UiDropdownComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDropdownModule, imports: [CommonModule,
            SieIconsModule,
            UiReadonlyModule,
            AttributeModule,
            UiRichtextModule,
            UiDropdownMenuModule,
            UiDropdownOptionsModule,
            OverlayModule,
            A11yModule,
            UiIconButtonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDropdownModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiDropdownComponent],
                    exports: [UiDropdownComponent],
                    imports: [
                        CommonModule,
                        SieIconsModule,
                        UiReadonlyModule,
                        AttributeModule,
                        UiRichtextModule,
                        UiDropdownMenuModule,
                        UiDropdownOptionsModule,
                        OverlayModule,
                        A11yModule,
                        UiIconButtonModule
                    ]
                }]
        }] });

/**
 * # Empty State Component
 * The empty state component is ensuring the same empty state experience wherever Empty state (Pattern) gets applied.
 * Whenever an empty state is to be shown according to the Empty state (Pattern) this component is to be used.
 * It can be used in different manifestations.
 *
 * ## Component variations
 *
 * - Regular
 * - Small (depending on the breakpoint)
 * - Light/dark theme
 *
 * ## Content
 * The empty state component does not accept any content.
 *
 * ## Code example
 *
 * @example ```html
 *
 * <sie-ui-empty-state
 *  customIcon="SieportalEmptyStateRecentlyViewed"
 *  headline="Empty State Headline"
 *  text="Empty State text lorem ipsum dolor sit"
 *  theme="light"
 *  [link]="emptyStateLink"
 * ></sie-ui-empty-state>
 * ```
 *
 * ```ts
 * const emptyStateLink = {
 *  href: 'https://www.siemens.com',
 *  variant: 'icon-link',
 *  background: 'light',
 *  linkText: 'Lorem Ipsum dolor'
 * };
 * ```
 */
class UiEmptyStateComponent {
    /**
     * @param icon defines {@link SieIcon icon} which is displayed in empty state
     */
    set customIcon(icon) {
        this._customIcon = icon;
        if (icon) {
            this.iconReg.register(icon);
        }
    }
    get customIcon() {
        return this._customIcon;
    }
    constructor(iconReg, cdr) {
        this.iconReg = iconReg;
        this.cdr = cdr;
        /**
         * Defines {@link ThemeVariant theme} for empty state
         * @default 'light'
         */
        this.theme = 'light';
        /**
         * Defines {@link EmptyStateIconPosition position} for icon displayed in empty state
         * @default 'onTop'
         */
        this.iconPosition = 'onTop';
        /**
         * Defines top and bottom component padding
         */
        this.padding = '2rem';
        /**
         * Triggered when button is clicked
         */
        this.buttonClicked = new Subject();
        /** @ignore */
        this.variant = 'regular';
        /** @ignore */
        this.componentViewports = new Map([
            ['S', 0],
            ['L', 473]
        ]);
        this._customIcon = null;
    }
    /** @ignore */
    setBreakpoint(breakpoint) {
        this.variant = breakpoint === 'S' ? 'small' : 'regular';
        this.cdr.detectChanges();
    }
    /** @ignore */
    onClick(event) {
        this.buttonClicked.next(event);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiEmptyStateComponent, deps: [{ token: i1.SieIconRegistryService }, { token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiEmptyStateComponent, selector: "sie-ui-empty-state", inputs: { theme: "theme", headline: "headline", text: "text", link: "link", button: "button", iconPosition: "iconPosition", padding: "padding", customIcon: "customIcon" }, outputs: { buttonClicked: "buttonClicked" }, ngImport: i0, template: "<div\n  class=\"empty-dialog__wrapper\"\n  [ngStyle]=\"{ 'padding-top': padding, 'padding-bottom': padding }\"\n  [sieCoreComponentBreakpoints]=\"componentViewports\"\n  (componentViewportChanged)=\"setBreakpoint($event)\"\n>\n  <div class=\"empty-dialog\" [ngClass]=\"theme\" [class.error]=\"iconPosition === 'inFrontOfHeadline'\">\n    <div *ngIf=\"customIcon && iconPosition === 'onTop'\" aria-hidden=\"true\">\n      <div class=\"empty-dialog__illustration\">\n        <sie-icon class=\"empty-dialog__icon\" [name]=\"customIcon\"></sie-icon>\n      </div>\n    </div>\n\n    <div class=\"empty-dialog__content {{ variant }}\">\n      <div class=\"empty-dialog__content-full-width\">\n        <h4 *ngIf=\"variant === 'regular'\" class=\"empty-dialog__headline\" sieCoreAddTooltip>\n          <ng-template [ngTemplateOutlet]=\"headlineContent\"></ng-template>\n        </h4>\n        <h5 *ngIf=\"variant === 'small'\" class=\"empty-dialog__headline\" sieCoreAddTooltip>\n          <ng-template [ngTemplateOutlet]=\"headlineContent\"></ng-template>\n        </h5>\n\n        <sie-ui-richtext class=\"empty-dialog__text\" sieCoreAddTooltip [content]=\"text\"></sie-ui-richtext>\n\n        <div class=\"empty-dialog__content__button-container\">\n          <sie-ui-link\n            *ngIf=\"link\"\n            class=\"empty-dialog__link\"\n            [href]=\"link.href\"\n            [icon]=\"link.icon\"\n            [background]=\"link.background\"\n            [target]=\"link.target\"\n            [size]=\"link.size || ''\"\n            (clicked)=\"onClick($event)\"\n            cssClass=\"no-padding\"\n            >{{ link.linkText }}</sie-ui-link\n          >\n\n          <sie-ui-button\n            *ngIf=\"button\"\n            class=\"empty-dialog__button\"\n            [class.empty-dialog__button--uncontained]=\"button.variant === 'icon-un-contained'\"\n            [themeType]=\"button.variant === 'icon-un-contained' ? 'un-contained' : 'main'\"\n            [id]=\"button.id\"\n            [variant]=\"button.variant\"\n            [buttonType]=\"button.buttonType\"\n            [icon]=\"button.icon\"\n            [target]=\"button.target\"\n            [link]=\"button.link\"\n            [disabled]=\"button.disabled\"\n            [withSpinner]=\"button.withSpinner\"\n            [showSpinner]=\"button.showSpinner\"\n            (clicked)=\"onClick($event)\"\n            >{{ button.label }}</sie-ui-button\n          >\n        </div>\n      </div>\n    </div>\n  </div>\n</div>\n\n<ng-template #headlineContent>\n  <sie-icon\n    *ngIf=\"customIcon && iconPosition === 'inFrontOfHeadline'\"\n    [name]=\"customIcon\"\n    class=\"empty-dialog__headline__icon\"\n  ></sie-icon\n  >{{ headline }}\n</ng-template>\n", styles: [":host{height:100%;display:block}.empty-dialog{max-width:472px;min-width:240px;max-height:100%;width:100%;display:flex;flex-direction:column}.empty-dialog__wrapper{display:flex;width:100%;height:100%;flex-direction:column;align-items:center;justify-content:center;overflow:hidden}.empty-dialog__illustration{aspect-ratio:16/9;max-width:328px;margin:0 auto 8px;padding:16px}.empty-dialog__icon{height:100%;width:100%;display:flex;justify-content:center;margin:auto}.empty-dialog__icon svg{width:inherit;height:inherit}.empty-dialog__icon .st0,.empty-dialog__icon .st1{fill:#7d8099}.empty-dialog__content{padding:0 16px;overflow:hidden}.error .empty-dialog__content{padding:16px}.empty-dialog__content__button-container{display:flex;flex-direction:column;align-items:center}.empty-dialog__content-full-width{height:100%}.empty-dialog__headline{color:#000028;text-align:center;width:100%;text-overflow:ellipsis;margin-bottom:16px}.empty-dialog__headline__icon{width:24px;height:24px;display:flex;align-items:center;fill:currentColor;display:inline-flex;margin-right:6px;vertical-align:bottom;color:#ef0137}.empty-dialog__headline__icon svg{fill:currentColor;width:inherit;height:inherit}.empty-dialog__headline__icon svg g{fill:currentColor;width:inherit;height:inherit}.empty-dialog__headline__icon svg text{font-family:Siemens Sans,sans-serif}.empty-dialog__text{font-size:1rem;font-weight:400;line-height:1.5rem;width:100%;display:block;text-align:center;color:#4c4c68}.small .empty-dialog__text{font-size:.875rem;font-weight:400;line-height:1.25rem}.empty-dialog__button{margin-bottom:3px}.empty-dialog__button,.empty-dialog__link{margin-top:24px;width:auto}.empty-dialog__button--uncontained,.empty-dialog__link--uncontained{margin-top:12px}.empty-dialog.dark .empty-dialog__icon .st0,.empty-dialog.dark .empty-dialog__icon .st1{fill:#e5e5e9}.empty-dialog.dark .empty-dialog__headline{color:#fff}.empty-dialog.dark .empty-dialog__text{color:#ccccd4}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: i2.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "directive", type: i1$1.AddTooltipDirective, selector: "[sieCoreAddTooltip]" }, { kind: "directive", type: i1$1.ComponentBreakpointsDirective, selector: "[sieCoreComponentBreakpoints]", inputs: ["sieCoreComponentBreakpoints"], outputs: ["componentViewportChanged"] }, { kind: "component", type: UiLinkComponent, selector: "sie-ui-link", inputs: ["disabled", "disableVisitedStyle", "hasMarginTop", "offsetIcon", "truncate", "inLinkList", "trailingIcon", "icon", "cssClass", "href", "size", "target", "variant", "background", "type", "reference", "screenReaderText", "secondaryLabel", "download", "dataAttributes", "tooltip", "buttonType"], outputs: ["clicked"] }, { kind: "component", type: UiButtonComponent, selector: "sie-ui-button" }, { kind: "component", type: UiRichtextComponent, selector: "sie-ui-richtext", inputs: ["content", "theme", "whiteListedTags"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiEmptyStateComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-empty-state', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div\n  class=\"empty-dialog__wrapper\"\n  [ngStyle]=\"{ 'padding-top': padding, 'padding-bottom': padding }\"\n  [sieCoreComponentBreakpoints]=\"componentViewports\"\n  (componentViewportChanged)=\"setBreakpoint($event)\"\n>\n  <div class=\"empty-dialog\" [ngClass]=\"theme\" [class.error]=\"iconPosition === 'inFrontOfHeadline'\">\n    <div *ngIf=\"customIcon && iconPosition === 'onTop'\" aria-hidden=\"true\">\n      <div class=\"empty-dialog__illustration\">\n        <sie-icon class=\"empty-dialog__icon\" [name]=\"customIcon\"></sie-icon>\n      </div>\n    </div>\n\n    <div class=\"empty-dialog__content {{ variant }}\">\n      <div class=\"empty-dialog__content-full-width\">\n        <h4 *ngIf=\"variant === 'regular'\" class=\"empty-dialog__headline\" sieCoreAddTooltip>\n          <ng-template [ngTemplateOutlet]=\"headlineContent\"></ng-template>\n        </h4>\n        <h5 *ngIf=\"variant === 'small'\" class=\"empty-dialog__headline\" sieCoreAddTooltip>\n          <ng-template [ngTemplateOutlet]=\"headlineContent\"></ng-template>\n        </h5>\n\n        <sie-ui-richtext class=\"empty-dialog__text\" sieCoreAddTooltip [content]=\"text\"></sie-ui-richtext>\n\n        <div class=\"empty-dialog__content__button-container\">\n          <sie-ui-link\n            *ngIf=\"link\"\n            class=\"empty-dialog__link\"\n            [href]=\"link.href\"\n            [icon]=\"link.icon\"\n            [background]=\"link.background\"\n            [target]=\"link.target\"\n            [size]=\"link.size || ''\"\n            (clicked)=\"onClick($event)\"\n            cssClass=\"no-padding\"\n            >{{ link.linkText }}</sie-ui-link\n          >\n\n          <sie-ui-button\n            *ngIf=\"button\"\n            class=\"empty-dialog__button\"\n            [class.empty-dialog__button--uncontained]=\"button.variant === 'icon-un-contained'\"\n            [themeType]=\"button.variant === 'icon-un-contained' ? 'un-contained' : 'main'\"\n            [id]=\"button.id\"\n            [variant]=\"button.variant\"\n            [buttonType]=\"button.buttonType\"\n            [icon]=\"button.icon\"\n            [target]=\"button.target\"\n            [link]=\"button.link\"\n            [disabled]=\"button.disabled\"\n            [withSpinner]=\"button.withSpinner\"\n            [showSpinner]=\"button.showSpinner\"\n            (clicked)=\"onClick($event)\"\n            >{{ button.label }}</sie-ui-button\n          >\n        </div>\n      </div>\n    </div>\n  </div>\n</div>\n\n<ng-template #headlineContent>\n  <sie-icon\n    *ngIf=\"customIcon && iconPosition === 'inFrontOfHeadline'\"\n    [name]=\"customIcon\"\n    class=\"empty-dialog__headline__icon\"\n  ></sie-icon\n  >{{ headline }}\n</ng-template>\n", styles: [":host{height:100%;display:block}.empty-dialog{max-width:472px;min-width:240px;max-height:100%;width:100%;display:flex;flex-direction:column}.empty-dialog__wrapper{display:flex;width:100%;height:100%;flex-direction:column;align-items:center;justify-content:center;overflow:hidden}.empty-dialog__illustration{aspect-ratio:16/9;max-width:328px;margin:0 auto 8px;padding:16px}.empty-dialog__icon{height:100%;width:100%;display:flex;justify-content:center;margin:auto}.empty-dialog__icon svg{width:inherit;height:inherit}.empty-dialog__icon .st0,.empty-dialog__icon .st1{fill:#7d8099}.empty-dialog__content{padding:0 16px;overflow:hidden}.error .empty-dialog__content{padding:16px}.empty-dialog__content__button-container{display:flex;flex-direction:column;align-items:center}.empty-dialog__content-full-width{height:100%}.empty-dialog__headline{color:#000028;text-align:center;width:100%;text-overflow:ellipsis;margin-bottom:16px}.empty-dialog__headline__icon{width:24px;height:24px;display:flex;align-items:center;fill:currentColor;display:inline-flex;margin-right:6px;vertical-align:bottom;color:#ef0137}.empty-dialog__headline__icon svg{fill:currentColor;width:inherit;height:inherit}.empty-dialog__headline__icon svg g{fill:currentColor;width:inherit;height:inherit}.empty-dialog__headline__icon svg text{font-family:Siemens Sans,sans-serif}.empty-dialog__text{font-size:1rem;font-weight:400;line-height:1.5rem;width:100%;display:block;text-align:center;color:#4c4c68}.small .empty-dialog__text{font-size:.875rem;font-weight:400;line-height:1.25rem}.empty-dialog__button{margin-bottom:3px}.empty-dialog__button,.empty-dialog__link{margin-top:24px;width:auto}.empty-dialog__button--uncontained,.empty-dialog__link--uncontained{margin-top:12px}.empty-dialog.dark .empty-dialog__icon .st0,.empty-dialog.dark .empty-dialog__icon .st1{fill:#e5e5e9}.empty-dialog.dark .empty-dialog__headline{color:#fff}.empty-dialog.dark .empty-dialog__text{color:#ccccd4}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }, { type: i0.ChangeDetectorRef }]; }, propDecorators: { theme: [{
                type: Input
            }], headline: [{
                type: Input
            }], text: [{
                type: Input
            }], link: [{
                type: Input
            }], button: [{
                type: Input
            }], iconPosition: [{
                type: Input
            }], padding: [{
                type: Input
            }], customIcon: [{
                type: Input
            }], buttonClicked: [{
                type: Output
            }] } });

/**
 * # Empty State Module
 * - {@link UiEmptyStateComponent}
 *
 * ## Module peer dependencies
 * - {@link SieIconsModule}
 */
class UiEmptyStateModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiEmptyStateModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiEmptyStateModule, declarations: [UiEmptyStateComponent], imports: [CommonModule,
            SieIconsModule,
            AddTooltipModule,
            ComponentBreakpointsModule,
            UiLinkModule,
            UiButtonModule,
            UiRichtextModule], exports: [UiEmptyStateComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiEmptyStateModule, imports: [CommonModule,
            SieIconsModule,
            AddTooltipModule,
            ComponentBreakpointsModule,
            UiLinkModule,
            UiButtonModule,
            UiRichtextModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiEmptyStateModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiEmptyStateComponent],
                    exports: [UiEmptyStateComponent],
                    imports: [
                        CommonModule,
                        SieIconsModule,
                        AddTooltipModule,
                        ComponentBreakpointsModule,
                        UiLinkModule,
                        UiButtonModule,
                        UiRichtextModule
                    ]
                }]
        }] });

const expandAnimationTiming = AnimationDurationNormal + ' ' + EasingStandardProductive;
const toggleExpandableAnimation = trigger('toggleExpandable', [
    state('false', style({
        height: '0',
        opacity: 0,
        overflow: 'hidden'
    })),
    state('true', style({
        height: '*',
        opacity: 1,
        overflow: 'visible'
    })),
    transition('true <=> false', animate(expandAnimationTiming))
]);

/**
 * # Expandable component
 *
 * Expandable support the interaction mechanism to show and hide information on-demand.
 *
 * ## Component variations
 *
 * - Small headline
 * - Large headline
 * - Headline displayed only
 * - Body (content) displayed only
 * - Light theme
 * - Dark theme
 * - Disabled
 *
 * ## Content
 *
 * The content of the expandable component can be any valid markup.
 *
 * ## Code example
 * @example
 *  ```html
 * <sie-ui-expandable headlineCollapsed="Show More" headlineExpanded="Show Less" headlineVariant="s">
 *   <p>
 *     Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et
 *     dolore magna aliquyam erat, sed diam voluptua.
 *   </p>
 * </sie-ui-expandable>
 * ```
 */
class UiExpandableComponent {
    /**
     * @param disabled Removes functionality (click events, expanding capability) from the component and changes heading
     * color when set to true.
     * @default false
     */
    set disabled(disabled) {
        this._disabled = coerceBooleanProperty(disabled);
    }
    get disabled() {
        return this._disabled;
    }
    /**
     * @param value Displays only the header and icon of the component when set to true.
     * @default false
     */
    set onlyHeader(value) {
        this._onlyHeader = coerceBooleanProperty(value);
    }
    get onlyHeader() {
        return this._onlyHeader;
    }
    /**
     * @param value Displays only content of the component when set to true.
     * @default false
     */
    set onlyBody(value) {
        this._onlyBody = coerceBooleanProperty(value);
    }
    get onlyBody() {
        return this._onlyBody;
    }
    /**
     * @param headlineCollapsed Defines content displayed in the heading when the component is collapsed.
     * @default ''
     */
    set headlineCollapsed(headlineCollapsed) {
        this._headlineCollapsed = headlineCollapsed;
        this.checkForExpandedTitle();
    }
    get headlineCollapsed() {
        return this._headlineCollapsed;
    }
    /**
     * @param headlineExpanded Defines content displayed in the heading when the component is expanded.
     * @default ''
     */
    set headlineExpanded(headlineExpanded) {
        this._headlineExpanded = headlineExpanded;
        this.checkForExpandedTitle();
    }
    get headlineExpanded() {
        return this._headlineExpanded;
    }
    /**
     * @param expanded defines if the component is expanded.
     * @default false
     */
    set expanded(expanded) {
        this._expanded = coerceBooleanProperty(expanded);
    }
    get expanded() {
        return this._expanded;
    }
    /**
     * @param disabled defines whether the expandable animation is disabled.
     * @default false
     */
    set animationDisabled(disabled) {
        this._animationDisabled = coerceBooleanProperty(disabled);
    }
    get animationDisabled() {
        return this._animationDisabled;
    }
    /**
     * @param hasMargin defines whether the content inside the body of the component has a top margin.
     * @default true
     */
    set hasBodyMargin(hasMargin) {
        this._hasBodyMargin = coerceBooleanProperty(hasMargin);
    }
    get hasBodyMargin() {
        return this._hasBodyMargin;
    }
    constructor(cdr, iconReg) {
        this.cdr = cdr;
        this.iconReg = iconReg;
        /**
         * Defines {@link ThemeVariant the theme} of the component.
         * @default 'light'
         */
        this.theme = 'light';
        /**
         * Defines {@link UiExpandableHeadlineVariant the size} of the component headline.
         * @default 'm'
         */
        this.headlineVariant = 'm';
        /**
         * Screen reader text which is used for icon when component can be expanded and the headline is missing.
         * @default ''
         */
        this.screenReaderTextExpand = '';
        /**
         * Screen reader text which is used for icon when component can be collapsed and the headline is missing.
         * @default ''
         */
        this.screenReaderTextCollapse = '';
        /**
         * Event triggered when component expands or collapses.
         */
        this.toggled = new EventEmitter();
        /**
         * Event is triggered when animation is done.
         */
        this.animationEnd = new EventEmitter();
        /** @ignore */
        this.headline = '';
        /** @ignore */
        this.expandableClosedAndAnimationFinished = true;
        this._onlyHeader = false;
        this._onlyBody = false;
        this._expanded = false;
        this._animationDisabled = false;
        this._hasBodyMargin = true;
        iconReg.register(SieIcon.ArrowDown);
    }
    /** @ignore */
    ngOnInit() {
        this.checkForExpandedTitle();
    }
    /** @ignore */
    toggle() {
        if (!this.disabled) {
            this.changeExpand(!this._expanded);
        }
    }
    /** Expands the component. */
    open() {
        if (!this.disabled && !this._expanded) {
            this.changeExpand(true);
        }
    }
    /** Collapses the component. */
    close() {
        if (!this.disabled && this._expanded) {
            this.changeExpand(false);
        }
    }
    /** @ignore */
    onAnimationEnd() {
        if (!this._expanded) {
            this.expandableClosedAndAnimationFinished = true;
            this.toggled.next(this._expanded);
        }
        else {
            this.expandableClosedAndAnimationFinished = false;
            this.body.nativeElement.style.height = null;
        }
        this.animationEnd.emit();
    }
    changeExpand(expanded) {
        this._expanded = expanded;
        if (this._expanded || this.onlyHeader) {
            this.expandableClosedAndAnimationFinished = false;
            this.toggled.next(this._expanded);
        }
        this.checkForExpandedTitle();
        this.cdr.detectChanges();
    }
    checkForExpandedTitle() {
        if (this._expanded && this.headlineExpanded) {
            this.headline = this.headlineExpanded;
        }
        else {
            this.headline = this.headlineCollapsed;
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiExpandableComponent, deps: [{ token: i0.ChangeDetectorRef }, { token: i1.SieIconRegistryService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiExpandableComponent, selector: "sie-ui-expandable", inputs: { theme: "theme", headlineVariant: "headlineVariant", disabled: "disabled", onlyHeader: "onlyHeader", onlyBody: "onlyBody", headlineCollapsed: "headlineCollapsed", headlineExpanded: "headlineExpanded", expanded: "expanded", animationDisabled: "animationDisabled", hasBodyMargin: "hasBodyMargin", screenReaderTextExpand: "screenReaderTextExpand", screenReaderTextCollapse: "screenReaderTextCollapse" }, outputs: { toggled: "toggled", animationEnd: "animationEnd" }, host: { properties: { "attr.disabled": "this.disabled" } }, viewQueries: [{ propertyName: "body", first: true, predicate: ["body"], descendants: true }], ngImport: i0, template: "<div class=\"expandable\" [ngClass]=\"{ dark: theme === 'dark' }\">\n  <div\n    *ngIf=\"!onlyBody\"\n    [ngClass]=\"{ disabled: disabled }\"\n    class=\"expandable__header variant--{{ headlineVariant }}\"\n    tabindex=\"0\"\n    (keydown.enter)=\"toggle()\"\n    (click)=\"toggle()\"\n  >\n    <div class=\"expandable__header__icon-wrapper\" [ngClass]=\"{ expanded: expanded }\">\n      <sie-icon [name]=\"iconReg.sieIcon.ArrowDown\" svgClass=\"expandable__header__icon\"></sie-icon>\n      <span *ngIf=\"!disabled\" class=\"visually-hidden\">{{\n        expanded ? screenReaderTextCollapse : screenReaderTextExpand\n      }}</span>\n    </div>\n    <span class=\"expandable__header__title\">\n      {{ headline }}\n    </span>\n  </div>\n\n  <div\n    *ngIf=\"!onlyHeader\"\n    [ngClass]=\"{ expanded: expanded, 'has-body-margin': hasBodyMargin }\"\n    [@toggleExpandable]=\"expanded\"\n    (@toggleExpandable.done)=\"onAnimationEnd()\"\n    [@.disabled]=\"animationDisabled\"\n    class=\"expandable__body\"\n    #body\n  >\n    <ng-container *ngIf=\"!expandableClosedAndAnimationFinished\">\n      <ng-content></ng-content>\n    </ng-container>\n  </div>\n</div>\n", styles: [".expandable__header{outline:none;outline-offset:0}@media (pointer: fine){.expandable__header{position:relative}.expandable__header:focus{outline:1px solid #1491eb;outline-offset:2px}.expandable__header:focus:not(:focus-visible){outline:0}.expandable__header:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}.expandable{display:flex;flex-direction:column}.expandable__header{display:inline-flex;width:-moz-fit-content;width:fit-content;max-width:328px;flex-direction:row}.expandable__header__icon-wrapper{display:flex;justify-content:center;align-items:center}.expandable__header__icon-wrapper sie-icon{width:24px;height:24px;display:flex;align-items:center;fill:currentColor;display:inline-flex;margin-right:4px;margin-left:-5px;color:#007993}.expandable__header__icon-wrapper sie-icon svg{fill:currentColor;width:inherit;height:inherit}.expandable__header__icon-wrapper sie-icon svg g{fill:currentColor;width:inherit;height:inherit}.expandable__header__icon-wrapper sie-icon svg text{font-family:Siemens Sans,sans-serif}.variant--s .expandable__header__icon-wrapper sie-icon{width:20px;height:20px;display:flex;align-items:center;fill:currentColor;display:inline-flex;margin-right:1px;margin-left:-4px}.variant--s .expandable__header__icon-wrapper sie-icon svg{fill:currentColor;width:inherit;height:inherit}.variant--s .expandable__header__icon-wrapper sie-icon svg g{fill:currentColor;width:inherit;height:inherit}.variant--s .expandable__header__icon-wrapper sie-icon svg text{font-family:Siemens Sans,sans-serif}.expandable__header__icon{color:#007993;transition:all .5s cubic-bezier(.2,0,.38,.9);width:16px;height:16px;display:flex;align-items:center;fill:currentColor}.expandable__header__icon svg{fill:currentColor;width:inherit;height:inherit}.expandable__header__icon svg g{fill:currentColor;width:inherit;height:inherit}.expandable__header__icon svg text{font-family:Siemens Sans,sans-serif}.variant--s .expandable__header__icon{width:12px;height:12px;display:flex;align-items:center;fill:currentColor}.variant--s .expandable__header__icon svg{fill:currentColor;width:inherit;height:inherit}.variant--s .expandable__header__icon svg g{fill:currentColor;width:inherit;height:inherit}.variant--s .expandable__header__icon svg text{font-family:Siemens Sans,sans-serif}.expanded .expandable__header__icon{transform:translateZ(0) rotate(180deg)}.expandable__header__title{white-space:nowrap;overflow:hidden;text-overflow:ellipsis;color:#007993}.expandable__header.disabled{cursor:not-allowed}.expandable__header.disabled .expandable__header__title,.expandable__header.disabled .expandable__header__icon{color:#b3b3be}.expandable__header:not(.disabled):hover{cursor:pointer}.expandable__header:not(.disabled):hover .expandable__header__title{color:#33747a;text-decoration:underline}.expandable__header:not(.disabled):hover .expandable__header__icon{color:#33747a}.expandable__header.variant--s{font-size:.875rem;font-weight:400;line-height:1.25rem}@media (min-width: 640px){.expandable__body{min-width:100%}}@media (min-width: 640px) and (min-width: 640px){.expandable__body{min-width:calc(calc(100vw - 208px)/12 * 4 + 48px)}}@media (min-width: 640px) and (min-width: 1024px){.expandable__body{min-width:calc(calc(100vw - 376px)/12 * 4 + 72px)}}@media (min-width: 640px) and (min-width: 1440px){.expandable__body{min-width:calc(calc(100vw - 456px)/12 * 4 + 72px)}}@media (min-width: 640px) and (min-width: 1920px){.expandable__body{min-width:560px}}.expandable__body.expanded.has-body-margin{margin-top:8px}.expandable.dark{color:#fff}.expandable.dark .expandable__header .expandable__header__icon,.expandable.dark .expandable__header .expandable__header__title{color:#0cc}.expandable.dark .expandable__header.disabled .expandable__header__title,.expandable.dark .expandable__header.disabled .expandable__header__icon{color:#b3b3be}.expandable.dark .expandable__header:not(.disabled):hover .expandable__header__title,.expandable.dark .expandable__header:not(.disabled):hover .expandable__header__icon{color:#00ffb9}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }], animations: [toggleExpandableAnimation], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiExpandableComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-expandable', changeDetection: ChangeDetectionStrategy.OnPush, animations: [toggleExpandableAnimation], template: "<div class=\"expandable\" [ngClass]=\"{ dark: theme === 'dark' }\">\n  <div\n    *ngIf=\"!onlyBody\"\n    [ngClass]=\"{ disabled: disabled }\"\n    class=\"expandable__header variant--{{ headlineVariant }}\"\n    tabindex=\"0\"\n    (keydown.enter)=\"toggle()\"\n    (click)=\"toggle()\"\n  >\n    <div class=\"expandable__header__icon-wrapper\" [ngClass]=\"{ expanded: expanded }\">\n      <sie-icon [name]=\"iconReg.sieIcon.ArrowDown\" svgClass=\"expandable__header__icon\"></sie-icon>\n      <span *ngIf=\"!disabled\" class=\"visually-hidden\">{{\n        expanded ? screenReaderTextCollapse : screenReaderTextExpand\n      }}</span>\n    </div>\n    <span class=\"expandable__header__title\">\n      {{ headline }}\n    </span>\n  </div>\n\n  <div\n    *ngIf=\"!onlyHeader\"\n    [ngClass]=\"{ expanded: expanded, 'has-body-margin': hasBodyMargin }\"\n    [@toggleExpandable]=\"expanded\"\n    (@toggleExpandable.done)=\"onAnimationEnd()\"\n    [@.disabled]=\"animationDisabled\"\n    class=\"expandable__body\"\n    #body\n  >\n    <ng-container *ngIf=\"!expandableClosedAndAnimationFinished\">\n      <ng-content></ng-content>\n    </ng-container>\n  </div>\n</div>\n", styles: [".expandable__header{outline:none;outline-offset:0}@media (pointer: fine){.expandable__header{position:relative}.expandable__header:focus{outline:1px solid #1491eb;outline-offset:2px}.expandable__header:focus:not(:focus-visible){outline:0}.expandable__header:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}.expandable{display:flex;flex-direction:column}.expandable__header{display:inline-flex;width:-moz-fit-content;width:fit-content;max-width:328px;flex-direction:row}.expandable__header__icon-wrapper{display:flex;justify-content:center;align-items:center}.expandable__header__icon-wrapper sie-icon{width:24px;height:24px;display:flex;align-items:center;fill:currentColor;display:inline-flex;margin-right:4px;margin-left:-5px;color:#007993}.expandable__header__icon-wrapper sie-icon svg{fill:currentColor;width:inherit;height:inherit}.expandable__header__icon-wrapper sie-icon svg g{fill:currentColor;width:inherit;height:inherit}.expandable__header__icon-wrapper sie-icon svg text{font-family:Siemens Sans,sans-serif}.variant--s .expandable__header__icon-wrapper sie-icon{width:20px;height:20px;display:flex;align-items:center;fill:currentColor;display:inline-flex;margin-right:1px;margin-left:-4px}.variant--s .expandable__header__icon-wrapper sie-icon svg{fill:currentColor;width:inherit;height:inherit}.variant--s .expandable__header__icon-wrapper sie-icon svg g{fill:currentColor;width:inherit;height:inherit}.variant--s .expandable__header__icon-wrapper sie-icon svg text{font-family:Siemens Sans,sans-serif}.expandable__header__icon{color:#007993;transition:all .5s cubic-bezier(.2,0,.38,.9);width:16px;height:16px;display:flex;align-items:center;fill:currentColor}.expandable__header__icon svg{fill:currentColor;width:inherit;height:inherit}.expandable__header__icon svg g{fill:currentColor;width:inherit;height:inherit}.expandable__header__icon svg text{font-family:Siemens Sans,sans-serif}.variant--s .expandable__header__icon{width:12px;height:12px;display:flex;align-items:center;fill:currentColor}.variant--s .expandable__header__icon svg{fill:currentColor;width:inherit;height:inherit}.variant--s .expandable__header__icon svg g{fill:currentColor;width:inherit;height:inherit}.variant--s .expandable__header__icon svg text{font-family:Siemens Sans,sans-serif}.expanded .expandable__header__icon{transform:translateZ(0) rotate(180deg)}.expandable__header__title{white-space:nowrap;overflow:hidden;text-overflow:ellipsis;color:#007993}.expandable__header.disabled{cursor:not-allowed}.expandable__header.disabled .expandable__header__title,.expandable__header.disabled .expandable__header__icon{color:#b3b3be}.expandable__header:not(.disabled):hover{cursor:pointer}.expandable__header:not(.disabled):hover .expandable__header__title{color:#33747a;text-decoration:underline}.expandable__header:not(.disabled):hover .expandable__header__icon{color:#33747a}.expandable__header.variant--s{font-size:.875rem;font-weight:400;line-height:1.25rem}@media (min-width: 640px){.expandable__body{min-width:100%}}@media (min-width: 640px) and (min-width: 640px){.expandable__body{min-width:calc(calc(100vw - 208px)/12 * 4 + 48px)}}@media (min-width: 640px) and (min-width: 1024px){.expandable__body{min-width:calc(calc(100vw - 376px)/12 * 4 + 72px)}}@media (min-width: 640px) and (min-width: 1440px){.expandable__body{min-width:calc(calc(100vw - 456px)/12 * 4 + 72px)}}@media (min-width: 640px) and (min-width: 1920px){.expandable__body{min-width:560px}}.expandable__body.expanded.has-body-margin{margin-top:8px}.expandable.dark{color:#fff}.expandable.dark .expandable__header .expandable__header__icon,.expandable.dark .expandable__header .expandable__header__title{color:#0cc}.expandable.dark .expandable__header.disabled .expandable__header__title,.expandable.dark .expandable__header.disabled .expandable__header__icon{color:#b3b3be}.expandable.dark .expandable__header:not(.disabled):hover .expandable__header__title,.expandable.dark .expandable__header:not(.disabled):hover .expandable__header__icon{color:#00ffb9}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i1.SieIconRegistryService }]; }, propDecorators: { body: [{
                type: ViewChild,
                args: ['body']
            }], theme: [{
                type: Input
            }], headlineVariant: [{
                type: Input
            }], disabled: [{
                type: HostBinding,
                args: ['attr.disabled']
            }, {
                type: Input
            }], onlyHeader: [{
                type: Input
            }], onlyBody: [{
                type: Input
            }], headlineCollapsed: [{
                type: Input
            }], headlineExpanded: [{
                type: Input
            }], expanded: [{
                type: Input
            }], animationDisabled: [{
                type: Input
            }], hasBodyMargin: [{
                type: Input
            }], screenReaderTextExpand: [{
                type: Input
            }], screenReaderTextCollapse: [{
                type: Input
            }], toggled: [{
                type: Output
            }], animationEnd: [{
                type: Output
            }] } });

/**
 * # Expandable Module
 * - {@link UiExpandableComponent}
 *
 * ## Module peer dependencies
 * - `@angular/platform-browser/animations/BrowserAnimationsModule`: This module is needed for the animation of
 *    expanding or collapsing expandable component for showing the content that is inside the component.
 * - {@link SieIconsModule}
 */
class UiExpandableModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiExpandableModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiExpandableModule, declarations: [UiExpandableComponent], imports: [CommonModule, SieIconsModule], exports: [UiExpandableComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiExpandableModule, imports: [CommonModule, SieIconsModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiExpandableModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiExpandableComponent],
                    imports: [CommonModule, SieIconsModule],
                    exports: [UiExpandableComponent]
                }]
        }] });

class UiExternalHtmlComponent {
    set content(value) {
        const shadowRoot = this.element.nativeElement.shadowRoot;
        shadowRoot.innerHTML = '';
        if (!!value) {
            shadowRoot.appendChild(value);
        }
    }
    constructor(element) {
        this.element = element;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiExternalHtmlComponent, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiExternalHtmlComponent, selector: "sie-ui-external-html", inputs: { content: "content" }, ngImport: i0, template: '', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.ShadowDom }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiExternalHtmlComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'sie-ui-external-html',
                    template: '',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    encapsulation: ViewEncapsulation.ShadowDom
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; }, propDecorators: { content: [{
                type: Input
            }] } });

class UiExternalHtmlModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiExternalHtmlModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiExternalHtmlModule, declarations: [UiExternalHtmlComponent], imports: [CommonModule], exports: [UiExternalHtmlComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiExternalHtmlModule, imports: [CommonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiExternalHtmlModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiExternalHtmlComponent],
                    imports: [CommonModule],
                    exports: [UiExternalHtmlComponent]
                }]
        }] });

/**
 * # Video Player component
 *
 * Videos are used as a part of a content item’s representation (functional),
 * e.g. showing product videos, etc. or part of the brand expression (emotional).
 *
 * ## Component variations
 *
 * This component has no variation. However, this component can be used in combination with the `ui-video-modal`.
 *
 * ## Content
 *
 * The video component does not accept any content.
 *
 * ## Code example
 * @example ```html
 * <sie-ui-video-player
 *   [ratio]="''16-9''"
 *    [size]="'l'"
 *    [video]="{
 *      videoId: '6106650258001',
 *      accountId: '1813624294001',
 *      playerId: 'VMi7Ptd8P',
 *      url: 'https://players.brightcove.net/1813624294001/VMi7Ptd8P_default/index.min.js'
 *     }"
 *    [autoplay]="'true'"
 *    [inModal]="true"
 * ></sie-ui-video-player>
 * ```
 */
class UiVideoPlayerComponent {
    /**
     * @param value Defines if the video should start immediately
     * @default false
     */
    set autoplay(value) {
        this._autoplay = coerceBooleanProperty(value);
    }
    get autoplay() {
        return this._autoplay;
    }
    /**
     * @param value Defines if the video is placed inside of an `ui-video-modal` component
     * @default false
     */
    set inModal(value) {
        this._inModal = coerceBooleanProperty(value);
    }
    get inModal() {
        return this._inModal;
    }
    constructor(document, renderer, iconReg, cdr, scriptService) {
        this.document = document;
        this.renderer = renderer;
        this.iconReg = iconReg;
        this.cdr = cdr;
        this.scriptService = scriptService;
        /**
         * {@link VideoPlayerSize Size} of the video canvas
         * @default 'l'
         */
        this.size = 'l';
        /**
         * {@link VideoPlayerRatio Ratio} of the video canvas
         * @default '16-9'
         */
        this.ratio = '16-9';
        this._autoplay = false;
        this._inModal = false;
        /** @ignore */
        this.showPlaceholder = false;
    }
    /** @ignore */
    async ngOnChanges(changes) {
        if (this.videoWrapper && changes.video.previousValue !== changes.video.currentValue) {
            this.videoWrapper.nativeElement.firstElementChild.remove();
            await this.setVideoData();
        }
    }
    /** @ignore */
    async ngAfterViewInit() {
        if (this.video && this.video.videoId && this.video.playerId && this.video.accountId) {
            await this.setVideoData();
        }
        else {
            this.showPlaceholder = true;
            this.cdr.markForCheck();
        }
    }
    async setVideoData() {
        const attributes = {
            'data-account': this.video.accountId,
            'data-video-id': this.video.videoId,
            'data-player': this.video.playerId,
            'data-embed': 'default',
            'data-application-id': '',
            'data-ste-component': 'video',
            controls: ''
        };
        this.videoEl = this.renderer.createElement('video-js');
        for (const attr of Object.keys(attributes)) {
            this.videoEl.setAttribute(attr, attributes[attr]);
        }
        if (this._autoplay) {
            this.videoEl.setAttribute('autoplay', 'true');
        }
        this.videoEl.classList.add('video-js', 'ratio-' + this.ratio, 'inner-size-' + this.size);
        this.videoEl.style.display = 'block';
        this.videoWrapper.nativeElement.appendChild(this.videoEl);
        await this.scriptService.appendUniqueScriptAsPromise(this.video.url);
        this.videoScriptLoaded();
    }
    videoScriptLoaded() {
        this.videoPlayer = this.document.defaultView['bc'](this.videoEl);
        this.videoPlayer.on('loadeddata', () => {
            this.cdr.detectChanges();
        });
        this.videoPlayer.on('error', () => {
            this.showPlaceholder = true;
            this.cdr.detectChanges();
        });
    }
    /** @ignore */
    ngOnInit() {
        this.setPlaceholderImage();
    }
    /**
     * Method that sets the placeholder image
     */
    setPlaceholderImage() {
        this.placeholderImage = this.iconReg.getInternalIconPath(SieIcon.SieportalPlaceholderVideo);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiVideoPlayerComponent, deps: [{ token: DOCUMENT }, { token: i0.Renderer2 }, { token: i1.SieIconRegistryService }, { token: i0.ChangeDetectorRef }, { token: i1$1.ScriptService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiVideoPlayerComponent, selector: "sie-ui-video-player", inputs: { video: "video", size: "size", ratio: "ratio", autoplay: "autoplay", inModal: "inModal" }, viewQueries: [{ propertyName: "videoWrapper", first: true, predicate: ["videoWrapper"], descendants: true }], usesOnChanges: true, ngImport: i0, template: "<figure *ngIf=\"showPlaceholder\" class=\"figure\" [ngClass]=\"[size ? 'size-' + size : '', inModal ? 'in-modal' : '']\">\n  <picture class=\"placeholder-image\" [ngClass]=\"[ratio ? 'ratio-' + ratio : '']\">\n    <img loading=\"lazy\" class=\"placeholder-image__icon\" [attr.src]=\"placeholderImage\" alt=\"\" />\n  </picture>\n</figure>\n\n<div\n  [ngStyle]=\"{ display: showPlaceholder ? 'none' : 'block' }\"\n  [ngClass]=\"[size ? 'size-' + size : '']\"\n  #videoWrapper\n></div>\n", styles: [".figure{position:relative;margin:0;width:100%;height:100%;display:flex;flex-direction:column}.placeholder-image{width:100%;height:100%;display:flex;justify-content:center;align-items:center;background:#e5e5e9}.placeholder-image.ratio-16-9,.placeholder-image.ratio-4-3,.placeholder-image.ratio-3-4{display:block;width:100%;height:0;overflow:hidden;position:relative}.placeholder-image__icon{position:absolute;top:50%;left:50%;transform:translate(-50%,-50%);width:140px;height:145px;filter:invert(52%) sepia(8%) saturate(844%) hue-rotate(196deg) brightness(96%) contrast(88%)}.figure.size-xxs .placeholder-image__icon{width:70px;height:75px}@media (max-width: 639.78px){.figure.in-modal.size-xxs .placeholder-image .placeholder-image__icon,.figure.in-modal.size-xs .placeholder-image .placeholder-image__icon,.figure.in-modal.size-s .placeholder-image .placeholder-image__icon,.figure.in-modal.size-m .placeholder-image .placeholder-image__icon,.figure.in-modal.size-l .placeholder-image .placeholder-image__icon{height:90%;width:auto}}@media (max-width: 359.78px){.figure.in-modal.size-xl .placeholder-image .placeholder-image__icon,.figure.in-modal.size-xxl .placeholder-image .placeholder-image__icon{height:90%;width:auto}}.video-js,.size-auto{width:100%}.size-xxs{width:calc(calc(100vw - 208px)/12 * 2 + 16px)}@media (min-width: 1024px){.size-xxs{width:calc(calc(100vw - 376px)/12 * 2 + 24px)}}@media (min-width: 1440px){.size-xxs{width:calc(calc(100vw - 456px)/12 * 2 + 24px)}}@media (min-width: 1920px){.size-xxs{width:268px}}.size-xs{width:calc((100vw - 208px)/4 + 32px)}@media (min-width: 1024px){.size-xs{width:calc((100vw - 376px)/4 + 48px)}}@media (min-width: 1440px){.size-xs{width:calc((100vw - 456px)/4 + 48px)}}@media (min-width: 1920px){.size-xs{width:414px}}.size-s{width:calc(calc(100vw - 208px)/12 * 4 + 48px)}@media (min-width: 1024px){.size-s{width:calc(calc(100vw - 376px)/12 * 4 + 72px)}}@media (min-width: 1440px){.size-s{width:calc(calc(100vw - 456px)/12 * 4 + 72px)}}@media (min-width: 1920px){.size-s{width:560px}}.size-m{width:calc((100vw - 208px)/2 + 80px)}@media (min-width: 1024px){.size-m{width:calc((100vw - 376px)/2 + 120px)}}@media (min-width: 1440px){.size-m{width:calc((100vw - 456px)/2 + 120px)}}@media (min-width: 1920px){.size-m{width:852px}}.size-l{width:calc(calc(100vw - 208px)/12 * 8 + 112px)}@media (min-width: 1024px){.size-l{width:calc(calc(100vw - 376px)/12 * 8 + 168px)}}@media (min-width: 1440px){.size-l{width:calc(calc(100vw - 456px)/12 * 8 + 168px)}}@media (min-width: 1920px){.size-l{width:1144px}}.size-xl{width:calc((100vw - 208px)*.75 + 128px)}@media (min-width: 1024px){.size-xl{width:calc((100vw - 376px)*.75 + 192px)}}@media (min-width: 1440px){.size-xl{width:calc((100vw - 456px)*.75 + 192px)}}@media (min-width: 1920px){.size-xl{width:1290px}}.size-xxl{width:calc((100vw - 208px)*1 + 176px)}@media (min-width: 1024px){.size-xxl{width:calc((100vw - 376px)*1 + 264px)}}@media (min-width: 1440px){.size-xxl{width:calc((100vw - 456px)*1 + 264px)}}@media (min-width: 1920px){.size-xxl{width:1728px}}.ratio-16-9{padding-top:56.25%}.ratio-4-3{padding-top:75%}.ratio-3-4{padding-top:133.3333333333%}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiVideoPlayerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-video-player', changeDetection: ChangeDetectionStrategy.OnPush, template: "<figure *ngIf=\"showPlaceholder\" class=\"figure\" [ngClass]=\"[size ? 'size-' + size : '', inModal ? 'in-modal' : '']\">\n  <picture class=\"placeholder-image\" [ngClass]=\"[ratio ? 'ratio-' + ratio : '']\">\n    <img loading=\"lazy\" class=\"placeholder-image__icon\" [attr.src]=\"placeholderImage\" alt=\"\" />\n  </picture>\n</figure>\n\n<div\n  [ngStyle]=\"{ display: showPlaceholder ? 'none' : 'block' }\"\n  [ngClass]=\"[size ? 'size-' + size : '']\"\n  #videoWrapper\n></div>\n", styles: [".figure{position:relative;margin:0;width:100%;height:100%;display:flex;flex-direction:column}.placeholder-image{width:100%;height:100%;display:flex;justify-content:center;align-items:center;background:#e5e5e9}.placeholder-image.ratio-16-9,.placeholder-image.ratio-4-3,.placeholder-image.ratio-3-4{display:block;width:100%;height:0;overflow:hidden;position:relative}.placeholder-image__icon{position:absolute;top:50%;left:50%;transform:translate(-50%,-50%);width:140px;height:145px;filter:invert(52%) sepia(8%) saturate(844%) hue-rotate(196deg) brightness(96%) contrast(88%)}.figure.size-xxs .placeholder-image__icon{width:70px;height:75px}@media (max-width: 639.78px){.figure.in-modal.size-xxs .placeholder-image .placeholder-image__icon,.figure.in-modal.size-xs .placeholder-image .placeholder-image__icon,.figure.in-modal.size-s .placeholder-image .placeholder-image__icon,.figure.in-modal.size-m .placeholder-image .placeholder-image__icon,.figure.in-modal.size-l .placeholder-image .placeholder-image__icon{height:90%;width:auto}}@media (max-width: 359.78px){.figure.in-modal.size-xl .placeholder-image .placeholder-image__icon,.figure.in-modal.size-xxl .placeholder-image .placeholder-image__icon{height:90%;width:auto}}.video-js,.size-auto{width:100%}.size-xxs{width:calc(calc(100vw - 208px)/12 * 2 + 16px)}@media (min-width: 1024px){.size-xxs{width:calc(calc(100vw - 376px)/12 * 2 + 24px)}}@media (min-width: 1440px){.size-xxs{width:calc(calc(100vw - 456px)/12 * 2 + 24px)}}@media (min-width: 1920px){.size-xxs{width:268px}}.size-xs{width:calc((100vw - 208px)/4 + 32px)}@media (min-width: 1024px){.size-xs{width:calc((100vw - 376px)/4 + 48px)}}@media (min-width: 1440px){.size-xs{width:calc((100vw - 456px)/4 + 48px)}}@media (min-width: 1920px){.size-xs{width:414px}}.size-s{width:calc(calc(100vw - 208px)/12 * 4 + 48px)}@media (min-width: 1024px){.size-s{width:calc(calc(100vw - 376px)/12 * 4 + 72px)}}@media (min-width: 1440px){.size-s{width:calc(calc(100vw - 456px)/12 * 4 + 72px)}}@media (min-width: 1920px){.size-s{width:560px}}.size-m{width:calc((100vw - 208px)/2 + 80px)}@media (min-width: 1024px){.size-m{width:calc((100vw - 376px)/2 + 120px)}}@media (min-width: 1440px){.size-m{width:calc((100vw - 456px)/2 + 120px)}}@media (min-width: 1920px){.size-m{width:852px}}.size-l{width:calc(calc(100vw - 208px)/12 * 8 + 112px)}@media (min-width: 1024px){.size-l{width:calc(calc(100vw - 376px)/12 * 8 + 168px)}}@media (min-width: 1440px){.size-l{width:calc(calc(100vw - 456px)/12 * 8 + 168px)}}@media (min-width: 1920px){.size-l{width:1144px}}.size-xl{width:calc((100vw - 208px)*.75 + 128px)}@media (min-width: 1024px){.size-xl{width:calc((100vw - 376px)*.75 + 192px)}}@media (min-width: 1440px){.size-xl{width:calc((100vw - 456px)*.75 + 192px)}}@media (min-width: 1920px){.size-xl{width:1290px}}.size-xxl{width:calc((100vw - 208px)*1 + 176px)}@media (min-width: 1024px){.size-xxl{width:calc((100vw - 376px)*1 + 264px)}}@media (min-width: 1440px){.size-xxl{width:calc((100vw - 456px)*1 + 264px)}}@media (min-width: 1920px){.size-xxl{width:1728px}}.ratio-16-9{padding-top:56.25%}.ratio-4-3{padding-top:75%}.ratio-3-4{padding-top:133.3333333333%}\n"] }]
        }], ctorParameters: function () { return [{ type: Document, decorators: [{
                    type: Inject,
                    args: [DOCUMENT]
                }] }, { type: i0.Renderer2 }, { type: i1.SieIconRegistryService }, { type: i0.ChangeDetectorRef }, { type: i1$1.ScriptService }]; }, propDecorators: { videoWrapper: [{
                type: ViewChild,
                args: ['videoWrapper']
            }], video: [{
                type: Input
            }], size: [{
                type: Input
            }], ratio: [{
                type: Input
            }], autoplay: [{
                type: Input
            }], inModal: [{
                type: Input
            }] } });

/**
 * # Video Player Module
 * - {@link UiVideoPlayerComponent}
 *
 * ## Module peer dependencies
 * - {@link SieIconsModule}
 */
class UiVideoPlayerModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiVideoPlayerModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiVideoPlayerModule, declarations: [UiVideoPlayerComponent], imports: [CommonModule, SieIconsModule], exports: [UiVideoPlayerComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiVideoPlayerModule, imports: [CommonModule, SieIconsModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiVideoPlayerModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiVideoPlayerComponent],
                    imports: [CommonModule, SieIconsModule],
                    exports: [UiVideoPlayerComponent]
                }]
        }] });

class UiInterstitialComponent {
    constructor(iconReg) {
        this.iconReg = iconReg;
        this.loading = true;
        this.spinnerSize = UiSpinnerSize.large;
        this.iconReg.register(SieIcon.CheckMark);
        this.iconReg.register(SieIcon.LocationPin);
        this.iconReg.register(SieIcon.Calendar);
        this.iconReg.register(SieIcon.QuotationGradient);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiInterstitialComponent, deps: [{ token: i1.SieIconRegistryService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiInterstitialComponent, selector: "sie-ui-interstitial", inputs: { loading: "loading", interstitialData$: "interstitialData$" }, ngImport: i0, template: "<div *ngIf=\"loading\" class=\"spinner-centered\">\n  <sie-ui-spinner active [size]=\"spinnerSize\"></sie-ui-spinner>\n</div>\n\n<sie-ui-empty-state\n  *ngIf=\"!loading && !interstitialData$?.value\"\n  [customIcon]=\"iconReg.sieIcon.SieportalEmptyStateNotification\"\n  class=\"container empty-spacing\"\n></sie-ui-empty-state>\n\n<ng-container *ngIf=\"interstitialData$?.value as data\">\n  <div class=\"interstitial-wrapper\">\n    <header>\n      <span *ngIf=\"data.subtitle\" class=\"interstitial__headline\">\n        {{ data.subtitle }}\n      </span>\n      <div *ngIf=\"data.video?.videoId\" class=\"interstitial__video-wrapper\">\n        <sie-ui-video-player [video]=\"data.video\" size=\"auto\"></sie-ui-video-player>\n      </div>\n      <div *ngIf=\"!data.video?.videoId && data.secondaryImage?.urlLarge\" class=\"interstitial__image-wrapper\">\n        <sie-ui-picture [model]=\"data.secondaryImage\" ratio=\"16-9\"></sie-ui-picture>\n      </div>\n      <div *ngIf=\"data.benefits || data.type === 'event'\" class=\"interstitial__details-outer-wrapper\">\n        <div *ngIf=\"data.benefits\" class=\"interstitial__details-wrapper\">\n          <ng-container *ngFor=\"let benefit of data.benefits\">\n            <div class=\"interstitial__details__item-wrapper\">\n              <sie-icon [name]=\"iconReg.sieIcon.CheckMark\" class=\"interstitial__details__icon\"></sie-icon>\n              <span>{{ benefit }}</span>\n            </div>\n          </ng-container>\n        </div>\n        <div *ngIf=\"data.type === 'event'\" class=\"interstitial__details-wrapper interstitial__details-wrapper--time\">\n          <div class=\"interstitial__details__item-wrapper\">\n            <sie-icon [name]=\"iconReg.sieIcon.LocationPin\" class=\"interstitial__details__icon\"></sie-icon>\n            <span>{{ data.location }}</span>\n          </div>\n          <div class=\"interstitial__details__item-wrapper\">\n            <sie-icon [name]=\"iconReg.sieIcon.Calendar\" class=\"interstitial__details__icon\"></sie-icon>\n            <span>{{ data.date }}</span>\n          </div>\n        </div>\n      </div>\n    </header>\n    <section class=\"interstitial__body\">\n      <div class=\"interstitial__body--left\">\n        <div *ngIf=\"data.quote\" class=\"interstitial__quote-wrapper\">\n          <sie-icon [name]=\"iconReg.sieIcon.QuotationGradient\" class=\"interstitial__quote__icon\"></sie-icon>\n          <div class=\"interstitial__quote\">\n            <p class=\"interstitial__quote__text\">\n              {{ data.quote }}\n            </p>\n            <span class=\"interstitial__quote__author\">\n              {{ data.quoteAuthor }}\n            </span>\n          </div>\n        </div>\n        <div class=\"interstitial__description-wrapper\">\n          <sie-ui-richtext [content]=\"data.description\" class=\"interstitial__description\"></sie-ui-richtext>\n          <div *ngFor=\"let link of data.links\" class=\"interstitial__link-wrapper\">\n            <ng-container *ngIf=\"link.href\">\n              <sie-ui-link [href]=\"link.href\" [target]=\"link.target\" offsetIcon>{{ link.linkText }}</sie-ui-link>\n            </ng-container>\n          </div>\n        </div>\n      </div>\n      <div *ngIf=\"data.video?.videoId !== '' && data.secondaryImage?.urlLarge\" class=\"interstitial__body--right\">\n        <div class=\"interstitial__body__image-wrapper\">\n          <sie-ui-picture [model]=\"data.secondaryImage\" ratio=\"16-9\"></sie-ui-picture>\n        </div>\n      </div>\n    </section>\n    <footer class=\"interstitial__footer\">\n      <div class=\"interstitial__footer--left\">\n        <div *ngIf=\"data.mlfb\" class=\"interstitial__price-wrapper--mobile\">\n          <span class=\"interstitial__mlfb\">\n            {{ data.mlfb }}\n          </span>\n        </div>\n        <div class=\"interstitial__button-wrapper--mobile\">\n          <sie-ui-button-group\n            [buttons]=\"data.buttons\"\n            [fullWidthOnViewportS]=\"true\"\n            buttonAlignmentClass=\"right\"\n          ></sie-ui-button-group>\n        </div>\n        <div *ngIf=\"data.disclaimer\" class=\"interstitial__disclaimer-wrapper\">\n          <span>\n            {{ data.disclaimer }}\n          </span>\n        </div>\n      </div>\n      <div class=\"interstitial__footer--right\">\n        <div *ngIf=\"data.mlfb\" class=\"interstitial__price-wrapper\">\n          <span class=\"interstitial__mlfb\">\n            {{ data.mlfb }}\n          </span>\n        </div>\n        <div class=\"interstitial__button-wrapper\">\n          <sie-ui-button-group [buttons]=\"data.buttons\" buttonAlignmentClass=\"right\"></sie-ui-button-group>\n        </div>\n      </div>\n    </footer>\n  </div>\n</ng-container>\n", styles: [".interstitial__headline{display:inline-block;margin-bottom:24px}@media (min-width: 1024px){.interstitial__headline{font-size:1.25rem;font-weight:400;line-height:1.625rem}}.interstitial__video-wrapper,.interstitial__image-wrapper{margin-bottom:40px}@media (max-width: 1023.78px){.interstitial__video-wrapper,.interstitial__image-wrapper{margin-bottom:32px}}.interstitial__details-wrapper{display:flex}@media (max-width: 639.78px){.interstitial__details-wrapper{flex-direction:column}}.interstitial__details-wrapper--time{margin-top:0}@media (max-width: 639.78px){.interstitial__details-wrapper--time{margin-top:8px}}@media (max-width: 1023.78px){.interstitial__details-wrapper--time{margin-bottom:8px}}.interstitial__details__item-wrapper{display:flex;align-items:center;margin:0 32px 32px 0}@media (max-width: 1023.78px){.interstitial__details__item-wrapper{margin:0 24px 24px 0}}@media (max-width: 639.78px){.interstitial__details__item-wrapper{margin-bottom:16px}}.interstitial__details__item-wrapper span{margin-left:8px;color:#4c4c68}@media (min-width: 1024px){.interstitial__details__item-wrapper span{font-size:1.25rem;font-weight:400;line-height:1.625rem}}.interstitial__details__icon{width:24px;height:24px;display:flex;align-items:center;fill:currentColor;color:#005159}@media (min-width: 1024px){.interstitial__details__icon{width:32px;height:32px;display:flex;align-items:center;fill:currentColor}.interstitial__details__icon svg{fill:currentColor;width:inherit;height:inherit}.interstitial__details__icon svg g{fill:currentColor;width:inherit;height:inherit}.interstitial__details__icon svg text{font-family:Siemens Sans,sans-serif}}.interstitial__details__icon svg{fill:currentColor;width:inherit;height:inherit}.interstitial__details__icon svg g{fill:currentColor;width:inherit;height:inherit}.interstitial__details__icon svg text{font-family:Siemens Sans,sans-serif}.interstitial__quote{margin:0 0 32px 8px}.interstitial__quote-wrapper{display:flex}@media (max-width: 639.78px){.interstitial__quote-wrapper{margin-top:8px}}.interstitial__quote__icon{margin-top:-1px}.interstitial__quote__text{font-size:1.25rem;font-weight:400;line-height:1.625rem;color:#4c4c68;margin-bottom:16px}.interstitial__quote__author{font-size:.875rem;font-weight:400;line-height:1.25rem;color:#9999a9}.interstitial__body{display:flex}@media (max-width: 1023.78px){.interstitial__body{flex-direction:column}}.interstitial__body--left,.interstitial__body--right{flex:1}@media (min-width: 1024px){.interstitial__body--right{margin-left:24px}}@media (max-width: 1023.78px){.interstitial__body--right{margin-top:24px}}.interstitial__body__image-wrapper{padding-bottom:8px}.interstitial__link-wrapper{margin-top:8px}.interstitial__footer{display:flex;justify-content:space-between;margin-top:16px}@media (max-width: 1023.78px){.interstitial__footer{margin-top:24px}}.interstitial__footer--left{align-self:flex-end;flex-grow:1}.interstitial__footer--left span{font-size:.875rem;font-weight:400;line-height:1.25rem;color:#4c4c68}.interstitial__footer--right{display:flex}@media (max-width: 1023.78px){.interstitial__footer--right{align-items:flex-end}}.interstitial__price-wrapper{display:flex;align-items:flex-end;margin-right:24px}@media (max-width: 1023.78px){.interstitial__price-wrapper{display:none}}.interstitial__price-wrapper--mobile{margin-bottom:24px}@media (min-width: 1024px){.interstitial__price-wrapper--mobile{display:none}}.interstitial__button-wrapper{display:none}@media (min-width: 640px){.interstitial__button-wrapper{display:block}}@media (min-width: 640px){.interstitial__button-wrapper--mobile{display:none}}@media (max-width: 1023.78px){.interstitial__disclaimer-wrapper{margin-top:16px}}.interstitial__disclaimer-wrapper span{font-size:.75rem;font-weight:400;line-height:1rem;color:#9999a9}.interstitial__mlfb{font-size:.875rem;font-weight:400;line-height:1.25rem}.spinner-centered{display:flex;justify-content:center;align-items:center;padding:40px 100px 70px}\n"], dependencies: [{ kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "component", type: UiVideoPlayerComponent, selector: "sie-ui-video-player", inputs: ["video", "size", "ratio", "autoplay", "inModal"] }, { kind: "component", type: UiPictureComponent, selector: "sie-ui-picture", inputs: ["model", "size", "ratio", "notLoadedLabel", "theme", "context", "caption", "shouldHaveOutline"], outputs: ["failedToLoadImg"] }, { kind: "component", type: UiLinkComponent, selector: "sie-ui-link", inputs: ["disabled", "disableVisitedStyle", "hasMarginTop", "offsetIcon", "truncate", "inLinkList", "trailingIcon", "icon", "cssClass", "href", "size", "target", "variant", "background", "type", "reference", "screenReaderText", "secondaryLabel", "download", "dataAttributes", "tooltip", "buttonType"], outputs: ["clicked"] }, { kind: "component", type: UiButtonGroupComponent, selector: "sie-ui-button-group", inputs: ["buttons", "fullWidthOnViewportS", "wrapButtons", "direction", "flexDirection", "fullWidth", "buttonAlignmentClass"], outputs: ["buttonClick"] }, { kind: "component", type: UiSpinnerComponent, selector: "sie-ui-spinner", inputs: ["size", "message", "overlayOnTop", "overlay", "active"], outputs: ["animationEnded"] }, { kind: "component", type: UiRichtextComponent, selector: "sie-ui-richtext", inputs: ["content", "theme", "whiteListedTags"] }, { kind: "component", type: UiEmptyStateComponent, selector: "sie-ui-empty-state", inputs: ["theme", "headline", "text", "link", "button", "iconPosition", "padding", "customIcon"], outputs: ["buttonClicked"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiInterstitialComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-interstitial', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div *ngIf=\"loading\" class=\"spinner-centered\">\n  <sie-ui-spinner active [size]=\"spinnerSize\"></sie-ui-spinner>\n</div>\n\n<sie-ui-empty-state\n  *ngIf=\"!loading && !interstitialData$?.value\"\n  [customIcon]=\"iconReg.sieIcon.SieportalEmptyStateNotification\"\n  class=\"container empty-spacing\"\n></sie-ui-empty-state>\n\n<ng-container *ngIf=\"interstitialData$?.value as data\">\n  <div class=\"interstitial-wrapper\">\n    <header>\n      <span *ngIf=\"data.subtitle\" class=\"interstitial__headline\">\n        {{ data.subtitle }}\n      </span>\n      <div *ngIf=\"data.video?.videoId\" class=\"interstitial__video-wrapper\">\n        <sie-ui-video-player [video]=\"data.video\" size=\"auto\"></sie-ui-video-player>\n      </div>\n      <div *ngIf=\"!data.video?.videoId && data.secondaryImage?.urlLarge\" class=\"interstitial__image-wrapper\">\n        <sie-ui-picture [model]=\"data.secondaryImage\" ratio=\"16-9\"></sie-ui-picture>\n      </div>\n      <div *ngIf=\"data.benefits || data.type === 'event'\" class=\"interstitial__details-outer-wrapper\">\n        <div *ngIf=\"data.benefits\" class=\"interstitial__details-wrapper\">\n          <ng-container *ngFor=\"let benefit of data.benefits\">\n            <div class=\"interstitial__details__item-wrapper\">\n              <sie-icon [name]=\"iconReg.sieIcon.CheckMark\" class=\"interstitial__details__icon\"></sie-icon>\n              <span>{{ benefit }}</span>\n            </div>\n          </ng-container>\n        </div>\n        <div *ngIf=\"data.type === 'event'\" class=\"interstitial__details-wrapper interstitial__details-wrapper--time\">\n          <div class=\"interstitial__details__item-wrapper\">\n            <sie-icon [name]=\"iconReg.sieIcon.LocationPin\" class=\"interstitial__details__icon\"></sie-icon>\n            <span>{{ data.location }}</span>\n          </div>\n          <div class=\"interstitial__details__item-wrapper\">\n            <sie-icon [name]=\"iconReg.sieIcon.Calendar\" class=\"interstitial__details__icon\"></sie-icon>\n            <span>{{ data.date }}</span>\n          </div>\n        </div>\n      </div>\n    </header>\n    <section class=\"interstitial__body\">\n      <div class=\"interstitial__body--left\">\n        <div *ngIf=\"data.quote\" class=\"interstitial__quote-wrapper\">\n          <sie-icon [name]=\"iconReg.sieIcon.QuotationGradient\" class=\"interstitial__quote__icon\"></sie-icon>\n          <div class=\"interstitial__quote\">\n            <p class=\"interstitial__quote__text\">\n              {{ data.quote }}\n            </p>\n            <span class=\"interstitial__quote__author\">\n              {{ data.quoteAuthor }}\n            </span>\n          </div>\n        </div>\n        <div class=\"interstitial__description-wrapper\">\n          <sie-ui-richtext [content]=\"data.description\" class=\"interstitial__description\"></sie-ui-richtext>\n          <div *ngFor=\"let link of data.links\" class=\"interstitial__link-wrapper\">\n            <ng-container *ngIf=\"link.href\">\n              <sie-ui-link [href]=\"link.href\" [target]=\"link.target\" offsetIcon>{{ link.linkText }}</sie-ui-link>\n            </ng-container>\n          </div>\n        </div>\n      </div>\n      <div *ngIf=\"data.video?.videoId !== '' && data.secondaryImage?.urlLarge\" class=\"interstitial__body--right\">\n        <div class=\"interstitial__body__image-wrapper\">\n          <sie-ui-picture [model]=\"data.secondaryImage\" ratio=\"16-9\"></sie-ui-picture>\n        </div>\n      </div>\n    </section>\n    <footer class=\"interstitial__footer\">\n      <div class=\"interstitial__footer--left\">\n        <div *ngIf=\"data.mlfb\" class=\"interstitial__price-wrapper--mobile\">\n          <span class=\"interstitial__mlfb\">\n            {{ data.mlfb }}\n          </span>\n        </div>\n        <div class=\"interstitial__button-wrapper--mobile\">\n          <sie-ui-button-group\n            [buttons]=\"data.buttons\"\n            [fullWidthOnViewportS]=\"true\"\n            buttonAlignmentClass=\"right\"\n          ></sie-ui-button-group>\n        </div>\n        <div *ngIf=\"data.disclaimer\" class=\"interstitial__disclaimer-wrapper\">\n          <span>\n            {{ data.disclaimer }}\n          </span>\n        </div>\n      </div>\n      <div class=\"interstitial__footer--right\">\n        <div *ngIf=\"data.mlfb\" class=\"interstitial__price-wrapper\">\n          <span class=\"interstitial__mlfb\">\n            {{ data.mlfb }}\n          </span>\n        </div>\n        <div class=\"interstitial__button-wrapper\">\n          <sie-ui-button-group [buttons]=\"data.buttons\" buttonAlignmentClass=\"right\"></sie-ui-button-group>\n        </div>\n      </div>\n    </footer>\n  </div>\n</ng-container>\n", styles: [".interstitial__headline{display:inline-block;margin-bottom:24px}@media (min-width: 1024px){.interstitial__headline{font-size:1.25rem;font-weight:400;line-height:1.625rem}}.interstitial__video-wrapper,.interstitial__image-wrapper{margin-bottom:40px}@media (max-width: 1023.78px){.interstitial__video-wrapper,.interstitial__image-wrapper{margin-bottom:32px}}.interstitial__details-wrapper{display:flex}@media (max-width: 639.78px){.interstitial__details-wrapper{flex-direction:column}}.interstitial__details-wrapper--time{margin-top:0}@media (max-width: 639.78px){.interstitial__details-wrapper--time{margin-top:8px}}@media (max-width: 1023.78px){.interstitial__details-wrapper--time{margin-bottom:8px}}.interstitial__details__item-wrapper{display:flex;align-items:center;margin:0 32px 32px 0}@media (max-width: 1023.78px){.interstitial__details__item-wrapper{margin:0 24px 24px 0}}@media (max-width: 639.78px){.interstitial__details__item-wrapper{margin-bottom:16px}}.interstitial__details__item-wrapper span{margin-left:8px;color:#4c4c68}@media (min-width: 1024px){.interstitial__details__item-wrapper span{font-size:1.25rem;font-weight:400;line-height:1.625rem}}.interstitial__details__icon{width:24px;height:24px;display:flex;align-items:center;fill:currentColor;color:#005159}@media (min-width: 1024px){.interstitial__details__icon{width:32px;height:32px;display:flex;align-items:center;fill:currentColor}.interstitial__details__icon svg{fill:currentColor;width:inherit;height:inherit}.interstitial__details__icon svg g{fill:currentColor;width:inherit;height:inherit}.interstitial__details__icon svg text{font-family:Siemens Sans,sans-serif}}.interstitial__details__icon svg{fill:currentColor;width:inherit;height:inherit}.interstitial__details__icon svg g{fill:currentColor;width:inherit;height:inherit}.interstitial__details__icon svg text{font-family:Siemens Sans,sans-serif}.interstitial__quote{margin:0 0 32px 8px}.interstitial__quote-wrapper{display:flex}@media (max-width: 639.78px){.interstitial__quote-wrapper{margin-top:8px}}.interstitial__quote__icon{margin-top:-1px}.interstitial__quote__text{font-size:1.25rem;font-weight:400;line-height:1.625rem;color:#4c4c68;margin-bottom:16px}.interstitial__quote__author{font-size:.875rem;font-weight:400;line-height:1.25rem;color:#9999a9}.interstitial__body{display:flex}@media (max-width: 1023.78px){.interstitial__body{flex-direction:column}}.interstitial__body--left,.interstitial__body--right{flex:1}@media (min-width: 1024px){.interstitial__body--right{margin-left:24px}}@media (max-width: 1023.78px){.interstitial__body--right{margin-top:24px}}.interstitial__body__image-wrapper{padding-bottom:8px}.interstitial__link-wrapper{margin-top:8px}.interstitial__footer{display:flex;justify-content:space-between;margin-top:16px}@media (max-width: 1023.78px){.interstitial__footer{margin-top:24px}}.interstitial__footer--left{align-self:flex-end;flex-grow:1}.interstitial__footer--left span{font-size:.875rem;font-weight:400;line-height:1.25rem;color:#4c4c68}.interstitial__footer--right{display:flex}@media (max-width: 1023.78px){.interstitial__footer--right{align-items:flex-end}}.interstitial__price-wrapper{display:flex;align-items:flex-end;margin-right:24px}@media (max-width: 1023.78px){.interstitial__price-wrapper{display:none}}.interstitial__price-wrapper--mobile{margin-bottom:24px}@media (min-width: 1024px){.interstitial__price-wrapper--mobile{display:none}}.interstitial__button-wrapper{display:none}@media (min-width: 640px){.interstitial__button-wrapper{display:block}}@media (min-width: 640px){.interstitial__button-wrapper--mobile{display:none}}@media (max-width: 1023.78px){.interstitial__disclaimer-wrapper{margin-top:16px}}.interstitial__disclaimer-wrapper span{font-size:.75rem;font-weight:400;line-height:1rem;color:#9999a9}.interstitial__mlfb{font-size:.875rem;font-weight:400;line-height:1.25rem}.spinner-centered{display:flex;justify-content:center;align-items:center;padding:40px 100px 70px}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }]; }, propDecorators: { loading: [{
                type: Input
            }], interstitialData$: [{
                type: Input
            }] } });

class UiInterstitialModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiInterstitialModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiInterstitialModule, declarations: [UiInterstitialComponent], imports: [CommonModule,
            SieIconsModule,
            UiVideoPlayerModule,
            UiPictureModule,
            UiLinkModule,
            UiButtonGroupModule,
            UiSpinnerModule,
            UiRichtextModule,
            UiEmptyStateModule], exports: [UiInterstitialComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiInterstitialModule, imports: [CommonModule,
            SieIconsModule,
            UiVideoPlayerModule,
            UiPictureModule,
            UiLinkModule,
            UiButtonGroupModule,
            UiSpinnerModule,
            UiRichtextModule,
            UiEmptyStateModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiInterstitialModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiInterstitialComponent],
                    imports: [
                        CommonModule,
                        SieIconsModule,
                        UiVideoPlayerModule,
                        UiPictureModule,
                        UiLinkModule,
                        UiButtonGroupModule,
                        UiSpinnerModule,
                        UiRichtextModule,
                        UiEmptyStateModule
                    ],
                    exports: [UiInterstitialComponent]
                }]
        }] });

class UiLoadingComponent {
    constructor() {
        this.duration = 2000;
        this.showEmptyState = false;
        this.spinnerSize = UiSpinnerSize.medium;
        this.emptyStateRetryButtonClicked = new Subject();
    }
    ngOnInit() {
        if (this.listOfTexts) {
            this.cycleText();
        }
    }
    cycleText() {
        if (this.listOfTexts.length === 1) {
            this.message$ = of(this.listOfTexts[0]);
            return;
        }
        let first = true;
        this.message$ = from(this.listOfTexts).pipe(concatMap(message => of(message).pipe(delay(first ? ((first = false), 0) : this.duration))), repeat());
    }
    onTryAgainButtonClicked(event) {
        this.cycleText();
        this.emptyStateRetryButtonClicked.next(event);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiLoadingComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiLoadingComponent, selector: "sie-ui-loading", inputs: { listOfTexts: "listOfTexts", duration: "duration", showEmptyState: "showEmptyState", emptyState: "emptyState", spinnerSize: "spinnerSize" }, outputs: { emptyStateRetryButtonClicked: "emptyStateRetryButtonClicked" }, ngImport: i0, template: "<div class=\"loading\">\n  <ng-container *ngIf=\"!showEmptyState\">\n    <sie-ui-spinner class=\"loading__spinner\" active [size]=\"spinnerSize\"></sie-ui-spinner>\n    <p class=\"loading__message\">{{ message$ | async }}</p>\n  </ng-container>\n  <sie-ui-empty-state\n    *ngIf=\"showEmptyState\"\n    class=\"container empty-spacing\"\n    [iconPosition]=\"emptyState.iconPosition\"\n    [headline]=\"emptyState.headline\"\n    [text]=\"emptyState.text\"\n    [customIcon]=\"emptyState.customIcon\"\n    [button]=\"emptyState.button\"\n    (buttonClicked)=\"onTryAgainButtonClicked($event)\"\n  ></sie-ui-empty-state>\n</div>\n", styles: [":host{text-align:center}.loading__spinner{margin:0 auto}.loading__message{font-size:14px;line-height:20px;margin-top:4px}\n"], dependencies: [{ kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: UiSpinnerComponent, selector: "sie-ui-spinner", inputs: ["size", "message", "overlayOnTop", "overlay", "active"], outputs: ["animationEnded"] }, { kind: "component", type: UiEmptyStateComponent, selector: "sie-ui-empty-state", inputs: ["theme", "headline", "text", "link", "button", "iconPosition", "padding", "customIcon"], outputs: ["buttonClicked"] }, { kind: "pipe", type: i2.AsyncPipe, name: "async" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiLoadingComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-loading', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"loading\">\n  <ng-container *ngIf=\"!showEmptyState\">\n    <sie-ui-spinner class=\"loading__spinner\" active [size]=\"spinnerSize\"></sie-ui-spinner>\n    <p class=\"loading__message\">{{ message$ | async }}</p>\n  </ng-container>\n  <sie-ui-empty-state\n    *ngIf=\"showEmptyState\"\n    class=\"container empty-spacing\"\n    [iconPosition]=\"emptyState.iconPosition\"\n    [headline]=\"emptyState.headline\"\n    [text]=\"emptyState.text\"\n    [customIcon]=\"emptyState.customIcon\"\n    [button]=\"emptyState.button\"\n    (buttonClicked)=\"onTryAgainButtonClicked($event)\"\n  ></sie-ui-empty-state>\n</div>\n", styles: [":host{text-align:center}.loading__spinner{margin:0 auto}.loading__message{font-size:14px;line-height:20px;margin-top:4px}\n"] }]
        }], propDecorators: { listOfTexts: [{
                type: Input
            }], duration: [{
                type: Input
            }], showEmptyState: [{
                type: Input
            }], emptyState: [{
                type: Input
            }], spinnerSize: [{
                type: Input
            }], emptyStateRetryButtonClicked: [{
                type: Output
            }] } });

class UiLoadingModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiLoadingModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiLoadingModule, declarations: [UiLoadingComponent], imports: [CommonModule, UiSpinnerModule, UiEmptyStateModule], exports: [UiLoadingComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiLoadingModule, imports: [CommonModule, UiSpinnerModule, UiEmptyStateModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiLoadingModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiLoadingComponent],
                    imports: [CommonModule, UiSpinnerModule, UiEmptyStateModule],
                    exports: [UiLoadingComponent]
                }]
        }] });

class UiStatusComponent {
    constructor(iconReg) {
        this.iconReg = iconReg;
        this.labelVariant = 'S';
        iconReg.register(SieIcon.SuccessFilled);
        iconReg.register(SieIcon.SieportalBadgeSuccess);
        iconReg.register(SieIcon.Warning);
        iconReg.register(SieIcon.WarningFilled);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiStatusComponent, deps: [{ token: i1.SieIconRegistryService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiStatusComponent, selector: "sie-ui-status", inputs: { variant: "variant", label: "label", labelVariant: "labelVariant", icon: "icon" }, ngImport: i0, template: "<sie-icon *ngIf=\"icon\" [ngClass]=\"'status-component__icon status-component__icon--' + variant\" [name]=\"icon\"></sie-icon\n><span *ngIf=\"label\" [ngClass]=\"[labelVariant ? 'size-' + labelVariant : '']\" class=\"status-component__label\" sieCoreAddTooltip>{{ label }}</span>\n", styles: [":host{white-space:nowrap;overflow:hidden;text-overflow:ellipsis;display:flex;align-items:center;justify-content:flex-start}.status-component__icon{margin-right:8px}.status-component__icon--success{color:#00af52;fill:#00af52}.status-component__icon--information{color:#00557c;fill:#00557c}.status-component__icon--warning{color:#ff9000;fill:#ff9000}.status-component__icon--error{color:#ef0137;fill:#ef0137}.status-component__label{white-space:nowrap;overflow:hidden;text-overflow:ellipsis}.status-component__label.size-S,.status-component__label.size-M{font-size:.875rem;font-weight:400;line-height:1.25rem}@media (min-width: 1024px){.status-component__label.size-M{font-size:1rem;font-weight:400;line-height:1.5rem}}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "directive", type: i1$1.AddTooltipDirective, selector: "[sieCoreAddTooltip]" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiStatusComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-status', changeDetection: ChangeDetectionStrategy.OnPush, template: "<sie-icon *ngIf=\"icon\" [ngClass]=\"'status-component__icon status-component__icon--' + variant\" [name]=\"icon\"></sie-icon\n><span *ngIf=\"label\" [ngClass]=\"[labelVariant ? 'size-' + labelVariant : '']\" class=\"status-component__label\" sieCoreAddTooltip>{{ label }}</span>\n", styles: [":host{white-space:nowrap;overflow:hidden;text-overflow:ellipsis;display:flex;align-items:center;justify-content:flex-start}.status-component__icon{margin-right:8px}.status-component__icon--success{color:#00af52;fill:#00af52}.status-component__icon--information{color:#00557c;fill:#00557c}.status-component__icon--warning{color:#ff9000;fill:#ff9000}.status-component__icon--error{color:#ef0137;fill:#ef0137}.status-component__label{white-space:nowrap;overflow:hidden;text-overflow:ellipsis}.status-component__label.size-S,.status-component__label.size-M{font-size:.875rem;font-weight:400;line-height:1.25rem}@media (min-width: 1024px){.status-component__label.size-M{font-size:1rem;font-weight:400;line-height:1.5rem}}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }]; }, propDecorators: { variant: [{
                type: Input
            }], label: [{
                type: Input
            }], labelVariant: [{
                type: Input
            }], icon: [{
                type: Input
            }] } });

class UiStatusModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiStatusModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiStatusModule, declarations: [UiStatusComponent], imports: [CommonModule, SieIconsModule, AddTooltipModule], exports: [UiStatusComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiStatusModule, imports: [CommonModule, SieIconsModule, AddTooltipModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiStatusModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiStatusComponent],
                    imports: [CommonModule, SieIconsModule, AddTooltipModule],
                    exports: [UiStatusComponent]
                }]
        }] });

class UiOverflowComponent {
    /**
     * @example
     * limit="45px" (pixel value)
     * limit="3" (number of lines of text)
     */
    set limit(value) {
        if (value) {
            this._limit = `${value}`;
        }
        this.handleLimitUpdate();
    }
    constructor(iconReg, cdr, layoutService, elementRef, doc) {
        this.iconReg = iconReg;
        this.cdr = cdr;
        this.layoutService = layoutService;
        this.elementRef = elementRef;
        this.doc = doc;
        this.useGradient = true;
        this.size = 'm';
        this.buttonIndentationLeft = '0px';
        this.buttonIndentationTop = '0px';
        this.centered = false;
        this.theme = 'light';
        this.useDynamicSubItemHeight = false;
        this.disabled = false;
        this.showExpandButton = true;
        this.gradientColor = ColorBackground1;
        this.toggled = new EventEmitter();
        this.isExpandable = false;
        this.lastIsExpandable = false;
        this.isExpanded = false;
        this.lastIsExpanded = false;
        this.maxHeight = 0;
        this.viewInitialised = false;
        this.keyBoardActivatedToggle = false;
        iconReg.register(SieIcon.ArrowDown);
        iconReg.register(SieIcon.ArrowUp);
    }
    ngAfterViewInit() {
        // wait until the element is properly rendered and has a height other than 0
        this.resizeObserver = new ResizeObserver(() => {
            if (this.content.nativeElement.scrollHeight) {
                this.initialize();
                this.resizeObserver?.disconnect();
            }
        });
        this.resizeObserver.observe(this.elementRef.nativeElement);
        this.innerContent = this.innerContentWrapper.nativeElement?.children[0];
        this.initialize();
        this.viewInitialised = true;
        this.observeContentChanges();
        this.disableContentFocus();
        this.registerImageLoadListeners();
    }
    ngOnDestroy() {
        this.mutationObserver?.disconnect();
        this.resizeObserver?.disconnect();
        this.breakpointSubscription?.unsubscribe();
        this.resizeSubscription$?.unsubscribe();
    }
    detectChange() {
        this.calculateMaxHeight();
        this.isExpanded = false;
        this.cdr.detectChanges();
    }
    toggle() {
        if (this.isExpanded) {
            this.collapse();
        }
        else {
            this.expand();
        }
        this.toggled.emit(this.isExpanded);
    }
    onKeyboardToggle(event) {
        // Identifying if the show more/less button was activated via keyboard, toggle() will be called afterwards.
        if (KeyboardEventUtil.is(event.key).equalToKey(KeyboardKey.Enter, KeyboardKey.Space)) {
            this.keyBoardActivatedToggle = true;
        }
    }
    collapse() {
        if (this.isExpandable) {
            DomUtil.disableFocusForChildren(this.content.nativeElement);
        }
        this.lastIsExpanded = this.isExpanded = false;
        this.updateElementMaxHeight();
        this.doc.defaultView.clearTimeout(this.afterExpandFocusTimeout);
        this.cdr.detectChanges();
    }
    updateElementMaxHeight() {
        requestAnimationFrame(() => {
            this.content.nativeElement.style.maxHeight = this.isExpanded
                ? `${this.content.nativeElement.scrollHeight}px`
                : `${this.maxHeight}px`;
        });
    }
    updateIsExpandable() {
        this.isExpandable = this.maxHeight && this.maxHeight < this.content.nativeElement.scrollHeight;
        if (this.isExpandable !== this.lastIsExpandable) {
            this.cdr.detectChanges();
        }
        this.lastIsExpandable = this.isExpandable;
    }
    registerImageLoadListeners() {
        const container = this.innerContentWrapper.nativeElement;
        if (container) {
            const images = container.querySelectorAll('img');
            images?.forEach((image) => {
                if (!image.complete) {
                    image.addEventListener('load', () => this.initialize(), { once: true });
                }
            });
        }
    }
    initialize() {
        if (!this._limit) {
            return;
        }
        // sometimes angular rendering is slow, we need the correct values for first check
        this.calculateMaxHeight();
        this.breakpointSubscription?.unsubscribe();
        this.breakpointSubscription = this.layoutService.breakPointChangedEvent.subscribe(breakpoint => this.handleBreakpointChange(breakpoint));
        this.handleBreakpointChange(this.layoutService.currentBreakpoint);
    }
    expand() {
        this.lastIsExpanded = this.isExpanded = true;
        this.updateElementMaxHeight();
        DomUtil.enableFocusForChildren(this.content.nativeElement);
        if (this.keyBoardActivatedToggle) {
            this.afterExpandFocusTimeout = this.doc.defaultView.setTimeout(() => {
                DomUtil.getFirstFocusableChild(this.content.nativeElement)?.focus();
                this.keyBoardActivatedToggle = false;
            }, 500);
        }
    }
    handleBreakpointChange(breakpoint) {
        if (!this.forBreakpoints || this.forBreakpoints.includes(breakpoint)) {
            this.subscribeToResize();
            this.enableExpanding();
        }
        else {
            this.unsubscribeFromResize();
            this.disableExpanding();
        }
    }
    subscribeToResize() {
        this.unsubscribeFromResize();
        this.handleResize();
        this.resizeSubscription$ = this.layoutService.resizeEvent.subscribe(() => {
            this.handleResize();
        });
    }
    /**
     * This method can be used to re-trigger the overflow mechanism (e.g. content inside  the overflow has changed)
     *
     * @public This is public because external projects could use this method
     */
    handleResize() {
        requestAnimationFrame(() => {
            this.calculateMaxHeight();
            this.updateIsExpandable();
            this.updateElementMaxHeight();
        });
    }
    handleLimitUpdate() {
        if (this.viewInitialised) {
            this.handleResize();
        }
    }
    unsubscribeFromResize() {
        this.resizeSubscription$?.unsubscribe();
    }
    enableExpanding() {
        this.updateIsExpandable();
        if (this.lastIsExpanded) {
            this.expand();
        }
        else {
            this.collapse();
        }
        this.cdr.detectChanges();
    }
    disableExpanding() {
        this.content.nativeElement.style.maxHeight = null;
        this.isExpandable = false;
        this.cdr.detectChanges();
    }
    calculateMaxHeight() {
        if (this._limit.includes('px')) {
            this.maxHeight = parseFloat(this._limit);
        }
        else {
            if (this.useDynamicSubItemHeight) {
                const innerContentWrapper = this.innerContentWrapper?.nativeElement;
                const childrenToShow = innerContentWrapper?.children;
                let height = 0;
                for (let index = 0; index < parseInt(this._limit, 10); index++) {
                    const currentElement = childrenToShow[index];
                    const currentItemStyles = getComputedStyle(currentElement);
                    const currentItemMarginBottom = parseInt(currentItemStyles.marginBottom.replace('px', ''), 10);
                    const currentItemMarginTop = parseInt(currentItemStyles.marginTop.replace('px', ''), 10);
                    let overlapMargin = 0;
                    const previousItemStyles = childrenToShow[index - 1] ? getComputedStyle(childrenToShow[index - 1]) : null;
                    if (previousItemStyles?.marginBottom && currentItemStyles.marginTop) {
                        const previousItemMarginBottom = parseInt(previousItemStyles.marginBottom.replace('px', ''), 10);
                        overlapMargin = Math.min(previousItemMarginBottom, currentItemMarginTop);
                    }
                    height += currentElement.offsetHeight + currentItemMarginTop + currentItemMarginBottom - overlapMargin;
                }
                this.maxHeight = height;
            }
            else {
                const lineHeight = parseFloat(getComputedStyle(this.innerContent).lineHeight);
                this.maxHeight = Math.round(parseFloat(this._limit) * lineHeight + parseInt(ComponentTruncationVarMargin.replace('px', ''), 10) * 2);
            }
        }
    }
    observeContentChanges() {
        // this observer is utilized to intercept when angular re-renders the reflected content
        this.mutationObserver = new MutationObserver(() => {
            this.disableContentFocus();
        });
        this.mutationObserver.observe(this.content.nativeElement, { subtree: true, childList: true });
    }
    disableContentFocus() {
        if (this.isExpandable && !this.isExpanded) {
            DomUtil.disableFocusForChildren(this.content.nativeElement);
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiOverflowComponent, deps: [{ token: i1.SieIconRegistryService }, { token: i0.ChangeDetectorRef }, { token: i1$1.LayoutService }, { token: i0.ElementRef }, { token: DOCUMENT }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiOverflowComponent, selector: "sie-ui-overflow", inputs: { limit: "limit", forBreakpoints: "forBreakpoints", headlineCollapsed: "headlineCollapsed", headlineExpanded: "headlineExpanded", useGradient: "useGradient", size: "size", buttonIndentationLeft: "buttonIndentationLeft", buttonIndentationTop: "buttonIndentationTop", centered: "centered", theme: "theme", useDynamicSubItemHeight: "useDynamicSubItemHeight", disabled: "disabled", showExpandButton: "showExpandButton", gradientColor: "gradientColor" }, outputs: { toggled: "toggled" }, host: { properties: { "style.--gradient-color": "this.gradientColor" } }, viewQueries: [{ propertyName: "content", first: true, predicate: ["content"], descendants: true }, { propertyName: "innerContentWrapper", first: true, predicate: ["innerContentWrapper"], descendants: true }], ngImport: i0, template: "<div\n  class=\"content\"\n  [ngClass]=\"{\n    collapsed: isExpandable && !isExpanded,\n    expanded: isExpandable && isExpanded,\n    gradient: isExpandable && useGradient,\n    'expanded-for-print-preview': layoutService.expandForPrintPreview$ | async,\n    'print-preview-without-expandable-toggle': !isExpandable\n  }\"\n  (transitionend)=\"isExpandable && isExpanded && updateElementMaxHeight()\"\n  #content\n>\n  <div class=\"content-spacer\" #innerContentWrapper>\n    <ng-content></ng-content>\n  </div>\n</div>\n\n<button\n  type=\"button\"\n  *ngIf=\"showExpandButton && isExpandable\"\n  (keydown)=\"onKeyboardToggle($event)\"\n  (click)=\"toggle()\"\n  [disabled]=\"disabled\"\n  [ngStyle]=\"!centered && { marginLeft: buttonIndentationLeft, top: buttonIndentationTop }\"\n  [ngClass]=\"['size-' + size, useGradient ? 'gradient' : '', centered ? 'center' : '', theme === 'dark' ? 'dark' : '']\"\n  [attr.aria-expanded]=\"isExpanded\"\n  [attr.aria-label]=\"isExpanded ? headlineExpanded : headlineCollapsed\"\n>\n  <ng-container *ngIf=\"!isExpanded\">\n    <sie-icon class=\"icon-wrapper\" [name]=\"iconReg.sieIcon.ArrowDown\" aria-hidden=\"true\"></sie-icon>\n    <span class=\"label\">{{ headlineCollapsed }}</span>\n  </ng-container>\n  <ng-container *ngIf=\"isExpanded\">\n    <sie-icon class=\"icon-wrapper\" [name]=\"iconReg.sieIcon.ArrowUp\" aria-hidden=\"true\"></sie-icon>\n    <span class=\"label\">{{ headlineExpanded }}</span>\n  </ng-container>\n</button>\n", styles: ["button{outline:none;outline-offset:0}@media (pointer: fine){button{position:relative}button:focus{outline:1px solid #1491eb;outline-offset:2px}button:focus:not(:focus-visible){outline:0}button:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}:host{--gradient-color: #fff;display:inherit;width:100%}.content{position:relative;height:auto;overflow:hidden;transition:max-height .5s cubic-bezier(.2,0,.38,.9);margin:-4px}@media print{@supports (-moz-appearance: none){.content{max-height:-moz-fit-content!important;max-height:fit-content!important}}}@media print{.content.expanded,.content.expanded-for-print-preview{overflow:visible!important;max-height:-moz-fit-content!important;max-height:fit-content!important}}@media print{.content.print-preview-without-expandable-toggle{max-height:-moz-fit-content!important;max-height:fit-content!important}}.content.gradient:after{content:\"\";display:block;position:absolute;right:0;bottom:0;left:0;height:0;background:linear-gradient(0deg,var(--gradient-color),rgba(255,255,255,0));transition:height .5s cubic-bezier(.2,0,.38,.9);z-index:2}@media screen{.content.gradient.collapsed:after{height:44px}}.content.gradient.expanded:after{height:0}.content-spacer{margin:4px}button{font-size:1rem;font-weight:400;line-height:1.5rem;white-space:nowrap;overflow:hidden;text-overflow:ellipsis;display:block;position:relative;height:40px;margin-top:8px;border:0;padding:.5rem 0;background:none;text-decoration:none;text-align:left;color:#007993;fill:#007993;max-width:328px}button:hover,button:active{text-decoration:underline;text-underline-offset:5px;color:#33747a;fill:#33747a;cursor:pointer}button:visited{color:#66afbe;fill:#66afbe}button.disabled{color:#b3b3be;fill:#b3b3be;pointer-events:none}button.dark{color:#0cc;fill:#0cc}button.dark:hover{color:#00ffb9;fill:#00ffb9}button .icon-wrapper{width:24px;height:24px;display:flex;align-items:center;fill:currentColor;display:inline-flex;margin-right:4px;margin-left:-5px}button .icon-wrapper svg{fill:currentColor;width:inherit;height:inherit}button .icon-wrapper svg g{fill:currentColor;width:inherit;height:inherit}button .icon-wrapper svg text{font-family:Siemens Sans,sans-serif}button.size-s{font-size:.875rem;font-weight:400;line-height:1.25rem;margin-top:2px}button.size-s .icon-wrapper{width:20px;height:20px;display:flex;align-items:center;fill:currentColor;display:inline-flex;margin-right:1px;margin-left:-4px}button.size-s .icon-wrapper svg{fill:currentColor;width:inherit;height:inherit}button.size-s .icon-wrapper svg g{fill:currentColor;width:inherit;height:inherit}button.size-s .icon-wrapper svg text{font-family:Siemens Sans,sans-serif}button.center{margin-left:auto;margin-right:auto}button .label{vertical-align:middle}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "pipe", type: i2.AsyncPipe, name: "async" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiOverflowComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-overflow', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div\n  class=\"content\"\n  [ngClass]=\"{\n    collapsed: isExpandable && !isExpanded,\n    expanded: isExpandable && isExpanded,\n    gradient: isExpandable && useGradient,\n    'expanded-for-print-preview': layoutService.expandForPrintPreview$ | async,\n    'print-preview-without-expandable-toggle': !isExpandable\n  }\"\n  (transitionend)=\"isExpandable && isExpanded && updateElementMaxHeight()\"\n  #content\n>\n  <div class=\"content-spacer\" #innerContentWrapper>\n    <ng-content></ng-content>\n  </div>\n</div>\n\n<button\n  type=\"button\"\n  *ngIf=\"showExpandButton && isExpandable\"\n  (keydown)=\"onKeyboardToggle($event)\"\n  (click)=\"toggle()\"\n  [disabled]=\"disabled\"\n  [ngStyle]=\"!centered && { marginLeft: buttonIndentationLeft, top: buttonIndentationTop }\"\n  [ngClass]=\"['size-' + size, useGradient ? 'gradient' : '', centered ? 'center' : '', theme === 'dark' ? 'dark' : '']\"\n  [attr.aria-expanded]=\"isExpanded\"\n  [attr.aria-label]=\"isExpanded ? headlineExpanded : headlineCollapsed\"\n>\n  <ng-container *ngIf=\"!isExpanded\">\n    <sie-icon class=\"icon-wrapper\" [name]=\"iconReg.sieIcon.ArrowDown\" aria-hidden=\"true\"></sie-icon>\n    <span class=\"label\">{{ headlineCollapsed }}</span>\n  </ng-container>\n  <ng-container *ngIf=\"isExpanded\">\n    <sie-icon class=\"icon-wrapper\" [name]=\"iconReg.sieIcon.ArrowUp\" aria-hidden=\"true\"></sie-icon>\n    <span class=\"label\">{{ headlineExpanded }}</span>\n  </ng-container>\n</button>\n", styles: ["button{outline:none;outline-offset:0}@media (pointer: fine){button{position:relative}button:focus{outline:1px solid #1491eb;outline-offset:2px}button:focus:not(:focus-visible){outline:0}button:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}:host{--gradient-color: #fff;display:inherit;width:100%}.content{position:relative;height:auto;overflow:hidden;transition:max-height .5s cubic-bezier(.2,0,.38,.9);margin:-4px}@media print{@supports (-moz-appearance: none){.content{max-height:-moz-fit-content!important;max-height:fit-content!important}}}@media print{.content.expanded,.content.expanded-for-print-preview{overflow:visible!important;max-height:-moz-fit-content!important;max-height:fit-content!important}}@media print{.content.print-preview-without-expandable-toggle{max-height:-moz-fit-content!important;max-height:fit-content!important}}.content.gradient:after{content:\"\";display:block;position:absolute;right:0;bottom:0;left:0;height:0;background:linear-gradient(0deg,var(--gradient-color),rgba(255,255,255,0));transition:height .5s cubic-bezier(.2,0,.38,.9);z-index:2}@media screen{.content.gradient.collapsed:after{height:44px}}.content.gradient.expanded:after{height:0}.content-spacer{margin:4px}button{font-size:1rem;font-weight:400;line-height:1.5rem;white-space:nowrap;overflow:hidden;text-overflow:ellipsis;display:block;position:relative;height:40px;margin-top:8px;border:0;padding:.5rem 0;background:none;text-decoration:none;text-align:left;color:#007993;fill:#007993;max-width:328px}button:hover,button:active{text-decoration:underline;text-underline-offset:5px;color:#33747a;fill:#33747a;cursor:pointer}button:visited{color:#66afbe;fill:#66afbe}button.disabled{color:#b3b3be;fill:#b3b3be;pointer-events:none}button.dark{color:#0cc;fill:#0cc}button.dark:hover{color:#00ffb9;fill:#00ffb9}button .icon-wrapper{width:24px;height:24px;display:flex;align-items:center;fill:currentColor;display:inline-flex;margin-right:4px;margin-left:-5px}button .icon-wrapper svg{fill:currentColor;width:inherit;height:inherit}button .icon-wrapper svg g{fill:currentColor;width:inherit;height:inherit}button .icon-wrapper svg text{font-family:Siemens Sans,sans-serif}button.size-s{font-size:.875rem;font-weight:400;line-height:1.25rem;margin-top:2px}button.size-s .icon-wrapper{width:20px;height:20px;display:flex;align-items:center;fill:currentColor;display:inline-flex;margin-right:1px;margin-left:-4px}button.size-s .icon-wrapper svg{fill:currentColor;width:inherit;height:inherit}button.size-s .icon-wrapper svg g{fill:currentColor;width:inherit;height:inherit}button.size-s .icon-wrapper svg text{font-family:Siemens Sans,sans-serif}button.center{margin-left:auto;margin-right:auto}button .label{vertical-align:middle}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }, { type: i0.ChangeDetectorRef }, { type: i1$1.LayoutService }, { type: i0.ElementRef }, { type: Document, decorators: [{
                    type: Inject,
                    args: [DOCUMENT]
                }] }]; }, propDecorators: { limit: [{
                type: Input
            }], forBreakpoints: [{
                type: Input
            }], headlineCollapsed: [{
                type: Input
            }], headlineExpanded: [{
                type: Input
            }], useGradient: [{
                type: Input
            }], size: [{
                type: Input
            }], buttonIndentationLeft: [{
                type: Input
            }], buttonIndentationTop: [{
                type: Input
            }], centered: [{
                type: Input
            }], theme: [{
                type: Input
            }], useDynamicSubItemHeight: [{
                type: Input
            }], disabled: [{
                type: Input
            }], showExpandButton: [{
                type: Input
            }], gradientColor: [{
                type: HostBinding,
                args: [`style.${ComponentTruncationVarGradientColor}`]
            }, {
                type: Input
            }], toggled: [{
                type: Output
            }], content: [{
                type: ViewChild,
                args: ['content']
            }], innerContentWrapper: [{
                type: ViewChild,
                args: ['innerContentWrapper']
            }] } });

class UiOverflowModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiOverflowModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiOverflowModule, declarations: [UiOverflowComponent], imports: [CommonModule, SieIconsModule], exports: [UiOverflowComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiOverflowModule, imports: [CommonModule, SieIconsModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiOverflowModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiOverflowComponent],
                    imports: [CommonModule, SieIconsModule],
                    exports: [UiOverflowComponent]
                }]
        }] });

class UiChatBubbleComponent {
    constructor(iconReg) {
        this.iconReg = iconReg;
        this.showInitials = true;
    }
    getMessageActions(message) {
        const actionsString = message?.trim().replace(/[{}]/g, '').split(':');
        return actionsString[1]?.split(',');
    }
    doesMessageContainsActions(message) {
        return message?.includes('{ChatWindowButton:');
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiChatBubbleComponent, deps: [{ token: i1.SieIconRegistryService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiChatBubbleComponent, selector: "sie-ui-chat-bubble", inputs: { showInitials: "showInitials", chatBubbleData: "chatBubbleData" }, ngImport: i0, template: "<ng-container *ngIf=\"chatBubbleData\">\n  <div\n    *ngIf=\"chatBubbleData.messageRole && chatBubbleData.messageType\"\n    class=\"chat-bubble\"\n    [ngClass]=\"['role-' + chatBubbleData.messageRole, 'type-' + chatBubbleData.messageType]\"\n  >\n    <span\n      *ngIf=\"showInitials && (chatBubbleData.messageRole === 'chatbot' || chatBubbleData.messageRole === 'agent')\"\n      class=\"chat-bubble__initials\"\n      >{{ chatBubbleData.userInitials }}</span\n    >\n\n    <div class=\"chat-bubble__wrapper\">\n      <div *ngIf=\"showInitials\" class=\"chat-bubble__wrapper__header\">\n        <span\n          *ngIf=\"chatBubbleData.messageRole === 'chatbot' || chatBubbleData.messageRole === 'agent'\"\n          class=\"chat-bubble__wrapper__header__contact-name\"\n          >{{ chatBubbleData.userName }}</span\n        >\n        <span *ngIf=\"chatBubbleData.createdDate\" class=\"chat-bubble__wrapper__header__date-time\">{{\n          chatBubbleData.createdDate\n        }}</span>\n      </div>\n\n      <!-- will be changed in POC task -->\n      <div class=\"chat-bubble__wrapper__body\">\n        <ng-container *ngIf=\"doesMessageContainsActions(chatBubbleData.messageBody); else messageBody\">\n          <ul>\n            <li *ngFor=\"let messageAction of getMessageActions(chatBubbleData.messageBody)\">\n              <span class=\"chat-bubble__wrapper__body__message\">{{ messageAction }}</span>\n            </li>\n          </ul>\n        </ng-container>\n        <ng-template #messageBody>\n          <sie-ui-overflow limit=\"12\" headlineCollapsed=\"Read more\" headlineExpanded=\"Read less\" size=\"s\">\n            <span class=\"chat-bubble__wrapper__body__message\">\n              <sie-ui-richtext [content]=\"chatBubbleData.messageBody\"></sie-ui-richtext>\n              <div *ngIf=\"chatBubbleData.attachments\" class=\"chat-bubble__wrapper__body__message__documents\">\n                <ng-container *ngFor=\"let attachment of chatBubbleData.attachments\">\n                  <sie-ui-link href=\"#\" [icon]=\"iconReg.sieIcon.Pdf\" size=\"s\">{{ attachment }}</sie-ui-link>\n                </ng-container>\n              </div>\n            </span>\n          </sie-ui-overflow>\n        </ng-template>\n      </div>\n    </div>\n  </div>\n</ng-container>\n", styles: [".chat-bubble{display:flex;page-break-inside:avoid}.chat-bubble__wrapper{page-break-inside:avoid;box-sizing:border-box;min-width:262px;max-width:262px;margin-left:32px}@media (min-width: 640px){.chat-bubble__wrapper{max-width:312px;margin-left:56px}}@media (min-width: 1024px){.chat-bubble__wrapper{padding:16px;max-width:400px}}@media print{.chat-bubble__wrapper{max-width:400px;padding:16px;margin-left:56px}@supports (-moz-appearance: none){.chat-bubble__wrapper{max-width:350px}}}.chat-bubble__wrapper__header{display:flex;flex-direction:column;margin-bottom:8px}@media (min-width: 640px){.chat-bubble__wrapper__header{flex-direction:row}}@media print{.chat-bubble__wrapper__header{flex-direction:row}}.chat-bubble__wrapper__header:empty{display:none}.chat-bubble__wrapper__header__contact-name{font-size:.875rem;font-weight:700;line-height:1.25rem;color:#000028;margin-right:8px}.chat-bubble__wrapper__header__date-time{font-size:.875rem;font-weight:400;line-height:1.25rem;color:#9999a9}.chat-bubble__wrapper__body{font-size:.875rem;font-weight:400;line-height:1.25rem}.chat-bubble__wrapper__body__message{color:#000028}.chat-bubble__initials{display:flex;flex-shrink:0;align-items:center;justify-content:center;font-size:11px;width:24px;height:24px;margin-top:7px;background-color:#00557c;color:#fff;border-radius:50%}@media (min-width: 640px){.chat-bubble__initials{font-size:16px;width:48px;height:48px;margin-top:3px}}@media print{.chat-bubble__initials{font-size:16px;width:48px;height:48px;margin-top:3px}}@media print{.chat-bubble__initials{-webkit-print-color-adjust:exact;print-color-adjust:exact}}.chat-bubble__initials+.chat-bubble__wrapper{margin-left:8px}.chat-bubble.role-agent .chat-bubble__wrapper,.chat-bubble.role-chatbot .chat-bubble__wrapper{border:1px solid #ccccd4;border-radius:0 10px 10px;background-color:#fff;box-shadow:0 6px 8px #0000001a,0 2px 2px #0000000f;padding:10px 8px}@media (min-width: 640px){.chat-bubble.role-agent .chat-bubble__wrapper,.chat-bubble.role-chatbot .chat-bubble__wrapper{padding:16px 16px 14px}}@media print{.chat-bubble.role-agent .chat-bubble__wrapper,.chat-bubble.role-chatbot .chat-bubble__wrapper{padding:16px 16px 14px}}.chat-bubble.role-user{justify-content:flex-end}.chat-bubble.role-user .chat-bubble__wrapper{border-radius:10px 0 10px 10px;background-color:#ebebee;box-shadow:0 2px 2px #0000000f,0 4px 8px #0000001f;padding:16px 8px}@media (min-width: 640px){.chat-bubble.role-user .chat-bubble__wrapper{padding:20px 16px}}@media print{.chat-bubble.role-user .chat-bubble__wrapper{padding:20px 16px}}@media print{.chat-bubble.role-user .chat-bubble__wrapper{-webkit-print-color-adjust:exact;print-color-adjust:exact}}.chat-bubble.role-user .chat-bubble__wrapper__body sie-ui-overflow{--gradient-color: #ebebee !important}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: UiOverflowComponent, selector: "sie-ui-overflow", inputs: ["limit", "forBreakpoints", "headlineCollapsed", "headlineExpanded", "useGradient", "size", "buttonIndentationLeft", "buttonIndentationTop", "centered", "theme", "useDynamicSubItemHeight", "disabled", "showExpandButton", "gradientColor"], outputs: ["toggled"] }, { kind: "component", type: UiLinkComponent, selector: "sie-ui-link", inputs: ["disabled", "disableVisitedStyle", "hasMarginTop", "offsetIcon", "truncate", "inLinkList", "trailingIcon", "icon", "cssClass", "href", "size", "target", "variant", "background", "type", "reference", "screenReaderText", "secondaryLabel", "download", "dataAttributes", "tooltip", "buttonType"], outputs: ["clicked"] }, { kind: "component", type: UiRichtextComponent, selector: "sie-ui-richtext", inputs: ["content", "theme", "whiteListedTags"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiChatBubbleComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-chat-bubble', changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-container *ngIf=\"chatBubbleData\">\n  <div\n    *ngIf=\"chatBubbleData.messageRole && chatBubbleData.messageType\"\n    class=\"chat-bubble\"\n    [ngClass]=\"['role-' + chatBubbleData.messageRole, 'type-' + chatBubbleData.messageType]\"\n  >\n    <span\n      *ngIf=\"showInitials && (chatBubbleData.messageRole === 'chatbot' || chatBubbleData.messageRole === 'agent')\"\n      class=\"chat-bubble__initials\"\n      >{{ chatBubbleData.userInitials }}</span\n    >\n\n    <div class=\"chat-bubble__wrapper\">\n      <div *ngIf=\"showInitials\" class=\"chat-bubble__wrapper__header\">\n        <span\n          *ngIf=\"chatBubbleData.messageRole === 'chatbot' || chatBubbleData.messageRole === 'agent'\"\n          class=\"chat-bubble__wrapper__header__contact-name\"\n          >{{ chatBubbleData.userName }}</span\n        >\n        <span *ngIf=\"chatBubbleData.createdDate\" class=\"chat-bubble__wrapper__header__date-time\">{{\n          chatBubbleData.createdDate\n        }}</span>\n      </div>\n\n      <!-- will be changed in POC task -->\n      <div class=\"chat-bubble__wrapper__body\">\n        <ng-container *ngIf=\"doesMessageContainsActions(chatBubbleData.messageBody); else messageBody\">\n          <ul>\n            <li *ngFor=\"let messageAction of getMessageActions(chatBubbleData.messageBody)\">\n              <span class=\"chat-bubble__wrapper__body__message\">{{ messageAction }}</span>\n            </li>\n          </ul>\n        </ng-container>\n        <ng-template #messageBody>\n          <sie-ui-overflow limit=\"12\" headlineCollapsed=\"Read more\" headlineExpanded=\"Read less\" size=\"s\">\n            <span class=\"chat-bubble__wrapper__body__message\">\n              <sie-ui-richtext [content]=\"chatBubbleData.messageBody\"></sie-ui-richtext>\n              <div *ngIf=\"chatBubbleData.attachments\" class=\"chat-bubble__wrapper__body__message__documents\">\n                <ng-container *ngFor=\"let attachment of chatBubbleData.attachments\">\n                  <sie-ui-link href=\"#\" [icon]=\"iconReg.sieIcon.Pdf\" size=\"s\">{{ attachment }}</sie-ui-link>\n                </ng-container>\n              </div>\n            </span>\n          </sie-ui-overflow>\n        </ng-template>\n      </div>\n    </div>\n  </div>\n</ng-container>\n", styles: [".chat-bubble{display:flex;page-break-inside:avoid}.chat-bubble__wrapper{page-break-inside:avoid;box-sizing:border-box;min-width:262px;max-width:262px;margin-left:32px}@media (min-width: 640px){.chat-bubble__wrapper{max-width:312px;margin-left:56px}}@media (min-width: 1024px){.chat-bubble__wrapper{padding:16px;max-width:400px}}@media print{.chat-bubble__wrapper{max-width:400px;padding:16px;margin-left:56px}@supports (-moz-appearance: none){.chat-bubble__wrapper{max-width:350px}}}.chat-bubble__wrapper__header{display:flex;flex-direction:column;margin-bottom:8px}@media (min-width: 640px){.chat-bubble__wrapper__header{flex-direction:row}}@media print{.chat-bubble__wrapper__header{flex-direction:row}}.chat-bubble__wrapper__header:empty{display:none}.chat-bubble__wrapper__header__contact-name{font-size:.875rem;font-weight:700;line-height:1.25rem;color:#000028;margin-right:8px}.chat-bubble__wrapper__header__date-time{font-size:.875rem;font-weight:400;line-height:1.25rem;color:#9999a9}.chat-bubble__wrapper__body{font-size:.875rem;font-weight:400;line-height:1.25rem}.chat-bubble__wrapper__body__message{color:#000028}.chat-bubble__initials{display:flex;flex-shrink:0;align-items:center;justify-content:center;font-size:11px;width:24px;height:24px;margin-top:7px;background-color:#00557c;color:#fff;border-radius:50%}@media (min-width: 640px){.chat-bubble__initials{font-size:16px;width:48px;height:48px;margin-top:3px}}@media print{.chat-bubble__initials{font-size:16px;width:48px;height:48px;margin-top:3px}}@media print{.chat-bubble__initials{-webkit-print-color-adjust:exact;print-color-adjust:exact}}.chat-bubble__initials+.chat-bubble__wrapper{margin-left:8px}.chat-bubble.role-agent .chat-bubble__wrapper,.chat-bubble.role-chatbot .chat-bubble__wrapper{border:1px solid #ccccd4;border-radius:0 10px 10px;background-color:#fff;box-shadow:0 6px 8px #0000001a,0 2px 2px #0000000f;padding:10px 8px}@media (min-width: 640px){.chat-bubble.role-agent .chat-bubble__wrapper,.chat-bubble.role-chatbot .chat-bubble__wrapper{padding:16px 16px 14px}}@media print{.chat-bubble.role-agent .chat-bubble__wrapper,.chat-bubble.role-chatbot .chat-bubble__wrapper{padding:16px 16px 14px}}.chat-bubble.role-user{justify-content:flex-end}.chat-bubble.role-user .chat-bubble__wrapper{border-radius:10px 0 10px 10px;background-color:#ebebee;box-shadow:0 2px 2px #0000000f,0 4px 8px #0000001f;padding:16px 8px}@media (min-width: 640px){.chat-bubble.role-user .chat-bubble__wrapper{padding:20px 16px}}@media print{.chat-bubble.role-user .chat-bubble__wrapper{padding:20px 16px}}@media print{.chat-bubble.role-user .chat-bubble__wrapper{-webkit-print-color-adjust:exact;print-color-adjust:exact}}.chat-bubble.role-user .chat-bubble__wrapper__body sie-ui-overflow{--gradient-color: #ebebee !important}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }]; }, propDecorators: { showInitials: [{
                type: Input
            }], chatBubbleData: [{
                type: Input
            }] } });

class UiChatBubbleModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiChatBubbleModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiChatBubbleModule, declarations: [UiChatBubbleComponent], imports: [CommonModule, UiOverflowModule, UiLinkModule, UiRichtextModule], exports: [UiChatBubbleComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiChatBubbleModule, imports: [CommonModule, UiOverflowModule, UiLinkModule, UiRichtextModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiChatBubbleModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiChatBubbleComponent],
                    imports: [CommonModule, UiOverflowModule, UiLinkModule, UiRichtextModule],
                    exports: [UiChatBubbleComponent]
                }]
        }] });

/** @ignore */
const MSG_BOX_ICON_MAPPING = {
    info: SieIcon.InformationFilled,
    success: SieIcon.SuccessFilled,
    warning: SieIcon.WarningFilled,
    error: SieIcon.ErrorFilled
};
/** @ignore */
const MSG_BOX_GRADIENT_COLOR = {
    info: ColorFunctionalInformationLight,
    success: ColorFunctionalSuccessLight,
    warning: ColorFunctionalWarningLight,
    error: ColorFunctionalErrorLight
};
/** @ignore */
const MSG_BOX_TRUNCATION_LINES = {
    XS: 6,
    S: 6,
    M: 4,
    L: 3,
    XL: 2,
    XXL: 2
};

// eslint-disable-next-line @angular-eslint/directive-class-suffix
class UiAutoDestroyableComponent {
    constructor(vcr) {
        this.vcr = vcr;
    }
    destroy(_event) {
        this.ngOnDestroy();
        const element = this.vcr.element.nativeElement;
        element.parentElement.removeChild(element);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiAutoDestroyableComponent, deps: [{ token: i0.ViewContainerRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: UiAutoDestroyableComponent, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiAutoDestroyableComponent, decorators: [{
            type: Directive
        }], ctorParameters: function () { return [{ type: i0.ViewContainerRef }]; } });

const animationTiming = '250ms ';
const blendInAnimation = animationTiming + EasingEntranceProductive;
const blendOutAnimation = animationTiming + EasingExitProductive;
const slideUpAnimation = animationTiming + EasingStandardProductive;
const slideDownAnimation = animationTiming + EasingStandardProductive;
const slideInSlideOutAnimation = trigger('slideInSlideOut', [
    state('show', style({
        opacity: 1,
        height: 'auto'
    })),
    state('hide', style({
        opacity: 0,
        height: 0
    })),
    transition('* => hide', [
        sequence([animate(blendOutAnimation, style({ opacity: '0' })), animate(slideUpAnimation, style({ height: '0' }))])
    ]),
    transition('* => show', [
        sequence([
            animate(slideDownAnimation, style({ height: 'auto' })),
            animate(blendInAnimation, style({ opacity: '1' }))
        ])
    ])
]);

/** @ignore */
const primaryActionButton = {
    id: 'action',
    buttonType: 'button',
    variant: 'secondary'
};
/** @ignore */
const secondaryActionButton = {
    id: 'secondaryAction',
    buttonType: 'button',
    variant: 'tertiary'
};
/**
 * # Message box component
 *
 * Message box provides useful status information to the user within a specific scope.
 * It is used to notify the user about successful or failed actions or to convey information about an element’s status.
 * For example if a product is about to be discontinued or a new successor version is available etc.
 *
 * ## Component variations
 *
 * - Text/headline behaviour
 *  - Standard Message Box
 *  - Message Box with Copy Text truncation
 *  - Message Box with headline only
 *  - Message Box with Copy text only
 * - Different states: info, warning, error, success
 * - With or without action button
 * - Fixed or closeable
 * - Condensed Message Box
 *
 * ## Content
 *
 * The message box component can contain child elements. With the right decorators they can be used as the following:
 * `messageContentSlot`: Used as the **messageContentSlot** within the message box
 *
 * ## Code example
 * @example ```html
 * <sie-ui-message-box
 *  variant="info"
 *  limit="3"
 *  headlineCollapsed="Show more"
 *  headlineExpanded="Show less"
 *  headline="This product is a Spare Part, please visit the Spares & Service section for more information"
 *  message="..."
 *  actionButtonLabel="Action"
 *  [closeable]="true"
 * >
 *  <div messageContentSlot>Lorem ipsum dolor sit amet, consectetur adipiscing elit.</div>
 * </sie-ui-message-box>
 * ```
 */
class UiMessageBoxComponent extends UiAutoDestroyableComponent {
    /**
     * Type of the message box
     * @default 'standard'
     */
    set type(value) {
        this._type = value;
    }
    get type() {
        return this._type;
    }
    /**
     * If provided a button (or action-link) is added with the given label. When clicked an {@link actionTriggered event} is triggered
     */
    set actionButtonLabel(label) {
        this._actionButtonLabel = label;
        if (!!label) {
            this.actionButtons[0] = { ...primaryActionButton, label };
        }
    }
    get actionButtonLabel() {
        return this._actionButtonLabel;
    }
    /**
     * If provided the main button will behave as a link leading you to the destination specified
     */
    set actionButtonLink(link) {
        if (!!link) {
            this.actionButtons[0].link = link;
            this.actionButtons[0].buttonType = 'link';
        }
    }
    /**
     * If provided a button is added with the given label with a different style. Only available for the `standard` type of the Message box.
     * When clicked an {@link actionTriggered event} is triggered
     */
    set secondaryActionButtonLabel(label) {
        this._secondaryActionButtonLabel = label;
        if (!!label) {
            this.actionButtons[1] = { ...secondaryActionButton, label };
        }
    }
    get secondaryActionButtonLabel() {
        return this._secondaryActionButtonLabel;
    }
    /**
     * Variant of the message box
     * @default 'info'
     */
    set variant(value) {
        this._variant = value;
        this.setMessageBoxFunctionalType();
    }
    get variant() {
        return this._variant;
    }
    get iconName() {
        return this._icon;
    }
    get gradientColor() {
        return this._truncationGradientColor;
    }
    constructor(iconReg, vcr, cdr, layoutService, resizeDirective) {
        super(vcr);
        this.iconReg = iconReg;
        this.vcr = vcr;
        this.cdr = cdr;
        this.layoutService = layoutService;
        this.resizeDirective = resizeDirective;
        /** @ignore */
        this.messageViewports = new Map([
            ['S', 0],
            ['L', 1024]
        ]);
        /** @ignore */
        this.actionButtons = [];
        /** @ignore */
        this.toggleAnimationState = 'hide';
        /** @ignore */
        this.smallViewport = false;
        /**
         * Screen reader label for close icon when component is closeable
         * @default ''
         */
        this.screenReaderCloseIcon = '';
        /**
         * Additional input for element positioning (only used for `standard` type)
         * @default 'standard-layout'
         */
        this.elementsLayout = 'standard-layout';
        /**
         * If provided a fade in animation is displayed
         * @default false
         */
        this.fadeInAnimation = false;
        /**
         * Defines whether the message box can be closed. When the close button is closed an {@link messageClosed event} is triggered
         * @default true
         */
        this.closeable = true;
        /**
         * Defines if container-queries or media-queries are used for the message-box styling
         * @default true
         */
        this.containerStyled = true;
        /**
         * Event triggered when the action button or action link is clicked
         */
        this.actionTriggered = new EventEmitter();
        /**
         * Event triggered when the close button is clicked (finished action)
         */
        this.messageClosed = new EventEmitter();
        /**
         * Event triggered when the close button is being clicked
         */
        this.messageClosing = new EventEmitter();
        this.messageLinkTriggered = new EventEmitter();
        /** @ignore */
        this.containerCssClass = this.containerStyled;
        this._variant = 'info';
        this._type = 'standard';
        this.subscriptions = new Subscription();
        iconReg.register(SieIcon.InformationFilled);
        iconReg.register(SieIcon.Close);
    }
    /** @ignore */
    ngOnInit() {
        this.setMessageBoxFunctionalType();
        this.fadeInAnimation ? this.triggerFadeInAnimation() : (this.toggleAnimationState = 'visible');
        this.updateLinesToTruncate();
    }
    ngOnChanges(changes) {
        if (changes.containerStyled) {
            this.containerCssClass = this.containerStyled;
        }
    }
    ngAfterViewInit() {
        this.listenToSizeChange();
    }
    ngOnDestroy() {
        // must be implemented according to UiAutoDestroyableComponent
        this.subscriptions?.unsubscribe();
    }
    /** @ignore */
    destroy(event) {
        this.toggleAnimationState = 'hide';
        this.messageClosing.emit(event);
        this.cdr.detectChanges();
    }
    /** @ignore */
    triggerFadeInAnimation() {
        if (this.playAnimation) {
            const subscription = this.playAnimation.subscribe(animate => {
                if (animate) {
                    this.toggleAnimationState = 'show';
                }
                this.cdr.detectChanges();
                subscription?.unsubscribe();
            });
        }
        else {
            this.toggleAnimationState = 'show';
        }
        this.cdr.detectChanges();
    }
    /** @ignore */
    onAnimationDone(event) {
        if (this.toggleAnimationState === 'hide') {
            this.messageClosed.emit(event);
            super.destroy(event);
        }
    }
    actionLinkClicked(e) {
        e.preventDefault();
        this.actionTriggered.emit(this.actionButtons[0].id);
    }
    messageLinkClicked(e) {
        this.messageLinkTriggered.emit(e);
    }
    setMessageBoxFunctionalType() {
        if (this._variant) {
            this._truncationGradientColor = MSG_BOX_GRADIENT_COLOR[this._variant];
            this._icon = MSG_BOX_ICON_MAPPING[this._variant];
            this.iconReg.register(this._icon);
        }
    }
    updateLinesToTruncate() {
        if (this.containerStyled) {
            this.linesToTruncate$ = this.resizeDirective.breakpointKey.pipe(map(breakpointKey => MSG_BOX_TRUNCATION_LINES[breakpointKey]));
        }
        else {
            this.linesToTruncate$ = this.layoutService.currentViewPort$.pipe(map(currentViewport => MSG_BOX_TRUNCATION_LINES[currentViewport]));
        }
    }
    listenToSizeChange() {
        if (this.containerStyled) {
            this.subscriptions.add(this.resizeDirective.breakpointKey.subscribe(key => {
                this.updateSmallViewport(key);
            }));
        }
        else {
            this.subscriptions.add(this.layoutService.currentViewPort$.subscribe(key => {
                this.updateSmallViewport(key);
            }));
        }
    }
    updateSmallViewport(key) {
        this.smallViewport = ['S', 'XS'].includes(key);
        this.cdr.detectChanges();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiMessageBoxComponent, deps: [{ token: i1.SieIconRegistryService }, { token: i0.ViewContainerRef }, { token: i0.ChangeDetectorRef }, { token: i1$1.LayoutService }, { token: i1$1.ElementResizeDirective }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiMessageBoxComponent, selector: "sie-ui-message-box", inputs: { type: "type", headline: "headline", message: "message", headlineCollapsed: "headlineCollapsed", headlineExpanded: "headlineExpanded", limit: "limit", link: "link", playAnimation: "playAnimation", screenReaderCloseIcon: "screenReaderCloseIcon", elementsLayout: "elementsLayout", fadeInAnimation: ["fadeInAnimation", "fadeInAnimation", booleanAttribute], actionButtonLabel: "actionButtonLabel", actionButtonLink: "actionButtonLink", secondaryActionButtonLabel: "secondaryActionButtonLabel", variant: "variant", closeable: ["closeable", "closeable", booleanAttribute], containerStyled: ["containerStyled", "containerStyled", booleanAttribute] }, outputs: { actionTriggered: "actionTriggered", messageClosed: "messageClosed", messageClosing: "messageClosing", messageLinkTriggered: "messageLinkTriggered" }, host: { properties: { "class.container-styled": "this.containerCssClass" } }, usesInheritance: true, usesOnChanges: true, hostDirectives: [{ directive: i1$1.ElementResizeDirective }], ngImport: i0, template: "<div\n  class=\"message-box\"\n  [sieCoreComponentBreakpoints]=\"messageViewports\"\n  [ngClass]=\"[\n    variant,\n    type === 'condensed' ? 'condensed' : '',\n    fadeInAnimation ? 'fade-in-animation' : '',\n    !actionButtonLabel ? 'without-action-link' : '',\n    !containerStyled ? 'viewport-layout' : '',\n    elementsLayout\n  ]\"\n  [@slideInSlideOut]=\"toggleAnimationState\"\n  (@slideInSlideOut.done)=\"onAnimationDone($event)\"\n>\n  <ng-template #messageText>\n    <sie-ui-richtext [content]=\"message\" theme=\"light\">\n      <ng-container *ngIf=\"link?.variant === 'inline'\">\n        <ng-container *ngTemplateOutlet=\"messageLink\"></ng-container>\n      </ng-container>\n    </sie-ui-richtext>\n  </ng-template>\n\n  <sie-icon\n    [name]=\"iconName\"\n    [inheritSize]=\"true\"\n    class=\"message-box__badge-icon\"\n    [ngClass]=\"'message-box__badge-icon--' + variant\"\n  ></sie-icon>\n  <h5\n    *ngIf=\"headline && type === 'standard'\"\n    class=\"message-box__headline\"\n    [ngClass]=\"{ 'with-close-button': closeable }\"\n  >\n    {{ headline }}\n  </h5>\n\n  <div\n    *ngIf=\"(message || link) && type === 'standard'; else messageCondensed\"\n    class=\"message-box__message\"\n    [ngClass]=\"{ 'with-close-button': closeable && !headline }\"\n  >\n    <sie-ui-overflow\n      *ngIf=\"limit; else messageText\"\n      [limit]=\"limit\"\n      [headlineCollapsed]=\"headlineCollapsed\"\n      [headlineExpanded]=\"headlineExpanded\"\n      [gradientColor]=\"gradientColor\"\n    >\n      <ng-container *ngTemplateOutlet=\"messageText\"></ng-container>\n    </sie-ui-overflow>\n\n    <ng-container *ngIf=\"link?.variant === 'icon-link'\">\n      <ng-container *ngTemplateOutlet=\"messageLink\"></ng-container>\n    </ng-container>\n\n    <ng-container *ngTemplateOutlet=\"messageContentSlot\"></ng-container>\n  </div>\n\n  <ng-template #messageCondensed>\n    <div\n      class=\"message-box__message\"\n      [ngClass]=\"{\n        'with-close-button': closeable,\n        'with-action-link': actionButtonLabel\n      }\"\n    >\n      <div sieCoreAddTruncationAndTooltip [maxNumberOfLinesToShow]=\"linesToTruncate$ | async\">\n        <ng-container *ngTemplateOutlet=\"messageText\"></ng-container>\n      </div>\n      <ng-container *ngTemplateOutlet=\"messageContentSlot\"></ng-container>\n    </div>\n  </ng-template>\n\n  <sie-ui-button\n    *ngIf=\"closeable && type === 'standard'\"\n    class=\"message-box__close-icon\"\n    buttonType=\"button\"\n    themeType=\"icon\"\n    variant=\"icon-un-contained\"\n    [icon]=\"iconReg.sieIcon.Close\"\n    (clicked)=\"destroy($event)\"\n    [iconScreenReaderText]=\"screenReaderCloseIcon\"\n  ></sie-ui-button>\n\n  <button *ngIf=\"closeable && type === 'condensed'\" class=\"message-box__close-button\" (click)=\"destroy($event)\">\n    <sie-icon [name]=\"iconReg.sieIcon.Close\" svgClass=\"message-box__close-button-icon\" aria-hidden=\"true\"></sie-icon>\n    <span class=\"visually-hidden\">{{ screenReaderCloseIcon }}</span>\n  </button>\n\n  <sie-ui-button-group\n    class=\"message-box__action-button\"\n    [ngClass]=\"[!headline ? 'no-headline' : '']\"\n    *ngIf=\"(actionButtonLabel || secondaryActionButtonLabel) && type === 'standard'; else condensedAction\"\n    buttonAlignmentClass=\"right\"\n    [fullWidthOnViewportS]=\"smallViewport\"\n    [buttons]=\"actionButtons\"\n    (buttonClick)=\"actionTriggered.emit($event.button.id)\"\n  ></sie-ui-button-group>\n</div>\n\n<ng-template #messageLink>\n  <sie-ui-link\n    *ngIf=\"link\"\n    class=\"message-box__link\"\n    [ngClass]=\"{ 'message-box__link--inline': link.variant === 'inline' }\"\n    [href]=\"link.href\"\n    [icon]=\"link.icon\"\n    [variant]=\"link.variant\"\n    [background]=\"link.background\"\n    [target]=\"link.target\"\n    [size]=\"link.size || ''\"\n    (clicked)=\"messageLinkClicked($event)\"\n    >{{ link.linkText }}</sie-ui-link\n  >\n</ng-template>\n\n<ng-template #condensedAction>\n  <sie-ui-link\n    *ngIf=\"actionButtonLabel\"\n    class=\"message-box__action-link\"\n    [href]=\"actionButtons[0]?.link\"\n    [variant]=\"'inline'\"\n    [target]=\"actionButtons[0]?.target\"\n    [size]=\"'sm'\"\n    (clicked)=\"actionLinkClicked($event)\"\n  >\n    {{ actionButtonLabel }}\n  </sie-ui-link>\n</ng-template>\n\n<ng-template #messageContentSlot>\n  <div class=\"message-box__content-slot\">\n    <ng-content select=\"[messageContentSlot]\"></ng-content>\n  </div>\n</ng-template>\n", styles: [".message-box.condensed .message-box__close-button{outline:none;outline-offset:0}@media (pointer: fine){.message-box.condensed .message-box__close-button{position:relative}.message-box.condensed .message-box__close-button:focus{outline:1px solid #1491eb;outline-offset:2px}.message-box.condensed .message-box__close-button:focus:not(:focus-visible){outline:0}.message-box.condensed .message-box__close-button:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}:host{display:block}.message-box{display:flex;width:100%;padding:1rem;flex-wrap:wrap;position:relative}.message-box__badge-icon{width:1.5rem;height:1.5rem;display:flex;align-items:center;fill:currentColor;grid-area:icon;flex-grow:0;margin-right:.5rem}.message-box__badge-icon svg{fill:currentColor;width:inherit;height:inherit}.message-box__badge-icon svg g{fill:currentColor;width:inherit;height:inherit}.message-box__badge-icon svg text{font-family:Siemens Sans,sans-serif}.message-box__badge-icon--info{color:#00557c}.message-box__badge-icon--success{color:#00af52}.message-box__badge-icon--warning{color:#ff9000}.message-box__badge-icon--error{color:#ef0137}@media (min-width: 640px) and (max-width: 1023.8px){.message-box.viewport-layout .message-box__badge-icon+.message-box__message{width:100%}}@media (max-width: 1439.78px){.message-box.viewport-layout .with-close-button{padding-right:1.5rem}}@media (min-width: 1024px){.message-box.viewport-layout .no-headline{margin-top:40px}}@media (min-width: 640px){.message-box.viewport-layout.condensed{min-height:32px}.message-box.viewport-layout.condensed .message-box__message{margin-bottom:0}.message-box.viewport-layout.condensed .message-box__action-link{padding-left:24px;padding-right:4px;margin:0 0 auto auto}.message-box.viewport-layout.condensed .message-box__close-button+.message-box__action-link{margin-right:40px;padding-right:0}}@media (max-width: 639.78px){.message-box.viewport-layout.condensed{position:relative;padding-bottom:0}.message-box.viewport-layout.condensed.without-action-link{min-height:32px}.message-box.viewport-layout.condensed .message-box__message{margin-bottom:28px}.message-box.viewport-layout.condensed .message-box__message:not(.with-action-link){margin-bottom:4px}.message-box.viewport-layout.condensed .message-box__action-link{position:absolute;bottom:4px;right:16px;max-width:calc(100% - 36px)}}@media (min-width: 1024px){.message-box.viewport-layout.standard-layout:not(.condensed) .message-box__message{max-width:auto;--container-max-width: 100%;width:calc((100vw - 208px)*.75 + 128px)}}@media (min-width: 1024px) and (min-width: 1024px){.message-box.viewport-layout.standard-layout:not(.condensed) .message-box__message{width:calc((100vw - 376px)*.75 + 192px)}}@media (min-width: 1024px) and (min-width: 1440px){.message-box.viewport-layout.standard-layout:not(.condensed) .message-box__message{width:calc((100vw - 456px)*.75 + 192px)}}@media (min-width: 1024px) and (min-width: 1920px){.message-box.viewport-layout.standard-layout:not(.condensed) .message-box__message{width:1290px}}.message-box.fade-in-animation{height:0;opacity:0}.message-box.info{background-color:#e0f1f4}.message-box.success{background-color:#d4fae6}.message-box.warning{background-color:#fff7d2}.message-box.error{background-color:#fcccd7}.message-box__headline{grid-area:headline;flex-basis:calc(100% - 2rem)}.message-box__headline.with-close-button{padding-right:1.5rem}.message-box__close-icon{position:absolute;top:6px;right:2px}.message-box__link{margin:5px 0 -9px;max-width:100%}.message-box__link--inline{display:inline-block;margin:0}.message-box__message{font-size:.875rem;line-height:1.25rem;grid-area:message;padding-top:2px;max-width:100%}@container shared-container (max-width: 1439.78px){.message-box__message.with-close-button{padding-right:1.5rem}}.message-box__headline+.message-box__message{margin-top:var(--message-box-content-margin-top, .5rem)}.message-box__badge-icon+.message-box__message{max-width:calc(100% - 2rem)}@container shared-container (min-width: 640px) and (max-width: 1023.8px){.message-box__badge-icon+.message-box__message{width:100%}}.message-box__content-slot:not(:empty){padding-top:8px}.message-box__action-button{grid-area:actionButton;margin-left:auto;align-self:flex-end;margin-top:16px}@container shared-container (min-width: 1024px){.message-box__action-button.no-headline{margin-top:40px}}@container shared-container (max-width: 639.78px){.message-box__action-button{width:100%}}.message-box.condensed{flex-wrap:nowrap;justify-content:flex-start;min-height:68px;padding:.375rem .75rem .25rem 1rem}@container shared-container (min-width: 640px){.message-box.condensed{min-height:32px}.message-box.condensed .message-box__message{margin-bottom:0}.message-box.condensed .message-box__action-link{padding-left:24px;padding-right:4px;margin:0 0 auto auto}.message-box.condensed .message-box__close-button+.message-box__action-link{margin-right:40px;padding-right:0}}@container shared-container (max-width: 639.78px){.message-box.condensed{position:relative;padding-bottom:0}.message-box.condensed.without-action-link{min-height:32px}.message-box.condensed .message-box__message{margin-bottom:28px}.message-box.condensed .message-box__message:not(.with-action-link){margin-bottom:4px}.message-box.condensed .message-box__action-link{position:absolute;bottom:4px;right:16px;max-width:calc(100% - 36px)}}.message-box.condensed .message-box__badge-icon{width:1.25rem;height:1.25rem;display:flex;align-items:center;fill:currentColor;padding-top:0}.message-box.condensed .message-box__badge-icon svg{fill:currentColor;width:inherit;height:inherit}.message-box.condensed .message-box__badge-icon svg g{fill:currentColor;width:inherit;height:inherit}.message-box.condensed .message-box__badge-icon svg text{font-family:Siemens Sans,sans-serif}.message-box.condensed .message-box__message{width:100%;padding-top:0;padding-right:0}.message-box.condensed .message-box__message.with-close-button{margin-right:40px}.message-box.condensed .message-box__action-link{width:-moz-fit-content;width:fit-content}.message-box.condensed .message-box__close-button{position:absolute;width:24px;height:24px;right:12px;top:4px;border:0;background-color:transparent;color:#4c4c68;cursor:pointer;outline:none;z-index:4;padding:0}.message-box.condensed .message-box__close-button-icon{width:24px;height:24px;display:flex;align-items:center;fill:currentColor}.message-box.condensed .message-box__close-button-icon svg{fill:currentColor;width:inherit;height:inherit}.message-box.condensed .message-box__close-button-icon svg g{fill:currentColor;width:inherit;height:inherit}.message-box.condensed .message-box__close-button-icon svg text{font-family:Siemens Sans,sans-serif}@container shared-container (min-width: 1024px){.message-box.standard-layout:not(.condensed) .message-box__message{max-width:auto;--container-max-width: 100%;width:calc((100vw - 208px)*.75 + 128px)}@media (min-width: 1024px){.message-box.standard-layout:not(.condensed) .message-box__message{width:calc((100vw - 376px)*.75 + 192px)}}@media (min-width: 1440px){.message-box.standard-layout:not(.condensed) .message-box__message{width:calc((100vw - 456px)*.75 + 192px)}}@media (min-width: 1920px){.message-box.standard-layout:not(.condensed) .message-box__message{width:1290px}}}@media (min-width: 640px){.top-button.viewport-layout{display:grid;grid-template-columns:32px auto auto;grid-template-areas:\"icon headline actionButton\" \"message message actionButton\"}.top-button.viewport-layout>.message-box__action-button{margin-top:4px;align-self:auto}.top-button.viewport-layout>.message-box__message{margin-top:0}}@container shared-container (min-width: 640px){.top-button{display:grid;grid-template-columns:32px auto auto;grid-template-areas:\"icon headline actionButton\" \"message message actionButton\"}.top-button>.message-box__action-button{margin-top:4px;align-self:auto}.top-button>.message-box__message{margin-top:0}}@media (min-width: 1024px){.inline-button.viewport-layout{display:grid;grid-template-columns:32px auto auto;grid-template-areas:\"icon headline headline\" \"message message actionButton\"}.inline-button.viewport-layout>.message-box__action-button{margin:auto 0;align-self:auto}.inline-button.viewport-layout>.message-box__message{margin-top:0;padding-right:103px}}@media (min-width: 1024px) and (min-width: 1440px){.inline-button.viewport-layout>.message-box__message{padding-right:172px}}@container shared-container (min-width: 1024px){.inline-button{display:grid;grid-template-columns:32px auto auto;grid-template-areas:\"icon headline headline\" \"message message actionButton\"}.inline-button>.message-box__action-button{margin:auto 0;align-self:auto}.inline-button>.message-box__message{margin-top:0;padding-right:103px}@media (min-width: 1440px){.inline-button>.message-box__message{padding-right:172px}}}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "component", type: UiOverflowComponent, selector: "sie-ui-overflow", inputs: ["limit", "forBreakpoints", "headlineCollapsed", "headlineExpanded", "useGradient", "size", "buttonIndentationLeft", "buttonIndentationTop", "centered", "theme", "useDynamicSubItemHeight", "disabled", "showExpandButton", "gradientColor"], outputs: ["toggled"] }, { kind: "component", type: UiButtonComponent, selector: "sie-ui-button" }, { kind: "component", type: UiButtonGroupComponent, selector: "sie-ui-button-group", inputs: ["buttons", "fullWidthOnViewportS", "wrapButtons", "direction", "flexDirection", "fullWidth", "buttonAlignmentClass"], outputs: ["buttonClick"] }, { kind: "component", type: UiLinkComponent, selector: "sie-ui-link", inputs: ["disabled", "disableVisitedStyle", "hasMarginTop", "offsetIcon", "truncate", "inLinkList", "trailingIcon", "icon", "cssClass", "href", "size", "target", "variant", "background", "type", "reference", "screenReaderText", "secondaryLabel", "download", "dataAttributes", "tooltip", "buttonType"], outputs: ["clicked"] }, { kind: "component", type: UiRichtextComponent, selector: "sie-ui-richtext", inputs: ["content", "theme", "whiteListedTags"] }, { kind: "directive", type: i1$1.ComponentBreakpointsDirective, selector: "[sieCoreComponentBreakpoints]", inputs: ["sieCoreComponentBreakpoints"], outputs: ["componentViewportChanged"] }, { kind: "directive", type: i1$1.AddTruncationAndTooltipDirective, selector: "[sieCoreAddTruncationAndTooltip]", inputs: ["maxNumberOfLinesToShow"] }, { kind: "pipe", type: i2.AsyncPipe, name: "async" }], animations: [slideInSlideOutAnimation], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
__decorate([
    RunInZone
], UiMessageBoxComponent.prototype, "destroy", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiMessageBoxComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-message-box', animations: [slideInSlideOutAnimation], changeDetection: ChangeDetectionStrategy.OnPush, hostDirectives: [
                        {
                            directive: ElementResizeDirective
                        }
                    ], template: "<div\n  class=\"message-box\"\n  [sieCoreComponentBreakpoints]=\"messageViewports\"\n  [ngClass]=\"[\n    variant,\n    type === 'condensed' ? 'condensed' : '',\n    fadeInAnimation ? 'fade-in-animation' : '',\n    !actionButtonLabel ? 'without-action-link' : '',\n    !containerStyled ? 'viewport-layout' : '',\n    elementsLayout\n  ]\"\n  [@slideInSlideOut]=\"toggleAnimationState\"\n  (@slideInSlideOut.done)=\"onAnimationDone($event)\"\n>\n  <ng-template #messageText>\n    <sie-ui-richtext [content]=\"message\" theme=\"light\">\n      <ng-container *ngIf=\"link?.variant === 'inline'\">\n        <ng-container *ngTemplateOutlet=\"messageLink\"></ng-container>\n      </ng-container>\n    </sie-ui-richtext>\n  </ng-template>\n\n  <sie-icon\n    [name]=\"iconName\"\n    [inheritSize]=\"true\"\n    class=\"message-box__badge-icon\"\n    [ngClass]=\"'message-box__badge-icon--' + variant\"\n  ></sie-icon>\n  <h5\n    *ngIf=\"headline && type === 'standard'\"\n    class=\"message-box__headline\"\n    [ngClass]=\"{ 'with-close-button': closeable }\"\n  >\n    {{ headline }}\n  </h5>\n\n  <div\n    *ngIf=\"(message || link) && type === 'standard'; else messageCondensed\"\n    class=\"message-box__message\"\n    [ngClass]=\"{ 'with-close-button': closeable && !headline }\"\n  >\n    <sie-ui-overflow\n      *ngIf=\"limit; else messageText\"\n      [limit]=\"limit\"\n      [headlineCollapsed]=\"headlineCollapsed\"\n      [headlineExpanded]=\"headlineExpanded\"\n      [gradientColor]=\"gradientColor\"\n    >\n      <ng-container *ngTemplateOutlet=\"messageText\"></ng-container>\n    </sie-ui-overflow>\n\n    <ng-container *ngIf=\"link?.variant === 'icon-link'\">\n      <ng-container *ngTemplateOutlet=\"messageLink\"></ng-container>\n    </ng-container>\n\n    <ng-container *ngTemplateOutlet=\"messageContentSlot\"></ng-container>\n  </div>\n\n  <ng-template #messageCondensed>\n    <div\n      class=\"message-box__message\"\n      [ngClass]=\"{\n        'with-close-button': closeable,\n        'with-action-link': actionButtonLabel\n      }\"\n    >\n      <div sieCoreAddTruncationAndTooltip [maxNumberOfLinesToShow]=\"linesToTruncate$ | async\">\n        <ng-container *ngTemplateOutlet=\"messageText\"></ng-container>\n      </div>\n      <ng-container *ngTemplateOutlet=\"messageContentSlot\"></ng-container>\n    </div>\n  </ng-template>\n\n  <sie-ui-button\n    *ngIf=\"closeable && type === 'standard'\"\n    class=\"message-box__close-icon\"\n    buttonType=\"button\"\n    themeType=\"icon\"\n    variant=\"icon-un-contained\"\n    [icon]=\"iconReg.sieIcon.Close\"\n    (clicked)=\"destroy($event)\"\n    [iconScreenReaderText]=\"screenReaderCloseIcon\"\n  ></sie-ui-button>\n\n  <button *ngIf=\"closeable && type === 'condensed'\" class=\"message-box__close-button\" (click)=\"destroy($event)\">\n    <sie-icon [name]=\"iconReg.sieIcon.Close\" svgClass=\"message-box__close-button-icon\" aria-hidden=\"true\"></sie-icon>\n    <span class=\"visually-hidden\">{{ screenReaderCloseIcon }}</span>\n  </button>\n\n  <sie-ui-button-group\n    class=\"message-box__action-button\"\n    [ngClass]=\"[!headline ? 'no-headline' : '']\"\n    *ngIf=\"(actionButtonLabel || secondaryActionButtonLabel) && type === 'standard'; else condensedAction\"\n    buttonAlignmentClass=\"right\"\n    [fullWidthOnViewportS]=\"smallViewport\"\n    [buttons]=\"actionButtons\"\n    (buttonClick)=\"actionTriggered.emit($event.button.id)\"\n  ></sie-ui-button-group>\n</div>\n\n<ng-template #messageLink>\n  <sie-ui-link\n    *ngIf=\"link\"\n    class=\"message-box__link\"\n    [ngClass]=\"{ 'message-box__link--inline': link.variant === 'inline' }\"\n    [href]=\"link.href\"\n    [icon]=\"link.icon\"\n    [variant]=\"link.variant\"\n    [background]=\"link.background\"\n    [target]=\"link.target\"\n    [size]=\"link.size || ''\"\n    (clicked)=\"messageLinkClicked($event)\"\n    >{{ link.linkText }}</sie-ui-link\n  >\n</ng-template>\n\n<ng-template #condensedAction>\n  <sie-ui-link\n    *ngIf=\"actionButtonLabel\"\n    class=\"message-box__action-link\"\n    [href]=\"actionButtons[0]?.link\"\n    [variant]=\"'inline'\"\n    [target]=\"actionButtons[0]?.target\"\n    [size]=\"'sm'\"\n    (clicked)=\"actionLinkClicked($event)\"\n  >\n    {{ actionButtonLabel }}\n  </sie-ui-link>\n</ng-template>\n\n<ng-template #messageContentSlot>\n  <div class=\"message-box__content-slot\">\n    <ng-content select=\"[messageContentSlot]\"></ng-content>\n  </div>\n</ng-template>\n", styles: [".message-box.condensed .message-box__close-button{outline:none;outline-offset:0}@media (pointer: fine){.message-box.condensed .message-box__close-button{position:relative}.message-box.condensed .message-box__close-button:focus{outline:1px solid #1491eb;outline-offset:2px}.message-box.condensed .message-box__close-button:focus:not(:focus-visible){outline:0}.message-box.condensed .message-box__close-button:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}:host{display:block}.message-box{display:flex;width:100%;padding:1rem;flex-wrap:wrap;position:relative}.message-box__badge-icon{width:1.5rem;height:1.5rem;display:flex;align-items:center;fill:currentColor;grid-area:icon;flex-grow:0;margin-right:.5rem}.message-box__badge-icon svg{fill:currentColor;width:inherit;height:inherit}.message-box__badge-icon svg g{fill:currentColor;width:inherit;height:inherit}.message-box__badge-icon svg text{font-family:Siemens Sans,sans-serif}.message-box__badge-icon--info{color:#00557c}.message-box__badge-icon--success{color:#00af52}.message-box__badge-icon--warning{color:#ff9000}.message-box__badge-icon--error{color:#ef0137}@media (min-width: 640px) and (max-width: 1023.8px){.message-box.viewport-layout .message-box__badge-icon+.message-box__message{width:100%}}@media (max-width: 1439.78px){.message-box.viewport-layout .with-close-button{padding-right:1.5rem}}@media (min-width: 1024px){.message-box.viewport-layout .no-headline{margin-top:40px}}@media (min-width: 640px){.message-box.viewport-layout.condensed{min-height:32px}.message-box.viewport-layout.condensed .message-box__message{margin-bottom:0}.message-box.viewport-layout.condensed .message-box__action-link{padding-left:24px;padding-right:4px;margin:0 0 auto auto}.message-box.viewport-layout.condensed .message-box__close-button+.message-box__action-link{margin-right:40px;padding-right:0}}@media (max-width: 639.78px){.message-box.viewport-layout.condensed{position:relative;padding-bottom:0}.message-box.viewport-layout.condensed.without-action-link{min-height:32px}.message-box.viewport-layout.condensed .message-box__message{margin-bottom:28px}.message-box.viewport-layout.condensed .message-box__message:not(.with-action-link){margin-bottom:4px}.message-box.viewport-layout.condensed .message-box__action-link{position:absolute;bottom:4px;right:16px;max-width:calc(100% - 36px)}}@media (min-width: 1024px){.message-box.viewport-layout.standard-layout:not(.condensed) .message-box__message{max-width:auto;--container-max-width: 100%;width:calc((100vw - 208px)*.75 + 128px)}}@media (min-width: 1024px) and (min-width: 1024px){.message-box.viewport-layout.standard-layout:not(.condensed) .message-box__message{width:calc((100vw - 376px)*.75 + 192px)}}@media (min-width: 1024px) and (min-width: 1440px){.message-box.viewport-layout.standard-layout:not(.condensed) .message-box__message{width:calc((100vw - 456px)*.75 + 192px)}}@media (min-width: 1024px) and (min-width: 1920px){.message-box.viewport-layout.standard-layout:not(.condensed) .message-box__message{width:1290px}}.message-box.fade-in-animation{height:0;opacity:0}.message-box.info{background-color:#e0f1f4}.message-box.success{background-color:#d4fae6}.message-box.warning{background-color:#fff7d2}.message-box.error{background-color:#fcccd7}.message-box__headline{grid-area:headline;flex-basis:calc(100% - 2rem)}.message-box__headline.with-close-button{padding-right:1.5rem}.message-box__close-icon{position:absolute;top:6px;right:2px}.message-box__link{margin:5px 0 -9px;max-width:100%}.message-box__link--inline{display:inline-block;margin:0}.message-box__message{font-size:.875rem;line-height:1.25rem;grid-area:message;padding-top:2px;max-width:100%}@container shared-container (max-width: 1439.78px){.message-box__message.with-close-button{padding-right:1.5rem}}.message-box__headline+.message-box__message{margin-top:var(--message-box-content-margin-top, .5rem)}.message-box__badge-icon+.message-box__message{max-width:calc(100% - 2rem)}@container shared-container (min-width: 640px) and (max-width: 1023.8px){.message-box__badge-icon+.message-box__message{width:100%}}.message-box__content-slot:not(:empty){padding-top:8px}.message-box__action-button{grid-area:actionButton;margin-left:auto;align-self:flex-end;margin-top:16px}@container shared-container (min-width: 1024px){.message-box__action-button.no-headline{margin-top:40px}}@container shared-container (max-width: 639.78px){.message-box__action-button{width:100%}}.message-box.condensed{flex-wrap:nowrap;justify-content:flex-start;min-height:68px;padding:.375rem .75rem .25rem 1rem}@container shared-container (min-width: 640px){.message-box.condensed{min-height:32px}.message-box.condensed .message-box__message{margin-bottom:0}.message-box.condensed .message-box__action-link{padding-left:24px;padding-right:4px;margin:0 0 auto auto}.message-box.condensed .message-box__close-button+.message-box__action-link{margin-right:40px;padding-right:0}}@container shared-container (max-width: 639.78px){.message-box.condensed{position:relative;padding-bottom:0}.message-box.condensed.without-action-link{min-height:32px}.message-box.condensed .message-box__message{margin-bottom:28px}.message-box.condensed .message-box__message:not(.with-action-link){margin-bottom:4px}.message-box.condensed .message-box__action-link{position:absolute;bottom:4px;right:16px;max-width:calc(100% - 36px)}}.message-box.condensed .message-box__badge-icon{width:1.25rem;height:1.25rem;display:flex;align-items:center;fill:currentColor;padding-top:0}.message-box.condensed .message-box__badge-icon svg{fill:currentColor;width:inherit;height:inherit}.message-box.condensed .message-box__badge-icon svg g{fill:currentColor;width:inherit;height:inherit}.message-box.condensed .message-box__badge-icon svg text{font-family:Siemens Sans,sans-serif}.message-box.condensed .message-box__message{width:100%;padding-top:0;padding-right:0}.message-box.condensed .message-box__message.with-close-button{margin-right:40px}.message-box.condensed .message-box__action-link{width:-moz-fit-content;width:fit-content}.message-box.condensed .message-box__close-button{position:absolute;width:24px;height:24px;right:12px;top:4px;border:0;background-color:transparent;color:#4c4c68;cursor:pointer;outline:none;z-index:4;padding:0}.message-box.condensed .message-box__close-button-icon{width:24px;height:24px;display:flex;align-items:center;fill:currentColor}.message-box.condensed .message-box__close-button-icon svg{fill:currentColor;width:inherit;height:inherit}.message-box.condensed .message-box__close-button-icon svg g{fill:currentColor;width:inherit;height:inherit}.message-box.condensed .message-box__close-button-icon svg text{font-family:Siemens Sans,sans-serif}@container shared-container (min-width: 1024px){.message-box.standard-layout:not(.condensed) .message-box__message{max-width:auto;--container-max-width: 100%;width:calc((100vw - 208px)*.75 + 128px)}@media (min-width: 1024px){.message-box.standard-layout:not(.condensed) .message-box__message{width:calc((100vw - 376px)*.75 + 192px)}}@media (min-width: 1440px){.message-box.standard-layout:not(.condensed) .message-box__message{width:calc((100vw - 456px)*.75 + 192px)}}@media (min-width: 1920px){.message-box.standard-layout:not(.condensed) .message-box__message{width:1290px}}}@media (min-width: 640px){.top-button.viewport-layout{display:grid;grid-template-columns:32px auto auto;grid-template-areas:\"icon headline actionButton\" \"message message actionButton\"}.top-button.viewport-layout>.message-box__action-button{margin-top:4px;align-self:auto}.top-button.viewport-layout>.message-box__message{margin-top:0}}@container shared-container (min-width: 640px){.top-button{display:grid;grid-template-columns:32px auto auto;grid-template-areas:\"icon headline actionButton\" \"message message actionButton\"}.top-button>.message-box__action-button{margin-top:4px;align-self:auto}.top-button>.message-box__message{margin-top:0}}@media (min-width: 1024px){.inline-button.viewport-layout{display:grid;grid-template-columns:32px auto auto;grid-template-areas:\"icon headline headline\" \"message message actionButton\"}.inline-button.viewport-layout>.message-box__action-button{margin:auto 0;align-self:auto}.inline-button.viewport-layout>.message-box__message{margin-top:0;padding-right:103px}}@media (min-width: 1024px) and (min-width: 1440px){.inline-button.viewport-layout>.message-box__message{padding-right:172px}}@container shared-container (min-width: 1024px){.inline-button{display:grid;grid-template-columns:32px auto auto;grid-template-areas:\"icon headline headline\" \"message message actionButton\"}.inline-button>.message-box__action-button{margin:auto 0;align-self:auto}.inline-button>.message-box__message{margin-top:0;padding-right:103px}@media (min-width: 1440px){.inline-button>.message-box__message{padding-right:172px}}}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }, { type: i0.ViewContainerRef }, { type: i0.ChangeDetectorRef }, { type: i1$1.LayoutService }, { type: i1$1.ElementResizeDirective }]; }, propDecorators: { type: [{
                type: Input
            }], headline: [{
                type: Input
            }], message: [{
                type: Input
            }], headlineCollapsed: [{
                type: Input
            }], headlineExpanded: [{
                type: Input
            }], limit: [{
                type: Input
            }], link: [{
                type: Input
            }], playAnimation: [{
                type: Input
            }], screenReaderCloseIcon: [{
                type: Input
            }], elementsLayout: [{
                type: Input
            }], fadeInAnimation: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], actionButtonLabel: [{
                type: Input
            }], actionButtonLink: [{
                type: Input
            }], secondaryActionButtonLabel: [{
                type: Input
            }], variant: [{
                type: Input
            }], closeable: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], containerStyled: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], actionTriggered: [{
                type: Output
            }], messageClosed: [{
                type: Output
            }], messageClosing: [{
                type: Output
            }], messageLinkTriggered: [{
                type: Output
            }], containerCssClass: [{
                type: HostBinding,
                args: ['class.container-styled']
            }], destroy: [] } });

/**
 * # Message box Module
 * - {@link UiMessageBoxComponent}
 *
 * ## Module peer dependencies
 * - `@angular/platform-browser/animations/BrowserAnimationsModule`:
 * This module is needed for the animations when the message box is entering/leaving the view
 * - {@link SieIconsModule}
 */
class UiMessageBoxModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiMessageBoxModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiMessageBoxModule, declarations: [UiMessageBoxComponent], imports: [CommonModule,
            SieIconsModule,
            UiOverflowModule,
            UiButtonModule,
            UiButtonGroupModule,
            UiLinkModule,
            UiRichtextModule,
            RunInZoneModule,
            ComponentBreakpointsModule,
            AddTruncationAndTooltipModule], exports: [UiMessageBoxComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiMessageBoxModule, imports: [CommonModule,
            SieIconsModule,
            UiOverflowModule,
            UiButtonModule,
            UiButtonGroupModule,
            UiLinkModule,
            UiRichtextModule,
            RunInZoneModule,
            ComponentBreakpointsModule,
            AddTruncationAndTooltipModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiMessageBoxModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiMessageBoxComponent],
                    imports: [
                        CommonModule,
                        SieIconsModule,
                        UiOverflowModule,
                        UiButtonModule,
                        UiButtonGroupModule,
                        UiLinkModule,
                        UiRichtextModule,
                        RunInZoneModule,
                        ComponentBreakpointsModule,
                        AddTruncationAndTooltipModule
                    ],
                    exports: [UiMessageBoxComponent]
                }]
        }] });

/**
 * # Link List component
 *
 * Link list provides a list of links that are contextual and related to each other in most cases.
 * Link list is used when there are multiple links required to be displayed.
 * For example, footer. The link list is available in all the variants defined in links.
 *
 * ## Component variations
 *
 * - With separator
 * - Without separator
 *
 * ## Content
 *
 * The link list component does not accept any content.
 *
 * ## Code example
 * @example
 * Template:
 * ```html
 *  <sie-ui-link-list
 *    [numberOfVisibleLinks]="3"
 *    [hasUnderline]="true"
 *    [links]="linkListItems"
 *    [headlineCollapsed]="'Show More'"
 *    [headlineExpanded]="'Show Less'"
 *  ></sie-ui-link-list>
 * ```
 *
 * Link list items data example:
 * ```js
 *  linkListItems = [
 *    {
 *       href: '#',
 *       linkText: 'Test link'
 *    },
 *    {
 *       href: '#',
 *       linkText: 'Test link with a bit longer text',
 *       icon: SieIcon.Email
 *    },
 *    {
 *       href: '#',
 *       linkText: 'Test link without icon'
 *    },
 *    {
 *       href: '#',
 *       linkText: 'Link that overflows'
 *    },
 *    {
 *       href: '#',
 *       linkText: 'Link that overflows',
 *       disabled: true
 *    }
 *  ];
 * ```
 */
class UiLinkListComponent {
    /**
     * @param numberOfVisibleLinks Sets the number of visible links inside the overflow.
     * If it is not set, all links will be visible without overflow.
     * @default null
     */
    set numberOfVisibleLinks(numberOfVisibleLinks) {
        this._numberOfVisibleLinks = coerceNumberProperty(numberOfVisibleLinks);
        this.calculateExpandableLimit();
    }
    get numberOfVisibleLinks() {
        return this._numberOfVisibleLinks;
    }
    /**
     * @param value Defines whether the links inside the link list are separated.
     * @default false
     */
    set hasUnderline(value) {
        this._hasUnderline = coerceBooleanProperty(value);
    }
    get hasUnderline() {
        return this._hasUnderline;
    }
    /**
     * @param value Defines whether the content inside the links should be truncated.
     * @default true
     */
    set truncate(value) {
        this._truncate = coerceBooleanProperty(value);
    }
    get truncate() {
        return this._truncate;
    }
    constructor(cdr) {
        this.cdr = cdr;
        /**
         * Event triggered when one of the link in the link list is clicked.
         */
        this.clicked = new Subject();
        this._numberOfVisibleLinks = null;
        this._hasUnderline = false;
        this._truncate = true;
    }
    /** @ignore */
    ngOnInit() {
        this.calculateExpandableLimit();
    }
    calculateExpandableLimit() {
        const multiplier = this.hasUnderline ? 45 : 44;
        this.expandableLimit = '0';
        if (this.numberOfVisibleLinks) {
            this.expandableLimit = this.numberOfVisibleLinks * multiplier + 'px';
        }
    }
    /** @ignore */
    onClicked(link) {
        this.clicked.next(link);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiLinkListComponent, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiLinkListComponent, selector: "sie-ui-link-list", inputs: { links: "links", headlineCollapsed: "headlineCollapsed", headlineExpanded: "headlineExpanded", overflowGradientColor: "overflowGradientColor", numberOfVisibleLinks: "numberOfVisibleLinks", hasUnderline: "hasUnderline", truncate: "truncate" }, outputs: { clicked: "clicked" }, ngImport: i0, template: "<ng-template #linkList>\n  <ul class=\"link-list\" [ngClass]=\"{ underline: hasUnderline }\">\n    <li *ngFor=\"let link of links; let i = index\" class=\"link-list--link\" [sieCoreAttributes]=\"link.dataAttributes\">\n      <sie-ui-link\n        [href]=\"link.href\"\n        [icon]=\"link.icon\"\n        [size]=\"link.size || ''\"\n        [truncate]=\"truncate\"\n        [disabled]=\"link.disabled\"\n        [target]=\"link.target || '_self'\"\n        [secondaryLabel]=\"link.secondaryLabel\"\n        [background]=\"link.background || 'light'\"\n        [type]=\"link.type || 'link'\"\n        [inLinkList]=\"true\"\n        [trailingIcon]=\"link.trailingIcon\"\n        (clicked)=\"onClicked(link)\"\n        >{{ link.linkText }}</sie-ui-link\n      >\n    </li>\n  </ul>\n</ng-template>\n\n<sie-ui-overflow\n  *ngIf=\"numberOfVisibleLinks; else linkList\"\n  [limit]=\"expandableLimit\"\n  [headlineCollapsed]=\"headlineCollapsed\"\n  [headlineExpanded]=\"headlineExpanded\"\n  [gradientColor]=\"overflowGradientColor\"\n>\n  <ng-container *ngTemplateOutlet=\"linkList\"></ng-container>\n</sie-ui-overflow>\n", styles: [".link-list{list-style:none;margin:0;padding:0}.link-list--link{padding-bottom:5px}.link-list--link:last-child{padding-bottom:0}.link-list.underline li{padding:9px 0;border-bottom:1px solid #ccccd4}.link-list.underline li:last-child{border-bottom:0}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "component", type: UiLinkComponent, selector: "sie-ui-link", inputs: ["disabled", "disableVisitedStyle", "hasMarginTop", "offsetIcon", "truncate", "inLinkList", "trailingIcon", "icon", "cssClass", "href", "size", "target", "variant", "background", "type", "reference", "screenReaderText", "secondaryLabel", "download", "dataAttributes", "tooltip", "buttonType"], outputs: ["clicked"] }, { kind: "component", type: UiOverflowComponent, selector: "sie-ui-overflow", inputs: ["limit", "forBreakpoints", "headlineCollapsed", "headlineExpanded", "useGradient", "size", "buttonIndentationLeft", "buttonIndentationTop", "centered", "theme", "useDynamicSubItemHeight", "disabled", "showExpandButton", "gradientColor"], outputs: ["toggled"] }, { kind: "directive", type: i1$1.AttributeDirective, selector: "[sieCoreAttributes]", inputs: ["sieCoreAttributes"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiLinkListComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-link-list', changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-template #linkList>\n  <ul class=\"link-list\" [ngClass]=\"{ underline: hasUnderline }\">\n    <li *ngFor=\"let link of links; let i = index\" class=\"link-list--link\" [sieCoreAttributes]=\"link.dataAttributes\">\n      <sie-ui-link\n        [href]=\"link.href\"\n        [icon]=\"link.icon\"\n        [size]=\"link.size || ''\"\n        [truncate]=\"truncate\"\n        [disabled]=\"link.disabled\"\n        [target]=\"link.target || '_self'\"\n        [secondaryLabel]=\"link.secondaryLabel\"\n        [background]=\"link.background || 'light'\"\n        [type]=\"link.type || 'link'\"\n        [inLinkList]=\"true\"\n        [trailingIcon]=\"link.trailingIcon\"\n        (clicked)=\"onClicked(link)\"\n        >{{ link.linkText }}</sie-ui-link\n      >\n    </li>\n  </ul>\n</ng-template>\n\n<sie-ui-overflow\n  *ngIf=\"numberOfVisibleLinks; else linkList\"\n  [limit]=\"expandableLimit\"\n  [headlineCollapsed]=\"headlineCollapsed\"\n  [headlineExpanded]=\"headlineExpanded\"\n  [gradientColor]=\"overflowGradientColor\"\n>\n  <ng-container *ngTemplateOutlet=\"linkList\"></ng-container>\n</sie-ui-overflow>\n", styles: [".link-list{list-style:none;margin:0;padding:0}.link-list--link{padding-bottom:5px}.link-list--link:last-child{padding-bottom:0}.link-list.underline li{padding:9px 0;border-bottom:1px solid #ccccd4}.link-list.underline li:last-child{border-bottom:0}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }]; }, propDecorators: { links: [{
                type: Input
            }], headlineCollapsed: [{
                type: Input
            }], headlineExpanded: [{
                type: Input
            }], overflowGradientColor: [{
                type: Input
            }], numberOfVisibleLinks: [{
                type: Input
            }], hasUnderline: [{
                type: Input
            }], truncate: [{
                type: Input
            }], clicked: [{
                type: Output
            }] } });

/**
 * # Link List Module
 * - {@link UiLinkListComponent}
 *
 * ## Module peer dependencies
 * - {@link SieIconsModule}
 */
class UiLinkListModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiLinkListModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiLinkListModule, declarations: [UiLinkListComponent], imports: [CommonModule, UiLinkModule, UiOverflowModule, AttributeModule], exports: [UiLinkListComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiLinkListModule, imports: [CommonModule, UiLinkModule, UiOverflowModule, AttributeModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiLinkListModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiLinkListComponent],
                    imports: [CommonModule, UiLinkModule, UiOverflowModule, AttributeModule],
                    exports: [UiLinkListComponent]
                }]
        }] });

class UiTreeListService {
    /**
     * find the path to a specific node id, that means if you have a node id from the 3 level of the tree this
     * will return an array of all the parents [parentLevel1, parentLevel2, node]
     * @param currentPathToNode = path to a node
     * @param nodes = the whole tree
     * @param id = id of the node where you want the path too
     */
    static getPathToNode(currentPathToNode, nodes, id) {
        if (!currentPathToNode) {
            currentPathToNode = [];
        }
        if (currentPathToNode.length > 0) {
            // check the currentPath (its cheaper then looping through the whole tree)
            for (let i = 0; i < currentPathToNode.length; i++) {
                if (currentPathToNode[i].id === id) {
                    currentPathToNode.splice(i + 1, currentPathToNode.length - i);
                    return currentPathToNode;
                }
            }
            // check if its a child of the node
            if (currentPathToNode[currentPathToNode.length - 1].children) {
                for (const node of currentPathToNode[currentPathToNode.length - 1].children) {
                    if (id === node.id) {
                        currentPathToNode.push(node);
                        return currentPathToNode;
                    }
                }
            }
        }
        // check whole tree
        return this.getPathToNodeFromWholeTree([], nodes, id);
    }
    static getNode(nodes, id) {
        for (const node of nodes) {
            if (id === node.id) {
                return node;
            }
            else {
                if (node.children) {
                    const foundNode = this.getNode(node.children, id);
                    if (foundNode) {
                        return foundNode;
                    }
                }
            }
        }
        return null;
    }
    static updateSelection(nodes, selectedNodes) {
        nodes.forEach(node => {
            node.selected = false;
            selectedNodes.forEach(id => {
                if (id === node.id) {
                    node.selected = true;
                }
                if (node.children) {
                    this.updateSelection(node.children, selectedNodes);
                }
            });
        });
    }
    /**
     * Adds or removes the item from `selectedNodes` array
     * @param selectedNodes list of selected nodes
     * @param id id that should be added/removed
     * @param add whether to add or remove the item
     */
    static updateSelectedNodes(selectedNodes, id, add) {
        const index = selectedNodes.findIndex(el => el === id);
        if (add) {
            if (index < 0) {
                selectedNodes.push(id);
            }
        }
        else {
            if (index > -1) {
                selectedNodes.splice(index, 1);
            }
        }
    }
    static updateNodeAndChildren(node, selection, selectedNodes) {
        node.selected = selection;
        // update selection in the selectedNodes list
        this.updateSelectedNodes(selectedNodes, node.id, selection);
        // propagate the current state to all the children and their children
        node.children?.forEach(c => {
            this.updateNodeAndChildren(c, selection, selectedNodes);
        });
    }
    static updateNodeParents(node, nodes, selectedNodes) {
        const parents = UiTreeListService.getPathToNode(null, nodes, node.id);
        // current node ends up in parents list, so it should be removed
        parents.pop();
        // reverse the order
        parents.reverse();
        if (node.selected) {
            parents.forEach(p => {
                // loop through children of a parent, and if all of them are selected, select the parent
                if (p.children?.every(c => c.selected)) {
                    p.selected = true;
                    this.updateSelectedNodes(selectedNodes, p.id, true);
                }
            });
        }
        else {
            // remove "selected" from parent, to make it indeterminate
            parents.forEach(p => {
                p.selected = false;
                this.updateSelectedNodes(selectedNodes, p.id, false);
            });
        }
    }
    static isNodeIndeterminate(node) {
        if (!node.children) {
            return false;
        }
        for (const child of node.children) {
            const isIndeterminate = this.isNodeIndeterminate(child);
            if (isIndeterminate) {
                return true;
            }
        }
        return node.children.some(c => c.selected) && !node.children.every(c => c.selected);
    }
    static getAliasNode(nodes, aliasId, checkedAliasIds) {
        if (checkedAliasIds.find(id => id === aliasId)) {
            // prevent endless loop
            return null;
        }
        checkedAliasIds.push(aliasId);
        let node = this.getNode(nodes, aliasId);
        if (node?.aliasId) {
            node = this.getAliasNode(nodes, node.aliasId, checkedAliasIds);
        }
        return node;
    }
    static getPathToNodeFromWholeTree(parents, nodes, id) {
        for (const node of nodes) {
            if (id === node.id) {
                parents.push(node);
                break;
            }
            else {
                if (parents.length === 0 && node.children) {
                    parents = this.getPathToNodeFromWholeTree(parents, node.children, id);
                    if (parents.length > 0) {
                        parents.splice(0, 0, node);
                        break;
                    }
                }
            }
        }
        return parents;
    }
}

/**
 * # Radio Button Component
 *
 * Radio button support one single Radio Button Input.
 *
 * ## Component variations
 * - Standard version (when `label` value (with or without `icons` value) is defined)
 * - Condensed version (when no `label` nor `icons` value is defined)
 * - Light theme
 * - Dark theme
 * - Disabled
 * - Readonly
 * - Invalid
 *
 * ## Content
 *
 * The radio button component does not accept any content.
 *
 * ## Code example
 * @example ```html
 * <sie-ui-radio-button
 *   [radioButton]="{
 *       label: 'Apple',
 *       id: 'a'
 *     }
 *   "
 *   label="Choose your daily fruit"
 *   [checked]="true"
 *   [disabled]="true"
 * ></sie-ui-radio-button>
 * ```
 */
class UiRadioButtonComponent extends NgFormControlDirective {
    /** @ignore */
    set radioButtonInput(radioButtonInput) {
        if (this.focusRadioButton) {
            this.focusRadioButton = false;
            if (radioButtonInput?.nativeElement?.checked) {
                radioButtonInput.nativeElement.focus({ preventScroll: true });
            }
        }
    }
    /**
     * @param value Flag can be used to overrule disabled flag on the items itself
     * @default false
     */
    set disabled(value) {
        this._disabled = coerceBooleanProperty(value);
    }
    get disabled() {
        return this._disabled;
    }
    /**
     * Defines the checked state of the component
     * @default false
     */
    set checked(value) {
        this._checked = coerceBooleanProperty(value);
    }
    get checked() {
        return this._checked;
    }
    /**
     * @param value Used to add focus state on the radio button selected through `selectedId` input. It will be possible
     * to add focus on the selected option until the selected option is changed
     * @default false
     */
    set focusRadioButton(value) {
        this._focusRadioButton = coerceBooleanProperty(value);
    }
    get focusRadioButton() {
        return this._focusRadioButton;
    }
    /**
     * @param value adds styles for required state to the placeholder when set to true
     * @default false
     */
    set required(value) {
        this._required = coerceBooleanProperty(value);
    }
    get required() {
        return this._required;
    }
    constructor(iconReg) {
        super();
        this.iconReg = iconReg;
        /**
         * Used to define content in radio button. Checkout {@link UiRadioButtonModel}
         * @default empty array
         */
        this.radioButton = null;
        /**
         * Event when a different radio button is selected
         */
        this.selected = new EventEmitter();
        this._disabled = false;
        this._focusRadioButton = false;
        this._required = false;
        this._checked = false;
    }
    /** @ignore */
    ngOnInit() {
        this.radioButton.icons?.forEach(icon => {
            this.iconReg.register(icon);
        });
    }
    /** @ignore */
    onSelect(id) {
        this.selected.emit(id);
        this.markAsTouched();
        this.onChange(id);
    }
    /** @ignore */
    validateInternal(control) {
        if ((this.required && control.value === undefined) || control.value === null) {
            return {
                required: true
            };
        }
        return null;
    }
    /** @ignore */
    writeValue(value) {
        this.checked = value;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiRadioButtonComponent, deps: [{ token: i1.SieIconRegistryService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiRadioButtonComponent, selector: "sie-ui-radio-button", inputs: { disabled: "disabled", checked: "checked", radioButton: "radioButton", focusRadioButton: "focusRadioButton", required: "required" }, outputs: { selected: "selected" }, providers: [
            {
                provide: NG_VALUE_ACCESSOR,
                multi: true,
                useExisting: UiRadioButtonComponent
            },
            {
                provide: NG_VALIDATORS,
                multi: true,
                useExisting: UiRadioButtonComponent
            }
        ], viewQueries: [{ propertyName: "radioButtonInput", predicate: ["radioButtonInput"], descendants: true }], usesInheritance: true, ngImport: i0, template: "<div [ngClass]=\"[theme, disabled ? 'disabled' : '']\" class=\"radio-button__wrapper\">\n  <label [for]=\"name + '_' + radioButton.id\">\n    <input\n      (change)=\"onSelect(radioButton.id)\"\n      [checked]=\"checked\"\n      [disabled]=\"disabled\"\n      [id]=\"name + '_' + radioButton.id\"\n      [name]=\"name\"\n      [value]=\"radioButton.id\"\n      class=\"radio-button__input\"\n      type=\"radio\"\n      #radioButtonInput\n    />\n    <span class=\"radio-button__inner-wrapper\">\n      <span\n        [ngClass]=\"[theme, disabled ? 'disabled' : '', invalid && !disabled ? 'invalid' : '']\"\n        class=\"radio-button\"\n      ></span>\n    </span>\n    <span\n      *ngIf=\"radioButton.label || (radioButton.labelAppendix$ | async) || radioButton.icons\"\n      [ngClass]=\"{ invalid: invalid }\"\n      class=\"radio-button__label\"\n    >\n      <span\n        *ngIf=\"radioButton.label || (radioButton.labelAppendix$ | async)\"\n        [innerHTML]=\"(radioButton.label || '') + ((radioButton.labelAppendix$ | async) || '')\"\n        class=\"radio-button__label-text\"\n      ></span>\n      <span *ngIf=\"radioButton.icons\"\n        ><sie-icon *ngFor=\"let icon of radioButton.icons\" [name]=\"icon\" class=\"radio-button__label-icon\"></sie-icon\n      ></span>\n    </span>\n  </label>\n  <ng-content *ngIf=\"radioButton.hasAdditionalContent\" select=\"[slot=radio-button-content]\"></ng-content>\n</div>\n", styles: [".radio-button__input:focus{outline:0}.radio-button{position:absolute;top:0;left:0;height:20px;width:20px;background-color:#fff;border-radius:50%;display:flex;justify-content:center;align-items:center}.radio-button.disabled{background-color:#f3f3f0}.radio-button.disabled:after{background-color:#b3b3be}.radio-button:after,.radio-button:before{content:\"\";position:absolute;display:none;border-radius:50%}.radio-button:after{width:12px;height:12px;background-color:#33747a}@media print{.radio-button:after{-webkit-print-color-adjust:exact;print-color-adjust:exact}}.radio-button:before{display:block;top:0;left:0;width:20px;height:20px;background-color:#ebf7f8;border:1px solid #4c4c68}.radio-button__inner-wrapper{width:20px;height:20px;min-width:20px;position:relative;display:inline-block;border-radius:50%}.radio-button__input{position:absolute;opacity:0}.radio-button__input~.radio-button__inner-wrapper .radio-button:before{border-color:#4c4c68}.radio-button__input~.radio-button__inner-wrapper .radio-button.invalid:before{border-color:#ef0137}.radio-button__input~.radio-button__inner-wrapper .radio-button.disabled:before{border-color:#b3b3be}.radio-button__input~.radio-button__inner-wrapper .radio-button.dark:before{border-color:#ccccd4;background-color:#00183b}.radio-button__input~.radio-button__inner-wrapper .radio-button.dark:after{background-color:#ccccd4}.radio-button__input~.radio-button__inner-wrapper .radio-button.dark.invalid:before{border-color:#ef0137}.radio-button__input~.radio-button__inner-wrapper .radio-button.dark.disabled:before{border-color:#737389}.radio-button__input~.radio-button__inner-wrapper .radio-button.dark.disabled:after{background:#737389}.radio-button__input:checked~.radio-button__inner-wrapper .radio-button:after{display:block}.radio-button__input:checked~.radio-button__inner-wrapper .radio-button:before{border-color:#33747a}.radio-button__input:checked~.radio-button__inner-wrapper .radio-button.disabled:before{border-color:#b3b3be}.radio-button__input:checked~.radio-button__inner-wrapper .radio-button.dark:before{border-color:#ccccd4}.radio-button__input:checked~.radio-button__inner-wrapper .radio-button.dark.disabled:before{border-color:#737389}.radio-button__input:focus~.radio-button__inner-wrapper:before{content:\"\";position:absolute;inset:-3px;z-index:1;border:1px solid #1491eb;border-radius:50%}.radio-button__input:focus-visible~.radio-button__inner-wrapper:before{content:\"\";position:absolute;inset:-3px;z-index:1;border:1px solid #1491eb;border-radius:50%}.radio-button__input:focus:not(:focus-visible)~.radio-button__inner-wrapper:before{border:none}.radio-button__input:focus:not(:checked)~.radio-button__inner-wrapper .radio-button:before{border:1px solid #33747a}.radio-button__label{color:#000028;padding-left:8px;margin-top:-1px;word-break:break-word}.radio-button__label.invalid{color:#ef0137}.radio-button__label-text{margin-right:8px}.radio-button__label-icon{width:auto;height:20px;display:flex;align-items:center;fill:currentColor;display:inline-flex}.radio-button__label-icon svg{fill:currentColor;width:inherit;height:inherit}.radio-button__label-icon svg g{fill:currentColor;width:inherit;height:inherit}.radio-button__label-icon svg text{font-family:Siemens Sans,sans-serif}.radio-button__label-icon svg{max-width:32px}.radio-button__label-icon:not(:last-of-type){margin-right:8px}.radio-button__wrapper{position:relative;margin-bottom:13px}.radio-button__wrapper label{display:flex;cursor:pointer}.radio-button__wrapper:hover .radio-button__input:not(:disabled)~.radio-button__inner-wrapper .radio-button.dark:not(.invalid):after{background:#00ffb9}.radio-button__wrapper:hover .radio-button__input:not(:disabled)~.radio-button__inner-wrapper .radio-button:not(.invalid):before,.radio-button__wrapper:hover .radio-button__input:not(:checked):not(:disabled)~.radio-button__inner-wrapper .radio-button:not(.invalid):before{background:#d1fff2;border-color:#33747a}.radio-button__wrapper:hover .radio-button__input:not(:disabled)~.radio-button__inner-wrapper .radio-button.dark:not(.invalid):before,.radio-button__wrapper:hover .radio-button__input:not(:checked):not(:disabled)~.radio-button__inner-wrapper .radio-button.dark:not(.invalid):before{background:#001f39;border-color:#00ffb9}.radio-button-group .radio-button__wrapper:last-child{margin-bottom:0}.radio-button__wrapper.disabled .radio-button__label{color:#b3b3be}.radio-button__wrapper.disabled label{cursor:not-allowed}.radio-button__wrapper.dark .radio-button__label{color:#fff}.radio-button__wrapper.dark .radio-button__label.invalid{color:#ef0137}.radio-button__wrapper.dark.disabled .radio-button__label{color:#737389}.readonly__item{margin-bottom:13px}.readonly__hidden-input{display:none}.readonly__title{font-size:.75rem;font-weight:400;line-height:1rem;display:block;color:#9999a9}.readonly__label{display:block;color:#000028}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "pipe", type: i2.AsyncPipe, name: "async" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiRadioButtonComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-radio-button', changeDetection: ChangeDetectionStrategy.OnPush, providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            multi: true,
                            useExisting: UiRadioButtonComponent
                        },
                        {
                            provide: NG_VALIDATORS,
                            multi: true,
                            useExisting: UiRadioButtonComponent
                        }
                    ], template: "<div [ngClass]=\"[theme, disabled ? 'disabled' : '']\" class=\"radio-button__wrapper\">\n  <label [for]=\"name + '_' + radioButton.id\">\n    <input\n      (change)=\"onSelect(radioButton.id)\"\n      [checked]=\"checked\"\n      [disabled]=\"disabled\"\n      [id]=\"name + '_' + radioButton.id\"\n      [name]=\"name\"\n      [value]=\"radioButton.id\"\n      class=\"radio-button__input\"\n      type=\"radio\"\n      #radioButtonInput\n    />\n    <span class=\"radio-button__inner-wrapper\">\n      <span\n        [ngClass]=\"[theme, disabled ? 'disabled' : '', invalid && !disabled ? 'invalid' : '']\"\n        class=\"radio-button\"\n      ></span>\n    </span>\n    <span\n      *ngIf=\"radioButton.label || (radioButton.labelAppendix$ | async) || radioButton.icons\"\n      [ngClass]=\"{ invalid: invalid }\"\n      class=\"radio-button__label\"\n    >\n      <span\n        *ngIf=\"radioButton.label || (radioButton.labelAppendix$ | async)\"\n        [innerHTML]=\"(radioButton.label || '') + ((radioButton.labelAppendix$ | async) || '')\"\n        class=\"radio-button__label-text\"\n      ></span>\n      <span *ngIf=\"radioButton.icons\"\n        ><sie-icon *ngFor=\"let icon of radioButton.icons\" [name]=\"icon\" class=\"radio-button__label-icon\"></sie-icon\n      ></span>\n    </span>\n  </label>\n  <ng-content *ngIf=\"radioButton.hasAdditionalContent\" select=\"[slot=radio-button-content]\"></ng-content>\n</div>\n", styles: [".radio-button__input:focus{outline:0}.radio-button{position:absolute;top:0;left:0;height:20px;width:20px;background-color:#fff;border-radius:50%;display:flex;justify-content:center;align-items:center}.radio-button.disabled{background-color:#f3f3f0}.radio-button.disabled:after{background-color:#b3b3be}.radio-button:after,.radio-button:before{content:\"\";position:absolute;display:none;border-radius:50%}.radio-button:after{width:12px;height:12px;background-color:#33747a}@media print{.radio-button:after{-webkit-print-color-adjust:exact;print-color-adjust:exact}}.radio-button:before{display:block;top:0;left:0;width:20px;height:20px;background-color:#ebf7f8;border:1px solid #4c4c68}.radio-button__inner-wrapper{width:20px;height:20px;min-width:20px;position:relative;display:inline-block;border-radius:50%}.radio-button__input{position:absolute;opacity:0}.radio-button__input~.radio-button__inner-wrapper .radio-button:before{border-color:#4c4c68}.radio-button__input~.radio-button__inner-wrapper .radio-button.invalid:before{border-color:#ef0137}.radio-button__input~.radio-button__inner-wrapper .radio-button.disabled:before{border-color:#b3b3be}.radio-button__input~.radio-button__inner-wrapper .radio-button.dark:before{border-color:#ccccd4;background-color:#00183b}.radio-button__input~.radio-button__inner-wrapper .radio-button.dark:after{background-color:#ccccd4}.radio-button__input~.radio-button__inner-wrapper .radio-button.dark.invalid:before{border-color:#ef0137}.radio-button__input~.radio-button__inner-wrapper .radio-button.dark.disabled:before{border-color:#737389}.radio-button__input~.radio-button__inner-wrapper .radio-button.dark.disabled:after{background:#737389}.radio-button__input:checked~.radio-button__inner-wrapper .radio-button:after{display:block}.radio-button__input:checked~.radio-button__inner-wrapper .radio-button:before{border-color:#33747a}.radio-button__input:checked~.radio-button__inner-wrapper .radio-button.disabled:before{border-color:#b3b3be}.radio-button__input:checked~.radio-button__inner-wrapper .radio-button.dark:before{border-color:#ccccd4}.radio-button__input:checked~.radio-button__inner-wrapper .radio-button.dark.disabled:before{border-color:#737389}.radio-button__input:focus~.radio-button__inner-wrapper:before{content:\"\";position:absolute;inset:-3px;z-index:1;border:1px solid #1491eb;border-radius:50%}.radio-button__input:focus-visible~.radio-button__inner-wrapper:before{content:\"\";position:absolute;inset:-3px;z-index:1;border:1px solid #1491eb;border-radius:50%}.radio-button__input:focus:not(:focus-visible)~.radio-button__inner-wrapper:before{border:none}.radio-button__input:focus:not(:checked)~.radio-button__inner-wrapper .radio-button:before{border:1px solid #33747a}.radio-button__label{color:#000028;padding-left:8px;margin-top:-1px;word-break:break-word}.radio-button__label.invalid{color:#ef0137}.radio-button__label-text{margin-right:8px}.radio-button__label-icon{width:auto;height:20px;display:flex;align-items:center;fill:currentColor;display:inline-flex}.radio-button__label-icon svg{fill:currentColor;width:inherit;height:inherit}.radio-button__label-icon svg g{fill:currentColor;width:inherit;height:inherit}.radio-button__label-icon svg text{font-family:Siemens Sans,sans-serif}.radio-button__label-icon svg{max-width:32px}.radio-button__label-icon:not(:last-of-type){margin-right:8px}.radio-button__wrapper{position:relative;margin-bottom:13px}.radio-button__wrapper label{display:flex;cursor:pointer}.radio-button__wrapper:hover .radio-button__input:not(:disabled)~.radio-button__inner-wrapper .radio-button.dark:not(.invalid):after{background:#00ffb9}.radio-button__wrapper:hover .radio-button__input:not(:disabled)~.radio-button__inner-wrapper .radio-button:not(.invalid):before,.radio-button__wrapper:hover .radio-button__input:not(:checked):not(:disabled)~.radio-button__inner-wrapper .radio-button:not(.invalid):before{background:#d1fff2;border-color:#33747a}.radio-button__wrapper:hover .radio-button__input:not(:disabled)~.radio-button__inner-wrapper .radio-button.dark:not(.invalid):before,.radio-button__wrapper:hover .radio-button__input:not(:checked):not(:disabled)~.radio-button__inner-wrapper .radio-button.dark:not(.invalid):before{background:#001f39;border-color:#00ffb9}.radio-button-group .radio-button__wrapper:last-child{margin-bottom:0}.radio-button__wrapper.disabled .radio-button__label{color:#b3b3be}.radio-button__wrapper.disabled label{cursor:not-allowed}.radio-button__wrapper.dark .radio-button__label{color:#fff}.radio-button__wrapper.dark .radio-button__label.invalid{color:#ef0137}.radio-button__wrapper.dark.disabled .radio-button__label{color:#737389}.readonly__item{margin-bottom:13px}.readonly__hidden-input{display:none}.readonly__title{font-size:.75rem;font-weight:400;line-height:1rem;display:block;color:#9999a9}.readonly__label{display:block;color:#000028}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }]; }, propDecorators: { radioButtonInput: [{
                type: ViewChildren,
                args: ['radioButtonInput']
            }], disabled: [{
                type: Input
            }], checked: [{
                type: Input
            }], radioButton: [{
                type: Input
            }], focusRadioButton: [{
                type: Input
            }], required: [{
                type: Input
            }], selected: [{
                type: Output
            }] } });

/**
 * # Radio Button Group Component
 *
 * Radio buttons support compulsory selection of one single option out of multiple, mutually exclusive options.
 *
 * ## Component variations
 * - Standard version (when `label` value (with or without `icons` value) is defined)
 * - Condensed version (when no `label` nor `icons` value is defined)
 * - Light theme
 * - Dark theme
 * - Disabled
 * - Readonly
 * - Invalid
 *
 * ## Content
 *
 * The radio button component does not accept any content.
 *
 * ## Code example
 * @example ```html
 * <sie-ui-radio-button-group
 *   [radioButtons]="[
 *     {
 *       label: 'Apple',
 *       id: 'a'
 *     },
 *     {
 *       label: 'Banana',
 *       id: 'b'
 *     }
 *   ]"
 *   label="Choose your daily fruit"
 *   [selectedId]="'a'"
 * ></sie-ui-radio-button-group>
 * ```
 */
class UiRadioButtonGroupComponent extends NgFormControlDirective {
    /**
     * @param value Flag can be used to overrule disabled flag on the items itself
     * @default false
     */
    set disabled(value) {
        super.disabled = coerceBooleanProperty(value);
    }
    get disabled() {
        return super.disabled;
    }
    /**
     * @param value Used to add focus state on the radio button selected through `selectedId` input. It will be possible
     * to add focus on the selected option until the selected option is changed
     * @default false
     */
    set focusRadioButton(value) {
        this._focusRadioButton = coerceBooleanProperty(value);
    }
    get focusRadioButton() {
        return this._focusRadioButton;
    }
    /**
     * @param value adds styles for required state to the placeholder when set to true
     * @default false
     */
    set required(value) {
        this._required = coerceBooleanProperty(value);
    }
    get required() {
        return this._required;
    }
    constructor(iconReg) {
        super();
        this.iconReg = iconReg;
        /**
         * Defines which button of the component is selected by default (controlled through id set in 'radioButtons' input)
         * @default ''
         */
        this.selectedId = null;
        /**
         * Used to define content in radio buttons group. Checkout {@link UiRadioButtonGroupModel}
         * @default empty array
         */
        this.radioButtons = [];
        /**
         * Event when a different radio button is selected
         */
        this.selectedIdChange = new EventEmitter();
        this._focusRadioButton = false;
        this._required = false;
    }
    /** @ignore */
    ngOnInit() {
        this.radioButtons.forEach(item => {
            item.icons?.forEach(icon => {
                this.iconReg.register(icon);
            });
        });
    }
    /** @ignore */
    selected(id) {
        this.selectedId = id;
        this.selectedIdChange.emit(id);
        this.markAsTouched();
        this.onChange(id);
    }
    /** @ignore */
    getSelectedItem(selectedId) {
        return this.radioButtons.find(r => r.id === selectedId);
    }
    /** @ignore */
    validateInternal(control) {
        if ((this.required && control.value === undefined) || control.value === null) {
            return {
                required: true
            };
        }
        return null;
    }
    /** @ignore */
    writeValue(value) {
        this.selectedId = value;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiRadioButtonGroupComponent, deps: [{ token: i1.SieIconRegistryService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiRadioButtonGroupComponent, selector: "sie-ui-radio-button-group", inputs: { disabled: "disabled", selectedId: "selectedId", radioButtons: "radioButtons", focusRadioButton: "focusRadioButton", required: "required" }, outputs: { selectedIdChange: "selectedIdChange" }, host: { properties: { "attr.disabled": "this.disabled" } }, providers: [
            {
                provide: NG_VALUE_ACCESSOR,
                multi: true,
                useExisting: UiRadioButtonGroupComponent
            },
            {
                provide: NG_VALIDATORS,
                multi: true,
                useExisting: UiRadioButtonGroupComponent
            }
        ], usesInheritance: true, ngImport: i0, template: "<ul [ngClass]=\"theme\" class=\"radio-button-group\">\n  <li *ngIf=\"label && !readonly\" class=\"radio-button-group__text-wrapper\">\n    <span class=\"radio-button-group__title\">{{ label }}</span>\n    <span *ngIf=\"errorMessage && invalid\" class=\"radio-button-group__error-message\">{{ errorMessage }}</span>\n  </li>\n  <ng-container *ngIf=\"!readonly; else readOnly\">\n    <ng-container *ngFor=\"let radioButton of radioButtons\">\n      <sie-ui-radio-button\n        [name]=\"name\"\n        [focusRadioButton]=\"focusRadioButton\"\n        [radioButton]=\"radioButton\"\n        [checked]=\"radioButton.id === selectedId\"\n        [disabled]=\"radioButton.disabled || this.disabled\"\n        (selected)=\"selected(radioButton.id)\"\n      >\n        <ng-content slot=\"radio-button-content\" select=\"[slot=radio-button-group-content]\"></ng-content>\n      </sie-ui-radio-button>\n    </ng-container>\n  </ng-container>\n</ul>\n\n<ng-template #readOnly>\n  <sie-ui-readonly\n    *ngIf=\"selectedId\"\n    [value]=\"selectedId\"\n    [label]=\"label\"\n    [name]=\"name\"\n    [displayValue]=\"getSelectedItem(selectedId).label\"\n    [theme]=\"theme\"\n    [icons]=\"getSelectedItem(selectedId).icons\"\n  ></sie-ui-readonly>\n</ng-template>\n", styles: [".radio-button-group{list-style:none;margin:0;padding:0}.radio-button-group__text-wrapper{margin-bottom:8px}.radio-button-group__title{display:inline-block;color:#000028}.radio-button-group__error-message{font-size:.75rem;font-weight:400;line-height:1rem;display:block;color:#ef0137}.radio-button-group.dark .radio-button-group__title{color:#fff}.readonly__item{margin-bottom:13px}.readonly__hidden-input{display:none}.readonly__title{font-size:.75rem;font-weight:400;line-height:1rem;display:block;color:#9999a9}.readonly__label{display:block;color:#000028}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: UiReadonlyComponent, selector: "sie-ui-readonly", inputs: ["value", "label", "displayValue", "name", "theme", "icons"] }, { kind: "component", type: UiRadioButtonComponent, selector: "sie-ui-radio-button", inputs: ["disabled", "checked", "radioButton", "focusRadioButton", "required"], outputs: ["selected"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiRadioButtonGroupComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-radio-button-group', changeDetection: ChangeDetectionStrategy.OnPush, providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            multi: true,
                            useExisting: UiRadioButtonGroupComponent
                        },
                        {
                            provide: NG_VALIDATORS,
                            multi: true,
                            useExisting: UiRadioButtonGroupComponent
                        }
                    ], template: "<ul [ngClass]=\"theme\" class=\"radio-button-group\">\n  <li *ngIf=\"label && !readonly\" class=\"radio-button-group__text-wrapper\">\n    <span class=\"radio-button-group__title\">{{ label }}</span>\n    <span *ngIf=\"errorMessage && invalid\" class=\"radio-button-group__error-message\">{{ errorMessage }}</span>\n  </li>\n  <ng-container *ngIf=\"!readonly; else readOnly\">\n    <ng-container *ngFor=\"let radioButton of radioButtons\">\n      <sie-ui-radio-button\n        [name]=\"name\"\n        [focusRadioButton]=\"focusRadioButton\"\n        [radioButton]=\"radioButton\"\n        [checked]=\"radioButton.id === selectedId\"\n        [disabled]=\"radioButton.disabled || this.disabled\"\n        (selected)=\"selected(radioButton.id)\"\n      >\n        <ng-content slot=\"radio-button-content\" select=\"[slot=radio-button-group-content]\"></ng-content>\n      </sie-ui-radio-button>\n    </ng-container>\n  </ng-container>\n</ul>\n\n<ng-template #readOnly>\n  <sie-ui-readonly\n    *ngIf=\"selectedId\"\n    [value]=\"selectedId\"\n    [label]=\"label\"\n    [name]=\"name\"\n    [displayValue]=\"getSelectedItem(selectedId).label\"\n    [theme]=\"theme\"\n    [icons]=\"getSelectedItem(selectedId).icons\"\n  ></sie-ui-readonly>\n</ng-template>\n", styles: [".radio-button-group{list-style:none;margin:0;padding:0}.radio-button-group__text-wrapper{margin-bottom:8px}.radio-button-group__title{display:inline-block;color:#000028}.radio-button-group__error-message{font-size:.75rem;font-weight:400;line-height:1rem;display:block;color:#ef0137}.radio-button-group.dark .radio-button-group__title{color:#fff}.readonly__item{margin-bottom:13px}.readonly__hidden-input{display:none}.readonly__title{font-size:.75rem;font-weight:400;line-height:1rem;display:block;color:#9999a9}.readonly__label{display:block;color:#000028}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }]; }, propDecorators: { disabled: [{
                type: HostBinding,
                args: ['attr.disabled']
            }, {
                type: Input
            }], selectedId: [{
                type: Input
            }], radioButtons: [{
                type: Input
            }], focusRadioButton: [{
                type: Input
            }], required: [{
                type: Input
            }], selectedIdChange: [{
                type: Output
            }] } });

class UiTreeListBreadcrumbsComponent {
    constructor() {
        this.isOpen = true;
        this.showExpandButton = true;
        this.toggled = new Subject();
    }
    onToggle() {
        this.isOpen = !this.isOpen;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTreeListBreadcrumbsComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiTreeListBreadcrumbsComponent, selector: "sie-ui-tree-list-breadcrumbs", inputs: { isOpen: "isOpen", showExpandButton: "showExpandButton" }, outputs: { toggled: "toggled" }, ngImport: i0, template: "<div class=\"breadcrumb\">\n  <div class=\"breadcrumb__items\">\n    <div *ngIf=\"showExpandButton\" class=\"breadcrumb__closeable-list\" [@toggleExpandable]=\"isOpen\">\n      <ng-content select=\"[items]\"></ng-content>\n    </div>\n    <ng-content select=\"[last-item]\"></ng-content>\n  </div>\n\n  <sie-ui-expand-button\n    class=\"breadcrumb__expand-button\"\n    *ngIf=\"showExpandButton\"\n    (clicked)=\"onToggle()\"\n    prominence=\"tertiary\"\n  >\n  </sie-ui-expand-button>\n</div>\n", styles: [".breadcrumb{display:flex;justify-content:space-between;flex-direction:row;position:relative}.breadcrumb__closeable-list{display:flex;flex-direction:column}.breadcrumb__expand-button{position:absolute;top:-10px;right:-16px}.breadcrumb__items{width:100%;padding-right:30px}\n"], dependencies: [{ kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: UiExpandButtonComponent, selector: "sie-ui-expand-button", inputs: ["expanded"] }], animations: [toggleExpandableAnimation], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTreeListBreadcrumbsComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-tree-list-breadcrumbs', animations: [toggleExpandableAnimation], changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"breadcrumb\">\n  <div class=\"breadcrumb__items\">\n    <div *ngIf=\"showExpandButton\" class=\"breadcrumb__closeable-list\" [@toggleExpandable]=\"isOpen\">\n      <ng-content select=\"[items]\"></ng-content>\n    </div>\n    <ng-content select=\"[last-item]\"></ng-content>\n  </div>\n\n  <sie-ui-expand-button\n    class=\"breadcrumb__expand-button\"\n    *ngIf=\"showExpandButton\"\n    (clicked)=\"onToggle()\"\n    prominence=\"tertiary\"\n  >\n  </sie-ui-expand-button>\n</div>\n", styles: [".breadcrumb{display:flex;justify-content:space-between;flex-direction:row;position:relative}.breadcrumb__closeable-list{display:flex;flex-direction:column}.breadcrumb__expand-button{position:absolute;top:-10px;right:-16px}.breadcrumb__items{width:100%;padding-right:30px}\n"] }]
        }], propDecorators: { isOpen: [{
                type: Input
            }], showExpandButton: [{
                type: Input
            }], toggled: [{
                type: Output
            }] } });

const ITEM_LIMIT_FOR_CLOSEABLE_SECTION = 2;
/**
 * # Tree List Component
 *
 * Tree list provides the user a set of nested options to choose from, either a single option only or a multitude of options.
 *
 * ## Component variations
 *
 * - Single select
 * - Multi select
 *
 * ## Content
 *
 * Tree list component does not accept any content
 *
 * ## Code example
 * @example
 * Template:
 * ```html
 * <sie-ui-tree-list
 *   [multiSelect]="true"
 *   [nodes]="treeListNodes"
 *   [breadCrumbSelection]="'partial'"
 *   [selectedNodes]="[]"
 *   [overflowLimit]="'5'"
 *   [overflowHeadlineCollapsed]="'Expandable button more'"
 *   [overflowHeadlineExpanded]="'Expandable button less'"
 *   [backToLabel]="'Tree list back to label'"
 *   [showSelectAllNode]="'Tree List Show All'"
 *   [selectAllLabel]="'All'"
 *   (selectedNodesChanged)="selectedNodesChanged($event)"
 *   (newNodeSelected)="newNodeSelected($event)"
 *   (overflowToggled)="overflowToggled($event)"
 * ></sie-ui-tree-list>
 * ```
 *
 * Data example:
 * ```js
 * const treeListNodeData = [
 *   {
 *     id: 'all',
 *     label: 'All',
 *     children: [
 *       {
 *         id: '13204',
 *         label: 'Drive Technology (4291)',
 *         children: [
 *           {
 *             id: '13205',
 *             label: 'Converters (2079)'
 *           }
 *         ]
 *       }
 *     ],
 *     selected: true
 *   }
 * ];
 * ```
 */
class UiTreeListComponent {
    /**
     * Defines if the multi-select is enabled
     * @default false
     */
    set multiSelect(value) {
        this._multiSelect = coerceBooleanProperty(value);
    }
    get multiSelect() {
        return this._multiSelect;
    }
    /**
     * Defines which nodes are selected
     * @default empty array
     */
    set selectedNodes(selectedNodes) {
        this._selectedNodes = selectedNodes || [];
        if (this.initialized) {
            this.updateTreeList();
        }
    }
    get selectedNodes() {
        return this._selectedNodes;
    }
    /**
     * Main source of the nodes data that should be displayed
     * @default empty array
     */
    set nodes(nodes) {
        this._nodes = nodes;
        if (this.initialized) {
            this.breadcrumbs = [];
            this.updateTreeList();
        }
    }
    get nodes() {
        return this._nodes;
    }
    /**
     * Defines which breadcrumb mode should be used. Applicable only in case of single-select mode.
     * In `'partial'` mode if selected node has no children, it will not be moved to the breadcrumb section.
     * In `'full'` mode if selected node has no children, it will be moved to the breadcrumb section
     * @default 'partial'
     */
    set breadCrumbSelection(breadCrumbSelection) {
        if (breadCrumbSelection && this._breadCrumbSelection !== breadCrumbSelection) {
            this._breadCrumbSelection = breadCrumbSelection;
            this.updateTreeList();
        }
    }
    get breadCrumbSelection() {
        return this._breadCrumbSelection;
    }
    /**
     * Defines if the option to select all should be shown or not
     * @default true
     */
    set showSelectAllNode(value) {
        this._showSelectAll = coerceBooleanProperty(value);
    }
    get showSelectAllNode() {
        return this._showSelectAll;
    }
    constructor(iconReg, cdr) {
        this.iconReg = iconReg;
        this.cdr = cdr;
        /**
         * Defines whether the overflow should be expanded on initial component render
         * @default false
         */
        this.expandOverflowInitially = false;
        /**
         * Event triggered when a tree list selection is changed.
         * The event data is the list of selected node IDs.
         */
        this.selectedNodesChanged = new EventEmitter();
        /**
         * Event triggered when a new tree list node is selected.
         * The event data is the selected {@link UiTreeNodeModel Tree node data}
         */
        this.newNodeSelected = new EventEmitter();
        /**
         * Event triggered when overflow component gets toggled by the user.
         * The event data is a boolean and will be true, false for expanded, collapsed respectively.
         */
        this.overflowToggled = new EventEmitter();
        /** @ignore */
        this.isOpen = true;
        /** @ignore */
        this.focusRadioButton = false;
        /** @ignore */
        this.hasFocus = false;
        /** @ignore */
        this.breadcrumbs = [];
        /** @ignore */
        this.visibleNodeId = '';
        /** @ignore */
        this.uniqueId = getUniqueID();
        /** @ignore */
        this.itemLimit = ITEM_LIMIT_FOR_CLOSEABLE_SECTION;
        this._multiSelect = false;
        this.initialized = false;
        this._selectedNodes = [];
        this._nodes = [];
        this._breadCrumbSelection = 'partial';
        this._showSelectAll = true;
        iconReg.register(SieIcon.ArrowRight);
    }
    /** @ignore */
    ngAfterViewInit() {
        this.updateTreeList();
        this.initialized = true;
        if (this.expandOverflowInitially) {
            requestAnimationFrame(() => this.overflowComponent?.expand());
        }
    }
    /** @ignore */
    onFocus(hasFocus) {
        this.hasFocus = hasFocus;
    }
    /** @ignore */
    onSingleTreeSelection(node) {
        this.focusRadioButton = true;
        if (node.aliasId) {
            const aliasNode = UiTreeListService.getAliasNode(this.nodes, node.aliasId, []);
            if (aliasNode) {
                node = aliasNode;
            }
        }
        this.visibleNodeId = node.id;
        // setter calls updateSingleSelectTreeList
        this.selectedNodes = [node.id];
        this.selectedNodesChanged.next(this.selectedNodes);
        this.newNodeSelected.next(node);
        // toggle (collapse) overflow component when it is expanded and selected node has children
        if (this.overflowComponent?.isExpanded && !!node.children?.length) {
            this.overflowComponent.toggle();
        }
    }
    updateTreeList() {
        if (this.nodes?.length > 0) {
            if (this.multiSelect) {
                this.initMultiSelectTreeList();
            }
            else {
                this.updateSingleSelectTreeList();
            }
        }
        this.cdr.detectChanges();
        this.focusRadioButton = false;
    }
    updateSingleSelectTreeList() {
        // in single select mode always the selected Node is also the visible Node
        if (!this.selectedNodes?.length) {
            this.selectedNodes = [this.nodes[0].id];
        }
        // check aliasId
        let node = UiTreeListService.getNode(this.nodes, this.selectedNodes[0]);
        if (!node) {
            // selectedNodeId is invalid
            this.selectedNodes = [this.nodes[0].id];
        }
        if (node?.aliasId) {
            node = UiTreeListService.getAliasNode(this.nodes, node.aliasId, []);
            if (node && node.id !== this.selectedNodes[0]) {
                // setter calls updateSingleSelectTreeList
                this.selectedNodes = [node.id];
                if (this.initialized) {
                    return;
                }
            }
        }
        this.visibleNodeId = this.selectedNodes[0];
        // update tree with selected information
        UiTreeListService.updateSelection(this.nodes, this.selectedNodes);
        // fill breadcrumbs and find activeNode
        this.updateBreadCrumbsAndActiveNode();
    }
    initMultiSelectTreeList() {
        this.activeNode = this.nodes[0];
        this.updateMultiSelectTreeList();
    }
    updateMultiSelectTreeList() {
        this.breadcrumbs = UiTreeListService.getPathToNode(this.breadcrumbs, this.nodes, this.activeNode.id);
        this.cdr.markForCheck();
    }
    updateBreadCrumbsAndActiveNode() {
        const visibleNode = UiTreeListService.getNode(this.nodes, this.visibleNodeId);
        if (visibleNode) {
            this.breadcrumbs = UiTreeListService.getPathToNode(this.breadcrumbs, this.nodes, this.visibleNodeId);
            if (this.breadCrumbSelection === 'partial' &&
                this.breadcrumbs.length > 1 &&
                (!visibleNode.children || visibleNode.children.length === 0)) {
                // if the selected node has no children the node is not moving to the breadcrumb-section
                this.activeNode = this.breadcrumbs[this.breadcrumbs.length - 2];
                this.breadcrumbs.splice(this.breadcrumbs.length - 1, 1);
            }
            else {
                this.activeNode = visibleNode;
            }
            if (this.breadcrumbs.length <= this.itemLimit) {
                this.isOpen = true;
            }
        }
    }
    /** @ignore */
    handleMultiSelectChange(node, state) {
        if (state) {
            this.newNodeSelected.next(node);
        }
        UiTreeListService.updateNodeAndChildren(node, state, this.selectedNodes ?? []);
        UiTreeListService.updateNodeParents(node, this.nodes, this.selectedNodes);
        this.selectedNodesChanged.next(this.selectedNodes);
        this.cdr.markForCheck();
    }
    /** @ignore */
    openNode(node) {
        this.activeNode = node;
        this.updateMultiSelectTreeList();
        this.focusFirstCheckbox();
    }
    focusFirstCheckbox() {
        requestAnimationFrame(() => {
            if (this.showSelectAllNode) {
                this.selectAllCheckbox.focus();
            }
            else {
                this.multiSelectCheckboxes?.first.focus();
            }
        });
    }
    /** @ignore */
    isIndeterminate(node) {
        return UiTreeListService.isNodeIndeterminate(node);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTreeListComponent, deps: [{ token: i1.SieIconRegistryService }, { token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiTreeListComponent, selector: "sie-ui-tree-list", inputs: { overflowHeadlineCollapsed: "overflowHeadlineCollapsed", overflowHeadlineExpanded: "overflowHeadlineExpanded", overflowLimit: "overflowLimit", backToLabel: "backToLabel", selectAllLabel: "selectAllLabel", multiSelect: "multiSelect", selectedNodes: "selectedNodes", nodes: "nodes", breadCrumbSelection: "breadCrumbSelection", showSelectAllNode: "showSelectAllNode", expandOverflowInitially: "expandOverflowInitially" }, outputs: { selectedNodesChanged: "selectedNodesChanged", newNodeSelected: "newNodeSelected", overflowToggled: "overflowToggled" }, viewQueries: [{ propertyName: "overflowComponent", first: true, predicate: UiOverflowComponent, descendants: true }, { propertyName: "selectAllCheckbox", first: true, predicate: ["selectAllCheckbox"], descendants: true }, { propertyName: "multiSelectCheckboxes", predicate: ["multiSelectCheckboxes"], descendants: true }], ngImport: i0, template: "<ng-container *ngIf=\"!multiSelect; else multiSelectPartial\">\n  <div class=\"single-tree\" (focusin)=\"onFocus(true)\" (focusout)=\"onFocus(false)\">\n    <sie-ui-tree-list-breadcrumbs\n      *ngIf=\"breadcrumbs.length\"\n      [isOpen]=\"isOpen\"\n      [showExpandButton]=\"breadcrumbs.length > itemLimit\"\n    >\n      <ng-container items>\n        <sie-ui-radio-button-group\n          *ngFor=\"let breadcrumb of breadcrumbs | slice: 0 : breadcrumbs.length - itemLimit\"\n          [selectedId]=\"breadcrumb.selected ? breadcrumb.id : ''\"\n          [focusRadioButton]=\"breadcrumb.selected ? hasFocus || focusRadioButton : false\"\n          [name]=\"uniqueId + 'singleTree' + breadcrumb.id\"\n          [radioButtons]=\"[\n            {\n              id: breadcrumb.id,\n              label: breadcrumb.label,\n              labelAppendix$: breadcrumb.labelAppendix$,\n              icons: breadcrumb.aliasId ? [iconReg.sieIcon.Ext] : breadcrumb.icons\n            }\n          ]\"\n          (selectedIdChange)=\"onSingleTreeSelection(breadcrumb)\"\n          class=\"radio-button-group\"\n        ></sie-ui-radio-button-group>\n      </ng-container>\n\n      <ng-container last-item>\n        <sie-ui-radio-button-group\n          *ngFor=\"let breadcrumb of breadcrumbs | slice: breadcrumbs.length - itemLimit\"\n          [selectedId]=\"breadcrumb.selected ? breadcrumb.id : ''\"\n          [focusRadioButton]=\"breadcrumb.selected ? hasFocus || focusRadioButton : false\"\n          [name]=\"uniqueId + 'singleTree' + breadcrumb.id\"\n          [radioButtons]=\"[\n            {\n              id: breadcrumb.id,\n              label: breadcrumb.label,\n              labelAppendix$: breadcrumb.labelAppendix$,\n              icons: breadcrumb.aliasId ? [iconReg.sieIcon.Ext] : breadcrumb.icons\n            }\n          ]\"\n          (selectedIdChange)=\"onSingleTreeSelection(breadcrumb)\"\n          class=\"radio-button-group non-expandable\"\n        ></sie-ui-radio-button-group>\n      </ng-container>\n    </sie-ui-tree-list-breadcrumbs>\n\n    <hr *ngIf=\"breadcrumbs.length > 1 && activeNode?.children?.length > 0\" />\n    <div class=\"single-tree__active-level\" [ngClass]=\"{ indent: breadcrumbs.length > 1 }\">\n      <sie-ui-overflow\n        *ngIf=\"\n          overflowLimit && activeNode?.children?.length > 0 && activeNode.children?.length > +overflowLimit;\n          else subItems\n        \"\n        [limit]=\"overflowLimit\"\n        [headlineCollapsed]=\"overflowHeadlineCollapsed\"\n        [headlineExpanded]=\"overflowHeadlineExpanded\"\n        [useDynamicSubItemHeight]=\"true\"\n        (toggled)=\"overflowToggled.emit($event)\"\n      >\n        <ng-container *ngTemplateOutlet=\"subItems\"></ng-container>\n      </sie-ui-overflow>\n    </div>\n  </div>\n</ng-container>\n\n<ng-template #subItems>\n  <sie-ui-radio-button-group\n    *ngFor=\"let node of activeNode?.children\"\n    [name]=\"uniqueId + 'singleTree' + node.id\"\n    [selectedId]=\"node.selected ? node.id : ''\"\n    [focusRadioButton]=\"node.selected ? hasFocus || focusRadioButton : false\"\n    [radioButtons]=\"[\n      {\n        id: node.id,\n        label: node.label,\n        labelAppendix$: node.labelAppendix$,\n        icons: node.aliasId ? [iconReg.sieIcon.Ext] : node.icons\n      }\n    ]\"\n    (selectedIdChange)=\"onSingleTreeSelection(node)\"\n    class=\"radio-button-group sub-item\"\n  ></sie-ui-radio-button-group>\n</ng-template>\n\n<ng-template #multiSelectPartial>\n  <div class=\"multi-tree\">\n    <sie-ui-tree-list-breadcrumbs\n      *ngIf=\"breadcrumbs.length > 1\"\n      [isOpen]=\"isOpen\"\n      [showExpandButton]=\"breadcrumbs.length > itemLimit\"\n    >\n      <ng-container items>\n        <sie-ui-link\n          *ngFor=\"let b of breadcrumbs | slice: 0 : breadcrumbs.length - itemLimit\"\n          [icon]=\"iconReg.sieIcon.ArrowLeft\"\n          [disableVisitedStyle]=\"true\"\n          [type]=\"'button'\"\n          (clicked)=\"openNode(b)\"\n          class=\"multi-tree__breadcrumb-item\"\n          >{{ backToLabel }}&nbsp;[{{ b.label }}]</sie-ui-link\n        >\n      </ng-container>\n      <ng-container last-item>\n        <sie-ui-link\n          [icon]=\"iconReg.sieIcon.ArrowLeft\"\n          [disableVisitedStyle]=\"true\"\n          [type]=\"'button'\"\n          (clicked)=\"openNode(breadcrumbs[breadcrumbs.length - itemLimit])\"\n          class=\"multi-tree__breadcrumb-item\"\n          >{{ backToLabel }}&nbsp;[{{ breadcrumbs[breadcrumbs.length - itemLimit].label }}]</sie-ui-link\n        >\n      </ng-container>\n    </sie-ui-tree-list-breadcrumbs>\n\n    <h5 class=\"multi-tree__title\">{{ activeNode?.label }}</h5>\n\n    <sie-ui-overflow\n      *ngIf=\"\n        overflowLimit && activeNode?.children?.length > 0 && activeNode?.children?.length > +overflowLimit;\n        else multiSelectSubItems\n      \"\n      [limit]=\"overflowLimit\"\n      [headlineCollapsed]=\"overflowHeadlineCollapsed\"\n      [headlineExpanded]=\"overflowHeadlineExpanded\"\n      [useDynamicSubItemHeight]=\"true\"\n      (toggled)=\"overflowToggled.emit($event)\"\n    >\n      <ng-container *ngTemplateOutlet=\"multiSelectSubItems\"></ng-container>\n    </sie-ui-overflow>\n  </div>\n</ng-template>\n\n<ng-template #multiSelectSubItems>\n  <div class=\"multi-tree__item\" *ngIf=\"showSelectAllNode && activeNode\">\n    <sie-ui-checkbox\n      [id]=\"activeNode.id\"\n      [label]=\"selectAllLabel\"\n      [icons]=\"activeNode.icons\"\n      [value]=\"activeNode.selected\"\n      [indeterminate]=\"isIndeterminate(activeNode)\"\n      (valueChange)=\"handleMultiSelectChange(activeNode, $event)\"\n      class=\"multi-tree__checkbox\"\n      #selectAllCheckbox\n    ></sie-ui-checkbox>\n  </div>\n\n  <div *ngFor=\"let node of activeNode?.children\" class=\"multi-tree__item\">\n    <sie-ui-checkbox\n      [id]=\"node.id\"\n      [label]=\"node.label\"\n      [icons]=\"node.icons\"\n      [value]=\"node.selected\"\n      [indeterminate]=\"isIndeterminate(node)\"\n      [hint]=\"node.inputHint\"\n      (valueChange)=\"handleMultiSelectChange(node, $event)\"\n      #multiSelectCheckboxes\n      class=\"multi-tree__checkbox\"\n    ></sie-ui-checkbox>\n    <button *ngIf=\"node.children?.length > 0\" (click)=\"openNode(node)\" class=\"multi-tree__button\">\n      <sie-icon class=\"multi-tree__button-icon\" [name]=\"iconReg.sieIcon.ArrowRight\"></sie-icon>\n    </button>\n  </div>\n</ng-template>\n", styles: [".single-tree .radio-button-group{display:block;margin-bottom:11px}.single-tree .radio-button-group.non-expandable:last-child:not(:only-child){margin-bottom:0}.single-tree__active-level.indent{padding-left:29px}.single-tree__active-level .sub-item:last-child{margin-bottom:0}.multi-tree{padding-top:1rem}.multi-tree__item{display:flex;justify-content:space-between;align-items:baseline;margin-bottom:12px;padding-right:34px;position:relative}.multi-tree__button{padding:0;position:absolute;right:-10px;top:0;border:0;background:none;width:32px;height:32px;flex-shrink:0;display:flex;justify-content:center;align-items:center}.multi-tree__button:focus-visible{outline:0}.multi-tree__button:focus-visible:before{content:\"\";position:absolute;inset:-3px;z-index:1;border:1px solid #1491eb;border-radius:0}.multi-tree__button:active:not(:disabled):not(.hover-disabled),.multi-tree__button:hover:not(:disabled):not(.hover-disabled){cursor:pointer}.multi-tree__button:active:not(:disabled):not(.hover-disabled) .multi-tree__button-icon,.multi-tree__button:hover:not(:disabled):not(.hover-disabled) .multi-tree__button-icon{color:#33747a}.multi-tree__button-icon{width:24px;height:24px;display:flex;align-items:center;fill:currentColor;color:#4c4c68}.multi-tree__button-icon svg{fill:currentColor;width:inherit;height:inherit}.multi-tree__button-icon svg g{fill:currentColor;width:inherit;height:inherit}.multi-tree__button-icon svg text{font-family:Siemens Sans,sans-serif}.multi-tree__checkbox{display:block}.multi-tree__title{margin-bottom:1rem;margin-top:.5rem}.multi-tree__breadcrumb-item{margin-left:-7px}hr{border:none;height:1px;margin-bottom:15px;margin-top:3px;background:#ccccd4}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "component", type: UiRadioButtonGroupComponent, selector: "sie-ui-radio-button-group", inputs: ["disabled", "selectedId", "radioButtons", "focusRadioButton", "required"], outputs: ["selectedIdChange"] }, { kind: "component", type: UiOverflowComponent, selector: "sie-ui-overflow", inputs: ["limit", "forBreakpoints", "headlineCollapsed", "headlineExpanded", "useGradient", "size", "buttonIndentationLeft", "buttonIndentationTop", "centered", "theme", "useDynamicSubItemHeight", "disabled", "showExpandButton", "gradientColor"], outputs: ["toggled"] }, { kind: "component", type: UiCheckboxComponent, selector: "sie-ui-checkbox", inputs: ["id", "checkboxIdToFocus", "indeterminate", "value", "active", "required", "icons", "labelAppendix$"], outputs: ["valueChange"] }, { kind: "component", type: UiLinkComponent, selector: "sie-ui-link", inputs: ["disabled", "disableVisitedStyle", "hasMarginTop", "offsetIcon", "truncate", "inLinkList", "trailingIcon", "icon", "cssClass", "href", "size", "target", "variant", "background", "type", "reference", "screenReaderText", "secondaryLabel", "download", "dataAttributes", "tooltip", "buttonType"], outputs: ["clicked"] }, { kind: "component", type: UiTreeListBreadcrumbsComponent, selector: "sie-ui-tree-list-breadcrumbs", inputs: ["isOpen", "showExpandButton"], outputs: ["toggled"] }, { kind: "pipe", type: i2.SlicePipe, name: "slice" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTreeListComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-tree-list', changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-container *ngIf=\"!multiSelect; else multiSelectPartial\">\n  <div class=\"single-tree\" (focusin)=\"onFocus(true)\" (focusout)=\"onFocus(false)\">\n    <sie-ui-tree-list-breadcrumbs\n      *ngIf=\"breadcrumbs.length\"\n      [isOpen]=\"isOpen\"\n      [showExpandButton]=\"breadcrumbs.length > itemLimit\"\n    >\n      <ng-container items>\n        <sie-ui-radio-button-group\n          *ngFor=\"let breadcrumb of breadcrumbs | slice: 0 : breadcrumbs.length - itemLimit\"\n          [selectedId]=\"breadcrumb.selected ? breadcrumb.id : ''\"\n          [focusRadioButton]=\"breadcrumb.selected ? hasFocus || focusRadioButton : false\"\n          [name]=\"uniqueId + 'singleTree' + breadcrumb.id\"\n          [radioButtons]=\"[\n            {\n              id: breadcrumb.id,\n              label: breadcrumb.label,\n              labelAppendix$: breadcrumb.labelAppendix$,\n              icons: breadcrumb.aliasId ? [iconReg.sieIcon.Ext] : breadcrumb.icons\n            }\n          ]\"\n          (selectedIdChange)=\"onSingleTreeSelection(breadcrumb)\"\n          class=\"radio-button-group\"\n        ></sie-ui-radio-button-group>\n      </ng-container>\n\n      <ng-container last-item>\n        <sie-ui-radio-button-group\n          *ngFor=\"let breadcrumb of breadcrumbs | slice: breadcrumbs.length - itemLimit\"\n          [selectedId]=\"breadcrumb.selected ? breadcrumb.id : ''\"\n          [focusRadioButton]=\"breadcrumb.selected ? hasFocus || focusRadioButton : false\"\n          [name]=\"uniqueId + 'singleTree' + breadcrumb.id\"\n          [radioButtons]=\"[\n            {\n              id: breadcrumb.id,\n              label: breadcrumb.label,\n              labelAppendix$: breadcrumb.labelAppendix$,\n              icons: breadcrumb.aliasId ? [iconReg.sieIcon.Ext] : breadcrumb.icons\n            }\n          ]\"\n          (selectedIdChange)=\"onSingleTreeSelection(breadcrumb)\"\n          class=\"radio-button-group non-expandable\"\n        ></sie-ui-radio-button-group>\n      </ng-container>\n    </sie-ui-tree-list-breadcrumbs>\n\n    <hr *ngIf=\"breadcrumbs.length > 1 && activeNode?.children?.length > 0\" />\n    <div class=\"single-tree__active-level\" [ngClass]=\"{ indent: breadcrumbs.length > 1 }\">\n      <sie-ui-overflow\n        *ngIf=\"\n          overflowLimit && activeNode?.children?.length > 0 && activeNode.children?.length > +overflowLimit;\n          else subItems\n        \"\n        [limit]=\"overflowLimit\"\n        [headlineCollapsed]=\"overflowHeadlineCollapsed\"\n        [headlineExpanded]=\"overflowHeadlineExpanded\"\n        [useDynamicSubItemHeight]=\"true\"\n        (toggled)=\"overflowToggled.emit($event)\"\n      >\n        <ng-container *ngTemplateOutlet=\"subItems\"></ng-container>\n      </sie-ui-overflow>\n    </div>\n  </div>\n</ng-container>\n\n<ng-template #subItems>\n  <sie-ui-radio-button-group\n    *ngFor=\"let node of activeNode?.children\"\n    [name]=\"uniqueId + 'singleTree' + node.id\"\n    [selectedId]=\"node.selected ? node.id : ''\"\n    [focusRadioButton]=\"node.selected ? hasFocus || focusRadioButton : false\"\n    [radioButtons]=\"[\n      {\n        id: node.id,\n        label: node.label,\n        labelAppendix$: node.labelAppendix$,\n        icons: node.aliasId ? [iconReg.sieIcon.Ext] : node.icons\n      }\n    ]\"\n    (selectedIdChange)=\"onSingleTreeSelection(node)\"\n    class=\"radio-button-group sub-item\"\n  ></sie-ui-radio-button-group>\n</ng-template>\n\n<ng-template #multiSelectPartial>\n  <div class=\"multi-tree\">\n    <sie-ui-tree-list-breadcrumbs\n      *ngIf=\"breadcrumbs.length > 1\"\n      [isOpen]=\"isOpen\"\n      [showExpandButton]=\"breadcrumbs.length > itemLimit\"\n    >\n      <ng-container items>\n        <sie-ui-link\n          *ngFor=\"let b of breadcrumbs | slice: 0 : breadcrumbs.length - itemLimit\"\n          [icon]=\"iconReg.sieIcon.ArrowLeft\"\n          [disableVisitedStyle]=\"true\"\n          [type]=\"'button'\"\n          (clicked)=\"openNode(b)\"\n          class=\"multi-tree__breadcrumb-item\"\n          >{{ backToLabel }}&nbsp;[{{ b.label }}]</sie-ui-link\n        >\n      </ng-container>\n      <ng-container last-item>\n        <sie-ui-link\n          [icon]=\"iconReg.sieIcon.ArrowLeft\"\n          [disableVisitedStyle]=\"true\"\n          [type]=\"'button'\"\n          (clicked)=\"openNode(breadcrumbs[breadcrumbs.length - itemLimit])\"\n          class=\"multi-tree__breadcrumb-item\"\n          >{{ backToLabel }}&nbsp;[{{ breadcrumbs[breadcrumbs.length - itemLimit].label }}]</sie-ui-link\n        >\n      </ng-container>\n    </sie-ui-tree-list-breadcrumbs>\n\n    <h5 class=\"multi-tree__title\">{{ activeNode?.label }}</h5>\n\n    <sie-ui-overflow\n      *ngIf=\"\n        overflowLimit && activeNode?.children?.length > 0 && activeNode?.children?.length > +overflowLimit;\n        else multiSelectSubItems\n      \"\n      [limit]=\"overflowLimit\"\n      [headlineCollapsed]=\"overflowHeadlineCollapsed\"\n      [headlineExpanded]=\"overflowHeadlineExpanded\"\n      [useDynamicSubItemHeight]=\"true\"\n      (toggled)=\"overflowToggled.emit($event)\"\n    >\n      <ng-container *ngTemplateOutlet=\"multiSelectSubItems\"></ng-container>\n    </sie-ui-overflow>\n  </div>\n</ng-template>\n\n<ng-template #multiSelectSubItems>\n  <div class=\"multi-tree__item\" *ngIf=\"showSelectAllNode && activeNode\">\n    <sie-ui-checkbox\n      [id]=\"activeNode.id\"\n      [label]=\"selectAllLabel\"\n      [icons]=\"activeNode.icons\"\n      [value]=\"activeNode.selected\"\n      [indeterminate]=\"isIndeterminate(activeNode)\"\n      (valueChange)=\"handleMultiSelectChange(activeNode, $event)\"\n      class=\"multi-tree__checkbox\"\n      #selectAllCheckbox\n    ></sie-ui-checkbox>\n  </div>\n\n  <div *ngFor=\"let node of activeNode?.children\" class=\"multi-tree__item\">\n    <sie-ui-checkbox\n      [id]=\"node.id\"\n      [label]=\"node.label\"\n      [icons]=\"node.icons\"\n      [value]=\"node.selected\"\n      [indeterminate]=\"isIndeterminate(node)\"\n      [hint]=\"node.inputHint\"\n      (valueChange)=\"handleMultiSelectChange(node, $event)\"\n      #multiSelectCheckboxes\n      class=\"multi-tree__checkbox\"\n    ></sie-ui-checkbox>\n    <button *ngIf=\"node.children?.length > 0\" (click)=\"openNode(node)\" class=\"multi-tree__button\">\n      <sie-icon class=\"multi-tree__button-icon\" [name]=\"iconReg.sieIcon.ArrowRight\"></sie-icon>\n    </button>\n  </div>\n</ng-template>\n", styles: [".single-tree .radio-button-group{display:block;margin-bottom:11px}.single-tree .radio-button-group.non-expandable:last-child:not(:only-child){margin-bottom:0}.single-tree__active-level.indent{padding-left:29px}.single-tree__active-level .sub-item:last-child{margin-bottom:0}.multi-tree{padding-top:1rem}.multi-tree__item{display:flex;justify-content:space-between;align-items:baseline;margin-bottom:12px;padding-right:34px;position:relative}.multi-tree__button{padding:0;position:absolute;right:-10px;top:0;border:0;background:none;width:32px;height:32px;flex-shrink:0;display:flex;justify-content:center;align-items:center}.multi-tree__button:focus-visible{outline:0}.multi-tree__button:focus-visible:before{content:\"\";position:absolute;inset:-3px;z-index:1;border:1px solid #1491eb;border-radius:0}.multi-tree__button:active:not(:disabled):not(.hover-disabled),.multi-tree__button:hover:not(:disabled):not(.hover-disabled){cursor:pointer}.multi-tree__button:active:not(:disabled):not(.hover-disabled) .multi-tree__button-icon,.multi-tree__button:hover:not(:disabled):not(.hover-disabled) .multi-tree__button-icon{color:#33747a}.multi-tree__button-icon{width:24px;height:24px;display:flex;align-items:center;fill:currentColor;color:#4c4c68}.multi-tree__button-icon svg{fill:currentColor;width:inherit;height:inherit}.multi-tree__button-icon svg g{fill:currentColor;width:inherit;height:inherit}.multi-tree__button-icon svg text{font-family:Siemens Sans,sans-serif}.multi-tree__checkbox{display:block}.multi-tree__title{margin-bottom:1rem;margin-top:.5rem}.multi-tree__breadcrumb-item{margin-left:-7px}hr{border:none;height:1px;margin-bottom:15px;margin-top:3px;background:#ccccd4}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }, { type: i0.ChangeDetectorRef }]; }, propDecorators: { overflowComponent: [{
                type: ViewChild,
                args: [UiOverflowComponent]
            }], selectAllCheckbox: [{
                type: ViewChild,
                args: ['selectAllCheckbox']
            }], multiSelectCheckboxes: [{
                type: ViewChildren,
                args: ['multiSelectCheckboxes']
            }], overflowHeadlineCollapsed: [{
                type: Input
            }], overflowHeadlineExpanded: [{
                type: Input
            }], overflowLimit: [{
                type: Input
            }], backToLabel: [{
                type: Input
            }], selectAllLabel: [{
                type: Input
            }], multiSelect: [{
                type: Input
            }], selectedNodes: [{
                type: Input
            }], nodes: [{
                type: Input
            }], breadCrumbSelection: [{
                type: Input
            }], showSelectAllNode: [{
                type: Input
            }], expandOverflowInitially: [{
                type: Input
            }], selectedNodesChanged: [{
                type: Output
            }], newNodeSelected: [{
                type: Output
            }], overflowToggled: [{
                type: Output
            }] } });

/**
 * # Radio Button Module
 * - {@link UiRadioButtonComponent}
 *
 * ## Module peer dependencies
 * - {@link SieIconsModule}
 * - `@angular/forms/FormsModule`: Enables data binding for Angular forms
 */
class UiRadioButtonModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiRadioButtonModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiRadioButtonModule, declarations: [UiRadioButtonComponent], imports: [CommonModule, FormsModule, UiReadonlyModule, SieIconsModule], exports: [UiRadioButtonComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiRadioButtonModule, imports: [CommonModule, FormsModule, UiReadonlyModule, SieIconsModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiRadioButtonModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiRadioButtonComponent],
                    imports: [CommonModule, FormsModule, UiReadonlyModule, SieIconsModule],
                    exports: [UiRadioButtonComponent]
                }]
        }] });

/**
 * # Radio Button Group Module
 * - {@link UiRadioButtonGroupComponent}
 *
 * ## Module peer dependencies
 * - {@link SieIconsModule}
 * - `@angular/forms/FormsModule`: Enables data binding for Angular forms
 */
class UiRadioButtonGroupModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiRadioButtonGroupModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiRadioButtonGroupModule, declarations: [UiRadioButtonGroupComponent], imports: [CommonModule, FormsModule, UiReadonlyModule, SieIconsModule, UiRadioButtonModule], exports: [UiRadioButtonGroupComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiRadioButtonGroupModule, imports: [CommonModule, FormsModule, UiReadonlyModule, SieIconsModule, UiRadioButtonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiRadioButtonGroupModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiRadioButtonGroupComponent],
                    imports: [CommonModule, FormsModule, UiReadonlyModule, SieIconsModule, UiRadioButtonModule],
                    exports: [UiRadioButtonGroupComponent]
                }]
        }] });

/**
 * # Tree List Module
 * - {@link UiTreeListComponent}
 *
 * ## Module peer dependencies
 * - {@link SieIconsModule}
 * - `@angular/platform-browser/animations/BrowserAnimationsModule`: This module is needed to run the animations
 */
class UiTreeListModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTreeListModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiTreeListModule, declarations: [UiTreeListComponent, UiTreeListBreadcrumbsComponent], imports: [CommonModule,
            SieIconsModule,
            UiRadioButtonGroupModule,
            UiOverflowModule,
            UiCheckboxModule,
            UiButtonModule,
            UiLinkModule], exports: [UiTreeListComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTreeListModule, imports: [CommonModule,
            SieIconsModule,
            UiRadioButtonGroupModule,
            UiOverflowModule,
            UiCheckboxModule,
            UiButtonModule,
            UiLinkModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTreeListModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiTreeListComponent, UiTreeListBreadcrumbsComponent],
                    imports: [
                        CommonModule,
                        SieIconsModule,
                        UiRadioButtonGroupModule,
                        UiOverflowModule,
                        UiCheckboxModule,
                        UiButtonModule,
                        UiLinkModule
                    ],
                    exports: [UiTreeListComponent]
                }]
        }] });

class UiListItemDirective {
    /**
     * @param itemData data of the list item
     */
    set itemData(itemData) {
        this._itemData = itemData;
    }
    get itemData() {
        return this._itemData;
    }
    constructor(cdr, viewContainerRef) {
        this.cdr = cdr;
        this.viewContainerRef = viewContainerRef;
        /**
         * Defines list item type {@link UIListItemType}
         * @default 'file'
         */
        this.itemType = 'file';
        /**
         * Defines appearance of list item {@link UIListItemAppearance}
         * @default 'simple'
         */
        this.itemAppearance = 'simple';
        /**
         * Manages styling with less padding and margin
         * @default false
         */
        this.condensed = false;
        /**
         * Defines if hover should be tracked and hover styles applied on the list items
         * @default false
         */
        this.trackHover = false;
        /**
         * Displays loading state of list items if set to true
         * @default false
         */
        this.loading = false;
        /** @ignore */
        this.loadingChildren = false;
        /**
         * Defines if bulk mode is active if true
         * @default false
         */
        this.bulkMode = false;
        /**
         * Allows item to be dissmissed when set to true
         * @default false
         */
        this.dismissable = false;
        /**
         * Text for show more button of list item
         * @default ''
         */
        this.expandableButtonMore = '';
        /**
         * Text for show less button of list item
         * @default ''
         */
        this.expandableButtonLess = '';
        /** @ignore */
        this.showCatalogConfigureProducts = true;
        /**
         * Defines if status indicator is displayed
         * @default true
         */
        this.showStatusIndicator = true;
        /**
         * Triggered when component is in bulk mode and a new item was selected {@link UiAdvancedListItemSelectionChangeData}
         */
        this.selectionChanged = new Subject();
        /**
         * Triggered when list element is selected and passes {@link UiItemActions} and selected item
         */
        this.itemEvent = new Subject();
        this.dismissAnimationState$ = new BehaviorSubject('');
    }
    /** @ignore */
    ngAfterViewInit() {
        if (this.isSelected$) {
            this.isSelectedSubscription = this.isSelected$.subscribe(value => {
                if (this.itemData) {
                    this.itemData.isSelected = value.some(id => id === this.itemData.id);
                    this.cdr.detectChanges();
                    this.selectionChanged.next({ id: this.itemData.id, isSelected: this.itemData.isSelected });
                }
            });
        }
    }
    /** @ignore */
    ngOnChanges(_changes) {
        this.cdr.detectChanges();
    }
    /** @ignore */
    ngOnDestroy() {
        this.isSelectedSubscription?.unsubscribe();
    }
    /** @ignore */
    headerContentAvailable() {
        return false;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiListItemDirective, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ViewContainerRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: UiListItemDirective, selector: "[sieUiAdvancedListItem]", inputs: { itemData: "itemData", itemType: "itemType", itemAppearance: "itemAppearance", condensed: "condensed", trackHover: "trackHover", loading: "loading", loadingChildren: "loadingChildren", bulkMode: "bulkMode", dismissable: "dismissable", isSelected$: "isSelected$", expandableButtonMore: "expandableButtonMore", expandableButtonLess: "expandableButtonLess", index: "index", dataAttributes: "dataAttributes", showCatalogConfigureProducts: "showCatalogConfigureProducts", connectedComponent: "connectedComponent", showStatusIndicator: "showStatusIndicator" }, outputs: { selectionChanged: "selectionChanged", itemEvent: "itemEvent" }, host: { properties: { "class.bulk-mode": "this.bulkMode" } }, usesOnChanges: true, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiListItemDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[sieUiAdvancedListItem]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ViewContainerRef }]; }, propDecorators: { itemData: [{
                type: Input
            }], itemType: [{
                type: Input
            }], itemAppearance: [{
                type: Input
            }], condensed: [{
                type: Input
            }], trackHover: [{
                type: Input
            }], loading: [{
                type: Input
            }], loadingChildren: [{
                type: Input
            }], bulkMode: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['class.bulk-mode']
            }], dismissable: [{
                type: Input
            }], isSelected$: [{
                type: Input
            }], expandableButtonMore: [{
                type: Input
            }], expandableButtonLess: [{
                type: Input
            }], index: [{
                type: Input
            }], dataAttributes: [{
                type: Input
            }], showCatalogConfigureProducts: [{
                type: Input
            }], connectedComponent: [{
                type: Input
            }], showStatusIndicator: [{
                type: Input
            }], selectionChanged: [{
                type: Output
            }], itemEvent: [{
                type: Output
            }] } });

const fadeOutAnimationTiming = '200ms ' + EasingExitProductive;
const fadeInAnimationTiming = '200ms ' + EasingEntranceProductive;
const fadeInFadeOutAnimation = trigger('fadeInFadeOut', [
    state('fadeIn', style({ opacity: 1 })),
    state('halfFadeOut', style({ opacity: 0.3, pointerEvents: 'none' })),
    state('fadeOut', style({ opacity: 0, pointerEvents: 'none' })),
    transition('* => halfFadeOut', sequence([
        animate(fadeOutAnimationTiming, style({
            opacity: 0.3
        }))
    ])),
    transition('* => fadeOut', sequence([
        animate(fadeOutAnimationTiming, style({
            opacity: 0
        }))
    ])),
    transition('* => fadeIn', sequence([
        animate(fadeInAnimationTiming, style({
            opacity: 1
        }))
    ]))
]);

class UiSkeletonComponent {
    constructor() {
        this.shape = 'line';
        this.loadingText = 'Loading...';
        this.ariaLabel = 'loading';
        this.count = 1;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiSkeletonComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiSkeletonComponent, selector: "sie-ui-skeleton", inputs: { shape: "shape", loadingText: "loadingText", ariaLabel: "ariaLabel", count: "count" }, ngImport: i0, template: "<span\n  *sieCoreRepeat=\"count\"\n  class=\"loader progress\"\n  [ngClass]=\"{\n    circle: shape === 'circle'\n  }\"\n  [attr.aria-label]=\"ariaLabel\"\n  [attr.aria-valuetext]=\"loadingText\"\n  aria-busy=\"true\"\n  aria-valuemin=\"0\"\n  aria-valuemax=\"100\"\n  role=\"progressbar\"\n  tabindex=\"0\"\n></span>\n", styles: [":host{display:block}.loader{display:var(--ui-skeleton-display, inline-block);box-sizing:border-box;overflow:hidden;position:relative;background:rgba(179,179,190,.4);width:var(--ui-skeleton-width, 100%);height:var(--ui-skeleton-height, 100%);will-change:transform;margin-right:var(--ui-skeleton-marginRight, 0);margin-bottom:var(--ui-skeleton-marginBottom, 0);margin-top:var(--ui-skeleton-marginTop, 0);border-radius:var(--ui-skeleton-borderRadius, 0);transform:translateZ(0)}.loader:after,.loader:before{box-sizing:border-box}.loader.circle{margin:var(--ui-skeleton-circleMarginTop, 5px) var(--ui-skeleton-circleMarginRight, 5px) var(--ui-skeleton-circleMarginBottom, 5px) var(--ui-skeleton-circleMarginLeft, 5px);border-radius:50%;width:var(--ui-skeleton-circleWidth, 100%);height:var(--ui-skeleton-circleHeight, 100%)}.loader:before{animation:progress 2s ease-in-out infinite;background-size:200px 100%;background-image:linear-gradient(90deg,rgba(255,255,255,0),rgba(255,255,255,.6),rgba(255,255,255,0));position:absolute;z-index:1;top:0;left:0;width:200px;height:100%;content:\"\";animation-delay:var(--ui-skeleton-animationOffset, 0s)}@keyframes progress{0%{transform:translate3d(-200px,0,0)}to{transform:translate3d(calc(200px + 100vw),0,0)}}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1$1.RepeatDirective, selector: "[sieCoreRepeat]", inputs: ["sieCoreRepeat"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiSkeletonComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-skeleton', changeDetection: ChangeDetectionStrategy.OnPush, template: "<span\n  *sieCoreRepeat=\"count\"\n  class=\"loader progress\"\n  [ngClass]=\"{\n    circle: shape === 'circle'\n  }\"\n  [attr.aria-label]=\"ariaLabel\"\n  [attr.aria-valuetext]=\"loadingText\"\n  aria-busy=\"true\"\n  aria-valuemin=\"0\"\n  aria-valuemax=\"100\"\n  role=\"progressbar\"\n  tabindex=\"0\"\n></span>\n", styles: [":host{display:block}.loader{display:var(--ui-skeleton-display, inline-block);box-sizing:border-box;overflow:hidden;position:relative;background:rgba(179,179,190,.4);width:var(--ui-skeleton-width, 100%);height:var(--ui-skeleton-height, 100%);will-change:transform;margin-right:var(--ui-skeleton-marginRight, 0);margin-bottom:var(--ui-skeleton-marginBottom, 0);margin-top:var(--ui-skeleton-marginTop, 0);border-radius:var(--ui-skeleton-borderRadius, 0);transform:translateZ(0)}.loader:after,.loader:before{box-sizing:border-box}.loader.circle{margin:var(--ui-skeleton-circleMarginTop, 5px) var(--ui-skeleton-circleMarginRight, 5px) var(--ui-skeleton-circleMarginBottom, 5px) var(--ui-skeleton-circleMarginLeft, 5px);border-radius:50%;width:var(--ui-skeleton-circleWidth, 100%);height:var(--ui-skeleton-circleHeight, 100%)}.loader:before{animation:progress 2s ease-in-out infinite;background-size:200px 100%;background-image:linear-gradient(90deg,rgba(255,255,255,0),rgba(255,255,255,.6),rgba(255,255,255,0));position:absolute;z-index:1;top:0;left:0;width:200px;height:100%;content:\"\";animation-delay:var(--ui-skeleton-animationOffset, 0s)}@keyframes progress{0%{transform:translate3d(-200px,0,0)}to{transform:translate3d(calc(200px + 100vw),0,0)}}\n"] }]
        }], propDecorators: { shape: [{
                type: Input
            }], loadingText: [{
                type: Input
            }], ariaLabel: [{
                type: Input
            }], count: [{
                type: Input
            }] } });

class UiListItemSkeletonComponent {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiListItemSkeletonComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiListItemSkeletonComponent, selector: "sie-ui-list-item-skeleton", ngImport: i0, template: "<div class=\"bulk-skeleton\">\n  <sie-ui-skeleton class=\"bulk-skeleton__loader\"\n  ></sie-ui-skeleton>\n</div>\n", styles: [".bulk-skeleton{position:relative;top:1px;height:20px;width:20px}.bulk-skeleton__loader{display:inline}\n"], dependencies: [{ kind: "component", type: UiSkeletonComponent, selector: "sie-ui-skeleton", inputs: ["shape", "loadingText", "ariaLabel", "count"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiListItemSkeletonComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-list-item-skeleton', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"bulk-skeleton\">\n  <sie-ui-skeleton class=\"bulk-skeleton__loader\"\n  ></sie-ui-skeleton>\n</div>\n", styles: [".bulk-skeleton{position:relative;top:1px;height:20px;width:20px}.bulk-skeleton__loader{display:inline}\n"] }]
        }] });

class UiListItemComponent extends UiListItemDirective {
    /** @ignore */
    static { this.nextUniqueCheckboxId = 0; }
    /** @ignore */
    get hoverClass() {
        return this.trackHover && this.isHovering && !this.loading;
    }
    /** @ignore */
    get classes() {
        return `type-${this.itemType} appearance-${this.itemAppearance}
    status-${this.setStatusState() ? this.itemData?.status : 'none'}
    readstatus-${this.setStatusState() ? this.itemData?.readStatus : 'none'}
    ${this.bulkMode ? 'selectable' : ''} ${this.condensed ? 'condensed' : ''}
    `;
    }
    /** @ignore */
    onMouseEnter() {
        this.isHovering = !this.layoutService.isTouchDevice;
    }
    /** @ignore */
    onMouseLeave() {
        this.isHovering = false;
    }
    constructor(iconReg, cdr, layoutService) {
        super(cdr);
        this.iconReg = iconReg;
        this.cdr = cdr;
        this.layoutService = layoutService;
        this.isHovering = false;
        /** @ignore */
        this.uniqueCheckboxId = UiListItemComponent.nextUniqueCheckboxId++;
        iconReg.register(iconReg.sieIcon.CloseSmall);
    }
    /** @ignore */
    itemSelectionChanged(selectionState) {
        if (this.itemData) {
            this.itemData.isSelected = selectionState;
            this.selectionChanged.next({
                id: this.itemData.id,
                isSelected: this.itemData.isSelected
            });
        }
    }
    /** @ignore */
    ngOnChanges(changes) {
        if (!!changes['itemData']) {
            this.dismissAnimationState$.next(''); // restore initial visibility as item wrapper will be re-utilized
        }
        this.updateView();
    }
    /** @ignore */
    updateView() {
        this.cdr.detectChanges();
    }
    /** @ignore */
    setSelectedState() {
        return !this.loading && this.isSelectedOrHoverInBulkMode();
    }
    isSelectedOrHoverInBulkMode() {
        const className = this.itemData?.itemComponent?.name;
        const isSelected = className !== 'UiSeparatorListItemComponent' &&
            className !== 'UiIconListItemComponent' &&
            this.itemData?.isSelected;
        return this.bulkMode && (isSelected || this.isHovering);
    }
    /** @ignore */
    setStatusBar() {
        return !this.loading && !this.isSelectedOrHoverInBulkMode();
    }
    setStatusState() {
        return !this.loading && !this.bulkMode;
    }
    onFadeInFadeOutAnimationDone(event) {
        if (event.toState === 'halfFadeOut') {
            this.trackHover = false;
            this.itemEvent.next({
                action: 'DISMISS_ONE_ITEM',
                item: this.itemData,
                fadeOutOptions: {
                    success: () => {
                        this.dismissAnimationState$.next('fadeOut');
                    },
                    failure: () => {
                        this.dismissAnimationState$.next('fadeIn');
                    }
                }
            });
        }
        else if (event.toState === 'fadeOut' || event.toState === 'fadeIn') {
            this.trackHover = true;
            this.itemEvent.next({ action: 'REFRESH', item: this.itemData });
        }
    }
    onDeleteButtonClick() {
        // play animation
        this.dismissAnimationState$.next('halfFadeOut');
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiListItemComponent, deps: [{ token: i1.SieIconRegistryService }, { token: i0.ChangeDetectorRef }, { token: i1$1.LayoutService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiListItemComponent, selector: "sie-ui-list-item", host: { listeners: { "mouseenter": "onMouseEnter()", "mouseleave": "onMouseLeave()" }, properties: { "class.hover": "this.hoverClass", "class": "this.classes" } }, usesInheritance: true, usesOnChanges: true, ngImport: i0, template: "<div\n  class=\"list-item\"\n  [ngClass]=\"{ 'header-content': connectedComponent?.headerContentAvailable() }\"\n  [sieCoreAttributes]=\"itemData?.dataAttributes\"\n  [@fadeInFadeOut]=\"dismissAnimationState$ | async\"\n  (@fadeInFadeOut.done)=\"onFadeInFadeOutAnimationDone($event)\"\n>\n  <div\n    class=\"list-item__status-indicator\"\n    *ngIf=\"showStatusIndicator\"\n    [ngClass]=\"[\n      setSelectedState() ? 'status-selected' : '',\n      setStatusBar() ? 'status-bar status-bar--' + itemData?.status : ''\n    ]\"\n  ></div>\n  <div class=\"list-item__selection-toggle\" *ngIf=\"bulkMode\">\n    <sie-ui-checkbox\n      [name]=\"'bulk_checkbox_' + uniqueCheckboxId\"\n      *ngIf=\"!loading; else bulkSkeleton\"\n      [value]=\"itemData?.isSelected\"\n      (valueChange)=\"itemSelectionChanged($event)\"\n    ></sie-ui-checkbox>\n  </div>\n  <div class=\"list-item__content\">\n    <ng-content></ng-content>\n  </div>\n  <div class=\"list-item__actions\"></div>\n  <div class=\"list-item__close\" *ngIf=\"dismissable && !loading\">\n    <sie-ui-button\n      themeType=\"icon\"\n      variant=\"icon-un-contained\"\n      class=\"list-item__close-btn\"\n      [icon]=\"iconReg.sieIcon.CloseSmall\"\n      (clicked)=\"onDeleteButtonClick()\"\n    ></sie-ui-button>\n  </div>\n</div>\n\n<ng-template #bulkSkeleton>\n  <sie-ui-list-item-skeleton></sie-ui-list-item-skeleton>\n</ng-template>\n", styles: [".list-item{display:flex}@media print{.list-item{display:block}}.list-item__selection-toggle{position:absolute;left:16px}@media print{.list-item__selection-toggle{display:none}}.list-item.header-content{padding-top:16px}.list-item.header-content .list-item__selection-toggle{top:40px}.list-item__close-btn{position:absolute;right:-4px;top:8px;display:flex;--icon-size-custom: 20px;--btn-width-custom: 20px;--btn-height-custom: 20px}.list-item__status-indicator{position:absolute;top:0;bottom:0;left:0;width:4px;display:var(--list-item-status-indicator-display, block)}:host.readstatus-new .list-item__status-indicator{background-color:#0087be}:host.status-internal .list-item__status-indicator{background-color:#d2007c}:host.status-external .list-item__status-indicator{background-color:#0b909e}:host.status-critical .list-item__status-indicator{background-color:#ef0137}:host.status-warning .list-item__status-indicator{background-color:#ff9000}:host.status-success .list-item__status-indicator{background-color:#00af52}:host.status-info .list-item__status-indicator{background-color:#0087be}.list-item__status-indicator.status-selected{background-color:#33747a}.list-item__content{width:100%}:host{display:block;position:relative}:host.type-file.appearance-simple{padding:16px 0 24px}:host.type-file.appearance-simple.condensed{padding:8px 0}@media screen{:host.type-file.appearance-simple.selectable.bulk-mode{padding-left:42px}}:host.type-file.appearance-complex{padding:16px 0}@media print{:host.type-file.appearance-complex{break-inside:avoid}}:host.type-folder{background-color:#f3f3f0}:host.type-undefined.appearance-complex.hover,:host.type-file.appearance-simple.hover{background-color:#f3f3f0bf}:host:not(.bulk-mode) .list-item__content{padding-left:4px}:host:not(.bulk-mode).status-undefined .list-item__content,:host:not(.bulk-mode).status-none .list-item__content{margin:0}:host.selectable.bulk-mode.type-folder .list-item__content{padding-left:32px}:host.readstatus-new{background-color:#e0f1f433}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: UiButtonComponent, selector: "sie-ui-button" }, { kind: "component", type: UiCheckboxComponent, selector: "sie-ui-checkbox", inputs: ["id", "checkboxIdToFocus", "indeterminate", "value", "active", "required", "icons", "labelAppendix$"], outputs: ["valueChange"] }, { kind: "directive", type: i1$1.AttributeDirective, selector: "[sieCoreAttributes]", inputs: ["sieCoreAttributes"] }, { kind: "component", type: UiListItemSkeletonComponent, selector: "sie-ui-list-item-skeleton" }, { kind: "pipe", type: i2.AsyncPipe, name: "async" }], animations: [fadeInFadeOutAnimation], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiListItemComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-list-item', animations: [fadeInFadeOutAnimation], changeDetection: ChangeDetectionStrategy.OnPush, template: "<div\n  class=\"list-item\"\n  [ngClass]=\"{ 'header-content': connectedComponent?.headerContentAvailable() }\"\n  [sieCoreAttributes]=\"itemData?.dataAttributes\"\n  [@fadeInFadeOut]=\"dismissAnimationState$ | async\"\n  (@fadeInFadeOut.done)=\"onFadeInFadeOutAnimationDone($event)\"\n>\n  <div\n    class=\"list-item__status-indicator\"\n    *ngIf=\"showStatusIndicator\"\n    [ngClass]=\"[\n      setSelectedState() ? 'status-selected' : '',\n      setStatusBar() ? 'status-bar status-bar--' + itemData?.status : ''\n    ]\"\n  ></div>\n  <div class=\"list-item__selection-toggle\" *ngIf=\"bulkMode\">\n    <sie-ui-checkbox\n      [name]=\"'bulk_checkbox_' + uniqueCheckboxId\"\n      *ngIf=\"!loading; else bulkSkeleton\"\n      [value]=\"itemData?.isSelected\"\n      (valueChange)=\"itemSelectionChanged($event)\"\n    ></sie-ui-checkbox>\n  </div>\n  <div class=\"list-item__content\">\n    <ng-content></ng-content>\n  </div>\n  <div class=\"list-item__actions\"></div>\n  <div class=\"list-item__close\" *ngIf=\"dismissable && !loading\">\n    <sie-ui-button\n      themeType=\"icon\"\n      variant=\"icon-un-contained\"\n      class=\"list-item__close-btn\"\n      [icon]=\"iconReg.sieIcon.CloseSmall\"\n      (clicked)=\"onDeleteButtonClick()\"\n    ></sie-ui-button>\n  </div>\n</div>\n\n<ng-template #bulkSkeleton>\n  <sie-ui-list-item-skeleton></sie-ui-list-item-skeleton>\n</ng-template>\n", styles: [".list-item{display:flex}@media print{.list-item{display:block}}.list-item__selection-toggle{position:absolute;left:16px}@media print{.list-item__selection-toggle{display:none}}.list-item.header-content{padding-top:16px}.list-item.header-content .list-item__selection-toggle{top:40px}.list-item__close-btn{position:absolute;right:-4px;top:8px;display:flex;--icon-size-custom: 20px;--btn-width-custom: 20px;--btn-height-custom: 20px}.list-item__status-indicator{position:absolute;top:0;bottom:0;left:0;width:4px;display:var(--list-item-status-indicator-display, block)}:host.readstatus-new .list-item__status-indicator{background-color:#0087be}:host.status-internal .list-item__status-indicator{background-color:#d2007c}:host.status-external .list-item__status-indicator{background-color:#0b909e}:host.status-critical .list-item__status-indicator{background-color:#ef0137}:host.status-warning .list-item__status-indicator{background-color:#ff9000}:host.status-success .list-item__status-indicator{background-color:#00af52}:host.status-info .list-item__status-indicator{background-color:#0087be}.list-item__status-indicator.status-selected{background-color:#33747a}.list-item__content{width:100%}:host{display:block;position:relative}:host.type-file.appearance-simple{padding:16px 0 24px}:host.type-file.appearance-simple.condensed{padding:8px 0}@media screen{:host.type-file.appearance-simple.selectable.bulk-mode{padding-left:42px}}:host.type-file.appearance-complex{padding:16px 0}@media print{:host.type-file.appearance-complex{break-inside:avoid}}:host.type-folder{background-color:#f3f3f0}:host.type-undefined.appearance-complex.hover,:host.type-file.appearance-simple.hover{background-color:#f3f3f0bf}:host:not(.bulk-mode) .list-item__content{padding-left:4px}:host:not(.bulk-mode).status-undefined .list-item__content,:host:not(.bulk-mode).status-none .list-item__content{margin:0}:host.selectable.bulk-mode.type-folder .list-item__content{padding-left:32px}:host.readstatus-new{background-color:#e0f1f433}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }, { type: i0.ChangeDetectorRef }, { type: i1$1.LayoutService }]; }, propDecorators: { hoverClass: [{
                type: HostBinding,
                args: ['class.hover']
            }], classes: [{
                type: HostBinding,
                args: ['class']
            }], onMouseEnter: [{
                type: HostListener,
                args: ['mouseenter']
            }], onMouseLeave: [{
                type: HostListener,
                args: ['mouseleave']
            }] } });

class UiDynamicListItemComponent {
    get component() {
        return this._component;
    }
    set component(component) {
        this._component = component;
        this.createComponent();
    }
    get classes() {
        return `type-${this.itemType} appearance-${this.itemAppearance} status-${this.itemData?.status} ${this.itemData?.isSelected ? 'status-selected' : ''} ${this.bulkMode ? 'selectable' : ''}`;
    }
    get concreteComponent() {
        return this._componentRef?.instance;
    }
    constructor(cdr) {
        this.cdr = cdr;
        this.condensed = false;
        this.bulkMode = false;
        this.dismissable = false;
        this.expandableButtonMore = '';
        this.expandableButtonLess = '';
        this.trackHover = false;
        this.showCatalogConfigureProducts = true;
        this.showStatusIndicator = true;
        this.selectionChanged = new Subject();
        this.itemEvent = new Subject();
    }
    ngOnChanges(changes) {
        for (const input in changes) {
            if (changes.hasOwnProperty(input)) {
                this._componentRef.instance[input] = changes[input].currentValue;
            }
        }
        if (changes.hasOwnProperty('component')) {
            this.setListWideDefaultsToInstance();
        }
        this._componentRef.instance.ngOnChanges();
    }
    ngOnDestroy() {
        this._componentRef.instance.selectionChanged?.unsubscribe();
        this._componentRef.instance.itemEvent?.unsubscribe();
    }
    updateView() {
        this.listItemComponent.updateView();
        this.cdr.detectChanges();
    }
    createComponent() {
        if (!this._component) {
            return;
        }
        const viewContainerRef = this.itemHost.viewContainerRef;
        viewContainerRef.clear();
        this._componentRef = viewContainerRef.createComponent(this._component);
        this._componentRef.instance.selectionChanged.subscribe((selectionChange) => {
            if (this.itemData) {
                this.itemData.isSelected = selectionChange.isSelected;
            }
            this.selectionChanged.next(selectionChange);
        });
        this._componentRef.instance.itemEvent.subscribe(itemEvent => {
            this.itemEvent.next(itemEvent);
        });
    }
    // This method updates list wide settings on instances that are not rebuilt.
    // For example on tab change -> first 5 that are kept for the skeleton.
    setListWideDefaultsToInstance() {
        this._componentRef.instance.itemType = this.itemType;
        this._componentRef.instance.itemAppearance = this.itemAppearance;
        this._componentRef.instance.bulkMode = this.bulkMode;
        this._componentRef.instance.expandableButtonMore = this.expandableButtonMore;
        this._componentRef.instance.expandableButtonLess = this.expandableButtonLess;
        this._componentRef.instance.trackHover = this.trackHover;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDynamicListItemComponent, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiDynamicListItemComponent, selector: "li[sie-ui-dynamic-list-item]", inputs: { component: "component", itemData: "itemData", loading: "loading", loadingChildren: "loadingChildren", loadingMore: "loadingMore", itemType: "itemType", itemAppearance: "itemAppearance", condensed: "condensed", bulkMode: "bulkMode", dismissable: "dismissable", isSelected$: "isSelected$", expandableButtonMore: "expandableButtonMore", expandableButtonLess: "expandableButtonLess", trackHover: "trackHover", index: "index", showCatalogConfigureProducts: "showCatalogConfigureProducts", showStatusIndicator: "showStatusIndicator" }, outputs: { selectionChanged: "selectionChanged", itemEvent: "itemEvent" }, host: { properties: { "class": "this.classes" } }, viewQueries: [{ propertyName: "itemHost", first: true, predicate: UiListItemDirective, descendants: true, static: true }, { propertyName: "listItemComponent", first: true, predicate: UiListItemComponent, descendants: true }], usesOnChanges: true, ngImport: i0, template: "<!-- sie-ui-list-item is the base item displays only the borders and the bulkmode checkbox -->\n<sie-ui-list-item\n  [itemType]=\"itemType\"\n  [itemAppearance]=\"itemAppearance\"\n  [condensed]=\"condensed\"\n  [itemData]=\"itemData\"\n  [bulkMode]=\"!component?.isStaticComponent && bulkMode\"\n  [dismissable]=\"dismissable\"\n  [loading]=\"loading\"\n  [loadingChildren]=\"loadingChildren\"\n  [isSelected$]=\"isSelected$\"\n  [trackHover]=\"!component?.isStaticComponent && trackHover\"\n  (selectionChanged)=\"selectionChanged.next($event)\"\n  (itemEvent)=\"itemEvent.next($event)\"\n  [connectedComponent]=\"concreteComponent\"\n  [showStatusIndicator]=\"!component?.isStaticComponent && showStatusIndicator\"\n>\n  <ng-template sieUiAdvancedListItem></ng-template>\n</sie-ui-list-item>\n", dependencies: [{ kind: "component", type: UiListItemComponent, selector: "sie-ui-list-item" }, { kind: "directive", type: UiListItemDirective, selector: "[sieUiAdvancedListItem]", inputs: ["itemData", "itemType", "itemAppearance", "condensed", "trackHover", "loading", "loadingChildren", "bulkMode", "dismissable", "isSelected$", "expandableButtonMore", "expandableButtonLess", "index", "dataAttributes", "showCatalogConfigureProducts", "connectedComponent", "showStatusIndicator"], outputs: ["selectionChanged", "itemEvent"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDynamicListItemComponent, decorators: [{
            type: Component,
            args: [{ selector: 'li[sie-ui-dynamic-list-item]', changeDetection: ChangeDetectionStrategy.OnPush, template: "<!-- sie-ui-list-item is the base item displays only the borders and the bulkmode checkbox -->\n<sie-ui-list-item\n  [itemType]=\"itemType\"\n  [itemAppearance]=\"itemAppearance\"\n  [condensed]=\"condensed\"\n  [itemData]=\"itemData\"\n  [bulkMode]=\"!component?.isStaticComponent && bulkMode\"\n  [dismissable]=\"dismissable\"\n  [loading]=\"loading\"\n  [loadingChildren]=\"loadingChildren\"\n  [isSelected$]=\"isSelected$\"\n  [trackHover]=\"!component?.isStaticComponent && trackHover\"\n  (selectionChanged)=\"selectionChanged.next($event)\"\n  (itemEvent)=\"itemEvent.next($event)\"\n  [connectedComponent]=\"concreteComponent\"\n  [showStatusIndicator]=\"!component?.isStaticComponent && showStatusIndicator\"\n>\n  <ng-template sieUiAdvancedListItem></ng-template>\n</sie-ui-list-item>\n" }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }]; }, propDecorators: { itemHost: [{
                type: ViewChild,
                args: [UiListItemDirective, { static: true }]
            }], component: [{
                type: Input
            }], itemData: [{
                type: Input
            }], loading: [{
                type: Input
            }], loadingChildren: [{
                type: Input
            }], loadingMore: [{
                type: Input
            }], itemType: [{
                type: Input
            }], itemAppearance: [{
                type: Input
            }], condensed: [{
                type: Input
            }], bulkMode: [{
                type: Input
            }], dismissable: [{
                type: Input
            }], isSelected$: [{
                type: Input
            }], expandableButtonMore: [{
                type: Input
            }], expandableButtonLess: [{
                type: Input
            }], trackHover: [{
                type: Input
            }], index: [{
                type: Input
            }], showCatalogConfigureProducts: [{
                type: Input
            }], showStatusIndicator: [{
                type: Input
            }], selectionChanged: [{
                type: Output
            }], itemEvent: [{
                type: Output
            }], listItemComponent: [{
                type: ViewChild,
                args: [UiListItemComponent]
            }], classes: [{
                type: HostBinding,
                args: ['class']
            }] } });

/**
 * # List Component
 *
 * The component is only used within the {@link UiListNavigatorComponent}.
 */
class UiListComponent {
    constructor(cdr) {
        this.cdr = cdr;
        /**
         * Defines default component type for list items
         */
        this.defaultItemComponents = [];
        /**
         * Defines data of each list item
         */
        this.itemData = [];
        /**
         * Defines if bulk mode is used
         * @default false
         */
        this.bulkMode = false;
        /**
         * Allows items to be dismissed when set to true
         * @default false
         */
        this.itemsDismissible = false;
        /**
         * Defines list item type {@link UIListItemType}
         * @default 'folder'
         */
        this.itemType = 'folder';
        /**
         * Defines appearance of list item {@link UIListItemAppearance}
         * @default 'simple'
         */
        this.itemAppearance = 'simple';
        /**
         * Manages styling with less padding and margin
         * @default false
         */
        this.condensed = false;
        /**
         * Displays loading state of list items if set to true
         * @default true
         */
        this.loading = true;
        /** @ignore */
        this.loadingChildren = false;
        /**
         * Defines if more list items are being loaded (used in infinite pagination style)
         * @default false
         */
        this.loadingMore = false;
        /**
         * Defines if hover should be tracked and hover styles applied on the list items
         * @default false
         */
        this.trackHover = false;
        /**
         * Defines if status indicator is displayed
         * @default true
         */
        this.showStatusIndicator = true;
        /**
         * Defines if only selected items will be displayed in print preview, does nothing when not in bulk-selection mode
         * @default false
         */
        this.hideNotSelectedItemsInPrintPreview = false;
        /**
         * Defines how many skeleton elements should be displayed
         * @default 5
         */
        this.numberOfSkeletons = 5;
        /**
         * Defines how many skeleton elements should be displayed in case of infinite pagination
         * @default 3
         */
        this.numberOfLoadMoreSkeletons = 3;
        /**
         * Text for show more button of list item
         * @default ''
         */
        this.expandableButtonMore = '';
        /**
         * Text for show less button of list item
         * @default ''
         */
        this.expandableButtonLess = '';
        /**
         * Defines what pagination type should be used if pagination is needed
         * @default 'default'
         */
        this.paginationType = 'default';
        /** @ignore */
        this.showCatalogConfigureProducts = true;
        /**
         * Triggered when user interaction is done, see {@link UiListItemEvent} for implementation details
         */
        this.itemEvent = new Subject();
        /**
         * Triggered when component is in bulk mode and a new item was selected {@link UiAdvancedListItemSelectionChangeData}
         */
        this.selectionChanged = new Subject();
    }
    /** @ignore */
    updateView() {
        this.dynamicListItemsComponents.forEach((listItem) => {
            listItem.updateView();
        });
        this.cdr.detectChanges();
    }
    /** @ignore */
    itemIntersected(isVisible) {
        if (isVisible) {
            this.itemEvent.next({ action: 'LOAD_MORE_LIST_ITEMS', item: null });
        }
    }
    trackById(_, item) {
        return item?.id;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiListComponent, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiListComponent, selector: "ul[sie-ui-list]", inputs: { defaultItemComponents: "defaultItemComponents", itemData: "itemData", bulkMode: "bulkMode", itemsDismissible: "itemsDismissible", isSelected$: "isSelected$", itemType: "itemType", itemAppearance: "itemAppearance", condensed: "condensed", itemLength: "itemLength", loading: "loading", loadingChildren: "loadingChildren", loadingMore: "loadingMore", trackHover: "trackHover", showStatusIndicator: "showStatusIndicator", hideNotSelectedItemsInPrintPreview: "hideNotSelectedItemsInPrintPreview", numberOfSkeletons: "numberOfSkeletons", numberOfLoadMoreSkeletons: "numberOfLoadMoreSkeletons", expandableButtonMore: "expandableButtonMore", expandableButtonLess: "expandableButtonLess", paginationType: "paginationType", showCatalogConfigureProducts: "showCatalogConfigureProducts" }, outputs: { itemEvent: "itemEvent", selectionChanged: "selectionChanged" }, viewQueries: [{ propertyName: "dynamicListItemsComponents", predicate: UiDynamicListItemComponent, descendants: true }], ngImport: i0, template: "<ng-container\n  *ngFor=\"\n    let item of [].constructor(loading && !loadingMore ? numberOfSkeletons : itemLength);\n    let index = index;\n    trackBy: trackById\n  \"\n>\n  <ng-container *ngIf=\"index === itemLength - 1\">\n    <li\n      sie-ui-dynamic-list-item\n      *ngIf=\"loading || itemData[index]\"\n      class=\"list__li\"\n      [ngStyle]=\"itemData[index]?.style\"\n      [ngClass]=\"{\n        hidden: itemData[index]?.hidden$ | async,\n        'hide-in-print-preview':\n          itemData[index]?.hideInPrintPreview ||\n          (bulkMode && hideNotSelectedItemsInPrintPreview && !itemData[index]?.isSelected)\n      }\"\n      [component]=\"itemData[index]?.itemComponent || defaultItemComponents[0]\"\n      [itemData]=\"itemData[index]\"\n      [itemType]=\"itemType\"\n      [itemAppearance]=\"itemAppearance\"\n      [condensed]=\"condensed\"\n      [loading]=\"loading\"\n      [loadingChildren]=\"loadingChildren\"\n      [loadingMore]=\"loadingMore\"\n      [bulkMode]=\"bulkMode\"\n      [dismissable]=\"itemsDismissible\"\n      [trackHover]=\"trackHover\"\n      (selectionChanged)=\"selectionChanged.next($event)\"\n      (itemEvent)=\"itemEvent.next($event)\"\n      [expandableButtonMore]=\"expandableButtonMore\"\n      [expandableButtonLess]=\"expandableButtonLess\"\n      [index]=\"index\"\n      [isSelected$]=\"isSelected$\"\n      [showCatalogConfigureProducts]=\"showCatalogConfigureProducts\"\n      [showStatusIndicator]=\"showStatusIndicator\"\n      (elementIsVisible)=\"itemIntersected($event)\"\n      sieCoreIntersectionObserver\n    ></li>\n  </ng-container>\n  <ng-container *ngIf=\"index !== itemLength - 1\">\n    <li\n      sie-ui-dynamic-list-item\n      *ngIf=\"loading || itemData[index]\"\n      class=\"list__li\"\n      [ngStyle]=\"itemData[index]?.style\"\n      [ngClass]=\"{\n        hidden: itemData[index]?.hidden$ | async,\n        'hide-in-print-preview':\n          itemData[index]?.hideInPrintPreview ||\n          (bulkMode && hideNotSelectedItemsInPrintPreview && !itemData[index]?.isSelected)\n      }\"\n      [component]=\"itemData[index]?.itemComponent || defaultItemComponents[0]\"\n      [itemData]=\"itemData[index]\"\n      [itemType]=\"itemType\"\n      [itemAppearance]=\"itemAppearance\"\n      [condensed]=\"condensed\"\n      [loading]=\"loading\"\n      [loadingChildren]=\"loadingChildren\"\n      [loadingMore]=\"loadingMore\"\n      [bulkMode]=\"bulkMode\"\n      [dismissable]=\"itemsDismissible\"\n      [trackHover]=\"trackHover\"\n      (selectionChanged)=\"selectionChanged.next($event)\"\n      (itemEvent)=\"itemEvent.next($event)\"\n      [expandableButtonMore]=\"expandableButtonMore\"\n      [expandableButtonLess]=\"expandableButtonLess\"\n      [index]=\"index\"\n      [isSelected$]=\"isSelected$\"\n      [showCatalogConfigureProducts]=\"showCatalogConfigureProducts\"\n      [showStatusIndicator]=\"showStatusIndicator\"\n    ></li>\n  </ng-container>\n</ng-container>\n\n<ng-container *ngIf=\"paginationType === 'infinite' && loadingMore\">\n  <ng-container *ngFor=\"let item of [].constructor(numberOfLoadMoreSkeletons); let index = index\">\n    <li\n      sie-ui-dynamic-list-item\n      class=\"list__li\"\n      [component]=\"defaultItemComponents[0]\"\n      [itemType]=\"itemType\"\n      [itemAppearance]=\"itemAppearance\"\n      [condensed]=\"condensed\"\n      [loading]=\"true\"\n      [bulkMode]=\"bulkMode\"\n      [dismissable]=\"itemsDismissible\"\n      [trackHover]=\"trackHover\"\n      [showStatusIndicator]=\"showStatusIndicator\"\n      [isSelected$]=\"isSelected$\"\n    ></li>\n  </ng-container>\n</ng-container>\n", styles: [":host{list-style:none;margin:0;padding:0}.list__li.hidden{display:none}@media print{.list__li.hide-in-print-preview{display:none}}.list__li.type-file{border-width:0;border-style:solid;border-color:#ccccd4}.list__li.type-file.appearance-simple{border-bottom-width:1px}@media print{.list__li.type-file.appearance-simple{border-bottom-width:1pt}}.list__li.type-file.appearance-simple:first-child{border-top-width:1px}@media print{.list__li.type-file.appearance-simple:first-child{border-top-width:1pt}}.list__li.type-file.appearance-complex{border-bottom-width:8px;border-color:#f3f3f0}.list__li.type-file.appearance-complex:first-child{border-top-width:8px}.list__li.type-folder{margin-bottom:12px}.list__li.type-folder:last-child{margin-bottom:0}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "directive", type: i1$1.IntersectionObserverDirective, selector: "[sieCoreIntersectionObserver]", outputs: ["elementIsVisible"] }, { kind: "component", type: UiDynamicListItemComponent, selector: "li[sie-ui-dynamic-list-item]", inputs: ["component", "itemData", "loading", "loadingChildren", "loadingMore", "itemType", "itemAppearance", "condensed", "bulkMode", "dismissable", "isSelected$", "expandableButtonMore", "expandableButtonLess", "trackHover", "index", "showCatalogConfigureProducts", "showStatusIndicator"], outputs: ["selectionChanged", "itemEvent"] }, { kind: "pipe", type: i2.AsyncPipe, name: "async" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiListComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ul[sie-ui-list]', changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-container\n  *ngFor=\"\n    let item of [].constructor(loading && !loadingMore ? numberOfSkeletons : itemLength);\n    let index = index;\n    trackBy: trackById\n  \"\n>\n  <ng-container *ngIf=\"index === itemLength - 1\">\n    <li\n      sie-ui-dynamic-list-item\n      *ngIf=\"loading || itemData[index]\"\n      class=\"list__li\"\n      [ngStyle]=\"itemData[index]?.style\"\n      [ngClass]=\"{\n        hidden: itemData[index]?.hidden$ | async,\n        'hide-in-print-preview':\n          itemData[index]?.hideInPrintPreview ||\n          (bulkMode && hideNotSelectedItemsInPrintPreview && !itemData[index]?.isSelected)\n      }\"\n      [component]=\"itemData[index]?.itemComponent || defaultItemComponents[0]\"\n      [itemData]=\"itemData[index]\"\n      [itemType]=\"itemType\"\n      [itemAppearance]=\"itemAppearance\"\n      [condensed]=\"condensed\"\n      [loading]=\"loading\"\n      [loadingChildren]=\"loadingChildren\"\n      [loadingMore]=\"loadingMore\"\n      [bulkMode]=\"bulkMode\"\n      [dismissable]=\"itemsDismissible\"\n      [trackHover]=\"trackHover\"\n      (selectionChanged)=\"selectionChanged.next($event)\"\n      (itemEvent)=\"itemEvent.next($event)\"\n      [expandableButtonMore]=\"expandableButtonMore\"\n      [expandableButtonLess]=\"expandableButtonLess\"\n      [index]=\"index\"\n      [isSelected$]=\"isSelected$\"\n      [showCatalogConfigureProducts]=\"showCatalogConfigureProducts\"\n      [showStatusIndicator]=\"showStatusIndicator\"\n      (elementIsVisible)=\"itemIntersected($event)\"\n      sieCoreIntersectionObserver\n    ></li>\n  </ng-container>\n  <ng-container *ngIf=\"index !== itemLength - 1\">\n    <li\n      sie-ui-dynamic-list-item\n      *ngIf=\"loading || itemData[index]\"\n      class=\"list__li\"\n      [ngStyle]=\"itemData[index]?.style\"\n      [ngClass]=\"{\n        hidden: itemData[index]?.hidden$ | async,\n        'hide-in-print-preview':\n          itemData[index]?.hideInPrintPreview ||\n          (bulkMode && hideNotSelectedItemsInPrintPreview && !itemData[index]?.isSelected)\n      }\"\n      [component]=\"itemData[index]?.itemComponent || defaultItemComponents[0]\"\n      [itemData]=\"itemData[index]\"\n      [itemType]=\"itemType\"\n      [itemAppearance]=\"itemAppearance\"\n      [condensed]=\"condensed\"\n      [loading]=\"loading\"\n      [loadingChildren]=\"loadingChildren\"\n      [loadingMore]=\"loadingMore\"\n      [bulkMode]=\"bulkMode\"\n      [dismissable]=\"itemsDismissible\"\n      [trackHover]=\"trackHover\"\n      (selectionChanged)=\"selectionChanged.next($event)\"\n      (itemEvent)=\"itemEvent.next($event)\"\n      [expandableButtonMore]=\"expandableButtonMore\"\n      [expandableButtonLess]=\"expandableButtonLess\"\n      [index]=\"index\"\n      [isSelected$]=\"isSelected$\"\n      [showCatalogConfigureProducts]=\"showCatalogConfigureProducts\"\n      [showStatusIndicator]=\"showStatusIndicator\"\n    ></li>\n  </ng-container>\n</ng-container>\n\n<ng-container *ngIf=\"paginationType === 'infinite' && loadingMore\">\n  <ng-container *ngFor=\"let item of [].constructor(numberOfLoadMoreSkeletons); let index = index\">\n    <li\n      sie-ui-dynamic-list-item\n      class=\"list__li\"\n      [component]=\"defaultItemComponents[0]\"\n      [itemType]=\"itemType\"\n      [itemAppearance]=\"itemAppearance\"\n      [condensed]=\"condensed\"\n      [loading]=\"true\"\n      [bulkMode]=\"bulkMode\"\n      [dismissable]=\"itemsDismissible\"\n      [trackHover]=\"trackHover\"\n      [showStatusIndicator]=\"showStatusIndicator\"\n      [isSelected$]=\"isSelected$\"\n    ></li>\n  </ng-container>\n</ng-container>\n", styles: [":host{list-style:none;margin:0;padding:0}.list__li.hidden{display:none}@media print{.list__li.hide-in-print-preview{display:none}}.list__li.type-file{border-width:0;border-style:solid;border-color:#ccccd4}.list__li.type-file.appearance-simple{border-bottom-width:1px}@media print{.list__li.type-file.appearance-simple{border-bottom-width:1pt}}.list__li.type-file.appearance-simple:first-child{border-top-width:1px}@media print{.list__li.type-file.appearance-simple:first-child{border-top-width:1pt}}.list__li.type-file.appearance-complex{border-bottom-width:8px;border-color:#f3f3f0}.list__li.type-file.appearance-complex:first-child{border-top-width:8px}.list__li.type-folder{margin-bottom:12px}.list__li.type-folder:last-child{margin-bottom:0}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }]; }, propDecorators: { defaultItemComponents: [{
                type: Input
            }], itemData: [{
                type: Input
            }], bulkMode: [{
                type: Input
            }], itemsDismissible: [{
                type: Input
            }], isSelected$: [{
                type: Input
            }], itemType: [{
                type: Input
            }], itemAppearance: [{
                type: Input
            }], condensed: [{
                type: Input
            }], itemLength: [{
                type: Input
            }], loading: [{
                type: Input
            }], loadingChildren: [{
                type: Input
            }], loadingMore: [{
                type: Input
            }], trackHover: [{
                type: Input
            }], showStatusIndicator: [{
                type: Input
            }], hideNotSelectedItemsInPrintPreview: [{
                type: Input
            }], numberOfSkeletons: [{
                type: Input
            }], numberOfLoadMoreSkeletons: [{
                type: Input
            }], expandableButtonMore: [{
                type: Input
            }], expandableButtonLess: [{
                type: Input
            }], paginationType: [{
                type: Input
            }], showCatalogConfigureProducts: [{
                type: Input
            }], itemEvent: [{
                type: Output
            }], selectionChanged: [{
                type: Output
            }], dynamicListItemsComponents: [{
                type: ViewChildren,
                args: [UiDynamicListItemComponent]
            }] } });

const MAX_RATING = 5;
/**
 * # Rating Stars component
 *
 * Rating stars are used to show rating for support materials such as downloads, FAQs, manuals etc.
 *
 * ## Component variations
 *
 * - Rated
 * - Not rated
 *
 * ## Content
 *
 * The rating stars component does not accept any content.
 *
 * ## Code example
 * @example ```html
 * <sie-ui-rating-stars
 *   [rating]="5"
 *   [ratingCount]="1000"
 *   [tooltip]="'Average based on 1000 customer ratings.'"
 *   [locale]="'en'"
 * ></sie-ui-rating-stars>
 * ```
 */
class UiRatingStarsComponent {
    /**
     * @param value Sets the number of ratings
     */
    set ratingCount(value) {
        if (value) {
            this._ratingCount = coerceNumberProperty(value);
        }
        else {
            this._ratingCount = undefined;
        }
    }
    get ratingCount() {
        return this._ratingCount;
    }
    /**
     * @param rating Rating value that is displayed within the component
     * @default `0`
     */
    set rating(rating) {
        this.icons = UiRatingStarsComponent.determineIcons(coerceNumberProperty(rating));
    }
    constructor(iconReg) {
        /**
         * Sets the tooltip message
         */
        this.tooltip = '';
        /** @ignore */
        this.icons = UiRatingStarsComponent.determineIcons(0);
        iconReg.register(SieIcon.SieportalStarFull);
        iconReg.register(SieIcon.SieportalStarHalfOutline);
        iconReg.register(SieIcon.SieportalStarOutline);
    }
    static determineIcon(rating, midRange, upperRange) {
        if (rating >= upperRange) {
            return SieIcon.SieportalStarFull;
        }
        else if (rating >= midRange) {
            return SieIcon.SieportalStarHalfOutline;
        }
        return SieIcon.SieportalStarOutline;
    }
    static determineIcons(rating) {
        const safeRating = safeRange(rating, 0, MAX_RATING);
        return Array.from({ length: MAX_RATING }, (_, i) => UiRatingStarsComponent.determineIcon(safeRating, i + 0.25, i + 0.75));
    }
    /** @ignore */
    classForIcon(icon) {
        if (icon === SieIcon.SieportalStarFull) {
            return 'full';
        }
        else if (icon === SieIcon.SieportalStarHalfOutline) {
            return 'half';
        }
        else {
            return 'outline';
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiRatingStarsComponent, deps: [{ token: i1.SieIconRegistryService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiRatingStarsComponent, selector: "sie-ui-rating-stars", inputs: { tooltip: "tooltip", ratingCount: "ratingCount", rating: "rating", locale: "locale" }, ngImport: i0, template: "<ng-container [ngSwitch]=\"!!tooltip\">\n  <div *ngSwitchCase=\"true\" class=\"rating-stars\" sieUiPopover [content]=\"tooltip\" popoverSize=\"s\">\n    <ng-container *ngTemplateOutlet=\"content\"></ng-container>\n  </div>\n  <div *ngSwitchDefault class=\"rating-stars\">\n    <ng-container *ngTemplateOutlet=\"content\"></ng-container>\n  </div>\n</ng-container>\n\n<ng-template #content>\n  <div class=\"rating-stars__icons\">\n    <sie-icon\n      *ngFor=\"let icon of icons\"\n      [name]=\"icon\"\n      class=\"rating-stars__icons-icon\"\n      [ngClass]=\"classForIcon(icon)\"\n    ></sie-icon>\n  </div>\n  <span class=\"rating-stars__counter\">\n    ({{ ratingCount === undefined ? '\u2013' : (ratingCount | sieNumber : locale) }})\n  </span>\n</ng-template>\n", styles: [".rating-stars{display:flex;align-items:center;color:#9999a9}.rating-stars__icons{display:flex;align-items:center}.rating-stars__icons-icon{width:16px;height:16px;display:flex;align-items:center;fill:currentColor;margin-right:3px}.rating-stars__icons-icon svg{fill:currentColor;width:inherit;height:inherit}.rating-stars__icons-icon svg g{fill:currentColor;width:inherit;height:inherit}.rating-stars__icons-icon svg text{font-family:Siemens Sans,sans-serif}.rating-stars__icons-icon.full,.rating-stars__icons-icon.half{color:#00d7a0}.rating-stars__counter{font-size:.875rem;font-weight:400;line-height:1.25rem}\n"], dependencies: [{ kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: i2.NgSwitch, selector: "[ngSwitch]", inputs: ["ngSwitch"] }, { kind: "directive", type: i2.NgSwitchCase, selector: "[ngSwitchCase]", inputs: ["ngSwitchCase"] }, { kind: "directive", type: i2.NgSwitchDefault, selector: "[ngSwitchDefault]" }, { kind: "directive", type: UiPopoverDirective, selector: "[sieUiPopover]", inputs: ["content", "popoverTemplate", "popoverSize", "popoverPlacement", "popoverAnimation", "popoverPlayAnimation", "popoverAnimationHideAfterTimeoutMS", "popoverLightTheme"] }, { kind: "pipe", type: i1$1.NumberPipe, name: "sieNumber" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiRatingStarsComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-rating-stars', changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-container [ngSwitch]=\"!!tooltip\">\n  <div *ngSwitchCase=\"true\" class=\"rating-stars\" sieUiPopover [content]=\"tooltip\" popoverSize=\"s\">\n    <ng-container *ngTemplateOutlet=\"content\"></ng-container>\n  </div>\n  <div *ngSwitchDefault class=\"rating-stars\">\n    <ng-container *ngTemplateOutlet=\"content\"></ng-container>\n  </div>\n</ng-container>\n\n<ng-template #content>\n  <div class=\"rating-stars__icons\">\n    <sie-icon\n      *ngFor=\"let icon of icons\"\n      [name]=\"icon\"\n      class=\"rating-stars__icons-icon\"\n      [ngClass]=\"classForIcon(icon)\"\n    ></sie-icon>\n  </div>\n  <span class=\"rating-stars__counter\">\n    ({{ ratingCount === undefined ? '\u2013' : (ratingCount | sieNumber : locale) }})\n  </span>\n</ng-template>\n", styles: [".rating-stars{display:flex;align-items:center;color:#9999a9}.rating-stars__icons{display:flex;align-items:center}.rating-stars__icons-icon{width:16px;height:16px;display:flex;align-items:center;fill:currentColor;margin-right:3px}.rating-stars__icons-icon svg{fill:currentColor;width:inherit;height:inherit}.rating-stars__icons-icon svg g{fill:currentColor;width:inherit;height:inherit}.rating-stars__icons-icon svg text{font-family:Siemens Sans,sans-serif}.rating-stars__icons-icon.full,.rating-stars__icons-icon.half{color:#00d7a0}.rating-stars__counter{font-size:.875rem;font-weight:400;line-height:1.25rem}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }]; }, propDecorators: { tooltip: [{
                type: Input
            }], ratingCount: [{
                type: Input
            }], rating: [{
                type: Input
            }], locale: [{
                type: Input
            }] } });

/**
 * # Rating stars Module
 * - {@link UiRatingStarsComponent}
 *
 * ## Module peer dependencies
 * - {@link SieIconsModule}
 */
class UiRatingStarsModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiRatingStarsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiRatingStarsModule, declarations: [UiRatingStarsComponent], imports: [SieIconsModule, CommonModule, SieCorePipesModule, UiPopoverModule], exports: [UiRatingStarsComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiRatingStarsModule, imports: [SieIconsModule, CommonModule, SieCorePipesModule, UiPopoverModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiRatingStarsModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiRatingStarsComponent],
                    imports: [SieIconsModule, CommonModule, SieCorePipesModule, UiPopoverModule],
                    exports: [UiRatingStarsComponent]
                }]
        }] });

/**
 * # Table component
 *
 * Tables are used to present information and relationship between data in a two-dimensional view.
 *
 * ## Component variations
 *
 * There are no variations
 *
 * ## Content
 *
 * The table component does not accept any content.
 *
 * ## Code example
 * ```html
 * <sie-ui-table [table]="tableContent"></sie-ui-table>
 * ```
 *
 * Table data example:
 * ```js
 * tableContent = {
 *   width: '800px',
 *   tHead: {
 *     rows: [{cells: [{value: 'I am a thead cell'}]}]
 *   },
 *   tBodies: [
 *     {
 *       rows: [{cells: [{value: 'I am a tbody cell'}]}]
 *     }
 *   ],
 *   tFoot: {
 *     rows: [
 *       {
 *         cells: [{value: 'I am a tfoot cell'}]
 *       }
 *     ]
 *   }
 * };
 * ```
 *
 * ### Builder
 * Table model can be build with the {@link UiTableBuilder table builder}
 */
class UiTableComponent {
    get table() {
        return this._table;
    }
    /**
     * @param table Defines displayed table data
     */
    set table(table) {
        this._table = table;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTableComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiTableComponent, selector: "sie-ui-table", inputs: { table: "table" }, ngImport: i0, template: "<div [ngStyle]=\"{ maxWidth: table.width }\" class=\"focus-wrapper\">\n  <div class=\"table-wrapper\" tabindex=\"0\">\n    <table\n      [ngStyle]=\"{ width: table.width, height: table.height }\"\n      [ngClass]=\"{ 'has-footer': table.tFoot, 'has-header': table.tHead }\"\n      [attr.aria-label]=\"table.caption\"\n    >\n      <thead *ngIf=\"table.tHead\">\n        <tr *ngFor=\"let row of table.tHead.rows\">\n          <th\n            *ngFor=\"let cell of row.cells\"\n            [align]=\"cell.alignment ? cell.alignment : 'left'\"\n            [colSpan]=\"cell.colspan ? cell.colspan : 1\"\n            [ngStyle]=\"{ width: cell.width, height: cell.height }\"\n            [rowSpan]=\"cell.rowspan ? cell.rowspan : 1\"\n            [ngClass]=\"{ truncate: cell.truncate }\"\n          >\n            {{ cell.value }}\n          </th>\n        </tr>\n      </thead>\n\n      <ng-container *ngFor=\"let tbody of table.tBodies\">\n        <tbody>\n          <ng-container [ngTemplateOutlet]=\"rowElement\" [ngTemplateOutletContext]=\"{ rows: tbody.rows }\">\n          </ng-container>\n        </tbody>\n      </ng-container>\n\n      <tfoot *ngIf=\"table.tFoot\">\n        <ng-container [ngTemplateOutlet]=\"rowElement\" [ngTemplateOutletContext]=\"{ rows: table.tFoot.rows }\">\n        </ng-container>\n      </tfoot>\n    </table>\n  </div>\n</div>\n\n<ng-template #rowElement let-rows=\"rows\">\n  <tr *ngFor=\"let rows of rows\">\n    <td\n      *ngFor=\"let cell of rows.cells\"\n      [align]=\"cell.alignment ? cell.alignment : 'left'\"\n      [colSpan]=\"cell.colspan ? cell.colspan : 1\"\n      [ngStyle]=\"{ width: cell.width, height: cell.height }\"\n      [rowSpan]=\"cell.rowspan ? cell.rowspan : 1\"\n      [ngClass]=\"{ truncate: cell.truncate, 'no-wrap': cell.noWrap }\"\n    >\n      {{ cell.value }}\n    </td>\n  </tr>\n</ng-template>\n", styles: [".focus-wrapper .table-wrapper{outline:none;outline-offset:0}@media (pointer: fine){.focus-wrapper .table-wrapper{position:relative}.focus-wrapper .table-wrapper:focus{outline:1px solid #1491eb;outline-offset:2px}.focus-wrapper .table-wrapper:focus:not(:focus-visible){outline:0}.focus-wrapper .table-wrapper:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}::-webkit-scrollbar-thumb{background-clip:padding-box;background-color:#737389}::-webkit-scrollbar-button{display:none}::-webkit-scrollbar-corner{background-color:transparent}::-webkit-scrollbar{width:16px;height:8px}:host{scrollbar-color:#737389 #fff}:host .dark,:host.dark{scrollbar-color:#ccccd4 #000028}::-webkit-scrollbar-thumb:vertical{border-left:8px solid transparent;border-right:4px solid transparent}::-webkit-scrollbar-thumb:horizontal{border-top:4px solid transparent}::-webkit-scrollbar-track:vertical{border-left:8px solid #fff;background:#ccccd4;border-right:4px solid #fff}::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #ccccd4}.dark::-webkit-scrollbar-thumb,.dark ::-webkit-scrollbar-thumb{background-color:#ccccd4}.dark::-webkit-scrollbar-track:vertical,.dark ::-webkit-scrollbar-track:vertical{background:#737389;border-right:4px solid #000028;border-left:8px solid #000028}.dark::-webkit-scrollbar-track:horizontal,.dark ::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #737389}.focus-wrapper{display:inline-flex;position:relative;display:block}.table-wrapper{overflow-x:auto}.table-wrapper table{border-collapse:collapse}.table-wrapper table tr{border-top:1px solid #ccccd4;border-bottom:1px solid #ccccd4}.table-wrapper table td{font-size:.875rem;font-weight:400;line-height:1.25rem;padding:10px 8px 11px;color:#000028}.table-wrapper table td.truncate{display:-webkit-inline-box;-webkit-box-orient:vertical;-webkit-line-clamp:1;padding:0;margin:10px 8px 11px;text-overflow:ellipsis;overflow:hidden}.table-wrapper table td.no-wrap{white-space:nowrap}.table-wrapper table.has-header thead tr,.table-wrapper table.has-footer thead tr{background-color:#00002829;border:unset}.table-wrapper table.has-header thead tr th,.table-wrapper table.has-footer thead tr th{font-size:.875rem;font-weight:700;line-height:1.25rem;padding:10px 8px 12px}@media print{.table-wrapper table.has-header thead tr,.table-wrapper table.has-footer thead tr{display:table-row-group}}.table-wrapper table.has-header tfoot tr,.table-wrapper table.has-footer tfoot tr{background-color:#00002829;border:unset}.table-wrapper table.has-header tfoot tr td,.table-wrapper table.has-footer tfoot tr td{font-size:.875rem;font-weight:700;line-height:1.25rem}@media print{.table-wrapper table.has-header tfoot,.table-wrapper table.has-footer tfoot{display:table-row-group}}.table-wrapper table.has-header tbody tr:first-of-type,.table-wrapper table.has-footer tbody tr:first-of-type{border-top:unset}.table-wrapper table.has-header tbody tr:last-of-type,.table-wrapper table.has-footer tbody tr:last-of-type{border-bottom:unset}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: i2.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTableComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-table', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div [ngStyle]=\"{ maxWidth: table.width }\" class=\"focus-wrapper\">\n  <div class=\"table-wrapper\" tabindex=\"0\">\n    <table\n      [ngStyle]=\"{ width: table.width, height: table.height }\"\n      [ngClass]=\"{ 'has-footer': table.tFoot, 'has-header': table.tHead }\"\n      [attr.aria-label]=\"table.caption\"\n    >\n      <thead *ngIf=\"table.tHead\">\n        <tr *ngFor=\"let row of table.tHead.rows\">\n          <th\n            *ngFor=\"let cell of row.cells\"\n            [align]=\"cell.alignment ? cell.alignment : 'left'\"\n            [colSpan]=\"cell.colspan ? cell.colspan : 1\"\n            [ngStyle]=\"{ width: cell.width, height: cell.height }\"\n            [rowSpan]=\"cell.rowspan ? cell.rowspan : 1\"\n            [ngClass]=\"{ truncate: cell.truncate }\"\n          >\n            {{ cell.value }}\n          </th>\n        </tr>\n      </thead>\n\n      <ng-container *ngFor=\"let tbody of table.tBodies\">\n        <tbody>\n          <ng-container [ngTemplateOutlet]=\"rowElement\" [ngTemplateOutletContext]=\"{ rows: tbody.rows }\">\n          </ng-container>\n        </tbody>\n      </ng-container>\n\n      <tfoot *ngIf=\"table.tFoot\">\n        <ng-container [ngTemplateOutlet]=\"rowElement\" [ngTemplateOutletContext]=\"{ rows: table.tFoot.rows }\">\n        </ng-container>\n      </tfoot>\n    </table>\n  </div>\n</div>\n\n<ng-template #rowElement let-rows=\"rows\">\n  <tr *ngFor=\"let rows of rows\">\n    <td\n      *ngFor=\"let cell of rows.cells\"\n      [align]=\"cell.alignment ? cell.alignment : 'left'\"\n      [colSpan]=\"cell.colspan ? cell.colspan : 1\"\n      [ngStyle]=\"{ width: cell.width, height: cell.height }\"\n      [rowSpan]=\"cell.rowspan ? cell.rowspan : 1\"\n      [ngClass]=\"{ truncate: cell.truncate, 'no-wrap': cell.noWrap }\"\n    >\n      {{ cell.value }}\n    </td>\n  </tr>\n</ng-template>\n", styles: [".focus-wrapper .table-wrapper{outline:none;outline-offset:0}@media (pointer: fine){.focus-wrapper .table-wrapper{position:relative}.focus-wrapper .table-wrapper:focus{outline:1px solid #1491eb;outline-offset:2px}.focus-wrapper .table-wrapper:focus:not(:focus-visible){outline:0}.focus-wrapper .table-wrapper:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}::-webkit-scrollbar-thumb{background-clip:padding-box;background-color:#737389}::-webkit-scrollbar-button{display:none}::-webkit-scrollbar-corner{background-color:transparent}::-webkit-scrollbar{width:16px;height:8px}:host{scrollbar-color:#737389 #fff}:host .dark,:host.dark{scrollbar-color:#ccccd4 #000028}::-webkit-scrollbar-thumb:vertical{border-left:8px solid transparent;border-right:4px solid transparent}::-webkit-scrollbar-thumb:horizontal{border-top:4px solid transparent}::-webkit-scrollbar-track:vertical{border-left:8px solid #fff;background:#ccccd4;border-right:4px solid #fff}::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #ccccd4}.dark::-webkit-scrollbar-thumb,.dark ::-webkit-scrollbar-thumb{background-color:#ccccd4}.dark::-webkit-scrollbar-track:vertical,.dark ::-webkit-scrollbar-track:vertical{background:#737389;border-right:4px solid #000028;border-left:8px solid #000028}.dark::-webkit-scrollbar-track:horizontal,.dark ::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #737389}.focus-wrapper{display:inline-flex;position:relative;display:block}.table-wrapper{overflow-x:auto}.table-wrapper table{border-collapse:collapse}.table-wrapper table tr{border-top:1px solid #ccccd4;border-bottom:1px solid #ccccd4}.table-wrapper table td{font-size:.875rem;font-weight:400;line-height:1.25rem;padding:10px 8px 11px;color:#000028}.table-wrapper table td.truncate{display:-webkit-inline-box;-webkit-box-orient:vertical;-webkit-line-clamp:1;padding:0;margin:10px 8px 11px;text-overflow:ellipsis;overflow:hidden}.table-wrapper table td.no-wrap{white-space:nowrap}.table-wrapper table.has-header thead tr,.table-wrapper table.has-footer thead tr{background-color:#00002829;border:unset}.table-wrapper table.has-header thead tr th,.table-wrapper table.has-footer thead tr th{font-size:.875rem;font-weight:700;line-height:1.25rem;padding:10px 8px 12px}@media print{.table-wrapper table.has-header thead tr,.table-wrapper table.has-footer thead tr{display:table-row-group}}.table-wrapper table.has-header tfoot tr,.table-wrapper table.has-footer tfoot tr{background-color:#00002829;border:unset}.table-wrapper table.has-header tfoot tr td,.table-wrapper table.has-footer tfoot tr td{font-size:.875rem;font-weight:700;line-height:1.25rem}@media print{.table-wrapper table.has-header tfoot,.table-wrapper table.has-footer tfoot{display:table-row-group}}.table-wrapper table.has-header tbody tr:first-of-type,.table-wrapper table.has-footer tbody tr:first-of-type{border-top:unset}.table-wrapper table.has-header tbody tr:last-of-type,.table-wrapper table.has-footer tbody tr:last-of-type{border-bottom:unset}\n"] }]
        }], propDecorators: { table: [{
                type: Input
            }] } });

/**
 * # Table Module
 * - {@link UiTableComponent}
 */
class UiTableModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTableModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiTableModule, declarations: [UiTableComponent], imports: [CommonModule], exports: [UiTableComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTableModule, imports: [CommonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTableModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiTableComponent],
                    imports: [CommonModule],
                    exports: [UiTableComponent]
                }]
        }] });

/**
 * This directive is used to display items within the tabs container component.
 */
class UiTabDirective {
    constructor(templateRef) {
        this.templateRef = templateRef;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTabDirective, deps: [{ token: i0.TemplateRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: UiTabDirective, selector: "[sieUiTab]", ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTabDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[sieUiTab]'
                }]
        }], ctorParameters: function () { return [{ type: i0.TemplateRef }]; } });

// injection token
const UI_TABS_CONTAINER_WEB_COMPONENT_SERVICE = 'UI_TABS_CONTAINER_WEB_COMPONENT_SERVICE';

/**
 * # Tabs Controls Component
 *
 * The tabs controls represent the controls of the tabs component
 *
 * ## Component variations
 *
 * - contained tabs
 * - uncontained tabs
 *
 * ## Content
 *
 * The tabs controls component does not accept any content.
 *
 * ## Code example
 * @example
 * Template:
 * ```html
 * <sie-ui-tabs-controls [tabs]="tabs" [backgroundColor]="'235, 240, 245'"></sie-ui-tabs-controls>
 * ```
 *
 * Tabs controls data example:
 * ```js
 * tabs: TabsControlConfig = [
 *  {
 *    title: 'product',
 *    badge: {
 *      type: 'counter',
 *      status: 'error',
 *      mode: 'light',
 *      number: 9
 *    },
 *    count: 99,
 *    icon: {
 *      name: 'InformationFilled',
 *      color: '#FF9000'
 *    }
 *  },
 *  {
 *    title: 'service',
 *    badge: {
 *      type: 'counter',
 *      status: 'error',
 *      mode: 'light',
 *      number: 99
 *    }
 *  }
 * ];
 * ```
 */
class UiTabsControlsComponent extends SelectableWithUnderlineDirective {
    /**
     * @param value Defines which tab should be selected by default. If the value is set to `-1`, no item is selected by default.
     * @default 0
     */
    set selectedItemIndex(value) {
        if (value < 0) {
            this._activeItemIndex = -1;
        }
        const coercedValue = coerceNumberProperty(value);
        this._selectedItemIndex = coercedValue;
        this._activeItemIndex = coercedValue;
        this.moveUnderlineToItem(coercedValue, true);
        this.bringIntoView(coercedValue);
        this.cd.detectChanges();
    }
    /**
     * @param value Defines if the horizontal line on the tabs controls should be extended.
     * @default false
     */
    set afterLine(value) {
        this._afterLine = coerceBooleanProperty(value);
    }
    get afterLine() {
        return this._afterLine;
    }
    /**
     * @param tabs {@link TabsControlConfig Config} Defines data of tabs that will be displayed in tabs controls.
     */
    set tabs(tabs) {
        tabs.forEach(tab => {
            if (tab.icon) {
                this.iconReg.register(tab.icon.name);
            }
        });
        this._tabs = tabs;
        if (this.initialized) {
            this.renderListItems();
        }
    }
    get tabs() {
        return this._tabs;
    }
    constructor(layoutService, iconReg, cd) {
        super(cd, layoutService);
        this.layoutService = layoutService;
        this.iconReg = iconReg;
        this.cd = cd;
        /**
         * Defines {@link TabsControlsType Type} which tab style should be used.
         * @default 'un-contained'
         */
        this.type = 'un-contained';
        /**
         * Defines {@link ThemeVariant Variant} theme of the tabs controls.
         * @default 'light'
         */
        this.theme = 'light';
        /**
         * Defines {@link TabsControlsAlignment Alignment} how tabs controls should be aligned.
         * @default 'left'
         */
        this.align = 'left';
        /**
         * Defines which text should be used by screen readers when small screen navigate left button is used.
         * @default ''
         */
        this.navigateLeftScreenReaderText = '';
        /**
         * Defines which text should be used by screen readers when small screen navigate right button is used.
         * @default ''
         */
        this.navigateRightScreenReaderText = '';
        /**
         * Event triggered when a different tab item is selected.
         */
        this.selectionChanged = new EventEmitter();
        /**
         * Event triggered when a different tab item is selected.
         */
        this.selectedItemIndexChange = new EventEmitter();
        /**
         * Event triggered when a tab item is clicked.
         */
        this.tabClicked = new EventEmitter();
        /** @ignore */
        this.currentTranslateX = 0;
        /** @ignore */
        this.wrapperStyle = {
            transform: 'translateX(0)'
        };
        /** @ignore */
        this.panStarted = false;
        /** @ignore */
        this.showLeft = false;
        /** @ignore */
        this.showRight = false;
        this.countLimit = UIConstants.COUNT_LIMIT;
        this.countExceededPlaceholder = UIConstants.COUNT_EXCEEDED_PLACEHOLDER;
        this.itemWidths = [];
        this.itemsTotalWidth = 0;
        this.subscriptions = new Subscription();
        this._selectedItemIndex = 0;
        this._afterLine = false;
        // For storing the container width temporary not to query on every pan event (screen should not resize while panning)
        this._tabs = [];
        this.initialized = false;
        iconReg.register(SieIcon.ArrowRight);
        iconReg.register(SieIcon.ArrowLeft);
    }
    /** @ignore */
    ngOnInit() {
        this.activeItemIndex = this.focusedItemIndex = this._selectedItemIndex;
        this.setDefaultBackground();
    }
    /** @ignore */
    ngAfterViewInit() {
        this.renderListItems();
        this.setContainedItemWidth();
        this.initialized = true;
        this.subscribeToScreenResize();
    }
    /** @ignore */
    ngOnDestroy() {
        this.subscriptions.unsubscribe();
    }
    /** @ignore */
    activeItemChanged() {
        if (this.type === 'contained') {
            const tabItemElement = this.tabContainerElement.nativeElement.querySelector('.tabs-controls__item.active');
            const eventHandler = (e) => {
                //make sure the transition event is listening only on ::after pseudo-element, not the whole element.
                if (e.pseudoElement !== '') {
                    this.emitSelectionChange();
                    tabItemElement.removeEventListener('transitionend', eventHandler);
                }
            };
            tabItemElement.addEventListener('transitionend', eventHandler);
        }
        else {
            this.emitSelectionChange();
        }
    }
    itemClicked(index, event) {
        super.itemClicked(index, event);
        this.tabClicked.emit(index);
    }
    /** @ignore */
    positionToLeft() {
        const offsetX = this.currentTranslateX;
        let startPosition = 0;
        for (const item of this.itemWidths) {
            const withNext = startPosition + item;
            if (withNext >= offsetX) {
                break;
            }
            startPosition = withNext;
        }
        // consider gradient offset except if first item
        if (startPosition !== 0) {
            startPosition -= parseInt(this.getGradientOffset(), 10);
        }
        this.currentTranslateX = startPosition;
        this.wrapperStyle.transform = `translateX(${this.currentTranslateX * -1}px)`;
        this.cd.detectChanges();
        this.positionControls();
    }
    /** @ignore */
    positionToRight() {
        const containerWidth = this.getContainerWidth();
        const targetWidth = containerWidth + this.currentTranslateX;
        let sumWidths = 0;
        let isLastItem = false;
        let translate = 0;
        for (let i = 0; sumWidths <= targetWidth && i < this.itemWidths.length; i++) {
            sumWidths += this.itemWidths[i] + this.calculateItemMargin(i) || 0;
            isLastItem = i === this.itemWidths.length - 1;
        }
        if (sumWidths > 0) {
            translate = sumWidths - containerWidth;
        }
        // consider offset except if last item
        if (!isLastItem) {
            translate += parseInt(this.getGradientOffset(), 10);
        }
        this.currentTranslateX = translate;
        this.wrapperStyle.transform = `translateX(${this.currentTranslateX * -1}px)`;
        this.cd.detectChanges();
        this.positionControls();
    }
    /** @ignore */
    onPanStart() {
        this.panStarted = true;
    }
    /** @ignore */
    onPan(event) {
        if (this.showLeft || this.showRight) {
            const newTranslate = this.getNewTranslate(event);
            this.wrapperStyle.transform = `translateX(${newTranslate * -1}px)`;
        }
    }
    /** @ignore */
    onPanEnd(event) {
        const newTranslate = this.getNewTranslate(event);
        const oldTranslate = this.currentTranslateX;
        this.currentTranslateX = newTranslate;
        this.panStarted = false;
        if (newTranslate > oldTranslate) {
            this.positionToRight();
        }
        else if (newTranslate < oldTranslate) {
            this.positionToLeft();
        }
        else {
            this.positionControls();
        }
    }
    onBlur() {
        if (this.closeable && this.activeItemIndex < 0) {
            this.moveUnderlineToItem(this.activeItemIndex, true);
        }
    }
    /** @ignore */
    bringIntoView(index) {
        const visibleRangeStart = this.currentTranslateX;
        const visibleRangeEnd = visibleRangeStart + this.getContainerWidth();
        const itemOffsetStart = this.itemWidths.slice(0, index).reduce((accumulator, current) => accumulator + current, 0);
        const itemOffsetEnd = itemOffsetStart + this.itemWidths[index];
        const isLastItem = index === this.selectableItems.length - 1;
        if (itemOffsetStart < visibleRangeStart && itemOffsetEnd >= visibleRangeStart) {
            this.positionToLeft();
        }
        if (isLastItem || (itemOffsetStart <= visibleRangeEnd && itemOffsetEnd > visibleRangeEnd)) {
            this.positionToRight();
        }
    }
    /** @ignore */
    blockScroll() {
        requestAnimationFrame(() => {
            this.tabListContainerElement.nativeElement.scrollLeft = 0;
        });
    }
    /** @ignore */
    tabTextTransitionEnd() {
        this.setContainedItemWidth();
        this.calculateItemWidths();
        this.positionControls();
        this.bringIntoView(this._activeItemIndex);
        this.moveUnderlineToItem(this._activeItemIndex, true);
    }
    /** @ignore */
    calculateItemWidths() {
        this.itemsTotalWidth = 0;
        if (this.selectableItems) {
            this.itemWidths = this.selectableItems.toArray().map(item => {
                const { width } = item.nativeElement.getBoundingClientRect();
                this.itemsTotalWidth += width;
                return width;
            });
        }
    }
    /** @ignore */
    _resetUnderline() {
        this.moveUnderlineToItem(this._selectedItemIndex, true);
        this.setContainedItemWidth();
        this.calculateItemWidths();
        this.positionControls();
        if (this._selectedItemIndex > 0) {
            this.bringIntoView(this._selectedItemIndex);
        }
    }
    setDefaultBackground() {
        if (!this.backgroundColor) {
            if (this.theme === 'light') {
                this.backgroundColor = ColorBackground1RgbList;
            }
            else {
                this.backgroundColor = ColorBackground3RgbList;
            }
        }
    }
    emitSelectionChange() {
        this.selectionChanged.emit(this.activeItemIndex);
        this.selectedItemIndexChange.emit(this.activeItemIndex);
    }
    renderListItems() {
        // simply reset the underline if the component is already initialized
        if (this.initialized && this.getContainerWidth() > 0) {
            this._resetUnderline();
            return;
        }
        // otherwise create an observer to wait for angulars first proper resize event
        const observer = new ResizeObserver(() => {
            this._resetUnderline();
            observer.disconnect();
        });
        observer.observe(this.containerElement.nativeElement);
    }
    setContainedItemWidth() {
        const containerWidth = this.getTabContainerWidth();
        if (this.type === 'contained' && this.selectableItems) {
            const itemCount = this.selectableItems.length;
            const generatedWidth = containerWidth / itemCount;
            this.selectableItems.toArray().forEach(item => {
                item.nativeElement.style.width = `${generatedWidth}px`;
            });
        }
    }
    positionControls() {
        const containerWidth = this.getContainerWidth();
        const isFarRight = containerWidth + this.currentTranslateX >= this.itemsTotalWidth;
        const needsArrows = Math.ceil(this.itemsTotalWidth) > Math.ceil(containerWidth);
        const newShowLeft = needsArrows && this.currentTranslateX !== 0;
        const newShowRight = needsArrows && !isFarRight;
        let changed = false;
        if (this.showLeft !== newShowLeft) {
            this.showLeft = newShowLeft;
            changed = true;
        }
        if (this.showRight !== newShowRight) {
            this.showRight = newShowRight;
            changed = true;
        }
        if (changed) {
            this.cd.detectChanges();
        }
        if (!needsArrows) {
            this.currentTranslateX = 0;
            this.wrapperStyle.transform = `translateX(0px)`;
        }
    }
    getContainerWidth() {
        if (this.containerElement) {
            return this.containerElement.nativeElement.getBoundingClientRect().width;
        }
        else {
            return 0;
        }
    }
    getTabContainerWidth() {
        if (this.tabContainerElement) {
            return this.tabContainerElement.nativeElement.getBoundingClientRect().width;
        }
        else {
            return 0;
        }
    }
    getNewTranslate(panEvent) {
        return this.currentTranslateX - panEvent.deltaX;
    }
    subscribeToScreenResize() {
        this.subscriptions.add(this.layoutService.resizeEventWithInitial$.subscribe(() => {
            this.setContainedItemWidth();
            this.calculateItemWidths();
            this.positionControls();
        }));
    }
    getGradientOffset() {
        if (this.type === 'contained') {
            if (this.layoutService.isViewport('S', 'M')) {
                return ComponentTabsGradientWidthContainedS;
            }
            return ComponentTabsGradientWidthContainedL;
        }
        return ComponentTabsGradientWidthUnContained;
    }
    calculateItemMargin(index) {
        let itemMargin = 0;
        if (this.type === 'contained') {
            // first and last item have only right/left margin
            if (!index || index === this.itemWidths.length - 1) {
                itemMargin = 1;
            }
            else {
                itemMargin = 2;
            }
        }
        return itemMargin;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTabsControlsComponent, deps: [{ token: i1$1.LayoutService }, { token: i1.SieIconRegistryService }, { token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiTabsControlsComponent, selector: "sie-ui-tabs-controls", inputs: { backgroundColor: "backgroundColor", selectedItemIndex: "selectedItemIndex", afterLine: "afterLine", tabs: "tabs", type: "type", theme: "theme", align: "align", navigateLeftScreenReaderText: "navigateLeftScreenReaderText", navigateRightScreenReaderText: "navigateRightScreenReaderText" }, outputs: { selectionChanged: "selectionChanged", selectedItemIndexChange: "selectedItemIndexChange", tabClicked: "tabClicked" }, host: { properties: { "style.--background-color": "this.backgroundColor" } }, viewQueries: [{ propertyName: "containerElement", first: true, predicate: ["container"], descendants: true }, { propertyName: "tabContainerElement", first: true, predicate: ["tabsControls"], descendants: true }, { propertyName: "tabListContainerElement", first: true, predicate: ["listWrapper"], descendants: true }, { propertyName: "selectableItems", predicate: ["selectableItem"], descendants: true }], usesInheritance: true, ngImport: i0, template: "<nav\n  class=\"tabs-controls tabs-controls--{{ type }} align-{{ align }}\"\n  (mouseleave)=\"mouseLeftContainer()\"\n  #tabsControls\n>\n  <div *ngIf=\"showLeft\" class=\"tabs-controls__button-wrapper left\">\n    <sie-ui-button\n      themeType=\"icon\"\n      variant=\"icon-un-contained\"\n      [icon]=\"iconReg.sieIcon.ArrowLeft\"\n      [iconScreenReaderText]=\"navigateLeftScreenReaderText\"\n      [background]=\"theme\"\n      (clicked)=\"positionToLeft()\"\n    ></sie-ui-button>\n  </div>\n  <div *ngIf=\"showRight\" class=\"tabs-controls__button-wrapper right\">\n    <sie-ui-button\n      themeType=\"icon\"\n      variant=\"icon-un-contained\"\n      [icon]=\"iconReg.sieIcon.ArrowRight\"\n      [iconScreenReaderText]=\"navigateRightScreenReaderText\"\n      [background]=\"theme\"\n      (clicked)=\"positionToRight()\"\n    ></sie-ui-button>\n  </div>\n\n  <div class=\"tabs-controls__list-wrapper\" #listWrapper>\n    <div\n      class=\"tabs-controls__list-position-wrapper\"\n      [ngStyle]=\"wrapperStyle\"\n      [ngClass]=\"{ 'no-transition': panStarted }\"\n      (panstart)=\"onPanStart()\"\n      (pan)=\"onPan($event)\"\n      (panend)=\"onPanEnd($event)\"\n      #container\n    >\n      <ul class=\"tabs-controls__list\" role=\"tablist\">\n        <li\n          *ngFor=\"let tab of tabs; let i = index\"\n          class=\"tabs-controls__item\"\n          role=\"tab\"\n          [ngClass]=\"{\n            active: activeItemIndex === i,\n            hide: tab.hide\n          }\"\n          (mouseenter)=\"!tab.disabled && mouseEnterItem(i)\"\n          #selectableItem\n        >\n          <a\n            sieCoreAnchorButton\n            class=\"tabs-controls__tab-button {{ 'theme-' + theme }}\"\n            [ngClass]=\"{ active: activeItemIndex === i, disabled: tab.disabled, 'with-icon': tab.icon }\"\n            [disabled]=\"tab.disabled\"\n            [sieCoreAttributes]=\"tab.dataAttributes\"\n            [attr.aria-expanded]=\"activeItemIndex === i\"\n            (click)=\"!tab.disabled && itemClicked(i, $event)\"\n            (keyup.enter)=\"!tab.disabled && itemClicked(i, $event)\"\n            (keyup.space)=\"!tab.disabled && moveUnderlineToItem(i)\"\n            (keyup.arrowLeft)=\"!tab.disabled && positionToLeft()\"\n            (keyup.arrowRight)=\"!tab.disabled && positionToRight()\"\n            (keydown.Tab)=\"blockScroll()\"\n            (focus)=\"!tab.disabled && moveUnderlineToItem(i, !tab.icon); !tab.disabled && bringIntoView(i)\"\n            (blur)=\"onBlur()\"\n          >\n            <sie-icon\n              *ngIf=\"tab.icon && type === 'un-contained'\"\n              class=\"tabs-controls__tab-icon\"\n              [name]=\"tab.icon.name\"\n              [ngStyle]=\"{ color: tab.icon.color, fill: tab.icon.color }\"\n            ></sie-icon>\n            <span\n              class=\"tabs-controls__tab-text\"\n              [ngClass]=\"{ 'with-spacing': tab.badge?.type === 'icon' && !tab.count && tab.count !== 0 }\"\n              (transitionend)=\"tabTextTransitionEnd()\"\n              sieCoreAddTooltip\n              >{{ tab.title }}</span\n            >\n            <span\n              class=\"tabs-controls__count\"\n              *ngIf=\"tab.count || tab.count === 0\"\n              [ngClass]=\"{ 'with-spacing': tab.badge?.type === 'icon' }\"\n              >({{ tab.count < countLimit ? tab.count : countExceededPlaceholder }})</span\n            >\n            <sie-ui-badge\n              *ngIf=\"tab.badge\"\n              class=\"tabs-controls__badge-wrapper tabs-controls__badge-wrapper--{{ tab.badge.type }}\"\n              [type]=\"tab.badge.type\"\n              [mode]=\"activeItemIndex === i && type === 'contained' ? 'dark' : tab.badge.mode\"\n              [status]=\"tab.badge.status\"\n              [number]=\"tab.badge.number\"\n              [highlighted]=\"type === 'un-contained' && activeItemIndex === i\"\n            ></sie-ui-badge>\n          </a>\n        </li>\n      </ul>\n\n      <div class=\"tabs-controls__underline {{ 'theme-' + theme }}\" [ngStyle]=\"underlineStyle\"></div>\n    </div>\n    <div *ngIf=\"showLeft\" class=\"tabs-controls__list-wrapper--gradient-left {{ type }}\"></div>\n    <div *ngIf=\"showRight\" class=\"tabs-controls__list-wrapper--gradient-right {{ type }}\"></div>\n  </div>\n  <ng-container *ngIf=\"afterLine\">\n    <div class=\"tabs-controls__after-line\"></div>\n  </ng-container>\n</nav>\n", styles: [".tabs-controls .tabs-controls__tab-button:focus,.tabs-controls .tabs-controls__tab-button:focus:not(.disabled),.tabs-controls .tabs-controls__tab-button:focus-visible{outline:0}.tabs-controls__list-wrapper--gradient-right,.tabs-controls__list-wrapper--gradient-left{position:absolute;display:block;top:0;bottom:0;pointer-events:none}.prominent-uncontained.tabs-controls__list-wrapper--gradient-right,.prominent-uncontained.tabs-controls__list-wrapper--gradient-left,.un-contained.tabs-controls__list-wrapper--gradient-right,.un-contained.tabs-controls__list-wrapper--gradient-left{width:70px}.contained.tabs-controls__list-wrapper--gradient-right,.contained.tabs-controls__list-wrapper--gradient-left{width:41px}@media (min-width: 1024px){.contained.tabs-controls__list-wrapper--gradient-right,.contained.tabs-controls__list-wrapper--gradient-left{width:58px}}.tabs-controls{position:relative;display:flex;justify-content:flex-start}.tabs-controls.align-center{justify-content:center}.tabs-controls.align-right{justify-content:flex-end}.tabs-controls .tabs-controls__tab-button:not(.disabled){position:relative;z-index:2}.tabs-controls .tabs-controls__tab-button:not(.disabled):focus:before{content:\"\";position:absolute;inset:0;z-index:1;border:1px solid #1491eb;border-radius:0}.tabs-controls .tabs-controls__tab-button:not(.disabled):focus-visible:before{content:\"\";position:absolute;inset:0;z-index:1;border:1px solid #1491eb;border-radius:0}.tabs-controls .tabs-controls__tab-button:not(.disabled):focus-visible:before{bottom:-2px}.tabs-controls .tabs-controls__tab-button:not(.disabled):focus:not(:focus-visible):before{border:none}.tabs-controls .tabs-controls__tab-button{display:flex;border:0;outline:0}.tabs-controls .tabs-controls__list{list-style:none;margin:0;padding:0}.tabs-controls__badge-wrapper{display:flex;align-self:flex-start}.tabs-controls__badge-wrapper--dot,.tabs-controls__badge-wrapper--icon{margin-top:2px}.tabs-controls__badge-wrapper--counter{margin-top:3px}.tabs-controls--un-contained .tabs-controls__list{display:flex}.tabs-controls--un-contained .tabs-controls__list .tabs-controls__item{position:relative}.tabs-controls--un-contained .tabs-controls__list .tabs-controls__item.hide{display:none}.tabs-controls--un-contained .tabs-controls__list .tabs-controls__tab-button{max-width:296px;border-bottom:2px solid #ccccd4;padding:5px 24px 7px;background:none;color:#000028}.tabs-controls--un-contained .tabs-controls__list .tabs-controls__tab-button:active,.tabs-controls--un-contained .tabs-controls__list .tabs-controls__tab-button.active{color:#33747a;fill:#33747a}.tabs-controls--un-contained .tabs-controls__list .tabs-controls__tab-button:disabled,.tabs-controls--un-contained .tabs-controls__list .tabs-controls__tab-button.disabled{color:#b3b3be;fill:#b3b3be}.tabs-controls--un-contained .tabs-controls__list .tabs-controls__tab-button:disabled:hover,.tabs-controls--un-contained .tabs-controls__list .tabs-controls__tab-button.disabled:hover{cursor:not-allowed}.tabs-controls--un-contained .tabs-controls__list .tabs-controls__tab-button:not(.disabled):hover{cursor:pointer}.tabs-controls--un-contained .tabs-controls__list .tabs-controls__tab-button .tabs-controls__tab-icon+.tabs-controls__tab-text{margin-left:8px}@media (max-width: 639.78px){.tabs-controls--un-contained .tabs-controls__list .tabs-controls__tab-button.with-icon{transition:max-width .5s cubic-bezier(.2,0,.38,.9)}.tabs-controls--un-contained .tabs-controls__list .tabs-controls__tab-button.with-icon:not(.active) .tabs-controls__tab-text{max-width:0;opacity:0;margin-left:0;transition:max-width .5s cubic-bezier(.2,0,.38,.9)}.tabs-controls--un-contained .tabs-controls__list .tabs-controls__tab-button.with-icon.active{opacity:1}}.tabs-controls--un-contained .tabs-controls__list .tabs-controls__tab-button .tabs-controls__tab-icon{margin-top:-1px;width:24px}.tabs-controls--un-contained .tabs-controls__list .tabs-controls__tab-button .tabs-controls__tab-text{white-space:nowrap;overflow:hidden;text-overflow:ellipsis;display:block;outline:none;max-width:100%;transition:max-width .5s cubic-bezier(.2,0,.38,.9)}.tabs-controls--un-contained .tabs-controls__list .tabs-controls__tab-button .tabs-controls__tab-text.with-spacing{padding-right:20px}.tabs-controls--un-contained .tabs-controls__list .tabs-controls__tab-button .tabs-controls__count{padding-left:4px}.tabs-controls--un-contained .tabs-controls__list .tabs-controls__tab-button .tabs-controls__count.with-spacing{padding-right:20px}.tabs-controls--un-contained .tabs-controls__list .tabs-controls__tab-button .tabs-controls__badge-wrapper--counter{margin-top:1px}.tabs-controls--un-contained .tabs-controls__list .tabs-controls__tab-button .tabs-controls__badge-wrapper--icon{position:absolute;right:24px;top:-1px}.tabs-controls--contained .tabs-controls__list{display:flex;max-height:68px;height:100%}.tabs-controls--contained .tabs-controls__list .tabs-controls__item{min-height:100%;min-width:130px;max-width:296px;position:relative;line-height:20px;margin:0 1px;transition:color .3s cubic-bezier(.2,0,.38,.9)}.tabs-controls--contained .tabs-controls__list .tabs-controls__item.hide{display:none}.tabs-controls--contained .tabs-controls__list .tabs-controls__item:first-child{margin-left:0}.tabs-controls--contained .tabs-controls__list .tabs-controls__item:last-child{margin-right:0}.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button{min-height:100%;width:100%;padding:6px 8px 20px;transition:color .3s cubic-bezier(.2,0,.38,.9)}.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button:not(.disabled):after{content:\"\";position:absolute;bottom:0;left:0;width:100%;height:100%;z-index:-1;background-position:top left;transition:background .3s cubic-bezier(.2,0,.38,.9)}.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button:not(.disabled):hover,.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button:not(.disabled):focus{cursor:pointer}.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button:disabled:hover,.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button.disabled:hover{cursor:not-allowed}.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button.theme-light{color:#000028;background-color:#ebf7f8;border-bottom:2px solid #9999a9}.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button.theme-light:not(.disabled):after{background:linear-gradient(to top,#33747a 50%,transparent 50%);background-size:100% 200%}.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button.theme-light:active,.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button.theme-light.active{color:#fff;border-bottom:2px solid #33747a}.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button.theme-light:active:after,.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button.theme-light.active:after{background-position:bottom left}.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button.theme-light:not(.disabled):hover,.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button.theme-light:not(.disabled):focus{border-color:#33747a;box-shadow:inset 0 -2px #33747a}.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button.theme-light:disabled,.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button.theme-light.disabled{color:#b3b3be;border-color:#ccccd4}.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button.theme-dark{color:#fff;background-color:#00183b;border-bottom:2px solid #ccccd4}.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button.theme-dark:not(.disabled):after{background:linear-gradient(to top,#00ffb9 50%,transparent 50%);background-size:100% 200%}.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button.theme-dark:active,.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button.theme-dark.active{color:#000028;border-bottom:2px solid #00ffb9}.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button.theme-dark:active:after,.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button.theme-dark.active:after{background-position:bottom left}.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button.theme-dark:not(.disabled):hover,.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button.theme-dark:not(.disabled):focus{border-color:#00ffb9;box-shadow:inset 0 -2px #00ffb9}.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button.theme-dark:disabled,.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button.theme-dark.disabled{color:#b3b3be;border-color:#737389}.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button .tabs-controls__tab-text{display:-webkit-box;-webkit-box-orient:vertical;-webkit-line-clamp:2;text-align:left;text-overflow:ellipsis;overflow:hidden}.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button .tabs-controls__badge-wrapper--dot{margin-top:3px}.tabs-controls--prominent-uncontained{container:list-container/inline-size}.tabs-controls--prominent-uncontained .tabs-controls__list{display:flex}.tabs-controls--prominent-uncontained .tabs-controls__list .tabs-controls__item{position:relative}.tabs-controls--prominent-uncontained .tabs-controls__list .tabs-controls__item.hide{display:none}.tabs-controls--prominent-uncontained .tabs-controls__list .tabs-controls__tab-button{max-width:296px;padding:0 16px 4px;background:none}.tabs-controls--prominent-uncontained .tabs-controls__list .tabs-controls__tab-button.theme-light{border-bottom:2px solid #ccccd4;color:#000028}.tabs-controls--prominent-uncontained .tabs-controls__list .tabs-controls__tab-button.theme-light:active,.tabs-controls--prominent-uncontained .tabs-controls__list .tabs-controls__tab-button.theme-light.active{color:#33747a;fill:#33747a}.tabs-controls--prominent-uncontained .tabs-controls__list .tabs-controls__tab-button.theme-light:disabled,.tabs-controls--prominent-uncontained .tabs-controls__list .tabs-controls__tab-button.theme-light.disabled{color:#b3b3be;fill:#b3b3be}.tabs-controls--prominent-uncontained .tabs-controls__list .tabs-controls__tab-button.theme-light:disabled:hover,.tabs-controls--prominent-uncontained .tabs-controls__list .tabs-controls__tab-button.theme-light.disabled:hover{cursor:not-allowed}.tabs-controls--prominent-uncontained .tabs-controls__list .tabs-controls__tab-button.theme-dark{border-bottom:2px solid #737389;color:#fff}.tabs-controls--prominent-uncontained .tabs-controls__list .tabs-controls__tab-button.theme-dark:active,.tabs-controls--prominent-uncontained .tabs-controls__list .tabs-controls__tab-button.theme-dark.active{color:#0cc;fill:#0cc}.tabs-controls--prominent-uncontained .tabs-controls__list .tabs-controls__tab-button.theme-dark:disabled,.tabs-controls--prominent-uncontained .tabs-controls__list .tabs-controls__tab-button.theme-dark.disabled{color:#737389;fill:#737389}.tabs-controls--prominent-uncontained .tabs-controls__list .tabs-controls__tab-button.theme-dark:disabled:hover,.tabs-controls--prominent-uncontained .tabs-controls__list .tabs-controls__tab-button.theme-dark.disabled:hover{cursor:not-allowed}.tabs-controls--prominent-uncontained .tabs-controls__list .tabs-controls__tab-button:not(.disabled):hover{cursor:pointer}.tabs-controls--prominent-uncontained .tabs-controls__list .tabs-controls__tab-button .tabs-controls__tab-text{white-space:nowrap;overflow:hidden;text-overflow:ellipsis;font-size:1.25rem;font-weight:900;line-height:1.625rem;display:block;outline:none;max-width:100%;transition:max-width .5s cubic-bezier(.2,0,.38,.9);letter-spacing:-.03125rem}.tabs-controls--prominent-uncontained .tabs-controls__list .tabs-controls__tab-button .tabs-controls__tab-text.with-spacing{padding-right:20px}.tabs-controls--prominent-uncontained .tabs-controls__button-wrapper.right{right:-26px}@container list-container (max-width: 1023px){.tabs-controls--prominent-uncontained .tabs-controls__list .tabs-controls__tab-button{max-width:236px;padding-bottom:6px}.tabs-controls--prominent-uncontained .tabs-controls__list .tabs-controls__tab-button .tabs-controls__tab-text{font-size:1rem;font-weight:900;line-height:1.5rem;letter-spacing:-.03125rem}@media (min-width: 1024px){.tabs-controls--prominent-uncontained .tabs-controls__list .tabs-controls__tab-button .tabs-controls__tab-text{font-size:1.25rem;font-weight:900;line-height:1.625rem}}.tabs-controls--prominent-uncontained .tabs-controls__button-wrapper.right{right:-16px}}.tabs-controls__after-line{flex:1}.tabs-controls--prominent-uncontained .tabs-controls__after-line,.tabs-controls--un-contained .tabs-controls__after-line{border-bottom:2px solid #f3f3f0}.tabs-controls--contained .tabs-controls__after-line{background:linear-gradient(90deg,#ccccd4,#ccccd4) 2px 100%/100% 2px no-repeat}.tabs-controls--prominent-uncontained .tabs-controls__underline,.tabs-controls--un-contained .tabs-controls__underline{position:absolute;bottom:0;left:0;height:2px;background:#33747a;transition:all .5s cubic-bezier(.4,0,.3,1);z-index:3}.tabs-controls--prominent-uncontained .tabs-controls__underline.theme-dark,.tabs-controls--un-contained .tabs-controls__underline.theme-dark{background:#0cc}.tabs-controls__list-position-wrapper{transition:all .5s cubic-bezier(.4,0,.3,1)}.tabs-controls__list-wrapper{position:relative;overflow:hidden}.tabs-controls__list-wrapper--gradient-left{left:0}.tabs-controls__list-wrapper--gradient-left.prominent-uncontained,.tabs-controls__list-wrapper--gradient-left.un-contained{background:linear-gradient(90deg,rgba(var(--background-color),1) 0%,rgba(var(--background-color),1) calc(0% + 12px),rgba(var(--background-color),0) 100%)}.tabs-controls__list-wrapper--gradient-left.contained{background:linear-gradient(90deg,rgba(var(--background-color),1) 0%,rgba(var(--background-color),1) calc(0% + 4px),rgba(var(--background-color),0) 100%)}@media (min-width: 1024px){.tabs-controls__list-wrapper--gradient-left.contained{background:linear-gradient(90deg,rgba(var(--background-color),1) 0%,rgba(var(--background-color),1) calc(0% + 12px),rgba(var(--background-color),0) 100%)}}.tabs-controls__list-wrapper--gradient-right{right:0}.tabs-controls__list-wrapper--gradient-right.prominent-uncontained,.tabs-controls__list-wrapper--gradient-right.un-contained{background:linear-gradient(90deg,rgba(var(--background-color),0) 0%,rgba(var(--background-color),1) calc(100% - 12px),rgba(var(--background-color),1) 100%)}.tabs-controls__list-wrapper--gradient-right.contained{background:linear-gradient(90deg,rgba(var(--background-color),0) 0%,rgba(var(--background-color),1) calc(100% - 4px),rgba(var(--background-color),1) 100%)}@media (min-width: 1024px){.tabs-controls__list-wrapper--gradient-right.contained{background:linear-gradient(90deg,rgba(var(--background-color),0) 0%,rgba(var(--background-color),1) calc(100% - 12px),rgba(var(--background-color),1) 100%)}}.tabs-controls__button-wrapper{display:flex;align-items:center;justify-content:center;position:absolute;height:100%;z-index:1}.tabs-controls__button-wrapper.left{left:-16px}@media (max-width: 359.78px){.tabs-controls__button-wrapper.left{left:0}}@media (min-width: 1024px){.tabs-controls__button-wrapper.left{left:-26px}}.tabs-controls__button-wrapper.right{right:-16px}@media (max-width: 359.78px){.tabs-controls__button-wrapper.right{right:0}}@media (min-width: 1024px){.tabs-controls__button-wrapper.right{right:-26px}}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "component", type: UiBadgeComponent, selector: "sie-ui-badge", inputs: ["mode", "type", "number", "addOutline", "highlighted", "status"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "directive", type: i1$1.AnchorButtonDirective, selector: "[sieCoreAnchorButton]", inputs: ["disabled"] }, { kind: "directive", type: i1$1.AddTooltipDirective, selector: "[sieCoreAddTooltip]" }, { kind: "component", type: UiButtonComponent, selector: "sie-ui-button" }, { kind: "directive", type: i1$1.AttributeDirective, selector: "[sieCoreAttributes]", inputs: ["sieCoreAttributes"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTabsControlsComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-tabs-controls', changeDetection: ChangeDetectionStrategy.OnPush, template: "<nav\n  class=\"tabs-controls tabs-controls--{{ type }} align-{{ align }}\"\n  (mouseleave)=\"mouseLeftContainer()\"\n  #tabsControls\n>\n  <div *ngIf=\"showLeft\" class=\"tabs-controls__button-wrapper left\">\n    <sie-ui-button\n      themeType=\"icon\"\n      variant=\"icon-un-contained\"\n      [icon]=\"iconReg.sieIcon.ArrowLeft\"\n      [iconScreenReaderText]=\"navigateLeftScreenReaderText\"\n      [background]=\"theme\"\n      (clicked)=\"positionToLeft()\"\n    ></sie-ui-button>\n  </div>\n  <div *ngIf=\"showRight\" class=\"tabs-controls__button-wrapper right\">\n    <sie-ui-button\n      themeType=\"icon\"\n      variant=\"icon-un-contained\"\n      [icon]=\"iconReg.sieIcon.ArrowRight\"\n      [iconScreenReaderText]=\"navigateRightScreenReaderText\"\n      [background]=\"theme\"\n      (clicked)=\"positionToRight()\"\n    ></sie-ui-button>\n  </div>\n\n  <div class=\"tabs-controls__list-wrapper\" #listWrapper>\n    <div\n      class=\"tabs-controls__list-position-wrapper\"\n      [ngStyle]=\"wrapperStyle\"\n      [ngClass]=\"{ 'no-transition': panStarted }\"\n      (panstart)=\"onPanStart()\"\n      (pan)=\"onPan($event)\"\n      (panend)=\"onPanEnd($event)\"\n      #container\n    >\n      <ul class=\"tabs-controls__list\" role=\"tablist\">\n        <li\n          *ngFor=\"let tab of tabs; let i = index\"\n          class=\"tabs-controls__item\"\n          role=\"tab\"\n          [ngClass]=\"{\n            active: activeItemIndex === i,\n            hide: tab.hide\n          }\"\n          (mouseenter)=\"!tab.disabled && mouseEnterItem(i)\"\n          #selectableItem\n        >\n          <a\n            sieCoreAnchorButton\n            class=\"tabs-controls__tab-button {{ 'theme-' + theme }}\"\n            [ngClass]=\"{ active: activeItemIndex === i, disabled: tab.disabled, 'with-icon': tab.icon }\"\n            [disabled]=\"tab.disabled\"\n            [sieCoreAttributes]=\"tab.dataAttributes\"\n            [attr.aria-expanded]=\"activeItemIndex === i\"\n            (click)=\"!tab.disabled && itemClicked(i, $event)\"\n            (keyup.enter)=\"!tab.disabled && itemClicked(i, $event)\"\n            (keyup.space)=\"!tab.disabled && moveUnderlineToItem(i)\"\n            (keyup.arrowLeft)=\"!tab.disabled && positionToLeft()\"\n            (keyup.arrowRight)=\"!tab.disabled && positionToRight()\"\n            (keydown.Tab)=\"blockScroll()\"\n            (focus)=\"!tab.disabled && moveUnderlineToItem(i, !tab.icon); !tab.disabled && bringIntoView(i)\"\n            (blur)=\"onBlur()\"\n          >\n            <sie-icon\n              *ngIf=\"tab.icon && type === 'un-contained'\"\n              class=\"tabs-controls__tab-icon\"\n              [name]=\"tab.icon.name\"\n              [ngStyle]=\"{ color: tab.icon.color, fill: tab.icon.color }\"\n            ></sie-icon>\n            <span\n              class=\"tabs-controls__tab-text\"\n              [ngClass]=\"{ 'with-spacing': tab.badge?.type === 'icon' && !tab.count && tab.count !== 0 }\"\n              (transitionend)=\"tabTextTransitionEnd()\"\n              sieCoreAddTooltip\n              >{{ tab.title }}</span\n            >\n            <span\n              class=\"tabs-controls__count\"\n              *ngIf=\"tab.count || tab.count === 0\"\n              [ngClass]=\"{ 'with-spacing': tab.badge?.type === 'icon' }\"\n              >({{ tab.count < countLimit ? tab.count : countExceededPlaceholder }})</span\n            >\n            <sie-ui-badge\n              *ngIf=\"tab.badge\"\n              class=\"tabs-controls__badge-wrapper tabs-controls__badge-wrapper--{{ tab.badge.type }}\"\n              [type]=\"tab.badge.type\"\n              [mode]=\"activeItemIndex === i && type === 'contained' ? 'dark' : tab.badge.mode\"\n              [status]=\"tab.badge.status\"\n              [number]=\"tab.badge.number\"\n              [highlighted]=\"type === 'un-contained' && activeItemIndex === i\"\n            ></sie-ui-badge>\n          </a>\n        </li>\n      </ul>\n\n      <div class=\"tabs-controls__underline {{ 'theme-' + theme }}\" [ngStyle]=\"underlineStyle\"></div>\n    </div>\n    <div *ngIf=\"showLeft\" class=\"tabs-controls__list-wrapper--gradient-left {{ type }}\"></div>\n    <div *ngIf=\"showRight\" class=\"tabs-controls__list-wrapper--gradient-right {{ type }}\"></div>\n  </div>\n  <ng-container *ngIf=\"afterLine\">\n    <div class=\"tabs-controls__after-line\"></div>\n  </ng-container>\n</nav>\n", styles: [".tabs-controls .tabs-controls__tab-button:focus,.tabs-controls .tabs-controls__tab-button:focus:not(.disabled),.tabs-controls .tabs-controls__tab-button:focus-visible{outline:0}.tabs-controls__list-wrapper--gradient-right,.tabs-controls__list-wrapper--gradient-left{position:absolute;display:block;top:0;bottom:0;pointer-events:none}.prominent-uncontained.tabs-controls__list-wrapper--gradient-right,.prominent-uncontained.tabs-controls__list-wrapper--gradient-left,.un-contained.tabs-controls__list-wrapper--gradient-right,.un-contained.tabs-controls__list-wrapper--gradient-left{width:70px}.contained.tabs-controls__list-wrapper--gradient-right,.contained.tabs-controls__list-wrapper--gradient-left{width:41px}@media (min-width: 1024px){.contained.tabs-controls__list-wrapper--gradient-right,.contained.tabs-controls__list-wrapper--gradient-left{width:58px}}.tabs-controls{position:relative;display:flex;justify-content:flex-start}.tabs-controls.align-center{justify-content:center}.tabs-controls.align-right{justify-content:flex-end}.tabs-controls .tabs-controls__tab-button:not(.disabled){position:relative;z-index:2}.tabs-controls .tabs-controls__tab-button:not(.disabled):focus:before{content:\"\";position:absolute;inset:0;z-index:1;border:1px solid #1491eb;border-radius:0}.tabs-controls .tabs-controls__tab-button:not(.disabled):focus-visible:before{content:\"\";position:absolute;inset:0;z-index:1;border:1px solid #1491eb;border-radius:0}.tabs-controls .tabs-controls__tab-button:not(.disabled):focus-visible:before{bottom:-2px}.tabs-controls .tabs-controls__tab-button:not(.disabled):focus:not(:focus-visible):before{border:none}.tabs-controls .tabs-controls__tab-button{display:flex;border:0;outline:0}.tabs-controls .tabs-controls__list{list-style:none;margin:0;padding:0}.tabs-controls__badge-wrapper{display:flex;align-self:flex-start}.tabs-controls__badge-wrapper--dot,.tabs-controls__badge-wrapper--icon{margin-top:2px}.tabs-controls__badge-wrapper--counter{margin-top:3px}.tabs-controls--un-contained .tabs-controls__list{display:flex}.tabs-controls--un-contained .tabs-controls__list .tabs-controls__item{position:relative}.tabs-controls--un-contained .tabs-controls__list .tabs-controls__item.hide{display:none}.tabs-controls--un-contained .tabs-controls__list .tabs-controls__tab-button{max-width:296px;border-bottom:2px solid #ccccd4;padding:5px 24px 7px;background:none;color:#000028}.tabs-controls--un-contained .tabs-controls__list .tabs-controls__tab-button:active,.tabs-controls--un-contained .tabs-controls__list .tabs-controls__tab-button.active{color:#33747a;fill:#33747a}.tabs-controls--un-contained .tabs-controls__list .tabs-controls__tab-button:disabled,.tabs-controls--un-contained .tabs-controls__list .tabs-controls__tab-button.disabled{color:#b3b3be;fill:#b3b3be}.tabs-controls--un-contained .tabs-controls__list .tabs-controls__tab-button:disabled:hover,.tabs-controls--un-contained .tabs-controls__list .tabs-controls__tab-button.disabled:hover{cursor:not-allowed}.tabs-controls--un-contained .tabs-controls__list .tabs-controls__tab-button:not(.disabled):hover{cursor:pointer}.tabs-controls--un-contained .tabs-controls__list .tabs-controls__tab-button .tabs-controls__tab-icon+.tabs-controls__tab-text{margin-left:8px}@media (max-width: 639.78px){.tabs-controls--un-contained .tabs-controls__list .tabs-controls__tab-button.with-icon{transition:max-width .5s cubic-bezier(.2,0,.38,.9)}.tabs-controls--un-contained .tabs-controls__list .tabs-controls__tab-button.with-icon:not(.active) .tabs-controls__tab-text{max-width:0;opacity:0;margin-left:0;transition:max-width .5s cubic-bezier(.2,0,.38,.9)}.tabs-controls--un-contained .tabs-controls__list .tabs-controls__tab-button.with-icon.active{opacity:1}}.tabs-controls--un-contained .tabs-controls__list .tabs-controls__tab-button .tabs-controls__tab-icon{margin-top:-1px;width:24px}.tabs-controls--un-contained .tabs-controls__list .tabs-controls__tab-button .tabs-controls__tab-text{white-space:nowrap;overflow:hidden;text-overflow:ellipsis;display:block;outline:none;max-width:100%;transition:max-width .5s cubic-bezier(.2,0,.38,.9)}.tabs-controls--un-contained .tabs-controls__list .tabs-controls__tab-button .tabs-controls__tab-text.with-spacing{padding-right:20px}.tabs-controls--un-contained .tabs-controls__list .tabs-controls__tab-button .tabs-controls__count{padding-left:4px}.tabs-controls--un-contained .tabs-controls__list .tabs-controls__tab-button .tabs-controls__count.with-spacing{padding-right:20px}.tabs-controls--un-contained .tabs-controls__list .tabs-controls__tab-button .tabs-controls__badge-wrapper--counter{margin-top:1px}.tabs-controls--un-contained .tabs-controls__list .tabs-controls__tab-button .tabs-controls__badge-wrapper--icon{position:absolute;right:24px;top:-1px}.tabs-controls--contained .tabs-controls__list{display:flex;max-height:68px;height:100%}.tabs-controls--contained .tabs-controls__list .tabs-controls__item{min-height:100%;min-width:130px;max-width:296px;position:relative;line-height:20px;margin:0 1px;transition:color .3s cubic-bezier(.2,0,.38,.9)}.tabs-controls--contained .tabs-controls__list .tabs-controls__item.hide{display:none}.tabs-controls--contained .tabs-controls__list .tabs-controls__item:first-child{margin-left:0}.tabs-controls--contained .tabs-controls__list .tabs-controls__item:last-child{margin-right:0}.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button{min-height:100%;width:100%;padding:6px 8px 20px;transition:color .3s cubic-bezier(.2,0,.38,.9)}.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button:not(.disabled):after{content:\"\";position:absolute;bottom:0;left:0;width:100%;height:100%;z-index:-1;background-position:top left;transition:background .3s cubic-bezier(.2,0,.38,.9)}.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button:not(.disabled):hover,.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button:not(.disabled):focus{cursor:pointer}.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button:disabled:hover,.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button.disabled:hover{cursor:not-allowed}.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button.theme-light{color:#000028;background-color:#ebf7f8;border-bottom:2px solid #9999a9}.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button.theme-light:not(.disabled):after{background:linear-gradient(to top,#33747a 50%,transparent 50%);background-size:100% 200%}.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button.theme-light:active,.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button.theme-light.active{color:#fff;border-bottom:2px solid #33747a}.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button.theme-light:active:after,.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button.theme-light.active:after{background-position:bottom left}.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button.theme-light:not(.disabled):hover,.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button.theme-light:not(.disabled):focus{border-color:#33747a;box-shadow:inset 0 -2px #33747a}.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button.theme-light:disabled,.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button.theme-light.disabled{color:#b3b3be;border-color:#ccccd4}.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button.theme-dark{color:#fff;background-color:#00183b;border-bottom:2px solid #ccccd4}.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button.theme-dark:not(.disabled):after{background:linear-gradient(to top,#00ffb9 50%,transparent 50%);background-size:100% 200%}.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button.theme-dark:active,.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button.theme-dark.active{color:#000028;border-bottom:2px solid #00ffb9}.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button.theme-dark:active:after,.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button.theme-dark.active:after{background-position:bottom left}.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button.theme-dark:not(.disabled):hover,.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button.theme-dark:not(.disabled):focus{border-color:#00ffb9;box-shadow:inset 0 -2px #00ffb9}.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button.theme-dark:disabled,.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button.theme-dark.disabled{color:#b3b3be;border-color:#737389}.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button .tabs-controls__tab-text{display:-webkit-box;-webkit-box-orient:vertical;-webkit-line-clamp:2;text-align:left;text-overflow:ellipsis;overflow:hidden}.tabs-controls--contained .tabs-controls__list .tabs-controls__tab-button .tabs-controls__badge-wrapper--dot{margin-top:3px}.tabs-controls--prominent-uncontained{container:list-container/inline-size}.tabs-controls--prominent-uncontained .tabs-controls__list{display:flex}.tabs-controls--prominent-uncontained .tabs-controls__list .tabs-controls__item{position:relative}.tabs-controls--prominent-uncontained .tabs-controls__list .tabs-controls__item.hide{display:none}.tabs-controls--prominent-uncontained .tabs-controls__list .tabs-controls__tab-button{max-width:296px;padding:0 16px 4px;background:none}.tabs-controls--prominent-uncontained .tabs-controls__list .tabs-controls__tab-button.theme-light{border-bottom:2px solid #ccccd4;color:#000028}.tabs-controls--prominent-uncontained .tabs-controls__list .tabs-controls__tab-button.theme-light:active,.tabs-controls--prominent-uncontained .tabs-controls__list .tabs-controls__tab-button.theme-light.active{color:#33747a;fill:#33747a}.tabs-controls--prominent-uncontained .tabs-controls__list .tabs-controls__tab-button.theme-light:disabled,.tabs-controls--prominent-uncontained .tabs-controls__list .tabs-controls__tab-button.theme-light.disabled{color:#b3b3be;fill:#b3b3be}.tabs-controls--prominent-uncontained .tabs-controls__list .tabs-controls__tab-button.theme-light:disabled:hover,.tabs-controls--prominent-uncontained .tabs-controls__list .tabs-controls__tab-button.theme-light.disabled:hover{cursor:not-allowed}.tabs-controls--prominent-uncontained .tabs-controls__list .tabs-controls__tab-button.theme-dark{border-bottom:2px solid #737389;color:#fff}.tabs-controls--prominent-uncontained .tabs-controls__list .tabs-controls__tab-button.theme-dark:active,.tabs-controls--prominent-uncontained .tabs-controls__list .tabs-controls__tab-button.theme-dark.active{color:#0cc;fill:#0cc}.tabs-controls--prominent-uncontained .tabs-controls__list .tabs-controls__tab-button.theme-dark:disabled,.tabs-controls--prominent-uncontained .tabs-controls__list .tabs-controls__tab-button.theme-dark.disabled{color:#737389;fill:#737389}.tabs-controls--prominent-uncontained .tabs-controls__list .tabs-controls__tab-button.theme-dark:disabled:hover,.tabs-controls--prominent-uncontained .tabs-controls__list .tabs-controls__tab-button.theme-dark.disabled:hover{cursor:not-allowed}.tabs-controls--prominent-uncontained .tabs-controls__list .tabs-controls__tab-button:not(.disabled):hover{cursor:pointer}.tabs-controls--prominent-uncontained .tabs-controls__list .tabs-controls__tab-button .tabs-controls__tab-text{white-space:nowrap;overflow:hidden;text-overflow:ellipsis;font-size:1.25rem;font-weight:900;line-height:1.625rem;display:block;outline:none;max-width:100%;transition:max-width .5s cubic-bezier(.2,0,.38,.9);letter-spacing:-.03125rem}.tabs-controls--prominent-uncontained .tabs-controls__list .tabs-controls__tab-button .tabs-controls__tab-text.with-spacing{padding-right:20px}.tabs-controls--prominent-uncontained .tabs-controls__button-wrapper.right{right:-26px}@container list-container (max-width: 1023px){.tabs-controls--prominent-uncontained .tabs-controls__list .tabs-controls__tab-button{max-width:236px;padding-bottom:6px}.tabs-controls--prominent-uncontained .tabs-controls__list .tabs-controls__tab-button .tabs-controls__tab-text{font-size:1rem;font-weight:900;line-height:1.5rem;letter-spacing:-.03125rem}@media (min-width: 1024px){.tabs-controls--prominent-uncontained .tabs-controls__list .tabs-controls__tab-button .tabs-controls__tab-text{font-size:1.25rem;font-weight:900;line-height:1.625rem}}.tabs-controls--prominent-uncontained .tabs-controls__button-wrapper.right{right:-16px}}.tabs-controls__after-line{flex:1}.tabs-controls--prominent-uncontained .tabs-controls__after-line,.tabs-controls--un-contained .tabs-controls__after-line{border-bottom:2px solid #f3f3f0}.tabs-controls--contained .tabs-controls__after-line{background:linear-gradient(90deg,#ccccd4,#ccccd4) 2px 100%/100% 2px no-repeat}.tabs-controls--prominent-uncontained .tabs-controls__underline,.tabs-controls--un-contained .tabs-controls__underline{position:absolute;bottom:0;left:0;height:2px;background:#33747a;transition:all .5s cubic-bezier(.4,0,.3,1);z-index:3}.tabs-controls--prominent-uncontained .tabs-controls__underline.theme-dark,.tabs-controls--un-contained .tabs-controls__underline.theme-dark{background:#0cc}.tabs-controls__list-position-wrapper{transition:all .5s cubic-bezier(.4,0,.3,1)}.tabs-controls__list-wrapper{position:relative;overflow:hidden}.tabs-controls__list-wrapper--gradient-left{left:0}.tabs-controls__list-wrapper--gradient-left.prominent-uncontained,.tabs-controls__list-wrapper--gradient-left.un-contained{background:linear-gradient(90deg,rgba(var(--background-color),1) 0%,rgba(var(--background-color),1) calc(0% + 12px),rgba(var(--background-color),0) 100%)}.tabs-controls__list-wrapper--gradient-left.contained{background:linear-gradient(90deg,rgba(var(--background-color),1) 0%,rgba(var(--background-color),1) calc(0% + 4px),rgba(var(--background-color),0) 100%)}@media (min-width: 1024px){.tabs-controls__list-wrapper--gradient-left.contained{background:linear-gradient(90deg,rgba(var(--background-color),1) 0%,rgba(var(--background-color),1) calc(0% + 12px),rgba(var(--background-color),0) 100%)}}.tabs-controls__list-wrapper--gradient-right{right:0}.tabs-controls__list-wrapper--gradient-right.prominent-uncontained,.tabs-controls__list-wrapper--gradient-right.un-contained{background:linear-gradient(90deg,rgba(var(--background-color),0) 0%,rgba(var(--background-color),1) calc(100% - 12px),rgba(var(--background-color),1) 100%)}.tabs-controls__list-wrapper--gradient-right.contained{background:linear-gradient(90deg,rgba(var(--background-color),0) 0%,rgba(var(--background-color),1) calc(100% - 4px),rgba(var(--background-color),1) 100%)}@media (min-width: 1024px){.tabs-controls__list-wrapper--gradient-right.contained{background:linear-gradient(90deg,rgba(var(--background-color),0) 0%,rgba(var(--background-color),1) calc(100% - 12px),rgba(var(--background-color),1) 100%)}}.tabs-controls__button-wrapper{display:flex;align-items:center;justify-content:center;position:absolute;height:100%;z-index:1}.tabs-controls__button-wrapper.left{left:-16px}@media (max-width: 359.78px){.tabs-controls__button-wrapper.left{left:0}}@media (min-width: 1024px){.tabs-controls__button-wrapper.left{left:-26px}}.tabs-controls__button-wrapper.right{right:-16px}@media (max-width: 359.78px){.tabs-controls__button-wrapper.right{right:0}}@media (min-width: 1024px){.tabs-controls__button-wrapper.right{right:-26px}}\n"] }]
        }], ctorParameters: function () { return [{ type: i1$1.LayoutService }, { type: i1.SieIconRegistryService }, { type: i0.ChangeDetectorRef }]; }, propDecorators: { containerElement: [{
                type: ViewChild,
                args: ['container']
            }], tabContainerElement: [{
                type: ViewChild,
                args: ['tabsControls']
            }], tabListContainerElement: [{
                type: ViewChild,
                args: ['listWrapper']
            }], selectableItems: [{
                type: ViewChildren,
                args: ['selectableItem']
            }], backgroundColor: [{
                type: HostBinding,
                args: [`style.${ComponentTabsVarBackgroundColor}`]
            }, {
                type: Input
            }], selectedItemIndex: [{
                type: Input
            }], afterLine: [{
                type: Input
            }], tabs: [{
                type: Input
            }], type: [{
                type: Input
            }], theme: [{
                type: Input
            }], align: [{
                type: Input
            }], navigateLeftScreenReaderText: [{
                type: Input
            }], navigateRightScreenReaderText: [{
                type: Input
            }], selectionChanged: [{
                type: Output
            }], selectedItemIndexChange: [{
                type: Output
            }], tabClicked: [{
                type: Output
            }] } });

/**
 * This directive is used in conjunction with the tabs container component to set the item
 * to be rendered inside the tabs.
 */
class UiTabRenderDirective {
    /**
     * @param item Sets item that needs to be rendered inside the tabs.
     */
    set itemToRender(item) {
        this.uiTabsContainerComponentService.renderChild(this.viewContainer, item);
    }
    constructor(viewContainer, uiTabsContainerComponentService) {
        this.viewContainer = viewContainer;
        this.uiTabsContainerComponentService = uiTabsContainerComponentService;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTabRenderDirective, deps: [{ token: i0.ViewContainerRef }, { token: UI_TABS_CONTAINER_WEB_COMPONENT_SERVICE }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: UiTabRenderDirective, selector: "[sieUiTabRender]", inputs: { itemToRender: "itemToRender" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTabRenderDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[sieUiTabRender]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ViewContainerRef }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [UI_TABS_CONTAINER_WEB_COMPONENT_SERVICE]
                }] }]; }, propDecorators: { itemToRender: [{
                type: Input
            }] } });

class UiTabsShouldRenderTabPipe {
    constructor() {
        this.alreadyRenderedTabs = [];
    }
    transform(indexOfTab, selectedTab) {
        let render = this.alreadyRenderedTabs.findIndex(index => index === indexOfTab) >= 0;
        if (!render && indexOfTab === selectedTab) {
            render = true;
            this.alreadyRenderedTabs.push(indexOfTab);
        }
        return render;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTabsShouldRenderTabPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe }); }
    static { this.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiTabsShouldRenderTabPipe, name: "sieUiTabsShouldRenderTab" }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTabsShouldRenderTabPipe, decorators: [{
            type: Pipe,
            args: [{ name: 'sieUiTabsShouldRenderTab' }]
        }] });

/**
 * # Tabs Container Component
 *
 * Provide direct access to contents of a category.
 * Use tabs when there are multiple items of equal importance available.
 *
 * ## Component variations
 *
 * - contained tabs
 * - uncontained tabs
 *
 * ## Content
 *
 * The content of tabs can be passed as child elements with using `sieUiTab`.
 * See the example below.
 *
 * ## Code example
 * @example
 * Template:
 * ```html
 * <sie-ui-tabs-container [tabs]="tabs" type="contained" theme="dark">
 *  <ng-template sieUiTab> Item 1</ng-template>
 *  <ng-template sieUiTab> Item 2</ng-template>
 *  <ng-template sieUiTab> Item 3</ng-template>
 *  <ng-template sieUiTab> Item 4</ng-template>
 * </sie-ui-tabs-container>
 * ```
 *
 * Tabs container data example:
 * ```js
 * tabs: TabsControlConfig = [
 *  {
 *    title: 'Any valid HTML',
 *    badge: {
 *      type: 'counter',
 *      status: 'error',
 *      mode: 'light',
 *      number: 1
 *    },
 *    icon: {
 *      name: 'InformationFilled',
 *      color: '#FF9000',
 *    },
 *    count: 99
 *  },
 *  {
 *    title: 'Any valid HTML',
 *    badge: {
 *      type: 'dot',
 *      status: 'warning',
 *      mode: 'light'
 *    },
 *    count: 1000
 *  },
 *  {
 *    title: 'Any valid HTML'
 *  }
 * ];
 * ```
 */
class UiTabsContainerComponent {
    /**
     * @param value {@link TabsControlConfig Config} Defines data of tabs that will be displayed in tabs controls.
     */
    set tabs(value) {
        this._tabs = value;
    }
    get tabs() {
        return this._tabs;
    }
    /**
     * @param value Defines which tab should be selected by default.
     * @default 0
     */
    set selectedItemIndex(value) {
        this._selectedItemIndex = coerceNumberProperty(value);
    }
    get selectedItemIndex() {
        return this._selectedItemIndex;
    }
    constructor(cdr, uiTabsContainerComponentService) {
        this.cdr = cdr;
        this.uiTabsContainerComponentService = uiTabsContainerComponentService;
        /**
         * Defines {@link TabsControlsType Type} which tab style should be used
         * @default 'un-contained'
         */
        this.type = 'un-contained';
        /**
         * Defines {@link ThemeVariant Variant} theme of the tabs
         * @default 'light'
         */
        this.theme = 'light';
        /**
         * Event triggered when a different tab item is selected.
         */
        this.selectedItemIndexChange = new EventEmitter();
        this._selectedItemIndex = 0;
    }
    /** @ignore */
    ngAfterViewInit() {
        this.uiTabsContainerComponentService.init(this);
    }
    /**
     * @param index Selects the tab.
     */
    selectTab(index) {
        this.selectedItemIndex = index;
        this.updateView();
    }
    /** @ignore */
    selectedItemChanged(index) {
        this.selectedItemIndexChange.emit(index);
    }
    /**
     * Updates the view by calling the change detection.
     */
    /** @ignore */
    updateView() {
        this.cdr.detectChanges();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTabsContainerComponent, deps: [{ token: i0.ChangeDetectorRef }, { token: UI_TABS_CONTAINER_WEB_COMPONENT_SERVICE }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiTabsContainerComponent, selector: "sie-ui-tabs-container", inputs: { tabs: "tabs", selectedItemIndex: "selectedItemIndex", type: "type", theme: "theme", backgroundColor: "backgroundColor" }, outputs: { selectedItemIndexChange: "selectedItemIndexChange" }, queries: [{ propertyName: "tabContents", predicate: UiTabDirective }], viewQueries: [{ propertyName: "elementsRef", first: true, predicate: ["elements"], descendants: true }], ngImport: i0, template: "<div #elements class=\"tabs-container\">\n  <ng-content select=\".tabs-item\"></ng-content>\n</div>\n\n<sie-ui-tabs-controls\n  [tabs]=\"tabs\"\n  [type]=\"type\"\n  [theme]=\"theme\"\n  [(selectedItemIndex)]=\"selectedItemIndex\"\n  [backgroundColor]=\"backgroundColor\"\n  (selectionChanged)=\"selectedItemChanged($event)\"\n></sie-ui-tabs-controls>\n<div *ngFor=\"let tab of tabContents; let i = index\" [ngStyle]=\"{ display: selectedItemIndex === i ? 'block' : 'none' }\">\n  <div *ngIf=\"i | sieUiTabsShouldRenderTab: selectedItemIndex\" sieUiTabRender [itemToRender]=\"tab\"></div>\n</div>\n", styles: [".tabs-container{display:none}\n"], dependencies: [{ kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "component", type: UiTabsControlsComponent, selector: "sie-ui-tabs-controls", inputs: ["backgroundColor", "selectedItemIndex", "afterLine", "tabs", "type", "theme", "align", "navigateLeftScreenReaderText", "navigateRightScreenReaderText"], outputs: ["selectionChanged", "selectedItemIndexChange", "tabClicked"] }, { kind: "directive", type: UiTabRenderDirective, selector: "[sieUiTabRender]", inputs: ["itemToRender"] }, { kind: "pipe", type: UiTabsShouldRenderTabPipe, name: "sieUiTabsShouldRenderTab" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTabsContainerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-tabs-container', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div #elements class=\"tabs-container\">\n  <ng-content select=\".tabs-item\"></ng-content>\n</div>\n\n<sie-ui-tabs-controls\n  [tabs]=\"tabs\"\n  [type]=\"type\"\n  [theme]=\"theme\"\n  [(selectedItemIndex)]=\"selectedItemIndex\"\n  [backgroundColor]=\"backgroundColor\"\n  (selectionChanged)=\"selectedItemChanged($event)\"\n></sie-ui-tabs-controls>\n<div *ngFor=\"let tab of tabContents; let i = index\" [ngStyle]=\"{ display: selectedItemIndex === i ? 'block' : 'none' }\">\n  <div *ngIf=\"i | sieUiTabsShouldRenderTab: selectedItemIndex\" sieUiTabRender [itemToRender]=\"tab\"></div>\n</div>\n", styles: [".tabs-container{display:none}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [UI_TABS_CONTAINER_WEB_COMPONENT_SERVICE]
                }] }]; }, propDecorators: { tabContents: [{
                type: ContentChildren,
                args: [UiTabDirective]
            }], elementsRef: [{
                type: ViewChild,
                args: ['elements']
            }], tabs: [{
                type: Input
            }], selectedItemIndex: [{
                type: Input
            }], type: [{
                type: Input
            }], theme: [{
                type: Input
            }], backgroundColor: [{
                type: Input
            }], selectedItemIndexChange: [{
                type: Output
            }] } });

class UiTabsContainerNgService {
    init() {
        // don't do anything here
    }
    resetUnderline() {
        // don't do anything here
    }
    renderChild(viewContainer, item) {
        viewContainer.createEmbeddedView(item.templateRef);
    }
}

class UiTabsContainerComponentElementsService {
    static getDomItems(component) {
        const itemsNodeList = component.elementsRef.nativeElement.querySelectorAll('.tabs-item');
        return Array.from(itemsNodeList);
    }
    init(component) {
        component.tabContents = UiTabsContainerComponentElementsService.getDomItems(component);
        component.updateView();
    }
    resetUnderline(component) {
        component._resetUnderline();
    }
    renderChild(viewContainer, item) {
        if (item) {
            viewContainer.element.nativeElement.appendChild(item);
        }
    }
}

/**
 * # Tabs Module
 * - {@link UiTabsContainerComponent}
 * - {@link UiTabsControlsComponent}
 *
 * ## Module peer dependencies
 * - {@link SieIconsModule}
 */
class UiTabsModule {
    static forWebComponent() {
        const providers = [
            {
                provide: UI_TABS_CONTAINER_WEB_COMPONENT_SERVICE,
                useClass: UiTabsContainerComponentElementsService
            }
        ];
        return {
            ngModule: UiTabsModule,
            providers
        };
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTabsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiTabsModule, declarations: [UiTabsControlsComponent,
            UiTabsContainerComponent,
            UiTabDirective,
            UiTabRenderDirective,
            UiTabsShouldRenderTabPipe], imports: [CommonModule,
            UiBadgeModule,
            SieIconsModule,
            AnchorButtonModule,
            AddTooltipModule,
            UiButtonModule,
            AttributeModule], exports: [UiTabsControlsComponent, UiTabsContainerComponent, UiTabDirective] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTabsModule, providers: [
            {
                provide: UI_TABS_CONTAINER_WEB_COMPONENT_SERVICE,
                useClass: UiTabsContainerNgService
            }
        ], imports: [CommonModule,
            UiBadgeModule,
            SieIconsModule,
            AnchorButtonModule,
            AddTooltipModule,
            UiButtonModule,
            AttributeModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTabsModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        UiTabsControlsComponent,
                        UiTabsContainerComponent,
                        UiTabDirective,
                        UiTabRenderDirective,
                        UiTabsShouldRenderTabPipe
                    ],
                    providers: [
                        {
                            provide: UI_TABS_CONTAINER_WEB_COMPONENT_SERVICE,
                            useClass: UiTabsContainerNgService
                        }
                    ],
                    imports: [
                        CommonModule,
                        UiBadgeModule,
                        SieIconsModule,
                        AnchorButtonModule,
                        AddTooltipModule,
                        UiButtonModule,
                        AttributeModule
                    ],
                    exports: [UiTabsControlsComponent, UiTabsContainerComponent, UiTabDirective]
                }]
        }] });

// When a new validation rule is added (e.g. for a "random" case) make sure following applies:
// 1. Add an entry to `InputValidity` like `RandomError` (Pascal Case)
// 2. Add an input for a corresponding message like `randomErrorMessage` (Camel Case)
//
// In case inputs containing: 'ErrorMessage', 'min', 'max', 'step' in their name change, the component
// will automatically regenerate the error messages with the correct values.
//
// Error messages can contain following placeholders: '<MIN_VALUE>', '<MAX_VALUE>', '<STEP_SIZE>'.
// These placeholders will be automatically replaced with the correct input values.
// For reference see: `populateErrorMessages()`
/** @ignore */
var InputValidity$1;
(function (InputValidity) {
    InputValidity[InputValidity["Valid"] = 0] = "Valid";
    InputValidity[InputValidity["RequiredError"] = 1] = "RequiredError";
    InputValidity[InputValidity["RangeError"] = 2] = "RangeError";
    InputValidity[InputValidity["RangeMinError"] = 3] = "RangeMinError";
    InputValidity[InputValidity["RangeMaxError"] = 4] = "RangeMaxError";
    InputValidity[InputValidity["StepSizeError"] = 5] = "StepSizeError";
})(InputValidity$1 || (InputValidity$1 = {}));
/**
 * Data type for validity state changes
 */
class UiNumericInputValidityChange {
    /**
     * @param previous Previous validity state (`true` = valid)
     * @param current Current validity state (`true` = valid)
     * @param [errorMessage] Error message representing current validity state
     */
    constructor(previous, current, errorMessage) {
        this.previous = previous;
        this.current = current;
        this.errorMessage = errorMessage;
    }
}
/**
 * # Numeric Input Component
 *
 * Numeric Inputs are components that let the users choose the value they want to submit, e.g. as part of the form.
 *
 * ## Component variations
 * There are no variations
 *
 * ## Content
 *
 * The numeric input component does not accept any content.
 *
 * ## Code example
 * @example ```html
 * <sie-ui-numeric-input
 *   [min]="1"
 *   [max]="10"
 *   [value]="1"
 *   rangeErrorMessage="Invalid value. Please enter a value between <MIN_VALUE> and <MAX_VALUE>."
 *   rangeMinErrorMessage="Invalid value. Please enter a value >= <MIN_VALUE>."
 *   rangeMaxErrorMessage="Invalid value. Please enter a value between <MIN_VALUE> and <MAX_VALUE>."
 *   requiredErrorMessage="Invalid value. Please enter a value."
 *   stepSizeErrorMessage="Invalid value. Please enter a value in multiple of <STEP_SIZE>."
 *   label="Enter a number"
 * ></sie-ui-numeric-input>
 * ```
 */
class UiNumericInputComponent extends NgFormControlDirective {
    /**
     * @param value Defines the current value of the component
     * @default 0 (if not provided, it will have the same value as `min`)
     */
    set value(value) {
        this._value = coerceNumberProperty(value, null);
        this.validateValue();
    }
    get value() {
        return this._value;
    }
    /**
     * @param value Defines the maximum value of the component
     */
    set max(value) {
        this._max = coerceNumberProperty(value);
    }
    get max() {
        return this._max;
    }
    /**
     * @param min Defines the minimal value of the component
     * @default 0
     */
    set min(min) {
        this._min = coerceNumberProperty(min);
    }
    get min() {
        return this._min;
    }
    /**
     * @param step Defines the step in which the value can be increased or decreased
     * @default 1
     */
    set step(step) {
        this._step = coerceNumberProperty(step);
    }
    get step() {
        return this._step;
    }
    /**
     * @param decimal Defines if the value can be decimal (not fully implemented yet, decimal separators missing)
     * @default false
     */
    set decimal(decimal) {
        this._decimal = coerceBooleanProperty(decimal);
    }
    get decimal() {
        return this._decimal;
    }
    /**
     * @param required Defines if the component's input is required
     * @default false
     */
    set required(required) {
        this._required = coerceBooleanProperty(required);
    }
    get required() {
        return this._required;
    }
    /**
     * @param allowNegative Defines if the component allows negative numbers (not fully implemented yet)
     * @default false
     */
    set allowNegative(allowNegative) {
        this._allowNegative = coerceBooleanProperty(allowNegative);
    }
    get allowNegative() {
        return this._allowNegative;
    }
    /**
     * @param suppressErrorLabel Defines if the error message for the wrong input should be shown or not
     * @default false
     */
    set suppressErrorLabel(suppressErrorLabel) {
        this._suppressErrorLabel = coerceBooleanProperty(suppressErrorLabel);
    }
    get suppressErrorLabel() {
        return this._suppressErrorLabel;
    }
    /** @ignore */
    get inputId() {
        return this._inputId;
    }
    /** @ignore */
    get isInvalid() {
        return this.validityState !== InputValidity$1.Valid;
    }
    /** @ignore */
    get isEmpty() {
        return this._value === null;
    }
    /** @ignore */
    get controlsHovered() {
        return this._controlsHovered;
    }
    /** @ignore */
    get inputFocused() {
        return this._inputFocused;
    }
    /** @ignore */
    get error() {
        return this._error;
    }
    /** @ignore */
    get disableArrowUp() {
        return this._value >= this._max || this.disabled;
    }
    /** @ignore */
    get disableArrowDown() {
        return this._value <= this.min || this.disabled;
    }
    constructor(iconReg) {
        super();
        this.iconReg = iconReg;
        /**
         * Event triggered when the value of the numeric input is changed
         */
        this.valueChange = new EventEmitter();
        /**
         * {@link UiNumericInputValidityChange Event} triggered when the value of numeric input goes from the invalid to valid value, and vice versa
         */
        this.validationStateChanged = new EventEmitter();
        this._inputId = getUniqueID('numeric-input');
        this.validityState = InputValidity$1.Valid;
        this.errorMessages = [''];
        this._controlsHovered = false;
        this._inputFocused = false;
        this._min = 0;
        this._max = Infinity;
        this._step = 1;
        this._decimal = false;
        this._allowNegative = false;
        this._suppressErrorLabel = false;
    }
    /** @ignore */
    ngOnChanges(changes) {
        const messagePopulationTriggers = ['ErrorMessage', 'min', 'max', 'step'];
        const populateMessages = Object.keys(changes).some(change => messagePopulationTriggers.some(trigger => change.includes(trigger)));
        if (populateMessages) {
            this.populateErrorMessages();
            this.validateValue();
        }
    }
    /** @ignore */
    ngOnInit() {
        if (!this._value) {
            this._value = this.min;
        }
    }
    /** @ignore */
    validateKeyDown(event) {
        const whitelistedKeys = [
            KeyboardKey.Backspace,
            KeyboardKey.Escape,
            KeyboardKey.Enter,
            KeyboardKey.Tab,
            KeyboardKey.ArrowUp,
            KeyboardKey.ArrowDown,
            KeyboardKey.ArrowLeft,
            KeyboardKey.ArrowRight
        ];
        this.decimal && whitelistedKeys.push(KeyboardKey.Period);
        const comparator = KeyboardEventUtil.is(event.key);
        let valid = false;
        valid ||= comparator.numeric();
        valid ||= comparator.equalToKey(...whitelistedKeys);
        valid ||= event.ctrlKey || event.metaKey;
        if (!valid) {
            event.preventDefault();
        }
        return valid;
    }
    /** @ignore */
    onModelChange(value) {
        this.validateValue();
        this.valueChange.emit(value);
        this.markAsTouched();
        this.onChange(value);
    }
    /** @ignore */
    onStepUp(event) {
        event?.preventDefault();
        if (!this.disableArrowUp) {
            if (this._value < this.min) {
                this._value = this.min;
            }
            else {
                const mod = (this._value - this.min) % this.step;
                if (mod) {
                    this._value = Math.max(Math.min(this._value + (this.step - mod), this.max), this.min);
                }
                else {
                    this._value = Math.max(Math.min(this._value + this.step, this.max), this.min);
                }
            }
            this.onModelChange(this._value);
        }
    }
    /** @ignore */
    onStepDown(event) {
        event?.preventDefault();
        if (!this.disableArrowDown) {
            const mod = (this._value - this.min) % this.step;
            if (mod) {
                this._value = Math.min(Math.max(this._value - mod, this.min), this.max);
            }
            else {
                this._value = Math.min(Math.max(this._value - this.step, this.min), this.max);
            }
            this.onModelChange(this._value);
        }
    }
    /** @ignore */
    onControlsHover() {
        this._controlsHovered = true;
    }
    /** @ignore */
    onControlsHoverEnd() {
        this._controlsHovered = false;
    }
    /** @ignore */
    onInputFocus() {
        this._inputFocused = true;
    }
    /** @ignore */
    onInputBlur() {
        this._inputFocused = false;
    }
    populateErrorMessages() {
        ArrayUtil.fromEnum(InputValidity$1).forEach((validityState) => {
            const errorMessageInput = StringUtil.unCapitalize(validityState) + 'Message';
            if (this[errorMessageInput]) {
                this.errorMessages[InputValidity$1[validityState]] = this[errorMessageInput]
                    .replace('<MIN_VALUE>', this.min)
                    .replace('<MAX_VALUE>', this.max)
                    .replace('<STEP_SIZE>', this.step);
            }
        });
    }
    validateValue() {
        const condition = (testCondition, error) => {
            return testCondition ? error : InputValidity$1.Valid;
        };
        let validity = InputValidity$1.Valid;
        validity ||= condition(this.required && this._value === null, InputValidity$1.RequiredError);
        validity ||= condition(this._value < this.min || this._value > this.max, InputValidity$1.RangeError);
        validity ||= condition(this._value < this.min, InputValidity$1.RangeMinError);
        validity ||= condition(this.max !== Infinity && this._value > this.max, InputValidity$1.RangeMaxError);
        validity ||= condition(!!((this._value - this.min) % this.step), InputValidity$1.StepSizeError);
        this.emitValidityChange(validity, this.errorMessages[validity]);
        this.validityState = validity;
    }
    emitValidityChange(newValidity, newErrorMessage) {
        if (this.validityState !== newValidity || this._error !== newErrorMessage) {
            this.validationStateChanged.emit(new UiNumericInputValidityChange(!this.validityState, !newValidity, newErrorMessage));
        }
        this._error = newErrorMessage;
    }
    /** @ignore */
    validateInternal() {
        this.validateValue();
        if (this.validityState !== InputValidity$1.Valid) {
            return { invalid: this.validityState };
        }
        return null;
    }
    /** @ignore */
    writeValue(value) {
        this._value = value;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiNumericInputComponent, deps: [{ token: i1.SieIconRegistryService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiNumericInputComponent, selector: "sie-ui-numeric-input", inputs: { value: "value", max: "max", min: "min", step: "step", decimal: "decimal", required: "required", allowNegative: "allowNegative", suppressErrorLabel: "suppressErrorLabel", requiredErrorMessage: "requiredErrorMessage", rangeErrorMessage: "rangeErrorMessage", rangeMinErrorMessage: "rangeMinErrorMessage", rangeMaxErrorMessage: "rangeMaxErrorMessage", stepSizeErrorMessage: "stepSizeErrorMessage" }, outputs: { valueChange: "valueChange", validationStateChanged: "validationStateChanged" }, providers: [
            {
                provide: NG_VALUE_ACCESSOR,
                multi: true,
                useExisting: UiNumericInputComponent
            },
            {
                provide: NG_VALIDATORS,
                multi: true,
                useExisting: UiNumericInputComponent
            }
        ], usesInheritance: true, usesOnChanges: true, ngImport: i0, template: "<div\n  *ngIf=\"!readonly; else readOnly\"\n  class=\"numeric-input\"\n  [ngClass]=\"{\n    'controls-hovered': controlsHovered,\n    'is-focused': inputFocused,\n    'is-invalid': isInvalid,\n    'has-label': label,\n    'is-disabled': disabled,\n    'bg-dark': theme === 'dark'\n  }\"\n>\n  <label *ngIf=\"label\" [for]=\"inputId\" class=\"numeric-input__label\">{{ label }}<span *ngIf=\"required\">*</span></label>\n  <input\n    [id]=\"inputId\"\n    class=\"numeric-input__input-field\"\n    type=\"number\"\n    [(ngModel)]=\"value\"\n    (ngModelChange)=\"onModelChange($event)\"\n    (keydown)=\"validateKeyDown($event)\"\n    (keydown.arrowUp)=\"onStepUp($event)\"\n    (keydown.arrowDown)=\"onStepDown($event)\"\n    (focus)=\"onInputFocus()\"\n    (blur)=\"onInputBlur()\"\n    [name]=\"name\"\n    [disabled]=\"disabled\"\n  />\n  <div class=\"numeric-input__buttons\" (mouseenter)=\"onControlsHover()\" (mouseleave)=\"onControlsHoverEnd()\">\n    <sie-ui-button\n      class=\"numeric-input__button-down\"\n      position=\"content\"\n      variant=\"icon-un-contained\"\n      [disabled]=\"disableArrowDown\"\n      [focusable]=\"false\"\n      [icon]=\"iconReg.sieIcon.SieportalArrowBig\"\n      themeType=\"icon\"\n      [background]=\"theme\"\n      (clicked)=\"onStepDown()\"\n    ></sie-ui-button>\n    <sie-ui-button\n      class=\"numeric-input__button-up step-up-button\"\n      position=\"content\"\n      variant=\"icon-un-contained\"\n      [disabled]=\"disableArrowUp\"\n      [focusable]=\"false\"\n      [icon]=\"iconReg.sieIcon.SieportalArrowBig\"\n      themeType=\"icon\"\n      [background]=\"theme\"\n      (clicked)=\"onStepUp()\"\n    ></sie-ui-button>\n  </div>\n</div>\n<div class=\"numeric-input-error\" *ngIf=\"!suppressErrorLabel && isInvalid\">{{ error }}</div>\n<sie-ui-richtext\n  *ngIf=\"hint?.type === 'inline' && hint?.content\"\n  [content]=\"hint.content\"\n  class=\"numeric-input-hint\"\n  [ngClass]=\"theme\"\n></sie-ui-richtext>\n<ng-template #readOnly>\n  <sie-ui-readonly\n    [value]=\"value\"\n    [label]=\"label\"\n    [name]=\"this.name\"\n    [displayValue]=\"value\"\n    [theme]=\"theme\"\n  ></sie-ui-readonly>\n</ng-template>\n", styles: [".numeric-input__input-field:focus,.numeric-input__input-field:focus-visible{outline:0}input::-webkit-outer-spin-button,input::-webkit-inner-spin-button{-webkit-appearance:none;margin:0}input[type=number]{-moz-appearance:textfield;font-family:inherit}:host{display:flex;flex-direction:column}.numeric-input{--color: #000028;--background: #ebf7f8;--label: #4c4c68;--border: #4c4c68;display:inline-flex;position:relative;width:100%;height:100%;min-height:3.5rem;border-bottom:1px solid var(--border);padding:0 55px 0 16px;background-color:var(--background);flex-wrap:wrap}@media print{.numeric-input{-webkit-print-color-adjust:exact;print-color-adjust:exact}}.numeric-input:not(.has-label){align-items:center;min-height:2.5rem}.numeric-input__label{font-size:.75rem;font-weight:400;line-height:1rem;white-space:nowrap;overflow:hidden;text-overflow:ellipsis;display:inline-block;width:100%;margin-top:6px;color:var(--label)}.numeric-input__input-field{font-size:1rem;font-weight:400;line-height:1.5rem;display:flex;width:100%;height:100%;border:0;padding:0;background-color:transparent;color:var(--color)}.has-label .numeric-input__input-field{height:1.5rem;margin-top:-.375rem}.numeric-input.is-disabled{--color: #b3b3be;border-bottom:none}.numeric-input.is-disabled .numeric-input__label{color:var(--color)}.numeric-input.is-invalid:not(.is-disabled){--background: #fcccd7;--label: #ef0137;--border: #ef0137}.numeric-input:hover:not(.is-invalid):not(.is-disabled){--background: #d1fff2;--border: #00d7a0}.numeric-input:hover:not(.is-invalid):not(.is-disabled):not(.controls-hovered),.numeric-input:hover:not(.is-invalid):not(.is-disabled).is-focused{--label: #33747a}.numeric-input__buttons{display:flex;flex-shrink:0;flex-grow:0;flex-direction:column-reverse;position:absolute;top:50%;right:12px;margin-left:24px;transform:translateY(-50%)}.coarse .numeric-input__buttons{flex-direction:row}.coarse .numeric-input__buttons .step-up-button{margin-bottom:0}.coarse .numeric-input__buttons sie-ui-button{display:flex;--icon-size-custom: 16px;--btn-width-custom: 24px;--btn-height-custom: 24px}.numeric-input__button-down,.numeric-input__button-up{display:flex;--icon-size-custom: 14px;--btn-width-custom: 18px;--btn-height-custom: 18px}.numeric-input__button-up{transform:rotate(180deg)}.has-label .numeric-input__button-up{margin-bottom:3px}.numeric-input.bg-dark{--color: #fff;--background: #00183b;--label: #ccccd4;--border: #ccccd4}.numeric-input.bg-dark.is-disabled{--color: #737389}.numeric-input.bg-dark.is-invalid:not(.is-disabled){--background: #331131}.numeric-input.bg-dark:hover:not(.is-invalid):not(.is-disabled){--background: #001f39;--border: #00d7a0}.numeric-input.bg-dark:hover:not(.is-invalid):not(.is-disabled):not(.controls-hovered),.numeric-input.bg-dark:hover:not(.is-invalid):not(.is-disabled).is-focused{--label: #00d7a0}.numeric-input-error{font-size:.875rem;font-weight:400;line-height:1.25rem;margin-top:4px;color:#ef0137}.numeric-input-hint{--hint: #4c4c68;font-size:.75rem;font-weight:400;line-height:1rem;margin-top:8px;color:var(--hint)}.numeric-input-hint.dark{--hint: #ccccd4}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: UiButtonComponent, selector: "sie-ui-button" }, { kind: "directive", type: i3.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i3.NumberValueAccessor, selector: "input[type=number][formControlName],input[type=number][formControl],input[type=number][ngModel]" }, { kind: "directive", type: i3.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i3.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "component", type: UiReadonlyComponent, selector: "sie-ui-readonly", inputs: ["value", "label", "displayValue", "name", "theme", "icons"] }, { kind: "component", type: UiRichtextComponent, selector: "sie-ui-richtext", inputs: ["content", "theme", "whiteListedTags"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiNumericInputComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-numeric-input', changeDetection: ChangeDetectionStrategy.OnPush, providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            multi: true,
                            useExisting: UiNumericInputComponent
                        },
                        {
                            provide: NG_VALIDATORS,
                            multi: true,
                            useExisting: UiNumericInputComponent
                        }
                    ], template: "<div\n  *ngIf=\"!readonly; else readOnly\"\n  class=\"numeric-input\"\n  [ngClass]=\"{\n    'controls-hovered': controlsHovered,\n    'is-focused': inputFocused,\n    'is-invalid': isInvalid,\n    'has-label': label,\n    'is-disabled': disabled,\n    'bg-dark': theme === 'dark'\n  }\"\n>\n  <label *ngIf=\"label\" [for]=\"inputId\" class=\"numeric-input__label\">{{ label }}<span *ngIf=\"required\">*</span></label>\n  <input\n    [id]=\"inputId\"\n    class=\"numeric-input__input-field\"\n    type=\"number\"\n    [(ngModel)]=\"value\"\n    (ngModelChange)=\"onModelChange($event)\"\n    (keydown)=\"validateKeyDown($event)\"\n    (keydown.arrowUp)=\"onStepUp($event)\"\n    (keydown.arrowDown)=\"onStepDown($event)\"\n    (focus)=\"onInputFocus()\"\n    (blur)=\"onInputBlur()\"\n    [name]=\"name\"\n    [disabled]=\"disabled\"\n  />\n  <div class=\"numeric-input__buttons\" (mouseenter)=\"onControlsHover()\" (mouseleave)=\"onControlsHoverEnd()\">\n    <sie-ui-button\n      class=\"numeric-input__button-down\"\n      position=\"content\"\n      variant=\"icon-un-contained\"\n      [disabled]=\"disableArrowDown\"\n      [focusable]=\"false\"\n      [icon]=\"iconReg.sieIcon.SieportalArrowBig\"\n      themeType=\"icon\"\n      [background]=\"theme\"\n      (clicked)=\"onStepDown()\"\n    ></sie-ui-button>\n    <sie-ui-button\n      class=\"numeric-input__button-up step-up-button\"\n      position=\"content\"\n      variant=\"icon-un-contained\"\n      [disabled]=\"disableArrowUp\"\n      [focusable]=\"false\"\n      [icon]=\"iconReg.sieIcon.SieportalArrowBig\"\n      themeType=\"icon\"\n      [background]=\"theme\"\n      (clicked)=\"onStepUp()\"\n    ></sie-ui-button>\n  </div>\n</div>\n<div class=\"numeric-input-error\" *ngIf=\"!suppressErrorLabel && isInvalid\">{{ error }}</div>\n<sie-ui-richtext\n  *ngIf=\"hint?.type === 'inline' && hint?.content\"\n  [content]=\"hint.content\"\n  class=\"numeric-input-hint\"\n  [ngClass]=\"theme\"\n></sie-ui-richtext>\n<ng-template #readOnly>\n  <sie-ui-readonly\n    [value]=\"value\"\n    [label]=\"label\"\n    [name]=\"this.name\"\n    [displayValue]=\"value\"\n    [theme]=\"theme\"\n  ></sie-ui-readonly>\n</ng-template>\n", styles: [".numeric-input__input-field:focus,.numeric-input__input-field:focus-visible{outline:0}input::-webkit-outer-spin-button,input::-webkit-inner-spin-button{-webkit-appearance:none;margin:0}input[type=number]{-moz-appearance:textfield;font-family:inherit}:host{display:flex;flex-direction:column}.numeric-input{--color: #000028;--background: #ebf7f8;--label: #4c4c68;--border: #4c4c68;display:inline-flex;position:relative;width:100%;height:100%;min-height:3.5rem;border-bottom:1px solid var(--border);padding:0 55px 0 16px;background-color:var(--background);flex-wrap:wrap}@media print{.numeric-input{-webkit-print-color-adjust:exact;print-color-adjust:exact}}.numeric-input:not(.has-label){align-items:center;min-height:2.5rem}.numeric-input__label{font-size:.75rem;font-weight:400;line-height:1rem;white-space:nowrap;overflow:hidden;text-overflow:ellipsis;display:inline-block;width:100%;margin-top:6px;color:var(--label)}.numeric-input__input-field{font-size:1rem;font-weight:400;line-height:1.5rem;display:flex;width:100%;height:100%;border:0;padding:0;background-color:transparent;color:var(--color)}.has-label .numeric-input__input-field{height:1.5rem;margin-top:-.375rem}.numeric-input.is-disabled{--color: #b3b3be;border-bottom:none}.numeric-input.is-disabled .numeric-input__label{color:var(--color)}.numeric-input.is-invalid:not(.is-disabled){--background: #fcccd7;--label: #ef0137;--border: #ef0137}.numeric-input:hover:not(.is-invalid):not(.is-disabled){--background: #d1fff2;--border: #00d7a0}.numeric-input:hover:not(.is-invalid):not(.is-disabled):not(.controls-hovered),.numeric-input:hover:not(.is-invalid):not(.is-disabled).is-focused{--label: #33747a}.numeric-input__buttons{display:flex;flex-shrink:0;flex-grow:0;flex-direction:column-reverse;position:absolute;top:50%;right:12px;margin-left:24px;transform:translateY(-50%)}.coarse .numeric-input__buttons{flex-direction:row}.coarse .numeric-input__buttons .step-up-button{margin-bottom:0}.coarse .numeric-input__buttons sie-ui-button{display:flex;--icon-size-custom: 16px;--btn-width-custom: 24px;--btn-height-custom: 24px}.numeric-input__button-down,.numeric-input__button-up{display:flex;--icon-size-custom: 14px;--btn-width-custom: 18px;--btn-height-custom: 18px}.numeric-input__button-up{transform:rotate(180deg)}.has-label .numeric-input__button-up{margin-bottom:3px}.numeric-input.bg-dark{--color: #fff;--background: #00183b;--label: #ccccd4;--border: #ccccd4}.numeric-input.bg-dark.is-disabled{--color: #737389}.numeric-input.bg-dark.is-invalid:not(.is-disabled){--background: #331131}.numeric-input.bg-dark:hover:not(.is-invalid):not(.is-disabled){--background: #001f39;--border: #00d7a0}.numeric-input.bg-dark:hover:not(.is-invalid):not(.is-disabled):not(.controls-hovered),.numeric-input.bg-dark:hover:not(.is-invalid):not(.is-disabled).is-focused{--label: #00d7a0}.numeric-input-error{font-size:.875rem;font-weight:400;line-height:1.25rem;margin-top:4px;color:#ef0137}.numeric-input-hint{--hint: #4c4c68;font-size:.75rem;font-weight:400;line-height:1rem;margin-top:8px;color:var(--hint)}.numeric-input-hint.dark{--hint: #ccccd4}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }]; }, propDecorators: { value: [{
                type: Input
            }], max: [{
                type: Input
            }], min: [{
                type: Input
            }], step: [{
                type: Input
            }], decimal: [{
                type: Input
            }], required: [{
                type: Input
            }], allowNegative: [{
                type: Input
            }], suppressErrorLabel: [{
                type: Input
            }], requiredErrorMessage: [{
                type: Input
            }], rangeErrorMessage: [{
                type: Input
            }], rangeMinErrorMessage: [{
                type: Input
            }], rangeMaxErrorMessage: [{
                type: Input
            }], stepSizeErrorMessage: [{
                type: Input
            }], valueChange: [{
                type: Output
            }], validationStateChanged: [{
                type: Output
            }] } });

class UiAddToCartComponent {
    get cartData() {
        return this._cartData;
    }
    set cartData(cartData) {
        this._cartData = cartData;
        this.min = cartData?.minimumOrderQuantity || 1;
        this.max = cartData?.productQuantityOrderLimit ?? 99999;
        this.stepSize = cartData?.stepSize || 1;
    }
    get errorMessage() {
        return this._errorMessage;
    }
    get isInvalid() {
        return this.numericInputComponent.isInvalid;
    }
    constructor(cdr) {
        this.cdr = cdr;
        this.showSkeleton = false;
        this.darkMode = false;
        this.fullWidthNumericInput = false;
        this.addToCartButtonInSeparateLine = false;
        this.quantityChange = new EventEmitter();
        this.addToCart = new EventEmitter();
        this.min = 1;
        this.max = 99999;
        this.stepSize = 1;
    }
    onValidityChange(validityChange) {
        this._errorMessage = validityChange.errorMessage;
    }
    quantityChanged(newValue) {
        this.cartData.quantity = newValue;
        this.quantityChange.emit(newValue);
    }
    buttonClicked() {
        this.addToCart.emit();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiAddToCartComponent, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiAddToCartComponent, selector: "sie-ui-add-to-cart", inputs: { showSkeleton: "showSkeleton", darkMode: "darkMode", fullWidthNumericInput: "fullWidthNumericInput", cartData: "cartData", addToCartButtonInSeparateLine: "addToCartButtonInSeparateLine", addToCartLabel: "addToCartLabel", required: "required" }, outputs: { quantityChange: "quantityChange", addToCart: "addToCart" }, viewQueries: [{ propertyName: "numericInputComponent", first: true, predicate: UiNumericInputComponent, descendants: true }], ngImport: i0, template: "<ng-container *ngIf=\"!showSkeleton; else addToCartSkeletons\">\n  <sie-ui-numeric-input\n    class=\"add-to-cart__input\"\n    [ngClass]=\"{\n      'add-to-cart__input--full-width': addToCartButtonInSeparateLine,\n      'add-to-cart__input--full-width-numeric': fullWidthNumericInput\n    }\"\n    [min]=\"min\"\n    [max]=\"max\"\n    [step]=\"stepSize\"\n    [value]=\"cartData.quantity\"\n    [required]=\"required\"\n    [disabled]=\"cartData.addToCartLoading$ | async\"\n    [suppressErrorLabel]=\"true\"\n    [rangeErrorMessage]=\"cartData.rangeErrorMessage\"\n    [rangeMinErrorMessage]=\"cartData.rangeMinErrorMessage\"\n    [rangeMaxErrorMessage]=\"cartData.rangeMaxErrorMessage\"\n    [requiredErrorMessage]=\"cartData.requiredErrorMessage\"\n    [stepSizeErrorMessage]=\"cartData.stepSizeErrorMessage\"\n    [theme]=\"darkMode ? 'dark' : 'light'\"\n    (valueChange)=\"quantityChanged($event)\"\n    (validationStateChanged)=\"onValidityChange($event)\"\n    #numericInput\n  ></sie-ui-numeric-input>\n  <ng-container *ngIf=\"addToCartButtonInSeparateLine\">\n    <p class=\"add-to-cart__error add-to-cart__error--in-separate-line\">{{ errorMessage }}</p>\n  </ng-container>\n  <sie-ui-button\n    [themeType]=\"addToCartLabel ? 'main' : 'icon'\"\n    [variant]=\"addToCartLabel ? 'primary' : 'icon-contained'\"\n    position=\"content\"\n    [background]=\"darkMode ? 'dark' : 'light'\"\n    [prominence]=\"addToCartLabel ? null : 'secondary'\"\n    [icon]=\"cartData.icon$ | async\"\n    [disabled]=\"numericInput.isInvalid\"\n    withSpinner\n    [showSpinner]=\"cartData.addToCartLoading$ | async\"\n    (clicked)=\"buttonClicked()\"\n    [fullWidth]=\"addToCartButtonInSeparateLine ? true : false\"\n    ><span *ngIf=\"addToCartLabel\">{{ addToCartLabel }}</span></sie-ui-button\n  >\n  <ng-container *ngIf=\"!addToCartButtonInSeparateLine\">\n    <p class=\"add-to-cart__error\">{{ errorMessage }}</p>\n  </ng-container>\n</ng-container>\n\n<ng-template #addToCartSkeletons>\n  <ng-container>\n    <div class=\"add-to-cart__skeletons\">\n      <sie-ui-skeleton class=\"skeleton\" [ngClass]=\"{ 'skeleton-1': addToCartButtonInSeparateLine }\"></sie-ui-skeleton>\n      <sie-ui-skeleton *ngIf=\"addToCartButtonInSeparateLine\" class=\"skeleton\"></sie-ui-skeleton>\n    </div>\n  </ng-container>\n</ng-template>\n", styles: [":host{display:flex;flex-wrap:wrap;width:100%}.add-to-cart__input{width:120px}.add-to-cart__input--full-width{width:100%;margin-bottom:8px}.add-to-cart__input--full-width-numeric{width:calc(100% - 48px)}.add-to-cart__error{font-size:.75rem;font-weight:400;line-height:1rem;width:100%;color:#ef0137}.add-to-cart__error:not(:empty){margin-top:4px}.add-to-cart__error--in-separate-line{text-align:left}.add-to-cart__error--in-separate-line:not(:empty){margin-top:0;margin-bottom:8px}.add-to-cart__skeletons{display:block;width:100%}.add-to-cart__skeletons .skeleton{height:48px}.add-to-cart__skeletons .skeleton-1{margin-bottom:8px}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: UiNumericInputComponent, selector: "sie-ui-numeric-input", inputs: ["value", "max", "min", "step", "decimal", "required", "allowNegative", "suppressErrorLabel", "requiredErrorMessage", "rangeErrorMessage", "rangeMinErrorMessage", "rangeMaxErrorMessage", "stepSizeErrorMessage"], outputs: ["valueChange", "validationStateChanged"] }, { kind: "component", type: UiButtonComponent, selector: "sie-ui-button" }, { kind: "component", type: UiSkeletonComponent, selector: "sie-ui-skeleton", inputs: ["shape", "loadingText", "ariaLabel", "count"] }, { kind: "pipe", type: i2.AsyncPipe, name: "async" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiAddToCartComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-add-to-cart', changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-container *ngIf=\"!showSkeleton; else addToCartSkeletons\">\n  <sie-ui-numeric-input\n    class=\"add-to-cart__input\"\n    [ngClass]=\"{\n      'add-to-cart__input--full-width': addToCartButtonInSeparateLine,\n      'add-to-cart__input--full-width-numeric': fullWidthNumericInput\n    }\"\n    [min]=\"min\"\n    [max]=\"max\"\n    [step]=\"stepSize\"\n    [value]=\"cartData.quantity\"\n    [required]=\"required\"\n    [disabled]=\"cartData.addToCartLoading$ | async\"\n    [suppressErrorLabel]=\"true\"\n    [rangeErrorMessage]=\"cartData.rangeErrorMessage\"\n    [rangeMinErrorMessage]=\"cartData.rangeMinErrorMessage\"\n    [rangeMaxErrorMessage]=\"cartData.rangeMaxErrorMessage\"\n    [requiredErrorMessage]=\"cartData.requiredErrorMessage\"\n    [stepSizeErrorMessage]=\"cartData.stepSizeErrorMessage\"\n    [theme]=\"darkMode ? 'dark' : 'light'\"\n    (valueChange)=\"quantityChanged($event)\"\n    (validationStateChanged)=\"onValidityChange($event)\"\n    #numericInput\n  ></sie-ui-numeric-input>\n  <ng-container *ngIf=\"addToCartButtonInSeparateLine\">\n    <p class=\"add-to-cart__error add-to-cart__error--in-separate-line\">{{ errorMessage }}</p>\n  </ng-container>\n  <sie-ui-button\n    [themeType]=\"addToCartLabel ? 'main' : 'icon'\"\n    [variant]=\"addToCartLabel ? 'primary' : 'icon-contained'\"\n    position=\"content\"\n    [background]=\"darkMode ? 'dark' : 'light'\"\n    [prominence]=\"addToCartLabel ? null : 'secondary'\"\n    [icon]=\"cartData.icon$ | async\"\n    [disabled]=\"numericInput.isInvalid\"\n    withSpinner\n    [showSpinner]=\"cartData.addToCartLoading$ | async\"\n    (clicked)=\"buttonClicked()\"\n    [fullWidth]=\"addToCartButtonInSeparateLine ? true : false\"\n    ><span *ngIf=\"addToCartLabel\">{{ addToCartLabel }}</span></sie-ui-button\n  >\n  <ng-container *ngIf=\"!addToCartButtonInSeparateLine\">\n    <p class=\"add-to-cart__error\">{{ errorMessage }}</p>\n  </ng-container>\n</ng-container>\n\n<ng-template #addToCartSkeletons>\n  <ng-container>\n    <div class=\"add-to-cart__skeletons\">\n      <sie-ui-skeleton class=\"skeleton\" [ngClass]=\"{ 'skeleton-1': addToCartButtonInSeparateLine }\"></sie-ui-skeleton>\n      <sie-ui-skeleton *ngIf=\"addToCartButtonInSeparateLine\" class=\"skeleton\"></sie-ui-skeleton>\n    </div>\n  </ng-container>\n</ng-template>\n", styles: [":host{display:flex;flex-wrap:wrap;width:100%}.add-to-cart__input{width:120px}.add-to-cart__input--full-width{width:100%;margin-bottom:8px}.add-to-cart__input--full-width-numeric{width:calc(100% - 48px)}.add-to-cart__error{font-size:.75rem;font-weight:400;line-height:1rem;width:100%;color:#ef0137}.add-to-cart__error:not(:empty){margin-top:4px}.add-to-cart__error--in-separate-line{text-align:left}.add-to-cart__error--in-separate-line:not(:empty){margin-top:0;margin-bottom:8px}.add-to-cart__skeletons{display:block;width:100%}.add-to-cart__skeletons .skeleton{height:48px}.add-to-cart__skeletons .skeleton-1{margin-bottom:8px}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }]; }, propDecorators: { numericInputComponent: [{
                type: ViewChild,
                args: [UiNumericInputComponent]
            }], showSkeleton: [{
                type: Input
            }], darkMode: [{
                type: Input
            }], fullWidthNumericInput: [{
                type: Input
            }], cartData: [{
                type: Input
            }], addToCartButtonInSeparateLine: [{
                type: Input
            }], addToCartLabel: [{
                type: Input
            }], required: [{
                type: Input
            }], quantityChange: [{
                type: Output
            }], addToCart: [{
                type: Output
            }] } });

/**
 * # Numeric Input Module
 * - {@link UiNumericInputComponent}
 *
 * ## Module peer dependencies
 * - {@link SieIconsModule}
 * - `@angular/forms/FormsModule`: Enables data binding for Angular forms
 */
class UiNumericInputModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiNumericInputModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiNumericInputModule, declarations: [UiNumericInputComponent], imports: [CommonModule, SieIconsModule, UiButtonModule, FormsModule, UiReadonlyModule, UiRichtextModule], exports: [UiNumericInputComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiNumericInputModule, imports: [CommonModule, SieIconsModule, UiButtonModule, FormsModule, UiReadonlyModule, UiRichtextModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiNumericInputModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiNumericInputComponent],
                    imports: [CommonModule, SieIconsModule, UiButtonModule, FormsModule, UiReadonlyModule, UiRichtextModule],
                    exports: [UiNumericInputComponent]
                }]
        }] });

class UiSkeletonModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiSkeletonModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiSkeletonModule, declarations: [UiSkeletonComponent], imports: [CommonModule, RepeatDirective], exports: [UiSkeletonComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiSkeletonModule, imports: [CommonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiSkeletonModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiSkeletonComponent],
                    imports: [CommonModule, RepeatDirective],
                    exports: [UiSkeletonComponent]
                }]
        }] });

class UiAddToCartModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiAddToCartModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiAddToCartModule, declarations: [UiAddToCartComponent], imports: [CommonModule, UiNumericInputModule, UiButtonModule, UiSkeletonModule], exports: [UiAddToCartComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiAddToCartModule, imports: [CommonModule, UiNumericInputModule, UiButtonModule, UiSkeletonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiAddToCartModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiAddToCartComponent],
                    exports: [UiAddToCartComponent],
                    imports: [CommonModule, UiNumericInputModule, UiButtonModule, UiSkeletonModule]
                }]
        }] });

/**
 * Base list item component
 */
class UiBaseListItemComponent extends UiListItemDirective {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiBaseListItemComponent, deps: null, target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiBaseListItemComponent, selector: "sie-ui-base-list-item", viewQueries: [{ propertyName: "content", first: true, predicate: ["content"], descendants: true }], usesInheritance: true, ngImport: i0, template: "<ng-container>\n  <div #content></div>\n</ng-container>\n", changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiBaseListItemComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-base-list-item', changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-container>\n  <div #content></div>\n</ng-container>\n" }]
        }], propDecorators: { content: [{
                type: ViewChild,
                args: ['content']
            }] } });

const MODULES_TO_EXPORT = [
    CommonModule,
    UiSpinnerModule,
    UiRichtextModule,
    UiOverflowModule,
    UiPictureModule,
    ComponentBreakpointsModule,
    SieIconsModule,
    UiButtonModule,
    UiCheckboxModule,
    AddTooltipModule,
    SieCorePipesModule,
    UiRatingStarsModule,
    UiLinkModule,
    UiExpandableModule,
    UiTreeListModule,
    UiLinkListModule,
    UiTableModule,
    UiTabsModule,
    UiAddToCartModule,
    UiPopoverModule,
    UiMessageBoxModule,
    AdvancedHoverEffectModule,
    UiChatBubbleModule,
    UiStatusModule,
    IntersectionObserverModule,
    AttributeModule,
    UiEmptyStateModule,
    UiTagModule,
    UiLoadingModule,
    UiBadgeModule,
    AddTruncationAndTooltipModule,
    UiSkeletonModule
];
class BaseUiListModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: BaseUiListModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: BaseUiListModule, declarations: [UiListComponent,
            UiListItemComponent,
            UiListItemDirective,
            UiDynamicListItemComponent,
            UiListItemSkeletonComponent,
            UiBaseListItemComponent], imports: [CommonModule,
            UiSpinnerModule,
            UiRichtextModule,
            UiOverflowModule,
            UiPictureModule,
            ComponentBreakpointsModule,
            SieIconsModule,
            UiButtonModule,
            UiCheckboxModule,
            AddTooltipModule,
            SieCorePipesModule,
            UiRatingStarsModule,
            UiLinkModule,
            UiExpandableModule,
            UiTreeListModule,
            UiLinkListModule,
            UiTableModule,
            UiTabsModule,
            UiAddToCartModule,
            UiPopoverModule,
            UiMessageBoxModule,
            AdvancedHoverEffectModule,
            UiChatBubbleModule,
            UiStatusModule,
            IntersectionObserverModule,
            AttributeModule,
            UiEmptyStateModule,
            UiTagModule,
            UiLoadingModule,
            UiBadgeModule,
            AddTruncationAndTooltipModule,
            UiSkeletonModule], exports: [CommonModule,
            UiSpinnerModule,
            UiRichtextModule,
            UiOverflowModule,
            UiPictureModule,
            ComponentBreakpointsModule,
            SieIconsModule,
            UiButtonModule,
            UiCheckboxModule,
            AddTooltipModule,
            SieCorePipesModule,
            UiRatingStarsModule,
            UiLinkModule,
            UiExpandableModule,
            UiTreeListModule,
            UiLinkListModule,
            UiTableModule,
            UiTabsModule,
            UiAddToCartModule,
            UiPopoverModule,
            UiMessageBoxModule,
            AdvancedHoverEffectModule,
            UiChatBubbleModule,
            UiStatusModule,
            IntersectionObserverModule,
            AttributeModule,
            UiEmptyStateModule,
            UiTagModule,
            UiLoadingModule,
            UiBadgeModule,
            AddTruncationAndTooltipModule,
            UiSkeletonModule, UiListComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: BaseUiListModule, imports: [MODULES_TO_EXPORT, CommonModule,
            UiSpinnerModule,
            UiRichtextModule,
            UiOverflowModule,
            UiPictureModule,
            ComponentBreakpointsModule,
            SieIconsModule,
            UiButtonModule,
            UiCheckboxModule,
            AddTooltipModule,
            SieCorePipesModule,
            UiRatingStarsModule,
            UiLinkModule,
            UiExpandableModule,
            UiTreeListModule,
            UiLinkListModule,
            UiTableModule,
            UiTabsModule,
            UiAddToCartModule,
            UiPopoverModule,
            UiMessageBoxModule,
            AdvancedHoverEffectModule,
            UiChatBubbleModule,
            UiStatusModule,
            IntersectionObserverModule,
            AttributeModule,
            UiEmptyStateModule,
            UiTagModule,
            UiLoadingModule,
            UiBadgeModule,
            AddTruncationAndTooltipModule,
            UiSkeletonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: BaseUiListModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        UiListComponent,
                        UiListItemComponent,
                        UiListItemDirective,
                        UiDynamicListItemComponent,
                        UiListItemSkeletonComponent,
                        UiBaseListItemComponent
                    ],
                    imports: MODULES_TO_EXPORT,
                    exports: [...MODULES_TO_EXPORT, UiListComponent]
                }]
        }] });

class UiCatalogCategoryListItemSkeletonComponent {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCatalogCategoryListItemSkeletonComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiCatalogCategoryListItemSkeletonComponent, selector: "sie-ui-catalog-category-list-item-skeleton", ngImport: i0, template: "<div class=\"catalog-category-list-item__skeleton\">\n  <div class=\"catalog-category-list-item__skeleton__header\">\n    <sie-ui-skeleton class=\"default-loading\"></sie-ui-skeleton>\n  </div>\n  <div class=\"catalog-category-list-item__skeleton__body\">\n    <sie-ui-skeleton class=\"default-loading\"></sie-ui-skeleton>\n    <sie-ui-skeleton class=\"default-loading\"></sie-ui-skeleton>\n    <sie-ui-skeleton class=\"default-loading\"></sie-ui-skeleton>\n  </div>\n</div>\n", styles: [".catalog-category-list-item__skeleton{margin-bottom:20px}.catalog-category-list-item__skeleton .default-loading{height:20px;margin-bottom:4px}.catalog-category-list-item__skeleton__header{width:30%}\n"], dependencies: [{ kind: "component", type: UiSkeletonComponent, selector: "sie-ui-skeleton", inputs: ["shape", "loadingText", "ariaLabel", "count"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCatalogCategoryListItemSkeletonComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-catalog-category-list-item-skeleton', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"catalog-category-list-item__skeleton\">\n  <div class=\"catalog-category-list-item__skeleton__header\">\n    <sie-ui-skeleton class=\"default-loading\"></sie-ui-skeleton>\n  </div>\n  <div class=\"catalog-category-list-item__skeleton__body\">\n    <sie-ui-skeleton class=\"default-loading\"></sie-ui-skeleton>\n    <sie-ui-skeleton class=\"default-loading\"></sie-ui-skeleton>\n    <sie-ui-skeleton class=\"default-loading\"></sie-ui-skeleton>\n  </div>\n</div>\n", styles: [".catalog-category-list-item__skeleton{margin-bottom:20px}.catalog-category-list-item__skeleton .default-loading{height:20px;margin-bottom:4px}.catalog-category-list-item__skeleton__header{width:30%}\n"] }]
        }] });

class UiCatalogDocumentListItemSkeletonComponent {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCatalogDocumentListItemSkeletonComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiCatalogDocumentListItemSkeletonComponent, selector: "sie-ui-catalog-document-list-item-skeleton", ngImport: i0, template: "<div class=\"catalog-document-list-item__skeleton\">\n  <div class=\"catalog-document-list-item__skeleton__header\">\n    <sie-ui-skeleton class=\"default-loading\"></sie-ui-skeleton>\n  </div>\n  <div class=\"catalog-document-list-item__skeleton__body\">\n    <sie-ui-skeleton class=\"default-loading\"></sie-ui-skeleton>\n    <sie-ui-skeleton class=\"default-loading\"></sie-ui-skeleton>\n    <sie-ui-skeleton class=\"default-loading\"></sie-ui-skeleton>\n  </div>\n</div>\n", styles: [".catalog-document-list-item__skeleton{margin-bottom:20px}.catalog-document-list-item__skeleton .default-loading{height:20px;margin-bottom:4px}.catalog-document-list-item__skeleton__header{width:30%}\n"], dependencies: [{ kind: "component", type: UiSkeletonComponent, selector: "sie-ui-skeleton", inputs: ["shape", "loadingText", "ariaLabel", "count"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCatalogDocumentListItemSkeletonComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-catalog-document-list-item-skeleton', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"catalog-document-list-item__skeleton\">\n  <div class=\"catalog-document-list-item__skeleton__header\">\n    <sie-ui-skeleton class=\"default-loading\"></sie-ui-skeleton>\n  </div>\n  <div class=\"catalog-document-list-item__skeleton__body\">\n    <sie-ui-skeleton class=\"default-loading\"></sie-ui-skeleton>\n    <sie-ui-skeleton class=\"default-loading\"></sie-ui-skeleton>\n    <sie-ui-skeleton class=\"default-loading\"></sie-ui-skeleton>\n  </div>\n</div>\n", styles: [".catalog-document-list-item__skeleton{margin-bottom:20px}.catalog-document-list-item__skeleton .default-loading{height:20px;margin-bottom:4px}.catalog-document-list-item__skeleton__header{width:30%}\n"] }]
        }] });

class UiCatalogServicesListItemSkeletonComponent {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCatalogServicesListItemSkeletonComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiCatalogServicesListItemSkeletonComponent, selector: "sie-ui-catalog-services-list-item-skeleton", ngImport: i0, template: "<sie-ui-skeleton class=\"default-loading\"></sie-ui-skeleton>\n", styles: [".default-loading{height:20px;margin-bottom:4px}\n"], dependencies: [{ kind: "component", type: UiSkeletonComponent, selector: "sie-ui-skeleton", inputs: ["shape", "loadingText", "ariaLabel", "count"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCatalogServicesListItemSkeletonComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-catalog-services-list-item-skeleton', changeDetection: ChangeDetectionStrategy.OnPush, template: "<sie-ui-skeleton class=\"default-loading\"></sie-ui-skeleton>\n", styles: [".default-loading{height:20px;margin-bottom:4px}\n"] }]
        }] });

class UiCatalogDocumentListItemComponent extends UiListItemDirective {
    constructor(cdr) {
        super(cdr);
        this.cdr = cdr;
        this.catalogItemViewports = new Map([
            ['XS', 0],
            ['S', 480],
            ['M', 590],
            ['L', 930]
        ]);
        this.componentViewportChanged = new Subject();
    }
    setBreakpoint(breakpoint) {
        this.breakpoint = breakpoint;
        this.cdr.detectChanges();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCatalogDocumentListItemComponent, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiCatalogDocumentListItemComponent, selector: "sie-ui-document-catalog-list-item", outputs: { componentViewportChanged: "componentViewportChanged" }, usesInheritance: true, ngImport: i0, template: "<ng-container *ngIf=\"!loading && itemData; else skeleton\">\n  <article\n    class=\"catalog-document-list-item\"\n    sieCoreAdvancedHoverEffect\n    [hoverEffectLink]=\"itemData.documentUrl\"\n    [sieCoreComponentBreakpoints]=\"catalogItemViewports\"\n    (componentViewportChanged)=\"setBreakpoint($event)\"\n  >\n    <div class=\"catalog-document-list-item__header\" [ngClass]=\"{ column: ['XS', 'S'].includes(breakpoint) }\">\n      <p *ngIf=\"['XS', 'S'].includes(breakpoint)\" class=\"catalog-document-list-item__file-type\">\n        <ng-container *ngTemplateOutlet=\"filetype\"></ng-container>\n      </p>\n      <h5>\n        <a class=\"catalog-document-list-item__link\" rel=\"noopener\" [href]=\"itemData.documentUrl\">{{\n          itemData.title\n        }}</a>\n      </h5>\n      <p *ngIf=\"!['XS', 'S'].includes(breakpoint)\" class=\"catalog-document-list-item__file-type\">\n        <ng-container *ngTemplateOutlet=\"filetype\"></ng-container>\n      </p>\n    </div>\n    <sie-ui-overflow\n      class=\"catalog-document-list-item__description\"\n      [headlineCollapsed]=\"itemData.buttonShowMore\"\n      [headlineExpanded]=\"itemData.buttonShowLess\"\n      limit=\"3\"\n      size=\"s\"\n    >\n      <sie-ui-richtext [content]=\"itemData.formattedDescription\"></sie-ui-richtext>\n    </sie-ui-overflow>\n  </article>\n</ng-container>\n\n<ng-template #skeleton>\n  <sie-ui-catalog-document-list-item-skeleton></sie-ui-catalog-document-list-item-skeleton>\n</ng-template>\n\n<ng-template #filetype>\n  {{ itemData.language }}\n  <span *ngIf=\"itemData.fileExtension && !['htm', 'html'].includes(itemData.fileExtension)\">\n    &#183; {{ itemData.fileExtension.toUpperCase() }} ({{ itemData.size }})</span\n  >\n</ng-template>\n", styles: [".catalog-document-list-item__link{outline:none;outline-offset:0}@media (pointer: fine){.catalog-document-list-item__link{position:relative}.catalog-document-list-item__link:focus{outline:1px solid #1491eb;outline-offset:2px}.catalog-document-list-item__link:focus:not(:focus-visible){outline:0}.catalog-document-list-item__link:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}.catalog-document-list-item__file-type{font-size:.875rem;font-weight:400;line-height:1.25rem;color:#9999a9}.catalog-document-list-item__header{display:flex;justify-content:space-between;margin-bottom:4px;flex-direction:row}.catalog-document-list-item__header p{margin:0}.catalog-document-list-item__header.column{flex-direction:column}.catalog-document-list-item__header.column .catalog-document-list-item__file-type{margin-bottom:12px}.catalog-document-list-item__link{display:block;height:100%;color:inherit;word-break:break-word}.advanced-hover .catalog-document-list-item__link{text-decoration:underline;text-decoration-thickness:3px}.catalog-document-list-item__description{font-size:.875rem;font-weight:400;line-height:1.25rem}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "component", type: UiRichtextComponent, selector: "sie-ui-richtext", inputs: ["content", "theme", "whiteListedTags"] }, { kind: "component", type: UiOverflowComponent, selector: "sie-ui-overflow", inputs: ["limit", "forBreakpoints", "headlineCollapsed", "headlineExpanded", "useGradient", "size", "buttonIndentationLeft", "buttonIndentationTop", "centered", "theme", "useDynamicSubItemHeight", "disabled", "showExpandButton", "gradientColor"], outputs: ["toggled"] }, { kind: "directive", type: i1$1.ComponentBreakpointsDirective, selector: "[sieCoreComponentBreakpoints]", inputs: ["sieCoreComponentBreakpoints"], outputs: ["componentViewportChanged"] }, { kind: "directive", type: i1$1.AdvancedHoverEffectDirective, selector: "[sieCoreAdvancedHoverEffect]", inputs: ["hoverEffectLink", "hoverEffectAdditionalDataLoaded"] }, { kind: "component", type: UiCatalogDocumentListItemSkeletonComponent, selector: "sie-ui-catalog-document-list-item-skeleton" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCatalogDocumentListItemComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-document-catalog-list-item', changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-container *ngIf=\"!loading && itemData; else skeleton\">\n  <article\n    class=\"catalog-document-list-item\"\n    sieCoreAdvancedHoverEffect\n    [hoverEffectLink]=\"itemData.documentUrl\"\n    [sieCoreComponentBreakpoints]=\"catalogItemViewports\"\n    (componentViewportChanged)=\"setBreakpoint($event)\"\n  >\n    <div class=\"catalog-document-list-item__header\" [ngClass]=\"{ column: ['XS', 'S'].includes(breakpoint) }\">\n      <p *ngIf=\"['XS', 'S'].includes(breakpoint)\" class=\"catalog-document-list-item__file-type\">\n        <ng-container *ngTemplateOutlet=\"filetype\"></ng-container>\n      </p>\n      <h5>\n        <a class=\"catalog-document-list-item__link\" rel=\"noopener\" [href]=\"itemData.documentUrl\">{{\n          itemData.title\n        }}</a>\n      </h5>\n      <p *ngIf=\"!['XS', 'S'].includes(breakpoint)\" class=\"catalog-document-list-item__file-type\">\n        <ng-container *ngTemplateOutlet=\"filetype\"></ng-container>\n      </p>\n    </div>\n    <sie-ui-overflow\n      class=\"catalog-document-list-item__description\"\n      [headlineCollapsed]=\"itemData.buttonShowMore\"\n      [headlineExpanded]=\"itemData.buttonShowLess\"\n      limit=\"3\"\n      size=\"s\"\n    >\n      <sie-ui-richtext [content]=\"itemData.formattedDescription\"></sie-ui-richtext>\n    </sie-ui-overflow>\n  </article>\n</ng-container>\n\n<ng-template #skeleton>\n  <sie-ui-catalog-document-list-item-skeleton></sie-ui-catalog-document-list-item-skeleton>\n</ng-template>\n\n<ng-template #filetype>\n  {{ itemData.language }}\n  <span *ngIf=\"itemData.fileExtension && !['htm', 'html'].includes(itemData.fileExtension)\">\n    &#183; {{ itemData.fileExtension.toUpperCase() }} ({{ itemData.size }})</span\n  >\n</ng-template>\n", styles: [".catalog-document-list-item__link{outline:none;outline-offset:0}@media (pointer: fine){.catalog-document-list-item__link{position:relative}.catalog-document-list-item__link:focus{outline:1px solid #1491eb;outline-offset:2px}.catalog-document-list-item__link:focus:not(:focus-visible){outline:0}.catalog-document-list-item__link:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}.catalog-document-list-item__file-type{font-size:.875rem;font-weight:400;line-height:1.25rem;color:#9999a9}.catalog-document-list-item__header{display:flex;justify-content:space-between;margin-bottom:4px;flex-direction:row}.catalog-document-list-item__header p{margin:0}.catalog-document-list-item__header.column{flex-direction:column}.catalog-document-list-item__header.column .catalog-document-list-item__file-type{margin-bottom:12px}.catalog-document-list-item__link{display:block;height:100%;color:inherit;word-break:break-word}.advanced-hover .catalog-document-list-item__link{text-decoration:underline;text-decoration-thickness:3px}.catalog-document-list-item__description{font-size:.875rem;font-weight:400;line-height:1.25rem}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }]; }, propDecorators: { componentViewportChanged: [{
                type: Output
            }] } });

class UiCatalogCategoryListItemComponent extends UiListItemDirective {
    constructor(cdr, iconReg) {
        super(cdr);
        this.cdr = cdr;
        this.iconReg = iconReg;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCatalogCategoryListItemComponent, deps: [{ token: i0.ChangeDetectorRef }, { token: i1.SieIconRegistryService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiCatalogCategoryListItemComponent, selector: "sie-ui-category-catalog-list-item", usesInheritance: true, ngImport: i0, template: "<ng-container *ngIf=\"!loading && itemData; else skeleton\">\n  <article\n    class=\"catalog-category-list-item\"\n    sieCoreAdvancedHoverEffect\n    [hoverEffectLink]=\"itemData.productCategoriesUrl\"\n  >\n    <h5 class=\"catalog-category-list-item__header\">\n      <a class=\"catalog-category-list-item__link\" rel=\"noopener\" [href]=\"itemData.productCategoriesUrl\">{{\n        itemData.description\n      }}</a>\n    </h5>\n    <p class=\"catalog-category-list-item__type-description\">{{ itemData.productCategoryType }}</p>\n  </article>\n</ng-container>\n\n<ng-template #skeleton>\n  <sie-ui-catalog-category-list-item-skeleton></sie-ui-catalog-category-list-item-skeleton>\n</ng-template>\n", styles: [".catalog-category-list-item__link{outline:none;outline-offset:0}@media (pointer: fine){.catalog-category-list-item__link{position:relative}.catalog-category-list-item__link:focus{outline:1px solid #1491eb;outline-offset:2px}.catalog-category-list-item__link:focus:not(:focus-visible){outline:0}.catalog-category-list-item__link:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}.catalog-category-list-item__header{margin-bottom:4px}.catalog-category-list-item__type-description{font-size:.875rem;font-weight:400;line-height:1.25rem;margin-top:4px}.catalog-category-list-item__link{display:block;height:100%;color:inherit;word-break:break-word}.advanced-hover .catalog-category-list-item__link{text-decoration:underline;text-decoration-thickness:3px}\n"], dependencies: [{ kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1$1.AdvancedHoverEffectDirective, selector: "[sieCoreAdvancedHoverEffect]", inputs: ["hoverEffectLink", "hoverEffectAdditionalDataLoaded"] }, { kind: "component", type: UiCatalogCategoryListItemSkeletonComponent, selector: "sie-ui-catalog-category-list-item-skeleton" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCatalogCategoryListItemComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-category-catalog-list-item', changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-container *ngIf=\"!loading && itemData; else skeleton\">\n  <article\n    class=\"catalog-category-list-item\"\n    sieCoreAdvancedHoverEffect\n    [hoverEffectLink]=\"itemData.productCategoriesUrl\"\n  >\n    <h5 class=\"catalog-category-list-item__header\">\n      <a class=\"catalog-category-list-item__link\" rel=\"noopener\" [href]=\"itemData.productCategoriesUrl\">{{\n        itemData.description\n      }}</a>\n    </h5>\n    <p class=\"catalog-category-list-item__type-description\">{{ itemData.productCategoryType }}</p>\n  </article>\n</ng-container>\n\n<ng-template #skeleton>\n  <sie-ui-catalog-category-list-item-skeleton></sie-ui-catalog-category-list-item-skeleton>\n</ng-template>\n", styles: [".catalog-category-list-item__link{outline:none;outline-offset:0}@media (pointer: fine){.catalog-category-list-item__link{position:relative}.catalog-category-list-item__link:focus{outline:1px solid #1491eb;outline-offset:2px}.catalog-category-list-item__link:focus:not(:focus-visible){outline:0}.catalog-category-list-item__link:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}.catalog-category-list-item__header{margin-bottom:4px}.catalog-category-list-item__type-description{font-size:.875rem;font-weight:400;line-height:1.25rem;margin-top:4px}.catalog-category-list-item__link{display:block;height:100%;color:inherit;word-break:break-word}.advanced-hover .catalog-category-list-item__link{text-decoration:underline;text-decoration-thickness:3px}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i1.SieIconRegistryService }]; } });

class UiCatalogServicesListItemComponent extends UiListItemDirective {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCatalogServicesListItemComponent, deps: null, target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiCatalogServicesListItemComponent, selector: "sie-ui-catalog-services-list-item", usesInheritance: true, ngImport: i0, template: "<ng-container *ngIf=\"!loading && itemData; else skeleton\">\n  <sie-ui-link [href]=\"itemData?.serviceUrl\">\n    <sie-ui-richtext [content]=\"itemData.formattedDescription\"></sie-ui-richtext>\n  </sie-ui-link>\n</ng-container>\n<ng-template #skeleton>\n  <sie-ui-catalog-services-list-item-skeleton></sie-ui-catalog-services-list-item-skeleton>\n</ng-template>\n", dependencies: [{ kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: UiRichtextComponent, selector: "sie-ui-richtext", inputs: ["content", "theme", "whiteListedTags"] }, { kind: "component", type: UiLinkComponent, selector: "sie-ui-link", inputs: ["disabled", "disableVisitedStyle", "hasMarginTop", "offsetIcon", "truncate", "inLinkList", "trailingIcon", "icon", "cssClass", "href", "size", "target", "variant", "background", "type", "reference", "screenReaderText", "secondaryLabel", "download", "dataAttributes", "tooltip", "buttonType"], outputs: ["clicked"] }, { kind: "component", type: UiCatalogServicesListItemSkeletonComponent, selector: "sie-ui-catalog-services-list-item-skeleton" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCatalogServicesListItemComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-catalog-services-list-item', changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-container *ngIf=\"!loading && itemData; else skeleton\">\n  <sie-ui-link [href]=\"itemData?.serviceUrl\">\n    <sie-ui-richtext [content]=\"itemData.formattedDescription\"></sie-ui-richtext>\n  </sie-ui-link>\n</ng-container>\n<ng-template #skeleton>\n  <sie-ui-catalog-services-list-item-skeleton></sie-ui-catalog-services-list-item-skeleton>\n</ng-template>\n" }]
        }] });

class MockTreeListService {
    static getTree(prefix, levels, amountOfChildren, singleRoot, aliasArray) {
        return this.generateTreeLevels(prefix, levels, amountOfChildren, singleRoot, [], '', 1, aliasArray);
    }
    static generateTreeLevels(prefix, levels, amountOfChildren, singleRoot, tree, parentId, level, aliasArray) {
        const isLastLevel = levels === level;
        if (level === 1 && singleRoot) {
            const aliasId = this.getAliasId('1', aliasArray);
            const item = {
                id: '1',
                label: prefix + 'L_1' + (aliasId ? '(alias' + aliasId + ')' : ''),
                children: isLastLevel ? null : [],
                aliasId: aliasId
            };
            tree.push(item);
            if (!isLastLevel) {
                item.children = this.generateTreeLevels(prefix, levels, amountOfChildren, singleRoot, item.children, '1', level + 1, aliasArray);
            }
        }
        else {
            for (let i = 0; i < amountOfChildren; i++) {
                const aliasId = this.getAliasId(parentId + '_' + (i + 1), aliasArray);
                const item = {
                    id: parentId + '_' + (i + 1),
                    label: prefix + 'L' + parentId + '_' + (i + 1) + (aliasId ? '(alias' + aliasId + ')' : ''),
                    children: isLastLevel ? null : [],
                    aliasId: aliasId,
                    icons: i === 2 ? [SieIcon.SieportalExtIdleWithBorderTag] : i === 3 ? [SieIcon.SieportalIntIdleWithBorderTag] : []
                };
                tree.push(item);
                if (!isLastLevel) {
                    item.children = this.generateTreeLevels(prefix, levels, amountOfChildren, singleRoot, item.children, parentId + '_' + (i + 1), level + 1, aliasArray);
                }
            }
        }
        return tree;
    }
    static getAliasId(id, aliasArray) {
        return aliasArray?.find(alias => alias.id === id)?.aliasId ?? null;
    }
}

class MockFilterDataService {
    static { this.mockFilterHeader = {
        tagGroups: [
            {
                subFilters: ['111111'],
                tags: [
                    {
                        mode: 'removable',
                        id: '5',
                        label: 'Label 5',
                        order: 2
                    },
                    {
                        mode: 'removable',
                        id: '6',
                        label: 'Label 6',
                        order: 1
                    }
                ],
                order: 3,
                parameterName: 'Param 1'
            },
            {
                subFilters: ['222222'],
                tags: [
                    {
                        mode: 'removable',
                        id: '1',
                        label: 'Label 1',
                        order: 4
                    },
                    {
                        mode: 'removable',
                        id: '2',
                        label: 'Label 2',
                        order: 1
                    }
                ],
                order: 1,
                parameterName: 'Param 2'
            }
        ]
    }; }
    static { this.mockFilterChangesAdd = {
        params: [
            {
                id: 'CatalogSearchSettings.NodeFilters',
                changes: [
                    {
                        canHaveMultipleValues: true,
                        remove: false,
                        value: '10047575'
                    }
                ]
            }
        ]
    }; }
    static { this.mockFilterChangesRemove = {
        params: [
            {
                id: 'CatalogSearchSettings.NodeFilters',
                changes: [
                    {
                        canHaveMultipleValues: true,
                        remove: true,
                        value: '10047575'
                    }
                ]
            }
        ]
    }; }
    static { this.mockCheckboxChangeEvent = {
        index: 1,
        name: 'name',
        state: true
    }; }
}

/**
 * # Menu button component
 *
 * Menu button is a combination of a button and a menu. It provides access to multiple related actions to the user
 * within one button.
 *
 * ## Component variations
 *
 * - standard menu button: The default menu button is displayed.
 * - icon button: Provided icon will be used to display the menu button.
 *
 * ## Content
 *
 * The Menu Button component does not accept any content.
 *
 * ## Code example
 *
 * @example ```html
 * <sie-ui-menu-button
 *   theme="light"
 *   menuButtonType="standard"
 *   menuButtonText="Export"
 *   [leadingButtonIcon]="iconReg.sieIcon.Globe"
 *   [options]="[
 *     { value: '1', label: 'Value Option 1', disabled: false },
 *     { value: '5', label: 'Value Option 5', disabled: false}
 *   ]"
 *   (actionClicked)="menuButtonActionClicked($event)"
 * ></sie-ui-menu-button>
 *
 * <sie-ui-menu-button
 *   theme="light"
 *   [options]= "[
 *     {
 *       value: '1',
 *       label: 'SieportalIntMiniWithoutBorderTag',
 *       disabled: false,
 *       icon: SieIcon.SieportalIntMiniWithoutBorderTag
 *     }
 *   ]"
 *   (actionClicked)="menuButtonActionClicked($event)"
 * ></sie-ui-menu-button>
 * ```
 */
class UiMenuButtonComponent extends UiDropdownBaseDirective {
    /**
     * @param value Adds the text to the button used when the standard type was chosen
     * @default ''
     */
    set menuButtonText(value) {
        this._menuButtonText = value + ' ...';
    }
    get menuButtonText() {
        return this._menuButtonText;
    }
    constructor(iconReg, layoutService, eventPropagationService, cdr, elementRef, cdkOverlayService) {
        super(cdr, elementRef, eventPropagationService, cdkOverlayService);
        this.iconReg = iconReg;
        this.layoutService = layoutService;
        this.eventPropagationService = eventPropagationService;
        this.cdr = cdr;
        this.elementRef = elementRef;
        this.cdkOverlayService = cdkOverlayService;
        /**
         * {@link UiMenuButtonModel Event emitter} when action is clicked or selected via keyboard
         */
        this.actionClicked = new EventEmitter();
        /**
         * Defines the {@link ButtonType type} of the menu button
         * @default 'icon'
         */
        this.menuButtonType = 'icon';
        /**
         * Defines the {@link UiButtonVariant variant} of the standard menu button
         * @default 'secondary'
         */
        this.menuButtonVariant = 'secondary';
        /**
         * Defines the {@link UiButtonThemeType theme} of the standard menu button
         * @default 'un-contained'
         */
        this.menuButtonThemeType = 'un-contained';
        this._menuButtonText = '';
        /** @ignore */
        this.leftAligned = false;
        /** @ignore */
        this.isSecondaryIconRotated$ = new BehaviorSubject(false);
        iconReg.register(SieIcon.SieportalMorePortrait);
    }
    /** @ignore */
    ngOnInit() {
        if (!this.menuTheme) {
            this.menuTheme = this.theme;
        }
    }
    /** @ignore */
    itemSelected(item) {
        if (!item.disabled) {
            this.actionClicked.emit(item);
            super.closeOverlay();
        }
        this.rotateSecondaryIcon(false);
    }
    /** @ignore */
    focusOut() {
        super.focusOut();
        this.rotateSecondaryIcon(false);
    }
    /** @ignore */
    toggleDropDown() {
        super.toggleDropDown();
        this.rotateSecondaryIcon(!this.isSecondaryIconRotated$.value);
    }
    /** @ignore */
    rotateSecondaryIcon(isRotated) {
        if (this.disabled) {
            return;
        }
        this.isSecondaryIconRotated$.next(isRotated);
    }
    /** @ignore */
    determineHorizontalMenuAlignment() {
        const buttonX = this.dropDownElement.nativeElement.getBoundingClientRect().left;
        const menuWidth = this.dropDownMenu.elementRef.nativeElement.offsetWidth;
        this.leftAligned = menuWidth >= buttonX;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiMenuButtonComponent, deps: [{ token: i1.SieIconRegistryService }, { token: i1$1.LayoutService }, { token: UiEventPropagationService }, { token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: CdkOverlayService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiMenuButtonComponent, selector: "sie-ui-menu-button", inputs: { menuButtonScreenReaderText: "menuButtonScreenReaderText", menuTheme: "menuTheme", menuButtonType: "menuButtonType", menuButtonVariant: "menuButtonVariant", menuButtonThemeType: "menuButtonThemeType", menuButtonText: "menuButtonText", leadingButtonIcon: "leadingButtonIcon" }, outputs: { actionClicked: "actionClicked" }, providers: [UiEventPropagationService], usesInheritance: true, ngImport: i0, template: "<div\n  class=\"menu-button\"\n  [class.disabled]=\"disabled\"\n  (focusin)=\"focusIn()\"\n  (focusout)=\"focusOut()\"\n  (keydown.escape)=\"handleEscape($event)\"\n  (keyup.escape)=\"eventPropagationService.handleEvent($event)\"\n  #dropDownRendering\n>\n  <div\n    class=\"menu-button__button-wrapper\"\n    [ngClass]=\"['menu-theme-' + menuButtonType, 'menu-variant-' + menuButtonVariant]\"\n    [attr.tabindex]=\"-1\"\n    [attr.aria-haspopup]=\"'listbox'\"\n    (click)=\"toggleDropDown()\"\n    (keydown.arrowDown)=\"onArrowDownOnButton($event)\"\n    role=\"button\"\n    #dropDownElement\n    [ngSwitch]=\"menuButtonType\"\n  >\n    <span *ngIf=\"screenReaderText && screenReaderText.length > 0\" class=\"visually-hidden\">{{ screenReaderText }}</span>\n    <sie-ui-button\n      *ngSwitchCase=\"'icon'\"\n      themeType=\"icon\"\n      variant=\"icon-un-contained\"\n      position=\"content\"\n      [icon]=\"iconReg.sieIcon.SieportalMorePortrait\"\n      [background]=\"theme\"\n      [disabled]=\"disabled\"\n      [iconScreenReaderText]=\"menuButtonScreenReaderText\"\n    ></sie-ui-button>\n    <sie-ui-button\n      *ngSwitchCase=\"'standard'\"\n      class=\"standard-menu-button\"\n      position=\"content\"\n      [variant]=\"menuButtonVariant\"\n      [themeType]=\"menuButtonThemeType\"\n      [icon]=\"leadingButtonIcon\"\n      [iconSecondary]=\"iconReg.sieIcon.Dropdown\"\n      [background]=\"theme\"\n      [disabled]=\"disabled\"\n      [isSecondaryIconRotated]=\"isSecondaryIconRotated$ | async\"\n      [fullWidth]=\"layoutService.isViewport$('S') | async\"\n      >{{ menuButtonText }}</sie-ui-button\n    >\n    <button\n      *ngSwitchCase=\"'icon-condensed'\"\n      class=\"icon-condensed-menu-button position-content\"\n      [ngClass]=\"['bg-' + theme, menuOpen ? 'open' : '']\"\n      [disabled]=\"disabled\"\n    >\n      <sie-icon\n        [name]=\"iconReg.sieIcon.SieportalMorePortrait\"\n        class=\"icon-condensed__icon\"\n        aria-hidden=\"true\"\n      ></sie-icon>\n      <span *ngIf=\"menuButtonScreenReaderText\" class=\"visually-hidden\">{{ menuButtonScreenReaderText }}</span>\n    </button>\n  </div>\n\n  <sie-ui-dropdown-menu\n    *ngIf=\"menuOpen\"\n    class=\"menu-button__menu\"\n    type=\"menu\"\n    [@openClose]=\"menuOpen\"\n    [theme]=\"menuTheme\"\n    [ngClass]=\"[\n      menuTheme,\n      menuButtonType === 'standard' ? 'standard' : '',\n      menuButtonType === 'icon-condensed' ? 'condensed' : '',\n      leftAligned ? 'left-aligned' : '',\n      'menu-variant-' + menuButtonVariant\n    ]\"\n    [menuPositionedBottom]=\"menuPositionedBottom\"\n  >\n    <sie-ui-dropdown-options\n      content\n      [open]=\"menuOpen\"\n      [ariaLabel]=\"screenReaderText\"\n      [options]=\"options\"\n      [theme]=\"menuTheme\"\n      (optionDiscarded)=\"closeOverlay(true)\"\n      (optionSelected)=\"itemSelected($event)\"\n      [displayIconSpace]=\"displayIconSpace\"\n      [checkmarkDisabled]=\"menuButtonType === 'standard'\"\n    ></sie-ui-dropdown-options>\n  </sie-ui-dropdown-menu>\n</div>\n", styles: [".menu-button{position:relative;width:100%}.menu-button__button-wrapper{width:44px}.menu-button__button-wrapper:focus-visible{outline:none}.menu-button__button-wrapper.menu-theme-standard{display:flex;align-items:center;min-width:200px;max-width:260px;width:100%}@media (max-width: 639.78px){.menu-button__button-wrapper.menu-theme-standard{max-width:none}}.menu-button__button-wrapper.menu-theme-standard.menu-variant-tertiary{min-width:initial}.menu-button__button-wrapper .standard-menu-button{width:100%}.menu-button__button-wrapper.icon-condensed{width:24px;margin-bottom:8px}.menu-button__button-wrapper.icon-condensed__icon{width:24px;height:24px;display:flex;align-items:center;fill:currentColor}.menu-button__button-wrapper.icon-condensed__icon svg{fill:currentColor;width:inherit;height:inherit}.menu-button__button-wrapper.icon-condensed__icon svg g{fill:currentColor;width:inherit;height:inherit}.menu-button__button-wrapper.icon-condensed__icon svg text{font-family:Siemens Sans,sans-serif}.menu-button__button-wrapper .icon-condensed-menu-button{border:0;background:transparent;cursor:pointer;padding:0 10px;height:24px;width:24px;display:flex;justify-content:center;align-items:center}.menu-button__button-wrapper .icon-condensed-menu-button.position-content.bg-light{--btn-color: var(--btn-color-custom, #4c4c68);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.menu-button__button-wrapper .icon-condensed-menu-button.position-content.bg-light:active:not(:disabled):not(.hover-disabled),.menu-button__button-wrapper .icon-condensed-menu-button.position-content.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.menu-button__button-wrapper .icon-condensed-menu-button.position-content.bg-light:disabled,.menu-button__button-wrapper .icon-condensed-menu-button.position-content.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.menu-button__button-wrapper .icon-condensed-menu-button.position-content.bg-dark{--btn-color: var(--btn-color-custom, #e5e5e9);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.menu-button__button-wrapper .icon-condensed-menu-button.position-content.bg-dark:active:not(:disabled):not(.hover-disabled),.menu-button__button-wrapper .icon-condensed-menu-button.position-content.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.menu-button__button-wrapper .icon-condensed-menu-button.position-content.bg-dark:disabled,.menu-button__button-wrapper .icon-condensed-menu-button.position-content.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.menu-button__button-wrapper .icon-condensed-menu-button.position-content.to-top-button{--btn-color: var(--btn-color-custom, #007993);color:var(--btn-color);fill:var(--btn-color)}.menu-button__button-wrapper .icon-condensed-menu-button.position-content:focus,.menu-button__button-wrapper .icon-condensed-menu-button.position-content.open{--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}.menu-button__menu{z-index:100;position:absolute;min-width:200px;max-width:260px;width:max-content;transform:translate(calc(-100% + 22px));left:2px}.menu-button__menu.condensed{transform:translate(calc(-100% + 2.4px));left:10px}.menu-button__menu.left-aligned{transform:translate(22px);left:-2px}.menu-button__menu.left-aligned.condensed{transform:translate(2.4px);left:10px}.menu-button__menu.standard{transform:none;top:46px;left:-8px;width:calc(100% + 8px)}@media (max-width: 639.78px){.menu-button__menu.standard{max-width:none}}.menu-button__menu.standard.menu-variant-tertiary{left:0;width:100%;min-width:initial}.menu-button ::ng-deep .type-un-contained .general-button__label-content{white-space:nowrap;overflow:hidden;text-overflow:ellipsis;display:block;min-width:132px;max-width:192px}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgSwitch, selector: "[ngSwitch]", inputs: ["ngSwitch"] }, { kind: "directive", type: i2.NgSwitchCase, selector: "[ngSwitchCase]", inputs: ["ngSwitchCase"] }, { kind: "component", type: UiButtonComponent, selector: "sie-ui-button" }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "component", type: UiDropdownMenuComponent, selector: "sie-ui-dropdown-menu", inputs: ["theme", "type", "menuPositionedBottom"] }, { kind: "component", type: UiDropdownOptionsComponent, selector: "sie-ui-dropdown-options", inputs: ["options", "theme", "selectionType", "selectedValues", "displayIconSpace", "type", "checkmarkDisabled", "open", "ariaLabel"], outputs: ["optionSelected", "optionDiscarded"] }, { kind: "pipe", type: i2.AsyncPipe, name: "async" }], animations: [createDropdownAnimation()], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiMenuButtonComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-menu-button', changeDetection: ChangeDetectionStrategy.OnPush, providers: [UiEventPropagationService], animations: [createDropdownAnimation()], template: "<div\n  class=\"menu-button\"\n  [class.disabled]=\"disabled\"\n  (focusin)=\"focusIn()\"\n  (focusout)=\"focusOut()\"\n  (keydown.escape)=\"handleEscape($event)\"\n  (keyup.escape)=\"eventPropagationService.handleEvent($event)\"\n  #dropDownRendering\n>\n  <div\n    class=\"menu-button__button-wrapper\"\n    [ngClass]=\"['menu-theme-' + menuButtonType, 'menu-variant-' + menuButtonVariant]\"\n    [attr.tabindex]=\"-1\"\n    [attr.aria-haspopup]=\"'listbox'\"\n    (click)=\"toggleDropDown()\"\n    (keydown.arrowDown)=\"onArrowDownOnButton($event)\"\n    role=\"button\"\n    #dropDownElement\n    [ngSwitch]=\"menuButtonType\"\n  >\n    <span *ngIf=\"screenReaderText && screenReaderText.length > 0\" class=\"visually-hidden\">{{ screenReaderText }}</span>\n    <sie-ui-button\n      *ngSwitchCase=\"'icon'\"\n      themeType=\"icon\"\n      variant=\"icon-un-contained\"\n      position=\"content\"\n      [icon]=\"iconReg.sieIcon.SieportalMorePortrait\"\n      [background]=\"theme\"\n      [disabled]=\"disabled\"\n      [iconScreenReaderText]=\"menuButtonScreenReaderText\"\n    ></sie-ui-button>\n    <sie-ui-button\n      *ngSwitchCase=\"'standard'\"\n      class=\"standard-menu-button\"\n      position=\"content\"\n      [variant]=\"menuButtonVariant\"\n      [themeType]=\"menuButtonThemeType\"\n      [icon]=\"leadingButtonIcon\"\n      [iconSecondary]=\"iconReg.sieIcon.Dropdown\"\n      [background]=\"theme\"\n      [disabled]=\"disabled\"\n      [isSecondaryIconRotated]=\"isSecondaryIconRotated$ | async\"\n      [fullWidth]=\"layoutService.isViewport$('S') | async\"\n      >{{ menuButtonText }}</sie-ui-button\n    >\n    <button\n      *ngSwitchCase=\"'icon-condensed'\"\n      class=\"icon-condensed-menu-button position-content\"\n      [ngClass]=\"['bg-' + theme, menuOpen ? 'open' : '']\"\n      [disabled]=\"disabled\"\n    >\n      <sie-icon\n        [name]=\"iconReg.sieIcon.SieportalMorePortrait\"\n        class=\"icon-condensed__icon\"\n        aria-hidden=\"true\"\n      ></sie-icon>\n      <span *ngIf=\"menuButtonScreenReaderText\" class=\"visually-hidden\">{{ menuButtonScreenReaderText }}</span>\n    </button>\n  </div>\n\n  <sie-ui-dropdown-menu\n    *ngIf=\"menuOpen\"\n    class=\"menu-button__menu\"\n    type=\"menu\"\n    [@openClose]=\"menuOpen\"\n    [theme]=\"menuTheme\"\n    [ngClass]=\"[\n      menuTheme,\n      menuButtonType === 'standard' ? 'standard' : '',\n      menuButtonType === 'icon-condensed' ? 'condensed' : '',\n      leftAligned ? 'left-aligned' : '',\n      'menu-variant-' + menuButtonVariant\n    ]\"\n    [menuPositionedBottom]=\"menuPositionedBottom\"\n  >\n    <sie-ui-dropdown-options\n      content\n      [open]=\"menuOpen\"\n      [ariaLabel]=\"screenReaderText\"\n      [options]=\"options\"\n      [theme]=\"menuTheme\"\n      (optionDiscarded)=\"closeOverlay(true)\"\n      (optionSelected)=\"itemSelected($event)\"\n      [displayIconSpace]=\"displayIconSpace\"\n      [checkmarkDisabled]=\"menuButtonType === 'standard'\"\n    ></sie-ui-dropdown-options>\n  </sie-ui-dropdown-menu>\n</div>\n", styles: [".menu-button{position:relative;width:100%}.menu-button__button-wrapper{width:44px}.menu-button__button-wrapper:focus-visible{outline:none}.menu-button__button-wrapper.menu-theme-standard{display:flex;align-items:center;min-width:200px;max-width:260px;width:100%}@media (max-width: 639.78px){.menu-button__button-wrapper.menu-theme-standard{max-width:none}}.menu-button__button-wrapper.menu-theme-standard.menu-variant-tertiary{min-width:initial}.menu-button__button-wrapper .standard-menu-button{width:100%}.menu-button__button-wrapper.icon-condensed{width:24px;margin-bottom:8px}.menu-button__button-wrapper.icon-condensed__icon{width:24px;height:24px;display:flex;align-items:center;fill:currentColor}.menu-button__button-wrapper.icon-condensed__icon svg{fill:currentColor;width:inherit;height:inherit}.menu-button__button-wrapper.icon-condensed__icon svg g{fill:currentColor;width:inherit;height:inherit}.menu-button__button-wrapper.icon-condensed__icon svg text{font-family:Siemens Sans,sans-serif}.menu-button__button-wrapper .icon-condensed-menu-button{border:0;background:transparent;cursor:pointer;padding:0 10px;height:24px;width:24px;display:flex;justify-content:center;align-items:center}.menu-button__button-wrapper .icon-condensed-menu-button.position-content.bg-light{--btn-color: var(--btn-color-custom, #4c4c68);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.menu-button__button-wrapper .icon-condensed-menu-button.position-content.bg-light:active:not(:disabled):not(.hover-disabled),.menu-button__button-wrapper .icon-condensed-menu-button.position-content.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.menu-button__button-wrapper .icon-condensed-menu-button.position-content.bg-light:disabled,.menu-button__button-wrapper .icon-condensed-menu-button.position-content.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.menu-button__button-wrapper .icon-condensed-menu-button.position-content.bg-dark{--btn-color: var(--btn-color-custom, #e5e5e9);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.menu-button__button-wrapper .icon-condensed-menu-button.position-content.bg-dark:active:not(:disabled):not(.hover-disabled),.menu-button__button-wrapper .icon-condensed-menu-button.position-content.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.menu-button__button-wrapper .icon-condensed-menu-button.position-content.bg-dark:disabled,.menu-button__button-wrapper .icon-condensed-menu-button.position-content.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.menu-button__button-wrapper .icon-condensed-menu-button.position-content.to-top-button{--btn-color: var(--btn-color-custom, #007993);color:var(--btn-color);fill:var(--btn-color)}.menu-button__button-wrapper .icon-condensed-menu-button.position-content:focus,.menu-button__button-wrapper .icon-condensed-menu-button.position-content.open{--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}.menu-button__menu{z-index:100;position:absolute;min-width:200px;max-width:260px;width:max-content;transform:translate(calc(-100% + 22px));left:2px}.menu-button__menu.condensed{transform:translate(calc(-100% + 2.4px));left:10px}.menu-button__menu.left-aligned{transform:translate(22px);left:-2px}.menu-button__menu.left-aligned.condensed{transform:translate(2.4px);left:10px}.menu-button__menu.standard{transform:none;top:46px;left:-8px;width:calc(100% + 8px)}@media (max-width: 639.78px){.menu-button__menu.standard{max-width:none}}.menu-button__menu.standard.menu-variant-tertiary{left:0;width:100%;min-width:initial}.menu-button ::ng-deep .type-un-contained .general-button__label-content{white-space:nowrap;overflow:hidden;text-overflow:ellipsis;display:block;min-width:132px;max-width:192px}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }, { type: i1$1.LayoutService }, { type: UiEventPropagationService }, { type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: CdkOverlayService }]; }, propDecorators: { menuButtonScreenReaderText: [{
                type: Input
            }], actionClicked: [{
                type: Output
            }], menuTheme: [{
                type: Input
            }], menuButtonType: [{
                type: Input
            }], menuButtonVariant: [{
                type: Input
            }], menuButtonThemeType: [{
                type: Input
            }], menuButtonText: [{
                type: Input
            }], leadingButtonIcon: [{
                type: Input
            }] } });

class UiServicesListItemSkeletonComponent {
    constructor() {
        this.hasBulkMode = false;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiServicesListItemSkeletonComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiServicesListItemSkeletonComponent, selector: "sie-ui-services-list-item-skeleton", inputs: { hasBulkMode: "hasBulkMode" }, ngImport: i0, template: "<div class=\"services-list-item__skeleton\" [class.bulk-mode]=\"hasBulkMode\">\n  <div class=\"services-list-item__skeleton__header\">\n    <div class=\"services-list-item__skeleton__header__left-aligned\">\n      <sie-ui-skeleton\n        class=\"services-list-item__skeleton__header__left-aligned__loader default-loading\"\n      ></sie-ui-skeleton>\n    </div>\n  </div>\n  <div class=\"services-list-item__skeleton__body\">\n    <div class=\"services-list-item__skeleton__body-description\">\n      <sie-ui-skeleton class=\"first-loader default-loading\"></sie-ui-skeleton>\n      <sie-ui-skeleton class=\"default-loading\"></sie-ui-skeleton>\n      <sie-ui-skeleton class=\"last-loader default-loading\"></sie-ui-skeleton>\n    </div>\n  </div>\n</div>\n", styles: [".services-list-item__skeleton{padding:1px 0 0 20px}.services-list-item__skeleton.bulk-mode{padding-left:48px}.services-list-item__skeleton__header{margin:0 0 16px 32px;width:80px;height:20px}@media (min-width: 640px){.services-list-item__skeleton__header{margin-left:0}}@media (min-width: 1024px){.services-list-item__skeleton .last-loader{width:30%}}@media (max-width: 1023.78px){.services-list-item__skeleton .last-loader{width:50%}}.services-list-item__skeleton .default-loading{height:20px;margin-bottom:4px}@media (min-width: 1024px){.services-list-item__skeleton .default-loading:not(.last-loader){width:90%}}.services-list-item__skeleton .first-loader{height:24px}\n"], dependencies: [{ kind: "component", type: UiSkeletonComponent, selector: "sie-ui-skeleton", inputs: ["shape", "loadingText", "ariaLabel", "count"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiServicesListItemSkeletonComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-services-list-item-skeleton', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"services-list-item__skeleton\" [class.bulk-mode]=\"hasBulkMode\">\n  <div class=\"services-list-item__skeleton__header\">\n    <div class=\"services-list-item__skeleton__header__left-aligned\">\n      <sie-ui-skeleton\n        class=\"services-list-item__skeleton__header__left-aligned__loader default-loading\"\n      ></sie-ui-skeleton>\n    </div>\n  </div>\n  <div class=\"services-list-item__skeleton__body\">\n    <div class=\"services-list-item__skeleton__body-description\">\n      <sie-ui-skeleton class=\"first-loader default-loading\"></sie-ui-skeleton>\n      <sie-ui-skeleton class=\"default-loading\"></sie-ui-skeleton>\n      <sie-ui-skeleton class=\"last-loader default-loading\"></sie-ui-skeleton>\n    </div>\n  </div>\n</div>\n", styles: [".services-list-item__skeleton{padding:1px 0 0 20px}.services-list-item__skeleton.bulk-mode{padding-left:48px}.services-list-item__skeleton__header{margin:0 0 16px 32px;width:80px;height:20px}@media (min-width: 640px){.services-list-item__skeleton__header{margin-left:0}}@media (min-width: 1024px){.services-list-item__skeleton .last-loader{width:30%}}@media (max-width: 1023.78px){.services-list-item__skeleton .last-loader{width:50%}}.services-list-item__skeleton .default-loading{height:20px;margin-bottom:4px}@media (min-width: 1024px){.services-list-item__skeleton .default-loading:not(.last-loader){width:90%}}.services-list-item__skeleton .first-loader{height:24px}\n"] }]
        }], propDecorators: { hasBulkMode: [{
                type: Input
            }] } });

class UiServicesListItemComponent extends UiListItemDirective {
    set itemData(itemData) {
        this._itemData = itemData;
        if (itemData?.networkFlag?.icon) {
            this.iconReg.register(itemData.networkFlag.icon);
        }
    }
    get itemData() {
        return this._itemData;
    }
    constructor(cdr, iconReg, viewContainerRef) {
        super(cdr, viewContainerRef);
        this.cdr = cdr;
        this.iconReg = iconReg;
        this.viewContainerRef = viewContainerRef;
    }
    onDropdownOptionSelected(event) {
        this.itemEvent.next({ action: 'ACTION_MENU_CLICKED', item: this.itemData, id: event.value });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiServicesListItemComponent, deps: [{ token: i0.ChangeDetectorRef }, { token: i1.SieIconRegistryService }, { token: i0.ViewContainerRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiServicesListItemComponent, selector: "sie-ui-services-list-item", inputs: { itemData: "itemData" }, usesInheritance: true, ngImport: i0, template: "<ng-container *ngIf=\"!loading && itemData; else skeleton\">\n  <div sieCoreAdvancedHoverEffect [hoverEffectLink]=\"itemData.url\" class=\"services-list-item\">\n    <header\n      [ngClass]=\"{ 'has-label': !!itemData.networkFlag?.icon || !!itemData.itemStatusLabel }\"\n      class=\"services-list-item__header\"\n    >\n      <div class=\"services-list-item__header__date\">\n        <span class=\"services-list-item__header__info\">\n          {{ itemData.date | localDate }} \u00B7 {{ itemData.translatedId }}\n        </span>\n        <ng-container *ngIf=\"itemData.actionMenuDropdownOptions?.length > 0\">\n          <sie-ui-menu-button\n            class=\"services-list-item__header__menu-button\"\n            [options]=\"itemData.actionMenuDropdownOptions\"\n            (actionClicked)=\"onDropdownOptionSelected($event)\"\n          ></sie-ui-menu-button>\n        </ng-container>\n      </div>\n      <div\n        *ngIf=\"!!itemData.networkFlag?.icon || !!itemData.itemStatusLabel\"\n        class=\"services-list-item__header__status\"\n      >\n        <sie-icon\n          *ngIf=\"itemData.networkFlag?.icon\"\n          class=\"services-list-item__header__status__icon\"\n          [name]=\"itemData.networkFlag?.icon\"\n        ></sie-icon>\n        <span *ngIf=\"!!itemData.itemStatusLabel\" class=\"services-list-item__header__status__update-tag\">\n          {{ itemData.itemStatusLabel }}\n        </span>\n      </div>\n      <a href=\"{{ this.itemData.url }}\" class=\"services-list-item__header__headline\" rel=\"noopener\">\n        <h4>{{ itemData.title }}</h4>\n      </a>\n    </header>\n    <div class=\"services-list-item__body\">\n      <div class=\"row\">\n        <div class=\"col-l-8\">\n          <a href=\"{{ this.itemData.url }}\" class=\"services-list-item__body__description__link\" rel=\"noopener\">\n            <div class=\"services-list-item__body__description\">\n              <sie-ui-richtext [content]=\"itemData.description\"></sie-ui-richtext>\n            </div>\n          </a>\n        </div>\n      </div>\n    </div>\n  </div>\n</ng-container>\n\n<ng-template #skeleton>\n  <sie-ui-services-list-item-skeleton [hasBulkMode]=\"bulkMode\"></sie-ui-services-list-item-skeleton>\n</ng-template>\n", styles: [".services-list-item__body__description__link,.services-list-item__header__headline{outline:none;outline-offset:0}@media (pointer: fine){.services-list-item__body__description__link,.services-list-item__header__headline{position:relative}.services-list-item__body__description__link:focus,.services-list-item__header__headline:focus{outline:1px solid #1491eb;outline-offset:2px}.services-list-item__body__description__link:focus:not(:focus-visible),.services-list-item__header__headline:focus:not(:focus-visible){outline:0}.services-list-item__body__description__link:focus-visible,.services-list-item__header__headline:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}.services-list-item{display:block;padding:1rem 0 .625rem 1rem}:host.bulk-mode .services-list-item{padding:0 0 0 48px;flex-direction:column}.services-list-item__header{display:flex;flex-direction:row;flex-wrap:wrap;font-size:14px;line-height:20px}@media (min-width: 640px){.services-list-item__header{justify-content:space-between}}@media print{.services-list-item__header{justify-content:space-between}}.services-list-item__header__date{display:flex;align-items:center;white-space:nowrap;color:#9999a9;width:100%}@media (min-width: 640px){.services-list-item__header__date{margin-top:0}}:host.bulk-mode .services-list-item__header__date{margin:0 0 0 30px}.services-list-item__header__menu-button{position:relative;top:4px}.services-list-item__header__headline{margin-top:8px;width:100%;display:inline-block;color:inherit}.advanced-hover .services-list-item__header__headline{text-decoration:underline;text-decoration-thickness:3px}.services-list-item__header__status{width:inherit;display:flex}.services-list-item__header__status__update-tag{text-transform:uppercase;color:#00af52;margin-right:5px}.services-list-item__header__status__icon{margin-right:8px}.has-label .services-list-item__header__date{margin-top:10px;order:2;margin-left:0;width:inherit}@media (min-width: 640px){.has-label .services-list-item__header__date{margin-top:0}}@media print{.has-label .services-list-item__header__date{margin-top:0}}.has-label .services-list-item__header__status{order:1;width:100%}@media (min-width: 640px){.has-label .services-list-item__header__status{margin-left:0;width:inherit}:host.bulk-mode .has-label .services-list-item__header__status{margin-left:0}}@media print{.has-label .services-list-item__header__status{width:auto}}.has-label .services-list-item__header__headline{order:3;width:100%}@media (min-width: 640px){.services-list-item__header:not(.has-label){flex-wrap:nowrap}}@media print{.services-list-item__header:not(.has-label){flex-wrap:nowrap}}@media (min-width: 640px){.services-list-item__header:not(header.has-label) .services-list-item__header__headline{margin-top:0;width:inherit;order:1}}@media print{.services-list-item__header:not(header.has-label) .services-list-item__header__headline{margin-top:0;order:1}}@media (min-width: 640px){.services-list-item__header:not(.has-label) .services-list-item__header__date{width:inherit;order:2;margin-left:24px}}@media print{.services-list-item__header:not(.has-label) .services-list-item__header__date{width:inherit;order:2}}.services-list-item__body__description{font-size:.875rem;font-weight:400;line-height:1.25rem;margin-top:4px;word-break:break-word}.services-list-item__body__description__link{display:inline-block;height:100%;color:inherit;width:100%}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: UiRichtextComponent, selector: "sie-ui-richtext", inputs: ["content", "theme", "whiteListedTags"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "directive", type: i1$1.AdvancedHoverEffectDirective, selector: "[sieCoreAdvancedHoverEffect]", inputs: ["hoverEffectLink", "hoverEffectAdditionalDataLoaded"] }, { kind: "component", type: UiMenuButtonComponent, selector: "sie-ui-menu-button", inputs: ["menuButtonScreenReaderText", "menuTheme", "menuButtonType", "menuButtonVariant", "menuButtonThemeType", "menuButtonText", "leadingButtonIcon"], outputs: ["actionClicked"] }, { kind: "component", type: UiServicesListItemSkeletonComponent, selector: "sie-ui-services-list-item-skeleton", inputs: ["hasBulkMode"] }, { kind: "pipe", type: i1$1.LocalDatePipe, name: "localDate" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiServicesListItemComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-services-list-item', changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-container *ngIf=\"!loading && itemData; else skeleton\">\n  <div sieCoreAdvancedHoverEffect [hoverEffectLink]=\"itemData.url\" class=\"services-list-item\">\n    <header\n      [ngClass]=\"{ 'has-label': !!itemData.networkFlag?.icon || !!itemData.itemStatusLabel }\"\n      class=\"services-list-item__header\"\n    >\n      <div class=\"services-list-item__header__date\">\n        <span class=\"services-list-item__header__info\">\n          {{ itemData.date | localDate }} \u00B7 {{ itemData.translatedId }}\n        </span>\n        <ng-container *ngIf=\"itemData.actionMenuDropdownOptions?.length > 0\">\n          <sie-ui-menu-button\n            class=\"services-list-item__header__menu-button\"\n            [options]=\"itemData.actionMenuDropdownOptions\"\n            (actionClicked)=\"onDropdownOptionSelected($event)\"\n          ></sie-ui-menu-button>\n        </ng-container>\n      </div>\n      <div\n        *ngIf=\"!!itemData.networkFlag?.icon || !!itemData.itemStatusLabel\"\n        class=\"services-list-item__header__status\"\n      >\n        <sie-icon\n          *ngIf=\"itemData.networkFlag?.icon\"\n          class=\"services-list-item__header__status__icon\"\n          [name]=\"itemData.networkFlag?.icon\"\n        ></sie-icon>\n        <span *ngIf=\"!!itemData.itemStatusLabel\" class=\"services-list-item__header__status__update-tag\">\n          {{ itemData.itemStatusLabel }}\n        </span>\n      </div>\n      <a href=\"{{ this.itemData.url }}\" class=\"services-list-item__header__headline\" rel=\"noopener\">\n        <h4>{{ itemData.title }}</h4>\n      </a>\n    </header>\n    <div class=\"services-list-item__body\">\n      <div class=\"row\">\n        <div class=\"col-l-8\">\n          <a href=\"{{ this.itemData.url }}\" class=\"services-list-item__body__description__link\" rel=\"noopener\">\n            <div class=\"services-list-item__body__description\">\n              <sie-ui-richtext [content]=\"itemData.description\"></sie-ui-richtext>\n            </div>\n          </a>\n        </div>\n      </div>\n    </div>\n  </div>\n</ng-container>\n\n<ng-template #skeleton>\n  <sie-ui-services-list-item-skeleton [hasBulkMode]=\"bulkMode\"></sie-ui-services-list-item-skeleton>\n</ng-template>\n", styles: [".services-list-item__body__description__link,.services-list-item__header__headline{outline:none;outline-offset:0}@media (pointer: fine){.services-list-item__body__description__link,.services-list-item__header__headline{position:relative}.services-list-item__body__description__link:focus,.services-list-item__header__headline:focus{outline:1px solid #1491eb;outline-offset:2px}.services-list-item__body__description__link:focus:not(:focus-visible),.services-list-item__header__headline:focus:not(:focus-visible){outline:0}.services-list-item__body__description__link:focus-visible,.services-list-item__header__headline:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}.services-list-item{display:block;padding:1rem 0 .625rem 1rem}:host.bulk-mode .services-list-item{padding:0 0 0 48px;flex-direction:column}.services-list-item__header{display:flex;flex-direction:row;flex-wrap:wrap;font-size:14px;line-height:20px}@media (min-width: 640px){.services-list-item__header{justify-content:space-between}}@media print{.services-list-item__header{justify-content:space-between}}.services-list-item__header__date{display:flex;align-items:center;white-space:nowrap;color:#9999a9;width:100%}@media (min-width: 640px){.services-list-item__header__date{margin-top:0}}:host.bulk-mode .services-list-item__header__date{margin:0 0 0 30px}.services-list-item__header__menu-button{position:relative;top:4px}.services-list-item__header__headline{margin-top:8px;width:100%;display:inline-block;color:inherit}.advanced-hover .services-list-item__header__headline{text-decoration:underline;text-decoration-thickness:3px}.services-list-item__header__status{width:inherit;display:flex}.services-list-item__header__status__update-tag{text-transform:uppercase;color:#00af52;margin-right:5px}.services-list-item__header__status__icon{margin-right:8px}.has-label .services-list-item__header__date{margin-top:10px;order:2;margin-left:0;width:inherit}@media (min-width: 640px){.has-label .services-list-item__header__date{margin-top:0}}@media print{.has-label .services-list-item__header__date{margin-top:0}}.has-label .services-list-item__header__status{order:1;width:100%}@media (min-width: 640px){.has-label .services-list-item__header__status{margin-left:0;width:inherit}:host.bulk-mode .has-label .services-list-item__header__status{margin-left:0}}@media print{.has-label .services-list-item__header__status{width:auto}}.has-label .services-list-item__header__headline{order:3;width:100%}@media (min-width: 640px){.services-list-item__header:not(.has-label){flex-wrap:nowrap}}@media print{.services-list-item__header:not(.has-label){flex-wrap:nowrap}}@media (min-width: 640px){.services-list-item__header:not(header.has-label) .services-list-item__header__headline{margin-top:0;width:inherit;order:1}}@media print{.services-list-item__header:not(header.has-label) .services-list-item__header__headline{margin-top:0;order:1}}@media (min-width: 640px){.services-list-item__header:not(.has-label) .services-list-item__header__date{width:inherit;order:2;margin-left:24px}}@media print{.services-list-item__header:not(.has-label) .services-list-item__header__date{width:inherit;order:2}}.services-list-item__body__description{font-size:.875rem;font-weight:400;line-height:1.25rem;margin-top:4px;word-break:break-word}.services-list-item__body__description__link{display:inline-block;height:100%;color:inherit;width:100%}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i1.SieIconRegistryService }, { type: i0.ViewContainerRef }]; }, propDecorators: { itemData: [{
                type: Input
            }] } });

const UI_BASE_LIST_CONTEXT_MENU_SERVICE = new InjectionToken('UI_BASE_LIST_CONTEXT_MENU_SERVICE');

class UiForumListItemSkeletonComponent {
    constructor() {
        this.recommendation = false;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiForumListItemSkeletonComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiForumListItemSkeletonComponent, selector: "sie-ui-forum-list-item-skeleton", inputs: { recommendation: "recommendation" }, ngImport: i0, template: "<div class=\"forum-list-item__skeleton\" [ngClass]=\"{recommendation}\">\n  <div class=\"forum-list-item__skeleton__tag\">\n    <sie-ui-skeleton class=\"default-loading\"></sie-ui-skeleton>\n  </div>\n  <div class=\"forum-list-item__skeleton__header\">\n    <div class=\"forum-list-item__skeleton__header__right-aligned\">\n      <sie-ui-skeleton\n        *ngIf=\"!recommendation; else actions\"\n        class=\"circle-loader\"\n        [count]=\"5\"\n        [shape]=\"'circle'\"\n      ></sie-ui-skeleton>\n    </div>\n    <div class=\"forum-list-item__skeleton__header__left-aligned\">\n      <sie-ui-skeleton class=\"default-loading\"></sie-ui-skeleton>\n    </div>\n  </div>\n  <div class=\"forum-list-item__skeleton__body\">\n    <sie-ui-skeleton class=\"default-loading\"></sie-ui-skeleton>\n    <sie-ui-skeleton class=\"default-loading\"></sie-ui-skeleton>\n    <div class=\"forum-list-item__skeleton__body__loaders\" *ngIf=\"recommendation\">\n      <sie-ui-skeleton class=\"default-loading\"></sie-ui-skeleton>\n      <sie-ui-skeleton class=\"default-loading\"></sie-ui-skeleton>\n      <sie-ui-skeleton class=\"default-loading\"></sie-ui-skeleton>\n    </div>\n  </div>\n</div>\n\n<ng-template #actions>\n  <sie-ui-skeleton class=\"default-loading\"></sie-ui-skeleton>\n  <sie-ui-skeleton class=\"button-loading\"></sie-ui-skeleton>\n</ng-template>\n", styles: [".forum-list-item__skeleton{margin-bottom:20px}.forum-list-item__skeleton .default-loading{height:20px;margin-bottom:4px;--ui-skeleton-display: block}@media (min-width: 1024px){.forum-list-item__skeleton__header{display:flex;justify-content:space-between}}.forum-list-item__skeleton__header__left-aligned{width:60%}.forum-list-item__skeleton__header__left-aligned .default-loading{height:25px}.forum-list-item__skeleton__header__right-aligned{height:100%;order:2;display:flex;flex-direction:row;justify-content:flex-end}.forum-list-item__skeleton__header__right-aligned .circle-loader{--ui-skeleton-circleHeight: 16px;--ui-skeleton-circleWidth: 16px;--ui-skeleton-circleMarginTop: 0;--ui-skeleton-circleMarginBottom: 0;--ui-skeleton-circleMarginLeft: 3px;--ui-skeleton-circleMarginRight: 3px}@media (min-width: 640px){.forum-list-item__skeleton__body .default-loading{width:85%}}.forum-list-item__skeleton.recommendation{background:#f3f3f0;padding-bottom:16px}.forum-list-item__skeleton.recommendation .forum-list-item__skeleton__header{padding-left:16px;padding-top:16px}.forum-list-item__skeleton.recommendation .forum-list-item__skeleton__header__left-aligned .default-loading{width:40%}.forum-list-item__skeleton.recommendation .forum-list-item__skeleton__header__right-aligned{padding-right:0;width:100%;gap:17px}.forum-list-item__skeleton.recommendation .forum-list-item__skeleton__header__right-aligned .default-loading{width:100%;height:25px;max-width:195px}.forum-list-item__skeleton.recommendation .forum-list-item__skeleton__header__right-aligned .button-loading{width:100%;height:25px;max-width:26px}.forum-list-item__skeleton.recommendation .forum-list-item__skeleton__body{padding-left:16px}.forum-list-item__skeleton.recommendation .forum-list-item__skeleton__body .default-loading{width:95%}@media (min-width: 640px){.forum-list-item__skeleton.recommendation .forum-list-item__skeleton__body .default-loading{width:60%}}@media (min-width: 1024px){.forum-list-item__skeleton.recommendation .forum-list-item__skeleton__body .default-loading{width:70%}}@media (min-width: 640px){.forum-list-item__skeleton.recommendation .forum-list-item__skeleton__body .forum-list-item__skeleton__body__loaders{display:none}}.forum-list-item__skeleton__tag{height:25px;max-width:154px;width:100%}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: UiSkeletonComponent, selector: "sie-ui-skeleton", inputs: ["shape", "loadingText", "ariaLabel", "count"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiForumListItemSkeletonComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-forum-list-item-skeleton', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"forum-list-item__skeleton\" [ngClass]=\"{recommendation}\">\n  <div class=\"forum-list-item__skeleton__tag\">\n    <sie-ui-skeleton class=\"default-loading\"></sie-ui-skeleton>\n  </div>\n  <div class=\"forum-list-item__skeleton__header\">\n    <div class=\"forum-list-item__skeleton__header__right-aligned\">\n      <sie-ui-skeleton\n        *ngIf=\"!recommendation; else actions\"\n        class=\"circle-loader\"\n        [count]=\"5\"\n        [shape]=\"'circle'\"\n      ></sie-ui-skeleton>\n    </div>\n    <div class=\"forum-list-item__skeleton__header__left-aligned\">\n      <sie-ui-skeleton class=\"default-loading\"></sie-ui-skeleton>\n    </div>\n  </div>\n  <div class=\"forum-list-item__skeleton__body\">\n    <sie-ui-skeleton class=\"default-loading\"></sie-ui-skeleton>\n    <sie-ui-skeleton class=\"default-loading\"></sie-ui-skeleton>\n    <div class=\"forum-list-item__skeleton__body__loaders\" *ngIf=\"recommendation\">\n      <sie-ui-skeleton class=\"default-loading\"></sie-ui-skeleton>\n      <sie-ui-skeleton class=\"default-loading\"></sie-ui-skeleton>\n      <sie-ui-skeleton class=\"default-loading\"></sie-ui-skeleton>\n    </div>\n  </div>\n</div>\n\n<ng-template #actions>\n  <sie-ui-skeleton class=\"default-loading\"></sie-ui-skeleton>\n  <sie-ui-skeleton class=\"button-loading\"></sie-ui-skeleton>\n</ng-template>\n", styles: [".forum-list-item__skeleton{margin-bottom:20px}.forum-list-item__skeleton .default-loading{height:20px;margin-bottom:4px;--ui-skeleton-display: block}@media (min-width: 1024px){.forum-list-item__skeleton__header{display:flex;justify-content:space-between}}.forum-list-item__skeleton__header__left-aligned{width:60%}.forum-list-item__skeleton__header__left-aligned .default-loading{height:25px}.forum-list-item__skeleton__header__right-aligned{height:100%;order:2;display:flex;flex-direction:row;justify-content:flex-end}.forum-list-item__skeleton__header__right-aligned .circle-loader{--ui-skeleton-circleHeight: 16px;--ui-skeleton-circleWidth: 16px;--ui-skeleton-circleMarginTop: 0;--ui-skeleton-circleMarginBottom: 0;--ui-skeleton-circleMarginLeft: 3px;--ui-skeleton-circleMarginRight: 3px}@media (min-width: 640px){.forum-list-item__skeleton__body .default-loading{width:85%}}.forum-list-item__skeleton.recommendation{background:#f3f3f0;padding-bottom:16px}.forum-list-item__skeleton.recommendation .forum-list-item__skeleton__header{padding-left:16px;padding-top:16px}.forum-list-item__skeleton.recommendation .forum-list-item__skeleton__header__left-aligned .default-loading{width:40%}.forum-list-item__skeleton.recommendation .forum-list-item__skeleton__header__right-aligned{padding-right:0;width:100%;gap:17px}.forum-list-item__skeleton.recommendation .forum-list-item__skeleton__header__right-aligned .default-loading{width:100%;height:25px;max-width:195px}.forum-list-item__skeleton.recommendation .forum-list-item__skeleton__header__right-aligned .button-loading{width:100%;height:25px;max-width:26px}.forum-list-item__skeleton.recommendation .forum-list-item__skeleton__body{padding-left:16px}.forum-list-item__skeleton.recommendation .forum-list-item__skeleton__body .default-loading{width:95%}@media (min-width: 640px){.forum-list-item__skeleton.recommendation .forum-list-item__skeleton__body .default-loading{width:60%}}@media (min-width: 1024px){.forum-list-item__skeleton.recommendation .forum-list-item__skeleton__body .default-loading{width:70%}}@media (min-width: 640px){.forum-list-item__skeleton.recommendation .forum-list-item__skeleton__body .forum-list-item__skeleton__body__loaders{display:none}}.forum-list-item__skeleton__tag{height:25px;max-width:154px;width:100%}\n"] }]
        }], propDecorators: { recommendation: [{
                type: Input
            }] } });

class UiForumListItemComponent extends UiListItemDirective {
    constructor(cdr, localeService, iconReg, baseListContextMenuService, document) {
        super(cdr);
        this.cdr = cdr;
        this.localeService = localeService;
        this.iconReg = iconReg;
        this.baseListContextMenuService = baseListContextMenuService;
        this.document = document;
        this.recommendation = false;
        iconReg.register(SieIcon.Information);
    }
    contextMenuOptionSelected(button) {
        this.baseListContextMenuService?.handleChildActions({ button: button, item: this.itemData });
    }
    clickEventHandler(e) {
        e.preventDefault();
        this.itemEvent.next({ item: this.itemData, action: 'OPEN_DETAILS_PAGE' });
        this.document.defaultView.window.location.href = this.itemData.url;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiForumListItemComponent, deps: [{ token: i0.ChangeDetectorRef }, { token: i1$1.LocaleService }, { token: i1.SieIconRegistryService }, { token: UI_BASE_LIST_CONTEXT_MENU_SERVICE, optional: true }, { token: DOCUMENT }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiForumListItemComponent, selector: "sie-ui-forum-list-item", inputs: { recommendation: "recommendation", tagLabel: "tagLabel" }, usesInheritance: true, ngImport: i0, template: "<ng-container *ngIf=\"!loading && itemData; else skeleton\">\n  <article\n    sieCoreAdvancedHoverEffect\n    [hoverEffectLink]=\"itemData.url\"\n    class=\"forum-list-item\"\n    [ngClass]=\"{ recommendation }\"\n    [sieCoreAttributes]=\"itemData.dataAttributes\"\n  >\n    <sie-ui-tag *ngIf=\"recommendation\" status=\"neutral\" [croppedTop]=\"true\"\n      >{{ tagLabel }}\n      <sie-icon [name]=\"iconReg.sieIcon.Information\" class=\"forum-list-item__icon\"></sie-icon>\n    </sie-ui-tag>\n\n    <header class=\"forum-list-item__header\">\n      <div class=\"forum-list-item__header__info\">\n        <div class=\"forum-list-item__header__date\">{{ itemData.documentDate | localDate }}</div>\n        <sie-ui-rating-stars\n          [rating]=\"itemData.rating\"\n          [ratingCount]=\"itemData.ratingCount\"\n          [tooltip]=\"itemData.tooltipLabel\"\n          [locale]=\"localeService.getIsoValidLocaleString()\"\n        ></sie-ui-rating-stars>\n        <sie-ui-menu-button\n          *ngIf=\"recommendation && itemData.childActions\"\n          class=\"forum-list-item__header__menu-button\"\n          [options]=\"itemData.childActions\"\n          menuButtonType=\"icon-condensed\"\n          (actionClicked)=\"contextMenuOptionSelected($event)\"\n        ></sie-ui-menu-button>\n      </div>\n      <h5 class=\"forum-list-item__header__title\">\n        <a\n          class=\"forum-list-item__header__title__link\"\n          [href]=\"itemData.url\"\n          (click)=\"clickEventHandler($event)\"\n          rel=\"noopener\"\n          >{{ itemData.title }}</a\n        >\n      </h5>\n    </header>\n    <div class=\"forum-list-item__body\">\n      <div class=\"row\">\n        <div class=\"col-l-8\">\n          <a\n            class=\"forum-list-item__body__link\"\n            [href]=\"itemData.url\"\n            (click)=\"clickEventHandler($event)\"\n            rel=\"noopener\"\n          >\n            <sie-ui-richtext\n              [content]=\"itemData.description\"\n              class=\"forum-list-item__body__link__description\"\n            ></sie-ui-richtext>\n          </a>\n        </div>\n      </div>\n    </div>\n  </article>\n</ng-container>\n\n<ng-template #skeleton>\n  <sie-ui-forum-list-item-skeleton></sie-ui-forum-list-item-skeleton>\n</ng-template>\n", styles: [".forum-list-item__body__link,.forum-list-item__header__title__link{outline:none;outline-offset:0}@media (pointer: fine){.forum-list-item__body__link,.forum-list-item__header__title__link{position:relative}.forum-list-item__body__link:focus,.forum-list-item__header__title__link:focus{outline:1px solid #1491eb;outline-offset:2px}.forum-list-item__body__link:focus:not(:focus-visible),.forum-list-item__header__title__link:focus:not(:focus-visible){outline:0}.forum-list-item__body__link:focus-visible,.forum-list-item__header__title__link:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}.forum-list-item__header{margin-bottom:4px}@media (min-width: 1024px){.forum-list-item__header{display:flex}}@media print{.forum-list-item__header{display:flex;flex-direction:row-reverse;justify-content:space-between}}.forum-list-item__header__title{margin-right:auto}@media (min-width: 1024px){.forum-list-item__header__title{padding-right:16px}}.forum-list-item__header__title__link{display:block;height:100%;color:inherit}.advanced-hover .forum-list-item__header__title__link{text-decoration:underline;text-decoration-thickness:3px}.forum-list-item__header__info{font-size:.875rem;font-weight:400;line-height:1.25rem;display:flex;justify-content:space-between;margin-bottom:12px;color:#737389}@media (min-width: 1024px){.forum-list-item__header__info{justify-content:flex-end;margin-bottom:0;order:2}}@media print{.forum-list-item__header__info{justify-content:flex-end}}.recommendation .forum-list-item__header__info{align-items:center}.forum-list-item__header__date{margin-right:16px}.forum-list-item__header__menu-button{position:relative;white-space:normal;height:24px;width:24px;margin-left:8px}.forum-list-item__body__link{display:block;height:100%;color:inherit}.forum-list-item__body__link__description{font-size:.875rem;font-weight:400;line-height:1.25rem}.forum-list-item.recommendation{background:#f3f3f0;padding-bottom:16px}.forum-list-item.recommendation .forum-list-item__header{padding:16px 0 0 16px;position:relative}.forum-list-item.recommendation .forum-list-item__header__title{padding-right:16px}.forum-list-item.recommendation .forum-list-item__header__info{justify-content:flex-start}@media (min-width: 640px) and (max-width: 1023.8px){.forum-list-item.recommendation .forum-list-item__header__info{justify-content:flex-end}}@media (max-width: 639.78px){.forum-list-item.recommendation .forum-list-item__header__menu-button{position:absolute;right:0;top:-10px}}.forum-list-item.recommendation .forum-list-item__body{padding-left:16px;padding-right:16px}.forum-list-item.recommendation .forum-list-item__body__link__description{overflow:hidden;display:-webkit-box;-webkit-box-orient:vertical;-webkit-line-clamp:3}.forum-list-item__icon{width:18px;height:18px;display:flex;align-items:center;fill:currentColor;display:inline-flex;margin-left:15px}.forum-list-item__icon svg{fill:currentColor;width:inherit;height:inherit}.forum-list-item__icon svg g{fill:currentColor;width:inherit;height:inherit}.forum-list-item__icon svg text{font-family:Siemens Sans,sans-serif}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: UiRichtextComponent, selector: "sie-ui-richtext", inputs: ["content", "theme", "whiteListedTags"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "component", type: UiRatingStarsComponent, selector: "sie-ui-rating-stars", inputs: ["tooltip", "ratingCount", "rating", "locale"] }, { kind: "directive", type: i1$1.AdvancedHoverEffectDirective, selector: "[sieCoreAdvancedHoverEffect]", inputs: ["hoverEffectLink", "hoverEffectAdditionalDataLoaded"] }, { kind: "directive", type: i1$1.AttributeDirective, selector: "[sieCoreAttributes]", inputs: ["sieCoreAttributes"] }, { kind: "component", type: UiTagComponent, selector: "sie-ui-tag", inputs: ["mode", "theme", "status", "tagId", "dataAttrName", "dataAttrValue", "disabled", "croppedTop", "condensed", "linkable", "removeButtonAriaLabel"], outputs: ["selected", "unselected", "removed", "clicked"] }, { kind: "component", type: UiMenuButtonComponent, selector: "sie-ui-menu-button", inputs: ["menuButtonScreenReaderText", "menuTheme", "menuButtonType", "menuButtonVariant", "menuButtonThemeType", "menuButtonText", "leadingButtonIcon"], outputs: ["actionClicked"] }, { kind: "component", type: UiForumListItemSkeletonComponent, selector: "sie-ui-forum-list-item-skeleton", inputs: ["recommendation"] }, { kind: "pipe", type: i1$1.LocalDatePipe, name: "localDate" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiForumListItemComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-forum-list-item', changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-container *ngIf=\"!loading && itemData; else skeleton\">\n  <article\n    sieCoreAdvancedHoverEffect\n    [hoverEffectLink]=\"itemData.url\"\n    class=\"forum-list-item\"\n    [ngClass]=\"{ recommendation }\"\n    [sieCoreAttributes]=\"itemData.dataAttributes\"\n  >\n    <sie-ui-tag *ngIf=\"recommendation\" status=\"neutral\" [croppedTop]=\"true\"\n      >{{ tagLabel }}\n      <sie-icon [name]=\"iconReg.sieIcon.Information\" class=\"forum-list-item__icon\"></sie-icon>\n    </sie-ui-tag>\n\n    <header class=\"forum-list-item__header\">\n      <div class=\"forum-list-item__header__info\">\n        <div class=\"forum-list-item__header__date\">{{ itemData.documentDate | localDate }}</div>\n        <sie-ui-rating-stars\n          [rating]=\"itemData.rating\"\n          [ratingCount]=\"itemData.ratingCount\"\n          [tooltip]=\"itemData.tooltipLabel\"\n          [locale]=\"localeService.getIsoValidLocaleString()\"\n        ></sie-ui-rating-stars>\n        <sie-ui-menu-button\n          *ngIf=\"recommendation && itemData.childActions\"\n          class=\"forum-list-item__header__menu-button\"\n          [options]=\"itemData.childActions\"\n          menuButtonType=\"icon-condensed\"\n          (actionClicked)=\"contextMenuOptionSelected($event)\"\n        ></sie-ui-menu-button>\n      </div>\n      <h5 class=\"forum-list-item__header__title\">\n        <a\n          class=\"forum-list-item__header__title__link\"\n          [href]=\"itemData.url\"\n          (click)=\"clickEventHandler($event)\"\n          rel=\"noopener\"\n          >{{ itemData.title }}</a\n        >\n      </h5>\n    </header>\n    <div class=\"forum-list-item__body\">\n      <div class=\"row\">\n        <div class=\"col-l-8\">\n          <a\n            class=\"forum-list-item__body__link\"\n            [href]=\"itemData.url\"\n            (click)=\"clickEventHandler($event)\"\n            rel=\"noopener\"\n          >\n            <sie-ui-richtext\n              [content]=\"itemData.description\"\n              class=\"forum-list-item__body__link__description\"\n            ></sie-ui-richtext>\n          </a>\n        </div>\n      </div>\n    </div>\n  </article>\n</ng-container>\n\n<ng-template #skeleton>\n  <sie-ui-forum-list-item-skeleton></sie-ui-forum-list-item-skeleton>\n</ng-template>\n", styles: [".forum-list-item__body__link,.forum-list-item__header__title__link{outline:none;outline-offset:0}@media (pointer: fine){.forum-list-item__body__link,.forum-list-item__header__title__link{position:relative}.forum-list-item__body__link:focus,.forum-list-item__header__title__link:focus{outline:1px solid #1491eb;outline-offset:2px}.forum-list-item__body__link:focus:not(:focus-visible),.forum-list-item__header__title__link:focus:not(:focus-visible){outline:0}.forum-list-item__body__link:focus-visible,.forum-list-item__header__title__link:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}.forum-list-item__header{margin-bottom:4px}@media (min-width: 1024px){.forum-list-item__header{display:flex}}@media print{.forum-list-item__header{display:flex;flex-direction:row-reverse;justify-content:space-between}}.forum-list-item__header__title{margin-right:auto}@media (min-width: 1024px){.forum-list-item__header__title{padding-right:16px}}.forum-list-item__header__title__link{display:block;height:100%;color:inherit}.advanced-hover .forum-list-item__header__title__link{text-decoration:underline;text-decoration-thickness:3px}.forum-list-item__header__info{font-size:.875rem;font-weight:400;line-height:1.25rem;display:flex;justify-content:space-between;margin-bottom:12px;color:#737389}@media (min-width: 1024px){.forum-list-item__header__info{justify-content:flex-end;margin-bottom:0;order:2}}@media print{.forum-list-item__header__info{justify-content:flex-end}}.recommendation .forum-list-item__header__info{align-items:center}.forum-list-item__header__date{margin-right:16px}.forum-list-item__header__menu-button{position:relative;white-space:normal;height:24px;width:24px;margin-left:8px}.forum-list-item__body__link{display:block;height:100%;color:inherit}.forum-list-item__body__link__description{font-size:.875rem;font-weight:400;line-height:1.25rem}.forum-list-item.recommendation{background:#f3f3f0;padding-bottom:16px}.forum-list-item.recommendation .forum-list-item__header{padding:16px 0 0 16px;position:relative}.forum-list-item.recommendation .forum-list-item__header__title{padding-right:16px}.forum-list-item.recommendation .forum-list-item__header__info{justify-content:flex-start}@media (min-width: 640px) and (max-width: 1023.8px){.forum-list-item.recommendation .forum-list-item__header__info{justify-content:flex-end}}@media (max-width: 639.78px){.forum-list-item.recommendation .forum-list-item__header__menu-button{position:absolute;right:0;top:-10px}}.forum-list-item.recommendation .forum-list-item__body{padding-left:16px;padding-right:16px}.forum-list-item.recommendation .forum-list-item__body__link__description{overflow:hidden;display:-webkit-box;-webkit-box-orient:vertical;-webkit-line-clamp:3}.forum-list-item__icon{width:18px;height:18px;display:flex;align-items:center;fill:currentColor;display:inline-flex;margin-left:15px}.forum-list-item__icon svg{fill:currentColor;width:inherit;height:inherit}.forum-list-item__icon svg g{fill:currentColor;width:inherit;height:inherit}.forum-list-item__icon svg text{font-family:Siemens Sans,sans-serif}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i1$1.LocaleService }, { type: i1.SieIconRegistryService }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [UI_BASE_LIST_CONTEXT_MENU_SERVICE]
                }, {
                    type: Optional
                }] }, { type: Document, decorators: [{
                    type: Inject,
                    args: [DOCUMENT]
                }] }]; }, propDecorators: { recommendation: [{
                type: Input
            }], tagLabel: [{
                type: Input
            }] } });

/**
 * # Menu Button Module
 * - {@link UiMenuButtonComponent}
 *
 * ## Module peer dependencies
 * - {@link SieIconsModule}
 */
class UiMenuButtonModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiMenuButtonModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiMenuButtonModule, declarations: [UiMenuButtonComponent], imports: [CommonModule, UiButtonModule, SieIconsModule, UiDropdownMenuModule, UiDropdownOptionsModule], exports: [UiMenuButtonComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiMenuButtonModule, imports: [CommonModule, UiButtonModule, SieIconsModule, UiDropdownMenuModule, UiDropdownOptionsModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiMenuButtonModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiMenuButtonComponent],
                    imports: [CommonModule, UiButtonModule, SieIconsModule, UiDropdownMenuModule, UiDropdownOptionsModule],
                    exports: [UiMenuButtonComponent]
                }]
        }] });

class UiStaticListItemDirective {
    static { this.isStaticComponent = true; }
    set itemData(itemData) {
        this._itemData = itemData;
    }
    get itemData() {
        return this._itemData;
    }
    constructor(cdr, viewContainerRef) {
        this.cdr = cdr;
        this.viewContainerRef = viewContainerRef;
        this.itemType = 'file';
        this.itemAppearance = 'simple';
        this.selectionChanged = new Subject();
        this.itemEvent = new Subject();
    }
    ngOnChanges(_changes) {
        this.cdr.detectChanges();
    }
    headerContentAvailable() {
        return false;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiStaticListItemDirective, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ViewContainerRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: UiStaticListItemDirective, inputs: { itemType: "itemType", itemAppearance: "itemAppearance", connectedComponent: "connectedComponent", itemData: "itemData" }, outputs: { selectionChanged: "selectionChanged", itemEvent: "itemEvent" }, usesOnChanges: true, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiStaticListItemDirective, decorators: [{
            type: Directive
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ViewContainerRef }]; }, propDecorators: { itemType: [{
                type: Input
            }], itemAppearance: [{
                type: Input
            }], connectedComponent: [{
                type: Input
            }], itemData: [{
                type: Input
            }], selectionChanged: [{
                type: Output
            }], itemEvent: [{
                type: Output
            }] } });

class UiSeparatorListItemComponent extends UiStaticListItemDirective {
    constructor(cdr) {
        super(cdr);
        this.cdr = cdr;
        this.loading = false;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiSeparatorListItemComponent, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiSeparatorListItemComponent, selector: "sie-ui-separator-list-item", inputs: { loading: "loading" }, usesInheritance: true, ngImport: i0, template: "<span class=\"separator-list-item__date-time\">\n  <ng-container *ngIf=\"!loading; else skeleton\">{{ itemData?.date | localDate }}</ng-container>\n</span>\n\n<div *ngIf=\"loading\" class=\"separator-list-item--bottom-line\"></div>\n\n<ng-template #skeleton>\n  <sie-ui-skeleton class=\"loader-wrapper\"></sie-ui-skeleton>\n</ng-template>\n", styles: [".separator-list-item__date-time{font-size:.75rem;font-weight:700;line-height:1rem;display:flex;color:#9999a9}@media (min-width: 640px){.separator-list-item__date-time{margin-left:-16px;margin-right:-16px}}@media (min-width: 1024px){.separator-list-item__date-time{margin-left:calc(-1 * calc(calc(100vw - 376px)/12 * 1 + 0px));margin-right:calc(-1 * calc(calc(100vw - 376px)/12 * 1 + 0px))}}@media (min-width: 1440px){.separator-list-item__date-time{margin-left:calc(-1 * calc(calc(100vw - 456px)/12 * 1 + 0px));margin-right:calc(-1 * calc(calc(100vw - 456px)/12 * 1 + 0px))}}@media (min-width: 1920px){.separator-list-item__date-time{margin-left:-122px;margin-right:-122px}}.separator-list-item__date-time:empty{display:none}.separator-list-item__date-time:before,.separator-list-item__date-time:after{content:\"\";flex:1 1;border-bottom:1px solid #ccccd4;margin:auto}@media print{.separator-list-item__date-time:before,.separator-list-item__date-time:after{border-bottom-width:1pt}}.separator-list-item__date-time:before{margin-right:16px}@media (min-width: 640px){.separator-list-item__date-time:before{margin-right:10px}}@media print{.separator-list-item__date-time:before{margin-right:10px}}.separator-list-item__date-time:after{margin-left:16px}@media (min-width: 640px){.separator-list-item__date-time:after{margin-left:10px}}.separator-list-item__date-time .loader-wrapper{width:40px;height:16px}.separator-list-item--bottom-line{border:2px solid #fff;position:absolute;width:100%;top:15px}\n"], dependencies: [{ kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: UiSkeletonComponent, selector: "sie-ui-skeleton", inputs: ["shape", "loadingText", "ariaLabel", "count"] }, { kind: "pipe", type: i1$1.LocalDatePipe, name: "localDate" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiSeparatorListItemComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-separator-list-item', changeDetection: ChangeDetectionStrategy.OnPush, template: "<span class=\"separator-list-item__date-time\">\n  <ng-container *ngIf=\"!loading; else skeleton\">{{ itemData?.date | localDate }}</ng-container>\n</span>\n\n<div *ngIf=\"loading\" class=\"separator-list-item--bottom-line\"></div>\n\n<ng-template #skeleton>\n  <sie-ui-skeleton class=\"loader-wrapper\"></sie-ui-skeleton>\n</ng-template>\n", styles: [".separator-list-item__date-time{font-size:.75rem;font-weight:700;line-height:1rem;display:flex;color:#9999a9}@media (min-width: 640px){.separator-list-item__date-time{margin-left:-16px;margin-right:-16px}}@media (min-width: 1024px){.separator-list-item__date-time{margin-left:calc(-1 * calc(calc(100vw - 376px)/12 * 1 + 0px));margin-right:calc(-1 * calc(calc(100vw - 376px)/12 * 1 + 0px))}}@media (min-width: 1440px){.separator-list-item__date-time{margin-left:calc(-1 * calc(calc(100vw - 456px)/12 * 1 + 0px));margin-right:calc(-1 * calc(calc(100vw - 456px)/12 * 1 + 0px))}}@media (min-width: 1920px){.separator-list-item__date-time{margin-left:-122px;margin-right:-122px}}.separator-list-item__date-time:empty{display:none}.separator-list-item__date-time:before,.separator-list-item__date-time:after{content:\"\";flex:1 1;border-bottom:1px solid #ccccd4;margin:auto}@media print{.separator-list-item__date-time:before,.separator-list-item__date-time:after{border-bottom-width:1pt}}.separator-list-item__date-time:before{margin-right:16px}@media (min-width: 640px){.separator-list-item__date-time:before{margin-right:10px}}@media print{.separator-list-item__date-time:before{margin-right:10px}}.separator-list-item__date-time:after{margin-left:16px}@media (min-width: 640px){.separator-list-item__date-time:after{margin-left:10px}}.separator-list-item__date-time .loader-wrapper{width:40px;height:16px}.separator-list-item--bottom-line{border:2px solid #fff;position:absolute;width:100%;top:15px}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }]; }, propDecorators: { loading: [{
                type: Input
            }] } });

class UiIconListItemComponent extends UiStaticListItemDirective {
    constructor(cdr, layoutService) {
        super(cdr);
        this.cdr = cdr;
        this.layoutService = layoutService;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiIconListItemComponent, deps: [{ token: i0.ChangeDetectorRef }, { token: i1$1.LayoutService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiIconListItemComponent, selector: "sie-ui-icon-list-item", usesInheritance: true, ngImport: i0, template: "<div class=\"icon-list-item\">\n  <sie-icon [name]=\"itemData?.icon\" class=\"icon-list-item__icon\" aria-hidden=\"true\"></sie-icon>\n</div>\n", styles: [".icon-list-item{display:flex;justify-content:center;padding-top:8px}.icon-list-item__icon{position:relative}.icon-list-item__icon>svg{width:30px;height:30px}\n"], dependencies: [{ kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiIconListItemComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-icon-list-item', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"icon-list-item\">\n  <sie-icon [name]=\"itemData?.icon\" class=\"icon-list-item__icon\" aria-hidden=\"true\"></sie-icon>\n</div>\n", styles: [".icon-list-item{display:flex;justify-content:center;padding-top:8px}.icon-list-item__icon{position:relative}.icon-list-item__icon>svg{width:30px;height:30px}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i1$1.LayoutService }]; } });

class UiListModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiListModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiListModule, declarations: [UiCatalogDocumentListItemComponent,
            UiCatalogServicesListItemComponent,
            UiCatalogCategoryListItemComponent,
            UiCatalogCategoryListItemSkeletonComponent,
            UiCatalogDocumentListItemSkeletonComponent,
            UiCatalogServicesListItemSkeletonComponent,
            UiServicesListItemComponent,
            UiServicesListItemSkeletonComponent,
            UiForumListItemComponent,
            UiForumListItemSkeletonComponent,
            UiSeparatorListItemComponent,
            UiIconListItemComponent], imports: [BaseUiListModule, UiMenuButtonModule, UiSkeletonModule], exports: [UiListComponent, UiSeparatorListItemComponent, UiForumListItemComponent, UiForumListItemSkeletonComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiListModule, imports: [BaseUiListModule, UiMenuButtonModule, UiSkeletonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiListModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        UiCatalogDocumentListItemComponent,
                        UiCatalogServicesListItemComponent,
                        UiCatalogCategoryListItemComponent,
                        UiCatalogCategoryListItemSkeletonComponent,
                        UiCatalogDocumentListItemSkeletonComponent,
                        UiCatalogServicesListItemSkeletonComponent,
                        UiServicesListItemComponent,
                        UiServicesListItemSkeletonComponent,
                        UiForumListItemComponent,
                        UiForumListItemSkeletonComponent,
                        UiSeparatorListItemComponent,
                        UiIconListItemComponent
                    ],
                    imports: [BaseUiListModule, UiMenuButtonModule, UiSkeletonModule],
                    exports: [UiListComponent, UiSeparatorListItemComponent, UiForumListItemComponent, UiForumListItemSkeletonComponent]
                }]
        }] });

/**
 * # Pagination Component
 *
 * Pagination provides access mechanism to browse through subsets of search results or lists with many items.
 * Pagination is mainly used when there are pages which includes list and list items. For example, Search results page.
 *
 * ## Content
 *
 * The pagination component does not accept any content.
 *
 * ## Code example
 * @example ```html
 * <sie-ui-pagination
 *  [totalPages]=“7”
 *  [activePage]=“4”
 *  ariaLabel="Pagination"
 *  ariaLabelActivePage="Active Page"
 *  ariaLabelSwitchToNextPage="Next page"
 *  ariaLabelSwitchToPage="Switch to page"
 *  ariaLabelSwitchToPreviousPage="Previous page"
 *  (pageSelected)="onPageSelection($event)"
 * ></sie-ui-pagination>
 * ```
 */
let UiPaginationComponent = class UiPaginationComponent {
    /**
     * @param value Set the total number of pages
     */
    set totalPages(value) {
        this._totalPages = coerceNumberProperty(value);
    }
    get totalPages() {
        return this._totalPages;
    }
    /**
     * Set the currently active page
     */
    set activePage(value) {
        this._activePage = coerceNumberProperty(value);
    }
    get activePage() {
        return this._activePage;
    }
    constructor(iconReg) {
        this.iconReg = iconReg;
        /**
         * Aria label for the pagination
         * @default ''
         */
        this.ariaLabel = '';
        /**
         * Aria label for the active page button
         * @default ''
         */
        this.ariaLabelActivePage = '';
        /**
         * Aria label for the non-active page button
         * @default ''
         */
        this.ariaLabelSwitchToPage = '';
        /**
         * Aria label for switch to next page button
         * @default ''
         */
        this.ariaLabelSwitchToNextPage = '';
        /**
         * Aria label for switch to previous page button
         * @default ''
         */
        this.ariaLabelSwitchToPreviousPage = '';
        /**
         * @param value Set the text of the tooltip when the last page reached
         */
        this.resultLimitReachedTooltipLabel = '';
        /**
         * Defined based on the {@link PaginationSize pagination size} whether 5 or 7 visible pages are displayed.
         * @default 'regular' 7 visible pages
         */
        this.paginationSize = 'regular';
        /**
         * Event triggered when the current active page is changed
         */
        this.pageSelected = new Subject();
        /** @ignore */
        this.pageNumbers = [];
        this.PAGE_AND_ELLIPSIS = 2;
        this.ELLIPSIS_JUMP_STEP = 5;
        iconReg.register(SieIcon.ArrowRight);
        iconReg.register(SieIcon.ArrowLeft);
    }
    ngOnInit() {
        this.updatePaginationSettings();
        this.arrangePagination();
    }
    /** @ignore */
    changePage(newPageNumber) {
        this.pageSelected.next(newPageNumber);
    }
    updatePaginationSettings() {
        this._visiblePages = this.paginationSize === 'small' ? 5 : 7;
        this._maxButtonWithoutEllipsis = this._visiblePages - this.PAGE_AND_ELLIPSIS;
        this._itemsBeforeOrAfterActivePage = (this._visiblePages - this.PAGE_AND_ELLIPSIS * 2 - 1) / 2;
    }
    arrangePagination() {
        this.pageNumbers = [];
        if (this.totalPages <= this._visiblePages) {
            this.addPageNumbers(1, this.totalPages);
        }
        else {
            this.paginationRendering();
        }
    }
    paginationRendering() {
        if (this.activePage < this._maxButtonWithoutEllipsis) {
            this.addPageNumbers(1, this._maxButtonWithoutEllipsis);
            this.getEllipsisNextPage(this.totalPages);
            this.addPageNumbers(this.totalPages, this.totalPages);
        }
        else if (this.activePage > this.totalPages - (this._maxButtonWithoutEllipsis - 1)) {
            this.addPageNumbers(1, 1);
            this.addPreviousEllipsis(this.totalPages - (this._maxButtonWithoutEllipsis - 1));
            this.addPageNumbers(this.totalPages - (this._maxButtonWithoutEllipsis - 1), this.totalPages);
        }
        else {
            this.addPageNumbers(1, 1);
            this.addPreviousEllipsis(this.activePage - this._itemsBeforeOrAfterActivePage);
            this.addPageNumbers(this.activePage - this._itemsBeforeOrAfterActivePage, this.activePage + this._itemsBeforeOrAfterActivePage);
            this.getEllipsisNextPage(this.totalPages);
            this.addPageNumbers(this.totalPages, this.totalPages);
        }
    }
    addPageNumbers(start, end) {
        for (let i = start; i <= end; i++) {
            this.pageNumbers.push({ label: i + '', value: i, bigSpaceNeeded: i > 999 });
        }
    }
    addPreviousEllipsis(nextShownPage) {
        let newPageNumber = this.activePage - this.ELLIPSIS_JUMP_STEP;
        if (newPageNumber <= 0) {
            newPageNumber = 2;
        }
        this.pageNumbers.push({ label: '...', value: newPageNumber, bigSpaceNeeded: nextShownPage > 999 });
    }
    getEllipsisNextPage(nextShownPage) {
        let newPageNumber = this.activePage + this.ELLIPSIS_JUMP_STEP;
        if (newPageNumber >= this.totalPages) {
            newPageNumber = this.totalPages - 1;
        }
        this.pageNumbers.push({ label: '...', value: newPageNumber, bigSpaceNeeded: nextShownPage > 999 });
    }
    /** @ignore */
    getPageSRText(active, page) {
        return `${active ? this.ariaLabelActivePage : this.ariaLabelSwitchToPage}: ${page}`;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiPaginationComponent, deps: [{ token: i1.SieIconRegistryService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiPaginationComponent, selector: "sie-ui-pagination", inputs: { ariaLabel: "ariaLabel", ariaLabelActivePage: "ariaLabelActivePage", ariaLabelSwitchToPage: "ariaLabelSwitchToPage", ariaLabelSwitchToNextPage: "ariaLabelSwitchToNextPage", ariaLabelSwitchToPreviousPage: "ariaLabelSwitchToPreviousPage", resultLimitReachedTooltipLabel: "resultLimitReachedTooltipLabel", totalPages: "totalPages", activePage: "activePage", paginationSize: "paginationSize" }, outputs: { pageSelected: "pageSelected" }, ngImport: i0, template: "<nav class=\"pagination\" [attr.aria-label]=\"ariaLabel\">\n  <div class=\"pagination__button-wrapper pagination__button-wrapper-left\">\n    <button\n      class=\"pagination__button pagination__button--left\"\n      type=\"button\"\n      [disabled]=\"activePage === 1\"\n      (click)=\"changePage(activePage - 1)\"\n    >\n      <sie-icon aria-hidden=\"true\" [name]=\"iconReg.sieIcon.ArrowLeft\"></sie-icon>\n      <span class=\"visually-hidden\" *ngIf=\"ariaLabelSwitchToPreviousPage\">{{ ariaLabelSwitchToPreviousPage }}</span>\n    </button>\n  </div>\n  <ul class=\"pagination__list\">\n    <li\n      *ngFor=\"let pageNumber of pageNumbers; let pageNumberIndex = index;\"\n      [ngClass]=\"pageNumber.bigSpaceNeeded ? 'large' : ''\"\n      class=\"pagination__item\"\n    >\n      <button\n        [ngClass]=\"[\n          pageNumber.value === activePage ? 'active-page' : '',\n          pageNumber.bigSpaceNeeded ? 'large' : '',\n          pageNumber.label === '...' ? 'ellipsis' : ''\n        ]\"\n        [attr.aria-label]=\"getPageSRText(pageNumber.value === activePage, pageNumber.value)\"\n        [attr.aria-current]=\"pageNumber.value === activePage\"\n        class=\"pagination__item--button\"\n        (click)=\"changePage(pageNumber.value)\"\n        sieUiPopover\n        popoverSize=\"s\"\n        [content]=\"pageNumberIndex === pageNumbers.length - 1  ? resultLimitReachedTooltipLabel : ''\"\n      >\n        <span>{{ pageNumber.label }}</span>\n      </button>\n    </li>\n  </ul>\n  <div class=\"pagination__button-wrapper pagination__button-wrapper-right\">\n    <button\n      class=\"pagination__button pagination__button--right\"\n      type=\"button\"\n      [disabled]=\"activePage === totalPages\"\n      (click)=\"changePage(activePage + 1)\"\n    >\n      <sie-icon aria-hidden=\"true\" [name]=\"iconReg.sieIcon.ArrowRight\"></sie-icon>\n      <span class=\"visually-hidden\" *ngIf=\"ariaLabelSwitchToNextPage\">{{ ariaLabelSwitchToNextPage }}</span>\n    </button>\n  </div>\n</nav>\n", styles: [".pagination__list .pagination__item--button:focus,.pagination__list .pagination__item--button:focus-visible{outline:0}.pagination .pagination__button{outline:none;outline-offset:0}@media (pointer: fine){.pagination .pagination__button{position:relative}.pagination .pagination__button:focus{outline:1px solid #1491eb;outline-offset:2px}.pagination .pagination__button:focus:not(:focus-visible){outline:0}.pagination .pagination__button:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}.pagination__button--left,.pagination__button--right,.pagination__list .pagination__item--button{display:flex;align-items:center;justify-content:center;background:none;border:none;outline:none;cursor:pointer;z-index:1;padding:0}.pagination{display:inline-flex;position:relative;display:flex;flex-direction:row;justify-content:center;max-width:334px;width:100%}.pagination__list{list-style:none;margin:0;padding:0;display:flex;flex-direction:row;align-items:center}.pagination__list .pagination__item{display:flex;justify-content:center;align-items:center;margin-right:8px}.pagination__list .pagination__item.large{margin-right:4px}.pagination__list .pagination__item:last-child{margin-right:0}.pagination__list .pagination__item--button{width:34px;height:24px;color:#000028;border-radius:4px}.pagination__list .pagination__item--button.active-page,.pagination__list .pagination__item--button:hover{background-color:#33747a;color:#fff}.pagination__list .pagination__item--button:focus{position:relative}.pagination__list .pagination__item--button:focus:before{content:\"\";position:absolute;inset:-3px;z-index:1;border:1px solid #1491eb;border-radius:4px}.pagination__list .pagination__item--button:focus-visible:before{content:\"\";position:absolute;inset:-3px;z-index:1;border:1px solid #1491eb;border-radius:4px}.pagination__list .pagination__item--button:focus:not(:focus-visible):before{border:none}.pagination__list .pagination__item--button.large{width:38px}.pagination__list .pagination__item--button.large.ellipsis{width:34px}.pagination__button-wrapper{display:flex;position:relative}.pagination__button-wrapper-left{margin-right:4px}.pagination__button-wrapper-right{margin-left:4px}.pagination__button--left,.pagination__button--right{width:24px;height:24px;display:flex;align-items:center;fill:currentColor;fill:#000028}.pagination__button--left svg,.pagination__button--right svg{fill:currentColor;width:inherit;height:inherit}.pagination__button--left svg g,.pagination__button--right svg g{fill:currentColor;width:inherit;height:inherit}.pagination__button--left svg text,.pagination__button--right svg text{font-family:Siemens Sans,sans-serif}.pagination__button--left:disabled,.pagination__button--right:disabled{fill:#b3b3be}.pagination__button--left:disabled:hover,.pagination__button--right:disabled:hover{cursor:initial}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "directive", type: UiPopoverDirective, selector: "[sieUiPopover]", inputs: ["content", "popoverTemplate", "popoverSize", "popoverPlacement", "popoverAnimation", "popoverPlayAnimation", "popoverAnimationHideAfterTimeoutMS", "popoverLightTheme"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
};
__decorate([
    OnChangesGroup('arrangePagination')
], UiPaginationComponent.prototype, "totalPages", null);
__decorate([
    OnChangesGroup('arrangePagination')
], UiPaginationComponent.prototype, "activePage", null);
__decorate([
    OnChangesGroup('updatePaginationSettings')
], UiPaginationComponent.prototype, "paginationSize", void 0);
__decorate([
    OnChangesGroupHandler('arrangePagination')
], UiPaginationComponent.prototype, "arrangePagination", null);
UiPaginationComponent = __decorate([
    OnChange({ groupHandlerExecutionPriority: ['updatePaginationSettings'] })
], UiPaginationComponent);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiPaginationComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-pagination', changeDetection: ChangeDetectionStrategy.OnPush, template: "<nav class=\"pagination\" [attr.aria-label]=\"ariaLabel\">\n  <div class=\"pagination__button-wrapper pagination__button-wrapper-left\">\n    <button\n      class=\"pagination__button pagination__button--left\"\n      type=\"button\"\n      [disabled]=\"activePage === 1\"\n      (click)=\"changePage(activePage - 1)\"\n    >\n      <sie-icon aria-hidden=\"true\" [name]=\"iconReg.sieIcon.ArrowLeft\"></sie-icon>\n      <span class=\"visually-hidden\" *ngIf=\"ariaLabelSwitchToPreviousPage\">{{ ariaLabelSwitchToPreviousPage }}</span>\n    </button>\n  </div>\n  <ul class=\"pagination__list\">\n    <li\n      *ngFor=\"let pageNumber of pageNumbers; let pageNumberIndex = index;\"\n      [ngClass]=\"pageNumber.bigSpaceNeeded ? 'large' : ''\"\n      class=\"pagination__item\"\n    >\n      <button\n        [ngClass]=\"[\n          pageNumber.value === activePage ? 'active-page' : '',\n          pageNumber.bigSpaceNeeded ? 'large' : '',\n          pageNumber.label === '...' ? 'ellipsis' : ''\n        ]\"\n        [attr.aria-label]=\"getPageSRText(pageNumber.value === activePage, pageNumber.value)\"\n        [attr.aria-current]=\"pageNumber.value === activePage\"\n        class=\"pagination__item--button\"\n        (click)=\"changePage(pageNumber.value)\"\n        sieUiPopover\n        popoverSize=\"s\"\n        [content]=\"pageNumberIndex === pageNumbers.length - 1  ? resultLimitReachedTooltipLabel : ''\"\n      >\n        <span>{{ pageNumber.label }}</span>\n      </button>\n    </li>\n  </ul>\n  <div class=\"pagination__button-wrapper pagination__button-wrapper-right\">\n    <button\n      class=\"pagination__button pagination__button--right\"\n      type=\"button\"\n      [disabled]=\"activePage === totalPages\"\n      (click)=\"changePage(activePage + 1)\"\n    >\n      <sie-icon aria-hidden=\"true\" [name]=\"iconReg.sieIcon.ArrowRight\"></sie-icon>\n      <span class=\"visually-hidden\" *ngIf=\"ariaLabelSwitchToNextPage\">{{ ariaLabelSwitchToNextPage }}</span>\n    </button>\n  </div>\n</nav>\n", styles: [".pagination__list .pagination__item--button:focus,.pagination__list .pagination__item--button:focus-visible{outline:0}.pagination .pagination__button{outline:none;outline-offset:0}@media (pointer: fine){.pagination .pagination__button{position:relative}.pagination .pagination__button:focus{outline:1px solid #1491eb;outline-offset:2px}.pagination .pagination__button:focus:not(:focus-visible){outline:0}.pagination .pagination__button:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}.pagination__button--left,.pagination__button--right,.pagination__list .pagination__item--button{display:flex;align-items:center;justify-content:center;background:none;border:none;outline:none;cursor:pointer;z-index:1;padding:0}.pagination{display:inline-flex;position:relative;display:flex;flex-direction:row;justify-content:center;max-width:334px;width:100%}.pagination__list{list-style:none;margin:0;padding:0;display:flex;flex-direction:row;align-items:center}.pagination__list .pagination__item{display:flex;justify-content:center;align-items:center;margin-right:8px}.pagination__list .pagination__item.large{margin-right:4px}.pagination__list .pagination__item:last-child{margin-right:0}.pagination__list .pagination__item--button{width:34px;height:24px;color:#000028;border-radius:4px}.pagination__list .pagination__item--button.active-page,.pagination__list .pagination__item--button:hover{background-color:#33747a;color:#fff}.pagination__list .pagination__item--button:focus{position:relative}.pagination__list .pagination__item--button:focus:before{content:\"\";position:absolute;inset:-3px;z-index:1;border:1px solid #1491eb;border-radius:4px}.pagination__list .pagination__item--button:focus-visible:before{content:\"\";position:absolute;inset:-3px;z-index:1;border:1px solid #1491eb;border-radius:4px}.pagination__list .pagination__item--button:focus:not(:focus-visible):before{border:none}.pagination__list .pagination__item--button.large{width:38px}.pagination__list .pagination__item--button.large.ellipsis{width:34px}.pagination__button-wrapper{display:flex;position:relative}.pagination__button-wrapper-left{margin-right:4px}.pagination__button-wrapper-right{margin-left:4px}.pagination__button--left,.pagination__button--right{width:24px;height:24px;display:flex;align-items:center;fill:currentColor;fill:#000028}.pagination__button--left svg,.pagination__button--right svg{fill:currentColor;width:inherit;height:inherit}.pagination__button--left svg g,.pagination__button--right svg g{fill:currentColor;width:inherit;height:inherit}.pagination__button--left svg text,.pagination__button--right svg text{font-family:Siemens Sans,sans-serif}.pagination__button--left:disabled,.pagination__button--right:disabled{fill:#b3b3be}.pagination__button--left:disabled:hover,.pagination__button--right:disabled:hover{cursor:initial}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }]; }, propDecorators: { ariaLabel: [{
                type: Input
            }], ariaLabelActivePage: [{
                type: Input
            }], ariaLabelSwitchToPage: [{
                type: Input
            }], ariaLabelSwitchToNextPage: [{
                type: Input
            }], ariaLabelSwitchToPreviousPage: [{
                type: Input
            }], resultLimitReachedTooltipLabel: [{
                type: Input
            }], totalPages: [{
                type: Input
            }], activePage: [{
                type: Input
            }], paginationSize: [{
                type: Input
            }], pageSelected: [{
                type: Output
            }], arrangePagination: [] } });

/**
 * # Pagination Module
 * - {@link UiPaginationComponent}
 *
 * ## Module peer dependencies
 * - {@link SieIconsModule}
 */
class UiPaginationModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiPaginationModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiPaginationModule, declarations: [UiPaginationComponent], imports: [CommonModule, SieIconsModule, UiPopoverModule], exports: [UiPaginationComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiPaginationModule, imports: [CommonModule, SieIconsModule, UiPopoverModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiPaginationModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiPaginationComponent],
                    imports: [CommonModule, SieIconsModule, UiPopoverModule],
                    exports: [UiPaginationComponent]
                }]
        }] });

class UiListNavigatorFooterComponent {
    set itemsPerPageOptions(itemsPerPageOptions) {
        this._itemsPerPageOptions = itemsPerPageOptions;
        this.updateFooterInformation();
    }
    get itemsPerPageOptions() {
        return this._itemsPerPageOptions;
    }
    set currentItemsPerPageOption(currentItemsPerPageOption) {
        this._currentItemsPerPageOption = currentItemsPerPageOption;
        this.updateFooterInformation();
    }
    get currentItemsPerPageOption() {
        return this._currentItemsPerPageOption;
    }
    set totalResultsCount(totalResultsCount) {
        this._totalResultsCount = totalResultsCount;
        this.updateFooterInformation();
    }
    get totalResultsCount() {
        return this._totalResultsCount;
    }
    constructor(iconReg, cdr) {
        this.iconReg = iconReg;
        this.cdr = cdr;
        this.showItemPerPageSelector = true;
        this.showBackToTopButton = true;
        this.showPagination = true;
        this.paginationType = 'default';
        this.paginationSize = 'regular';
        this.itemsPerPageText = '';
        this.backToTopButtonScreenReaderText = '';
        this.activePage = 1;
        this.resultLimitReachedTooltipLabel = '';
        this.resultLimitReachedMessageBoxHeadline = '';
        this.resultLimitReachedMessageBoxMessage = '';
        this.paginationScreenReader = {
            label: '',
            currentActivePage: '',
            switchToPage: '',
            switchToNextPage: '',
            switchToPreviousPage: ''
        };
        /**
         * Sets the pagination dropdown overlay in top position.
         */
        this.paginationOverlayOnTop = false;
        this.pageSelected = new Subject();
        this.backToTopClicked = new Subject();
        this.itemsPerPageChanged = new Subject();
        this.componentViewports = new Map([
            ['S', 0],
            ['L', 930]
        ]);
        this.resultLimitReached = false;
        this.iconReg.register(SieIcon.ArrowToTop);
    }
    ngOnInit() {
        this.updateFooterInformation();
    }
    setBreakpoint(breakpoint) {
        this.breakpoint = breakpoint;
        this.cdr.detectChanges();
    }
    updateItemsPerPage(value) {
        this.currentItemsPerPageOption = value;
        this.itemsPerPageChanged.next(parseInt(this.currentItemsPerPageOption, 10));
    }
    onPageSelection(page) {
        this.pageSelected.next(page);
        this.backToTopClicked.next();
    }
    updateFooterInformation() {
        if (this._itemsPerPageOptions) {
            this.itemsPerPage = this.itemsPerPageOptions.map(m => ({
                label: m.toString(),
                value: m.toString()
            }));
            if (!this.currentItemsPerPageOption && this.itemsPerPage.length > 0) {
                this.currentItemsPerPageOption = this.itemsPerPage[0].value;
            }
        }
        if (this.currentItemsPerPageOption && this.totalResultsCount) {
            let numberOfItemsToShow = this.totalResultsCount;
            if (this.limitOfItemsToRender && this.totalResultsCount > this.limitOfItemsToRender) {
                numberOfItemsToShow = this.limitOfItemsToRender;
                this.resultLimitReached = true;
            }
            else {
                this.resultLimitReached = false;
            }
            this.totalPages = Math.ceil(numberOfItemsToShow / parseInt(this.currentItemsPerPageOption, 10));
        }
        else {
            this.totalPages = 1;
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiListNavigatorFooterComponent, deps: [{ token: i1.SieIconRegistryService }, { token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiListNavigatorFooterComponent, selector: "sie-ui-list-navigator-footer", inputs: { showItemPerPageSelector: "showItemPerPageSelector", showBackToTopButton: "showBackToTopButton", showPagination: "showPagination", paginationType: "paginationType", paginationSize: "paginationSize", itemsPerPageText: "itemsPerPageText", backToTopButtonScreenReaderText: "backToTopButtonScreenReaderText", activePage: "activePage", limitOfItemsToRender: "limitOfItemsToRender", resultLimitReachedTooltipLabel: "resultLimitReachedTooltipLabel", resultLimitReachedMessageBoxHeadline: "resultLimitReachedMessageBoxHeadline", resultLimitReachedMessageBoxMessage: "resultLimitReachedMessageBoxMessage", paginationScreenReader: "paginationScreenReader", itemsPerPageOptions: "itemsPerPageOptions", currentItemsPerPageOption: "currentItemsPerPageOption", totalResultsCount: "totalResultsCount", paginationOverlayOnTop: "paginationOverlayOnTop" }, outputs: { pageSelected: "pageSelected", backToTopClicked: "backToTopClicked", itemsPerPageChanged: "itemsPerPageChanged" }, ngImport: i0, template: "<div class=\"list-footer__message-box\" *ngIf=\"activePage === totalPages && resultLimitReached\">\n  <sie-ui-message-box\n    variant=\"info\"\n    [closeable]=\"false\"\n    [headline]=\"resultLimitReachedMessageBoxHeadline\"\n    [message]=\"resultLimitReachedMessageBoxMessage\"\n  >\n  </sie-ui-message-box>\n</div>\n<div\n  class=\"list-footer\"\n  [sieCoreComponentBreakpoints]=\"componentViewports\"\n  (componentViewportChanged)=\"setBreakpoint($event)\"\n>\n  <div\n    class=\"list-footer__pagination\"\n    [ngClass]=\"{ 'with-margin': (showItemPerPageSelector || showBackToTopButton) && totalResultsCount }\"\n    *ngIf=\"breakpoint === 'S'\"\n  >\n    <ng-container *ngTemplateOutlet=\"pagination\"></ng-container>\n  </div>\n  <div\n    class=\"list-footer__items_per_page\"\n    [ngClass]=\"{ 'list-footer__items_per_page--no-content': !showItemPerPageSelector }\"\n  >\n    <ng-container *ngIf=\"showItemPerPageSelector && totalResultsCount\">\n      <span>{{ itemsPerPageText }}</span>\n      <sie-ui-dropdown\n        class=\"dropdown\"\n        [label]=\"itemsPerPageText\"\n        [options]=\"itemsPerPage\"\n        (selectionChanged)=\"updateItemsPerPage($event)\"\n        [selectedValue]=\"currentItemsPerPageOption\"\n        [overlayOnTop]=\"paginationOverlayOnTop\"\n      ></sie-ui-dropdown>\n    </ng-container>\n  </div>\n  <div\n    *ngIf=\"breakpoint === 'L'\"\n    class=\"list-footer__pagination\"\n    [ngClass]=\"{ 'list-footer__pagination--no-back-to-top-button': !showBackToTopButton }\"\n  >\n    <ng-container *ngTemplateOutlet=\"pagination\"></ng-container>\n  </div>\n  <div class=\"list-footer__button\" *ngIf=\"showBackToTopButton && totalResultsCount\">\n    <sie-ui-button\n      cssClass=\"to-top-button\"\n      (clicked)=\"backToTopClicked.next()\"\n      [icon]=\"iconReg.sieIcon.ArrowToTop\"\n      themeType=\"icon\"\n      variant=\"icon-un-contained\"\n    >\n      <span class=\"visually-hidden\">{{ backToTopButtonScreenReaderText }}</span>\n    </sie-ui-button>\n  </div>\n</div>\n\n<ng-template #pagination>\n  <sie-ui-pagination\n    *ngIf=\"showPagination && totalPages > 1 && paginationType !== 'infinite'\"\n    [totalPages]=\"totalPages\"\n    [activePage]=\"activePage\"\n    [paginationSize]=\"paginationSize\"\n    [resultLimitReachedTooltipLabel]=\"resultLimitReached ? resultLimitReachedTooltipLabel : ''\"\n    [ariaLabel]=\"paginationScreenReader.label\"\n    [ariaLabelActivePage]=\"paginationScreenReader.currentActivePage\"\n    [ariaLabelSwitchToNextPage]=\"paginationScreenReader.switchToNextPage\"\n    [ariaLabelSwitchToPage]=\"paginationScreenReader.switchToPage\"\n    [ariaLabelSwitchToPreviousPage]=\"paginationScreenReader.switchToPreviousPage\"\n    (pageSelected)=\"onPageSelection($event)\"\n  ></sie-ui-pagination>\n</ng-template>\n", styles: [".list-footer{display:flex;flex-direction:row;flex-wrap:wrap;justify-content:center;margin:16px 0}@media print{.list-footer{display:none}}@media (min-width: 1024px){.list-footer{margin:24px 0}}.list-footer__items_per_page{flex-basis:100%;line-height:18px}@media (max-width: 639.78px){.list-footer__items_per_page{flex-basis:80%}}.list-footer__items_per_page--no-content{height:28px}.list-footer__button{position:relative;display:flex;justify-content:flex-end}@media (max-width: 639.78px){.list-footer__button{flex-basis:20%}}.list-footer__button sie-ui-button{position:absolute;top:calc(50% - 22px);right:-14px}.list-footer__pagination{display:flex;justify-content:center}.list-footer__pagination.with-margin{margin-bottom:16px}.list-footer__message-box{margin:24px 0 16px}.list-footer.component-viewport--L{flex-wrap:nowrap}.list-footer.component-viewport--L .list-footer__items_per_page,.list-footer.component-viewport--L .list-footer__button{flex:1}.list-footer.component-viewport--L .list-footer__pagination{margin:0}.list-footer.component-viewport--L .list-footer__pagination--no-back-to-top-button{flex-basis:100%}.list-footer.component-viewport--S{margin-bottom:0}.list-footer .dropdown{margin-left:5px}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "component", type: UiPaginationComponent, selector: "sie-ui-pagination", inputs: ["ariaLabel", "ariaLabelActivePage", "ariaLabelSwitchToPage", "ariaLabelSwitchToNextPage", "ariaLabelSwitchToPreviousPage", "resultLimitReachedTooltipLabel", "totalPages", "activePage", "paginationSize"], outputs: ["pageSelected"] }, { kind: "directive", type: i1$1.ComponentBreakpointsDirective, selector: "[sieCoreComponentBreakpoints]", inputs: ["sieCoreComponentBreakpoints"], outputs: ["componentViewportChanged"] }, { kind: "component", type: UiButtonComponent, selector: "sie-ui-button" }, { kind: "component", type: UiMessageBoxComponent, selector: "sie-ui-message-box", inputs: ["type", "headline", "message", "headlineCollapsed", "headlineExpanded", "limit", "link", "playAnimation", "screenReaderCloseIcon", "elementsLayout", "fadeInAnimation", "actionButtonLabel", "actionButtonLink", "secondaryActionButtonLabel", "variant", "closeable", "containerStyled"], outputs: ["actionTriggered", "messageClosed", "messageClosing", "messageLinkTriggered"] }, { kind: "component", type: UiDropdownComponent, selector: "sie-ui-dropdown", inputs: ["type", "condensed", "options", "selectedValue", "required", "id", "name", "label", "placeholder", "errorMessage", "customClass", "readonly", "invalid", "hint", "marginBottomOnInvalidState"], outputs: ["selectionChanged"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiListNavigatorFooterComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-list-navigator-footer', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"list-footer__message-box\" *ngIf=\"activePage === totalPages && resultLimitReached\">\n  <sie-ui-message-box\n    variant=\"info\"\n    [closeable]=\"false\"\n    [headline]=\"resultLimitReachedMessageBoxHeadline\"\n    [message]=\"resultLimitReachedMessageBoxMessage\"\n  >\n  </sie-ui-message-box>\n</div>\n<div\n  class=\"list-footer\"\n  [sieCoreComponentBreakpoints]=\"componentViewports\"\n  (componentViewportChanged)=\"setBreakpoint($event)\"\n>\n  <div\n    class=\"list-footer__pagination\"\n    [ngClass]=\"{ 'with-margin': (showItemPerPageSelector || showBackToTopButton) && totalResultsCount }\"\n    *ngIf=\"breakpoint === 'S'\"\n  >\n    <ng-container *ngTemplateOutlet=\"pagination\"></ng-container>\n  </div>\n  <div\n    class=\"list-footer__items_per_page\"\n    [ngClass]=\"{ 'list-footer__items_per_page--no-content': !showItemPerPageSelector }\"\n  >\n    <ng-container *ngIf=\"showItemPerPageSelector && totalResultsCount\">\n      <span>{{ itemsPerPageText }}</span>\n      <sie-ui-dropdown\n        class=\"dropdown\"\n        [label]=\"itemsPerPageText\"\n        [options]=\"itemsPerPage\"\n        (selectionChanged)=\"updateItemsPerPage($event)\"\n        [selectedValue]=\"currentItemsPerPageOption\"\n        [overlayOnTop]=\"paginationOverlayOnTop\"\n      ></sie-ui-dropdown>\n    </ng-container>\n  </div>\n  <div\n    *ngIf=\"breakpoint === 'L'\"\n    class=\"list-footer__pagination\"\n    [ngClass]=\"{ 'list-footer__pagination--no-back-to-top-button': !showBackToTopButton }\"\n  >\n    <ng-container *ngTemplateOutlet=\"pagination\"></ng-container>\n  </div>\n  <div class=\"list-footer__button\" *ngIf=\"showBackToTopButton && totalResultsCount\">\n    <sie-ui-button\n      cssClass=\"to-top-button\"\n      (clicked)=\"backToTopClicked.next()\"\n      [icon]=\"iconReg.sieIcon.ArrowToTop\"\n      themeType=\"icon\"\n      variant=\"icon-un-contained\"\n    >\n      <span class=\"visually-hidden\">{{ backToTopButtonScreenReaderText }}</span>\n    </sie-ui-button>\n  </div>\n</div>\n\n<ng-template #pagination>\n  <sie-ui-pagination\n    *ngIf=\"showPagination && totalPages > 1 && paginationType !== 'infinite'\"\n    [totalPages]=\"totalPages\"\n    [activePage]=\"activePage\"\n    [paginationSize]=\"paginationSize\"\n    [resultLimitReachedTooltipLabel]=\"resultLimitReached ? resultLimitReachedTooltipLabel : ''\"\n    [ariaLabel]=\"paginationScreenReader.label\"\n    [ariaLabelActivePage]=\"paginationScreenReader.currentActivePage\"\n    [ariaLabelSwitchToNextPage]=\"paginationScreenReader.switchToNextPage\"\n    [ariaLabelSwitchToPage]=\"paginationScreenReader.switchToPage\"\n    [ariaLabelSwitchToPreviousPage]=\"paginationScreenReader.switchToPreviousPage\"\n    (pageSelected)=\"onPageSelection($event)\"\n  ></sie-ui-pagination>\n</ng-template>\n", styles: [".list-footer{display:flex;flex-direction:row;flex-wrap:wrap;justify-content:center;margin:16px 0}@media print{.list-footer{display:none}}@media (min-width: 1024px){.list-footer{margin:24px 0}}.list-footer__items_per_page{flex-basis:100%;line-height:18px}@media (max-width: 639.78px){.list-footer__items_per_page{flex-basis:80%}}.list-footer__items_per_page--no-content{height:28px}.list-footer__button{position:relative;display:flex;justify-content:flex-end}@media (max-width: 639.78px){.list-footer__button{flex-basis:20%}}.list-footer__button sie-ui-button{position:absolute;top:calc(50% - 22px);right:-14px}.list-footer__pagination{display:flex;justify-content:center}.list-footer__pagination.with-margin{margin-bottom:16px}.list-footer__message-box{margin:24px 0 16px}.list-footer.component-viewport--L{flex-wrap:nowrap}.list-footer.component-viewport--L .list-footer__items_per_page,.list-footer.component-viewport--L .list-footer__button{flex:1}.list-footer.component-viewport--L .list-footer__pagination{margin:0}.list-footer.component-viewport--L .list-footer__pagination--no-back-to-top-button{flex-basis:100%}.list-footer.component-viewport--S{margin-bottom:0}.list-footer .dropdown{margin-left:5px}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }, { type: i0.ChangeDetectorRef }]; }, propDecorators: { showItemPerPageSelector: [{
                type: Input
            }], showBackToTopButton: [{
                type: Input
            }], showPagination: [{
                type: Input
            }], paginationType: [{
                type: Input
            }], paginationSize: [{
                type: Input
            }], itemsPerPageText: [{
                type: Input
            }], backToTopButtonScreenReaderText: [{
                type: Input
            }], activePage: [{
                type: Input
            }], limitOfItemsToRender: [{
                type: Input
            }], resultLimitReachedTooltipLabel: [{
                type: Input
            }], resultLimitReachedMessageBoxHeadline: [{
                type: Input
            }], resultLimitReachedMessageBoxMessage: [{
                type: Input
            }], paginationScreenReader: [{
                type: Input
            }], itemsPerPageOptions: [{
                type: Input
            }], currentItemsPerPageOption: [{
                type: Input
            }], totalResultsCount: [{
                type: Input
            }], paginationOverlayOnTop: [{
                type: Input
            }], pageSelected: [{
                type: Output
            }], backToTopClicked: [{
                type: Output
            }], itemsPerPageChanged: [{
                type: Output
            }] } });

/**
 * # List Navigator Component
 *
 * Lists provide a structured and manageable view on content items of a kind.
 *
 * ## Content
 *
 * The content can be passed as child elements and only those with the class `.list-item` are
 * recognized. List can also accept header as any valid HTML markup with an attribute `headerslot` on the element.
 *
 * ## Component variations
 *
 * - `itemType: 'file'` and `itemAppearance: 'simple'`
 * - `itemType: 'file'` and `itemAppearance: 'complex'`
 * - `itemType: 'folder'`
 *
 * ## Code example
 * @example ```html
 * <sie-ui-list-navigator
 *   itemType="file"
 *   itemAppearance="complex"
 *   [itemComponents]="itemComponents"
 *   [loading]="loading"
 *   [itemData]="itemData"
 *   [itemsPerPage]="10"
 *   [numberOfSkeletons]="3"
 *   [bulkMode]="false"
 * ></sie-ui-list-navigator>
 * ```
 *
 * List data example:
 * ```js
 * itemComponents: Type<any>[] = [UiCockpitListItemComponent];
 * itemData: any[] = [
 *   {
 *     id: 1,
 *     categoryName: 'orders',
 *     statusPhraseLabel: 'A product is not available',
 *     primaryMeta: 'Your order no.: 740490/Freiherr-von-Vincke-Reals',
 *     secondaryMeta: 'Order date: 07/20/2020',
 *     timestampRelative: 'Just now',
 *     urlToItemDetails: 'https://new.siemens.com/at/de.html'
 *   }
 * ```
 */
class UiListNavigatorComponent {
    /**
     * @param data {@link UiListItemModel} list data to be set
     */
    set itemData(data) {
        this._itemData = data;
        this.setEmptyState();
    }
    get itemData() {
        return this._itemData;
    }
    /**
     * If true list items are loading (shows loading indicator)
     * @default true
     */
    set loading(isLoading) {
        this._loading = isLoading;
        this.setEmptyState();
    }
    get loading() {
        return this._loading;
    }
    /** @ignore only for SPA purpose */
    set emptyState(emptyState) {
        this.emptyStateHeadline = emptyState?.headline;
        this.emptyStateText = emptyState?.text;
        this.emptyStateCustomIcon = emptyState?.customIcon;
        this.emptyStateIconPosition = emptyState?.iconPosition || 'onTop';
        this.emptyStateLink = emptyState?.link;
        this.emptyStateButton = emptyState?.button;
    }
    constructor(cd, layoutService) {
        this.cd = cd;
        this.layoutService = layoutService;
        /**
         * Component type which is created for each list item dynamically
         * @default `[UiBaseListItemComponent]`
         */
        this.itemComponents = [UiBaseListItemComponent];
        /**
         * Defines what {@link PaginationType pagination type} should be used if pagination is needed
         * @default 'default'
         */
        this.paginationType = 'default';
        /**
         * Defined based on the {@link PaginationSize pagination size} whether 5 or 7 visible pages are displayed.
         * @default 'regular' 7 visible pages
         */
        this.paginationSize = 'regular';
        /**
         * Set the text of the tooltip when the result limit reached
         */
        this.resultLimitReachedTooltipLabel = '';
        /**
         * Set the headline of the message box when the result limit reached
         */
        this.resultLimitReachedMessageBoxHeadline = '';
        /**
         * Set the message of the message box when the result limit reached
         */
        this.resultLimitReachedMessageBoxMessage = '';
        /** @ignore only for SPA purpose */
        this.showCatalogConfigureProducts = true;
        /**
         * Removes some margins and paddings for a 'condensed' styling if set to true
         * @default false
         */
        this.condensed = false;
        /**
         * Displays item per page selector if set to true
         * @default true
         */
        this.showItemPerPageSelector = true;
        /**
         * Displays 'back to top' button if set to true
         * @default true
         */
        this.showBackToTopButton = true;
        /**
         * Defines if pagination is displayed if set to true
         * @default true
         */
        this.showPagination = true;
        /**
         * Adds styling to align pagination to the bottom of the parent container if set to true
         * @default false
         */
        this.alignPaginationToBottom = false;
        /**
         * Defines which pagination page is set to active
         * @default 1
         */
        this.activePage = 1;
        /**
         * Count of all list items
         * @default null
         */
        this.totalResultsCount = null;
        /**
         * {@link EmptyStateIconPosition Position} of empty state icon
         * @default 'onTop'
         */
        this.emptyStateIconPosition = 'onTop';
        /**
         * Defines if bulk mode is used if set to true
         * @default false
         */
        this.bulkMode = false;
        /**
         * Allows items to be dismissed when set to true
         * @default false
         */
        this.itemsDismissible = false;
        /**
         * If true more list items are being loaded (used in infinite pagination style)
         * @default false
         */
        this.loadingMore = false;
        /** @ignore only for SPA purpose */
        this.loadingChildren = false;
        /**
         * If true hover is tracked and a styling for hover is added for the list items
         * @default false
         */
        this.trackHover = false;
        /**
         * Defines if only selected items will be displayed in print preview, does nothing when not in bulk-selection mode
         * @default false
         */
        this.hideNotSelectedItemsInPrintPreview = false;
        /**
         * Number of displayed skeleton elements
         * @default 5
         */
        this.numberOfSkeletons = 5;
        /**
         * Number of displayed skeleton elements in case of infinite pagination
         * @default 3
         */
        this.numberOfLoadMoreSkeletons = 3;
        // Strings and labels
        /**
         * Headline of empty state
         * @default ''
         */
        this.emptyStateHeadline = '';
        /**
         * Text of empty state
         * @default ''
         */
        this.emptyStateText = '';
        /**
         * Text for show more button of list item
         * @default ''
         */
        this.expandableButtonMore = '';
        /**
         * Text for show less button of list items
         * @default ''
         */
        this.expandableButtonLess = '';
        /**
         * Text displayed next to 'items per page' dropdown
         * @default ''
         */
        this.itemsPerPageText = '';
        /**
         * Text used by screen readers for back to top button
         * @default ''
         */
        this.backToTopButtonScreenReaderText = '';
        /**
         * {@link UiPaginationScreenReaderInputs} screen reader texts for pagination
         */
        this.paginationScreenReader = {
            label: '',
            currentActivePage: '',
            switchToPage: '',
            switchToNextPage: '',
            switchToPreviousPage: ''
        };
        /**
         * Sets the pagination dropdown overlay in top position.
         */
        this.paginationOverlayOnTop = false;
        /**
         * Provide an additional offset for scroll to top button
         */
        this.scrollToTopOffset = 0;
        /**
         * Triggered when empty state is present and action was clicked
         */
        this.emptyStateActionClicked = new Subject();
        /**
         * Triggered when in the items per page dropdown a new value was selected
         */
        this.itemsPerPageChanged = new Subject();
        /**
         * Triggered when a new page in pagination was selected
         */
        this.pageChanged = new Subject();
        /**
         * Triggered when user interaction is done, see {@link UiListItemEvent} for implementation details
         */
        this.itemEvent = new Subject();
        /** Triggered when component is in bulk mode and a new item was selected {@link UiAdvancedListItemSelectionChangeData} */
        this.selectionChanged = new Subject();
        /** @ignore */
        this.isSelectedSubject = new Subject();
        this._itemData = [];
        this._loading = true;
        /** @ignore */
        this.showEmptyState = false;
    }
    /** @ignore */
    ngOnInit() {
        this.itemsPerPage = this.itemsPerPage || (this.itemsPerPageOptions && this.itemsPerPageOptions[0]) || null;
    }
    /**
     * Set the empty state if the list items do not load and there is no data
     */
    setEmptyState() {
        this.showEmptyState = !this.loading && !this.itemData?.length;
    }
    /** @ignore */
    onBackToTopClicked(el) {
        if (this.scrollToTopElementSelector) {
            this.layoutService.scrollToTopOnElement(this.scrollToTopElementSelector);
        }
        else {
            this.layoutService.scrollToNativeElement(el, -this.scrollToTopOffset);
        }
    }
    /** @ignore */
    onEmptyStateActionClicked(event) {
        this.emptyStateActionClicked.next(event);
    }
    /** @ignore */
    onItemsPerPageChange(itemsPerPage) {
        this.itemsPerPage = itemsPerPage;
        this.itemsPerPageChanged.next(itemsPerPage);
    }
    /** @ignore */
    onPageChange(page) {
        this.pageChanged.next(page);
    }
    /**
     * Selects or deselects all checkboxes currently available in the list (only if bulkMode is true)
     * @param [selected=true] if checkbox is selected or not
     */
    bulkSelect(selected = true) {
        if (!this.bulkMode) {
            return;
        }
        let ids = [];
        if (selected) {
            ids = this.itemData.map(item => item.id);
        }
        this.isSelectedSubject.next(ids);
    }
    /**
     * Selects or deselects the items provided
     * @param [ids] array of ids of the items which should be selected or deselected
     * @param [select=true] whether a bulk select or unselect is carried out
     */
    specificBulkSelect(ids, select = true) {
        if (!this.bulkMode) {
            return;
        }
        let selectedIds = this.itemData.filter(item => item.isSelected).map(item => item.id);
        if (select) {
            selectedIds = [...selectedIds, ...ids];
        }
        else {
            selectedIds = selectedIds.filter(id => !ids.includes(id));
        }
        this.isSelectedSubject.next(selectedIds);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiListNavigatorComponent, deps: [{ token: i0.ChangeDetectorRef }, { token: i1$1.LayoutService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiListNavigatorComponent, selector: "sie-ui-list-navigator", inputs: { itemType: "itemType", itemAppearance: "itemAppearance", itemComponents: "itemComponents", paginationType: "paginationType", paginationSize: "paginationSize", limitOfItemsToRender: "limitOfItemsToRender", resultLimitReachedTooltipLabel: "resultLimitReachedTooltipLabel", resultLimitReachedMessageBoxHeadline: "resultLimitReachedMessageBoxHeadline", resultLimitReachedMessageBoxMessage: "resultLimitReachedMessageBoxMessage", showCatalogConfigureProducts: "showCatalogConfigureProducts", pagination: "pagination", scrollToTopElementSelector: "scrollToTopElementSelector", condensed: "condensed", showItemPerPageSelector: "showItemPerPageSelector", showBackToTopButton: "showBackToTopButton", showPagination: "showPagination", alignPaginationToBottom: "alignPaginationToBottom", activePage: "activePage", itemData: "itemData", totalResultsCount: "totalResultsCount", itemsPerPageOptions: "itemsPerPageOptions", emptyStateCustomIcon: "emptyStateCustomIcon", emptyStateIconPosition: "emptyStateIconPosition", bulkMode: "bulkMode", itemsDismissible: "itemsDismissible", loading: "loading", loadingMore: "loadingMore", loadingChildren: "loadingChildren", trackHover: "trackHover", hideNotSelectedItemsInPrintPreview: ["hideNotSelectedItemsInPrintPreview", "hideNotSelectedItemsInPrintPreview", booleanAttribute], numberOfSkeletons: "numberOfSkeletons", numberOfLoadMoreSkeletons: "numberOfLoadMoreSkeletons", itemsPerPage: "itemsPerPage", emptyState: "emptyState", emptyStateHeadline: "emptyStateHeadline", emptyStateText: "emptyStateText", emptyStateButton: "emptyStateButton", emptyStateLink: "emptyStateLink", expandableButtonMore: "expandableButtonMore", expandableButtonLess: "expandableButtonLess", itemsPerPageText: "itemsPerPageText", backToTopButtonScreenReaderText: "backToTopButtonScreenReaderText", paginationScreenReader: "paginationScreenReader", dataAttributeWrapper: "dataAttributeWrapper", paginationOverlayOnTop: "paginationOverlayOnTop", scrollToTopOffset: "scrollToTopOffset" }, outputs: { emptyStateActionClicked: "emptyStateActionClicked", itemsPerPageChanged: "itemsPerPageChanged", pageChanged: "pageChanged", itemEvent: "itemEvent", selectionChanged: "selectionChanged" }, viewQueries: [{ propertyName: "elementsRef", first: true, predicate: ["webComponentContentWrapper"], descendants: true, static: true }, { propertyName: "listComponent", first: true, predicate: UiListComponent, descendants: true }], ngImport: i0, template: "<div class=\"scroll-item\" #scrollUnderHeader></div>\n\n<ng-content select=\"[HeaderSlot]\"></ng-content>\n\n<div #webComponentContentWrapper class=\"wc-list-container\">\n  <ng-content select=\".list-item\"></ng-content>\n</div>\n\n<div class=\"list__results\" [sieCoreAttributes]=\"dataAttributeWrapper?.resultAttributes\">\n  <ng-container *ngIf=\"showEmptyState; else listContainer\">\n    <sie-ui-empty-state\n      class=\"container empty-spacing\"\n      [headline]=\"emptyStateHeadline\"\n      [text]=\"emptyStateText\"\n      [customIcon]=\"emptyStateCustomIcon\"\n      [iconPosition]=\"emptyStateIconPosition\"\n      [button]=\"emptyStateButton\"\n      [link]=\"emptyStateLink\"\n      (buttonClicked)=\"onEmptyStateActionClicked($event)\"\n    ></sie-ui-empty-state>\n    <ng-content select=\"[ButtonSlot]\"></ng-content>\n  </ng-container>\n\n  <ng-template #listContainer>\n    <ul\n      sie-ui-list\n      [itemType]=\"itemType\"\n      [itemAppearance]=\"itemAppearance\"\n      [condensed]=\"condensed\"\n      [defaultItemComponents]=\"itemComponents\"\n      [itemData]=\"itemData\"\n      [bulkMode]=\"bulkMode\"\n      [itemsDismissible]=\"itemsDismissible\"\n      [itemLength]=\"pagination?.pageSize || itemsPerPage || itemData?.length || 0\"\n      [loading]=\"loading\"\n      [loadingChildren]=\"loadingChildren\"\n      [loadingMore]=\"loadingMore\"\n      [expandableButtonMore]=\"expandableButtonMore\"\n      [expandableButtonLess]=\"expandableButtonLess\"\n      [trackHover]=\"trackHover\"\n      [hideNotSelectedItemsInPrintPreview]=\"hideNotSelectedItemsInPrintPreview\"\n      [paginationType]=\"paginationType\"\n      [numberOfSkeletons]=\"numberOfSkeletons\"\n      [numberOfLoadMoreSkeletons]=\"numberOfLoadMoreSkeletons\"\n      [showCatalogConfigureProducts]=\"showCatalogConfigureProducts\"\n      [isSelected$]=\"isSelectedSubject.asObservable()\"\n      (itemEvent)=\"itemEvent.next($event)\"\n      (selectionChanged)=\"selectionChanged.next($event)\"\n    ></ul>\n  </ng-template>\n</div>\n\n<div\n  class=\"navigator-footer\"\n  *ngIf=\"showPagination || showBackToTopButton || showItemPerPageSelector\"\n  [ngClass]=\"{ bottom: alignPaginationToBottom }\"\n  [sieCoreAttributes]=\"dataAttributeWrapper?.footerAttributes\"\n>\n  <sie-ui-list-navigator-footer\n    [showItemPerPageSelector]=\"showItemPerPageSelector\"\n    [showBackToTopButton]=\"showBackToTopButton\"\n    [showPagination]=\"showPagination\"\n    [paginationType]=\"paginationType\"\n    [paginationSize]=\"paginationSize\"\n    [itemsPerPageOptions]=\"pagination?.pageSizeOptions || itemsPerPageOptions\"\n    [itemsPerPageText]=\"itemsPerPageText\"\n    [currentItemsPerPageOption]=\"pagination?.pageSize ? pagination?.pageSize + '' : itemsPerPage + ''\"\n    [activePage]=\"pagination?.activePage || activePage\"\n    [totalResultsCount]=\"pagination?.totalEntries || totalResultsCount\"\n    [limitOfItemsToRender]=\"limitOfItemsToRender\"\n    [resultLimitReachedTooltipLabel]=\"resultLimitReachedTooltipLabel\"\n    [resultLimitReachedMessageBoxHeadline]=\"resultLimitReachedMessageBoxHeadline\"\n    [resultLimitReachedMessageBoxMessage]=\"resultLimitReachedMessageBoxMessage\"\n    [backToTopButtonScreenReaderText]=\"backToTopButtonScreenReaderText\"\n    [paginationScreenReader]=\"paginationScreenReader\"\n    [paginationOverlayOnTop]=\"paginationOverlayOnTop\"\n    (backToTopClicked)=\"onBackToTopClicked(scrollUnderHeader)\"\n    (itemsPerPageChanged)=\"onItemsPerPageChange($event)\"\n    (pageSelected)=\"onPageChange($event)\"\n  ></sie-ui-list-navigator-footer>\n  <ng-content select=\"[footerLink]\"></ng-content>\n</div>\n", styles: [":host{display:flex;flex-direction:column;flex:1;position:relative;height:100%}@media print{:host{display:block}}.scroll-item{position:absolute;top:-50px}.navigator-footer.bottom{margin-top:auto;position:relative}.wc-list-container{display:none}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1$1.AttributeDirective, selector: "[sieCoreAttributes]", inputs: ["sieCoreAttributes"] }, { kind: "component", type: UiEmptyStateComponent, selector: "sie-ui-empty-state", inputs: ["theme", "headline", "text", "link", "button", "iconPosition", "padding", "customIcon"], outputs: ["buttonClicked"] }, { kind: "component", type: UiListComponent, selector: "ul[sie-ui-list]", inputs: ["defaultItemComponents", "itemData", "bulkMode", "itemsDismissible", "isSelected$", "itemType", "itemAppearance", "condensed", "itemLength", "loading", "loadingChildren", "loadingMore", "trackHover", "showStatusIndicator", "hideNotSelectedItemsInPrintPreview", "numberOfSkeletons", "numberOfLoadMoreSkeletons", "expandableButtonMore", "expandableButtonLess", "paginationType", "showCatalogConfigureProducts"], outputs: ["itemEvent", "selectionChanged"] }, { kind: "component", type: UiListNavigatorFooterComponent, selector: "sie-ui-list-navigator-footer", inputs: ["showItemPerPageSelector", "showBackToTopButton", "showPagination", "paginationType", "paginationSize", "itemsPerPageText", "backToTopButtonScreenReaderText", "activePage", "limitOfItemsToRender", "resultLimitReachedTooltipLabel", "resultLimitReachedMessageBoxHeadline", "resultLimitReachedMessageBoxMessage", "paginationScreenReader", "itemsPerPageOptions", "currentItemsPerPageOption", "totalResultsCount", "paginationOverlayOnTop"], outputs: ["pageSelected", "backToTopClicked", "itemsPerPageChanged"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiListNavigatorComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-list-navigator', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"scroll-item\" #scrollUnderHeader></div>\n\n<ng-content select=\"[HeaderSlot]\"></ng-content>\n\n<div #webComponentContentWrapper class=\"wc-list-container\">\n  <ng-content select=\".list-item\"></ng-content>\n</div>\n\n<div class=\"list__results\" [sieCoreAttributes]=\"dataAttributeWrapper?.resultAttributes\">\n  <ng-container *ngIf=\"showEmptyState; else listContainer\">\n    <sie-ui-empty-state\n      class=\"container empty-spacing\"\n      [headline]=\"emptyStateHeadline\"\n      [text]=\"emptyStateText\"\n      [customIcon]=\"emptyStateCustomIcon\"\n      [iconPosition]=\"emptyStateIconPosition\"\n      [button]=\"emptyStateButton\"\n      [link]=\"emptyStateLink\"\n      (buttonClicked)=\"onEmptyStateActionClicked($event)\"\n    ></sie-ui-empty-state>\n    <ng-content select=\"[ButtonSlot]\"></ng-content>\n  </ng-container>\n\n  <ng-template #listContainer>\n    <ul\n      sie-ui-list\n      [itemType]=\"itemType\"\n      [itemAppearance]=\"itemAppearance\"\n      [condensed]=\"condensed\"\n      [defaultItemComponents]=\"itemComponents\"\n      [itemData]=\"itemData\"\n      [bulkMode]=\"bulkMode\"\n      [itemsDismissible]=\"itemsDismissible\"\n      [itemLength]=\"pagination?.pageSize || itemsPerPage || itemData?.length || 0\"\n      [loading]=\"loading\"\n      [loadingChildren]=\"loadingChildren\"\n      [loadingMore]=\"loadingMore\"\n      [expandableButtonMore]=\"expandableButtonMore\"\n      [expandableButtonLess]=\"expandableButtonLess\"\n      [trackHover]=\"trackHover\"\n      [hideNotSelectedItemsInPrintPreview]=\"hideNotSelectedItemsInPrintPreview\"\n      [paginationType]=\"paginationType\"\n      [numberOfSkeletons]=\"numberOfSkeletons\"\n      [numberOfLoadMoreSkeletons]=\"numberOfLoadMoreSkeletons\"\n      [showCatalogConfigureProducts]=\"showCatalogConfigureProducts\"\n      [isSelected$]=\"isSelectedSubject.asObservable()\"\n      (itemEvent)=\"itemEvent.next($event)\"\n      (selectionChanged)=\"selectionChanged.next($event)\"\n    ></ul>\n  </ng-template>\n</div>\n\n<div\n  class=\"navigator-footer\"\n  *ngIf=\"showPagination || showBackToTopButton || showItemPerPageSelector\"\n  [ngClass]=\"{ bottom: alignPaginationToBottom }\"\n  [sieCoreAttributes]=\"dataAttributeWrapper?.footerAttributes\"\n>\n  <sie-ui-list-navigator-footer\n    [showItemPerPageSelector]=\"showItemPerPageSelector\"\n    [showBackToTopButton]=\"showBackToTopButton\"\n    [showPagination]=\"showPagination\"\n    [paginationType]=\"paginationType\"\n    [paginationSize]=\"paginationSize\"\n    [itemsPerPageOptions]=\"pagination?.pageSizeOptions || itemsPerPageOptions\"\n    [itemsPerPageText]=\"itemsPerPageText\"\n    [currentItemsPerPageOption]=\"pagination?.pageSize ? pagination?.pageSize + '' : itemsPerPage + ''\"\n    [activePage]=\"pagination?.activePage || activePage\"\n    [totalResultsCount]=\"pagination?.totalEntries || totalResultsCount\"\n    [limitOfItemsToRender]=\"limitOfItemsToRender\"\n    [resultLimitReachedTooltipLabel]=\"resultLimitReachedTooltipLabel\"\n    [resultLimitReachedMessageBoxHeadline]=\"resultLimitReachedMessageBoxHeadline\"\n    [resultLimitReachedMessageBoxMessage]=\"resultLimitReachedMessageBoxMessage\"\n    [backToTopButtonScreenReaderText]=\"backToTopButtonScreenReaderText\"\n    [paginationScreenReader]=\"paginationScreenReader\"\n    [paginationOverlayOnTop]=\"paginationOverlayOnTop\"\n    (backToTopClicked)=\"onBackToTopClicked(scrollUnderHeader)\"\n    (itemsPerPageChanged)=\"onItemsPerPageChange($event)\"\n    (pageSelected)=\"onPageChange($event)\"\n  ></sie-ui-list-navigator-footer>\n  <ng-content select=\"[footerLink]\"></ng-content>\n</div>\n", styles: [":host{display:flex;flex-direction:column;flex:1;position:relative;height:100%}@media print{:host{display:block}}.scroll-item{position:absolute;top:-50px}.navigator-footer.bottom{margin-top:auto;position:relative}.wc-list-container{display:none}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i1$1.LayoutService }]; }, propDecorators: { elementsRef: [{
                type: ViewChild,
                args: ['webComponentContentWrapper', { static: true }]
            }], itemType: [{
                type: Input
            }], itemAppearance: [{
                type: Input
            }], itemComponents: [{
                type: Input
            }], paginationType: [{
                type: Input
            }], paginationSize: [{
                type: Input
            }], limitOfItemsToRender: [{
                type: Input
            }], resultLimitReachedTooltipLabel: [{
                type: Input
            }], resultLimitReachedMessageBoxHeadline: [{
                type: Input
            }], resultLimitReachedMessageBoxMessage: [{
                type: Input
            }], showCatalogConfigureProducts: [{
                type: Input
            }], pagination: [{
                type: Input
            }], scrollToTopElementSelector: [{
                type: Input
            }], condensed: [{
                type: Input
            }], showItemPerPageSelector: [{
                type: Input
            }], showBackToTopButton: [{
                type: Input
            }], showPagination: [{
                type: Input
            }], alignPaginationToBottom: [{
                type: Input
            }], activePage: [{
                type: Input
            }], itemData: [{
                type: Input
            }], totalResultsCount: [{
                type: Input
            }], itemsPerPageOptions: [{
                type: Input
            }], emptyStateCustomIcon: [{
                type: Input
            }], emptyStateIconPosition: [{
                type: Input
            }], bulkMode: [{
                type: Input
            }], itemsDismissible: [{
                type: Input
            }], loading: [{
                type: Input
            }], loadingMore: [{
                type: Input
            }], loadingChildren: [{
                type: Input
            }], trackHover: [{
                type: Input
            }], hideNotSelectedItemsInPrintPreview: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], numberOfSkeletons: [{
                type: Input
            }], numberOfLoadMoreSkeletons: [{
                type: Input
            }], itemsPerPage: [{
                type: Input
            }], emptyState: [{
                type: Input
            }], emptyStateHeadline: [{
                type: Input
            }], emptyStateText: [{
                type: Input
            }], emptyStateButton: [{
                type: Input
            }], emptyStateLink: [{
                type: Input
            }], expandableButtonMore: [{
                type: Input
            }], expandableButtonLess: [{
                type: Input
            }], itemsPerPageText: [{
                type: Input
            }], backToTopButtonScreenReaderText: [{
                type: Input
            }], paginationScreenReader: [{
                type: Input
            }], dataAttributeWrapper: [{
                type: Input
            }], paginationOverlayOnTop: [{
                type: Input
            }], scrollToTopOffset: [{
                type: Input
            }], emptyStateActionClicked: [{
                type: Output
            }], itemsPerPageChanged: [{
                type: Output
            }], pageChanged: [{
                type: Output
            }], itemEvent: [{
                type: Output
            }], selectionChanged: [{
                type: Output
            }], listComponent: [{
                type: ViewChild,
                args: [UiListComponent]
            }] } });

/**
 * # List Navigator Module
 * - {@link UiListNavigatorComponent}
 *
 * ## Module peer dependencies
 * - {@link SieIconsModule}
 */
class UiListNavigatorModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiListNavigatorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiListNavigatorModule, declarations: [UiListNavigatorComponent, UiListNavigatorFooterComponent], imports: [CommonModule,
            UiPaginationModule,
            BaseUiListModule,
            UiEmptyStateModule,
            UiDropdownModule,
            UiButtonModule,
            UiMessageBoxModule,
            SieCorePipesModule,
            ComponentBreakpointsModule], exports: [UiListNavigatorComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiListNavigatorModule, imports: [CommonModule,
            UiPaginationModule,
            BaseUiListModule,
            UiEmptyStateModule,
            UiDropdownModule,
            UiButtonModule,
            UiMessageBoxModule,
            SieCorePipesModule,
            ComponentBreakpointsModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiListNavigatorModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiListNavigatorComponent, UiListNavigatorFooterComponent],
                    imports: [
                        CommonModule,
                        UiPaginationModule,
                        BaseUiListModule,
                        UiEmptyStateModule,
                        UiDropdownModule,
                        UiButtonModule,
                        UiMessageBoxModule,
                        SieCorePipesModule,
                        ComponentBreakpointsModule
                    ],
                    exports: [UiListNavigatorComponent]
                }]
        }] });

/**
 * Service used for global modals handling
 */
class UiGlobalModalHandlingEventService {
    constructor() {
        /**
         * {@link UiGlobalModalModel Event} triggered on registration of the modal
         */
        this.registerModalEvent = new Subject();
        /**
         * {@link UiGlobalModalModel Event} triggered on opening the modal
         */
        this.openModalEvent = new Subject();
        /**
         * Triggered on closing the modal
         */
        this.closedModalEvent = new Subject();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiGlobalModalHandlingEventService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiGlobalModalHandlingEventService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiGlobalModalHandlingEventService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], propDecorators: { registerModalEvent: [{
                type: Output
            }], openModalEvent: [{
                type: Output
            }], closedModalEvent: [{
                type: Output
            }] } });

const UI_MODAL_COMPONENT_SERVICE = 'UI_MODAL_COMPONENT_SERVICE';

class UiBaseModalComponent extends NgxSmartModalComponent {
    constructor(layoutService, modalComponentService, renderer, cdr, vcr, elRef, _document, _platformId, cdkOverlayService) {
        super(renderer, cdr, vcr, elRef, _document, _platformId);
        this.layoutService = layoutService;
        this.modalComponentService = modalComponentService;
        this.renderer = renderer;
        this.cdr = cdr;
        this.vcr = vcr;
        this.elRef = elRef;
        this.cdkOverlayService = cdkOverlayService;
        this.subscriptions = new Subscription();
        /**
         * Event triggered when the video modal is closed
         */
        this.modalClosed = new EventEmitter();
    }
    /** @ignore */
    ngOnInit() {
        super.ngOnInit();
        const detectRouteChange = this.modalComponentService.detectRouteChange();
        if (detectRouteChange) {
            this.subscriptions.add(detectRouteChange.subscribe());
        }
    }
    /**
     * @param value Defines whether the modal has a close button available
     */
    set modalClosable(value) {
        this.closable = coerceBooleanProperty(value);
    }
    get modalClosable() {
        return this.closable;
    }
    /**
     * @param value Defines whether the modal can be dismissed by clicking on the backdrop
     */
    set modalDismissable(value) {
        this.dismissable = coerceBooleanProperty(value);
    }
    get modalDismissable() {
        return this.dismissable;
    }
    /**
     * @param value Defines whether the modal can be closed by pressing the ESC key
     */
    set modalEscapable(value) {
        this.escapable = coerceBooleanProperty(value);
    }
    get modalEscapable() {
        return this.escapable;
    }
    /** @ignore */
    ngAfterViewInit() {
        super.ngAfterViewInit();
        this.subscriptions.add(this.onAnyCloseEvent.subscribe(() => {
            this.modalClosed.emit();
            this.beforeClose();
            if (this._modalId) {
                this.modalComponentService.updateModalIdInUrl(null);
            }
        }));
    }
    /** @ignore */
    ngOnDestroy() {
        super.ngOnDestroy();
        this.subscriptions.unsubscribe();
    }
    /**
     * @param modalId Opens the modal instance with the selected modal id
     * @returns `NgxSmartModalComponent` the modal component
     */
    openDialog(modalId) {
        this._modalId = modalId;
        if (modalId) {
            this.modalComponentService.updateModalIdInUrl(modalId);
        }
        return this.open();
    }
    /**
     * The method that opens the modal
     * @returns `NgxSmartModalComponent` the modal component
     */
    open() {
        this.layoutService.disableScroll();
        this.cdkOverlayService.deactivateModalFocusTrap();
        return super.open(true);
    }
    /**
     * The method that closes the modal
     * @returns `NgxSmartModalComponent` the modal component
     */
    close() {
        this.beforeClose();
        return super.close();
    }
    beforeClose() {
        this.layoutService.enableScroll();
        this.cdkOverlayService.reactivateModalFocusTrap();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiBaseModalComponent, deps: [{ token: i1$1.LayoutService }, { token: UI_MODAL_COMPONENT_SERVICE }, { token: i0.Renderer2 }, { token: i0.ChangeDetectorRef }, { token: i0.ViewContainerRef }, { token: i0.ElementRef }, { token: DOCUMENT }, { token: PLATFORM_ID }, { token: CdkOverlayService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiBaseModalComponent, selector: "ng-component", inputs: { modalClosable: "modalClosable", modalDismissable: "modalDismissable", modalEscapable: "modalEscapable" }, outputs: { modalClosed: "modalClosed" }, usesInheritance: true, ngImport: i0, template: '', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiBaseModalComponent, decorators: [{
            type: Component,
            args: [{
                    template: '',
                    changeDetection: ChangeDetectionStrategy.OnPush
                }]
        }], ctorParameters: function () { return [{ type: i1$1.LayoutService }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [UI_MODAL_COMPONENT_SERVICE]
                }] }, { type: i0.Renderer2 }, { type: i0.ChangeDetectorRef }, { type: i0.ViewContainerRef }, { type: i0.ElementRef }, { type: Document, decorators: [{
                    type: Inject,
                    args: [DOCUMENT]
                }] }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [PLATFORM_ID]
                }] }, { type: CdkOverlayService }]; }, propDecorators: { modalClosed: [{
                type: Output
            }], modalClosable: [{
                type: Input
            }], modalDismissable: [{
                type: Input
            }], modalEscapable: [{
                type: Input
            }] } });

/** @ignore */
const MODAL_HEADLINE_ICON_MAPPING = {
    info: SieIcon.InformationFilled,
    success: SieIcon.SuccessFilled,
    warning: SieIcon.WarningFilled,
    error: SieIcon.ErrorFilled
};
/**
 * # Modal component
 *
 * Present critical information to the user or to (re)assure users about a critical action.
 *
 * ## Component variations
 *
 * - Regular Modal component that contains a headline, arbitrary content and an optional footer.
 *
 * ## Content
 *
 * The component can contain child elements. With the right decorators
 * they can be used within the modal as the following:
 *
 * - `content`: Used as the content within the modal
 * - `footer`: Used as the footer within the modal
 *
 * ## Code example
 * @example ```html
 * <sie-ui-modal
 *  [headline]="'Do you want to delete this software?'"
 *  [identifier]="'modal1'"
 *  [closable]="true"
 *  [escapable]="true"
 *  screenReaderCloseIcon="Close"
 *  #myModal1
 * >
 *  <div content>
 *    <p>This is some content...</p>
 *  </div>
 *  <div footer>
 *    <ul class="footer__list">
 *      <li class="footer__list-item">
 *        <sie-ui-button variant="secondary" actionType="delete" fullWidth>Delete</sie-ui-button>
 *      </li>
 *      <li class="footer__list-item">
 *        <sie-ui-button variant="tertiary" fullWidth>Cancel</sie-ui-button>
 *      </li>
 *    </ul>
 *  </div>
 * </sie-ui-modal>
 * ```
 */
class UiModalComponent extends UiBaseModalComponent {
    /**
     * Icon displayed on the left of the headline
     */
    set headlineVariant(variant) {
        this.headlineIcon = MODAL_HEADLINE_ICON_MAPPING[variant];
        if (this.headlineIcon) {
            this.iconReg.register(this.headlineIcon);
        }
        this._headlineVariant = variant;
    }
    get headlineVariant() {
        return this._headlineVariant;
    }
    /**
     * @param value Determines whether the modal has content inside the header
     * @default false
     */
    set hasHeaderContent(value) {
        this._hasHeaderContent = coerceBooleanProperty(value);
    }
    get hasHeaderContent() {
        return this._hasHeaderContent;
    }
    /**
     * @param value Determines whether the modal has a footer area
     * @default true
     */
    set hasFooter(value) {
        this._hasFooter = coerceBooleanProperty(value);
    }
    get hasFooter() {
        return this._hasFooter;
    }
    /**
     * @param value Defines whether the modal close button should be disabled
     * @default false
     */
    set closeButtonDisabled(value) {
        this._closeButtonDisabled = coerceBooleanProperty(value);
    }
    get closeButtonDisabled() {
        return this._closeButtonDisabled;
    }
    /**
     * @param value Defines whether the modal should have the full available width
     * @default false
     */
    set fullWidth(value) {
        this._fullWidth = coerceBooleanProperty(value);
    }
    get fullWidth() {
        return this._fullWidth;
    }
    /**
     * @param value Defines whether the modal should have the full available width on mobile
     * @default false
     */
    set fullScreenMobile(value) {
        this._fullScreenMobile = coerceBooleanProperty(value);
    }
    get fullScreenMobile() {
        return this._fullScreenMobile;
    }
    /**
     * @param value Defines whether the modal should use sticky footer
     * @default false
     */
    set stickyFooter(value) {
        this._stickyFooter = coerceBooleanProperty(value);
    }
    get stickyFooter() {
        return this._stickyFooter;
    }
    constructor(layoutService, modalComponentService, renderer, cdr, vcr, elRef, document, _platformId, iconReg, cdkOverlayService) {
        super(layoutService, modalComponentService, renderer, cdr, vcr, elRef, document, _platformId, cdkOverlayService);
        this.iconReg = iconReg;
        this.cdkOverlayService = cdkOverlayService;
        /**
         * Defines the {@link ModalSizes size} that the modal takes
         * @default 'medium'
         */
        this.size = 'medium';
        /**
         * Screen reader text for the close icon
         * @default '' empty string
         */
        this.screenReaderCloseIcon = '';
        /**
         * The event that is triggered on scrolling
         */
        this.scrolled = new Subject();
        /** @ignore */
        this.hasShadow = false;
        /** @ignore */
        this.footerShadow = false;
        this._fullWidth = false;
        this._fullScreenMobile = false;
        this._hasFooter = true;
        this._hasHeaderContent = false;
        this._closeButtonDisabled = false;
        this._stickyFooter = false;
        this.subscriptions = new Subscription();
        iconReg.register(SieIcon.Close);
    }
    /** @ignore */
    ngOnInit() {
        this.subscriptions.add(this.onOpenFinished.subscribe(() => this.setFooterShadow()));
        super.ngOnInit();
    }
    /** @ignore */
    ngOnDestroy() {
        this.subscriptions.unsubscribe();
        this.resizeObserver?.disconnect();
        super.ngOnDestroy();
    }
    /**
     * @param modalId Opens the modal instance with the selected modal id
     * @returns `NgxSmartModalComponent` the modal component
     */
    openDialog(modalId) {
        this.hasShadow = false;
        return super.openDialog(modalId);
    }
    /** @ignore */
    onScroll() {
        if (!this.modalContentRef) {
            return false;
        }
        const el = this.modalContentRef.nativeElement;
        this.hasShadow = el.scrollTop !== 0;
        this.updateFooterShadowBasedOnModalHeight(el);
        this.scrolled.next(el.scrollTop);
        return true;
    }
    /** @ignore */
    setFooterShadow() {
        if (!this.modalContentRef) {
            return;
        }
        const el = this.modalContentRef.nativeElement;
        this.updateFooterShadowBasedOnModalHeight(el);
        this.resizeObserver = this.createResizeObserver(() => {
            this.updateFooterShadowBasedOnModalHeight(el);
            this.cdr.detectChanges();
        });
        this.resizeObserver.observe(el);
    }
    updateFooterShadowBasedOnModalHeight(element) {
        this.footerShadow = element.scrollTop !== element.scrollHeight - element.offsetHeight;
    }
    createResizeObserver(callback) {
        return new ResizeObserver(callback);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiModalComponent, deps: [{ token: i1$1.LayoutService }, { token: UI_MODAL_COMPONENT_SERVICE }, { token: i0.Renderer2 }, { token: i0.ChangeDetectorRef }, { token: i0.ViewContainerRef }, { token: i0.ElementRef }, { token: DOCUMENT }, { token: PLATFORM_ID }, { token: i1.SieIconRegistryService }, { token: CdkOverlayService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiModalComponent, selector: "sie-ui-modal", inputs: { size: "size", headline: "headline", headlineVariant: "headlineVariant", screenReaderCloseIcon: "screenReaderCloseIcon", hasHeaderContent: "hasHeaderContent", hasFooter: "hasFooter", closeButtonDisabled: "closeButtonDisabled", fullWidth: "fullWidth", fullScreenMobile: "fullScreenMobile", stickyFooter: "stickyFooter" }, outputs: { scrolled: "scrolled" }, viewQueries: [{ propertyName: "modalContentRef", first: true, predicate: ["modalContent"], descendants: true, read: ElementRef }], usesInheritance: true, ngImport: i0, template: "<div\n  class=\"backdrop\"\n  *ngIf=\"overlayVisible\"\n  [style.z-index]=\"visible ? layerPosition - 1 : -1\"\n  [ngClass]=\"{\n    transparent: !backdrop,\n    overlay: true,\n    videoMode: false,\n    'nsm-overlay-open': openedClass,\n    'container-padding': size === 'page-size'\n  }\"\n  (mousedown)=\"dismiss($event)\"\n>\n  <div\n    class=\"modal__container nsm-dialog {{ customClass }} {{ size === 'page-size' ? 'page-size' : 'size-' + size }}\"\n    [style.z-index]=\"visible ? layerPosition : -1\"\n    [attr.aria-hidden]=\"!openedClass\"\n    [attr.aria-label]=\"ariaLabel\"\n    [attr.aria-labelledby]=\"ariaLabelledBy\"\n    [attr.aria-describedby]=\"ariaDescribedBy\"\n    [ngClass]=\"{\n      'has-shadow': this.hasShadow,\n      'nsm-dialog-open': openedClass,\n      'nsm-dialog-close': !openedClass,\n      'modal__container--fullWidth': fullWidth,\n      'modal__container--fullScreenMobile': fullScreenMobile,\n      'no-padding': stickyFooter\n    }\"\n    #nsmDialog\n    cdkTrapFocus\n  >\n    <header class=\"modal__header\">\n      <h4 class=\"modal__header-headline\" [class.with-badge]=\"!!headlineIcon\">\n        <sie-icon\n          *ngIf=\"!!headlineIcon\"\n          class=\"modal__header-badge-icon\"\n          [name]=\"headlineIcon\"\n          [inheritSize]=\"true\"\n          [ngClass]=\"'modal__header-badge-icon--' + headlineVariant\"\n        ></sie-icon>\n        {{ headline }}\n      </h4>\n      <sie-ui-button\n        *ngIf=\"closable\"\n        themeType=\"icon\"\n        variant=\"icon-un-contained\"\n        class=\"close-button\"\n        [disabled]=\"closeButtonDisabled\"\n        [icon]=\"iconReg.sieIcon.Close\"\n        (clicked)=\"close()\"\n        [iconScreenReaderText]=\"screenReaderCloseIcon\"\n      ></sie-ui-button>\n      <div *ngIf=\"hasHeaderContent\" class=\"modal__header-content\">\n        <ng-content select=\"[header-content]\"></ng-content>\n      </div>\n    </header>\n    <div class=\"modal__content\" (scroll)=\"onScroll()\" #modalContent>\n      <ng-content select=\"[content]\"></ng-content>\n      <footer *ngIf=\"hasFooter && !stickyFooter\" class=\"modal__footer\">\n        <ng-container [ngTemplateOutlet]=\"footerContent\"></ng-container>\n      </footer>\n    </div>\n    <footer *ngIf=\"stickyFooter\" class=\"modal__footer-sticky\" [ngClass]=\"{ 'footer-shadow': footerShadow }\">\n      <ng-container [ngTemplateOutlet]=\"footerContent\"></ng-container>\n    </footer>\n  </div>\n</div>\n\n<ng-template #footerContent>\n  <ng-content select=\"[footer]\"></ng-content>\n</ng-template>\n", styles: [".modal__container:focus,.modal__container:focus-visible{outline:0}::-webkit-scrollbar-thumb{background-clip:padding-box;background-color:#737389}::-webkit-scrollbar-button{display:none}::-webkit-scrollbar-corner{background-color:transparent}::-webkit-scrollbar{width:16px;height:8px}:host{scrollbar-color:#737389 #fff}:host .dark,:host.dark{scrollbar-color:#ccccd4 #000028}::-webkit-scrollbar-thumb:vertical{border-left:8px solid transparent;border-right:4px solid transparent}::-webkit-scrollbar-thumb:horizontal{border-top:4px solid transparent}::-webkit-scrollbar-track:vertical{border-left:8px solid #fff;background:#ccccd4;border-right:4px solid #fff}::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #ccccd4}.dark::-webkit-scrollbar-thumb,.dark ::-webkit-scrollbar-thumb{background-color:#ccccd4}.dark::-webkit-scrollbar-track:vertical,.dark ::-webkit-scrollbar-track:vertical{background:#737389;border-right:4px solid #000028;border-left:8px solid #000028}.dark::-webkit-scrollbar-track:horizontal,.dark ::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #737389}.overlay{display:flex;justify-content:center;align-items:center;height:100vh}.overlay.nsm-overlay-open{background-color:#0009}@media (min-width: 640px){.backdrop{padding:0 16px}}.backdrop.container-padding{padding:0}@media (min-width: 640px){.backdrop.container-padding{padding:0 16px}}@media (min-width: 1024px){.backdrop.container-padding{padding:0 56px}}@media (min-width: 1440px){.backdrop.container-padding{padding:0 96px}}.size-small{max-width:480px}.size-medium{max-width:608px}.size-large{max-width:912px}.page-size{max-width:1920px;width:100%;height:100%}@media (min-width: 640px){.page-size{height:calc(100vh - 32px)}}.modal__header{display:flex;flex-direction:column;align-items:flex-start;flex-shrink:0;max-width:100%;min-height:60px;padding:20px 16px 16px;z-index:4}@media (min-width: 1024px){.modal__header{padding:20px 24px 16px}}.modal__header-badge-icon{width:24px;height:24px;display:flex;align-items:center;fill:currentColor;margin-right:8px}.modal__header-badge-icon svg{fill:currentColor;width:inherit;height:inherit}.modal__header-badge-icon svg g{fill:currentColor;width:inherit;height:inherit}.modal__header-badge-icon svg text{font-family:Siemens Sans,sans-serif}.modal__header-badge-icon--info{color:#00557c}.modal__header-badge-icon--success{color:#00af52}.modal__header-badge-icon--warning{color:#ff9000}.modal__header-badge-icon--error{color:#ef0137}.modal__header-headline{margin-right:28px;color:#000028}.modal__header-headline.with-badge{font-size:1.125rem;font-weight:900;line-height:1.5rem;font-size:1rem;display:flex;margin-bottom:4px}.modal__header-content{width:100%;margin-top:16px}.modal__header .close-button{position:absolute;top:10px;right:3px}.modal__container{display:flex;max-height:100vh;padding-bottom:20px;flex-direction:column;background:#fff;box-shadow:0 2px 2px #0000000f,0 4px 8px #0000001f;overflow-y:hidden;pointer-events:auto;-webkit-overflow-scrolling:touch}@media (min-width: 640px){.modal__container.size-medium,.modal__container.size-large{min-width:608px}}.modal__container.page-size{max-height:2560px}@media only screen and (min-width: 480px){.modal__container{max-height:calc(100vh - 16px)}}@media only screen and (max-width: 480px){.modal__container{width:100%;max-width:initial}}@media (max-width: 639.78px){.modal__container{position:fixed;top:0;right:0;left:0;max-height:100%}}.modal__container--fullWidth{width:100%;max-width:none}@media (max-width: 639.78px){.modal__container--fullScreenMobile{bottom:0}.modal__container--fullScreenMobile .modal-content{overflow:hidden!important}}.modal__container.has-shadow .modal__header{box-shadow:0 2px 2px #0000000f,0 4px 8px #0000001f}.modal__container.no-padding{padding:0}.modal__content{flex:1;padding:0 16px 4px;overflow-x:hidden;overflow-y:auto}@media (min-width: 1024px){.modal__content{padding:0 24px 4px}}.modal__footer{display:flex;margin-top:24px;flex-direction:column}@media (min-width: 640px){.modal__footer{flex-direction:row;justify-content:flex-end}}.modal__footer-sticky{margin-top:auto;padding:16px 24px}@media (min-width: 640px){.modal__footer-sticky{display:flex;flex-direction:row;justify-content:flex-end}}.modal__footer-sticky.footer-shadow{box-shadow:0 -2px 2px #0000000f,0 -4px 8px #0000001f;z-index:10}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "component", type: UiButtonComponent, selector: "sie-ui-button" }, { kind: "directive", type: i6.CdkTrapFocus, selector: "[cdkTrapFocus]", inputs: ["cdkTrapFocus", "cdkTrapFocusAutoCapture"], exportAs: ["cdkTrapFocus"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiModalComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-modal', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div\n  class=\"backdrop\"\n  *ngIf=\"overlayVisible\"\n  [style.z-index]=\"visible ? layerPosition - 1 : -1\"\n  [ngClass]=\"{\n    transparent: !backdrop,\n    overlay: true,\n    videoMode: false,\n    'nsm-overlay-open': openedClass,\n    'container-padding': size === 'page-size'\n  }\"\n  (mousedown)=\"dismiss($event)\"\n>\n  <div\n    class=\"modal__container nsm-dialog {{ customClass }} {{ size === 'page-size' ? 'page-size' : 'size-' + size }}\"\n    [style.z-index]=\"visible ? layerPosition : -1\"\n    [attr.aria-hidden]=\"!openedClass\"\n    [attr.aria-label]=\"ariaLabel\"\n    [attr.aria-labelledby]=\"ariaLabelledBy\"\n    [attr.aria-describedby]=\"ariaDescribedBy\"\n    [ngClass]=\"{\n      'has-shadow': this.hasShadow,\n      'nsm-dialog-open': openedClass,\n      'nsm-dialog-close': !openedClass,\n      'modal__container--fullWidth': fullWidth,\n      'modal__container--fullScreenMobile': fullScreenMobile,\n      'no-padding': stickyFooter\n    }\"\n    #nsmDialog\n    cdkTrapFocus\n  >\n    <header class=\"modal__header\">\n      <h4 class=\"modal__header-headline\" [class.with-badge]=\"!!headlineIcon\">\n        <sie-icon\n          *ngIf=\"!!headlineIcon\"\n          class=\"modal__header-badge-icon\"\n          [name]=\"headlineIcon\"\n          [inheritSize]=\"true\"\n          [ngClass]=\"'modal__header-badge-icon--' + headlineVariant\"\n        ></sie-icon>\n        {{ headline }}\n      </h4>\n      <sie-ui-button\n        *ngIf=\"closable\"\n        themeType=\"icon\"\n        variant=\"icon-un-contained\"\n        class=\"close-button\"\n        [disabled]=\"closeButtonDisabled\"\n        [icon]=\"iconReg.sieIcon.Close\"\n        (clicked)=\"close()\"\n        [iconScreenReaderText]=\"screenReaderCloseIcon\"\n      ></sie-ui-button>\n      <div *ngIf=\"hasHeaderContent\" class=\"modal__header-content\">\n        <ng-content select=\"[header-content]\"></ng-content>\n      </div>\n    </header>\n    <div class=\"modal__content\" (scroll)=\"onScroll()\" #modalContent>\n      <ng-content select=\"[content]\"></ng-content>\n      <footer *ngIf=\"hasFooter && !stickyFooter\" class=\"modal__footer\">\n        <ng-container [ngTemplateOutlet]=\"footerContent\"></ng-container>\n      </footer>\n    </div>\n    <footer *ngIf=\"stickyFooter\" class=\"modal__footer-sticky\" [ngClass]=\"{ 'footer-shadow': footerShadow }\">\n      <ng-container [ngTemplateOutlet]=\"footerContent\"></ng-container>\n    </footer>\n  </div>\n</div>\n\n<ng-template #footerContent>\n  <ng-content select=\"[footer]\"></ng-content>\n</ng-template>\n", styles: [".modal__container:focus,.modal__container:focus-visible{outline:0}::-webkit-scrollbar-thumb{background-clip:padding-box;background-color:#737389}::-webkit-scrollbar-button{display:none}::-webkit-scrollbar-corner{background-color:transparent}::-webkit-scrollbar{width:16px;height:8px}:host{scrollbar-color:#737389 #fff}:host .dark,:host.dark{scrollbar-color:#ccccd4 #000028}::-webkit-scrollbar-thumb:vertical{border-left:8px solid transparent;border-right:4px solid transparent}::-webkit-scrollbar-thumb:horizontal{border-top:4px solid transparent}::-webkit-scrollbar-track:vertical{border-left:8px solid #fff;background:#ccccd4;border-right:4px solid #fff}::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #ccccd4}.dark::-webkit-scrollbar-thumb,.dark ::-webkit-scrollbar-thumb{background-color:#ccccd4}.dark::-webkit-scrollbar-track:vertical,.dark ::-webkit-scrollbar-track:vertical{background:#737389;border-right:4px solid #000028;border-left:8px solid #000028}.dark::-webkit-scrollbar-track:horizontal,.dark ::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #737389}.overlay{display:flex;justify-content:center;align-items:center;height:100vh}.overlay.nsm-overlay-open{background-color:#0009}@media (min-width: 640px){.backdrop{padding:0 16px}}.backdrop.container-padding{padding:0}@media (min-width: 640px){.backdrop.container-padding{padding:0 16px}}@media (min-width: 1024px){.backdrop.container-padding{padding:0 56px}}@media (min-width: 1440px){.backdrop.container-padding{padding:0 96px}}.size-small{max-width:480px}.size-medium{max-width:608px}.size-large{max-width:912px}.page-size{max-width:1920px;width:100%;height:100%}@media (min-width: 640px){.page-size{height:calc(100vh - 32px)}}.modal__header{display:flex;flex-direction:column;align-items:flex-start;flex-shrink:0;max-width:100%;min-height:60px;padding:20px 16px 16px;z-index:4}@media (min-width: 1024px){.modal__header{padding:20px 24px 16px}}.modal__header-badge-icon{width:24px;height:24px;display:flex;align-items:center;fill:currentColor;margin-right:8px}.modal__header-badge-icon svg{fill:currentColor;width:inherit;height:inherit}.modal__header-badge-icon svg g{fill:currentColor;width:inherit;height:inherit}.modal__header-badge-icon svg text{font-family:Siemens Sans,sans-serif}.modal__header-badge-icon--info{color:#00557c}.modal__header-badge-icon--success{color:#00af52}.modal__header-badge-icon--warning{color:#ff9000}.modal__header-badge-icon--error{color:#ef0137}.modal__header-headline{margin-right:28px;color:#000028}.modal__header-headline.with-badge{font-size:1.125rem;font-weight:900;line-height:1.5rem;font-size:1rem;display:flex;margin-bottom:4px}.modal__header-content{width:100%;margin-top:16px}.modal__header .close-button{position:absolute;top:10px;right:3px}.modal__container{display:flex;max-height:100vh;padding-bottom:20px;flex-direction:column;background:#fff;box-shadow:0 2px 2px #0000000f,0 4px 8px #0000001f;overflow-y:hidden;pointer-events:auto;-webkit-overflow-scrolling:touch}@media (min-width: 640px){.modal__container.size-medium,.modal__container.size-large{min-width:608px}}.modal__container.page-size{max-height:2560px}@media only screen and (min-width: 480px){.modal__container{max-height:calc(100vh - 16px)}}@media only screen and (max-width: 480px){.modal__container{width:100%;max-width:initial}}@media (max-width: 639.78px){.modal__container{position:fixed;top:0;right:0;left:0;max-height:100%}}.modal__container--fullWidth{width:100%;max-width:none}@media (max-width: 639.78px){.modal__container--fullScreenMobile{bottom:0}.modal__container--fullScreenMobile .modal-content{overflow:hidden!important}}.modal__container.has-shadow .modal__header{box-shadow:0 2px 2px #0000000f,0 4px 8px #0000001f}.modal__container.no-padding{padding:0}.modal__content{flex:1;padding:0 16px 4px;overflow-x:hidden;overflow-y:auto}@media (min-width: 1024px){.modal__content{padding:0 24px 4px}}.modal__footer{display:flex;margin-top:24px;flex-direction:column}@media (min-width: 640px){.modal__footer{flex-direction:row;justify-content:flex-end}}.modal__footer-sticky{margin-top:auto;padding:16px 24px}@media (min-width: 640px){.modal__footer-sticky{display:flex;flex-direction:row;justify-content:flex-end}}.modal__footer-sticky.footer-shadow{box-shadow:0 -2px 2px #0000000f,0 -4px 8px #0000001f;z-index:10}\n"] }]
        }], ctorParameters: function () { return [{ type: i1$1.LayoutService }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [UI_MODAL_COMPONENT_SERVICE]
                }] }, { type: i0.Renderer2 }, { type: i0.ChangeDetectorRef }, { type: i0.ViewContainerRef }, { type: i0.ElementRef }, { type: Document, decorators: [{
                    type: Inject,
                    args: [DOCUMENT]
                }] }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [PLATFORM_ID]
                }] }, { type: i1.SieIconRegistryService }, { type: CdkOverlayService }]; }, propDecorators: { modalContentRef: [{
                type: ViewChild,
                args: ['modalContent', { read: ElementRef }]
            }], size: [{
                type: Input
            }], headline: [{
                type: Input
            }], headlineVariant: [{
                type: Input
            }], screenReaderCloseIcon: [{
                type: Input
            }], hasHeaderContent: [{
                type: Input
            }], hasFooter: [{
                type: Input
            }], closeButtonDisabled: [{
                type: Input
            }], fullWidth: [{
                type: Input
            }], fullScreenMobile: [{
                type: Input
            }], stickyFooter: [{
                type: Input
            }], scrolled: [{
                type: Output
            }] } });

class UiModalComponentNgService {
    constructor(router, activatedRoute, location) {
        this.router = router;
        this.activatedRoute = activatedRoute;
        this.location = location;
    }
    detectRouteChange() {
        return this.router.events.pipe(filter(e => e instanceof NavigationEnd), map$1(_ => null));
    }
    updateModalIdInUrl(modalId) {
        const queryParams = this.activatedRoute.snapshot?.queryParams ?? {};
        const url = this.router
            .createUrlTree([], { relativeTo: this.activatedRoute, queryParams: { ...queryParams, modalId } })
            .toString();
        this.location.go(url);
    }
    openConfirmation() {
        return true;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiModalComponentNgService, deps: [{ token: i2$1.Router }, { token: i2$1.ActivatedRoute }, { token: i2.Location }], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiModalComponentNgService }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiModalComponentNgService, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return [{ type: i2$1.Router }, { type: i2$1.ActivatedRoute }, { type: i2.Location }]; } });

class UiModalComponentElementService {
    detectRouteChange() {
        return null; // not supported
    }
    updateModalIdInUrl() {
        // do nothing
    }
    openConfirmation() {
        return false;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiModalComponentElementService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiModalComponentElementService }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiModalComponentElementService, decorators: [{
            type: Injectable
        }] });

/**
 * # Modal Module
 * - {@link UiModalComponent}
 *
 * ## Module peer dependencies
 * - `@angular/platform-browser/animations/BrowserAnimationsModule`: This module is needed for the animation of opening
 *    and closing the modal component.
 * - `ngx-smart-modal/NgxSmartModalModule`: Handler to manage modals and data.
 * - {@link SieIconsModule}
 */
class UiModalModule {
    /** @ignore */
    static forWebComponent() {
        const providers = [
            {
                provide: UI_MODAL_COMPONENT_SERVICE,
                useClass: UiModalComponentElementService
            }
        ];
        return {
            ngModule: UiModalModule,
            providers
        };
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiModalModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiModalModule, declarations: [UiModalComponent], imports: [CommonModule, SieIconsModule, UiButtonModule, A11yModule], exports: [UiModalComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiModalModule, providers: [
            {
                provide: UI_MODAL_COMPONENT_SERVICE,
                useClass: UiModalComponentNgService
            }
        ], imports: [CommonModule, SieIconsModule, UiButtonModule, A11yModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiModalModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiModalComponent],
                    providers: [
                        {
                            provide: UI_MODAL_COMPONENT_SERVICE,
                            useClass: UiModalComponentNgService
                        }
                    ],
                    imports: [CommonModule, SieIconsModule, UiButtonModule, A11yModule],
                    exports: [UiModalComponent]
                }]
        }] });

/**
 * # Video Modal component
 *
 * Present critical information to the user or to (re)assure users about a critical action.
 *
 * ## Component variations
 *
 * - Video Modal component that is specially styled to contain video components.
 *
 * ## Content
 *
 * The component can contain child elements. With the right decorator
 * they can be used within the video modal as the following:
 *
 * - `content`: Used as the content within the video modal
 *
 * ## Code example
 * @example ```html
 * <sie-ui-video-modal [backdrop]="false" identifier="videoModal" [closable]="true" [escapable]="true" #videoModal>
 *  <div content>
 *    <sie-ui-video-player
 *      [ratio]="''16-9''"
 *      [size]="'l'"
 *      [video]="{
 *        videoId: '6106650258001',
 *        accountId: '1813624294001',
 *        playerId: 'VMi7Ptd8P',
 *        url: 'https://players.brightcove.net/1813624294001/VMi7Ptd8P_default/index.min.js'
 *      }"
 *      [autoplay]="'true'"
 *      [inModal]="true"
 *    ></sie-ui-video-player>
 *  </div>
 * </sie-ui-video-modal>
 * ```
 */
class UiVideoModalComponent extends UiBaseModalComponent {
    constructor(layoutService, modalComponentService, renderer, cdr, vcr, elRef, document, _platformId, iconReg, cdkOverlayService) {
        super(layoutService, modalComponentService, renderer, cdr, vcr, elRef, document, _platformId, cdkOverlayService);
        this.iconReg = iconReg;
        this.cdkOverlayService = cdkOverlayService;
        /**
         * Screen reader text for the close icon
         * @default '' empty string
         */
        this.screenReaderCloseIcon = '';
        iconReg.register(SieIcon.Close);
    }
    /** @ignore */
    onOutsideClick(event) {
        // check if click was outside of video
        // we use includes here to also hit web components
        if (!event.composedPath().find((m) => m.tagName?.toLowerCase().includes('sie-ui-video-player'))) {
            this.close();
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiVideoModalComponent, deps: [{ token: i1$1.LayoutService }, { token: UI_MODAL_COMPONENT_SERVICE }, { token: i0.Renderer2 }, { token: i0.ChangeDetectorRef }, { token: i0.ViewContainerRef }, { token: i0.ElementRef }, { token: DOCUMENT }, { token: PLATFORM_ID }, { token: i1.SieIconRegistryService }, { token: CdkOverlayService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiVideoModalComponent, selector: "sie-ui-video-modal", inputs: { screenReaderCloseIcon: "screenReaderCloseIcon" }, usesInheritance: true, ngImport: i0, template: "<div\n  *ngIf=\"overlayVisible\"\n  [style.z-index]=\"visible ? layerPosition - 1 : -1\"\n  [ngClass]=\"{ transparent: !backdrop, overlay: true, videoMode: false, 'nsm-overlay-open': openedClass }\"\n  (mousedown)=\"dismiss($event)\"\n>\n  <div\n    class=\"nsm-dialog {{ customClass }} modal-container\"\n    [style.z-index]=\"visible ? layerPosition : -1\"\n    [attr.aria-hidden]=\"!openedClass\"\n    [attr.aria-label]=\"ariaLabel\"\n    [attr.aria-labelledby]=\"ariaLabelledBy\"\n    [attr.aria-describedby]=\"ariaDescribedBy\"\n    [ngClass]=\"{\n      'nsm-dialog-open': openedClass,\n      'nsm-dialog-close': !openedClass\n    }\"\n    (click)=\"onOutsideClick($event)\"\n    #nsmDialog\n    cdkTrapFocus\n  >\n    <header class=\"modal-header\">\n      <sie-ui-button\n        class=\"close_button\"\n        themeType=\"icon\"\n        variant=\"icon-un-contained\"\n        background=\"dark\"\n        position=\"header\"\n        [icon]=\"iconReg.sieIcon.Close\"\n        (clicked)=\"close()\"\n        [iconScreenReaderText]=\"screenReaderCloseIcon\"\n      ></sie-ui-button>\n    </header>\n\n    <div class=\"video\">\n      <ng-content select=\"[content]\"></ng-content>\n    </div>\n  </div>\n</div>\n", styles: [".modal-container:focus,.modal-container:focus-visible{outline:0}.overlay{display:flex;justify-content:center;align-items:center}.overlay.nsm-overlay-open{background-color:#0009}.modal-container{pointer-events:auto;position:fixed;inset:0;background-color:#0009;max-width:none;max-height:none;padding:0}.modal-container .modal-header{display:flex;justify-content:flex-end;width:100%}.modal-container .video{position:absolute;top:50%;left:50%;transform:translate(-50%,-50%)}.close_button{margin:6px 6px 0 0}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: UiButtonComponent, selector: "sie-ui-button" }, { kind: "directive", type: i6.CdkTrapFocus, selector: "[cdkTrapFocus]", inputs: ["cdkTrapFocus", "cdkTrapFocusAutoCapture"], exportAs: ["cdkTrapFocus"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiVideoModalComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-video-modal', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div\n  *ngIf=\"overlayVisible\"\n  [style.z-index]=\"visible ? layerPosition - 1 : -1\"\n  [ngClass]=\"{ transparent: !backdrop, overlay: true, videoMode: false, 'nsm-overlay-open': openedClass }\"\n  (mousedown)=\"dismiss($event)\"\n>\n  <div\n    class=\"nsm-dialog {{ customClass }} modal-container\"\n    [style.z-index]=\"visible ? layerPosition : -1\"\n    [attr.aria-hidden]=\"!openedClass\"\n    [attr.aria-label]=\"ariaLabel\"\n    [attr.aria-labelledby]=\"ariaLabelledBy\"\n    [attr.aria-describedby]=\"ariaDescribedBy\"\n    [ngClass]=\"{\n      'nsm-dialog-open': openedClass,\n      'nsm-dialog-close': !openedClass\n    }\"\n    (click)=\"onOutsideClick($event)\"\n    #nsmDialog\n    cdkTrapFocus\n  >\n    <header class=\"modal-header\">\n      <sie-ui-button\n        class=\"close_button\"\n        themeType=\"icon\"\n        variant=\"icon-un-contained\"\n        background=\"dark\"\n        position=\"header\"\n        [icon]=\"iconReg.sieIcon.Close\"\n        (clicked)=\"close()\"\n        [iconScreenReaderText]=\"screenReaderCloseIcon\"\n      ></sie-ui-button>\n    </header>\n\n    <div class=\"video\">\n      <ng-content select=\"[content]\"></ng-content>\n    </div>\n  </div>\n</div>\n", styles: [".modal-container:focus,.modal-container:focus-visible{outline:0}.overlay{display:flex;justify-content:center;align-items:center}.overlay.nsm-overlay-open{background-color:#0009}.modal-container{pointer-events:auto;position:fixed;inset:0;background-color:#0009;max-width:none;max-height:none;padding:0}.modal-container .modal-header{display:flex;justify-content:flex-end;width:100%}.modal-container .video{position:absolute;top:50%;left:50%;transform:translate(-50%,-50%)}.close_button{margin:6px 6px 0 0}\n"] }]
        }], ctorParameters: function () { return [{ type: i1$1.LayoutService }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [UI_MODAL_COMPONENT_SERVICE]
                }] }, { type: i0.Renderer2 }, { type: i0.ChangeDetectorRef }, { type: i0.ViewContainerRef }, { type: i0.ElementRef }, { type: Document, decorators: [{
                    type: Inject,
                    args: [DOCUMENT]
                }] }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [PLATFORM_ID]
                }] }, { type: i1.SieIconRegistryService }, { type: CdkOverlayService }]; }, propDecorators: { screenReaderCloseIcon: [{
                type: Input
            }] } });

/**
 * # Video Modal Module
 * - {@link UiVideoModalComponent}
 *
 * ## Module peer dependencies
 * - `@angular/platform-browser/animations/BrowserAnimationsModule`: This module is needed for the animation of opening
 *    and closing the video modal component.
 * - `ngx-smart-modal/NgxSmartModalModule`: Handler to manage modals and data.
 * - {@link SieIconsModule}
 */
class UiVideoModalModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiVideoModalModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiVideoModalModule, declarations: [UiVideoModalComponent], imports: [CommonModule, SieIconsModule, UiButtonModule, A11yModule], exports: [UiVideoModalComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiVideoModalModule, imports: [CommonModule, SieIconsModule, UiButtonModule, A11yModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiVideoModalModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiVideoModalComponent],
                    imports: [CommonModule, SieIconsModule, UiButtonModule, A11yModule],
                    exports: [UiVideoModalComponent]
                }]
        }] });

const OK_BUTTON_ID = 'ok';
const CANCEL_BUTTON_ID$1 = 'cancel';

/**
 * Directive used to handle the confirmation modal and language change modal
 */
class UiConfirmationModalBaseDirective {
    constructor(iconReg) {
        this.iconReg = iconReg;
        /** @ignore */
        this.buttons = [];
        /**
         * Event triggered when the interaction with a modal is done and the modal closes
         */
        this.modalInteractionDone = new Subject();
    }
    createButtons(data) {
        this.buttons = [];
        this.addButton(OK_BUTTON_ID, data.okButton);
        this.addButton(CANCEL_BUTTON_ID$1, data.cancelButton);
    }
    subscribeToClose(modal) {
        const sub = modal.onAnyCloseEventFinished.subscribe(() => {
            sub.unsubscribe();
            this.modalInteractionDone.next();
        });
    }
    addButton(id, button) {
        if (!button) {
            return;
        }
        if (button.icon) {
            this.iconReg.register(button.icon);
        }
        this.buttons.push({
            id,
            label: button.text,
            buttonType: 'button',
            icon: button.icon,
            variant: id === OK_BUTTON_ID ? 'secondary' : 'tertiary'
        });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiConfirmationModalBaseDirective, deps: [{ token: i1.SieIconRegistryService }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: UiConfirmationModalBaseDirective, outputs: { modalInteractionDone: "modalInteractionDone" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiConfirmationModalBaseDirective, decorators: [{
            type: Directive
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }]; }, propDecorators: { modalInteractionDone: [{
                type: Output
            }] } });

/**
 * # Confirmation Modal component
 *
 * Present critical information to the user or to (re)assure users about a critical action.
 *
 * ## Component variations
 *
 * - Confirmation Modal component that contains a headline mostly used for confirmation and optionally two buttons
 * to ask the user how to proceed.
 *
 * ## Content
 *
 * A confirmation modal does not accept any content.
 *
 * ## Code example
 * @example ```html
 * <sie-ui-confirmation-modal
 *  [data]="{
 *    headline: 'Confirmation',
 *    text: 'Do you really want to delete this item?',
 *    okButton: { text: 'Ok', icon: 'CheckMark' },
 *    cancelButton: { text: 'Abort', icon: 'Close' },
 *    size: 'm',
 *    screenReaderCloseIcon: 'Close'
 *   }"
 * ></sie-ui-confirmation-modal>
 * ```
 */
class UiConfirmationModalComponent extends UiConfirmationModalBaseDirective {
    /**
     * @param data Provides {@link UiConfirmationModalModel configuration} on how the
     * confirmationtion modal will look like
     */
    set data(data) {
        this._data = data;
        this.createButtons(this.data);
    }
    get data() {
        return this._data;
    }
    constructor(iconReg, cdr, modalComponentService) {
        super(iconReg);
        this.iconReg = iconReg;
        this.cdr = cdr;
        this.modalComponentService = modalComponentService;
    }
    /** @ignore */
    ngAfterViewInit() {
        if (this.modalComponentService.openConfirmation()) {
            this.confirmationModal.openDialog(null);
            this.subscribeToClose(this.confirmationModal);
        }
        this.cdr.markForCheck();
    }
    /** @ignore */
    onButtonClick(event) {
        if (event.button?.id === OK_BUTTON_ID) {
            this.okFunction();
        }
        else {
            this.cancelFunction();
        }
        this.okFunction = null;
        this.cancelFunction = null;
        this.confirmationModal.close();
    }
    /** @ignore */
    onClose() {
        if (this.cancelFunction) {
            this.cancelFunction();
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiConfirmationModalComponent, deps: [{ token: i1.SieIconRegistryService }, { token: i0.ChangeDetectorRef }, { token: UI_MODAL_COMPONENT_SERVICE }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiConfirmationModalComponent, selector: "sie-ui-confirmation-modal", inputs: { data: "data", okFunction: "okFunction", cancelFunction: "cancelFunction" }, viewQueries: [{ propertyName: "buttonGroupComponent", first: true, predicate: ["buttonGroup"], descendants: true }, { propertyName: "confirmationModal", first: true, predicate: ["confirmationModal"], descendants: true }], usesInheritance: true, ngImport: i0, template: "<sie-ui-modal\n  identifier=\"confirmationModal\"\n  [headline]=\"data.headline\"\n  [headlineVariant]=\"data.headlineVariant\"\n  closable=\"true\"\n  escapable=\"true\"\n  dismissable=\"true\"\n  (onClose)=\"onClose()\"\n  (onDismiss)=\"onClose()\"\n  [size]=\"data.size || 'medium'\"\n  [screenReaderCloseIcon]=\"data.screenReaderCloseIcon\"\n  [stickyFooter]=\"data?.stickyFooter\"\n  #confirmationModal\n>\n  <div content>\n    <p>{{ data.text }}</p>\n  </div>\n  <div footer>\n    <sie-ui-button-group\n      [buttons]=\"buttons\"\n      buttonAlignmentClass=\"right\"\n      fullWidthOnViewportS=\"true\"\n      wrapButtons=\"true\"\n      (buttonClick)=\"onButtonClick($event)\"\n      #buttonGroup\n    ></sie-ui-button-group>\n  </div>\n</sie-ui-modal>\n", dependencies: [{ kind: "component", type: UiModalComponent, selector: "sie-ui-modal", inputs: ["size", "headline", "headlineVariant", "screenReaderCloseIcon", "hasHeaderContent", "hasFooter", "closeButtonDisabled", "fullWidth", "fullScreenMobile", "stickyFooter"], outputs: ["scrolled"] }, { kind: "component", type: UiButtonGroupComponent, selector: "sie-ui-button-group", inputs: ["buttons", "fullWidthOnViewportS", "wrapButtons", "direction", "flexDirection", "fullWidth", "buttonAlignmentClass"], outputs: ["buttonClick"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiConfirmationModalComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-confirmation-modal', changeDetection: ChangeDetectionStrategy.OnPush, template: "<sie-ui-modal\n  identifier=\"confirmationModal\"\n  [headline]=\"data.headline\"\n  [headlineVariant]=\"data.headlineVariant\"\n  closable=\"true\"\n  escapable=\"true\"\n  dismissable=\"true\"\n  (onClose)=\"onClose()\"\n  (onDismiss)=\"onClose()\"\n  [size]=\"data.size || 'medium'\"\n  [screenReaderCloseIcon]=\"data.screenReaderCloseIcon\"\n  [stickyFooter]=\"data?.stickyFooter\"\n  #confirmationModal\n>\n  <div content>\n    <p>{{ data.text }}</p>\n  </div>\n  <div footer>\n    <sie-ui-button-group\n      [buttons]=\"buttons\"\n      buttonAlignmentClass=\"right\"\n      fullWidthOnViewportS=\"true\"\n      wrapButtons=\"true\"\n      (buttonClick)=\"onButtonClick($event)\"\n      #buttonGroup\n    ></sie-ui-button-group>\n  </div>\n</sie-ui-modal>\n" }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }, { type: i0.ChangeDetectorRef }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [UI_MODAL_COMPONENT_SERVICE]
                }] }]; }, propDecorators: { buttonGroupComponent: [{
                type: ViewChild,
                args: ['buttonGroup']
            }], confirmationModal: [{
                type: ViewChild,
                args: ['confirmationModal']
            }], data: [{
                type: Input
            }], okFunction: [{
                type: Input
            }], cancelFunction: [{
                type: Input
            }] } });

/**
 * # Confirmation Modal Module
 * - {@link UiConfirmationModalComponent}
 *
 * ## Module peer dependencies
 * - `@angular/platform-browser/animations/BrowserAnimationsModule`: This module is needed for the animation of opening
 *    and closing the confirmation modal component.
 * - `ngx-smart-modal/NgxSmartModalModule`: Handler to manage modals and data.
 * - {@link SieIconsModule}
 */
class UiConfirmationModalModule {
    /** @ignore */
    static forWebComponent() {
        const providers = [
            {
                provide: UI_MODAL_COMPONENT_SERVICE,
                useClass: UiModalComponentElementService
            }
        ];
        return {
            ngModule: UiConfirmationModalModule,
            providers
        };
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiConfirmationModalModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiConfirmationModalModule, declarations: [UiConfirmationModalComponent], imports: [CommonModule, SieIconsModule, UiButtonModule, UiModalModule, UiButtonGroupModule], exports: [UiConfirmationModalComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiConfirmationModalModule, providers: [
            {
                provide: UI_MODAL_COMPONENT_SERVICE,
                useClass: UiModalComponentNgService
            }
        ], imports: [CommonModule, SieIconsModule, UiButtonModule, UiModalModule, UiButtonGroupModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiConfirmationModalModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiConfirmationModalComponent],
                    imports: [CommonModule, SieIconsModule, UiButtonModule, UiModalModule, UiButtonGroupModule],
                    providers: [
                        {
                            provide: UI_MODAL_COMPONENT_SERVICE,
                            useClass: UiModalComponentNgService
                        }
                    ],
                    exports: [UiConfirmationModalComponent]
                }]
        }] });

/**
 * # Language Change Modal component
 *
 * Present critical information to the user or to (re)assure users about a critical action.
 *
 * ## Component variations
 *
 * - Language Change Modal component that contains a headline, content and optionally two buttons
 * to ask the user how to proceed.
 *
 * ## Content
 *
 * A language change modal does not accept any content.
 *
 * ## Code example
 * @example ```html
 * <sie-ui-language-change-modal
 *  [data]="{
 *    headline: 'Headline',
 *    text: 'Some text...',
 *    cancelButton: { text: 'Cancel', icon: 'Close' },
 *    size: 'm',
 *    screenReaderCloseIcon: 'Close',
 *    subText: 'Subtext',
 *    links: [
 *      {
 *        id: '1',
 *        label: 'One'
 *      },
 *      {
 *        id: '2',
 *        label: 'Two'
 *      }
 *    ]
 *  }"
 * ></sie-ui-language-change-modal>
 * ```
 */
class UiLanguageChangeModalComponent extends UiConfirmationModalBaseDirective {
    /**
     * @param data Provides {@link UiLanguageChangeModalModel configuration} on how the
     * language change modal will look like
     */
    set data(data) {
        this._data = data;
        this.radioButtonUrlValue = data.links ? data.links[0]?.id : null;
        this.createButtons(this.data);
    }
    get data() {
        return this._data;
    }
    constructor(iconReg, cdr, modalComponentService) {
        super(iconReg);
        this.iconReg = iconReg;
        this.cdr = cdr;
        this.modalComponentService = modalComponentService;
        /** @ignore */
        this.radioButtonUrlValue = null;
    }
    /** @ignore */
    ngAfterViewInit() {
        if (this.modalComponentService.openConfirmation()) {
            this.languageChangeModal.openDialog(null);
        }
        this.cdr.markForCheck();
    }
    /** @ignore */
    onButtonClick(event) {
        if (event.button.id === OK_BUTTON_ID) {
            this.okFunction(this.radioButtonUrlValue);
        }
        else {
            this.cancelFunction();
        }
        this.okFunction = null;
        this.cancelFunction = null;
        this.languageChangeModal.close();
    }
    /** @ignore */
    onClose() {
        if (this.cancelFunction) {
            this.cancelFunction();
        }
    }
    /** @ignore */
    onRadioButtonChanged(id) {
        this.radioButtonUrlValue = id;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiLanguageChangeModalComponent, deps: [{ token: i1.SieIconRegistryService }, { token: i0.ChangeDetectorRef }, { token: UI_MODAL_COMPONENT_SERVICE }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiLanguageChangeModalComponent, selector: "sie-ui-language-change-modal", inputs: { data: "data", okFunction: "okFunction", cancelFunction: "cancelFunction" }, viewQueries: [{ propertyName: "languageChangeModal", first: true, predicate: ["languageChangeModal"], descendants: true }], usesInheritance: true, ngImport: i0, template: "<sie-ui-modal\n  [identifier]=\"'languageChangeModal'\"\n  [headline]=\"data.headline\"\n  [closable]=\"true\"\n  [escapable]=\"true\"\n  [dismissable]=\"true\"\n  (onClose)=\"onClose()\"\n  [screenReaderCloseIcon]=\"data.screenReaderCloseIcon\"\n  #languageChangeModal\n>\n  <div content>\n    <p>{{ data.text }}</p>\n    <p *ngIf=\"data.subText\" class=\"modal-content__subText\">{{ data.subText }}</p>\n    <div *ngIf=\"data.links?.length > 1\" class=\"modal-content__radio-buttons\">\n      <sie-ui-radio-button-group\n        name=\"modalLinks\"\n        [radioButtons]=\"data.links\"\n        [selectedId]=\"data.links[0].id\"\n        (selectedIdChange)=\"onRadioButtonChanged($event)\"\n      ></sie-ui-radio-button-group>\n    </div>\n  </div>\n  <div footer>\n    <sie-ui-button-group\n      [buttons]=\"buttons\"\n      [buttonAlignmentClass]=\"'right'\"\n      [fullWidthOnViewportS]=\"true\"\n      [wrapButtons]=\"true\"\n      (buttonClick)=\"onButtonClick($event)\"\n    ></sie-ui-button-group>\n  </div>\n</sie-ui-modal>\n", styles: [":host{cursor:auto}.modal-content__subText{margin-top:24px;color:#9999a9}.modal-content__radio-buttons{margin-top:24px}\n"], dependencies: [{ kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: UiModalComponent, selector: "sie-ui-modal", inputs: ["size", "headline", "headlineVariant", "screenReaderCloseIcon", "hasHeaderContent", "hasFooter", "closeButtonDisabled", "fullWidth", "fullScreenMobile", "stickyFooter"], outputs: ["scrolled"] }, { kind: "component", type: UiButtonGroupComponent, selector: "sie-ui-button-group", inputs: ["buttons", "fullWidthOnViewportS", "wrapButtons", "direction", "flexDirection", "fullWidth", "buttonAlignmentClass"], outputs: ["buttonClick"] }, { kind: "component", type: UiRadioButtonGroupComponent, selector: "sie-ui-radio-button-group", inputs: ["disabled", "selectedId", "radioButtons", "focusRadioButton", "required"], outputs: ["selectedIdChange"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiLanguageChangeModalComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-language-change-modal', changeDetection: ChangeDetectionStrategy.OnPush, template: "<sie-ui-modal\n  [identifier]=\"'languageChangeModal'\"\n  [headline]=\"data.headline\"\n  [closable]=\"true\"\n  [escapable]=\"true\"\n  [dismissable]=\"true\"\n  (onClose)=\"onClose()\"\n  [screenReaderCloseIcon]=\"data.screenReaderCloseIcon\"\n  #languageChangeModal\n>\n  <div content>\n    <p>{{ data.text }}</p>\n    <p *ngIf=\"data.subText\" class=\"modal-content__subText\">{{ data.subText }}</p>\n    <div *ngIf=\"data.links?.length > 1\" class=\"modal-content__radio-buttons\">\n      <sie-ui-radio-button-group\n        name=\"modalLinks\"\n        [radioButtons]=\"data.links\"\n        [selectedId]=\"data.links[0].id\"\n        (selectedIdChange)=\"onRadioButtonChanged($event)\"\n      ></sie-ui-radio-button-group>\n    </div>\n  </div>\n  <div footer>\n    <sie-ui-button-group\n      [buttons]=\"buttons\"\n      [buttonAlignmentClass]=\"'right'\"\n      [fullWidthOnViewportS]=\"true\"\n      [wrapButtons]=\"true\"\n      (buttonClick)=\"onButtonClick($event)\"\n    ></sie-ui-button-group>\n  </div>\n</sie-ui-modal>\n", styles: [":host{cursor:auto}.modal-content__subText{margin-top:24px;color:#9999a9}.modal-content__radio-buttons{margin-top:24px}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }, { type: i0.ChangeDetectorRef }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [UI_MODAL_COMPONENT_SERVICE]
                }] }]; }, propDecorators: { languageChangeModal: [{
                type: ViewChild,
                args: ['languageChangeModal']
            }], data: [{
                type: Input
            }], okFunction: [{
                type: Input
            }], cancelFunction: [{
                type: Input
            }] } });

/**
 * # Language Change Modal Module
 * - {@link UiLanguageChangeModalComponent}
 *
 * ## Module peer dependencies
 * - `@angular/platform-browser/animations/BrowserAnimationsModule`: This module is needed for the animation of opening
 *    and closing the language change modal component.
 * - `ngx-smart-modal/NgxSmartModalModule`: Handler to manage modals and data.
 * - {@link SieIconsModule}
 */
class UiLanguageChangeModalModule {
    /** @ignore */
    static forWebComponent() {
        const providers = [
            {
                provide: UI_MODAL_COMPONENT_SERVICE,
                useClass: UiModalComponentElementService
            }
        ];
        return {
            ngModule: UiLanguageChangeModalModule,
            providers
        };
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiLanguageChangeModalModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiLanguageChangeModalModule, declarations: [UiLanguageChangeModalComponent], imports: [CommonModule, SieIconsModule, UiButtonModule, UiModalModule, UiButtonGroupModule, UiRadioButtonGroupModule], exports: [UiLanguageChangeModalComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiLanguageChangeModalModule, providers: [
            {
                provide: UI_MODAL_COMPONENT_SERVICE,
                useClass: UiModalComponentNgService
            }
        ], imports: [CommonModule, SieIconsModule, UiButtonModule, UiModalModule, UiButtonGroupModule, UiRadioButtonGroupModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiLanguageChangeModalModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiLanguageChangeModalComponent],
                    imports: [CommonModule, SieIconsModule, UiButtonModule, UiModalModule, UiButtonGroupModule, UiRadioButtonGroupModule],
                    providers: [
                        {
                            provide: UI_MODAL_COMPONENT_SERVICE,
                            useClass: UiModalComponentNgService
                        }
                    ],
                    exports: [UiLanguageChangeModalComponent]
                }]
        }] });

class UiModalService {
    /**
     * Method that creates the confirmation modal component and provides the data for it
     */
    openOkCancelModal(container, data, okFunction, cancelFunction) {
        const componentRef = container.createComponent(UiConfirmationModalComponent);
        componentRef.instance.data = data;
        componentRef.instance.okFunction = okFunction;
        componentRef.instance.cancelFunction = cancelFunction;
        componentRef.hostView.markForCheck();
        const sub = componentRef.instance.modalInteractionDone?.subscribe(() => {
            sub.unsubscribe();
            componentRef.destroy();
        });
    }
    /**
     * Method that creates the language change modal component and provides the data for it
     */
    openLanguageChangeModal(container, data, okFunction, cancelFunction) {
        const componentRef = container.createComponent(UiLanguageChangeModalComponent);
        componentRef.instance.data = data;
        componentRef.instance.okFunction = okFunction;
        componentRef.instance.cancelFunction = cancelFunction;
        componentRef.hostView.markForCheck();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiModalService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiModalService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiModalService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }] });

class UiProfileMenuComponent {
    set networks(networks) {
        this._networks = networks;
        if (networks) {
            networks.forEach(network => {
                if (network.icon) {
                    this.iconReg.register(network.icon);
                }
            });
        }
    }
    get networks() {
        return this._networks;
    }
    constructor(iconReg) {
        this.iconReg = iconReg;
        this.profileMenuList$ = new Subject();
        this.logoutClick = new Subject();
        this.closeDrawerClick = new Subject();
        this.accountSwitchClicked = new Subject();
        this.networkSwitchEvent = new Subject();
    }
    onClick(event) {
        this.logoutClick.next(event);
    }
    closeDrawer(event) {
        this.closeDrawerClick.next(event);
    }
    accountSwitchLinkAction(event) {
        event.preventDefault();
        this.accountSwitchClicked.next(event);
    }
    onNetworkChange(value) {
        if (this.selectedNetwork !== value) {
            this.selectedNetwork = value;
            this.networkSwitchEvent.next(value);
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiProfileMenuComponent, deps: [{ token: i1.SieIconRegistryService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiProfileMenuComponent, selector: "sie-ui-profile-menu", inputs: { profileMenuList$: "profileMenuList$", userData: "userData", networks: "networks", selectedNetwork: "selectedNetwork", userSettingsInformation: "userSettingsInformation", logout: "logout", switchAccountLabel: "switchAccountLabel", dataLoaded: "dataLoaded" }, outputs: { logoutClick: "logoutClick", closeDrawerClick: "closeDrawerClick", accountSwitchClicked: "accountSwitchClicked", networkSwitchEvent: "networkSwitchEvent" }, ngImport: i0, template: "<div class=\"profile-menu\">\n  <div class=\"profile-menu__header\">\n    <sie-ui-account-identifier\n      size=\"l\"\n      mode=\"dark\"\n      variant=\"name-primary-secondary\"\n      [initials]=\"userData?.initials\"\n      [name]=\"userData?.name\"\n      [primaryMetaData]=\"userSettingsInformation?.companyName\"\n      [secondaryMetaData]=\"userSettingsInformation?.sapAccountId\"\n    ></sie-ui-account-identifier>\n    <sie-ui-link\n      *ngIf=\"userSettingsInformation?.userSettings.allowSwitchAccount\"\n      background=\"dark-alt\"\n      variant=\"icon-link\"\n      size=\"xs\"\n      class=\"profile-menu__account-switch\"\n      (clicked)=\"accountSwitchLinkAction($event)\"\n      type=\"button\"\n      data-cy=\"accountswitch-btn\"\n    >\n      {{ switchAccountLabel }}\n    </sie-ui-link>\n    <div *ngIf=\"networks && networks.length !== (0 || 1)\" class=\"profile-menu__dropdown\">\n      <sie-ui-dropdown\n        [options]=\"networks\"\n        [selectedValue]=\"selectedNetwork !== '' ? selectedNetwork : networks[0].value\"\n        [theme]=\"'dark'\"\n        (selectionChanged)=\"onNetworkChange($event)\"\n        overlayOnTop=\"true\"\n      ></sie-ui-dropdown>\n    </div>\n  </div>\n  <div class=\"profile-menu__body\">\n    <ul class=\"profile-menu__list\">\n      <ng-container *ngFor=\"let listItem of profileMenuList$ | async\">\n        <li class=\"profile-menu__list-item\" [ngClass]=\"listItem.disabled ? 'disabled' : ''\">\n          <ng-container *ngIf=\"!listItem.internal; else internalBlock\">\n            <a\n              [href]=\"listItem.url\"\n              [ngClass]=\"listItem.disabled ? 'disabled' : ''\"\n              [attr.data-cy]=\"listItem.id\"\n              class=\"profile-menu__link\"\n              rel=\"noopener\"\n              >{{ listItem.title }}</a\n            >\n          </ng-container>\n\n          <ng-template #internalBlock>\n            <a\n              [routerLink]=\"listItem.url\"\n              [ngClass]=\"listItem.disabled ? 'disabled' : ''\"\n              [attr.data-cy]=\"listItem.id\"\n              class=\"profile-menu__link\"\n              rel=\"noopener\"\n              (click)=\"closeDrawer($event)\"\n              >{{ listItem.title }}</a\n            >\n          </ng-template>\n        </li>\n      </ng-container>\n      <li class=\"profile-menu__list-item\">\n        <div *ngIf=\"!dataLoaded\" class=\"profile-menu__list profile-menu__skeleton-link\">\n          <sie-ui-skeleton class=\"skeleton__link\"></sie-ui-skeleton>\n        </div>\n      </li>\n    </ul>\n  </div>\n\n  <div class=\"profile-menu__footer\">\n    <sie-ui-button\n      id=\"profileMenuLogoutButton\"\n      data-cy=\"profileMenuLogoutButton\"\n      [icon]=\"iconReg.sieIcon.LogOut\"\n      [variant]=\"'tertiary'\"\n      (clicked)=\"onClick($event)\"\n    >\n      {{ logout }}\n    </sie-ui-button>\n  </div>\n</div>\n", styles: [".profile-menu__link,.profile-menu__skeleton-link{outline:none;outline-offset:0}@media (pointer: fine){.profile-menu__link,.profile-menu__skeleton-link{position:relative}.profile-menu__link:focus,.profile-menu__skeleton-link:focus{outline:1px solid #1491eb;outline-offset:2px}.profile-menu__link:focus:not(:focus-visible),.profile-menu__skeleton-link:focus:not(:focus-visible){outline:0}.profile-menu__link:focus-visible,.profile-menu__skeleton-link:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}.profile-menu{position:absolute;top:0;left:0;bottom:0;overflow-y:auto}.profile-menu__header{position:relative;top:0;left:0;width:360px;min-height:200px;padding:40px 16px 35px;background:linear-gradient(180deg,#000028 0%,#0087be 100%)}.profile-menu__list{list-style:none;margin:0 0 40px;padding:0}.profile-menu__list-item{font-size:1rem;font-weight:400;line-height:1.5rem;position:relative;margin:-1px 16px}.profile-menu__link,.profile-menu__skeleton-link{position:relative;display:block;padding:18px 16px;margin:0 -16px;color:#000028;background:linear-gradient(to right,#ccccd4,#ccccd4) 16px 100%/calc(100% - 32px) .0625rem no-repeat}.profile-menu__link.disabled,.profile-menu__skeleton-link.disabled{pointer-events:none}.profile-menu .disabled{color:#b3b3be;cursor:not-allowed}.profile-menu__link:hover,.profile-menu__link:active{cursor:pointer;background:linear-gradient(to right,#ccccd4,#ccccd4) 16px 0/calc(100% - 32px) .0625rem no-repeat,linear-gradient(to right,#ccccd4,#ccccd4) 16px 100%/calc(100% - 32px) .0625rem no-repeat,linear-gradient(to right,#e5e5e9,#e5e5e9);color:#00646e}.profile-menu__list-item:first-child{margin-top:0}.profile-menu__link.disabled:hover,.profile-menu__link.disabled:active{cursor:not-allowed;background:linear-gradient(to right,#f3f3f0,#f3f3f0) 16px 100%/calc(100% - 32px) .0625rem no-repeat;color:#b3b3be}.profile-menu__footer{padding:0 16px 40px}.profile-menu__account-switch{padding-left:70px}.profile-menu__dropdown{margin-top:30px;margin-left:75px}.profile-menu__skeleton-link .skeleton__link{height:28px;width:229px}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: UiAccountIdentifierComponent, selector: "sie-ui-account-identifier", inputs: ["size", "mode", "variant", "status", "name", "initials", "primaryMetaData", "secondaryMetaData", "linkText", "greetings", "searchHighlight", "avatarImage", "badgeData", "networkIcon", "forHashing", "disabled", "interactable"], outputs: ["actionLinkClicked"] }, { kind: "component", type: UiButtonComponent, selector: "sie-ui-button" }, { kind: "directive", type: i2$1.RouterLink, selector: "[routerLink]", inputs: ["target", "queryParams", "fragment", "queryParamsHandling", "state", "relativeTo", "preserveFragment", "skipLocationChange", "replaceUrl", "routerLink"] }, { kind: "component", type: UiLinkComponent, selector: "sie-ui-link", inputs: ["disabled", "disableVisitedStyle", "hasMarginTop", "offsetIcon", "truncate", "inLinkList", "trailingIcon", "icon", "cssClass", "href", "size", "target", "variant", "background", "type", "reference", "screenReaderText", "secondaryLabel", "download", "dataAttributes", "tooltip", "buttonType"], outputs: ["clicked"] }, { kind: "component", type: UiDropdownComponent, selector: "sie-ui-dropdown", inputs: ["type", "condensed", "options", "selectedValue", "required", "id", "name", "label", "placeholder", "errorMessage", "customClass", "readonly", "invalid", "hint", "marginBottomOnInvalidState"], outputs: ["selectionChanged"] }, { kind: "component", type: UiSkeletonComponent, selector: "sie-ui-skeleton", inputs: ["shape", "loadingText", "ariaLabel", "count"] }, { kind: "pipe", type: i2.AsyncPipe, name: "async" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiProfileMenuComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-profile-menu', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"profile-menu\">\n  <div class=\"profile-menu__header\">\n    <sie-ui-account-identifier\n      size=\"l\"\n      mode=\"dark\"\n      variant=\"name-primary-secondary\"\n      [initials]=\"userData?.initials\"\n      [name]=\"userData?.name\"\n      [primaryMetaData]=\"userSettingsInformation?.companyName\"\n      [secondaryMetaData]=\"userSettingsInformation?.sapAccountId\"\n    ></sie-ui-account-identifier>\n    <sie-ui-link\n      *ngIf=\"userSettingsInformation?.userSettings.allowSwitchAccount\"\n      background=\"dark-alt\"\n      variant=\"icon-link\"\n      size=\"xs\"\n      class=\"profile-menu__account-switch\"\n      (clicked)=\"accountSwitchLinkAction($event)\"\n      type=\"button\"\n      data-cy=\"accountswitch-btn\"\n    >\n      {{ switchAccountLabel }}\n    </sie-ui-link>\n    <div *ngIf=\"networks && networks.length !== (0 || 1)\" class=\"profile-menu__dropdown\">\n      <sie-ui-dropdown\n        [options]=\"networks\"\n        [selectedValue]=\"selectedNetwork !== '' ? selectedNetwork : networks[0].value\"\n        [theme]=\"'dark'\"\n        (selectionChanged)=\"onNetworkChange($event)\"\n        overlayOnTop=\"true\"\n      ></sie-ui-dropdown>\n    </div>\n  </div>\n  <div class=\"profile-menu__body\">\n    <ul class=\"profile-menu__list\">\n      <ng-container *ngFor=\"let listItem of profileMenuList$ | async\">\n        <li class=\"profile-menu__list-item\" [ngClass]=\"listItem.disabled ? 'disabled' : ''\">\n          <ng-container *ngIf=\"!listItem.internal; else internalBlock\">\n            <a\n              [href]=\"listItem.url\"\n              [ngClass]=\"listItem.disabled ? 'disabled' : ''\"\n              [attr.data-cy]=\"listItem.id\"\n              class=\"profile-menu__link\"\n              rel=\"noopener\"\n              >{{ listItem.title }}</a\n            >\n          </ng-container>\n\n          <ng-template #internalBlock>\n            <a\n              [routerLink]=\"listItem.url\"\n              [ngClass]=\"listItem.disabled ? 'disabled' : ''\"\n              [attr.data-cy]=\"listItem.id\"\n              class=\"profile-menu__link\"\n              rel=\"noopener\"\n              (click)=\"closeDrawer($event)\"\n              >{{ listItem.title }}</a\n            >\n          </ng-template>\n        </li>\n      </ng-container>\n      <li class=\"profile-menu__list-item\">\n        <div *ngIf=\"!dataLoaded\" class=\"profile-menu__list profile-menu__skeleton-link\">\n          <sie-ui-skeleton class=\"skeleton__link\"></sie-ui-skeleton>\n        </div>\n      </li>\n    </ul>\n  </div>\n\n  <div class=\"profile-menu__footer\">\n    <sie-ui-button\n      id=\"profileMenuLogoutButton\"\n      data-cy=\"profileMenuLogoutButton\"\n      [icon]=\"iconReg.sieIcon.LogOut\"\n      [variant]=\"'tertiary'\"\n      (clicked)=\"onClick($event)\"\n    >\n      {{ logout }}\n    </sie-ui-button>\n  </div>\n</div>\n", styles: [".profile-menu__link,.profile-menu__skeleton-link{outline:none;outline-offset:0}@media (pointer: fine){.profile-menu__link,.profile-menu__skeleton-link{position:relative}.profile-menu__link:focus,.profile-menu__skeleton-link:focus{outline:1px solid #1491eb;outline-offset:2px}.profile-menu__link:focus:not(:focus-visible),.profile-menu__skeleton-link:focus:not(:focus-visible){outline:0}.profile-menu__link:focus-visible,.profile-menu__skeleton-link:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}.profile-menu{position:absolute;top:0;left:0;bottom:0;overflow-y:auto}.profile-menu__header{position:relative;top:0;left:0;width:360px;min-height:200px;padding:40px 16px 35px;background:linear-gradient(180deg,#000028 0%,#0087be 100%)}.profile-menu__list{list-style:none;margin:0 0 40px;padding:0}.profile-menu__list-item{font-size:1rem;font-weight:400;line-height:1.5rem;position:relative;margin:-1px 16px}.profile-menu__link,.profile-menu__skeleton-link{position:relative;display:block;padding:18px 16px;margin:0 -16px;color:#000028;background:linear-gradient(to right,#ccccd4,#ccccd4) 16px 100%/calc(100% - 32px) .0625rem no-repeat}.profile-menu__link.disabled,.profile-menu__skeleton-link.disabled{pointer-events:none}.profile-menu .disabled{color:#b3b3be;cursor:not-allowed}.profile-menu__link:hover,.profile-menu__link:active{cursor:pointer;background:linear-gradient(to right,#ccccd4,#ccccd4) 16px 0/calc(100% - 32px) .0625rem no-repeat,linear-gradient(to right,#ccccd4,#ccccd4) 16px 100%/calc(100% - 32px) .0625rem no-repeat,linear-gradient(to right,#e5e5e9,#e5e5e9);color:#00646e}.profile-menu__list-item:first-child{margin-top:0}.profile-menu__link.disabled:hover,.profile-menu__link.disabled:active{cursor:not-allowed;background:linear-gradient(to right,#f3f3f0,#f3f3f0) 16px 100%/calc(100% - 32px) .0625rem no-repeat;color:#b3b3be}.profile-menu__footer{padding:0 16px 40px}.profile-menu__account-switch{padding-left:70px}.profile-menu__dropdown{margin-top:30px;margin-left:75px}.profile-menu__skeleton-link .skeleton__link{height:28px;width:229px}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }]; }, propDecorators: { profileMenuList$: [{
                type: Input
            }], userData: [{
                type: Input
            }], networks: [{
                type: Input
            }], selectedNetwork: [{
                type: Input
            }], userSettingsInformation: [{
                type: Input
            }], logout: [{
                type: Input
            }], switchAccountLabel: [{
                type: Input
            }], dataLoaded: [{
                type: Input
            }], logoutClick: [{
                type: Output
            }], closeDrawerClick: [{
                type: Output
            }], accountSwitchClicked: [{
                type: Output
            }], networkSwitchEvent: [{
                type: Output
            }] } });

class UiProfileMenuModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiProfileMenuModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiProfileMenuModule, declarations: [UiProfileMenuComponent], imports: [CommonModule,
            UiAccountIdentifierModule,
            UiButtonModule,
            RouterModule,
            UiLinkModule,
            UiDropdownModule,
            UiSkeletonModule], exports: [UiProfileMenuComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiProfileMenuModule, imports: [CommonModule,
            UiAccountIdentifierModule,
            UiButtonModule,
            RouterModule,
            UiLinkModule,
            UiDropdownModule,
            UiSkeletonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiProfileMenuModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiProfileMenuComponent],
                    imports: [
                        CommonModule,
                        UiAccountIdentifierModule,
                        UiButtonModule,
                        RouterModule,
                        UiLinkModule,
                        UiDropdownModule,
                        UiSkeletonModule
                    ],
                    exports: [UiProfileMenuComponent]
                }]
        }] });

/**
 * # Progress Spinner Component
 *
 * Progress spinner is used to indicate the processing of a user action.
 *
 * ## Component variations
 *
 * - Light/dark theme
 *
 * ## Content
 *
 * The spinner component does not accept any content.
 *
 * ## Code example
 *
 * @example ```html
 * <sie-ui-progress-spinner
 *  [percentage]="50"
 *  [message]="'Loading...'"
 *  [size]="'m'"
 * ></sie-ui-progress-spinner>
 * ```
 */
class UiProgressSpinnerComponent {
    constructor() {
        /**
         * Defines {@link ThemeVariant Variant} theme of the progress spinner.
         * @default 'light'
         */
        this.theme = 'light';
        this._size = UiSpinnerSize.small;
        this._overlayOnTop = true;
        this._overlay = false;
        this._strokeSize = PROGRESS_SPINNER_DEFAULT_STROKE;
    }
    /**
     * Defines {@link UiSpinnerSize size} of progress spinner
     * @default 's'
     */
    set size(value) {
        this._size = value;
        this.setSvgDefinitions();
        this.calculateIndicatorPercentage();
    }
    get size() {
        return this._size;
    }
    /**
     * Defines the percentage indicated in the progress spinner
     */
    set percentage(value) {
        if (value <= PROGRESS_SPINNER_MAX_PERCENTAGE) {
            this._percentage = value;
            this.calculateIndicatorPercentage();
        }
        else {
            this._percentage = null;
        }
    }
    /** @ignore */
    get percentage() {
        return this._percentage;
    }
    /**
     * @param overlayOnTop Indication whether a progress spinner's overlay should be covering the whole page (default) or just the container
     * @default true
     */
    set overlayOnTop(value) {
        this._overlayOnTop = coerceBooleanProperty(value);
    }
    get overlayOnTop() {
        return this._overlayOnTop;
    }
    /**
     * @param overlay indication whether a progress spinner is positioned inside an overlay
     * @default false
     */
    set overlay(overlay) {
        this._overlay = coerceBooleanProperty(overlay);
    }
    get overlay() {
        return this._overlay;
    }
    /** @ignore */
    get circumference() {
        return this._circumference;
    }
    calculateIndicatorPercentage() {
        const radius = PROGRESS_SPINNER_SIZE[this._size] / 2 - this._strokeSize / 2;
        this._circumference = `calc(50% - ${this._strokeSize}px / 2)`;
        this.indicatorDashArray = 2 * Math.PI * radius;
        this.indicatorDashOffset = this.indicatorDashArray * ((100 - this._percentage) / 100);
    }
    setSvgDefinitions() {
        this._strokeSize = PROGRESS_SPINNER_STROKE_SIZE[this._size];
        this._svgSize = `${PROGRESS_SPINNER_SIZE[this._size]}px`;
    }
    /** @ignore */
    ngOnInit() {
        this.setSvgDefinitions();
        this.calculateIndicatorPercentage();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiProgressSpinnerComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiProgressSpinnerComponent, selector: "sie-ui-progress-spinner", inputs: { theme: "theme", message: "message", size: "size", percentage: "percentage", overlayOnTop: "overlayOnTop", overlay: "overlay" }, host: { properties: { "style.--stroke-size": "this._strokeSize", "style.--size": "this._svgSize" } }, ngImport: i0, template: "<ng-container>\n  <div class=\"progress-spinner__wrapper\" *ngIf=\"overlay; else spinner\" [ngClass]=\"{ 'overlay-on-top': overlayOnTop }\">\n    <ng-template [ngTemplateOutlet]=\"spinner\"></ng-template>\n  </div>\n</ng-container>\n\n<ng-template #spinner>\n  <div class=\"progress-spinner\" *ngIf=\"percentage\" [ngClass]=\"'theme-' + theme\">\n    <div class=\"progress-spinner__svg-wrapper\">\n      <svg class=\"progress-spinner__svg\" [ngClass]=\"'size-' + size\">\n        <circle\n          cx=\"50%\"\n          cy=\"50%\"\n          class=\"progress-spinner__circle\"\n          [attr.r]=\"circumference\"\n          [ngClass]=\"'size-' + size\"\n          shape-rendering=\"geometricPrecision\"\n        ></circle>\n        <circle\n          cx=\"50%\"\n          cy=\"50%\"\n          class=\"progress-spinner__indication\"\n          [ngClass]=\"'size-' + size\"\n          [attr.r]=\"circumference\"\n          [attr.stroke-dashoffset]=\"indicatorDashOffset\"\n          [attr.stroke-dasharray]=\"indicatorDashArray\"\n          shape-rendering=\"geometricPrecision\"\n        ></circle>\n      </svg>\n      <span *ngIf=\"percentage\" class=\"progress-spinner__percentage\" [ngClass]=\"'size-' + size\">{{ percentage }}%</span>\n    </div>\n    <span *ngIf=\"message\" class=\"progress-spinner__message\">{{ message }}</span>\n  </div>\n</ng-template>\n", styles: [".progress-spinner{display:inline-flex;flex-direction:column;align-items:center;color:#000028}.progress-spinner__svg{width:var(--size);height:var(--size);transform:rotate(-90deg);max-width:100%;vertical-align:middle}.progress-spinner__svg-wrapper{position:relative;display:flex;flex-direction:row;align-items:center}.progress-spinner__percentage{font-size:.875rem;font-weight:400;line-height:1.25rem;margin-left:8px}.progress-spinner__percentage.size-l{position:absolute;display:flex;width:100%;height:100%;margin-left:0;justify-content:center;align-items:center}.progress-spinner__circle,.progress-spinner__indication{fill:transparent;stroke-width:var(--stroke-size)}.progress-spinner__circle{stroke:#ccccd4}.progress-spinner__indication{stroke:#00557c;transition:all .5s cubic-bezier(.4,0,.3,1)}.progress-spinner__message{font-size:.875rem;font-weight:400;line-height:1.25rem;margin-top:4px}.progress-spinner__wrapper{position:absolute;top:0;left:0;width:100%;height:100%;display:flex;align-items:center;justify-content:center;background:rgba(255,255,255,.95);z-index:900}.progress-spinner__wrapper.overlay-on-top{z-index:1000}.progress-spinner.theme-dark{color:#fff}.progress-spinner.theme-dark .progress-spinner__indication{stroke:#0087be}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiProgressSpinnerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-progress-spinner', changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-container>\n  <div class=\"progress-spinner__wrapper\" *ngIf=\"overlay; else spinner\" [ngClass]=\"{ 'overlay-on-top': overlayOnTop }\">\n    <ng-template [ngTemplateOutlet]=\"spinner\"></ng-template>\n  </div>\n</ng-container>\n\n<ng-template #spinner>\n  <div class=\"progress-spinner\" *ngIf=\"percentage\" [ngClass]=\"'theme-' + theme\">\n    <div class=\"progress-spinner__svg-wrapper\">\n      <svg class=\"progress-spinner__svg\" [ngClass]=\"'size-' + size\">\n        <circle\n          cx=\"50%\"\n          cy=\"50%\"\n          class=\"progress-spinner__circle\"\n          [attr.r]=\"circumference\"\n          [ngClass]=\"'size-' + size\"\n          shape-rendering=\"geometricPrecision\"\n        ></circle>\n        <circle\n          cx=\"50%\"\n          cy=\"50%\"\n          class=\"progress-spinner__indication\"\n          [ngClass]=\"'size-' + size\"\n          [attr.r]=\"circumference\"\n          [attr.stroke-dashoffset]=\"indicatorDashOffset\"\n          [attr.stroke-dasharray]=\"indicatorDashArray\"\n          shape-rendering=\"geometricPrecision\"\n        ></circle>\n      </svg>\n      <span *ngIf=\"percentage\" class=\"progress-spinner__percentage\" [ngClass]=\"'size-' + size\">{{ percentage }}%</span>\n    </div>\n    <span *ngIf=\"message\" class=\"progress-spinner__message\">{{ message }}</span>\n  </div>\n</ng-template>\n", styles: [".progress-spinner{display:inline-flex;flex-direction:column;align-items:center;color:#000028}.progress-spinner__svg{width:var(--size);height:var(--size);transform:rotate(-90deg);max-width:100%;vertical-align:middle}.progress-spinner__svg-wrapper{position:relative;display:flex;flex-direction:row;align-items:center}.progress-spinner__percentage{font-size:.875rem;font-weight:400;line-height:1.25rem;margin-left:8px}.progress-spinner__percentage.size-l{position:absolute;display:flex;width:100%;height:100%;margin-left:0;justify-content:center;align-items:center}.progress-spinner__circle,.progress-spinner__indication{fill:transparent;stroke-width:var(--stroke-size)}.progress-spinner__circle{stroke:#ccccd4}.progress-spinner__indication{stroke:#00557c;transition:all .5s cubic-bezier(.4,0,.3,1)}.progress-spinner__message{font-size:.875rem;font-weight:400;line-height:1.25rem;margin-top:4px}.progress-spinner__wrapper{position:absolute;top:0;left:0;width:100%;height:100%;display:flex;align-items:center;justify-content:center;background:rgba(255,255,255,.95);z-index:900}.progress-spinner__wrapper.overlay-on-top{z-index:1000}.progress-spinner.theme-dark{color:#fff}.progress-spinner.theme-dark .progress-spinner__indication{stroke:#0087be}\n"] }]
        }], propDecorators: { theme: [{
                type: Input
            }], message: [{
                type: Input
            }], size: [{
                type: Input
            }], percentage: [{
                type: Input
            }], overlayOnTop: [{
                type: Input
            }], overlay: [{
                type: Input
            }], _strokeSize: [{
                type: HostBinding,
                args: ['style.--stroke-size']
            }], _svgSize: [{
                type: HostBinding,
                args: ['style.--size']
            }] } });

/**
 * # Progress Spinner Module
 * - {@link UiProgressSpinnerComponent}
 */
class UiProgressSpinnerModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiProgressSpinnerModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiProgressSpinnerModule, declarations: [UiProgressSpinnerComponent], imports: [CommonModule], exports: [UiProgressSpinnerComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiProgressSpinnerModule, imports: [CommonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiProgressSpinnerModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiProgressSpinnerComponent],
                    imports: [CommonModule],
                    exports: [UiProgressSpinnerComponent]
                }]
        }] });

/**
 * Class to create new UiTableBuilder object using the {@link UiTableBuilderOptions}
 *
 * @example
 * ```ts
 * const generateTableWithBuilder = () => {
 *   const options: UiTableBuilderOptions = {
 *     width: '100%',
 *     height: '300px',
 *     caption: 'table caption'
 *   };
 *
 *   const builder = new UiTableBuilder(options);
 *
 *   const cells: UiTableCellModel[] = [
 *     {
 *       value: 'Cell one',
 *       alignment: 'center'
 *     },
 *     {
 *       value: 'Cell two',
 *       alignment: 'center'
 *     }
 *   ];
 *
 *   // Adds tbody ID = 0 to table
 *   builder.addRow(cells);
 *
 *   // Adds new tbody with ID = 1 to table
 *   builder.addRow(cells, '1');
 *
 *   // Adds new row to tbody with ID = 0
 *   builder.addRow([{ value: 'tbody1', alignment: 'left' }]);
 *
 *   // Adds new row to tbody with ID = 1
 *   builder.addRow([{ value: 'tbody2', alignment: 'left' }], '1');
 *
 *   builder.setFooter(cells);
 *
 *   return builder.toModel();
 * };
 * ```
 */
class UiTableBuilder {
    constructor(options = {}) {
        this.tBodies = [];
        Object.assign(this, options);
    }
    /**
     * Method to add a row to table section
     * @param [cells=[]] cells of rows
     * @param [bodyId=0] ID of table body
     */
    addRow(cells = [], bodyId = '0') {
        const body = this.getOrCreateBody(bodyId);
        body.addRow(cells);
    }
    /**
     * Method to add new table body
     * @param id table body ID
     * @returns new table body
     */
    addBody(id) {
        const newBody = new UiTableSection(id || `${this.tBodies.length}`);
        this.tBodies.push(newBody);
        return newBody;
    }
    /**
     * Method to set a table footer
     * @param [cells=[]] cells displayed in the table footer
     */
    setFooter(cells = []) {
        const footer = this.getOrCreateFooter();
        footer.addRow(cells);
    }
    /**
     * @returns Builds {@link UiTableModel table model}
     */
    toModel() {
        return deepCopy(this);
    }
    getBody(id) {
        return this.tBodies.find(body => body.id === id);
    }
    getOrCreateBody(id) {
        return this.getBody(id) || this.addBody(id);
    }
    getOrCreateFooter() {
        if (!this.tFoot) {
            this.tFoot = new UiTableSection('footer');
        }
        return this.tFoot;
    }
}
/**
 * Class to create table section object
 */
class UiTableSection {
    get id() {
        return this._id;
    }
    constructor(id) {
        this.rows = [];
        this._id = id;
    }
    /**
     * Method that adds a new row to the rows array of the table section
     * @param [cells=[]] cells of the row
     */
    addRow(cells = []) {
        this.rows.push(new UiTableRow(cells));
    }
}
/**
 * Class to create table row object
 */
class UiTableRow {
    constructor(cells = []) {
        this.cells = [];
        this._columns = 0;
        cells.forEach(cell => {
            if (typeof cell === 'string') {
                cell = {
                    value: cell
                };
            }
            this._columns += cell.colspan || 1;
            this.cells.push(new UiTableCell(cell));
        });
    }
}
/**
 * Class to create table cell object
 */
class UiTableCell {
    constructor(cell) {
        this.alignment = 'left';
        Object.assign(this, cell);
    }
}

class UiBaseTeaserDirective {
    /**
     * When container-styled used provides container viewport to child
     * @default ''
     */
    set viewportContainer(key) {
        this._breakpointKey = key;
    }
    get viewportContainer() {
        return this._breakpointKey;
    }
    constructor(layoutService, cdr) {
        this.layoutService = layoutService;
        this.cdr = cdr;
        // special case for the carousel, it renders every teaser 3 times -> video modal should not be created 3 times
        /**
         * Special case for the carousel, it renders every teaser 3 times -> video modal should not be created 3 times.
         * @default false
         */
        this.ignoreVideoModal = false;
        /**
         * Defines if container-queries or media-queries are used for the teaser styling -> needed for carousel if containerStyling is enabled
         * NOTE: currently should only be used in combination with carousel
         * @default false
         */
        this.containerStyled = false;
        /**
         * Define should the button use the full width when the viewport is S (small).
         * @default false
         */
        this.buttonFullWidthOnViewportS = false;
        /**
         * {@link UiButtonClickModel Event} triggered when the button is clicked.
         */
        this.buttonClick = new Subject();
        /**
         * {@link UiTeaserModel Event} triggered when button is clicked and emit teaser data
         */
        this.cardClicked = new EventEmitter();
        /** @ignore */
        this.breakpointSActive = false;
        /** @ignore */
        this.smallViewport = false;
        /** @ignore */
        this.mediumViewport = false;
        this.subscription = new Subscription();
    }
    /** @ignore */
    ngOnInit() {
        this.updateObservables();
    }
    ngOnChanges(changes) {
        if (changes.viewportContainer && this.containerStyled) {
            this.updateObservables();
        }
    }
    /** @ignore */
    ngOnDestroy() {
        this.subscription?.unsubscribe();
    }
    checkBreakpoint() {
        if (this.teaserData) {
            if (this.smallViewport) {
                this.imageUrl = this.teaserData.picture?.urlSmall;
                this.breakpointSActive = true;
            }
            else if (this.mediumViewport) {
                this.imageUrl = this.teaserData.picture?.urlMedium;
                this.breakpointSActive = false;
            }
            else {
                this.imageUrl = this.teaserData.picture?.urlLarge;
                this.breakpointSActive = false;
            }
            this.cdr.detectChanges();
        }
    }
    updateObservables() {
        if (this.containerStyled) {
            this.updateViewportVars(this.viewportContainer);
        }
        else {
            this.subscription.add(this.layoutService.currentViewPort$.subscribe(breakpoint => {
                this.updateViewportVars(breakpoint);
            }));
        }
        this.cdr.detectChanges();
    }
    updateViewportVars(key) {
        this.smallViewport = ['XS', 'S'].includes(key);
        this.mediumViewport = ['M'].includes(key);
        this.checkBreakpoint();
        this.cdr.detectChanges();
    }
    /** @ignore */
    onButtonClick(event) {
        this.cardClicked.emit(this.teaserData);
        this.buttonClick.next(deepCopy(event));
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiBaseTeaserDirective, deps: [{ token: i1$1.LayoutService }, { token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: UiBaseTeaserDirective, inputs: { teaserData: "teaserData", buttonAlignment: "buttonAlignment", ignoreVideoModal: ["ignoreVideoModal", "ignoreVideoModal", booleanAttribute], containerStyled: ["containerStyled", "containerStyled", booleanAttribute], viewportContainer: "viewportContainer", buttonFullWidthOnViewportS: ["buttonFullWidthOnViewportS", "buttonFullWidthOnViewportS", booleanAttribute] }, outputs: { buttonClick: "buttonClick", cardClicked: "cardClicked" }, usesOnChanges: true, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiBaseTeaserDirective, decorators: [{
            type: Directive
        }], ctorParameters: function () { return [{ type: i1$1.LayoutService }, { type: i0.ChangeDetectorRef }]; }, propDecorators: { teaserData: [{
                type: Input
            }], buttonAlignment: [{
                type: Input
            }], ignoreVideoModal: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], containerStyled: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], viewportContainer: [{
                type: Input
            }], buttonFullWidthOnViewportS: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], buttonClick: [{
                type: Output
            }], cardClicked: [{
                type: Output
            }] } });

class UiBenefitsComponent {
    constructor(iconReg) {
        this.iconReg = iconReg;
        this.useTruncation = false;
        this.truncationPrioOffset = 0;
    }
    ngOnInit() {
        this.iconReg.register(SieIcon.CheckMark);
    }
    calculatePrio(indexNumber) {
        return +this.truncationPrioOffset + +indexNumber;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiBenefitsComponent, deps: [{ token: i1.SieIconRegistryService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiBenefitsComponent, selector: "ul[sie-ui-benefits]", inputs: { benefits: "benefits", useTruncation: "useTruncation", truncationPrioOffset: "truncationPrioOffset", truncationGroupName: "truncationGroupName" }, ngImport: i0, template: "<li\n  *ngFor=\"let benefit of benefits; let index = index\"\n  [attr.data-truncate-group-name]=\"useTruncation === true ? truncationGroupName : undefined\"\n  [attr.data-truncate-prio]=\"useTruncation === true ? calculatePrio(index) : undefined\"\n  sieCoreAddTooltip\n>\n  <span aria-hidden=\"true\" class=\"list__icon-container\">\n    <sie-icon [name]=\"iconReg.sieIcon.CheckMark\" class=\"list-item__icon\"></sie-icon>\n  </span>\n  <span class=\"list__text\">{{ benefit }}</span>\n</li>\n", styles: [":host{list-style:none;margin:0;padding:0}:host>li{position:relative;display:flex;justify-content:flex-start;padding-left:28px}:host>li:last-child{margin-bottom:2px}:host>li>.list__icon-container{position:absolute;left:0;width:20px;height:20px}:host>li .list-item__icon{width:20px;height:20px;display:flex;align-items:center;fill:currentColor;position:relative;top:1px}:host>li .list-item__icon svg{fill:currentColor;width:inherit;height:inherit}:host>li .list-item__icon svg g{fill:currentColor;width:inherit;height:inherit}:host>li .list-item__icon svg text{font-family:Siemens Sans,sans-serif}\n"], dependencies: [{ kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "directive", type: i1$1.AddTooltipDirective, selector: "[sieCoreAddTooltip]" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiBenefitsComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ul[sie-ui-benefits]', changeDetection: ChangeDetectionStrategy.OnPush, template: "<li\n  *ngFor=\"let benefit of benefits; let index = index\"\n  [attr.data-truncate-group-name]=\"useTruncation === true ? truncationGroupName : undefined\"\n  [attr.data-truncate-prio]=\"useTruncation === true ? calculatePrio(index) : undefined\"\n  sieCoreAddTooltip\n>\n  <span aria-hidden=\"true\" class=\"list__icon-container\">\n    <sie-icon [name]=\"iconReg.sieIcon.CheckMark\" class=\"list-item__icon\"></sie-icon>\n  </span>\n  <span class=\"list__text\">{{ benefit }}</span>\n</li>\n", styles: [":host{list-style:none;margin:0;padding:0}:host>li{position:relative;display:flex;justify-content:flex-start;padding-left:28px}:host>li:last-child{margin-bottom:2px}:host>li>.list__icon-container{position:absolute;left:0;width:20px;height:20px}:host>li .list-item__icon{width:20px;height:20px;display:flex;align-items:center;fill:currentColor;position:relative;top:1px}:host>li .list-item__icon svg{fill:currentColor;width:inherit;height:inherit}:host>li .list-item__icon svg g{fill:currentColor;width:inherit;height:inherit}:host>li .list-item__icon svg text{font-family:Siemens Sans,sans-serif}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }]; }, propDecorators: { benefits: [{
                type: Input
            }], useTruncation: [{
                type: Input
            }], truncationPrioOffset: [{
                type: Input
            }], truncationGroupName: [{
                type: Input
            }] } });

/**
 * # Ad Teaser Component
 *
 * Ad Teasers provide a way to highlight a product, service or any other type of content that deserves users' attention.
 *
 * ## Component variations
 *
 * There are no variations.
 *
 * ## Content
 *
 * The Ad Teaser component does not accept any content.
 *
 * ## Code example
 * @example
 * Template:
 * ```html
 * <sie-ui-ad-teaser [buttonFullWidthOnViewportS]="false" [buttonAlignment]="'left'" [teaserData]="adTeaserData"></sie-ui-ad-teaser>
 * ```
 * Card Portrait item example:
 * ``` js
 * const adTeaserData = {
 *  id: 2,
 *  picture: {
 *    urlSmall:
 *     'https://assets.new.siemens.com/siemens/assets/api/uuid:c67c52de-8441-4e05-93ed-2644bed4f080/width:640/quality:LOW/AdobeStock-263584338.jpeg',
 *    urlMedium:
 *     'https://assets.new.siemens.com/siemens/assets/api/uuid:c67c52de-8441-4e05-93ed-2644bed4f080/width:1280/quality:MEDIUM/AdobeStock-263584338.jpeg',
 *    urlLarge:
 *     'https://assets.new.siemens.com/siemens/assets/api/uuid:c67c52de-8441-4e05-93ed-2644bed4f080/width:1920/quality:HIGH/AdobeStock-263584338.jpeg',
 *    altText: 'In case the image does not load..',
 *    mode: 'cover'
 *  },
 *  buttons: [
 *   {
 *     label: 'Register',
 *     link: 'https://new.siemens.com/global/en/company/fairs-events/digital-enterprise-virtual-summit.html#Registration',
 *     variant: 'secondary',
 *     background: 'dark',
 *     icon: 'UserAccount',
 *     iconPosition: 'leading',
 *     buttonType: 'link',
 *     target: '_self'
 *   }
 *  ],
 *  subTitle: 'Industry Mall and Industry Online Support are starting to evolve into one unified platform!',
 *  title: 'PROMO AD SiePortal: The integrated platform for your information, buying and order workflow.',
 *  linkLabel: 'Learn more',
 *  linkTarget: 'https://new.siemens.com/global/en/company/fairs-events/digital-enterprise-virtual-summit.html',
 *  linkType: 'link'
 *  };
 *```
 */
class UiAdTeaserComponent extends UiBaseTeaserDirective {
    constructor(layoutService, cdr, elementRef, document) {
        super(layoutService, cdr);
        this.layoutService = layoutService;
        this.cdr = cdr;
        this.elementRef = elementRef;
        this.document = document;
        /**
         * {@link UiChildActionEventModel Event} triggered when the action in the dropdown is clicked or selected via keyboard
         * (options button on the ad teaser).
         */
        this.childActionClicked = new EventEmitter();
        /** @ignore */
        this.ColorBackgroundTeaserOverlay = ComponentTeaserOverlay;
        /** @ignore */
        this.personImage = '/assets/images/person.png';
        /** @ignore */
        this.adTeaserBg = '/assets/images/adteaserbg.svg';
    }
    /** @ignore */
    ngOnInit() {
        super.ngOnInit();
    }
    /** @ignore */
    dropdownOptionSelected(button, item) {
        this.childActionClicked.emit({ button, item });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiAdTeaserComponent, deps: [{ token: i1$1.LayoutService }, { token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: DOCUMENT }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiAdTeaserComponent, selector: "sie-ui-ad-teaser", inputs: { teaserCount: "teaserCount", height: "height" }, outputs: { childActionClicked: "childActionClicked" }, viewQueries: [{ propertyName: "badge", first: true, predicate: ["adTeaser"], descendants: true }], usesInheritance: true, ngImport: i0, template: "<article\n  [sieCoreAttributes]=\"teaserData?.dataAttributes\"\n  [ngClass]=\"[\n    'ad-teaser',\n    'teasers-' + teaserCount,\n    teaserData?.visualizationType === 'stage-adteaser-platform-promo' ? 'ad-teaser--platform-promo' : '',\n    containerStyled ? 'container-layout' : ''\n  ]\"\n  [style.height]=\"height + 'px'\"\n  [style.background-image]=\"\n    teaserData?.visualizationType === 'stage-adteaser-platform-promo'\n      ? 'url(' + adTeaserBg + ')'\n      : ColorBackgroundTeaserOverlay + ', url(' + imageUrl + ')'\n  \"\n  [style.background-repeat]=\"'no-repeat'\"\n  [style.background-position]=\"'center'\"\n  [style.background-size]=\"'cover'\"\n  #adTeaser\n>\n  <sie-ui-menu-button\n    *ngIf=\"teaserData.childActions?.length\"\n    class=\"ad-teaser__menu-button\"\n    [options]=\"teaserData.childActions\"\n    (actionClicked)=\"dropdownOptionSelected($event, teaserData)\"\n    theme=\"dark\"\n    menuTheme=\"light\"\n  ></sie-ui-menu-button>\n  <header class=\"ad-teaser__header\" *ngIf=\"teaserData?.visualizationType !== 'stage-adteaser-platform-promo'\">\n    <sie-ui-tag *ngIf=\"teaserData?.visualTag\" status=\"neutral\" [croppedTop]=\"true\">{{\n      teaserData?.visualTag\n    }}</sie-ui-tag>\n  </header>\n  <section class=\"ad-teaser__content\" sieCoreTruncate [attr.data-truncate-log]=\"false\">\n    <div class=\"ad-teaser__content__text-full-height\">\n      <h2 class=\"ad-teaser__content__headline\" [attr.data-truncate-prio]=\"2\" sieCoreAddTooltip>\n        {{ teaserData?.title }}\n      </h2>\n      <h5\n        *ngIf=\"\n          teaserData?.subTitle && teaserData?.visualizationType !== 'stage-adteaser-platform-promo';\n          else copySmall\n        \"\n        class=\"ad-teaser__content__subheadline\"\n        role=\"doc-subtitle\"\n        [attr.data-truncate-prio]=\"3\"\n        sieCoreAddTooltip\n      >\n        {{ teaserData.subTitle }}\n      </h5>\n\n      <ng-template #copySmall>\n        <p class=\"ad-teaser__content__subheadline\" role=\"doc-subtitle\" [attr.data-truncate-prio]=\"3\" sieCoreAddTooltip>\n          {{ teaserData.subTitle }}\n        </p>\n      </ng-template>\n      <ul\n        sie-ui-benefits\n        *ngIf=\"teaserData?.benefits?.length > 0\"\n        [useTruncation]=\"true\"\n        [truncationPrioOffset]=\"4\"\n        [benefits]=\"teaserData?.benefits\"\n      ></ul>\n      <ng-container *ngIf=\"teaserData?.linkLabel\">\n        <sie-ui-link\n          class=\"ad-teaser__content__link\"\n          background=\"dark\"\n          [href]=\"teaserData.linkTarget\"\n          [type]=\"teaserData.linkType\"\n          [attr.data-truncate-prio]=\"1\"\n          >{{ teaserData.linkLabel }}</sie-ui-link\n        >\n      </ng-container>\n    </div>\n  </section>\n  <figure\n    class=\"ad-teaser__image-wrapper\"\n    *ngIf=\"teaserData?.visualizationType === 'stage-adteaser-platform-promo'\"\n    aria-hidden=\"true\"\n  >\n    <img src=\"{{ personImage }}\" alt=\"person-image\" />\n  </figure>\n  <footer class=\"ad-teaser__footer\">\n    <sie-ui-button-group\n      *ngIf=\"!!teaserData?.buttons?.length\"\n      [buttons]=\"teaserData.buttons\"\n      [buttonAlignmentClass]=\"buttonAlignment\"\n      [fullWidthOnViewportS]=\"\n        teaserData?.visualizationType === 'stage-adteaser-platform-promo' ? false : buttonFullWidthOnViewportS\n      \"\n      [direction]=\"teaserData.visualizationType === 'stage-adteaser-platform-promo' ? 'row' : 'column'\"\n      [wrapButtons]=\"true\"\n      (buttonClick)=\"onButtonClick($event)\"\n    >\n    </sie-ui-button-group>\n  </footer>\n</article>\n", styles: [".ad-teaser{display:flex;flex-direction:column;justify-content:space-between;width:100%;height:100%;color:#fff;background-color:#00bedc;padding:0 24px 24px;position:relative;overflow:hidden}.ad-teaser__menu-button{position:absolute;right:0;top:5px}.ad-teaser__header{height:24px;margin-bottom:32px}.ad-teaser__content{display:flex;flex-direction:column;overflow:hidden;flex:1 1 auto;height:100%;margin-bottom:24px;z-index:1}.ad-teaser__content ul{font-size:1rem;font-weight:900;line-height:1.5rem;color:#fff;fill:#fff;overflow:hidden}.ad-teaser__content__text-full-height{height:100%}.ad-teaser__content__headline{-webkit-box-orient:vertical;display:-webkit-box;overflow:hidden;text-overflow:ellipsis;margin-bottom:18px;flex:0 0 auto;width:100%}.ad-teaser__content__subheadline{-webkit-box-orient:vertical;margin-bottom:24px;display:-webkit-box;width:100%;overflow:hidden}.ad-teaser--platform-promo .ad-teaser__content__subheadline{font-size:1rem;font-weight:400;line-height:1.5rem;margin-bottom:16px}.ad-teaser__image-wrapper{position:absolute;inset:0;padding:0;margin:0}.ad-teaser__image-wrapper>img{position:absolute;left:0;bottom:0}.ad-teaser--platform-promo{padding-top:40px;padding-bottom:32px}.ad-teaser--platform-promo .ad-teaser__content__headline{margin-bottom:24px}.ad-teaser--platform-promo .ad-teaser__image-wrapper{left:unset}@media (min-width: 1024px){.ad-teaser:not(.container-layout) .ad-teaser__content__headline{margin-bottom:24px}}.ad-teaser.container-layout .ad-teaser__content__headline{margin-top:0;overflow-wrap:break-word}@container shared-container (max-width: 1023.78px){.ad-teaser.container-layout .ad-teaser__content__headline{font-size:1.25rem;line-height:1.625rem;letter-spacing:-.03125rem}}@container shared-container (min-width: 1024px){.ad-teaser.container-layout .ad-teaser__content__headline{font-size:2rem;line-height:2.75rem;letter-spacing:-.03125rem;margin-bottom:24px}}.ad-teaser.container-layout .ad-teaser__content__subheadline{font-size:1rem;line-height:1.5rem;letter-spacing:-.03125rem;font-weight:900}@container shared-container (min-width: 1024px){.ad-teaser.container-layout .ad-teaser__content__subheadline{font-weight:900;font-size:1rem;line-height:1.5rem;letter-spacing:-.03125rem}}.ad-teaser.teasers-1{width:100%;margin-right:auto;margin-left:auto;padding-right:16px;padding-left:16px}@media (min-width: 640px){.ad-teaser.teasers-1{padding-right:16px;padding-left:16px}}@media (min-width: 1024px){.ad-teaser.teasers-1{padding-right:56px;padding-left:56px}}@media (min-width: 1440px){.ad-teaser.teasers-1{padding-right:96px;padding-left:96px}}@media (min-width: 1920px){.ad-teaser.teasers-1{padding-right:96px;padding-left:96px}}.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-1 .ad-teaser__image-wrapper{right:10px;width:166px}.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-1 .ad-teaser__image-wrapper img{width:166px}@media (max-width: 1023.78px){.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-1 .ad-teaser__image-wrapper{bottom:-65px}}@media (min-width: 640px){.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-1 .ad-teaser__image-wrapper{right:-10px;width:239px}.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-1 .ad-teaser__image-wrapper img{width:239px}.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-1 .ad-teaser__image-wrapper img{top:120px}}@media (min-width: 1024px){.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-1 .ad-teaser__image-wrapper{right:8%;width:267px}.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-1 .ad-teaser__image-wrapper img{width:267px}.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-1 .ad-teaser__image-wrapper img{top:95px}}@media (min-width: 1440px){.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-1 .ad-teaser__image-wrapper{right:9%;width:342px}.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-1 .ad-teaser__image-wrapper img{width:342px}.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-1 .ad-teaser__image-wrapper img{top:50px}}@media (min-width: 640px){.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-1 .ad-teaser__content__headline{max-width:85%}}@media (min-width: 1440px){.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-1 .ad-teaser__content__headline{max-width:calc(60% - 24px)}}.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-2 .ad-teaser__image-wrapper{right:-15px;width:167px}.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-2 .ad-teaser__image-wrapper img{width:167px}.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-2 .ad-teaser__image-wrapper img{top:142px}@media (min-width: 1024px){.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-2 .ad-teaser__image-wrapper{right:-50px;width:239px}.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-2 .ad-teaser__image-wrapper img{width:239px}.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-2 .ad-teaser__image-wrapper img{top:112px}}@media (min-width: 1440px){.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-2 .ad-teaser__image-wrapper{right:0;width:267px}.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-2 .ad-teaser__image-wrapper img{width:267px}}@media (min-width: 1440px){.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-2 .ad-teaser__content__headline{max-width:85%}}@media (min-width: 1024px){.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-2 .ad-teaser__content__headline,.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-3 .ad-teaser__content__headline{font-size:1.625rem;font-weight:700;line-height:2.25rem;line-height:2.125rem;font-weight:900}}@media (min-width: 1024px){.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-3 .ad-teaser__image-wrapper{right:-15px;width:178px}.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-3 .ad-teaser__image-wrapper img{width:178px}.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-3 .ad-teaser__image-wrapper img{top:125px}}@media (min-width: 1440px){.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-3 .ad-teaser__image-wrapper{right:-20px;width:210px}.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-3 .ad-teaser__image-wrapper img{width:210px}.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-3 .ad-teaser__image-wrapper img{top:115px}}@media (min-width: 1024px) and (max-width: 1439.8px){.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-3 .ad-teaser__content__headline{font-size:1.25rem;font-weight:900;line-height:1.625rem}}.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-1 .ad-teaser__image-wrapper{right:10px;width:166px}.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-1 .ad-teaser__image-wrapper img{width:166px}@container shared-container (max-width: 1023.78px){.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-1 .ad-teaser__image-wrapper{bottom:-65px}}@container shared-container (min-width: 640px){.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-1 .ad-teaser__image-wrapper{right:-10px;width:239px}.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-1 .ad-teaser__image-wrapper img{width:239px}.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-1 .ad-teaser__image-wrapper img{top:120px}}@container shared-container (min-width: 1024px){.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-1 .ad-teaser__image-wrapper{right:8%;width:267px}.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-1 .ad-teaser__image-wrapper img{width:267px}.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-1 .ad-teaser__image-wrapper img{top:95px}}@container shared-container (min-width: 1440px){.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-1 .ad-teaser__image-wrapper{right:9%;width:342px}.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-1 .ad-teaser__image-wrapper img{width:342px}.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-1 .ad-teaser__image-wrapper img{top:50px}}@container shared-container (min-width: 640px){.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-1 .ad-teaser__content__headline{max-width:85%}}@container shared-container (min-width: 1440px){.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-1 .ad-teaser__content__headline{max-width:calc(60% - 24px)}}.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-2 .ad-teaser__image-wrapper{right:-15px;width:167px}.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-2 .ad-teaser__image-wrapper img{width:167px}.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-2 .ad-teaser__image-wrapper img{top:142px}@container shared-container (min-width: 1024px){.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-2 .ad-teaser__image-wrapper{right:-50px;width:239px}.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-2 .ad-teaser__image-wrapper img{width:239px}.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-2 .ad-teaser__image-wrapper img{top:112px}}@container shared-container (min-width: 1440px){.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-2 .ad-teaser__image-wrapper{right:0;width:267px}.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-2 .ad-teaser__image-wrapper img{width:267px}}@container shared-container (min-width: 1440px){.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-2 .ad-teaser__content__headline{max-width:85%}}@container shared-container (min-width: 1024px){.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-2 .ad-teaser__content__headline,.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-3 .ad-teaser__content__headline{font-size:1.625rem;font-weight:700;line-height:2.25rem;line-height:2.125rem;font-weight:900}}@container shared-container (min-width: 1024px){.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-3 .ad-teaser__image-wrapper{right:-15px;width:178px}.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-3 .ad-teaser__image-wrapper img{width:178px}.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-3 .ad-teaser__image-wrapper img{top:125px}}@container shared-container (min-width: 1440px){.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-3 .ad-teaser__image-wrapper{right:-20px;width:210px}.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-3 .ad-teaser__image-wrapper img{width:210px}.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-3 .ad-teaser__image-wrapper img{top:115px}}@container shared-container (min-width: 1024px) and (max-width: 1439.8px){.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-3 .ad-teaser__content__headline{font-size:1.25rem;font-weight:900;line-height:1.625rem}}.ad-teaser--platform-promo .platform-promo-indentation,.ad-teaser--platform-promo .ad-teaser__content__subheadline,.ad-teaser--platform-promo .ad-teaser__content__link{width:calc(60% - 16px)}@container shared-container (min-width: 1440px){.ad-teaser--platform-promo.container-layout .platform-promo-indentation,.ad-teaser--platform-promo.container-layout .ad-teaser__content__subheadline,.ad-teaser--platform-promo.container-layout .ad-teaser__content__link{width:calc(60% - 24px)}}@media (min-width: 1440px){.ad-teaser--platform-promo:not(.container-layout) .platform-promo-indentation,.ad-teaser--platform-promo:not(.container-layout) .ad-teaser__content__subheadline,.ad-teaser--platform-promo:not(.container-layout) .ad-teaser__content__link{width:calc(60% - 24px)}}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: UiButtonGroupComponent, selector: "sie-ui-button-group", inputs: ["buttons", "fullWidthOnViewportS", "wrapButtons", "direction", "flexDirection", "fullWidth", "buttonAlignmentClass"], outputs: ["buttonClick"] }, { kind: "component", type: UiBenefitsComponent, selector: "ul[sie-ui-benefits]", inputs: ["benefits", "useTruncation", "truncationPrioOffset", "truncationGroupName"] }, { kind: "component", type: UiTagComponent, selector: "sie-ui-tag", inputs: ["mode", "theme", "status", "tagId", "dataAttrName", "dataAttrValue", "disabled", "croppedTop", "condensed", "linkable", "removeButtonAriaLabel"], outputs: ["selected", "unselected", "removed", "clicked"] }, { kind: "directive", type: i1$1.TruncateDirective, selector: "[sieCoreTruncate]" }, { kind: "directive", type: i1$1.AddTooltipDirective, selector: "[sieCoreAddTooltip]" }, { kind: "component", type: UiLinkComponent, selector: "sie-ui-link", inputs: ["disabled", "disableVisitedStyle", "hasMarginTop", "offsetIcon", "truncate", "inLinkList", "trailingIcon", "icon", "cssClass", "href", "size", "target", "variant", "background", "type", "reference", "screenReaderText", "secondaryLabel", "download", "dataAttributes", "tooltip", "buttonType"], outputs: ["clicked"] }, { kind: "directive", type: i1$1.AttributeDirective, selector: "[sieCoreAttributes]", inputs: ["sieCoreAttributes"] }, { kind: "component", type: UiMenuButtonComponent, selector: "sie-ui-menu-button", inputs: ["menuButtonScreenReaderText", "menuTheme", "menuButtonType", "menuButtonVariant", "menuButtonThemeType", "menuButtonText", "leadingButtonIcon"], outputs: ["actionClicked"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiAdTeaserComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-ad-teaser', changeDetection: ChangeDetectionStrategy.OnPush, template: "<article\n  [sieCoreAttributes]=\"teaserData?.dataAttributes\"\n  [ngClass]=\"[\n    'ad-teaser',\n    'teasers-' + teaserCount,\n    teaserData?.visualizationType === 'stage-adteaser-platform-promo' ? 'ad-teaser--platform-promo' : '',\n    containerStyled ? 'container-layout' : ''\n  ]\"\n  [style.height]=\"height + 'px'\"\n  [style.background-image]=\"\n    teaserData?.visualizationType === 'stage-adteaser-platform-promo'\n      ? 'url(' + adTeaserBg + ')'\n      : ColorBackgroundTeaserOverlay + ', url(' + imageUrl + ')'\n  \"\n  [style.background-repeat]=\"'no-repeat'\"\n  [style.background-position]=\"'center'\"\n  [style.background-size]=\"'cover'\"\n  #adTeaser\n>\n  <sie-ui-menu-button\n    *ngIf=\"teaserData.childActions?.length\"\n    class=\"ad-teaser__menu-button\"\n    [options]=\"teaserData.childActions\"\n    (actionClicked)=\"dropdownOptionSelected($event, teaserData)\"\n    theme=\"dark\"\n    menuTheme=\"light\"\n  ></sie-ui-menu-button>\n  <header class=\"ad-teaser__header\" *ngIf=\"teaserData?.visualizationType !== 'stage-adteaser-platform-promo'\">\n    <sie-ui-tag *ngIf=\"teaserData?.visualTag\" status=\"neutral\" [croppedTop]=\"true\">{{\n      teaserData?.visualTag\n    }}</sie-ui-tag>\n  </header>\n  <section class=\"ad-teaser__content\" sieCoreTruncate [attr.data-truncate-log]=\"false\">\n    <div class=\"ad-teaser__content__text-full-height\">\n      <h2 class=\"ad-teaser__content__headline\" [attr.data-truncate-prio]=\"2\" sieCoreAddTooltip>\n        {{ teaserData?.title }}\n      </h2>\n      <h5\n        *ngIf=\"\n          teaserData?.subTitle && teaserData?.visualizationType !== 'stage-adteaser-platform-promo';\n          else copySmall\n        \"\n        class=\"ad-teaser__content__subheadline\"\n        role=\"doc-subtitle\"\n        [attr.data-truncate-prio]=\"3\"\n        sieCoreAddTooltip\n      >\n        {{ teaserData.subTitle }}\n      </h5>\n\n      <ng-template #copySmall>\n        <p class=\"ad-teaser__content__subheadline\" role=\"doc-subtitle\" [attr.data-truncate-prio]=\"3\" sieCoreAddTooltip>\n          {{ teaserData.subTitle }}\n        </p>\n      </ng-template>\n      <ul\n        sie-ui-benefits\n        *ngIf=\"teaserData?.benefits?.length > 0\"\n        [useTruncation]=\"true\"\n        [truncationPrioOffset]=\"4\"\n        [benefits]=\"teaserData?.benefits\"\n      ></ul>\n      <ng-container *ngIf=\"teaserData?.linkLabel\">\n        <sie-ui-link\n          class=\"ad-teaser__content__link\"\n          background=\"dark\"\n          [href]=\"teaserData.linkTarget\"\n          [type]=\"teaserData.linkType\"\n          [attr.data-truncate-prio]=\"1\"\n          >{{ teaserData.linkLabel }}</sie-ui-link\n        >\n      </ng-container>\n    </div>\n  </section>\n  <figure\n    class=\"ad-teaser__image-wrapper\"\n    *ngIf=\"teaserData?.visualizationType === 'stage-adteaser-platform-promo'\"\n    aria-hidden=\"true\"\n  >\n    <img src=\"{{ personImage }}\" alt=\"person-image\" />\n  </figure>\n  <footer class=\"ad-teaser__footer\">\n    <sie-ui-button-group\n      *ngIf=\"!!teaserData?.buttons?.length\"\n      [buttons]=\"teaserData.buttons\"\n      [buttonAlignmentClass]=\"buttonAlignment\"\n      [fullWidthOnViewportS]=\"\n        teaserData?.visualizationType === 'stage-adteaser-platform-promo' ? false : buttonFullWidthOnViewportS\n      \"\n      [direction]=\"teaserData.visualizationType === 'stage-adteaser-platform-promo' ? 'row' : 'column'\"\n      [wrapButtons]=\"true\"\n      (buttonClick)=\"onButtonClick($event)\"\n    >\n    </sie-ui-button-group>\n  </footer>\n</article>\n", styles: [".ad-teaser{display:flex;flex-direction:column;justify-content:space-between;width:100%;height:100%;color:#fff;background-color:#00bedc;padding:0 24px 24px;position:relative;overflow:hidden}.ad-teaser__menu-button{position:absolute;right:0;top:5px}.ad-teaser__header{height:24px;margin-bottom:32px}.ad-teaser__content{display:flex;flex-direction:column;overflow:hidden;flex:1 1 auto;height:100%;margin-bottom:24px;z-index:1}.ad-teaser__content ul{font-size:1rem;font-weight:900;line-height:1.5rem;color:#fff;fill:#fff;overflow:hidden}.ad-teaser__content__text-full-height{height:100%}.ad-teaser__content__headline{-webkit-box-orient:vertical;display:-webkit-box;overflow:hidden;text-overflow:ellipsis;margin-bottom:18px;flex:0 0 auto;width:100%}.ad-teaser__content__subheadline{-webkit-box-orient:vertical;margin-bottom:24px;display:-webkit-box;width:100%;overflow:hidden}.ad-teaser--platform-promo .ad-teaser__content__subheadline{font-size:1rem;font-weight:400;line-height:1.5rem;margin-bottom:16px}.ad-teaser__image-wrapper{position:absolute;inset:0;padding:0;margin:0}.ad-teaser__image-wrapper>img{position:absolute;left:0;bottom:0}.ad-teaser--platform-promo{padding-top:40px;padding-bottom:32px}.ad-teaser--platform-promo .ad-teaser__content__headline{margin-bottom:24px}.ad-teaser--platform-promo .ad-teaser__image-wrapper{left:unset}@media (min-width: 1024px){.ad-teaser:not(.container-layout) .ad-teaser__content__headline{margin-bottom:24px}}.ad-teaser.container-layout .ad-teaser__content__headline{margin-top:0;overflow-wrap:break-word}@container shared-container (max-width: 1023.78px){.ad-teaser.container-layout .ad-teaser__content__headline{font-size:1.25rem;line-height:1.625rem;letter-spacing:-.03125rem}}@container shared-container (min-width: 1024px){.ad-teaser.container-layout .ad-teaser__content__headline{font-size:2rem;line-height:2.75rem;letter-spacing:-.03125rem;margin-bottom:24px}}.ad-teaser.container-layout .ad-teaser__content__subheadline{font-size:1rem;line-height:1.5rem;letter-spacing:-.03125rem;font-weight:900}@container shared-container (min-width: 1024px){.ad-teaser.container-layout .ad-teaser__content__subheadline{font-weight:900;font-size:1rem;line-height:1.5rem;letter-spacing:-.03125rem}}.ad-teaser.teasers-1{width:100%;margin-right:auto;margin-left:auto;padding-right:16px;padding-left:16px}@media (min-width: 640px){.ad-teaser.teasers-1{padding-right:16px;padding-left:16px}}@media (min-width: 1024px){.ad-teaser.teasers-1{padding-right:56px;padding-left:56px}}@media (min-width: 1440px){.ad-teaser.teasers-1{padding-right:96px;padding-left:96px}}@media (min-width: 1920px){.ad-teaser.teasers-1{padding-right:96px;padding-left:96px}}.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-1 .ad-teaser__image-wrapper{right:10px;width:166px}.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-1 .ad-teaser__image-wrapper img{width:166px}@media (max-width: 1023.78px){.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-1 .ad-teaser__image-wrapper{bottom:-65px}}@media (min-width: 640px){.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-1 .ad-teaser__image-wrapper{right:-10px;width:239px}.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-1 .ad-teaser__image-wrapper img{width:239px}.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-1 .ad-teaser__image-wrapper img{top:120px}}@media (min-width: 1024px){.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-1 .ad-teaser__image-wrapper{right:8%;width:267px}.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-1 .ad-teaser__image-wrapper img{width:267px}.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-1 .ad-teaser__image-wrapper img{top:95px}}@media (min-width: 1440px){.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-1 .ad-teaser__image-wrapper{right:9%;width:342px}.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-1 .ad-teaser__image-wrapper img{width:342px}.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-1 .ad-teaser__image-wrapper img{top:50px}}@media (min-width: 640px){.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-1 .ad-teaser__content__headline{max-width:85%}}@media (min-width: 1440px){.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-1 .ad-teaser__content__headline{max-width:calc(60% - 24px)}}.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-2 .ad-teaser__image-wrapper{right:-15px;width:167px}.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-2 .ad-teaser__image-wrapper img{width:167px}.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-2 .ad-teaser__image-wrapper img{top:142px}@media (min-width: 1024px){.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-2 .ad-teaser__image-wrapper{right:-50px;width:239px}.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-2 .ad-teaser__image-wrapper img{width:239px}.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-2 .ad-teaser__image-wrapper img{top:112px}}@media (min-width: 1440px){.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-2 .ad-teaser__image-wrapper{right:0;width:267px}.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-2 .ad-teaser__image-wrapper img{width:267px}}@media (min-width: 1440px){.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-2 .ad-teaser__content__headline{max-width:85%}}@media (min-width: 1024px){.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-2 .ad-teaser__content__headline,.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-3 .ad-teaser__content__headline{font-size:1.625rem;font-weight:700;line-height:2.25rem;line-height:2.125rem;font-weight:900}}@media (min-width: 1024px){.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-3 .ad-teaser__image-wrapper{right:-15px;width:178px}.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-3 .ad-teaser__image-wrapper img{width:178px}.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-3 .ad-teaser__image-wrapper img{top:125px}}@media (min-width: 1440px){.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-3 .ad-teaser__image-wrapper{right:-20px;width:210px}.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-3 .ad-teaser__image-wrapper img{width:210px}.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-3 .ad-teaser__image-wrapper img{top:115px}}@media (min-width: 1024px) and (max-width: 1439.8px){.ad-teaser.ad-teaser--platform-promo:not(.container-layout).teasers-3 .ad-teaser__content__headline{font-size:1.25rem;font-weight:900;line-height:1.625rem}}.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-1 .ad-teaser__image-wrapper{right:10px;width:166px}.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-1 .ad-teaser__image-wrapper img{width:166px}@container shared-container (max-width: 1023.78px){.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-1 .ad-teaser__image-wrapper{bottom:-65px}}@container shared-container (min-width: 640px){.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-1 .ad-teaser__image-wrapper{right:-10px;width:239px}.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-1 .ad-teaser__image-wrapper img{width:239px}.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-1 .ad-teaser__image-wrapper img{top:120px}}@container shared-container (min-width: 1024px){.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-1 .ad-teaser__image-wrapper{right:8%;width:267px}.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-1 .ad-teaser__image-wrapper img{width:267px}.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-1 .ad-teaser__image-wrapper img{top:95px}}@container shared-container (min-width: 1440px){.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-1 .ad-teaser__image-wrapper{right:9%;width:342px}.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-1 .ad-teaser__image-wrapper img{width:342px}.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-1 .ad-teaser__image-wrapper img{top:50px}}@container shared-container (min-width: 640px){.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-1 .ad-teaser__content__headline{max-width:85%}}@container shared-container (min-width: 1440px){.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-1 .ad-teaser__content__headline{max-width:calc(60% - 24px)}}.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-2 .ad-teaser__image-wrapper{right:-15px;width:167px}.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-2 .ad-teaser__image-wrapper img{width:167px}.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-2 .ad-teaser__image-wrapper img{top:142px}@container shared-container (min-width: 1024px){.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-2 .ad-teaser__image-wrapper{right:-50px;width:239px}.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-2 .ad-teaser__image-wrapper img{width:239px}.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-2 .ad-teaser__image-wrapper img{top:112px}}@container shared-container (min-width: 1440px){.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-2 .ad-teaser__image-wrapper{right:0;width:267px}.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-2 .ad-teaser__image-wrapper img{width:267px}}@container shared-container (min-width: 1440px){.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-2 .ad-teaser__content__headline{max-width:85%}}@container shared-container (min-width: 1024px){.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-2 .ad-teaser__content__headline,.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-3 .ad-teaser__content__headline{font-size:1.625rem;font-weight:700;line-height:2.25rem;line-height:2.125rem;font-weight:900}}@container shared-container (min-width: 1024px){.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-3 .ad-teaser__image-wrapper{right:-15px;width:178px}.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-3 .ad-teaser__image-wrapper img{width:178px}.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-3 .ad-teaser__image-wrapper img{top:125px}}@container shared-container (min-width: 1440px){.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-3 .ad-teaser__image-wrapper{right:-20px;width:210px}.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-3 .ad-teaser__image-wrapper img{width:210px}.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-3 .ad-teaser__image-wrapper img{top:115px}}@container shared-container (min-width: 1024px) and (max-width: 1439.8px){.ad-teaser.ad-teaser--platform-promo.container-layout.teasers-3 .ad-teaser__content__headline{font-size:1.25rem;font-weight:900;line-height:1.625rem}}.ad-teaser--platform-promo .platform-promo-indentation,.ad-teaser--platform-promo .ad-teaser__content__subheadline,.ad-teaser--platform-promo .ad-teaser__content__link{width:calc(60% - 16px)}@container shared-container (min-width: 1440px){.ad-teaser--platform-promo.container-layout .platform-promo-indentation,.ad-teaser--platform-promo.container-layout .ad-teaser__content__subheadline,.ad-teaser--platform-promo.container-layout .ad-teaser__content__link{width:calc(60% - 24px)}}@media (min-width: 1440px){.ad-teaser--platform-promo:not(.container-layout) .platform-promo-indentation,.ad-teaser--platform-promo:not(.container-layout) .ad-teaser__content__subheadline,.ad-teaser--platform-promo:not(.container-layout) .ad-teaser__content__link{width:calc(60% - 24px)}}\n"] }]
        }], ctorParameters: function () { return [{ type: i1$1.LayoutService }, { type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: Document, decorators: [{
                    type: Inject,
                    args: [DOCUMENT]
                }] }]; }, propDecorators: { badge: [{
                type: ViewChild,
                args: ['adTeaser']
            }], teaserCount: [{
                type: Input
            }], height: [{
                type: Input
            }], childActionClicked: [{
                type: Output
            }] } });

class UiTeaserComponent extends UiBaseTeaserDirective {
    constructor(layoutService, cdr) {
        super(layoutService, cdr);
        this.layoutService = layoutService;
        this.cdr = cdr;
        this.ColorBackgroundTeaserOverlay = ComponentTeaserOverlay;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTeaserComponent, deps: [{ token: i1$1.LayoutService }, { token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiTeaserComponent, selector: "sie-ui-teaser", usesInheritance: true, ngImport: i0, template: "<article\n  [sieCoreAttributes]=\"teaserData?.dataAttributes\"\n  class=\"stage-teaser\"\n  [ngClass]=\"containerStyled ? 'container-layout' : ''\"\n  [style.background-image]=\"ColorBackgroundTeaserOverlay + ', url(' + imageUrl + ')'\"\n  [style.background-repeat]=\"'no-repeat'\"\n  [style.background-position]=\"'center'\"\n  sieCoreTruncate\n>\n  <div [ngClass]=\"!containerStyled ? 'container' : 'wrapper'\">\n    <div class=\"headlines-container\">\n      <h1 class=\"stage-teaser__headline\" [attr.data-truncate-prio]=\"1\">\n        {{ teaserData?.title }}\n      </h1>\n      <h4 class=\"stage-teaser__subheadline\" role=\"doc-subtitle\" [attr.data-truncate-prio]=\"2\">\n        {{ teaserData?.subTitle }}\n      </h4>\n    </div>\n    <footer class=\"stage-teaser__footer\">\n      <sie-ui-button-group\n        class=\"stage-teaser__button-group\"\n        [ngClass]=\"buttonFullWidthOnViewportS && containerStyled ? 'full-width' : ''\"\n        [buttons]=\"teaserData.buttons\"\n        [attr.data-truncate-always-visible]=\"true\"\n        [buttonAlignmentClass]=\"buttonAlignment\"\n        [fullWidthOnViewportS]=\"buttonFullWidthOnViewportS && smallViewport\"\n        (buttonClick)=\"onButtonClick($event)\"\n      ></sie-ui-button-group>\n    </footer>\n  </div>\n</article>\n", styles: [":host{width:100%}.stage-teaser{background-size:cover;background-color:#00bedc;color:#fff;padding:20px 0 88px;height:400px;overflow:hidden}@media (min-width: 640px){.stage-teaser:not(.container-layout){padding-bottom:42px}.stage-teaser:not(.container-layout) .headlines-container{max-width:75%}.stage-teaser:not(.container-layout) .stage-teaser__button-group{margin-top:40px}}@media (min-width: 1024px){.stage-teaser:not(.container-layout){height:440px}.stage-teaser:not(.container-layout) .headlines-container{max-width:66.667%}.stage-teaser:not(.container-layout) .stage-teaser__headline{margin-bottom:16px}}.stage-teaser .container,.stage-teaser .wrapper{display:flex;flex-direction:column;justify-content:center;align-items:flex-start;height:100%}.stage-teaser .headlines-container{width:100%;overflow:hidden}.stage-teaser__headline{margin-top:0;margin-bottom:8px;flex:0 0 auto;width:100%;font-weight:400}.stage-teaser__subheadline{overflow:hidden;-webkit-box-orient:vertical;display:-webkit-box;margin:0 auto}.stage-teaser__button-group{margin-top:32px;display:block}@container carousel-container (max-width: 639.78px){.stage-teaser__button-group.full-width{width:100%}}.stage-teaser__footer{width:100%}@container carousel-container (min-width: 640px){.stage-teaser.container-layout{padding-bottom:42px}.stage-teaser.container-layout .headlines-container{max-width:75%}.stage-teaser.container-layout .stage-teaser__button-group{margin-top:40px}}@container carousel-container (min-width: 1024px){.stage-teaser.container-layout{height:440px}.stage-teaser.container-layout .headlines-container{max-width:66.667%}.stage-teaser.container-layout .stage-teaser__headline{margin-bottom:16px}}.stage-teaser.container-layout .stage-teaser__headline{margin-top:0;overflow-wrap:break-word}@container carousel-container (max-width: 1023.78px){.stage-teaser.container-layout .stage-teaser__headline{font-size:1.625rem;line-height:2.125rem;letter-spacing:-.03125rem}}@container carousel-container (min-width: 1024px){.stage-teaser.container-layout .stage-teaser__headline{font-size:3rem;line-height:3.75rem;letter-spacing:-.03125rem}}.stage-teaser.container-layout .stage-teaser__subheadline{font-size:1rem;line-height:1.5rem;letter-spacing:-.03125rem;font-weight:900}@container carousel-container (min-width: 1024px){.stage-teaser.container-layout .stage-teaser__subheadline{font-weight:900;font-size:1.25rem;line-height:1.625rem;letter-spacing:-.03125rem}}.stage-teaser.container-layout .wrapper{width:100%;margin-right:auto;margin-left:auto;padding:0}@container carousel-container (max-width: 1023.78px){.stage-teaser.container-layout .wrapper{padding:0 16px}}@container carousel-container (min-width: 1024px) and (max-width: 1439.8px){.stage-teaser.container-layout .wrapper{padding:0 56px}}@container carousel-container (min-width: 1440px){.stage-teaser.container-layout .wrapper{padding:0 96px}}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "component", type: UiButtonGroupComponent, selector: "sie-ui-button-group", inputs: ["buttons", "fullWidthOnViewportS", "wrapButtons", "direction", "flexDirection", "fullWidth", "buttonAlignmentClass"], outputs: ["buttonClick"] }, { kind: "directive", type: i1$1.TruncateDirective, selector: "[sieCoreTruncate]" }, { kind: "directive", type: i1$1.AttributeDirective, selector: "[sieCoreAttributes]", inputs: ["sieCoreAttributes"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTeaserComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-teaser', changeDetection: ChangeDetectionStrategy.OnPush, template: "<article\n  [sieCoreAttributes]=\"teaserData?.dataAttributes\"\n  class=\"stage-teaser\"\n  [ngClass]=\"containerStyled ? 'container-layout' : ''\"\n  [style.background-image]=\"ColorBackgroundTeaserOverlay + ', url(' + imageUrl + ')'\"\n  [style.background-repeat]=\"'no-repeat'\"\n  [style.background-position]=\"'center'\"\n  sieCoreTruncate\n>\n  <div [ngClass]=\"!containerStyled ? 'container' : 'wrapper'\">\n    <div class=\"headlines-container\">\n      <h1 class=\"stage-teaser__headline\" [attr.data-truncate-prio]=\"1\">\n        {{ teaserData?.title }}\n      </h1>\n      <h4 class=\"stage-teaser__subheadline\" role=\"doc-subtitle\" [attr.data-truncate-prio]=\"2\">\n        {{ teaserData?.subTitle }}\n      </h4>\n    </div>\n    <footer class=\"stage-teaser__footer\">\n      <sie-ui-button-group\n        class=\"stage-teaser__button-group\"\n        [ngClass]=\"buttonFullWidthOnViewportS && containerStyled ? 'full-width' : ''\"\n        [buttons]=\"teaserData.buttons\"\n        [attr.data-truncate-always-visible]=\"true\"\n        [buttonAlignmentClass]=\"buttonAlignment\"\n        [fullWidthOnViewportS]=\"buttonFullWidthOnViewportS && smallViewport\"\n        (buttonClick)=\"onButtonClick($event)\"\n      ></sie-ui-button-group>\n    </footer>\n  </div>\n</article>\n", styles: [":host{width:100%}.stage-teaser{background-size:cover;background-color:#00bedc;color:#fff;padding:20px 0 88px;height:400px;overflow:hidden}@media (min-width: 640px){.stage-teaser:not(.container-layout){padding-bottom:42px}.stage-teaser:not(.container-layout) .headlines-container{max-width:75%}.stage-teaser:not(.container-layout) .stage-teaser__button-group{margin-top:40px}}@media (min-width: 1024px){.stage-teaser:not(.container-layout){height:440px}.stage-teaser:not(.container-layout) .headlines-container{max-width:66.667%}.stage-teaser:not(.container-layout) .stage-teaser__headline{margin-bottom:16px}}.stage-teaser .container,.stage-teaser .wrapper{display:flex;flex-direction:column;justify-content:center;align-items:flex-start;height:100%}.stage-teaser .headlines-container{width:100%;overflow:hidden}.stage-teaser__headline{margin-top:0;margin-bottom:8px;flex:0 0 auto;width:100%;font-weight:400}.stage-teaser__subheadline{overflow:hidden;-webkit-box-orient:vertical;display:-webkit-box;margin:0 auto}.stage-teaser__button-group{margin-top:32px;display:block}@container carousel-container (max-width: 639.78px){.stage-teaser__button-group.full-width{width:100%}}.stage-teaser__footer{width:100%}@container carousel-container (min-width: 640px){.stage-teaser.container-layout{padding-bottom:42px}.stage-teaser.container-layout .headlines-container{max-width:75%}.stage-teaser.container-layout .stage-teaser__button-group{margin-top:40px}}@container carousel-container (min-width: 1024px){.stage-teaser.container-layout{height:440px}.stage-teaser.container-layout .headlines-container{max-width:66.667%}.stage-teaser.container-layout .stage-teaser__headline{margin-bottom:16px}}.stage-teaser.container-layout .stage-teaser__headline{margin-top:0;overflow-wrap:break-word}@container carousel-container (max-width: 1023.78px){.stage-teaser.container-layout .stage-teaser__headline{font-size:1.625rem;line-height:2.125rem;letter-spacing:-.03125rem}}@container carousel-container (min-width: 1024px){.stage-teaser.container-layout .stage-teaser__headline{font-size:3rem;line-height:3.75rem;letter-spacing:-.03125rem}}.stage-teaser.container-layout .stage-teaser__subheadline{font-size:1rem;line-height:1.5rem;letter-spacing:-.03125rem;font-weight:900}@container carousel-container (min-width: 1024px){.stage-teaser.container-layout .stage-teaser__subheadline{font-weight:900;font-size:1.25rem;line-height:1.625rem;letter-spacing:-.03125rem}}.stage-teaser.container-layout .wrapper{width:100%;margin-right:auto;margin-left:auto;padding:0}@container carousel-container (max-width: 1023.78px){.stage-teaser.container-layout .wrapper{padding:0 16px}}@container carousel-container (min-width: 1024px) and (max-width: 1439.8px){.stage-teaser.container-layout .wrapper{padding:0 56px}}@container carousel-container (min-width: 1440px){.stage-teaser.container-layout .wrapper{padding:0 96px}}\n"] }]
        }], ctorParameters: function () { return [{ type: i1$1.LayoutService }, { type: i0.ChangeDetectorRef }]; } });

class UiBenefitsModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiBenefitsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiBenefitsModule, declarations: [UiBenefitsComponent], imports: [CommonModule, SieIconsModule, AddTooltipModule], exports: [UiBenefitsComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiBenefitsModule, imports: [CommonModule, SieIconsModule, AddTooltipModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiBenefitsModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiBenefitsComponent],
                    imports: [CommonModule, SieIconsModule, AddTooltipModule],
                    exports: [UiBenefitsComponent]
                }]
        }] });

/**
 * # Teaser Module
 * - {@link UiTeaserComponent}
 * - {@link UiAdTeaserComponent}
 *
 * ## Module peer dependencies
 * - {@link SieIconsModule}: the package is optional since the teaser data could contain buttons that have an icon.
 */
class UiTeaserModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTeaserModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiTeaserModule, declarations: [UiAdTeaserComponent, UiTeaserComponent], imports: [CommonModule,
            UiButtonGroupModule,
            UiBenefitsModule,
            UiTagModule,
            TruncateModule,
            AddTooltipModule,
            UiLinkModule,
            AttributeModule,
            UiMenuButtonModule], exports: [UiAdTeaserComponent, UiTeaserComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTeaserModule, imports: [CommonModule,
            UiButtonGroupModule,
            UiBenefitsModule,
            UiTagModule,
            TruncateModule,
            AddTooltipModule,
            UiLinkModule,
            AttributeModule,
            UiMenuButtonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTeaserModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiAdTeaserComponent, UiTeaserComponent],
                    imports: [
                        CommonModule,
                        UiButtonGroupModule,
                        UiBenefitsModule,
                        UiTagModule,
                        TruncateModule,
                        AddTooltipModule,
                        UiLinkModule,
                        AttributeModule,
                        UiMenuButtonModule
                    ],
                    exports: [UiAdTeaserComponent, UiTeaserComponent]
                }]
        }] });

/**
 * # Action Bar Component
 *
 * Action Bar facilitates on-demand, clear and transparent access to section- or page-specific actions.
 *
 * ## Component variations
 *
 * - page mode
 * - bulk action mode
 *
 * ## Content
 *
 * The Action Bar component does not accept any content.
 *
 * ## Code example
 * @example ```html
 * <sie-ui-action-bar
 *  mode="page"
 *  [buttons]="buttons"
 *  theme="light"
 *  (stickyModeChange)="onActionBarStickyModeChange($event)"
 *  [toggleStickyMode]="true"
 * ></sie-ui-action-bar>
 * ```
 *
 * ```ts
 * const buttons = [
 *   {
 *     id: 'Apply',
 *     buttonType: 'button',
 *     variant: 'secondary',
 *     background: 'dark',
 *     label: 'Apply'
 *   },
 *   {
 *     id: 'Cancel',
 *     buttonType: 'button',
 *     variant: 'tertiary',
 *     background: 'dark',
 *     label: 'Cancel'
 *   }
 * ];
 * ```
 */
class UiActionBarComponent {
    /**
     * @param value {@link ThemeVariant Theme} of action bar
     * @default 'dark'
     */
    set theme(value) {
        this._theme = value;
        if (this.buttons && this.buttons.length) {
            const buttons = [...this.buttons];
            buttons.forEach(button => (button.background = value));
            this.buttons = buttons;
        }
    }
    get theme() {
        return this._theme;
    }
    /**
     * @param value defines if the component use the full width when the viewport is L (Large)
     * @default false
     */
    set isFullWidthOnViewportL(value) {
        this._isFullWidthOnViewportL = coerceBooleanProperty(value);
    }
    get isFullWidthOnViewportL() {
        return this._isFullWidthOnViewportL;
    }
    /**
     * @param selectedItemsLength defines the count of selected items
     */
    set selectedItemsLength(selectedItemsLength) {
        this._selectedItemsLength = coerceNumberProperty(selectedItemsLength);
    }
    /**
     * @param actions defines array of {@link ActionsModel actions} which will be applied
     */
    set dropdownOptions(actions) {
        this._dropdownOptions = actions;
        this.selectedAction = null;
        if (!this.dropdownPlaceholder || this._dropdownOptions?.length === 1) {
            this.selectedAction = actions[0];
        }
    }
    get dropdownOptions() {
        return this._dropdownOptions;
    }
    /**
     * @param value defines whether the action bar is in sticky mode or not
     * @default true
     */
    set stickyMode(value) {
        this._stickyMode = coerceBooleanProperty(value);
    }
    get stickyMode() {
        return this._stickyMode;
    }
    /**
     * @param value flag so that the z-index is increased and the dropdown overlay is above other elements
     * @default false
     */
    set dropdownOverlayOnTop(value) {
        this._dropdownOverlayOnTop = coerceBooleanProperty(value);
    }
    get dropdownOverlayOnTop() {
        return this._dropdownOverlayOnTop;
    }
    constructor(iconReg, layoutService, host, cdr) {
        this.iconReg = iconReg;
        this.layoutService = layoutService;
        this.host = host;
        this.cdr = cdr;
        /**
         * Defines {@link UiActionBarMode mode} of action bar
         * @default 'bulkAction'
         */
        this.mode = 'bulkAction';
        /**
         * Defines the text on the dropdown before the action is selected
         * @default null
         */
        this.dropdownPlaceholder = null;
        /**
         * Defines if sticky mode of the action bar should be toggled
         * @default true
         */
        this.toggleStickyMode = true;
        /**
         * Triggered when button is clicked
         * * bulk mode: value of the selected action
         * * page mode: id of the clicked button (save or cancel)
         */
        this.appliedAction = new EventEmitter();
        /**
         * Triggered when the action bar becomes or stops being sticky (when scrolling)
         */
        this.stickyModeChange = new EventEmitter();
        /**
         * Triggered when save button is clicked (page mode)
         */
        this.save = new EventEmitter();
        /**
         * Triggered when cancel button is clicked (page mode)
         */
        this.cancel = new EventEmitter();
        /**
         * Triggered when infoButtonLabel button is clicked (page mode)
         */
        this.infoButtonClicked = new EventEmitter();
        /**
         * Triggered on dropdown changed event
         */
        this.dropdownChanged = new EventEmitter();
        /** @ignore */
        this.showRequirementsLabel = false;
        this._theme = 'dark';
        this._stickyMode = true;
        this._isFullWidthOnViewportL = false;
        /** @ignore */
        this._dropdownOverlayOnTop = false;
        iconReg.register(SieIcon.Information);
    }
    /** @ignore */
    ngOnChanges(changes) {
        if (changes.selectedItemsLength || changes.dropdownOptions) {
            this.isActionValid();
        }
    }
    /** @ignore */
    intersected(inView) {
        this._stickyMode = !inView;
        this.cdr.markForCheck();
        this.stickyModeChange.emit(this._stickyMode);
    }
    /** @ignore */
    onSelectionChange(actionValue) {
        this.selectedAction = this.findDropdownActionByValue(actionValue);
        this.isActionValid();
        this.dropdownChanged.emit(this.selectedAction);
    }
    /** @ignore */
    emitAction(event) {
        if (this.mode === 'bulkAction') {
            if (this.mode === 'bulkAction' && event.button.id === 'Apply') {
                this.appliedAction.emit(this.selectedAction.value);
            }
            else {
                this.appliedAction.emit(event.button.id);
            }
        }
        if (this.mode === 'page') {
            if (event.button.id === 'save') {
                this.save.emit();
            }
            else {
                this.cancel.emit();
            }
        }
    }
    onInfoButtonClick() {
        this.infoButtonClicked.next(this.selectedAction?.value);
    }
    outOfSelectedActionRange() {
        return (this._selectedItemsLength < this.selectedAction.minValue ||
            this._selectedItemsLength > this.selectedAction.maxValue);
    }
    isActionValid() {
        if (this.mode === 'bulkAction' && this.selectedAction) {
            if (this.outOfSelectedActionRange()) {
                this.setRestrictionState();
            }
            else {
                this.setApprovedState();
            }
        }
        else {
            this.setRestrictionState();
        }
        this.cdr.markForCheck();
    }
    setRestrictionState() {
        this.showRequirementsLabel = !!this.selectedAction?.requirementsLabel;
        if (this.buttons) {
            const buttons = [...this.buttons];
            if (buttons.length) {
                buttons[0].disabled = true;
            }
            this.buttons = buttons;
        }
    }
    setApprovedState() {
        this.showRequirementsLabel = false;
        const buttons = [...this.buttons];
        delete buttons[0]?.disabled;
        this.buttons = buttons;
        this.buttonGroupComponent?.updateView();
    }
    findDropdownActionByValue(value) {
        return this._dropdownOptions.find(action => action.value === value);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiActionBarComponent, deps: [{ token: i1.SieIconRegistryService }, { token: i1$1.LayoutService }, { token: i0.ElementRef }, { token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiActionBarComponent, selector: "sie-ui-action-bar", inputs: { mode: "mode", dropdownPlaceholder: "dropdownPlaceholder", dropdownScreenReaderText: "dropdownScreenReaderText", actionsLabel: "actionsLabel", buttons: "buttons", toggleStickyMode: "toggleStickyMode", theme: "theme", isFullWidthOnViewportL: "isFullWidthOnViewportL", selectedItemsLength: "selectedItemsLength", infoButtonLabel: "infoButtonLabel", infoButtonTooltipLabel: "infoButtonTooltipLabel", dropdownOptions: "dropdownOptions", stickyMode: "stickyMode", dropdownOverlayOnTop: "dropdownOverlayOnTop", _dropdownOverlayOnTop: "_dropdownOverlayOnTop" }, outputs: { appliedAction: "appliedAction", stickyModeChange: "stickyModeChange", save: "save", cancel: "cancel", infoButtonClicked: "infoButtonClicked", dropdownChanged: "dropdownChanged" }, viewQueries: [{ propertyName: "buttonGroupComponent", first: true, predicate: ["buttonGroup"], descendants: true }], usesOnChanges: true, ngImport: i0, template: "<div class=\"action-bar__page-wrapper\">\n  <div class=\"action-bar__sentinel\" sieCoreInView (inView)=\"intersected($event)\"></div>\n\n  <div\n    class=\"action-bar\"\n    [ngClass]=\"{\n      hide: stickyMode,\n      'full-width': isFullWidthOnViewportL,\n      'light-theme': theme === 'light' && !stickyMode\n    }\"\n  >\n    <ng-container *ngTemplateOutlet=\"actionBarContent\"></ng-container>\n  </div>\n</div>\n\n<div class=\"action-bar sticky\" *ngIf=\"stickyMode && toggleStickyMode\">\n  <ng-container *ngTemplateOutlet=\"actionBarContent\"></ng-container>\n</div>\n\n<ng-template #actionBarContent>\n  <div\n    class=\"action-bar__container container\"\n    [class.light-theme-paddings]=\"mode === 'page' && !stickyMode && theme === 'light'\"\n  >\n    <div\n      class=\"action-bar__actions-container\"\n      *ngIf=\"mode === 'bulkAction'\"\n      [ngClass]=\"{ 'align-center': !showRequirementsLabel }\"\n    >\n      <div class=\"action-bar__actions-wrapper\" [ngClass]=\"{ 'align-center': !showRequirementsLabel }\">\n        <span class=\"action-bar__actions-text\"> {{ actionsLabel }}</span>\n        <ng-container *ngIf=\"dropdownOptions?.length > 1; else singleOption\">\n          <sie-ui-dropdown\n            class=\"action-bar__actions-dropdown\"\n            [options]=\"dropdownOptions\"\n            [selectedValue]=\"selectedAction?.value\"\n            [placeholder]=\"dropdownPlaceholder\"\n            [overlayOnTop]=\"dropdownOverlayOnTop\"\n            id=\"actions\"\n            [theme]=\"'dark'\"\n            (selectionChanged)=\"onSelectionChange($event)\"\n            [screenReaderText]=\"dropdownScreenReaderText\"\n          ></sie-ui-dropdown>\n        </ng-container>\n        <ng-template #singleOption>\n          <span>{{ selectedAction?.label }}</span>\n        </ng-template>\n      </div>\n\n      <div class=\"action-bar__actions-information\">\n        <div class=\"action-bar__actions-information__requirements\" *ngIf=\"showRequirementsLabel\">\n          <sie-icon class=\"action-bar__actions-information__icon\" [name]=\"iconReg.sieIcon.Information\"></sie-icon>\n          <span class=\"action-bar__actions-information__text\">{{ selectedAction?.requirementsLabel }} </span>\n        </div>\n        <div\n          [ngClass]=\"{ 'add-padding-top': !showRequirementsLabel }\"\n          class=\"action-bar__actions-information__link-wrapper\"\n        >\n          <sie-ui-link\n            class=\"action-bar__actions-information__link\"\n            [ngClass]=\"{ 'align-with-label': showRequirementsLabel }\"\n            [type]=\"'button'\"\n            [tooltip]=\"infoButtonTooltipLabel\"\n            [variant]=\"'inline'\"\n            [background]=\"'dark'\"\n            (clicked)=\"onInfoButtonClick()\"\n          >{{ infoButtonLabel }}</sie-ui-link\n          >\n        </div>\n      </div>\n    </div>\n    <sie-ui-button-group\n      [buttons]=\"buttons\"\n      [fullWidthOnViewportS]=\"true\"\n      [buttonAlignmentClass]=\"mode === 'bulkAction' ? 'right' : 'left'\"\n      (buttonClick)=\"emitAction($event)\"\n      class=\"action-bar__buttons\"\n      #buttonGroup\n    ></sie-ui-button-group>\n  </div>\n</ng-template>\n", styles: [":host{--viewport-width: calc(100vw - var(--scrollbar-width));display:flex;width:100%;min-height:220px;margin-top:16px}@media (min-width: 640px){:host{min-height:80px}}.action-bar{width:var(--viewport-width);margin-left:calc((100% - var(--viewport-width)) / 2);margin-right:calc((100% - var(--viewport-width)) / 2);background-color:#000028;color:#fff;min-height:220px;border:1px solid #9999a9;border-style:solid none}@media (min-width: 640px){.action-bar{min-height:80px}}@media (min-width: 1024px){.action-bar{width:100%;margin:0;border-style:solid solid}}.action-bar.light-theme{background-color:transparent;border:none}.action-bar.hide{visibility:hidden}.action-bar.full-width{border-style:solid none}@media (min-width: 1024px){.action-bar.full-width{width:var(--viewport-width);margin-left:calc((100% - var(--viewport-width)) / 2);margin-right:calc((100% - var(--viewport-width)) / 2)}}.action-bar.sticky{position:fixed;z-index:1000;bottom:0;left:0;right:0;border:none;border-top:1px solid #9999a9;margin:0;width:100%}.action-bar__container{flex:0 0 auto;width:100%;padding:16px 16px 8px;margin:0 auto;display:flex;flex-direction:column;justify-content:flex-start;flex-wrap:wrap;align-items:flex-start}@media (min-width: 640px){.action-bar__container{padding:16px;flex-direction:row;justify-content:space-between}}@media (min-width: 1024px){.action-bar__container{padding:20px 60px 20px 20px;justify-self:flex-end;align-items:center}}@media (min-width: 1440px){.action-bar__container{padding:16px}}.action-bar__container.light-theme-paddings{padding-top:0}@media (min-width: 1024px){.action-bar__container.light-theme-paddings{padding:0 60px 20px 0}}@media (min-width: 1440px){.action-bar__container.light-theme-paddings{padding:0 16px 16px 0}}@media (min-width: 1024px){.action-bar.full-width .action-bar__container,.action-bar.sticky .action-bar__container{padding:22px 53px}}@media (min-width: 1440px){.action-bar.full-width .action-bar__container,.action-bar.sticky .action-bar__container{padding:22px 93px}}.action-bar__page-wrapper{position:relative;width:100%;height:100%}.action-bar__sentinel{position:absolute;width:100%;min-height:80px;height:100%}.action-bar__actions-container{width:100%;display:flex;padding:3px;flex-direction:column;flex:1;overflow:hidden}@media (min-width: 640px){.action-bar__actions-container{flex:2;height:100%;justify-content:center;gap:3px 40px}}@media (min-width: 1024px){.action-bar__actions-container{justify-content:flex-start;flex-direction:row;flex-wrap:wrap}.action-bar__actions-container.align-center{align-items:center}}.action-bar__actions-wrapper{display:flex;align-items:flex-start;flex-direction:column}@media (min-width: 640px){.action-bar__actions-wrapper{flex-direction:row;min-height:48px}.action-bar__actions-wrapper.align-center{align-items:center}}.action-bar__actions-text{font-size:1rem;font-weight:400;line-height:1.5rem;margin:0 8px 8px 0}@media (min-width: 640px){.action-bar__actions-text{margin:0 8px 0 0}}.action-bar__actions-information{min-width:0}.action-bar__actions-information__requirements{margin-top:16px;display:flex;align-items:center}@media (min-width: 640px){.action-bar__actions-information__requirements{margin:0}}.action-bar__actions-information__icon{color:#fff;fill:#fff;margin-right:10px}.action-bar__actions-information__text{font-size:.875rem;font-weight:400;line-height:1.25rem;color:#ccccd4}.action-bar__actions-information__link-wrapper{width:100%;margin:0}@media (max-width: 639.78px){.action-bar__actions-information__link-wrapper.add-padding-top{padding-top:18px}}.action-bar__actions-information__link.align-with-label{margin-left:33px;width:95%}.action-bar__buttons{margin-top:25px;flex:1;align-self:flex-start}@media (min-width: 640px){.action-bar__buttons{margin:0}}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "component", type: UiButtonGroupComponent, selector: "sie-ui-button-group", inputs: ["buttons", "fullWidthOnViewportS", "wrapButtons", "direction", "flexDirection", "fullWidth", "buttonAlignmentClass"], outputs: ["buttonClick"] }, { kind: "component", type: UiDropdownComponent, selector: "sie-ui-dropdown", inputs: ["type", "condensed", "options", "selectedValue", "required", "id", "name", "label", "placeholder", "errorMessage", "customClass", "readonly", "invalid", "hint", "marginBottomOnInvalidState"], outputs: ["selectionChanged"] }, { kind: "directive", type: i1$1.InViewDirective, selector: "[sieCoreInView]", inputs: ["sieCoreInView", "rootMargin"], outputs: ["inView"] }, { kind: "component", type: UiLinkComponent, selector: "sie-ui-link", inputs: ["disabled", "disableVisitedStyle", "hasMarginTop", "offsetIcon", "truncate", "inLinkList", "trailingIcon", "icon", "cssClass", "href", "size", "target", "variant", "background", "type", "reference", "screenReaderText", "secondaryLabel", "download", "dataAttributes", "tooltip", "buttonType"], outputs: ["clicked"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiActionBarComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-action-bar', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"action-bar__page-wrapper\">\n  <div class=\"action-bar__sentinel\" sieCoreInView (inView)=\"intersected($event)\"></div>\n\n  <div\n    class=\"action-bar\"\n    [ngClass]=\"{\n      hide: stickyMode,\n      'full-width': isFullWidthOnViewportL,\n      'light-theme': theme === 'light' && !stickyMode\n    }\"\n  >\n    <ng-container *ngTemplateOutlet=\"actionBarContent\"></ng-container>\n  </div>\n</div>\n\n<div class=\"action-bar sticky\" *ngIf=\"stickyMode && toggleStickyMode\">\n  <ng-container *ngTemplateOutlet=\"actionBarContent\"></ng-container>\n</div>\n\n<ng-template #actionBarContent>\n  <div\n    class=\"action-bar__container container\"\n    [class.light-theme-paddings]=\"mode === 'page' && !stickyMode && theme === 'light'\"\n  >\n    <div\n      class=\"action-bar__actions-container\"\n      *ngIf=\"mode === 'bulkAction'\"\n      [ngClass]=\"{ 'align-center': !showRequirementsLabel }\"\n    >\n      <div class=\"action-bar__actions-wrapper\" [ngClass]=\"{ 'align-center': !showRequirementsLabel }\">\n        <span class=\"action-bar__actions-text\"> {{ actionsLabel }}</span>\n        <ng-container *ngIf=\"dropdownOptions?.length > 1; else singleOption\">\n          <sie-ui-dropdown\n            class=\"action-bar__actions-dropdown\"\n            [options]=\"dropdownOptions\"\n            [selectedValue]=\"selectedAction?.value\"\n            [placeholder]=\"dropdownPlaceholder\"\n            [overlayOnTop]=\"dropdownOverlayOnTop\"\n            id=\"actions\"\n            [theme]=\"'dark'\"\n            (selectionChanged)=\"onSelectionChange($event)\"\n            [screenReaderText]=\"dropdownScreenReaderText\"\n          ></sie-ui-dropdown>\n        </ng-container>\n        <ng-template #singleOption>\n          <span>{{ selectedAction?.label }}</span>\n        </ng-template>\n      </div>\n\n      <div class=\"action-bar__actions-information\">\n        <div class=\"action-bar__actions-information__requirements\" *ngIf=\"showRequirementsLabel\">\n          <sie-icon class=\"action-bar__actions-information__icon\" [name]=\"iconReg.sieIcon.Information\"></sie-icon>\n          <span class=\"action-bar__actions-information__text\">{{ selectedAction?.requirementsLabel }} </span>\n        </div>\n        <div\n          [ngClass]=\"{ 'add-padding-top': !showRequirementsLabel }\"\n          class=\"action-bar__actions-information__link-wrapper\"\n        >\n          <sie-ui-link\n            class=\"action-bar__actions-information__link\"\n            [ngClass]=\"{ 'align-with-label': showRequirementsLabel }\"\n            [type]=\"'button'\"\n            [tooltip]=\"infoButtonTooltipLabel\"\n            [variant]=\"'inline'\"\n            [background]=\"'dark'\"\n            (clicked)=\"onInfoButtonClick()\"\n          >{{ infoButtonLabel }}</sie-ui-link\n          >\n        </div>\n      </div>\n    </div>\n    <sie-ui-button-group\n      [buttons]=\"buttons\"\n      [fullWidthOnViewportS]=\"true\"\n      [buttonAlignmentClass]=\"mode === 'bulkAction' ? 'right' : 'left'\"\n      (buttonClick)=\"emitAction($event)\"\n      class=\"action-bar__buttons\"\n      #buttonGroup\n    ></sie-ui-button-group>\n  </div>\n</ng-template>\n", styles: [":host{--viewport-width: calc(100vw - var(--scrollbar-width));display:flex;width:100%;min-height:220px;margin-top:16px}@media (min-width: 640px){:host{min-height:80px}}.action-bar{width:var(--viewport-width);margin-left:calc((100% - var(--viewport-width)) / 2);margin-right:calc((100% - var(--viewport-width)) / 2);background-color:#000028;color:#fff;min-height:220px;border:1px solid #9999a9;border-style:solid none}@media (min-width: 640px){.action-bar{min-height:80px}}@media (min-width: 1024px){.action-bar{width:100%;margin:0;border-style:solid solid}}.action-bar.light-theme{background-color:transparent;border:none}.action-bar.hide{visibility:hidden}.action-bar.full-width{border-style:solid none}@media (min-width: 1024px){.action-bar.full-width{width:var(--viewport-width);margin-left:calc((100% - var(--viewport-width)) / 2);margin-right:calc((100% - var(--viewport-width)) / 2)}}.action-bar.sticky{position:fixed;z-index:1000;bottom:0;left:0;right:0;border:none;border-top:1px solid #9999a9;margin:0;width:100%}.action-bar__container{flex:0 0 auto;width:100%;padding:16px 16px 8px;margin:0 auto;display:flex;flex-direction:column;justify-content:flex-start;flex-wrap:wrap;align-items:flex-start}@media (min-width: 640px){.action-bar__container{padding:16px;flex-direction:row;justify-content:space-between}}@media (min-width: 1024px){.action-bar__container{padding:20px 60px 20px 20px;justify-self:flex-end;align-items:center}}@media (min-width: 1440px){.action-bar__container{padding:16px}}.action-bar__container.light-theme-paddings{padding-top:0}@media (min-width: 1024px){.action-bar__container.light-theme-paddings{padding:0 60px 20px 0}}@media (min-width: 1440px){.action-bar__container.light-theme-paddings{padding:0 16px 16px 0}}@media (min-width: 1024px){.action-bar.full-width .action-bar__container,.action-bar.sticky .action-bar__container{padding:22px 53px}}@media (min-width: 1440px){.action-bar.full-width .action-bar__container,.action-bar.sticky .action-bar__container{padding:22px 93px}}.action-bar__page-wrapper{position:relative;width:100%;height:100%}.action-bar__sentinel{position:absolute;width:100%;min-height:80px;height:100%}.action-bar__actions-container{width:100%;display:flex;padding:3px;flex-direction:column;flex:1;overflow:hidden}@media (min-width: 640px){.action-bar__actions-container{flex:2;height:100%;justify-content:center;gap:3px 40px}}@media (min-width: 1024px){.action-bar__actions-container{justify-content:flex-start;flex-direction:row;flex-wrap:wrap}.action-bar__actions-container.align-center{align-items:center}}.action-bar__actions-wrapper{display:flex;align-items:flex-start;flex-direction:column}@media (min-width: 640px){.action-bar__actions-wrapper{flex-direction:row;min-height:48px}.action-bar__actions-wrapper.align-center{align-items:center}}.action-bar__actions-text{font-size:1rem;font-weight:400;line-height:1.5rem;margin:0 8px 8px 0}@media (min-width: 640px){.action-bar__actions-text{margin:0 8px 0 0}}.action-bar__actions-information{min-width:0}.action-bar__actions-information__requirements{margin-top:16px;display:flex;align-items:center}@media (min-width: 640px){.action-bar__actions-information__requirements{margin:0}}.action-bar__actions-information__icon{color:#fff;fill:#fff;margin-right:10px}.action-bar__actions-information__text{font-size:.875rem;font-weight:400;line-height:1.25rem;color:#ccccd4}.action-bar__actions-information__link-wrapper{width:100%;margin:0}@media (max-width: 639.78px){.action-bar__actions-information__link-wrapper.add-padding-top{padding-top:18px}}.action-bar__actions-information__link.align-with-label{margin-left:33px;width:95%}.action-bar__buttons{margin-top:25px;flex:1;align-self:flex-start}@media (min-width: 640px){.action-bar__buttons{margin:0}}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }, { type: i1$1.LayoutService }, { type: i0.ElementRef }, { type: i0.ChangeDetectorRef }]; }, propDecorators: { buttonGroupComponent: [{
                type: ViewChild,
                args: ['buttonGroup']
            }], mode: [{
                type: Input
            }], dropdownPlaceholder: [{
                type: Input
            }], dropdownScreenReaderText: [{
                type: Input
            }], actionsLabel: [{
                type: Input
            }], buttons: [{
                type: Input
            }], toggleStickyMode: [{
                type: Input
            }], theme: [{
                type: Input
            }], isFullWidthOnViewportL: [{
                type: Input
            }], selectedItemsLength: [{
                type: Input
            }], infoButtonLabel: [{
                type: Input
            }], infoButtonTooltipLabel: [{
                type: Input
            }], dropdownOptions: [{
                type: Input
            }], stickyMode: [{
                type: Input
            }], dropdownOverlayOnTop: [{
                type: Input
            }], appliedAction: [{
                type: Output
            }], stickyModeChange: [{
                type: Output
            }], save: [{
                type: Output
            }], cancel: [{
                type: Output
            }], infoButtonClicked: [{
                type: Output
            }], dropdownChanged: [{
                type: Output
            }], _dropdownOverlayOnTop: [{
                type: Input
            }] } });

/**
 * # Action Bar Module
 * - {@link UiActionBarComponent}
 *
 * ## Module peer dependencies
 * - {@link SieIconsModule}
 */
class UiActionBarModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiActionBarModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiActionBarModule, declarations: [UiActionBarComponent], imports: [CommonModule, SieIconsModule, UiButtonGroupModule, UiDropdownModule, InViewModule, UiLinkModule], exports: [UiActionBarComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiActionBarModule, imports: [CommonModule, SieIconsModule, UiButtonGroupModule, UiDropdownModule, InViewModule, UiLinkModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiActionBarModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiActionBarComponent],
                    imports: [CommonModule, SieIconsModule, UiButtonGroupModule, UiDropdownModule, InViewModule, UiLinkModule],
                    exports: [UiActionBarComponent]
                }]
        }] });

const TRUNCATION_PLACEHOLDER_ID = 'TRUNCATION_PLACEHOLDER';
const TRUNCATION_PLACEHOLDER_WIDTH = 46;
/**
 * # Breadcrumb Component
 *
 * Breadcrumb allows user to gain orientation about on which page they are currently and the path of the page. It also
 * allows them to navigate to a specific page mentioned in the breadcrumb trail. Breadcrumb should be used in the main
 * menu as well as on the actual pages.
 *
 * ## Content
 *
 * The breadcrumb component does not accept any content.
 *
 * ## Component variations
 * - Only one breadcrumb is available
 * - All breadcrumbs available (incl. root element)
 * - All breadcrumbs available (excl. root element)
 *
 * ## Code example
 * @example ```html
 * <sie-ui-breadcrumb
 *   [pageBreadcrumbs]="true"
 *   [breadcrumbs]="breadcrumbs"
 *   [variant]="'onlyOneLevel'"
 *   (clicked)="onBreadcrumbClicked($event)"
 *   [screenReaderHomeButton]="'Home'"
 * ></sie-ui-breadcrumb>
 * ```
 *
 * Breadcrumb data example:
 * ```js
 * const breadcrumbs = [
 *   {
 *     parentId: 'noParent',
 *     id: 'root',
 *     title: '',
 *     hasChildren: true
 *   },
 *   {
 *     parentId: 'root',
 *     id: 'services',
 *     title: 'Services',
 *     hasChildren: true
 *   },
 *   {
 *     parentId: 'services',
 *     id: '2300',
 *     title: 'Service Partner Management',
 *     hasChildren: true
 *   },
 *   {
 *     parentId: '2300',
 *     id: '5460',
 *     title: 'Approved Partner Industry Service Program',
 *     hasChildren: false,
 *     href: 'https://www.siemens.com'
 *   }
 * ];
 * ```
 */
class UiBreadcrumbComponent {
    /**
     * @param value Defines whether on-page component version should be used.
     * @default false
     */
    set pageBreadcrumbs(value) {
        this._pageBreadcrumbs = coerceBooleanProperty(value);
    }
    get pageBreadcrumbs() {
        return this._pageBreadcrumbs;
    }
    /**
     * @param breadcrumbs Defines {@link UiBreadcrumbModel content} of the breadcrumbs component.
     * @default []
     */
    set breadcrumbs(breadcrumbs) {
        this._breadcrumbs = breadcrumbs;
        this.rerender();
    }
    /**
     * @param variant Defines which {@link UiBreadcrumbVariants variant} should be used
     * @default "onlyOneLevel"
     */
    set variant(variant) {
        this._variant = variant;
        this.rerender();
    }
    constructor(iconReg, cd, layoutService) {
        this.iconReg = iconReg;
        this.cd = cd;
        this.layoutService = layoutService;
        /**
         * Defines text used by screen readers for breadcrumbs title.
         * @default ''
         */
        this.screenReaderMenuTitle = '';
        /**
         * Defines text used by screen readers for breadcrumbs back button.
         * @default ''
         */
        this.screenReaderBackButton = '';
        /**
         * Defines text used by screen readers for breadcrumbs home button.
         * @default ''
         */
        this.screenReaderHomeButton = '';
        /**
         * {@link UiBreadcrumbModel Event} triggered when the breadcrumb element is clicked.
         */
        this.clicked = new Subject();
        /** @ignore */
        this.truncationPlaceholderId = TRUNCATION_PLACEHOLDER_ID;
        /** @ignore */
        this.truncationPlaceholderWidth = TRUNCATION_PLACEHOLDER_WIDTH;
        /** @ignore */
        this.rootItem = null;
        /** @ignore */
        this.activeItem = null;
        /** @ignore */
        this.levels = [];
        /** @ignore */
        this.breadcrumbWidthOnViewportS = 0;
        /** @ignore */
        this._variant = 'onlyOneLevel';
        this._pageBreadcrumbs = false;
        this._breadcrumbs = [];
        this.iconReg.register(SieIcon.ArrowToTop);
        this.iconReg.register(SieIcon.HomeSmall);
        this.iconReg.register(SieIcon.ArrowRight);
        this.iconReg.register(SieIcon.LevelUp);
    }
    /** @ignore internal use only */
    rerender() {
        if (this._breadcrumbs.length > 0) {
            const rootIndex = this.setRootItem();
            this.setActiveItem();
            this.populateLevels(rootIndex);
        }
        else {
            this.rootItem = null;
            this.activeItem = null;
            this.levels = [];
        }
        this.cd.detectChanges();
        this.checkWidthOfBreadCrumbs();
        this.cd.detectChanges();
    }
    /** @ignore */
    onClick(clickedItem, event) {
        event?.preventDefault();
        this.clicked.next(deepCopy(clickedItem));
    }
    checkWidthOfBreadCrumbs() {
        let itemWidths = [];
        let totalWidth = 0;
        if (this.breadCrumbItems) {
            const ulWidth = this.olElement.nativeElement.getBoundingClientRect().width - 3; // padding
            itemWidths = this.breadCrumbItems.toArray().map(item => {
                const width = item.nativeElement.getBoundingClientRect().width;
                const roundedWith = Math.round(width * 100) / 100;
                totalWidth += roundedWith;
                return roundedWith;
            });
            // remove item in the middle
            this.removeItemsTillItFits(itemWidths, ulWidth, totalWidth);
            // max-width for viewportS
            this.breadcrumbWidthOnViewportS = ulWidth - itemWidths[0];
        }
    }
    removeItemsTillItFits(itemWidths, ulWidth, totalWidth) {
        if (totalWidth > ulWidth) {
            // rootItem, activeItem are always visible
            if (this.rootItem) {
                itemWidths.splice(0, 1);
            }
            if (this.activeItem) {
                itemWidths.splice(itemWidths.length - 1, 1);
            }
            // add with of truncation placeholder
            totalWidth += this.truncationPlaceholderWidth;
            let smallestIndex = -1;
            while (totalWidth > ulWidth) {
                // find next index to remove
                let indexToRemove;
                if (itemWidths.length % 2 === 0) {
                    indexToRemove = itemWidths.length / 2 - 1;
                }
                else {
                    indexToRemove = Math.floor(itemWidths.length / 2);
                }
                totalWidth -= itemWidths[indexToRemove];
                itemWidths.splice(indexToRemove, 1);
                this.levels.splice(indexToRemove, 1);
                if (smallestIndex < 0 || smallestIndex > indexToRemove) {
                    smallestIndex = indexToRemove;
                }
            }
            this.levels.splice(smallestIndex, 0, {
                id: this.truncationPlaceholderId,
                title: null,
                hasChildren: false,
                parentId: null
            });
        }
    }
    setRootItem() {
        let rootIndex;
        const lastLevel = this._breadcrumbs[this._breadcrumbs.length - 1];
        if (this._variant === 'onlyOneLevel' || this._variant === 'allWithRoot') {
            rootIndex = 0;
        }
        else {
            rootIndex = 1;
        }
        // last item is always the active item
        if (rootIndex >= 0 && rootIndex < this._breadcrumbs.length - 1) {
            this.rootItem = this._breadcrumbs[rootIndex];
        }
        else {
            this.rootItem = null;
        }
        // we don't show a root [root -> home] if home is selected because home is on root level (length has to > 2)
        // we don't show a root if on-page breadcrumb is used in viewport S
        if ((!lastLevel.hasChildren && this._breadcrumbs.length <= 2) ||
            (this.pageBreadcrumbs && this.layoutService.isViewport('S'))) {
            this.rootItem = null;
            rootIndex = 0;
        }
        return rootIndex;
    }
    setActiveItem() {
        const lastLevel = this._breadcrumbs[this._breadcrumbs.length - 1];
        if (this._variant === 'onlyOneLevel') {
            this.activeItem = null;
            if (this._breadcrumbs.length === 2 ||
                (!this.pageBreadcrumbs && !lastLevel.hasChildren && this._breadcrumbs.length === 3)) {
                this.activeItem = this._breadcrumbs[1];
            }
        }
        else {
            this.activeItem = this._breadcrumbs[this._breadcrumbs.length - 1];
        }
    }
    populateLevels(rootIndex) {
        this.levels = [];
        if (this._variant === 'onlyOneLevel') {
            if (this.activeItem === null && this._breadcrumbs.length > 2) {
                const lastLevel = this._breadcrumbs[this._breadcrumbs.length - 1];
                if (lastLevel.hasChildren || this.pageBreadcrumbs) {
                    this.levels.push(this._breadcrumbs[this._breadcrumbs.length - 2]);
                }
                else {
                    this.levels.push(this._breadcrumbs[this._breadcrumbs.length - 3]);
                }
            }
        }
        else {
            for (let i = rootIndex + 1; i < this._breadcrumbs.length - 1; i++) {
                this.levels.push(this._breadcrumbs[i]);
            }
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiBreadcrumbComponent, deps: [{ token: i1.SieIconRegistryService }, { token: i0.ChangeDetectorRef }, { token: i1$1.LayoutService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiBreadcrumbComponent, selector: "sie-ui-breadcrumb", inputs: { screenReaderMenuTitle: "screenReaderMenuTitle", screenReaderBackButton: "screenReaderBackButton", screenReaderHomeButton: "screenReaderHomeButton", pageBreadcrumbs: "pageBreadcrumbs", breadcrumbs: "breadcrumbs", variant: "variant" }, outputs: { clicked: "clicked" }, host: { properties: { "class.on-page-breadcrumbs": "this.screenReaderMenuTitle" } }, viewQueries: [{ propertyName: "olElement", first: true, predicate: ["olElement"], descendants: true }, { propertyName: "breadCrumbItems", predicate: ["breadCrumbItem"], descendants: true }], ngImport: i0, template: "<nav [attr.aria-label]=\"screenReaderMenuTitle\">\n  <ol #olElement [ngClass]=\"{ 'page-breadcrumb': pageBreadcrumbs }\">\n    <li *ngIf=\"rootItem\" #breadCrumbItem>\n      <ng-container *ngIf=\"!pageBreadcrumbs; else breadcrumbWithLinks\">\n        <button type=\"button\" class=\"btn-root\" (click)=\"onClick(rootItem)\">\n          <sie-icon class=\"btn-root-icon navigation\" [name]=\"iconReg.sieIcon.ArrowToTop\"></sie-icon>\n          <span class=\"visually-hidden\">{{ screenReaderBackButton }}</span>\n        </button>\n        <span class=\"spacer\"></span>\n      </ng-container>\n      <ng-template #breadcrumbWithLinks>\n        <a [attr.href]=\"rootItem.href\" class=\"btn-root\" (click)=\"onClick(rootItem, $event)\">\n          <sie-icon class=\"btn-root-icon on-page\" [name]=\"iconReg.sieIcon.HomeSmall\"></sie-icon>\n          <span class=\"visually-hidden\">{{ screenReaderHomeButton }}</span>\n        </a>\n        <span class=\"next-child\">\n          <sie-icon [name]=\"iconReg.sieIcon.ArrowRight\"></sie-icon>\n        </span>\n      </ng-template>\n    </li>\n\n    <li *ngFor=\"let breadcrumb of levels\" #breadCrumbItem>\n      <span *ngIf=\"breadcrumb.id === truncationPlaceholderId; else breadcrumbBtn\" class=\"truncation-placeholder\"\n        >...</span\n      >\n      <ng-template #breadcrumbBtnContent>\n        <span class=\"breadcrumb-button-text\" [sieCoreAttributes]=\"breadcrumb.dataAttributes\">{{\n          breadcrumb.title\n        }}</span>\n        <span *ngIf=\"_variant === 'onlyOneLevel'\" class=\"breadcrumb-button-level-up\">\n          <sie-icon\n            [name]=\"iconReg.sieIcon.LevelUp\"\n            [inheritSize]=\"true\"\n            [ngClass]=\"{ 'page-breadcrumb': pageBreadcrumbs }\"\n            class=\"breadcrumb-button__icon\"\n            aria-hidden=\"true\"\n          ></sie-icon>\n        </span>\n      </ng-template>\n\n      <ng-template #breadcrumbBtn>\n        <button\n          *ngIf=\"!pageBreadcrumbs; else breadcrumbWithLinks\"\n          type=\"button\"\n          class=\"breadcrumb-button\"\n          role=\"link\"\n          (click)=\"onClick(breadcrumb)\"\n          sieCoreAddTooltip\n        >\n          <ng-template [ngTemplateOutlet]=\"breadcrumbBtnContent\"></ng-template>\n        </button>\n        <ng-template #breadcrumbWithLinks>\n          <a\n            [attr.href]=\"breadcrumb.href\"\n            class=\"breadcrumb-button\"\n            [ngClass]=\"{ disabled: !breadcrumb.href }\"\n            sieCoreAddTooltip\n            (click)=\"onClick(breadcrumb, $event)\"\n          >\n            <ng-template [ngTemplateOutlet]=\"breadcrumbBtnContent\"></ng-template>\n          </a>\n        </ng-template>\n      </ng-template>\n      <span *ngIf=\"_variant !== 'onlyOneLevel'\" class=\"next-child\">\n        <sie-icon [name]=\"iconReg.sieIcon.ArrowRight\" aria-hidden=\"true\"></sie-icon>\n      </span>\n    </li>\n    <li *ngIf=\"activeItem\">\n      <button\n        *ngIf=\"!pageBreadcrumbs; else breadcrumbWithLinks\"\n        #breadCrumbItem\n        type=\"button\"\n        class=\"active\"\n        title=\"{{ activeItem.title }}\"\n        aria-current=\"step\"\n      >\n        <span class=\"breadcrumb-button-text\" [sieCoreAttributes]=\"activeItem.dataAttributes\">{{\n          activeItem.title\n        }}</span>\n      </button>\n      <ng-template #breadcrumbWithLinks>\n        <a\n          #breadCrumbItem\n          [attr.href]=\"activeItem.href\"\n          class=\"active\"\n          title=\"{{ activeItem.title }}\"\n          aria-current=\"step\"\n          (click)=\"onClick(activeItem, $event)\"\n        >\n          <span class=\"breadcrumb-button-text\">{{ activeItem.title }}</span>\n        </a>\n      </ng-template>\n    </li>\n  </ol>\n</nav>\n", styles: ["button,a{outline:none;outline-offset:0}@media (pointer: fine){button,a{position:relative}button:focus,a:focus{outline:1px solid #1491eb;outline-offset:2px}button:focus:not(:focus-visible),a:focus:not(:focus-visible){outline:0}button:focus-visible,a:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}:host{font-size:.875rem;font-weight:400;line-height:1.25rem;color:#4c4c68;fill:#4c4c68}ol{height:21px;margin:auto;padding:0 5px 0 0;white-space:nowrap;list-style-type:none;overflow:hidden;display:flex;align-items:center}@media (min-width: 640px){ol{padding:0 0 5px}}@media (min-width: 1024px){ol{height:31px;margin:-5px 0 -5px -5px}}li{display:flex;align-items:center}@media (min-width: 1024px){li:first-of-type{margin-left:5px}}button,a{white-space:nowrap;overflow:hidden;text-overflow:ellipsis;max-width:calc(100vw - 35px);height:20px;padding:0;background:none;border:none;outline:none;cursor:pointer;color:#4c4c68}@media (min-width: 640px){button,a{max-width:200px}}button:hover,a:hover{color:#000028;fill:#000028}button:hover .breadcrumb-button__icon,a:hover .breadcrumb-button__icon{width:16px;height:16px;display:flex;align-items:center;fill:currentColor;color:inherit}button:hover .breadcrumb-button__icon svg,a:hover .breadcrumb-button__icon svg{fill:currentColor;width:inherit;height:inherit}button:hover .breadcrumb-button__icon svg g,a:hover .breadcrumb-button__icon svg g{fill:currentColor;width:inherit;height:inherit}button:hover .breadcrumb-button__icon svg text,a:hover .breadcrumb-button__icon svg text{font-family:Siemens Sans,sans-serif}.breadcrumb-button-level-up{flex:0 0 auto;display:flex;margin:0 0 0 17px;padding:0}.breadcrumb-button-level-up sie-icon{width:16px;height:16px;display:flex;align-items:center;fill:currentColor;color:#4c4c68}.breadcrumb-button-level-up sie-icon svg{fill:currentColor;width:inherit;height:inherit}.breadcrumb-button-level-up sie-icon svg g{fill:currentColor;width:inherit;height:inherit}.breadcrumb-button-level-up sie-icon svg text{font-family:Siemens Sans,sans-serif}.next-child{margin:1px 6px 0}.next-child sie-icon{width:20px;height:20px;display:flex;align-items:center;fill:currentColor;color:#4c4c68}.next-child sie-icon svg{fill:currentColor;width:inherit;height:inherit}.next-child sie-icon svg g{fill:currentColor;width:inherit;height:inherit}.next-child sie-icon svg text{font-family:Siemens Sans,sans-serif}.btn-root{display:flex;align-items:center}.btn-root .btn-root-icon{color:#4c4c68}.btn-root .btn-root-icon:hover{color:#000028}.btn-root .btn-root-icon.navigation{width:20px;height:20px;display:flex;align-items:center;fill:currentColor}.btn-root .btn-root-icon.navigation svg{fill:currentColor;width:inherit;height:inherit}.btn-root .btn-root-icon.navigation svg g{fill:currentColor;width:inherit;height:inherit}.btn-root .btn-root-icon.navigation svg text{font-family:Siemens Sans,sans-serif}.btn-root .btn-root-icon.navigation svg{transform:rotate(270deg)}.btn-root .btn-root-icon.on-page{width:14px;height:14px;display:flex;align-items:center;fill:currentColor}.btn-root .btn-root-icon.on-page svg{fill:currentColor;width:inherit;height:inherit}.btn-root .btn-root-icon.on-page svg g{fill:currentColor;width:inherit;height:inherit}.btn-root .btn-root-icon.on-page svg text{font-family:Siemens Sans,sans-serif}.spacer{background-color:#4c4c68;width:1px;height:10px;margin:0 16px 0 11px}.truncation-placeholder{margin:1px 0 0}.breadcrumb-button{align-items:center;white-space:nowrap;overflow:hidden}@supports (display: grid){.breadcrumb-button{display:flex}}.breadcrumb-button-text{white-space:nowrap;overflow:hidden;text-overflow:ellipsis;flex:1}.active,.disabled{white-space:nowrap;overflow:hidden;text-overflow:ellipsis;max-width:200px;cursor:default}.active:hover,.disabled:hover{color:#4c4c68}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "directive", type: i1$1.AddTooltipDirective, selector: "[sieCoreAddTooltip]" }, { kind: "directive", type: i1$1.AttributeDirective, selector: "[sieCoreAttributes]", inputs: ["sieCoreAttributes"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiBreadcrumbComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-breadcrumb', changeDetection: ChangeDetectionStrategy.OnPush, template: "<nav [attr.aria-label]=\"screenReaderMenuTitle\">\n  <ol #olElement [ngClass]=\"{ 'page-breadcrumb': pageBreadcrumbs }\">\n    <li *ngIf=\"rootItem\" #breadCrumbItem>\n      <ng-container *ngIf=\"!pageBreadcrumbs; else breadcrumbWithLinks\">\n        <button type=\"button\" class=\"btn-root\" (click)=\"onClick(rootItem)\">\n          <sie-icon class=\"btn-root-icon navigation\" [name]=\"iconReg.sieIcon.ArrowToTop\"></sie-icon>\n          <span class=\"visually-hidden\">{{ screenReaderBackButton }}</span>\n        </button>\n        <span class=\"spacer\"></span>\n      </ng-container>\n      <ng-template #breadcrumbWithLinks>\n        <a [attr.href]=\"rootItem.href\" class=\"btn-root\" (click)=\"onClick(rootItem, $event)\">\n          <sie-icon class=\"btn-root-icon on-page\" [name]=\"iconReg.sieIcon.HomeSmall\"></sie-icon>\n          <span class=\"visually-hidden\">{{ screenReaderHomeButton }}</span>\n        </a>\n        <span class=\"next-child\">\n          <sie-icon [name]=\"iconReg.sieIcon.ArrowRight\"></sie-icon>\n        </span>\n      </ng-template>\n    </li>\n\n    <li *ngFor=\"let breadcrumb of levels\" #breadCrumbItem>\n      <span *ngIf=\"breadcrumb.id === truncationPlaceholderId; else breadcrumbBtn\" class=\"truncation-placeholder\"\n        >...</span\n      >\n      <ng-template #breadcrumbBtnContent>\n        <span class=\"breadcrumb-button-text\" [sieCoreAttributes]=\"breadcrumb.dataAttributes\">{{\n          breadcrumb.title\n        }}</span>\n        <span *ngIf=\"_variant === 'onlyOneLevel'\" class=\"breadcrumb-button-level-up\">\n          <sie-icon\n            [name]=\"iconReg.sieIcon.LevelUp\"\n            [inheritSize]=\"true\"\n            [ngClass]=\"{ 'page-breadcrumb': pageBreadcrumbs }\"\n            class=\"breadcrumb-button__icon\"\n            aria-hidden=\"true\"\n          ></sie-icon>\n        </span>\n      </ng-template>\n\n      <ng-template #breadcrumbBtn>\n        <button\n          *ngIf=\"!pageBreadcrumbs; else breadcrumbWithLinks\"\n          type=\"button\"\n          class=\"breadcrumb-button\"\n          role=\"link\"\n          (click)=\"onClick(breadcrumb)\"\n          sieCoreAddTooltip\n        >\n          <ng-template [ngTemplateOutlet]=\"breadcrumbBtnContent\"></ng-template>\n        </button>\n        <ng-template #breadcrumbWithLinks>\n          <a\n            [attr.href]=\"breadcrumb.href\"\n            class=\"breadcrumb-button\"\n            [ngClass]=\"{ disabled: !breadcrumb.href }\"\n            sieCoreAddTooltip\n            (click)=\"onClick(breadcrumb, $event)\"\n          >\n            <ng-template [ngTemplateOutlet]=\"breadcrumbBtnContent\"></ng-template>\n          </a>\n        </ng-template>\n      </ng-template>\n      <span *ngIf=\"_variant !== 'onlyOneLevel'\" class=\"next-child\">\n        <sie-icon [name]=\"iconReg.sieIcon.ArrowRight\" aria-hidden=\"true\"></sie-icon>\n      </span>\n    </li>\n    <li *ngIf=\"activeItem\">\n      <button\n        *ngIf=\"!pageBreadcrumbs; else breadcrumbWithLinks\"\n        #breadCrumbItem\n        type=\"button\"\n        class=\"active\"\n        title=\"{{ activeItem.title }}\"\n        aria-current=\"step\"\n      >\n        <span class=\"breadcrumb-button-text\" [sieCoreAttributes]=\"activeItem.dataAttributes\">{{\n          activeItem.title\n        }}</span>\n      </button>\n      <ng-template #breadcrumbWithLinks>\n        <a\n          #breadCrumbItem\n          [attr.href]=\"activeItem.href\"\n          class=\"active\"\n          title=\"{{ activeItem.title }}\"\n          aria-current=\"step\"\n          (click)=\"onClick(activeItem, $event)\"\n        >\n          <span class=\"breadcrumb-button-text\">{{ activeItem.title }}</span>\n        </a>\n      </ng-template>\n    </li>\n  </ol>\n</nav>\n", styles: ["button,a{outline:none;outline-offset:0}@media (pointer: fine){button,a{position:relative}button:focus,a:focus{outline:1px solid #1491eb;outline-offset:2px}button:focus:not(:focus-visible),a:focus:not(:focus-visible){outline:0}button:focus-visible,a:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}:host{font-size:.875rem;font-weight:400;line-height:1.25rem;color:#4c4c68;fill:#4c4c68}ol{height:21px;margin:auto;padding:0 5px 0 0;white-space:nowrap;list-style-type:none;overflow:hidden;display:flex;align-items:center}@media (min-width: 640px){ol{padding:0 0 5px}}@media (min-width: 1024px){ol{height:31px;margin:-5px 0 -5px -5px}}li{display:flex;align-items:center}@media (min-width: 1024px){li:first-of-type{margin-left:5px}}button,a{white-space:nowrap;overflow:hidden;text-overflow:ellipsis;max-width:calc(100vw - 35px);height:20px;padding:0;background:none;border:none;outline:none;cursor:pointer;color:#4c4c68}@media (min-width: 640px){button,a{max-width:200px}}button:hover,a:hover{color:#000028;fill:#000028}button:hover .breadcrumb-button__icon,a:hover .breadcrumb-button__icon{width:16px;height:16px;display:flex;align-items:center;fill:currentColor;color:inherit}button:hover .breadcrumb-button__icon svg,a:hover .breadcrumb-button__icon svg{fill:currentColor;width:inherit;height:inherit}button:hover .breadcrumb-button__icon svg g,a:hover .breadcrumb-button__icon svg g{fill:currentColor;width:inherit;height:inherit}button:hover .breadcrumb-button__icon svg text,a:hover .breadcrumb-button__icon svg text{font-family:Siemens Sans,sans-serif}.breadcrumb-button-level-up{flex:0 0 auto;display:flex;margin:0 0 0 17px;padding:0}.breadcrumb-button-level-up sie-icon{width:16px;height:16px;display:flex;align-items:center;fill:currentColor;color:#4c4c68}.breadcrumb-button-level-up sie-icon svg{fill:currentColor;width:inherit;height:inherit}.breadcrumb-button-level-up sie-icon svg g{fill:currentColor;width:inherit;height:inherit}.breadcrumb-button-level-up sie-icon svg text{font-family:Siemens Sans,sans-serif}.next-child{margin:1px 6px 0}.next-child sie-icon{width:20px;height:20px;display:flex;align-items:center;fill:currentColor;color:#4c4c68}.next-child sie-icon svg{fill:currentColor;width:inherit;height:inherit}.next-child sie-icon svg g{fill:currentColor;width:inherit;height:inherit}.next-child sie-icon svg text{font-family:Siemens Sans,sans-serif}.btn-root{display:flex;align-items:center}.btn-root .btn-root-icon{color:#4c4c68}.btn-root .btn-root-icon:hover{color:#000028}.btn-root .btn-root-icon.navigation{width:20px;height:20px;display:flex;align-items:center;fill:currentColor}.btn-root .btn-root-icon.navigation svg{fill:currentColor;width:inherit;height:inherit}.btn-root .btn-root-icon.navigation svg g{fill:currentColor;width:inherit;height:inherit}.btn-root .btn-root-icon.navigation svg text{font-family:Siemens Sans,sans-serif}.btn-root .btn-root-icon.navigation svg{transform:rotate(270deg)}.btn-root .btn-root-icon.on-page{width:14px;height:14px;display:flex;align-items:center;fill:currentColor}.btn-root .btn-root-icon.on-page svg{fill:currentColor;width:inherit;height:inherit}.btn-root .btn-root-icon.on-page svg g{fill:currentColor;width:inherit;height:inherit}.btn-root .btn-root-icon.on-page svg text{font-family:Siemens Sans,sans-serif}.spacer{background-color:#4c4c68;width:1px;height:10px;margin:0 16px 0 11px}.truncation-placeholder{margin:1px 0 0}.breadcrumb-button{align-items:center;white-space:nowrap;overflow:hidden}@supports (display: grid){.breadcrumb-button{display:flex}}.breadcrumb-button-text{white-space:nowrap;overflow:hidden;text-overflow:ellipsis;flex:1}.active,.disabled{white-space:nowrap;overflow:hidden;text-overflow:ellipsis;max-width:200px;cursor:default}.active:hover,.disabled:hover{color:#4c4c68}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }, { type: i0.ChangeDetectorRef }, { type: i1$1.LayoutService }]; }, propDecorators: { breadCrumbItems: [{
                type: ViewChildren,
                args: ['breadCrumbItem']
            }], olElement: [{
                type: ViewChild,
                args: ['olElement']
            }], screenReaderMenuTitle: [{
                type: HostBinding,
                args: ['class.on-page-breadcrumbs']
            }, {
                type: Input
            }], screenReaderBackButton: [{
                type: Input
            }], screenReaderHomeButton: [{
                type: Input
            }], pageBreadcrumbs: [{
                type: Input
            }], breadcrumbs: [{
                type: Input
            }], variant: [{
                type: Input
            }], clicked: [{
                type: Output
            }] } });

/**
 * # Breadcrumb Module
 * - {@link UiBreadcrumbComponent}
 *
 * ## Module peer dependencies
 * - {@link SieIconsModule}
 */
class UiBreadcrumbModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiBreadcrumbModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiBreadcrumbModule, declarations: [UiBreadcrumbComponent], imports: [CommonModule, SieIconsModule, AddTooltipModule, AttributeModule], exports: [UiBreadcrumbComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiBreadcrumbModule, imports: [CommonModule, SieIconsModule, AddTooltipModule, AttributeModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiBreadcrumbModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiBreadcrumbComponent],
                    imports: [CommonModule, SieIconsModule, AddTooltipModule, AttributeModule],
                    exports: [UiBreadcrumbComponent]
                }]
        }] });

class UiPromoBenefitsComponent {
    constructor(el, iconReg, layoutService, cdr) {
        this.el = el;
        this.iconReg = iconReg;
        this.layoutService = layoutService;
        this.cdr = cdr;
        this.size = 'sm';
        this.isVertical = false;
        iconReg.register(SieIcon.CheckMarkBenefits);
    }
    ngAfterViewInit() {
        this.resizeSub = this.layoutService.resizeEventWithInitial$.subscribe(() => this.verticalCheck());
    }
    verticalCheck() {
        const elementWidths = this.benefitElements.toArray().reduce((width, benefitEl) => {
            return width + benefitEl.nativeElement.offsetWidth;
        }, 0);
        this.isVertical = elementWidths >= this.el.nativeElement.offsetWidth;
        this.cdr.detectChanges();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiPromoBenefitsComponent, deps: [{ token: i0.ElementRef }, { token: i1.SieIconRegistryService }, { token: i1$1.LayoutService }, { token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiPromoBenefitsComponent, selector: "sie-ui-promo-benefits", inputs: { benefits: "benefits", size: "size" }, viewQueries: [{ propertyName: "benefitElements", predicate: ["benefit"], descendants: true }], ngImport: i0, template: "<ul class=\"{{ size }} ui-promo-benefits\" [ngClass]=\"{ 'is-vertical': isVertical }\">\n  <li class=\"ui-promo-benefits__item\" *ngFor=\"let benefit of benefits\">\n    <div #benefit>\n      <sie-icon [name]=\"iconReg.sieIcon.CheckMark\" class=\"ui-promo-benefits__item-icon\"></sie-icon>\n      <span>{{ benefit }}</span>\n    </div>\n  </li>\n</ul>\n", styles: [":host{display:block}.ui-promo-benefits{list-style:none;margin:8px 0 0;display:flex;padding:0}@media (max-width: 639.78px){.ui-promo-benefits{flex-direction:column}}.ui-promo-benefits__item{display:flex;align-items:center;list-style-type:none;margin-bottom:8px;margin-right:8px;white-space:nowrap}@media (min-width: 1440px){.ui-promo-benefits__item{margin-right:16px}}@media (min-width: 640px) and (max-width: 1023.8px){.ui-promo-benefits__item{margin-bottom:16px}}@media (max-width: 639.78px){.ui-promo-benefits__item:last-of-type{margin-bottom:24px}}.ui-promo-benefits__item:last-of-type{margin-right:0}.ui-promo-benefits__item-icon{width:16px;height:16px;display:flex;align-items:center;fill:currentColor;display:inline-flex;margin-right:6px;margin-bottom:3px;color:#00d7a0}.ui-promo-benefits__item-icon svg{fill:currentColor;width:inherit;height:inherit}.ui-promo-benefits__item-icon svg g{fill:currentColor;width:inherit;height:inherit}.ui-promo-benefits__item-icon svg text{font-family:Siemens Sans,sans-serif}.ui-promo-benefits.is-vertical{flex-direction:column}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiPromoBenefitsComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-promo-benefits', changeDetection: ChangeDetectionStrategy.OnPush, template: "<ul class=\"{{ size }} ui-promo-benefits\" [ngClass]=\"{ 'is-vertical': isVertical }\">\n  <li class=\"ui-promo-benefits__item\" *ngFor=\"let benefit of benefits\">\n    <div #benefit>\n      <sie-icon [name]=\"iconReg.sieIcon.CheckMark\" class=\"ui-promo-benefits__item-icon\"></sie-icon>\n      <span>{{ benefit }}</span>\n    </div>\n  </li>\n</ul>\n", styles: [":host{display:block}.ui-promo-benefits{list-style:none;margin:8px 0 0;display:flex;padding:0}@media (max-width: 639.78px){.ui-promo-benefits{flex-direction:column}}.ui-promo-benefits__item{display:flex;align-items:center;list-style-type:none;margin-bottom:8px;margin-right:8px;white-space:nowrap}@media (min-width: 1440px){.ui-promo-benefits__item{margin-right:16px}}@media (min-width: 640px) and (max-width: 1023.8px){.ui-promo-benefits__item{margin-bottom:16px}}@media (max-width: 639.78px){.ui-promo-benefits__item:last-of-type{margin-bottom:24px}}.ui-promo-benefits__item:last-of-type{margin-right:0}.ui-promo-benefits__item-icon{width:16px;height:16px;display:flex;align-items:center;fill:currentColor;display:inline-flex;margin-right:6px;margin-bottom:3px;color:#00d7a0}.ui-promo-benefits__item-icon svg{fill:currentColor;width:inherit;height:inherit}.ui-promo-benefits__item-icon svg g{fill:currentColor;width:inherit;height:inherit}.ui-promo-benefits__item-icon svg text{font-family:Siemens Sans,sans-serif}.ui-promo-benefits.is-vertical{flex-direction:column}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: i1.SieIconRegistryService }, { type: i1$1.LayoutService }, { type: i0.ChangeDetectorRef }]; }, propDecorators: { benefits: [{
                type: Input
            }], size: [{
                type: Input
            }], benefitElements: [{
                type: ViewChildren,
                args: ['benefit']
            }] } });

class UiPromotionExpandableComponent {
    get backgroundImageUrl() {
        return this.promotionExpandableData?.image?.urlLarge || this._backgroundImageUrl;
    }
    set backgroundImageUrl(value) {
        this._backgroundImageUrl = value;
    }
    get promotionExpandableData() {
        return this._promotionExpandableData;
    }
    set promotionExpandableData(value) {
        this._promotionExpandableData = value;
    }
    constructor(iconReg, layoutService) {
        this.iconReg = iconReg;
        this.layoutService = layoutService;
        this.singlePromotionExpandable = false;
        this.cardClicked = new EventEmitter();
        this._backgroundImageUrl = '/assets/images/promotion-expandable-fallback.jpg';
        iconReg.register(SieIcon.LocationPin);
        iconReg.register(SieIcon.Calendar);
    }
    onCardClicked(item) {
        this.cardClicked.emit(item);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiPromotionExpandableComponent, deps: [{ token: i1.SieIconRegistryService }, { token: i1$1.LayoutService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiPromotionExpandableComponent, selector: "sie-ui-promotion-expandable", inputs: { backgroundImageUrl: "backgroundImageUrl", promotionExpandableData: "promotionExpandableData", singlePromotionExpandable: "singlePromotionExpandable" }, outputs: { cardClicked: "cardClicked" }, ngImport: i0, template: "<div\n  [attr.data-gb-section]=\"'promotion-expandable'\"\n  [sieCoreAttributes]=\"promotionExpandableData?.dataAttributes\"\n  *ngIf=\"promotionExpandableData\"\n  class=\"promotion-expandable\"\n  [style.background-image]=\"'linear-gradient(rgba(0, 0, 0, 0.5), rgba(0, 0, 0, 0.5)), url(' + backgroundImageUrl + ')'\"\n>\n  <div class=\"container promotion-expandable__content\">\n    <div\n      class=\"promotion-expandable__left\"\n      [ngClass]=\"{ 'primary-image': promotionExpandableData.primaryImage?.urlLarge, single: singlePromotionExpandable }\"\n    >\n      <h3 class=\"promotion-expandable__title\">\n        {{ promotionExpandableData.title }}\n      </h3>\n      <p class=\"promotion-expandable__sub-title\">\n        {{ promotionExpandableData.subtitle }}\n      </p>\n\n      <sie-ui-promo-benefits\n        *ngIf=\"promotionExpandableData.type === 'product' && promotionExpandableData.benefits?.length > 0\"\n        class=\"promotion-expandable__benefits\"\n        [benefits]=\"promotionExpandableData.benefits\"\n      ></sie-ui-promo-benefits>\n\n      <div *ngIf=\"promotionExpandableData.type === 'event'\" class=\"promotion-expandable__location-time\">\n        <div class=\"promotion-expandable__location-time-item\">\n          <sie-icon [name]=\"iconReg.sieIcon.LocationPin\" class=\"promotion-expandable__location-time-icon\"></sie-icon>\n          <span>{{ promotionExpandableData.location }}</span>\n        </div>\n        <div class=\"promotion-expandable__location-time-item\">\n          <sie-icon [name]=\"iconReg.sieIcon.Calendar\" class=\"promotion-expandable__location-time-icon\"></sie-icon>\n          <span>{{ promotionExpandableData.date }}</span>\n        </div>\n      </div>\n    </div>\n\n    <div *ngIf=\"promotionExpandableData.type === 'product'\" class=\"promotion-expandable__image\">\n      <div *ngIf=\"promotionExpandableData.primaryImage?.urlLarge\" class=\"promotion-expandable__image-product-image\">\n        <sie-ui-picture [model]=\"promotionExpandableData.primaryImage\" ratio=\"16-9\"></sie-ui-picture>\n      </div>\n    </div>\n\n    <div\n      class=\"promotion-expandable__buttons\"\n      [ngClass]=\"{ product: promotionExpandableData.type === 'product', single: singlePromotionExpandable }\"\n    >\n      <sie-ui-button-group\n        [buttons]=\"promotionExpandableData.buttons\"\n        [fullWidth]=\"layoutService.isViewport('S')\"\n        [direction]=\"layoutService.isViewport('S') ? 'column' : 'row'\"\n        buttonAlignmentClass=\"right\"\n        (buttonClick)=\"onCardClicked(promotionExpandableData)\"\n      ></sie-ui-button-group>\n    </div>\n  </div>\n</div>\n", styles: [":host{width:100%;height:100%}.promotion-expandable{position:relative;color:#fff;overflow:hidden;background-size:cover;background-position:center center;z-index:2;height:100%;display:flex}.promotion-expandable__content{display:flex;justify-content:space-between;align-items:center;padding:40px 72px 56px}@media (min-width: 1440px){.promotion-expandable__content{padding:40px 96px 56px}}@media (min-width: 640px) and (max-width: 1023.8px){.promotion-expandable__content{flex-wrap:wrap}}@media (max-width: 639.78px){.promotion-expandable__content{flex-wrap:wrap;align-items:flex-start;padding:32px 16px 56px}}.promotion-expandable__left,.promotion-expandable__left.primary-image{width:50%}@media (min-width: 1024px){.promotion-expandable__left,.promotion-expandable__left.primary-image{padding-right:16px}}@media (min-width: 640px) and (max-width: 1023.8px){.promotion-expandable__left,.promotion-expandable__left.primary-image{width:100%}}@media (max-width: 639.78px){.promotion-expandable__left{width:100%}.promotion-expandable__left .single{margin-bottom:96px}}@media (max-width: 639.78px){.promotion-expandable__left.primary-image{margin-bottom:0}}.promotion-expandable__title{display:-webkit-box;-webkit-box-orient:vertical;-webkit-line-clamp:2;text-overflow:ellipsis;overflow:hidden}.promotion-expandable__sub-title{display:-webkit-box;-webkit-box-orient:vertical;-webkit-line-clamp:3;text-overflow:ellipsis;overflow:hidden;margin-top:8px}@media (max-width: 1439.78px){.promotion-expandable__sub-title,.promotion-expandable__benefits,.promotion-expandable__location-time{font-size:.875rem}}.promotion-expandable__image,.promotion-expandable__buttons.product{width:25%}@media (min-width: 640px) and (max-width: 1023.8px){.promotion-expandable__image,.promotion-expandable__buttons.product{width:50%}}@media (min-width: 1440px){.promotion-expandable__image{padding-left:64px}}@media (min-width: 640px) and (max-width: 1023.8px){.promotion-expandable__image{width:50%}}@media (max-width: 639.78px){.promotion-expandable__image{display:flex;justify-content:flex-end;width:50%}}.promotion-expandable__image-product-image{max-width:160px;flex:1}@media (max-width: 639.78px){.promotion-expandable__buttons{margin-bottom:32px;display:flex;align-self:flex-end}.promotion-expandable__buttons.single{margin-bottom:0}}@media (min-width: 640px) and (max-width: 1023.8px){.promotion-expandable__buttons{width:100%}}@media (min-width: 1024px){.promotion-expandable__buttons,.promotion-expandable__buttons.product{margin-top:20px}}@media (max-width: 639.78px){.promotion-expandable__buttons,.promotion-expandable__buttons.product{width:100%}}.promotion-expandable__location-time{display:flex;margin-top:8px}@media (max-width: 639.78px){.promotion-expandable__location-time{flex-direction:column}}.promotion-expandable__location-time-item{display:flex;align-items:center;margin-right:16px}@media (min-width: 1024px){.promotion-expandable__location-time-item{margin-right:40px}}.promotion-expandable__location-time-icon{width:16px;height:16px;display:flex;align-items:center;fill:currentColor;color:#00d7a0;margin-right:8px}.promotion-expandable__location-time-icon svg{fill:currentColor;width:inherit;height:inherit}.promotion-expandable__location-time-icon svg g{fill:currentColor;width:inherit;height:inherit}.promotion-expandable__location-time-icon svg text{font-family:Siemens Sans,sans-serif}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "component", type: UiPictureComponent, selector: "sie-ui-picture", inputs: ["model", "size", "ratio", "notLoadedLabel", "theme", "context", "caption", "shouldHaveOutline"], outputs: ["failedToLoadImg"] }, { kind: "component", type: UiButtonGroupComponent, selector: "sie-ui-button-group", inputs: ["buttons", "fullWidthOnViewportS", "wrapButtons", "direction", "flexDirection", "fullWidth", "buttonAlignmentClass"], outputs: ["buttonClick"] }, { kind: "component", type: UiPromoBenefitsComponent, selector: "sie-ui-promo-benefits", inputs: ["benefits", "size"] }, { kind: "directive", type: i1$1.AttributeDirective, selector: "[sieCoreAttributes]", inputs: ["sieCoreAttributes"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiPromotionExpandableComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-promotion-expandable', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div\n  [attr.data-gb-section]=\"'promotion-expandable'\"\n  [sieCoreAttributes]=\"promotionExpandableData?.dataAttributes\"\n  *ngIf=\"promotionExpandableData\"\n  class=\"promotion-expandable\"\n  [style.background-image]=\"'linear-gradient(rgba(0, 0, 0, 0.5), rgba(0, 0, 0, 0.5)), url(' + backgroundImageUrl + ')'\"\n>\n  <div class=\"container promotion-expandable__content\">\n    <div\n      class=\"promotion-expandable__left\"\n      [ngClass]=\"{ 'primary-image': promotionExpandableData.primaryImage?.urlLarge, single: singlePromotionExpandable }\"\n    >\n      <h3 class=\"promotion-expandable__title\">\n        {{ promotionExpandableData.title }}\n      </h3>\n      <p class=\"promotion-expandable__sub-title\">\n        {{ promotionExpandableData.subtitle }}\n      </p>\n\n      <sie-ui-promo-benefits\n        *ngIf=\"promotionExpandableData.type === 'product' && promotionExpandableData.benefits?.length > 0\"\n        class=\"promotion-expandable__benefits\"\n        [benefits]=\"promotionExpandableData.benefits\"\n      ></sie-ui-promo-benefits>\n\n      <div *ngIf=\"promotionExpandableData.type === 'event'\" class=\"promotion-expandable__location-time\">\n        <div class=\"promotion-expandable__location-time-item\">\n          <sie-icon [name]=\"iconReg.sieIcon.LocationPin\" class=\"promotion-expandable__location-time-icon\"></sie-icon>\n          <span>{{ promotionExpandableData.location }}</span>\n        </div>\n        <div class=\"promotion-expandable__location-time-item\">\n          <sie-icon [name]=\"iconReg.sieIcon.Calendar\" class=\"promotion-expandable__location-time-icon\"></sie-icon>\n          <span>{{ promotionExpandableData.date }}</span>\n        </div>\n      </div>\n    </div>\n\n    <div *ngIf=\"promotionExpandableData.type === 'product'\" class=\"promotion-expandable__image\">\n      <div *ngIf=\"promotionExpandableData.primaryImage?.urlLarge\" class=\"promotion-expandable__image-product-image\">\n        <sie-ui-picture [model]=\"promotionExpandableData.primaryImage\" ratio=\"16-9\"></sie-ui-picture>\n      </div>\n    </div>\n\n    <div\n      class=\"promotion-expandable__buttons\"\n      [ngClass]=\"{ product: promotionExpandableData.type === 'product', single: singlePromotionExpandable }\"\n    >\n      <sie-ui-button-group\n        [buttons]=\"promotionExpandableData.buttons\"\n        [fullWidth]=\"layoutService.isViewport('S')\"\n        [direction]=\"layoutService.isViewport('S') ? 'column' : 'row'\"\n        buttonAlignmentClass=\"right\"\n        (buttonClick)=\"onCardClicked(promotionExpandableData)\"\n      ></sie-ui-button-group>\n    </div>\n  </div>\n</div>\n", styles: [":host{width:100%;height:100%}.promotion-expandable{position:relative;color:#fff;overflow:hidden;background-size:cover;background-position:center center;z-index:2;height:100%;display:flex}.promotion-expandable__content{display:flex;justify-content:space-between;align-items:center;padding:40px 72px 56px}@media (min-width: 1440px){.promotion-expandable__content{padding:40px 96px 56px}}@media (min-width: 640px) and (max-width: 1023.8px){.promotion-expandable__content{flex-wrap:wrap}}@media (max-width: 639.78px){.promotion-expandable__content{flex-wrap:wrap;align-items:flex-start;padding:32px 16px 56px}}.promotion-expandable__left,.promotion-expandable__left.primary-image{width:50%}@media (min-width: 1024px){.promotion-expandable__left,.promotion-expandable__left.primary-image{padding-right:16px}}@media (min-width: 640px) and (max-width: 1023.8px){.promotion-expandable__left,.promotion-expandable__left.primary-image{width:100%}}@media (max-width: 639.78px){.promotion-expandable__left{width:100%}.promotion-expandable__left .single{margin-bottom:96px}}@media (max-width: 639.78px){.promotion-expandable__left.primary-image{margin-bottom:0}}.promotion-expandable__title{display:-webkit-box;-webkit-box-orient:vertical;-webkit-line-clamp:2;text-overflow:ellipsis;overflow:hidden}.promotion-expandable__sub-title{display:-webkit-box;-webkit-box-orient:vertical;-webkit-line-clamp:3;text-overflow:ellipsis;overflow:hidden;margin-top:8px}@media (max-width: 1439.78px){.promotion-expandable__sub-title,.promotion-expandable__benefits,.promotion-expandable__location-time{font-size:.875rem}}.promotion-expandable__image,.promotion-expandable__buttons.product{width:25%}@media (min-width: 640px) and (max-width: 1023.8px){.promotion-expandable__image,.promotion-expandable__buttons.product{width:50%}}@media (min-width: 1440px){.promotion-expandable__image{padding-left:64px}}@media (min-width: 640px) and (max-width: 1023.8px){.promotion-expandable__image{width:50%}}@media (max-width: 639.78px){.promotion-expandable__image{display:flex;justify-content:flex-end;width:50%}}.promotion-expandable__image-product-image{max-width:160px;flex:1}@media (max-width: 639.78px){.promotion-expandable__buttons{margin-bottom:32px;display:flex;align-self:flex-end}.promotion-expandable__buttons.single{margin-bottom:0}}@media (min-width: 640px) and (max-width: 1023.8px){.promotion-expandable__buttons{width:100%}}@media (min-width: 1024px){.promotion-expandable__buttons,.promotion-expandable__buttons.product{margin-top:20px}}@media (max-width: 639.78px){.promotion-expandable__buttons,.promotion-expandable__buttons.product{width:100%}}.promotion-expandable__location-time{display:flex;margin-top:8px}@media (max-width: 639.78px){.promotion-expandable__location-time{flex-direction:column}}.promotion-expandable__location-time-item{display:flex;align-items:center;margin-right:16px}@media (min-width: 1024px){.promotion-expandable__location-time-item{margin-right:40px}}.promotion-expandable__location-time-icon{width:16px;height:16px;display:flex;align-items:center;fill:currentColor;color:#00d7a0;margin-right:8px}.promotion-expandable__location-time-icon svg{fill:currentColor;width:inherit;height:inherit}.promotion-expandable__location-time-icon svg g{fill:currentColor;width:inherit;height:inherit}.promotion-expandable__location-time-icon svg text{font-family:Siemens Sans,sans-serif}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }, { type: i1$1.LayoutService }]; }, propDecorators: { backgroundImageUrl: [{
                type: Input
            }], promotionExpandableData: [{
                type: Input
            }], singlePromotionExpandable: [{
                type: Input
            }], cardClicked: [{
                type: Output
            }] } });

class UiPromoBenefitsModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiPromoBenefitsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiPromoBenefitsModule, declarations: [UiPromoBenefitsComponent], imports: [CommonModule, SieIconsModule], exports: [UiPromoBenefitsComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiPromoBenefitsModule, imports: [CommonModule, SieIconsModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiPromoBenefitsModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiPromoBenefitsComponent],
                    imports: [CommonModule, SieIconsModule],
                    exports: [UiPromoBenefitsComponent]
                }]
        }] });

class UiPromotionExpandableModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiPromotionExpandableModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiPromotionExpandableModule, declarations: [UiPromotionExpandableComponent], imports: [CommonModule,
            SieIconsModule,
            UiPictureModule,
            UiButtonGroupModule,
            UiPromoBenefitsModule,
            TruncateModule,
            AttributeModule], exports: [UiPromotionExpandableComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiPromotionExpandableModule, imports: [CommonModule,
            SieIconsModule,
            UiPictureModule,
            UiButtonGroupModule,
            UiPromoBenefitsModule,
            TruncateModule,
            AttributeModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiPromotionExpandableModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiPromotionExpandableComponent],
                    imports: [
                        CommonModule,
                        SieIconsModule,
                        UiPictureModule,
                        UiButtonGroupModule,
                        UiPromoBenefitsModule,
                        TruncateModule,
                        AttributeModule
                    ],
                    exports: [UiPromotionExpandableComponent]
                }]
        }] });

const toggleCircle = trigger('toggleCircle', [
    state('growCircle', style({
        opacity: '1',
        transform: 'scale(1.2)'
    })),
    state('shrinkCircle', style({
        opacity: '1',
        transform: 'scale(1)'
    })),
    state('hide', style({
        opacity: '0'
    })),
    transition('hide => growCircle', [
        group([
            animate('300ms cubic-bezier(0.4, 0, 0.3, 1)', style({ opacity: '1' })),
            animate('400ms cubic-bezier(0.4, 0, 1, 1)', style({ transform: 'scale(1.2)' }))
        ])
    ]),
    transition('growCircle => shrinkCircle', [
        group([animate('400ms cubic-bezier(0.4, 0, 0.3, 1)', style({ transform: 'scale(1)' }))])
    ])
]);
const toggleThumbsUp = trigger('toggleThumbsUp', [
    state('show', style({
        opacity: 1,
        transform: 'translateY(0)'
    })),
    state('hide', style({
        opacity: 0,
        transform: 'translateY(9px) rotate(29deg)'
    })),
    transition('hide => show', [
        group([
            animate('300ms cubic-bezier(0, 0, 0.3, 1)', style({ opacity: '1' })),
            animate('300ms cubic-bezier(0, 0, 0.3, 1)', style({ transform: 'translateY(0) rotate(0)' }))
        ])
    ])
]);
const toggleThumbsDown = trigger('toggleThumbsDown', [
    state('show', style({
        opacity: 1,
        transform: 'translateY(0)'
    })),
    state('hide', style({
        opacity: 0,
        transform: 'translateY(-6px)'
    })),
    transition('hide => show', [
        group([
            animate('250ms cubic-bezier(0, 0, 0.3, 1)', style({ opacity: '1' })),
            animate('250ms cubic-bezier(0, 0, 0.3, 1)', style({ transform: 'translateY(0)' }))
        ])
    ])
]);

class UiFeedbackFormComponent {
    set feedbackFormUrl(feedbackFormUrl) {
        if (feedbackFormUrl) {
            this._feedbackFormUrl = this.sanitizer.bypassSecurityTrustResourceUrl(feedbackFormUrl
                .replace('<LANGUAGE>', this.localeService.locale.language)
                .replace('<REGION>', this.localeService.locale.region));
        }
    }
    constructor(cdr, iconReg, localeService, activatedRoute, sanitizer) {
        this.cdr = cdr;
        this.iconReg = iconReg;
        this.localeService = localeService;
        this.activatedRoute = activatedRoute;
        this.sanitizer = sanitizer;
        this.animationStateThumbsUp = 'hide';
        this.animationStateThumbsDown = 'hide';
        this.animationStateCircle = 'hide';
        this.subscriptions = new Subscription();
        this.playAnimation = true;
        this.screenReaderCloseIcon = '';
        this.animationDelayMS = 3000;
        this.openDialog$ = of(false);
        this.animatePopover = new Subject();
        this.clicked = new EventEmitter();
        this.animationSeen = new EventEmitter();
        this.modalClosed = new EventEmitter();
        iconReg.register(SieIcon.SieportalThumbsUp);
        iconReg.register(SieIcon.SieportalThumbsDown);
    }
    get animationCircle() {
        return this.animationStateCircle;
    }
    get animationThumbsUp() {
        return this.animationStateThumbsUp;
    }
    get animationThumbsDown() {
        return this.animationStateThumbsDown;
    }
    ngOnInit() {
        this.playAnimation = Date.now() >= new Date(this.animationStopExpirationDate).getTime();
        this.subscriptions.add(this.openDialog$.subscribe(open => {
            if (!this.feedbackModal) {
                return;
            }
            if (open) {
                this.feedbackModal.openDialog('feedbackModal');
            }
            else {
                this.feedbackModal.close();
            }
        }));
    }
    ngOnDestroy() {
        this.subscriptions.unsubscribe();
    }
    ngAfterViewInit() {
        setTimeout(() => {
            this.animationStateCircle = 'growCircle';
            this.cdr.detectChanges();
        }, this.animationDelayMS);
        const queryModalId = this.activatedRoute.snapshot.queryParamMap.get(UIConstants.QUERY_PARAMS.MODAL_ID);
        if (queryModalId === 'feedbackModal') {
            this.feedbackModal.openDialog('feedbackModal');
        }
    }
    onAnimationDone(e) {
        if (e.triggerName === 'toggleCircle') {
            if (e.toState === 'growCircle') {
                this.animationStateCircle = 'shrinkCircle';
            }
            if (e.toState === 'shrinkCircle') {
                this.animationStateThumbsUp = 'show';
            }
        }
        if (e.triggerName === 'toggleThumbsUp' && e.toState === 'show') {
            this.animationStateThumbsDown = 'show';
        }
        if (e.triggerName === 'toggleThumbsDown' && e.toState === 'show') {
            this.animatePopover.next(true);
            this.animationSeen.emit(true);
        }
        this.cdr.detectChanges();
    }
    onClick() {
        this.feedbackModal.openDialog('feedbackModal');
        this.clicked.emit(true);
    }
    onModalClose() {
        this.modalClosed.emit();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiFeedbackFormComponent, deps: [{ token: i0.ChangeDetectorRef }, { token: i1.SieIconRegistryService }, { token: i1$1.LocaleService }, { token: i2$1.ActivatedRoute }, { token: i4$1.DomSanitizer }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiFeedbackFormComponent, selector: "sie-ui-feedback-form", inputs: { feedbackFormUrl: "feedbackFormUrl", screenReaderCloseIcon: "screenReaderCloseIcon", tooltipText: "tooltipText", buttonScreenReaderText: "buttonScreenReaderText", animationDelayMS: "animationDelayMS", animationStopExpirationDate: "animationStopExpirationDate", openDialog$: "openDialog$" }, outputs: { animatePopover: "animatePopover", clicked: "clicked", animationSeen: "animationSeen", modalClosed: "modalClosed" }, viewQueries: [{ propertyName: "feedbackModal", first: true, predicate: ["feedbackModal"], descendants: true }], ngImport: i0, template: "<sie-ui-modal\n  [headline]=\"''\"\n  [identifier]=\"'feedbackModal'\"\n  [closable]=\"true\"\n  [escapable]=\"true\"\n  [fullWidth]=\"true\"\n  [fullScreenMobile]=\"true\"\n  [size]=\"'large'\"\n  [screenReaderCloseIcon]=\"screenReaderCloseIcon\"\n  (modalClosed)=\"onModalClose()\"\n  #feedbackModal\n>\n  <div content>\n    <div class=\"feedback__iframe\">\n      <iframe\n        loading=\"lazy\"\n        [attr.src]=\"_feedbackFormUrl\"\n        title=\"Feedback\"\n        height=\"700px\"\n        width=\"100%\"\n        frameBorder=\"0\"\n        sieCoreCalcViewHeight\n        [sieCoreCalcViewHeightBreakpoints]=\"[{ name: 'S', vh: 100, offset: 80 }]\"\n      ></iframe>\n    </div>\n  </div>\n</sie-ui-modal>\n\n<div class=\"feedback\">\n  <button\n    type=\"button\"\n    class=\"feedback__button\"\n    (click)=\"onClick()\"\n    #feedBackButton\n    [@toggleCircle]=\"playAnimation ? animationCircle : null\"\n    (@toggleCircle.done)=\"onAnimationDone($event)\"\n    sieUiPopover\n    [content]=\"playAnimation ? tooltipText : null\"\n    popoverSize=\"s\"\n    popoverLightTheme=\"true\"\n    popoverAnimation=\"true\"\n    [popoverPlayAnimation]=\"animatePopover\"\n  >\n    <sie-icon\n      class=\"feedback__button-icon feedback__button-icon--thumbsUp\"\n      [name]=\"iconReg.sieIcon.SieportalThumbsUp\"\n      [@toggleThumbsUp]=\"playAnimation ? animationThumbsUp : null\"\n      (@toggleThumbsUp.done)=\"onAnimationDone($event)\"\n    ></sie-icon>\n    <sie-icon\n      class=\"feedback__button-icon feedback__button-icon--thumbsDown\"\n      [name]=\"iconReg.sieIcon.SieportalThumbsDown\"\n      [@toggleThumbsDown]=\"playAnimation ? animationThumbsDown : null\"\n      (@toggleThumbsDown.done)=\"onAnimationDone($event)\"\n    ></sie-icon>\n    <span class=\"visually-hidden\">{{ buttonScreenReaderText }}</span>\n  </button>\n</div>\n", styles: [".feedback__button:focus-visible{outline:0}.feedback{z-index:997;overflow:visible}@media print{.feedback{display:none}}.feedback__button{position:relative;z-index:997;width:44px;height:44px;padding:0;border:none;border-radius:50%;background-color:#00bedc;cursor:pointer;box-shadow:0 5px 2px #00000014,0 4px 8px #0000001f}.feedback__button:hover,.feedback__button:active{background-color:#00ffb9}.feedback__button:focus-visible:before{content:\"\";position:absolute;inset:-4px;z-index:1;border:1px solid #1491eb;border-radius:50%}.feedback__button-icon{color:#000028;height:100%;width:100%;display:flex;align-items:center;justify-content:center;position:absolute}.feedback__button-icon--thumbsUp{top:-3px;left:-3px}.feedback__button-icon--thumbsUp svg{width:16px;height:16px}.feedback__button-icon--thumbsDown{top:5px;left:5px}.feedback__button-icon--thumbsDown svg{width:14px;height:13px}.feedback__button:disabled{pointer-events:none;cursor:none;background-color:#737389}.feedback__button:disabled .feedback__button-icon{color:#ebebee}\n"], dependencies: [{ kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "component", type: UiModalComponent, selector: "sie-ui-modal", inputs: ["size", "headline", "headlineVariant", "screenReaderCloseIcon", "hasHeaderContent", "hasFooter", "closeButtonDisabled", "fullWidth", "fullScreenMobile", "stickyFooter"], outputs: ["scrolled"] }, { kind: "directive", type: UiPopoverDirective, selector: "[sieUiPopover]", inputs: ["content", "popoverTemplate", "popoverSize", "popoverPlacement", "popoverAnimation", "popoverPlayAnimation", "popoverAnimationHideAfterTimeoutMS", "popoverLightTheme"] }, { kind: "directive", type: i1$1.CalcViewHeightDirective, selector: "[sieCoreCalcViewHeight]", inputs: ["sieCoreCalcViewHeightBreakpoints", "sieCoreCalcViewHeightEnabled"] }], animations: [toggleThumbsUp, toggleThumbsDown, toggleCircle], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiFeedbackFormComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-feedback-form', animations: [toggleThumbsUp, toggleThumbsDown, toggleCircle], changeDetection: ChangeDetectionStrategy.OnPush, template: "<sie-ui-modal\n  [headline]=\"''\"\n  [identifier]=\"'feedbackModal'\"\n  [closable]=\"true\"\n  [escapable]=\"true\"\n  [fullWidth]=\"true\"\n  [fullScreenMobile]=\"true\"\n  [size]=\"'large'\"\n  [screenReaderCloseIcon]=\"screenReaderCloseIcon\"\n  (modalClosed)=\"onModalClose()\"\n  #feedbackModal\n>\n  <div content>\n    <div class=\"feedback__iframe\">\n      <iframe\n        loading=\"lazy\"\n        [attr.src]=\"_feedbackFormUrl\"\n        title=\"Feedback\"\n        height=\"700px\"\n        width=\"100%\"\n        frameBorder=\"0\"\n        sieCoreCalcViewHeight\n        [sieCoreCalcViewHeightBreakpoints]=\"[{ name: 'S', vh: 100, offset: 80 }]\"\n      ></iframe>\n    </div>\n  </div>\n</sie-ui-modal>\n\n<div class=\"feedback\">\n  <button\n    type=\"button\"\n    class=\"feedback__button\"\n    (click)=\"onClick()\"\n    #feedBackButton\n    [@toggleCircle]=\"playAnimation ? animationCircle : null\"\n    (@toggleCircle.done)=\"onAnimationDone($event)\"\n    sieUiPopover\n    [content]=\"playAnimation ? tooltipText : null\"\n    popoverSize=\"s\"\n    popoverLightTheme=\"true\"\n    popoverAnimation=\"true\"\n    [popoverPlayAnimation]=\"animatePopover\"\n  >\n    <sie-icon\n      class=\"feedback__button-icon feedback__button-icon--thumbsUp\"\n      [name]=\"iconReg.sieIcon.SieportalThumbsUp\"\n      [@toggleThumbsUp]=\"playAnimation ? animationThumbsUp : null\"\n      (@toggleThumbsUp.done)=\"onAnimationDone($event)\"\n    ></sie-icon>\n    <sie-icon\n      class=\"feedback__button-icon feedback__button-icon--thumbsDown\"\n      [name]=\"iconReg.sieIcon.SieportalThumbsDown\"\n      [@toggleThumbsDown]=\"playAnimation ? animationThumbsDown : null\"\n      (@toggleThumbsDown.done)=\"onAnimationDone($event)\"\n    ></sie-icon>\n    <span class=\"visually-hidden\">{{ buttonScreenReaderText }}</span>\n  </button>\n</div>\n", styles: [".feedback__button:focus-visible{outline:0}.feedback{z-index:997;overflow:visible}@media print{.feedback{display:none}}.feedback__button{position:relative;z-index:997;width:44px;height:44px;padding:0;border:none;border-radius:50%;background-color:#00bedc;cursor:pointer;box-shadow:0 5px 2px #00000014,0 4px 8px #0000001f}.feedback__button:hover,.feedback__button:active{background-color:#00ffb9}.feedback__button:focus-visible:before{content:\"\";position:absolute;inset:-4px;z-index:1;border:1px solid #1491eb;border-radius:50%}.feedback__button-icon{color:#000028;height:100%;width:100%;display:flex;align-items:center;justify-content:center;position:absolute}.feedback__button-icon--thumbsUp{top:-3px;left:-3px}.feedback__button-icon--thumbsUp svg{width:16px;height:16px}.feedback__button-icon--thumbsDown{top:5px;left:5px}.feedback__button-icon--thumbsDown svg{width:14px;height:13px}.feedback__button:disabled{pointer-events:none;cursor:none;background-color:#737389}.feedback__button:disabled .feedback__button-icon{color:#ebebee}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i1.SieIconRegistryService }, { type: i1$1.LocaleService }, { type: i2$1.ActivatedRoute }, { type: i4$1.DomSanitizer }]; }, propDecorators: { feedbackFormUrl: [{
                type: Input
            }], screenReaderCloseIcon: [{
                type: Input
            }], tooltipText: [{
                type: Input
            }], buttonScreenReaderText: [{
                type: Input
            }], animationDelayMS: [{
                type: Input
            }], animationStopExpirationDate: [{
                type: Input
            }], openDialog$: [{
                type: Input
            }], animatePopover: [{
                type: Output
            }], clicked: [{
                type: Output
            }], animationSeen: [{
                type: Output
            }], modalClosed: [{
                type: Output
            }], feedbackModal: [{
                type: ViewChild,
                args: ['feedbackModal']
            }] } });

class UiFeedbackFormModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiFeedbackFormModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiFeedbackFormModule, declarations: [UiFeedbackFormComponent], imports: [CommonModule, SieIconsModule, UiModalModule, UiPopoverModule, CalcViewHeightModule], exports: [UiFeedbackFormComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiFeedbackFormModule, imports: [CommonModule, SieIconsModule, UiModalModule, UiPopoverModule, CalcViewHeightModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiFeedbackFormModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiFeedbackFormComponent],
                    imports: [CommonModule, SieIconsModule, UiModalModule, UiPopoverModule, CalcViewHeightModule],
                    exports: [UiFeedbackFormComponent]
                }]
        }] });

/**
 * # Bar chart component
 *
 * Bar charts are used to provide a specific type of visual representation of given data. They help to quickly grasp
 * the information visually which is otherwise available in complex text format.
 *
 * ## Component variations
 *
 * - distribution
 * - progress
 *
 * ## Content
 *
 * The bar chart component accepts valid HTML markup to be displayed in the popover.
 *
 * @example
 * With Textual Popover:
 * ```html
 * <sie-ui-bar-chart variant="progress" [partials]="barChartPartials" size="small" [popoverText]="'Popover Text'">
 * </sie-ui-bar-chart>
 * ```
 *
 * With HTML Popover:
 * ```html
 * <sie-ui-bar-chart variant="progress" [partials]="barChartPartials" size="small">
 *   <span popover>Popover HTML</span>
 * </sie-ui-bar-chart>
 * ```
 */
class UiBarChartComponent {
    constructor() {
        /**
         * Defines {@link UiBarChartVariant variant} of the bar chart.
         * @default 'distribution'
         */
        this.variant = 'distribution';
        /**
         * Defines {@link UiBarChartSize size} of the bar chart.
         * @default 'regular'
         */
        this.size = 'regular';
        /**
         * Defines {@link UiBarChartAlignment alignment} of the bar chart.
         * @default 'horizontal'
         */
        this.alignment = 'horizontal';
        /**
         * Defines {@link UiBarPartial partials} used to render the bar chart.
         * @default '[]'
         */
        this.partials = [];
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiBarChartComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiBarChartComponent, selector: "sie-ui-bar-chart", inputs: { variant: "variant", size: "size", alignment: "alignment", popoverText: "popoverText", partials: "partials" }, ngImport: i0, template: "<div\n  class=\"bar-chart\"\n  [ngClass]=\"{\n    'bar-chart__progress': variant === 'progress',\n    'bar-chart__small': size === 'small',\n    'bar-chart__vertical': alignment === 'vertical'\n  }\"\n  sieUiPopover\n  popoverSize=\"s\"\n  [popoverTemplate]=\"popoverTemplate\"\n  [content]=\"popoverText\"\n>\n  <ng-container *ngIf=\"variant === 'distribution'\">\n    <ng-container *ngTemplateOutlet=\"barChartDistribution\"></ng-container>\n  </ng-container>\n  <ng-container *ngIf=\"variant === 'progress'\">\n    <ng-container *ngTemplateOutlet=\"barChartProgress\"></ng-container>\n  </ng-container>\n</div>\n\n<ng-template #barChartDistribution>\n  <div\n    class=\"bar-chart__item\"\n    *ngFor=\"let partial of partials\"\n    [style.width]=\"alignment === 'horizontal' ? partial.percentage + '%' : ''\"\n    [style.height]=\"alignment === 'vertical' ? partial.percentage + '%' : ''\"\n    [style.background]=\"partial.color\"\n  ></div>\n</ng-template>\n\n<ng-template #barChartProgress>\n  <div class=\"bar-chart__item\" *ngFor=\"let partial of partials\">\n    <div\n      class=\"bar-chart__item-inner\"\n      [style.width]=\"alignment === 'horizontal' ? partial.percentage + '%' : ''\"\n      [style.height]=\"alignment === 'vertical' ? partial.percentage + '%' : ''\"\n      [style.background]=\"partial.color\"\n    ></div>\n  </div>\n</ng-template>\n\n<ng-template #popoverTemplate>\n  <ng-content select=\"[popover]\"></ng-content>\n</ng-template>\n", styles: [".bar-chart{background-color:#ccccd4;display:flex}.bar-chart__item{height:24px;position:relative}.bar-chart__item-inner{height:24px}.bar-chart__vertical{height:100%;width:24px;flex-wrap:wrap-reverse;align-content:flex-start}.bar-chart__vertical .bar-chart__item,.bar-chart__vertical .bar-chart__item-inner{width:24px}.bar-chart__progress{display:block;background-color:transparent}.bar-chart__progress .bar-chart__item{margin-bottom:28px;background-color:#ccccd4}.bar-chart__small .bar-chart__item,.bar-chart__small .bar-chart__item-inner{height:8px}.bar-chart__small.bar-chart__vertical{width:8px}.bar-chart__small.bar-chart__vertical .bar-chart__item{margin-bottom:0}.bar-chart__small.bar-chart__vertical .bar-chart__item,.bar-chart__small.bar-chart__vertical .bar-chart__item-inner{width:8px;height:auto}.bar-chart__small.bar-chart__progress .bar-chart__item{margin-bottom:16px}.bar-chart.bar-chart__progress.bar-chart__vertical{display:flex;flex-wrap:nowrap;width:auto}.bar-chart.bar-chart__progress.bar-chart__vertical .bar-chart__item{width:24px;height:100%;margin-right:28px;display:flex;align-items:flex-end}.bar-chart.bar-chart__progress.bar-chart__vertical .bar-chart__item:last-child{margin-right:0}.bar-chart.bar-chart__progress.bar-chart__vertical.bar-chart__small .bar-chart__item{width:8px;margin-right:16px}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: UiPopoverDirective, selector: "[sieUiPopover]", inputs: ["content", "popoverTemplate", "popoverSize", "popoverPlacement", "popoverAnimation", "popoverPlayAnimation", "popoverAnimationHideAfterTimeoutMS", "popoverLightTheme"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiBarChartComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-bar-chart', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div\n  class=\"bar-chart\"\n  [ngClass]=\"{\n    'bar-chart__progress': variant === 'progress',\n    'bar-chart__small': size === 'small',\n    'bar-chart__vertical': alignment === 'vertical'\n  }\"\n  sieUiPopover\n  popoverSize=\"s\"\n  [popoverTemplate]=\"popoverTemplate\"\n  [content]=\"popoverText\"\n>\n  <ng-container *ngIf=\"variant === 'distribution'\">\n    <ng-container *ngTemplateOutlet=\"barChartDistribution\"></ng-container>\n  </ng-container>\n  <ng-container *ngIf=\"variant === 'progress'\">\n    <ng-container *ngTemplateOutlet=\"barChartProgress\"></ng-container>\n  </ng-container>\n</div>\n\n<ng-template #barChartDistribution>\n  <div\n    class=\"bar-chart__item\"\n    *ngFor=\"let partial of partials\"\n    [style.width]=\"alignment === 'horizontal' ? partial.percentage + '%' : ''\"\n    [style.height]=\"alignment === 'vertical' ? partial.percentage + '%' : ''\"\n    [style.background]=\"partial.color\"\n  ></div>\n</ng-template>\n\n<ng-template #barChartProgress>\n  <div class=\"bar-chart__item\" *ngFor=\"let partial of partials\">\n    <div\n      class=\"bar-chart__item-inner\"\n      [style.width]=\"alignment === 'horizontal' ? partial.percentage + '%' : ''\"\n      [style.height]=\"alignment === 'vertical' ? partial.percentage + '%' : ''\"\n      [style.background]=\"partial.color\"\n    ></div>\n  </div>\n</ng-template>\n\n<ng-template #popoverTemplate>\n  <ng-content select=\"[popover]\"></ng-content>\n</ng-template>\n", styles: [".bar-chart{background-color:#ccccd4;display:flex}.bar-chart__item{height:24px;position:relative}.bar-chart__item-inner{height:24px}.bar-chart__vertical{height:100%;width:24px;flex-wrap:wrap-reverse;align-content:flex-start}.bar-chart__vertical .bar-chart__item,.bar-chart__vertical .bar-chart__item-inner{width:24px}.bar-chart__progress{display:block;background-color:transparent}.bar-chart__progress .bar-chart__item{margin-bottom:28px;background-color:#ccccd4}.bar-chart__small .bar-chart__item,.bar-chart__small .bar-chart__item-inner{height:8px}.bar-chart__small.bar-chart__vertical{width:8px}.bar-chart__small.bar-chart__vertical .bar-chart__item{margin-bottom:0}.bar-chart__small.bar-chart__vertical .bar-chart__item,.bar-chart__small.bar-chart__vertical .bar-chart__item-inner{width:8px;height:auto}.bar-chart__small.bar-chart__progress .bar-chart__item{margin-bottom:16px}.bar-chart.bar-chart__progress.bar-chart__vertical{display:flex;flex-wrap:nowrap;width:auto}.bar-chart.bar-chart__progress.bar-chart__vertical .bar-chart__item{width:24px;height:100%;margin-right:28px;display:flex;align-items:flex-end}.bar-chart.bar-chart__progress.bar-chart__vertical .bar-chart__item:last-child{margin-right:0}.bar-chart.bar-chart__progress.bar-chart__vertical.bar-chart__small .bar-chart__item{width:8px;margin-right:16px}\n"] }]
        }], propDecorators: { variant: [{
                type: Input
            }], size: [{
                type: Input
            }], alignment: [{
                type: Input
            }], popoverText: [{
                type: Input
            }], partials: [{
                type: Input
            }] } });

class UiBarChartModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiBarChartModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiBarChartModule, declarations: [UiBarChartComponent], imports: [CommonModule, UiPopoverModule], exports: [UiBarChartComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiBarChartModule, imports: [CommonModule, UiPopoverModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiBarChartModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiBarChartComponent],
                    imports: [CommonModule, UiPopoverModule],
                    exports: [UiBarChartComponent]
                }]
        }] });

const API_ICON_MAPPING = {
    Download: SieIcon.Download,
    Faq: SieIcon.Question,
    Manual: SieIcon.InformationPackage,
    ExampleOfUse: SieIcon.SieportalApplicationExamples,
    Characteristic: SieIcon.SieportalCharacteristics,
    Catalog: SieIcon.SieportalCatalogue,
    Certificate: SieIcon.SieportalSoftPki,
    ProductNote: SieIcon.Information,
    TechnicalData: SieIcon.SieportalTechnicalData,
    TopicPage: SieIcon.SieportalTopicPage
};

/**
 * # Card Landscape Component
 *
 * Cards are used to take a sneak peek at some type of content(e.g. product information).
 * Usually, it holds marketing or promotional material. There are two types of cards: Portrait and Landscape.
 *
 * ## Component variations
 *
 * Card Landscape is horizontally oriented and has certain content exclusive to it
 * (rating stars, secondary meta) with the option to show/hide the media.
 *
 * ## Content
 *
 * The card landscape component does not accept any content.
 *
 * ## Code example
 * @example
 * Template:
 * ```html
 * <sie-ui-card-landscape
 *   [titleLines]="3"
 *   [showMedia]="true"
 *   [item]="cardLandscapeItem"
 *   [locale]="'en'"
 *   >
 * <sie-ui-card-landscape>
 * ```
 *
 * Card Landscape item example:
 * ``` js
 * const cardLandscapeItem = {
 *  title: 'Card Landscape Title',
 *  tagLabel: 'Manual',
 *  type: 'Manual',
 *  documentDate: '2021-01-22T00:11:52.907',
 *  linkToItem:
 *   'https://supportstage.industry.siemens.com/cs/document/109786741/tc_111062_cluster_iat_automated_importer_test_2310_1.01.22.2021?dti=0&lc=en-WW',
 *  linkToAllItems: 'https://supportstage.industry.siemens.com/cs/products?dtp=Manual&mfn=ps&lc=en-WW',
 *  version: '02/2017',
 *  rating: 3,
 *  tooltipLabel: 'Rating cannot be displayed at the moment',
 *  childActions: [
 *     {
 *       value: '...',
 *       label: 'Edit'
 *     }
 *   ]
 * };
 * ```
 */
class UiCardLandscapeComponent {
    /**
     * @param value Height of the card.
     */
    set height(value) {
        this._height = coerceNumberProperty(value);
    }
    get height() {
        return this._height;
    }
    /**
     * @param value Number of lines of title to display, more than 3 isn't realistic use case.
     * @default 3
     */
    set titleLines(value) {
        this._titleLines = coerceNumberProperty(value);
    }
    get titleLines() {
        return this._titleLines;
    }
    /**
     * @param value Defines should the media be shown.
     */
    set showMedia(value) {
        this._showMedia = coerceBooleanProperty(value);
    }
    get showMedia() {
        return this._showMedia;
    }
    constructor(iconReg) {
        this.iconReg = iconReg;
        /**
         * The target of the link when the card is clicked.
         * @default '_self'
         */
        this.target = '_self';
        /**
         * {@link ThemeVariant Theme} of the card.
         * @default 'light'
         */
        this.theme = 'light';
        /**
         * Defines if container-queries or media-queries are used for the card styling
         * @default false
         */
        this.containerStyled = false;
        /**
         * {@link UiChildActionEventModel Event} triggered when the action in the dropdown is clicked or selected via keyboard
         * (options button on the card).
         */
        this.cardChildActionClicked = new EventEmitter();
        /**
         * {@link UiLinkClickedEventModel Event} triggered when a link is clicked on the component
         */
        this.linkClicked = new EventEmitter();
        /**
         * {@link UiCardLandscapeModel Event} triggered when card is clicked
         */
        this.cardClicked = new EventEmitter();
        /** @ignore */
        this.cardBaseHeight = 92;
        /** @ignore */
        this.titleLineHeight = 26;
        /** @ignore */
        this.titleBaseMarginBottom = 18;
        /** @ignore */
        this.titleSpacingCoefficient = 6;
        /** @ignore */
        this.cardHeight = this.cardBaseHeight + this.titleLines * this.titleLineHeight + 'px';
        /** @ignore */
        this.titleStyle = {
            '-webkit-line-clamp': this.titleLines,
            height: this.titleLines * this.titleLineHeight + 'px',
            'margin-bottom': this.titleBaseMarginBottom + (this.titleLines - 1) * this.titleSpacingCoefficient + 'px'
        };
        /** @ignore */
        this.iconName = null;
        this._titleLines = 3;
    }
    /** @ignore */
    ngOnInit() {
        this.iconName = API_ICON_MAPPING[this.item.type];
        if (!this.iconName) {
            this.iconName = SieIcon.File;
        }
        this.iconReg.register(this.iconName);
    }
    /** @ignore */
    onNavigateLink(href) {
        if (!href) {
            return;
        }
        this.onCardClicked(this.item);
        this.linkClicked.emit({
            link: {
                type: 'url',
                href: href,
                target: this.target
            }
        });
    }
    /** @ignore */
    onCardClicked(item) {
        this.cardClicked.emit(item);
    }
    /** @ignore */
    ngOnChanges(_) {
        this.calculateDimensions();
    }
    /** @ignore */
    onChildActionClicked(button, item) {
        this.cardChildActionClicked.emit({ button, item });
    }
    calculateDimensions() {
        this.cardHeight = (this.height || this.calculateCardHeight()) + 'px';
        this.titleStyle = {
            '-webkit-line-clamp': this.titleLines,
            height: this.calculateTitleHeight() + 'px',
            'margin-bottom': this.calculateTitleMarginBottom() + 'px'
        };
    }
    calculateCardHeight() {
        return this.cardBaseHeight + this.calculateTitleHeight(true);
    }
    calculateTitleHeight(includeMargin = false) {
        return this.titleLines * this.titleLineHeight + (includeMargin ? this.calculateTitleMarginBottom() : 0);
    }
    calculateTitleMarginBottom() {
        return this.titleBaseMarginBottom + (this.titleLines - 1) * this.titleSpacingCoefficient;
    }
    /** @ignore */
    onAllItemsLinkClick(event) {
        event.preventDefault();
        this.onCardClicked(this.item);
        this.linkClicked.emit({
            link: deepCopy(this.item.linkToAll)
        });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCardLandscapeComponent, deps: [{ token: i1.SieIconRegistryService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiCardLandscapeComponent, selector: "sie-ui-card-landscape", inputs: { item: "item", slideIndex: "slideIndex", target: "target", theme: "theme", locale: "locale", height: "height", titleLines: "titleLines", showMedia: "showMedia", containerStyled: ["containerStyled", "containerStyled", booleanAttribute] }, outputs: { cardChildActionClicked: "cardChildActionClicked", linkClicked: "linkClicked", cardClicked: "cardClicked" }, usesOnChanges: true, ngImport: i0, template: "<div\n  class=\"card-wrapper\"\n  [ngClass]=\"{ 'no-media': !showMedia, 'landscape-card-container': containerStyled }\"\n  [attr.data-ste-component]=\"'tile-' + item.type\"\n  [sieCoreAttributes]=\"item.dataAttributes\"\n>\n  <a\n    class=\"card-landscape__link\"\n    [href]=\"item.linkToItem\"\n    [ngClass]=\"{ 'no-link': !item.linkToItem }\"\n    [attr.data-ste-teaser-type]=\"'lsm-' + item.type\"\n    [attr.data-ste-teaser-index]=\"slideIndex + 1\"\n    [attr.data-ste-teaser-title]=\"item.title\"\n    [attr.data-ste-href]=\"item.linkToItem\"\n    (click)=\"$event.preventDefault(); onNavigateLink(item.linkToItem)\"\n    (keyup.enter)=\"$event.preventDefault(); onNavigateLink(item.linkToItem)\"\n  >\n    <article class=\"card-landscape {{ theme }}\" [ngStyle]=\"{ height: cardHeight }\">\n      <div *ngIf=\"showMedia\" class=\"card-landscape__media-container\">\n        <img\n          loading=\"lazy\"\n          class=\"card-landscape__media-container-bg\"\n          src=\"data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAMAAAAECAQAAADhJE2MAAAADklEQVR42mNkAANGbBQAAGIABUN3+8IAAAAASUVORK5CYII=\"\n          alt=\"background\"\n          width=\"3\"\n          height=\"4\"\n        />\n        <sie-icon svgClass=\"card-landscape__media-icon\" [name]=\"iconName\"></sie-icon>\n      </div>\n      <div class=\"card-landscape__body\">\n        <header>\n          <div class=\"card-landscape__meta\">\n            <sie-ui-tag class=\"card-landscape__tag\" status=\"neutral\" sieCoreAddTooltip>\n              {{ item.tagLabel }}\n            </sie-ui-tag>\n            <span class=\"card-landscape__meta--primary\" sieCoreAddTooltip>{{\n              item.documentDate | sieDate: locale\n            }}</span>\n          </div>\n          <h3 class=\"card-landscape__headline\" [ngStyle]=\"titleStyle\" sieCoreAddTooltip>{{ item.title }}</h3>\n        </header>\n        <footer class=\"card-landscape__footer\">\n          <span class=\"card-landscape__meta--secondary\">\n            <ng-container *ngIf=\"item.version\" sieCoreAddTooltip>{{ item.version }}</ng-container>\n          </span>\n          <div class=\"card-landscape__rating\">\n            <sie-ui-rating-stars\n              [rating]=\"item.rating\"\n              [tooltip]=\"item.tooltipLabel\"\n              [ratingCount]=\"item.ratingCount\"\n              [locale]=\"locale\"\n            ></sie-ui-rating-stars>\n          </div>\n        </footer>\n      </div>\n    </article>\n  </a>\n  <sie-ui-menu-button\n    *ngIf=\"item.childActions?.length\"\n    class=\"card-landscape__menu-button\"\n    (click)=\"$event.stopPropagation()\"\n    [options]=\"item.childActions\"\n    (actionClicked)=\"onChildActionClicked($event, item)\"\n    (keyup.enter)=\"$event.stopPropagation()\"\n  ></sie-ui-menu-button>\n</div>\n<sie-ui-link\n  *ngIf=\"!!item.linkToAll\"\n  [href]=\"item.linkToAll.type === 'url' ? item.linkToAll.href : item.linkToAll.route\"\n  [attr.data-ste-component]=\"'seeall-' + item.type\"\n  offsetIcon\n  (clicked)=\"onAllItemsLinkClick($event)\"\n  >{{ item.linkToAll.label }}</sie-ui-link\n>\n", styles: [".card-landscape__link{outline:none;outline-offset:0}@media (pointer: fine){.card-landscape__link{position:relative}.card-landscape__link:focus{outline:1px solid #1491eb;outline-offset:2px}.card-landscape__link:focus:not(:focus-visible){outline:0}.card-landscape__link:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}:host{display:block}.landscape-card-container{container:landscape-card-container/inline-size}.card-wrapper{position:relative;height:inherit;max-width:550px;min-height:136px;max-height:200px}.card-wrapper.no-media{max-width:400px}.card-landscape{display:flex;flex-direction:row;border:1px solid #ccccd4;margin-bottom:6px;background-color:#fff;height:inherit;text-decoration:none;color:#000028;cursor:pointer;box-shadow:0 2px 2px #0000000f,0 6px 8px #00000014}.card-landscape__link{display:block}.card-landscape__link.no-link{cursor:default}.card-landscape__media-container{position:relative;height:100%}.card-landscape__media-container-bg{height:100%;width:auto}.card-landscape__media-icon{width:40px;height:40px;display:flex;align-items:center;fill:currentColor;position:absolute;left:50%;top:50%;transform:translate(-50%,-50%);color:#fff}.card-landscape__media-icon svg{fill:currentColor;width:inherit;height:inherit}.card-landscape__media-icon svg g{fill:currentColor;width:inherit;height:inherit}.card-landscape__media-icon svg text{font-family:Siemens Sans,sans-serif}.card-landscape__body{position:relative;display:flex;flex-direction:column;justify-content:space-between;flex:1;padding:16px;min-width:280px;max-width:400px}.card-landscape__tag{display:inline-block;white-space:nowrap}.card-landscape__meta{display:flex;align-items:center}.card-landscape__meta--primary{font-size:.875rem;font-weight:400;line-height:1.25rem;white-space:nowrap;overflow:hidden;text-overflow:ellipsis;margin-left:9px;color:#9999a9}.card-landscape__meta--secondary{white-space:nowrap;overflow:hidden;text-overflow:ellipsis}.card-landscape__menu-button{position:absolute;right:1px;top:5px;margin-left:8px}.card-landscape__headline{font-size:1.25rem;font-weight:900;line-height:1.625rem;display:-webkit-box;-webkit-box-orient:vertical;-webkit-line-clamp:2;text-overflow:ellipsis;overflow:hidden;word-break:break-word;margin-top:14px;color:#000028}@media (min-width: 1024px){.card-landscape__headline{-webkit-line-clamp:3}}@container landscape-card-container (min-width: 1024px){.card-landscape__headline{-webkit-line-clamp:3}}.card-landscape__footer{display:flex;flex-direction:row;justify-content:space-between;align-items:center}.card-landscape__rating{margin-left:8px;margin-bottom:2px;white-space:nowrap}.dark .card-landscape__media-container{background-color:#000028}.light .card-landscape__media-container{background-color:#00557c}sie-ui-link{width:auto}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "component", type: UiTagComponent, selector: "sie-ui-tag", inputs: ["mode", "theme", "status", "tagId", "dataAttrName", "dataAttrValue", "disabled", "croppedTop", "condensed", "linkable", "removeButtonAriaLabel"], outputs: ["selected", "unselected", "removed", "clicked"] }, { kind: "component", type: UiRatingStarsComponent, selector: "sie-ui-rating-stars", inputs: ["tooltip", "ratingCount", "rating", "locale"] }, { kind: "component", type: UiLinkComponent, selector: "sie-ui-link", inputs: ["disabled", "disableVisitedStyle", "hasMarginTop", "offsetIcon", "truncate", "inLinkList", "trailingIcon", "icon", "cssClass", "href", "size", "target", "variant", "background", "type", "reference", "screenReaderText", "secondaryLabel", "download", "dataAttributes", "tooltip", "buttonType"], outputs: ["clicked"] }, { kind: "component", type: UiMenuButtonComponent, selector: "sie-ui-menu-button", inputs: ["menuButtonScreenReaderText", "menuTheme", "menuButtonType", "menuButtonVariant", "menuButtonThemeType", "menuButtonText", "leadingButtonIcon"], outputs: ["actionClicked"] }, { kind: "directive", type: i1$1.AddTooltipDirective, selector: "[sieCoreAddTooltip]" }, { kind: "directive", type: i1$1.AttributeDirective, selector: "[sieCoreAttributes]", inputs: ["sieCoreAttributes"] }, { kind: "pipe", type: i1$1.DatePipe, name: "sieDate" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCardLandscapeComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-card-landscape', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div\n  class=\"card-wrapper\"\n  [ngClass]=\"{ 'no-media': !showMedia, 'landscape-card-container': containerStyled }\"\n  [attr.data-ste-component]=\"'tile-' + item.type\"\n  [sieCoreAttributes]=\"item.dataAttributes\"\n>\n  <a\n    class=\"card-landscape__link\"\n    [href]=\"item.linkToItem\"\n    [ngClass]=\"{ 'no-link': !item.linkToItem }\"\n    [attr.data-ste-teaser-type]=\"'lsm-' + item.type\"\n    [attr.data-ste-teaser-index]=\"slideIndex + 1\"\n    [attr.data-ste-teaser-title]=\"item.title\"\n    [attr.data-ste-href]=\"item.linkToItem\"\n    (click)=\"$event.preventDefault(); onNavigateLink(item.linkToItem)\"\n    (keyup.enter)=\"$event.preventDefault(); onNavigateLink(item.linkToItem)\"\n  >\n    <article class=\"card-landscape {{ theme }}\" [ngStyle]=\"{ height: cardHeight }\">\n      <div *ngIf=\"showMedia\" class=\"card-landscape__media-container\">\n        <img\n          loading=\"lazy\"\n          class=\"card-landscape__media-container-bg\"\n          src=\"data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAMAAAAECAQAAADhJE2MAAAADklEQVR42mNkAANGbBQAAGIABUN3+8IAAAAASUVORK5CYII=\"\n          alt=\"background\"\n          width=\"3\"\n          height=\"4\"\n        />\n        <sie-icon svgClass=\"card-landscape__media-icon\" [name]=\"iconName\"></sie-icon>\n      </div>\n      <div class=\"card-landscape__body\">\n        <header>\n          <div class=\"card-landscape__meta\">\n            <sie-ui-tag class=\"card-landscape__tag\" status=\"neutral\" sieCoreAddTooltip>\n              {{ item.tagLabel }}\n            </sie-ui-tag>\n            <span class=\"card-landscape__meta--primary\" sieCoreAddTooltip>{{\n              item.documentDate | sieDate: locale\n            }}</span>\n          </div>\n          <h3 class=\"card-landscape__headline\" [ngStyle]=\"titleStyle\" sieCoreAddTooltip>{{ item.title }}</h3>\n        </header>\n        <footer class=\"card-landscape__footer\">\n          <span class=\"card-landscape__meta--secondary\">\n            <ng-container *ngIf=\"item.version\" sieCoreAddTooltip>{{ item.version }}</ng-container>\n          </span>\n          <div class=\"card-landscape__rating\">\n            <sie-ui-rating-stars\n              [rating]=\"item.rating\"\n              [tooltip]=\"item.tooltipLabel\"\n              [ratingCount]=\"item.ratingCount\"\n              [locale]=\"locale\"\n            ></sie-ui-rating-stars>\n          </div>\n        </footer>\n      </div>\n    </article>\n  </a>\n  <sie-ui-menu-button\n    *ngIf=\"item.childActions?.length\"\n    class=\"card-landscape__menu-button\"\n    (click)=\"$event.stopPropagation()\"\n    [options]=\"item.childActions\"\n    (actionClicked)=\"onChildActionClicked($event, item)\"\n    (keyup.enter)=\"$event.stopPropagation()\"\n  ></sie-ui-menu-button>\n</div>\n<sie-ui-link\n  *ngIf=\"!!item.linkToAll\"\n  [href]=\"item.linkToAll.type === 'url' ? item.linkToAll.href : item.linkToAll.route\"\n  [attr.data-ste-component]=\"'seeall-' + item.type\"\n  offsetIcon\n  (clicked)=\"onAllItemsLinkClick($event)\"\n  >{{ item.linkToAll.label }}</sie-ui-link\n>\n", styles: [".card-landscape__link{outline:none;outline-offset:0}@media (pointer: fine){.card-landscape__link{position:relative}.card-landscape__link:focus{outline:1px solid #1491eb;outline-offset:2px}.card-landscape__link:focus:not(:focus-visible){outline:0}.card-landscape__link:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}:host{display:block}.landscape-card-container{container:landscape-card-container/inline-size}.card-wrapper{position:relative;height:inherit;max-width:550px;min-height:136px;max-height:200px}.card-wrapper.no-media{max-width:400px}.card-landscape{display:flex;flex-direction:row;border:1px solid #ccccd4;margin-bottom:6px;background-color:#fff;height:inherit;text-decoration:none;color:#000028;cursor:pointer;box-shadow:0 2px 2px #0000000f,0 6px 8px #00000014}.card-landscape__link{display:block}.card-landscape__link.no-link{cursor:default}.card-landscape__media-container{position:relative;height:100%}.card-landscape__media-container-bg{height:100%;width:auto}.card-landscape__media-icon{width:40px;height:40px;display:flex;align-items:center;fill:currentColor;position:absolute;left:50%;top:50%;transform:translate(-50%,-50%);color:#fff}.card-landscape__media-icon svg{fill:currentColor;width:inherit;height:inherit}.card-landscape__media-icon svg g{fill:currentColor;width:inherit;height:inherit}.card-landscape__media-icon svg text{font-family:Siemens Sans,sans-serif}.card-landscape__body{position:relative;display:flex;flex-direction:column;justify-content:space-between;flex:1;padding:16px;min-width:280px;max-width:400px}.card-landscape__tag{display:inline-block;white-space:nowrap}.card-landscape__meta{display:flex;align-items:center}.card-landscape__meta--primary{font-size:.875rem;font-weight:400;line-height:1.25rem;white-space:nowrap;overflow:hidden;text-overflow:ellipsis;margin-left:9px;color:#9999a9}.card-landscape__meta--secondary{white-space:nowrap;overflow:hidden;text-overflow:ellipsis}.card-landscape__menu-button{position:absolute;right:1px;top:5px;margin-left:8px}.card-landscape__headline{font-size:1.25rem;font-weight:900;line-height:1.625rem;display:-webkit-box;-webkit-box-orient:vertical;-webkit-line-clamp:2;text-overflow:ellipsis;overflow:hidden;word-break:break-word;margin-top:14px;color:#000028}@media (min-width: 1024px){.card-landscape__headline{-webkit-line-clamp:3}}@container landscape-card-container (min-width: 1024px){.card-landscape__headline{-webkit-line-clamp:3}}.card-landscape__footer{display:flex;flex-direction:row;justify-content:space-between;align-items:center}.card-landscape__rating{margin-left:8px;margin-bottom:2px;white-space:nowrap}.dark .card-landscape__media-container{background-color:#000028}.light .card-landscape__media-container{background-color:#00557c}sie-ui-link{width:auto}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }]; }, propDecorators: { item: [{
                type: Input
            }], slideIndex: [{
                type: Input
            }], target: [{
                type: Input
            }], theme: [{
                type: Input
            }], locale: [{
                type: Input
            }], height: [{
                type: Input
            }], titleLines: [{
                type: Input
            }], showMedia: [{
                type: Input
            }], containerStyled: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], cardChildActionClicked: [{
                type: Output
            }], linkClicked: [{
                type: Output
            }], cardClicked: [{
                type: Output
            }] } });

/**
 * # Card Landscape Module
 * - {@link UiCardLandscapeComponent}
 *
 * ## Module peer dependencies
 * - {@link SieIconsModule}
 */
class UiCardLandscapeModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCardLandscapeModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiCardLandscapeModule, declarations: [UiCardLandscapeComponent], imports: [CommonModule,
            SieIconsModule,
            UiTagModule,
            UiRatingStarsModule,
            UiLinkModule,
            UiMenuButtonModule,
            SieCorePipesModule,
            AddTooltipModule,
            AttributeModule], exports: [UiCardLandscapeComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCardLandscapeModule, imports: [CommonModule,
            SieIconsModule,
            UiTagModule,
            UiRatingStarsModule,
            UiLinkModule,
            UiMenuButtonModule,
            SieCorePipesModule,
            AddTooltipModule,
            AttributeModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCardLandscapeModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiCardLandscapeComponent],
                    imports: [
                        CommonModule,
                        SieIconsModule,
                        UiTagModule,
                        UiRatingStarsModule,
                        UiLinkModule,
                        UiMenuButtonModule,
                        SieCorePipesModule,
                        AddTooltipModule,
                        AttributeModule
                    ],
                    exports: [UiCardLandscapeComponent]
                }]
        }] });

/**
 * # Card Portrait Component
 *
 * Cards are used to take a sneak peek at some type of content(e.g. product information).
 * Usually, it holds marketing or promotional material. There are two types of cards: Portrait and Landscape.
 *
 * ## Component variations
 *
 * Card Portrait is vertically oriented. It has an image describing the topic of the content.
 * Holds additional descriptive copy or a list of benefits, and has the button that triggers some kind of action
 * (e.g. plays a video).
 *
 * ## Content
 *
 * The card portrait component does not accept any content.
 *
 * ## Code example
 * @example
 * Template:
 * ```html
 * <sie-ui-card-portrait [item]="cardPortraitItem"><sie-ui-card-portrait>
 * ````
 *
 * Card Portrait item example:
 * ``` js
 * const cardPortraitItem = {
 *  picture: {
 *   mode: 'cover',
 *   urlLarge:
 *     'https://assets.new.siemens.com/siemens/assets/api/uuid:7a2780b6-d058-4e8d-9acc-eb3daa974c00/width:1920/quality:HIGH/Siemens-WinCC-Unified-Software-Visual.jpg',
 *   urlMedium:
 *     'https://assets.new.siemens.com/siemens/assets/api/uuid:7a2780b6-d058-4e8d-9acc-eb3daa974c00/width:1280/quality:MEDIUM/Siemens-WinCC-Unified-Software-Visual.jpg',
 *   urlSmall:
 *     'https://assets.new.siemens.com/siemens/assets/api/uuid:7a2780b6-d058-4e8d-9acc-eb3daa974c00/width:640/quality:LOW/Siemens-WinCC-Unified-Software-Visual.jpg',
 *   altText: 'Image Description'
 *  },
 *  benefits: [
 *   'Latest technology with proven engineering',
 *   'Simple and unlimited scalability',
 *   'Runs any time, in different environments'
 *  ],
 *  itemType: 'certificate',
 *  button: {
 *   id: '',
 *   label: 'Buy now',
 *   link: 'https://mall.industry.siemens.com/mall/de/de/Catalog/Products/10364582',
 *   variant: 'secondary',
 *   background: 'light',
 *   icon: 'ShoppingCart',
 *   iconPosition: 'leading',
 *   buttonType: 'link',
 *   target: '_self'
 *  },
 *  showPrice: false,
 *  title: 'Card with image mode "Covered"',
 *  visualTag: '',
 *  description: '',
 *  childActions: [
 *     {
 *      value: '...',
 *       label: 'Edit'
 *     }
 *   ]
 *  };
 *```
 */
class UiCardPortraitComponent {
    constructor(iconReg) {
        this.iconReg = iconReg;
        /**
         * Defines if container-queries or media-queries are used for the card styling
         * @default false
         */
        this.containerStyled = false;
        /**
         * {@link UiButtonClickModel Event} triggered when the button is clicked.
         */
        this.buttonClick = new Subject();
        /**
         * {@link UiChildActionEventModel Event} triggered when the action in the dropdown is clicked or selected via keyboard
         * (options button on the card).
         */
        this.cardChildActionClicked = new EventEmitter();
        /**
         * {@link UiCardPortraitModel Event} triggered when card is clicked
         */
        this.cardClicked = new EventEmitter();
        iconReg.register(SieIcon.CheckMark);
    }
    /** @ignore */
    onButtonClick(event) {
        this.onCardClicked(this.item);
        this.buttonClick.next(deepCopy({ button: this.item.button, event }));
    }
    /** @ignore */
    navigateLink(href) {
        if (!href) {
            return;
        }
        this.onCardClicked(this.item);
        window.open(href, '_self');
    }
    /** @ignore */
    onCardClicked(item, event) {
        if (event) {
            event.stopPropagation();
        }
        this.cardClicked.emit(item);
    }
    /** @ignore */
    dropdownOptionSelected(button, item) {
        this.cardChildActionClicked.emit({ button, item });
    }
    /** @ignore */
    getLongHeadlineClass(item) {
        let longText = true;
        if (item.benefits?.length > 0 || (item.description && item.description !== '')) {
            longText = false;
        }
        return { 'card-portrait__headline--long': longText };
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCardPortraitComponent, deps: [{ token: i1.SieIconRegistryService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiCardPortraitComponent, selector: "sie-ui-card-portrait", inputs: { item: "item", menuButtonScreenReaderText: "menuButtonScreenReaderText", containerStyled: ["containerStyled", "containerStyled", booleanAttribute] }, outputs: { buttonClick: "buttonClick", cardChildActionClicked: "cardChildActionClicked", cardClicked: "cardClicked" }, ngImport: i0, template: "<div\n  class=\"card-portrait__wrapper\"\n  [ngClass]=\"{\n    'card-portrait__link--main': !!item.button,\n    'container-layout': containerStyled\n  }\"\n  [attr.role]=\"!!item.button?.link ? 'link' : null\"\n  [sieCoreAttributes]=\"item.dataAttributes\"\n  (keydown.enter)=\"navigateLink(item.button?.link)\"\n  (click)=\"navigateLink(item.button?.link)\"\n  tabindex=\"0\"\n>\n  <article class=\"card-portrait\">\n    <figure class=\"card-portrait__media\" [class.margin-bottom]=\"!item.childActions?.length\">\n      <a\n        *ngIf=\"!!item.button?.link; else picture\"\n        (click)=\"onCardClicked(item, $event)\"\n        (keydown.enter)=\"$event.stopPropagation()\"\n        [attr.href]=\"item.button.link\"\n        class=\"card-portrait__link\"\n        target=\"_self\"\n        rel=\"noopener\"\n      >\n        <ng-container [ngTemplateOutlet]=\"picture\"></ng-container>\n      </a>\n    </figure>\n    <sie-ui-tag *ngIf=\"item.visualTag\" class=\"card-portrait__tag\" status=\"neutral\" [croppedTop]=\"true\">\n      {{ item.visualTag }}\n    </sie-ui-tag>\n    <section class=\"card-portrait__content card-portrait__content--has-button\">\n      <div class=\"card-portrait__meta-wrapper\" [class.flex-end]=\"!primaryMetaPlaceholder\">\n        <p *ngIf=\"primaryMetaPlaceholder\" class=\"card-portrait__meta--primary\" sieCoreAddTooltip>\n          {{ primaryMetaPlaceholder }}\n        </p>\n        <sie-ui-menu-button\n          *ngIf=\"item.childActions?.length\"\n          class=\"card-portrait__menu-button\"\n          (click)=\"$event.stopPropagation()\"\n          [options]=\"item.childActions\"\n          (actionClicked)=\"dropdownOptionSelected($event, item)\"\n          (keydown.enter)=\"$event.stopPropagation()\"\n          [menuButtonScreenReaderText]=\"menuButtonScreenReaderText\"\n        ></sie-ui-menu-button>\n      </div>\n      <h3 class=\"card-portrait__headline\" [ngClass]=\"getLongHeadlineClass(item)\" sieCoreAddTooltip>\n        {{ item.title }}\n      </h3>\n      <div class=\"card-portrait__copy-container\">\n        <p class=\"card-portrait__copy-text\" *ngIf=\"item.description\" sieCoreAddTooltip>\n          {{ item.description }}\n        </p>\n        <ul\n          sie-ui-benefits\n          *ngIf=\"item.benefits?.length\"\n          class=\"card-portrait__list\"\n          [ngClass]=\"{ 'has-margin': item.showPrice }\"\n          [benefits]=\"item.benefits\"\n          [attr.data-truncate-group-name]=\"'benefits'\"\n          [attr.data-truncate-max-lines-per-item]=\"3\"\n          [attr.data-truncate-max-lines-per-group]=\"4\"\n          [attr.data-truncate-limited-trough-group]=\"true\"\n          [useTruncation]=\"true\"\n          [truncationPrioOffset]=\"1\"\n          [truncationGroupName]=\"'benefits'\"\n          sieCoreTruncate\n        ></ul>\n\n        <span class=\"card-portrait__price-tag\" *ngIf=\"item.showPrice\">1,420.00 &euro;</span>\n        <p class=\"card-portrait__meta--secondary\" *ngIf=\"item.showPrice\">Hint Text Lorem Ipsum</p>\n      </div>\n    </section>\n\n    <footer class=\"card-portrait__footer\">\n      <sie-ui-button-wrapper\n        *ngIf=\"!!item.button?.buttonType\"\n        [model]=\"item.button\"\n        (click)=\"$event.stopPropagation()\"\n        (keydown.enter)=\"$event.stopPropagation()\"\n        (clicked)=\"onButtonClick($event)\"\n        sieCoreAddTooltip\n      >\n        {{ item.button.label }}\n      </sie-ui-button-wrapper>\n    </footer>\n  </article>\n</div>\n\n<ng-template #picture>\n  <sie-ui-picture\n    ratio=\"16-9\"\n    [model]=\"item.picture\"\n    [context]=\"item.itemType\"\n    [shouldHaveOutline]=\"false\"\n  ></sie-ui-picture>\n</ng-template>\n", styles: [".card-portrait__link--main,.card-portrait__link{outline:none;outline-offset:0}@media (pointer: fine){.card-portrait__link--main,.card-portrait__link{position:relative}.card-portrait__link--main:focus,.card-portrait__link:focus{outline:1px solid #1491eb;outline-offset:2px}.card-portrait__link--main:focus:not(:focus-visible),.card-portrait__link:focus:not(:focus-visible){outline:0}.card-portrait__link--main:focus-visible,.card-portrait__link:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}:host{display:block}.card-portrait{position:relative;display:flex;flex-direction:column;height:520px;background:#fff;border:1px solid #ccccd4;box-shadow:0 2px 2px #0000000f,0 6px 8px #00000014}.card-portrait__media{margin:0}.card-portrait__media.margin-bottom{margin-bottom:24px}.card-portrait__wrapper{min-width:280px;max-width:400px}@media (min-width: 1024px){.card-portrait__wrapper:not(.container-layout) .card-portrait{height:580px}}@container shared-container (min-width: 1024px){.card-portrait__wrapper.container-layout .card-portrait{height:580px}}.card-portrait__link{text-decoration:none;color:inherit;display:block;height:100%}.card-portrait__link--main{cursor:pointer}.card-portrait__tag{font-size:1rem;font-weight:400;line-height:1.5rem;position:absolute;top:0;left:16px;z-index:10}.card-portrait__content{height:100%;padding:0 20px 0 24px}.card-portrait__meta-wrapper{display:flex;justify-content:space-between;align-items:flex-end}.card-portrait__meta-wrapper.flex-end{justify-content:flex-end}.card-portrait__menu-button{margin-right:-20px}.card-portrait__meta--primary{font-size:.875rem;font-weight:400;line-height:1.25rem;margin-bottom:16px;color:#9999a9}.card-portrait__meta--primary:last-child{margin-bottom:0}.card-portrait__meta--secondary{font-size:.75rem;font-weight:400;line-height:1rem;color:#ccccd4}.card-portrait__headline{font-size:1.25rem;font-weight:900;line-height:1.625rem;display:-webkit-box;-webkit-box-orient:vertical;-webkit-line-clamp:2;min-height:52px;margin-bottom:8px;color:#000028;overflow:hidden;text-overflow:ellipsis}.card-portrait__headline--long{-webkit-line-clamp:5}.card-portrait__copy-text{display:-webkit-box;-webkit-box-orient:vertical;-webkit-line-clamp:5;max-height:120px;color:#000028;overflow:hidden}.card-portrait__copy-text+.card-portrait__copy-text__meta--primary{margin-bottom:32px}.card-portrait__list{list-style:none;margin:0;padding:0;overflow:hidden}.card-portrait__list:empty{display:none}.card-portrait__list.has-margin{margin-bottom:16px}.card-portrait__price-tag{font-size:1.625rem;font-weight:700;line-height:2.25rem;line-height:2.125rem;font-weight:900;letter-spacing:-.03125rem;color:#000028}.card-portrait__footer{padding:28px 20px 24px 24px}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "component", type: UiButtonWrapperComponent, selector: "sie-ui-button-wrapper", inputs: ["model"], outputs: ["clicked"] }, { kind: "component", type: UiPictureComponent, selector: "sie-ui-picture", inputs: ["model", "size", "ratio", "notLoadedLabel", "theme", "context", "caption", "shouldHaveOutline"], outputs: ["failedToLoadImg"] }, { kind: "component", type: UiTagComponent, selector: "sie-ui-tag", inputs: ["mode", "theme", "status", "tagId", "dataAttrName", "dataAttrValue", "disabled", "croppedTop", "condensed", "linkable", "removeButtonAriaLabel"], outputs: ["selected", "unselected", "removed", "clicked"] }, { kind: "component", type: UiBenefitsComponent, selector: "ul[sie-ui-benefits]", inputs: ["benefits", "useTruncation", "truncationPrioOffset", "truncationGroupName"] }, { kind: "component", type: UiMenuButtonComponent, selector: "sie-ui-menu-button", inputs: ["menuButtonScreenReaderText", "menuTheme", "menuButtonType", "menuButtonVariant", "menuButtonThemeType", "menuButtonText", "leadingButtonIcon"], outputs: ["actionClicked"] }, { kind: "directive", type: i1$1.AddTooltipDirective, selector: "[sieCoreAddTooltip]" }, { kind: "directive", type: i1$1.TruncateDirective, selector: "[sieCoreTruncate]" }, { kind: "directive", type: i1$1.AttributeDirective, selector: "[sieCoreAttributes]", inputs: ["sieCoreAttributes"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCardPortraitComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-card-portrait', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div\n  class=\"card-portrait__wrapper\"\n  [ngClass]=\"{\n    'card-portrait__link--main': !!item.button,\n    'container-layout': containerStyled\n  }\"\n  [attr.role]=\"!!item.button?.link ? 'link' : null\"\n  [sieCoreAttributes]=\"item.dataAttributes\"\n  (keydown.enter)=\"navigateLink(item.button?.link)\"\n  (click)=\"navigateLink(item.button?.link)\"\n  tabindex=\"0\"\n>\n  <article class=\"card-portrait\">\n    <figure class=\"card-portrait__media\" [class.margin-bottom]=\"!item.childActions?.length\">\n      <a\n        *ngIf=\"!!item.button?.link; else picture\"\n        (click)=\"onCardClicked(item, $event)\"\n        (keydown.enter)=\"$event.stopPropagation()\"\n        [attr.href]=\"item.button.link\"\n        class=\"card-portrait__link\"\n        target=\"_self\"\n        rel=\"noopener\"\n      >\n        <ng-container [ngTemplateOutlet]=\"picture\"></ng-container>\n      </a>\n    </figure>\n    <sie-ui-tag *ngIf=\"item.visualTag\" class=\"card-portrait__tag\" status=\"neutral\" [croppedTop]=\"true\">\n      {{ item.visualTag }}\n    </sie-ui-tag>\n    <section class=\"card-portrait__content card-portrait__content--has-button\">\n      <div class=\"card-portrait__meta-wrapper\" [class.flex-end]=\"!primaryMetaPlaceholder\">\n        <p *ngIf=\"primaryMetaPlaceholder\" class=\"card-portrait__meta--primary\" sieCoreAddTooltip>\n          {{ primaryMetaPlaceholder }}\n        </p>\n        <sie-ui-menu-button\n          *ngIf=\"item.childActions?.length\"\n          class=\"card-portrait__menu-button\"\n          (click)=\"$event.stopPropagation()\"\n          [options]=\"item.childActions\"\n          (actionClicked)=\"dropdownOptionSelected($event, item)\"\n          (keydown.enter)=\"$event.stopPropagation()\"\n          [menuButtonScreenReaderText]=\"menuButtonScreenReaderText\"\n        ></sie-ui-menu-button>\n      </div>\n      <h3 class=\"card-portrait__headline\" [ngClass]=\"getLongHeadlineClass(item)\" sieCoreAddTooltip>\n        {{ item.title }}\n      </h3>\n      <div class=\"card-portrait__copy-container\">\n        <p class=\"card-portrait__copy-text\" *ngIf=\"item.description\" sieCoreAddTooltip>\n          {{ item.description }}\n        </p>\n        <ul\n          sie-ui-benefits\n          *ngIf=\"item.benefits?.length\"\n          class=\"card-portrait__list\"\n          [ngClass]=\"{ 'has-margin': item.showPrice }\"\n          [benefits]=\"item.benefits\"\n          [attr.data-truncate-group-name]=\"'benefits'\"\n          [attr.data-truncate-max-lines-per-item]=\"3\"\n          [attr.data-truncate-max-lines-per-group]=\"4\"\n          [attr.data-truncate-limited-trough-group]=\"true\"\n          [useTruncation]=\"true\"\n          [truncationPrioOffset]=\"1\"\n          [truncationGroupName]=\"'benefits'\"\n          sieCoreTruncate\n        ></ul>\n\n        <span class=\"card-portrait__price-tag\" *ngIf=\"item.showPrice\">1,420.00 &euro;</span>\n        <p class=\"card-portrait__meta--secondary\" *ngIf=\"item.showPrice\">Hint Text Lorem Ipsum</p>\n      </div>\n    </section>\n\n    <footer class=\"card-portrait__footer\">\n      <sie-ui-button-wrapper\n        *ngIf=\"!!item.button?.buttonType\"\n        [model]=\"item.button\"\n        (click)=\"$event.stopPropagation()\"\n        (keydown.enter)=\"$event.stopPropagation()\"\n        (clicked)=\"onButtonClick($event)\"\n        sieCoreAddTooltip\n      >\n        {{ item.button.label }}\n      </sie-ui-button-wrapper>\n    </footer>\n  </article>\n</div>\n\n<ng-template #picture>\n  <sie-ui-picture\n    ratio=\"16-9\"\n    [model]=\"item.picture\"\n    [context]=\"item.itemType\"\n    [shouldHaveOutline]=\"false\"\n  ></sie-ui-picture>\n</ng-template>\n", styles: [".card-portrait__link--main,.card-portrait__link{outline:none;outline-offset:0}@media (pointer: fine){.card-portrait__link--main,.card-portrait__link{position:relative}.card-portrait__link--main:focus,.card-portrait__link:focus{outline:1px solid #1491eb;outline-offset:2px}.card-portrait__link--main:focus:not(:focus-visible),.card-portrait__link:focus:not(:focus-visible){outline:0}.card-portrait__link--main:focus-visible,.card-portrait__link:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}:host{display:block}.card-portrait{position:relative;display:flex;flex-direction:column;height:520px;background:#fff;border:1px solid #ccccd4;box-shadow:0 2px 2px #0000000f,0 6px 8px #00000014}.card-portrait__media{margin:0}.card-portrait__media.margin-bottom{margin-bottom:24px}.card-portrait__wrapper{min-width:280px;max-width:400px}@media (min-width: 1024px){.card-portrait__wrapper:not(.container-layout) .card-portrait{height:580px}}@container shared-container (min-width: 1024px){.card-portrait__wrapper.container-layout .card-portrait{height:580px}}.card-portrait__link{text-decoration:none;color:inherit;display:block;height:100%}.card-portrait__link--main{cursor:pointer}.card-portrait__tag{font-size:1rem;font-weight:400;line-height:1.5rem;position:absolute;top:0;left:16px;z-index:10}.card-portrait__content{height:100%;padding:0 20px 0 24px}.card-portrait__meta-wrapper{display:flex;justify-content:space-between;align-items:flex-end}.card-portrait__meta-wrapper.flex-end{justify-content:flex-end}.card-portrait__menu-button{margin-right:-20px}.card-portrait__meta--primary{font-size:.875rem;font-weight:400;line-height:1.25rem;margin-bottom:16px;color:#9999a9}.card-portrait__meta--primary:last-child{margin-bottom:0}.card-portrait__meta--secondary{font-size:.75rem;font-weight:400;line-height:1rem;color:#ccccd4}.card-portrait__headline{font-size:1.25rem;font-weight:900;line-height:1.625rem;display:-webkit-box;-webkit-box-orient:vertical;-webkit-line-clamp:2;min-height:52px;margin-bottom:8px;color:#000028;overflow:hidden;text-overflow:ellipsis}.card-portrait__headline--long{-webkit-line-clamp:5}.card-portrait__copy-text{display:-webkit-box;-webkit-box-orient:vertical;-webkit-line-clamp:5;max-height:120px;color:#000028;overflow:hidden}.card-portrait__copy-text+.card-portrait__copy-text__meta--primary{margin-bottom:32px}.card-portrait__list{list-style:none;margin:0;padding:0;overflow:hidden}.card-portrait__list:empty{display:none}.card-portrait__list.has-margin{margin-bottom:16px}.card-portrait__price-tag{font-size:1.625rem;font-weight:700;line-height:2.25rem;line-height:2.125rem;font-weight:900;letter-spacing:-.03125rem;color:#000028}.card-portrait__footer{padding:28px 20px 24px 24px}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }]; }, propDecorators: { item: [{
                type: Input
            }], menuButtonScreenReaderText: [{
                type: Input
            }], containerStyled: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], buttonClick: [{
                type: Output
            }], cardChildActionClicked: [{
                type: Output
            }], cardClicked: [{
                type: Output
            }] } });

/**
 * # Card Portrait Module
 * - {@link UiCardPortraitComponent}
 *
 * ## Module peer dependencies
 * - {@link SieIconsModule}
 */
class UiCardPortraitModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCardPortraitModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiCardPortraitModule, declarations: [UiCardPortraitComponent], imports: [CommonModule,
            UiButtonModule,
            UiPictureModule,
            UiTagModule,
            UiBenefitsModule,
            UiMenuButtonModule,
            AddTooltipModule,
            TruncateModule,
            AttributeModule], exports: [UiCardPortraitComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCardPortraitModule, imports: [CommonModule,
            UiButtonModule,
            UiPictureModule,
            UiTagModule,
            UiBenefitsModule,
            UiMenuButtonModule,
            AddTooltipModule,
            TruncateModule,
            AttributeModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCardPortraitModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiCardPortraitComponent],
                    imports: [
                        CommonModule,
                        UiButtonModule,
                        UiPictureModule,
                        UiTagModule,
                        UiBenefitsModule,
                        UiMenuButtonModule,
                        AddTooltipModule,
                        TruncateModule,
                        AttributeModule
                    ],
                    exports: [UiCardPortraitComponent]
                }]
        }] });

class UiCardSupportMaterialComponent {
    constructor(iconReg) {
        this.iconReg = iconReg;
        this.theme = 'light';
        this.target = '_self';
        /**
         * Defines if container-queries or media-queries are used for the card styling
         * @default false
         */
        this.containerStyled = false;
        this.cardChildActionClicked = new EventEmitter();
        this.cardClicked = new EventEmitter();
        this.iconName = null;
    }
    ngOnInit() {
        this.iconName = API_ICON_MAPPING[this.item.type];
        if (!this.iconName) {
            this.iconName = SieIcon.File;
        }
        this.iconReg.register(this.iconName);
    }
    navigateLink(href) {
        window.open(href, this.target);
    }
    /** @ignore */
    onCardClicked(item) {
        this.cardClicked.emit(item);
        this.navigateLink(item.linkToItem);
    }
    dropdownOptionSelected(button, item) {
        this.cardChildActionClicked.emit({ button, item });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCardSupportMaterialComponent, deps: [{ token: i1.SieIconRegistryService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiCardSupportMaterialComponent, selector: "sie-ui-card-support-material", inputs: { item: "item", menuButtonScreenReaderText: "menuButtonScreenReaderText", theme: "theme", target: "target", locale: "locale", containerStyled: ["containerStyled", "containerStyled", booleanAttribute] }, outputs: { cardChildActionClicked: "cardChildActionClicked", cardClicked: "cardClicked" }, ngImport: i0, template: "<div\n  [sieCoreAttributes]=\"item.dataAttributes\"\n  [ngClass]=\"{ 'support-card-container': containerStyled }\"\n  (click)=\"onCardClicked(item)\"\n  (keyup.enter)=\"navigateLink(item.linkToItem)\"\n  tabindex=\"0\"\n  role=\"link\"\n  class=\"card-support-material__link--main\"\n>\n  <article class=\"card-support-material {{ theme }}\">\n    <figure class=\"card-support-material__media\" [class.margin-bottom]=\"!item.childActions?.length\">\n      <span class=\"card-support-material__media-bg\"></span>\n      <sie-icon svgClass=\"card-support-material__media-icon\" [name]=\"iconName\"></sie-icon>\n    </figure>\n    <sie-ui-tag *ngIf=\"item.tagLabel\" class=\"card-support-material__tag\" status=\"neutral\" [croppedTop]=\"true\">\n      {{ item.tagLabel }}\n    </sie-ui-tag>\n    <section class=\"card-support-material__content\">\n      <div class=\"card-support-material__content-header\">\n        <p class=\"card-support-material__meta\" [class.margin-bottom]=\"!item.childActions?.length\">\n          <ng-container *ngIf=\"item.version\" sieCoreAddTooltip>{{ item.version }}</ng-container>\n        </p>\n        <sie-ui-menu-button\n          *ngIf=\"item.childActions?.length\"\n          class=\"card-support-material__menu-button\"\n          (click)=\"$event.stopPropagation()\"\n          [options]=\"item.childActions\"\n          (actionClicked)=\"dropdownOptionSelected($event, item)\"\n          (keyup.enter)=\"$event.stopPropagation()\"\n          [menuButtonScreenReaderText]=\"menuButtonScreenReaderText\"\n        ></sie-ui-menu-button>\n      </div>\n      <h3 class=\"card-support-material__headline\" sieCoreAddTooltip>{{ item.title }}</h3>\n      <div class=\"card-support-material__content-footer\">\n        <span sieCoreAddTooltip>{{ item.documentDate | sieDate: locale }}</span>\n        <sie-ui-rating-stars\n          [rating]=\"item.rating\"\n          [tooltip]=\"item.tooltipLabel\"\n          [ratingCount]=\"item.ratingCount\"\n          [locale]=\"locale\"\n        >\n        </sie-ui-rating-stars>\n      </div>\n    </section>\n  </article>\n</div>\n", styles: [".card-support-material__link--main,.card-support-material__link{outline:none;outline-offset:0}@media (pointer: fine){.card-support-material__link--main,.card-support-material__link{position:relative}.card-support-material__link--main:focus,.card-support-material__link:focus{outline:1px solid #1491eb;outline-offset:2px}.card-support-material__link--main:focus:not(:focus-visible),.card-support-material__link:focus:not(:focus-visible){outline:0}.card-support-material__link--main:focus-visible,.card-support-material__link:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}:host{display:block}.support-card-container{container:support-card-container/inline-size}.card-support-material{position:relative;display:flex;flex-direction:column;height:520px;background:#fff;border:1px solid #ccccd4;box-shadow:0 2px 2px #0000000f,0 6px 8px #00000014}@media (min-width: 1024px){.card-support-material{height:580px}}@container support-card-container (min-width: 1024px){.card-support-material{height:580px}}.card-support-material__media{margin:0;position:relative;display:flex;flex-direction:column}.card-support-material__media-bg{aspect-ratio:16/9;width:100%;height:auto}.card-support-material__media-icon{width:80px;height:80px;display:flex;align-items:center;fill:currentColor;position:absolute;left:50%;top:50%;transform:translate(-50%,-50%);color:#fff}.card-support-material__media-icon svg{fill:currentColor;width:inherit;height:inherit}.card-support-material__media-icon svg g{fill:currentColor;width:inherit;height:inherit}.card-support-material__media-icon svg text{font-family:Siemens Sans,sans-serif}.card-support-material__media.margin-bottom,.card-support-material__meta.margin-bottom{margin-bottom:10px}.card-support-material__link{text-decoration:none;color:inherit;display:block;height:100%}.card-support-material__link--main{min-width:280px;max-width:400px;cursor:pointer}.card-support-material__tag{font-size:1rem;font-weight:400;line-height:1.5rem;position:absolute;top:0;left:16px;z-index:10}.card-support-material__content{height:100%;padding:0 20px 0 24px}.card-support-material__content-header,.card-support-material__content-footer{display:flex;justify-content:space-between;align-items:center}.card-support-material__menu-button{margin-right:-20px}.card-support-material__headline{font-size:1.25rem;font-weight:900;line-height:1.625rem;display:-webkit-box;-webkit-box-orient:vertical;-webkit-line-clamp:2;margin-bottom:16px;color:#000028;overflow:hidden;text-overflow:ellipsis}.dark .card-support-material__media-bg{background-color:#000028}.light .card-support-material__media-bg{background-color:#00557c}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "component", type: UiTagComponent, selector: "sie-ui-tag", inputs: ["mode", "theme", "status", "tagId", "dataAttrName", "dataAttrValue", "disabled", "croppedTop", "condensed", "linkable", "removeButtonAriaLabel"], outputs: ["selected", "unselected", "removed", "clicked"] }, { kind: "component", type: UiRatingStarsComponent, selector: "sie-ui-rating-stars", inputs: ["tooltip", "ratingCount", "rating", "locale"] }, { kind: "component", type: UiMenuButtonComponent, selector: "sie-ui-menu-button", inputs: ["menuButtonScreenReaderText", "menuTheme", "menuButtonType", "menuButtonVariant", "menuButtonThemeType", "menuButtonText", "leadingButtonIcon"], outputs: ["actionClicked"] }, { kind: "directive", type: i1$1.AddTooltipDirective, selector: "[sieCoreAddTooltip]" }, { kind: "directive", type: i1$1.AttributeDirective, selector: "[sieCoreAttributes]", inputs: ["sieCoreAttributes"] }, { kind: "pipe", type: i1$1.DatePipe, name: "sieDate" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCardSupportMaterialComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-card-support-material', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div\n  [sieCoreAttributes]=\"item.dataAttributes\"\n  [ngClass]=\"{ 'support-card-container': containerStyled }\"\n  (click)=\"onCardClicked(item)\"\n  (keyup.enter)=\"navigateLink(item.linkToItem)\"\n  tabindex=\"0\"\n  role=\"link\"\n  class=\"card-support-material__link--main\"\n>\n  <article class=\"card-support-material {{ theme }}\">\n    <figure class=\"card-support-material__media\" [class.margin-bottom]=\"!item.childActions?.length\">\n      <span class=\"card-support-material__media-bg\"></span>\n      <sie-icon svgClass=\"card-support-material__media-icon\" [name]=\"iconName\"></sie-icon>\n    </figure>\n    <sie-ui-tag *ngIf=\"item.tagLabel\" class=\"card-support-material__tag\" status=\"neutral\" [croppedTop]=\"true\">\n      {{ item.tagLabel }}\n    </sie-ui-tag>\n    <section class=\"card-support-material__content\">\n      <div class=\"card-support-material__content-header\">\n        <p class=\"card-support-material__meta\" [class.margin-bottom]=\"!item.childActions?.length\">\n          <ng-container *ngIf=\"item.version\" sieCoreAddTooltip>{{ item.version }}</ng-container>\n        </p>\n        <sie-ui-menu-button\n          *ngIf=\"item.childActions?.length\"\n          class=\"card-support-material__menu-button\"\n          (click)=\"$event.stopPropagation()\"\n          [options]=\"item.childActions\"\n          (actionClicked)=\"dropdownOptionSelected($event, item)\"\n          (keyup.enter)=\"$event.stopPropagation()\"\n          [menuButtonScreenReaderText]=\"menuButtonScreenReaderText\"\n        ></sie-ui-menu-button>\n      </div>\n      <h3 class=\"card-support-material__headline\" sieCoreAddTooltip>{{ item.title }}</h3>\n      <div class=\"card-support-material__content-footer\">\n        <span sieCoreAddTooltip>{{ item.documentDate | sieDate: locale }}</span>\n        <sie-ui-rating-stars\n          [rating]=\"item.rating\"\n          [tooltip]=\"item.tooltipLabel\"\n          [ratingCount]=\"item.ratingCount\"\n          [locale]=\"locale\"\n        >\n        </sie-ui-rating-stars>\n      </div>\n    </section>\n  </article>\n</div>\n", styles: [".card-support-material__link--main,.card-support-material__link{outline:none;outline-offset:0}@media (pointer: fine){.card-support-material__link--main,.card-support-material__link{position:relative}.card-support-material__link--main:focus,.card-support-material__link:focus{outline:1px solid #1491eb;outline-offset:2px}.card-support-material__link--main:focus:not(:focus-visible),.card-support-material__link:focus:not(:focus-visible){outline:0}.card-support-material__link--main:focus-visible,.card-support-material__link:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}:host{display:block}.support-card-container{container:support-card-container/inline-size}.card-support-material{position:relative;display:flex;flex-direction:column;height:520px;background:#fff;border:1px solid #ccccd4;box-shadow:0 2px 2px #0000000f,0 6px 8px #00000014}@media (min-width: 1024px){.card-support-material{height:580px}}@container support-card-container (min-width: 1024px){.card-support-material{height:580px}}.card-support-material__media{margin:0;position:relative;display:flex;flex-direction:column}.card-support-material__media-bg{aspect-ratio:16/9;width:100%;height:auto}.card-support-material__media-icon{width:80px;height:80px;display:flex;align-items:center;fill:currentColor;position:absolute;left:50%;top:50%;transform:translate(-50%,-50%);color:#fff}.card-support-material__media-icon svg{fill:currentColor;width:inherit;height:inherit}.card-support-material__media-icon svg g{fill:currentColor;width:inherit;height:inherit}.card-support-material__media-icon svg text{font-family:Siemens Sans,sans-serif}.card-support-material__media.margin-bottom,.card-support-material__meta.margin-bottom{margin-bottom:10px}.card-support-material__link{text-decoration:none;color:inherit;display:block;height:100%}.card-support-material__link--main{min-width:280px;max-width:400px;cursor:pointer}.card-support-material__tag{font-size:1rem;font-weight:400;line-height:1.5rem;position:absolute;top:0;left:16px;z-index:10}.card-support-material__content{height:100%;padding:0 20px 0 24px}.card-support-material__content-header,.card-support-material__content-footer{display:flex;justify-content:space-between;align-items:center}.card-support-material__menu-button{margin-right:-20px}.card-support-material__headline{font-size:1.25rem;font-weight:900;line-height:1.625rem;display:-webkit-box;-webkit-box-orient:vertical;-webkit-line-clamp:2;margin-bottom:16px;color:#000028;overflow:hidden;text-overflow:ellipsis}.dark .card-support-material__media-bg{background-color:#000028}.light .card-support-material__media-bg{background-color:#00557c}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }]; }, propDecorators: { item: [{
                type: Input
            }], menuButtonScreenReaderText: [{
                type: Input
            }], theme: [{
                type: Input
            }], target: [{
                type: Input
            }], locale: [{
                type: Input
            }], containerStyled: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], cardChildActionClicked: [{
                type: Output
            }], cardClicked: [{
                type: Output
            }] } });

class UiCardEventComponent {
    constructor(layoutService, cdr, iconReg) {
        this.layoutService = layoutService;
        this.cdr = cdr;
        this.iconReg = iconReg;
        /**
         * Defines if container-queries or media-queries are used for the card styling
         * @default false
         */
        this.containerStyled = false;
        /**
         * {@link UiCardEventModel Event} triggered when card is clicked
         */
        this.cardClicked = new EventEmitter();
        /**
         * {@link UiButtonClickModel Event} triggered when the button is clicked.
         */
        this.buttonClick = new Subject();
        /** @ignore */
        this.breakpointSActive = false;
        /** @ignore */
        this.smallViewport = false;
        /** @ignore */
        this.mediumViewport = false;
        this.subscription = new Subscription();
        iconReg.register(SieIcon.LocationPin);
        iconReg.register(SieIcon.Calendar);
    }
    /** @ignore */
    ngOnInit() {
        this.updateObservables();
    }
    /** @ignore */
    ngOnChanges(changes) {
        if (changes.viewportContainer && this.containerStyled) {
            this.updateObservables();
        }
    }
    /** @ignore */
    ngOnDestroy() {
        this.subscription?.unsubscribe();
    }
    checkBreakpoint() {
        if (this.item) {
            if (this.smallViewport) {
                this.imageUrl = this.item.picture?.urlSmall;
                this.breakpointSActive = true;
            }
            else if (this.mediumViewport) {
                this.imageUrl = this.item.picture?.urlMedium;
                this.breakpointSActive = false;
            }
            else {
                this.imageUrl = this.item.picture?.urlLarge;
                this.breakpointSActive = false;
            }
            this.cdr.detectChanges();
        }
    }
    updateObservables() {
        if (this.containerStyled) {
            this.updateViewportVars(this.viewportContainer);
        }
        else {
            this.subscription.add(this.layoutService.currentViewPort$.subscribe(breakpoint => {
                this.updateViewportVars(breakpoint);
            }));
        }
        this.cdr.detectChanges();
    }
    updateViewportVars(key) {
        this.smallViewport = ['XS', 'S'].includes(key);
        this.mediumViewport = ['M'].includes(key);
        this.checkBreakpoint();
        this.cdr.detectChanges();
    }
    /** @ignore */
    onButtonClick(event) {
        this.cardClicked.emit(this.item);
        this.buttonClick.next(deepCopy({ button: this.item.button, event }));
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCardEventComponent, deps: [{ token: i1$1.LayoutService }, { token: i0.ChangeDetectorRef }, { token: i1.SieIconRegistryService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiCardEventComponent, selector: "sie-ui-card-event", inputs: { item: "item", containerStyled: ["containerStyled", "containerStyled", booleanAttribute], viewportContainer: "viewportContainer" }, outputs: { cardClicked: "cardClicked", buttonClick: "buttonClick" }, usesOnChanges: true, ngImport: i0, template: "<article\n  [ngClass]=\"['card-event', containerStyled ? 'container-layout' : '']\"\n  [ngStyle]=\"{ 'background-image': imageUrl ? 'url(' + imageUrl + ')' : '' }\"\n  [sieCoreAttributes]=\"item.dataAttributes\"\n  tabindex=\"0\"\n>\n  <header class=\"card-event__header\">\n    <sie-ui-tag *ngIf=\"item?.visualTag\" status=\"neutral\" [croppedTop]=\"true\">{{ item?.visualTag }}</sie-ui-tag>\n  </header>\n  <section class=\"card-event__content\">\n    <div class=\"card-event__full-height\" sieCoreTruncate>\n      <h2 class=\"card-event__headline\" sieCoreAddTooltip>\n        {{ item?.title }}\n      </h2>\n      <div\n        *ngIf=\"item?.description\"\n        class=\"card-event__description\"\n        [attr.data-truncate-prio]=\"1\"\n        [attr.data-truncate-group-name]=\"'description'\"\n        [attr.data-truncate-max-lines-per-item]=\"5\"\n        sieCoreAddTooltip\n      >\n        <p>{{ item?.description }}</p>\n      </div>\n      <ul\n        sie-ui-benefits\n        *ngIf=\"item?.benefits?.length > 0\"\n        class=\"card-event__benefits\"\n        [benefits]=\"item?.benefits\"\n        [attr.data-truncate-group-name]=\"'benefits'\"\n        [attr.data-truncate-max-lines-per-group]=\"3\"\n        [attr.data-truncate-limited-trough-group]=\"true\"\n        [useTruncation]=\"true\"\n        [truncationPrioOffset]=\"2\"\n        [truncationGroupName]=\"'benefits'\"\n      ></ul>\n      <div [attr.data-truncate-always-visible]=\"true\">\n        <div *ngIf=\"item.location\" class=\"card-event__loc-time\">\n          <sie-icon class=\"card-event__icon\" [name]=\"iconReg.sieIcon.LocationPin\"></sie-icon>\n          <span>{{ item?.location }}</span>\n        </div>\n        <div *ngIf=\"item.date\" class=\"card-event__loc-time\">\n          <sie-icon class=\"card-event__icon\" [name]=\"iconReg.sieIcon.Calendar\"></sie-icon>\n          <span>{{ item?.date }}</span>\n        </div>\n      </div>\n    </div>\n  </section>\n  <footer class=\"card-event__footer\">\n    <sie-ui-button-wrapper\n      *ngIf=\"!!item.button?.buttonType\"\n      [model]=\"item?.button\"\n      (click)=\"$event.stopPropagation()\"\n      (keydown.enter)=\"$event.stopPropagation()\"\n      (clicked)=\"onButtonClick($event)\"\n      sieCoreAddTooltip\n    >\n      {{ item.button.label }}\n    </sie-ui-button-wrapper>\n  </footer>\n</article>\n", styles: [".card-event{--component-height: 520px;--headline-min-height: 52px;height:var(--component-height);display:flex;flex-direction:column;background-color:#000028;background-repeat:no-repeat;background-position:center;background-size:cover;color:#fff;padding:0 24px 24px;position:relative;overflow:hidden}.card-event__header{margin-bottom:32px}.card-event__content{display:flex;flex-direction:column;overflow:hidden;flex:1 1 auto;height:100%;margin-bottom:24px}.card-event__full-height{height:100%}.card-event__headline{display:-webkit-box;-webkit-box-orient:vertical;-webkit-line-clamp:2;overflow:hidden;min-height:var(--headline-min-height);margin-bottom:24px}.card-event__description,.card-event__benefits{margin-bottom:24px}.card-event__loc-time{display:flex;align-items:center;margin-bottom:4px}.card-event__icon{width:16px;height:16px;display:flex;align-items:center;fill:currentColor;margin-right:10px}.card-event__icon svg{fill:currentColor;width:inherit;height:inherit}.card-event__icon svg g{fill:currentColor;width:inherit;height:inherit}.card-event__icon svg text{font-family:Siemens Sans,sans-serif}@media (min-width: 1024px){.card-event:not(.container-layout){--component-height: 580px;--headline-min-height: 88px}}@container shared-container (max-width: 1023.78px){.card-event.container-layout .card-event__headline{font-size:1.25rem;line-height:1.625rem;letter-spacing:-.03125rem}}@container shared-container (min-width: 1024px){.card-event.container-layout .card-event__headline{--component-height: 580px;--headline-min-height: 88px;font-size:2rem;line-height:2.75rem;letter-spacing:-.03125rem}}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "component", type: UiButtonWrapperComponent, selector: "sie-ui-button-wrapper", inputs: ["model"], outputs: ["clicked"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "component", type: UiBenefitsComponent, selector: "ul[sie-ui-benefits]", inputs: ["benefits", "useTruncation", "truncationPrioOffset", "truncationGroupName"] }, { kind: "directive", type: i1$1.TruncateDirective, selector: "[sieCoreTruncate]" }, { kind: "component", type: UiTagComponent, selector: "sie-ui-tag", inputs: ["mode", "theme", "status", "tagId", "dataAttrName", "dataAttrValue", "disabled", "croppedTop", "condensed", "linkable", "removeButtonAriaLabel"], outputs: ["selected", "unselected", "removed", "clicked"] }, { kind: "directive", type: i1$1.AddTooltipDirective, selector: "[sieCoreAddTooltip]" }, { kind: "directive", type: i1$1.AttributeDirective, selector: "[sieCoreAttributes]", inputs: ["sieCoreAttributes"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCardEventComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-card-event', changeDetection: ChangeDetectionStrategy.OnPush, template: "<article\n  [ngClass]=\"['card-event', containerStyled ? 'container-layout' : '']\"\n  [ngStyle]=\"{ 'background-image': imageUrl ? 'url(' + imageUrl + ')' : '' }\"\n  [sieCoreAttributes]=\"item.dataAttributes\"\n  tabindex=\"0\"\n>\n  <header class=\"card-event__header\">\n    <sie-ui-tag *ngIf=\"item?.visualTag\" status=\"neutral\" [croppedTop]=\"true\">{{ item?.visualTag }}</sie-ui-tag>\n  </header>\n  <section class=\"card-event__content\">\n    <div class=\"card-event__full-height\" sieCoreTruncate>\n      <h2 class=\"card-event__headline\" sieCoreAddTooltip>\n        {{ item?.title }}\n      </h2>\n      <div\n        *ngIf=\"item?.description\"\n        class=\"card-event__description\"\n        [attr.data-truncate-prio]=\"1\"\n        [attr.data-truncate-group-name]=\"'description'\"\n        [attr.data-truncate-max-lines-per-item]=\"5\"\n        sieCoreAddTooltip\n      >\n        <p>{{ item?.description }}</p>\n      </div>\n      <ul\n        sie-ui-benefits\n        *ngIf=\"item?.benefits?.length > 0\"\n        class=\"card-event__benefits\"\n        [benefits]=\"item?.benefits\"\n        [attr.data-truncate-group-name]=\"'benefits'\"\n        [attr.data-truncate-max-lines-per-group]=\"3\"\n        [attr.data-truncate-limited-trough-group]=\"true\"\n        [useTruncation]=\"true\"\n        [truncationPrioOffset]=\"2\"\n        [truncationGroupName]=\"'benefits'\"\n      ></ul>\n      <div [attr.data-truncate-always-visible]=\"true\">\n        <div *ngIf=\"item.location\" class=\"card-event__loc-time\">\n          <sie-icon class=\"card-event__icon\" [name]=\"iconReg.sieIcon.LocationPin\"></sie-icon>\n          <span>{{ item?.location }}</span>\n        </div>\n        <div *ngIf=\"item.date\" class=\"card-event__loc-time\">\n          <sie-icon class=\"card-event__icon\" [name]=\"iconReg.sieIcon.Calendar\"></sie-icon>\n          <span>{{ item?.date }}</span>\n        </div>\n      </div>\n    </div>\n  </section>\n  <footer class=\"card-event__footer\">\n    <sie-ui-button-wrapper\n      *ngIf=\"!!item.button?.buttonType\"\n      [model]=\"item?.button\"\n      (click)=\"$event.stopPropagation()\"\n      (keydown.enter)=\"$event.stopPropagation()\"\n      (clicked)=\"onButtonClick($event)\"\n      sieCoreAddTooltip\n    >\n      {{ item.button.label }}\n    </sie-ui-button-wrapper>\n  </footer>\n</article>\n", styles: [".card-event{--component-height: 520px;--headline-min-height: 52px;height:var(--component-height);display:flex;flex-direction:column;background-color:#000028;background-repeat:no-repeat;background-position:center;background-size:cover;color:#fff;padding:0 24px 24px;position:relative;overflow:hidden}.card-event__header{margin-bottom:32px}.card-event__content{display:flex;flex-direction:column;overflow:hidden;flex:1 1 auto;height:100%;margin-bottom:24px}.card-event__full-height{height:100%}.card-event__headline{display:-webkit-box;-webkit-box-orient:vertical;-webkit-line-clamp:2;overflow:hidden;min-height:var(--headline-min-height);margin-bottom:24px}.card-event__description,.card-event__benefits{margin-bottom:24px}.card-event__loc-time{display:flex;align-items:center;margin-bottom:4px}.card-event__icon{width:16px;height:16px;display:flex;align-items:center;fill:currentColor;margin-right:10px}.card-event__icon svg{fill:currentColor;width:inherit;height:inherit}.card-event__icon svg g{fill:currentColor;width:inherit;height:inherit}.card-event__icon svg text{font-family:Siemens Sans,sans-serif}@media (min-width: 1024px){.card-event:not(.container-layout){--component-height: 580px;--headline-min-height: 88px}}@container shared-container (max-width: 1023.78px){.card-event.container-layout .card-event__headline{font-size:1.25rem;line-height:1.625rem;letter-spacing:-.03125rem}}@container shared-container (min-width: 1024px){.card-event.container-layout .card-event__headline{--component-height: 580px;--headline-min-height: 88px;font-size:2rem;line-height:2.75rem;letter-spacing:-.03125rem}}\n"] }]
        }], ctorParameters: function () { return [{ type: i1$1.LayoutService }, { type: i0.ChangeDetectorRef }, { type: i1.SieIconRegistryService }]; }, propDecorators: { item: [{
                type: Input
            }], containerStyled: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], viewportContainer: [{
                type: Input
            }], cardClicked: [{
                type: Output
            }], buttonClick: [{
                type: Output
            }] } });

const CARD_HEIGHT_M_AND_LOWER_BREAKPOINT = 520;
const CARD_HEIGHT_L_AND_HIGHER_BREAKPOINT = 580;
class UiCardsContainerComponent {
    constructor(layoutService, resizeDirective) {
        this.layoutService = layoutService;
        this.resizeDirective = resizeDirective;
        this.items = [];
        this.orientation = 'landscape';
        this.theme = 'dark';
        /**
         * Defines if container-queries or media-queries are used for the cards container styling
         * @default false
         */
        this.containerStyled = false;
        this.buttonClick = new Subject();
        this.childActionClicked = new EventEmitter();
        this.linkClicked = new EventEmitter();
        this.cardClicked = new EventEmitter();
        this.containerWidth = this.resizeDirective.width.pipe(filter(w => (w !== null || w !== undefined) && this.containerStyled));
        this.subscriptions = new Subscription();
        /** @ignore */
        this.containerCssClass = this.containerStyled;
    }
    ngOnInit() {
        this.listenToSizeChange();
    }
    ngOnChanges(changes) {
        if (changes.containerStyled) {
            this.containerCssClass = this.containerStyled;
        }
    }
    ngOnDestroy() {
        this.subscriptions?.unsubscribe();
    }
    onButtonClick(event) {
        this.buttonClick.next(event);
    }
    onChildActionSelected(event) {
        this.childActionClicked.emit(event);
    }
    onLinkClicked(event) {
        this.linkClicked.emit(event);
    }
    onCardClicked(item) {
        this.cardClicked.emit(item);
    }
    listenToSizeChange() {
        if (this.containerStyled) {
            this.cardHeight$ = this.resizeDirective.breakpointKey.pipe(map$1(breakpointKey => this.getCardHeightForBreakpoint(breakpointKey)));
            this.viewportContainer$ = this.resizeDirective.breakpointKey.pipe(map$1(key => key));
        }
        else {
            this.cardHeight$ = this.layoutService.currentViewPort$.pipe(map$1(currentViewport => this.getCardHeightForBreakpoint(currentViewport)));
            this.viewportContainer$ = null;
        }
    }
    getCardHeightForBreakpoint(breakpointKey) {
        return ['M', 'S', 'XS'].includes(breakpointKey)
            ? CARD_HEIGHT_M_AND_LOWER_BREAKPOINT
            : CARD_HEIGHT_L_AND_HIGHER_BREAKPOINT;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCardsContainerComponent, deps: [{ token: i1$1.LayoutService }, { token: i1$1.ElementResizeDirective }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiCardsContainerComponent, selector: "sie-ui-cards-container", inputs: { items: "items", orientation: "orientation", viewportSettings: "viewportSettings", theme: "theme", slideIndex: "slideIndex", menuButtonScreenReaderText: "menuButtonScreenReaderText", containerStyled: ["containerStyled", "containerStyled", booleanAttribute], locale: "locale" }, outputs: { buttonClick: "buttonClick", childActionClicked: "childActionClicked", linkClicked: "linkClicked", cardClicked: "cardClicked", containerWidth: "containerWidth" }, host: { properties: { "class.container-styled": "this.containerCssClass" } }, usesOnChanges: true, hostDirectives: [{ directive: i1$1.ElementResizeDirective }], ngImport: i0, template: "<div class=\"card-container\" [ngClass]=\"'card-container--' + orientation\" [class.container-layout]=\"containerStyled\">\n  <div class=\"card-container__row\" *ngFor=\"let row of items\">\n    <div class=\"card-container__item\" *ngFor=\"let item of row\">\n      <ng-container *ngIf=\"item\">\n        <sie-ui-card-landscape\n          *ngIf=\"orientation === 'landscape'\"\n          [containerStyled]=\"containerStyled\"\n          [item]=\"item\"\n          [titleLines]=\"viewportSettings.titleMaxLines\"\n          [showMedia]=\"viewportSettings.showMedia\"\n          [theme]=\"theme\"\n          [slideIndex]=\"slideIndex\"\n          (cardChildActionClicked)=\"onChildActionSelected($event)\"\n          (cardClicked)=\"onCardClicked(item)\"\n          (linkClicked)=\"onLinkClicked($event)\"\n          [locale]=\"locale\"\n        >\n        </sie-ui-card-landscape>\n        <sie-ui-ad-teaser\n          *ngIf=\"orientation === 'portrait' && item.visualizationType === 'adteaser'\"\n          [containerStyled]=\"containerStyled\"\n          [viewportContainer]=\"viewportContainer$ | async\"\n          [buttonFullWidthOnViewportS]=\"false\"\n          [buttonAlignment]=\"'left'\"\n          [teaserData]=\"item\"\n          (buttonClick)=\"onButtonClick($event)\"\n          (childActionClicked)=\"onChildActionSelected($event)\"\n          (cardClicked)=\"onCardClicked(item)\"\n          [height]=\"cardHeight$ | async\"\n          ignoreVideoModal\n        >\n        </sie-ui-ad-teaser>\n        <sie-ui-card-portrait\n          *ngIf=\"orientation === 'portrait' && item.visualizationType === 'card' && item.contentType !== 'event'\"\n          [containerStyled]=\"containerStyled\"\n          [item]=\"item\"\n          (buttonClick)=\"onButtonClick($event)\"\n          (cardChildActionClicked)=\"onChildActionSelected($event)\"\n          (cardClicked)=\"onCardClicked(item)\"\n          [menuButtonScreenReaderText]=\"menuButtonScreenReaderText\"\n        >\n        </sie-ui-card-portrait>\n        <sie-ui-card-support-material\n          *ngIf=\"orientation === 'portrait' && item.visualizationType === 'support-material'\"\n          [containerStyled]=\"containerStyled\"\n          [item]=\"item\"\n          [theme]=\"theme\"\n          (cardChildActionClicked)=\"onChildActionSelected($event)\"\n          (cardClicked)=\"onCardClicked(item)\"\n          [menuButtonScreenReaderText]=\"menuButtonScreenReaderText\"\n          [locale]=\"locale\"\n        >\n        </sie-ui-card-support-material>\n        <sie-ui-card-event\n          *ngIf=\"orientation === 'portrait' && item.visualizationType === 'card' && item.contentType === 'event'\"\n          [containerStyled]=\"containerStyled\"\n          [viewportContainer]=\"viewportContainer$ | async\"\n          [item]=\"item\"\n          (buttonClick)=\"onButtonClick($event)\"\n          (cardClicked)=\"onCardClicked(item)\"\n        ></sie-ui-card-event>\n      </ng-container>\n    </div>\n  </div>\n</div>\n", styles: [":host{display:block;width:100%;height:100%}.card-container{margin:0 -4px;padding-top:4px;height:100%}.card-container__row{display:grid;margin:0 auto;max-width:408px;width:100%}.card-container--portrait .card-container__row{height:100%}.card-container__item{padding:0 4px}.card-container--landscape .card-container__item,.card-container--portrait .card-container__item{max-width:408px;min-width:288px}@media (min-width: 1024px){.card-container:not(.container-layout){margin:0 -12px}}@media (min-width: 608px){.card-container:not(.container-layout).card-container--landscape .card-container__row{grid-template-columns:1fr 1fr;grid-template-rows:auto;max-width:816px}}@media (min-width: 1024px){.card-container:not(.container-layout).card-container--landscape .card-container__row{max-width:1148px}}@media (min-width: 1530px){.card-container:not(.container-layout).card-container--landscape .card-container__row{grid-template-columns:1fr 1fr 1fr;grid-template-rows:auto;max-width:1722px}}@media (min-width: 1024px){.card-container:not(.container-layout).card-container--landscape .card-container__row:first-child{margin-bottom:36px}}@media (min-width: 1024px){.card-container:not(.container-layout).card-container--landscape .card-container__item{max-width:574px;min-width:406px;padding:0 12px}}@media (min-width: 608px){.card-container:not(.container-layout).card-container--portrait .card-container__row{grid-template-columns:1fr 1fr;grid-template-rows:auto;max-width:816px}}@media (min-width: 1024px){.card-container:not(.container-layout).card-container--portrait .card-container__row{grid-template-columns:1fr 1fr 1fr;grid-template-rows:auto;max-width:1272px}}@media (min-width: 1304px){.card-container:not(.container-layout).card-container--portrait .card-container__row{grid-template-columns:1fr 1fr 1fr 1fr;grid-template-rows:auto;max-width:1696px}}@media (min-width: 1024px){.card-container:not(.container-layout).card-container--portrait .card-container__item{max-width:424px;min-width:304px;padding:0 12px}}@container shared-container (min-width: 1024px){.card-container.container-layout{margin:0 -12px}}@container shared-container (min-width: 608px){.card-container.container-layout.card-container--landscape .card-container__row{grid-template-columns:1fr 1fr;grid-template-rows:auto;max-width:816px}}@container shared-container (min-width: 1024px){.card-container.container-layout.card-container--landscape .card-container__row{max-width:1148px}}@container shared-container (min-width: 1530px){.card-container.container-layout.card-container--landscape .card-container__row{grid-template-columns:1fr 1fr 1fr;grid-template-rows:auto;max-width:1722px}}@container shared-container (min-width: 1024px){.card-container.container-layout.card-container--landscape .card-container__row:first-child{margin-bottom:36px}}@container shared-container (min-width: 1024px){.card-container.container-layout.card-container--landscape .card-container__item{max-width:574px;min-width:406px;padding:0 12px}}@container shared-container (min-width: 608px){.card-container.container-layout.card-container--portrait .card-container__row{grid-template-columns:1fr 1fr;grid-template-rows:auto;max-width:816px}}@container shared-container (min-width: 1024px){.card-container.container-layout.card-container--portrait .card-container__row{grid-template-columns:1fr 1fr 1fr;grid-template-rows:auto;max-width:1272px}}@container shared-container (min-width: 1304px){.card-container.container-layout.card-container--portrait .card-container__row{grid-template-columns:1fr 1fr 1fr 1fr;grid-template-rows:auto;max-width:1696px}}@container shared-container (min-width: 1024px){.card-container.container-layout.card-container--portrait .card-container__item{max-width:424px;min-width:304px;padding:0 12px}}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: UiCardLandscapeComponent, selector: "sie-ui-card-landscape", inputs: ["item", "slideIndex", "target", "theme", "locale", "height", "titleLines", "showMedia", "containerStyled"], outputs: ["cardChildActionClicked", "linkClicked", "cardClicked"] }, { kind: "component", type: UiAdTeaserComponent, selector: "sie-ui-ad-teaser", inputs: ["teaserCount", "height"], outputs: ["childActionClicked"] }, { kind: "component", type: UiCardPortraitComponent, selector: "sie-ui-card-portrait", inputs: ["item", "menuButtonScreenReaderText", "containerStyled"], outputs: ["buttonClick", "cardChildActionClicked", "cardClicked"] }, { kind: "component", type: UiCardSupportMaterialComponent, selector: "sie-ui-card-support-material", inputs: ["item", "menuButtonScreenReaderText", "theme", "target", "locale", "containerStyled"], outputs: ["cardChildActionClicked", "cardClicked"] }, { kind: "component", type: UiCardEventComponent, selector: "sie-ui-card-event", inputs: ["item", "containerStyled", "viewportContainer"], outputs: ["cardClicked", "buttonClick"] }, { kind: "pipe", type: i2.AsyncPipe, name: "async" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCardsContainerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-cards-container', changeDetection: ChangeDetectionStrategy.OnPush, hostDirectives: [
                        {
                            directive: ElementResizeDirective
                        }
                    ], template: "<div class=\"card-container\" [ngClass]=\"'card-container--' + orientation\" [class.container-layout]=\"containerStyled\">\n  <div class=\"card-container__row\" *ngFor=\"let row of items\">\n    <div class=\"card-container__item\" *ngFor=\"let item of row\">\n      <ng-container *ngIf=\"item\">\n        <sie-ui-card-landscape\n          *ngIf=\"orientation === 'landscape'\"\n          [containerStyled]=\"containerStyled\"\n          [item]=\"item\"\n          [titleLines]=\"viewportSettings.titleMaxLines\"\n          [showMedia]=\"viewportSettings.showMedia\"\n          [theme]=\"theme\"\n          [slideIndex]=\"slideIndex\"\n          (cardChildActionClicked)=\"onChildActionSelected($event)\"\n          (cardClicked)=\"onCardClicked(item)\"\n          (linkClicked)=\"onLinkClicked($event)\"\n          [locale]=\"locale\"\n        >\n        </sie-ui-card-landscape>\n        <sie-ui-ad-teaser\n          *ngIf=\"orientation === 'portrait' && item.visualizationType === 'adteaser'\"\n          [containerStyled]=\"containerStyled\"\n          [viewportContainer]=\"viewportContainer$ | async\"\n          [buttonFullWidthOnViewportS]=\"false\"\n          [buttonAlignment]=\"'left'\"\n          [teaserData]=\"item\"\n          (buttonClick)=\"onButtonClick($event)\"\n          (childActionClicked)=\"onChildActionSelected($event)\"\n          (cardClicked)=\"onCardClicked(item)\"\n          [height]=\"cardHeight$ | async\"\n          ignoreVideoModal\n        >\n        </sie-ui-ad-teaser>\n        <sie-ui-card-portrait\n          *ngIf=\"orientation === 'portrait' && item.visualizationType === 'card' && item.contentType !== 'event'\"\n          [containerStyled]=\"containerStyled\"\n          [item]=\"item\"\n          (buttonClick)=\"onButtonClick($event)\"\n          (cardChildActionClicked)=\"onChildActionSelected($event)\"\n          (cardClicked)=\"onCardClicked(item)\"\n          [menuButtonScreenReaderText]=\"menuButtonScreenReaderText\"\n        >\n        </sie-ui-card-portrait>\n        <sie-ui-card-support-material\n          *ngIf=\"orientation === 'portrait' && item.visualizationType === 'support-material'\"\n          [containerStyled]=\"containerStyled\"\n          [item]=\"item\"\n          [theme]=\"theme\"\n          (cardChildActionClicked)=\"onChildActionSelected($event)\"\n          (cardClicked)=\"onCardClicked(item)\"\n          [menuButtonScreenReaderText]=\"menuButtonScreenReaderText\"\n          [locale]=\"locale\"\n        >\n        </sie-ui-card-support-material>\n        <sie-ui-card-event\n          *ngIf=\"orientation === 'portrait' && item.visualizationType === 'card' && item.contentType === 'event'\"\n          [containerStyled]=\"containerStyled\"\n          [viewportContainer]=\"viewportContainer$ | async\"\n          [item]=\"item\"\n          (buttonClick)=\"onButtonClick($event)\"\n          (cardClicked)=\"onCardClicked(item)\"\n        ></sie-ui-card-event>\n      </ng-container>\n    </div>\n  </div>\n</div>\n", styles: [":host{display:block;width:100%;height:100%}.card-container{margin:0 -4px;padding-top:4px;height:100%}.card-container__row{display:grid;margin:0 auto;max-width:408px;width:100%}.card-container--portrait .card-container__row{height:100%}.card-container__item{padding:0 4px}.card-container--landscape .card-container__item,.card-container--portrait .card-container__item{max-width:408px;min-width:288px}@media (min-width: 1024px){.card-container:not(.container-layout){margin:0 -12px}}@media (min-width: 608px){.card-container:not(.container-layout).card-container--landscape .card-container__row{grid-template-columns:1fr 1fr;grid-template-rows:auto;max-width:816px}}@media (min-width: 1024px){.card-container:not(.container-layout).card-container--landscape .card-container__row{max-width:1148px}}@media (min-width: 1530px){.card-container:not(.container-layout).card-container--landscape .card-container__row{grid-template-columns:1fr 1fr 1fr;grid-template-rows:auto;max-width:1722px}}@media (min-width: 1024px){.card-container:not(.container-layout).card-container--landscape .card-container__row:first-child{margin-bottom:36px}}@media (min-width: 1024px){.card-container:not(.container-layout).card-container--landscape .card-container__item{max-width:574px;min-width:406px;padding:0 12px}}@media (min-width: 608px){.card-container:not(.container-layout).card-container--portrait .card-container__row{grid-template-columns:1fr 1fr;grid-template-rows:auto;max-width:816px}}@media (min-width: 1024px){.card-container:not(.container-layout).card-container--portrait .card-container__row{grid-template-columns:1fr 1fr 1fr;grid-template-rows:auto;max-width:1272px}}@media (min-width: 1304px){.card-container:not(.container-layout).card-container--portrait .card-container__row{grid-template-columns:1fr 1fr 1fr 1fr;grid-template-rows:auto;max-width:1696px}}@media (min-width: 1024px){.card-container:not(.container-layout).card-container--portrait .card-container__item{max-width:424px;min-width:304px;padding:0 12px}}@container shared-container (min-width: 1024px){.card-container.container-layout{margin:0 -12px}}@container shared-container (min-width: 608px){.card-container.container-layout.card-container--landscape .card-container__row{grid-template-columns:1fr 1fr;grid-template-rows:auto;max-width:816px}}@container shared-container (min-width: 1024px){.card-container.container-layout.card-container--landscape .card-container__row{max-width:1148px}}@container shared-container (min-width: 1530px){.card-container.container-layout.card-container--landscape .card-container__row{grid-template-columns:1fr 1fr 1fr;grid-template-rows:auto;max-width:1722px}}@container shared-container (min-width: 1024px){.card-container.container-layout.card-container--landscape .card-container__row:first-child{margin-bottom:36px}}@container shared-container (min-width: 1024px){.card-container.container-layout.card-container--landscape .card-container__item{max-width:574px;min-width:406px;padding:0 12px}}@container shared-container (min-width: 608px){.card-container.container-layout.card-container--portrait .card-container__row{grid-template-columns:1fr 1fr;grid-template-rows:auto;max-width:816px}}@container shared-container (min-width: 1024px){.card-container.container-layout.card-container--portrait .card-container__row{grid-template-columns:1fr 1fr 1fr;grid-template-rows:auto;max-width:1272px}}@container shared-container (min-width: 1304px){.card-container.container-layout.card-container--portrait .card-container__row{grid-template-columns:1fr 1fr 1fr 1fr;grid-template-rows:auto;max-width:1696px}}@container shared-container (min-width: 1024px){.card-container.container-layout.card-container--portrait .card-container__item{max-width:424px;min-width:304px;padding:0 12px}}\n"] }]
        }], ctorParameters: function () { return [{ type: i1$1.LayoutService }, { type: i1$1.ElementResizeDirective }]; }, propDecorators: { items: [{
                type: Input
            }], orientation: [{
                type: Input
            }], viewportSettings: [{
                type: Input
            }], theme: [{
                type: Input
            }], slideIndex: [{
                type: Input
            }], menuButtonScreenReaderText: [{
                type: Input
            }], containerStyled: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], locale: [{
                type: Input
            }], buttonClick: [{
                type: Output
            }], childActionClicked: [{
                type: Output
            }], linkClicked: [{
                type: Output
            }], cardClicked: [{
                type: Output
            }], containerWidth: [{
                type: Output
            }], containerCssClass: [{
                type: HostBinding,
                args: ['class.container-styled']
            }] } });

class UiCardSupportMaterialModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCardSupportMaterialModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiCardSupportMaterialModule, declarations: [UiCardSupportMaterialComponent], imports: [CommonModule,
            SieIconsModule,
            UiTagModule,
            UiRatingStarsModule,
            UiLinkModule,
            UiMenuButtonModule,
            SieCorePipesModule,
            AddTooltipModule,
            AttributeModule], exports: [UiCardSupportMaterialComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCardSupportMaterialModule, imports: [CommonModule,
            SieIconsModule,
            UiTagModule,
            UiRatingStarsModule,
            UiLinkModule,
            UiMenuButtonModule,
            SieCorePipesModule,
            AddTooltipModule,
            AttributeModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCardSupportMaterialModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiCardSupportMaterialComponent],
                    imports: [
                        CommonModule,
                        SieIconsModule,
                        UiTagModule,
                        UiRatingStarsModule,
                        UiLinkModule,
                        UiMenuButtonModule,
                        SieCorePipesModule,
                        AddTooltipModule,
                        AttributeModule
                    ],
                    exports: [UiCardSupportMaterialComponent]
                }]
        }] });

class UiCardEventModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCardEventModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiCardEventModule, declarations: [UiCardEventComponent], imports: [CommonModule,
            UiButtonModule,
            SieIconsModule,
            UiBenefitsModule,
            TruncateModule,
            UiMenuButtonModule,
            UiTagModule,
            AddTooltipModule,
            AttributeModule], exports: [UiCardEventComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCardEventModule, imports: [CommonModule,
            UiButtonModule,
            SieIconsModule,
            UiBenefitsModule,
            TruncateModule,
            UiMenuButtonModule,
            UiTagModule,
            AddTooltipModule,
            AttributeModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCardEventModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiCardEventComponent],
                    imports: [
                        CommonModule,
                        UiButtonModule,
                        SieIconsModule,
                        UiBenefitsModule,
                        TruncateModule,
                        UiMenuButtonModule,
                        UiTagModule,
                        AddTooltipModule,
                        AttributeModule
                    ],
                    exports: [UiCardEventComponent]
                }]
        }] });

class UiCardsContainerModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCardsContainerModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiCardsContainerModule, declarations: [UiCardsContainerComponent], imports: [CommonModule,
            UiCardLandscapeModule,
            UiTeaserModule,
            UiCardPortraitModule,
            UiCardSupportMaterialModule,
            UiCardEventModule], exports: [UiCardsContainerComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCardsContainerModule, imports: [CommonModule,
            UiCardLandscapeModule,
            UiTeaserModule,
            UiCardPortraitModule,
            UiCardSupportMaterialModule,
            UiCardEventModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCardsContainerModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiCardsContainerComponent],
                    imports: [
                        CommonModule,
                        UiCardLandscapeModule,
                        UiTeaserModule,
                        UiCardPortraitModule,
                        UiCardSupportMaterialModule,
                        UiCardEventModule
                    ],
                    exports: [UiCardsContainerComponent]
                }]
        }] });

const CARDS_ARRANGEMENT_CONFIG = {
    landscape: {
        [ComponentCarouselBreakpointsSQuery]: {
            itemsPerRow: 1,
            titleMaxLines: 2,
            showMedia: false
        },
        [ComponentCarouselBreakpointsMQuery]: {
            itemsPerRow: 2,
            titleMaxLines: 2,
            showMedia: false
        },
        [ComponentCarouselBreakpointsLandscapeLQuery]: {
            itemsPerRow: 2,
            titleMaxLines: 3,
            showMedia: true
        },
        [ComponentCarouselBreakpointsLandscapeXlQuery]: {
            itemsPerRow: 3,
            titleMaxLines: 3,
            showMedia: true
        }
    },
    portrait: {
        [ComponentCarouselBreakpointsSQuery]: {
            itemsPerRow: 1
        },
        [ComponentCarouselBreakpointsMQuery]: {
            itemsPerRow: 2
        },
        [ComponentCarouselBreakpointsLQuery]: {
            itemsPerRow: 3
        },
        [ComponentCarouselBreakpointsXlQuery]: {
            itemsPerRow: 4
        }
    }
};
const CARDS_ARRANGEMENT_CONFIG_CONTAINER = {
    landscape: {
        ['S']: {
            itemsPerRow: 1,
            titleMaxLines: 2,
            showMedia: false
        },
        ['M']: {
            itemsPerRow: 2,
            titleMaxLines: 2,
            showMedia: false
        },
        ['L']: {
            itemsPerRow: 2,
            titleMaxLines: 3,
            showMedia: true
        },
        ['XL']: {
            itemsPerRow: 3,
            titleMaxLines: 3,
            showMedia: true
        }
    },
    portrait: {
        ['S']: {
            itemsPerRow: 1
        },
        ['M']: {
            itemsPerRow: 2
        },
        ['L']: {
            itemsPerRow: 3
        },
        ['XL']: {
            itemsPerRow: 4
        }
    }
};
const ContainerBreakpointsLandscape = {
    S: [0, 607.8],
    M: [608, 1023.8],
    L: [1024, 1529.8],
    XL: [1530, Infinity]
};
const ContainerBreakpointsPortrait = {
    S: [0, 607.8],
    M: [608, 1023.8],
    L: [1024, 1303.8],
    XL: [1304, Infinity]
};
const SMALL_BREAKPOINT_ROW_COUNT = 1;
const LARGE_BREAKPOINT_ROW_COUNT = 2;

class UiCardsContainerService {
    constructor(layoutService, carouselService) {
        this.layoutService = layoutService;
        this.carouselService = carouselService;
    }
    getItemWidth(orientation, itemsPerSlide, containerWidth) {
        let maxWidth;
        let itemWidth;
        if (containerWidth) {
            maxWidth =
                this.getItemMaxWidthContainerStyle(orientation, containerWidth) + this.carouselService.getCarouselGutter();
            itemWidth = containerWidth / itemsPerSlide;
        }
        else {
            maxWidth = this.getItemMaxWidthViewportStyle(orientation) + this.carouselService.getCarouselGutter();
            itemWidth = this.layoutService.getContainerWidth() / itemsPerSlide;
        }
        if (itemWidth > maxWidth) {
            itemWidth = maxWidth;
        }
        return itemWidth;
    }
    getItemMaxWidthContainerStyle(orientation, containerWidth) {
        if (orientation === 'landscape') {
            this.width = ['S', 'M'].includes(this.layoutService.getBreakpointKeyForValue(containerWidth))
                ? ComponentCardsLandscapeMaxWidthS
                : ComponentCardsLandscapeMaxWidthL;
        }
        else {
            this.width = ComponentCardsPortraitMaxWidth;
        }
        return parseInt(this.width, 10);
    }
    getItemMaxWidthViewportStyle(orientation) {
        if (orientation === 'landscape') {
            this.width = this.layoutService.isViewport('S', 'M')
                ? ComponentCardsLandscapeMaxWidthS
                : ComponentCardsLandscapeMaxWidthL;
        }
        else {
            this.width = ComponentCardsPortraitMaxWidth;
        }
        return parseInt(this.width, 10);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCardsContainerService, deps: [{ token: i1$1.LayoutService }, { token: UiCarouselService }], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCardsContainerService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCardsContainerService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: i1$1.LayoutService }, { type: UiCarouselService }]; } });

class UiCardsArrangementComponent {
    set items(value) {
        this._items = value;
        if (this.viewportSettings !== null) {
            this.arrange();
        }
    }
    constructor(breakpointObserver, layoutService, cd, cardsContainerService, elementRef, renderer) {
        this.breakpointObserver = breakpointObserver;
        this.layoutService = layoutService;
        this.cd = cd;
        this.cardsContainerService = cardsContainerService;
        this.elementRef = elementRef;
        this.renderer = renderer;
        this.orientation = 'landscape';
        this.theme = 'light';
        /**
         * Defines if container-queries or media-queries are used for the carousel styling
         * @default false
         */
        this.containerStyled = false;
        /**
         * Defines whether this carousel will be rendered in the cut-off version.
         * NOTE: if cutOff is enabled containerStyled doesn't work
         * @default true
         */
        this.cutOff = true;
        this.buttonClick = new Subject();
        this.childActionClicked = new EventEmitter();
        this.linkClicked = new EventEmitter();
        this.cardClicked = new EventEmitter();
        this._items = [];
        this.viewportSettings = null;
        this.slides = [];
        this.previousItemsPerPage = 0;
        this.subscriptions = new Subscription();
    }
    ngOnInit() {
        if (this.containerStyled) {
            this.updateContainerConfigurations();
        }
        else {
            this.listenToSizeChange();
        }
    }
    ngOnChanges(changes) {
        if (changes.containerStyled) {
            if (this.containerStyled) {
                this.updateContainerConfigurations();
            }
            else {
                this.listenToSizeChange();
            }
        }
    }
    ngOnDestroy() {
        this.subscriptions?.unsubscribe();
    }
    onButtonClick(event) {
        this.buttonClick.next(event);
    }
    onChildActionSelected(event) {
        this.childActionClicked.emit(event);
    }
    onContainerWidthChange(containerWidth) {
        this.updateContainerConfigurations(containerWidth);
    }
    updateContainerConfigurations(width) {
        if (width) {
            this.containerWidth = width;
        }
        else {
            this.containerWidth = this.getElementContainerWidth();
        }
        const breakpoint = this.getBreakpointKeyForContainerWidth(this.containerWidth);
        const settings = this.getSettingsForContainerWidth(breakpoint);
        this.handleViewportChange(settings);
        this.rearrangeCarousel();
    }
    getElementContainerWidth() {
        const hostElement = this.renderer.parentNode(this.elementRef.nativeElement);
        return hostElement.offsetWidth;
    }
    getBreakpointKeyForContainerWidth(value) {
        const breakpointQuery = this.orientation === 'portrait' ? ContainerBreakpointsPortrait : ContainerBreakpointsLandscape;
        return value
            ? Object.entries(breakpointQuery).find(([, [start, end]]) => value >= start && value <= end)?.[0]
            : null;
    }
    createCarouselSettings(rows, settings) {
        const cols = settings.itemsPerRow;
        const itemsPerPage = rows * cols;
        return {
            rows,
            cols,
            itemsPerPage,
            titleMaxLines: settings.titleMaxLines,
            showMedia: settings.showMedia
        };
    }
    getSettingsForContainerWidth(breakpoint) {
        const settings = CARDS_ARRANGEMENT_CONFIG_CONTAINER[this.orientation][breakpoint];
        const rows = this.orientation === 'portrait' || ['S', 'M'].includes(breakpoint)
            ? SMALL_BREAKPOINT_ROW_COUNT
            : LARGE_BREAKPOINT_ROW_COUNT;
        return this.createCarouselSettings(rows, settings);
    }
    getBreakpointQueriesForOrientation() {
        return Object.keys(CARDS_ARRANGEMENT_CONFIG[this.orientation]);
    }
    handleViewportChange(settings) {
        this.viewportSettings = settings;
        if (settings.itemsPerPage !== this.previousItemsPerPage) {
            this.previousItemsPerPage = settings.itemsPerPage;
            this.arrange();
        }
    }
    arrange() {
        const slideCount = Math.ceil(this._items.length / this.viewportSettings.itemsPerPage);
        const currentSlides = [];
        for (let i = 0; i < slideCount; i++) {
            currentSlides.push(this.arrangeSlide(i));
        }
        this.slides = currentSlides;
        this.cd.detectChanges();
        this.rearrangeCarousel();
    }
    arrangeSlide(slideIndex) {
        const cardsPerRow = this.viewportSettings.itemsPerPage / this.viewportSettings.rows;
        const startIdxSlide = slideIndex * this.viewportSettings.itemsPerPage;
        const rowSlides = [];
        for (let i = 0; i < this.viewportSettings.rows; i++) {
            const startIdxRow = startIdxSlide + cardsPerRow * i;
            const endIdxRow = startIdxRow + cardsPerRow;
            for (let x = startIdxRow; x < endIdxRow; x++) {
                const item = this._items[x];
                if (item && item['dataAttributes'] && item['dataAttributes']['data-ste-teaser-index']) {
                    item['dataAttributes']['data-ste-teaser-index'] = slideIndex + 1 + '';
                }
            }
            rowSlides.push(this._items.slice(startIdxRow, endIdxRow));
            const itemsInRow = rowSlides[i].length;
            if (itemsInRow < cardsPerRow) {
                const missingItems = cardsPerRow - itemsInRow;
                rowSlides[i] = [...rowSlides[i], ...Array.from({ length: missingItems }, () => undefined)];
            }
        }
        return rowSlides;
    }
    getSettingsForViewport(breakpoint) {
        const settings = CARDS_ARRANGEMENT_CONFIG[this.orientation][breakpoint];
        const isBreakpointSorM = breakpoint === ComponentCarouselBreakpointsSQuery || breakpoint === ComponentCarouselBreakpointsMQuery;
        const rows = this.orientation === 'portrait' || isBreakpointSorM ? SMALL_BREAKPOINT_ROW_COUNT : LARGE_BREAKPOINT_ROW_COUNT;
        return this.createCarouselSettings(rows, settings);
    }
    rearrangeCarousel() {
        const cardWidth = this.calculateCardWidth();
        // query all card items and apply width if it has a different width
        this.elementRef.nativeElement.querySelectorAll('.card-container__item').forEach((item) => {
            const itemWidth = parseFloat(window.getComputedStyle(item).getPropertyValue('width'));
            if (itemWidth !== cardWidth) {
                item.style.width = `${cardWidth}px`;
            }
        });
        // reset the carousel
        this.carousel?.resetCarousel();
    }
    calculateCardWidth() {
        let cardWidth;
        if (this.containerStyled) {
            cardWidth = this.cardsContainerService.getItemWidth(this.orientation, this.viewportSettings.cols, this.containerWidth);
        }
        else {
            cardWidth = this.cardsContainerService.getItemWidth(this.orientation, this.viewportSettings.cols);
        }
        return cardWidth;
    }
    listenToSizeChange() {
        this.subscriptions.add(this.breakpointObserver
            .observe([...this.getBreakpointQueriesForOrientation()])
            .pipe(map$1(result => BreakpointUtil.activeBreakpoint(result.breakpoints)), map$1(breakpoint => this.getSettingsForViewport(breakpoint)))
            .subscribe(settings => this.handleViewportChange(settings)));
        this.subscriptions.add(this.layoutService.resizeEventWithInitial$.subscribe(() => this.rearrangeCarousel()));
    }
    onLinkClicked(event) {
        this.linkClicked.emit(event);
    }
    onCardClicked(event) {
        this.cardClicked.emit(event);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCardsArrangementComponent, deps: [{ token: i1$2.BreakpointObserver }, { token: i1$1.LayoutService }, { token: i0.ChangeDetectorRef }, { token: UiCardsContainerService }, { token: i0.ElementRef }, { token: i0.Renderer2 }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiCardsArrangementComponent, selector: "sie-ui-cards-arrangement", inputs: { items: "items", orientation: "orientation", theme: "theme", menuButtonScreenReaderText: "menuButtonScreenReaderText", locale: "locale", carouselScreenReaderText: "carouselScreenReaderText", containerStyled: ["containerStyled", "containerStyled", booleanAttribute], cutOff: ["cutOff", "cutOff", booleanAttribute] }, outputs: { buttonClick: "buttonClick", childActionClicked: "childActionClicked", linkClicked: "linkClicked", cardClicked: "cardClicked" }, viewQueries: [{ propertyName: "carousel", first: true, predicate: ["carousel"], descendants: true }], usesOnChanges: true, ngImport: i0, template: "<sie-ui-carousel\n  #carousel\n  [containerStyled]=\"containerStyled\"\n  [cutOff]=\"cutOff\"\n  [screenReader]=\"carouselScreenReaderText\"\n>\n  <ng-template *ngFor=\"let slide of slides; index as i\" sieUiCarouselSlide>\n    <sie-ui-cards-container\n      [containerStyled]=\"containerStyled\"\n      [items]=\"slide\"\n      [orientation]=\"orientation\"\n      [viewportSettings]=\"viewportSettings\"\n      [theme]=\"theme\"\n      [slideIndex]=\"i\"\n      (buttonClick)=\"onButtonClick($event)\"\n      (childActionClicked)=\"onChildActionSelected($event)\"\n      (linkClicked)=\"onLinkClicked($event)\"\n      (cardClicked)=\"onCardClicked($event)\"\n      (containerWidth)=\"onContainerWidthChange($event)\"\n      [menuButtonScreenReaderText]=\"menuButtonScreenReaderText\"\n      [locale]=\"locale\"\n    ></sie-ui-cards-container>\n  </ng-template>\n</sie-ui-carousel>\n", styles: [""], dependencies: [{ kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "component", type: UiCardsContainerComponent, selector: "sie-ui-cards-container", inputs: ["items", "orientation", "viewportSettings", "theme", "slideIndex", "menuButtonScreenReaderText", "containerStyled", "locale"], outputs: ["buttonClick", "childActionClicked", "linkClicked", "cardClicked", "containerWidth"] }, { kind: "component", type: UiCarouselComponent, selector: "sie-ui-carousel", inputs: ["dir", "theme", "type", "screenReader", "containerStyled", "cutOff", "pauseAutoplay"] }, { kind: "directive", type: UiCarouselSlideDirective, selector: "[sieUiCarouselSlide]", inputs: ["id"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCardsArrangementComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-cards-arrangement', changeDetection: ChangeDetectionStrategy.OnPush, template: "<sie-ui-carousel\n  #carousel\n  [containerStyled]=\"containerStyled\"\n  [cutOff]=\"cutOff\"\n  [screenReader]=\"carouselScreenReaderText\"\n>\n  <ng-template *ngFor=\"let slide of slides; index as i\" sieUiCarouselSlide>\n    <sie-ui-cards-container\n      [containerStyled]=\"containerStyled\"\n      [items]=\"slide\"\n      [orientation]=\"orientation\"\n      [viewportSettings]=\"viewportSettings\"\n      [theme]=\"theme\"\n      [slideIndex]=\"i\"\n      (buttonClick)=\"onButtonClick($event)\"\n      (childActionClicked)=\"onChildActionSelected($event)\"\n      (linkClicked)=\"onLinkClicked($event)\"\n      (cardClicked)=\"onCardClicked($event)\"\n      (containerWidth)=\"onContainerWidthChange($event)\"\n      [menuButtonScreenReaderText]=\"menuButtonScreenReaderText\"\n      [locale]=\"locale\"\n    ></sie-ui-cards-container>\n  </ng-template>\n</sie-ui-carousel>\n" }]
        }], ctorParameters: function () { return [{ type: i1$2.BreakpointObserver }, { type: i1$1.LayoutService }, { type: i0.ChangeDetectorRef }, { type: UiCardsContainerService }, { type: i0.ElementRef }, { type: i0.Renderer2 }]; }, propDecorators: { carousel: [{
                type: ViewChild,
                args: ['carousel']
            }], items: [{
                type: Input
            }], orientation: [{
                type: Input
            }], theme: [{
                type: Input
            }], menuButtonScreenReaderText: [{
                type: Input
            }], locale: [{
                type: Input
            }], carouselScreenReaderText: [{
                type: Input
            }], containerStyled: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], cutOff: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], buttonClick: [{
                type: Output
            }], childActionClicked: [{
                type: Output
            }], linkClicked: [{
                type: Output
            }], cardClicked: [{
                type: Output
            }] } });

class UiCardsArrangementModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCardsArrangementModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiCardsArrangementModule, declarations: [UiCardsArrangementComponent], imports: [CommonModule, UiCardsContainerModule, UiCarouselModule], exports: [UiCardsArrangementComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCardsArrangementModule, imports: [CommonModule, UiCardsContainerModule, UiCarouselModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCardsArrangementModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiCardsArrangementComponent],
                    imports: [CommonModule, UiCardsContainerModule, UiCarouselModule],
                    exports: [UiCardsArrangementComponent]
                }]
        }] });

const openTiming = '80ms cubic-bezier(0, 0, .38, .9)';
const closeTiming = '80ms cubic-bezier(.35, 0, 1, .9)';
const toggleSuggestionsAnimation = trigger('openClose', [
    transition(':enter', [
        animate(openTiming, keyframes([style({ height: '0', opacity: 0, overflow: 'hidden' }), style({ height: '*', opacity: 1 })]))
    ]),
    transition(':leave', [
        animate(closeTiming, keyframes([style({ height: '*', opacity: 1, overflow: 'hidden' }), style({ height: '0', opacity: 0 })]))
    ])
]);

/** @ignore */
var InputValidity;
(function (InputValidity) {
    InputValidity[InputValidity["Valid"] = 0] = "Valid";
    InputValidity[InputValidity["RequiredError"] = 1] = "RequiredError";
    InputValidity[InputValidity["Error"] = 2] = "Error";
    InputValidity[InputValidity["AllowedLengthError"] = 3] = "AllowedLengthError";
    InputValidity[InputValidity["PatternValidationError"] = 4] = "PatternValidationError";
})(InputValidity || (InputValidity = {}));
/**
 * Base directive as base for all components that allow user's inputs
 */
class InputBaseDirective extends NgFormControlDirective {
    get value() {
        return this._value;
    }
    /**
     * @param value Value of the input
     * @default '' empty string
     */
    set value(value) {
        this.writeValue(value);
        this.markAsTouched();
        this.onChange(value);
        this.validateInput();
    }
    /**
     * @param required Defines if input is required
     * @default false
     */
    set required(required) {
        this._required = coerceBooleanProperty(required);
    }
    get required() {
        return this._required;
    }
    /**
     * @param invalid Sets state of the component as invalid and adds style changes
     * @default false
     */
    set invalid(invalid) {
        this._invalid = coerceBooleanProperty(invalid);
        this.validateInput();
    }
    get invalid() {
        return this._invalid;
    }
    /**
     * @param value Defines if input is focused
     * @default false
     */
    set inputFocused(value) {
        this._inputFocused = coerceBooleanProperty(value);
    }
    get inputFocused() {
        return this._inputFocused;
    }
    /**
     * @param value Defines how much characters text input components accepts
     */
    set allowedCharacterLength(value) {
        this._allowedCharacterLength = coerceNumberProperty(value);
    }
    get allowedCharacterLength() {
        return this._allowedCharacterLength;
    }
    /**
     * @param value Defines the condensed variance of the input.
     * Available only for the following input types:
     * - `text`: regular text input
     * - `textarea`: textarea input
     * @default false
     */
    set condensed(value) {
        this._condensed = coerceBooleanProperty(value);
    }
    get condensed() {
        return this._condensed;
    }
    /** @ignore */
    set error(error) {
        this._error = error;
    }
    get error() {
        return this._error;
    }
    constructor(cdr) {
        super();
        this.cdr = cdr;
        /** @ignore */
        this.labelTransformed = false;
        this._value = '';
        this._required = false;
        this._inputFocused = false;
        this._condensed = false;
        this.validityState = InputValidity.Valid;
        this.errorMessages = [''];
        /**
         * Defines the text used by screen readers for the reset icon button
         * @default '' (empty string)
         */
        this.resetButtonScreenReaderText = '';
        /** @ignore */
        this.cssErrorClass = '';
        /**
         * Defines the autocomplete attribute
         * @default 'on'
         */
        this.autocomplete = 'on';
        /**
         * Defines whether internal validation is used.
         * If set to `false` the error must be set externally, bound to a FormControl for example.
         */
        this.internalValidation = true;
        /** @ignore */
        this.mode = 'input';
        /** @ignore */
        this.inlineSearch = false;
        /** @ignore */
        this.combobox = false;
        /**
         * Event triggered when the input is focused
         */
        this.focused = new EventEmitter();
        /**
         * Event triggered the input is blurred
         */
        this.blurred = new EventEmitter();
        /**
         * When a value in the input is changed. The emitted value is the input's value
         */
        this.valueChange = new EventEmitter();
        /**
         * Event triggered when the reset input icon is clicked.
         */
        this.resetInput = new EventEmitter();
        this.placeholder = '';
    }
    /** @ignore */
    ngOnInit() {
        this.checkLabelStyleOnLoad();
    }
    /** @ignore */
    ngOnChanges(changes) {
        const messagePopulationTriggers = ['errorMessage', 'ErrorMessage'];
        const populateMessages = Object.keys(changes).some(change => {
            return messagePopulationTriggers.some(trigger => {
                return change.includes(trigger);
            });
        });
        if (populateMessages) {
            this.populateErrorMessages();
            this.setValidity(this.validityState);
        }
    }
    /**
     * Triggers the change detection of the component
     */
    updateView() {
        this.cdr.detectChanges();
    }
    /** @ignore */
    onFocus(e) {
        this.labelTransformed = !this._condensed || !this.inlineSearch;
        this.inputFocused = true;
        e.target.placeholder = this.placeholder;
        this.focused.emit();
    }
    /** @ignore */
    onBlur(e) {
        this.onTouched();
        const target = e.target;
        if (target.value === '') {
            this.labelTransformed = false;
        }
        this.inputFocused = false;
        if (this._condensed || this.inlineSearch) {
            target.placeholder = this.placeholder;
        }
        else {
            target.placeholder = '';
        }
        this.blurred.emit();
    }
    /** @ignore */
    onValueChange(e) {
        this.valueChange.emit(e);
    }
    /** @ignore */
    checkLabelStyleOnLoad() {
        if (this._value && this._value !== '') {
            this.labelTransformed = true;
        }
        else if (!this.inputFocused && !this.touched) {
            this.labelTransformed = false;
        }
    }
    /** @ignore */
    writeValue(value) {
        this._value = value;
        this.checkLabelStyleOnLoad();
    }
    /** @ignore */
    isInputValid() {
        let validity = InputValidity.Valid;
        validity ||= this.condition(!this.isValidRequired(), InputValidity.RequiredError);
        validity ||= this.condition(!this.isValidAllowedLength(), InputValidity.AllowedLengthError);
        validity ||= this.condition(!this.isValidPattern(), InputValidity.PatternValidationError);
        validity ||= this.condition(!this.isValid(), InputValidity.Error);
        return validity;
    }
    /**
     * Enforces the validation of the input component to be triggered
     */
    validateInput() {
        this.setValidity(this.isInputValid());
    }
    /** @ignore */
    validateInternal(control) {
        if (control.value) {
            this.validateInput();
        }
        if (this.validityState !== InputValidity.Valid) {
            return { invalid: this.validityState };
        }
        return null;
    }
    onResetButtonClicked(event) {
        const target = event.target;
        const button = target.closest('button');
        const input = button.parentElement.previousSibling;
        this.value = null;
        this.inputFocused = true;
        input.placeholder = this.placeholder;
        this.dispatchChangeEvent();
        input.focus();
        this.resetInput.emit();
    }
    getInput() {
        return this.inputField;
    }
    focus() {
        this.inputField.nativeElement.focus();
    }
    isValidRequired() {
        return !this.required || (this._value !== null && (this._value !== '' || !this.touched));
    }
    isValidAllowedLength() {
        return this.allowedCharacterLength && this._value ? this._value.length <= this.allowedCharacterLength : true;
    }
    isValidPattern() {
        if (!this._value) {
            return true;
        }
        if (!this.validationPattern) {
            return true;
        }
        return this._value.match(this.validationPattern) !== null;
    }
    isValid() {
        return !this.invalid;
    }
    setValidity(validity) {
        if (this.internalValidation) {
            this.validityState = validity;
            this.error = this.errorMessages[validity];
            this.cdr.markForCheck();
        }
    }
    condition(testCondition, error) {
        return testCondition ? error : InputValidity.Valid;
    }
    populateErrorMessages() {
        ArrayUtil.fromEnum(InputValidity).forEach((validityState) => {
            const errorMessageInput = StringUtil.unCapitalize(validityState) + 'Message';
            if (this[errorMessageInput]) {
                this.errorMessages[InputValidity[validityState]] = this[errorMessageInput];
            }
        });
    }
    dispatchChangeEvent() {
        const event = new Event('change', { bubbles: true });
        this.inputField.nativeElement.dispatchEvent(event);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: InputBaseDirective, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: InputBaseDirective, inputs: { value: "value", requiredErrorMessage: "requiredErrorMessage", allowedLengthErrorMessage: "allowedLengthErrorMessage", validationPattern: "validationPattern", patternValidationErrorMessage: "patternValidationErrorMessage", resetButtonScreenReaderText: "resetButtonScreenReaderText", cssErrorClass: "cssErrorClass", autocomplete: "autocomplete", required: "required", invalid: "invalid", inputFocused: "inputFocused", allowedCharacterLength: "allowedCharacterLength", condensed: "condensed", error: "error", internalValidation: "internalValidation", mode: "mode", inlineSearch: "inlineSearch", combobox: "combobox" }, outputs: { focused: "focused", blurred: "blurred", valueChange: "valueChange", resetInput: "resetInput" }, viewQueries: [{ propertyName: "inputField", first: true, predicate: ["textInput"], descendants: true }], usesInheritance: true, usesOnChanges: true, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: InputBaseDirective, decorators: [{
            type: Directive
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }]; }, propDecorators: { value: [{
                type: Input
            }], requiredErrorMessage: [{
                type: Input
            }], allowedLengthErrorMessage: [{
                type: Input
            }], validationPattern: [{
                type: Input
            }], patternValidationErrorMessage: [{
                type: Input
            }], resetButtonScreenReaderText: [{
                type: Input
            }], cssErrorClass: [{
                type: Input
            }], autocomplete: [{
                type: Input
            }], required: [{
                type: Input
            }], invalid: [{
                type: Input
            }], inputFocused: [{
                type: Input
            }], allowedCharacterLength: [{
                type: Input
            }], condensed: [{
                type: Input
            }], error: [{
                type: Input
            }], internalValidation: [{
                type: Input
            }], mode: [{
                type: Input
            }], inlineSearch: [{
                type: Input
            }], combobox: [{
                type: Input
            }], focused: [{
                type: Output
            }], blurred: [{
                type: Output
            }], valueChange: [{
                type: Output
            }], resetInput: [{
                type: Output
            }], inputField: [{
                type: ViewChild,
                args: ['textInput']
            }] } });

class UiBaseInputComponent extends InputBaseDirective {
    constructor(iconReg, cdr) {
        super(cdr);
        this.iconReg = iconReg;
        this.cdr = cdr;
        this.iconName = this.iconReg.sieIcon.Information;
        iconReg.register(SieIcon.Information);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiBaseInputComponent, deps: [{ token: i1.SieIconRegistryService }, { token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiBaseInputComponent, selector: "sie-ui-base-input", inputs: { labelTransformed: "labelTransformed", validationPattern: "validationPattern" }, usesInheritance: true, ngImport: i0, template: "<div class=\"base-input__container\" [ngClass]=\"{ condensed: condensed }\">\n  <label\n    *ngIf=\"condensed && !readonly\"\n    [for]=\"id\"\n    class=\"base-input__label--condensed\"\n    [ngClass]=\"{ 'is-invalid': invalid || error }\"\n    >{{ label }}<span *ngIf=\"required && label\">*</span>\n  </label>\n  <div\n    *ngIf=\"!readonly; else readOnly\"\n    class=\"base-input\"\n    [ngClass]=\"[\n      customClass,\n      inputFocused ? 'is-focused' : '',\n      invalid || error ? 'is-invalid' : '',\n      disabled ? 'is-disabled' : '',\n      condensed ? 'is-condensed' : '',\n      mode !== 'input' ? 'base-input--textarea' : ''\n    ]\"\n  >\n    <label\n      *ngIf=\"!condensed\"\n      [for]=\"id\"\n      class=\"base-input__label\"\n      [ngClass]=\"{\n        'is-focused': inputFocused,\n        transformed: labelTransformed || placeholder !== '',\n        'base-input__label--textarea': mode === 'textarea'\n      }\"\n      ><span>{{ label }}</span\n      ><span *ngIf=\"required && label\">*</span></label\n    >\n    <div class=\"base-input__wrapper\" [ngClass]=\"{ 'base-input__wrapper--textarea': mode !== 'input' }\">\n      <ng-content></ng-content>\n    </div>\n  </div>\n  <span class=\"base-input__hint-tooltip\" *ngIf=\"hint?.type === 'tooltip' && hint?.content\">\n    <sie-icon\n      class=\"base-input__hint-tooltip-icon\"\n      sieUiPopover\n      [popoverSize]=\"hint?.size ? hint?.size : 's'\"\n      [content]=\"hint?.content\"\n      [name]=\"iconReg.sieIcon.Information\"\n    ></sie-icon>\n  </span>\n</div>\n<div class=\"base-input__error\" *ngIf=\"error && !readonly\" [ngClass]=\"cssErrorClass\">\n  <sie-ui-richtext class=\"base-input__error-content\" [content]=\"error\"></sie-ui-richtext>\n</div>\n<div class=\"base-input__hint-inline\" *ngIf=\"hint?.type === 'inline' && hint?.content\">\n  <sie-ui-richtext class=\"base-input__hint-inline\" [content]=\"hint.content\"></sie-ui-richtext>\n</div>\n<ng-template #readOnly>\n  <sie-ui-readonly [value]=\"value\" [label]=\"label\" [name]=\"name\" [displayValue]=\"value\"></sie-ui-readonly>\n</ng-template>\n", styles: ["input::-webkit-outer-spin-button,input::-webkit-inner-spin-button{-webkit-appearance:none;margin:0}.base-input{display:inline-flex;position:relative;width:100%;height:100%;min-height:3.5rem;border-bottom:1px solid #4c4c68;padding:0 15px 0 16px;background-color:#ebf7f8;flex-wrap:wrap}.base-input.is-condensed{min-height:2.5rem}.base-input.inline-search--s{min-height:3rem;border-bottom:none}.base-input--textarea{padding-right:8px}.base-input--textarea.is-focused{outline:1px solid #1491eb;outline-offset:2px}.base-input__container{display:flex;align-items:center}.base-input__container.condensed{display:flex;flex-direction:column;align-items:flex-start}.base-input__wrapper{position:absolute;width:100%;height:100%;top:0;left:0}.base-input__wrapper--textarea{position:relative}.base-input__label{font-size:1rem;font-weight:400;line-height:1.5rem;white-space:nowrap;overflow:hidden;text-overflow:ellipsis;display:inline-block;width:100%;color:#4c4c68;padding-top:16px;transition:all .15s,color 0ms}.base-input__label--textarea{position:absolute;width:calc(100% - 24px)}.base-input__label--condensed{margin-bottom:8px;color:#000028}.base-input__label--condensed.is-invalid{color:#ef0137}.base-input__label.transformed{font-size:.75rem;font-weight:400;line-height:1rem;padding-top:6px}.base-input__label.transformed span{position:relative;z-index:3}.base-input.is-disabled{border-bottom:none;background-color:#ebf7f8}.base-input.is-disabled .base-input__label{color:#b3b3be}.base-input.is-invalid:not(.is-disabled){background-color:#fcccd7;border-bottom:1px solid #ef0137}.base-input.is-invalid:not(.is-disabled) .base-input__label{color:#4c4c68}.base-input.is-invalid:not(.is-disabled) .base-input__label.transformed{color:#ef0137}.base-input:hover:not(.is-invalid):not(.is-disabled),.base-input.is-focused:not(.is-invalid):not(.is-disabled){background-color:#d1fff2;border-bottom:1px solid #00d7a0}.base-input:hover:not(.is-invalid):not(.is-disabled) .base-input__label,.base-input.is-focused:not(.is-invalid):not(.is-disabled) .base-input__label{color:#00646e}.base-input:hover:not(.is-invalid):not(.is-disabled) .base-input__label:not(.transformed),.base-input.is-focused:not(.is-invalid):not(.is-disabled) .base-input__label:not(.transformed){color:#000028}.base-input__error{font-size:.75rem;font-weight:400;line-height:1rem;margin-top:4px;margin-left:16px;color:#ef0137}.base-input__error.combobox-cdk-overlay-error{position:relative;top:4px;height:0;margin-top:0}.base-input__hint-tooltip{margin-left:10px}.base-input__hint-tooltip-icon{width:20px;height:20px;display:flex;align-items:center;fill:currentColor;color:#4c4c68}.base-input__hint-tooltip-icon svg{fill:currentColor;width:inherit;height:inherit}.base-input__hint-tooltip-icon svg g{fill:currentColor;width:inherit;height:inherit}.base-input__hint-tooltip-icon svg text{font-family:Siemens Sans,sans-serif}.base-input__hint-inline{font-size:.75rem;font-weight:400;line-height:1rem;margin-top:4px;color:#4c4c68}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: UiReadonlyComponent, selector: "sie-ui-readonly", inputs: ["value", "label", "displayValue", "name", "theme", "icons"] }, { kind: "component", type: UiRichtextComponent, selector: "sie-ui-richtext", inputs: ["content", "theme", "whiteListedTags"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "directive", type: UiPopoverDirective, selector: "[sieUiPopover]", inputs: ["content", "popoverTemplate", "popoverSize", "popoverPlacement", "popoverAnimation", "popoverPlayAnimation", "popoverAnimationHideAfterTimeoutMS", "popoverLightTheme"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiBaseInputComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-base-input', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"base-input__container\" [ngClass]=\"{ condensed: condensed }\">\n  <label\n    *ngIf=\"condensed && !readonly\"\n    [for]=\"id\"\n    class=\"base-input__label--condensed\"\n    [ngClass]=\"{ 'is-invalid': invalid || error }\"\n    >{{ label }}<span *ngIf=\"required && label\">*</span>\n  </label>\n  <div\n    *ngIf=\"!readonly; else readOnly\"\n    class=\"base-input\"\n    [ngClass]=\"[\n      customClass,\n      inputFocused ? 'is-focused' : '',\n      invalid || error ? 'is-invalid' : '',\n      disabled ? 'is-disabled' : '',\n      condensed ? 'is-condensed' : '',\n      mode !== 'input' ? 'base-input--textarea' : ''\n    ]\"\n  >\n    <label\n      *ngIf=\"!condensed\"\n      [for]=\"id\"\n      class=\"base-input__label\"\n      [ngClass]=\"{\n        'is-focused': inputFocused,\n        transformed: labelTransformed || placeholder !== '',\n        'base-input__label--textarea': mode === 'textarea'\n      }\"\n      ><span>{{ label }}</span\n      ><span *ngIf=\"required && label\">*</span></label\n    >\n    <div class=\"base-input__wrapper\" [ngClass]=\"{ 'base-input__wrapper--textarea': mode !== 'input' }\">\n      <ng-content></ng-content>\n    </div>\n  </div>\n  <span class=\"base-input__hint-tooltip\" *ngIf=\"hint?.type === 'tooltip' && hint?.content\">\n    <sie-icon\n      class=\"base-input__hint-tooltip-icon\"\n      sieUiPopover\n      [popoverSize]=\"hint?.size ? hint?.size : 's'\"\n      [content]=\"hint?.content\"\n      [name]=\"iconReg.sieIcon.Information\"\n    ></sie-icon>\n  </span>\n</div>\n<div class=\"base-input__error\" *ngIf=\"error && !readonly\" [ngClass]=\"cssErrorClass\">\n  <sie-ui-richtext class=\"base-input__error-content\" [content]=\"error\"></sie-ui-richtext>\n</div>\n<div class=\"base-input__hint-inline\" *ngIf=\"hint?.type === 'inline' && hint?.content\">\n  <sie-ui-richtext class=\"base-input__hint-inline\" [content]=\"hint.content\"></sie-ui-richtext>\n</div>\n<ng-template #readOnly>\n  <sie-ui-readonly [value]=\"value\" [label]=\"label\" [name]=\"name\" [displayValue]=\"value\"></sie-ui-readonly>\n</ng-template>\n", styles: ["input::-webkit-outer-spin-button,input::-webkit-inner-spin-button{-webkit-appearance:none;margin:0}.base-input{display:inline-flex;position:relative;width:100%;height:100%;min-height:3.5rem;border-bottom:1px solid #4c4c68;padding:0 15px 0 16px;background-color:#ebf7f8;flex-wrap:wrap}.base-input.is-condensed{min-height:2.5rem}.base-input.inline-search--s{min-height:3rem;border-bottom:none}.base-input--textarea{padding-right:8px}.base-input--textarea.is-focused{outline:1px solid #1491eb;outline-offset:2px}.base-input__container{display:flex;align-items:center}.base-input__container.condensed{display:flex;flex-direction:column;align-items:flex-start}.base-input__wrapper{position:absolute;width:100%;height:100%;top:0;left:0}.base-input__wrapper--textarea{position:relative}.base-input__label{font-size:1rem;font-weight:400;line-height:1.5rem;white-space:nowrap;overflow:hidden;text-overflow:ellipsis;display:inline-block;width:100%;color:#4c4c68;padding-top:16px;transition:all .15s,color 0ms}.base-input__label--textarea{position:absolute;width:calc(100% - 24px)}.base-input__label--condensed{margin-bottom:8px;color:#000028}.base-input__label--condensed.is-invalid{color:#ef0137}.base-input__label.transformed{font-size:.75rem;font-weight:400;line-height:1rem;padding-top:6px}.base-input__label.transformed span{position:relative;z-index:3}.base-input.is-disabled{border-bottom:none;background-color:#ebf7f8}.base-input.is-disabled .base-input__label{color:#b3b3be}.base-input.is-invalid:not(.is-disabled){background-color:#fcccd7;border-bottom:1px solid #ef0137}.base-input.is-invalid:not(.is-disabled) .base-input__label{color:#4c4c68}.base-input.is-invalid:not(.is-disabled) .base-input__label.transformed{color:#ef0137}.base-input:hover:not(.is-invalid):not(.is-disabled),.base-input.is-focused:not(.is-invalid):not(.is-disabled){background-color:#d1fff2;border-bottom:1px solid #00d7a0}.base-input:hover:not(.is-invalid):not(.is-disabled) .base-input__label,.base-input.is-focused:not(.is-invalid):not(.is-disabled) .base-input__label{color:#00646e}.base-input:hover:not(.is-invalid):not(.is-disabled) .base-input__label:not(.transformed),.base-input.is-focused:not(.is-invalid):not(.is-disabled) .base-input__label:not(.transformed){color:#000028}.base-input__error{font-size:.75rem;font-weight:400;line-height:1rem;margin-top:4px;margin-left:16px;color:#ef0137}.base-input__error.combobox-cdk-overlay-error{position:relative;top:4px;height:0;margin-top:0}.base-input__hint-tooltip{margin-left:10px}.base-input__hint-tooltip-icon{width:20px;height:20px;display:flex;align-items:center;fill:currentColor;color:#4c4c68}.base-input__hint-tooltip-icon svg{fill:currentColor;width:inherit;height:inherit}.base-input__hint-tooltip-icon svg g{fill:currentColor;width:inherit;height:inherit}.base-input__hint-tooltip-icon svg text{font-family:Siemens Sans,sans-serif}.base-input__hint-inline{font-size:.75rem;font-weight:400;line-height:1rem;margin-top:4px;color:#4c4c68}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }, { type: i0.ChangeDetectorRef }]; }, propDecorators: { labelTransformed: [{
                type: Input
            }], validationPattern: [{
                type: Input
            }] } });

/**
 * # Text Input Component
 *
 * Text input allows users to add free text input.
 *
 * ## Component variations
 * - Standard variation
 * - Condensed variation
 *
 * ## Content
 *
 * The Text input component does not accept any content.
 *
 * ## Code example
 * @example ```html
 * <sie-ui-text-input label="Headline" placeholder="Put in the headline you want"></sie-ui-text-input>
 * ```
 */
class UiTextInputComponent extends InputBaseDirective {
    constructor(cdr, iconReg) {
        super(cdr);
        this.cdr = cdr;
        this.iconReg = iconReg;
        /**
         * Defines which type the input component should use
         * @default 'text'
         */
        this.inputType = 'text';
        /** @ignore */
        this.placeholderIcon = false;
        iconReg.register(SieIcon.SearchSmall);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTextInputComponent, deps: [{ token: i0.ChangeDetectorRef }, { token: i1.SieIconRegistryService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiTextInputComponent, selector: "sie-ui-text-input", inputs: { inputType: "inputType", placeholderIcon: "placeholderIcon" }, providers: [
            {
                provide: NG_VALUE_ACCESSOR,
                multi: true,
                useExisting: UiTextInputComponent
            },
            {
                provide: NG_VALIDATORS,
                multi: true,
                useExisting: UiTextInputComponent
            },
            {
                provide: FORM_COMPONENT_ACCESSOR,
                useExisting: forwardRef(() => UiTextInputComponent)
            }
        ], usesInheritance: true, ngImport: i0, template: "<sie-ui-base-input\n  [ngClass]=\"{ 'is-inline-search': inlineSearch }\"\n  [readonly]=\"readonly\"\n  [id]=\"id\"\n  [label]=\"label\"\n  [value]=\"value\"\n  [labelTransformed]=\"labelTransformed\"\n  [inputFocused]=\"inputFocused\"\n  [invalid]=\"invalid\"\n  [disabled]=\"disabled\"\n  [required]=\"required && !disabled\"\n  [error]=\"error\"\n  [errorMessage]=\"errorMessage\"\n  [requiredErrorMessage]=\"requiredErrorMessage\"\n  [allowedLengthErrorMessage]=\"allowedLengthErrorMessage\"\n  [allowedCharacterLength]=\"allowedCharacterLength\"\n  [patternValidationErrorMessage]=\"patternValidationErrorMessage\"\n  [validationPattern]=\"validationPattern\"\n  [hint]=\"hint\"\n  [cssErrorClass]=\"cssErrorClass\"\n  [condensed]=\"condensed\"\n  [inlineSearch]=\"inlineSearch\"\n  [customClass]=\"customClass\"\n  [internalValidation]=\"internalValidation\"\n>\n  <sie-icon\n    class=\"placeholder-icon\"\n    *ngIf=\"inlineSearch && placeholderIcon\"\n    [name]=\"iconReg.sieIcon.SearchSmall\"\n    [ngClass]=\"{\n      'is-focused': inputFocused,\n      'is-disabled': disabled\n    }\"\n  ></sie-icon>\n  <input\n    [id]=\"id\"\n    class=\"text-input__input-field\"\n    [ngClass]=\"{\n      'is-focused': inputFocused,\n      'is-invalid': invalid || error,\n      'is-disabled': disabled,\n      'is-condensed': condensed,\n      'is-inline-search': inlineSearch,\n      'is-combobox': combobox,\n      'has-icon': placeholderIcon\n    }\"\n    [type]=\"inputType\"\n    [disabled]=\"disabled\"\n    [autocomplete]=\"autocomplete\"\n    [placeholder]=\"condensed || inlineSearch ? placeholder : ''\"\n    (focus)=\"onFocus($event)\"\n    (blur)=\"onBlur($event)\"\n    [(ngModel)]=\"value\"\n    (ngModelChange)=\"onValueChange($event)\"\n    [attr.aria-invalid]=\"errorMessage || invalid\"\n    [attr.aria-describedby]=\"id + '_errorMessage'\"\n    #textInput\n    #validate=\"ngModel\"\n  />\n  <span [id]=\"id + '_errorMessage'\" class=\"visually-hidden\">{{ errorMessage }}</span>\n  <sie-ui-icon-button\n    *ngIf=\"value\"\n    class=\"reset-button\"\n    [ngClass]=\"{\n      condensed: condensed,\n      'is-combobox': combobox\n    }\"\n    [disabled]=\"inlineSearch ? false : disabled\"\n    [iconScreenReaderText]=\"resetButtonScreenReaderText\"\n    (clicked)=\"onResetButtonClicked($event)\"\n  ></sie-ui-icon-button>\n</sie-ui-base-input>\n", styles: [".password-input__input-field:focus,.text-input__input-field:focus,.textarea__input-field:focus,.password-input__input-field:focus-visible,.text-input__input-field:focus-visible,.textarea__input-field:focus-visible{outline:0}.password-input__input-field,.text-input__input-field{outline:none;outline-offset:0}@media (pointer: fine){.password-input__input-field,.text-input__input-field{position:relative}.password-input__input-field:focus,.text-input__input-field:focus{outline:1px solid #1491eb;outline-offset:2px}.password-input__input-field:focus:not(:focus-visible),.text-input__input-field:focus:not(:focus-visible){outline:0}.password-input__input-field:focus-visible,.text-input__input-field:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}:host{display:block}.text-input__input-field.is-condensed{padding:8px 55px 8px 16px}.text-input__input-field.is-condensed::placeholder,.text-input__input-field.is-inline-search::placeholder{color:#4c4c68}.text-input__input-field.is-inline-search{padding:.125rem 3rem 0 1rem}.text-input__input-field.is-inline-search.has-icon{padding:.125rem 3rem 0 2.5rem}.text-input__input-field.is-inline-search:placeholder-shown{text-overflow:ellipsis}.text-input__input-field.is-combobox{padding-right:65px}.password-input__input-field,.text-input__input-field,.textarea__input-field{font-size:1rem;font-weight:400;line-height:1.5rem;font-family:Siemens Sans,sans-serif;display:flex;width:100%;height:100%;border:0;background-color:transparent;color:#000028;padding:22px 55px 10px 16px}.password-input__input-field.is-disabled,.password-input__input-field.is-disabled::placeholder,.text-input__input-field.is-disabled,.text-input__input-field.is-disabled::placeholder,.textarea__input-field.is-disabled,.textarea__input-field.is-disabled::placeholder{color:#b3b3be;-webkit-text-fill-color:#b3b3be;opacity:1;cursor:not-allowed}.password-input__input-field.is-focused:not(.is-invalid):not(.is-disabled)::placeholder,.text-input__input-field.is-focused:not(.is-invalid):not(.is-disabled)::placeholder,.textarea__input-field.is-focused:not(.is-invalid):not(.is-disabled)::placeholder{color:#9999a9}.reset-button{position:absolute;top:18px;right:8px}.reset-button.is-combobox{right:35px}.reset-button.condensed{top:12px}.reset-button.condensed.search{top:10px}.textarea__input-field{padding:0}.placeholder-icon{width:20px;height:20px;display:flex;align-items:center;fill:currentColor;color:#4c4c68;fill:#4c4c68;position:absolute;left:.75rem;top:50%;transform:translateY(-50%)}.placeholder-icon svg{fill:currentColor;width:inherit;height:inherit}.placeholder-icon svg g{fill:currentColor;width:inherit;height:inherit}.placeholder-icon svg text{font-family:Siemens Sans,sans-serif}.placeholder-icon:hover,.placeholder-icon.is-focused{color:#000028;fill:#000028}.placeholder-icon.is-disabled{color:#b3b3be;fill:#b3b3be}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i3.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i3.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i3.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "component", type: UiBaseInputComponent, selector: "sie-ui-base-input", inputs: ["labelTransformed", "validationPattern"] }, { kind: "component", type: UiIconButtonComponent, selector: "sie-ui-icon-button", inputs: ["theme", "disabled", "hoverColored", "iconScreenReaderText", "icon"], outputs: ["clicked"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTextInputComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-text-input', changeDetection: ChangeDetectionStrategy.OnPush, providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            multi: true,
                            useExisting: UiTextInputComponent
                        },
                        {
                            provide: NG_VALIDATORS,
                            multi: true,
                            useExisting: UiTextInputComponent
                        },
                        {
                            provide: FORM_COMPONENT_ACCESSOR,
                            useExisting: forwardRef(() => UiTextInputComponent)
                        }
                    ], template: "<sie-ui-base-input\n  [ngClass]=\"{ 'is-inline-search': inlineSearch }\"\n  [readonly]=\"readonly\"\n  [id]=\"id\"\n  [label]=\"label\"\n  [value]=\"value\"\n  [labelTransformed]=\"labelTransformed\"\n  [inputFocused]=\"inputFocused\"\n  [invalid]=\"invalid\"\n  [disabled]=\"disabled\"\n  [required]=\"required && !disabled\"\n  [error]=\"error\"\n  [errorMessage]=\"errorMessage\"\n  [requiredErrorMessage]=\"requiredErrorMessage\"\n  [allowedLengthErrorMessage]=\"allowedLengthErrorMessage\"\n  [allowedCharacterLength]=\"allowedCharacterLength\"\n  [patternValidationErrorMessage]=\"patternValidationErrorMessage\"\n  [validationPattern]=\"validationPattern\"\n  [hint]=\"hint\"\n  [cssErrorClass]=\"cssErrorClass\"\n  [condensed]=\"condensed\"\n  [inlineSearch]=\"inlineSearch\"\n  [customClass]=\"customClass\"\n  [internalValidation]=\"internalValidation\"\n>\n  <sie-icon\n    class=\"placeholder-icon\"\n    *ngIf=\"inlineSearch && placeholderIcon\"\n    [name]=\"iconReg.sieIcon.SearchSmall\"\n    [ngClass]=\"{\n      'is-focused': inputFocused,\n      'is-disabled': disabled\n    }\"\n  ></sie-icon>\n  <input\n    [id]=\"id\"\n    class=\"text-input__input-field\"\n    [ngClass]=\"{\n      'is-focused': inputFocused,\n      'is-invalid': invalid || error,\n      'is-disabled': disabled,\n      'is-condensed': condensed,\n      'is-inline-search': inlineSearch,\n      'is-combobox': combobox,\n      'has-icon': placeholderIcon\n    }\"\n    [type]=\"inputType\"\n    [disabled]=\"disabled\"\n    [autocomplete]=\"autocomplete\"\n    [placeholder]=\"condensed || inlineSearch ? placeholder : ''\"\n    (focus)=\"onFocus($event)\"\n    (blur)=\"onBlur($event)\"\n    [(ngModel)]=\"value\"\n    (ngModelChange)=\"onValueChange($event)\"\n    [attr.aria-invalid]=\"errorMessage || invalid\"\n    [attr.aria-describedby]=\"id + '_errorMessage'\"\n    #textInput\n    #validate=\"ngModel\"\n  />\n  <span [id]=\"id + '_errorMessage'\" class=\"visually-hidden\">{{ errorMessage }}</span>\n  <sie-ui-icon-button\n    *ngIf=\"value\"\n    class=\"reset-button\"\n    [ngClass]=\"{\n      condensed: condensed,\n      'is-combobox': combobox\n    }\"\n    [disabled]=\"inlineSearch ? false : disabled\"\n    [iconScreenReaderText]=\"resetButtonScreenReaderText\"\n    (clicked)=\"onResetButtonClicked($event)\"\n  ></sie-ui-icon-button>\n</sie-ui-base-input>\n", styles: [".password-input__input-field:focus,.text-input__input-field:focus,.textarea__input-field:focus,.password-input__input-field:focus-visible,.text-input__input-field:focus-visible,.textarea__input-field:focus-visible{outline:0}.password-input__input-field,.text-input__input-field{outline:none;outline-offset:0}@media (pointer: fine){.password-input__input-field,.text-input__input-field{position:relative}.password-input__input-field:focus,.text-input__input-field:focus{outline:1px solid #1491eb;outline-offset:2px}.password-input__input-field:focus:not(:focus-visible),.text-input__input-field:focus:not(:focus-visible){outline:0}.password-input__input-field:focus-visible,.text-input__input-field:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}:host{display:block}.text-input__input-field.is-condensed{padding:8px 55px 8px 16px}.text-input__input-field.is-condensed::placeholder,.text-input__input-field.is-inline-search::placeholder{color:#4c4c68}.text-input__input-field.is-inline-search{padding:.125rem 3rem 0 1rem}.text-input__input-field.is-inline-search.has-icon{padding:.125rem 3rem 0 2.5rem}.text-input__input-field.is-inline-search:placeholder-shown{text-overflow:ellipsis}.text-input__input-field.is-combobox{padding-right:65px}.password-input__input-field,.text-input__input-field,.textarea__input-field{font-size:1rem;font-weight:400;line-height:1.5rem;font-family:Siemens Sans,sans-serif;display:flex;width:100%;height:100%;border:0;background-color:transparent;color:#000028;padding:22px 55px 10px 16px}.password-input__input-field.is-disabled,.password-input__input-field.is-disabled::placeholder,.text-input__input-field.is-disabled,.text-input__input-field.is-disabled::placeholder,.textarea__input-field.is-disabled,.textarea__input-field.is-disabled::placeholder{color:#b3b3be;-webkit-text-fill-color:#b3b3be;opacity:1;cursor:not-allowed}.password-input__input-field.is-focused:not(.is-invalid):not(.is-disabled)::placeholder,.text-input__input-field.is-focused:not(.is-invalid):not(.is-disabled)::placeholder,.textarea__input-field.is-focused:not(.is-invalid):not(.is-disabled)::placeholder{color:#9999a9}.reset-button{position:absolute;top:18px;right:8px}.reset-button.is-combobox{right:35px}.reset-button.condensed{top:12px}.reset-button.condensed.search{top:10px}.textarea__input-field{padding:0}.placeholder-icon{width:20px;height:20px;display:flex;align-items:center;fill:currentColor;color:#4c4c68;fill:#4c4c68;position:absolute;left:.75rem;top:50%;transform:translateY(-50%)}.placeholder-icon svg{fill:currentColor;width:inherit;height:inherit}.placeholder-icon svg g{fill:currentColor;width:inherit;height:inherit}.placeholder-icon svg text{font-family:Siemens Sans,sans-serif}.placeholder-icon:hover,.placeholder-icon.is-focused{color:#000028;fill:#000028}.placeholder-icon.is-disabled{color:#b3b3be;fill:#b3b3be}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i1.SieIconRegistryService }]; }, propDecorators: { inputType: [{
                type: Input
            }], placeholderIcon: [{
                type: Input
            }] } });

const MAX_SUGGESTIONS = 10;
const BLUR_DEBOUNCE = 150;
/**
 * # Inline Search Component
 *
 * Search field provides search results within the same context it has been used. It allows user to find the information
 * without changing the page/context and intends to provide the results quickly.
 *
 * ## Component variations
 *
 * - Component can include suggestion list which is then filtered as the user adds input to the field.
 *
 * ## Content
 *
 * The component can contain any type of content. If content is provided, it will be displayed in the flyout instead of the suggestion list.
 *
 * ## Code example
 * @example ```html
 * <sie-ui-inline-search
 *   placeholder="Search for..."
 *   [suggestions]="[
 *     {
 *       primaryLabel: 'Apple',
 *       secondaryLabel: 'Sweet reddish fruit',
 *       suggestionData: 'anything you want you can add here'
 *     }
 *   ]"
 *   (suggestionSelected)="suggestionSelected($event)"
 *   noResultsMessage="No results"
 *   (fieldCleared)="clearSuggestion()"
 * >
 *  <placeholder-component></placeholder-component>
 * </sie-ui-inline-search>
 * ```
 */
class UiInlineSearchComponent {
    /**
     * List of {@link UiInlineSearchSuggestion suggestion items} being rendered in this component
     */
    get suggestions() {
        return this._suggestions;
    }
    set suggestions(value) {
        if (value !== undefined) {
            this._suggestions = value?.slice(0, MAX_SUGGESTIONS);
            this.suggestionCircularArray.set(this._suggestions);
        }
        else {
            this._suggestions = [];
        }
    }
    /**
     * @param value Whether to show the placeholder icon
     * @default true
     */
    set showPlaceholderIcon(value) {
        this._showPlaceholderIcon = coerceBooleanProperty(value);
    }
    get showPlaceholderIcon() {
        return this._showPlaceholderIcon;
    }
    /**
     * @param value Whether to show the suggestion icon
     * @default false
     */
    set showMobileSuggestionIcon(value) {
        this._showMobileSuggestionIcon = coerceBooleanProperty(value);
    }
    get showMobileSuggestionIcon() {
        return this._showMobileSuggestionIcon;
    }
    /**
     * @param value Whether to animate the suggestions dropdown
     * @default false
     */
    set enableAnimation(value) {
        this._enableAnimation = coerceBooleanProperty(value);
    }
    get enableAnimation() {
        return this._enableAnimation;
    }
    /**
     * @param value Whether to disable the mobile fullscreen suggestions dropdown
     * @default false
     */
    set disableMobileFullScreenOverlay(value) {
        this._disableMobileFullScreenOverlay = coerceBooleanProperty(value);
    }
    get disableMobileFullScreenOverlay() {
        return this._disableMobileFullScreenOverlay;
    }
    /**
     * Defines should component be locked after selecting suggestion from the flyout
     * @default true
     */
    set lockComponent(value) {
        this._lockComponent = coerceBooleanProperty(value);
    }
    get lockComponent() {
        return this._lockComponent;
    }
    /**
     * @param value Disables the component
     * @default false
     */
    set disabled(value) {
        this._disabled = coerceBooleanProperty(value);
    }
    get disabled() {
        return this._disabled;
    }
    /**
     * @param value Locks the component
     * @default false
     */
    set locked(value) {
        this._locked = coerceBooleanProperty(value);
    }
    get locked() {
        return this._locked;
    }
    /**
     * @param value Whether to use the secondary label of suggestion as value
     * @default false (by default primary label is used)
     */
    set useSecondaryLabelAsValue(value) {
        this._useSecondaryLabelAsValue = coerceBooleanProperty(value);
    }
    get useSecondaryLabelAsValue() {
        return this._useSecondaryLabelAsValue;
    }
    /**
     * @param value Boolean value with which we can force the active state on the component
     * @default false
     */
    set activated(value) {
        this._activated = coerceBooleanProperty(value);
    }
    get activated() {
        return this._activated;
    }
    /**
     * @param value Flag to toggle between showing and hiding overlay as fixed variant to span the whole screen (only
     * relevant for viewport S)
     * @default true
     */
    set fixable(value) {
        this._fixable = coerceBooleanProperty(value);
    }
    get fixable() {
        return !this.disableMobileFullScreenOverlay && this._fixable;
    }
    /**
     * @param value Flag to enable custom content within the flyout
     * @default false
     */
    set enableCustomContent(value) {
        this._customContent = coerceBooleanProperty(value);
    }
    get enableCustomContent() {
        return this._customContent;
    }
    /**
     * @param value Defines whether the invalid state of the component should be shown
     * @default false
     */
    set invalid(value) {
        this._invalid = coerceBooleanProperty(value);
    }
    get invalid() {
        return this._invalid;
    }
    /** @ignore */
    get isFixed() {
        return this.fixable && this.fixed;
    }
    /** @ignore */
    set focused(value) {
        this._focused = coerceBooleanProperty(value);
    }
    get focused() {
        return this._focused;
    }
    /** @ignore */
    get notEmpty() {
        return !!this.value;
    }
    /** @ignore */
    get showOverlay() {
        return this._focused && !this.disableFirstOverlayWhenEmpty && (!!this._suggestions?.length || this._customContent);
    }
    /** @ignore */
    get highlightedSuggestion() {
        return this._highlightedSuggestion;
    }
    /** @ignore */
    blurCustomContent(event) {
        if (!this.elementRef.nativeElement.contains(event.target) &&
            this.enableCustomContent &&
            !this.customContent?.nativeElement.contains(event.target)) {
            this.onFieldBlur(true);
        }
    }
    constructor(iconReg, layoutService, cdr, cdrSelf, elementRef) {
        this.iconReg = iconReg;
        this.layoutService = layoutService;
        this.cdr = cdr;
        this.cdrSelf = cdrSelf;
        this.elementRef = elementRef;
        /**
         * Placeholder for the component
         * @default empty string
         */
        this.placeholder = '';
        /**
         * Used to add custom ccs classes to the inline search
         * @default ''
         */
        this.customClass = '';
        /**
         * Message to be shown if the suggestions are available and entered entry gives no results
         * @default empty string
         */
        this.noResultsMessage = '';
        /**
         * Message to be shown if no custom content is provided
         * @default empty string
         */
        this.noContentMessage = '';
        /**
         * ARIA-Label to be shown for the "clear search" button
         * @default empty string
         */
        this.clearSearchScreenReaderText = '';
        /**
         * @param value to hide initial overlay when there is no content
         * @default false
         */
        this.disableFirstOverlayWhenEmpty = false;
        /**
         * Defines if inline search is displayed in condensed styling
         * @default false
         */
        this.condensed = false;
        /**
         * Defines whether the padding for the search overlay should be set to 0 if customContent is enabled
         * @default false
         */
        this.resetCustomContentPadding = false;
        /**
         * {@link UiInlineSearchSuggestion Event} triggered when the suggestion is selected
         */
        this.suggestionSelected = new Subject();
        /**
         * Event triggered when the search field is cleared
         */
        this.fieldCleared = new Subject();
        /**
         * Event triggered when the value of the search field changes. Debounced with 300ms.
         */
        this.valueChange = new EventEmitter();
        /**
         * Event when the search is executed (e.g. Enter key pressed)
         */
        this.search = new Subject();
        /**
         * Event triggered when the value of the search field changes and emits `true` when a value is changed manually
         * (not selected from suggestions)
         */
        this.manualValueChange = new EventEmitter();
        /**
         * Event triggered the input is blurred
         */
        this.blurred = new EventEmitter();
        /** @ignore */
        this.fixed = false;
        this._activated = false;
        this._fixable = true;
        this._disabled = false;
        this._locked = false;
        this._useSecondaryLabelAsValue = false;
        this._focused = false;
        this._showPlaceholderIcon = true;
        this._enableAnimation = false;
        this._showMobileSuggestionIcon = false;
        this._disableMobileFullScreenOverlay = false;
        this._lockComponent = true;
        this._customContent = false;
        this._invalid = false;
        this.blurSubject = new Subject();
        this.blurSubscription = new Subscription();
        this.suggestionCircularArray = new CircularArray();
        this.avoidPointerDownCollision = PointerDeviceService.avoidPointerDownCollision;
        iconReg.register(SieIcon.Close);
        iconReg.register(SieIcon.Ext);
        this.blurSubscription.add(this.blurSubject.pipe(debounceTime(BLUR_DEBOUNCE)).subscribe(close => {
            this.fixed = !close;
            this._focused = !close;
            if (this.cdr) {
                this.cdr.detectChanges();
            }
            this.cdrSelf.detectChanges();
        }));
    }
    /** @ignore */
    ngOnDestroy() {
        this.blurSubscription?.unsubscribe();
    }
    /** @ignore */
    ngAfterViewInit() {
        this._inputElement = this.inputField.getInput();
        if (this.activated) {
            this._inputElement.nativeElement.focus();
        }
    }
    /** @ignore */
    onFieldFocus() {
        clearTimeout(this.blurTimeout);
        this.blurSubject.next(false);
        this.fixed = true;
        this._focused = true;
    }
    /** @ignore */
    onFieldBlur(force = false) {
        if (this.enableCustomContent && !force) {
            return;
        }
        if (this.disableMobileFullScreenOverlay || force || !this.layoutService.isViewport('S')) {
            this.blurSubject.next(true);
        }
        this.blurred.emit();
    }
    /** @ignore */
    selectSuggestion(event, suggestion) {
        event?.stopPropagation();
        this._focused = false;
        if (!suggestion) {
            this.search.next(this.value);
            return;
        }
        this.value = this.useSecondaryLabelAsValue ? suggestion.secondaryLabel : suggestion.primaryLabel;
        this.suggestionSelected.next(deepCopy(suggestion));
        this.manualValueChange.next(false);
        this.valueChange.emit(this.value);
        this.unhighlightSuggestion();
        if (this.lockComponent) {
            this.lock();
        }
    }
    /** @ignore */
    copySuggestion(event, suggestion) {
        this.selectSuggestion(event, suggestion);
        this.focusField();
    }
    /** @ignore */
    onOverlayClick(event) {
        const buttonClicked = event.composedPath().some((eventTarget) => {
            return eventTarget.nodeName?.toLowerCase() === 'button';
        });
        if (!buttonClicked) {
            this.focusField();
        }
    }
    /**
     * Method to lock the component and blur the input field
     */
    lock() {
        this.locked = true;
        this.blurField();
    }
    /**
     * Method to unlock the component which clears the input component and focuses it
     */
    unlock() {
        this.locked = false;
        this.value = '';
        this.valueChange.emit(this.value);
        this.fieldCleared.next();
        this.focusField();
    }
    /** @ignore */
    highlightNextSuggestion() {
        this._highlightedSuggestion = this.suggestionCircularArray.nextIndex();
    }
    /** @ignore */
    highlightPreviousSuggestion() {
        this._highlightedSuggestion = this.suggestionCircularArray.previousIndex();
    }
    /** @ignore */
    highlightSuggestion(index) {
        this.suggestionCircularArray.select(index);
    }
    handleEscape(event) {
        if (this.showOverlay) {
            event.stopPropagation();
        }
        this.unhighlightSuggestion();
    }
    /** @ignore */
    unhighlightSuggestion() {
        this._highlightedSuggestion = null;
        this.suggestionCircularArray.reset();
    }
    /** @ignore */
    onValueChange(value) {
        this.valueChange.emit(value);
        this.manualValueChange.next(true);
    }
    /**
     * Method to set the focus to the component's input field
     */
    focusField() {
        setTimeout(() => {
            this._inputElement.nativeElement.focus();
            this.fixed = true;
            if (this.showMobileSuggestionIcon) {
                const valueLength = this.value?.length;
                this._inputElement.nativeElement.setSelectionRange(valueLength, valueLength, 'forward');
            }
        }, 0);
    }
    /**
     * Method to blur the focus to the component's input field
     */
    blurField() {
        setTimeout(() => {
            this._inputElement.nativeElement.blur();
            this._focused = false;
            this.fixed = false;
        }, 0);
    }
    continueTyping() {
        if (!this.focused) {
            this.focused = true;
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiInlineSearchComponent, deps: [{ token: i1.SieIconRegistryService }, { token: i1$1.LayoutService }, { token: i0.ChangeDetectorRef, optional: true, skipSelf: true }, { token: i0.ChangeDetectorRef }, { token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiInlineSearchComponent, selector: "sie-ui-inline-search", inputs: { id: "id", suggestions: "suggestions", placeholder: "placeholder", showPlaceholderIcon: "showPlaceholderIcon", customClass: "customClass", showMobileSuggestionIcon: "showMobileSuggestionIcon", enableAnimation: "enableAnimation", disableMobileFullScreenOverlay: "disableMobileFullScreenOverlay", value: "value", lockComponent: "lockComponent", noResultsMessage: "noResultsMessage", noContentMessage: "noContentMessage", clearSearchScreenReaderText: "clearSearchScreenReaderText", disableFirstOverlayWhenEmpty: "disableFirstOverlayWhenEmpty", disabled: "disabled", locked: "locked", useSecondaryLabelAsValue: "useSecondaryLabelAsValue", activated: "activated", fixable: "fixable", enableCustomContent: "enableCustomContent", invalid: "invalid", invalidErrorMessage: "invalidErrorMessage", condensed: "condensed", resetCustomContentPadding: "resetCustomContentPadding" }, outputs: { suggestionSelected: "suggestionSelected", fieldCleared: "fieldCleared", valueChange: "valueChange", search: "search", manualValueChange: "manualValueChange", blurred: "blurred" }, host: { listeners: { "document:focusin": "blurCustomContent($event)", "document:mousedown": "blurCustomContent($event)" }, properties: { "class.is-disabled": "this.disabled", "class.is-locked": "this.locked", "class.is-fixed": "this.isFixed", "class.is-focused": "this.focused", "class.not-empty": "this.notEmpty" } }, viewQueries: [{ propertyName: "inputField", first: true, predicate: ["inputField"], descendants: true }, { propertyName: "customContent", first: true, predicate: ["customOverlayContent"], descendants: true }], ngImport: i0, template: "<div class=\"inline-search\" [ngClass]=\"customClass\">\n  <sie-ui-text-input\n    [id]=\"id\"\n    [customClass]=\"'search ' + customClass\"\n    [inlineSearch]=\"true\"\n    [placeholderIcon]=\"showPlaceholderIcon\"\n    [placeholder]=\"placeholder\"\n    [disabled]=\"disabled || locked\"\n    [(value)]=\"value\"\n    [invalid]=\"invalid\"\n    [errorMessage]=\"invalidErrorMessage\"\n    [condensed]=\"condensed\"\n    (valueChange)=\"continueTyping(); onValueChange($event)\"\n    (focused)=\"onFieldFocus()\"\n    (blurred)=\"onFieldBlur()\"\n    (keyup.arrowDown)=\"highlightNextSuggestion()\"\n    (keyup.arrowUp)=\"highlightPreviousSuggestion()\"\n    (keyup.escape)=\"handleEscape($event)\"\n    (keydown.enter)=\"selectSuggestion(null, suggestions && suggestions[highlightedSuggestion])\"\n    (resetInput)=\"unlock()\"\n    #inputField\n  ></sie-ui-text-input>\n\n  <div\n    class=\"inline-search__overlay\"\n    [ngClass]=\"{\n      '--no-fullscreen': disableMobileFullScreenOverlay,\n      'custom-content': enableCustomContent,\n      'reset-padding': resetCustomContentPadding,\n      condensed\n    }\"\n    *ngIf=\"showOverlay\"\n    (mousedown)=\"onOverlayClick($event)\"\n    [@openClose]=\"showOverlay\"\n    [@.disabled]=\"!enableAnimation\"\n  >\n    <div #customOverlayContent>\n      <ng-content></ng-content>\n    </div>\n    <ng-container *ngIf=\"enableCustomContent && !customOverlayContent.hasChildNodes()\">\n      <span class=\"inline-search__no-results-message\"> {{ noContentMessage }}</span>\n    </ng-container>\n    <ng-container *ngIf=\"!enableCustomContent\">\n      <ul *ngIf=\"suggestions?.length\" class=\"inline-search__suggestions\">\n        <li *ngFor=\"let suggestion of suggestions; let i = index\">\n          <button\n            class=\"inline-search__suggestion-btn\"\n            [ngClass]=\"{ 'is-selected': highlightedSuggestion === i }\"\n            (click)=\"selectSuggestion($event, suggestion)\"\n            (pointerdown)=\"avoidPointerDownCollision($event)\"\n            (mouseover)=\"highlightSuggestion(i)\"\n            (mouseout)=\"unhighlightSuggestion()\"\n          >\n            <span class=\"inline-search__width-fix\">{{ suggestion.primaryLabel }}</span>\n            <span\n              class=\"inline-search__primary-label\"\n              sieCoreHighlight\n              [highlightStartOnly]=\"false\"\n              [reference]=\"value\"\n              >{{ suggestion.primaryLabel }}</span\n            >\n            <span\n              class=\"inline-search__secondary-label\"\n              sieCoreHighlight\n              [highlightStartOnly]=\"false\"\n              [reference]=\"value\"\n              >{{ suggestion.secondaryLabel }}</span\n            >\n            <sie-icon\n              *ngIf=\"showMobileSuggestionIcon\"\n              class=\"inline-search__suggestion-icon\"\n              aria-hidden=\"true\"\n              [name]=\"iconReg.sieIcon.Ext\"\n              (click)=\"copySuggestion($event, suggestion)\"\n            ></sie-icon>\n          </button>\n        </li>\n      </ul>\n      <span *ngIf=\"!suggestions || suggestions?.length === 0\" class=\"inline-search__no-results-message\">\n        {{ noResultsMessage }}\n      </span>\n    </ng-container>\n  </div>\n</div>\n\n<sie-ui-button\n  *ngIf=\"isFixed && (layoutService.currentViewportObj$ | async | viewport: 'is' : 'S')\"\n  class=\"inline-search__close-button\"\n  buttonType=\"button\"\n  themeType=\"icon\"\n  variant=\"icon-un-contained\"\n  (clicked)=\"onFieldBlur(true)\"\n>\n  <sie-icon [name]=\"iconReg.sieIcon.Close\"></sie-icon>\n</sie-ui-button>\n", styles: [":host{position:relative}@media (max-width: 639.78px){:host.is-fixed{position:fixed;inset:0;background-color:#fff;z-index:9999;padding:48px 16px 16px}}.inline-search{position:relative}.inline-search__close-button{--icon-size-custom: $icon-size;position:absolute;top:2px;right:1px}.inline-search__overlay{position:absolute;top:55px;box-shadow:0 6px 8px #0000001a,0 2px 2px #0000000f;border:1px solid #ccccd4}.inline-search__overlay.condensed{top:48px}@media (max-width: 639.78px){.inline-search__overlay:not(.--no-fullscreen){width:100%;height:calc(100vh - 124px);padding-top:21px;overflow-y:scroll;border:0;box-shadow:none}.inline-search__overlay:not(.--no-fullscreen).custom-content{overflow-y:auto}.inline-search__overlay:not(.--no-fullscreen).custom-content-disabled{display:none}}.inline-search__overlay.--no-fullscreen{min-width:100%;max-width:100%;padding:17px 0 16px;background-color:#fff;color:#000;z-index:4}.inline-search__overlay.--no-fullscreen.reset-padding{padding:0}@media (min-width: 640px){.inline-search__overlay{min-width:100%;max-width:450px;padding:17px 0 16px;background-color:#fff;color:#000;z-index:3}}.inline-search--s .inline-search__overlay{top:47px}.inline-search--s .inline-search__search-icon{top:calc((3rem - 20px)/2 + 1px)}.inline-search__suggestions{list-style:none;margin:0;padding:0}.inline-search__suggestion-btn{position:relative;display:flex;flex-direction:column;width:100%;border:0;padding:4px 16px;background-color:transparent;text-align:left}.inline-search__suggestion-btn.is-selected,.inline-search__suggestion-btn:hover{background-color:#62eec7;cursor:pointer}.inline-search__suggestion-icon{width:20px;height:20px;display:flex;align-items:center;fill:currentColor;position:absolute;top:calc(50% - 10px);right:10px;transform:scaleX(-1)}.inline-search__suggestion-icon svg{fill:currentColor;width:inherit;height:inherit}.inline-search__suggestion-icon svg g{fill:currentColor;width:inherit;height:inherit}.inline-search__suggestion-icon svg text{font-family:Siemens Sans,sans-serif}@media (min-width: 640px){.inline-search__suggestion-icon{display:none}}.inline-search__primary-label,.inline-search__secondary-label{display:-webkit-inline-box;-webkit-box-orient:vertical;-webkit-line-clamp:2;overflow:hidden}.inline-search__secondary-label{font-size:.875rem;font-weight:400;line-height:1.25rem;margin-top:-3px}.inline-search__width-fix{white-space:nowrap;height:0;visibility:hidden}.inline-search__no-results-message{display:inline-block;padding:1rem;text-align:center;color:#9999a9}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: UiButtonComponent, selector: "sie-ui-button" }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "directive", type: i1$1.HighlightDirective, selector: "[sieCoreHighlight]", inputs: ["reference", "inverted", "highlightStartOnly", "highlightBackgroundColor"] }, { kind: "component", type: UiTextInputComponent, selector: "sie-ui-text-input", inputs: ["inputType", "placeholderIcon"] }, { kind: "pipe", type: i2.AsyncPipe, name: "async" }, { kind: "pipe", type: i1$1.ViewportPipe, name: "viewport" }], animations: [toggleSuggestionsAnimation], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
__decorate([
    Debounce()
], UiInlineSearchComponent.prototype, "onValueChange", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiInlineSearchComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-inline-search', changeDetection: ChangeDetectionStrategy.OnPush, animations: [toggleSuggestionsAnimation], template: "<div class=\"inline-search\" [ngClass]=\"customClass\">\n  <sie-ui-text-input\n    [id]=\"id\"\n    [customClass]=\"'search ' + customClass\"\n    [inlineSearch]=\"true\"\n    [placeholderIcon]=\"showPlaceholderIcon\"\n    [placeholder]=\"placeholder\"\n    [disabled]=\"disabled || locked\"\n    [(value)]=\"value\"\n    [invalid]=\"invalid\"\n    [errorMessage]=\"invalidErrorMessage\"\n    [condensed]=\"condensed\"\n    (valueChange)=\"continueTyping(); onValueChange($event)\"\n    (focused)=\"onFieldFocus()\"\n    (blurred)=\"onFieldBlur()\"\n    (keyup.arrowDown)=\"highlightNextSuggestion()\"\n    (keyup.arrowUp)=\"highlightPreviousSuggestion()\"\n    (keyup.escape)=\"handleEscape($event)\"\n    (keydown.enter)=\"selectSuggestion(null, suggestions && suggestions[highlightedSuggestion])\"\n    (resetInput)=\"unlock()\"\n    #inputField\n  ></sie-ui-text-input>\n\n  <div\n    class=\"inline-search__overlay\"\n    [ngClass]=\"{\n      '--no-fullscreen': disableMobileFullScreenOverlay,\n      'custom-content': enableCustomContent,\n      'reset-padding': resetCustomContentPadding,\n      condensed\n    }\"\n    *ngIf=\"showOverlay\"\n    (mousedown)=\"onOverlayClick($event)\"\n    [@openClose]=\"showOverlay\"\n    [@.disabled]=\"!enableAnimation\"\n  >\n    <div #customOverlayContent>\n      <ng-content></ng-content>\n    </div>\n    <ng-container *ngIf=\"enableCustomContent && !customOverlayContent.hasChildNodes()\">\n      <span class=\"inline-search__no-results-message\"> {{ noContentMessage }}</span>\n    </ng-container>\n    <ng-container *ngIf=\"!enableCustomContent\">\n      <ul *ngIf=\"suggestions?.length\" class=\"inline-search__suggestions\">\n        <li *ngFor=\"let suggestion of suggestions; let i = index\">\n          <button\n            class=\"inline-search__suggestion-btn\"\n            [ngClass]=\"{ 'is-selected': highlightedSuggestion === i }\"\n            (click)=\"selectSuggestion($event, suggestion)\"\n            (pointerdown)=\"avoidPointerDownCollision($event)\"\n            (mouseover)=\"highlightSuggestion(i)\"\n            (mouseout)=\"unhighlightSuggestion()\"\n          >\n            <span class=\"inline-search__width-fix\">{{ suggestion.primaryLabel }}</span>\n            <span\n              class=\"inline-search__primary-label\"\n              sieCoreHighlight\n              [highlightStartOnly]=\"false\"\n              [reference]=\"value\"\n              >{{ suggestion.primaryLabel }}</span\n            >\n            <span\n              class=\"inline-search__secondary-label\"\n              sieCoreHighlight\n              [highlightStartOnly]=\"false\"\n              [reference]=\"value\"\n              >{{ suggestion.secondaryLabel }}</span\n            >\n            <sie-icon\n              *ngIf=\"showMobileSuggestionIcon\"\n              class=\"inline-search__suggestion-icon\"\n              aria-hidden=\"true\"\n              [name]=\"iconReg.sieIcon.Ext\"\n              (click)=\"copySuggestion($event, suggestion)\"\n            ></sie-icon>\n          </button>\n        </li>\n      </ul>\n      <span *ngIf=\"!suggestions || suggestions?.length === 0\" class=\"inline-search__no-results-message\">\n        {{ noResultsMessage }}\n      </span>\n    </ng-container>\n  </div>\n</div>\n\n<sie-ui-button\n  *ngIf=\"isFixed && (layoutService.currentViewportObj$ | async | viewport: 'is' : 'S')\"\n  class=\"inline-search__close-button\"\n  buttonType=\"button\"\n  themeType=\"icon\"\n  variant=\"icon-un-contained\"\n  (clicked)=\"onFieldBlur(true)\"\n>\n  <sie-icon [name]=\"iconReg.sieIcon.Close\"></sie-icon>\n</sie-ui-button>\n", styles: [":host{position:relative}@media (max-width: 639.78px){:host.is-fixed{position:fixed;inset:0;background-color:#fff;z-index:9999;padding:48px 16px 16px}}.inline-search{position:relative}.inline-search__close-button{--icon-size-custom: $icon-size;position:absolute;top:2px;right:1px}.inline-search__overlay{position:absolute;top:55px;box-shadow:0 6px 8px #0000001a,0 2px 2px #0000000f;border:1px solid #ccccd4}.inline-search__overlay.condensed{top:48px}@media (max-width: 639.78px){.inline-search__overlay:not(.--no-fullscreen){width:100%;height:calc(100vh - 124px);padding-top:21px;overflow-y:scroll;border:0;box-shadow:none}.inline-search__overlay:not(.--no-fullscreen).custom-content{overflow-y:auto}.inline-search__overlay:not(.--no-fullscreen).custom-content-disabled{display:none}}.inline-search__overlay.--no-fullscreen{min-width:100%;max-width:100%;padding:17px 0 16px;background-color:#fff;color:#000;z-index:4}.inline-search__overlay.--no-fullscreen.reset-padding{padding:0}@media (min-width: 640px){.inline-search__overlay{min-width:100%;max-width:450px;padding:17px 0 16px;background-color:#fff;color:#000;z-index:3}}.inline-search--s .inline-search__overlay{top:47px}.inline-search--s .inline-search__search-icon{top:calc((3rem - 20px)/2 + 1px)}.inline-search__suggestions{list-style:none;margin:0;padding:0}.inline-search__suggestion-btn{position:relative;display:flex;flex-direction:column;width:100%;border:0;padding:4px 16px;background-color:transparent;text-align:left}.inline-search__suggestion-btn.is-selected,.inline-search__suggestion-btn:hover{background-color:#62eec7;cursor:pointer}.inline-search__suggestion-icon{width:20px;height:20px;display:flex;align-items:center;fill:currentColor;position:absolute;top:calc(50% - 10px);right:10px;transform:scaleX(-1)}.inline-search__suggestion-icon svg{fill:currentColor;width:inherit;height:inherit}.inline-search__suggestion-icon svg g{fill:currentColor;width:inherit;height:inherit}.inline-search__suggestion-icon svg text{font-family:Siemens Sans,sans-serif}@media (min-width: 640px){.inline-search__suggestion-icon{display:none}}.inline-search__primary-label,.inline-search__secondary-label{display:-webkit-inline-box;-webkit-box-orient:vertical;-webkit-line-clamp:2;overflow:hidden}.inline-search__secondary-label{font-size:.875rem;font-weight:400;line-height:1.25rem;margin-top:-3px}.inline-search__width-fix{white-space:nowrap;height:0;visibility:hidden}.inline-search__no-results-message{display:inline-block;padding:1rem;text-align:center;color:#9999a9}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }, { type: i1$1.LayoutService }, { type: i0.ChangeDetectorRef, decorators: [{
                    type: SkipSelf
                }, {
                    type: Optional
                }] }, { type: i0.ChangeDetectorRef }, { type: i0.ElementRef }]; }, propDecorators: { id: [{
                type: Input
            }], suggestions: [{
                type: Input
            }], placeholder: [{
                type: Input
            }], showPlaceholderIcon: [{
                type: Input
            }], customClass: [{
                type: Input
            }], showMobileSuggestionIcon: [{
                type: Input
            }], enableAnimation: [{
                type: Input
            }], disableMobileFullScreenOverlay: [{
                type: Input
            }], value: [{
                type: Input
            }], lockComponent: [{
                type: Input
            }], noResultsMessage: [{
                type: Input
            }], noContentMessage: [{
                type: Input
            }], clearSearchScreenReaderText: [{
                type: Input
            }], disableFirstOverlayWhenEmpty: [{
                type: Input
            }], disabled: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['class.is-disabled']
            }], locked: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['class.is-locked']
            }], useSecondaryLabelAsValue: [{
                type: Input
            }], activated: [{
                type: Input
            }], fixable: [{
                type: Input
            }], enableCustomContent: [{
                type: Input
            }], invalid: [{
                type: Input
            }], invalidErrorMessage: [{
                type: Input
            }], condensed: [{
                type: Input
            }], resetCustomContentPadding: [{
                type: Input
            }], isFixed: [{
                type: HostBinding,
                args: ['class.is-fixed']
            }], focused: [{
                type: HostBinding,
                args: ['class.is-focused']
            }], suggestionSelected: [{
                type: Output
            }], fieldCleared: [{
                type: Output
            }], valueChange: [{
                type: Output
            }], search: [{
                type: Output
            }], manualValueChange: [{
                type: Output
            }], blurred: [{
                type: Output
            }], inputField: [{
                type: ViewChild,
                args: ['inputField']
            }], customContent: [{
                type: ViewChild,
                args: ['customOverlayContent']
            }], notEmpty: [{
                type: HostBinding,
                args: ['class.not-empty']
            }], blurCustomContent: [{
                type: HostListener,
                args: ['document:focusin', ['$event']]
            }, {
                type: HostListener,
                args: ['document:mousedown', ['$event']]
            }], onValueChange: [] } });

class UiLanguageSelectorService {
    constructor(sieIconRegistryService) {
        this.sieIconRegistryService = sieIconRegistryService;
    }
    downloadFlagOrReplaceIt(appRegion, fallbackIcon) {
        return new Promise(resolve => {
            const iconName = appRegion.flag;
            if (iconName) {
                if (iconName === SieIcon.Globe) {
                    this.sieIconRegistryService.register(SieIcon.Globe);
                    resolve(false);
                }
                else {
                    this.sieIconRegistryService.register(iconName, UIConstants.FLAG_ICONS_PATH + iconName);
                    this.sieIconRegistryService.getIcon(iconName).subscribe(icon => {
                        if (icon === '') {
                            appRegion.flag = fallbackIcon;
                            this.sieIconRegistryService.register(fallbackIcon);
                            resolve(true);
                        }
                        else if (icon !== null) {
                            resolve(false);
                        }
                        else {
                            // do nothing -> null is the initial value which will change when icon is downloaded
                        }
                    });
                }
            }
        });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiLanguageSelectorService, deps: [{ token: i1.SieIconRegistryService }], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiLanguageSelectorService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiLanguageSelectorService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }]; } });

class UiLanguageSelectorItemComponent {
    constructor(iconReg, uiLanguageSelectorService, cdr) {
        this.iconReg = iconReg;
        this.uiLanguageSelectorService = uiLanguageSelectorService;
        this.cdr = cdr;
        this.isCurrentRegion = false;
        this.regionLanguageSelected = new Subject();
        this.isHovered = false;
        this.isLanguageHovered = false;
        this.globeIconName = SieIcon.Globe;
    }
    ngOnInit() {
        this.uiLanguageSelectorService
            .downloadFlagOrReplaceIt(this.languageSelectorItem, SieIcon.Globe)
            .then(iconReplaced => {
            if (iconReplaced) {
                this.cdr.markForCheck();
            }
        });
    }
    onRegionLanguageSelect(event, language, region) {
        event.preventDefault();
        this.regionLanguageSelected.next({
            newLocale: {
                language,
                region
            },
            languageSelectorItem: this.languageSelectorItem
        });
    }
    mouseEnter(isLanguageHovered = true) {
        this.isLanguageHovered = isLanguageHovered;
        this.isHovered = true;
    }
    mouseLeave() {
        this.isLanguageHovered = false;
        this.isHovered = false;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiLanguageSelectorItemComponent, deps: [{ token: i1.SieIconRegistryService }, { token: UiLanguageSelectorService }, { token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiLanguageSelectorItemComponent, selector: "sie-ui-language-selector-item", inputs: { languageSelectorItem: "languageSelectorItem", isCurrentRegion: "isCurrentRegion", highlightText: "highlightText" }, outputs: { regionLanguageSelected: "regionLanguageSelected" }, ngImport: i0, template: "<div class=\"language-selector-item\" [ngClass]=\"{ 'is-current-region': isCurrentRegion }\">\n  <div\n    class=\"language-selector-item__flag-wrapper\"\n    [ngClass]=\"{ 'is-hovered': isHovered }\"\n    (mouseenter)=\"mouseEnter()\"\n    (mouseleave)=\"mouseLeave()\"\n  >\n    <sie-icon\n      [name]=\"languageSelectorItem.flag\"\n      class=\"language-selector-item__flag\"\n      [ngClass]=\"{ globe: languageSelectorItem.flag === globeIconName }\"\n      role=\"button\"\n      (click)=\"onRegionLanguageSelect($event, languageSelectorItem?.defaultLanguage.code, languageSelectorItem.code)\"\n    ></sie-icon>\n  </div>\n  <div class=\"language-selector-item__info-wrapper\">\n    <div class=\"language-selector-item__country-wrapper\">\n      <span\n        class=\"language-selector-item__country\"\n        role=\"button\"\n        sieCoreHighlight\n        [reference]=\"highlightText\"\n        [highlightStartOnly]=\"false\"\n        [highlightBackgroundColor]=\"true\"\n        (click)=\"onRegionLanguageSelect($event, languageSelectorItem?.defaultLanguage.code, languageSelectorItem.code)\"\n        (mouseenter)=\"mouseEnter()\"\n        (mouseleave)=\"mouseLeave()\"\n        >{{ languageSelectorItem?.name }}\n      </span>\n    </div>\n    <div class=\"language-selector-item__languages-wrapper\">\n      <ng-container *ngFor=\"let language of languageSelectorItem?.languages; let i = index\">\n        <div class=\"language-selector-item__language-wrapper\">\n          <a\n            role=\"button\"\n            class=\"language-selector-item__language\"\n            (click)=\"onRegionLanguageSelect($event, language.code, languageSelectorItem?.code)\"\n            (keydown.enter)=\"onRegionLanguageSelect($event, language.code, languageSelectorItem?.code)\"\n            [ngClass]=\"{ 'is-hovered': isLanguageHovered, 'is-first': i === 0 }\"\n            (mouseenter)=\"mouseEnter(false)\"\n            (mouseleave)=\"mouseLeave()\"\n            (focusin)=\"mouseEnter(false)\"\n            (focusout)=\"mouseLeave()\"\n            tabindex=\"0\"\n            >{{ language.name }}</a\n          >\n        </div>\n      </ng-container>\n    </div>\n  </div>\n</div>\n", styles: [".language-selector-item__language-wrapper a{outline:none;outline-offset:0}@media (pointer: fine){.language-selector-item__language-wrapper a{position:relative}.language-selector-item__language-wrapper a:focus{outline:1px solid #1491eb;outline-offset:2px}.language-selector-item__language-wrapper a:focus:not(:focus-visible){outline:0}.language-selector-item__language-wrapper a:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}.language-selector-item{display:flex;margin-top:15px}.language-selector-item__change-language-wrapper{margin-top:25px}.language-selector-item__info-wrapper{margin-left:12px}.language-selector-item__flag-wrapper{height:50px;min-width:50px;display:flex;justify-content:center;align-items:center;border:2px solid transparent;border-radius:50%}.language-selector-item__flag-wrapper:hover,.language-selector-item__flag-wrapper.is-hovered{border-color:#e5e5e9;cursor:pointer}.language-selector-item__flag-wrapper sie-icon{width:40px;height:40px;display:flex;align-items:center;fill:currentColor;display:inline-flex}.language-selector-item__flag-wrapper sie-icon svg{fill:currentColor;width:inherit;height:inherit}.language-selector-item__flag-wrapper sie-icon svg g{fill:currentColor;width:inherit;height:inherit}.language-selector-item__flag-wrapper sie-icon svg text{font-family:Siemens Sans,sans-serif}.language-selector-item__flag-wrapper .globe{color:#7d8099}.language-selector-item__country-wrapper{font-size:1.25rem;font-weight:400;line-height:1.625rem;display:inline-block}.language-selector-item__country-wrapper span:hover{cursor:pointer}.language-selector-item__languages-wrapper{display:flex;flex-wrap:wrap}.language-selector-item__language-wrapper{display:inline-flex;position:relative;margin-right:9px}.language-selector-item__language-wrapper:not(:last-child):after{content:\"|\";margin-left:7px;color:#9999a9}.language-selector-item__language-wrapper .is-first.is-hovered{text-decoration:underline}.language-selector-item__language{color:#007993}.language-selector-item__language:hover{text-decoration:underline;cursor:pointer}.language-selector-item.is-current-region .language-selector-item__flag-wrapper{border-color:#005159}.language-selector-item.is-current-region .language-selector-item__language-wrapper:first-of-type .language-selector-item__language{color:#000028}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "directive", type: i1$1.HighlightDirective, selector: "[sieCoreHighlight]", inputs: ["reference", "inverted", "highlightStartOnly", "highlightBackgroundColor"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiLanguageSelectorItemComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-language-selector-item', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"language-selector-item\" [ngClass]=\"{ 'is-current-region': isCurrentRegion }\">\n  <div\n    class=\"language-selector-item__flag-wrapper\"\n    [ngClass]=\"{ 'is-hovered': isHovered }\"\n    (mouseenter)=\"mouseEnter()\"\n    (mouseleave)=\"mouseLeave()\"\n  >\n    <sie-icon\n      [name]=\"languageSelectorItem.flag\"\n      class=\"language-selector-item__flag\"\n      [ngClass]=\"{ globe: languageSelectorItem.flag === globeIconName }\"\n      role=\"button\"\n      (click)=\"onRegionLanguageSelect($event, languageSelectorItem?.defaultLanguage.code, languageSelectorItem.code)\"\n    ></sie-icon>\n  </div>\n  <div class=\"language-selector-item__info-wrapper\">\n    <div class=\"language-selector-item__country-wrapper\">\n      <span\n        class=\"language-selector-item__country\"\n        role=\"button\"\n        sieCoreHighlight\n        [reference]=\"highlightText\"\n        [highlightStartOnly]=\"false\"\n        [highlightBackgroundColor]=\"true\"\n        (click)=\"onRegionLanguageSelect($event, languageSelectorItem?.defaultLanguage.code, languageSelectorItem.code)\"\n        (mouseenter)=\"mouseEnter()\"\n        (mouseleave)=\"mouseLeave()\"\n        >{{ languageSelectorItem?.name }}\n      </span>\n    </div>\n    <div class=\"language-selector-item__languages-wrapper\">\n      <ng-container *ngFor=\"let language of languageSelectorItem?.languages; let i = index\">\n        <div class=\"language-selector-item__language-wrapper\">\n          <a\n            role=\"button\"\n            class=\"language-selector-item__language\"\n            (click)=\"onRegionLanguageSelect($event, language.code, languageSelectorItem?.code)\"\n            (keydown.enter)=\"onRegionLanguageSelect($event, language.code, languageSelectorItem?.code)\"\n            [ngClass]=\"{ 'is-hovered': isLanguageHovered, 'is-first': i === 0 }\"\n            (mouseenter)=\"mouseEnter(false)\"\n            (mouseleave)=\"mouseLeave()\"\n            (focusin)=\"mouseEnter(false)\"\n            (focusout)=\"mouseLeave()\"\n            tabindex=\"0\"\n            >{{ language.name }}</a\n          >\n        </div>\n      </ng-container>\n    </div>\n  </div>\n</div>\n", styles: [".language-selector-item__language-wrapper a{outline:none;outline-offset:0}@media (pointer: fine){.language-selector-item__language-wrapper a{position:relative}.language-selector-item__language-wrapper a:focus{outline:1px solid #1491eb;outline-offset:2px}.language-selector-item__language-wrapper a:focus:not(:focus-visible){outline:0}.language-selector-item__language-wrapper a:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}.language-selector-item{display:flex;margin-top:15px}.language-selector-item__change-language-wrapper{margin-top:25px}.language-selector-item__info-wrapper{margin-left:12px}.language-selector-item__flag-wrapper{height:50px;min-width:50px;display:flex;justify-content:center;align-items:center;border:2px solid transparent;border-radius:50%}.language-selector-item__flag-wrapper:hover,.language-selector-item__flag-wrapper.is-hovered{border-color:#e5e5e9;cursor:pointer}.language-selector-item__flag-wrapper sie-icon{width:40px;height:40px;display:flex;align-items:center;fill:currentColor;display:inline-flex}.language-selector-item__flag-wrapper sie-icon svg{fill:currentColor;width:inherit;height:inherit}.language-selector-item__flag-wrapper sie-icon svg g{fill:currentColor;width:inherit;height:inherit}.language-selector-item__flag-wrapper sie-icon svg text{font-family:Siemens Sans,sans-serif}.language-selector-item__flag-wrapper .globe{color:#7d8099}.language-selector-item__country-wrapper{font-size:1.25rem;font-weight:400;line-height:1.625rem;display:inline-block}.language-selector-item__country-wrapper span:hover{cursor:pointer}.language-selector-item__languages-wrapper{display:flex;flex-wrap:wrap}.language-selector-item__language-wrapper{display:inline-flex;position:relative;margin-right:9px}.language-selector-item__language-wrapper:not(:last-child):after{content:\"|\";margin-left:7px;color:#9999a9}.language-selector-item__language-wrapper .is-first.is-hovered{text-decoration:underline}.language-selector-item__language{color:#007993}.language-selector-item__language:hover{text-decoration:underline;cursor:pointer}.language-selector-item.is-current-region .language-selector-item__flag-wrapper{border-color:#005159}.language-selector-item.is-current-region .language-selector-item__language-wrapper:first-of-type .language-selector-item__language{color:#000028}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }, { type: UiLanguageSelectorService }, { type: i0.ChangeDetectorRef }]; }, propDecorators: { languageSelectorItem: [{
                type: Input
            }], isCurrentRegion: [{
                type: Input
            }], highlightText: [{
                type: Input
            }], regionLanguageSelected: [{
                type: Output
            }] } });

class UiLanguageSelectorComponent {
    constructor(iconReg, localeService) {
        this.iconReg = iconReg;
        this.localeService = localeService;
        this.currentRegionTitle = '';
        this.changeRegionTitle = '';
        this.searchRegionPlaceholder = '';
        this.regionLanguageSelected = new Subject();
        this.triggerSearchRegionChange = new Subject();
        this.triggerResetFilteredRegions = new Subject();
        this.highlightText = '';
    }
    ngOnDestroy() {
        this.triggerResetFilteredRegions.next(true);
    }
    onRegionLanguageSelect(event) {
        this.regionLanguageSelected.next(event);
    }
    onSearchRegionChange(searchTerm) {
        this.triggerSearchRegionChange.next(searchTerm);
        this.highlightText = searchTerm;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiLanguageSelectorComponent, deps: [{ token: i1.SieIconRegistryService }, { token: i1$1.LocaleService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiLanguageSelectorComponent, selector: "sie-ui-language-selector", inputs: { currentRegion: "currentRegion", languageSelectorItems: "languageSelectorItems", currentRegionTitle: "currentRegionTitle", changeRegionTitle: "changeRegionTitle", searchRegionPlaceholder: "searchRegionPlaceholder" }, outputs: { regionLanguageSelected: "regionLanguageSelected", triggerSearchRegionChange: "triggerSearchRegionChange", triggerResetFilteredRegions: "triggerResetFilteredRegions" }, ngImport: i0, template: "<div class=\"language-selector\">\n  <div class=\"language-selector__current-language-wrapper\">\n    <h5 class=\"language-selector__title\">\n      {{ currentRegionTitle }}\n    </h5>\n    <div *ngIf=\"currentRegion\" class=\"language-selector__item\">\n      <sie-ui-language-selector-item\n        [languageSelectorItem]=\"currentRegion\"\n        (regionLanguageSelected)=\"onRegionLanguageSelect($event)\"\n        isCurrentRegion=\"true\"\n      ></sie-ui-language-selector-item>\n    </div>\n  </div>\n\n  <div class=\"language-selector__change-language-wrapper\">\n    <h5 class=\"language-selector__title\">\n      {{ changeRegionTitle }}\n    </h5>\n\n    <sie-ui-inline-search\n      #regionSearch\n      [placeholder]=\"searchRegionPlaceholder\"\n      (valueChange)=\"onSearchRegionChange($event)\"\n      [fixable]=\"false\"\n    ></sie-ui-inline-search>\n\n    <ng-container *ngFor=\"let region of languageSelectorItems\">\n      <ng-container *ngIf=\"region.urlCode !== localeService.locale.region\">\n        <sie-ui-language-selector-item\n          [languageSelectorItem]=\"region\"\n          [highlightText]=\"highlightText\"\n          (regionLanguageSelected)=\"onRegionLanguageSelect($event)\"\n        ></sie-ui-language-selector-item>\n      </ng-container>\n    </ng-container>\n  </div>\n</div>\n", styles: [".language-selector{padding-bottom:56px}.language-selector__change-language-wrapper{margin-top:25px}.language-selector__title{margin-bottom:10px}\n"], dependencies: [{ kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: UiInlineSearchComponent, selector: "sie-ui-inline-search", inputs: ["id", "suggestions", "placeholder", "showPlaceholderIcon", "customClass", "showMobileSuggestionIcon", "enableAnimation", "disableMobileFullScreenOverlay", "value", "lockComponent", "noResultsMessage", "noContentMessage", "clearSearchScreenReaderText", "disableFirstOverlayWhenEmpty", "disabled", "locked", "useSecondaryLabelAsValue", "activated", "fixable", "enableCustomContent", "invalid", "invalidErrorMessage", "condensed", "resetCustomContentPadding"], outputs: ["suggestionSelected", "fieldCleared", "valueChange", "search", "manualValueChange", "blurred"] }, { kind: "component", type: UiLanguageSelectorItemComponent, selector: "sie-ui-language-selector-item", inputs: ["languageSelectorItem", "isCurrentRegion", "highlightText"], outputs: ["regionLanguageSelected"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiLanguageSelectorComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-language-selector', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"language-selector\">\n  <div class=\"language-selector__current-language-wrapper\">\n    <h5 class=\"language-selector__title\">\n      {{ currentRegionTitle }}\n    </h5>\n    <div *ngIf=\"currentRegion\" class=\"language-selector__item\">\n      <sie-ui-language-selector-item\n        [languageSelectorItem]=\"currentRegion\"\n        (regionLanguageSelected)=\"onRegionLanguageSelect($event)\"\n        isCurrentRegion=\"true\"\n      ></sie-ui-language-selector-item>\n    </div>\n  </div>\n\n  <div class=\"language-selector__change-language-wrapper\">\n    <h5 class=\"language-selector__title\">\n      {{ changeRegionTitle }}\n    </h5>\n\n    <sie-ui-inline-search\n      #regionSearch\n      [placeholder]=\"searchRegionPlaceholder\"\n      (valueChange)=\"onSearchRegionChange($event)\"\n      [fixable]=\"false\"\n    ></sie-ui-inline-search>\n\n    <ng-container *ngFor=\"let region of languageSelectorItems\">\n      <ng-container *ngIf=\"region.urlCode !== localeService.locale.region\">\n        <sie-ui-language-selector-item\n          [languageSelectorItem]=\"region\"\n          [highlightText]=\"highlightText\"\n          (regionLanguageSelected)=\"onRegionLanguageSelect($event)\"\n        ></sie-ui-language-selector-item>\n      </ng-container>\n    </ng-container>\n  </div>\n</div>\n", styles: [".language-selector{padding-bottom:56px}.language-selector__change-language-wrapper{margin-top:25px}.language-selector__title{margin-bottom:10px}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }, { type: i1$1.LocaleService }]; }, propDecorators: { currentRegion: [{
                type: Input
            }], languageSelectorItems: [{
                type: Input
            }], currentRegionTitle: [{
                type: Input
            }], changeRegionTitle: [{
                type: Input
            }], searchRegionPlaceholder: [{
                type: Input
            }], regionLanguageSelected: [{
                type: Output
            }], triggerSearchRegionChange: [{
                type: Output
            }], triggerResetFilteredRegions: [{
                type: Output
            }] } });

class UiBaseInputModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiBaseInputModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiBaseInputModule, declarations: [UiBaseInputComponent], imports: [CommonModule, UiReadonlyModule, UiRichtextModule, SieIconsModule, UiPopoverModule], exports: [UiBaseInputComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiBaseInputModule, imports: [CommonModule, UiReadonlyModule, UiRichtextModule, SieIconsModule, UiPopoverModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiBaseInputModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiBaseInputComponent],
                    imports: [CommonModule, UiReadonlyModule, UiRichtextModule, SieIconsModule, UiPopoverModule],
                    exports: [UiBaseInputComponent]
                }]
        }] });

/**
 * # Text Input Module
 * - {@link UiTextInputComponent}
 *
 * ## Module peer dependencies
 * - {@link SieIconsModule}
 * - `@angular/forms/FormsModule`: Enables data binding for Angular forms
 */
class UiTextInputModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTextInputModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiTextInputModule, declarations: [UiTextInputComponent], imports: [CommonModule, FormsModule, UiReadonlyModule, UiBaseInputModule, UiIconButtonModule, SieIconsModule], exports: [UiTextInputComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTextInputModule, imports: [CommonModule, FormsModule, UiReadonlyModule, UiBaseInputModule, UiIconButtonModule, SieIconsModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTextInputModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiTextInputComponent],
                    imports: [CommonModule, FormsModule, UiReadonlyModule, UiBaseInputModule, UiIconButtonModule, SieIconsModule],
                    exports: [UiTextInputComponent]
                }]
        }] });

/**
 * # Inline Search Module
 * - {@link UiInlineSearchComponent}
 *
 * ## Module peer dependencies
 * - {@link SieIconsModule}
 */
class UiInlineSearchModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiInlineSearchModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiInlineSearchModule, declarations: [UiInlineSearchComponent], imports: [CommonModule, UiButtonModule, SieIconsModule, HighlightModule, SieCorePipesModule, UiTextInputModule], exports: [UiInlineSearchComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiInlineSearchModule, imports: [CommonModule, UiButtonModule, SieIconsModule, HighlightModule, SieCorePipesModule, UiTextInputModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiInlineSearchModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiInlineSearchComponent],
                    imports: [CommonModule, UiButtonModule, SieIconsModule, HighlightModule, SieCorePipesModule, UiTextInputModule],
                    exports: [UiInlineSearchComponent]
                }]
        }] });

class UiLanguageSelectorModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiLanguageSelectorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiLanguageSelectorModule, declarations: [UiLanguageSelectorComponent, UiLanguageSelectorItemComponent], imports: [CommonModule, SieIconsModule, UiLinkModule, UiInlineSearchModule, HighlightModule], exports: [UiLanguageSelectorComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiLanguageSelectorModule, imports: [CommonModule, SieIconsModule, UiLinkModule, UiInlineSearchModule, HighlightModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiLanguageSelectorModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiLanguageSelectorComponent, UiLanguageSelectorItemComponent],
                    imports: [CommonModule, SieIconsModule, UiLinkModule, UiInlineSearchModule, HighlightModule],
                    exports: [UiLanguageSelectorComponent]
                }]
        }] });

class UiRouteButtonComponent extends UiBaseButtonDirective {
    constructor(cdr, iconReg, router, route) {
        super(cdr, iconReg);
        this.router = router;
        this.route = route;
        this.routeExtras = {};
        this.relative = true;
        this.routeFinished = new Subject();
    }
    onClick(event) {
        event.preventDefault();
        const extras = this.getRouteExtras();
        this.router.navigate(this.routeCommands, extras).then(() => {
            this.routeFinished.next();
        });
    }
    getRouteExtras() {
        const extras = {
            ...this.routeExtras
        };
        if (this.relative) {
            extras.relativeTo = this.route;
        }
        return extras;
    }
    applyExtraData(data) {
        this.routeExtras = data.route.routeExtras;
        this.routeCommands = data.route.routeCommands;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiRouteButtonComponent, deps: [{ token: i0.ChangeDetectorRef }, { token: i1.SieIconRegistryService }, { token: i2$1.Router }, { token: i2$1.ActivatedRoute }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiRouteButtonComponent, selector: "sie-ui-route-button", inputs: { routeCommands: "routeCommands", routeExtras: "routeExtras", relative: "relative" }, outputs: { routeFinished: "routeFinished" }, usesInheritance: true, ngImport: i0, template: "<!-- BUTTON -->\n<ng-container *ngIf=\"isButton\">\n  <button\n    class=\"general-button\"\n    #uiButton\n    [sieCoreAttributes]=\"dataAttributes\"\n    [ngClass]=\"[\n      cssClass,\n      'type-' + themeType,\n      'variant-' + variant,\n      'bg-' + background,\n      'position-' + position,\n      prominence ? 'prominence-' + prominence : '',\n      fullWidth ? 'general-button--width' : 'general-button--max-width',\n      withSpinner ? 'with-spinner' : '',\n      showSpinner ? 'spinner-active' : '',\n      spinnerAnimating ? 'fade-appearance' : '',\n      shouldFadeOutText ? 'fade-text' : '',\n      !bold ? 'not-bold' : '',\n      increasedSize ? 'increased-size' : '',\n      hoverDisabled ? 'hover-disabled' : '',\n      disableLineBreak && !fullWidth ? 'disable-line-break-max-width' : ''\n    ]\"\n    [class.open]=\"isSecondaryIconRotated\"\n    [type]=\"this.buttonType.endsWith('submit') ? 'submit' : 'button'\"\n    (click)=\"onClick($event)\"\n    (focus)=\"onFocus($event)\"\n    [tabIndex]=\"this.focusable ? 0 : -1\"\n    (blur)=\"onBlur($event)\"\n    [disabled]=\"disabled || showSpinner ? 'disabled' : null\"\n    [ngStyle]=\"withSpinner && !fullWidth && !dimensionsSet ? { width: buttonWithSpinnerWidth + 'px' } : ''\"\n  >\n    <ng-container *ngTemplateOutlet=\"contentField\"></ng-container>\n  </button>\n</ng-container>\n\n<!-- EXTERNAL BUTTON (siemens internal and external links) --><a\n  *ngIf=\"!isButton\"\n  #uiButton\n  [sieCoreAttributes]=\"dataAttributes\"\n  [href]=\"link\"\n  [target]=\"target\"\n  class=\"general-button\"\n  rel=\"noopener\"\n  (click)=\"onClick($event)\"\n  [ngClass]=\"[\n    'type-' + themeType,\n    'variant-' + variant,\n    'bg-' + background,\n    'position-' + position,\n    prominence ? 'prominence-' + prominence : '',\n    cssClass,\n    disabled ? 'disabled' : '',\n    fullWidth ? 'general-button--width' : 'general-button--max-width',\n    withSpinner ? 'with-spinner' : '',\n    showSpinner ? 'spinner-active' : '',\n    spinnerAnimating ? 'fade-appearance' : '',\n    shouldFadeOutText ? 'fade-text' : ''\n  ]\"\n>\n  <ng-container *ngTemplateOutlet=\"contentField\"></ng-container>\n</a>\n\n<!-- CONTENT -->\n<ng-template #contentField>\n  <span class=\"general-button__body\" [ngClass]=\"{ 'has-spinner': withSpinner, 'has-secondary-icon': iconSecondary }\">\n    <sie-ui-badge\n      *ngIf=\"badge\"\n      class=\"general-button__badge\"\n      type=\"counter\"\n      [number]=\"badgeNumber\"\n      addOutline\n    ></sie-ui-badge>\n    <span class=\"general-button__label\">\n      <ng-container *ngIf=\"icon && iconPosition === 'leading'\">\n        <sie-icon [name]=\"icon\" class=\"general-button__icon\" [ngClass]=\"getIconClasses()\" aria-hidden=\"true\"></sie-icon>\n        <span *ngIf=\"iconScreenReaderText\" class=\"visually-hidden\">{{ iconScreenReaderText }}</span>\n      </ng-container>\n      <span class=\"general-button__label-content\" [ngClass]=\"{ 'disable-line-break': disableLineBreak }\"\n        ><ng-content></ng-content\n      ></span>\n      <ng-container *ngIf=\"icon && iconPosition === 'trailing'\">\n        <sie-icon [name]=\"icon\" class=\"general-button__icon\" [ngClass]=\"getIconClasses()\"></sie-icon>\n      </ng-container>\n      <ng-container *ngIf=\"iconSecondary\">\n        <sie-icon\n          [name]=\"iconSecondary\"\n          class=\"general-button__icon secondary-icon\"\n          [ngClass]=\"getIconClasses()\"\n          [class.open]=\"isSecondaryIconRotated\"\n        ></sie-icon>\n      </ng-container>\n      <ng-container *ngIf=\"showSpinner || spinnerAnimating\">\n        <div\n          class=\"general-button__spinner-wrapper\"\n          [ngClass]=\"{\n            'sp-fade-in': showSpinner,\n            'fade-out-text': shouldFadeOutText\n          }\"\n        >\n          <sie-ui-spinner\n            [size]=\"spinnerSize\"\n            [active]=\"showSpinner\"\n            (animationEnded)=\"onAnimationEnd()\"\n          ></sie-ui-spinner>\n        </div>\n      </ng-container>\n    </span>\n  </span>\n</ng-template>\n", styles: [":host .general-button{outline:none;outline-offset:0}@media (pointer: fine){:host .general-button{position:relative}:host .general-button:focus{outline:1px solid #1491eb;outline-offset:2px}:host .general-button:focus:not(:focus-visible){outline:0}:host .general-button:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}:host{display:inline-flex;position:relative;--icon-size-default: 24px;--btn-height-default: 48px;--btn-width-default: auto;outline:0}:host(.full-width){width:100%}.general-button.type-icon.variant-icon-contained .general-button__icon,.general-button.type-icon.variant-icon-un-contained .general-button__icon,.general-button.type-icon.variant-icon-menu .general-button__icon{margin:0}.increased-size.general-button.type-icon.variant-icon-contained.position-content,.increased-size.general-button.type-icon.variant-icon-contained.position-header,.increased-size.general-button.type-icon.variant-icon-un-contained,.increased-size.general-button.type-icon.variant-icon-with-label.position-content,.increased-size.general-button.type-icon.variant-icon-with-label.position-header,.increased-size.general-button{--btn-height-default: 56px;--icon-size-default: 28px;min-width:56px}.general-button{font-size:1rem;font-weight:900;line-height:1.5rem;--icon-size: var(--icon-size-custom, var(--icon-size-default));--btn-width: var(--btn-width-custom, var(--btn-width-default));--btn-height: var(--btn-height-custom, var(--btn-height-default));-webkit-user-drag:none;display:inline-flex;flex:1 1 0;align-items:center;justify-content:center;border-width:0;text-align:left;text-decoration:none;cursor:pointer;line-height:var(--icon-size);width:var(--btn-width);height:var(--btn-height)}@media print{.general-button{-webkit-print-color-adjust:exact;print-color-adjust:exact}}.general-button.disable-line-break-max-width{max-width:260px}.general-button__body{position:relative;display:flex;align-items:center;margin-right:0;transition:margin-right 1s ease-in-out}.general-button__body.has-spinner{position:static}.general-button__body.has-secondary-icon{width:100%}@media (max-width: 639.78px){.general-button__body.has-secondary-icon{width:100%}.general-button__body.has-secondary-icon .secondary-icon{position:absolute;right:0}}.general-button__body.has-secondary-icon>span{width:100%}.general-button__body.has-secondary-icon .secondary-icon{margin-left:auto}.general-button__badge{position:absolute;top:-10px;right:0;transform:translate(50%)}.general-button__icon{height:var(--icon-size);display:flex;align-items:center;fill:currentColor;align-self:flex-start;margin-top:-1px;margin-right:6px;width:var(--icon-size)}.general-button__icon svg{fill:currentColor;width:inherit;height:inherit}.general-button__icon svg g{fill:currentColor;width:inherit;height:inherit}.general-button__icon svg text{font-family:Siemens Sans,sans-serif}.general-button__label-content+.general-button__icon{margin-right:0;margin-left:6px}.general-button__icon.secondary-icon svg{transition:transform .12s cubic-bezier(.4,0,.3,1)}.general-button__icon.secondary-icon.open svg{transform:translateZ(0) rotate(180deg)}.general-button__label{display:inline-flex;max-height:40px;word-break:break-word;align-items:center;max-width:228px}.general-button__label-content{display:-webkit-box;-webkit-box-orient:vertical;-webkit-line-clamp:2;overflow:hidden;line-height:initial;text-overflow:ellipsis}.general-button__label-content:empty{display:none}.general-button__label-content.disable-line-break{display:block;white-space:nowrap}.general-button__spinner-wrapper{height:100%;position:absolute;display:flex;justify-content:flex-end;align-items:center;min-width:76px;right:16px;top:0}.general-button__spinner-wrapper.sp-fade-in{animation:fadein 1s linear}.bg-light.spinner-active .general-button__spinner-wrapper.fade-out-text{background:linear-gradient(270deg,#b3b3be 19.14%,rgba(179,179,190,0) 100%)}.bg-dark.spinner-active .general-button__spinner-wrapper.fade-out-text{background:linear-gradient(270deg,#737389 19.14%,rgba(115,115,137,0) 100%)}.bg-light.spinner-active.variant-tertiary .general-button__spinner-wrapper.fade-out-text{background:linear-gradient(270deg,#fff 19.14%,rgba(255,255,255,0) 100%)}.bg-dark.spinner-active.variant-tertiary .general-button__spinner-wrapper.fade-out-text{background:linear-gradient(270deg,#000028 19.14%,rgba(0,0,40,0) 100%)}.general-button--max-width{max-width:260px}.general-button--width{width:100%}.general-button:disabled{cursor:not-allowed}.general-button.type-main{--icon-size-default: 20px;display:flex;align-items:center;min-width:96px;min-height:48px;max-height:56px;padding:6px 16px}.general-button.type-main.fade-appearance{transition-property:border-color,background-color,color,fill;transition-duration:.25s;transition-timing-function:cubic-bezier(.2,0,.38,.9)}.general-button.type-main.fade-appearance .general-button__body{transition:margin-right .25s cubic-bezier(.2,0,.38,.9)}.general-button.type-main.variant-primary.bg-light{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, linear-gradient(90deg, #00ffb9 0%, #00e6dc 100%));background:var(--btn-bg)}@media (hover: hover){.general-button.type-main.variant-primary.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-main.variant-primary.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c5ffef);background:var(--btn-bg)}}.general-button.type-main.variant-primary.bg-light:disabled,.general-button.type-main.variant-primary.bg-light.disabled{--btn-bg: var(--btn-bg-custom, #b3b3be);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #ebebee);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-main.variant-primary.bg-dark{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, linear-gradient(90deg, #00ffb9 0%, #00e6dc 100%));background:var(--btn-bg)}@media (hover: hover){.general-button.type-main.variant-primary.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-main.variant-primary.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c5ffef);background:var(--btn-bg)}}.general-button.type-main.variant-primary.bg-dark:disabled,.general-button.type-main.variant-primary.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, #737389);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-main.variant-secondary.bg-light{--btn-color: var(--btn-color-custom, #fff);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, #007993);background:var(--btn-bg)}@media (hover: hover){.general-button.type-main.variant-secondary.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-main.variant-secondary.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #33747a);background:var(--btn-bg)}}.general-button.type-main.variant-secondary.bg-light:disabled,.general-button.type-main.variant-secondary.bg-light.disabled{--btn-bg: var(--btn-bg-custom, #b3b3be);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #ebebee);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-main.variant-secondary.bg-dark{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, #0cc);background:var(--btn-bg)}@media (hover: hover){.general-button.type-main.variant-secondary.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-main.variant-secondary.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #00ffb9);background:var(--btn-bg)}}.general-button.type-main.variant-secondary.bg-dark:disabled,.general-button.type-main.variant-secondary.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, #737389);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-main.variant-tertiary.bg-light{--btn-color: var(--btn-color-custom, #007993);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);border:1px solid #007993;border-radius:0}@media (hover: hover){.general-button.type-main.variant-tertiary.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-main.variant-tertiary.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c2ffee);background:var(--btn-bg);border:1px solid #33747a;border-radius:0;--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-main.variant-tertiary.bg-light:disabled,.general-button.type-main.variant-tertiary.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);border:1px solid #b3b3be;border-radius:0;--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-main.variant-tertiary.bg-dark{--btn-color: var(--btn-color-custom, #0cc);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, rgba(0, 0, 40, .4));background:var(--btn-bg);border:1px solid #0cc;border-radius:0}@media (hover: hover){.general-button.type-main.variant-tertiary.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-main.variant-tertiary.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #001f39);background:var(--btn-bg);border:1px solid #00ffb9;border-radius:0;--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-main.variant-tertiary.bg-dark:disabled,.general-button.type-main.variant-tertiary.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);border:1px solid #b3b3be;border-radius:0;--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-main.with-spinner{overflow:hidden}.general-button.type-main.with-spinner .general-button__label{transition:min-width 1s ease-in-out;min-width:100%}.general-button.type-main.spinner-active{max-width:260px}.general-button.type-main.spinner-active.general-button--width{max-width:100%}.general-button.type-main.spinner-active:not(.fade-text) .general-button__label{min-width:calc(100% + 40px)}.general-button.type-main.spinner-active:not(.fade-text) .general-button__body{padding:0;margin-right:40px}.general-button.type-icon{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}.general-button.type-icon .general-button__spinner-wrapper{min-width:100%;right:0;display:flex;justify-content:center}.general-button.type-icon .general-button__icon svg{opacity:1;transition:opacity .3s ease-in-out}.general-button.type-icon.spinner-active .general-button__icon{opacity:0}.general-button.type-icon.variant-icon-with-label{padding:0 8px}.general-button.type-icon.variant-icon-with-label.position-header{--btn-height-default: 44px;font-size:1.125rem;font-weight:400;line-height:1.5rem}.general-button.type-icon.variant-icon-with-label.position-header.m-black{font-size:1.125rem;font-weight:900;line-height:1.5rem}.general-button.type-icon.variant-icon-with-label.position-header.bg-light{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-with-label.position-header.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-with-label.position-header.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-with-label.position-header.bg-light:disabled,.general-button.type-icon.variant-icon-with-label.position-header.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-with-label.position-header.bg-dark{--btn-color: var(--btn-color-custom, #fff);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-with-label.position-header.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-with-label.position-header.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-with-label.position-header.bg-dark:disabled,.general-button.type-icon.variant-icon-with-label.position-header.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-with-label.position-content{--icon-size-default: 20px;--btn-height-default: 48px}.general-button.type-icon.variant-icon-with-label.position-content.bg-light{--btn-color: var(--btn-color-custom, #007993);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-with-label.position-content.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-with-label.position-content.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c2ffee);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-with-label.position-content.bg-light:disabled,.general-button.type-icon.variant-icon-with-label.position-content.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-with-label.position-content.bg-dark{--btn-color: var(--btn-color-custom, #0cc);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-with-label.position-content.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-with-label.position-content.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #001f39);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-with-label.position-content.bg-dark:disabled,.general-button.type-icon.variant-icon-with-label.position-content.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-menu{--btn-height-default: 44px;min-width:44px;letter-spacing:-.5px}.general-button.type-icon.variant-icon-menu.bg-light{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-menu.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-menu.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-menu.bg-light:disabled,.general-button.type-icon.variant-icon-menu.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-menu.bg-dark{--btn-color: var(--btn-color-custom, #fff);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-menu.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-menu.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-menu.bg-dark:disabled,.general-button.type-icon.variant-icon-menu.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-menu .general-button__label-content{margin-left:16px;font-size:1rem;font-weight:900;line-height:1.5rem}.general-button.type-icon.variant-icon-menu .general-button__icon{margin-top:-1px}.general-button.type-icon.variant-icon-un-contained{--btn-width-default: 44px;--btn-height-default: 44px}.general-button.type-icon.variant-icon-un-contained.position-header.bg-light{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-un-contained.position-header.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-un-contained.position-header.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-un-contained.position-header.bg-light:disabled,.general-button.type-icon.variant-icon-un-contained.position-header.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-un-contained.position-header.bg-dark{--btn-color: var(--btn-color-custom, #fff);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-un-contained.position-header.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-un-contained.position-header.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-un-contained.position-header.bg-dark:disabled,.general-button.type-icon.variant-icon-un-contained.position-header.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-un-contained.position-content.bg-light{--btn-color: var(--btn-color-custom, #4c4c68);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-un-contained.position-content.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-un-contained.position-content.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-un-contained.position-content.bg-light:disabled,.general-button.type-icon.variant-icon-un-contained.position-content.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-un-contained.position-content.bg-dark{--btn-color: var(--btn-color-custom, #e5e5e9);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-un-contained.position-content.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-un-contained.position-content.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-un-contained.position-content.bg-dark:disabled,.general-button.type-icon.variant-icon-un-contained.position-content.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-un-contained.position-content.to-top-button{--btn-color: var(--btn-color-custom, #007993);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-un-contained.position-content:focus{color:var(--btn-focus-color-custom, #33747a)}.general-button.type-icon.variant-icon-contained.position-header{--btn-width-default: 40px;--btn-height-default: 40px}.general-button.type-icon.variant-icon-contained.position-header.bg-light{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, linear-gradient(90deg, #00ffb9 0%, #00e6dc 100%));background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-contained.position-header.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-contained.position-header.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #00646e);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #fff);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-contained.position-header.bg-light:disabled,.general-button.type-icon.variant-icon-contained.position-header.bg-light.disabled{--btn-bg: var(--btn-bg-custom, #b3b3be);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #ebebee);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-contained.position-header.bg-dark{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, linear-gradient(90deg, #00ffb9 0%, #00e6dc 100%));background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-contained.position-header.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-contained.position-header.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c5ffef);background:var(--btn-bg)}}.general-button.type-icon.variant-icon-contained.position-header.bg-dark:disabled,.general-button.type-icon.variant-icon-contained.position-header.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, #737389);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-contained.position-content{--btn-width-default: 48px;--btn-height-default: 48px}.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-light{--btn-color: var(--btn-color-custom, #fff);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, #007993);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #33747a);background:var(--btn-bg)}}.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-light:disabled,.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-light.disabled{--btn-bg: var(--btn-bg-custom, #b3b3be);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #ebebee);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-dark{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, #0cc);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #00ffb9);background:var(--btn-bg)}}.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-dark:disabled,.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, #737389);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-light{--btn-color: var(--btn-color-custom, #007993);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, rgba(255, 255, 255, .6));background:var(--btn-bg);border:1px solid #007993;border-radius:0}@media (hover: hover){.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c2ffee);background:var(--btn-bg);border:1px solid #33747a;border-radius:0;--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-light:disabled,.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-light.disabled{--btn-bg: var(--btn-bg-custom, rgba(255, 255, 255, .6));background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-dark{--btn-color: var(--btn-color-custom, #0cc);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, rgba(0, 0, 40, .4));background:var(--btn-bg);border:1px solid #0cc;border-radius:0}@media (hover: hover){.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #001f39);background:var(--btn-bg);border:1px solid #00ffb9;border-radius:0;--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-dark:disabled,.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, rgba(0, 0, 40, .4));background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-un-contained{padding:0 8px;margin-left:-8px;min-width:96px}.general-button.type-un-contained.bg-light{--btn-color: var(--btn-color-custom, #007993);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-un-contained.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-un-contained.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c2ffee);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-un-contained.bg-light:disabled,.general-button.type-un-contained.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-un-contained.bg-dark{--btn-color: var(--btn-color-custom, #0cc);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-un-contained.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-un-contained.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #001f39);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-un-contained.bg-dark:disabled,.general-button.type-un-contained.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-un-contained.position-content{--icon-size-default: 20px}.general-button.type-un-contained.open{background-color:#c2ffee;color:#33747a}.general-button.not-bold{font-size:1rem;font-weight:400;line-height:1.5rem}@keyframes fadein{0%{opacity:0}to{opacity:1}}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: i2.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "component", type: UiSpinnerComponent, selector: "sie-ui-spinner", inputs: ["size", "message", "overlayOnTop", "overlay", "active"], outputs: ["animationEnded"] }, { kind: "component", type: UiBadgeComponent, selector: "sie-ui-badge", inputs: ["mode", "type", "number", "addOutline", "highlighted", "status"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "directive", type: i1$1.AttributeDirective, selector: "[sieCoreAttributes]", inputs: ["sieCoreAttributes"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiRouteButtonComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-route-button', changeDetection: ChangeDetectionStrategy.OnPush, template: "<!-- BUTTON -->\n<ng-container *ngIf=\"isButton\">\n  <button\n    class=\"general-button\"\n    #uiButton\n    [sieCoreAttributes]=\"dataAttributes\"\n    [ngClass]=\"[\n      cssClass,\n      'type-' + themeType,\n      'variant-' + variant,\n      'bg-' + background,\n      'position-' + position,\n      prominence ? 'prominence-' + prominence : '',\n      fullWidth ? 'general-button--width' : 'general-button--max-width',\n      withSpinner ? 'with-spinner' : '',\n      showSpinner ? 'spinner-active' : '',\n      spinnerAnimating ? 'fade-appearance' : '',\n      shouldFadeOutText ? 'fade-text' : '',\n      !bold ? 'not-bold' : '',\n      increasedSize ? 'increased-size' : '',\n      hoverDisabled ? 'hover-disabled' : '',\n      disableLineBreak && !fullWidth ? 'disable-line-break-max-width' : ''\n    ]\"\n    [class.open]=\"isSecondaryIconRotated\"\n    [type]=\"this.buttonType.endsWith('submit') ? 'submit' : 'button'\"\n    (click)=\"onClick($event)\"\n    (focus)=\"onFocus($event)\"\n    [tabIndex]=\"this.focusable ? 0 : -1\"\n    (blur)=\"onBlur($event)\"\n    [disabled]=\"disabled || showSpinner ? 'disabled' : null\"\n    [ngStyle]=\"withSpinner && !fullWidth && !dimensionsSet ? { width: buttonWithSpinnerWidth + 'px' } : ''\"\n  >\n    <ng-container *ngTemplateOutlet=\"contentField\"></ng-container>\n  </button>\n</ng-container>\n\n<!-- EXTERNAL BUTTON (siemens internal and external links) --><a\n  *ngIf=\"!isButton\"\n  #uiButton\n  [sieCoreAttributes]=\"dataAttributes\"\n  [href]=\"link\"\n  [target]=\"target\"\n  class=\"general-button\"\n  rel=\"noopener\"\n  (click)=\"onClick($event)\"\n  [ngClass]=\"[\n    'type-' + themeType,\n    'variant-' + variant,\n    'bg-' + background,\n    'position-' + position,\n    prominence ? 'prominence-' + prominence : '',\n    cssClass,\n    disabled ? 'disabled' : '',\n    fullWidth ? 'general-button--width' : 'general-button--max-width',\n    withSpinner ? 'with-spinner' : '',\n    showSpinner ? 'spinner-active' : '',\n    spinnerAnimating ? 'fade-appearance' : '',\n    shouldFadeOutText ? 'fade-text' : ''\n  ]\"\n>\n  <ng-container *ngTemplateOutlet=\"contentField\"></ng-container>\n</a>\n\n<!-- CONTENT -->\n<ng-template #contentField>\n  <span class=\"general-button__body\" [ngClass]=\"{ 'has-spinner': withSpinner, 'has-secondary-icon': iconSecondary }\">\n    <sie-ui-badge\n      *ngIf=\"badge\"\n      class=\"general-button__badge\"\n      type=\"counter\"\n      [number]=\"badgeNumber\"\n      addOutline\n    ></sie-ui-badge>\n    <span class=\"general-button__label\">\n      <ng-container *ngIf=\"icon && iconPosition === 'leading'\">\n        <sie-icon [name]=\"icon\" class=\"general-button__icon\" [ngClass]=\"getIconClasses()\" aria-hidden=\"true\"></sie-icon>\n        <span *ngIf=\"iconScreenReaderText\" class=\"visually-hidden\">{{ iconScreenReaderText }}</span>\n      </ng-container>\n      <span class=\"general-button__label-content\" [ngClass]=\"{ 'disable-line-break': disableLineBreak }\"\n        ><ng-content></ng-content\n      ></span>\n      <ng-container *ngIf=\"icon && iconPosition === 'trailing'\">\n        <sie-icon [name]=\"icon\" class=\"general-button__icon\" [ngClass]=\"getIconClasses()\"></sie-icon>\n      </ng-container>\n      <ng-container *ngIf=\"iconSecondary\">\n        <sie-icon\n          [name]=\"iconSecondary\"\n          class=\"general-button__icon secondary-icon\"\n          [ngClass]=\"getIconClasses()\"\n          [class.open]=\"isSecondaryIconRotated\"\n        ></sie-icon>\n      </ng-container>\n      <ng-container *ngIf=\"showSpinner || spinnerAnimating\">\n        <div\n          class=\"general-button__spinner-wrapper\"\n          [ngClass]=\"{\n            'sp-fade-in': showSpinner,\n            'fade-out-text': shouldFadeOutText\n          }\"\n        >\n          <sie-ui-spinner\n            [size]=\"spinnerSize\"\n            [active]=\"showSpinner\"\n            (animationEnded)=\"onAnimationEnd()\"\n          ></sie-ui-spinner>\n        </div>\n      </ng-container>\n    </span>\n  </span>\n</ng-template>\n", styles: [":host .general-button{outline:none;outline-offset:0}@media (pointer: fine){:host .general-button{position:relative}:host .general-button:focus{outline:1px solid #1491eb;outline-offset:2px}:host .general-button:focus:not(:focus-visible){outline:0}:host .general-button:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}:host{display:inline-flex;position:relative;--icon-size-default: 24px;--btn-height-default: 48px;--btn-width-default: auto;outline:0}:host(.full-width){width:100%}.general-button.type-icon.variant-icon-contained .general-button__icon,.general-button.type-icon.variant-icon-un-contained .general-button__icon,.general-button.type-icon.variant-icon-menu .general-button__icon{margin:0}.increased-size.general-button.type-icon.variant-icon-contained.position-content,.increased-size.general-button.type-icon.variant-icon-contained.position-header,.increased-size.general-button.type-icon.variant-icon-un-contained,.increased-size.general-button.type-icon.variant-icon-with-label.position-content,.increased-size.general-button.type-icon.variant-icon-with-label.position-header,.increased-size.general-button{--btn-height-default: 56px;--icon-size-default: 28px;min-width:56px}.general-button{font-size:1rem;font-weight:900;line-height:1.5rem;--icon-size: var(--icon-size-custom, var(--icon-size-default));--btn-width: var(--btn-width-custom, var(--btn-width-default));--btn-height: var(--btn-height-custom, var(--btn-height-default));-webkit-user-drag:none;display:inline-flex;flex:1 1 0;align-items:center;justify-content:center;border-width:0;text-align:left;text-decoration:none;cursor:pointer;line-height:var(--icon-size);width:var(--btn-width);height:var(--btn-height)}@media print{.general-button{-webkit-print-color-adjust:exact;print-color-adjust:exact}}.general-button.disable-line-break-max-width{max-width:260px}.general-button__body{position:relative;display:flex;align-items:center;margin-right:0;transition:margin-right 1s ease-in-out}.general-button__body.has-spinner{position:static}.general-button__body.has-secondary-icon{width:100%}@media (max-width: 639.78px){.general-button__body.has-secondary-icon{width:100%}.general-button__body.has-secondary-icon .secondary-icon{position:absolute;right:0}}.general-button__body.has-secondary-icon>span{width:100%}.general-button__body.has-secondary-icon .secondary-icon{margin-left:auto}.general-button__badge{position:absolute;top:-10px;right:0;transform:translate(50%)}.general-button__icon{height:var(--icon-size);display:flex;align-items:center;fill:currentColor;align-self:flex-start;margin-top:-1px;margin-right:6px;width:var(--icon-size)}.general-button__icon svg{fill:currentColor;width:inherit;height:inherit}.general-button__icon svg g{fill:currentColor;width:inherit;height:inherit}.general-button__icon svg text{font-family:Siemens Sans,sans-serif}.general-button__label-content+.general-button__icon{margin-right:0;margin-left:6px}.general-button__icon.secondary-icon svg{transition:transform .12s cubic-bezier(.4,0,.3,1)}.general-button__icon.secondary-icon.open svg{transform:translateZ(0) rotate(180deg)}.general-button__label{display:inline-flex;max-height:40px;word-break:break-word;align-items:center;max-width:228px}.general-button__label-content{display:-webkit-box;-webkit-box-orient:vertical;-webkit-line-clamp:2;overflow:hidden;line-height:initial;text-overflow:ellipsis}.general-button__label-content:empty{display:none}.general-button__label-content.disable-line-break{display:block;white-space:nowrap}.general-button__spinner-wrapper{height:100%;position:absolute;display:flex;justify-content:flex-end;align-items:center;min-width:76px;right:16px;top:0}.general-button__spinner-wrapper.sp-fade-in{animation:fadein 1s linear}.bg-light.spinner-active .general-button__spinner-wrapper.fade-out-text{background:linear-gradient(270deg,#b3b3be 19.14%,rgba(179,179,190,0) 100%)}.bg-dark.spinner-active .general-button__spinner-wrapper.fade-out-text{background:linear-gradient(270deg,#737389 19.14%,rgba(115,115,137,0) 100%)}.bg-light.spinner-active.variant-tertiary .general-button__spinner-wrapper.fade-out-text{background:linear-gradient(270deg,#fff 19.14%,rgba(255,255,255,0) 100%)}.bg-dark.spinner-active.variant-tertiary .general-button__spinner-wrapper.fade-out-text{background:linear-gradient(270deg,#000028 19.14%,rgba(0,0,40,0) 100%)}.general-button--max-width{max-width:260px}.general-button--width{width:100%}.general-button:disabled{cursor:not-allowed}.general-button.type-main{--icon-size-default: 20px;display:flex;align-items:center;min-width:96px;min-height:48px;max-height:56px;padding:6px 16px}.general-button.type-main.fade-appearance{transition-property:border-color,background-color,color,fill;transition-duration:.25s;transition-timing-function:cubic-bezier(.2,0,.38,.9)}.general-button.type-main.fade-appearance .general-button__body{transition:margin-right .25s cubic-bezier(.2,0,.38,.9)}.general-button.type-main.variant-primary.bg-light{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, linear-gradient(90deg, #00ffb9 0%, #00e6dc 100%));background:var(--btn-bg)}@media (hover: hover){.general-button.type-main.variant-primary.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-main.variant-primary.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c5ffef);background:var(--btn-bg)}}.general-button.type-main.variant-primary.bg-light:disabled,.general-button.type-main.variant-primary.bg-light.disabled{--btn-bg: var(--btn-bg-custom, #b3b3be);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #ebebee);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-main.variant-primary.bg-dark{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, linear-gradient(90deg, #00ffb9 0%, #00e6dc 100%));background:var(--btn-bg)}@media (hover: hover){.general-button.type-main.variant-primary.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-main.variant-primary.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c5ffef);background:var(--btn-bg)}}.general-button.type-main.variant-primary.bg-dark:disabled,.general-button.type-main.variant-primary.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, #737389);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-main.variant-secondary.bg-light{--btn-color: var(--btn-color-custom, #fff);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, #007993);background:var(--btn-bg)}@media (hover: hover){.general-button.type-main.variant-secondary.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-main.variant-secondary.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #33747a);background:var(--btn-bg)}}.general-button.type-main.variant-secondary.bg-light:disabled,.general-button.type-main.variant-secondary.bg-light.disabled{--btn-bg: var(--btn-bg-custom, #b3b3be);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #ebebee);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-main.variant-secondary.bg-dark{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, #0cc);background:var(--btn-bg)}@media (hover: hover){.general-button.type-main.variant-secondary.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-main.variant-secondary.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #00ffb9);background:var(--btn-bg)}}.general-button.type-main.variant-secondary.bg-dark:disabled,.general-button.type-main.variant-secondary.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, #737389);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-main.variant-tertiary.bg-light{--btn-color: var(--btn-color-custom, #007993);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);border:1px solid #007993;border-radius:0}@media (hover: hover){.general-button.type-main.variant-tertiary.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-main.variant-tertiary.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c2ffee);background:var(--btn-bg);border:1px solid #33747a;border-radius:0;--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-main.variant-tertiary.bg-light:disabled,.general-button.type-main.variant-tertiary.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);border:1px solid #b3b3be;border-radius:0;--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-main.variant-tertiary.bg-dark{--btn-color: var(--btn-color-custom, #0cc);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, rgba(0, 0, 40, .4));background:var(--btn-bg);border:1px solid #0cc;border-radius:0}@media (hover: hover){.general-button.type-main.variant-tertiary.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-main.variant-tertiary.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #001f39);background:var(--btn-bg);border:1px solid #00ffb9;border-radius:0;--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-main.variant-tertiary.bg-dark:disabled,.general-button.type-main.variant-tertiary.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);border:1px solid #b3b3be;border-radius:0;--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-main.with-spinner{overflow:hidden}.general-button.type-main.with-spinner .general-button__label{transition:min-width 1s ease-in-out;min-width:100%}.general-button.type-main.spinner-active{max-width:260px}.general-button.type-main.spinner-active.general-button--width{max-width:100%}.general-button.type-main.spinner-active:not(.fade-text) .general-button__label{min-width:calc(100% + 40px)}.general-button.type-main.spinner-active:not(.fade-text) .general-button__body{padding:0;margin-right:40px}.general-button.type-icon{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}.general-button.type-icon .general-button__spinner-wrapper{min-width:100%;right:0;display:flex;justify-content:center}.general-button.type-icon .general-button__icon svg{opacity:1;transition:opacity .3s ease-in-out}.general-button.type-icon.spinner-active .general-button__icon{opacity:0}.general-button.type-icon.variant-icon-with-label{padding:0 8px}.general-button.type-icon.variant-icon-with-label.position-header{--btn-height-default: 44px;font-size:1.125rem;font-weight:400;line-height:1.5rem}.general-button.type-icon.variant-icon-with-label.position-header.m-black{font-size:1.125rem;font-weight:900;line-height:1.5rem}.general-button.type-icon.variant-icon-with-label.position-header.bg-light{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-with-label.position-header.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-with-label.position-header.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-with-label.position-header.bg-light:disabled,.general-button.type-icon.variant-icon-with-label.position-header.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-with-label.position-header.bg-dark{--btn-color: var(--btn-color-custom, #fff);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-with-label.position-header.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-with-label.position-header.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-with-label.position-header.bg-dark:disabled,.general-button.type-icon.variant-icon-with-label.position-header.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-with-label.position-content{--icon-size-default: 20px;--btn-height-default: 48px}.general-button.type-icon.variant-icon-with-label.position-content.bg-light{--btn-color: var(--btn-color-custom, #007993);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-with-label.position-content.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-with-label.position-content.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c2ffee);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-with-label.position-content.bg-light:disabled,.general-button.type-icon.variant-icon-with-label.position-content.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-with-label.position-content.bg-dark{--btn-color: var(--btn-color-custom, #0cc);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-with-label.position-content.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-with-label.position-content.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #001f39);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-with-label.position-content.bg-dark:disabled,.general-button.type-icon.variant-icon-with-label.position-content.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-menu{--btn-height-default: 44px;min-width:44px;letter-spacing:-.5px}.general-button.type-icon.variant-icon-menu.bg-light{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-menu.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-menu.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-menu.bg-light:disabled,.general-button.type-icon.variant-icon-menu.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-menu.bg-dark{--btn-color: var(--btn-color-custom, #fff);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-menu.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-menu.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-menu.bg-dark:disabled,.general-button.type-icon.variant-icon-menu.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-menu .general-button__label-content{margin-left:16px;font-size:1rem;font-weight:900;line-height:1.5rem}.general-button.type-icon.variant-icon-menu .general-button__icon{margin-top:-1px}.general-button.type-icon.variant-icon-un-contained{--btn-width-default: 44px;--btn-height-default: 44px}.general-button.type-icon.variant-icon-un-contained.position-header.bg-light{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-un-contained.position-header.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-un-contained.position-header.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-un-contained.position-header.bg-light:disabled,.general-button.type-icon.variant-icon-un-contained.position-header.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-un-contained.position-header.bg-dark{--btn-color: var(--btn-color-custom, #fff);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-un-contained.position-header.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-un-contained.position-header.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-un-contained.position-header.bg-dark:disabled,.general-button.type-icon.variant-icon-un-contained.position-header.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-un-contained.position-content.bg-light{--btn-color: var(--btn-color-custom, #4c4c68);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-un-contained.position-content.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-un-contained.position-content.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-un-contained.position-content.bg-light:disabled,.general-button.type-icon.variant-icon-un-contained.position-content.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-un-contained.position-content.bg-dark{--btn-color: var(--btn-color-custom, #e5e5e9);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-un-contained.position-content.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-un-contained.position-content.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-un-contained.position-content.bg-dark:disabled,.general-button.type-icon.variant-icon-un-contained.position-content.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-un-contained.position-content.to-top-button{--btn-color: var(--btn-color-custom, #007993);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-un-contained.position-content:focus{color:var(--btn-focus-color-custom, #33747a)}.general-button.type-icon.variant-icon-contained.position-header{--btn-width-default: 40px;--btn-height-default: 40px}.general-button.type-icon.variant-icon-contained.position-header.bg-light{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, linear-gradient(90deg, #00ffb9 0%, #00e6dc 100%));background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-contained.position-header.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-contained.position-header.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #00646e);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #fff);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-contained.position-header.bg-light:disabled,.general-button.type-icon.variant-icon-contained.position-header.bg-light.disabled{--btn-bg: var(--btn-bg-custom, #b3b3be);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #ebebee);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-contained.position-header.bg-dark{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, linear-gradient(90deg, #00ffb9 0%, #00e6dc 100%));background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-contained.position-header.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-contained.position-header.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c5ffef);background:var(--btn-bg)}}.general-button.type-icon.variant-icon-contained.position-header.bg-dark:disabled,.general-button.type-icon.variant-icon-contained.position-header.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, #737389);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-contained.position-content{--btn-width-default: 48px;--btn-height-default: 48px}.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-light{--btn-color: var(--btn-color-custom, #fff);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, #007993);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #33747a);background:var(--btn-bg)}}.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-light:disabled,.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-light.disabled{--btn-bg: var(--btn-bg-custom, #b3b3be);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #ebebee);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-dark{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, #0cc);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #00ffb9);background:var(--btn-bg)}}.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-dark:disabled,.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, #737389);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-light{--btn-color: var(--btn-color-custom, #007993);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, rgba(255, 255, 255, .6));background:var(--btn-bg);border:1px solid #007993;border-radius:0}@media (hover: hover){.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c2ffee);background:var(--btn-bg);border:1px solid #33747a;border-radius:0;--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-light:disabled,.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-light.disabled{--btn-bg: var(--btn-bg-custom, rgba(255, 255, 255, .6));background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-dark{--btn-color: var(--btn-color-custom, #0cc);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, rgba(0, 0, 40, .4));background:var(--btn-bg);border:1px solid #0cc;border-radius:0}@media (hover: hover){.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #001f39);background:var(--btn-bg);border:1px solid #00ffb9;border-radius:0;--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-dark:disabled,.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, rgba(0, 0, 40, .4));background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-un-contained{padding:0 8px;margin-left:-8px;min-width:96px}.general-button.type-un-contained.bg-light{--btn-color: var(--btn-color-custom, #007993);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-un-contained.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-un-contained.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c2ffee);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-un-contained.bg-light:disabled,.general-button.type-un-contained.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-un-contained.bg-dark{--btn-color: var(--btn-color-custom, #0cc);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-un-contained.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-un-contained.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #001f39);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-un-contained.bg-dark:disabled,.general-button.type-un-contained.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-un-contained.position-content{--icon-size-default: 20px}.general-button.type-un-contained.open{background-color:#c2ffee;color:#33747a}.general-button.not-bold{font-size:1rem;font-weight:400;line-height:1.5rem}@keyframes fadein{0%{opacity:0}to{opacity:1}}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i1.SieIconRegistryService }, { type: i2$1.Router }, { type: i2$1.ActivatedRoute }]; }, propDecorators: { 
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        routeCommands: [{
                type: Input
            }], routeExtras: [{
                type: Input
            }], relative: [{
                type: Input
            }], routeFinished: [{
                type: Output
            }] } });

class UiRouteButtonModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiRouteButtonModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiRouteButtonModule, declarations: [UiRouteButtonComponent], imports: [CommonModule, UiSpinnerModule, UiBadgeModule, SieIconsModule, AttributeModule], exports: [UiRouteButtonComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiRouteButtonModule, imports: [CommonModule, UiSpinnerModule, UiBadgeModule, SieIconsModule, AttributeModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiRouteButtonModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [CommonModule, UiSpinnerModule, UiBadgeModule, SieIconsModule, AttributeModule],
                    declarations: [UiRouteButtonComponent],
                    exports: [UiRouteButtonComponent]
                }]
        }] });

class UiModalButtonComponent extends UiBaseButtonDirective {
    constructor(cdr, iconReg, uiGlobalModalHandlingEventService) {
        super(cdr, iconReg);
        this.uiGlobalModalHandlingEventService = uiGlobalModalHandlingEventService;
    }
    set modalInformation(modalModel) {
        if (modalModel) {
            this.uiGlobalModalHandlingEventService.registerModalEvent.next(modalModel);
        }
        this._modalInformation = modalModel;
    }
    get modalInformation() {
        return this._modalInformation;
    }
    onClick(event) {
        this.clicked.next(event);
        event.preventDefault();
        this.uiGlobalModalHandlingEventService.openModalEvent.next(this._modalInformation);
    }
    applyExtraData(data) {
        this.modalInformation = data.modalInformation;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiModalButtonComponent, deps: [{ token: i0.ChangeDetectorRef }, { token: i1.SieIconRegistryService }, { token: UiGlobalModalHandlingEventService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiModalButtonComponent, selector: "sie-ui-modal-button", inputs: { modalInformation: "modalInformation" }, usesInheritance: true, ngImport: i0, template: "<!-- BUTTON -->\n<ng-container *ngIf=\"isButton\">\n  <button\n    class=\"general-button\"\n    #uiButton\n    [sieCoreAttributes]=\"dataAttributes\"\n    [ngClass]=\"[\n      cssClass,\n      'type-' + themeType,\n      'variant-' + variant,\n      'bg-' + background,\n      'position-' + position,\n      prominence ? 'prominence-' + prominence : '',\n      fullWidth ? 'general-button--width' : 'general-button--max-width',\n      withSpinner ? 'with-spinner' : '',\n      showSpinner ? 'spinner-active' : '',\n      spinnerAnimating ? 'fade-appearance' : '',\n      shouldFadeOutText ? 'fade-text' : '',\n      !bold ? 'not-bold' : '',\n      increasedSize ? 'increased-size' : '',\n      hoverDisabled ? 'hover-disabled' : '',\n      disableLineBreak && !fullWidth ? 'disable-line-break-max-width' : ''\n    ]\"\n    [class.open]=\"isSecondaryIconRotated\"\n    [type]=\"this.buttonType.endsWith('submit') ? 'submit' : 'button'\"\n    (click)=\"onClick($event)\"\n    (focus)=\"onFocus($event)\"\n    [tabIndex]=\"this.focusable ? 0 : -1\"\n    (blur)=\"onBlur($event)\"\n    [disabled]=\"disabled || showSpinner ? 'disabled' : null\"\n    [ngStyle]=\"withSpinner && !fullWidth && !dimensionsSet ? { width: buttonWithSpinnerWidth + 'px' } : ''\"\n  >\n    <ng-container *ngTemplateOutlet=\"contentField\"></ng-container>\n  </button>\n</ng-container>\n\n<!-- EXTERNAL BUTTON (siemens internal and external links) --><a\n  *ngIf=\"!isButton\"\n  #uiButton\n  [sieCoreAttributes]=\"dataAttributes\"\n  [href]=\"link\"\n  [target]=\"target\"\n  class=\"general-button\"\n  rel=\"noopener\"\n  (click)=\"onClick($event)\"\n  [ngClass]=\"[\n    'type-' + themeType,\n    'variant-' + variant,\n    'bg-' + background,\n    'position-' + position,\n    prominence ? 'prominence-' + prominence : '',\n    cssClass,\n    disabled ? 'disabled' : '',\n    fullWidth ? 'general-button--width' : 'general-button--max-width',\n    withSpinner ? 'with-spinner' : '',\n    showSpinner ? 'spinner-active' : '',\n    spinnerAnimating ? 'fade-appearance' : '',\n    shouldFadeOutText ? 'fade-text' : ''\n  ]\"\n>\n  <ng-container *ngTemplateOutlet=\"contentField\"></ng-container>\n</a>\n\n<!-- CONTENT -->\n<ng-template #contentField>\n  <span class=\"general-button__body\" [ngClass]=\"{ 'has-spinner': withSpinner, 'has-secondary-icon': iconSecondary }\">\n    <sie-ui-badge\n      *ngIf=\"badge\"\n      class=\"general-button__badge\"\n      type=\"counter\"\n      [number]=\"badgeNumber\"\n      addOutline\n    ></sie-ui-badge>\n    <span class=\"general-button__label\">\n      <ng-container *ngIf=\"icon && iconPosition === 'leading'\">\n        <sie-icon [name]=\"icon\" class=\"general-button__icon\" [ngClass]=\"getIconClasses()\" aria-hidden=\"true\"></sie-icon>\n        <span *ngIf=\"iconScreenReaderText\" class=\"visually-hidden\">{{ iconScreenReaderText }}</span>\n      </ng-container>\n      <span class=\"general-button__label-content\" [ngClass]=\"{ 'disable-line-break': disableLineBreak }\"\n        ><ng-content></ng-content\n      ></span>\n      <ng-container *ngIf=\"icon && iconPosition === 'trailing'\">\n        <sie-icon [name]=\"icon\" class=\"general-button__icon\" [ngClass]=\"getIconClasses()\"></sie-icon>\n      </ng-container>\n      <ng-container *ngIf=\"iconSecondary\">\n        <sie-icon\n          [name]=\"iconSecondary\"\n          class=\"general-button__icon secondary-icon\"\n          [ngClass]=\"getIconClasses()\"\n          [class.open]=\"isSecondaryIconRotated\"\n        ></sie-icon>\n      </ng-container>\n      <ng-container *ngIf=\"showSpinner || spinnerAnimating\">\n        <div\n          class=\"general-button__spinner-wrapper\"\n          [ngClass]=\"{\n            'sp-fade-in': showSpinner,\n            'fade-out-text': shouldFadeOutText\n          }\"\n        >\n          <sie-ui-spinner\n            [size]=\"spinnerSize\"\n            [active]=\"showSpinner\"\n            (animationEnded)=\"onAnimationEnd()\"\n          ></sie-ui-spinner>\n        </div>\n      </ng-container>\n    </span>\n  </span>\n</ng-template>\n", styles: [":host .general-button{outline:none;outline-offset:0}@media (pointer: fine){:host .general-button{position:relative}:host .general-button:focus{outline:1px solid #1491eb;outline-offset:2px}:host .general-button:focus:not(:focus-visible){outline:0}:host .general-button:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}:host{display:inline-flex;position:relative;--icon-size-default: 24px;--btn-height-default: 48px;--btn-width-default: auto;outline:0}:host(.full-width){width:100%}.general-button.type-icon.variant-icon-contained .general-button__icon,.general-button.type-icon.variant-icon-un-contained .general-button__icon,.general-button.type-icon.variant-icon-menu .general-button__icon{margin:0}.increased-size.general-button.type-icon.variant-icon-contained.position-content,.increased-size.general-button.type-icon.variant-icon-contained.position-header,.increased-size.general-button.type-icon.variant-icon-un-contained,.increased-size.general-button.type-icon.variant-icon-with-label.position-content,.increased-size.general-button.type-icon.variant-icon-with-label.position-header,.increased-size.general-button{--btn-height-default: 56px;--icon-size-default: 28px;min-width:56px}.general-button{font-size:1rem;font-weight:900;line-height:1.5rem;--icon-size: var(--icon-size-custom, var(--icon-size-default));--btn-width: var(--btn-width-custom, var(--btn-width-default));--btn-height: var(--btn-height-custom, var(--btn-height-default));-webkit-user-drag:none;display:inline-flex;flex:1 1 0;align-items:center;justify-content:center;border-width:0;text-align:left;text-decoration:none;cursor:pointer;line-height:var(--icon-size);width:var(--btn-width);height:var(--btn-height)}@media print{.general-button{-webkit-print-color-adjust:exact;print-color-adjust:exact}}.general-button.disable-line-break-max-width{max-width:260px}.general-button__body{position:relative;display:flex;align-items:center;margin-right:0;transition:margin-right 1s ease-in-out}.general-button__body.has-spinner{position:static}.general-button__body.has-secondary-icon{width:100%}@media (max-width: 639.78px){.general-button__body.has-secondary-icon{width:100%}.general-button__body.has-secondary-icon .secondary-icon{position:absolute;right:0}}.general-button__body.has-secondary-icon>span{width:100%}.general-button__body.has-secondary-icon .secondary-icon{margin-left:auto}.general-button__badge{position:absolute;top:-10px;right:0;transform:translate(50%)}.general-button__icon{height:var(--icon-size);display:flex;align-items:center;fill:currentColor;align-self:flex-start;margin-top:-1px;margin-right:6px;width:var(--icon-size)}.general-button__icon svg{fill:currentColor;width:inherit;height:inherit}.general-button__icon svg g{fill:currentColor;width:inherit;height:inherit}.general-button__icon svg text{font-family:Siemens Sans,sans-serif}.general-button__label-content+.general-button__icon{margin-right:0;margin-left:6px}.general-button__icon.secondary-icon svg{transition:transform .12s cubic-bezier(.4,0,.3,1)}.general-button__icon.secondary-icon.open svg{transform:translateZ(0) rotate(180deg)}.general-button__label{display:inline-flex;max-height:40px;word-break:break-word;align-items:center;max-width:228px}.general-button__label-content{display:-webkit-box;-webkit-box-orient:vertical;-webkit-line-clamp:2;overflow:hidden;line-height:initial;text-overflow:ellipsis}.general-button__label-content:empty{display:none}.general-button__label-content.disable-line-break{display:block;white-space:nowrap}.general-button__spinner-wrapper{height:100%;position:absolute;display:flex;justify-content:flex-end;align-items:center;min-width:76px;right:16px;top:0}.general-button__spinner-wrapper.sp-fade-in{animation:fadein 1s linear}.bg-light.spinner-active .general-button__spinner-wrapper.fade-out-text{background:linear-gradient(270deg,#b3b3be 19.14%,rgba(179,179,190,0) 100%)}.bg-dark.spinner-active .general-button__spinner-wrapper.fade-out-text{background:linear-gradient(270deg,#737389 19.14%,rgba(115,115,137,0) 100%)}.bg-light.spinner-active.variant-tertiary .general-button__spinner-wrapper.fade-out-text{background:linear-gradient(270deg,#fff 19.14%,rgba(255,255,255,0) 100%)}.bg-dark.spinner-active.variant-tertiary .general-button__spinner-wrapper.fade-out-text{background:linear-gradient(270deg,#000028 19.14%,rgba(0,0,40,0) 100%)}.general-button--max-width{max-width:260px}.general-button--width{width:100%}.general-button:disabled{cursor:not-allowed}.general-button.type-main{--icon-size-default: 20px;display:flex;align-items:center;min-width:96px;min-height:48px;max-height:56px;padding:6px 16px}.general-button.type-main.fade-appearance{transition-property:border-color,background-color,color,fill;transition-duration:.25s;transition-timing-function:cubic-bezier(.2,0,.38,.9)}.general-button.type-main.fade-appearance .general-button__body{transition:margin-right .25s cubic-bezier(.2,0,.38,.9)}.general-button.type-main.variant-primary.bg-light{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, linear-gradient(90deg, #00ffb9 0%, #00e6dc 100%));background:var(--btn-bg)}@media (hover: hover){.general-button.type-main.variant-primary.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-main.variant-primary.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c5ffef);background:var(--btn-bg)}}.general-button.type-main.variant-primary.bg-light:disabled,.general-button.type-main.variant-primary.bg-light.disabled{--btn-bg: var(--btn-bg-custom, #b3b3be);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #ebebee);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-main.variant-primary.bg-dark{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, linear-gradient(90deg, #00ffb9 0%, #00e6dc 100%));background:var(--btn-bg)}@media (hover: hover){.general-button.type-main.variant-primary.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-main.variant-primary.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c5ffef);background:var(--btn-bg)}}.general-button.type-main.variant-primary.bg-dark:disabled,.general-button.type-main.variant-primary.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, #737389);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-main.variant-secondary.bg-light{--btn-color: var(--btn-color-custom, #fff);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, #007993);background:var(--btn-bg)}@media (hover: hover){.general-button.type-main.variant-secondary.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-main.variant-secondary.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #33747a);background:var(--btn-bg)}}.general-button.type-main.variant-secondary.bg-light:disabled,.general-button.type-main.variant-secondary.bg-light.disabled{--btn-bg: var(--btn-bg-custom, #b3b3be);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #ebebee);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-main.variant-secondary.bg-dark{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, #0cc);background:var(--btn-bg)}@media (hover: hover){.general-button.type-main.variant-secondary.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-main.variant-secondary.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #00ffb9);background:var(--btn-bg)}}.general-button.type-main.variant-secondary.bg-dark:disabled,.general-button.type-main.variant-secondary.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, #737389);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-main.variant-tertiary.bg-light{--btn-color: var(--btn-color-custom, #007993);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);border:1px solid #007993;border-radius:0}@media (hover: hover){.general-button.type-main.variant-tertiary.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-main.variant-tertiary.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c2ffee);background:var(--btn-bg);border:1px solid #33747a;border-radius:0;--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-main.variant-tertiary.bg-light:disabled,.general-button.type-main.variant-tertiary.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);border:1px solid #b3b3be;border-radius:0;--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-main.variant-tertiary.bg-dark{--btn-color: var(--btn-color-custom, #0cc);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, rgba(0, 0, 40, .4));background:var(--btn-bg);border:1px solid #0cc;border-radius:0}@media (hover: hover){.general-button.type-main.variant-tertiary.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-main.variant-tertiary.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #001f39);background:var(--btn-bg);border:1px solid #00ffb9;border-radius:0;--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-main.variant-tertiary.bg-dark:disabled,.general-button.type-main.variant-tertiary.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);border:1px solid #b3b3be;border-radius:0;--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-main.with-spinner{overflow:hidden}.general-button.type-main.with-spinner .general-button__label{transition:min-width 1s ease-in-out;min-width:100%}.general-button.type-main.spinner-active{max-width:260px}.general-button.type-main.spinner-active.general-button--width{max-width:100%}.general-button.type-main.spinner-active:not(.fade-text) .general-button__label{min-width:calc(100% + 40px)}.general-button.type-main.spinner-active:not(.fade-text) .general-button__body{padding:0;margin-right:40px}.general-button.type-icon{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}.general-button.type-icon .general-button__spinner-wrapper{min-width:100%;right:0;display:flex;justify-content:center}.general-button.type-icon .general-button__icon svg{opacity:1;transition:opacity .3s ease-in-out}.general-button.type-icon.spinner-active .general-button__icon{opacity:0}.general-button.type-icon.variant-icon-with-label{padding:0 8px}.general-button.type-icon.variant-icon-with-label.position-header{--btn-height-default: 44px;font-size:1.125rem;font-weight:400;line-height:1.5rem}.general-button.type-icon.variant-icon-with-label.position-header.m-black{font-size:1.125rem;font-weight:900;line-height:1.5rem}.general-button.type-icon.variant-icon-with-label.position-header.bg-light{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-with-label.position-header.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-with-label.position-header.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-with-label.position-header.bg-light:disabled,.general-button.type-icon.variant-icon-with-label.position-header.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-with-label.position-header.bg-dark{--btn-color: var(--btn-color-custom, #fff);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-with-label.position-header.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-with-label.position-header.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-with-label.position-header.bg-dark:disabled,.general-button.type-icon.variant-icon-with-label.position-header.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-with-label.position-content{--icon-size-default: 20px;--btn-height-default: 48px}.general-button.type-icon.variant-icon-with-label.position-content.bg-light{--btn-color: var(--btn-color-custom, #007993);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-with-label.position-content.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-with-label.position-content.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c2ffee);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-with-label.position-content.bg-light:disabled,.general-button.type-icon.variant-icon-with-label.position-content.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-with-label.position-content.bg-dark{--btn-color: var(--btn-color-custom, #0cc);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-with-label.position-content.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-with-label.position-content.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #001f39);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-with-label.position-content.bg-dark:disabled,.general-button.type-icon.variant-icon-with-label.position-content.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-menu{--btn-height-default: 44px;min-width:44px;letter-spacing:-.5px}.general-button.type-icon.variant-icon-menu.bg-light{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-menu.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-menu.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-menu.bg-light:disabled,.general-button.type-icon.variant-icon-menu.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-menu.bg-dark{--btn-color: var(--btn-color-custom, #fff);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-menu.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-menu.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-menu.bg-dark:disabled,.general-button.type-icon.variant-icon-menu.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-menu .general-button__label-content{margin-left:16px;font-size:1rem;font-weight:900;line-height:1.5rem}.general-button.type-icon.variant-icon-menu .general-button__icon{margin-top:-1px}.general-button.type-icon.variant-icon-un-contained{--btn-width-default: 44px;--btn-height-default: 44px}.general-button.type-icon.variant-icon-un-contained.position-header.bg-light{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-un-contained.position-header.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-un-contained.position-header.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-un-contained.position-header.bg-light:disabled,.general-button.type-icon.variant-icon-un-contained.position-header.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-un-contained.position-header.bg-dark{--btn-color: var(--btn-color-custom, #fff);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-un-contained.position-header.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-un-contained.position-header.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-un-contained.position-header.bg-dark:disabled,.general-button.type-icon.variant-icon-un-contained.position-header.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-un-contained.position-content.bg-light{--btn-color: var(--btn-color-custom, #4c4c68);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-un-contained.position-content.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-un-contained.position-content.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-un-contained.position-content.bg-light:disabled,.general-button.type-icon.variant-icon-un-contained.position-content.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-un-contained.position-content.bg-dark{--btn-color: var(--btn-color-custom, #e5e5e9);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-un-contained.position-content.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-un-contained.position-content.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-un-contained.position-content.bg-dark:disabled,.general-button.type-icon.variant-icon-un-contained.position-content.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-un-contained.position-content.to-top-button{--btn-color: var(--btn-color-custom, #007993);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-un-contained.position-content:focus{color:var(--btn-focus-color-custom, #33747a)}.general-button.type-icon.variant-icon-contained.position-header{--btn-width-default: 40px;--btn-height-default: 40px}.general-button.type-icon.variant-icon-contained.position-header.bg-light{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, linear-gradient(90deg, #00ffb9 0%, #00e6dc 100%));background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-contained.position-header.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-contained.position-header.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #00646e);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #fff);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-contained.position-header.bg-light:disabled,.general-button.type-icon.variant-icon-contained.position-header.bg-light.disabled{--btn-bg: var(--btn-bg-custom, #b3b3be);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #ebebee);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-contained.position-header.bg-dark{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, linear-gradient(90deg, #00ffb9 0%, #00e6dc 100%));background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-contained.position-header.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-contained.position-header.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c5ffef);background:var(--btn-bg)}}.general-button.type-icon.variant-icon-contained.position-header.bg-dark:disabled,.general-button.type-icon.variant-icon-contained.position-header.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, #737389);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-contained.position-content{--btn-width-default: 48px;--btn-height-default: 48px}.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-light{--btn-color: var(--btn-color-custom, #fff);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, #007993);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #33747a);background:var(--btn-bg)}}.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-light:disabled,.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-light.disabled{--btn-bg: var(--btn-bg-custom, #b3b3be);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #ebebee);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-dark{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, #0cc);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #00ffb9);background:var(--btn-bg)}}.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-dark:disabled,.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, #737389);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-light{--btn-color: var(--btn-color-custom, #007993);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, rgba(255, 255, 255, .6));background:var(--btn-bg);border:1px solid #007993;border-radius:0}@media (hover: hover){.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c2ffee);background:var(--btn-bg);border:1px solid #33747a;border-radius:0;--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-light:disabled,.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-light.disabled{--btn-bg: var(--btn-bg-custom, rgba(255, 255, 255, .6));background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-dark{--btn-color: var(--btn-color-custom, #0cc);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, rgba(0, 0, 40, .4));background:var(--btn-bg);border:1px solid #0cc;border-radius:0}@media (hover: hover){.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #001f39);background:var(--btn-bg);border:1px solid #00ffb9;border-radius:0;--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-dark:disabled,.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, rgba(0, 0, 40, .4));background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-un-contained{padding:0 8px;margin-left:-8px;min-width:96px}.general-button.type-un-contained.bg-light{--btn-color: var(--btn-color-custom, #007993);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-un-contained.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-un-contained.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c2ffee);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-un-contained.bg-light:disabled,.general-button.type-un-contained.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-un-contained.bg-dark{--btn-color: var(--btn-color-custom, #0cc);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-un-contained.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-un-contained.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #001f39);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-un-contained.bg-dark:disabled,.general-button.type-un-contained.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-un-contained.position-content{--icon-size-default: 20px}.general-button.type-un-contained.open{background-color:#c2ffee;color:#33747a}.general-button.not-bold{font-size:1rem;font-weight:400;line-height:1.5rem}@keyframes fadein{0%{opacity:0}to{opacity:1}}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: i2.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "component", type: UiSpinnerComponent, selector: "sie-ui-spinner", inputs: ["size", "message", "overlayOnTop", "overlay", "active"], outputs: ["animationEnded"] }, { kind: "component", type: UiBadgeComponent, selector: "sie-ui-badge", inputs: ["mode", "type", "number", "addOutline", "highlighted", "status"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "directive", type: i1$1.AttributeDirective, selector: "[sieCoreAttributes]", inputs: ["sieCoreAttributes"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiModalButtonComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-modal-button', changeDetection: ChangeDetectionStrategy.OnPush, template: "<!-- BUTTON -->\n<ng-container *ngIf=\"isButton\">\n  <button\n    class=\"general-button\"\n    #uiButton\n    [sieCoreAttributes]=\"dataAttributes\"\n    [ngClass]=\"[\n      cssClass,\n      'type-' + themeType,\n      'variant-' + variant,\n      'bg-' + background,\n      'position-' + position,\n      prominence ? 'prominence-' + prominence : '',\n      fullWidth ? 'general-button--width' : 'general-button--max-width',\n      withSpinner ? 'with-spinner' : '',\n      showSpinner ? 'spinner-active' : '',\n      spinnerAnimating ? 'fade-appearance' : '',\n      shouldFadeOutText ? 'fade-text' : '',\n      !bold ? 'not-bold' : '',\n      increasedSize ? 'increased-size' : '',\n      hoverDisabled ? 'hover-disabled' : '',\n      disableLineBreak && !fullWidth ? 'disable-line-break-max-width' : ''\n    ]\"\n    [class.open]=\"isSecondaryIconRotated\"\n    [type]=\"this.buttonType.endsWith('submit') ? 'submit' : 'button'\"\n    (click)=\"onClick($event)\"\n    (focus)=\"onFocus($event)\"\n    [tabIndex]=\"this.focusable ? 0 : -1\"\n    (blur)=\"onBlur($event)\"\n    [disabled]=\"disabled || showSpinner ? 'disabled' : null\"\n    [ngStyle]=\"withSpinner && !fullWidth && !dimensionsSet ? { width: buttonWithSpinnerWidth + 'px' } : ''\"\n  >\n    <ng-container *ngTemplateOutlet=\"contentField\"></ng-container>\n  </button>\n</ng-container>\n\n<!-- EXTERNAL BUTTON (siemens internal and external links) --><a\n  *ngIf=\"!isButton\"\n  #uiButton\n  [sieCoreAttributes]=\"dataAttributes\"\n  [href]=\"link\"\n  [target]=\"target\"\n  class=\"general-button\"\n  rel=\"noopener\"\n  (click)=\"onClick($event)\"\n  [ngClass]=\"[\n    'type-' + themeType,\n    'variant-' + variant,\n    'bg-' + background,\n    'position-' + position,\n    prominence ? 'prominence-' + prominence : '',\n    cssClass,\n    disabled ? 'disabled' : '',\n    fullWidth ? 'general-button--width' : 'general-button--max-width',\n    withSpinner ? 'with-spinner' : '',\n    showSpinner ? 'spinner-active' : '',\n    spinnerAnimating ? 'fade-appearance' : '',\n    shouldFadeOutText ? 'fade-text' : ''\n  ]\"\n>\n  <ng-container *ngTemplateOutlet=\"contentField\"></ng-container>\n</a>\n\n<!-- CONTENT -->\n<ng-template #contentField>\n  <span class=\"general-button__body\" [ngClass]=\"{ 'has-spinner': withSpinner, 'has-secondary-icon': iconSecondary }\">\n    <sie-ui-badge\n      *ngIf=\"badge\"\n      class=\"general-button__badge\"\n      type=\"counter\"\n      [number]=\"badgeNumber\"\n      addOutline\n    ></sie-ui-badge>\n    <span class=\"general-button__label\">\n      <ng-container *ngIf=\"icon && iconPosition === 'leading'\">\n        <sie-icon [name]=\"icon\" class=\"general-button__icon\" [ngClass]=\"getIconClasses()\" aria-hidden=\"true\"></sie-icon>\n        <span *ngIf=\"iconScreenReaderText\" class=\"visually-hidden\">{{ iconScreenReaderText }}</span>\n      </ng-container>\n      <span class=\"general-button__label-content\" [ngClass]=\"{ 'disable-line-break': disableLineBreak }\"\n        ><ng-content></ng-content\n      ></span>\n      <ng-container *ngIf=\"icon && iconPosition === 'trailing'\">\n        <sie-icon [name]=\"icon\" class=\"general-button__icon\" [ngClass]=\"getIconClasses()\"></sie-icon>\n      </ng-container>\n      <ng-container *ngIf=\"iconSecondary\">\n        <sie-icon\n          [name]=\"iconSecondary\"\n          class=\"general-button__icon secondary-icon\"\n          [ngClass]=\"getIconClasses()\"\n          [class.open]=\"isSecondaryIconRotated\"\n        ></sie-icon>\n      </ng-container>\n      <ng-container *ngIf=\"showSpinner || spinnerAnimating\">\n        <div\n          class=\"general-button__spinner-wrapper\"\n          [ngClass]=\"{\n            'sp-fade-in': showSpinner,\n            'fade-out-text': shouldFadeOutText\n          }\"\n        >\n          <sie-ui-spinner\n            [size]=\"spinnerSize\"\n            [active]=\"showSpinner\"\n            (animationEnded)=\"onAnimationEnd()\"\n          ></sie-ui-spinner>\n        </div>\n      </ng-container>\n    </span>\n  </span>\n</ng-template>\n", styles: [":host .general-button{outline:none;outline-offset:0}@media (pointer: fine){:host .general-button{position:relative}:host .general-button:focus{outline:1px solid #1491eb;outline-offset:2px}:host .general-button:focus:not(:focus-visible){outline:0}:host .general-button:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}:host{display:inline-flex;position:relative;--icon-size-default: 24px;--btn-height-default: 48px;--btn-width-default: auto;outline:0}:host(.full-width){width:100%}.general-button.type-icon.variant-icon-contained .general-button__icon,.general-button.type-icon.variant-icon-un-contained .general-button__icon,.general-button.type-icon.variant-icon-menu .general-button__icon{margin:0}.increased-size.general-button.type-icon.variant-icon-contained.position-content,.increased-size.general-button.type-icon.variant-icon-contained.position-header,.increased-size.general-button.type-icon.variant-icon-un-contained,.increased-size.general-button.type-icon.variant-icon-with-label.position-content,.increased-size.general-button.type-icon.variant-icon-with-label.position-header,.increased-size.general-button{--btn-height-default: 56px;--icon-size-default: 28px;min-width:56px}.general-button{font-size:1rem;font-weight:900;line-height:1.5rem;--icon-size: var(--icon-size-custom, var(--icon-size-default));--btn-width: var(--btn-width-custom, var(--btn-width-default));--btn-height: var(--btn-height-custom, var(--btn-height-default));-webkit-user-drag:none;display:inline-flex;flex:1 1 0;align-items:center;justify-content:center;border-width:0;text-align:left;text-decoration:none;cursor:pointer;line-height:var(--icon-size);width:var(--btn-width);height:var(--btn-height)}@media print{.general-button{-webkit-print-color-adjust:exact;print-color-adjust:exact}}.general-button.disable-line-break-max-width{max-width:260px}.general-button__body{position:relative;display:flex;align-items:center;margin-right:0;transition:margin-right 1s ease-in-out}.general-button__body.has-spinner{position:static}.general-button__body.has-secondary-icon{width:100%}@media (max-width: 639.78px){.general-button__body.has-secondary-icon{width:100%}.general-button__body.has-secondary-icon .secondary-icon{position:absolute;right:0}}.general-button__body.has-secondary-icon>span{width:100%}.general-button__body.has-secondary-icon .secondary-icon{margin-left:auto}.general-button__badge{position:absolute;top:-10px;right:0;transform:translate(50%)}.general-button__icon{height:var(--icon-size);display:flex;align-items:center;fill:currentColor;align-self:flex-start;margin-top:-1px;margin-right:6px;width:var(--icon-size)}.general-button__icon svg{fill:currentColor;width:inherit;height:inherit}.general-button__icon svg g{fill:currentColor;width:inherit;height:inherit}.general-button__icon svg text{font-family:Siemens Sans,sans-serif}.general-button__label-content+.general-button__icon{margin-right:0;margin-left:6px}.general-button__icon.secondary-icon svg{transition:transform .12s cubic-bezier(.4,0,.3,1)}.general-button__icon.secondary-icon.open svg{transform:translateZ(0) rotate(180deg)}.general-button__label{display:inline-flex;max-height:40px;word-break:break-word;align-items:center;max-width:228px}.general-button__label-content{display:-webkit-box;-webkit-box-orient:vertical;-webkit-line-clamp:2;overflow:hidden;line-height:initial;text-overflow:ellipsis}.general-button__label-content:empty{display:none}.general-button__label-content.disable-line-break{display:block;white-space:nowrap}.general-button__spinner-wrapper{height:100%;position:absolute;display:flex;justify-content:flex-end;align-items:center;min-width:76px;right:16px;top:0}.general-button__spinner-wrapper.sp-fade-in{animation:fadein 1s linear}.bg-light.spinner-active .general-button__spinner-wrapper.fade-out-text{background:linear-gradient(270deg,#b3b3be 19.14%,rgba(179,179,190,0) 100%)}.bg-dark.spinner-active .general-button__spinner-wrapper.fade-out-text{background:linear-gradient(270deg,#737389 19.14%,rgba(115,115,137,0) 100%)}.bg-light.spinner-active.variant-tertiary .general-button__spinner-wrapper.fade-out-text{background:linear-gradient(270deg,#fff 19.14%,rgba(255,255,255,0) 100%)}.bg-dark.spinner-active.variant-tertiary .general-button__spinner-wrapper.fade-out-text{background:linear-gradient(270deg,#000028 19.14%,rgba(0,0,40,0) 100%)}.general-button--max-width{max-width:260px}.general-button--width{width:100%}.general-button:disabled{cursor:not-allowed}.general-button.type-main{--icon-size-default: 20px;display:flex;align-items:center;min-width:96px;min-height:48px;max-height:56px;padding:6px 16px}.general-button.type-main.fade-appearance{transition-property:border-color,background-color,color,fill;transition-duration:.25s;transition-timing-function:cubic-bezier(.2,0,.38,.9)}.general-button.type-main.fade-appearance .general-button__body{transition:margin-right .25s cubic-bezier(.2,0,.38,.9)}.general-button.type-main.variant-primary.bg-light{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, linear-gradient(90deg, #00ffb9 0%, #00e6dc 100%));background:var(--btn-bg)}@media (hover: hover){.general-button.type-main.variant-primary.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-main.variant-primary.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c5ffef);background:var(--btn-bg)}}.general-button.type-main.variant-primary.bg-light:disabled,.general-button.type-main.variant-primary.bg-light.disabled{--btn-bg: var(--btn-bg-custom, #b3b3be);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #ebebee);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-main.variant-primary.bg-dark{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, linear-gradient(90deg, #00ffb9 0%, #00e6dc 100%));background:var(--btn-bg)}@media (hover: hover){.general-button.type-main.variant-primary.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-main.variant-primary.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c5ffef);background:var(--btn-bg)}}.general-button.type-main.variant-primary.bg-dark:disabled,.general-button.type-main.variant-primary.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, #737389);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-main.variant-secondary.bg-light{--btn-color: var(--btn-color-custom, #fff);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, #007993);background:var(--btn-bg)}@media (hover: hover){.general-button.type-main.variant-secondary.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-main.variant-secondary.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #33747a);background:var(--btn-bg)}}.general-button.type-main.variant-secondary.bg-light:disabled,.general-button.type-main.variant-secondary.bg-light.disabled{--btn-bg: var(--btn-bg-custom, #b3b3be);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #ebebee);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-main.variant-secondary.bg-dark{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, #0cc);background:var(--btn-bg)}@media (hover: hover){.general-button.type-main.variant-secondary.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-main.variant-secondary.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #00ffb9);background:var(--btn-bg)}}.general-button.type-main.variant-secondary.bg-dark:disabled,.general-button.type-main.variant-secondary.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, #737389);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-main.variant-tertiary.bg-light{--btn-color: var(--btn-color-custom, #007993);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);border:1px solid #007993;border-radius:0}@media (hover: hover){.general-button.type-main.variant-tertiary.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-main.variant-tertiary.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c2ffee);background:var(--btn-bg);border:1px solid #33747a;border-radius:0;--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-main.variant-tertiary.bg-light:disabled,.general-button.type-main.variant-tertiary.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);border:1px solid #b3b3be;border-radius:0;--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-main.variant-tertiary.bg-dark{--btn-color: var(--btn-color-custom, #0cc);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, rgba(0, 0, 40, .4));background:var(--btn-bg);border:1px solid #0cc;border-radius:0}@media (hover: hover){.general-button.type-main.variant-tertiary.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-main.variant-tertiary.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #001f39);background:var(--btn-bg);border:1px solid #00ffb9;border-radius:0;--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-main.variant-tertiary.bg-dark:disabled,.general-button.type-main.variant-tertiary.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);border:1px solid #b3b3be;border-radius:0;--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-main.with-spinner{overflow:hidden}.general-button.type-main.with-spinner .general-button__label{transition:min-width 1s ease-in-out;min-width:100%}.general-button.type-main.spinner-active{max-width:260px}.general-button.type-main.spinner-active.general-button--width{max-width:100%}.general-button.type-main.spinner-active:not(.fade-text) .general-button__label{min-width:calc(100% + 40px)}.general-button.type-main.spinner-active:not(.fade-text) .general-button__body{padding:0;margin-right:40px}.general-button.type-icon{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}.general-button.type-icon .general-button__spinner-wrapper{min-width:100%;right:0;display:flex;justify-content:center}.general-button.type-icon .general-button__icon svg{opacity:1;transition:opacity .3s ease-in-out}.general-button.type-icon.spinner-active .general-button__icon{opacity:0}.general-button.type-icon.variant-icon-with-label{padding:0 8px}.general-button.type-icon.variant-icon-with-label.position-header{--btn-height-default: 44px;font-size:1.125rem;font-weight:400;line-height:1.5rem}.general-button.type-icon.variant-icon-with-label.position-header.m-black{font-size:1.125rem;font-weight:900;line-height:1.5rem}.general-button.type-icon.variant-icon-with-label.position-header.bg-light{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-with-label.position-header.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-with-label.position-header.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-with-label.position-header.bg-light:disabled,.general-button.type-icon.variant-icon-with-label.position-header.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-with-label.position-header.bg-dark{--btn-color: var(--btn-color-custom, #fff);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-with-label.position-header.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-with-label.position-header.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-with-label.position-header.bg-dark:disabled,.general-button.type-icon.variant-icon-with-label.position-header.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-with-label.position-content{--icon-size-default: 20px;--btn-height-default: 48px}.general-button.type-icon.variant-icon-with-label.position-content.bg-light{--btn-color: var(--btn-color-custom, #007993);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-with-label.position-content.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-with-label.position-content.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c2ffee);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-with-label.position-content.bg-light:disabled,.general-button.type-icon.variant-icon-with-label.position-content.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-with-label.position-content.bg-dark{--btn-color: var(--btn-color-custom, #0cc);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-with-label.position-content.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-with-label.position-content.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #001f39);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-with-label.position-content.bg-dark:disabled,.general-button.type-icon.variant-icon-with-label.position-content.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-menu{--btn-height-default: 44px;min-width:44px;letter-spacing:-.5px}.general-button.type-icon.variant-icon-menu.bg-light{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-menu.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-menu.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-menu.bg-light:disabled,.general-button.type-icon.variant-icon-menu.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-menu.bg-dark{--btn-color: var(--btn-color-custom, #fff);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-menu.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-menu.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-menu.bg-dark:disabled,.general-button.type-icon.variant-icon-menu.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-menu .general-button__label-content{margin-left:16px;font-size:1rem;font-weight:900;line-height:1.5rem}.general-button.type-icon.variant-icon-menu .general-button__icon{margin-top:-1px}.general-button.type-icon.variant-icon-un-contained{--btn-width-default: 44px;--btn-height-default: 44px}.general-button.type-icon.variant-icon-un-contained.position-header.bg-light{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-un-contained.position-header.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-un-contained.position-header.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-un-contained.position-header.bg-light:disabled,.general-button.type-icon.variant-icon-un-contained.position-header.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-un-contained.position-header.bg-dark{--btn-color: var(--btn-color-custom, #fff);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-un-contained.position-header.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-un-contained.position-header.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-un-contained.position-header.bg-dark:disabled,.general-button.type-icon.variant-icon-un-contained.position-header.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-un-contained.position-content.bg-light{--btn-color: var(--btn-color-custom, #4c4c68);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-un-contained.position-content.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-un-contained.position-content.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-un-contained.position-content.bg-light:disabled,.general-button.type-icon.variant-icon-un-contained.position-content.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-un-contained.position-content.bg-dark{--btn-color: var(--btn-color-custom, #e5e5e9);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-un-contained.position-content.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-un-contained.position-content.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-un-contained.position-content.bg-dark:disabled,.general-button.type-icon.variant-icon-un-contained.position-content.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-un-contained.position-content.to-top-button{--btn-color: var(--btn-color-custom, #007993);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-un-contained.position-content:focus{color:var(--btn-focus-color-custom, #33747a)}.general-button.type-icon.variant-icon-contained.position-header{--btn-width-default: 40px;--btn-height-default: 40px}.general-button.type-icon.variant-icon-contained.position-header.bg-light{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, linear-gradient(90deg, #00ffb9 0%, #00e6dc 100%));background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-contained.position-header.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-contained.position-header.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #00646e);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #fff);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-contained.position-header.bg-light:disabled,.general-button.type-icon.variant-icon-contained.position-header.bg-light.disabled{--btn-bg: var(--btn-bg-custom, #b3b3be);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #ebebee);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-contained.position-header.bg-dark{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, linear-gradient(90deg, #00ffb9 0%, #00e6dc 100%));background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-contained.position-header.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-contained.position-header.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c5ffef);background:var(--btn-bg)}}.general-button.type-icon.variant-icon-contained.position-header.bg-dark:disabled,.general-button.type-icon.variant-icon-contained.position-header.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, #737389);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-contained.position-content{--btn-width-default: 48px;--btn-height-default: 48px}.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-light{--btn-color: var(--btn-color-custom, #fff);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, #007993);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #33747a);background:var(--btn-bg)}}.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-light:disabled,.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-light.disabled{--btn-bg: var(--btn-bg-custom, #b3b3be);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #ebebee);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-dark{--btn-color: var(--btn-color-custom, #000028);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, #0cc);background:var(--btn-bg)}@media (hover: hover){.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #00ffb9);background:var(--btn-bg)}}.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-dark:disabled,.general-button.type-icon.variant-icon-contained.position-content.prominence-secondary.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, #737389);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-light{--btn-color: var(--btn-color-custom, #007993);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, rgba(255, 255, 255, .6));background:var(--btn-bg);border:1px solid #007993;border-radius:0}@media (hover: hover){.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c2ffee);background:var(--btn-bg);border:1px solid #33747a;border-radius:0;--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-light:disabled,.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-light.disabled{--btn-bg: var(--btn-bg-custom, rgba(255, 255, 255, .6));background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-dark{--btn-color: var(--btn-color-custom, #0cc);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, rgba(0, 0, 40, .4));background:var(--btn-bg);border:1px solid #0cc;border-radius:0}@media (hover: hover){.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #001f39);background:var(--btn-bg);border:1px solid #00ffb9;border-radius:0;--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-dark:disabled,.general-button.type-icon.variant-icon-contained.position-content.prominence-tertiary.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, rgba(0, 0, 40, .4));background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-un-contained{padding:0 8px;margin-left:-8px;min-width:96px}.general-button.type-un-contained.bg-light{--btn-color: var(--btn-color-custom, #007993);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-un-contained.bg-light:active:not(:disabled):not(.hover-disabled),.general-button.type-un-contained.bg-light:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #c2ffee);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #33747a);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-un-contained.bg-light:disabled,.general-button.type-un-contained.bg-light.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-un-contained.bg-dark{--btn-color: var(--btn-color-custom, #0cc);color:var(--btn-color);fill:var(--btn-color);--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg)}@media (hover: hover){.general-button.type-un-contained.bg-dark:active:not(:disabled):not(.hover-disabled),.general-button.type-un-contained.bg-dark:hover:not(:disabled):not(.hover-disabled){--btn-bg: var(--btn-bg-custom, #001f39);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #00ffb9);color:var(--btn-color);fill:var(--btn-color)}}.general-button.type-un-contained.bg-dark:disabled,.general-button.type-un-contained.bg-dark.disabled{--btn-bg: var(--btn-bg-custom, transparent);background:var(--btn-bg);--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color)}.general-button.type-un-contained.position-content{--icon-size-default: 20px}.general-button.type-un-contained.open{background-color:#c2ffee;color:#33747a}.general-button.not-bold{font-size:1rem;font-weight:400;line-height:1.5rem}@keyframes fadein{0%{opacity:0}to{opacity:1}}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i1.SieIconRegistryService }, { type: UiGlobalModalHandlingEventService }]; }, propDecorators: { modalInformation: [{
                type: Input
            }] } });

class UiModalButtonModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiModalButtonModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiModalButtonModule, declarations: [UiModalButtonComponent], imports: [CommonModule, UiSpinnerModule, UiBadgeModule, SieIconsModule, AttributeModule], exports: [UiModalButtonComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiModalButtonModule, imports: [CommonModule, UiSpinnerModule, UiBadgeModule, SieIconsModule, AttributeModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiModalButtonModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiModalButtonComponent],
                    imports: [CommonModule, UiSpinnerModule, UiBadgeModule, SieIconsModule, AttributeModule],
                    exports: [UiModalButtonComponent]
                }]
        }] });

class UiListNavigatorHeaderComponent {
    constructor(cdr, layoutService, iconReg) {
        this.cdr = cdr;
        this.layoutService = layoutService;
        this.iconReg = iconReg;
        this.totalResultsCount = null;
        this.activePage = 1;
        this.showFilterSlot = false;
        this.showFilterButton = false;
        this.showOptions = false;
        this.showExtendAll = false;
        this.showBulkSelect = false;
        this.showOptionsHint = false;
        this.showGeneralHint = false;
        this.filterButtonClicked = new Subject();
        this.spellCheckLinkClicked = new Subject();
        this.selectAllClicked = new Subject();
        this.selectedSortOption = new EventEmitter();
        iconReg.register(SieIcon.Filter);
        iconReg.register(SieIcon.ArrowRight);
    }
    ngOnInit() {
        this.layoutService.breakPointChangedEvent.subscribe(() => {
            this.cdr.detectChanges();
        });
    }
    onButtonClick() {
        this.filterButtonClicked.next();
    }
    onSortChanged(event) {
        this.selectedSortOption.next(event);
    }
    onSpellCheckHintClicked(event) {
        event.preventDefault();
        this.spellCheckLinkClicked.next();
    }
    onChangeSelectAll(state) {
        this.selectAllClicked.next(state);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiListNavigatorHeaderComponent, deps: [{ token: i0.ChangeDetectorRef }, { token: i1$1.LayoutService }, { token: i1.SieIconRegistryService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiListNavigatorHeaderComponent, selector: "sie-ui-list-navigator-header", inputs: { totalResultsCount: "totalResultsCount", totalResultsCountText: "totalResultsCountText", noResultsText: "noResultsText", loadingResultsText: "loadingResultsText", activePage: "activePage", filterButtonName: "filterButtonName", sortByLabel: "sortByLabel", sortByOptions: "sortByOptions", sortBySelectedOptionId: "sortBySelectedOptionId", showFilterSlot: "showFilterSlot", showFilterButton: "showFilterButton", showOptions: "showOptions", showExtendAll: "showExtendAll", showBulkSelect: "showBulkSelect", showOptionsHint: "showOptionsHint", showGeneralHint: "showGeneralHint", generalHint: "generalHint", loading: "loading", spellingCorrectionFirstLabel: "spellingCorrectionFirstLabel", spellingCorrectionSecondLabel: "spellingCorrectionSecondLabel", spellingCorrectionSearchTerm: "spellingCorrectionSearchTerm", selectAllParameters: "selectAllParameters" }, outputs: { filterButtonClicked: "filterButtonClicked", spellCheckLinkClicked: "spellCheckLinkClicked", selectAllClicked: "selectAllClicked", selectedSortOption: "selectedSortOption" }, ngImport: i0, template: "<header class=\"list-header\">\n  <ng-template [ngTemplateOutlet]=\"headerTags\"></ng-template>\n\n  <ng-container *ngIf=\"layoutService.currentViewportObj$ | async | viewport : 'lte' : 'M'\">\n    <div class=\"list-header__filter-options\">\n      <sie-ui-link\n        *ngIf=\"showFilterButton\"\n        type=\"button\"\n        variant=\"icon-link\"\n        class=\"filter-button\"\n        [icon]=\"iconReg.sieIcon.Filter\"\n        (clicked)=\"onButtonClick()\"\n        >{{ filterButtonName }}</sie-ui-link\n      >\n\n      <ng-container *ngTemplateOutlet=\"listHeaderToolsGroup\"></ng-container>\n    </div>\n  </ng-container>\n\n  <p\n    class=\"list-header__title\"\n    *ngIf=\"totalResultsCount !== null; else loadingCountText\"\n    [ngClass]=\"showGeneralHint ? 'with-hint' : ''\"\n  >\n    <ng-container *ngIf=\"totalResultsCount === 0 && noResultsText; else resultsCount\">{{ noResultsText }}</ng-container>\n    <ng-template #resultsCount>\n      <span *ngIf=\"!loading\">{{ totalResultsCount | localNumber }}</span> {{ totalResultsCountText }}\n    </ng-template>\n  </p>\n  <ng-template #loadingCountText>\n    <p class=\"list-header__title\" *ngIf=\"loading && loadingResultsText\">\n      {{ loadingResultsText }}\n    </p>\n  </ng-template>\n\n  <div *ngIf=\"!loading && (spellingCorrectionSearchTerm || showGeneralHint)\" class=\"list-header__hint\">\n    <div class=\"list-header__hint-spelling-correction\" *ngIf=\"spellingCorrectionSearchTerm\">\n      <span class=\"list-header__hint-spelling-correction__label\">{{ spellingCorrectionFirstLabel }}</span>\n      <sie-ui-link\n        variant=\"icon-link\"\n        size=\"sm\"\n        [icon]=\"iconReg.sieIcon.ArrowRight\"\n        (clicked)=\"onSpellCheckHintClicked($event)\"\n        cssClass=\"no-padding\"\n      >\n        {{ spellingCorrectionSearchTerm }}\n      </sie-ui-link>\n      <span class=\"list-header__hint-spelling-correction__question-mark\">{{ spellingCorrectionSecondLabel }}</span>\n    </div>\n    <p *ngIf=\"showGeneralHint\" class=\"list-header__hint-general\">{{ generalHint }}</p>\n  </div>\n\n  <div class=\"list-header__tools list-header__tools--multi\">\n    <div *ngIf=\"showOptionsHint\" class=\"list-header__hint list-header__hint-with-availability\">\n      <div class=\"list-header__hint-options\">\n        <ng-content select=\"[ShowOptionsHint]\"></ng-content>\n      </div>\n    </div>\n    <ng-content select=\"[ExclusiveContentContainer]\"></ng-content>\n  </div>\n\n  <div\n    class=\"list-header__tools\"\n    [ngClass]=\"{ 'list-header__tools--multi': showBulkSelect || showExtendAll || showOptions }\"\n  >\n    <div *ngIf=\"showBulkSelect && !loading && !!totalResultsCount\" class=\"list-header__bulk-select\">\n      <sie-ui-checkbox\n        [value]=\"selectAllParameters.value\"\n        [label]=\"selectAllParameters.label\"\n        [indeterminate]=\"selectAllParameters.indeterminate\"\n        (valueChange)=\"onChangeSelectAll($event)\"\n        [id]=\"'selectAll'\"\n        [name]=\"'listCheckbox'\"\n      ></sie-ui-checkbox>\n    </div>\n\n    <ng-container *ngIf=\"!layoutService.isViewport('S', 'M')\">\n      <ng-container *ngTemplateOutlet=\"listHeaderToolsGroup\"></ng-container>\n    </ng-container>\n\n    <div *ngIf=\"sortByOptions?.length > 0 && totalResultsCount > 0\" class=\"list-header__sort\">\n      <span class=\"list-header__sort-label\">{{ sortByLabel }}</span>\n      <sie-ui-dropdown\n        [label]=\"sortByLabel\"\n        [options]=\"sortByOptions\"\n        [selectedValue]=\"sortBySelectedOptionId\"\n        (selectionChanged)=\"onSortChanged($event)\"\n      ></sie-ui-dropdown>\n    </div>\n  </div>\n</header>\n\n<ng-template #headerTags>\n  <div class=\"list-header__filter-tags\" *ngIf=\"showFilterSlot\">\n    <ng-content select=\"[SearchFilterHeader]\"></ng-content>\n  </div>\n</ng-template>\n\n<ng-template #listHeaderToolsGroup>\n  <div *ngIf=\"showOptions || showExtendAll\" class=\"list-header__tools-group\">\n    <div *ngIf=\"showOptions\" class=\"list-header__tools-group__el\">\n      <ng-content select=\"[ShowOptionsButton]\"></ng-content>\n    </div>\n    <div *ngIf=\"showExtendAll\" class=\"list-header__tools-group__el\"></div>\n  </div>\n</ng-template>\n", styles: [".list-header{display:flex;flex-wrap:wrap;align-items:flex-start;width:100%;padding:8px 0}@media (max-width: 1023.78px){.list-header{align-items:center}}.list-header__title{margin-bottom:24px;font-size:1rem;font-weight:700;line-height:1.5rem}@media (max-width: 1023.78px){.list-header__title{flex:1 0 100%;margin-bottom:16px}}.list-header__title.with-hint{margin-bottom:8px}.list-header__filter-tags{flex:1 0 100%;margin-bottom:16px}.list-header__hint{font-size:.875rem;font-weight:400;line-height:1.25rem;flex:1 0 100%;margin-bottom:24px;width:100%}.list-header__hint-general{color:#9999a9}.list-header__hint-options{width:100%;color:#4c4c68}.list-header__hint-spelling-correction{display:flex;align-items:center}.list-header__hint-spelling-correction__label{font-size:.875rem;font-weight:700;line-height:1.25rem;padding-bottom:1px}.list-header__hint-spelling-correction__question-mark{padding-bottom:1px}.list-header__hint-spelling-correction sie-ui-link{width:auto;margin:0 2px}.list-header__hint-with-availability{flex:1 0}.list-header__sort{margin-left:24px;margin-bottom:4px}.list-header__sort:only-child{margin-left:auto}.list-header__sort-label{margin-right:8px}.list-header__bulk-select{margin-right:auto;margin-bottom:8px;padding-left:16px}.list-header__tools{display:flex;margin-left:auto;gap:24px;overflow-wrap:anywhere;flex-wrap:wrap}.list-header__tools--multi{flex:1 0 100%}@media print{.list-header__tools{display:none}}@media (max-width: 1023.78px){.list-header__tools{gap:0;column-gap:64px}.list-header__tools .list-header__sort{margin-left:auto}}.list-header__tools-group{display:flex;margin-left:auto;overflow:hidden}.list-header__tools-group__el{margin-left:16px;overflow:hidden}@media (max-width: 1023.78px){.list-header__tools-group__el{padding:8px 0 3px 8px}}@media (min-width: 1024px){.list-header__tools-group__el{margin:2px 0 4px}}.list-header__filter-options{flex:1 0 100%;display:flex;justify-content:space-between;margin-bottom:8px;overflow:hidden}.list-header .filter-button{display:flex;flex:0 1;padding:8px 8px 3px 0}.list-header .filter-button+.list-header__tools>.list-header__sort{margin-top:10px}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "component", type: UiLinkComponent, selector: "sie-ui-link", inputs: ["disabled", "disableVisitedStyle", "hasMarginTop", "offsetIcon", "truncate", "inLinkList", "trailingIcon", "icon", "cssClass", "href", "size", "target", "variant", "background", "type", "reference", "screenReaderText", "secondaryLabel", "download", "dataAttributes", "tooltip", "buttonType"], outputs: ["clicked"] }, { kind: "component", type: UiDropdownComponent, selector: "sie-ui-dropdown", inputs: ["type", "condensed", "options", "selectedValue", "required", "id", "name", "label", "placeholder", "errorMessage", "customClass", "readonly", "invalid", "hint", "marginBottomOnInvalidState"], outputs: ["selectionChanged"] }, { kind: "component", type: UiCheckboxComponent, selector: "sie-ui-checkbox", inputs: ["id", "checkboxIdToFocus", "indeterminate", "value", "active", "required", "icons", "labelAppendix$"], outputs: ["valueChange"] }, { kind: "pipe", type: i2.AsyncPipe, name: "async" }, { kind: "pipe", type: i1$1.LocalNumberPipe, name: "localNumber" }, { kind: "pipe", type: i1$1.ViewportPipe, name: "viewport" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiListNavigatorHeaderComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-list-navigator-header', changeDetection: ChangeDetectionStrategy.OnPush, template: "<header class=\"list-header\">\n  <ng-template [ngTemplateOutlet]=\"headerTags\"></ng-template>\n\n  <ng-container *ngIf=\"layoutService.currentViewportObj$ | async | viewport : 'lte' : 'M'\">\n    <div class=\"list-header__filter-options\">\n      <sie-ui-link\n        *ngIf=\"showFilterButton\"\n        type=\"button\"\n        variant=\"icon-link\"\n        class=\"filter-button\"\n        [icon]=\"iconReg.sieIcon.Filter\"\n        (clicked)=\"onButtonClick()\"\n        >{{ filterButtonName }}</sie-ui-link\n      >\n\n      <ng-container *ngTemplateOutlet=\"listHeaderToolsGroup\"></ng-container>\n    </div>\n  </ng-container>\n\n  <p\n    class=\"list-header__title\"\n    *ngIf=\"totalResultsCount !== null; else loadingCountText\"\n    [ngClass]=\"showGeneralHint ? 'with-hint' : ''\"\n  >\n    <ng-container *ngIf=\"totalResultsCount === 0 && noResultsText; else resultsCount\">{{ noResultsText }}</ng-container>\n    <ng-template #resultsCount>\n      <span *ngIf=\"!loading\">{{ totalResultsCount | localNumber }}</span> {{ totalResultsCountText }}\n    </ng-template>\n  </p>\n  <ng-template #loadingCountText>\n    <p class=\"list-header__title\" *ngIf=\"loading && loadingResultsText\">\n      {{ loadingResultsText }}\n    </p>\n  </ng-template>\n\n  <div *ngIf=\"!loading && (spellingCorrectionSearchTerm || showGeneralHint)\" class=\"list-header__hint\">\n    <div class=\"list-header__hint-spelling-correction\" *ngIf=\"spellingCorrectionSearchTerm\">\n      <span class=\"list-header__hint-spelling-correction__label\">{{ spellingCorrectionFirstLabel }}</span>\n      <sie-ui-link\n        variant=\"icon-link\"\n        size=\"sm\"\n        [icon]=\"iconReg.sieIcon.ArrowRight\"\n        (clicked)=\"onSpellCheckHintClicked($event)\"\n        cssClass=\"no-padding\"\n      >\n        {{ spellingCorrectionSearchTerm }}\n      </sie-ui-link>\n      <span class=\"list-header__hint-spelling-correction__question-mark\">{{ spellingCorrectionSecondLabel }}</span>\n    </div>\n    <p *ngIf=\"showGeneralHint\" class=\"list-header__hint-general\">{{ generalHint }}</p>\n  </div>\n\n  <div class=\"list-header__tools list-header__tools--multi\">\n    <div *ngIf=\"showOptionsHint\" class=\"list-header__hint list-header__hint-with-availability\">\n      <div class=\"list-header__hint-options\">\n        <ng-content select=\"[ShowOptionsHint]\"></ng-content>\n      </div>\n    </div>\n    <ng-content select=\"[ExclusiveContentContainer]\"></ng-content>\n  </div>\n\n  <div\n    class=\"list-header__tools\"\n    [ngClass]=\"{ 'list-header__tools--multi': showBulkSelect || showExtendAll || showOptions }\"\n  >\n    <div *ngIf=\"showBulkSelect && !loading && !!totalResultsCount\" class=\"list-header__bulk-select\">\n      <sie-ui-checkbox\n        [value]=\"selectAllParameters.value\"\n        [label]=\"selectAllParameters.label\"\n        [indeterminate]=\"selectAllParameters.indeterminate\"\n        (valueChange)=\"onChangeSelectAll($event)\"\n        [id]=\"'selectAll'\"\n        [name]=\"'listCheckbox'\"\n      ></sie-ui-checkbox>\n    </div>\n\n    <ng-container *ngIf=\"!layoutService.isViewport('S', 'M')\">\n      <ng-container *ngTemplateOutlet=\"listHeaderToolsGroup\"></ng-container>\n    </ng-container>\n\n    <div *ngIf=\"sortByOptions?.length > 0 && totalResultsCount > 0\" class=\"list-header__sort\">\n      <span class=\"list-header__sort-label\">{{ sortByLabel }}</span>\n      <sie-ui-dropdown\n        [label]=\"sortByLabel\"\n        [options]=\"sortByOptions\"\n        [selectedValue]=\"sortBySelectedOptionId\"\n        (selectionChanged)=\"onSortChanged($event)\"\n      ></sie-ui-dropdown>\n    </div>\n  </div>\n</header>\n\n<ng-template #headerTags>\n  <div class=\"list-header__filter-tags\" *ngIf=\"showFilterSlot\">\n    <ng-content select=\"[SearchFilterHeader]\"></ng-content>\n  </div>\n</ng-template>\n\n<ng-template #listHeaderToolsGroup>\n  <div *ngIf=\"showOptions || showExtendAll\" class=\"list-header__tools-group\">\n    <div *ngIf=\"showOptions\" class=\"list-header__tools-group__el\">\n      <ng-content select=\"[ShowOptionsButton]\"></ng-content>\n    </div>\n    <div *ngIf=\"showExtendAll\" class=\"list-header__tools-group__el\"></div>\n  </div>\n</ng-template>\n", styles: [".list-header{display:flex;flex-wrap:wrap;align-items:flex-start;width:100%;padding:8px 0}@media (max-width: 1023.78px){.list-header{align-items:center}}.list-header__title{margin-bottom:24px;font-size:1rem;font-weight:700;line-height:1.5rem}@media (max-width: 1023.78px){.list-header__title{flex:1 0 100%;margin-bottom:16px}}.list-header__title.with-hint{margin-bottom:8px}.list-header__filter-tags{flex:1 0 100%;margin-bottom:16px}.list-header__hint{font-size:.875rem;font-weight:400;line-height:1.25rem;flex:1 0 100%;margin-bottom:24px;width:100%}.list-header__hint-general{color:#9999a9}.list-header__hint-options{width:100%;color:#4c4c68}.list-header__hint-spelling-correction{display:flex;align-items:center}.list-header__hint-spelling-correction__label{font-size:.875rem;font-weight:700;line-height:1.25rem;padding-bottom:1px}.list-header__hint-spelling-correction__question-mark{padding-bottom:1px}.list-header__hint-spelling-correction sie-ui-link{width:auto;margin:0 2px}.list-header__hint-with-availability{flex:1 0}.list-header__sort{margin-left:24px;margin-bottom:4px}.list-header__sort:only-child{margin-left:auto}.list-header__sort-label{margin-right:8px}.list-header__bulk-select{margin-right:auto;margin-bottom:8px;padding-left:16px}.list-header__tools{display:flex;margin-left:auto;gap:24px;overflow-wrap:anywhere;flex-wrap:wrap}.list-header__tools--multi{flex:1 0 100%}@media print{.list-header__tools{display:none}}@media (max-width: 1023.78px){.list-header__tools{gap:0;column-gap:64px}.list-header__tools .list-header__sort{margin-left:auto}}.list-header__tools-group{display:flex;margin-left:auto;overflow:hidden}.list-header__tools-group__el{margin-left:16px;overflow:hidden}@media (max-width: 1023.78px){.list-header__tools-group__el{padding:8px 0 3px 8px}}@media (min-width: 1024px){.list-header__tools-group__el{margin:2px 0 4px}}.list-header__filter-options{flex:1 0 100%;display:flex;justify-content:space-between;margin-bottom:8px;overflow:hidden}.list-header .filter-button{display:flex;flex:0 1;padding:8px 8px 3px 0}.list-header .filter-button+.list-header__tools>.list-header__sort{margin-top:10px}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i1$1.LayoutService }, { type: i1.SieIconRegistryService }]; }, propDecorators: { totalResultsCount: [{
                type: Input
            }], totalResultsCountText: [{
                type: Input
            }], noResultsText: [{
                type: Input
            }], loadingResultsText: [{
                type: Input
            }], activePage: [{
                type: Input
            }], filterButtonName: [{
                type: Input
            }], sortByLabel: [{
                type: Input
            }], sortByOptions: [{
                type: Input
            }], sortBySelectedOptionId: [{
                type: Input
            }], showFilterSlot: [{
                type: Input
            }], showFilterButton: [{
                type: Input
            }], showOptions: [{
                type: Input
            }], showExtendAll: [{
                type: Input
            }], showBulkSelect: [{
                type: Input
            }], showOptionsHint: [{
                type: Input
            }], showGeneralHint: [{
                type: Input
            }], generalHint: [{
                type: Input
            }], loading: [{
                type: Input
            }], spellingCorrectionFirstLabel: [{
                type: Input
            }], spellingCorrectionSecondLabel: [{
                type: Input
            }], spellingCorrectionSearchTerm: [{
                type: Input
            }], selectAllParameters: [{
                type: Input
            }], filterButtonClicked: [{
                type: Output
            }], spellCheckLinkClicked: [{
                type: Output
            }], selectAllClicked: [{
                type: Output
            }], selectedSortOption: [{
                type: Output
            }] } });

class UiListNavigatorHeaderModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiListNavigatorHeaderModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiListNavigatorHeaderModule, declarations: [UiListNavigatorHeaderComponent], imports: [CommonModule,
            UiButtonModule,
            UiLinkModule,
            SieCorePipesModule,
            UiDropdownModule,
            UiCheckboxModule,
            SieIconsModule], exports: [UiListNavigatorHeaderComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiListNavigatorHeaderModule, imports: [CommonModule,
            UiButtonModule,
            UiLinkModule,
            SieCorePipesModule,
            UiDropdownModule,
            UiCheckboxModule,
            SieIconsModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiListNavigatorHeaderModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiListNavigatorHeaderComponent],
                    imports: [
                        CommonModule,
                        UiButtonModule,
                        UiLinkModule,
                        SieCorePipesModule,
                        UiDropdownModule,
                        UiCheckboxModule,
                        SieIconsModule
                    ],
                    exports: [UiListNavigatorHeaderComponent]
                }]
        }] });

/**
 * # Password Input Component
 *
 * Text input allows users to prompt passwords
 *
 * ## Component variations
 * - Standard variation
 *
 * ## Content
 *
 * The Password input component does not accept any content.
 *
 * ## Code example
 * @example ```html
 * <sie-ui-password-input
 *   label="New password"
 *   [hint]="{ content: 'Please at least a character, a digit and minimum one special characters for your password!' }"
 *   validationPattern="^(?=.*[a-z])(?=.*[A-Z])(?=.*\d)[A-Za-z\d@$!%*?&]{8,}$"
 *   placeholder="New password (placeholder)"
 * ></sie-ui-password-input>
 * ```
 */
class UiPasswordInputComponent extends InputBaseDirective {
    constructor(iconReg, cdr) {
        super(cdr);
        this.iconReg = iconReg;
        this.cdr = cdr;
        /** @ignore */
        this.iconName = this.iconReg.sieIcon.SieportalShowPassword;
        iconReg.register(SieIcon.SieportalShowPassword);
        iconReg.register(SieIcon.SieportalHidePassword);
    }
    /** @ignore */
    toggleInputType(e, element) {
        e.preventDefault();
        if (element.type === 'password') {
            this.iconName = this.iconReg.sieIcon.SieportalHidePassword;
            element.setAttribute('type', 'text');
        }
        else {
            this.iconName = this.iconReg.sieIcon.SieportalShowPassword;
            element.setAttribute('type', 'password');
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiPasswordInputComponent, deps: [{ token: i1.SieIconRegistryService }, { token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiPasswordInputComponent, selector: "sie-ui-password-input", providers: [
            {
                provide: NG_VALUE_ACCESSOR,
                multi: true,
                useExisting: UiPasswordInputComponent
            },
            {
                provide: NG_VALIDATORS,
                multi: true,
                useExisting: UiPasswordInputComponent
            }
        ], usesInheritance: true, ngImport: i0, template: "<sie-ui-base-input\n  [id]=\"id\"\n  [label]=\"label\"\n  [value]=\"value\"\n  [labelTransformed]=\"labelTransformed\"\n  [inputFocused]=\"inputFocused\"\n  [invalid]=\"invalid\"\n  [disabled]=\"disabled\"\n  [required]=\"required && !disabled\"\n  [error]=\"error\"\n  [errorMessage]=\"errorMessage\"\n  [requiredErrorMessage]=\"requiredErrorMessage\"\n  [allowedLengthErrorMessage]=\"allowedLengthErrorMessage\"\n  [allowedCharacterLength]=\"allowedCharacterLength\"\n  [patternValidationErrorMessage]=\"patternValidationErrorMessage\"\n  [validationPattern]=\"validationPattern\"\n  [hint]=\"hint\"\n>\n  <input\n    [id]=\"id\"\n    class=\"password-input__input-field\"\n    [ngClass]=\"{\n      'is-focused': inputFocused,\n      'is-invalid': invalid || error,\n      'is-disabled': disabled\n    }\"\n    type=\"password\"\n    [disabled]=\"disabled\"\n    (focus)=\"onFocus($event)\"\n    (blur)=\"onBlur($event)\"\n    [(ngModel)]=\"value\"\n    (ngModelChange)=\"onValueChange($event)\"\n    #passwordInput\n    #validate=\"ngModel\"\n  />\n  <div\n    class=\"password-input__icon-wrapper\"\n    [ngClass]=\"{\n      'label-transformed': labelTransformed\n    }\"\n    tabindex=\"0\"\n    role=\"button\"\n    (click)=\"toggleInputType($event, passwordInput)\"\n    (keydown.space)=\"toggleInputType($event, passwordInput)\"\n  >\n    <sie-icon class=\"password-input__icon\" aria-hidden=\"true\" [name]=\"iconName\"></sie-icon>\n  </div>\n</sie-ui-base-input>\n", styles: [".password-input__icon-wrapper:focus,.password-input__icon-wrapper:focus-visible{outline:0}.password-input__icon-wrapper{outline:none;outline-offset:0}@media (pointer: fine){.password-input__icon-wrapper{position:relative}.password-input__icon-wrapper:focus{outline:1px solid #1491eb;outline-offset:2px}.password-input__icon-wrapper:focus:not(:focus-visible){outline:0}.password-input__icon-wrapper:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}input[type=password]{letter-spacing:.125rem}input[type=password]::placeholder{letter-spacing:initial}input.password-input__input-field{z-index:0}.password-input__icon-wrapper{position:absolute;padding:2px;top:14px;right:6px}.password-input__icon-wrapper.label-transformed{top:18px}.password-input__icon{width:24px;height:24px;display:flex;align-items:center;fill:currentColor;color:#4c4c68;cursor:pointer}.password-input__icon svg{fill:currentColor;width:inherit;height:inherit}.password-input__icon svg g{fill:currentColor;width:inherit;height:inherit}.password-input__icon svg text{font-family:Siemens Sans,sans-serif}.password-input__input-field.is-disabled+.password-input__icon-wrapper .password-input__icon{cursor:not-allowed;color:#b3b3be}.password-input__input-field:hover:not(.is-invalid):not(.is-disabled)+.password-input__icon-wrapper .password-input__icon,.password-input__input-field.is-focused:not(.is-invalid):not(.is-disabled)+.password-input__icon-wrapper .password-input__icon{color:#000028}\n", ".password-input__input-field:focus,.text-input__input-field:focus,.textarea__input-field:focus,.password-input__input-field:focus-visible,.text-input__input-field:focus-visible,.textarea__input-field:focus-visible{outline:0}.password-input__input-field,.text-input__input-field{outline:none;outline-offset:0}@media (pointer: fine){.password-input__input-field,.text-input__input-field{position:relative}.password-input__input-field:focus,.text-input__input-field:focus{outline:1px solid #1491eb;outline-offset:2px}.password-input__input-field:focus:not(:focus-visible),.text-input__input-field:focus:not(:focus-visible){outline:0}.password-input__input-field:focus-visible,.text-input__input-field:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}:host{display:block}.text-input__input-field.is-condensed{padding:8px 55px 8px 16px}.text-input__input-field.is-condensed::placeholder,.text-input__input-field.is-inline-search::placeholder{color:#4c4c68}.text-input__input-field.is-inline-search{padding:.125rem 3rem 0 1rem}.text-input__input-field.is-inline-search.has-icon{padding:.125rem 3rem 0 2.5rem}.text-input__input-field.is-inline-search:placeholder-shown{text-overflow:ellipsis}.text-input__input-field.is-combobox{padding-right:65px}.password-input__input-field,.text-input__input-field,.textarea__input-field{font-size:1rem;font-weight:400;line-height:1.5rem;font-family:Siemens Sans,sans-serif;display:flex;width:100%;height:100%;border:0;background-color:transparent;color:#000028;padding:22px 55px 10px 16px}.password-input__input-field.is-disabled,.password-input__input-field.is-disabled::placeholder,.text-input__input-field.is-disabled,.text-input__input-field.is-disabled::placeholder,.textarea__input-field.is-disabled,.textarea__input-field.is-disabled::placeholder{color:#b3b3be;-webkit-text-fill-color:#b3b3be;opacity:1;cursor:not-allowed}.password-input__input-field.is-focused:not(.is-invalid):not(.is-disabled)::placeholder,.text-input__input-field.is-focused:not(.is-invalid):not(.is-disabled)::placeholder,.textarea__input-field.is-focused:not(.is-invalid):not(.is-disabled)::placeholder{color:#9999a9}.reset-button{position:absolute;top:18px;right:8px}.reset-button.is-combobox{right:35px}.reset-button.condensed{top:12px}.reset-button.condensed.search{top:10px}.textarea__input-field{padding:0}.placeholder-icon{width:20px;height:20px;display:flex;align-items:center;fill:currentColor;color:#4c4c68;fill:#4c4c68;position:absolute;left:.75rem;top:50%;transform:translateY(-50%)}.placeholder-icon svg{fill:currentColor;width:inherit;height:inherit}.placeholder-icon svg g{fill:currentColor;width:inherit;height:inherit}.placeholder-icon svg text{font-family:Siemens Sans,sans-serif}.placeholder-icon:hover,.placeholder-icon.is-focused{color:#000028;fill:#000028}.placeholder-icon.is-disabled{color:#b3b3be;fill:#b3b3be}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i3.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i3.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i3.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "component", type: UiBaseInputComponent, selector: "sie-ui-base-input", inputs: ["labelTransformed", "validationPattern"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiPasswordInputComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-password-input', changeDetection: ChangeDetectionStrategy.OnPush, providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            multi: true,
                            useExisting: UiPasswordInputComponent
                        },
                        {
                            provide: NG_VALIDATORS,
                            multi: true,
                            useExisting: UiPasswordInputComponent
                        }
                    ], template: "<sie-ui-base-input\n  [id]=\"id\"\n  [label]=\"label\"\n  [value]=\"value\"\n  [labelTransformed]=\"labelTransformed\"\n  [inputFocused]=\"inputFocused\"\n  [invalid]=\"invalid\"\n  [disabled]=\"disabled\"\n  [required]=\"required && !disabled\"\n  [error]=\"error\"\n  [errorMessage]=\"errorMessage\"\n  [requiredErrorMessage]=\"requiredErrorMessage\"\n  [allowedLengthErrorMessage]=\"allowedLengthErrorMessage\"\n  [allowedCharacterLength]=\"allowedCharacterLength\"\n  [patternValidationErrorMessage]=\"patternValidationErrorMessage\"\n  [validationPattern]=\"validationPattern\"\n  [hint]=\"hint\"\n>\n  <input\n    [id]=\"id\"\n    class=\"password-input__input-field\"\n    [ngClass]=\"{\n      'is-focused': inputFocused,\n      'is-invalid': invalid || error,\n      'is-disabled': disabled\n    }\"\n    type=\"password\"\n    [disabled]=\"disabled\"\n    (focus)=\"onFocus($event)\"\n    (blur)=\"onBlur($event)\"\n    [(ngModel)]=\"value\"\n    (ngModelChange)=\"onValueChange($event)\"\n    #passwordInput\n    #validate=\"ngModel\"\n  />\n  <div\n    class=\"password-input__icon-wrapper\"\n    [ngClass]=\"{\n      'label-transformed': labelTransformed\n    }\"\n    tabindex=\"0\"\n    role=\"button\"\n    (click)=\"toggleInputType($event, passwordInput)\"\n    (keydown.space)=\"toggleInputType($event, passwordInput)\"\n  >\n    <sie-icon class=\"password-input__icon\" aria-hidden=\"true\" [name]=\"iconName\"></sie-icon>\n  </div>\n</sie-ui-base-input>\n", styles: [".password-input__icon-wrapper:focus,.password-input__icon-wrapper:focus-visible{outline:0}.password-input__icon-wrapper{outline:none;outline-offset:0}@media (pointer: fine){.password-input__icon-wrapper{position:relative}.password-input__icon-wrapper:focus{outline:1px solid #1491eb;outline-offset:2px}.password-input__icon-wrapper:focus:not(:focus-visible){outline:0}.password-input__icon-wrapper:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}input[type=password]{letter-spacing:.125rem}input[type=password]::placeholder{letter-spacing:initial}input.password-input__input-field{z-index:0}.password-input__icon-wrapper{position:absolute;padding:2px;top:14px;right:6px}.password-input__icon-wrapper.label-transformed{top:18px}.password-input__icon{width:24px;height:24px;display:flex;align-items:center;fill:currentColor;color:#4c4c68;cursor:pointer}.password-input__icon svg{fill:currentColor;width:inherit;height:inherit}.password-input__icon svg g{fill:currentColor;width:inherit;height:inherit}.password-input__icon svg text{font-family:Siemens Sans,sans-serif}.password-input__input-field.is-disabled+.password-input__icon-wrapper .password-input__icon{cursor:not-allowed;color:#b3b3be}.password-input__input-field:hover:not(.is-invalid):not(.is-disabled)+.password-input__icon-wrapper .password-input__icon,.password-input__input-field.is-focused:not(.is-invalid):not(.is-disabled)+.password-input__icon-wrapper .password-input__icon{color:#000028}\n", ".password-input__input-field:focus,.text-input__input-field:focus,.textarea__input-field:focus,.password-input__input-field:focus-visible,.text-input__input-field:focus-visible,.textarea__input-field:focus-visible{outline:0}.password-input__input-field,.text-input__input-field{outline:none;outline-offset:0}@media (pointer: fine){.password-input__input-field,.text-input__input-field{position:relative}.password-input__input-field:focus,.text-input__input-field:focus{outline:1px solid #1491eb;outline-offset:2px}.password-input__input-field:focus:not(:focus-visible),.text-input__input-field:focus:not(:focus-visible){outline:0}.password-input__input-field:focus-visible,.text-input__input-field:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}:host{display:block}.text-input__input-field.is-condensed{padding:8px 55px 8px 16px}.text-input__input-field.is-condensed::placeholder,.text-input__input-field.is-inline-search::placeholder{color:#4c4c68}.text-input__input-field.is-inline-search{padding:.125rem 3rem 0 1rem}.text-input__input-field.is-inline-search.has-icon{padding:.125rem 3rem 0 2.5rem}.text-input__input-field.is-inline-search:placeholder-shown{text-overflow:ellipsis}.text-input__input-field.is-combobox{padding-right:65px}.password-input__input-field,.text-input__input-field,.textarea__input-field{font-size:1rem;font-weight:400;line-height:1.5rem;font-family:Siemens Sans,sans-serif;display:flex;width:100%;height:100%;border:0;background-color:transparent;color:#000028;padding:22px 55px 10px 16px}.password-input__input-field.is-disabled,.password-input__input-field.is-disabled::placeholder,.text-input__input-field.is-disabled,.text-input__input-field.is-disabled::placeholder,.textarea__input-field.is-disabled,.textarea__input-field.is-disabled::placeholder{color:#b3b3be;-webkit-text-fill-color:#b3b3be;opacity:1;cursor:not-allowed}.password-input__input-field.is-focused:not(.is-invalid):not(.is-disabled)::placeholder,.text-input__input-field.is-focused:not(.is-invalid):not(.is-disabled)::placeholder,.textarea__input-field.is-focused:not(.is-invalid):not(.is-disabled)::placeholder{color:#9999a9}.reset-button{position:absolute;top:18px;right:8px}.reset-button.is-combobox{right:35px}.reset-button.condensed{top:12px}.reset-button.condensed.search{top:10px}.textarea__input-field{padding:0}.placeholder-icon{width:20px;height:20px;display:flex;align-items:center;fill:currentColor;color:#4c4c68;fill:#4c4c68;position:absolute;left:.75rem;top:50%;transform:translateY(-50%)}.placeholder-icon svg{fill:currentColor;width:inherit;height:inherit}.placeholder-icon svg g{fill:currentColor;width:inherit;height:inherit}.placeholder-icon svg text{font-family:Siemens Sans,sans-serif}.placeholder-icon:hover,.placeholder-icon.is-focused{color:#000028;fill:#000028}.placeholder-icon.is-disabled{color:#b3b3be;fill:#b3b3be}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }, { type: i0.ChangeDetectorRef }]; } });

/**
 * # Password Input Module
 * - {@link UiPasswordInputComponent}
 *
 * ## Module peer dependencies
 * - {@link SieIconsModule}
 * - `@angular/forms/FormsModule`: Enables data binding for Angular forms
 */
class UiPasswordInputModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiPasswordInputModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiPasswordInputModule, declarations: [UiPasswordInputComponent], imports: [CommonModule, FormsModule, SieIconsModule, UiBaseInputModule], exports: [UiPasswordInputComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiPasswordInputModule, imports: [CommonModule, FormsModule, SieIconsModule, UiBaseInputModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiPasswordInputModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiPasswordInputComponent],
                    imports: [CommonModule, FormsModule, SieIconsModule, UiBaseInputModule],
                    exports: [UiPasswordInputComponent]
                }]
        }] });

class UiInfoBoxSkeletonComponent {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiInfoBoxSkeletonComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiInfoBoxSkeletonComponent, selector: "sie-ui-info-box-skeleton", ngImport: i0, template: "<ng-container>\n  <sie-ui-skeleton class=\"info-box-skeleton__headline\"></sie-ui-skeleton>\n</ng-container>\n", styles: [".info-box-skeleton__headline{--ui-skeleton-width: 84%;height:24px;display:block;margin-bottom:24px}\n"], dependencies: [{ kind: "component", type: UiSkeletonComponent, selector: "sie-ui-skeleton", inputs: ["shape", "loadingText", "ariaLabel", "count"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiInfoBoxSkeletonComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-info-box-skeleton', changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-container>\n  <sie-ui-skeleton class=\"info-box-skeleton__headline\"></sie-ui-skeleton>\n</ng-container>\n", styles: [".info-box-skeleton__headline{--ui-skeleton-width: 84%;height:24px;display:block;margin-bottom:24px}\n"] }]
        }] });

class UiInfoBoxComponent {
    constructor() {
        this.shouldHaveSameHeight = false;
        this.loading = false;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiInfoBoxComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiInfoBoxComponent, selector: "sie-ui-info-box", inputs: { headline: "headline", shouldHaveSameHeight: "shouldHaveSameHeight", loading: "loading" }, ngImport: i0, template: "<section class=\"info-box\" [class.same-height-containers]=\"shouldHaveSameHeight\">\n  <ng-container *ngIf=\"!loading; else skeleton\">\n    <h4 class=\"info-box__headline\" *ngIf=\"headline\">{{ headline }}</h4>\n  </ng-container>\n  <ng-content></ng-content>\n</section>\n\n<ng-template #skeleton>\n  <sie-ui-info-box-skeleton></sie-ui-info-box-skeleton>\n</ng-template>\n", styles: [":host{display:block}.info-box{padding:1rem 1rem 1.5rem;border:1px solid #ccccd4;height:auto}.info-box__headline{margin-bottom:.5rem}.same-height-containers{height:100%}\n"], dependencies: [{ kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: UiInfoBoxSkeletonComponent, selector: "sie-ui-info-box-skeleton" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiInfoBoxComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-info-box', changeDetection: ChangeDetectionStrategy.OnPush, template: "<section class=\"info-box\" [class.same-height-containers]=\"shouldHaveSameHeight\">\n  <ng-container *ngIf=\"!loading; else skeleton\">\n    <h4 class=\"info-box__headline\" *ngIf=\"headline\">{{ headline }}</h4>\n  </ng-container>\n  <ng-content></ng-content>\n</section>\n\n<ng-template #skeleton>\n  <sie-ui-info-box-skeleton></sie-ui-info-box-skeleton>\n</ng-template>\n", styles: [":host{display:block}.info-box{padding:1rem 1rem 1.5rem;border:1px solid #ccccd4;height:auto}.info-box__headline{margin-bottom:.5rem}.same-height-containers{height:100%}\n"] }]
        }], propDecorators: { headline: [{
                type: Input
            }], shouldHaveSameHeight: [{
                type: Input
            }], loading: [{
                type: Input
            }] } });

class UiInfoBoxModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiInfoBoxModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiInfoBoxModule, declarations: [UiInfoBoxComponent, UiInfoBoxSkeletonComponent, UiInfoBoxSkeletonComponent], imports: [CommonModule, UiSkeletonModule], exports: [UiInfoBoxComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiInfoBoxModule, imports: [CommonModule, UiSkeletonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiInfoBoxModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiInfoBoxComponent, UiInfoBoxSkeletonComponent, UiInfoBoxSkeletonComponent],
                    imports: [CommonModule, UiSkeletonModule],
                    exports: [UiInfoBoxComponent]
                }]
        }] });

class UiChartLegendComponent {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiChartLegendComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiChartLegendComponent, selector: "sie-ui-chart-legend", inputs: { legendData: "legendData" }, ngImport: i0, template: "<div *ngIf=\"legendData\" class=\"chart-legend\">\n  <dl class=\"chart-legend__description-list\" role=\"list\">\n    <div *ngFor=\"let item of legendData\" class=\"chart-legend__description-list-item\">\n      <dt\n        class=\"chart-legend__description-list-item-percentage\"\n        [ngStyle]=\"{ backgroundColor: item.backgroundColor, color: item.textColor }\"\n      >\n        <span>{{ item.value }}</span>\n      </dt>\n      <dd class=\"chart-legend__description-list-item-data\">\n        <ng-container *ngIf=\"item.secondLabel; else nonConcatenatedLabel\">\n          <p class=\"chart-legend__description-list-item-text\">\n            {{ item.label }}\n            <span class=\"chart-legend__second-label\" sieUiPopover popoverSize=\"s\" [content]=\"item.secondLabelTooltip\">{{\n              item.secondLabel\n            }}</span>\n          </p></ng-container\n        >\n        <ng-template #nonConcatenatedLabel>\n          <p class=\"chart-legend__description-list-item-text\">{{ item.label }}</p>\n        </ng-template>\n      </dd>\n    </div>\n  </dl>\n</div>\n", styles: [".chart-legend__description-list{margin:-1px 0}.chart-legend__description-list-item{display:flex;justify-content:flex-start;margin:9px 0}.chart-legend__description-list-item-percentage{font-size:.75rem;font-weight:700;line-height:1rem;display:flex;justify-content:center;align-items:center;flex-shrink:0;height:20px;width:37px}.chart-legend__description-list-item-data{margin-top:0;margin-left:17px}.chart-legend__description-list-item-text{font-size:.875rem;font-weight:400;line-height:1.25rem;margin-top:1px}.chart-legend__description-list-item:not(:last-child){margin-bottom:8px}.chart-legend__second-label{border-bottom:1px dotted #002949}.chart-legend__second-label:hover{cursor:pointer}\n"], dependencies: [{ kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "directive", type: UiPopoverDirective, selector: "[sieUiPopover]", inputs: ["content", "popoverTemplate", "popoverSize", "popoverPlacement", "popoverAnimation", "popoverPlayAnimation", "popoverAnimationHideAfterTimeoutMS", "popoverLightTheme"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiChartLegendComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-chart-legend', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div *ngIf=\"legendData\" class=\"chart-legend\">\n  <dl class=\"chart-legend__description-list\" role=\"list\">\n    <div *ngFor=\"let item of legendData\" class=\"chart-legend__description-list-item\">\n      <dt\n        class=\"chart-legend__description-list-item-percentage\"\n        [ngStyle]=\"{ backgroundColor: item.backgroundColor, color: item.textColor }\"\n      >\n        <span>{{ item.value }}</span>\n      </dt>\n      <dd class=\"chart-legend__description-list-item-data\">\n        <ng-container *ngIf=\"item.secondLabel; else nonConcatenatedLabel\">\n          <p class=\"chart-legend__description-list-item-text\">\n            {{ item.label }}\n            <span class=\"chart-legend__second-label\" sieUiPopover popoverSize=\"s\" [content]=\"item.secondLabelTooltip\">{{\n              item.secondLabel\n            }}</span>\n          </p></ng-container\n        >\n        <ng-template #nonConcatenatedLabel>\n          <p class=\"chart-legend__description-list-item-text\">{{ item.label }}</p>\n        </ng-template>\n      </dd>\n    </div>\n  </dl>\n</div>\n", styles: [".chart-legend__description-list{margin:-1px 0}.chart-legend__description-list-item{display:flex;justify-content:flex-start;margin:9px 0}.chart-legend__description-list-item-percentage{font-size:.75rem;font-weight:700;line-height:1rem;display:flex;justify-content:center;align-items:center;flex-shrink:0;height:20px;width:37px}.chart-legend__description-list-item-data{margin-top:0;margin-left:17px}.chart-legend__description-list-item-text{font-size:.875rem;font-weight:400;line-height:1.25rem;margin-top:1px}.chart-legend__description-list-item:not(:last-child){margin-bottom:8px}.chart-legend__second-label{border-bottom:1px dotted #002949}.chart-legend__second-label:hover{cursor:pointer}\n"] }]
        }], propDecorators: { legendData: [{
                type: Input
            }] } });

class UiChartLegendModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiChartLegendModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiChartLegendModule, declarations: [UiChartLegendComponent], imports: [CommonModule, UiPopoverModule], exports: [UiChartLegendComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiChartLegendModule, imports: [CommonModule, UiPopoverModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiChartLegendModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiChartLegendComponent],
                    imports: [CommonModule, UiPopoverModule],
                    exports: [UiChartLegendComponent]
                }]
        }] });

class UiOverflowButtonComponent {
    constructor() {
        this.isExpanded = false;
        this.clicked = new EventEmitter();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiOverflowButtonComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiOverflowButtonComponent, selector: "sie-ui-overflow-button", inputs: { icon: "icon", label: "label", isExpanded: "isExpanded" }, outputs: { clicked: "clicked" }, ngImport: i0, template: "<button\n  class=\"overflow-button\"\n  (click)=\"clicked.next($event)\"\n  [attr.aria-expanded]=\"isExpanded\"\n  [attr.aria-label]=\"label\"\n>\n  <sie-icon *ngIf=\"icon\" class=\"overflow-button__icon\" [name]=\"icon\" aria-hidden=\"true\"></sie-icon>\n  <span *ngIf=\"label\" class=\"overflow-button__label\">{{ label }}</span>\n</button>\n", styles: [".overflow-button{outline:none;outline-offset:0}@media (pointer: fine){.overflow-button{position:relative}.overflow-button:focus{outline:1px solid #1491eb;outline-offset:2px}.overflow-button:focus:not(:focus-visible){outline:0}.overflow-button:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}.overflow-button{font-size:1rem;font-weight:400;line-height:1.5rem;white-space:nowrap;overflow:hidden;text-overflow:ellipsis;display:block;position:relative;height:40px;border:0;padding:.5rem 0;background:none;text-decoration:none;text-align:left;color:#007993;fill:#007993}.overflow-button:hover,.overflow-button:active{text-decoration:underline;text-underline-offset:5px;color:#33747a;fill:#33747a;cursor:pointer}.overflow-button:visited{color:#66afbe;fill:#66afbe}.overflow-button.disabled{color:#b3b3be;fill:#b3b3be;pointer-events:none}.overflow-button__icon{width:24px;height:24px;display:flex;align-items:center;fill:currentColor;display:inline-flex;margin-right:4px;margin-left:-5px}.overflow-button__icon svg{fill:currentColor;width:inherit;height:inherit}.overflow-button__icon svg g{fill:currentColor;width:inherit;height:inherit}.overflow-button__icon svg text{font-family:Siemens Sans,sans-serif}.overflow-button__label{vertical-align:middle}\n"], dependencies: [{ kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiOverflowButtonComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-overflow-button', changeDetection: ChangeDetectionStrategy.OnPush, template: "<button\n  class=\"overflow-button\"\n  (click)=\"clicked.next($event)\"\n  [attr.aria-expanded]=\"isExpanded\"\n  [attr.aria-label]=\"label\"\n>\n  <sie-icon *ngIf=\"icon\" class=\"overflow-button__icon\" [name]=\"icon\" aria-hidden=\"true\"></sie-icon>\n  <span *ngIf=\"label\" class=\"overflow-button__label\">{{ label }}</span>\n</button>\n", styles: [".overflow-button{outline:none;outline-offset:0}@media (pointer: fine){.overflow-button{position:relative}.overflow-button:focus{outline:1px solid #1491eb;outline-offset:2px}.overflow-button:focus:not(:focus-visible){outline:0}.overflow-button:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}.overflow-button{font-size:1rem;font-weight:400;line-height:1.5rem;white-space:nowrap;overflow:hidden;text-overflow:ellipsis;display:block;position:relative;height:40px;border:0;padding:.5rem 0;background:none;text-decoration:none;text-align:left;color:#007993;fill:#007993}.overflow-button:hover,.overflow-button:active{text-decoration:underline;text-underline-offset:5px;color:#33747a;fill:#33747a;cursor:pointer}.overflow-button:visited{color:#66afbe;fill:#66afbe}.overflow-button.disabled{color:#b3b3be;fill:#b3b3be;pointer-events:none}.overflow-button__icon{width:24px;height:24px;display:flex;align-items:center;fill:currentColor;display:inline-flex;margin-right:4px;margin-left:-5px}.overflow-button__icon svg{fill:currentColor;width:inherit;height:inherit}.overflow-button__icon svg g{fill:currentColor;width:inherit;height:inherit}.overflow-button__icon svg text{font-family:Siemens Sans,sans-serif}.overflow-button__label{vertical-align:middle}\n"] }]
        }], propDecorators: { icon: [{
                type: Input
            }], label: [{
                type: Input
            }], isExpanded: [{
                type: Input
            }], clicked: [{
                type: Output
            }] } });

class UiStatusBarComponent {
    constructor(iconReg) {
        this.iconReg = iconReg;
        this.textExpand = '';
        this.textCollapse = '';
        this.statusBarToggled = new EventEmitter();
        this.isExpanded = false;
        this.iconReg.register(SieIcon.ArrowDown);
        this.iconReg.register(SieIcon.ArrowUp);
    }
    toggle() {
        this.overflowComponent.toggle();
        this.isExpanded = this.overflowComponent.isExpanded;
        this.statusBarToggled.emit(this.isExpanded);
    }
    contentChanged() {
        if (this.isExpanded) {
            this.overflowComponent.updateElementMaxHeight();
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiStatusBarComponent, deps: [{ token: i1.SieIconRegistryService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiStatusBarComponent, selector: "sie-ui-status-bar", inputs: { headline: "headline", textExpand: "textExpand", textCollapse: "textCollapse" }, outputs: { statusBarToggled: "statusBarToggled" }, viewQueries: [{ propertyName: "overflowComponent", first: true, predicate: ["overflowComponent"], descendants: true }], ngImport: i0, template: "<div class=\"status-bar\">\n  <sie-ui-overflow limit=\"88px\" [showExpandButton]=\"false\" #overflowComponent>\n    <div class=\"status-bar__header\" [ngClass]=\"{ 'status-bar__header--no-headline': !headline }\">\n      <h2 class=\"status-bar__header__title\" *ngIf=\"headline\">{{ headline }}</h2>\n    </div>\n    <div class=\"status-bar__main-content\">\n      <ng-content></ng-content>\n    </div>\n  </sie-ui-overflow>\n  <sie-ui-overflow-button\n    class=\"status-bar__toggle-button\"\n    [icon]=\"isExpanded ? iconReg.sieIcon.ArrowUp : iconReg.sieIcon.ArrowDown\"\n    [label]=\"isExpanded ? textCollapse : textExpand\"\n    [isExpanded]=\"isExpanded\"\n    (clicked)=\"toggle()\"\n  ></sie-ui-overflow-button>\n</div>\n", styles: [".status-bar{min-height:74px;box-shadow:0 2px 2px #0000000f,0 4px 8px #0000001f;background-color:#fff;padding:25px 16px 24px}.status-bar__header{display:flex;justify-content:space-between}.status-bar__header__title{font-size:1.25rem;font-weight:900;line-height:1.625rem;margin:0;display:block;overflow-wrap:break-word}.status-bar__header__expandable-button{margin-left:20px}.status-bar__header--no-headline{justify-content:flex-end}.status-bar__main-content{padding-top:25px}.status-bar__toggle-button{display:block;margin:0 auto;width:-moz-fit-content;width:fit-content}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: UiOverflowComponent, selector: "sie-ui-overflow", inputs: ["limit", "forBreakpoints", "headlineCollapsed", "headlineExpanded", "useGradient", "size", "buttonIndentationLeft", "buttonIndentationTop", "centered", "theme", "useDynamicSubItemHeight", "disabled", "showExpandButton", "gradientColor"], outputs: ["toggled"] }, { kind: "component", type: UiOverflowButtonComponent, selector: "sie-ui-overflow-button", inputs: ["icon", "label", "isExpanded"], outputs: ["clicked"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
__decorate([
    Debounce(100)
], UiStatusBarComponent.prototype, "contentChanged", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiStatusBarComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-status-bar', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"status-bar\">\n  <sie-ui-overflow limit=\"88px\" [showExpandButton]=\"false\" #overflowComponent>\n    <div class=\"status-bar__header\" [ngClass]=\"{ 'status-bar__header--no-headline': !headline }\">\n      <h2 class=\"status-bar__header__title\" *ngIf=\"headline\">{{ headline }}</h2>\n    </div>\n    <div class=\"status-bar__main-content\">\n      <ng-content></ng-content>\n    </div>\n  </sie-ui-overflow>\n  <sie-ui-overflow-button\n    class=\"status-bar__toggle-button\"\n    [icon]=\"isExpanded ? iconReg.sieIcon.ArrowUp : iconReg.sieIcon.ArrowDown\"\n    [label]=\"isExpanded ? textCollapse : textExpand\"\n    [isExpanded]=\"isExpanded\"\n    (clicked)=\"toggle()\"\n  ></sie-ui-overflow-button>\n</div>\n", styles: [".status-bar{min-height:74px;box-shadow:0 2px 2px #0000000f,0 4px 8px #0000001f;background-color:#fff;padding:25px 16px 24px}.status-bar__header{display:flex;justify-content:space-between}.status-bar__header__title{font-size:1.25rem;font-weight:900;line-height:1.625rem;margin:0;display:block;overflow-wrap:break-word}.status-bar__header__expandable-button{margin-left:20px}.status-bar__header--no-headline{justify-content:flex-end}.status-bar__main-content{padding-top:25px}.status-bar__toggle-button{display:block;margin:0 auto;width:-moz-fit-content;width:fit-content}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }]; }, propDecorators: { overflowComponent: [{
                type: ViewChild,
                args: ['overflowComponent']
            }], headline: [{
                type: Input
            }], textExpand: [{
                type: Input
            }], textCollapse: [{
                type: Input
            }], statusBarToggled: [{
                type: Output
            }], contentChanged: [] } });

class UiOverflowButtonModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiOverflowButtonModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiOverflowButtonModule, declarations: [UiOverflowButtonComponent], imports: [CommonModule, SieIconsModule], exports: [UiOverflowButtonComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiOverflowButtonModule, imports: [CommonModule, SieIconsModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiOverflowButtonModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiOverflowButtonComponent],
                    imports: [CommonModule, SieIconsModule],
                    exports: [UiOverflowButtonComponent]
                }]
        }] });

class UiStatusBarModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiStatusBarModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiStatusBarModule, declarations: [UiStatusBarComponent], imports: [CommonModule, UiOverflowModule, UiOverflowButtonModule, SieIconsModule], exports: [UiStatusBarComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiStatusBarModule, imports: [CommonModule, UiOverflowModule, UiOverflowButtonModule, SieIconsModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiStatusBarModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiStatusBarComponent],
                    imports: [CommonModule, UiOverflowModule, UiOverflowButtonModule, SieIconsModule],
                    exports: [UiStatusBarComponent]
                }]
        }] });

const FOCUS_OUT_WAIT_PERIOD = 150;
/**
 * # Complex dropdown component
 *
 * Complex Dropdown allows user to search and select a value from given set of options.
 *
 * ## Component variations
 *
 * - Contained (on light)
 * - Uncontained (on light)
 * - Disabled
 * - Readonly
 * - Invalid
 * - Required
 *
 * ## Content
 *
 * The content of the complex dropdown component can be any valid markup.
 *
 * ## Code example
 * @example ```html
 * <sie-ui-complex-dropdown
 *  [confirmButtonDisabled]="true"
 *  [resetButtonDisabled]="true"
 *  [confirmButtonDesc]="'Confirm'"
 *  [resetButtonDesc]="'Reset'"
 *  [clearInputEnabled]="true"
 *  [placeholder]="'Placeholder'"
 *  [theme]="'light'"
 *  [type]="'un-contained'"
 * >
 *  <sie-ui-richtext contentSlot [content]="'<h1>Hello world!</h1> <p>Lorem ipsum...</p>'"></sie-ui-richtext>
 * </sie-ui-complex-dropdown>
 * ```
 */
class UiComplexDropdownComponent extends UiDropdownComponent {
    get resetButtonDisabled() {
        return this._resetButtonDisabled;
    }
    /**
     * Defines if the reset button is disabled.
     * @default true
     */
    set resetButtonDisabled(value) {
        this._resetButtonDisabled = coerceBooleanProperty(value);
    }
    get confirmButtonDisabled() {
        return this._confirmButtonDisabled;
    }
    /**
     * Defines if the confirm button is disabled.
     * @default true
     */
    set confirmButtonDisabled(value) {
        this._confirmButtonDisabled = coerceBooleanProperty(value);
    }
    /** @ignore */
    onFocusAndClick(event) {
        if (!this.elementRef.nativeElement.contains(event.target) &&
            !this.complexDropdownMenu?.elementRef.nativeElement.contains(event.target)) {
            this.onFocusOut();
        }
    }
    constructor(iconReg, elementRef, cdr, layoutService, eventPropagationService, cdkOverlayService) {
        super(iconReg, eventPropagationService, elementRef, cdr, cdkOverlayService, layoutService);
        this.cdkOverlayService = cdkOverlayService;
        this._valueSelected = null;
        this._confirmButtonDisabled = true;
        this._resetButtonDisabled = true;
        /**
         * Defines the {@link DropdownType type} of complex dropdown.
         * @default 'contained'
         */
        this.type = 'contained';
        /**
         * Event triggered when the confirmation button is clicked.
         */
        this.confirmEvent = new EventEmitter();
        /**
         * Event triggered when the reset button is clicked.
         */
        this.resetEvent = new EventEmitter();
    }
    /**
     * @param value Defines the value that is selected in the complex dropdown menu.
     */
    set valueSelected(value) {
        this._valueSelected = value;
        if (value?.icon) {
            this.iconReg.register(value.icon);
        }
    }
    get valueSelected() {
        return this._valueSelected;
    }
    /**
     * Confirms the selected value in the complex dropdown menu.
     */
    confirm(event) {
        this.confirmEvent.emit();
        this.toggleDropDown(event);
    }
    /**
     * Resets the selected value in the complex dropdown menu.
     */
    reset() {
        this.resetEvent.emit();
    }
    /** @ignore */
    focusOverlayContent(event) {
        if (this.menuOpen) {
            event.preventDefault();
            this.complexDropdownMenuContent.nativeElement.focus();
        }
    }
    /** @ignore */
    onFocusIn() {
        clearTimeout(this.focusOutTimer);
    }
    /** Closes the overlay when the complex dropdown is focused out.  */
    onFocusOut() {
        this.focusOutTimer = setTimeout(() => {
            if (this.menuOpen) {
                this.confirm();
            }
            else {
                this.closeOverlay();
            }
        }, FOCUS_OUT_WAIT_PERIOD);
    }
    /** @ignore */
    onClose(event) {
        this.confirm();
        this.handleEscape(event);
    }
    /** @ignore */
    onResetButtonClicked() {
        this.valueSelected = null;
        super.onResetButtonClicked('.complex__dropdown__button');
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiComplexDropdownComponent, deps: [{ token: i1.SieIconRegistryService }, { token: i0.ElementRef }, { token: i0.ChangeDetectorRef }, { token: i1$1.LayoutService }, { token: UiEventPropagationService }, { token: CdkOverlayService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiComplexDropdownComponent, selector: "sie-ui-complex-dropdown", inputs: { resetButtonDisabled: "resetButtonDisabled", confirmButtonDisabled: "confirmButtonDisabled", confirmButtonDesc: "confirmButtonDesc", resetButtonDesc: "resetButtonDesc", type: "type", valueSelected: "valueSelected" }, outputs: { confirmEvent: "confirmEvent", resetEvent: "resetEvent" }, host: { listeners: { "document:focusin": "onFocusAndClick($event)", "document:mousedown": "onFocusAndClick($event)" } }, providers: [UiEventPropagationService], viewQueries: [{ propertyName: "complexDropdownMenu", first: true, predicate: ["complexDropdownMenu"], descendants: true }, { propertyName: "complexDropdownMenuContent", first: true, predicate: ["complexDropdownMenuContent"], descendants: true }], usesInheritance: true, ngImport: i0, template: "<div\n  *ngIf=\"!readonly; else readOnly\"\n  class=\"complex__dropdown complex__dropdown--{{ type }}\"\n  [ngClass]=\"customClass\"\n  [class.disabled]=\"disabled\"\n  [class.invalid]=\"invalid\"\n  [class.selected]=\"valueSelected\"\n  [attr.aria-expanded]=\"menuOpen\"\n  (focusin)=\"onFocusIn()\"\n  #dropDownRendering\n>\n  <div [ngClass]=\"clearInputEnabled && valueSelected ? 'complex__dropdown__wrapper' : ''\">\n    <div\n      class=\"complex__dropdown__button\"\n      [attr.tabindex]=\"disabled ? -1 : 0\"\n      [attr.aria-haspopup]=\"'listbox'\"\n      [attr.id]=\"id\"\n      (click)=\"menuOpen ? confirm() : toggleDropDown()\"\n      (keydown.enter)=\"menuOpen ? confirm() : toggleDropDown($event)\"\n      (keydown.space)=\"menuOpen ? confirm() : toggleDropDown($event)\"\n      (keydown.escape)=\"handleEscape($event)\"\n      (keydown.tab)=\"focusOverlayContent($event)\"\n      (keyup.escape)=\"eventPropagationService.handleEvent($event)\"\n      [ngClass]=\"{\n        open: menuOpen,\n        dark: theme === 'dark',\n        light: theme === 'light'\n      }\"\n      role=\"button\"\n      #dropDownElement\n      cdkOverlayOrigin\n      #trigger=\"cdkOverlayOrigin\"\n    >\n      <span *ngIf=\"screenReaderText && screenReaderText.length > 0\" class=\"visually-hidden\">{{\n        screenReaderText\n      }}</span>\n      <ng-container *ngIf=\"type === 'contained'; else unContainedComplexDropdown\">\n        <span\n          class=\"label\"\n          [ngClass]=\"{ itemSelected: valueSelected }\"\n          [innerHTML]=\"required ? placeholder + '*' : placeholder\"\n        ></span>\n        <span\n          class=\"selected-label\"\n          [ngClass]=\"{ 'no-placeholder': !placeholder }\"\n          [innerHTML]=\"valueSelected?.itemTitle\"\n          [title]=\"valueSelected?.itemTitle\"\n        ></span>\n      </ng-container>\n\n      <ng-template #unContainedComplexDropdown>\n        <sie-icon\n          class=\"selected-label__icon\"\n          *ngIf=\"valueSelected?.icon\"\n          [name]=\"valueSelected.icon\"\n          [ngClass]=\"clearInputEnabled && valueSelected ? 'reset' : ''\"\n        ></sie-icon>\n        <span\n          class=\"selected-label\"\n          [innerHTML]=\"valueSelected ? valueSelected?.itemTitle : placeholder\"\n          [title]=\"valueSelected ? valueSelected?.itemTitle : ''\"\n        ></span>\n      </ng-template>\n      <sie-icon\n        class=\"complex__dropdown__icon\"\n        aria-hidden=\"true\"\n        [name]=\"iconReg.sieIcon.Dropdown\"\n        [ngClass]=\"clearInputEnabled && valueSelected ? 'reset' : ''\"\n      ></sie-icon>\n    </div>\n    <sie-ui-icon-button\n      *ngIf=\"clearInputEnabled && !readonly && valueSelected\"\n      [ngClass]=\"{ condensed: condensed }\"\n      class=\"complex__dropdown__reset-input\"\n      [disabled]=\"disabled\"\n      [theme]=\"theme\"\n      [iconScreenReaderText]=\"clearInputIconScreenReaderText\"\n      (clicked)=\"onResetButtonClicked()\"\n    ></sie-ui-icon-button>\n  </div>\n\n  <ng-template\n    cdkConnectedOverlay\n    cdkConnectedOverlayBackdropClass=\"cdk-overlay-transparent-backdrop\"\n    [cdkConnectedOverlayOrigin]=\"trigger\"\n    [cdkConnectedOverlayOpen]=\"menuOpen\"\n    [cdkConnectedOverlayOffsetX]=\"type === 'un-contained' && cdkOverlayOffsetX\"\n  >\n    <sie-ui-dropdown-menu\n      cdkTrapFocus\n      class=\"complex__dropdown__menu\"\n      [type]=\"type === 'un-contained' ? 'dropdown-un-contained' : 'dropdown-contained'\"\n      [@openClose]=\"menuOpen\"\n      (keydown.escape)=\"onClose($event)\"\n      (keyup.escape)=\"eventPropagationService.handleEvent($event)\"\n      [theme]=\"theme\"\n      [ngStyle]=\"{\n        left: leftStyle,\n        width: type === 'contained' && dropdownWidth + 'px'\n      }\"\n      [menuPositionedBottom]=\"menuPositionedBottom\"\n      #complexDropdownMenu\n    >\n      <div content class=\"complex__dropdown__content\" tabindex=\"-1\" #complexDropdownMenuContent>\n        <ng-content select=\"[contentSlot]\"></ng-content>\n      </div>\n      <ng-container footer>\n        <div class=\"complex__dropdown__footer\">\n          <div class=\"complex__dropdown__footer__action__button\">\n            <ng-content select=\"[actionButton]\"></ng-content>\n          </div>\n          <div *ngIf=\"resetButtonDesc || confirmButtonDesc\" class=\"complex__dropdown__footer__group\">\n            <sie-ui-button\n              *ngIf=\"confirmButtonDesc\"\n              class=\"complex__dropdown__footer__group__button\"\n              [disabled]=\"confirmButtonDisabled\"\n              (clicked)=\"confirmButtonDisabled || confirm()\"\n              themeType=\"un-contained\"\n              variant=\"icon-un-contained\"\n              buttonType=\"button\"\n            >\n              {{ confirmButtonDesc }}\n            </sie-ui-button>\n            <sie-ui-button\n              *ngIf=\"resetButtonDesc\"\n              class=\"complex__dropdown__footer__group__button\"\n              [disabled]=\"resetButtonDisabled\"\n              (clicked)=\"resetButtonDisabled || reset()\"\n              themeType=\"un-contained\"\n              variant=\"icon-un-contained\"\n              buttonType=\"button\"\n            >\n              {{ resetButtonDesc }}\n            </sie-ui-button>\n          </div>\n        </div>\n      </ng-container>\n    </sie-ui-dropdown-menu>\n  </ng-template>\n\n  <div *ngIf=\"invalid\" class=\"complex__dropdown__invalid\">\n    {{ errorMessage }}\n  </div>\n  <sie-ui-richtext\n    class=\"complex__dropdown__hint\"\n    *ngIf=\"hint?.type === 'inline' && hint?.content\"\n    [content]=\"hint.content\"\n  ></sie-ui-richtext>\n</div>\n\n<ng-template #readOnly>\n  <sie-ui-readonly\n    [label]=\"condensed ? label : placeholder\"\n    [value]=\"placeholder\"\n    [displayValue]=\"placeholder\"\n    [name]=\"name\"\n    [theme]=\"theme\"\n  ></sie-ui-readonly>\n</ng-template>\n", styles: [".complex__dropdown__button,.complex__dropdown__content{outline:none;outline-offset:0}@media (pointer: fine){.complex__dropdown__button,.complex__dropdown__content{position:relative}.complex__dropdown__button:focus,.complex__dropdown__content:focus{outline:1px solid #1491eb;outline-offset:2px}.complex__dropdown__button:focus:not(:focus-visible),.complex__dropdown__content:focus:not(:focus-visible){outline:0}.complex__dropdown__button:focus-visible,.complex__dropdown__content:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}::-webkit-scrollbar-thumb{background-clip:padding-box;background-color:#737389}::-webkit-scrollbar-button{display:none}::-webkit-scrollbar-corner{background-color:transparent}::-webkit-scrollbar{width:16px;height:8px}:host{scrollbar-color:#737389 #fff}:host .dark,:host.dark{scrollbar-color:#ccccd4 #001f39}::-webkit-scrollbar-thumb:vertical{border-left:8px solid transparent;border-right:4px solid transparent}::-webkit-scrollbar-thumb:horizontal{border-top:4px solid transparent}::-webkit-scrollbar-track:vertical{border-left:8px solid #fff;background:#ccccd4;border-right:4px solid #fff}::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #ccccd4}.dark::-webkit-scrollbar-thumb,.dark ::-webkit-scrollbar-thumb{background-color:#ccccd4}.dark::-webkit-scrollbar-track:vertical,.dark ::-webkit-scrollbar-track:vertical{background:#737389;border-right:4px solid #001f39;border-left:8px solid #001f39}.dark::-webkit-scrollbar-track:horizontal,.dark ::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #737389}.complex__dropdown{display:inline-block;position:relative;text-align:left;max-width:100%}.complex__dropdown__menu{width:100%}.complex__dropdown:focus{outline:none}.complex__dropdown__content{height:115px;overflow-y:auto}.complex__dropdown__button{--icon-color: #4c4c68;--text-color: #4c4c68;--border-color: #4c4c68;display:inline-flex;align-items:center;justify-content:space-between;position:relative;text-overflow:ellipsis;cursor:pointer;color:var(--text-color);border-bottom:1px solid var(--border-color);white-space:nowrap}.complex__dropdown__button:hover,.complex__dropdown__button:focus,.complex__dropdown__button.open{--icon-color: #33747a;--text-color: #000028;--border-color: #00d7a0}.complex__dropdown__button.dark{--icon-color: #ccccd4;--text-color: #ccccd4;--border-color: #ccccd4}.complex__dropdown__button.dark:hover,.complex__dropdown__button.dark:focus,.complex__dropdown__button.dark.open{--icon-color: #00ffb9;--text-color: #fff;--border-color: #00ffb9}.complex__dropdown__reset-input{position:absolute;cursor:pointer;z-index:2}.complex__dropdown .label.itemSelected{font-size:.75rem;font-weight:400;line-height:1rem;color:#4c4c68;position:absolute;top:6px}.complex__dropdown--un-contained .complex__dropdown__wrapper{position:relative;display:inline-block}.complex__dropdown--un-contained .complex__dropdown__menu{width:max-content}.complex__dropdown--un-contained .complex__dropdown__button{height:28px}.complex__dropdown--un-contained .complex__dropdown__reset-input{top:4px;right:15px}.complex__dropdown--un-contained .complex__dropdown__icon.reset{margin-left:36px}.complex__dropdown--un-contained .selected-label{overflow:hidden;text-overflow:ellipsis}.complex__dropdown--un-contained .selected-label__icon{display:inline-flex;justify-content:center;align-items:center;min-width:27px;margin-right:8px}.complex__dropdown--un-contained .selected-label__icon sie-icon{width:24px;height:100%;display:flex;align-items:center;fill:currentColor}.complex__dropdown--un-contained .selected-label__icon sie-icon svg{fill:currentColor;width:inherit;height:inherit}.complex__dropdown--un-contained .selected-label__icon sie-icon svg g{fill:currentColor;width:inherit;height:inherit}.complex__dropdown--un-contained .selected-label__icon sie-icon svg text{font-family:Siemens Sans,sans-serif}.complex__dropdown__invalid{font-size:.75rem;font-weight:400;line-height:1rem;margin:4px 0 0 16px;color:#ef0137}.complex__dropdown--contained,.complex__dropdown--contained .complex__dropdown__menu{width:100%}.complex__dropdown--contained .complex__dropdown__button{--background-color: #ebf7f8;width:100%;height:56px;padding:0 16px;background-color:var(--background-color)}.complex__dropdown--contained .complex__dropdown__button:hover,.complex__dropdown--contained .complex__dropdown__button:focus,.complex__dropdown--contained .complex__dropdown__button.open{--background-color: #d1fff2}.complex__dropdown--contained .complex__dropdown__reset-input{top:18px;right:40px}.complex__dropdown--contained .complex__dropdown__icon.reset{margin-left:44px}.complex__dropdown--contained .complex__dropdown__invalid{margin:4px 0 0 16px}.complex__dropdown--contained .label.itemSelected{font-size:.75rem;font-weight:400;line-height:1rem;color:#4c4c68;position:absolute;top:6px}.complex__dropdown--contained.invalid .complex__dropdown__button{--background-color: #fcccd7}.complex__dropdown--contained.invalid .label.itemSelected{color:#ef0137}.complex__dropdown--contained .selected-label{overflow:hidden;text-overflow:ellipsis;margin-top:18px}.complex__dropdown--contained .selected-label.no-placeholder{margin-top:0}.complex__dropdown--contained .selected-label__icon{display:inline-flex;justify-content:center;align-items:center;min-width:27px;margin-right:8px}.complex__dropdown--contained .selected-label__icon sie-icon{width:24px;height:24px;display:flex;align-items:center;fill:currentColor}.complex__dropdown--contained .selected-label__icon sie-icon svg{fill:currentColor;width:inherit;height:inherit}.complex__dropdown--contained .selected-label__icon sie-icon svg g{fill:currentColor;width:inherit;height:inherit}.complex__dropdown--contained .selected-label__icon sie-icon svg text{font-family:Siemens Sans,sans-serif}.complex__dropdown.invalid{margin-bottom:20px}.complex__dropdown.invalid .complex__dropdown__button{--border-color: #ef0137}.complex__dropdown.invalid .label.itemSelected{color:#ef0137}.complex__dropdown__footer{display:flex;position:relative;align-items:center;flex-wrap:wrap;justify-content:space-between;min-height:60px;padding:5px 10px 5px 25px}.complex__dropdown__footer__action__button{margin-right:auto}.complex__dropdown__footer__group{display:flex;gap:15px;margin-left:auto}.complex__dropdown__icon{width:24px;height:24px;display:flex;align-items:center;fill:currentColor;color:var(--icon-color);margin-left:16px;margin-right:-7px}.complex__dropdown__icon svg{fill:currentColor;width:inherit;height:inherit}.complex__dropdown__icon svg g{fill:currentColor;width:inherit;height:inherit}.complex__dropdown__icon svg text{font-family:Siemens Sans,sans-serif}.complex__dropdown__icon svg{transition:transform .12s cubic-bezier(.4,0,.3,1)}.open .complex__dropdown__icon svg{transform:translateZ(0) rotate(180deg)}.complex__dropdown__hint{display:block;color:#4c4c68;margin-top:4px;font-size:.75rem;font-weight:400;line-height:1rem}.complex__dropdown.disabled{cursor:not-allowed}.complex__dropdown.disabled .complex__dropdown__button{--icon-color: currentColor;--text-color: #b3b3be;--border-color: currentColor;border-bottom:none;pointer-events:none}.complex__dropdown.disabled .complex__dropdown__button.dark{--icon-color: #737389;--text-color: #737389;--border-color: #737389}.complex__dropdown.selected:not(.disabled) .complex__dropdown__button{--text-color: #000028}.complex__dropdown.selected:not(.disabled) .complex__dropdown__button.dark{--text-color: #fff}.complex__dropdown.selected.complex__dropdown.invalid .complex__dropdown__button.dark{--text-color: #ccccd4}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "component", type: UiDropdownMenuComponent, selector: "sie-ui-dropdown-menu", inputs: ["theme", "type", "menuPositionedBottom"] }, { kind: "component", type: UiButtonComponent, selector: "sie-ui-button" }, { kind: "component", type: UiRichtextComponent, selector: "sie-ui-richtext", inputs: ["content", "theme", "whiteListedTags"] }, { kind: "component", type: UiReadonlyComponent, selector: "sie-ui-readonly", inputs: ["value", "label", "displayValue", "name", "theme", "icons"] }, { kind: "directive", type: i10.CdkConnectedOverlay, selector: "[cdk-connected-overlay], [connected-overlay], [cdkConnectedOverlay]", inputs: ["cdkConnectedOverlayOrigin", "cdkConnectedOverlayPositions", "cdkConnectedOverlayPositionStrategy", "cdkConnectedOverlayOffsetX", "cdkConnectedOverlayOffsetY", "cdkConnectedOverlayWidth", "cdkConnectedOverlayHeight", "cdkConnectedOverlayMinWidth", "cdkConnectedOverlayMinHeight", "cdkConnectedOverlayBackdropClass", "cdkConnectedOverlayPanelClass", "cdkConnectedOverlayViewportMargin", "cdkConnectedOverlayScrollStrategy", "cdkConnectedOverlayOpen", "cdkConnectedOverlayDisableClose", "cdkConnectedOverlayTransformOriginOn", "cdkConnectedOverlayHasBackdrop", "cdkConnectedOverlayLockPosition", "cdkConnectedOverlayFlexibleDimensions", "cdkConnectedOverlayGrowAfterOpen", "cdkConnectedOverlayPush"], outputs: ["backdropClick", "positionChange", "attach", "detach", "overlayKeydown", "overlayOutsideClick"], exportAs: ["cdkConnectedOverlay"] }, { kind: "directive", type: i10.CdkOverlayOrigin, selector: "[cdk-overlay-origin], [overlay-origin], [cdkOverlayOrigin]", exportAs: ["cdkOverlayOrigin"] }, { kind: "directive", type: i6.CdkTrapFocus, selector: "[cdkTrapFocus]", inputs: ["cdkTrapFocus", "cdkTrapFocusAutoCapture"], exportAs: ["cdkTrapFocus"] }, { kind: "component", type: UiIconButtonComponent, selector: "sie-ui-icon-button", inputs: ["theme", "disabled", "hoverColored", "iconScreenReaderText", "icon"], outputs: ["clicked"] }], animations: [createDropdownAnimation()], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiComplexDropdownComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-complex-dropdown', changeDetection: ChangeDetectionStrategy.OnPush, animations: [createDropdownAnimation()], providers: [UiEventPropagationService], template: "<div\n  *ngIf=\"!readonly; else readOnly\"\n  class=\"complex__dropdown complex__dropdown--{{ type }}\"\n  [ngClass]=\"customClass\"\n  [class.disabled]=\"disabled\"\n  [class.invalid]=\"invalid\"\n  [class.selected]=\"valueSelected\"\n  [attr.aria-expanded]=\"menuOpen\"\n  (focusin)=\"onFocusIn()\"\n  #dropDownRendering\n>\n  <div [ngClass]=\"clearInputEnabled && valueSelected ? 'complex__dropdown__wrapper' : ''\">\n    <div\n      class=\"complex__dropdown__button\"\n      [attr.tabindex]=\"disabled ? -1 : 0\"\n      [attr.aria-haspopup]=\"'listbox'\"\n      [attr.id]=\"id\"\n      (click)=\"menuOpen ? confirm() : toggleDropDown()\"\n      (keydown.enter)=\"menuOpen ? confirm() : toggleDropDown($event)\"\n      (keydown.space)=\"menuOpen ? confirm() : toggleDropDown($event)\"\n      (keydown.escape)=\"handleEscape($event)\"\n      (keydown.tab)=\"focusOverlayContent($event)\"\n      (keyup.escape)=\"eventPropagationService.handleEvent($event)\"\n      [ngClass]=\"{\n        open: menuOpen,\n        dark: theme === 'dark',\n        light: theme === 'light'\n      }\"\n      role=\"button\"\n      #dropDownElement\n      cdkOverlayOrigin\n      #trigger=\"cdkOverlayOrigin\"\n    >\n      <span *ngIf=\"screenReaderText && screenReaderText.length > 0\" class=\"visually-hidden\">{{\n        screenReaderText\n      }}</span>\n      <ng-container *ngIf=\"type === 'contained'; else unContainedComplexDropdown\">\n        <span\n          class=\"label\"\n          [ngClass]=\"{ itemSelected: valueSelected }\"\n          [innerHTML]=\"required ? placeholder + '*' : placeholder\"\n        ></span>\n        <span\n          class=\"selected-label\"\n          [ngClass]=\"{ 'no-placeholder': !placeholder }\"\n          [innerHTML]=\"valueSelected?.itemTitle\"\n          [title]=\"valueSelected?.itemTitle\"\n        ></span>\n      </ng-container>\n\n      <ng-template #unContainedComplexDropdown>\n        <sie-icon\n          class=\"selected-label__icon\"\n          *ngIf=\"valueSelected?.icon\"\n          [name]=\"valueSelected.icon\"\n          [ngClass]=\"clearInputEnabled && valueSelected ? 'reset' : ''\"\n        ></sie-icon>\n        <span\n          class=\"selected-label\"\n          [innerHTML]=\"valueSelected ? valueSelected?.itemTitle : placeholder\"\n          [title]=\"valueSelected ? valueSelected?.itemTitle : ''\"\n        ></span>\n      </ng-template>\n      <sie-icon\n        class=\"complex__dropdown__icon\"\n        aria-hidden=\"true\"\n        [name]=\"iconReg.sieIcon.Dropdown\"\n        [ngClass]=\"clearInputEnabled && valueSelected ? 'reset' : ''\"\n      ></sie-icon>\n    </div>\n    <sie-ui-icon-button\n      *ngIf=\"clearInputEnabled && !readonly && valueSelected\"\n      [ngClass]=\"{ condensed: condensed }\"\n      class=\"complex__dropdown__reset-input\"\n      [disabled]=\"disabled\"\n      [theme]=\"theme\"\n      [iconScreenReaderText]=\"clearInputIconScreenReaderText\"\n      (clicked)=\"onResetButtonClicked()\"\n    ></sie-ui-icon-button>\n  </div>\n\n  <ng-template\n    cdkConnectedOverlay\n    cdkConnectedOverlayBackdropClass=\"cdk-overlay-transparent-backdrop\"\n    [cdkConnectedOverlayOrigin]=\"trigger\"\n    [cdkConnectedOverlayOpen]=\"menuOpen\"\n    [cdkConnectedOverlayOffsetX]=\"type === 'un-contained' && cdkOverlayOffsetX\"\n  >\n    <sie-ui-dropdown-menu\n      cdkTrapFocus\n      class=\"complex__dropdown__menu\"\n      [type]=\"type === 'un-contained' ? 'dropdown-un-contained' : 'dropdown-contained'\"\n      [@openClose]=\"menuOpen\"\n      (keydown.escape)=\"onClose($event)\"\n      (keyup.escape)=\"eventPropagationService.handleEvent($event)\"\n      [theme]=\"theme\"\n      [ngStyle]=\"{\n        left: leftStyle,\n        width: type === 'contained' && dropdownWidth + 'px'\n      }\"\n      [menuPositionedBottom]=\"menuPositionedBottom\"\n      #complexDropdownMenu\n    >\n      <div content class=\"complex__dropdown__content\" tabindex=\"-1\" #complexDropdownMenuContent>\n        <ng-content select=\"[contentSlot]\"></ng-content>\n      </div>\n      <ng-container footer>\n        <div class=\"complex__dropdown__footer\">\n          <div class=\"complex__dropdown__footer__action__button\">\n            <ng-content select=\"[actionButton]\"></ng-content>\n          </div>\n          <div *ngIf=\"resetButtonDesc || confirmButtonDesc\" class=\"complex__dropdown__footer__group\">\n            <sie-ui-button\n              *ngIf=\"confirmButtonDesc\"\n              class=\"complex__dropdown__footer__group__button\"\n              [disabled]=\"confirmButtonDisabled\"\n              (clicked)=\"confirmButtonDisabled || confirm()\"\n              themeType=\"un-contained\"\n              variant=\"icon-un-contained\"\n              buttonType=\"button\"\n            >\n              {{ confirmButtonDesc }}\n            </sie-ui-button>\n            <sie-ui-button\n              *ngIf=\"resetButtonDesc\"\n              class=\"complex__dropdown__footer__group__button\"\n              [disabled]=\"resetButtonDisabled\"\n              (clicked)=\"resetButtonDisabled || reset()\"\n              themeType=\"un-contained\"\n              variant=\"icon-un-contained\"\n              buttonType=\"button\"\n            >\n              {{ resetButtonDesc }}\n            </sie-ui-button>\n          </div>\n        </div>\n      </ng-container>\n    </sie-ui-dropdown-menu>\n  </ng-template>\n\n  <div *ngIf=\"invalid\" class=\"complex__dropdown__invalid\">\n    {{ errorMessage }}\n  </div>\n  <sie-ui-richtext\n    class=\"complex__dropdown__hint\"\n    *ngIf=\"hint?.type === 'inline' && hint?.content\"\n    [content]=\"hint.content\"\n  ></sie-ui-richtext>\n</div>\n\n<ng-template #readOnly>\n  <sie-ui-readonly\n    [label]=\"condensed ? label : placeholder\"\n    [value]=\"placeholder\"\n    [displayValue]=\"placeholder\"\n    [name]=\"name\"\n    [theme]=\"theme\"\n  ></sie-ui-readonly>\n</ng-template>\n", styles: [".complex__dropdown__button,.complex__dropdown__content{outline:none;outline-offset:0}@media (pointer: fine){.complex__dropdown__button,.complex__dropdown__content{position:relative}.complex__dropdown__button:focus,.complex__dropdown__content:focus{outline:1px solid #1491eb;outline-offset:2px}.complex__dropdown__button:focus:not(:focus-visible),.complex__dropdown__content:focus:not(:focus-visible){outline:0}.complex__dropdown__button:focus-visible,.complex__dropdown__content:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}::-webkit-scrollbar-thumb{background-clip:padding-box;background-color:#737389}::-webkit-scrollbar-button{display:none}::-webkit-scrollbar-corner{background-color:transparent}::-webkit-scrollbar{width:16px;height:8px}:host{scrollbar-color:#737389 #fff}:host .dark,:host.dark{scrollbar-color:#ccccd4 #001f39}::-webkit-scrollbar-thumb:vertical{border-left:8px solid transparent;border-right:4px solid transparent}::-webkit-scrollbar-thumb:horizontal{border-top:4px solid transparent}::-webkit-scrollbar-track:vertical{border-left:8px solid #fff;background:#ccccd4;border-right:4px solid #fff}::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #ccccd4}.dark::-webkit-scrollbar-thumb,.dark ::-webkit-scrollbar-thumb{background-color:#ccccd4}.dark::-webkit-scrollbar-track:vertical,.dark ::-webkit-scrollbar-track:vertical{background:#737389;border-right:4px solid #001f39;border-left:8px solid #001f39}.dark::-webkit-scrollbar-track:horizontal,.dark ::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #737389}.complex__dropdown{display:inline-block;position:relative;text-align:left;max-width:100%}.complex__dropdown__menu{width:100%}.complex__dropdown:focus{outline:none}.complex__dropdown__content{height:115px;overflow-y:auto}.complex__dropdown__button{--icon-color: #4c4c68;--text-color: #4c4c68;--border-color: #4c4c68;display:inline-flex;align-items:center;justify-content:space-between;position:relative;text-overflow:ellipsis;cursor:pointer;color:var(--text-color);border-bottom:1px solid var(--border-color);white-space:nowrap}.complex__dropdown__button:hover,.complex__dropdown__button:focus,.complex__dropdown__button.open{--icon-color: #33747a;--text-color: #000028;--border-color: #00d7a0}.complex__dropdown__button.dark{--icon-color: #ccccd4;--text-color: #ccccd4;--border-color: #ccccd4}.complex__dropdown__button.dark:hover,.complex__dropdown__button.dark:focus,.complex__dropdown__button.dark.open{--icon-color: #00ffb9;--text-color: #fff;--border-color: #00ffb9}.complex__dropdown__reset-input{position:absolute;cursor:pointer;z-index:2}.complex__dropdown .label.itemSelected{font-size:.75rem;font-weight:400;line-height:1rem;color:#4c4c68;position:absolute;top:6px}.complex__dropdown--un-contained .complex__dropdown__wrapper{position:relative;display:inline-block}.complex__dropdown--un-contained .complex__dropdown__menu{width:max-content}.complex__dropdown--un-contained .complex__dropdown__button{height:28px}.complex__dropdown--un-contained .complex__dropdown__reset-input{top:4px;right:15px}.complex__dropdown--un-contained .complex__dropdown__icon.reset{margin-left:36px}.complex__dropdown--un-contained .selected-label{overflow:hidden;text-overflow:ellipsis}.complex__dropdown--un-contained .selected-label__icon{display:inline-flex;justify-content:center;align-items:center;min-width:27px;margin-right:8px}.complex__dropdown--un-contained .selected-label__icon sie-icon{width:24px;height:100%;display:flex;align-items:center;fill:currentColor}.complex__dropdown--un-contained .selected-label__icon sie-icon svg{fill:currentColor;width:inherit;height:inherit}.complex__dropdown--un-contained .selected-label__icon sie-icon svg g{fill:currentColor;width:inherit;height:inherit}.complex__dropdown--un-contained .selected-label__icon sie-icon svg text{font-family:Siemens Sans,sans-serif}.complex__dropdown__invalid{font-size:.75rem;font-weight:400;line-height:1rem;margin:4px 0 0 16px;color:#ef0137}.complex__dropdown--contained,.complex__dropdown--contained .complex__dropdown__menu{width:100%}.complex__dropdown--contained .complex__dropdown__button{--background-color: #ebf7f8;width:100%;height:56px;padding:0 16px;background-color:var(--background-color)}.complex__dropdown--contained .complex__dropdown__button:hover,.complex__dropdown--contained .complex__dropdown__button:focus,.complex__dropdown--contained .complex__dropdown__button.open{--background-color: #d1fff2}.complex__dropdown--contained .complex__dropdown__reset-input{top:18px;right:40px}.complex__dropdown--contained .complex__dropdown__icon.reset{margin-left:44px}.complex__dropdown--contained .complex__dropdown__invalid{margin:4px 0 0 16px}.complex__dropdown--contained .label.itemSelected{font-size:.75rem;font-weight:400;line-height:1rem;color:#4c4c68;position:absolute;top:6px}.complex__dropdown--contained.invalid .complex__dropdown__button{--background-color: #fcccd7}.complex__dropdown--contained.invalid .label.itemSelected{color:#ef0137}.complex__dropdown--contained .selected-label{overflow:hidden;text-overflow:ellipsis;margin-top:18px}.complex__dropdown--contained .selected-label.no-placeholder{margin-top:0}.complex__dropdown--contained .selected-label__icon{display:inline-flex;justify-content:center;align-items:center;min-width:27px;margin-right:8px}.complex__dropdown--contained .selected-label__icon sie-icon{width:24px;height:24px;display:flex;align-items:center;fill:currentColor}.complex__dropdown--contained .selected-label__icon sie-icon svg{fill:currentColor;width:inherit;height:inherit}.complex__dropdown--contained .selected-label__icon sie-icon svg g{fill:currentColor;width:inherit;height:inherit}.complex__dropdown--contained .selected-label__icon sie-icon svg text{font-family:Siemens Sans,sans-serif}.complex__dropdown.invalid{margin-bottom:20px}.complex__dropdown.invalid .complex__dropdown__button{--border-color: #ef0137}.complex__dropdown.invalid .label.itemSelected{color:#ef0137}.complex__dropdown__footer{display:flex;position:relative;align-items:center;flex-wrap:wrap;justify-content:space-between;min-height:60px;padding:5px 10px 5px 25px}.complex__dropdown__footer__action__button{margin-right:auto}.complex__dropdown__footer__group{display:flex;gap:15px;margin-left:auto}.complex__dropdown__icon{width:24px;height:24px;display:flex;align-items:center;fill:currentColor;color:var(--icon-color);margin-left:16px;margin-right:-7px}.complex__dropdown__icon svg{fill:currentColor;width:inherit;height:inherit}.complex__dropdown__icon svg g{fill:currentColor;width:inherit;height:inherit}.complex__dropdown__icon svg text{font-family:Siemens Sans,sans-serif}.complex__dropdown__icon svg{transition:transform .12s cubic-bezier(.4,0,.3,1)}.open .complex__dropdown__icon svg{transform:translateZ(0) rotate(180deg)}.complex__dropdown__hint{display:block;color:#4c4c68;margin-top:4px;font-size:.75rem;font-weight:400;line-height:1rem}.complex__dropdown.disabled{cursor:not-allowed}.complex__dropdown.disabled .complex__dropdown__button{--icon-color: currentColor;--text-color: #b3b3be;--border-color: currentColor;border-bottom:none;pointer-events:none}.complex__dropdown.disabled .complex__dropdown__button.dark{--icon-color: #737389;--text-color: #737389;--border-color: #737389}.complex__dropdown.selected:not(.disabled) .complex__dropdown__button{--text-color: #000028}.complex__dropdown.selected:not(.disabled) .complex__dropdown__button.dark{--text-color: #fff}.complex__dropdown.selected.complex__dropdown.invalid .complex__dropdown__button.dark{--text-color: #ccccd4}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }, { type: i0.ElementRef }, { type: i0.ChangeDetectorRef }, { type: i1$1.LayoutService }, { type: UiEventPropagationService }, { type: CdkOverlayService }]; }, propDecorators: { complexDropdownMenu: [{
                type: ViewChild,
                args: ['complexDropdownMenu']
            }], complexDropdownMenuContent: [{
                type: ViewChild,
                args: ['complexDropdownMenuContent']
            }], resetButtonDisabled: [{
                type: Input
            }], confirmButtonDisabled: [{
                type: Input
            }], confirmButtonDesc: [{
                type: Input
            }], resetButtonDesc: [{
                type: Input
            }], type: [{
                type: Input
            }], confirmEvent: [{
                type: Output
            }], resetEvent: [{
                type: Output
            }], onFocusAndClick: [{
                type: HostListener,
                args: ['document:focusin', ['$event']]
            }, {
                type: HostListener,
                args: ['document:mousedown', ['$event']]
            }], valueSelected: [{
                type: Input
            }] } });

/**
 * # Complex Dropdown Module
 * - {@link UiComplexDropdownComponent}
 *
 * ## Module peer dependencies
 * - {@link SieIconsModule}
 * - `@angular/platform-browser/animations/BrowserAnimationsModule`: This module is needed for the transition animation
 *    of the dropdown component.
 */
class UiComplexDropdownModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiComplexDropdownModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiComplexDropdownModule, declarations: [UiComplexDropdownComponent], imports: [CommonModule,
            SieIconsModule,
            UiDropdownModule,
            UiDropdownMenuModule,
            UiButtonModule,
            UiRichtextModule,
            UiReadonlyModule,
            OverlayModule,
            A11yModule,
            UiIconButtonModule], exports: [UiComplexDropdownComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiComplexDropdownModule, imports: [CommonModule,
            SieIconsModule,
            UiDropdownModule,
            UiDropdownMenuModule,
            UiButtonModule,
            UiRichtextModule,
            UiReadonlyModule,
            OverlayModule,
            A11yModule,
            UiIconButtonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiComplexDropdownModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiComplexDropdownComponent],
                    imports: [
                        CommonModule,
                        SieIconsModule,
                        UiDropdownModule,
                        UiDropdownMenuModule,
                        UiButtonModule,
                        UiRichtextModule,
                        UiReadonlyModule,
                        OverlayModule,
                        A11yModule,
                        UiIconButtonModule
                    ],
                    exports: [UiComplexDropdownComponent]
                }]
        }] });

const DEFAULT_LEFT_PADDING = 12;
class UiNestedListItemComponent {
    set itemLevel(value) {
        if (value > 1) {
            this.paddingLeft = DEFAULT_LEFT_PADDING * (value - 1);
        }
    }
    set nestedListType(value) {
        this._nestedListType = value;
        if (value === 'dropdown') {
            this.hoverMode = 'row';
        }
        else {
            this.hoverMode = 'item';
        }
    }
    get nestedListType() {
        return this._nestedListType;
    }
    set borderVisible(value) {
        if (this.nestedListType === 'table') {
            this._borderVisible = value;
        }
        else {
            this._borderVisible = false;
        }
    }
    get borderVisible() {
        return this._borderVisible;
    }
    constructor(iconReg) {
        this.iconReg = iconReg;
        this.showFolder = false;
        this.nestedListItemExpanded = new Subject();
        this.nestedListItemSelected = new Subject();
        this.linkItemClicked = new Subject();
        this.completeRowHover = false;
        this.truncateFolders = true;
        this.truncateLinks = true;
        this.hoverMode = 'row';
        this._borderVisible = false;
        this._nestedListType = 'regular';
        iconReg.register(SieIcon.Folder);
        iconReg.register(SieIcon.FolderOpen);
        iconReg.register(SieIcon.Dropdown);
        iconReg.register(SieIcon.Notification);
        iconReg.register(SieIcon.CheckMark);
    }
    toggleItemSelection(event, item) {
        event.stopPropagation();
        this.nestedListItemSelected.next(item);
    }
    toggleSublist(expandableState, item) {
        if (expandableState) {
            item.expanded = false;
        }
        else {
            item.expanded = true;
            this.nestedListItemExpanded.next(item);
        }
    }
    toggleSublistAndItemSelection(event, item) {
        this.toggleSublist(item?.expanded, item);
        this.toggleItemSelection(event, item);
    }
    onLinkItemClicked(event, item) {
        this.nestedListItemSelected.next(item);
        this.linkItemClicked.next({ event, item });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiNestedListItemComponent, deps: [{ token: i1.SieIconRegistryService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiNestedListItemComponent, selector: "sie-ui-nested-list-item", inputs: { nestedListItem: "nestedListItem", itemLevel: "itemLevel", selected: "selected", showFolder: "showFolder", nestedListType: "nestedListType", borderVisible: "borderVisible", completeRowHover: "completeRowHover", truncateFolders: "truncateFolders", truncateLinks: "truncateLinks" }, outputs: { nestedListItemExpanded: "nestedListItemExpanded", nestedListItemSelected: "nestedListItemSelected", linkItemClicked: "linkItemClicked" }, ngImport: i0, template: "<li\n  class=\"nested-list-item nested-list-item--{{ nestedListType }}\"\n  [ngClass]=\"{ 'border-visible': borderVisible, truncate: truncateFolders }\"\n>\n  <ng-container *ngIf=\"nestedListItem?.collapsable; else linkItem\">\n    <ng-container *ngIf=\"nestedListType !== 'dropdown'; else combinedFolder\">\n      <div\n        class=\"nested-list-item__wrapper nested-list-item__folder-wrapper nested-list-item__folder-wrapper--{{\n          hoverMode\n        }}\"\n        [ngClass]=\"[\n          truncateFolders ? 'truncate' : '',\n          !nestedListItem?.itemLink ? 'no-link' : '',\n          nestedListItem?.notifications ? 'notifications' : ''\n        ]\"\n        [style.padding-left.px]=\"paddingLeft\"\n      >\n        <div\n          class=\"nested-list-item__folder--selectable\"\n          [ngClass]=\"{ truncate: truncateFolders }\"\n          [tabIndex]=\"!nestedListItem?.itemLink ? 0 : -1\"\n          (keydown.enter)=\"!nestedListItem?.itemLink ? toggleSublistAndItemSelection($event, nestedListItem) : null\"\n        >\n          <div\n            class=\"nested-list-item__dropdown-icon\"\n            [ngClass]=\"{ expanded: nestedListItem?.expanded }\"\n            [tabindex]=\"nestedListItem?.itemLink ? 0 : -1\"\n            (click)=\"toggleSublistAndItemSelection($event, nestedListItem)\"\n            (keydown.enter)=\"nestedListItem?.itemLink ? toggleSublistAndItemSelection($event, nestedListItem) : null\"\n          >\n            <sie-icon [name]=\"iconReg.sieIcon.Dropdown\"></sie-icon>\n          </div>\n          <div\n            *ngIf=\"!nestedListItem?.itemLink; else collapsableLinkItem\"\n            class=\"nested-list-item__dropdown-label\"\n            [ngClass]=\"{ truncate: truncateFolders, 'expanded-label': nestedListItem?.expanded }\"\n            (click)=\"toggleSublistAndItemSelection($event, nestedListItem)\"\n          >\n            <ng-template [ngTemplateOutlet]=\"labelAndIcons\"></ng-template>\n          </div>\n        </div>\n      </div>\n    </ng-container>\n  </ng-container>\n  <ng-container *ngIf=\"nestedListItem?.date && nestedListType === 'table'\">\n    <div class=\"nested-list-item__date-wrapper\">{{ nestedListItem?.date }}</div>\n  </ng-container>\n  <ng-container *ngIf=\"nestedListItem?.notifications && nestedListType === 'table'\">\n    <div class=\"nested-list-item__notification-wrapper\">\n      <sie-icon [name]=\"iconReg.sieIcon.Notification\"></sie-icon>\n    </div>\n  </ng-container>\n</li>\n\n<ng-template #linkItem>\n  <div\n    *ngIf=\"nestedListType !== 'dropdown'; else combinedFolder\"\n    class=\"nested-list-item__wrapper nested-list-item__link-wrapper\"\n    [ngClass]=\"[truncateFolders ? 'truncate' : '']\"\n    [style.padding-left.px]=\"paddingLeft\"\n  >\n    <div class=\"nested-list-item__link-inner-wrapper\">\n      <sie-ui-link\n        [truncate]=\"truncateLinks\"\n        [href]=\"nestedListItem?.itemLink\"\n        [type]=\"nestedListItem?.itemLink ? 'link' : 'button'\"\n        [icon]=\"nestedListItem?.linkIcon\"\n        (clicked)=\"onLinkItemClicked($event, nestedListItem)\"\n        [cssClass]=\"'no-padding nested-list-link ' + (selected ? 'bold' : '')\"\n        >{{ nestedListItem?.itemTitle }}</sie-ui-link\n      >\n    </div>\n  </div>\n</ng-template>\n\n<ng-template #collapsableLinkItem>\n  <a\n    rel=\"noopener\"\n    [tabindex]=\"0\"\n    class=\"nested-list-item__dropdown-label link\"\n    [ngClass]=\"{ truncate: truncateFolders, 'expanded-label': nestedListItem?.expanded }\"\n    [href]=\"nestedListItem?.itemLink\"\n    [target]=\"'_blank'\"\n    (mousedown)=\"toggleSublistAndItemSelection($event, nestedListItem)\"\n    (keydown.enter)=\"toggleSublistAndItemSelection($event, nestedListItem)\"\n  >\n    <ng-template [ngTemplateOutlet]=\"labelAndIcons\"></ng-template>\n  </a>\n</ng-template>\n\n<ng-template #combinedFolder>\n  <div\n    class=\"nested-list-item__wrapper nested-list-item__folder-wrapper nested-list-item__folder-wrapper--{{ hoverMode }}\"\n    [style.padding-left.px]=\"paddingLeft\"\n  >\n    <div class=\"nested-list-item__folder\" [ngClass]=\"{ truncate: truncateFolders }\">\n      <div class=\"nested-list-item__folder--selectable\" [ngClass]=\"{ truncate: truncateFolders }\">\n        <div\n          *ngIf=\"nestedListItem?.collapsable\"\n          class=\"nested-list-item__dropdown-icon\"\n          [ngClass]=\"{ expanded: nestedListItem?.expanded }\"\n          (click)=\"toggleSublist(nestedListItem?.expanded, nestedListItem)\"\n          (keydown.enter)=\"toggleSublist(nestedListItem?.expanded, nestedListItem)\"\n          [tabIndex]=\"0\"\n        >\n          <sie-icon [name]=\"iconReg.sieIcon.Dropdown\"></sie-icon>\n        </div>\n        <span\n          class=\"nested-list-item__folder-item\"\n          [ngClass]=\"{ 'non-collapsable': !nestedListItem?.collapsable }\"\n          (click)=\"toggleItemSelection($event, nestedListItem)\"\n          (keydown.enter)=\"toggleItemSelection($event, nestedListItem)\"\n          [tabIndex]=\"0\"\n        >\n          <sie-icon\n            *ngIf=\"nestedListItem?.expanded && showFolder; else folderClosed\"\n            [name]=\"iconReg.sieIcon.FolderOpen\"\n          ></sie-icon>\n          <span class=\"nested-list-item__title\">{{ nestedListItem?.itemTitle }}</span>\n\n          <sie-icon *ngIf=\"selected\" [name]=\"iconReg.sieIcon.CheckMark\" class=\"nested-list-item__selected\"></sie-icon>\n        </span>\n      </div>\n    </div>\n  </div>\n</ng-template>\n\n<ng-template #folderClosed>\n  <sie-icon *ngIf=\"showFolder\" [name]=\"iconReg.sieIcon.Folder\"></sie-icon>\n</ng-template>\n\n<ng-template #labelAndIcons>\n  <sie-icon\n    *ngIf=\"nestedListItem?.expanded && showFolder; else folderClosed\"\n    [ngClass]=\"{ truncate: truncateFolders }\"\n    [name]=\"iconReg.sieIcon.FolderOpen\"\n  ></sie-icon>\n  <div class=\"nested-list-item__title-wrapper\">\n    <span\n      class=\"nested-list-item__title\"\n      [ngClass]=\"{\n        truncate: truncateFolders,\n        bold: selected && nestedListItem?.expanded && nestedListType === 'regular'\n      }\"\n      (click)=\"nestedListType === 'dropdown' ? toggleItemSelection($event, nestedListItem) : null\"\n      (keydown.enter)=\"nestedListType === 'dropdown' ? toggleItemSelection($event, nestedListItem) : null\"\n      >{{ nestedListItem?.itemTitle }}</span\n    >\n  </div>\n</ng-template>\n", styles: [".nested-list-item--dropdown .nested-list-item__folder-item,.nested-list-item--regular .nested-list-item__folder-wrapper .nested-list-item__dropdown-label,.nested-list-item--table .nested-list-item__folder-wrapper .nested-list-item__dropdown-label,.nested-list-item--dropdown .nested-list-item__folder-wrapper .nested-list-item__dropdown-label,.nested-list-item--regular .nested-list-item__folder-wrapper .nested-list-item__folder--selectable,.nested-list-item--table .nested-list-item__folder-wrapper .nested-list-item__folder--selectable,.nested-list-item--dropdown .nested-list-item__folder-wrapper .nested-list-item__folder--selectable,.nested-list-item--table .nested-list-item__dropdown-label.link,.nested-list-item__dropdown-icon{outline:none;outline-offset:0}@media (pointer: fine){.nested-list-item--dropdown .nested-list-item__folder-item,.nested-list-item--regular .nested-list-item__folder-wrapper .nested-list-item__dropdown-label,.nested-list-item--table .nested-list-item__folder-wrapper .nested-list-item__dropdown-label,.nested-list-item--dropdown .nested-list-item__folder-wrapper .nested-list-item__dropdown-label,.nested-list-item--regular .nested-list-item__folder-wrapper .nested-list-item__folder--selectable,.nested-list-item--table .nested-list-item__folder-wrapper .nested-list-item__folder--selectable,.nested-list-item--dropdown .nested-list-item__folder-wrapper .nested-list-item__folder--selectable,.nested-list-item--table .nested-list-item__dropdown-label.link,.nested-list-item__dropdown-icon{position:relative}.nested-list-item--dropdown .nested-list-item__folder-item:focus,.nested-list-item--regular .nested-list-item__folder-wrapper .nested-list-item__dropdown-label:focus,.nested-list-item--table .nested-list-item__folder-wrapper .nested-list-item__dropdown-label:focus,.nested-list-item--dropdown .nested-list-item__folder-wrapper .nested-list-item__dropdown-label:focus,.nested-list-item--regular .nested-list-item__folder-wrapper .nested-list-item__folder--selectable:focus,.nested-list-item--table .nested-list-item__folder-wrapper .nested-list-item__folder--selectable:focus,.nested-list-item--dropdown .nested-list-item__folder-wrapper .nested-list-item__folder--selectable:focus,.nested-list-item--table .nested-list-item__dropdown-label.link:focus,.nested-list-item__dropdown-icon:focus{outline:1px solid #1491eb;outline-offset:2px}.nested-list-item--dropdown .nested-list-item__folder-item:focus:not(:focus-visible),.nested-list-item--regular .nested-list-item__folder-wrapper .nested-list-item__dropdown-label:focus:not(:focus-visible),.nested-list-item--table .nested-list-item__folder-wrapper .nested-list-item__dropdown-label:focus:not(:focus-visible),.nested-list-item--dropdown .nested-list-item__folder-wrapper .nested-list-item__dropdown-label:focus:not(:focus-visible),.nested-list-item--regular .nested-list-item__folder-wrapper .nested-list-item__folder--selectable:focus:not(:focus-visible),.nested-list-item--table .nested-list-item__folder-wrapper .nested-list-item__folder--selectable:focus:not(:focus-visible),.nested-list-item--dropdown .nested-list-item__folder-wrapper .nested-list-item__folder--selectable:focus:not(:focus-visible),.nested-list-item--table .nested-list-item__dropdown-label.link:focus:not(:focus-visible),.nested-list-item__dropdown-icon:focus:not(:focus-visible){outline:0}.nested-list-item--dropdown .nested-list-item__folder-item:focus-visible,.nested-list-item--regular .nested-list-item__folder-wrapper .nested-list-item__dropdown-label:focus-visible,.nested-list-item--table .nested-list-item__folder-wrapper .nested-list-item__dropdown-label:focus-visible,.nested-list-item--dropdown .nested-list-item__folder-wrapper .nested-list-item__dropdown-label:focus-visible,.nested-list-item--regular .nested-list-item__folder-wrapper .nested-list-item__folder--selectable:focus-visible,.nested-list-item--table .nested-list-item__folder-wrapper .nested-list-item__folder--selectable:focus-visible,.nested-list-item--dropdown .nested-list-item__folder-wrapper .nested-list-item__folder--selectable:focus-visible,.nested-list-item--table .nested-list-item__dropdown-label.link:focus-visible,.nested-list-item__dropdown-icon:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}.nested-list-item{display:flex;box-sizing:border-box;align-items:center}.nested-list-item.border-visible{border-bottom:1px solid #ccccd4}.nested-list-item__dropdown-icon{height:16px;width:16px;display:inline;position:relative;margin-top:2px}.nested-list-item__dropdown-icon svg{position:relative;height:16px;width:16px;transition:transform .12s cubic-bezier(.4,0,.3,1);transform:translateZ(0) rotate(-90deg)}.nested-list-item__dropdown-icon.expanded{color:#000028}.nested-list-item__dropdown-icon.expanded svg{transform:translateZ(0) rotate(0)}.nested-list-item__dropdown-icon:hover{cursor:pointer;color:#00646e}.nested-list-item--table{height:28px;min-width:546px}@media (max-width: 1023.78px){.nested-list-item--table{height:30px}}.nested-list-item--table .nested-list-item__dropdown-label.link{color:inherit}.nested-list-item--table .nested-list-item__notification-wrapper{width:20%;-webkit-user-select:none;user-select:none}.nested-list-item--table .nested-list-item__notification-wrapper sie-icon{width:24px;height:24px;display:flex;align-items:center;fill:currentColor}.nested-list-item--table .nested-list-item__notification-wrapper sie-icon svg{fill:currentColor;width:inherit;height:inherit}.nested-list-item--table .nested-list-item__notification-wrapper sie-icon svg g{fill:currentColor;width:inherit;height:inherit}.nested-list-item--table .nested-list-item__notification-wrapper sie-icon svg text{font-family:Siemens Sans,sans-serif}.nested-list-item--table .nested-list-item__notification-wrapper sie-icon :hover{fill:#00646e}.nested-list-item--table .nested-list-item__date-wrapper{width:20%}.nested-list-item--table .nested-list-item__link-wrapper{width:60%}.nested-list-item--table .nested-list-item__link-wrapper+.nested-list-item__notifications-wrapper{margin-left:20%}.nested-list-item--table .nested-list-item__folder-wrapper{width:60%;padding-right:68px;align-items:center}.nested-list-item--table .nested-list-item__folder-wrapper+.nested-list-item__notification-wrapper{margin-left:20%}.nested-list-item--table .nested-list-item__folder-wrapper.no-link:hover .nested-list-item__dropdown-label{text-decoration:underline;cursor:pointer;color:#005159}.nested-list-item--table .nested-list-item__folder-wrapper.no-link:hover .nested-list-item__dropdown-icon{cursor:pointer;color:#00646e}.nested-list-item--regular{min-width:120px}.nested-list-item--regular .nested-list-item__dropdown-icon:focus-visible{outline-offset:0}.nested-list-item--regular .nested-list-item__dropdown-label.link{color:inherit}.nested-list-item--regular .nested-list-item__folder-wrapper.no-link .nested-list-item__dropdown-label:hover{text-decoration:underline;cursor:pointer;color:#005159}.nested-list-item--regular .nested-list-item__folder-wrapper.no-link .nested-list-item__dropdown-icon:hover{cursor:pointer;color:#00646e}.nested-list-item--regular .nested-list-item__link-wrapper{width:100%}.nested-list-item--regular .nested-list-item__date-wrapper,.nested-list-item--table .nested-list-item__date-wrapper,.nested-list-item--dropdown .nested-list-item__date-wrapper{font-size:.875rem;font-weight:400;line-height:1.25rem}.nested-list-item--regular .nested-list-item__link-inner-wrapper,.nested-list-item--table .nested-list-item__link-inner-wrapper,.nested-list-item--dropdown .nested-list-item__link-inner-wrapper{display:flex}.nested-list-item--regular .nested-list-item__link-wrapper,.nested-list-item--table .nested-list-item__link-wrapper,.nested-list-item--dropdown .nested-list-item__link-wrapper{line-height:20px;box-sizing:border-box;padding-right:68px}.nested-list-item--regular .nested-list-item__link-wrapper.truncate,.nested-list-item--table .nested-list-item__link-wrapper.truncate,.nested-list-item--dropdown .nested-list-item__link-wrapper.truncate{padding-right:5px;overflow:hidden}.nested-list-item--regular .nested-list-item__folder-wrapper,.nested-list-item--table .nested-list-item__folder-wrapper,.nested-list-item--dropdown .nested-list-item__folder-wrapper{box-sizing:border-box;padding-right:5px;display:flex}.nested-list-item--regular .nested-list-item__folder-wrapper sie-icon,.nested-list-item--table .nested-list-item__folder-wrapper sie-icon,.nested-list-item--dropdown .nested-list-item__folder-wrapper sie-icon{width:16px;height:16px;display:flex;align-items:center;fill:currentColor;position:relative}.nested-list-item--regular .nested-list-item__folder-wrapper sie-icon svg,.nested-list-item--table .nested-list-item__folder-wrapper sie-icon svg,.nested-list-item--dropdown .nested-list-item__folder-wrapper sie-icon svg{fill:currentColor;width:inherit;height:inherit}.nested-list-item--regular .nested-list-item__folder-wrapper sie-icon svg g,.nested-list-item--table .nested-list-item__folder-wrapper sie-icon svg g,.nested-list-item--dropdown .nested-list-item__folder-wrapper sie-icon svg g{fill:currentColor;width:inherit;height:inherit}.nested-list-item--regular .nested-list-item__folder-wrapper sie-icon svg text,.nested-list-item--table .nested-list-item__folder-wrapper sie-icon svg text,.nested-list-item--dropdown .nested-list-item__folder-wrapper sie-icon svg text{font-family:Siemens Sans,sans-serif}.nested-list-item--regular .nested-list-item__folder-wrapper.truncate,.nested-list-item--table .nested-list-item__folder-wrapper.truncate,.nested-list-item--dropdown .nested-list-item__folder-wrapper.truncate{align-items:center}.nested-list-item--regular .nested-list-item__folder-wrapper .nested-list-item__title,.nested-list-item--table .nested-list-item__folder-wrapper .nested-list-item__title,.nested-list-item--dropdown .nested-list-item__folder-wrapper .nested-list-item__title{font-size:.875rem;font-weight:400;line-height:1.25rem;margin-left:4px}.nested-list-item--regular .nested-list-item__folder-wrapper .nested-list-item__title.bold,.nested-list-item--table .nested-list-item__folder-wrapper .nested-list-item__title.bold,.nested-list-item--dropdown .nested-list-item__folder-wrapper .nested-list-item__title.bold{font-weight:700}.nested-list-item--regular .nested-list-item__folder-wrapper .nested-list-item__folder,.nested-list-item--table .nested-list-item__folder-wrapper .nested-list-item__folder,.nested-list-item--dropdown .nested-list-item__folder-wrapper .nested-list-item__folder{position:relative;min-width:100%;-webkit-user-select:none;user-select:none;display:flex;align-items:flex-start}.nested-list-item--regular .nested-list-item__folder-wrapper .nested-list-item__folder.truncate,.nested-list-item--table .nested-list-item__folder-wrapper .nested-list-item__folder.truncate,.nested-list-item--dropdown .nested-list-item__folder-wrapper .nested-list-item__folder.truncate{white-space:nowrap;overflow:hidden;text-overflow:ellipsis;display:block}.nested-list-item--regular .nested-list-item__folder-wrapper .nested-list-item__folder:hover,.nested-list-item--table .nested-list-item__folder-wrapper .nested-list-item__folder:hover,.nested-list-item--dropdown .nested-list-item__folder-wrapper .nested-list-item__folder:hover{cursor:pointer}.nested-list-item--regular .nested-list-item__folder-wrapper .nested-list-item__folder--selectable,.nested-list-item--table .nested-list-item__folder-wrapper .nested-list-item__folder--selectable,.nested-list-item--dropdown .nested-list-item__folder-wrapper .nested-list-item__folder--selectable{display:flex}.nested-list-item--regular .nested-list-item__folder-wrapper .nested-list-item__folder--selectable .nested-list-item__title,.nested-list-item--table .nested-list-item__folder-wrapper .nested-list-item__folder--selectable .nested-list-item__title,.nested-list-item--dropdown .nested-list-item__folder-wrapper .nested-list-item__folder--selectable .nested-list-item__title{min-width:0}.nested-list-item--regular .nested-list-item__folder-wrapper .nested-list-item__folder--selectable .nested-list-item__title-wrapper,.nested-list-item--table .nested-list-item__folder-wrapper .nested-list-item__folder--selectable .nested-list-item__title-wrapper,.nested-list-item--dropdown .nested-list-item__folder-wrapper .nested-list-item__folder--selectable .nested-list-item__title-wrapper{display:inline-grid;width:100%}.nested-list-item--regular .nested-list-item__folder-wrapper .nested-list-item__folder--selectable .nested-list-item__title.truncate,.nested-list-item--table .nested-list-item__folder-wrapper .nested-list-item__folder--selectable .nested-list-item__title.truncate,.nested-list-item--dropdown .nested-list-item__folder-wrapper .nested-list-item__folder--selectable .nested-list-item__title.truncate{white-space:nowrap;overflow:hidden;text-overflow:ellipsis}.nested-list-item--regular .nested-list-item__folder-wrapper .nested-list-item__folder--selectable .nested-list-item__dropdown-icon,.nested-list-item--table .nested-list-item__folder-wrapper .nested-list-item__folder--selectable .nested-list-item__dropdown-icon,.nested-list-item--dropdown .nested-list-item__folder-wrapper .nested-list-item__folder--selectable .nested-list-item__dropdown-icon{outline-offset:0}.nested-list-item--regular .nested-list-item__folder-wrapper .nested-list-item__dropdown-label,.nested-list-item--table .nested-list-item__folder-wrapper .nested-list-item__dropdown-label,.nested-list-item--dropdown .nested-list-item__folder-wrapper .nested-list-item__dropdown-label{display:flex;align-items:center}.nested-list-item--regular .nested-list-item__folder-wrapper .nested-list-item__dropdown-label:hover,.nested-list-item--table .nested-list-item__folder-wrapper .nested-list-item__dropdown-label:hover,.nested-list-item--dropdown .nested-list-item__folder-wrapper .nested-list-item__dropdown-label:hover{text-decoration:underline;cursor:pointer;color:#005159}.nested-list-item--dropdown.truncate .nested-list-item__folder-item{overflow:hidden}.nested-list-item--dropdown.truncate .nested-list-item__title{white-space:nowrap;overflow:hidden;text-overflow:ellipsis}.nested-list-item--dropdown .nested-list-item__folder{padding-left:8px}.nested-list-item--dropdown .nested-list-item__folder--selectable{width:100%}.nested-list-item--dropdown .nested-list-item__folder-item{display:flex;width:100%}.nested-list-item--dropdown .nested-list-item__folder-item:focus-visible{outline-offset:-1px}.nested-list-item--dropdown .nested-list-item__folder-item .nested-list-item__title{width:100%}.nested-list-item--dropdown .nested-list-item__folder-item.non-collapsable{padding-left:16px}@media (pointer: coarse){.nested-list-item--dropdown .nested-list-item__folder-item.non-collapsable{padding-left:20px}}.nested-list-item--dropdown .nested-list-item__folder-item sie-icon{margin-right:4px;margin-top:2px}.nested-list-item--dropdown .nested-list-item__folder-wrapper--row:hover{background-color:#62eec7;cursor:pointer}.nested-list-item--dropdown .nested-list-item__dropdown-icon:focus-visible{outline-offset:-1px}.nested-list-item--dropdown .nested-list-item__selected{margin-left:16px;width:16px;height:16px}@media (max-width: 1023.78px){.nested-list-item--dropdown .nested-list-item__selected{width:20px}}.nested-list-item--dropdown .nested-list-item__selected svg{width:16px;height:16px}.nested-list-item--dropdown .nested-list-item__wrapper{display:block;padding-top:2px;padding-bottom:2px;padding-right:10px;width:100%}.nested-list-item--dropdown .nested-list-item__wrapper .nested-list-item__dropdown-label{width:100%}.nested-list-item--dropdown .nested-list-item__wrapper .nested-list-item__dropdown-icon:hover{color:#000028}.nested-list-item--dropdown .nested-list-item__wrapper.no-link:hover .nested-list-item__dropdown-label:hover{text-decoration:none;font-weight:400;cursor:pointer;color:#000028}.nested-list-item--dropdown .nested-list-item__wrapper.no-link:hover .nested-list-item__dropdown-icon{cursor:pointer;color:#00646e}@media (pointer: coarse){.nested-list-item.nested-list-item--regular .nested-list-item__dropdown-icon,.nested-list-item.nested-list-item--table .nested-list-item__dropdown-icon,.nested-list-item.nested-list-item--dropdown .nested-list-item__dropdown-icon{height:20px;width:20px}.nested-list-item.nested-list-item--regular .nested-list-item__dropdown-icon sie-icon,.nested-list-item.nested-list-item--table .nested-list-item__dropdown-icon sie-icon,.nested-list-item.nested-list-item--dropdown .nested-list-item__dropdown-icon sie-icon{width:20px;height:20px;display:flex;align-items:center;fill:currentColor}.nested-list-item.nested-list-item--regular .nested-list-item__dropdown-icon sie-icon svg,.nested-list-item.nested-list-item--table .nested-list-item__dropdown-icon sie-icon svg,.nested-list-item.nested-list-item--dropdown .nested-list-item__dropdown-icon sie-icon svg{fill:currentColor;width:inherit;height:inherit}.nested-list-item.nested-list-item--regular .nested-list-item__dropdown-icon sie-icon svg g,.nested-list-item.nested-list-item--table .nested-list-item__dropdown-icon sie-icon svg g,.nested-list-item.nested-list-item--dropdown .nested-list-item__dropdown-icon sie-icon svg g{fill:currentColor;width:inherit;height:inherit}.nested-list-item.nested-list-item--regular .nested-list-item__dropdown-icon sie-icon svg text,.nested-list-item.nested-list-item--table .nested-list-item__dropdown-icon sie-icon svg text,.nested-list-item.nested-list-item--dropdown .nested-list-item__dropdown-icon sie-icon svg text{font-family:Siemens Sans,sans-serif}.nested-list-item.nested-list-item--regular .nested-list-item__date-wrapper,.nested-list-item.nested-list-item--table .nested-list-item__date-wrapper,.nested-list-item.nested-list-item--dropdown .nested-list-item__date-wrapper{font-size:1rem;font-weight:400;line-height:1.5rem}.nested-list-item.nested-list-item--regular .nested-list-item__link-wrapper,.nested-list-item.nested-list-item--table .nested-list-item__link-wrapper,.nested-list-item.nested-list-item--dropdown .nested-list-item__link-wrapper{line-height:24px}.nested-list-item.nested-list-item--regular .nested-list-item__title,.nested-list-item.nested-list-item--table .nested-list-item__title,.nested-list-item.nested-list-item--dropdown .nested-list-item__title{font-size:1rem;font-weight:400;line-height:1.5rem;margin-left:6px}.nested-list-item.nested-list-item--dropdown .nested-list-item__folder-item sie-icon{margin-top:4px}}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "component", type: UiLinkComponent, selector: "sie-ui-link", inputs: ["disabled", "disableVisitedStyle", "hasMarginTop", "offsetIcon", "truncate", "inLinkList", "trailingIcon", "icon", "cssClass", "href", "size", "target", "variant", "background", "type", "reference", "screenReaderText", "secondaryLabel", "download", "dataAttributes", "tooltip", "buttonType"], outputs: ["clicked"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiNestedListItemComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-nested-list-item', changeDetection: ChangeDetectionStrategy.OnPush, template: "<li\n  class=\"nested-list-item nested-list-item--{{ nestedListType }}\"\n  [ngClass]=\"{ 'border-visible': borderVisible, truncate: truncateFolders }\"\n>\n  <ng-container *ngIf=\"nestedListItem?.collapsable; else linkItem\">\n    <ng-container *ngIf=\"nestedListType !== 'dropdown'; else combinedFolder\">\n      <div\n        class=\"nested-list-item__wrapper nested-list-item__folder-wrapper nested-list-item__folder-wrapper--{{\n          hoverMode\n        }}\"\n        [ngClass]=\"[\n          truncateFolders ? 'truncate' : '',\n          !nestedListItem?.itemLink ? 'no-link' : '',\n          nestedListItem?.notifications ? 'notifications' : ''\n        ]\"\n        [style.padding-left.px]=\"paddingLeft\"\n      >\n        <div\n          class=\"nested-list-item__folder--selectable\"\n          [ngClass]=\"{ truncate: truncateFolders }\"\n          [tabIndex]=\"!nestedListItem?.itemLink ? 0 : -1\"\n          (keydown.enter)=\"!nestedListItem?.itemLink ? toggleSublistAndItemSelection($event, nestedListItem) : null\"\n        >\n          <div\n            class=\"nested-list-item__dropdown-icon\"\n            [ngClass]=\"{ expanded: nestedListItem?.expanded }\"\n            [tabindex]=\"nestedListItem?.itemLink ? 0 : -1\"\n            (click)=\"toggleSublistAndItemSelection($event, nestedListItem)\"\n            (keydown.enter)=\"nestedListItem?.itemLink ? toggleSublistAndItemSelection($event, nestedListItem) : null\"\n          >\n            <sie-icon [name]=\"iconReg.sieIcon.Dropdown\"></sie-icon>\n          </div>\n          <div\n            *ngIf=\"!nestedListItem?.itemLink; else collapsableLinkItem\"\n            class=\"nested-list-item__dropdown-label\"\n            [ngClass]=\"{ truncate: truncateFolders, 'expanded-label': nestedListItem?.expanded }\"\n            (click)=\"toggleSublistAndItemSelection($event, nestedListItem)\"\n          >\n            <ng-template [ngTemplateOutlet]=\"labelAndIcons\"></ng-template>\n          </div>\n        </div>\n      </div>\n    </ng-container>\n  </ng-container>\n  <ng-container *ngIf=\"nestedListItem?.date && nestedListType === 'table'\">\n    <div class=\"nested-list-item__date-wrapper\">{{ nestedListItem?.date }}</div>\n  </ng-container>\n  <ng-container *ngIf=\"nestedListItem?.notifications && nestedListType === 'table'\">\n    <div class=\"nested-list-item__notification-wrapper\">\n      <sie-icon [name]=\"iconReg.sieIcon.Notification\"></sie-icon>\n    </div>\n  </ng-container>\n</li>\n\n<ng-template #linkItem>\n  <div\n    *ngIf=\"nestedListType !== 'dropdown'; else combinedFolder\"\n    class=\"nested-list-item__wrapper nested-list-item__link-wrapper\"\n    [ngClass]=\"[truncateFolders ? 'truncate' : '']\"\n    [style.padding-left.px]=\"paddingLeft\"\n  >\n    <div class=\"nested-list-item__link-inner-wrapper\">\n      <sie-ui-link\n        [truncate]=\"truncateLinks\"\n        [href]=\"nestedListItem?.itemLink\"\n        [type]=\"nestedListItem?.itemLink ? 'link' : 'button'\"\n        [icon]=\"nestedListItem?.linkIcon\"\n        (clicked)=\"onLinkItemClicked($event, nestedListItem)\"\n        [cssClass]=\"'no-padding nested-list-link ' + (selected ? 'bold' : '')\"\n        >{{ nestedListItem?.itemTitle }}</sie-ui-link\n      >\n    </div>\n  </div>\n</ng-template>\n\n<ng-template #collapsableLinkItem>\n  <a\n    rel=\"noopener\"\n    [tabindex]=\"0\"\n    class=\"nested-list-item__dropdown-label link\"\n    [ngClass]=\"{ truncate: truncateFolders, 'expanded-label': nestedListItem?.expanded }\"\n    [href]=\"nestedListItem?.itemLink\"\n    [target]=\"'_blank'\"\n    (mousedown)=\"toggleSublistAndItemSelection($event, nestedListItem)\"\n    (keydown.enter)=\"toggleSublistAndItemSelection($event, nestedListItem)\"\n  >\n    <ng-template [ngTemplateOutlet]=\"labelAndIcons\"></ng-template>\n  </a>\n</ng-template>\n\n<ng-template #combinedFolder>\n  <div\n    class=\"nested-list-item__wrapper nested-list-item__folder-wrapper nested-list-item__folder-wrapper--{{ hoverMode }}\"\n    [style.padding-left.px]=\"paddingLeft\"\n  >\n    <div class=\"nested-list-item__folder\" [ngClass]=\"{ truncate: truncateFolders }\">\n      <div class=\"nested-list-item__folder--selectable\" [ngClass]=\"{ truncate: truncateFolders }\">\n        <div\n          *ngIf=\"nestedListItem?.collapsable\"\n          class=\"nested-list-item__dropdown-icon\"\n          [ngClass]=\"{ expanded: nestedListItem?.expanded }\"\n          (click)=\"toggleSublist(nestedListItem?.expanded, nestedListItem)\"\n          (keydown.enter)=\"toggleSublist(nestedListItem?.expanded, nestedListItem)\"\n          [tabIndex]=\"0\"\n        >\n          <sie-icon [name]=\"iconReg.sieIcon.Dropdown\"></sie-icon>\n        </div>\n        <span\n          class=\"nested-list-item__folder-item\"\n          [ngClass]=\"{ 'non-collapsable': !nestedListItem?.collapsable }\"\n          (click)=\"toggleItemSelection($event, nestedListItem)\"\n          (keydown.enter)=\"toggleItemSelection($event, nestedListItem)\"\n          [tabIndex]=\"0\"\n        >\n          <sie-icon\n            *ngIf=\"nestedListItem?.expanded && showFolder; else folderClosed\"\n            [name]=\"iconReg.sieIcon.FolderOpen\"\n          ></sie-icon>\n          <span class=\"nested-list-item__title\">{{ nestedListItem?.itemTitle }}</span>\n\n          <sie-icon *ngIf=\"selected\" [name]=\"iconReg.sieIcon.CheckMark\" class=\"nested-list-item__selected\"></sie-icon>\n        </span>\n      </div>\n    </div>\n  </div>\n</ng-template>\n\n<ng-template #folderClosed>\n  <sie-icon *ngIf=\"showFolder\" [name]=\"iconReg.sieIcon.Folder\"></sie-icon>\n</ng-template>\n\n<ng-template #labelAndIcons>\n  <sie-icon\n    *ngIf=\"nestedListItem?.expanded && showFolder; else folderClosed\"\n    [ngClass]=\"{ truncate: truncateFolders }\"\n    [name]=\"iconReg.sieIcon.FolderOpen\"\n  ></sie-icon>\n  <div class=\"nested-list-item__title-wrapper\">\n    <span\n      class=\"nested-list-item__title\"\n      [ngClass]=\"{\n        truncate: truncateFolders,\n        bold: selected && nestedListItem?.expanded && nestedListType === 'regular'\n      }\"\n      (click)=\"nestedListType === 'dropdown' ? toggleItemSelection($event, nestedListItem) : null\"\n      (keydown.enter)=\"nestedListType === 'dropdown' ? toggleItemSelection($event, nestedListItem) : null\"\n      >{{ nestedListItem?.itemTitle }}</span\n    >\n  </div>\n</ng-template>\n", styles: [".nested-list-item--dropdown .nested-list-item__folder-item,.nested-list-item--regular .nested-list-item__folder-wrapper .nested-list-item__dropdown-label,.nested-list-item--table .nested-list-item__folder-wrapper .nested-list-item__dropdown-label,.nested-list-item--dropdown .nested-list-item__folder-wrapper .nested-list-item__dropdown-label,.nested-list-item--regular .nested-list-item__folder-wrapper .nested-list-item__folder--selectable,.nested-list-item--table .nested-list-item__folder-wrapper .nested-list-item__folder--selectable,.nested-list-item--dropdown .nested-list-item__folder-wrapper .nested-list-item__folder--selectable,.nested-list-item--table .nested-list-item__dropdown-label.link,.nested-list-item__dropdown-icon{outline:none;outline-offset:0}@media (pointer: fine){.nested-list-item--dropdown .nested-list-item__folder-item,.nested-list-item--regular .nested-list-item__folder-wrapper .nested-list-item__dropdown-label,.nested-list-item--table .nested-list-item__folder-wrapper .nested-list-item__dropdown-label,.nested-list-item--dropdown .nested-list-item__folder-wrapper .nested-list-item__dropdown-label,.nested-list-item--regular .nested-list-item__folder-wrapper .nested-list-item__folder--selectable,.nested-list-item--table .nested-list-item__folder-wrapper .nested-list-item__folder--selectable,.nested-list-item--dropdown .nested-list-item__folder-wrapper .nested-list-item__folder--selectable,.nested-list-item--table .nested-list-item__dropdown-label.link,.nested-list-item__dropdown-icon{position:relative}.nested-list-item--dropdown .nested-list-item__folder-item:focus,.nested-list-item--regular .nested-list-item__folder-wrapper .nested-list-item__dropdown-label:focus,.nested-list-item--table .nested-list-item__folder-wrapper .nested-list-item__dropdown-label:focus,.nested-list-item--dropdown .nested-list-item__folder-wrapper .nested-list-item__dropdown-label:focus,.nested-list-item--regular .nested-list-item__folder-wrapper .nested-list-item__folder--selectable:focus,.nested-list-item--table .nested-list-item__folder-wrapper .nested-list-item__folder--selectable:focus,.nested-list-item--dropdown .nested-list-item__folder-wrapper .nested-list-item__folder--selectable:focus,.nested-list-item--table .nested-list-item__dropdown-label.link:focus,.nested-list-item__dropdown-icon:focus{outline:1px solid #1491eb;outline-offset:2px}.nested-list-item--dropdown .nested-list-item__folder-item:focus:not(:focus-visible),.nested-list-item--regular .nested-list-item__folder-wrapper .nested-list-item__dropdown-label:focus:not(:focus-visible),.nested-list-item--table .nested-list-item__folder-wrapper .nested-list-item__dropdown-label:focus:not(:focus-visible),.nested-list-item--dropdown .nested-list-item__folder-wrapper .nested-list-item__dropdown-label:focus:not(:focus-visible),.nested-list-item--regular .nested-list-item__folder-wrapper .nested-list-item__folder--selectable:focus:not(:focus-visible),.nested-list-item--table .nested-list-item__folder-wrapper .nested-list-item__folder--selectable:focus:not(:focus-visible),.nested-list-item--dropdown .nested-list-item__folder-wrapper .nested-list-item__folder--selectable:focus:not(:focus-visible),.nested-list-item--table .nested-list-item__dropdown-label.link:focus:not(:focus-visible),.nested-list-item__dropdown-icon:focus:not(:focus-visible){outline:0}.nested-list-item--dropdown .nested-list-item__folder-item:focus-visible,.nested-list-item--regular .nested-list-item__folder-wrapper .nested-list-item__dropdown-label:focus-visible,.nested-list-item--table .nested-list-item__folder-wrapper .nested-list-item__dropdown-label:focus-visible,.nested-list-item--dropdown .nested-list-item__folder-wrapper .nested-list-item__dropdown-label:focus-visible,.nested-list-item--regular .nested-list-item__folder-wrapper .nested-list-item__folder--selectable:focus-visible,.nested-list-item--table .nested-list-item__folder-wrapper .nested-list-item__folder--selectable:focus-visible,.nested-list-item--dropdown .nested-list-item__folder-wrapper .nested-list-item__folder--selectable:focus-visible,.nested-list-item--table .nested-list-item__dropdown-label.link:focus-visible,.nested-list-item__dropdown-icon:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}.nested-list-item{display:flex;box-sizing:border-box;align-items:center}.nested-list-item.border-visible{border-bottom:1px solid #ccccd4}.nested-list-item__dropdown-icon{height:16px;width:16px;display:inline;position:relative;margin-top:2px}.nested-list-item__dropdown-icon svg{position:relative;height:16px;width:16px;transition:transform .12s cubic-bezier(.4,0,.3,1);transform:translateZ(0) rotate(-90deg)}.nested-list-item__dropdown-icon.expanded{color:#000028}.nested-list-item__dropdown-icon.expanded svg{transform:translateZ(0) rotate(0)}.nested-list-item__dropdown-icon:hover{cursor:pointer;color:#00646e}.nested-list-item--table{height:28px;min-width:546px}@media (max-width: 1023.78px){.nested-list-item--table{height:30px}}.nested-list-item--table .nested-list-item__dropdown-label.link{color:inherit}.nested-list-item--table .nested-list-item__notification-wrapper{width:20%;-webkit-user-select:none;user-select:none}.nested-list-item--table .nested-list-item__notification-wrapper sie-icon{width:24px;height:24px;display:flex;align-items:center;fill:currentColor}.nested-list-item--table .nested-list-item__notification-wrapper sie-icon svg{fill:currentColor;width:inherit;height:inherit}.nested-list-item--table .nested-list-item__notification-wrapper sie-icon svg g{fill:currentColor;width:inherit;height:inherit}.nested-list-item--table .nested-list-item__notification-wrapper sie-icon svg text{font-family:Siemens Sans,sans-serif}.nested-list-item--table .nested-list-item__notification-wrapper sie-icon :hover{fill:#00646e}.nested-list-item--table .nested-list-item__date-wrapper{width:20%}.nested-list-item--table .nested-list-item__link-wrapper{width:60%}.nested-list-item--table .nested-list-item__link-wrapper+.nested-list-item__notifications-wrapper{margin-left:20%}.nested-list-item--table .nested-list-item__folder-wrapper{width:60%;padding-right:68px;align-items:center}.nested-list-item--table .nested-list-item__folder-wrapper+.nested-list-item__notification-wrapper{margin-left:20%}.nested-list-item--table .nested-list-item__folder-wrapper.no-link:hover .nested-list-item__dropdown-label{text-decoration:underline;cursor:pointer;color:#005159}.nested-list-item--table .nested-list-item__folder-wrapper.no-link:hover .nested-list-item__dropdown-icon{cursor:pointer;color:#00646e}.nested-list-item--regular{min-width:120px}.nested-list-item--regular .nested-list-item__dropdown-icon:focus-visible{outline-offset:0}.nested-list-item--regular .nested-list-item__dropdown-label.link{color:inherit}.nested-list-item--regular .nested-list-item__folder-wrapper.no-link .nested-list-item__dropdown-label:hover{text-decoration:underline;cursor:pointer;color:#005159}.nested-list-item--regular .nested-list-item__folder-wrapper.no-link .nested-list-item__dropdown-icon:hover{cursor:pointer;color:#00646e}.nested-list-item--regular .nested-list-item__link-wrapper{width:100%}.nested-list-item--regular .nested-list-item__date-wrapper,.nested-list-item--table .nested-list-item__date-wrapper,.nested-list-item--dropdown .nested-list-item__date-wrapper{font-size:.875rem;font-weight:400;line-height:1.25rem}.nested-list-item--regular .nested-list-item__link-inner-wrapper,.nested-list-item--table .nested-list-item__link-inner-wrapper,.nested-list-item--dropdown .nested-list-item__link-inner-wrapper{display:flex}.nested-list-item--regular .nested-list-item__link-wrapper,.nested-list-item--table .nested-list-item__link-wrapper,.nested-list-item--dropdown .nested-list-item__link-wrapper{line-height:20px;box-sizing:border-box;padding-right:68px}.nested-list-item--regular .nested-list-item__link-wrapper.truncate,.nested-list-item--table .nested-list-item__link-wrapper.truncate,.nested-list-item--dropdown .nested-list-item__link-wrapper.truncate{padding-right:5px;overflow:hidden}.nested-list-item--regular .nested-list-item__folder-wrapper,.nested-list-item--table .nested-list-item__folder-wrapper,.nested-list-item--dropdown .nested-list-item__folder-wrapper{box-sizing:border-box;padding-right:5px;display:flex}.nested-list-item--regular .nested-list-item__folder-wrapper sie-icon,.nested-list-item--table .nested-list-item__folder-wrapper sie-icon,.nested-list-item--dropdown .nested-list-item__folder-wrapper sie-icon{width:16px;height:16px;display:flex;align-items:center;fill:currentColor;position:relative}.nested-list-item--regular .nested-list-item__folder-wrapper sie-icon svg,.nested-list-item--table .nested-list-item__folder-wrapper sie-icon svg,.nested-list-item--dropdown .nested-list-item__folder-wrapper sie-icon svg{fill:currentColor;width:inherit;height:inherit}.nested-list-item--regular .nested-list-item__folder-wrapper sie-icon svg g,.nested-list-item--table .nested-list-item__folder-wrapper sie-icon svg g,.nested-list-item--dropdown .nested-list-item__folder-wrapper sie-icon svg g{fill:currentColor;width:inherit;height:inherit}.nested-list-item--regular .nested-list-item__folder-wrapper sie-icon svg text,.nested-list-item--table .nested-list-item__folder-wrapper sie-icon svg text,.nested-list-item--dropdown .nested-list-item__folder-wrapper sie-icon svg text{font-family:Siemens Sans,sans-serif}.nested-list-item--regular .nested-list-item__folder-wrapper.truncate,.nested-list-item--table .nested-list-item__folder-wrapper.truncate,.nested-list-item--dropdown .nested-list-item__folder-wrapper.truncate{align-items:center}.nested-list-item--regular .nested-list-item__folder-wrapper .nested-list-item__title,.nested-list-item--table .nested-list-item__folder-wrapper .nested-list-item__title,.nested-list-item--dropdown .nested-list-item__folder-wrapper .nested-list-item__title{font-size:.875rem;font-weight:400;line-height:1.25rem;margin-left:4px}.nested-list-item--regular .nested-list-item__folder-wrapper .nested-list-item__title.bold,.nested-list-item--table .nested-list-item__folder-wrapper .nested-list-item__title.bold,.nested-list-item--dropdown .nested-list-item__folder-wrapper .nested-list-item__title.bold{font-weight:700}.nested-list-item--regular .nested-list-item__folder-wrapper .nested-list-item__folder,.nested-list-item--table .nested-list-item__folder-wrapper .nested-list-item__folder,.nested-list-item--dropdown .nested-list-item__folder-wrapper .nested-list-item__folder{position:relative;min-width:100%;-webkit-user-select:none;user-select:none;display:flex;align-items:flex-start}.nested-list-item--regular .nested-list-item__folder-wrapper .nested-list-item__folder.truncate,.nested-list-item--table .nested-list-item__folder-wrapper .nested-list-item__folder.truncate,.nested-list-item--dropdown .nested-list-item__folder-wrapper .nested-list-item__folder.truncate{white-space:nowrap;overflow:hidden;text-overflow:ellipsis;display:block}.nested-list-item--regular .nested-list-item__folder-wrapper .nested-list-item__folder:hover,.nested-list-item--table .nested-list-item__folder-wrapper .nested-list-item__folder:hover,.nested-list-item--dropdown .nested-list-item__folder-wrapper .nested-list-item__folder:hover{cursor:pointer}.nested-list-item--regular .nested-list-item__folder-wrapper .nested-list-item__folder--selectable,.nested-list-item--table .nested-list-item__folder-wrapper .nested-list-item__folder--selectable,.nested-list-item--dropdown .nested-list-item__folder-wrapper .nested-list-item__folder--selectable{display:flex}.nested-list-item--regular .nested-list-item__folder-wrapper .nested-list-item__folder--selectable .nested-list-item__title,.nested-list-item--table .nested-list-item__folder-wrapper .nested-list-item__folder--selectable .nested-list-item__title,.nested-list-item--dropdown .nested-list-item__folder-wrapper .nested-list-item__folder--selectable .nested-list-item__title{min-width:0}.nested-list-item--regular .nested-list-item__folder-wrapper .nested-list-item__folder--selectable .nested-list-item__title-wrapper,.nested-list-item--table .nested-list-item__folder-wrapper .nested-list-item__folder--selectable .nested-list-item__title-wrapper,.nested-list-item--dropdown .nested-list-item__folder-wrapper .nested-list-item__folder--selectable .nested-list-item__title-wrapper{display:inline-grid;width:100%}.nested-list-item--regular .nested-list-item__folder-wrapper .nested-list-item__folder--selectable .nested-list-item__title.truncate,.nested-list-item--table .nested-list-item__folder-wrapper .nested-list-item__folder--selectable .nested-list-item__title.truncate,.nested-list-item--dropdown .nested-list-item__folder-wrapper .nested-list-item__folder--selectable .nested-list-item__title.truncate{white-space:nowrap;overflow:hidden;text-overflow:ellipsis}.nested-list-item--regular .nested-list-item__folder-wrapper .nested-list-item__folder--selectable .nested-list-item__dropdown-icon,.nested-list-item--table .nested-list-item__folder-wrapper .nested-list-item__folder--selectable .nested-list-item__dropdown-icon,.nested-list-item--dropdown .nested-list-item__folder-wrapper .nested-list-item__folder--selectable .nested-list-item__dropdown-icon{outline-offset:0}.nested-list-item--regular .nested-list-item__folder-wrapper .nested-list-item__dropdown-label,.nested-list-item--table .nested-list-item__folder-wrapper .nested-list-item__dropdown-label,.nested-list-item--dropdown .nested-list-item__folder-wrapper .nested-list-item__dropdown-label{display:flex;align-items:center}.nested-list-item--regular .nested-list-item__folder-wrapper .nested-list-item__dropdown-label:hover,.nested-list-item--table .nested-list-item__folder-wrapper .nested-list-item__dropdown-label:hover,.nested-list-item--dropdown .nested-list-item__folder-wrapper .nested-list-item__dropdown-label:hover{text-decoration:underline;cursor:pointer;color:#005159}.nested-list-item--dropdown.truncate .nested-list-item__folder-item{overflow:hidden}.nested-list-item--dropdown.truncate .nested-list-item__title{white-space:nowrap;overflow:hidden;text-overflow:ellipsis}.nested-list-item--dropdown .nested-list-item__folder{padding-left:8px}.nested-list-item--dropdown .nested-list-item__folder--selectable{width:100%}.nested-list-item--dropdown .nested-list-item__folder-item{display:flex;width:100%}.nested-list-item--dropdown .nested-list-item__folder-item:focus-visible{outline-offset:-1px}.nested-list-item--dropdown .nested-list-item__folder-item .nested-list-item__title{width:100%}.nested-list-item--dropdown .nested-list-item__folder-item.non-collapsable{padding-left:16px}@media (pointer: coarse){.nested-list-item--dropdown .nested-list-item__folder-item.non-collapsable{padding-left:20px}}.nested-list-item--dropdown .nested-list-item__folder-item sie-icon{margin-right:4px;margin-top:2px}.nested-list-item--dropdown .nested-list-item__folder-wrapper--row:hover{background-color:#62eec7;cursor:pointer}.nested-list-item--dropdown .nested-list-item__dropdown-icon:focus-visible{outline-offset:-1px}.nested-list-item--dropdown .nested-list-item__selected{margin-left:16px;width:16px;height:16px}@media (max-width: 1023.78px){.nested-list-item--dropdown .nested-list-item__selected{width:20px}}.nested-list-item--dropdown .nested-list-item__selected svg{width:16px;height:16px}.nested-list-item--dropdown .nested-list-item__wrapper{display:block;padding-top:2px;padding-bottom:2px;padding-right:10px;width:100%}.nested-list-item--dropdown .nested-list-item__wrapper .nested-list-item__dropdown-label{width:100%}.nested-list-item--dropdown .nested-list-item__wrapper .nested-list-item__dropdown-icon:hover{color:#000028}.nested-list-item--dropdown .nested-list-item__wrapper.no-link:hover .nested-list-item__dropdown-label:hover{text-decoration:none;font-weight:400;cursor:pointer;color:#000028}.nested-list-item--dropdown .nested-list-item__wrapper.no-link:hover .nested-list-item__dropdown-icon{cursor:pointer;color:#00646e}@media (pointer: coarse){.nested-list-item.nested-list-item--regular .nested-list-item__dropdown-icon,.nested-list-item.nested-list-item--table .nested-list-item__dropdown-icon,.nested-list-item.nested-list-item--dropdown .nested-list-item__dropdown-icon{height:20px;width:20px}.nested-list-item.nested-list-item--regular .nested-list-item__dropdown-icon sie-icon,.nested-list-item.nested-list-item--table .nested-list-item__dropdown-icon sie-icon,.nested-list-item.nested-list-item--dropdown .nested-list-item__dropdown-icon sie-icon{width:20px;height:20px;display:flex;align-items:center;fill:currentColor}.nested-list-item.nested-list-item--regular .nested-list-item__dropdown-icon sie-icon svg,.nested-list-item.nested-list-item--table .nested-list-item__dropdown-icon sie-icon svg,.nested-list-item.nested-list-item--dropdown .nested-list-item__dropdown-icon sie-icon svg{fill:currentColor;width:inherit;height:inherit}.nested-list-item.nested-list-item--regular .nested-list-item__dropdown-icon sie-icon svg g,.nested-list-item.nested-list-item--table .nested-list-item__dropdown-icon sie-icon svg g,.nested-list-item.nested-list-item--dropdown .nested-list-item__dropdown-icon sie-icon svg g{fill:currentColor;width:inherit;height:inherit}.nested-list-item.nested-list-item--regular .nested-list-item__dropdown-icon sie-icon svg text,.nested-list-item.nested-list-item--table .nested-list-item__dropdown-icon sie-icon svg text,.nested-list-item.nested-list-item--dropdown .nested-list-item__dropdown-icon sie-icon svg text{font-family:Siemens Sans,sans-serif}.nested-list-item.nested-list-item--regular .nested-list-item__date-wrapper,.nested-list-item.nested-list-item--table .nested-list-item__date-wrapper,.nested-list-item.nested-list-item--dropdown .nested-list-item__date-wrapper{font-size:1rem;font-weight:400;line-height:1.5rem}.nested-list-item.nested-list-item--regular .nested-list-item__link-wrapper,.nested-list-item.nested-list-item--table .nested-list-item__link-wrapper,.nested-list-item.nested-list-item--dropdown .nested-list-item__link-wrapper{line-height:24px}.nested-list-item.nested-list-item--regular .nested-list-item__title,.nested-list-item.nested-list-item--table .nested-list-item__title,.nested-list-item.nested-list-item--dropdown .nested-list-item__title{font-size:1rem;font-weight:400;line-height:1.5rem;margin-left:6px}.nested-list-item.nested-list-item--dropdown .nested-list-item__folder-item sie-icon{margin-top:4px}}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }]; }, propDecorators: { nestedListItem: [{
                type: Input
            }], itemLevel: [{
                type: Input
            }], selected: [{
                type: Input
            }], showFolder: [{
                type: Input
            }], nestedListItemExpanded: [{
                type: Output
            }], nestedListItemSelected: [{
                type: Output
            }], linkItemClicked: [{
                type: Output
            }], nestedListType: [{
                type: Input
            }], borderVisible: [{
                type: Input
            }], completeRowHover: [{
                type: Input
            }], truncateFolders: [{
                type: Input
            }], truncateLinks: [{
                type: Input
            }] } });

class UiNestedListItemSkeletonComponent {
    constructor() {
        this.itemLevel = 0;
        this.borderVisible = false;
        this.NUMBER_OF_SKELETONS = 3;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiNestedListItemSkeletonComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiNestedListItemSkeletonComponent, selector: "sie-ui-nested-list-item-skeleton", inputs: { itemLevel: "itemLevel", borderVisible: "borderVisible" }, ngImport: i0, template: "<div\n  class=\"nested-list-item-skeleton\"\n  *sieCoreRepeat=\"NUMBER_OF_SKELETONS\"\n  [ngClass]=\"{ 'border-visible': borderVisible }\"\n>\n  <div class=\"nested-list-item-skeleton--inner\">\n    <div class=\"nested-list-item-skeleton__content\" [style.--item-level]=\"itemLevel\">\n      <sie-ui-skeleton class=\"nested-list-item-skeleton__icon\" [count]=\"2\"></sie-ui-skeleton>\n      <sie-ui-skeleton class=\"nested-list-item-skeleton__text\"></sie-ui-skeleton>\n    </div>\n\n    <sie-ui-skeleton class=\"nested-list-item-skeleton__date\"></sie-ui-skeleton>\n    <sie-ui-skeleton class=\"nested-list-item-skeleton__notifications\"></sie-ui-skeleton>\n  </div>\n</div>\n", styles: [".nested-list-item-skeleton{width:100%;padding-left:8px}.nested-list-item-skeleton--inner{display:flex;align-items:center;margin-top:4px;margin-bottom:8px}.nested-list-item-skeleton.border-visible{border-bottom:1px solid #ccccd4}.nested-list-item-skeleton__content,.nested-list-item-skeleton__icon,.nested-list-item-skeleton__text,.nested-list-item-skeleton__date,.nested-list-item-skeleton__notifications{display:inline-block}.nested-list-item-skeleton__content{height:20px;width:60%;padding-left:calc(12px * var(--item-level))}.nested-list-item-skeleton__date,.nested-list-item-skeleton__notifications{width:20%;height:20px}.nested-list-item-skeleton__icon{--ui-skeleton-marginRight: 4px;--ui-skeleton-heigth: 20px;--ui-skeleton-width: 20px;--ui-skeleton-display: inline-block;height:20px}.nested-list-item-skeleton__text{width:calc(100% - 50px);padding-right:16px;margin-left:2px;height:20px}.nested-list-item-skeleton__date{padding-right:16px;height:20px}.nested-list-item-skeleton__notifications{height:20px;width:20px}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "component", type: UiSkeletonComponent, selector: "sie-ui-skeleton", inputs: ["shape", "loadingText", "ariaLabel", "count"] }, { kind: "directive", type: i1$1.RepeatDirective, selector: "[sieCoreRepeat]", inputs: ["sieCoreRepeat"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiNestedListItemSkeletonComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-nested-list-item-skeleton', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div\n  class=\"nested-list-item-skeleton\"\n  *sieCoreRepeat=\"NUMBER_OF_SKELETONS\"\n  [ngClass]=\"{ 'border-visible': borderVisible }\"\n>\n  <div class=\"nested-list-item-skeleton--inner\">\n    <div class=\"nested-list-item-skeleton__content\" [style.--item-level]=\"itemLevel\">\n      <sie-ui-skeleton class=\"nested-list-item-skeleton__icon\" [count]=\"2\"></sie-ui-skeleton>\n      <sie-ui-skeleton class=\"nested-list-item-skeleton__text\"></sie-ui-skeleton>\n    </div>\n\n    <sie-ui-skeleton class=\"nested-list-item-skeleton__date\"></sie-ui-skeleton>\n    <sie-ui-skeleton class=\"nested-list-item-skeleton__notifications\"></sie-ui-skeleton>\n  </div>\n</div>\n", styles: [".nested-list-item-skeleton{width:100%;padding-left:8px}.nested-list-item-skeleton--inner{display:flex;align-items:center;margin-top:4px;margin-bottom:8px}.nested-list-item-skeleton.border-visible{border-bottom:1px solid #ccccd4}.nested-list-item-skeleton__content,.nested-list-item-skeleton__icon,.nested-list-item-skeleton__text,.nested-list-item-skeleton__date,.nested-list-item-skeleton__notifications{display:inline-block}.nested-list-item-skeleton__content{height:20px;width:60%;padding-left:calc(12px * var(--item-level))}.nested-list-item-skeleton__date,.nested-list-item-skeleton__notifications{width:20%;height:20px}.nested-list-item-skeleton__icon{--ui-skeleton-marginRight: 4px;--ui-skeleton-heigth: 20px;--ui-skeleton-width: 20px;--ui-skeleton-display: inline-block;height:20px}.nested-list-item-skeleton__text{width:calc(100% - 50px);padding-right:16px;margin-left:2px;height:20px}.nested-list-item-skeleton__date{padding-right:16px;height:20px}.nested-list-item-skeleton__notifications{height:20px;width:20px}\n"] }]
        }], propDecorators: { itemLevel: [{
                type: Input
            }], borderVisible: [{
                type: Input
            }] } });

class UiNestedListComponent {
    set foldersLoading(value) {
        this._foldersLoading = coerceBooleanProperty(value);
    }
    get foldersLoading() {
        return this._foldersLoading;
    }
    set showFolder(value) {
        this._showFolder = coerceBooleanProperty(value);
    }
    get showFolder() {
        return this._showFolder;
    }
    set hasHeader(value) {
        this._hasHeader = coerceBooleanProperty(value);
    }
    get hasHeader() {
        return this._hasHeader;
    }
    set borderVisible(value) {
        this._borderVisible = coerceBooleanProperty(value);
    }
    get borderVisible() {
        return this._borderVisible;
    }
    set completeRowHover(value) {
        this._completeRowHover = coerceBooleanProperty(value);
    }
    get completeRowHover() {
        return this._completeRowHover;
    }
    set truncateFolders(value) {
        this._truncateFolders = coerceBooleanProperty(value);
    }
    get truncateFolders() {
        return this._truncateFolders;
    }
    set truncateLinks(value) {
        this._truncateLinks = coerceBooleanProperty(value);
    }
    get truncateLinks() {
        return this._truncateLinks;
    }
    constructor(iconReg, cdr, hostElement) {
        this.iconReg = iconReg;
        this.cdr = cdr;
        this.hostElement = hostElement;
        this.nestedListType = 'regular';
        /** @ignore internal use only */
        this.root = true;
        /** @ignore internal use only */
        this.hierarchyLevel = 0;
        this.headerColumnOneTitle = '';
        this.headerColumnTwoTitle = '';
        this.headerColumnThreeTitle = '';
        this.nestedListItemExpanded = new Subject();
        this.nestedListItemSelected = new Subject();
        this.linkItemClicked = new Subject();
        this._foldersLoading = false;
        this._hasHeader = false;
        this._borderVisible = false;
        this._completeRowHover = false;
        this._truncateFolders = true;
        this._truncateLinks = true;
        this._showFolder = false;
        iconReg.register(SieIcon.Folder);
        iconReg.register(SieIcon.FolderOpen);
        iconReg.register(SieIcon.Dropdown);
    }
    onItemExpanded(nestedListItem, index) {
        this.nestedListItems[index].expanded = nestedListItem.expanded;
        this.nestedListItemExpanded.next(nestedListItem);
    }
    onItemSelectionChanged(nestedListItem) {
        if (this.root) {
            this.selectedNodeId = nestedListItem.itemId;
            this.cdr.detectChanges();
        }
        this.nestedListItemSelected.next(nestedListItem);
    }
    onLinkItemClicked(itemClicked) {
        this.linkItemClicked.next(itemClicked);
    }
    reloadComponent() {
        this.cdr.detectChanges();
    }
    selectNode(nodeId) {
        this.selectedNodeId = nodeId;
        if (nodeId) {
            this.expandTree(this.nestedListItems);
        }
        this.cdr.detectChanges();
    }
    expandTree(items) {
        for (const item of items) {
            if (item.itemId === this.selectedNodeId) {
                if (this.nestedListType === 'regular' && item.collapsable) {
                    item.expanded = true;
                }
                return true;
            }
            const children = item.subItems?.value;
            const found = !!children?.length && this.expandTree(children);
            if (found) {
                item.expanded = true;
                return true;
            }
        }
        return false;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiNestedListComponent, deps: [{ token: i1.SieIconRegistryService }, { token: i0.ChangeDetectorRef }, { token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiNestedListComponent, selector: "sie-ui-nested-list", inputs: { nestedListType: "nestedListType", nestedListItems: "nestedListItems", root: "root", hierarchyLevel: "hierarchyLevel", headerColumnOneTitle: "headerColumnOneTitle", headerColumnTwoTitle: "headerColumnTwoTitle", headerColumnThreeTitle: "headerColumnThreeTitle", selectedNodeId: "selectedNodeId", foldersLoading: "foldersLoading", showFolder: "showFolder", hasHeader: "hasHeader", borderVisible: "borderVisible", completeRowHover: "completeRowHover", truncateFolders: "truncateFolders", truncateLinks: "truncateLinks" }, outputs: { nestedListItemExpanded: "nestedListItemExpanded", nestedListItemSelected: "nestedListItemSelected", linkItemClicked: "linkItemClicked" }, ngImport: i0, template: "<div class=\"nested-list--{{ nestedListType }}-outer-wrapper\" [ngClass]=\"{ root: root }\">\n  <div class=\"nested-list nested-list--{{ nestedListType }}\">\n    <div *ngIf=\"nestedListType === 'table' && hasHeader\" class=\"nested-list__header\">\n      <div class=\"col-1\" sieUiPopover [content]=\"headerColumnOneTitle\" popoverSize=\"s\">{{ headerColumnOneTitle }}</div>\n      <div class=\"col-2\" sieUiPopover [content]=\"headerColumnTwoTitle\" popoverSize=\"xs\">{{ headerColumnTwoTitle }}</div>\n      <div class=\"col-3\" sieUiPopover [content]=\"headerColumnThreeTitle\" popoverSize=\"xs\">\n        {{ headerColumnThreeTitle }}\n      </div>\n    </div>\n    <ul [tabIndex]=\"-1\">\n      <ng-container\n        *ngIf=\"foldersLoading\"\n        [ngTemplateOutlet]=\"loadingSkeleton\"\n        [ngTemplateOutletContext]=\"{ nestedLevel: 0 }\"\n      ></ng-container>\n      <ng-container *ngFor=\"let nestedListItem of nestedListItems; let index = index\">\n        <sie-ui-nested-list-item\n          [nestedListType]=\"nestedListType\"\n          [nestedListItem]=\"nestedListItem\"\n          [borderVisible]=\"borderVisible\"\n          [itemLevel]=\"hierarchyLevel + 1\"\n          [completeRowHover]=\"completeRowHover\"\n          [selected]=\"!!selectedNodeId && selectedNodeId === nestedListItem?.itemId\"\n          (nestedListItemExpanded)=\"onItemExpanded($event, index)\"\n          (nestedListItemSelected)=\"onItemSelectionChanged($event)\"\n          (linkItemClicked)=\"onLinkItemClicked($event)\"\n          [truncateFolders]=\"truncateFolders\"\n          [truncateLinks]=\"truncateLinks\"\n          [showFolder]=\"showFolder\"\n        ></sie-ui-nested-list-item>\n\n        <ul *ngIf=\"nestedListItem.expanded && nestedListItem.subItems | async\" [tabIndex]=\"-1\">\n          <sie-ui-nested-list\n            [root]=\"false\"\n            [nestedListType]=\"nestedListType\"\n            [nestedListItems]=\"nestedListItem.subItems | async\"\n            [borderVisible]=\"borderVisible\"\n            [hierarchyLevel]=\"hierarchyLevel + 1\"\n            [selectedNodeId]=\"selectedNodeId\"\n            [completeRowHover]=\"completeRowHover\"\n            (nestedListItemExpanded)=\"onItemExpanded($event, index)\"\n            (nestedListItemSelected)=\"onItemSelectionChanged($event)\"\n            (linkItemClicked)=\"onLinkItemClicked($event)\"\n            [truncateFolders]=\"truncateFolders\"\n            [truncateLinks]=\"truncateLinks\"\n            [showFolder]=\"showFolder\"\n          ></sie-ui-nested-list>\n        </ul>\n\n        <ng-container\n          *ngIf=\"nestedListItem.expanded && nestedListItem?.childrenLoading | async\"\n          [ngTemplateOutlet]=\"loadingSkeleton\"\n          [ngTemplateOutletContext]=\"{ nestedLevel: 2 }\"\n        >\n        </ng-container>\n      </ng-container>\n    </ul>\n  </div>\n</div>\n\n<ng-template #loadingSkeleton let-nestedLevel=\"nestedLevel\">\n  <sie-ui-nested-list-item-skeleton\n    [itemLevel]=\"hierarchyLevel + nestedLevel\"\n    [borderVisible]=\"borderVisible\"\n  ></sie-ui-nested-list-item-skeleton>\n</ng-template>\n", styles: ["::-webkit-scrollbar-thumb{background-clip:padding-box;background-color:#737389}::-webkit-scrollbar-button{display:none}::-webkit-scrollbar-corner{background-color:transparent}::-webkit-scrollbar{width:16px;height:8px}:host{scrollbar-color:#737389 #fff}:host .dark,:host.dark{scrollbar-color:#ccccd4 #000028}::-webkit-scrollbar-thumb:vertical{border-left:8px solid transparent;border-right:4px solid transparent}::-webkit-scrollbar-thumb:horizontal{border-top:4px solid transparent}::-webkit-scrollbar-track:vertical{border-left:8px solid #fff;background:#ccccd4;border-right:4px solid #fff}::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #ccccd4}.dark::-webkit-scrollbar-thumb,.dark ::-webkit-scrollbar-thumb{background-color:#ccccd4}.dark::-webkit-scrollbar-track:vertical,.dark ::-webkit-scrollbar-track:vertical{background:#737389;border-right:4px solid #000028;border-left:8px solid #000028}.dark::-webkit-scrollbar-track:horizontal,.dark ::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #737389}.nested-list ul{list-style:none;margin:0;padding:0}@media (max-width: 1023.78px){.nested-list--table-outer-wrapper.root{overflow-x:scroll}}.nested-list--regular{min-width:120px}.nested-list--regular ul{display:flex;flex-direction:column;gap:4px}.nested-list--table{min-width:546px;width:100%}.nested-list__header{font-size:1rem;font-weight:700;line-height:1.5rem;height:42px;display:flex;align-items:center;background-color:#00002829;color:#000028}.nested-list__header .col-1,.nested-list__header .col-2,.nested-list__header .col-3{white-space:nowrap;overflow:hidden;text-overflow:ellipsis}.nested-list__header .col-1{padding-left:8px;width:60%}.nested-list__header .col-2{width:20%}.nested-list__header .col-3{padding-right:8px;width:20%}@media (pointer: coarse){.nested-list ul{gap:8px}}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: UiPopoverDirective, selector: "[sieUiPopover]", inputs: ["content", "popoverTemplate", "popoverSize", "popoverPlacement", "popoverAnimation", "popoverPlayAnimation", "popoverAnimationHideAfterTimeoutMS", "popoverLightTheme"] }, { kind: "component", type: UiNestedListComponent, selector: "sie-ui-nested-list", inputs: ["nestedListType", "nestedListItems", "root", "hierarchyLevel", "headerColumnOneTitle", "headerColumnTwoTitle", "headerColumnThreeTitle", "selectedNodeId", "foldersLoading", "showFolder", "hasHeader", "borderVisible", "completeRowHover", "truncateFolders", "truncateLinks"], outputs: ["nestedListItemExpanded", "nestedListItemSelected", "linkItemClicked"] }, { kind: "component", type: UiNestedListItemComponent, selector: "sie-ui-nested-list-item", inputs: ["nestedListItem", "itemLevel", "selected", "showFolder", "nestedListType", "borderVisible", "completeRowHover", "truncateFolders", "truncateLinks"], outputs: ["nestedListItemExpanded", "nestedListItemSelected", "linkItemClicked"] }, { kind: "component", type: UiNestedListItemSkeletonComponent, selector: "sie-ui-nested-list-item-skeleton", inputs: ["itemLevel", "borderVisible"] }, { kind: "pipe", type: i2.AsyncPipe, name: "async" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiNestedListComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-nested-list', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"nested-list--{{ nestedListType }}-outer-wrapper\" [ngClass]=\"{ root: root }\">\n  <div class=\"nested-list nested-list--{{ nestedListType }}\">\n    <div *ngIf=\"nestedListType === 'table' && hasHeader\" class=\"nested-list__header\">\n      <div class=\"col-1\" sieUiPopover [content]=\"headerColumnOneTitle\" popoverSize=\"s\">{{ headerColumnOneTitle }}</div>\n      <div class=\"col-2\" sieUiPopover [content]=\"headerColumnTwoTitle\" popoverSize=\"xs\">{{ headerColumnTwoTitle }}</div>\n      <div class=\"col-3\" sieUiPopover [content]=\"headerColumnThreeTitle\" popoverSize=\"xs\">\n        {{ headerColumnThreeTitle }}\n      </div>\n    </div>\n    <ul [tabIndex]=\"-1\">\n      <ng-container\n        *ngIf=\"foldersLoading\"\n        [ngTemplateOutlet]=\"loadingSkeleton\"\n        [ngTemplateOutletContext]=\"{ nestedLevel: 0 }\"\n      ></ng-container>\n      <ng-container *ngFor=\"let nestedListItem of nestedListItems; let index = index\">\n        <sie-ui-nested-list-item\n          [nestedListType]=\"nestedListType\"\n          [nestedListItem]=\"nestedListItem\"\n          [borderVisible]=\"borderVisible\"\n          [itemLevel]=\"hierarchyLevel + 1\"\n          [completeRowHover]=\"completeRowHover\"\n          [selected]=\"!!selectedNodeId && selectedNodeId === nestedListItem?.itemId\"\n          (nestedListItemExpanded)=\"onItemExpanded($event, index)\"\n          (nestedListItemSelected)=\"onItemSelectionChanged($event)\"\n          (linkItemClicked)=\"onLinkItemClicked($event)\"\n          [truncateFolders]=\"truncateFolders\"\n          [truncateLinks]=\"truncateLinks\"\n          [showFolder]=\"showFolder\"\n        ></sie-ui-nested-list-item>\n\n        <ul *ngIf=\"nestedListItem.expanded && nestedListItem.subItems | async\" [tabIndex]=\"-1\">\n          <sie-ui-nested-list\n            [root]=\"false\"\n            [nestedListType]=\"nestedListType\"\n            [nestedListItems]=\"nestedListItem.subItems | async\"\n            [borderVisible]=\"borderVisible\"\n            [hierarchyLevel]=\"hierarchyLevel + 1\"\n            [selectedNodeId]=\"selectedNodeId\"\n            [completeRowHover]=\"completeRowHover\"\n            (nestedListItemExpanded)=\"onItemExpanded($event, index)\"\n            (nestedListItemSelected)=\"onItemSelectionChanged($event)\"\n            (linkItemClicked)=\"onLinkItemClicked($event)\"\n            [truncateFolders]=\"truncateFolders\"\n            [truncateLinks]=\"truncateLinks\"\n            [showFolder]=\"showFolder\"\n          ></sie-ui-nested-list>\n        </ul>\n\n        <ng-container\n          *ngIf=\"nestedListItem.expanded && nestedListItem?.childrenLoading | async\"\n          [ngTemplateOutlet]=\"loadingSkeleton\"\n          [ngTemplateOutletContext]=\"{ nestedLevel: 2 }\"\n        >\n        </ng-container>\n      </ng-container>\n    </ul>\n  </div>\n</div>\n\n<ng-template #loadingSkeleton let-nestedLevel=\"nestedLevel\">\n  <sie-ui-nested-list-item-skeleton\n    [itemLevel]=\"hierarchyLevel + nestedLevel\"\n    [borderVisible]=\"borderVisible\"\n  ></sie-ui-nested-list-item-skeleton>\n</ng-template>\n", styles: ["::-webkit-scrollbar-thumb{background-clip:padding-box;background-color:#737389}::-webkit-scrollbar-button{display:none}::-webkit-scrollbar-corner{background-color:transparent}::-webkit-scrollbar{width:16px;height:8px}:host{scrollbar-color:#737389 #fff}:host .dark,:host.dark{scrollbar-color:#ccccd4 #000028}::-webkit-scrollbar-thumb:vertical{border-left:8px solid transparent;border-right:4px solid transparent}::-webkit-scrollbar-thumb:horizontal{border-top:4px solid transparent}::-webkit-scrollbar-track:vertical{border-left:8px solid #fff;background:#ccccd4;border-right:4px solid #fff}::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #ccccd4}.dark::-webkit-scrollbar-thumb,.dark ::-webkit-scrollbar-thumb{background-color:#ccccd4}.dark::-webkit-scrollbar-track:vertical,.dark ::-webkit-scrollbar-track:vertical{background:#737389;border-right:4px solid #000028;border-left:8px solid #000028}.dark::-webkit-scrollbar-track:horizontal,.dark ::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #737389}.nested-list ul{list-style:none;margin:0;padding:0}@media (max-width: 1023.78px){.nested-list--table-outer-wrapper.root{overflow-x:scroll}}.nested-list--regular{min-width:120px}.nested-list--regular ul{display:flex;flex-direction:column;gap:4px}.nested-list--table{min-width:546px;width:100%}.nested-list__header{font-size:1rem;font-weight:700;line-height:1.5rem;height:42px;display:flex;align-items:center;background-color:#00002829;color:#000028}.nested-list__header .col-1,.nested-list__header .col-2,.nested-list__header .col-3{white-space:nowrap;overflow:hidden;text-overflow:ellipsis}.nested-list__header .col-1{padding-left:8px;width:60%}.nested-list__header .col-2{width:20%}.nested-list__header .col-3{padding-right:8px;width:20%}@media (pointer: coarse){.nested-list ul{gap:8px}}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }, { type: i0.ChangeDetectorRef }, { type: i0.ElementRef }]; }, propDecorators: { nestedListType: [{
                type: Input
            }], nestedListItems: [{
                type: Input
            }], root: [{
                type: Input
            }], hierarchyLevel: [{
                type: Input
            }], headerColumnOneTitle: [{
                type: Input
            }], headerColumnTwoTitle: [{
                type: Input
            }], headerColumnThreeTitle: [{
                type: Input
            }], selectedNodeId: [{
                type: Input
            }], nestedListItemExpanded: [{
                type: Output
            }], nestedListItemSelected: [{
                type: Output
            }], linkItemClicked: [{
                type: Output
            }], foldersLoading: [{
                type: Input
            }], showFolder: [{
                type: Input
            }], hasHeader: [{
                type: Input
            }], borderVisible: [{
                type: Input
            }], completeRowHover: [{
                type: Input
            }], truncateFolders: [{
                type: Input
            }], truncateLinks: [{
                type: Input
            }] } });

class UiNestedListModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiNestedListModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiNestedListModule, declarations: [UiNestedListComponent, UiNestedListItemComponent, UiNestedListItemSkeletonComponent], imports: [CommonModule,
            SieIconsModule,
            UiLinkModule,
            UiPopoverModule,
            UiSkeletonModule,
            SieCorePipesModule,
            RepeatDirective], exports: [UiNestedListComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiNestedListModule, imports: [CommonModule,
            SieIconsModule,
            UiLinkModule,
            UiPopoverModule,
            UiSkeletonModule,
            SieCorePipesModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiNestedListModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiNestedListComponent, UiNestedListItemComponent, UiNestedListItemSkeletonComponent],
                    imports: [
                        CommonModule,
                        SieIconsModule,
                        UiLinkModule,
                        UiPopoverModule,
                        UiSkeletonModule,
                        SieCorePipesModule,
                        RepeatDirective
                    ],
                    exports: [UiNestedListComponent]
                }]
        }] });

/**
 * # Textarea Input Component
 *
 * Textarea allow users to add free text input. It is used when multi-line input is expected (e.g. descriptions).
 *
 * ## Component variations
 * - Standard variation
 * - Condensed variation
 *
 * ## Content
 *
 * The Textarea component does not accept any content.
 *
 * ## Code example
 * @example ```html
 * <sie-ui-textarea label="Reply" placeholder="Put in your message that you want to reply"></sie-ui-textarea>
 * ```
 */
class UiTextareaComponent extends InputBaseDirective {
    constructor(cdr) {
        super(cdr);
        this.cdr = cdr;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTextareaComponent, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiTextareaComponent, selector: "sie-ui-textarea", providers: [
            {
                provide: NG_VALUE_ACCESSOR,
                multi: true,
                useExisting: UiTextareaComponent
            },
            {
                provide: NG_VALIDATORS,
                multi: true,
                useExisting: UiTextareaComponent
            }
        ], usesInheritance: true, ngImport: i0, template: "<sie-ui-base-input\n  [readonly]=\"readonly\"\n  [id]=\"id\"\n  [label]=\"label\"\n  [value]=\"value\"\n  [labelTransformed]=\"labelTransformed\"\n  [inputFocused]=\"inputFocused\"\n  [invalid]=\"invalid\"\n  [disabled]=\"disabled\"\n  [required]=\"required && !disabled\"\n  [error]=\"error\"\n  [errorMessage]=\"errorMessage\"\n  [requiredErrorMessage]=\"requiredErrorMessage\"\n  [allowedLengthErrorMessage]=\"allowedLengthErrorMessage\"\n  [allowedCharacterLength]=\"allowedCharacterLength\"\n  [patternValidationErrorMessage]=\"patternValidationErrorMessage\"\n  [validationPattern]=\"validationPattern\"\n  mode=\"textarea\"\n  [condensed]=\"condensed\"\n  [ngClass]=\"{ 'is-focused': inputFocused, 'is-invalid': invalid || error, 'is-disabled': disabled }\"\n>\n  <textarea\n    [id]=\"id\"\n    class=\"textarea__input-field\"\n    [ngClass]=\"{\n      'is-focused': inputFocused,\n      'is-invalid': invalid || error,\n      'is-disabled': disabled,\n      'textarea__input-field--textarea-condensed': condensed\n    }\"\n    [disabled]=\"disabled\"\n    (focus)=\"onFocus($event)\"\n    (blur)=\"onBlur($event)\"\n    [(ngModel)]=\"value\"\n    (ngModelChange)=\"onValueChange($event)\"\n    [placeholder]=\"condensed ? placeholder : ''\"\n  ></textarea>\n</sie-ui-base-input>\n", styles: ["::-webkit-scrollbar-thumb{background-clip:padding-box;background-color:#737389}::-webkit-scrollbar-button{display:none}::-webkit-scrollbar-corner{background-color:transparent}::-webkit-scrollbar{width:16px;height:8px}:host{scrollbar-color:#737389 #ebf7f8}::-webkit-scrollbar-thumb:vertical{border-left:8px solid transparent;border-right:4px solid transparent}::-webkit-scrollbar-thumb:horizontal{border-top:4px solid transparent}::-webkit-scrollbar-track:vertical{border-left:8px solid #ebf7f8;background:#ccccd4;border-right:4px solid #ebf7f8}::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #ccccd4}.dark::-webkit-scrollbar-thumb,.dark ::-webkit-scrollbar-thumb{background-color:#ccccd4}.dark::-webkit-scrollbar-track:vertical,.dark ::-webkit-scrollbar-track:vertical{background:#737389;border-right:4px solid #001f39;border-left:8px solid #001f39}.dark::-webkit-scrollbar-track:horizontal,.dark ::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #737389}.textarea__input-field{min-height:200px;max-height:320px;margin-top:20px;margin-bottom:10px;resize:none}.textarea__input-field--textarea-condensed{margin:10px 0}:hover:not(.is-invalid):not(.is-disabled) ::-webkit-scrollbar-thumb{background-clip:padding-box;background-color:#737389}:hover:not(.is-invalid):not(.is-disabled) ::-webkit-scrollbar-button{display:none}:hover:not(.is-invalid):not(.is-disabled) ::-webkit-scrollbar-corner{background-color:transparent}:hover:not(.is-invalid):not(.is-disabled) ::-webkit-scrollbar{width:16px;height:8px}:hover:not(.is-invalid):not(.is-disabled) ::-webkit-scrollbar-thumb:vertical{border-left:8px solid transparent;border-right:4px solid transparent}:hover:not(.is-invalid):not(.is-disabled) ::-webkit-scrollbar-thumb:horizontal{border-top:4px solid transparent}:hover:not(.is-invalid):not(.is-disabled) ::-webkit-scrollbar-track:vertical{border-left:8px solid #d1fff2;background:#ccccd4;border-right:4px solid #d1fff2}:hover:not(.is-invalid):not(.is-disabled) ::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #ccccd4}:hover:not(.is-invalid):not(.is-disabled) .dark::-webkit-scrollbar-thumb,:hover:not(.is-invalid):not(.is-disabled) .dark ::-webkit-scrollbar-thumb{background-color:#ccccd4}:hover:not(.is-invalid):not(.is-disabled) .dark::-webkit-scrollbar-track:vertical,:hover:not(.is-invalid):not(.is-disabled) .dark ::-webkit-scrollbar-track:vertical{background:#737389;border-right:4px solid #001f39;border-left:8px solid #001f39}:hover:not(.is-invalid):not(.is-disabled) .dark::-webkit-scrollbar-track:horizontal,:hover:not(.is-invalid):not(.is-disabled) .dark ::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #737389}.is-focused:not(.is-invalid):not(.is-disabled) ::-webkit-scrollbar-thumb{background-clip:padding-box;background-color:#737389}.is-focused:not(.is-invalid):not(.is-disabled) ::-webkit-scrollbar-button{display:none}.is-focused:not(.is-invalid):not(.is-disabled) ::-webkit-scrollbar-corner{background-color:transparent}.is-focused:not(.is-invalid):not(.is-disabled) ::-webkit-scrollbar{width:16px;height:8px}:host{scrollbar-color:#737389 #d1fff2}.is-focused:not(.is-invalid):not(.is-disabled) ::-webkit-scrollbar-thumb:vertical{border-left:8px solid transparent;border-right:4px solid transparent}.is-focused:not(.is-invalid):not(.is-disabled) ::-webkit-scrollbar-thumb:horizontal{border-top:4px solid transparent}.is-focused:not(.is-invalid):not(.is-disabled) ::-webkit-scrollbar-track:vertical{border-left:8px solid #d1fff2;background:#ccccd4;border-right:4px solid #d1fff2}.is-focused:not(.is-invalid):not(.is-disabled) ::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #ccccd4}.is-focused:not(.is-invalid):not(.is-disabled) .dark::-webkit-scrollbar-thumb,.is-focused:not(.is-invalid):not(.is-disabled) .dark ::-webkit-scrollbar-thumb{background-color:#ccccd4}.is-focused:not(.is-invalid):not(.is-disabled) .dark::-webkit-scrollbar-track:vertical,.is-focused:not(.is-invalid):not(.is-disabled) .dark ::-webkit-scrollbar-track:vertical{background:#737389;border-right:4px solid #001f39;border-left:8px solid #001f39}.is-focused:not(.is-invalid):not(.is-disabled) .dark::-webkit-scrollbar-track:horizontal,.is-focused:not(.is-invalid):not(.is-disabled) .dark ::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #737389}.is-invalid ::-webkit-scrollbar-thumb{background-clip:padding-box;background-color:#737389}.is-invalid ::-webkit-scrollbar-button{display:none}.is-invalid ::-webkit-scrollbar-corner{background-color:transparent}.is-invalid ::-webkit-scrollbar{width:16px;height:8px}:host{scrollbar-color:#737389 #fcccd7}:host .dark,:host.dark{scrollbar-color:#ccccd4 #001f39}.is-invalid ::-webkit-scrollbar-thumb:vertical{border-left:8px solid transparent;border-right:4px solid transparent}.is-invalid ::-webkit-scrollbar-thumb:horizontal{border-top:4px solid transparent}.is-invalid ::-webkit-scrollbar-track:vertical{border-left:8px solid #fcccd7;background:#ccccd4;border-right:4px solid #fcccd7}.is-invalid ::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #ccccd4}.is-invalid .dark::-webkit-scrollbar-thumb,.is-invalid .dark ::-webkit-scrollbar-thumb{background-color:#ccccd4}.is-invalid .dark::-webkit-scrollbar-track:vertical,.is-invalid .dark ::-webkit-scrollbar-track:vertical{background:#737389;border-right:4px solid #001f39;border-left:8px solid #001f39}.is-invalid .dark::-webkit-scrollbar-track:horizontal,.is-invalid .dark ::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #737389}\n", ".password-input__input-field:focus,.text-input__input-field:focus,.textarea__input-field:focus,.password-input__input-field:focus-visible,.text-input__input-field:focus-visible,.textarea__input-field:focus-visible{outline:0}.password-input__input-field,.text-input__input-field{outline:none;outline-offset:0}@media (pointer: fine){.password-input__input-field,.text-input__input-field{position:relative}.password-input__input-field:focus,.text-input__input-field:focus{outline:1px solid #1491eb;outline-offset:2px}.password-input__input-field:focus:not(:focus-visible),.text-input__input-field:focus:not(:focus-visible){outline:0}.password-input__input-field:focus-visible,.text-input__input-field:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}:host{display:block}.text-input__input-field.is-condensed{padding:8px 55px 8px 16px}.text-input__input-field.is-condensed::placeholder,.text-input__input-field.is-inline-search::placeholder{color:#4c4c68}.text-input__input-field.is-inline-search{padding:.125rem 3rem 0 1rem}.text-input__input-field.is-inline-search.has-icon{padding:.125rem 3rem 0 2.5rem}.text-input__input-field.is-inline-search:placeholder-shown{text-overflow:ellipsis}.text-input__input-field.is-combobox{padding-right:65px}.password-input__input-field,.text-input__input-field,.textarea__input-field{font-size:1rem;font-weight:400;line-height:1.5rem;font-family:Siemens Sans,sans-serif;display:flex;width:100%;height:100%;border:0;background-color:transparent;color:#000028;padding:22px 55px 10px 16px}.password-input__input-field.is-disabled,.password-input__input-field.is-disabled::placeholder,.text-input__input-field.is-disabled,.text-input__input-field.is-disabled::placeholder,.textarea__input-field.is-disabled,.textarea__input-field.is-disabled::placeholder{color:#b3b3be;-webkit-text-fill-color:#b3b3be;opacity:1;cursor:not-allowed}.password-input__input-field.is-focused:not(.is-invalid):not(.is-disabled)::placeholder,.text-input__input-field.is-focused:not(.is-invalid):not(.is-disabled)::placeholder,.textarea__input-field.is-focused:not(.is-invalid):not(.is-disabled)::placeholder{color:#9999a9}.reset-button{position:absolute;top:18px;right:8px}.reset-button.is-combobox{right:35px}.reset-button.condensed{top:12px}.reset-button.condensed.search{top:10px}.textarea__input-field{padding:0}.placeholder-icon{width:20px;height:20px;display:flex;align-items:center;fill:currentColor;color:#4c4c68;fill:#4c4c68;position:absolute;left:.75rem;top:50%;transform:translateY(-50%)}.placeholder-icon svg{fill:currentColor;width:inherit;height:inherit}.placeholder-icon svg g{fill:currentColor;width:inherit;height:inherit}.placeholder-icon svg text{font-family:Siemens Sans,sans-serif}.placeholder-icon:hover,.placeholder-icon.is-focused{color:#000028;fill:#000028}.placeholder-icon.is-disabled{color:#b3b3be;fill:#b3b3be}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i3.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i3.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i3.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "component", type: UiBaseInputComponent, selector: "sie-ui-base-input", inputs: ["labelTransformed", "validationPattern"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTextareaComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-textarea', changeDetection: ChangeDetectionStrategy.OnPush, providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            multi: true,
                            useExisting: UiTextareaComponent
                        },
                        {
                            provide: NG_VALIDATORS,
                            multi: true,
                            useExisting: UiTextareaComponent
                        }
                    ], template: "<sie-ui-base-input\n  [readonly]=\"readonly\"\n  [id]=\"id\"\n  [label]=\"label\"\n  [value]=\"value\"\n  [labelTransformed]=\"labelTransformed\"\n  [inputFocused]=\"inputFocused\"\n  [invalid]=\"invalid\"\n  [disabled]=\"disabled\"\n  [required]=\"required && !disabled\"\n  [error]=\"error\"\n  [errorMessage]=\"errorMessage\"\n  [requiredErrorMessage]=\"requiredErrorMessage\"\n  [allowedLengthErrorMessage]=\"allowedLengthErrorMessage\"\n  [allowedCharacterLength]=\"allowedCharacterLength\"\n  [patternValidationErrorMessage]=\"patternValidationErrorMessage\"\n  [validationPattern]=\"validationPattern\"\n  mode=\"textarea\"\n  [condensed]=\"condensed\"\n  [ngClass]=\"{ 'is-focused': inputFocused, 'is-invalid': invalid || error, 'is-disabled': disabled }\"\n>\n  <textarea\n    [id]=\"id\"\n    class=\"textarea__input-field\"\n    [ngClass]=\"{\n      'is-focused': inputFocused,\n      'is-invalid': invalid || error,\n      'is-disabled': disabled,\n      'textarea__input-field--textarea-condensed': condensed\n    }\"\n    [disabled]=\"disabled\"\n    (focus)=\"onFocus($event)\"\n    (blur)=\"onBlur($event)\"\n    [(ngModel)]=\"value\"\n    (ngModelChange)=\"onValueChange($event)\"\n    [placeholder]=\"condensed ? placeholder : ''\"\n  ></textarea>\n</sie-ui-base-input>\n", styles: ["::-webkit-scrollbar-thumb{background-clip:padding-box;background-color:#737389}::-webkit-scrollbar-button{display:none}::-webkit-scrollbar-corner{background-color:transparent}::-webkit-scrollbar{width:16px;height:8px}:host{scrollbar-color:#737389 #ebf7f8}::-webkit-scrollbar-thumb:vertical{border-left:8px solid transparent;border-right:4px solid transparent}::-webkit-scrollbar-thumb:horizontal{border-top:4px solid transparent}::-webkit-scrollbar-track:vertical{border-left:8px solid #ebf7f8;background:#ccccd4;border-right:4px solid #ebf7f8}::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #ccccd4}.dark::-webkit-scrollbar-thumb,.dark ::-webkit-scrollbar-thumb{background-color:#ccccd4}.dark::-webkit-scrollbar-track:vertical,.dark ::-webkit-scrollbar-track:vertical{background:#737389;border-right:4px solid #001f39;border-left:8px solid #001f39}.dark::-webkit-scrollbar-track:horizontal,.dark ::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #737389}.textarea__input-field{min-height:200px;max-height:320px;margin-top:20px;margin-bottom:10px;resize:none}.textarea__input-field--textarea-condensed{margin:10px 0}:hover:not(.is-invalid):not(.is-disabled) ::-webkit-scrollbar-thumb{background-clip:padding-box;background-color:#737389}:hover:not(.is-invalid):not(.is-disabled) ::-webkit-scrollbar-button{display:none}:hover:not(.is-invalid):not(.is-disabled) ::-webkit-scrollbar-corner{background-color:transparent}:hover:not(.is-invalid):not(.is-disabled) ::-webkit-scrollbar{width:16px;height:8px}:hover:not(.is-invalid):not(.is-disabled) ::-webkit-scrollbar-thumb:vertical{border-left:8px solid transparent;border-right:4px solid transparent}:hover:not(.is-invalid):not(.is-disabled) ::-webkit-scrollbar-thumb:horizontal{border-top:4px solid transparent}:hover:not(.is-invalid):not(.is-disabled) ::-webkit-scrollbar-track:vertical{border-left:8px solid #d1fff2;background:#ccccd4;border-right:4px solid #d1fff2}:hover:not(.is-invalid):not(.is-disabled) ::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #ccccd4}:hover:not(.is-invalid):not(.is-disabled) .dark::-webkit-scrollbar-thumb,:hover:not(.is-invalid):not(.is-disabled) .dark ::-webkit-scrollbar-thumb{background-color:#ccccd4}:hover:not(.is-invalid):not(.is-disabled) .dark::-webkit-scrollbar-track:vertical,:hover:not(.is-invalid):not(.is-disabled) .dark ::-webkit-scrollbar-track:vertical{background:#737389;border-right:4px solid #001f39;border-left:8px solid #001f39}:hover:not(.is-invalid):not(.is-disabled) .dark::-webkit-scrollbar-track:horizontal,:hover:not(.is-invalid):not(.is-disabled) .dark ::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #737389}.is-focused:not(.is-invalid):not(.is-disabled) ::-webkit-scrollbar-thumb{background-clip:padding-box;background-color:#737389}.is-focused:not(.is-invalid):not(.is-disabled) ::-webkit-scrollbar-button{display:none}.is-focused:not(.is-invalid):not(.is-disabled) ::-webkit-scrollbar-corner{background-color:transparent}.is-focused:not(.is-invalid):not(.is-disabled) ::-webkit-scrollbar{width:16px;height:8px}:host{scrollbar-color:#737389 #d1fff2}.is-focused:not(.is-invalid):not(.is-disabled) ::-webkit-scrollbar-thumb:vertical{border-left:8px solid transparent;border-right:4px solid transparent}.is-focused:not(.is-invalid):not(.is-disabled) ::-webkit-scrollbar-thumb:horizontal{border-top:4px solid transparent}.is-focused:not(.is-invalid):not(.is-disabled) ::-webkit-scrollbar-track:vertical{border-left:8px solid #d1fff2;background:#ccccd4;border-right:4px solid #d1fff2}.is-focused:not(.is-invalid):not(.is-disabled) ::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #ccccd4}.is-focused:not(.is-invalid):not(.is-disabled) .dark::-webkit-scrollbar-thumb,.is-focused:not(.is-invalid):not(.is-disabled) .dark ::-webkit-scrollbar-thumb{background-color:#ccccd4}.is-focused:not(.is-invalid):not(.is-disabled) .dark::-webkit-scrollbar-track:vertical,.is-focused:not(.is-invalid):not(.is-disabled) .dark ::-webkit-scrollbar-track:vertical{background:#737389;border-right:4px solid #001f39;border-left:8px solid #001f39}.is-focused:not(.is-invalid):not(.is-disabled) .dark::-webkit-scrollbar-track:horizontal,.is-focused:not(.is-invalid):not(.is-disabled) .dark ::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #737389}.is-invalid ::-webkit-scrollbar-thumb{background-clip:padding-box;background-color:#737389}.is-invalid ::-webkit-scrollbar-button{display:none}.is-invalid ::-webkit-scrollbar-corner{background-color:transparent}.is-invalid ::-webkit-scrollbar{width:16px;height:8px}:host{scrollbar-color:#737389 #fcccd7}:host .dark,:host.dark{scrollbar-color:#ccccd4 #001f39}.is-invalid ::-webkit-scrollbar-thumb:vertical{border-left:8px solid transparent;border-right:4px solid transparent}.is-invalid ::-webkit-scrollbar-thumb:horizontal{border-top:4px solid transparent}.is-invalid ::-webkit-scrollbar-track:vertical{border-left:8px solid #fcccd7;background:#ccccd4;border-right:4px solid #fcccd7}.is-invalid ::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #ccccd4}.is-invalid .dark::-webkit-scrollbar-thumb,.is-invalid .dark ::-webkit-scrollbar-thumb{background-color:#ccccd4}.is-invalid .dark::-webkit-scrollbar-track:vertical,.is-invalid .dark ::-webkit-scrollbar-track:vertical{background:#737389;border-right:4px solid #001f39;border-left:8px solid #001f39}.is-invalid .dark::-webkit-scrollbar-track:horizontal,.is-invalid .dark ::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #737389}\n", ".password-input__input-field:focus,.text-input__input-field:focus,.textarea__input-field:focus,.password-input__input-field:focus-visible,.text-input__input-field:focus-visible,.textarea__input-field:focus-visible{outline:0}.password-input__input-field,.text-input__input-field{outline:none;outline-offset:0}@media (pointer: fine){.password-input__input-field,.text-input__input-field{position:relative}.password-input__input-field:focus,.text-input__input-field:focus{outline:1px solid #1491eb;outline-offset:2px}.password-input__input-field:focus:not(:focus-visible),.text-input__input-field:focus:not(:focus-visible){outline:0}.password-input__input-field:focus-visible,.text-input__input-field:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}:host{display:block}.text-input__input-field.is-condensed{padding:8px 55px 8px 16px}.text-input__input-field.is-condensed::placeholder,.text-input__input-field.is-inline-search::placeholder{color:#4c4c68}.text-input__input-field.is-inline-search{padding:.125rem 3rem 0 1rem}.text-input__input-field.is-inline-search.has-icon{padding:.125rem 3rem 0 2.5rem}.text-input__input-field.is-inline-search:placeholder-shown{text-overflow:ellipsis}.text-input__input-field.is-combobox{padding-right:65px}.password-input__input-field,.text-input__input-field,.textarea__input-field{font-size:1rem;font-weight:400;line-height:1.5rem;font-family:Siemens Sans,sans-serif;display:flex;width:100%;height:100%;border:0;background-color:transparent;color:#000028;padding:22px 55px 10px 16px}.password-input__input-field.is-disabled,.password-input__input-field.is-disabled::placeholder,.text-input__input-field.is-disabled,.text-input__input-field.is-disabled::placeholder,.textarea__input-field.is-disabled,.textarea__input-field.is-disabled::placeholder{color:#b3b3be;-webkit-text-fill-color:#b3b3be;opacity:1;cursor:not-allowed}.password-input__input-field.is-focused:not(.is-invalid):not(.is-disabled)::placeholder,.text-input__input-field.is-focused:not(.is-invalid):not(.is-disabled)::placeholder,.textarea__input-field.is-focused:not(.is-invalid):not(.is-disabled)::placeholder{color:#9999a9}.reset-button{position:absolute;top:18px;right:8px}.reset-button.is-combobox{right:35px}.reset-button.condensed{top:12px}.reset-button.condensed.search{top:10px}.textarea__input-field{padding:0}.placeholder-icon{width:20px;height:20px;display:flex;align-items:center;fill:currentColor;color:#4c4c68;fill:#4c4c68;position:absolute;left:.75rem;top:50%;transform:translateY(-50%)}.placeholder-icon svg{fill:currentColor;width:inherit;height:inherit}.placeholder-icon svg g{fill:currentColor;width:inherit;height:inherit}.placeholder-icon svg text{font-family:Siemens Sans,sans-serif}.placeholder-icon:hover,.placeholder-icon.is-focused{color:#000028;fill:#000028}.placeholder-icon.is-disabled{color:#b3b3be;fill:#b3b3be}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }]; } });

/**
 * # Textarea Module
 * - {@link UiTextareaComponent}
 *
 * ## Module peer dependencies
 * - {@link SieIconsModule}
 * - `@angular/forms/FormsModule`: Enables data binding for Angular forms
 */
class UiTextareaModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTextareaModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiTextareaModule, declarations: [UiTextareaComponent], imports: [CommonModule, FormsModule, UiReadonlyModule, UiBaseInputModule], exports: [UiTextareaComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTextareaModule, imports: [CommonModule, FormsModule, UiReadonlyModule, UiBaseInputModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTextareaModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiTextareaComponent],
                    imports: [CommonModule, FormsModule, UiReadonlyModule, UiBaseInputModule],
                    exports: [UiTextareaComponent]
                }]
        }] });

/** @ignore */
const CDK_OVERLAY_POSITIONS$1 = [
    { originX: 'start', originY: 'bottom', overlayX: 'start', overlayY: 'top' }
];
/** @ignore */
const DELAY_TIME = 180;
/**
 * # Combobox component
 *
 * Combobox allows user to search and select a value from given set of options or add a value not offered in the options.
 *
 * ## Component variations
 *
 * There are no variations
 *
 * ## Content
 *
 * The Combobox component does not accept any content.
 *
 * ## Code example
 * @example
 * Template:
 * ```html
 * <sie-ui-combobox
 *   label="City"
 *   placeholder="Select city"
 *   autocomplete="off"
 *   [options]="comboboxSuggestions"
 *   [noResultsMessageTitle]="'No results title'"
 *   [noResultsMessageCopy]="'No results message copy'"
 *   [emptyStateMessageTitle]="'Empty state message title'"
 *   [emptyStateMessageCopy]="'Empty state message copy'"
 *   [invalidErrorMessage]="'Invalid error message'"
 *   [patternValidationErrorMessage]="'Component accepts alphanumeric characters and spaces'"
 *   [requiredErrorMessage]="'Field is required'"
 *   [loadingMessage]="'Combobox loading message'"
 *   [loading]="true"
 *   [clearSearchScreenReaderText]="'Clear search screen reader text'"
 *   [addCustomValueCopy]="'Add custom value'"
 *   (inputValueChanged)="onInputValueChanged($event)"
 * ></sie-ui-combobox>
 * ```
 *
 * Data example:
 * ``` js
 * const comboboxSuggestions = [
 *   {
 *     label: 'Kabul',
 *     value: 'Kabul',
 *     metaInformation: 'Capital city of Afghanistan'
 *   },
 *   {
 *     label: 'Mariehamn',
 *     value: 'Mariehamn',
 *     metaInformation: 'Meta information that gets truncated after one line when it reaches maximum width'
 *   },
 *   {
 *     label: 'Tirana',
 *     value: 'Tirana'
 *   }
 * ];
 * ```
 */
class UiComboboxComponent extends UiDropdownBaseDirective {
    /**
     * Defines the {@link UiComboboxOption options} (suggestions) shown in the overlay of the component
     */
    set options(value) {
        this._options = value;
        if (value && this._selectedValue) {
            this.selectedItem = value.find(option => option.value === this._selectedValue);
            this.value = this.selectedItem?.label;
        }
    }
    get options() {
        return this._options;
    }
    /**
     * Defines whether component should use 'Add option trigger' mode
     * @default false
     */
    set addCustomValue(value) {
        this._addCustomValue = coerceBooleanProperty(value);
    }
    get addCustomValue() {
        return this._addCustomValue;
    }
    /**
     * Defines whether the loading state of the component should be shown
     * @default false
     */
    set loading(value) {
        this._loading = coerceBooleanProperty(value);
    }
    get loading() {
        return this._loading;
    }
    /**
     * Defines whether the error state of the component should be shown
     * @default false
     */
    set error(value) {
        this._error = coerceBooleanProperty(value);
    }
    get error() {
        return this._error;
    }
    /**
     * Defines whether the invalid state of the component should be shown
     */
    set invalid(value) {
        this._invalid = coerceBooleanProperty(value);
    }
    get invalid() {
        return this._invalid;
    }
    /**
     * Defines whether the required state of the component should be shown
     */
    set required(value) {
        this._required = coerceBooleanProperty(value);
    }
    get required() {
        return this._required;
    }
    /**
     * @param selectedValue Defines which option of the component is selected by default (controlled through `value` set in `options` input)
     */
    set selectedValue(selectedValue) {
        this._selectedValue = selectedValue;
        this.selectedItem = null;
        if (this._options && selectedValue) {
            this.selectedItem = this._options.find(option => option.value === selectedValue);
        }
        this.value = this.selectedItem?.label;
        if (!this.value && this.dropDownElement) {
            this.dropDownElement.labelTransformed = false;
        }
    }
    /**
     * Defines whether the disabled state of the component should be shown
     * @default false
     */
    set disabled(value) {
        this._disabled = coerceBooleanProperty(value);
        if (this._disabled && this.menuOpen) {
            this.closeOverlay();
        }
    }
    get disabled() {
        return this._disabled;
    }
    /** @ignore */
    set focused(value) {
        this._focused = coerceBooleanProperty(value);
    }
    get focused() {
        return this._focused;
    }
    constructor(iconReg, cdr, elementRef, eventPropagationService, cdkOverlayService) {
        super(cdr, elementRef, eventPropagationService, cdkOverlayService);
        this.iconReg = iconReg;
        this.cdr = cdr;
        this.elementRef = elementRef;
        this.eventPropagationService = eventPropagationService;
        this.cdkOverlayService = cdkOverlayService;
        /**
         * Defines the placeholder value of the component
         * @default '' (empty string)
         */
        this.placeholder = '';
        /**
         * Defines the value of the component
         * @default null
         */
        this.value = null;
        /**
         * Defines the title of the message shown when no results for input are found (when {@link addCustomValue} is `false`)
         * @default '' (empty string)
         */
        this.noResultsMessageTitle = '';
        /**
         * Defines the text of the message shown when no results for input are found (when {@link addCustomValue} is `false`)
         * @default '' (empty string)
         */
        this.noResultsMessageCopy = '';
        /**
         * Defines the title of the message shown in the empty state (e.g. when API fails to fetch suggestions data)
         * @default '' (empty string)
         */
        this.emptyStateMessageTitle = '';
        /**
         * Defines the copy of the message shown in the empty state (e.g. when API fails to fetch suggestions data)
         * @default '' (empty string)
         */
        this.emptyStateMessageCopy = '';
        /**
         * Defines the text used by screen readers for the clear search icon
         * @default '' (empty string)
         */
        this.clearSearchScreenReaderText = '';
        /**
         * Defines the text shown under the input value when 'Add option trigger' is used ({@link addCustomValue} is `true`)
         * @default '' (empty string)
         */
        this.addCustomValueCopy = '';
        /**
         * Defines which regex should be used for combo box validation
         * @default null
         */
        this.validationPattern = null;
        /**
         * Event triggered when the option from the options list is selected
         * The event data is the {@link UiComboboxOption option} itself
         */
        this.optionSelected = new Subject();
        /**
         * Event triggered when the value of the input field has been changed
         * The event data is the `value` attribute of the selected {@link UiComboboxOption option}
         */
        this.inputValueChanged = new Subject();
        this.customOption = null;
        this.selectedItem = null;
        this.highlightedItem = null;
        this._disabled = false;
        this.positions = CDK_OVERLAY_POSITIONS$1;
        this.originalOptions = [];
        this.optionsCircularArray = new CircularArray();
        this._addCustomValue = false;
        this._loading = false;
        this._error = false;
        this._focused = false;
        this._itemFocused = false;
        this._selectedValue = '';
        /** @ignore */
        this.leftAligned = false;
        iconReg.register(SieIcon.CloseSmall);
        iconReg.register(SieIcon.Dropdown);
        iconReg.register(SieIcon.ErrorFilled);
    }
    /** @ignore */
    ngOnChanges(changes) {
        if (changes.options) {
            this.originalOptions = this._options;
        }
        if (changes.options || changes.value || changes.selectedValue) {
            this.updateDisplayedOptions();
        }
    }
    /** @ignore */
    onValueChange(value) {
        this.value = value ? value.trim() : value;
        this.inputValueChanged.next(this.value);
        this.updateDisplayedOptions();
        if (this.menuOpen) {
            this.recalculatePositions();
        }
        else {
            this.openOverlay();
        }
    }
    /** @ignore */
    onInputKeyEnter() {
        this.selectValueAndValidate();
        if (this.menuOpen) {
            this.closeOverlay();
        }
        else {
            this.openOverlay();
        }
    }
    /** @ignore */
    onInputKeyTab() {
        this.selectValueAndValidate();
        this.closeOverlay();
    }
    /** @ignore */
    onInputClick() {
        this.openOverlay();
    }
    /** @ignore */
    onInputFocus() {
        if (!this.menuOpen) {
            this.openOverlay();
        }
    }
    /** @ignore */
    onInputArrowDown(event) {
        this.highlightItem(event, this.optionsCircularArray.nextIndex());
    }
    /** @ignore */
    onInputEscape() {
        this.onValueChange(null);
        this.closeOverlay();
    }
    /** @ignore */
    onResetButtonClicked() {
        this.onValueChange(null);
        this.focusInputField();
        this.validate();
    }
    /** @ignore */
    onOverlayArrowHandler(e) {
        const direction = UiDropdownService.getDirectionForKey(e);
        e.preventDefault();
        if (direction === ArrowDirection.Down) {
            this.highlightItem(e, this.optionsCircularArray.nextIndex());
        }
        else if (direction === ArrowDirection.Up) {
            this.highlightItem(e, this.optionsCircularArray.previousIndex());
        }
        else {
            return;
        }
    }
    /** @ignore */
    onOverlayKeyTab() {
        this.itemSelected(this.highlightedItem);
        this.focusInputField();
        this.closeOverlay();
    }
    /** @ignore */
    onOverlayKeyEnter(e, item) {
        e.preventDefault(); // don't let enter cause overarching form to be submitted
        this.itemSelected(item);
        this.focusInputField();
        this.closeOverlay();
    }
    /** @ignore */
    onOverlayKeyEscape() {
        this.focusInputField();
        this.onValueChange(null);
        this.closeOverlay();
    }
    /** @ignore */
    onOverlayClick(item) {
        this.itemSelected(item);
        this.closeOverlay();
    }
    /** @ignore */
    onOverlayMouseOver(index) {
        this.highlightSuggestion(index);
    }
    /** @ignore */
    onOverlayMouseOut() {
        this.unHighlightSuggestion();
    }
    /** @ignore */
    focusOut(backdropClicked) {
        if (this._itemFocused && !backdropClicked) {
            return;
        }
        if (this.disabled) {
            return;
        }
        this.focusOutTimer = setTimeout(() => {
            if (this.value !== this.selectedItem?.value) {
                this.selectValueAndValidate();
            }
            this.closeOverlay();
        }, DELAY_TIME);
    }
    /** @ignore */
    closeOverlay() {
        this.unHighlightSuggestion();
        super.closeOverlay();
        this._itemFocused = false;
    }
    /** @ignore */
    openOverlay() {
        if (!this.disabled) {
            super.openOverlay();
        }
    }
    /** @ignore */
    itemSelected(selectedItem) {
        const changed = this.selectedItem !== selectedItem;
        this.selectedItem = selectedItem;
        if (this.validate() && changed) {
            const selectedItemCopy = selectedItem ? deepCopy(selectedItem) : null;
            this.optionSelected.next(selectedItemCopy);
        }
        if (selectedItem) {
            this.value = selectedItem.label;
        }
        this.updateDisplayedOptions();
    }
    /** @ignore */
    focusElement(index) {
        const nativeEl = this.cdkOverlayService.getOverlay();
        const newEl = nativeEl.querySelector(`[data-index="${index}"]`);
        if (!this.isDisabled(index) && newEl !== null) {
            this._itemFocused = true;
            newEl.focus();
        }
    }
    /** @ignore */
    onArrowIconClicked(e) {
        e.preventDefault();
        this.focusIn();
        this.focusInputField();
    }
    /**
     * @ignore
     * This method is used and overridden in the UiSupportSearchComboboxComponent,
     * which uses template and styling from this component
     * */
    onArrowIconMouseDown(_e) {
        //no effect
    }
    selectValueAndValidate() {
        if (this._options) {
            const foundOption = this._options.find(option => this.value && StringUtil.equalsIgnoreCase(option.label, this.value));
            this.itemSelected(foundOption);
        }
    }
    validateValue() {
        let valid = true;
        if (this.value && !!!(this.value && this.selectedItem)) {
            valid = false;
        }
        this.invalid = !valid;
        return valid;
    }
    validate() {
        return this.validateValue() && this.dropDownElement.isInputValid() === InputValidity.Valid;
    }
    highlightItem(event, index) {
        event.preventDefault();
        this.highlightedItem = this._options[index];
        this.focusElement(index);
        this.hover = false;
    }
    highlightSuggestion(index) {
        this.optionsCircularArray.select(index);
        this.hover = true;
    }
    unHighlightSuggestion() {
        this.highlightedItem = null;
        this.optionsCircularArray.reset();
    }
    determineHorizontalMenuAlignment() {
        const hostComponent = this.elementRef?.nativeElement.getBoundingClientRect().left;
        const menuWidth = this.dropDownMenu.elementRef?.nativeElement.offsetWidth;
        this.leftAligned = menuWidth >= hostComponent;
    }
    focusInputField() {
        const nativeEl = this.dropDownRendering.nativeElement;
        const newEl = nativeEl.querySelector('input');
        if (newEl !== null) {
            newEl.focus();
        }
    }
    updateDisplayedOptions() {
        const optionsToDisplay = this.filterOptions();
        if (this.value && optionsToDisplay) {
            optionsToDisplay.sort((a, b) => this.sortOptions(a, b));
        }
        this.customOption = this.getCustomOption();
        if (this.customOption) {
            optionsToDisplay.push(this.customOption);
        }
        this._options = optionsToDisplay;
        this.optionsCircularArray.set(this._options);
    }
    getCustomOption() {
        if (this._addCustomValue &&
            this.value &&
            !this.originalOptions.some(option => StringUtil.equalsIgnoreCase(option.label, this.value))) {
            return {
                label: this.value,
                value: this.value,
                customValue: true
            };
        }
        return null;
    }
    sortOptions(a, b) {
        const value = this.value.toLowerCase();
        const aValue = a.value.toLowerCase();
        const bValue = b.value.toLowerCase();
        if (aValue.indexOf(value) === 0 && bValue.indexOf(value) > 0) {
            return -1;
        }
        else if (aValue.indexOf(value) > 0 && bValue.indexOf(value) === 0) {
            return 1;
        }
        return a.value.localeCompare(b.value);
    }
    filterOptions() {
        if (this.originalOptions) {
            return this.originalOptions.filter(option => !this.value || option.label.toLowerCase().includes(this.value.toLowerCase()));
        }
        else {
            return null;
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiComboboxComponent, deps: [{ token: i1.SieIconRegistryService }, { token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: UiEventPropagationService }, { token: CdkOverlayService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiComboboxComponent, selector: "sie-ui-combobox", inputs: { id: "id", placeholder: "placeholder", value: "value", noResultsMessageTitle: "noResultsMessageTitle", noResultsMessageCopy: "noResultsMessageCopy", emptyStateMessageTitle: "emptyStateMessageTitle", emptyStateMessageCopy: "emptyStateMessageCopy", clearSearchScreenReaderText: "clearSearchScreenReaderText", addCustomValueCopy: "addCustomValueCopy", label: "label", loadingMessage: "loadingMessage", patternValidationErrorMessage: "patternValidationErrorMessage", invalidErrorMessage: "invalidErrorMessage", requiredErrorMessage: "requiredErrorMessage", autocomplete: "autocomplete", validationPattern: "validationPattern", options: "options", addCustomValue: "addCustomValue", loading: "loading", error: "error", invalid: "invalid", required: "required", selectedValue: "selectedValue", disabled: "disabled" }, outputs: { optionSelected: "optionSelected", inputValueChanged: "inputValueChanged" }, host: { properties: { "class.is-disabled": "this.disabled", "class.is-focused": "this.focused" } }, providers: [UiEventPropagationService], usesInheritance: true, usesOnChanges: true, ngImport: i0, template: "<div\n  class=\"combobox\"\n  (focusin)=\"focusIn()\"\n  (focusout)=\"focusOut()\"\n  #dropDownRendering\n  cdkOverlayOrigin\n  #trigger=\"cdkOverlayOrigin\"\n>\n  <sie-ui-text-input\n    class=\"combobox__input\"\n    [ngClass]=\"{ 'has-value': dropDownElement.value }\"\n    [id]=\"id\"\n    [combobox]=\"true\"\n    [placeholder]=\"placeholder\"\n    [autocomplete]=\"autocomplete\"\n    [disabled]=\"disabled\"\n    [label]=\"label\"\n    [value]=\"value\"\n    [invalid]=\"invalid\"\n    [errorMessage]=\"invalidErrorMessage\"\n    [required]=\"required\"\n    [requiredErrorMessage]=\"requiredErrorMessage\"\n    [validationPattern]=\"validationPattern\"\n    [patternValidationErrorMessage]=\"patternValidationErrorMessage\"\n    [cssErrorClass]=\"menuOpen ? 'combobox-cdk-overlay-error' : ''\"\n    (valueChange)=\"onValueChange($event)\"\n    (click)=\"onInputClick()\"\n    (focused)=\"onInputFocus()\"\n    (keydown.arrowDown)=\"onInputArrowDown($event)\"\n    (keydown.escape)=\"onInputEscape()\"\n    (keydown.enter)=\"onInputKeyEnter()\"\n    (keydown.tab)=\"onInputKeyTab()\"\n    (resetInput)=\"onResetButtonClicked()\"\n    #dropDownElement\n  >\n  </sie-ui-text-input>\n  <sie-icon\n    class=\"combobox__dropdown__icon\"\n    aria-hidden=\"true\"\n    [ngClass]=\"{\n      open: menuOpen,\n      disabled: disabled\n    }\"\n    [name]=\"iconReg.sieIcon.Dropdown\"\n    (click)=\"!menuOpen ? onArrowIconClicked($event) : ''\"\n    (dblclick)=\"onArrowIconClicked($event)\"\n    (mousedown)=\"onArrowIconMouseDown($event)\"\n  ></sie-icon>\n\n  <ng-template\n    cdkConnectedOverlay\n    cdkConnectedOverlayBackdropClass=\"cdk-overlay-hidden-backdrop\"\n    [cdkConnectedOverlayHasBackdrop]=\"false\"\n    [cdkConnectedOverlayOrigin]=\"trigger\"\n    [cdkConnectedOverlayOpen]=\"menuOpen\"\n    [cdkConnectedOverlayPositions]=\"positions\"\n    (backdropClick)=\"focusOut(true)\"\n  >\n    <sie-ui-dropdown-menu\n      cdkTrapFocus\n      *ngIf=\"menuOpen\"\n      class=\"combobox__menu\"\n      [@openClose]=\"menuOpen\"\n      [ngClass]=\"[leftAligned ? 'left-aligned' : '']\"\n      [ngStyle]=\"{ width: dropdownWidth + 'px' }\"\n      [menuPositionedBottom]=\"menuPositionedBottom\"\n    >\n      <div class=\"combobox__content\" content>\n        <ng-container\n          [ngTemplateOutlet]=\"loading ? loadingSpinner : error ? errorEmptyState : mainContent\"\n        ></ng-container>\n      </div>\n    </sie-ui-dropdown-menu>\n  </ng-template>\n</div>\n\n<ng-template #emptySuggestion>\n  <div *ngIf=\"!addCustomValue && !loading && !error\" class=\"combobox__no-results-message\" footer>\n    <p class=\"combobox__no-results-message-title\" [innerHTML]=\"noResultsMessageTitle\"></p>\n    <p class=\"combobox__no-results-message-copy\">{{ noResultsMessageCopy }}</p>\n  </div>\n</ng-template>\n\n<ng-template #loadingSpinner>\n  <div class=\"combobox__loading\">\n    <sie-ui-spinner [message]=\"loadingMessage\" active></sie-ui-spinner>\n  </div>\n</ng-template>\n\n<ng-template #errorEmptyState>\n  <div class=\"combobox__error\">\n    <sie-ui-empty-state\n      [customIcon]=\"iconReg.sieIcon.ErrorFilled\"\n      iconPosition=\"inFrontOfHeadline\"\n      [headline]=\"emptyStateMessageTitle\"\n      [text]=\"emptyStateMessageCopy\"\n    ></sie-ui-empty-state>\n  </div>\n</ng-template>\n\n<ng-template #mainContent>\n  <div *ngIf=\"options?.length || addCustomValue; else emptySuggestion\" class=\"combobox__suggestions\">\n    <ul *ngIf=\"options.length\" class=\"combobox__suggestions-list\">\n      <ng-container *ngFor=\"let option of options; let i = index\">\n        <li\n          *ngIf=\"!option.customValue\"\n          [tabindex]=\"-1\"\n          class=\"combobox__suggestions-item\"\n          role=\"option\"\n          [attr.data-index]=\"i\"\n          (keydown.arrowDown)=\"onOverlayArrowHandler($event)\"\n          (keydown.arrowUp)=\"onOverlayArrowHandler($event)\"\n          (keydown.tab)=\"onOverlayKeyTab()\"\n          (keydown.enter)=\"onOverlayKeyEnter($event, option)\"\n          (keydown.escape)=\"onOverlayKeyEscape()\"\n        >\n          <button\n            [tabindex]=\"-1\"\n            class=\"combobox__suggestions-btn\"\n            [ngClass]=\"{\n              'is-selected': option.id ? highlightedItem?.id === option.id : highlightedItem?.value === option.value,\n              'no-hover': !hover\n            }\"\n            (click)=\"onOverlayClick(option)\"\n            (mouseover)=\"onOverlayMouseOver(i)\"\n            (mouseout)=\"onOverlayMouseOut()\"\n          >\n            <p sieCoreHighlight [reference]=\"value\" [highlightStartOnly]=\"false\">{{ option.label }}</p>\n            <span *ngIf=\"option.metaInformation\" [title]=\"option.metaInformation\" class=\"combobox__meta-information\">{{\n              option.metaInformation\n            }}</span>\n          </button>\n        </li>\n      </ng-container>\n    </ul>\n    <ul\n      *ngIf=\"addCustomValue && customOption\"\n      class=\"combobox__add-option\"\n      [ngClass]=\"{ 'show-line': options.length > 1 }\"\n    >\n      <li\n        [tabindex]=\"-1\"\n        class=\"combobox__suggestions-item\"\n        role=\"option\"\n        [attr.data-index]=\"options.length - 1\"\n        (keydown.arrowDown)=\"onOverlayArrowHandler($event)\"\n        (keydown.arrowUp)=\"onOverlayArrowHandler($event)\"\n        (keydown.tab)=\"onOverlayKeyTab()\"\n        (keydown.enter)=\"onOverlayKeyEnter($event, customOption)\"\n        (keydown.escape)=\"onOverlayKeyEscape()\"\n      >\n        <div footer class=\"combobox__footer\">\n          <button\n            [tabindex]=\"-1\"\n            class=\"combobox__add-option-btn\"\n            (click)=\"onOverlayClick(customOption)\"\n            [ngClass]=\"{\n              'is-selected': highlightedItem?.value === customOption.value,\n              'no-hover': !hover\n            }\"\n            (mouseover)=\"onOverlayMouseOver(options.length - 1)\"\n            (mouseout)=\"onOverlayMouseOut()\"\n          >\n            <p class=\"combobox__add-option-value\">{{ customOption.label }}</p>\n            <p class=\"combobox__add-option-text\">{{ addCustomValueCopy }}</p>\n          </button>\n        </div>\n      </li>\n    </ul>\n  </div>\n</ng-template>\n", styles: [".combobox__dropdown__icon{outline:none;outline-offset:0}@media (pointer: fine){.combobox__dropdown__icon{position:relative}.combobox__dropdown__icon:focus{outline:1px solid #1491eb;outline-offset:2px}.combobox__dropdown__icon:focus:not(:focus-visible){outline:0}.combobox__dropdown__icon:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}:host{display:block}.combobox__add-option-btn,.combobox__suggestions-btn{display:flex;flex-direction:column;width:100%;border:0;background-color:transparent;text-align:left}.is-selected.combobox__add-option-btn,.is-selected.combobox__suggestions-btn,.combobox__add-option-btn:not(.no-hover):hover,.combobox__suggestions-btn:not(.no-hover):hover{background-color:#62eec7;cursor:pointer}.combobox{position:relative;width:100%}.combobox__label{display:flex;align-items:center;width:100%;height:100%}.combobox__menu{width:100%}.combobox__menu ::-webkit-scrollbar-thumb{background-clip:padding-box;background-color:#737389}.combobox__menu ::-webkit-scrollbar-button{display:none}.combobox__menu ::-webkit-scrollbar-corner{background-color:transparent}.combobox__menu ::-webkit-scrollbar{width:16px;height:8px}:host{scrollbar-color:#737389 #fff}:host .dark,:host.dark{scrollbar-color:#ccccd4 #001f39}.combobox__menu ::-webkit-scrollbar-thumb:vertical{border-left:8px solid transparent;border-right:4px solid transparent}.combobox__menu ::-webkit-scrollbar-thumb:horizontal{border-top:4px solid transparent}.combobox__menu ::-webkit-scrollbar-track:vertical{border-left:8px solid #fff;background:#ccccd4;border-right:4px solid #fff}.combobox__menu ::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #ccccd4}.combobox__menu .dark::-webkit-scrollbar-thumb,.combobox__menu .dark ::-webkit-scrollbar-thumb{background-color:#ccccd4}.combobox__menu .dark::-webkit-scrollbar-track:vertical,.combobox__menu .dark ::-webkit-scrollbar-track:vertical{background:#737389;border-right:4px solid #001f39;border-left:8px solid #001f39}.combobox__menu .dark::-webkit-scrollbar-track:horizontal,.combobox__menu .dark ::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #737389}.combobox__dropdown__icon{width:24px;height:24px;display:flex;align-items:center;fill:currentColor;position:absolute;top:16px;right:8px;margin-left:4px;z-index:1;-webkit-user-select:inherit;user-select:inherit;appearance:inherit;cursor:pointer}.combobox__dropdown__icon svg{fill:currentColor;width:inherit;height:inherit}.combobox__dropdown__icon svg g{fill:currentColor;width:inherit;height:inherit}.combobox__dropdown__icon svg text{font-family:Siemens Sans,sans-serif}.combobox__dropdown__icon svg{transition:transform .12s cubic-bezier(.4,0,.3,1)}.combobox__dropdown__icon.open svg{transform:translateZ(0) rotate(180deg)}.combobox__dropdown__icon.disabled{color:#b3b3be}.combobox__loading{height:270px;display:flex;justify-content:center;align-items:center}.combobox__suggestions-list{list-style:none;margin:0;padding:0;max-height:256px;overflow-y:auto}.combobox__suggestions-item:focus{outline:0}.combobox__suggestions-btn{padding:4px 16px}.combobox__meta-information{font-size:.75rem;font-weight:400;line-height:1rem;display:-webkit-box;-webkit-box-orient:vertical;-webkit-line-clamp:1;color:#4c4c68;text-overflow:ellipsis;overflow:hidden}.combobox__no-results-message{width:100%;display:inline-block;padding:4px 16px 6px;text-align:left}.combobox__no-results-message-copy,.combobox__add-option-text{font-size:.75rem;font-weight:400;line-height:1rem;color:#4c4c68}.combobox__add-option{list-style:none;padding:0;margin:0}.combobox__add-option.show-line:before{content:\"\";margin:8px 16px 4px;width:calc(100% - 32px);height:1px;display:block;background:#ccccd4}.combobox__add-option-btn{padding:0 16px 4px}.combobox__add-option-value{font-size:1rem;font-weight:700;line-height:1.5rem;padding-top:4px}.combobox__no-results-message-title,.combobox__add-option-value{white-space:nowrap;overflow:hidden;text-overflow:ellipsis;color:#000028;display:block;width:100%;vertical-align:top}.combobox__error{width:100%}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: i2.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "directive", type: i1$1.HighlightDirective, selector: "[sieCoreHighlight]", inputs: ["reference", "inverted", "highlightStartOnly", "highlightBackgroundColor"] }, { kind: "component", type: UiDropdownMenuComponent, selector: "sie-ui-dropdown-menu", inputs: ["theme", "type", "menuPositionedBottom"] }, { kind: "component", type: UiTextInputComponent, selector: "sie-ui-text-input", inputs: ["inputType", "placeholderIcon"] }, { kind: "component", type: UiSpinnerComponent, selector: "sie-ui-spinner", inputs: ["size", "message", "overlayOnTop", "overlay", "active"], outputs: ["animationEnded"] }, { kind: "component", type: UiEmptyStateComponent, selector: "sie-ui-empty-state", inputs: ["theme", "headline", "text", "link", "button", "iconPosition", "padding", "customIcon"], outputs: ["buttonClicked"] }, { kind: "directive", type: i10.CdkConnectedOverlay, selector: "[cdk-connected-overlay], [connected-overlay], [cdkConnectedOverlay]", inputs: ["cdkConnectedOverlayOrigin", "cdkConnectedOverlayPositions", "cdkConnectedOverlayPositionStrategy", "cdkConnectedOverlayOffsetX", "cdkConnectedOverlayOffsetY", "cdkConnectedOverlayWidth", "cdkConnectedOverlayHeight", "cdkConnectedOverlayMinWidth", "cdkConnectedOverlayMinHeight", "cdkConnectedOverlayBackdropClass", "cdkConnectedOverlayPanelClass", "cdkConnectedOverlayViewportMargin", "cdkConnectedOverlayScrollStrategy", "cdkConnectedOverlayOpen", "cdkConnectedOverlayDisableClose", "cdkConnectedOverlayTransformOriginOn", "cdkConnectedOverlayHasBackdrop", "cdkConnectedOverlayLockPosition", "cdkConnectedOverlayFlexibleDimensions", "cdkConnectedOverlayGrowAfterOpen", "cdkConnectedOverlayPush"], outputs: ["backdropClick", "positionChange", "attach", "detach", "overlayKeydown", "overlayOutsideClick"], exportAs: ["cdkConnectedOverlay"] }, { kind: "directive", type: i10.CdkOverlayOrigin, selector: "[cdk-overlay-origin], [overlay-origin], [cdkOverlayOrigin]", exportAs: ["cdkOverlayOrigin"] }, { kind: "directive", type: i6.CdkTrapFocus, selector: "[cdkTrapFocus]", inputs: ["cdkTrapFocus", "cdkTrapFocusAutoCapture"], exportAs: ["cdkTrapFocus"] }], animations: [createDropdownAnimation()], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiComboboxComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-combobox', animations: [createDropdownAnimation()], providers: [UiEventPropagationService], changeDetection: ChangeDetectionStrategy.OnPush, template: "<div\n  class=\"combobox\"\n  (focusin)=\"focusIn()\"\n  (focusout)=\"focusOut()\"\n  #dropDownRendering\n  cdkOverlayOrigin\n  #trigger=\"cdkOverlayOrigin\"\n>\n  <sie-ui-text-input\n    class=\"combobox__input\"\n    [ngClass]=\"{ 'has-value': dropDownElement.value }\"\n    [id]=\"id\"\n    [combobox]=\"true\"\n    [placeholder]=\"placeholder\"\n    [autocomplete]=\"autocomplete\"\n    [disabled]=\"disabled\"\n    [label]=\"label\"\n    [value]=\"value\"\n    [invalid]=\"invalid\"\n    [errorMessage]=\"invalidErrorMessage\"\n    [required]=\"required\"\n    [requiredErrorMessage]=\"requiredErrorMessage\"\n    [validationPattern]=\"validationPattern\"\n    [patternValidationErrorMessage]=\"patternValidationErrorMessage\"\n    [cssErrorClass]=\"menuOpen ? 'combobox-cdk-overlay-error' : ''\"\n    (valueChange)=\"onValueChange($event)\"\n    (click)=\"onInputClick()\"\n    (focused)=\"onInputFocus()\"\n    (keydown.arrowDown)=\"onInputArrowDown($event)\"\n    (keydown.escape)=\"onInputEscape()\"\n    (keydown.enter)=\"onInputKeyEnter()\"\n    (keydown.tab)=\"onInputKeyTab()\"\n    (resetInput)=\"onResetButtonClicked()\"\n    #dropDownElement\n  >\n  </sie-ui-text-input>\n  <sie-icon\n    class=\"combobox__dropdown__icon\"\n    aria-hidden=\"true\"\n    [ngClass]=\"{\n      open: menuOpen,\n      disabled: disabled\n    }\"\n    [name]=\"iconReg.sieIcon.Dropdown\"\n    (click)=\"!menuOpen ? onArrowIconClicked($event) : ''\"\n    (dblclick)=\"onArrowIconClicked($event)\"\n    (mousedown)=\"onArrowIconMouseDown($event)\"\n  ></sie-icon>\n\n  <ng-template\n    cdkConnectedOverlay\n    cdkConnectedOverlayBackdropClass=\"cdk-overlay-hidden-backdrop\"\n    [cdkConnectedOverlayHasBackdrop]=\"false\"\n    [cdkConnectedOverlayOrigin]=\"trigger\"\n    [cdkConnectedOverlayOpen]=\"menuOpen\"\n    [cdkConnectedOverlayPositions]=\"positions\"\n    (backdropClick)=\"focusOut(true)\"\n  >\n    <sie-ui-dropdown-menu\n      cdkTrapFocus\n      *ngIf=\"menuOpen\"\n      class=\"combobox__menu\"\n      [@openClose]=\"menuOpen\"\n      [ngClass]=\"[leftAligned ? 'left-aligned' : '']\"\n      [ngStyle]=\"{ width: dropdownWidth + 'px' }\"\n      [menuPositionedBottom]=\"menuPositionedBottom\"\n    >\n      <div class=\"combobox__content\" content>\n        <ng-container\n          [ngTemplateOutlet]=\"loading ? loadingSpinner : error ? errorEmptyState : mainContent\"\n        ></ng-container>\n      </div>\n    </sie-ui-dropdown-menu>\n  </ng-template>\n</div>\n\n<ng-template #emptySuggestion>\n  <div *ngIf=\"!addCustomValue && !loading && !error\" class=\"combobox__no-results-message\" footer>\n    <p class=\"combobox__no-results-message-title\" [innerHTML]=\"noResultsMessageTitle\"></p>\n    <p class=\"combobox__no-results-message-copy\">{{ noResultsMessageCopy }}</p>\n  </div>\n</ng-template>\n\n<ng-template #loadingSpinner>\n  <div class=\"combobox__loading\">\n    <sie-ui-spinner [message]=\"loadingMessage\" active></sie-ui-spinner>\n  </div>\n</ng-template>\n\n<ng-template #errorEmptyState>\n  <div class=\"combobox__error\">\n    <sie-ui-empty-state\n      [customIcon]=\"iconReg.sieIcon.ErrorFilled\"\n      iconPosition=\"inFrontOfHeadline\"\n      [headline]=\"emptyStateMessageTitle\"\n      [text]=\"emptyStateMessageCopy\"\n    ></sie-ui-empty-state>\n  </div>\n</ng-template>\n\n<ng-template #mainContent>\n  <div *ngIf=\"options?.length || addCustomValue; else emptySuggestion\" class=\"combobox__suggestions\">\n    <ul *ngIf=\"options.length\" class=\"combobox__suggestions-list\">\n      <ng-container *ngFor=\"let option of options; let i = index\">\n        <li\n          *ngIf=\"!option.customValue\"\n          [tabindex]=\"-1\"\n          class=\"combobox__suggestions-item\"\n          role=\"option\"\n          [attr.data-index]=\"i\"\n          (keydown.arrowDown)=\"onOverlayArrowHandler($event)\"\n          (keydown.arrowUp)=\"onOverlayArrowHandler($event)\"\n          (keydown.tab)=\"onOverlayKeyTab()\"\n          (keydown.enter)=\"onOverlayKeyEnter($event, option)\"\n          (keydown.escape)=\"onOverlayKeyEscape()\"\n        >\n          <button\n            [tabindex]=\"-1\"\n            class=\"combobox__suggestions-btn\"\n            [ngClass]=\"{\n              'is-selected': option.id ? highlightedItem?.id === option.id : highlightedItem?.value === option.value,\n              'no-hover': !hover\n            }\"\n            (click)=\"onOverlayClick(option)\"\n            (mouseover)=\"onOverlayMouseOver(i)\"\n            (mouseout)=\"onOverlayMouseOut()\"\n          >\n            <p sieCoreHighlight [reference]=\"value\" [highlightStartOnly]=\"false\">{{ option.label }}</p>\n            <span *ngIf=\"option.metaInformation\" [title]=\"option.metaInformation\" class=\"combobox__meta-information\">{{\n              option.metaInformation\n            }}</span>\n          </button>\n        </li>\n      </ng-container>\n    </ul>\n    <ul\n      *ngIf=\"addCustomValue && customOption\"\n      class=\"combobox__add-option\"\n      [ngClass]=\"{ 'show-line': options.length > 1 }\"\n    >\n      <li\n        [tabindex]=\"-1\"\n        class=\"combobox__suggestions-item\"\n        role=\"option\"\n        [attr.data-index]=\"options.length - 1\"\n        (keydown.arrowDown)=\"onOverlayArrowHandler($event)\"\n        (keydown.arrowUp)=\"onOverlayArrowHandler($event)\"\n        (keydown.tab)=\"onOverlayKeyTab()\"\n        (keydown.enter)=\"onOverlayKeyEnter($event, customOption)\"\n        (keydown.escape)=\"onOverlayKeyEscape()\"\n      >\n        <div footer class=\"combobox__footer\">\n          <button\n            [tabindex]=\"-1\"\n            class=\"combobox__add-option-btn\"\n            (click)=\"onOverlayClick(customOption)\"\n            [ngClass]=\"{\n              'is-selected': highlightedItem?.value === customOption.value,\n              'no-hover': !hover\n            }\"\n            (mouseover)=\"onOverlayMouseOver(options.length - 1)\"\n            (mouseout)=\"onOverlayMouseOut()\"\n          >\n            <p class=\"combobox__add-option-value\">{{ customOption.label }}</p>\n            <p class=\"combobox__add-option-text\">{{ addCustomValueCopy }}</p>\n          </button>\n        </div>\n      </li>\n    </ul>\n  </div>\n</ng-template>\n", styles: [".combobox__dropdown__icon{outline:none;outline-offset:0}@media (pointer: fine){.combobox__dropdown__icon{position:relative}.combobox__dropdown__icon:focus{outline:1px solid #1491eb;outline-offset:2px}.combobox__dropdown__icon:focus:not(:focus-visible){outline:0}.combobox__dropdown__icon:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}:host{display:block}.combobox__add-option-btn,.combobox__suggestions-btn{display:flex;flex-direction:column;width:100%;border:0;background-color:transparent;text-align:left}.is-selected.combobox__add-option-btn,.is-selected.combobox__suggestions-btn,.combobox__add-option-btn:not(.no-hover):hover,.combobox__suggestions-btn:not(.no-hover):hover{background-color:#62eec7;cursor:pointer}.combobox{position:relative;width:100%}.combobox__label{display:flex;align-items:center;width:100%;height:100%}.combobox__menu{width:100%}.combobox__menu ::-webkit-scrollbar-thumb{background-clip:padding-box;background-color:#737389}.combobox__menu ::-webkit-scrollbar-button{display:none}.combobox__menu ::-webkit-scrollbar-corner{background-color:transparent}.combobox__menu ::-webkit-scrollbar{width:16px;height:8px}:host{scrollbar-color:#737389 #fff}:host .dark,:host.dark{scrollbar-color:#ccccd4 #001f39}.combobox__menu ::-webkit-scrollbar-thumb:vertical{border-left:8px solid transparent;border-right:4px solid transparent}.combobox__menu ::-webkit-scrollbar-thumb:horizontal{border-top:4px solid transparent}.combobox__menu ::-webkit-scrollbar-track:vertical{border-left:8px solid #fff;background:#ccccd4;border-right:4px solid #fff}.combobox__menu ::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #ccccd4}.combobox__menu .dark::-webkit-scrollbar-thumb,.combobox__menu .dark ::-webkit-scrollbar-thumb{background-color:#ccccd4}.combobox__menu .dark::-webkit-scrollbar-track:vertical,.combobox__menu .dark ::-webkit-scrollbar-track:vertical{background:#737389;border-right:4px solid #001f39;border-left:8px solid #001f39}.combobox__menu .dark::-webkit-scrollbar-track:horizontal,.combobox__menu .dark ::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #737389}.combobox__dropdown__icon{width:24px;height:24px;display:flex;align-items:center;fill:currentColor;position:absolute;top:16px;right:8px;margin-left:4px;z-index:1;-webkit-user-select:inherit;user-select:inherit;appearance:inherit;cursor:pointer}.combobox__dropdown__icon svg{fill:currentColor;width:inherit;height:inherit}.combobox__dropdown__icon svg g{fill:currentColor;width:inherit;height:inherit}.combobox__dropdown__icon svg text{font-family:Siemens Sans,sans-serif}.combobox__dropdown__icon svg{transition:transform .12s cubic-bezier(.4,0,.3,1)}.combobox__dropdown__icon.open svg{transform:translateZ(0) rotate(180deg)}.combobox__dropdown__icon.disabled{color:#b3b3be}.combobox__loading{height:270px;display:flex;justify-content:center;align-items:center}.combobox__suggestions-list{list-style:none;margin:0;padding:0;max-height:256px;overflow-y:auto}.combobox__suggestions-item:focus{outline:0}.combobox__suggestions-btn{padding:4px 16px}.combobox__meta-information{font-size:.75rem;font-weight:400;line-height:1rem;display:-webkit-box;-webkit-box-orient:vertical;-webkit-line-clamp:1;color:#4c4c68;text-overflow:ellipsis;overflow:hidden}.combobox__no-results-message{width:100%;display:inline-block;padding:4px 16px 6px;text-align:left}.combobox__no-results-message-copy,.combobox__add-option-text{font-size:.75rem;font-weight:400;line-height:1rem;color:#4c4c68}.combobox__add-option{list-style:none;padding:0;margin:0}.combobox__add-option.show-line:before{content:\"\";margin:8px 16px 4px;width:calc(100% - 32px);height:1px;display:block;background:#ccccd4}.combobox__add-option-btn{padding:0 16px 4px}.combobox__add-option-value{font-size:1rem;font-weight:700;line-height:1.5rem;padding-top:4px}.combobox__no-results-message-title,.combobox__add-option-value{white-space:nowrap;overflow:hidden;text-overflow:ellipsis;color:#000028;display:block;width:100%;vertical-align:top}.combobox__error{width:100%}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }, { type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: UiEventPropagationService }, { type: CdkOverlayService }]; }, propDecorators: { id: [{
                type: Input
            }], placeholder: [{
                type: Input
            }], value: [{
                type: Input
            }], noResultsMessageTitle: [{
                type: Input
            }], noResultsMessageCopy: [{
                type: Input
            }], emptyStateMessageTitle: [{
                type: Input
            }], emptyStateMessageCopy: [{
                type: Input
            }], clearSearchScreenReaderText: [{
                type: Input
            }], addCustomValueCopy: [{
                type: Input
            }], label: [{
                type: Input
            }], loadingMessage: [{
                type: Input
            }], patternValidationErrorMessage: [{
                type: Input
            }], invalidErrorMessage: [{
                type: Input
            }], requiredErrorMessage: [{
                type: Input
            }], autocomplete: [{
                type: Input
            }], validationPattern: [{
                type: Input
            }], options: [{
                type: Input
            }], addCustomValue: [{
                type: Input
            }], loading: [{
                type: Input
            }], error: [{
                type: Input
            }], invalid: [{
                type: Input
            }], required: [{
                type: Input
            }], selectedValue: [{
                type: Input
            }], disabled: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['class.is-disabled']
            }], focused: [{
                type: HostBinding,
                args: ['class.is-focused']
            }], optionSelected: [{
                type: Output
            }], inputValueChanged: [{
                type: Output
            }] } });

/**
 * # Combobox Module
 * - {@link UiComboboxComponent}
 *
 * ## Module peer dependencies
 * - {@link SieIconsModule}
 * - `@angular/platform-browser/animations/BrowserAnimationsModule`: This module is needed for the transition animation of the dropdown component
 */
class UiComboboxModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiComboboxModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiComboboxModule, declarations: [UiComboboxComponent], imports: [CommonModule,
            SieIconsModule,
            HighlightModule,
            FormsModule,
            UiDropdownMenuModule,
            UiTextInputModule,
            UiSpinnerModule,
            UiEmptyStateModule,
            OverlayModule,
            A11yModule], exports: [UiComboboxComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiComboboxModule, imports: [CommonModule,
            SieIconsModule,
            HighlightModule,
            FormsModule,
            UiDropdownMenuModule,
            UiTextInputModule,
            UiSpinnerModule,
            UiEmptyStateModule,
            OverlayModule,
            A11yModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiComboboxModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiComboboxComponent],
                    imports: [
                        CommonModule,
                        SieIconsModule,
                        HighlightModule,
                        FormsModule,
                        UiDropdownMenuModule,
                        UiTextInputModule,
                        UiSpinnerModule,
                        UiEmptyStateModule,
                        OverlayModule,
                        A11yModule
                    ],
                    exports: [UiComboboxComponent]
                }]
        }] });

/**
 * @enum {string}
 * Thumbnail status:
 * - `uploading`
 * - `error`
 * - `success`
 */
var UiThumbnailStatus;
(function (UiThumbnailStatus) {
    UiThumbnailStatus["Uploading"] = "uploading";
    UiThumbnailStatus["Error"] = "error";
    UiThumbnailStatus["Success"] = "success";
})(UiThumbnailStatus || (UiThumbnailStatus = {}));
/**
 * @enum {string}
 * Thumbnail type:
 * - `file`
 * - `picture`
 * - `pdf`
 */
var UiThumbnailType;
(function (UiThumbnailType) {
    UiThumbnailType["File"] = "file";
    UiThumbnailType["Picture"] = "picture";
    UiThumbnailType["Pdf"] = "pdf";
})(UiThumbnailType || (UiThumbnailType = {}));

/**
 * # Thumbnail Component
 *
 * The Thumbnail component provides a preview of an uploaded material.
 *
 * ## Component variations
 *
 * The Thumbnail component doesn't have any variations.
 *
 * ## Content
 *
 * The Thumbnail component does not accept any content.
 *
 * ## Code example
 * @example
 * Template:
 * ```html
 * <sie-ui-thumbnail [title]="Thumbnail title" [status]="success" [type]="file"></sie-ui-thumbnail>
 * ```
 */
class UiThumbnailComponent extends UiAutoDestroyableComponent {
    /**
     * @param icon {@link SieIcon Icon} Defines custom icon of the Thumbnail component.
     */
    set icon(icon) {
        if (SIE_ICONS.has(icon)) {
            this.iconReg.register(icon);
            this._icon = icon;
        }
    }
    get icon() {
        return this._icon;
    }
    constructor(iconReg, vcr) {
        super(vcr);
        this.iconReg = iconReg;
        this.vcr = vcr;
        /**
         * Defines title of the Thumbnail component.
         * @default ''
         */
        this.title = '';
        /**
         * Defines {@link UiThumbnailStatus Status} in which status the Thumbnail component will be shown.
         * @default 'success'
         */
        this.status = UiThumbnailStatus.Success;
        /**
         * Defines {@link UiThumbnailType Type} in which type the Thumbnail component will be shown.
         * @default 'file'
         */
        this.type = UiThumbnailType.File;
        /**
         * Event triggered when the refresh button is clicked.
         */
        this.refreshActionClicked = new EventEmitter();
        /**
         * Event triggered when the close button is clicked.
         */
        this.closeActionClicked = new EventEmitter();
        /** @ignore */
        this.spinnerSize = UiSpinnerSize.extraSmall;
        iconReg.register(SieIcon.CloseSmall);
        iconReg.register(SieIcon.Refresh);
    }
    /** @ignore */
    // eslint-disable-next-line @angular-eslint/no-empty-lifecycle-method
    ngOnDestroy() {
        // must be implemented according to UiAutoDestroyableComponent
    }
    /** @ignore */
    onRefreshActionClicked() {
        this.status = UiThumbnailStatus.Uploading;
        this.refreshActionClicked.emit();
    }
    /** @ignore */
    destroy(event) {
        this.closeActionClicked.emit(event);
        super.destroy(event);
    }
    /** @ignore */
    getIcon() {
        switch (this.type) {
            case UiThumbnailType.Picture:
                this.iconReg.register(SieIcon.Picture);
                return this.iconReg.sieIcon.Picture;
            case UiThumbnailType.Pdf:
                this.iconReg.register(SieIcon.Pdf);
                return this.iconReg.sieIcon.Pdf;
            default:
                this.iconReg.register(SieIcon.File);
                return this.iconReg.sieIcon.File;
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiThumbnailComponent, deps: [{ token: i1.SieIconRegistryService }, { token: i0.ViewContainerRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiThumbnailComponent, selector: "sie-ui-thumbnail", inputs: { icon: "icon", title: "title", status: "status", type: "type", errorMessage: "errorMessage" }, outputs: { refreshActionClicked: "refreshActionClicked", closeActionClicked: "closeActionClicked" }, usesInheritance: true, ngImport: i0, template: "<div class=\"thumbnail\">\n  <div class=\"thumbnail__content\" [ngClass]=\"{ 'thumbnail--error': status === 'error' }\">\n    <div class=\"thumbnail__title-wrapper\">\n      <sie-icon class=\"thumbnail__title-wrapper__icon\" [name]=\"icon || getIcon()\"></sie-icon>\n      <span *ngIf=\"title\" sieCoreAddTooltip class=\"thumbnail__title-wrapper__title\">{{ title }}</span>\n    </div>\n\n    <div class=\"thumbnail__actions\">\n      <ng-container [ngSwitch]=\"status\">\n        <ng-container *ngSwitchCase=\"'uploading'\">\n          <sie-ui-spinner\n            class=\"thumbnail__actions__uploading-spinner\"\n            active=\"true\"\n            [size]=\"spinnerSize\"\n          ></sie-ui-spinner>\n        </ng-container>\n        <ng-container *ngSwitchCase=\"'error'\">\n          <sie-ui-badge class=\"thumbnail__actions__error-badge\" type=\"icon\" status=\"error\"></sie-ui-badge>\n          <sie-ui-button\n            class=\"thumbnail__actions__refresh-btn\"\n            variant=\"icon-un-contained\"\n            themeType=\"icon\"\n            [icon]=\"iconReg.sieIcon.Refresh\"\n            (clicked)=\"onRefreshActionClicked()\"\n          ></sie-ui-button>\n        </ng-container>\n        <ng-container *ngSwitchDefault>\n          <sie-ui-badge class=\"thumbnail__actions__success-badge\" type=\"icon\" status=\"success\"></sie-ui-badge>\n        </ng-container>\n      </ng-container>\n\n      <sie-ui-button\n        class=\"thumbnail__actions__close-btn\"\n        variant=\"icon-un-contained\"\n        themeType=\"icon\"\n        [icon]=\"iconReg.sieIcon.CloseSmall\"\n        (clicked)=\"destroy($event)\"\n      ></sie-ui-button>\n    </div>\n  </div>\n  <span class=\"thumbnail__error-message\" *ngIf=\"status === 'error' && errorMessage\">{{ errorMessage }}</span>\n</div>\n", styles: [".thumbnail__content{display:flex;justify-content:space-between;align-items:center;max-height:40px;padding:10px 8px;border:1px solid #ccccd4;background-color:#fff}.thumbnail__title-wrapper{display:inline-flex;max-width:calc(100% - 40px);margin-top:2px}.thumbnail__title-wrapper__icon{width:20px;height:20px;display:flex;align-items:center;fill:currentColor;display:inline-block;margin-right:8px}.thumbnail__title-wrapper__icon svg{fill:currentColor;width:inherit;height:inherit}.thumbnail__title-wrapper__icon svg g{fill:currentColor;width:inherit;height:inherit}.thumbnail__title-wrapper__icon svg text{font-family:Siemens Sans,sans-serif}.thumbnail__title-wrapper__title{white-space:nowrap;overflow:hidden;text-overflow:ellipsis;flex:1;margin-right:8px}.thumbnail__actions{display:flex;align-items:center;justify-content:center}.thumbnail__actions__refresh-btn,.thumbnail__actions__close-btn{--icon-size-custom: 16px;--btn-width-custom: 16px;--btn-height-custom: 16px;margin-left:4px}.thumbnail__actions__error-badge,.thumbnail__actions__success-badge{padding-top:6px}.thumbnail__actions__uploading-spinner{padding-bottom:2px}.thumbnail__error-message{font-size:.75rem;font-weight:400;line-height:1rem;display:block;padding:2px 0 4px;color:#ef0137}.thumbnail--error{border:1px solid #ef0137;background-color:#fcccd7}.thumbnail--error .thumbnail__title-wrapper{max-width:calc(100% - 60px)}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgSwitch, selector: "[ngSwitch]", inputs: ["ngSwitch"] }, { kind: "directive", type: i2.NgSwitchCase, selector: "[ngSwitchCase]", inputs: ["ngSwitchCase"] }, { kind: "directive", type: i2.NgSwitchDefault, selector: "[ngSwitchDefault]" }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "component", type: UiButtonComponent, selector: "sie-ui-button" }, { kind: "component", type: UiSpinnerComponent, selector: "sie-ui-spinner", inputs: ["size", "message", "overlayOnTop", "overlay", "active"], outputs: ["animationEnded"] }, { kind: "component", type: UiBadgeComponent, selector: "sie-ui-badge", inputs: ["mode", "type", "number", "addOutline", "highlighted", "status"] }, { kind: "directive", type: i1$1.AddTooltipDirective, selector: "[sieCoreAddTooltip]" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
__decorate([
    RunInZone
], UiThumbnailComponent.prototype, "destroy", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiThumbnailComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-thumbnail', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"thumbnail\">\n  <div class=\"thumbnail__content\" [ngClass]=\"{ 'thumbnail--error': status === 'error' }\">\n    <div class=\"thumbnail__title-wrapper\">\n      <sie-icon class=\"thumbnail__title-wrapper__icon\" [name]=\"icon || getIcon()\"></sie-icon>\n      <span *ngIf=\"title\" sieCoreAddTooltip class=\"thumbnail__title-wrapper__title\">{{ title }}</span>\n    </div>\n\n    <div class=\"thumbnail__actions\">\n      <ng-container [ngSwitch]=\"status\">\n        <ng-container *ngSwitchCase=\"'uploading'\">\n          <sie-ui-spinner\n            class=\"thumbnail__actions__uploading-spinner\"\n            active=\"true\"\n            [size]=\"spinnerSize\"\n          ></sie-ui-spinner>\n        </ng-container>\n        <ng-container *ngSwitchCase=\"'error'\">\n          <sie-ui-badge class=\"thumbnail__actions__error-badge\" type=\"icon\" status=\"error\"></sie-ui-badge>\n          <sie-ui-button\n            class=\"thumbnail__actions__refresh-btn\"\n            variant=\"icon-un-contained\"\n            themeType=\"icon\"\n            [icon]=\"iconReg.sieIcon.Refresh\"\n            (clicked)=\"onRefreshActionClicked()\"\n          ></sie-ui-button>\n        </ng-container>\n        <ng-container *ngSwitchDefault>\n          <sie-ui-badge class=\"thumbnail__actions__success-badge\" type=\"icon\" status=\"success\"></sie-ui-badge>\n        </ng-container>\n      </ng-container>\n\n      <sie-ui-button\n        class=\"thumbnail__actions__close-btn\"\n        variant=\"icon-un-contained\"\n        themeType=\"icon\"\n        [icon]=\"iconReg.sieIcon.CloseSmall\"\n        (clicked)=\"destroy($event)\"\n      ></sie-ui-button>\n    </div>\n  </div>\n  <span class=\"thumbnail__error-message\" *ngIf=\"status === 'error' && errorMessage\">{{ errorMessage }}</span>\n</div>\n", styles: [".thumbnail__content{display:flex;justify-content:space-between;align-items:center;max-height:40px;padding:10px 8px;border:1px solid #ccccd4;background-color:#fff}.thumbnail__title-wrapper{display:inline-flex;max-width:calc(100% - 40px);margin-top:2px}.thumbnail__title-wrapper__icon{width:20px;height:20px;display:flex;align-items:center;fill:currentColor;display:inline-block;margin-right:8px}.thumbnail__title-wrapper__icon svg{fill:currentColor;width:inherit;height:inherit}.thumbnail__title-wrapper__icon svg g{fill:currentColor;width:inherit;height:inherit}.thumbnail__title-wrapper__icon svg text{font-family:Siemens Sans,sans-serif}.thumbnail__title-wrapper__title{white-space:nowrap;overflow:hidden;text-overflow:ellipsis;flex:1;margin-right:8px}.thumbnail__actions{display:flex;align-items:center;justify-content:center}.thumbnail__actions__refresh-btn,.thumbnail__actions__close-btn{--icon-size-custom: 16px;--btn-width-custom: 16px;--btn-height-custom: 16px;margin-left:4px}.thumbnail__actions__error-badge,.thumbnail__actions__success-badge{padding-top:6px}.thumbnail__actions__uploading-spinner{padding-bottom:2px}.thumbnail__error-message{font-size:.75rem;font-weight:400;line-height:1rem;display:block;padding:2px 0 4px;color:#ef0137}.thumbnail--error{border:1px solid #ef0137;background-color:#fcccd7}.thumbnail--error .thumbnail__title-wrapper{max-width:calc(100% - 60px)}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }, { type: i0.ViewContainerRef }]; }, propDecorators: { icon: [{
                type: Input
            }], title: [{
                type: Input
            }], status: [{
                type: Input
            }], type: [{
                type: Input
            }], errorMessage: [{
                type: Input
            }], refreshActionClicked: [{
                type: Output
            }], closeActionClicked: [{
                type: Output
            }], destroy: [] } });

/**
 * # Thumbnail Module
 * - {@link UiThumbnailComponent}
 *
 * ## Module peer dependencies
 * - {@link SieIconsModule}
 */
class UiThumbnailModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiThumbnailModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiThumbnailModule, declarations: [UiThumbnailComponent], imports: [CommonModule,
            SieIconsModule,
            UiButtonModule,
            UiSpinnerModule,
            UiBadgeModule,
            RunInZoneModule,
            AddTooltipModule], exports: [UiThumbnailComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiThumbnailModule, imports: [CommonModule,
            SieIconsModule,
            UiButtonModule,
            UiSpinnerModule,
            UiBadgeModule,
            RunInZoneModule,
            AddTooltipModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiThumbnailModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiThumbnailComponent],
                    imports: [
                        CommonModule,
                        SieIconsModule,
                        UiButtonModule,
                        UiSpinnerModule,
                        UiBadgeModule,
                        RunInZoneModule,
                        AddTooltipModule
                    ],
                    exports: [UiThumbnailComponent]
                }]
        }] });

class UiProgressStepComponent {
    set subState(value) {
        this._subState = value;
        switch (value) {
            case 'completed':
                this.iconName = SieIcon.SuccessFilled;
                break;
            case 'error':
                this.iconName = SieIcon.ErrorFilled;
                break;
            case 'warning':
                this.iconName = SieIcon.WarningFilled;
                break;
            default:
                this.iconName = undefined;
        }
        if (this.iconName) {
            this.iconReg.register(this.iconName);
        }
    }
    get subState() {
        return this._subState;
    }
    constructor(iconReg) {
        this.iconReg = iconReg;
        this.stepNumber = 0;
        this.stepPosition = 'default';
        this.stepBeforeInactive = false;
        this.stepAfterInactive = false;
        this.selected = new Subject();
    }
    onSelect(event) {
        event.preventDefault();
        if (this.state === 'active' || this.state === 'disabled') {
            return;
        }
        this.selected.next();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiProgressStepComponent, deps: [{ token: i1.SieIconRegistryService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiProgressStepComponent, selector: "sie-ui-progress-step", inputs: { hasValue: "hasValue", state: "state", subState: "subState", stepNumber: "stepNumber", label: "label", value: "value", stepPosition: "stepPosition", stepBeforeInactive: "stepBeforeInactive", stepAfterInactive: "stepAfterInactive" }, outputs: { selected: "selected" }, ngImport: i0, template: "<div\n  class=\"progress-step state-{{ state }} substate-{{ subState }}\"\n  tabindex=\"0\"\n  (click)=\"onSelect($event)\"\n  (keyup.enter)=\"onSelect($event)\"\n  [ngClass]=\"{\n    'step-before-inactive': stepBeforeInactive,\n    'step-after-inactive': stepAfterInactive\n  }\"\n>\n  <div class=\"progress-step__wrapper position-{{ stepPosition }}\">\n    <div class=\"progress-step__wrapper--border\">\n      <div class=\"progress-step__wrapper--content\">\n        <span class=\"progress-step__badge--icon\" *ngIf=\"iconName\">\n          <sie-icon [svgClass]=\"'progress-step__badge--icon__svg'\" [name]=\"iconName\"></sie-icon>\n        </span>\n        <span class=\"progress-step__number\">{{ stepNumber }}</span>\n      </div>\n    </div>\n  </div>\n  <span\n    *ngIf=\"!!label\"\n    [ngClass]=\"{ 'progress-step__label-with-value': hasValue }\"\n    class=\"progress-step__label\"\n    sieCoreAddTruncationAndTooltip\n    [maxNumberOfLinesToShow]=\"2\"\n    >{{ label }}</span\n  >\n  <span *ngIf=\"!!value\" class=\"progress-step__value\" sieCoreAddTruncationAndTooltip>{{ value }}</span>\n</div>\n", styles: [".progress-step{container:progress-step/inline-size;width:calc(100% + .3px);max-width:200px}.progress-step__badge--icon{height:20px;width:20px;position:absolute;z-index:1;top:-5px;right:-5px}.substate-completed .progress-step__badge--icon{color:#00af52}.substate-error .progress-step__badge--icon{color:#ef0137}.substate-warning .progress-step__badge--icon{color:#ff9000}.substate-info .progress-step__badge--icon{color:#00557c}.progress-step__badge--icon__svg{width:20px;height:20px;display:flex;align-items:center;fill:currentColor;position:relative;top:-4px}.progress-step__badge--icon__svg svg{fill:currentColor;width:inherit;height:inherit}.progress-step__badge--icon__svg svg g{fill:currentColor;width:inherit;height:inherit}.progress-step__badge--icon__svg svg text{font-family:Siemens Sans,sans-serif}.progress-step__badge--icon__svg circle{stroke:#fff;stroke-width:2px}.progress-step__wrapper{border-radius:50%;border-top:2px solid transparent;border-bottom:2px solid transparent;display:flex;margin-top:-2px}.progress-step__wrapper--content{border-radius:50%;position:relative}.state-completed .progress-step__wrapper--content,.state-warning .progress-step__wrapper--content,.state-error .progress-step__wrapper--content,.state-enabled .progress-step__wrapper--content{background-color:#ccccd4}.state-active .progress-step__wrapper--content{background-color:#00646e;color:#fff}.progress-step__wrapper--content .progress-step__number{margin:0;position:absolute;top:50%;left:50%;transform:translate(-50%,-50%)}.state-disabled .progress-step__wrapper--content{background-color:#ebebee}.state-disabled .progress-step__wrapper--content .progress-step__number{color:#b3b3be}.progress-step__wrapper--border{border-radius:50%;padding:3px;background-color:#fff}.progress-step__wrapper.position-single:before,.progress-step__wrapper.position-first:before{border-bottom:none}.progress-step__wrapper.position-single:after,.progress-step__wrapper.position-last:after{border-bottom:none}.progress-step__wrapper:before,.progress-step__wrapper:after{content:\"\";flex:1 1;border-bottom:2px solid #ccccd4;margin:auto}.step-before-inactive .progress-step__wrapper:before{border-color:#ebebee}.step-after-inactive .progress-step__wrapper:after{border-color:#ebebee}.progress-step__label{padding:0 8px;text-align:center;max-width:132px;margin:auto}.state-active .progress-step__label{color:#00646e}.progress-step.state-disabled .progress-step__wrapper:before,.progress-step.state-disabled .progress-step__wrapper:after{border-color:#ebebee}.progress-step.state-disabled .progress-step__label{color:#b3b3be}.progress-step__value{font-size:.75rem;font-weight:400;line-height:1rem;display:block;padding:0 8px;text-align:center;color:#9999a9;max-width:184px;margin:auto}.progress-step:hover.state-enabled,.progress-step:hover.state-completed,.progress-step:hover.state-warning,.progress-step:hover.state-error{cursor:pointer}.progress-step:hover.state-enabled .progress-step__label,.progress-step:hover.state-completed .progress-step__label,.progress-step:hover.state-warning .progress-step__label,.progress-step:hover.state-error .progress-step__label{color:#005159}.progress-step:hover.state-enabled .progress-step__wrapper,.progress-step:hover.state-completed .progress-step__wrapper,.progress-step:hover.state-warning .progress-step__wrapper,.progress-step:hover.state-error .progress-step__wrapper{border:none}.progress-step:hover.state-enabled .progress-step__wrapper--border,.progress-step:hover.state-completed .progress-step__wrapper--border,.progress-step:hover.state-warning .progress-step__wrapper--border,.progress-step:hover.state-error .progress-step__wrapper--border{border:2px solid #e5e5e9}@container progress-step (min-width:154px){.progress-step__label{font-size:1rem;font-weight:400;line-height:1.5rem;line-height:20px;max-width:132px;display:-webkit-box}.state-active .progress-step__label{font-size:1rem;font-weight:700;line-height:1.5rem;line-height:20px;display:-webkit-box}.progress-step__number{font-size:20px}.progress-step__wrapper{margin-bottom:4px}.progress-step__wrapper--content{width:42px;height:42px}.progress-step__label-with-value{max-width:184px}}@container progress-step (max-width:154px){.progress-step__wrapper{margin-bottom:2px}.progress-step__wrapper--content{width:35px;height:35px}.progress-step__badge--icon{height:17px;width:17px;top:-4px;right:-4px}.progress-step__badge--icon__svg{width:17px;height:17px;display:flex;align-items:center;fill:currentColor;top:-4px}.progress-step__badge--icon__svg svg{fill:currentColor;width:inherit;height:inherit}.progress-step__badge--icon__svg svg g{fill:currentColor;width:inherit;height:inherit}.progress-step__badge--icon__svg svg text{font-family:Siemens Sans,sans-serif}.progress-step__label{display:none}@container progress-step (min-width:128px){.progress-step__label{font-size:.875rem;font-weight:400;line-height:1.25rem;line-height:18px;max-width:118px;display:-webkit-box}}@container progress-step (min-width:128px){.state-active .progress-step__label{font-size:.875rem;font-weight:700;line-height:1.25rem;line-height:18px;display:-webkit-box}}.progress-step__label-with-value{max-width:150px}.progress-step:hover.state-enabled .progress-step__label,.progress-step:hover.state-completed .progress-step__label,.progress-step:hover.state-warning .progress-step__label,.progress-step:hover.state-error .progress-step__label{color:#000028}}@container progress-step (max-width:72px){.progress-step__number,.progress-step__label,.progress-step__value{display:none}.progress-step__wrapper--content{width:20px;height:20px}.progress-step__wrapper--border{padding:2px}.progress-step__badge--icon{position:absolute;top:5.5px;left:-10%;display:flex;align-items:center}.progress-step__badge--icon__svg{width:24px;height:24px;display:flex;align-items:center;fill:currentColor}.progress-step__badge--icon__svg svg{fill:currentColor;width:inherit;height:inherit}.progress-step__badge--icon__svg svg g{fill:currentColor;width:inherit;height:inherit}.progress-step__badge--icon__svg svg text{font-family:Siemens Sans,sans-serif}}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "directive", type: i1$1.AddTruncationAndTooltipDirective, selector: "[sieCoreAddTruncationAndTooltip]", inputs: ["maxNumberOfLinesToShow"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiProgressStepComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-progress-step', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div\n  class=\"progress-step state-{{ state }} substate-{{ subState }}\"\n  tabindex=\"0\"\n  (click)=\"onSelect($event)\"\n  (keyup.enter)=\"onSelect($event)\"\n  [ngClass]=\"{\n    'step-before-inactive': stepBeforeInactive,\n    'step-after-inactive': stepAfterInactive\n  }\"\n>\n  <div class=\"progress-step__wrapper position-{{ stepPosition }}\">\n    <div class=\"progress-step__wrapper--border\">\n      <div class=\"progress-step__wrapper--content\">\n        <span class=\"progress-step__badge--icon\" *ngIf=\"iconName\">\n          <sie-icon [svgClass]=\"'progress-step__badge--icon__svg'\" [name]=\"iconName\"></sie-icon>\n        </span>\n        <span class=\"progress-step__number\">{{ stepNumber }}</span>\n      </div>\n    </div>\n  </div>\n  <span\n    *ngIf=\"!!label\"\n    [ngClass]=\"{ 'progress-step__label-with-value': hasValue }\"\n    class=\"progress-step__label\"\n    sieCoreAddTruncationAndTooltip\n    [maxNumberOfLinesToShow]=\"2\"\n    >{{ label }}</span\n  >\n  <span *ngIf=\"!!value\" class=\"progress-step__value\" sieCoreAddTruncationAndTooltip>{{ value }}</span>\n</div>\n", styles: [".progress-step{container:progress-step/inline-size;width:calc(100% + .3px);max-width:200px}.progress-step__badge--icon{height:20px;width:20px;position:absolute;z-index:1;top:-5px;right:-5px}.substate-completed .progress-step__badge--icon{color:#00af52}.substate-error .progress-step__badge--icon{color:#ef0137}.substate-warning .progress-step__badge--icon{color:#ff9000}.substate-info .progress-step__badge--icon{color:#00557c}.progress-step__badge--icon__svg{width:20px;height:20px;display:flex;align-items:center;fill:currentColor;position:relative;top:-4px}.progress-step__badge--icon__svg svg{fill:currentColor;width:inherit;height:inherit}.progress-step__badge--icon__svg svg g{fill:currentColor;width:inherit;height:inherit}.progress-step__badge--icon__svg svg text{font-family:Siemens Sans,sans-serif}.progress-step__badge--icon__svg circle{stroke:#fff;stroke-width:2px}.progress-step__wrapper{border-radius:50%;border-top:2px solid transparent;border-bottom:2px solid transparent;display:flex;margin-top:-2px}.progress-step__wrapper--content{border-radius:50%;position:relative}.state-completed .progress-step__wrapper--content,.state-warning .progress-step__wrapper--content,.state-error .progress-step__wrapper--content,.state-enabled .progress-step__wrapper--content{background-color:#ccccd4}.state-active .progress-step__wrapper--content{background-color:#00646e;color:#fff}.progress-step__wrapper--content .progress-step__number{margin:0;position:absolute;top:50%;left:50%;transform:translate(-50%,-50%)}.state-disabled .progress-step__wrapper--content{background-color:#ebebee}.state-disabled .progress-step__wrapper--content .progress-step__number{color:#b3b3be}.progress-step__wrapper--border{border-radius:50%;padding:3px;background-color:#fff}.progress-step__wrapper.position-single:before,.progress-step__wrapper.position-first:before{border-bottom:none}.progress-step__wrapper.position-single:after,.progress-step__wrapper.position-last:after{border-bottom:none}.progress-step__wrapper:before,.progress-step__wrapper:after{content:\"\";flex:1 1;border-bottom:2px solid #ccccd4;margin:auto}.step-before-inactive .progress-step__wrapper:before{border-color:#ebebee}.step-after-inactive .progress-step__wrapper:after{border-color:#ebebee}.progress-step__label{padding:0 8px;text-align:center;max-width:132px;margin:auto}.state-active .progress-step__label{color:#00646e}.progress-step.state-disabled .progress-step__wrapper:before,.progress-step.state-disabled .progress-step__wrapper:after{border-color:#ebebee}.progress-step.state-disabled .progress-step__label{color:#b3b3be}.progress-step__value{font-size:.75rem;font-weight:400;line-height:1rem;display:block;padding:0 8px;text-align:center;color:#9999a9;max-width:184px;margin:auto}.progress-step:hover.state-enabled,.progress-step:hover.state-completed,.progress-step:hover.state-warning,.progress-step:hover.state-error{cursor:pointer}.progress-step:hover.state-enabled .progress-step__label,.progress-step:hover.state-completed .progress-step__label,.progress-step:hover.state-warning .progress-step__label,.progress-step:hover.state-error .progress-step__label{color:#005159}.progress-step:hover.state-enabled .progress-step__wrapper,.progress-step:hover.state-completed .progress-step__wrapper,.progress-step:hover.state-warning .progress-step__wrapper,.progress-step:hover.state-error .progress-step__wrapper{border:none}.progress-step:hover.state-enabled .progress-step__wrapper--border,.progress-step:hover.state-completed .progress-step__wrapper--border,.progress-step:hover.state-warning .progress-step__wrapper--border,.progress-step:hover.state-error .progress-step__wrapper--border{border:2px solid #e5e5e9}@container progress-step (min-width:154px){.progress-step__label{font-size:1rem;font-weight:400;line-height:1.5rem;line-height:20px;max-width:132px;display:-webkit-box}.state-active .progress-step__label{font-size:1rem;font-weight:700;line-height:1.5rem;line-height:20px;display:-webkit-box}.progress-step__number{font-size:20px}.progress-step__wrapper{margin-bottom:4px}.progress-step__wrapper--content{width:42px;height:42px}.progress-step__label-with-value{max-width:184px}}@container progress-step (max-width:154px){.progress-step__wrapper{margin-bottom:2px}.progress-step__wrapper--content{width:35px;height:35px}.progress-step__badge--icon{height:17px;width:17px;top:-4px;right:-4px}.progress-step__badge--icon__svg{width:17px;height:17px;display:flex;align-items:center;fill:currentColor;top:-4px}.progress-step__badge--icon__svg svg{fill:currentColor;width:inherit;height:inherit}.progress-step__badge--icon__svg svg g{fill:currentColor;width:inherit;height:inherit}.progress-step__badge--icon__svg svg text{font-family:Siemens Sans,sans-serif}.progress-step__label{display:none}@container progress-step (min-width:128px){.progress-step__label{font-size:.875rem;font-weight:400;line-height:1.25rem;line-height:18px;max-width:118px;display:-webkit-box}}@container progress-step (min-width:128px){.state-active .progress-step__label{font-size:.875rem;font-weight:700;line-height:1.25rem;line-height:18px;display:-webkit-box}}.progress-step__label-with-value{max-width:150px}.progress-step:hover.state-enabled .progress-step__label,.progress-step:hover.state-completed .progress-step__label,.progress-step:hover.state-warning .progress-step__label,.progress-step:hover.state-error .progress-step__label{color:#000028}}@container progress-step (max-width:72px){.progress-step__number,.progress-step__label,.progress-step__value{display:none}.progress-step__wrapper--content{width:20px;height:20px}.progress-step__wrapper--border{padding:2px}.progress-step__badge--icon{position:absolute;top:5.5px;left:-10%;display:flex;align-items:center}.progress-step__badge--icon__svg{width:24px;height:24px;display:flex;align-items:center;fill:currentColor}.progress-step__badge--icon__svg svg{fill:currentColor;width:inherit;height:inherit}.progress-step__badge--icon__svg svg g{fill:currentColor;width:inherit;height:inherit}.progress-step__badge--icon__svg svg text{font-family:Siemens Sans,sans-serif}}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }]; }, propDecorators: { hasValue: [{
                type: Input
            }], state: [{
                type: Input
            }], subState: [{
                type: Input
            }], stepNumber: [{
                type: Input
            }], label: [{
                type: Input
            }], value: [{
                type: Input
            }], stepPosition: [{
                type: Input
            }], stepBeforeInactive: [{
                type: Input
            }], stepAfterInactive: [{
                type: Input
            }], selected: [{
                type: Output
            }] } });

const MAX_STEPS = 7;
const PROGRESS_STEP_WIDTH = 200;
/**
 * # Progress Tracker component
 *
 * The Progress Tracker adds a mechanism to display various steps so that the user has an idea where they are located in
 * the process. This can be used for processes like checkout, workflows or feedback forms.
 *
 *
 * ## Component variations
 *
 * There are no variations as of now.
 * Currently, only the variant "Horizontal progress tracker" is implemented
 *
 * ## Content
 *
 * The progress tracker component does not accept any content.
 *
 *
 * ## Code example
 * @example ```html
 * <sie-ui-progress-tracker
 *   [steps]="[
 *     {
 *       state: 'completed',
 *       label: '1. Step'
 *     },
 *     {
 *       state: 'active',
 *       label: '2. Step'
 *     }
 *   ]"
 *   (progressStepSelected)="onStepSelected($event)"
 * ></sie-ui-progress-tracker>
 * ```
 */
class UiProgressTrackerComponent {
    /**
     * @param steps Displayed {@link ProgressStep steps} and their states (limited to 7)
     */
    set steps(steps) {
        this._steps = steps.slice(0, MAX_STEPS);
        this.maxWidth = this._steps.length * PROGRESS_STEP_WIDTH;
        this._steps.forEach((step, index) => (step.position = this.calculatePosition(index)));
        this.isWideLabel = this.checkIfProgressTrackerHasValue();
    }
    get steps() {
        return this._steps;
    }
    constructor(cdr) {
        this.cdr = cdr;
        /**
         * It allows the progress tracker to be centered
         */
        this.variant = 'default';
        /**
         * Event triggered when a step is selected by the user. The payload of the event is of type `number` and represents the
         * selected step.
         */
        this.progressStepSelected = new Subject();
    }
    updateView() {
        this.cdr.markForCheck();
    }
    calculatePosition(index) {
        if (this.steps.length === 1) {
            return 'single';
        }
        if (index === 0) {
            return 'first';
        }
        return this.steps.length === index + 1 ? 'last' : 'default';
    }
    checkIfProgressTrackerHasValue() {
        return this._steps.some(step => !!step.value);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiProgressTrackerComponent, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiProgressTrackerComponent, selector: "sie-ui-progress-tracker", inputs: { variant: "variant", steps: "steps" }, outputs: { progressStepSelected: "progressStepSelected" }, host: { properties: { "class": "this.variant" } }, ngImport: i0, template: "<ul class=\"progress-tracker__steps\" [style.max-width.px]=\"maxWidth\">\n  <li *ngFor=\"let step of steps; let index = index\">\n    <sie-ui-progress-step\n      [state]=\"step.state\"\n      [subState]=\"step.subState\"\n      [stepNumber]=\"index + 1\"\n      [label]=\"step.label\"\n      [value]=\"step.value\"\n      [stepPosition]=\"step.position\"\n      (selected)=\"progressStepSelected.next(index)\"\n      [stepBeforeInactive]=\"index > 0 && steps[index - 1]?.state === 'disabled'\"\n      [stepAfterInactive]=\"steps.length > index + 1 && steps[index + 1]?.state === 'disabled'\"\n      [hasValue]=\"isWideLabel\"\n    ></sie-ui-progress-step>\n  </li>\n</ul>\n", styles: [".progress-tracker__steps{list-style:none;margin:0;padding:0;display:grid;grid-auto-flow:column}:host(.centered) .progress-tracker__steps{margin:0 auto}\n"], dependencies: [{ kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "component", type: UiProgressStepComponent, selector: "sie-ui-progress-step", inputs: ["hasValue", "state", "subState", "stepNumber", "label", "value", "stepPosition", "stepBeforeInactive", "stepAfterInactive"], outputs: ["selected"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiProgressTrackerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-progress-tracker', changeDetection: ChangeDetectionStrategy.OnPush, template: "<ul class=\"progress-tracker__steps\" [style.max-width.px]=\"maxWidth\">\n  <li *ngFor=\"let step of steps; let index = index\">\n    <sie-ui-progress-step\n      [state]=\"step.state\"\n      [subState]=\"step.subState\"\n      [stepNumber]=\"index + 1\"\n      [label]=\"step.label\"\n      [value]=\"step.value\"\n      [stepPosition]=\"step.position\"\n      (selected)=\"progressStepSelected.next(index)\"\n      [stepBeforeInactive]=\"index > 0 && steps[index - 1]?.state === 'disabled'\"\n      [stepAfterInactive]=\"steps.length > index + 1 && steps[index + 1]?.state === 'disabled'\"\n      [hasValue]=\"isWideLabel\"\n    ></sie-ui-progress-step>\n  </li>\n</ul>\n", styles: [".progress-tracker__steps{list-style:none;margin:0;padding:0;display:grid;grid-auto-flow:column}:host(.centered) .progress-tracker__steps{margin:0 auto}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }]; }, propDecorators: { variant: [{
                type: HostBinding,
                args: ['class']
            }, {
                type: Input
            }], steps: [{
                type: Input
            }], progressStepSelected: [{
                type: Output
            }] } });

/**
 * # Progress Tracker Module
 * - {@link UiProgressTrackerComponent}
 *
 * ## Module peer dependencies
 * - {@link SieIconsModule}
 */
class UiProgressTrackerModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiProgressTrackerModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiProgressTrackerModule, declarations: [UiProgressStepComponent, UiProgressTrackerComponent], imports: [CommonModule, SieIconsModule, AddTruncationAndTooltipModule], exports: [UiProgressTrackerComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiProgressTrackerModule, imports: [CommonModule, SieIconsModule, AddTruncationAndTooltipModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiProgressTrackerModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiProgressStepComponent, UiProgressTrackerComponent],
                    imports: [CommonModule, SieIconsModule, AddTruncationAndTooltipModule],
                    exports: [UiProgressTrackerComponent]
                }]
        }] });

/**
 * @enum {string}
 * Possible statuses of Drop Zone component.
 */
var UiDropZoneStatus;
(function (UiDropZoneStatus) {
    UiDropZoneStatus["Default"] = "default";
    UiDropZoneStatus["Uploading"] = "uploading";
    UiDropZoneStatus["Invalid"] = "invalid";
    UiDropZoneStatus["InvalidNumberOfFiles"] = "invalidNumberOfFiles";
    UiDropZoneStatus["Error"] = "error";
    UiDropZoneStatus["Success"] = "success";
    UiDropZoneStatus["Dragover"] = "dragover";
    UiDropZoneStatus["Disabled"] = "disabled";
})(UiDropZoneStatus || (UiDropZoneStatus = {}));

const DEFAULT_MAX_ALLOWED_FILES = 5;
const DEFAULT_MAX_ALLOWED_FILE_SIZE = 2;
const MEGABYTES_IN_BYTES = 1048576;
/**
 * # Drop Zone component
 *
 * Adds a mechanism to upload files for further processing.
 *
 * ## Component variations
 *
 * - `default`: The default drop zone is displayed
 * - `invisible`: Will hide the component but preserve functionality if an `fileDropElement` is provided
 *
 * ## Content
 *
 * The Drop Zone component does not accept any content.
 *
 * ## Code example
 *
 * @example ```html
 * <sie-ui-drop-zone [config]="dropZoneConfig" [status]="'uploading'"></sie-ui-drop-zone>
 * ```
 */
class UiDropZoneComponent {
    /**
     * Defines how the component will handle dropped files
     *
     * - `true` -> will emit files by replacing already existing files, does not show thumbnails
     * - `false` -> will emit files by appending to already existing files, does show thumbnails
     */
    set contextSwitch(contextSwitch) {
        this._contextSwitch = coerceBooleanProperty(contextSwitch);
    }
    get contextSwitch() {
        return this._contextSwitch;
    }
    /**
     * @param status {@link UiDropZoneStatus Status} of the Drop Zone.
     */
    set status(status) {
        this._status = status;
        const statusConfig = this.config?.statusConfig?.[status];
        const icon = statusConfig?.icon;
        if (icon) {
            this.iconReg.register(icon);
            this.icon = icon;
        }
        else {
            this.icon = undefined;
        }
        this.transformHelperText(statusConfig);
        this.label = statusConfig?.label;
        this.cdr.markForCheck();
    }
    get status() {
        return this._status;
    }
    /**
     * @param config {@link UiDropZoneModel Configuration} of the Drop Zone.
     */
    set config(config) {
        this._config = config;
        this.maxAllowedFiles = config.maxAllowedFiles ?? DEFAULT_MAX_ALLOWED_FILES;
        this.maxAllowedFileSize = config.maxAllowedFileSize ?? DEFAULT_MAX_ALLOWED_FILE_SIZE;
        this.allowedMimeTypes = config.allowedFileExtensions?.map(extension => getMimeType(extension));
        // here we actually want to reassign the status to trigger change detection (or set it to 'default')
        // reason: sometimes the status input is processed before the config input on web component creation
        this.status = this.status || UiDropZoneStatus.Default;
    }
    get config() {
        return this._config;
    }
    /**
     * @param files Update the displayed file thumbnails on the component after outside change.
     */
    set files(files) {
        this._files = files;
        this.cdr.markForCheck();
    }
    get files() {
        return this._files;
    }
    /**
     * @param errorMessage Allows specifying an error message which is displayed below the component.
     */
    set errorMessage(errorMessage) {
        this._errorMessage = errorMessage;
    }
    get errorMessage() {
        return this._errorMessage;
    }
    /** @ignore */
    get localization() {
        return this.config?.localization;
    }
    constructor(cdr, iconReg, attachmentService) {
        this.cdr = cdr;
        this.iconReg = iconReg;
        this.attachmentService = attachmentService;
        /**
         * {@link DropZoneVariant Variant} of the Drop Zone.
         */
        this.variant = 'default';
        /**
         * Set alignment of thumbnails
         */
        this.thumbnailAlignment = 'vertical';
        /**
         * Defines {@link UiButtonModel button} configuration
         */
        this.button = {
            id: 'drop-zone-button',
            variant: 'secondary',
            buttonType: 'button',
            themeType: 'main'
        };
        /**
         * Event triggered when files are removed or uploaded, containing current {@link UiDropZoneFile list} of files.
         */
        this.filesChanged = new EventEmitter();
        /** @ignore */
        this.spinnerSize = UiSpinnerSize.large;
        /** @ignore */
        this.errorLines = [];
        /** @ignore */
        this.maxAllowedFiles = DEFAULT_MAX_ALLOWED_FILES;
        /** @ignore */
        this.maxAllowedFileSize = DEFAULT_MAX_ALLOWED_FILE_SIZE;
        /** @ignore */
        this.fileDropRef = getUniqueID('drop-zone');
        this._contextSwitch = false;
        this._files = [];
    }
    /** @ignore */
    ngAfterViewInit() {
        const dropZoneElement = this.fileDropElement || this.dropZone.nativeElement;
        // Dragover listener
        dropZoneElement.addEventListener('dragover', (event) => {
            event.preventDefault();
            event.stopPropagation();
            const items = event.dataTransfer.items;
            this.onFileDragOver(items);
        });
        // Dragleave listener
        dropZoneElement.addEventListener('dragleave', (event) => {
            event.preventDefault();
            event.stopPropagation();
            this.onFileDragOut();
        });
        // Drop listener
        dropZoneElement.addEventListener('drop', (event) => {
            event.preventDefault();
            event.stopPropagation();
            const files = event.dataTransfer.files;
            if (files.length > 0) {
                this.onFileDropped(files);
            }
        });
    }
    /** @ignore */
    onFileDropped(fileList) {
        this.statusBeforeDragValidation = null;
        if (this.status === UiDropZoneStatus.Invalid || this.status === UiDropZoneStatus.InvalidNumberOfFiles) {
            this.status = UiDropZoneStatus.Default;
            return;
        }
        this.prepareFilesList(fileList);
    }
    /** @ignore */
    onFileDragOver(itemList) {
        if (this.isDisabled() || this.statusBeforeDragValidation) {
            return;
        }
        this.statusBeforeDragValidation = this.status;
        this.errorMessage = null;
        if (itemList.length > this.getNumberOfFilesRemaining()) {
            this.status = UiDropZoneStatus.InvalidNumberOfFiles;
            return;
        }
        const validated = Array.from(itemList).every(item => this.isAllowedFileType(item.type));
        this.status = validated ? UiDropZoneStatus.Dragover : UiDropZoneStatus.Invalid;
    }
    /** @ignore */
    onFileDragOut() {
        if (this.isDisabled() || !this.statusBeforeDragValidation) {
            return;
        }
        this.status = UiDropZoneStatus.Default;
        this.statusBeforeDragValidation = null;
    }
    /** @ignore */
    fileBrowseHandler(fileList) {
        this.prepareFilesList(fileList);
        this.fileInputRef.nativeElement.value = null;
    }
    /** @ignore */
    closeActionClicked(index) {
        this.files.splice(index, 1);
        if (this.files.length < this.maxAllowedFiles) {
            this.status = UiDropZoneStatus.Default;
            this.errorMessage = null;
        }
        this.filesChanged.emit(this.files);
    }
    /** @ignore */
    refreshActionClicked(file, thumbnailRef) {
        if (file.hasValidationError) {
            thumbnailRef.status = file.thumbnailStatus;
            return;
        }
        file.errorMessage = null;
        file.thumbnailStatus = UiThumbnailStatus.Uploading;
        this.filesChanged.emit(this.files);
    }
    /** @ignore */
    prepareFilesList(fileList) {
        if (this.isDisabled()) {
            return;
        }
        const numberOfFilesRemaining = this.getNumberOfFilesRemaining();
        this.errorMessage = null;
        this.errorLines = [];
        this.errorInfoParagraph = null;
        if (fileList.length > numberOfFilesRemaining) {
            this.errorMessage = populateTemplate(this.config.errorLabels.numberOfFilesExceeded, {
                numberOfFiles: '' + numberOfFilesRemaining
            });
            this.status = UiDropZoneStatus.Error;
            return;
        }
        const list = Array.from(fileList);
        this.contextSwitch ? this.processFilesWithContextSwitch(list) : this.processFiles(list);
    }
    /** @ignore */
    attachmentDownload(e) {
        if (this.helperTextLink.blob) {
            return;
        }
        e.preventDefault();
        if (!this.helperTextLink.loading$.value) {
            this.loadAttachment(e);
        }
    }
    /** @ignore */
    getType(type) {
        switch (type) {
            case 'image/jpeg':
            case 'image/png':
                return UiThumbnailType.Picture;
            case 'application/pdf':
                return UiThumbnailType.Pdf;
            default:
                return UiThumbnailType.File;
        }
    }
    /** @ignore */
    isDisabled() {
        return this.status === UiDropZoneStatus.Uploading || this.status === UiDropZoneStatus.Disabled;
    }
    /** @ignore */
    openFileBrowser() {
        this.fileInputRef.nativeElement.click();
    }
    processFilesWithContextSwitch(fileList) {
        const maxAllowedFileSize = this.maxAllowedFileSize * MEGABYTES_IN_BYTES;
        this.files = fileList.map(inputFile => this.validateFile(inputFile, maxAllowedFileSize));
        const invalidFiles = this.files.filter(file => file.hasValidationError);
        // show errors formatted as specified if any file is invalid
        if (invalidFiles.length) {
            this.transformErrors(invalidFiles);
            this.status = UiDropZoneStatus.Error;
            return;
        }
        this.status = UiDropZoneStatus.Uploading;
        this.filesChanged.emit(this.files); // only emit event if all files are valid
    }
    transformErrors(invalidFiles) {
        if (invalidFiles.length === 1) {
            // single file
            const file = invalidFiles[0];
            this.errorMessage = populateTemplate(this.config.errorLabels.contextSwitch.error, {
                fileName: file.name,
                constraints: file.appliedConstraints
            });
        }
        else {
            // multiple files
            const labels = this.config.errorLabels.contextSwitch.multipleFiles;
            this.errorLines = invalidFiles.map(file => populateTemplate(labels.file, { fileName: file.name, constraints: file.appliedConstraints }));
            this.errorMessage = labels.error;
            this.errorInfoParagraph = labels.info;
        }
    }
    processFiles(fileList) {
        const maxAllowedFileSize = this.maxAllowedFileSize * MEGABYTES_IN_BYTES;
        fileList.forEach(inputFile => {
            const file = this.validateFile(inputFile, maxAllowedFileSize);
            if (file.hasValidationError) {
                file.errorMessage = populateTemplate(this.config.errorLabels.thumbnail, {
                    constraints: file.appliedConstraints
                });
            }
            this.files.push(file);
        });
        this.status = this.files.length < this.maxAllowedFiles ? UiDropZoneStatus.Default : UiDropZoneStatus.Disabled;
        this.filesChanged.emit(this.files);
    }
    validateFile(inputFile, maxAllowedFileSize) {
        const file = inputFile;
        const validationErrors = [];
        const constraintLabels = this.config.errorLabels.constraintLabels;
        // validate file type
        if (!this.isAllowedFileType(file.type)) {
            validationErrors.push(constraintLabels.invalidFormat);
        }
        // validate file size
        if (file.size > maxAllowedFileSize) {
            validationErrors.push(constraintLabels.fileSizeExceeded);
        }
        // concat validation error and set flags on file object
        file.hasValidationError = !!validationErrors.length;
        file.thumbnailStatus = file.hasValidationError ? UiThumbnailStatus.Error : UiThumbnailStatus.Uploading;
        file.appliedConstraints = validationErrors.join(' ' + constraintLabels.conjunction + ' ');
        return file;
    }
    getNumberOfFilesRemaining() {
        return this.contextSwitch ? this.maxAllowedFiles : this.maxAllowedFiles - this.files.length;
    }
    /**
     * @param mimetype
     * @returns true if allowedMimeTypes is undefined/empty or mimetype includes in allowedMimeTypes
     */
    isAllowedFileType(mimetype) {
        return !this.allowedMimeTypes?.length || this.allowedMimeTypes.includes(mimetype);
    }
    transformHelperText(statusConfig) {
        this.helperText = statusConfig?.helperText;
        if (!this.helperText) {
            return;
        }
        this.helperText = populateTemplate(this.helperText, {
            numberOfFiles: '' + this.getNumberOfFilesRemaining(),
            maxFileSize: '' + this.maxAllowedFileSize,
            allowedFileExtensions: this.config?.allowedFileExtensions?.join(', ') ?? ''
        });
        if (this.helperText.includes('{{link}}')) {
            this.helperTextTitle = populateTemplate(this.helperText, {
                link: statusConfig?.helperTextLink?.label
            });
            const splits = this.helperText.split('{{link}}');
            this.helperText = splits[0];
            this.helperTextAfterLink = splits[1];
            this.helperTextLink = statusConfig?.helperTextLink;
            if (this.helperTextLink && !this.helperTextLink.loading$) {
                this.helperTextLink.loading$ = new BehaviorSubject(false);
            }
        }
        else {
            this.helperTextAfterLink = undefined;
            this.helperTextLink = undefined;
            this.helperTextTitle = this.helperText;
        }
    }
    loadAttachment(e) {
        this.helperTextLink.loading$.next(true);
        this.attachmentService
            .downloadAttachment(this.helperTextLink.url)
            .then(blob => {
            this.helperTextLink.blob = blob;
            this.helperTextLink.loading$.next(false);
            requestAnimationFrame(() => e.target.click());
        })
            .catch(() => {
            this.errorMessage = this.config.errorLabels.sampleFileNotLoaded;
            this.helperTextLink.loading$.next(false);
        });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDropZoneComponent, deps: [{ token: i0.ChangeDetectorRef }, { token: i1.SieIconRegistryService }, { token: i1$1.AttachmentService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiDropZoneComponent, selector: "sie-ui-drop-zone", inputs: { fileDropElement: "fileDropElement", variant: "variant", thumbnailAlignment: "thumbnailAlignment", button: "button", contextSwitch: "contextSwitch", status: "status", config: "config", files: "files", errorMessage: "errorMessage" }, outputs: { filesChanged: "filesChanged" }, viewQueries: [{ propertyName: "dropZone", first: true, predicate: ["dropZone"], descendants: true }, { propertyName: "fileInputRef", first: true, predicate: ["fileInputRef"], descendants: true }], ngImport: i0, template: "<ng-container *ngIf=\"variant === 'default'\">\n  <div class=\"drop-zone\" ngClass=\"{{ variant }}\">\n    <!-- Drop Zone  -->\n    <div class=\"drop-zone__input {{ status }}\" #dropZone>\n      <div class=\"drop-zone__input--drop-area\"></div>\n      <input\n        type=\"file\"\n        [id]=\"fileDropRef\"\n        class=\"drop-zone__input--hidden\"\n        [multiple]=\"maxAllowedFiles > 1\"\n        (change)=\"fileBrowseHandler($event.target.files)\"\n        [disabled]=\"isDisabled()\"\n        [accept]=\"allowedMimeTypes\"\n        #fileInputRef\n      />\n      <sie-icon *ngIf=\"status !== 'uploading'\" class=\"drop-zone__icon\" [name]=\"icon\"></sie-icon>\n      <div *ngIf=\"status !== 'uploading'\">\n        <span *ngIf=\"label; else defaultLabel\" class=\"drop-zone__input--label\">{{ label }}</span>\n      </div>\n      <sie-ui-spinner\n        *ngIf=\"status === 'uploading'\"\n        class=\"drop-zone__uploading-spinner\"\n        active=\"true\"\n        [size]=\"spinnerSize\"\n      ></sie-ui-spinner>\n      <p class=\"drop-zone__input--helper-text\" [title]=\"helperTextTitle\" *ngIf=\"helperText\">\n        <span>{{ helperText }}</span>\n        <sie-ui-link\n          *ngIf=\"helperTextLink\"\n          [href]=\"helperTextLink.blob | sieBlobDownload\"\n          (clicked)=\"attachmentDownload($event)\"\n          [download]=\"helperTextLink.fileName\"\n          [disabled]=\"helperTextLink.loading$ | async\"\n          target=\"_blank\"\n          variant=\"inline\"\n          >{{ helperTextLink.label }}</sie-ui-link\n        >\n        <span *ngIf=\"helperTextAfterLink\">{{ helperTextAfterLink }}</span>\n      </p>\n\n      <sie-ui-button\n        *ngIf=\"status === 'default' || status === 'error' || status === 'disabled'\"\n        class=\"drop-zone__button button-variant\"\n        [id]=\"button.id\"\n        [themeType]=\"button.themeType\"\n        [buttonType]=\"button.buttonType\"\n        [variant]=\"button.variant\"\n        [icon]=\"button.icon\"\n        [iconPosition]=\"button.iconPosition\"\n        [disabled]=\"status === 'disabled'\"\n        (clicked)=\"openFileBrowser()\"\n        >{{ localization?.coarse.browseButton }}</sie-ui-button\n      >\n    </div>\n\n    <!-- Error Message -->\n    <div class=\"drop-zone__error\" *ngIf=\"errorMessage\">\n      <p>{{ errorMessage }}</p>\n      <ul *ngIf=\"errorLines.length > 0\">\n        <li *ngFor=\"let line of errorLines\">\n          {{ line }}\n        </li>\n      </ul>\n      <p *ngIf=\"errorInfoParagraph\">{{ errorInfoParagraph }}</p>\n    </div>\n\n    <!-- Wrapper for File List -->\n    <div\n      class=\"drop-zone__filelist\"\n      *ngIf=\"!contextSwitch && files.length > 0\"\n      [ngClass]=\"{ 'drop-zone__filelist--horizontal': thumbnailAlignment === 'horizontal' }\"\n    >\n      <ng-container *ngFor=\"let file of files; let i = index\">\n        <sie-ui-thumbnail\n          [title]=\"file?.name\"\n          [status]=\"file.thumbnailStatus\"\n          [type]=\"getType(file?.type)\"\n          [errorMessage]=\"file.errorMessage\"\n          (closeActionClicked)=\"closeActionClicked(i)\"\n          (refreshActionClicked)=\"refreshActionClicked(file, thumbnailRef)\"\n          class=\"drop-zone__filelist-thumbnail\"\n          #thumbnailRef\n        ></sie-ui-thumbnail>\n      </ng-container>\n    </div>\n  </div>\n</ng-container>\n\n<ng-template #defaultLabel>\n  <span class=\"drop-zone__input--label link-variant\">{{ localization?.fine.label }}&nbsp;</span>\n  <label\n    class=\"drop-zone__input--browse-link link-variant\"\n    *ngIf=\"localization?.fine.browseLink\"\n    [for]=\"fileDropRef\"\n    tabIndex=\"0\"\n    >{{ localization?.fine.browseLink }}</label\n  >\n  <span class=\"drop-zone__input--label button-variant\">{{ localization?.coarse.label }}</span>\n</ng-template>\n", styles: [":host{height:100%;display:block}.drop-zone__icon{margin-bottom:12px}.drop-zone__icon svg{fill:#7d8099;width:48px;height:48px}.drop-zone__input{width:100%;min-height:204px;padding:48px 62px 8px;text-align:center;border:dashed 1px #ccccd4;background-color:#0000280f;position:relative;margin:0 auto;transition:background-color .2s linear}.drop-zone__input--drop-area{position:absolute;z-index:2;width:100%;height:100%;top:0;left:0}.drop-zone__input--hidden{display:none}.drop-zone__input--browse-link{font-size:1rem;font-weight:700;line-height:1.5rem;color:#007993;display:inline;text-decoration:underline;position:relative;z-index:3}.drop-zone__input--browse-link:hover{cursor:pointer}.drop-zone__input--label{font-size:1rem;font-weight:700;line-height:1.5rem;color:#000028;display:inline}.drop-zone__input--helper-text{font-size:.875rem;font-weight:400;line-height:1.25rem;display:-webkit-box;-webkit-box-orient:vertical;-webkit-line-clamp:2;position:relative;z-index:3;color:#4c4c68;margin-top:4px;overflow:hidden}.drop-zone__input.invalid{border:dashed 1px #ff9000;background-color:#fff7d2}.drop-zone__input.invalid svg{fill:#ff9000}.drop-zone__input.invalidNumberOfFiles{border:dashed 1px #ff9000;background-color:#fff7d2}.drop-zone__input.invalidNumberOfFiles svg{fill:#ff9000}.drop-zone__input.success{border:dashed 1px #00af52;background-color:#d4fae6}.drop-zone__input.success svg{fill:#00af52}.drop-zone__input.error{border:dashed 1px #ef0137;background-color:#fcccd7}.drop-zone__input.dragover{border:dashed 1px #00646e;background-color:#0000281f}.drop-zone__input.disabled{border:dashed 1px #ccccd4;background-color:#ebebee}.drop-zone__input.disabled .drop-zone__input--label,.drop-zone__input.disabled .drop-zone__input--helper-text{color:#7d8099}.drop-zone__input.disabled .drop-zone__input--helper-text{color:#b3b3be}.drop-zone__input.disabled svg{fill:#b3b3be}.drop-zone__input.uploading{border:dashed 1px #00646e}.drop-zone__input.uploading,.drop-zone__input.dragover{padding:60px 62px 8px}@media (pointer: coarse){.drop-zone__input.uploading,.drop-zone__input.dragover{padding:98px 62px 8px}}@media (pointer: coarse){.drop-zone__input{min-height:276px;border:none}.drop-zone__input.dragover,.drop-zone__input.uploading,.drop-zone__input.invalid,.drop-zone__input.error,.drop-zone__input.success,.drop-zone__input.disabled{border:none}.drop-zone__input.drop-zone__input--helper-text{height:auto}}.drop-zone__uploading-spinner{display:block;margin-bottom:12px}.drop-zone__filelist{margin-top:24px}.drop-zone__filelist-thumbnail{display:block;margin-bottom:8px;min-width:207px;max-width:328px}.drop-zone__filelist-thumbnail:last-of-type{margin-bottom:0}.drop-zone__filelist--horizontal{display:flex;flex-wrap:wrap;margin-left:-4px;margin-right:-4px}.drop-zone__filelist--horizontal .drop-zone__filelist-thumbnail{padding-left:4px;padding-right:4px;width:328px}.drop-zone__error{font-size:.75rem;font-weight:400;line-height:1rem;color:#ef0137;padding:8px 0}.drop-zone__button{margin-top:24px;z-index:4}@media (pointer: fine){.drop-zone .button-variant{display:none}}@media (pointer: coarse){.drop-zone .link-variant{display:none}}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "component", type: UiThumbnailComponent, selector: "sie-ui-thumbnail", inputs: ["icon", "title", "status", "type", "errorMessage"], outputs: ["refreshActionClicked", "closeActionClicked"] }, { kind: "component", type: UiSpinnerComponent, selector: "sie-ui-spinner", inputs: ["size", "message", "overlayOnTop", "overlay", "active"], outputs: ["animationEnded"] }, { kind: "component", type: UiButtonComponent, selector: "sie-ui-button" }, { kind: "component", type: UiLinkComponent, selector: "sie-ui-link", inputs: ["disabled", "disableVisitedStyle", "hasMarginTop", "offsetIcon", "truncate", "inLinkList", "trailingIcon", "icon", "cssClass", "href", "size", "target", "variant", "background", "type", "reference", "screenReaderText", "secondaryLabel", "download", "dataAttributes", "tooltip", "buttonType"], outputs: ["clicked"] }, { kind: "pipe", type: i2.AsyncPipe, name: "async" }, { kind: "pipe", type: i1$1.BlobDownloadPipe, name: "sieBlobDownload" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDropZoneComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-drop-zone', changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-container *ngIf=\"variant === 'default'\">\n  <div class=\"drop-zone\" ngClass=\"{{ variant }}\">\n    <!-- Drop Zone  -->\n    <div class=\"drop-zone__input {{ status }}\" #dropZone>\n      <div class=\"drop-zone__input--drop-area\"></div>\n      <input\n        type=\"file\"\n        [id]=\"fileDropRef\"\n        class=\"drop-zone__input--hidden\"\n        [multiple]=\"maxAllowedFiles > 1\"\n        (change)=\"fileBrowseHandler($event.target.files)\"\n        [disabled]=\"isDisabled()\"\n        [accept]=\"allowedMimeTypes\"\n        #fileInputRef\n      />\n      <sie-icon *ngIf=\"status !== 'uploading'\" class=\"drop-zone__icon\" [name]=\"icon\"></sie-icon>\n      <div *ngIf=\"status !== 'uploading'\">\n        <span *ngIf=\"label; else defaultLabel\" class=\"drop-zone__input--label\">{{ label }}</span>\n      </div>\n      <sie-ui-spinner\n        *ngIf=\"status === 'uploading'\"\n        class=\"drop-zone__uploading-spinner\"\n        active=\"true\"\n        [size]=\"spinnerSize\"\n      ></sie-ui-spinner>\n      <p class=\"drop-zone__input--helper-text\" [title]=\"helperTextTitle\" *ngIf=\"helperText\">\n        <span>{{ helperText }}</span>\n        <sie-ui-link\n          *ngIf=\"helperTextLink\"\n          [href]=\"helperTextLink.blob | sieBlobDownload\"\n          (clicked)=\"attachmentDownload($event)\"\n          [download]=\"helperTextLink.fileName\"\n          [disabled]=\"helperTextLink.loading$ | async\"\n          target=\"_blank\"\n          variant=\"inline\"\n          >{{ helperTextLink.label }}</sie-ui-link\n        >\n        <span *ngIf=\"helperTextAfterLink\">{{ helperTextAfterLink }}</span>\n      </p>\n\n      <sie-ui-button\n        *ngIf=\"status === 'default' || status === 'error' || status === 'disabled'\"\n        class=\"drop-zone__button button-variant\"\n        [id]=\"button.id\"\n        [themeType]=\"button.themeType\"\n        [buttonType]=\"button.buttonType\"\n        [variant]=\"button.variant\"\n        [icon]=\"button.icon\"\n        [iconPosition]=\"button.iconPosition\"\n        [disabled]=\"status === 'disabled'\"\n        (clicked)=\"openFileBrowser()\"\n        >{{ localization?.coarse.browseButton }}</sie-ui-button\n      >\n    </div>\n\n    <!-- Error Message -->\n    <div class=\"drop-zone__error\" *ngIf=\"errorMessage\">\n      <p>{{ errorMessage }}</p>\n      <ul *ngIf=\"errorLines.length > 0\">\n        <li *ngFor=\"let line of errorLines\">\n          {{ line }}\n        </li>\n      </ul>\n      <p *ngIf=\"errorInfoParagraph\">{{ errorInfoParagraph }}</p>\n    </div>\n\n    <!-- Wrapper for File List -->\n    <div\n      class=\"drop-zone__filelist\"\n      *ngIf=\"!contextSwitch && files.length > 0\"\n      [ngClass]=\"{ 'drop-zone__filelist--horizontal': thumbnailAlignment === 'horizontal' }\"\n    >\n      <ng-container *ngFor=\"let file of files; let i = index\">\n        <sie-ui-thumbnail\n          [title]=\"file?.name\"\n          [status]=\"file.thumbnailStatus\"\n          [type]=\"getType(file?.type)\"\n          [errorMessage]=\"file.errorMessage\"\n          (closeActionClicked)=\"closeActionClicked(i)\"\n          (refreshActionClicked)=\"refreshActionClicked(file, thumbnailRef)\"\n          class=\"drop-zone__filelist-thumbnail\"\n          #thumbnailRef\n        ></sie-ui-thumbnail>\n      </ng-container>\n    </div>\n  </div>\n</ng-container>\n\n<ng-template #defaultLabel>\n  <span class=\"drop-zone__input--label link-variant\">{{ localization?.fine.label }}&nbsp;</span>\n  <label\n    class=\"drop-zone__input--browse-link link-variant\"\n    *ngIf=\"localization?.fine.browseLink\"\n    [for]=\"fileDropRef\"\n    tabIndex=\"0\"\n    >{{ localization?.fine.browseLink }}</label\n  >\n  <span class=\"drop-zone__input--label button-variant\">{{ localization?.coarse.label }}</span>\n</ng-template>\n", styles: [":host{height:100%;display:block}.drop-zone__icon{margin-bottom:12px}.drop-zone__icon svg{fill:#7d8099;width:48px;height:48px}.drop-zone__input{width:100%;min-height:204px;padding:48px 62px 8px;text-align:center;border:dashed 1px #ccccd4;background-color:#0000280f;position:relative;margin:0 auto;transition:background-color .2s linear}.drop-zone__input--drop-area{position:absolute;z-index:2;width:100%;height:100%;top:0;left:0}.drop-zone__input--hidden{display:none}.drop-zone__input--browse-link{font-size:1rem;font-weight:700;line-height:1.5rem;color:#007993;display:inline;text-decoration:underline;position:relative;z-index:3}.drop-zone__input--browse-link:hover{cursor:pointer}.drop-zone__input--label{font-size:1rem;font-weight:700;line-height:1.5rem;color:#000028;display:inline}.drop-zone__input--helper-text{font-size:.875rem;font-weight:400;line-height:1.25rem;display:-webkit-box;-webkit-box-orient:vertical;-webkit-line-clamp:2;position:relative;z-index:3;color:#4c4c68;margin-top:4px;overflow:hidden}.drop-zone__input.invalid{border:dashed 1px #ff9000;background-color:#fff7d2}.drop-zone__input.invalid svg{fill:#ff9000}.drop-zone__input.invalidNumberOfFiles{border:dashed 1px #ff9000;background-color:#fff7d2}.drop-zone__input.invalidNumberOfFiles svg{fill:#ff9000}.drop-zone__input.success{border:dashed 1px #00af52;background-color:#d4fae6}.drop-zone__input.success svg{fill:#00af52}.drop-zone__input.error{border:dashed 1px #ef0137;background-color:#fcccd7}.drop-zone__input.dragover{border:dashed 1px #00646e;background-color:#0000281f}.drop-zone__input.disabled{border:dashed 1px #ccccd4;background-color:#ebebee}.drop-zone__input.disabled .drop-zone__input--label,.drop-zone__input.disabled .drop-zone__input--helper-text{color:#7d8099}.drop-zone__input.disabled .drop-zone__input--helper-text{color:#b3b3be}.drop-zone__input.disabled svg{fill:#b3b3be}.drop-zone__input.uploading{border:dashed 1px #00646e}.drop-zone__input.uploading,.drop-zone__input.dragover{padding:60px 62px 8px}@media (pointer: coarse){.drop-zone__input.uploading,.drop-zone__input.dragover{padding:98px 62px 8px}}@media (pointer: coarse){.drop-zone__input{min-height:276px;border:none}.drop-zone__input.dragover,.drop-zone__input.uploading,.drop-zone__input.invalid,.drop-zone__input.error,.drop-zone__input.success,.drop-zone__input.disabled{border:none}.drop-zone__input.drop-zone__input--helper-text{height:auto}}.drop-zone__uploading-spinner{display:block;margin-bottom:12px}.drop-zone__filelist{margin-top:24px}.drop-zone__filelist-thumbnail{display:block;margin-bottom:8px;min-width:207px;max-width:328px}.drop-zone__filelist-thumbnail:last-of-type{margin-bottom:0}.drop-zone__filelist--horizontal{display:flex;flex-wrap:wrap;margin-left:-4px;margin-right:-4px}.drop-zone__filelist--horizontal .drop-zone__filelist-thumbnail{padding-left:4px;padding-right:4px;width:328px}.drop-zone__error{font-size:.75rem;font-weight:400;line-height:1rem;color:#ef0137;padding:8px 0}.drop-zone__button{margin-top:24px;z-index:4}@media (pointer: fine){.drop-zone .button-variant{display:none}}@media (pointer: coarse){.drop-zone .link-variant{display:none}}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i1.SieIconRegistryService }, { type: i1$1.AttachmentService }]; }, propDecorators: { dropZone: [{
                type: ViewChild,
                args: ['dropZone']
            }], fileInputRef: [{
                type: ViewChild,
                args: ['fileInputRef']
            }], fileDropElement: [{
                type: Input
            }], variant: [{
                type: Input
            }], thumbnailAlignment: [{
                type: Input
            }], button: [{
                type: Input
            }], contextSwitch: [{
                type: Input
            }], status: [{
                type: Input
            }], config: [{
                type: Input
            }], files: [{
                type: Input
            }], errorMessage: [{
                type: Input
            }], filesChanged: [{
                type: Output
            }] } });

/**
 * # DropZone Module
 * - {@link UiDropZoneComponent}
 *
 * ## Module peer dependencies
 * Requires the following to work properly:
 * - {@link SieIconsModule}
 */
class UiDropZoneModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDropZoneModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiDropZoneModule, declarations: [UiDropZoneComponent], imports: [CommonModule,
            SieIconsModule,
            UiThumbnailModule,
            TruncateModule,
            ComponentBreakpointsModule,
            UiSpinnerModule,
            UiButtonModule,
            UiLinkModule,
            SieCorePipesModule], exports: [UiDropZoneComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDropZoneModule, imports: [CommonModule,
            SieIconsModule,
            UiThumbnailModule,
            TruncateModule,
            ComponentBreakpointsModule,
            UiSpinnerModule,
            UiButtonModule,
            UiLinkModule,
            SieCorePipesModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDropZoneModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiDropZoneComponent],
                    exports: [UiDropZoneComponent],
                    imports: [
                        CommonModule,
                        SieIconsModule,
                        UiThumbnailModule,
                        TruncateModule,
                        ComponentBreakpointsModule,
                        UiSpinnerModule,
                        UiButtonModule,
                        UiLinkModule,
                        SieCorePipesModule
                    ]
                }]
        }] });

class UiProductRecommendationSkeletonComponent {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiProductRecommendationSkeletonComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiProductRecommendationSkeletonComponent, selector: "sie-ui-product-recommendation-skeleton", inputs: { justImage: "justImage" }, ngImport: i0, template: "<div class=\"product-recommendation-skeleton\">\n  <ng-container *ngIf=\"!justImage; else imagePartial\">\n    <sie-ui-skeleton\n      class=\"product-recommendation-skeleton__tag\"\n    ></sie-ui-skeleton>\n\n    <sie-ui-skeleton\n      class=\"product-recommendation-skeleton__menu-icon\"\n    ></sie-ui-skeleton>\n\n    <div class=\"product-recommendation-skeleton__content\">\n      <ng-container *ngTemplateOutlet=\"imagePartial\"></ng-container>\n\n      <div class=\"product-recommendation-skeleton__content-text\">\n        <sie-ui-skeleton\n          class=\"product-recommendation-skeleton__content-text-headline\"\n        ></sie-ui-skeleton>\n        <sie-ui-skeleton\n          class=\"product-recommendation-skeleton__content-text-lines\"\n          [count]=\"4\"\n        ></sie-ui-skeleton>\n      </div>\n    </div>\n    <div class=\"product-recommendation-skeleton__button-wrapper\">\n      <sie-ui-skeleton\n        class=\"product-recommendation-skeleton__button-wrapper-btn\"\n      ></sie-ui-skeleton>\n    </div>\n  </ng-container>\n</div>\n\n<ng-template #imagePartial>\n  <sie-ui-skeleton\n    class=\"product-recommendation-skeleton__content-image\"\n  ></sie-ui-skeleton>\n</ng-template>\n", styles: [".product-recommendation-skeleton__tag{width:172px;height:24px;--ui-skeleton-borderRadius: 0 0 12px 12px;position:absolute;top:0}@media (min-width: 640px){.product-recommendation-skeleton__tag{width:156px;border-radius:0 0 12px 12px}}.product-recommendation-skeleton__menu-icon{width:24px;height:24px;position:absolute;top:16px;right:6px}.product-recommendation-skeleton__content{width:100%;display:flex;flex-direction:row}@media (max-width: 639.78px){.product-recommendation-skeleton__content-image{min-width:72px;height:72px;margin-right:8px}}@media (min-width: 640px){.product-recommendation-skeleton__content-image{min-width:142px;height:142px;position:relative;left:-4px;margin-right:16px}}.product-recommendation-skeleton__content-text{display:flex;flex-direction:column;width:100%}.product-recommendation-skeleton__content-text-headline{margin-bottom:12px;width:214px;height:24px}.product-recommendation-skeleton__content-text-lines{--ui-skeleton-display: block;--ui-skeleton-height: 16px;--ui-skeleton-marginBottom: 4px}.product-recommendation-skeleton__button-wrapper{margin-top:24px;width:100%}@media (min-width: 640px){.product-recommendation-skeleton__button-wrapper{position:relative;top:-6px;display:flex;justify-content:flex-end;margin-top:0}}@media (max-width: 639.78px){.product-recommendation-skeleton__button-wrapper-btn{width:100%;height:48px}}@media (min-width: 640px){.product-recommendation-skeleton__button-wrapper-btn{width:144px;height:48px}}\n"], dependencies: [{ kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "component", type: UiSkeletonComponent, selector: "sie-ui-skeleton", inputs: ["shape", "loadingText", "ariaLabel", "count"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiProductRecommendationSkeletonComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-product-recommendation-skeleton', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"product-recommendation-skeleton\">\n  <ng-container *ngIf=\"!justImage; else imagePartial\">\n    <sie-ui-skeleton\n      class=\"product-recommendation-skeleton__tag\"\n    ></sie-ui-skeleton>\n\n    <sie-ui-skeleton\n      class=\"product-recommendation-skeleton__menu-icon\"\n    ></sie-ui-skeleton>\n\n    <div class=\"product-recommendation-skeleton__content\">\n      <ng-container *ngTemplateOutlet=\"imagePartial\"></ng-container>\n\n      <div class=\"product-recommendation-skeleton__content-text\">\n        <sie-ui-skeleton\n          class=\"product-recommendation-skeleton__content-text-headline\"\n        ></sie-ui-skeleton>\n        <sie-ui-skeleton\n          class=\"product-recommendation-skeleton__content-text-lines\"\n          [count]=\"4\"\n        ></sie-ui-skeleton>\n      </div>\n    </div>\n    <div class=\"product-recommendation-skeleton__button-wrapper\">\n      <sie-ui-skeleton\n        class=\"product-recommendation-skeleton__button-wrapper-btn\"\n      ></sie-ui-skeleton>\n    </div>\n  </ng-container>\n</div>\n\n<ng-template #imagePartial>\n  <sie-ui-skeleton\n    class=\"product-recommendation-skeleton__content-image\"\n  ></sie-ui-skeleton>\n</ng-template>\n", styles: [".product-recommendation-skeleton__tag{width:172px;height:24px;--ui-skeleton-borderRadius: 0 0 12px 12px;position:absolute;top:0}@media (min-width: 640px){.product-recommendation-skeleton__tag{width:156px;border-radius:0 0 12px 12px}}.product-recommendation-skeleton__menu-icon{width:24px;height:24px;position:absolute;top:16px;right:6px}.product-recommendation-skeleton__content{width:100%;display:flex;flex-direction:row}@media (max-width: 639.78px){.product-recommendation-skeleton__content-image{min-width:72px;height:72px;margin-right:8px}}@media (min-width: 640px){.product-recommendation-skeleton__content-image{min-width:142px;height:142px;position:relative;left:-4px;margin-right:16px}}.product-recommendation-skeleton__content-text{display:flex;flex-direction:column;width:100%}.product-recommendation-skeleton__content-text-headline{margin-bottom:12px;width:214px;height:24px}.product-recommendation-skeleton__content-text-lines{--ui-skeleton-display: block;--ui-skeleton-height: 16px;--ui-skeleton-marginBottom: 4px}.product-recommendation-skeleton__button-wrapper{margin-top:24px;width:100%}@media (min-width: 640px){.product-recommendation-skeleton__button-wrapper{position:relative;top:-6px;display:flex;justify-content:flex-end;margin-top:0}}@media (max-width: 639.78px){.product-recommendation-skeleton__button-wrapper-btn{width:100%;height:48px}}@media (min-width: 640px){.product-recommendation-skeleton__button-wrapper-btn{width:144px;height:48px}}\n"] }]
        }], propDecorators: { justImage: [{
                type: Input
            }] } });

class UiProductRecommendationComponent {
    constructor(layoutService, iconReg) {
        this.layoutService = layoutService;
        this.iconReg = iconReg;
        this.MAX_NUMBER_OF_LINES_TO_SHOW_DESCRIPTION = 4;
        this.MAX_NUMBER_OF_LINES_TO_SHOW_HEADLINE = 1;
        this.childActionClicked = new EventEmitter();
    }
    dropdownOptionSelected(button, item) {
        this.childActionClicked.emit({ button, item });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiProductRecommendationComponent, deps: [{ token: i1$1.LayoutService }, { token: i1.SieIconRegistryService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiProductRecommendationComponent, selector: "sie-ui-product-recommendation", inputs: { data: "data", image: "image" }, outputs: { childActionClicked: "childActionClicked" }, ngImport: i0, template: "<ng-container *ngIf=\"!data; else recommendationDataPartial\">\n  <div class=\"product-recommendation\">\n    <sie-ui-product-recommendation-skeleton [justImage]=\"false\"></sie-ui-product-recommendation-skeleton>\n  </div>\n</ng-container>\n\n<ng-template #recommendationDataPartial>\n  <div class=\"product-recommendation\" [sieCoreAttributes]=\"data.dataAttributes\">\n    <sie-ui-tag\n      class=\"product-recommendation__tag\"\n      [status]=\"'neutral'\"\n      [croppedTop]=\"true\"\n      sieUiPopover\n      [content]=\"data.hint\"\n    >\n      <span class=\"product-recommendation__tag__content\">\n        <span [innerHTML]=\"data.tagLabel\"></span>\n        <sie-icon class=\"product-recommendation__tag__icon\" [name]=\"iconReg.sieIcon.Information\"></sie-icon>\n      </span>\n    </sie-ui-tag>\n\n    <sie-ui-menu-button\n      *ngIf=\"data.childActions?.length\"\n      class=\"product-recommendation__menu-button\"\n      (click)=\"$event.stopPropagation()\"\n      [options]=\"data.childActions\"\n      (actionClicked)=\"dropdownOptionSelected($event, data)\"\n      (keyup.enter)=\"$event.stopPropagation()\"\n    ></sie-ui-menu-button>\n\n    <div class=\"product-recommendation__info\">\n      <ng-container *ngIf=\"!image; else imagePartial\">\n        <sie-ui-product-recommendation-skeleton [justImage]=\"true\"></sie-ui-product-recommendation-skeleton>\n      </ng-container>\n\n      <ng-template #imagePartial>\n        <div class=\"product-recommendation__info__image\">\n          <sie-ui-picture [model]=\"image\"></sie-ui-picture>\n        </div>\n      </ng-template>\n\n      <div class=\"product-recommendation__info__text\">\n        <h4\n          *ngIf=\"layoutService.isViewport$('L', 'XL', 'XXL') | async\"\n          class=\"product-recommendation__info__text__headline\"\n          sieCoreAddTruncationAndTooltip\n          [maxNumberOfLinesToShow]=\"MAX_NUMBER_OF_LINES_TO_SHOW_HEADLINE\"\n        >\n          {{ data.articleNumber }}\n        </h4>\n        <h3\n          *ngIf=\"layoutService.isViewport$('XS', 'S', 'M') | async\"\n          class=\"product-recommendation__info__text__headline\"\n          sieCoreAddTruncationAndTooltip\n          [maxNumberOfLinesToShow]=\"MAX_NUMBER_OF_LINES_TO_SHOW_HEADLINE\"\n        >\n          {{ data.articleNumber }}\n        </h3>\n        <p\n          class=\"product-recommendation__info__text__description\"\n          sieCoreAddTruncationAndTooltip\n          [maxNumberOfLinesToShow]=\"MAX_NUMBER_OF_LINES_TO_SHOW_DESCRIPTION\"\n        >\n          {{ data.description }}\n        </p>\n      </div>\n    </div>\n\n    <div class=\"product-recommendation__button-wrapper\">\n      <sie-ui-button\n        buttonType=\"link\"\n        themeType=\"main\"\n        variant=\"secondary\"\n        position=\"content\"\n        class=\"product-recommendation__button\"\n        target=\"_self\"\n        [link]=\"data.link.href\"\n        [fullWidth]=\"layoutService.isViewport$('XS', 'S') | async\"\n        >{{ data.link.linkText }}</sie-ui-button\n      >\n    </div>\n  </div>\n</ng-template>\n", styles: [".product-recommendation{position:relative;max-height:258px;padding:56px 16px 16px;border:1px solid #ccccd4;box-shadow:0 2px 2px #0000000f,0 6px 8px #00000014}.product-recommendation__tag{position:absolute;top:0}.product-recommendation__tag__content{display:flex;align-items:center}.product-recommendation__tag__icon{width:16px;height:16px;display:flex;align-items:center;fill:currentColor;margin-left:5px}.product-recommendation__tag__icon svg{fill:currentColor;width:inherit;height:inherit}.product-recommendation__tag__icon svg g{fill:currentColor;width:inherit;height:inherit}.product-recommendation__tag__icon svg text{font-family:Siemens Sans,sans-serif}.product-recommendation__menu-button{position:absolute;top:0;right:0}.product-recommendation__info{display:flex}@media (min-width: 640px){.product-recommendation__info{padding-bottom:48px}}.product-recommendation__info__image{position:relative;left:-4px;min-width:142px;height:142px}@media (max-width: 639.78px){.product-recommendation__info__image{min-width:72px;height:72px;left:0}}.product-recommendation__info__text{overflow:hidden;margin-left:12px}@media (max-width: 639.78px){.product-recommendation__info__text{margin-left:8px}}.product-recommendation__info__text__headline{margin-bottom:8px}.product-recommendation__info__text__description{font-size:.875rem;font-weight:400;line-height:1.25rem}.product-recommendation__button-wrapper{position:relative;right:0;margin-top:24px}@media (min-width: 640px){.product-recommendation__button-wrapper{display:flex;justify-content:flex-end;position:absolute;margin-top:0;bottom:16px;right:16px}}\n"], dependencies: [{ kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: UiTagComponent, selector: "sie-ui-tag", inputs: ["mode", "theme", "status", "tagId", "dataAttrName", "dataAttrValue", "disabled", "croppedTop", "condensed", "linkable", "removeButtonAriaLabel"], outputs: ["selected", "unselected", "removed", "clicked"] }, { kind: "component", type: UiButtonComponent, selector: "sie-ui-button" }, { kind: "component", type: UiPictureComponent, selector: "sie-ui-picture", inputs: ["model", "size", "ratio", "notLoadedLabel", "theme", "context", "caption", "shouldHaveOutline"], outputs: ["failedToLoadImg"] }, { kind: "directive", type: UiPopoverDirective, selector: "[sieUiPopover]", inputs: ["content", "popoverTemplate", "popoverSize", "popoverPlacement", "popoverAnimation", "popoverPlayAnimation", "popoverAnimationHideAfterTimeoutMS", "popoverLightTheme"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "directive", type: i1$1.AddTruncationAndTooltipDirective, selector: "[sieCoreAddTruncationAndTooltip]", inputs: ["maxNumberOfLinesToShow"] }, { kind: "component", type: UiMenuButtonComponent, selector: "sie-ui-menu-button", inputs: ["menuButtonScreenReaderText", "menuTheme", "menuButtonType", "menuButtonVariant", "menuButtonThemeType", "menuButtonText", "leadingButtonIcon"], outputs: ["actionClicked"] }, { kind: "directive", type: i1$1.AttributeDirective, selector: "[sieCoreAttributes]", inputs: ["sieCoreAttributes"] }, { kind: "component", type: UiProductRecommendationSkeletonComponent, selector: "sie-ui-product-recommendation-skeleton", inputs: ["justImage"] }, { kind: "pipe", type: i2.AsyncPipe, name: "async" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiProductRecommendationComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-product-recommendation', changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-container *ngIf=\"!data; else recommendationDataPartial\">\n  <div class=\"product-recommendation\">\n    <sie-ui-product-recommendation-skeleton [justImage]=\"false\"></sie-ui-product-recommendation-skeleton>\n  </div>\n</ng-container>\n\n<ng-template #recommendationDataPartial>\n  <div class=\"product-recommendation\" [sieCoreAttributes]=\"data.dataAttributes\">\n    <sie-ui-tag\n      class=\"product-recommendation__tag\"\n      [status]=\"'neutral'\"\n      [croppedTop]=\"true\"\n      sieUiPopover\n      [content]=\"data.hint\"\n    >\n      <span class=\"product-recommendation__tag__content\">\n        <span [innerHTML]=\"data.tagLabel\"></span>\n        <sie-icon class=\"product-recommendation__tag__icon\" [name]=\"iconReg.sieIcon.Information\"></sie-icon>\n      </span>\n    </sie-ui-tag>\n\n    <sie-ui-menu-button\n      *ngIf=\"data.childActions?.length\"\n      class=\"product-recommendation__menu-button\"\n      (click)=\"$event.stopPropagation()\"\n      [options]=\"data.childActions\"\n      (actionClicked)=\"dropdownOptionSelected($event, data)\"\n      (keyup.enter)=\"$event.stopPropagation()\"\n    ></sie-ui-menu-button>\n\n    <div class=\"product-recommendation__info\">\n      <ng-container *ngIf=\"!image; else imagePartial\">\n        <sie-ui-product-recommendation-skeleton [justImage]=\"true\"></sie-ui-product-recommendation-skeleton>\n      </ng-container>\n\n      <ng-template #imagePartial>\n        <div class=\"product-recommendation__info__image\">\n          <sie-ui-picture [model]=\"image\"></sie-ui-picture>\n        </div>\n      </ng-template>\n\n      <div class=\"product-recommendation__info__text\">\n        <h4\n          *ngIf=\"layoutService.isViewport$('L', 'XL', 'XXL') | async\"\n          class=\"product-recommendation__info__text__headline\"\n          sieCoreAddTruncationAndTooltip\n          [maxNumberOfLinesToShow]=\"MAX_NUMBER_OF_LINES_TO_SHOW_HEADLINE\"\n        >\n          {{ data.articleNumber }}\n        </h4>\n        <h3\n          *ngIf=\"layoutService.isViewport$('XS', 'S', 'M') | async\"\n          class=\"product-recommendation__info__text__headline\"\n          sieCoreAddTruncationAndTooltip\n          [maxNumberOfLinesToShow]=\"MAX_NUMBER_OF_LINES_TO_SHOW_HEADLINE\"\n        >\n          {{ data.articleNumber }}\n        </h3>\n        <p\n          class=\"product-recommendation__info__text__description\"\n          sieCoreAddTruncationAndTooltip\n          [maxNumberOfLinesToShow]=\"MAX_NUMBER_OF_LINES_TO_SHOW_DESCRIPTION\"\n        >\n          {{ data.description }}\n        </p>\n      </div>\n    </div>\n\n    <div class=\"product-recommendation__button-wrapper\">\n      <sie-ui-button\n        buttonType=\"link\"\n        themeType=\"main\"\n        variant=\"secondary\"\n        position=\"content\"\n        class=\"product-recommendation__button\"\n        target=\"_self\"\n        [link]=\"data.link.href\"\n        [fullWidth]=\"layoutService.isViewport$('XS', 'S') | async\"\n        >{{ data.link.linkText }}</sie-ui-button\n      >\n    </div>\n  </div>\n</ng-template>\n", styles: [".product-recommendation{position:relative;max-height:258px;padding:56px 16px 16px;border:1px solid #ccccd4;box-shadow:0 2px 2px #0000000f,0 6px 8px #00000014}.product-recommendation__tag{position:absolute;top:0}.product-recommendation__tag__content{display:flex;align-items:center}.product-recommendation__tag__icon{width:16px;height:16px;display:flex;align-items:center;fill:currentColor;margin-left:5px}.product-recommendation__tag__icon svg{fill:currentColor;width:inherit;height:inherit}.product-recommendation__tag__icon svg g{fill:currentColor;width:inherit;height:inherit}.product-recommendation__tag__icon svg text{font-family:Siemens Sans,sans-serif}.product-recommendation__menu-button{position:absolute;top:0;right:0}.product-recommendation__info{display:flex}@media (min-width: 640px){.product-recommendation__info{padding-bottom:48px}}.product-recommendation__info__image{position:relative;left:-4px;min-width:142px;height:142px}@media (max-width: 639.78px){.product-recommendation__info__image{min-width:72px;height:72px;left:0}}.product-recommendation__info__text{overflow:hidden;margin-left:12px}@media (max-width: 639.78px){.product-recommendation__info__text{margin-left:8px}}.product-recommendation__info__text__headline{margin-bottom:8px}.product-recommendation__info__text__description{font-size:.875rem;font-weight:400;line-height:1.25rem}.product-recommendation__button-wrapper{position:relative;right:0;margin-top:24px}@media (min-width: 640px){.product-recommendation__button-wrapper{display:flex;justify-content:flex-end;position:absolute;margin-top:0;bottom:16px;right:16px}}\n"] }]
        }], ctorParameters: function () { return [{ type: i1$1.LayoutService }, { type: i1.SieIconRegistryService }]; }, propDecorators: { data: [{
                type: Input
            }], image: [{
                type: Input
            }], childActionClicked: [{
                type: Output
            }] } });

class UiProductRecommendationModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiProductRecommendationModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiProductRecommendationModule, declarations: [UiProductRecommendationComponent, UiProductRecommendationSkeletonComponent], imports: [CommonModule,
            UiTagModule,
            UiButtonModule,
            UiPictureModule,
            UiPopoverModule,
            SieIconsModule,
            AddTruncationAndTooltipModule,
            UiMenuButtonModule,
            AttributeModule,
            UiSkeletonModule], exports: [UiProductRecommendationComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiProductRecommendationModule, imports: [CommonModule,
            UiTagModule,
            UiButtonModule,
            UiPictureModule,
            UiPopoverModule,
            SieIconsModule,
            AddTruncationAndTooltipModule,
            UiMenuButtonModule,
            AttributeModule,
            UiSkeletonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiProductRecommendationModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiProductRecommendationComponent, UiProductRecommendationSkeletonComponent],
                    imports: [
                        CommonModule,
                        UiTagModule,
                        UiButtonModule,
                        UiPictureModule,
                        UiPopoverModule,
                        SieIconsModule,
                        AddTruncationAndTooltipModule,
                        UiMenuButtonModule,
                        AttributeModule,
                        UiSkeletonModule
                    ],
                    exports: [UiProductRecommendationComponent]
                }]
        }] });

var UiReplyFormStatus;
(function (UiReplyFormStatus) {
    UiReplyFormStatus["Default"] = "default";
    UiReplyFormStatus["Loading"] = "loading";
    UiReplyFormStatus["Error"] = "error";
    UiReplyFormStatus["Success"] = "success";
    UiReplyFormStatus["Draft"] = "draft";
})(UiReplyFormStatus || (UiReplyFormStatus = {}));

class UiReplyFormComponent {
    set fadeInAnimation(value) {
        this._fadeInAnimation = coerceBooleanProperty(value);
    }
    get fadeInAnimation() {
        return this._fadeInAnimation;
    }
    set config(config) {
        this._config = config;
    }
    get config() {
        return this._config;
    }
    constructor(iconReg, container, layoutService, uiModalService) {
        this.iconReg = iconReg;
        this.container = container;
        this.layoutService = layoutService;
        this.uiModalService = uiModalService;
        this.status = UiReplyFormStatus.Default;
        this.textAreaValue = '';
        this.submitButtonClicked = new EventEmitter();
        this.cancelButtonClicked = new EventEmitter();
        this.editDraftButtonClicked = new EventEmitter();
        this.files = [];
        this.fileValidationError = false;
        this.toggleAnimationState = 'hide';
        this.textareaValid = false;
        this._fadeInAnimation = false;
    }
    ngOnInit() {
        this.fadeInAnimation ? this.triggerFadeInAnimation() : (this.toggleAnimationState = 'visible');
    }
    triggerFadeInAnimation() {
        this.toggleAnimationState = 'show';
    }
    onSubmitForm() {
        this.submitButtonClicked.emit({ message: this.textAreaValue, files: this.files });
    }
    onCancel() {
        if (this.textAreaValue || (this.files?.length && !this.fileValidationError)) {
            this.uiModalService.openOkCancelModal(this.container, this.config.cancelModal, () => this.cancelConfirmed(), () => null);
            return;
        }
        this.cancelConfirmed();
    }
    onFilesChanged(files) {
        let validationError = false;
        files.forEach(file => {
            if (file.hasValidationError) {
                validationError = true;
            }
            else {
                file.thumbnailStatus = UiThumbnailStatus.Success;
            }
        });
        this.fileValidationError = validationError;
        this.files = files;
    }
    cancelConfirmed() {
        if (this.fadeInAnimation) {
            this.toggleAnimationState = 'hide';
        }
        this.cancelButtonClicked.emit();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiReplyFormComponent, deps: [{ token: i1.SieIconRegistryService }, { token: i0.ViewContainerRef }, { token: i1$1.LayoutService }, { token: UiModalService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiReplyFormComponent, selector: "sie-ui-reply-form[config]", inputs: { status: "status", playAnimation: "playAnimation", textAreaValue: "textAreaValue", customError: "customError", fadeInAnimation: "fadeInAnimation", config: "config" }, outputs: { submitButtonClicked: "submitButtonClicked", cancelButtonClicked: "cancelButtonClicked", editDraftButtonClicked: "editDraftButtonClicked" }, viewQueries: [{ propertyName: "dropZoneComponent", first: true, predicate: ["dropZoneComponent"], descendants: true }, { propertyName: "textAreaComponent", first: true, predicate: UiTextareaComponent, descendants: true }], ngImport: i0, template: "<div\n  class=\"reply-form\"\n  [ngClass]=\"fadeInAnimation ? 'fade-in-animation' : ''\"\n  [@slideInSlideOut]=\"toggleAnimationState\"\n>\n  <sie-ui-message-box\n    *ngIf=\"status === 'success'\"\n    type=\"condensed\"\n    [variant]=\"'success'\"\n    class=\"reply-form__message-box\"\n    [message]=\"config.messageBoxes.success.description\"\n    [closeable]=\"true\"\n  ></sie-ui-message-box>\n  <sie-ui-message-box\n    *ngIf=\"status === 'error'\"\n    type=\"condensed\"\n    [variant]=\"'error'\"\n    class=\"reply-form__message-box\"\n    [message]=\"customError ? customError.description : config.messageBoxes.error.description\"\n    [closeable]=\"true\"\n  ></sie-ui-message-box>\n  <sie-ui-message-box\n    *ngIf=\"status === 'draft'\"\n    class=\"reply-form__message-box\"\n    [variant]=\"'info'\"\n    elementsLayout=\"top-button\"\n    [headline]=\"config.messageBoxes.draft.headline\"\n    [message]=\"config.messageBoxes.draft.description\"\n    [closeable]=\"false\"\n    [actionButtonLabel]=\"config.messageBoxes.draft.buttonText\"\n    (actionTriggered)=\"editDraftButtonClicked.emit()\"\n  ></sie-ui-message-box>\n\n  <ng-container *ngIf=\"status === 'default' || status === 'loading' || status === 'error'\">\n    <h4 class=\"reply-form__title\">{{ config.title }}</h4>\n    <sie-ui-textarea\n      *ngIf=\"status === 'default' || status === 'error'\"\n      class=\"reply-form__textarea\"\n      id=\"reply-form-textarea\"\n      [placeholder]=\"config.textarea.label\"\n      condensed=\"true\"\n      [(value)]=\"textAreaValue\"\n      (valueChange)=\"textareaValid = !!this.textAreaComponent.isInputValid()\"\n      [allowedCharacterLength]=\"config.textarea.maxCharacters\"\n      [allowedLengthErrorMessage]=\"config.validationMessages.characterLimit\"\n      [validationPattern]=\"config.textarea?.pattern\"\n      [patternValidationErrorMessage]=\"config.validationMessages.invalidCharacters\"\n    ></sie-ui-textarea>\n    <sie-ui-drop-zone\n      *ngIf=\"!!config && (status === 'default' || status === 'error')\"\n      class=\"reply-form__drop-zone\"\n      [config]=\"config.dropzone\"\n      [files]=\"files\"\n      thumbnailAlignment=\"horizontal\"\n      (filesChanged)=\"onFilesChanged($event)\"\n      #dropZoneComponent\n    ></sie-ui-drop-zone>\n    <div class=\"reply-form__loading\" *ngIf=\"status === 'loading'\">\n      <sie-ui-loading [listOfTexts]=\"config.loadingMessages\"></sie-ui-loading>\n    </div>\n    <div class=\"reply-form__footer\">\n      <div class=\"reply-form__disclaimer\">\n        <sie-icon [name]=\"iconReg.sieIcon.WarningFilled\" class=\"reply-form__disclaimer-icon\"></sie-icon>\n        <p>{{ config.disclaimer }}</p>\n      </div>\n      <div class=\"reply-form__buttons\">\n        <sie-ui-button\n          class=\"reply-form__button\"\n          id=\"reply-form-send\"\n          variant=\"secondary\"\n          buttonType=\"button\"\n          [icon]=\"iconReg.sieIcon.Send\"\n          [disabled]=\"status === 'loading' || !textAreaValue || fileValidationError || textareaValid\"\n          (clicked)=\"onSubmitForm()\"\n          [fullWidth]=\"layoutService.currentViewportObj$ | async | viewport : 'is' : 'S'\"\n          >{{ config.buttonText.send }}</sie-ui-button\n        >\n        <sie-ui-button\n          class=\"reply-form__button\"\n          id=\"reply-form-cancel\"\n          variant=\"tertiary\"\n          buttonType=\"button\"\n          [disabled]=\"status === 'loading'\"\n          (clicked)=\"onCancel()\"\n          [fullWidth]=\"layoutService.currentViewportObj$ | async | viewport : 'is' : 'S'\"\n          >{{ config.buttonText.cancel }}</sie-ui-button\n        >\n      </div>\n    </div>\n  </ng-container>\n</div>\n", styles: [":host{width:100%}.reply-form.fade-in-animation{height:0;opacity:0}.reply-form__title{padding-top:16px}.reply-form__textarea,.reply-form__drop-zone{margin-bottom:24px}.reply-form__message-box{display:block;margin-bottom:8px;margin-top:16px}@media (min-width: 1024px){.reply-form__message-box{margin-top:-24px}}@media (min-width: 1440px){.reply-form__message-box{margin-top:16px}}.reply-form__footer{display:flex;flex-direction:column;justify-content:space-between;gap:24px;margin-bottom:64px}@media (min-width: 1024px){.reply-form__footer{flex-direction:row}}.reply-form__disclaimer{font-size:.875rem;line-height:1.25rem;display:flex;align-items:flex-start}.reply-form__disclaimer-icon{width:18px;height:18px;display:flex;align-items:center;fill:currentColor;color:#ff9000;fill:#ff9000;margin-top:1px;margin-right:8px}.reply-form__disclaimer-icon svg{fill:currentColor;width:inherit;height:inherit}.reply-form__disclaimer-icon svg g{fill:currentColor;width:inherit;height:inherit}.reply-form__disclaimer-icon svg text{font-family:Siemens Sans,sans-serif}.reply-form__buttons{display:flex;flex-direction:column}@media (min-width: 640px){.reply-form__buttons{flex-direction:row;justify-content:flex-end}}@media (min-width: 640px){.reply-form__button:first-child{margin-right:8px}}@media (max-width: 639.78px){.reply-form__button:first-child{margin-bottom:8px}}.reply-form__loading{min-height:480px;display:flex;justify-content:center;align-items:center}\n"], dependencies: [{ kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: UiTextareaComponent, selector: "sie-ui-textarea" }, { kind: "component", type: UiDropZoneComponent, selector: "sie-ui-drop-zone", inputs: ["fileDropElement", "variant", "thumbnailAlignment", "button", "contextSwitch", "status", "config", "files", "errorMessage"], outputs: ["filesChanged"] }, { kind: "component", type: UiButtonComponent, selector: "sie-ui-button" }, { kind: "component", type: UiLoadingComponent, selector: "sie-ui-loading", inputs: ["listOfTexts", "duration", "showEmptyState", "emptyState", "spinnerSize"], outputs: ["emptyStateRetryButtonClicked"] }, { kind: "component", type: UiMessageBoxComponent, selector: "sie-ui-message-box", inputs: ["type", "headline", "message", "headlineCollapsed", "headlineExpanded", "limit", "link", "playAnimation", "screenReaderCloseIcon", "elementsLayout", "fadeInAnimation", "actionButtonLabel", "actionButtonLink", "secondaryActionButtonLabel", "variant", "closeable", "containerStyled"], outputs: ["actionTriggered", "messageClosed", "messageClosing", "messageLinkTriggered"] }, { kind: "pipe", type: i1$1.ViewportPipe, name: "viewport" }, { kind: "pipe", type: i2.AsyncPipe, name: "async" }], animations: [slideInSlideOutAnimation], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiReplyFormComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-reply-form[config]', animations: [slideInSlideOutAnimation], changeDetection: ChangeDetectionStrategy.OnPush, template: "<div\n  class=\"reply-form\"\n  [ngClass]=\"fadeInAnimation ? 'fade-in-animation' : ''\"\n  [@slideInSlideOut]=\"toggleAnimationState\"\n>\n  <sie-ui-message-box\n    *ngIf=\"status === 'success'\"\n    type=\"condensed\"\n    [variant]=\"'success'\"\n    class=\"reply-form__message-box\"\n    [message]=\"config.messageBoxes.success.description\"\n    [closeable]=\"true\"\n  ></sie-ui-message-box>\n  <sie-ui-message-box\n    *ngIf=\"status === 'error'\"\n    type=\"condensed\"\n    [variant]=\"'error'\"\n    class=\"reply-form__message-box\"\n    [message]=\"customError ? customError.description : config.messageBoxes.error.description\"\n    [closeable]=\"true\"\n  ></sie-ui-message-box>\n  <sie-ui-message-box\n    *ngIf=\"status === 'draft'\"\n    class=\"reply-form__message-box\"\n    [variant]=\"'info'\"\n    elementsLayout=\"top-button\"\n    [headline]=\"config.messageBoxes.draft.headline\"\n    [message]=\"config.messageBoxes.draft.description\"\n    [closeable]=\"false\"\n    [actionButtonLabel]=\"config.messageBoxes.draft.buttonText\"\n    (actionTriggered)=\"editDraftButtonClicked.emit()\"\n  ></sie-ui-message-box>\n\n  <ng-container *ngIf=\"status === 'default' || status === 'loading' || status === 'error'\">\n    <h4 class=\"reply-form__title\">{{ config.title }}</h4>\n    <sie-ui-textarea\n      *ngIf=\"status === 'default' || status === 'error'\"\n      class=\"reply-form__textarea\"\n      id=\"reply-form-textarea\"\n      [placeholder]=\"config.textarea.label\"\n      condensed=\"true\"\n      [(value)]=\"textAreaValue\"\n      (valueChange)=\"textareaValid = !!this.textAreaComponent.isInputValid()\"\n      [allowedCharacterLength]=\"config.textarea.maxCharacters\"\n      [allowedLengthErrorMessage]=\"config.validationMessages.characterLimit\"\n      [validationPattern]=\"config.textarea?.pattern\"\n      [patternValidationErrorMessage]=\"config.validationMessages.invalidCharacters\"\n    ></sie-ui-textarea>\n    <sie-ui-drop-zone\n      *ngIf=\"!!config && (status === 'default' || status === 'error')\"\n      class=\"reply-form__drop-zone\"\n      [config]=\"config.dropzone\"\n      [files]=\"files\"\n      thumbnailAlignment=\"horizontal\"\n      (filesChanged)=\"onFilesChanged($event)\"\n      #dropZoneComponent\n    ></sie-ui-drop-zone>\n    <div class=\"reply-form__loading\" *ngIf=\"status === 'loading'\">\n      <sie-ui-loading [listOfTexts]=\"config.loadingMessages\"></sie-ui-loading>\n    </div>\n    <div class=\"reply-form__footer\">\n      <div class=\"reply-form__disclaimer\">\n        <sie-icon [name]=\"iconReg.sieIcon.WarningFilled\" class=\"reply-form__disclaimer-icon\"></sie-icon>\n        <p>{{ config.disclaimer }}</p>\n      </div>\n      <div class=\"reply-form__buttons\">\n        <sie-ui-button\n          class=\"reply-form__button\"\n          id=\"reply-form-send\"\n          variant=\"secondary\"\n          buttonType=\"button\"\n          [icon]=\"iconReg.sieIcon.Send\"\n          [disabled]=\"status === 'loading' || !textAreaValue || fileValidationError || textareaValid\"\n          (clicked)=\"onSubmitForm()\"\n          [fullWidth]=\"layoutService.currentViewportObj$ | async | viewport : 'is' : 'S'\"\n          >{{ config.buttonText.send }}</sie-ui-button\n        >\n        <sie-ui-button\n          class=\"reply-form__button\"\n          id=\"reply-form-cancel\"\n          variant=\"tertiary\"\n          buttonType=\"button\"\n          [disabled]=\"status === 'loading'\"\n          (clicked)=\"onCancel()\"\n          [fullWidth]=\"layoutService.currentViewportObj$ | async | viewport : 'is' : 'S'\"\n          >{{ config.buttonText.cancel }}</sie-ui-button\n        >\n      </div>\n    </div>\n  </ng-container>\n</div>\n", styles: [":host{width:100%}.reply-form.fade-in-animation{height:0;opacity:0}.reply-form__title{padding-top:16px}.reply-form__textarea,.reply-form__drop-zone{margin-bottom:24px}.reply-form__message-box{display:block;margin-bottom:8px;margin-top:16px}@media (min-width: 1024px){.reply-form__message-box{margin-top:-24px}}@media (min-width: 1440px){.reply-form__message-box{margin-top:16px}}.reply-form__footer{display:flex;flex-direction:column;justify-content:space-between;gap:24px;margin-bottom:64px}@media (min-width: 1024px){.reply-form__footer{flex-direction:row}}.reply-form__disclaimer{font-size:.875rem;line-height:1.25rem;display:flex;align-items:flex-start}.reply-form__disclaimer-icon{width:18px;height:18px;display:flex;align-items:center;fill:currentColor;color:#ff9000;fill:#ff9000;margin-top:1px;margin-right:8px}.reply-form__disclaimer-icon svg{fill:currentColor;width:inherit;height:inherit}.reply-form__disclaimer-icon svg g{fill:currentColor;width:inherit;height:inherit}.reply-form__disclaimer-icon svg text{font-family:Siemens Sans,sans-serif}.reply-form__buttons{display:flex;flex-direction:column}@media (min-width: 640px){.reply-form__buttons{flex-direction:row;justify-content:flex-end}}@media (min-width: 640px){.reply-form__button:first-child{margin-right:8px}}@media (max-width: 639.78px){.reply-form__button:first-child{margin-bottom:8px}}.reply-form__loading{min-height:480px;display:flex;justify-content:center;align-items:center}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }, { type: i0.ViewContainerRef }, { type: i1$1.LayoutService }, { type: UiModalService }]; }, propDecorators: { dropZoneComponent: [{
                type: ViewChild,
                args: ['dropZoneComponent']
            }], textAreaComponent: [{
                type: ViewChild,
                args: [UiTextareaComponent]
            }], status: [{
                type: Input
            }], playAnimation: [{
                type: Input
            }], textAreaValue: [{
                type: Input
            }], customError: [{
                type: Input
            }], fadeInAnimation: [{
                type: Input
            }], config: [{
                type: Input
            }], submitButtonClicked: [{
                type: Output
            }], cancelButtonClicked: [{
                type: Output
            }], editDraftButtonClicked: [{
                type: Output
            }] } });

const DEFAULT_DROP_ZONE = {
    localization: {
        fine: {
            label: 'DropZone#Label#Default',
            browseLink: 'DropZone#BrowseLink#Link'
        },
        coarse: {
            label: 'DropZone#Label#DefaultWithButton',
            browseButton: 'DropZone#BrowseLink#Button'
        }
    },
    statusConfig: {
        default: {
            icon: 'Doc',
            helperText: 'DropZone#HelperText#Default'
        },
        success: {
            icon: 'CheckMark',
            label: 'DropZone#Label#Success',
            helperText: 'DropZone#HelperText#Success'
        },
        error: {
            icon: 'Doc',
            helperText: 'DropZone#HelperText#Default'
        },
        disabled: {
            icon: 'Information',
            label: 'DropZone#Label#Disabled',
            helperText: 'DropZone#HelperText#Disabled'
        },
        uploading: {
            helperText: 'DropZone#HelperText#Uploading'
        },
        dragover: {
            icon: 'SieportalUpload',
            label: 'DropZone#Label#Dragover'
        },
        invalid: {
            icon: 'Warning',
            label: 'DropZone#Label#Invalid',
            helperText: 'DropZone#HelperText#Invalid'
        },
        invalidNumberOfFiles: {
            icon: 'Warning',
            label: 'DropZone#Label#InvalidNumber',
            helperText: 'DropZone#HelperText#InvalidNumber'
        }
    },
    errorLabels: {
        thumbnail: 'DropZone#ErrorLabel#Thumbnail',
        contextSwitch: {
            error: 'DropZone#ErrorLabel#ContextSwitch#Error',
            multipleFiles: {
                error: 'DropZone#ErrorLabel#ContextSwitch#Multi#Error',
                info: 'DropZone#ErrorLabel#ContextSwitch#Multi#Info',
                file: 'DropZone#ErrorLabel#ContextSwitch#Multi#File'
            }
        },
        constraintLabels: {
            invalidFormat: 'DropZone#ErrorLabel#ConstraintLabels#InvalidFormat',
            fileSizeExceeded: 'DropZone#ErrorLabel#ConstraintLabels#FileSizeExceeded',
            conjunction: 'DropZone#ErrorLabel#ConstraintLabels#Conjunction'
        },
        numberOfFilesExceeded: 'DropZone#HelperText#InvalidNumber',
        sampleFileNotLoaded: 'DropZone#ErrorLabel#SampleFileNotLoaded'
    }
};
const singleFileStatusConfigurations = {
    dragover: {
        icon: 'SieportalUpload',
        label: 'DropZone#Label#DragoverSingle'
    },
    invalid: {
        icon: 'Warning',
        label: 'DropZone#Label#Invalid',
        helperText: 'DropZone#HelperText#InvalidSingle'
    },
    invalidNumberOfFiles: {
        icon: 'Warning',
        label: 'DropZone#Label#InvalidNumber',
        helperText: 'DropZone#HelperText#InvalidNumberSingle'
    }
};
const SINGLE_FILE_DROP_ZONE = {
    ...DEFAULT_DROP_ZONE,
    maxAllowedFiles: 1,
    statusConfig: {
        ...DEFAULT_DROP_ZONE.statusConfig,
        ...singleFileStatusConfigurations
    },
    errorLabels: {
        ...DEFAULT_DROP_ZONE.errorLabels,
        numberOfFilesExceeded: 'DropZone#HelperText#InvalidNumberSingle'
    }
};

class UiReplyFormModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiReplyFormModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiReplyFormModule, declarations: [UiReplyFormComponent], imports: [SieIconsModule,
            SieCorePipesModule,
            CommonModule,
            UiTextareaModule,
            UiDropZoneModule,
            UiButtonModule,
            UiLoadingModule,
            UiMessageBoxModule,
            SieIconsModule], exports: [UiReplyFormComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiReplyFormModule, imports: [SieIconsModule,
            SieCorePipesModule,
            CommonModule,
            UiTextareaModule,
            UiDropZoneModule,
            UiButtonModule,
            UiLoadingModule,
            UiMessageBoxModule,
            SieIconsModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiReplyFormModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiReplyFormComponent],
                    exports: [UiReplyFormComponent],
                    imports: [
                        SieIconsModule,
                        SieCorePipesModule,
                        CommonModule,
                        UiTextareaModule,
                        UiDropZoneModule,
                        UiButtonModule,
                        UiLoadingModule,
                        UiMessageBoxModule,
                        SieIconsModule
                    ]
                }]
        }] });

class UiInfinitePaginationComponent {
    constructor(iconReg, layoutService) {
        this.iconReg = iconReg;
        this.layoutService = layoutService;
        this.variant = 'load-more';
        this.disableActionButton = false;
        this.showActionButton = true;
        this.backToTopClicked = new Subject();
        this.actionButtonClicked = new Subject();
        iconReg.register(SieIcon.ArrowToTop);
        iconReg.register(SieIcon.ArrowDown);
        iconReg.register(SieIcon.Plus);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiInfinitePaginationComponent, deps: [{ token: i1.SieIconRegistryService }, { token: i1$1.LayoutService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiInfinitePaginationComponent, selector: "sie-ui-infinite-pagination", inputs: { variant: "variant", infinitePaginationData: "infinitePaginationData", disableActionButton: "disableActionButton", showActionButton: "showActionButton" }, outputs: { backToTopClicked: "backToTopClicked", actionButtonClicked: "actionButtonClicked" }, ngImport: i0, template: "<div class=\"infinite-pagination\" [ngClass]=\"['infinite-pagination--' + variant]\" data-ste-component=\"load-more\">\n  <ng-container *ngIf=\"(layoutService.currentViewportObj$ | async | viewport : 'is' : 'S') && variant !== 'show-more'\">\n    <ng-container *ngTemplateOutlet=\"backToTopBtn\"></ng-container>\n  </ng-container>\n  <ng-container *ngIf=\"variant === 'load-more' && infinitePaginationData?.loadMoreButtonLabel\">\n    <sie-ui-button\n      *ngIf=\"showActionButton\"\n      class=\"infinite-pagination__load-more-btn\"\n      variant=\"secondary\"\n      [icon]=\"iconReg.sieIcon.Plus\"\n      [fullWidth]=\"layoutService.currentViewportObj$ | async | viewport : 'is' : 'S'\"\n      [disabled]=\"disableActionButton\"\n      (clicked)=\"actionButtonClicked.next()\"\n      >{{ infinitePaginationData.loadMoreButtonLabel }}\n    </sie-ui-button>\n  </ng-container>\n  <ng-container *ngIf=\"variant === 'show-more' && infinitePaginationData?.showMoreData as showMore\">\n    <div class=\"infinite-pagination__show-more-container\">\n      <p *ngIf=\"showMore.label\" class=\"infinite-pagination__show-more-container__label\">{{ showMore.label }}</p>\n      <button\n        *ngIf=\"showActionButton && showMore.buttonLabel\"\n        type=\"button\"\n        class=\"infinite-pagination__show-more-container__button\"\n        [disabled]=\"disableActionButton\"\n        (click)=\"actionButtonClicked.next()\"\n      >\n        <sie-icon [name]=\"iconReg.sieIcon.ArrowDown\" class=\"infinite-pagination__show-more-container__icon\"></sie-icon>\n        <span>{{ showMore.buttonLabel }}</span>\n      </button>\n    </div>\n  </ng-container>\n  <ng-container *ngIf=\"variant === 'empty-state' && infinitePaginationData?.emptyStateData as emptyState\">\n    <sie-ui-empty-state\n      class=\"infinite-pagination__empty-state\"\n      [iconPosition]=\"emptyState.iconPosition\"\n      [customIcon]=\"emptyState.customIcon\"\n      [headline]=\"emptyState.headline\"\n      [text]=\"emptyState.text\"\n      [button]=\"emptyState.button\"\n      (buttonClicked)=\"actionButtonClicked.next()\"\n    ></sie-ui-empty-state>\n  </ng-container>\n  <ng-container *ngIf=\"variant === 'message' && infinitePaginationData?.messageData as message\">\n    <div class=\"infinite-pagination__message-container\">\n      <span *ngIf=\"message.primaryLabel\" class=\"primary-message\">{{ message.primaryLabel }}</span>\n      <span *ngIf=\"message.secondaryLabel\" class=\"secondary-message\">{{ message.secondaryLabel }}</span>\n    </div>\n  </ng-container>\n  <ng-container *ngIf=\"(layoutService.currentViewportObj$ | async | viewport : 'not' : 'S') || variant === 'show-more'\">\n    <ng-container *ngTemplateOutlet=\"backToTopBtn\"></ng-container>\n  </ng-container>\n</div>\n\n<ng-template #backToTopBtn>\n  <sie-ui-button\n    class=\"infinite-pagination__back-to-top-btn\"\n    cssClass=\"to-top-button\"\n    themeType=\"icon\"\n    variant=\"icon-un-contained\"\n    (clicked)=\"backToTopClicked.next()\"\n    [icon]=\"iconReg.sieIcon.ArrowToTop\"\n  >\n    <span *ngIf=\"infinitePaginationData?.backToTopButtonScreenReaderText\" class=\"visually-hidden\">{{\n      infinitePaginationData.backToTopButtonScreenReaderText\n    }}</span>\n  </sie-ui-button>\n</ng-template>\n", styles: [".infinite-pagination__show-more-container__button{outline:none;outline-offset:0}@media (pointer: fine){.infinite-pagination__show-more-container__button{position:relative}.infinite-pagination__show-more-container__button:focus{outline:1px solid #1491eb;outline-offset:2px}.infinite-pagination__show-more-container__button:focus:not(:focus-visible){outline:0}.infinite-pagination__show-more-container__button:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}:host{display:block}.infinite-pagination{display:flex;position:relative;justify-content:center;flex-direction:column;align-items:flex-end}@media (min-width: 640px){.infinite-pagination{flex-direction:row;justify-content:center;align-items:flex-start}}.infinite-pagination__back-to-top-btn{position:initial;margin-right:-10px}@media (min-width: 640px){.infinite-pagination__back-to-top-btn{position:absolute;right:0}}.infinite-pagination--show-more{flex-direction:row;justify-content:center}.infinite-pagination--show-more .infinite-pagination__back-to-top-btn{position:absolute;right:0;top:-12px}@media (min-width: 640px){.infinite-pagination--load-more{align-items:center}}@media (max-width: 639.78px){.infinite-pagination__load-more-btn{margin-top:14px}}.infinite-pagination__show-more-container{display:flex;flex-direction:column;align-items:center;min-height:22px}.infinite-pagination__show-more-container__label{font-size:.875rem;font-weight:400;line-height:1.25rem;color:#4c4c68;margin-bottom:6px}.infinite-pagination__show-more-container__button{font-size:1rem;font-weight:400;line-height:1.5rem;border:0;background:none;text-decoration:none;color:#007993;fill:#007993;cursor:pointer;margin-top:-2px}.infinite-pagination__show-more-container__button:hover,.infinite-pagination__show-more-container__button:active{color:#33747a;fill:#33747a}.infinite-pagination__show-more-container__button:disabled{cursor:not-allowed;color:#b3b3be;fill:#b3b3be}.infinite-pagination__show-more-container__icon{margin:-4px 3px 0 -4px}.infinite-pagination__empty-state{width:100%;margin-top:-26px}@media (min-width: 640px){.infinite-pagination__empty-state{margin-top:-40px;align-items:flex-start}}.infinite-pagination__message-container{font-size:.75rem;font-weight:400;line-height:1rem;display:flex;flex-direction:column;margin-top:14px;width:100%;color:#4c4c68;text-align:center}@media (min-width: 640px){.infinite-pagination__message-container{width:initial;margin-top:10px}}.infinite-pagination__message-container .primary-message{margin-bottom:8px}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "component", type: UiButtonComponent, selector: "sie-ui-button" }, { kind: "component", type: UiEmptyStateComponent, selector: "sie-ui-empty-state", inputs: ["theme", "headline", "text", "link", "button", "iconPosition", "padding", "customIcon"], outputs: ["buttonClicked"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "pipe", type: i2.AsyncPipe, name: "async" }, { kind: "pipe", type: i1$1.ViewportPipe, name: "viewport" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiInfinitePaginationComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-infinite-pagination', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"infinite-pagination\" [ngClass]=\"['infinite-pagination--' + variant]\" data-ste-component=\"load-more\">\n  <ng-container *ngIf=\"(layoutService.currentViewportObj$ | async | viewport : 'is' : 'S') && variant !== 'show-more'\">\n    <ng-container *ngTemplateOutlet=\"backToTopBtn\"></ng-container>\n  </ng-container>\n  <ng-container *ngIf=\"variant === 'load-more' && infinitePaginationData?.loadMoreButtonLabel\">\n    <sie-ui-button\n      *ngIf=\"showActionButton\"\n      class=\"infinite-pagination__load-more-btn\"\n      variant=\"secondary\"\n      [icon]=\"iconReg.sieIcon.Plus\"\n      [fullWidth]=\"layoutService.currentViewportObj$ | async | viewport : 'is' : 'S'\"\n      [disabled]=\"disableActionButton\"\n      (clicked)=\"actionButtonClicked.next()\"\n      >{{ infinitePaginationData.loadMoreButtonLabel }}\n    </sie-ui-button>\n  </ng-container>\n  <ng-container *ngIf=\"variant === 'show-more' && infinitePaginationData?.showMoreData as showMore\">\n    <div class=\"infinite-pagination__show-more-container\">\n      <p *ngIf=\"showMore.label\" class=\"infinite-pagination__show-more-container__label\">{{ showMore.label }}</p>\n      <button\n        *ngIf=\"showActionButton && showMore.buttonLabel\"\n        type=\"button\"\n        class=\"infinite-pagination__show-more-container__button\"\n        [disabled]=\"disableActionButton\"\n        (click)=\"actionButtonClicked.next()\"\n      >\n        <sie-icon [name]=\"iconReg.sieIcon.ArrowDown\" class=\"infinite-pagination__show-more-container__icon\"></sie-icon>\n        <span>{{ showMore.buttonLabel }}</span>\n      </button>\n    </div>\n  </ng-container>\n  <ng-container *ngIf=\"variant === 'empty-state' && infinitePaginationData?.emptyStateData as emptyState\">\n    <sie-ui-empty-state\n      class=\"infinite-pagination__empty-state\"\n      [iconPosition]=\"emptyState.iconPosition\"\n      [customIcon]=\"emptyState.customIcon\"\n      [headline]=\"emptyState.headline\"\n      [text]=\"emptyState.text\"\n      [button]=\"emptyState.button\"\n      (buttonClicked)=\"actionButtonClicked.next()\"\n    ></sie-ui-empty-state>\n  </ng-container>\n  <ng-container *ngIf=\"variant === 'message' && infinitePaginationData?.messageData as message\">\n    <div class=\"infinite-pagination__message-container\">\n      <span *ngIf=\"message.primaryLabel\" class=\"primary-message\">{{ message.primaryLabel }}</span>\n      <span *ngIf=\"message.secondaryLabel\" class=\"secondary-message\">{{ message.secondaryLabel }}</span>\n    </div>\n  </ng-container>\n  <ng-container *ngIf=\"(layoutService.currentViewportObj$ | async | viewport : 'not' : 'S') || variant === 'show-more'\">\n    <ng-container *ngTemplateOutlet=\"backToTopBtn\"></ng-container>\n  </ng-container>\n</div>\n\n<ng-template #backToTopBtn>\n  <sie-ui-button\n    class=\"infinite-pagination__back-to-top-btn\"\n    cssClass=\"to-top-button\"\n    themeType=\"icon\"\n    variant=\"icon-un-contained\"\n    (clicked)=\"backToTopClicked.next()\"\n    [icon]=\"iconReg.sieIcon.ArrowToTop\"\n  >\n    <span *ngIf=\"infinitePaginationData?.backToTopButtonScreenReaderText\" class=\"visually-hidden\">{{\n      infinitePaginationData.backToTopButtonScreenReaderText\n    }}</span>\n  </sie-ui-button>\n</ng-template>\n", styles: [".infinite-pagination__show-more-container__button{outline:none;outline-offset:0}@media (pointer: fine){.infinite-pagination__show-more-container__button{position:relative}.infinite-pagination__show-more-container__button:focus{outline:1px solid #1491eb;outline-offset:2px}.infinite-pagination__show-more-container__button:focus:not(:focus-visible){outline:0}.infinite-pagination__show-more-container__button:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}:host{display:block}.infinite-pagination{display:flex;position:relative;justify-content:center;flex-direction:column;align-items:flex-end}@media (min-width: 640px){.infinite-pagination{flex-direction:row;justify-content:center;align-items:flex-start}}.infinite-pagination__back-to-top-btn{position:initial;margin-right:-10px}@media (min-width: 640px){.infinite-pagination__back-to-top-btn{position:absolute;right:0}}.infinite-pagination--show-more{flex-direction:row;justify-content:center}.infinite-pagination--show-more .infinite-pagination__back-to-top-btn{position:absolute;right:0;top:-12px}@media (min-width: 640px){.infinite-pagination--load-more{align-items:center}}@media (max-width: 639.78px){.infinite-pagination__load-more-btn{margin-top:14px}}.infinite-pagination__show-more-container{display:flex;flex-direction:column;align-items:center;min-height:22px}.infinite-pagination__show-more-container__label{font-size:.875rem;font-weight:400;line-height:1.25rem;color:#4c4c68;margin-bottom:6px}.infinite-pagination__show-more-container__button{font-size:1rem;font-weight:400;line-height:1.5rem;border:0;background:none;text-decoration:none;color:#007993;fill:#007993;cursor:pointer;margin-top:-2px}.infinite-pagination__show-more-container__button:hover,.infinite-pagination__show-more-container__button:active{color:#33747a;fill:#33747a}.infinite-pagination__show-more-container__button:disabled{cursor:not-allowed;color:#b3b3be;fill:#b3b3be}.infinite-pagination__show-more-container__icon{margin:-4px 3px 0 -4px}.infinite-pagination__empty-state{width:100%;margin-top:-26px}@media (min-width: 640px){.infinite-pagination__empty-state{margin-top:-40px;align-items:flex-start}}.infinite-pagination__message-container{font-size:.75rem;font-weight:400;line-height:1rem;display:flex;flex-direction:column;margin-top:14px;width:100%;color:#4c4c68;text-align:center}@media (min-width: 640px){.infinite-pagination__message-container{width:initial;margin-top:10px}}.infinite-pagination__message-container .primary-message{margin-bottom:8px}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }, { type: i1$1.LayoutService }]; }, propDecorators: { variant: [{
                type: Input
            }], infinitePaginationData: [{
                type: Input
            }], disableActionButton: [{
                type: Input
            }], showActionButton: [{
                type: Input
            }], backToTopClicked: [{
                type: Output
            }], actionButtonClicked: [{
                type: Output
            }] } });

class UiInfinitePaginationModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiInfinitePaginationModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiInfinitePaginationModule, declarations: [UiInfinitePaginationComponent], imports: [CommonModule, UiButtonModule, UiEmptyStateModule, SieIconsModule, SieCorePipesModule], exports: [UiInfinitePaginationComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiInfinitePaginationModule, imports: [CommonModule, UiButtonModule, UiEmptyStateModule, SieIconsModule, SieCorePipesModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiInfinitePaginationModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiInfinitePaginationComponent],
                    imports: [CommonModule, UiButtonModule, UiEmptyStateModule, SieIconsModule, SieCorePipesModule],
                    exports: [UiInfinitePaginationComponent]
                }]
        }] });

let id = 0;
class UiWizardStepDirective {
    constructor(templateRef) {
        this.templateRef = templateRef;
        this.id = id++;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiWizardStepDirective, deps: [{ token: i0.TemplateRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: UiWizardStepDirective, selector: "[sieUiWizardStep]", inputs: { title: "title", subtitle: "subtitle", id: "id" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiWizardStepDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[sieUiWizardStep]'
                }]
        }], ctorParameters: function () { return [{ type: i0.TemplateRef }]; }, propDecorators: { title: [{
                type: Input
            }], subtitle: [{
                type: Input
            }], id: [{
                type: Input
            }] } });

class UiWizardRenderDirective {
    set itemToRender(item) {
        if (item?.templateRef) {
            this.viewContainer.createEmbeddedView(item.templateRef);
        }
    }
    constructor(viewContainer) {
        this.viewContainer = viewContainer;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiWizardRenderDirective, deps: [{ token: i0.ViewContainerRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: UiWizardRenderDirective, selector: "[sieUiWizardStepRender]", inputs: { itemToRender: "itemToRender" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiWizardRenderDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[sieUiWizardStepRender]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ViewContainerRef }]; }, propDecorators: { itemToRender: [{
                type: Input
            }] } });

class UiWizardStepComponent {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiWizardStepComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiWizardStepComponent, selector: "sie-ui-wizard-step", inputs: { id: "id", label: "label" }, ngImport: i0, template: "<ng-content></ng-content>\n", changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiWizardStepComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-wizard-step', changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>\n" }]
        }], propDecorators: { id: [{
                type: Input
            }], label: [{
                type: Input
            }] } });

class UiWizardComponent {
    constructor() {
        this.progressStepSelected = new EventEmitter();
        this.stepIndex = 0;
        this.progressTrackerStepsData$ = new BehaviorSubject([]);
        this.subscription = new Subscription();
    }
    ngAfterViewInit() {
        this.initialStepsSetup();
        this.subscription.add(this.progressTrackerStepsData$.subscribe(() => {
            this.uiProgressTrackerComponent.updateView();
        }));
    }
    ngOnDestroy() {
        this.subscription.unsubscribe();
    }
    initialStepsSetup() {
        const progressTrackerData = [];
        this.steps.toArray().forEach(step => {
            const state = step.id === 0 ? 'active' : 'disabled';
            progressTrackerData.push({ label: step.title, value: step.subtitle, state });
        });
        requestAnimationFrame(() => {
            this.progressTrackerStepsData$.next(progressTrackerData);
        });
    }
    refreshData(index, data) {
        const progressTrackerData = this.progressTrackerStepsData$.value;
        const item = progressTrackerData[index];
        if (item) {
            Object.assign(progressTrackerData[index], data);
            this.progressTrackerStepsData$.next(progressTrackerData);
        }
    }
    goToNextStep(state = 'disabled') {
        if (this.stepExists(this.stepIndex + 1)) {
            const progressTrackerData = this.progressTrackerStepsData$.value;
            this.stepIndex++;
            progressTrackerData[this.stepIndex].state = 'active';
            progressTrackerData[this.stepIndex - 1].state = state;
            this.progressTrackerStepsData$.next(Array.from(progressTrackerData));
            this.wizardContent.nativeElement.focus();
        }
    }
    goToPrevStep(currentState = 'active', previousSubState = 'completed') {
        if (this.stepExists(this.stepIndex - 1)) {
            this.initialStepsSetup();
            const progressTrackerData = this.progressTrackerStepsData$.value;
            this.stepIndex--;
            progressTrackerData[this.stepIndex].state = currentState;
            progressTrackerData[this.stepIndex + 1].subState = previousSubState;
            this.progressTrackerStepsData$.next(Array.from(progressTrackerData));
            this.wizardContent.nativeElement.focus();
        }
    }
    stepExists(index) {
        return this.steps.length > 0 && index >= 0 && this.steps.length > index;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiWizardComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiWizardComponent, selector: "sie-ui-wizard", inputs: { previousButtonLabel: "previousButtonLabel", nextButtonLabel: "nextButtonLabel" }, outputs: { progressStepSelected: "progressStepSelected" }, queries: [{ propertyName: "steps", predicate: UiWizardStepDirective }], viewQueries: [{ propertyName: "uiProgressTrackerComponent", first: true, predicate: UiProgressTrackerComponent, descendants: true }, { propertyName: "wizardContent", first: true, predicate: ["wizardContent"], descendants: true }], ngImport: i0, template: "<div class=\"solution-wizard\">\n  <div class=\"solution-wizard__header\">\n    <ng-content select=\"[header]\"></ng-content>\n  </div>\n\n  <sie-ui-progress-tracker\n    #progressTracker\n    class=\"solution-wizard__progress-tracker\"\n    variant=\"centered\"\n    [steps]=\"progressTrackerStepsData$ | async\"\n    (progressStepSelected)=\"progressStepSelected.next($event)\"\n  ></sie-ui-progress-tracker>\n\n  <div class=\"solution-wizard__content\" #wizardContent content tabindex=\"0\">\n    <div *ngFor=\"let step of steps; let index = index\">\n      <sie-ui-wizard-step [hidden]=\"this.stepIndex !== index\">\n        <div sieUiWizardStepRender [itemToRender]=\"step\"></div>\n      </sie-ui-wizard-step>\n    </div>\n  </div>\n</div>\n", styles: [".solution-wizard__content{outline:none;outline-offset:0}@media (pointer: fine){.solution-wizard__content{position:relative}.solution-wizard__content:focus{outline:1px solid #1491eb;outline-offset:2px}.solution-wizard__content:focus:not(:focus-visible){outline:0}.solution-wizard__content:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}.solution-wizard{display:flex;flex-direction:column}.solution-wizard__header{align-self:center}.solution-wizard__progress-tracker{max-width:100%}.solution-wizard__content{margin:16px 0}@media (min-width: 640px){.solution-wizard__content{margin:24px 0}}\n"], dependencies: [{ kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "component", type: UiProgressTrackerComponent, selector: "sie-ui-progress-tracker", inputs: ["variant", "steps"], outputs: ["progressStepSelected"] }, { kind: "directive", type: UiWizardRenderDirective, selector: "[sieUiWizardStepRender]", inputs: ["itemToRender"] }, { kind: "component", type: UiWizardStepComponent, selector: "sie-ui-wizard-step", inputs: ["id", "label"] }, { kind: "pipe", type: i2.AsyncPipe, name: "async" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiWizardComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-wizard', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"solution-wizard\">\n  <div class=\"solution-wizard__header\">\n    <ng-content select=\"[header]\"></ng-content>\n  </div>\n\n  <sie-ui-progress-tracker\n    #progressTracker\n    class=\"solution-wizard__progress-tracker\"\n    variant=\"centered\"\n    [steps]=\"progressTrackerStepsData$ | async\"\n    (progressStepSelected)=\"progressStepSelected.next($event)\"\n  ></sie-ui-progress-tracker>\n\n  <div class=\"solution-wizard__content\" #wizardContent content tabindex=\"0\">\n    <div *ngFor=\"let step of steps; let index = index\">\n      <sie-ui-wizard-step [hidden]=\"this.stepIndex !== index\">\n        <div sieUiWizardStepRender [itemToRender]=\"step\"></div>\n      </sie-ui-wizard-step>\n    </div>\n  </div>\n</div>\n", styles: [".solution-wizard__content{outline:none;outline-offset:0}@media (pointer: fine){.solution-wizard__content{position:relative}.solution-wizard__content:focus{outline:1px solid #1491eb;outline-offset:2px}.solution-wizard__content:focus:not(:focus-visible){outline:0}.solution-wizard__content:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}.solution-wizard{display:flex;flex-direction:column}.solution-wizard__header{align-self:center}.solution-wizard__progress-tracker{max-width:100%}.solution-wizard__content{margin:16px 0}@media (min-width: 640px){.solution-wizard__content{margin:24px 0}}\n"] }]
        }], propDecorators: { steps: [{
                type: ContentChildren,
                args: [UiWizardStepDirective]
            }], uiProgressTrackerComponent: [{
                type: ViewChild,
                args: [UiProgressTrackerComponent]
            }], wizardContent: [{
                type: ViewChild,
                args: ['wizardContent']
            }], previousButtonLabel: [{
                type: Input
            }], nextButtonLabel: [{
                type: Input
            }], progressStepSelected: [{
                type: Output
            }] } });

class UiWizardModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiWizardModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiWizardModule, declarations: [UiWizardComponent, UiWizardRenderDirective, UiWizardStepDirective, UiWizardStepComponent], imports: [CommonModule, UiButtonModule, UiProgressTrackerModule], exports: [UiWizardComponent, UiWizardStepDirective] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiWizardModule, imports: [CommonModule, UiButtonModule, UiProgressTrackerModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiWizardModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiWizardComponent, UiWizardRenderDirective, UiWizardStepDirective, UiWizardStepComponent],
                    imports: [CommonModule, UiButtonModule, UiProgressTrackerModule],
                    exports: [UiWizardComponent, UiWizardStepDirective]
                }]
        }] });

/**
 * # Switch Button Group component
 *
 * A switch button group allows the user to select one of many logically grouped items,
 * comparable to a radio button group.
 *
 * ## Component variations
 *
 * There are no variations.
 *
 * ## Content
 *
 * The Switch Button Group component does not accept any content.
 *
 * ## Code example
 * @example ```html
 *  <sie-ui-switch-button-group
 *    [data]="switchButtonGroupData"
 *    selectedId="sb-l-2"
 *    name="group 1"
 *  ></sie-ui-switch-button-group>
 * ```
 *
 * Example of switch button group data:
 * ```ts
 * switchButtonGroupData = [
 *  {
 *    id: 'sb-l-1',
 *    label: 'One'
 *  },
 *  {
 *    id: 'sb-l-2',
 *    label: 'TWo',
 *    disabled: true
 *  }
 *];
 * ```
 */
class UiSwitchButtonGroupComponent extends NgFormControlDirective {
    constructor() {
        super(...arguments);
        /**
         * Defines the id of the currently selected button. If not defined, the first button will be selected by default.
         * @default '' (empty string)
         */
        this.selectedId = '';
        /**
         * Event triggered when another button that is not selected is clicked.
         * The event data is id of the selected button.
         */
        this.selectedIdChange = new EventEmitter();
    }
    /**
     * @param value Defines source {@link UiSwitchButtonGroupModel data} of the component
     */
    set data(value) {
        if (value?.length >= UIConstants.SWITCH_BUTTON_MIN) {
            this._data = value.slice(0, UIConstants.SWITCH_BUTTON_MAX);
        }
    }
    get data() {
        return this._data;
    }
    /** @ignore */
    ngOnInit() {
        const selectedItem = this.data.find(item => this.selectedId === item.id && !item.disabled);
        const enabledItems = this.data.filter(item => !item.disabled);
        if (!selectedItem && enabledItems.length > 0) {
            this.selectedId = enabledItems[0].id;
        }
    }
    /** @ignore */
    selected(id) {
        this.selectedId = id;
        this.selectedIdChange.emit(id);
        this.onChange(id);
    }
    /** @ignore */
    validateInternal(control) {
        if (control.value === undefined || control.value === null) {
            return {
                required: true
            };
        }
        return null;
    }
    /** @ignore */
    writeValue(value) {
        this.selectedId = value;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiSwitchButtonGroupComponent, deps: null, target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiSwitchButtonGroupComponent, selector: "sie-ui-switch-button-group", inputs: { data: "data", selectedId: "selectedId" }, outputs: { selectedIdChange: "selectedIdChange" }, providers: [
            {
                provide: NG_VALUE_ACCESSOR,
                multi: true,
                useExisting: UiSwitchButtonGroupComponent
            },
            {
                provide: NG_VALIDATORS,
                multi: true,
                useExisting: UiSwitchButtonGroupComponent
            }
        ], usesInheritance: true, ngImport: i0, template: "<ul class=\"switch-button-group\" role=\"group\" *ngIf=\"data\" [ngClass]=\"'number-of-buttons--' + data.length\">\n  <ng-container *ngFor=\"let item of data\">\n    <li class=\"switch-button-group__item\">\n      <input\n        type=\"radio\"\n        [id]=\"item.id\"\n        [name]=\"name\"\n        [disabled]=\"item.disabled\"\n        (change)=\"selected(item.id)\"\n        [checked]=\"item.id === this.selectedId && !item.disabled\"\n        [value]=\"item.id\"\n        [ngClass]=\"{\n          dark: theme === 'dark'\n        }\"\n        class=\"switch-button-group__input\"\n      />\n      <label [for]=\"item.id\" class=\"switch-button-group__label\">\n        <span [title]=\"item.label\">{{ item.label }}</span>\n      </label>\n    </li>\n  </ng-container>\n</ul>\n", styles: [".switch-button-group__input:focus-visible+.switch-button-group__label:focus,.switch-button-group__input:focus+.switch-button-group__label:focus,.switch-button-group__input:focus-visible+.switch-button-group__label:focus-visible{outline:0}.switch-button-group{list-style:none;margin:0;padding:0;display:grid;grid-auto-flow:column;min-width:60px;max-width:328px}.switch-button-group.number-of-buttons--2{grid-template-columns:repeat(2,minmax(30px,164px))}.switch-button-group.number-of-buttons--3{grid-template-columns:repeat(3,minmax(30px,164px))}.switch-button-group__item{position:relative;min-width:30px;max-width:164px;height:32px;margin-right:-1px}.switch-button-group__label{font-size:1rem;font-weight:400;line-height:1.5rem;white-space:nowrap;overflow:hidden;text-overflow:ellipsis;position:absolute;left:0;top:0;width:100%;height:100%;padding:4px 10px;text-align:center;color:#9999a9;border:1px solid #9999a9;cursor:pointer}.switch-button-group__input{position:absolute;appearance:none;margin:0;opacity:0}.switch-button-group__input:hover:not(:disabled,:checked)+.switch-button-group__label,.switch-button-group__input:focus:not(:disabled,:checked)+.switch-button-group__label{z-index:1;border-width:1px 1px 2px;border-color:#00646e;color:#00646e}.switch-button-group__input:checked+.switch-button-group__label{z-index:1;background-color:#00646e;color:#fff;border:1px solid #00646e}.switch-button-group__input:disabled+.switch-button-group__label{border-color:#b3b3be;color:#b3b3be;cursor:default}.switch-button-group__input.dark+.switch-button-group__label{border-color:#9999a9;color:#ccccd4}.switch-button-group__input:focus-visible+.switch-button-group__label,.switch-button-group__input:focus+.switch-button-group__label:focus{outline:1px solid #1491eb;outline-offset:2px}.switch-button-group__input.dark:hover:not(:disabled,:checked)+.switch-button-group__label{border-color:#00ffb9;color:#00ffb9}.switch-button-group__input.dark:checked+.switch-button-group__label{background-color:#00ffb9;color:#000028;border:1px solid #00ffb9}.switch-button-group__input.dark:disabled+.switch-button-group__label{border-color:#9999a9;color:#737389}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiSwitchButtonGroupComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-switch-button-group', changeDetection: ChangeDetectionStrategy.OnPush, providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            multi: true,
                            useExisting: UiSwitchButtonGroupComponent
                        },
                        {
                            provide: NG_VALIDATORS,
                            multi: true,
                            useExisting: UiSwitchButtonGroupComponent
                        }
                    ], template: "<ul class=\"switch-button-group\" role=\"group\" *ngIf=\"data\" [ngClass]=\"'number-of-buttons--' + data.length\">\n  <ng-container *ngFor=\"let item of data\">\n    <li class=\"switch-button-group__item\">\n      <input\n        type=\"radio\"\n        [id]=\"item.id\"\n        [name]=\"name\"\n        [disabled]=\"item.disabled\"\n        (change)=\"selected(item.id)\"\n        [checked]=\"item.id === this.selectedId && !item.disabled\"\n        [value]=\"item.id\"\n        [ngClass]=\"{\n          dark: theme === 'dark'\n        }\"\n        class=\"switch-button-group__input\"\n      />\n      <label [for]=\"item.id\" class=\"switch-button-group__label\">\n        <span [title]=\"item.label\">{{ item.label }}</span>\n      </label>\n    </li>\n  </ng-container>\n</ul>\n", styles: [".switch-button-group__input:focus-visible+.switch-button-group__label:focus,.switch-button-group__input:focus+.switch-button-group__label:focus,.switch-button-group__input:focus-visible+.switch-button-group__label:focus-visible{outline:0}.switch-button-group{list-style:none;margin:0;padding:0;display:grid;grid-auto-flow:column;min-width:60px;max-width:328px}.switch-button-group.number-of-buttons--2{grid-template-columns:repeat(2,minmax(30px,164px))}.switch-button-group.number-of-buttons--3{grid-template-columns:repeat(3,minmax(30px,164px))}.switch-button-group__item{position:relative;min-width:30px;max-width:164px;height:32px;margin-right:-1px}.switch-button-group__label{font-size:1rem;font-weight:400;line-height:1.5rem;white-space:nowrap;overflow:hidden;text-overflow:ellipsis;position:absolute;left:0;top:0;width:100%;height:100%;padding:4px 10px;text-align:center;color:#9999a9;border:1px solid #9999a9;cursor:pointer}.switch-button-group__input{position:absolute;appearance:none;margin:0;opacity:0}.switch-button-group__input:hover:not(:disabled,:checked)+.switch-button-group__label,.switch-button-group__input:focus:not(:disabled,:checked)+.switch-button-group__label{z-index:1;border-width:1px 1px 2px;border-color:#00646e;color:#00646e}.switch-button-group__input:checked+.switch-button-group__label{z-index:1;background-color:#00646e;color:#fff;border:1px solid #00646e}.switch-button-group__input:disabled+.switch-button-group__label{border-color:#b3b3be;color:#b3b3be;cursor:default}.switch-button-group__input.dark+.switch-button-group__label{border-color:#9999a9;color:#ccccd4}.switch-button-group__input:focus-visible+.switch-button-group__label,.switch-button-group__input:focus+.switch-button-group__label:focus{outline:1px solid #1491eb;outline-offset:2px}.switch-button-group__input.dark:hover:not(:disabled,:checked)+.switch-button-group__label{border-color:#00ffb9;color:#00ffb9}.switch-button-group__input.dark:checked+.switch-button-group__label{background-color:#00ffb9;color:#000028;border:1px solid #00ffb9}.switch-button-group__input.dark:disabled+.switch-button-group__label{border-color:#9999a9;color:#737389}\n"] }]
        }], propDecorators: { data: [{
                type: Input
            }], selectedId: [{
                type: Input
            }], selectedIdChange: [{
                type: Output
            }] } });

/**
 * # Switch Button Group Module
 * - {@link UiSwitchButtonGroupComponent}
 *
 * ## Module peer dependencies
 * - `@angular/forms/FormsModule`: Enables data binding for Angular forms
 */
class UiSwitchButtonGroupModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiSwitchButtonGroupModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiSwitchButtonGroupModule, declarations: [UiSwitchButtonGroupComponent], imports: [CommonModule, FormsModule], exports: [UiSwitchButtonGroupComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiSwitchButtonGroupModule, imports: [CommonModule, FormsModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiSwitchButtonGroupModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiSwitchButtonGroupComponent],
                    imports: [CommonModule, FormsModule],
                    exports: [UiSwitchButtonGroupComponent]
                }]
        }] });

/**
 * Directive used to display items within a vertical progress tracker and for setting their parameter values
 */
class UiVerticalProgressTrackerItemDirective {
    constructor(templateRef) {
        this.templateRef = templateRef;
        this._open = false;
    }
    /**
     * @param value defines should vertical progress tracker item be opened
     * @default false
     */
    set open(value) {
        this._open = coerceBooleanProperty(value);
    }
    get open() {
        return this._open;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiVerticalProgressTrackerItemDirective, deps: [{ token: i0.TemplateRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: UiVerticalProgressTrackerItemDirective, selector: "[sieUiVerticalProgressTrackerItem]", inputs: { status: "status", label: "label", selectedValue: "selectedValue", open: "open" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiVerticalProgressTrackerItemDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[sieUiVerticalProgressTrackerItem]'
                }]
        }], ctorParameters: function () { return [{ type: i0.TemplateRef }]; }, propDecorators: { status: [{
                type: Input
            }], label: [{
                type: Input
            }], selectedValue: [{
                type: Input
            }], open: [{
                type: Input
            }] } });

// injection token
const UI_VERTICAL_PROGRESS_TRACKER_WEB_COMPONENT_SERVICE = 'UI_VERTICAL_PROGRESS_TRACKER_WEB_COMPONENT_SERVICE';

/** @ignore */
const STEP_ICON_MAPPING = {
    completed: SieIcon.SuccessFilled,
    warning: SieIcon.WarningFilled,
    error: SieIcon.ErrorFilled
};

class UiVerticalProgressTrackerItemComponent {
    set status(value) {
        this._status = value;
        this.iconName = STEP_ICON_MAPPING[value];
        if (this.iconName) {
            this.iconReg.register(this.iconName);
        }
    }
    get status() {
        return this._status;
    }
    constructor(iconReg, cdr) {
        this.iconReg = iconReg;
        this.cdr = cdr;
        this.open = false;
        this.initialItemIndex = new Subject();
        this.itemClicked = new Subject();
        this._status = 'idle';
        this.animationRunning = false;
    }
    ngAfterViewInit() {
        this.emitInitialItemIndex();
    }
    toggleAndEmitItemClicked() {
        this.onToggle();
        this.itemClicked.next(this.index);
    }
    onToggle() {
        if (this.animationRunning) {
            return;
        }
        this.animationRunning = true;
        this.open = !this.open;
        if (this.open) {
            this.stepHeader.nativeElement.focus();
        }
        this.cdr.markForCheck();
    }
    onAnimationEvent() {
        this.animationRunning = false;
    }
    emitInitialItemIndex() {
        if (this.open) {
            this.initialItemIndex.next(this.index);
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiVerticalProgressTrackerItemComponent, deps: [{ token: i1.SieIconRegistryService }, { token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiVerticalProgressTrackerItemComponent, selector: "sie-ui-vertical-progress-tracker-item", inputs: { label: "label", index: "index", last: "last", selectedValue: "selectedValue", displaySelectedValue: "displaySelectedValue", disabled: "disabled", open: "open", status: "status", nextStepStatus: "nextStepStatus", nextStepOpen: "nextStepOpen" }, outputs: { initialItemIndex: "initialItemIndex", itemClicked: "itemClicked" }, viewQueries: [{ propertyName: "stepHeader", first: true, predicate: ["stepHeader"], descendants: true }], ngImport: i0, template: "<div\n  class=\"vertical-progress-tracker-step next-step-{{ nextStepStatus }} step-{{ open ? 'active' : status }}\"\n  [ngClass]=\"{\n    'first-step': index === 0,\n    'last-step': last === index + 1,\n    'next-step-open': nextStepOpen\n  }\"\n>\n  <div\n    #stepHeader\n    class=\"vertical-progress-tracker-step__header\"\n    [tabindex]=\"status === 'disabled' ? -1 : 0\"\n    (click)=\"!open && !disabled && toggleAndEmitItemClicked()\"\n    (keydown.enter)=\"!open && !disabled && toggleAndEmitItemClicked()\"\n  >\n    <div class=\"vertical-progress-tracker-step__header-icon-container\">\n      <span class=\"vertical-progress-tracker-step__header-icon-dot status-{{ open ? 'active' : status }}\"></span>\n      <sie-icon\n        *ngIf=\"!open && iconName\"\n        class=\"vertical-progress-tracker-step__header-icon\"\n        svgClass=\"vertical-progress-tracker-step__header-icon-svg\"\n        [name]=\"!open && iconName\"\n      ></sie-icon>\n    </div>\n    <div class=\"vertical-progress-tracker-step__header-content\">\n      <div class=\"vertical-progress-tracker-step__header-content-label truncate\" sieCoreAddTooltip>\n        {{ label }}\n      </div>\n      <div\n        class=\"vertical-progress-tracker-step__header-content-selected-value truncate\"\n        *ngIf=\"displaySelectedValue\"\n        sieCoreAddTooltip\n      >\n        {{ selectedValue }}\n      </div>\n    </div>\n  </div>\n  <div\n    [ngClass]=\"[open ? 'opened' : 'closed']\"\n    [@toggleItem]=\"[open ? 'opened' : 'closed']\"\n    (@toggleItem.done)=\"onAnimationEvent()\"\n    class=\"vertical-progress-tracker-step__body-container\"\n  >\n    <div\n      class=\"vertical-progress-tracker-step__body\"\n      [class.expanded]=\"open\"\n      *ngIf=\"open || (!open && animationRunning)\"\n    >\n      <ng-content></ng-content>\n    </div>\n  </div>\n</div>\n", styles: [".vertical-progress-tracker-step{position:relative}.vertical-progress-tracker-step:before{content:\"\";position:absolute;left:9px;border-left-width:2px;border-left-style:solid;border-left-color:#ccccd4;top:-17px;bottom:-17px;z-index:-1}.vertical-progress-tracker-step__header{display:flex;flex-direction:row;width:100%;padding:16px 0;cursor:pointer}.vertical-progress-tracker-step__header:after{content:\"\";position:absolute;left:42px;bottom:0;height:100%;width:calc(100% - 46px);border-bottom:1px solid;border-color:#ccccd4}.vertical-progress-tracker-step__header-content{z-index:1}.vertical-progress-tracker-step__header-content-label{font-size:1rem;font-weight:400;line-height:1.5rem;color:#007993}.vertical-progress-tracker-step__header-content-selected-value{font-size:1rem;font-weight:400;line-height:1.5rem}.vertical-progress-tracker-step__header-icon-container{position:relative;margin-top:3px;padding-right:22px}.vertical-progress-tracker-step__header-icon{position:absolute;top:4px}.vertical-progress-tracker-step__header-icon-dot{width:20px;height:20px;display:flex;border-radius:50%;background:#ccccd4;outline:solid 2px #fff}.vertical-progress-tracker-step__header-icon-dot.status-active{background:#00646e}.vertical-progress-tracker-step__header-icon-dot.status-disabled{background:#ebebee}.vertical-progress-tracker-step__header-icon-dot.status-completed{background:#00af52}.vertical-progress-tracker-step__header-icon-dot.status-warning{background:#ff9000}.vertical-progress-tracker-step__header-icon-dot.status-error{background:#ef0137}.vertical-progress-tracker-step__header-icon-svg{width:20px;height:20px;display:flex;align-items:center;fill:currentColor;position:relative;top:-4px}.vertical-progress-tracker-step__header-icon-svg svg{fill:currentColor;width:inherit;height:inherit}.vertical-progress-tracker-step__header-icon-svg svg g{fill:currentColor;width:inherit;height:inherit}.vertical-progress-tracker-step__header-icon-svg svg text{font-family:Siemens Sans,sans-serif}.vertical-progress-tracker-step__header:hover:active:not(:disabled):not(.hover-disabled),.vertical-progress-tracker-step__header:hover:hover:not(:disabled):not(.hover-disabled){cursor:pointer}.vertical-progress-tracker-step__header:hover:active:not(:disabled):not(.hover-disabled) .vertical-progress-tracker-step__header-icon-dot,.vertical-progress-tracker-step__header:hover:hover:not(:disabled):not(.hover-disabled) .vertical-progress-tracker-step__header-icon-dot{position:relative}.vertical-progress-tracker-step__header:hover:active:not(:disabled):not(.hover-disabled) .vertical-progress-tracker-step__header-icon-dot:before,.vertical-progress-tracker-step__header:hover:hover:not(:disabled):not(.hover-disabled) .vertical-progress-tracker-step__header-icon-dot:before{content:\"\";position:absolute;inset:-4px;z-index:1;border:2px solid #e5e5e9;border-radius:50%}.vertical-progress-tracker-step__header:hover .vertical-progress-tracker-step__header-content-label{color:#00646e}.vertical-progress-tracker-step__header:focus-visible{outline:none}.vertical-progress-tracker-step__header:focus-visible:before{content:\"\";position:absolute;inset:-3px -10px;z-index:1;border:1px solid #1491eb}.vertical-progress-tracker-step__header:focus-visible .vertical-progress-tracker-step__header-icon-dot{position:relative}.vertical-progress-tracker-step__header:focus-visible .vertical-progress-tracker-step__header-icon-dot:before{content:\"\";position:absolute;inset:-4px;z-index:1;border:2px solid #e5e5e9;border-radius:50%}.vertical-progress-tracker-step.step-completed .vertical-progress-tracker-step__header-icon-container{color:#00af52}.vertical-progress-tracker-step.step-warning .vertical-progress-tracker-step__header-icon-container{color:#ff9000}.vertical-progress-tracker-step.step-error .vertical-progress-tracker-step__header-icon-container{color:#ef0137}.vertical-progress-tracker-step.first-step .vertical-progress-tracker-step__header:after{border-top:1px solid;border-color:#ccccd4}.vertical-progress-tracker-step.first-step:before{top:19px}.vertical-progress-tracker-step.step-active .vertical-progress-tracker-step__header-content-label{color:#00646e}.vertical-progress-tracker-step.step-active .vertical-progress-tracker-step__header:after{border-color:#00646e}.vertical-progress-tracker-step.step-active .vertical-progress-tracker-step__header-content>*{cursor:default;pointer-events:auto}.vertical-progress-tracker-step.step-active .vertical-progress-tracker-step__header,.vertical-progress-tracker-step.step-disabled .vertical-progress-tracker-step__header{pointer-events:none}.vertical-progress-tracker-step.last-step:before{border:none}.vertical-progress-tracker-step.next-step-disabled:before{border-left-color:#ebebee;top:17px;bottom:-17px;z-index:0}.vertical-progress-tracker-step.next-step-active .vertical-progress-tracker-step__header:after,.vertical-progress-tracker-step.next-step-open .vertical-progress-tracker-step__header:after{border-bottom-color:#00646e}.vertical-progress-tracker-step.step-disabled .vertical-progress-tracker-step__header:after{border-bottom-color:#ebebee}.vertical-progress-tracker-step.step-disabled .vertical-progress-tracker-step__header-content-label,.vertical-progress-tracker-step.step-disabled .vertical-progress-tracker-step__header-content-selected-value{color:#b3b3be}.vertical-progress-tracker-step__body{display:block}.vertical-progress-tracker-step__body.expanded{padding-bottom:16px}.vertical-progress-tracker-step__body-container{position:relative;padding-left:42px}.vertical-progress-tracker-step .truncate{display:-webkit-box;-webkit-box-orient:vertical;-webkit-line-clamp:2;overflow:hidden}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "directive", type: i1$1.AddTooltipDirective, selector: "[sieCoreAddTooltip]" }], animations: [toggleItemAnimation], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiVerticalProgressTrackerItemComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-vertical-progress-tracker-item', animations: [toggleItemAnimation], changeDetection: ChangeDetectionStrategy.OnPush, template: "<div\n  class=\"vertical-progress-tracker-step next-step-{{ nextStepStatus }} step-{{ open ? 'active' : status }}\"\n  [ngClass]=\"{\n    'first-step': index === 0,\n    'last-step': last === index + 1,\n    'next-step-open': nextStepOpen\n  }\"\n>\n  <div\n    #stepHeader\n    class=\"vertical-progress-tracker-step__header\"\n    [tabindex]=\"status === 'disabled' ? -1 : 0\"\n    (click)=\"!open && !disabled && toggleAndEmitItemClicked()\"\n    (keydown.enter)=\"!open && !disabled && toggleAndEmitItemClicked()\"\n  >\n    <div class=\"vertical-progress-tracker-step__header-icon-container\">\n      <span class=\"vertical-progress-tracker-step__header-icon-dot status-{{ open ? 'active' : status }}\"></span>\n      <sie-icon\n        *ngIf=\"!open && iconName\"\n        class=\"vertical-progress-tracker-step__header-icon\"\n        svgClass=\"vertical-progress-tracker-step__header-icon-svg\"\n        [name]=\"!open && iconName\"\n      ></sie-icon>\n    </div>\n    <div class=\"vertical-progress-tracker-step__header-content\">\n      <div class=\"vertical-progress-tracker-step__header-content-label truncate\" sieCoreAddTooltip>\n        {{ label }}\n      </div>\n      <div\n        class=\"vertical-progress-tracker-step__header-content-selected-value truncate\"\n        *ngIf=\"displaySelectedValue\"\n        sieCoreAddTooltip\n      >\n        {{ selectedValue }}\n      </div>\n    </div>\n  </div>\n  <div\n    [ngClass]=\"[open ? 'opened' : 'closed']\"\n    [@toggleItem]=\"[open ? 'opened' : 'closed']\"\n    (@toggleItem.done)=\"onAnimationEvent()\"\n    class=\"vertical-progress-tracker-step__body-container\"\n  >\n    <div\n      class=\"vertical-progress-tracker-step__body\"\n      [class.expanded]=\"open\"\n      *ngIf=\"open || (!open && animationRunning)\"\n    >\n      <ng-content></ng-content>\n    </div>\n  </div>\n</div>\n", styles: [".vertical-progress-tracker-step{position:relative}.vertical-progress-tracker-step:before{content:\"\";position:absolute;left:9px;border-left-width:2px;border-left-style:solid;border-left-color:#ccccd4;top:-17px;bottom:-17px;z-index:-1}.vertical-progress-tracker-step__header{display:flex;flex-direction:row;width:100%;padding:16px 0;cursor:pointer}.vertical-progress-tracker-step__header:after{content:\"\";position:absolute;left:42px;bottom:0;height:100%;width:calc(100% - 46px);border-bottom:1px solid;border-color:#ccccd4}.vertical-progress-tracker-step__header-content{z-index:1}.vertical-progress-tracker-step__header-content-label{font-size:1rem;font-weight:400;line-height:1.5rem;color:#007993}.vertical-progress-tracker-step__header-content-selected-value{font-size:1rem;font-weight:400;line-height:1.5rem}.vertical-progress-tracker-step__header-icon-container{position:relative;margin-top:3px;padding-right:22px}.vertical-progress-tracker-step__header-icon{position:absolute;top:4px}.vertical-progress-tracker-step__header-icon-dot{width:20px;height:20px;display:flex;border-radius:50%;background:#ccccd4;outline:solid 2px #fff}.vertical-progress-tracker-step__header-icon-dot.status-active{background:#00646e}.vertical-progress-tracker-step__header-icon-dot.status-disabled{background:#ebebee}.vertical-progress-tracker-step__header-icon-dot.status-completed{background:#00af52}.vertical-progress-tracker-step__header-icon-dot.status-warning{background:#ff9000}.vertical-progress-tracker-step__header-icon-dot.status-error{background:#ef0137}.vertical-progress-tracker-step__header-icon-svg{width:20px;height:20px;display:flex;align-items:center;fill:currentColor;position:relative;top:-4px}.vertical-progress-tracker-step__header-icon-svg svg{fill:currentColor;width:inherit;height:inherit}.vertical-progress-tracker-step__header-icon-svg svg g{fill:currentColor;width:inherit;height:inherit}.vertical-progress-tracker-step__header-icon-svg svg text{font-family:Siemens Sans,sans-serif}.vertical-progress-tracker-step__header:hover:active:not(:disabled):not(.hover-disabled),.vertical-progress-tracker-step__header:hover:hover:not(:disabled):not(.hover-disabled){cursor:pointer}.vertical-progress-tracker-step__header:hover:active:not(:disabled):not(.hover-disabled) .vertical-progress-tracker-step__header-icon-dot,.vertical-progress-tracker-step__header:hover:hover:not(:disabled):not(.hover-disabled) .vertical-progress-tracker-step__header-icon-dot{position:relative}.vertical-progress-tracker-step__header:hover:active:not(:disabled):not(.hover-disabled) .vertical-progress-tracker-step__header-icon-dot:before,.vertical-progress-tracker-step__header:hover:hover:not(:disabled):not(.hover-disabled) .vertical-progress-tracker-step__header-icon-dot:before{content:\"\";position:absolute;inset:-4px;z-index:1;border:2px solid #e5e5e9;border-radius:50%}.vertical-progress-tracker-step__header:hover .vertical-progress-tracker-step__header-content-label{color:#00646e}.vertical-progress-tracker-step__header:focus-visible{outline:none}.vertical-progress-tracker-step__header:focus-visible:before{content:\"\";position:absolute;inset:-3px -10px;z-index:1;border:1px solid #1491eb}.vertical-progress-tracker-step__header:focus-visible .vertical-progress-tracker-step__header-icon-dot{position:relative}.vertical-progress-tracker-step__header:focus-visible .vertical-progress-tracker-step__header-icon-dot:before{content:\"\";position:absolute;inset:-4px;z-index:1;border:2px solid #e5e5e9;border-radius:50%}.vertical-progress-tracker-step.step-completed .vertical-progress-tracker-step__header-icon-container{color:#00af52}.vertical-progress-tracker-step.step-warning .vertical-progress-tracker-step__header-icon-container{color:#ff9000}.vertical-progress-tracker-step.step-error .vertical-progress-tracker-step__header-icon-container{color:#ef0137}.vertical-progress-tracker-step.first-step .vertical-progress-tracker-step__header:after{border-top:1px solid;border-color:#ccccd4}.vertical-progress-tracker-step.first-step:before{top:19px}.vertical-progress-tracker-step.step-active .vertical-progress-tracker-step__header-content-label{color:#00646e}.vertical-progress-tracker-step.step-active .vertical-progress-tracker-step__header:after{border-color:#00646e}.vertical-progress-tracker-step.step-active .vertical-progress-tracker-step__header-content>*{cursor:default;pointer-events:auto}.vertical-progress-tracker-step.step-active .vertical-progress-tracker-step__header,.vertical-progress-tracker-step.step-disabled .vertical-progress-tracker-step__header{pointer-events:none}.vertical-progress-tracker-step.last-step:before{border:none}.vertical-progress-tracker-step.next-step-disabled:before{border-left-color:#ebebee;top:17px;bottom:-17px;z-index:0}.vertical-progress-tracker-step.next-step-active .vertical-progress-tracker-step__header:after,.vertical-progress-tracker-step.next-step-open .vertical-progress-tracker-step__header:after{border-bottom-color:#00646e}.vertical-progress-tracker-step.step-disabled .vertical-progress-tracker-step__header:after{border-bottom-color:#ebebee}.vertical-progress-tracker-step.step-disabled .vertical-progress-tracker-step__header-content-label,.vertical-progress-tracker-step.step-disabled .vertical-progress-tracker-step__header-content-selected-value{color:#b3b3be}.vertical-progress-tracker-step__body{display:block}.vertical-progress-tracker-step__body.expanded{padding-bottom:16px}.vertical-progress-tracker-step__body-container{position:relative;padding-left:42px}.vertical-progress-tracker-step .truncate{display:-webkit-box;-webkit-box-orient:vertical;-webkit-line-clamp:2;overflow:hidden}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }, { type: i0.ChangeDetectorRef }]; }, propDecorators: { stepHeader: [{
                type: ViewChild,
                args: ['stepHeader']
            }], label: [{
                type: Input
            }], index: [{
                type: Input
            }], last: [{
                type: Input
            }], selectedValue: [{
                type: Input
            }], displaySelectedValue: [{
                type: Input
            }], disabled: [{
                type: Input
            }], open: [{
                type: Input
            }], status: [{
                type: Input
            }], nextStepStatus: [{
                type: Input
            }], nextStepOpen: [{
                type: Input
            }], initialItemIndex: [{
                type: Output
            }], itemClicked: [{
                type: Output
            }] } });

/**
 * This directive is used in conjunction with the vertical progress tracker component
 * to set the item to be rendered inside the component
 */
class UiVerticalProgressTrackerItemRenderDirective {
    /**
     * @param item Sets item that needs to be rendered inside the vertical progress tracker component
     */
    set itemToRender(item) {
        this.uiVerticalProgressTrackerComponentService.renderChild(this.viewContainer, item);
    }
    constructor(viewContainer, uiVerticalProgressTrackerComponentService) {
        this.viewContainer = viewContainer;
        this.uiVerticalProgressTrackerComponentService = uiVerticalProgressTrackerComponentService;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiVerticalProgressTrackerItemRenderDirective, deps: [{ token: i0.ViewContainerRef }, { token: UI_VERTICAL_PROGRESS_TRACKER_WEB_COMPONENT_SERVICE }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: UiVerticalProgressTrackerItemRenderDirective, selector: "[sieUiVerticalProgressTrackerItemRender]", inputs: { itemToRender: "itemToRender" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiVerticalProgressTrackerItemRenderDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[sieUiVerticalProgressTrackerItemRender]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ViewContainerRef }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [UI_VERTICAL_PROGRESS_TRACKER_WEB_COMPONENT_SERVICE]
                }] }]; }, propDecorators: { itemToRender: [{
                type: Input
            }] } });

/**
 * # Vertical Progress Tracker Component
 *
 * Vertical Progress Tracker tracks multistep processes and shows the status of different steps.
 * It can be used where multi-step processes like checkout, data package compilation, etc. are involved.
 *
 * ## Component variations
 *
 * Vertical Progress Tracker doesn't have any variations.
 *
 * ## Content
 *
 * The content of vertical progress tracker items can be any valid markup.
 * Next to the parameters, the content can be passed as child elements with using `sieUiVerticalProgressTrackerItem` directive.
 * See the example below.
 *
 * ## Code example
 * @example
 * Template:
 * ```html
 * <sie-ui-vertical-progress-tracker #verticalProgressTracker>
 *  <ng-template
 *   sieUiVerticalProgressTrackerItem
 *   label="Some component label"
 *   status="active"
 *   selectedValue="this value was available before"
 *   [open]="true"
 *   >
 *    Item 1
 *  <ng-template [ngTemplateOutlet]="previousNextButtons"></ng-template>
 *  </ng-template>
 *  <ng-template sieUiVerticalProgressTrackerItem label="Another component label" status="idle">
 *    Item 2
 *  <ng-template [ngTemplateOutlet]="previousNextButtons"></ng-template>
 *  </ng-template>
 * </sie-ui-vertical-progress-tracker>
 *
 * <ng-template #previousNextButtons>
 *  <sie-ui-button
 *   variant="tertiary"
 *   icon="ArrowUp"
 *   buttonType="button"
 *   themeType="un-contained"
 *   (clicked)="onPreviousStepClicked()"
 *   [disabled]="disablePreviousStep"
 *  >Previous</sie-ui-button>
 *  <sie-ui-button
 *   variant="tertiary"
 *   icon="ArrowDown"
 *   buttonType="button"
 *   themeType="un-contained"
 *   iconPosition="trailing"
 *   (clicked)="onNextStepClicked()"
 *   [disabled]="disableNextStep"
 *   >Next</sie-ui-button>
 * </ng-template>
 * ```
 *
 * Component:
 * ```js
 *
 * disableNextStep: boolean;
 * disablePreviousStep: boolean;
 *
 * onPreviousStepClicked(): void {
 *  this.verticalProgressTracker.onPreviousStepClicked();
 * }
 *
 * onNextStepClicked(): void {
 *  this.verticalProgressTracker.onNextStepClicked();
 * }
 *
 * nextStepDisabled(): boolean {
 *  return this.verticalProgressTracker.nextStepDisabled();
 * }
 *
 * previousStepDisabled(): boolean {
 *  return !this.verticalProgressTracker.previousStepExists();
 * }
 * ```
 */
class UiVerticalProgressTrackerComponent {
    /**
     * Defines if selected value should be displayed
     * @default true
     */
    set displaySelectedValue(value) {
        this._displaySelectedValue = coerceBooleanProperty(value);
    }
    get displaySelectedValue() {
        return this._displaySelectedValue;
    }
    constructor(cdr, uiVerticalProgressTrackerComponentService) {
        this.cdr = cdr;
        this.uiVerticalProgressTrackerComponentService = uiVerticalProgressTrackerComponentService;
        /**
         * Event triggered when the vertical progress tracker item is clicked
         */
        this.itemClicked = new EventEmitter();
        this._displaySelectedValue = true;
    }
    /** @ignore */
    ngAfterViewInit() {
        this.uiVerticalProgressTrackerComponentService.init(this);
    }
    /** @ignore */
    onInitialItemIndex(initialItemId) {
        this.initialItemIndex = initialItemId;
    }
    /** @ignore */
    onItemClicked(itemId) {
        this.loopItemsAndToggle(false, itemId);
        this.itemClicked.next(itemId);
    }
    /**
     * Method that if the previous step exist opens it and go to that step
     */
    onPreviousStepClicked() {
        if (this.previousStepExists()) {
            this.loopItemsAndToggle(true, this.initialItemIndex - 1);
        }
    }
    /**
     * Method that if the next step exists and is not disabled open it and goes to that step
     */
    onNextStepClicked() {
        if (!this.nextStepDisabled()) {
            this.loopItemsAndToggle(true, this.initialItemIndex + 1);
        }
    }
    /**
     * Method that defines if the next step in vertical progress tracker is disabled
     * @returns boolean value
     */
    nextStepDisabled() {
        return this.items.length <= this.initialItemIndex + 1 || this.nextStepStatus(this.initialItemIndex) === 'disabled';
    }
    /**
     * Method that defines if the previous step in vertical progress tracker is disabled
     * @returns boolean value
     */
    previousStepDisabled() {
        return this.previousStepStatus(this.initialItemIndex) === 'disabled';
    }
    /** @ignore */
    nextStepStatus(index) {
        const elements = this.items.map(item => item);
        return elements[index + 1]?.status;
    }
    /** @ignore */
    previousStepStatus(index) {
        const elements = this.items.map(item => item);
        return elements[index - 1]?.status;
    }
    /** @ignore */
    nextStepOpen(index) {
        return this.verticalProgressTrackerItems?.toArray()[index + 1]?.open;
    }
    /**
     * Method that defines if the previous step in vertical progress tracker exist
     * @returns boolean value
     */
    previousStepExists() {
        return this.initialItemIndex > 0;
    }
    loopItemsAndToggle(openItemManually, index) {
        this.verticalProgressTrackerItems.forEach(item => {
            if ((openItemManually && item.index === index) || item.index === this.initialItemIndex) {
                item.onToggle();
            }
        });
        this.initialItemIndex = index;
        this.cdr.detectChanges();
    }
    /**
     * Opens designated step by index number and closes other opened step (incl. animation).
     *
     * Disclaimer: There is no check if the step is disabled as this can be done from outside.
     *
     * @param index Index of step to be open. (If index is active step or if index is out of order the action is ignored)
     */
    openStep(index) {
        if (0 <= index && index < this.items.length && this.initialItemIndex !== index) {
            this.loopItemsAndToggle(true, index);
        }
    }
    // the following are only applicable for web components
    // to alter the structure after creation
    /** @ignore Use only intended in web components */
    openNextStep() {
        this.onNextStepClicked();
        this.cdr.detectChanges();
    }
    /** @ignore Use only intended in web components */
    openPreviousStep() {
        this.onPreviousStepClicked();
        this.cdr.detectChanges();
    }
    /** @ignore Use only intended in web components */
    checkIfPreviousStepExists() {
        return this.previousStepExists();
    }
    /** @ignore Use only intended in web components */
    checkIfNextStepDisabled() {
        return this.nextStepDisabled();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiVerticalProgressTrackerComponent, deps: [{ token: i0.ChangeDetectorRef }, { token: UI_VERTICAL_PROGRESS_TRACKER_WEB_COMPONENT_SERVICE }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiVerticalProgressTrackerComponent, selector: "sie-ui-vertical-progress-tracker", inputs: { displaySelectedValue: "displaySelectedValue", openNextStep: "openNextStep", openPreviousStep: "openPreviousStep", checkIfPreviousStepExists: "checkIfPreviousStepExists", checkIfNextStepDisabled: "checkIfNextStepDisabled" }, outputs: { itemClicked: "itemClicked" }, queries: [{ propertyName: "items", predicate: UiVerticalProgressTrackerItemDirective }], viewQueries: [{ propertyName: "elementsRef", first: true, predicate: ["elements"], descendants: true }, { propertyName: "verticalProgressTrackerItems", predicate: ["verticalProgressTrackerItem"], descendants: true }], ngImport: i0, template: "<div #elements class=\"vertical-progress-tracker-container\">\n  <ng-content select=\".item\"></ng-content>\n</div>\n\n<sie-ui-vertical-progress-tracker-item\n  #verticalProgressTrackerItem\n  *ngFor=\"let item of items; index as index\"\n  [label]=\"item.label\"\n  [status]=\"item.status\"\n  [selectedValue]=\"item.selectedValue\"\n  [displaySelectedValue]=\"displaySelectedValue\"\n  [open]=\"item.open\"\n  [index]=\"index\"\n  [last]=\"items.length\"\n  (itemClicked)=\"onItemClicked($event)\"\n  (initialItemIndex)=\"onInitialItemIndex($event)\"\n  [nextStepStatus]=\"nextStepStatus(index)\"\n  [nextStepOpen]=\"nextStepOpen(index)\"\n>\n  <div sieUiVerticalProgressTrackerItemRender [itemToRender]=\"item\"></div>\n</sie-ui-vertical-progress-tracker-item>\n", styles: [".vertical-progress-tracker-container{display:none}\n"], dependencies: [{ kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "component", type: UiVerticalProgressTrackerItemComponent, selector: "sie-ui-vertical-progress-tracker-item", inputs: ["label", "index", "last", "selectedValue", "displaySelectedValue", "disabled", "open", "status", "nextStepStatus", "nextStepOpen"], outputs: ["initialItemIndex", "itemClicked"] }, { kind: "directive", type: UiVerticalProgressTrackerItemRenderDirective, selector: "[sieUiVerticalProgressTrackerItemRender]", inputs: ["itemToRender"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiVerticalProgressTrackerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-vertical-progress-tracker', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div #elements class=\"vertical-progress-tracker-container\">\n  <ng-content select=\".item\"></ng-content>\n</div>\n\n<sie-ui-vertical-progress-tracker-item\n  #verticalProgressTrackerItem\n  *ngFor=\"let item of items; index as index\"\n  [label]=\"item.label\"\n  [status]=\"item.status\"\n  [selectedValue]=\"item.selectedValue\"\n  [displaySelectedValue]=\"displaySelectedValue\"\n  [open]=\"item.open\"\n  [index]=\"index\"\n  [last]=\"items.length\"\n  (itemClicked)=\"onItemClicked($event)\"\n  (initialItemIndex)=\"onInitialItemIndex($event)\"\n  [nextStepStatus]=\"nextStepStatus(index)\"\n  [nextStepOpen]=\"nextStepOpen(index)\"\n>\n  <div sieUiVerticalProgressTrackerItemRender [itemToRender]=\"item\"></div>\n</sie-ui-vertical-progress-tracker-item>\n", styles: [".vertical-progress-tracker-container{display:none}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [UI_VERTICAL_PROGRESS_TRACKER_WEB_COMPONENT_SERVICE]
                }] }]; }, propDecorators: { items: [{
                type: ContentChildren,
                args: [UiVerticalProgressTrackerItemDirective]
            }], verticalProgressTrackerItems: [{
                type: ViewChildren,
                args: ['verticalProgressTrackerItem']
            }], elementsRef: [{
                type: ViewChild,
                args: ['elements']
            }], displaySelectedValue: [{
                type: Input
            }], itemClicked: [{
                type: Output
            }], openNextStep: [{
                type: Input
            }], openPreviousStep: [{
                type: Input
            }], checkIfPreviousStepExists: [{
                type: Input
            }], checkIfNextStepDisabled: [{
                type: Input
            }] } });

/**
 * Implementation for web component export
 */
class UiVerticalProgressTrackerElementsService {
    static convertDomItem(element) {
        const label = element.dataset['label'];
        const selectedValue = element.dataset['selectedValue'];
        const open = element.dataset['open'] === 'true';
        const status = element.dataset['status'];
        return { label, selectedValue, open, status };
    }
    constructor(domManipulationService) {
        this.domManipulationService = domManipulationService;
    }
    init(component) {
        component.items = this.domManipulationService.getDomItemsAndCleanupDom(component, '.item', UiVerticalProgressTrackerElementsService.convertDomItem);
        component.cdr.detectChanges();
    }
    renderChild(viewContainer, item) {
        if (item.element) {
            viewContainer.element.nativeElement.appendChild(item.element);
        }
    }
}

/**
 * Implementation for Angular environment that is doing nothing
 */
class UiVerticalProgressTrackerNgService {
    init() {
        // don't do anything here
    }
    renderChild(viewContainer, item) {
        viewContainer.createEmbeddedView(item.templateRef);
    }
}

/**
 * # Vertical Progress Tracker Module
 * - {@link UiVerticalProgressTrackerComponent}
 * - {@link UiVerticalProgressTrackerItemDirective}
 *
 * ## Module peer dependencies
 * - `@angular/platform-browser/animations/BrowserAnimationsModule`: This module is needed for the animation of
 *    expanding or collapsing vertical progress tracker item.
 * - {@link SieIconsModule}
 */
class UiVerticalProgressTrackerModule {
    /** @ignore */
    static forWebComponent() {
        const providers = [
            {
                provide: UI_VERTICAL_PROGRESS_TRACKER_WEB_COMPONENT_SERVICE,
                useClass: UiVerticalProgressTrackerElementsService,
                deps: [UiDomManipulationService]
            }
        ];
        return {
            ngModule: UiVerticalProgressTrackerModule,
            providers
        };
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiVerticalProgressTrackerModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiVerticalProgressTrackerModule, declarations: [UiVerticalProgressTrackerComponent,
            UiVerticalProgressTrackerItemComponent,
            UiVerticalProgressTrackerItemDirective,
            UiVerticalProgressTrackerItemRenderDirective], imports: [CommonModule, SieIconsModule, UiButtonModule, AddTooltipModule], exports: [UiVerticalProgressTrackerComponent, UiVerticalProgressTrackerItemDirective] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiVerticalProgressTrackerModule, providers: [
            {
                provide: UI_VERTICAL_PROGRESS_TRACKER_WEB_COMPONENT_SERVICE,
                useClass: UiVerticalProgressTrackerNgService
            }
        ], imports: [CommonModule, SieIconsModule, UiButtonModule, AddTooltipModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiVerticalProgressTrackerModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        UiVerticalProgressTrackerComponent,
                        UiVerticalProgressTrackerItemComponent,
                        UiVerticalProgressTrackerItemDirective,
                        UiVerticalProgressTrackerItemRenderDirective
                    ],
                    providers: [
                        {
                            provide: UI_VERTICAL_PROGRESS_TRACKER_WEB_COMPONENT_SERVICE,
                            useClass: UiVerticalProgressTrackerNgService
                        }
                    ],
                    imports: [CommonModule, SieIconsModule, UiButtonModule, AddTooltipModule],
                    exports: [UiVerticalProgressTrackerComponent, UiVerticalProgressTrackerItemDirective]
                }]
        }] });

class UiBypassLinkComponent {
    constructor(iconRegistry) {
        this.iconRegistry = iconRegistry;
        /**
         * Defines the area to which the focus will jump to
         */
        this.skipTo = 'main-navigation';
        iconRegistry.register(SieIcon.ArrowRight);
    }
    /** @ignore */
    skipToContent(event) {
        event.preventDefault();
        const section = document.getElementById(this.skipTo);
        if (section) {
            const focusableChild = this.getFirstFocusableChild(section);
            focusableChild?.focus();
        }
    }
    /** @ignore */
    getFirstFocusableChild(element) {
        const focusableChildren = Array.from(element.querySelectorAll('a, button, input, textarea, select, details,[tabindex]:not([tabindex="-1"])'));
        return focusableChildren.find(el => !el.hasAttribute('disabled'));
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiBypassLinkComponent, deps: [{ token: i1.SieIconRegistryService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiBypassLinkComponent, selector: "sie-ui-bypass-link", inputs: { skipTo: "skipTo", linkText: "linkText" }, ngImport: i0, template: "<a class=\"bypass-link\" href=\".\" (click)=\"skipToContent($event)\">\n  <sie-icon name=\"ArrowRight\" class=\"bypass-link__icon\"></sie-icon>\n  {{ linkText }}\n</a>\n", styles: [".bypass-link{padding:3px;border:1px solid #1491eb;color:#0cc;background-color:#000028;position:absolute;right:0;display:flex;align-items:center;font-size:.75rem;gap:2px;transform:translateY(-100%)}.bypass-link:focus{outline:none;z-index:1000;transform:translateY(0)}.bypass-link__icon{width:15px;height:15px;display:flex;align-items:center;fill:currentColor}.bypass-link__icon svg{fill:currentColor;width:inherit;height:inherit}.bypass-link__icon svg g{fill:currentColor;width:inherit;height:inherit}.bypass-link__icon svg text{font-family:Siemens Sans,sans-serif}\n"], dependencies: [{ kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiBypassLinkComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-bypass-link', changeDetection: ChangeDetectionStrategy.OnPush, template: "<a class=\"bypass-link\" href=\".\" (click)=\"skipToContent($event)\">\n  <sie-icon name=\"ArrowRight\" class=\"bypass-link__icon\"></sie-icon>\n  {{ linkText }}\n</a>\n", styles: [".bypass-link{padding:3px;border:1px solid #1491eb;color:#0cc;background-color:#000028;position:absolute;right:0;display:flex;align-items:center;font-size:.75rem;gap:2px;transform:translateY(-100%)}.bypass-link:focus{outline:none;z-index:1000;transform:translateY(0)}.bypass-link__icon{width:15px;height:15px;display:flex;align-items:center;fill:currentColor}.bypass-link__icon svg{fill:currentColor;width:inherit;height:inherit}.bypass-link__icon svg g{fill:currentColor;width:inherit;height:inherit}.bypass-link__icon svg text{font-family:Siemens Sans,sans-serif}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }]; }, propDecorators: { skipTo: [{
                type: Input
            }], linkText: [{
                type: Input
            }] } });

/**
 * # Badge Module
 * - {@link UiBypassLinkComponent}
 *
 * ## Module peer dependencies
 * - {@link SieIconsModule}
 */
class UiBypassLinkModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiBypassLinkModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiBypassLinkModule, declarations: [UiBypassLinkComponent], imports: [CommonModule, SieIconsModule], exports: [UiBypassLinkComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiBypassLinkModule, imports: [CommonModule, SieIconsModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiBypassLinkModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiBypassLinkComponent],
                    imports: [CommonModule, SieIconsModule],
                    exports: [UiBypassLinkComponent]
                }]
        }] });

/**
 * # Toggle button component
 *
 * Toggle buttons are used to display the checked and unchecked state of a button.
 * They are part of a form, allowing us to select or deselect a given option.
 *
 * ## Component variations
 *
 * - Toggle button only
 * - Toggle button with a label to the right (when `labelChecked` value is defined)
 * - Toggle button with a label to the left (when `labelUnchecked` value is defined)
 * - Toggle button with two labels (when both `labelUnchecked` and `labelChecked` values are defined)
 * - Toggle button with tooltip (when `tooltipChecked` or/and `tooltipUnchecked` values are defined)
 * - Toggle button with input hint (when `hint` value is defined)
 * - Disabled toggle button
 *
 * ## Content
 *
 * The toggle button component does not accept any content.
 *
 * ## Code example
 * @example ```html
 * <sie-ui-toggle-button id="toggleId" name="toggleName" labelUnchecked="Off" labelChecked="On"></sie-ui-toggle-button>
 * ```
 */
class UiToggleButtonComponent extends NgFormControlDirective {
    /**
     * @param value Defines the value of the toggle button (used instead of checked)
     * @default false
     */
    set value(value) {
        this._value = coerceBooleanProperty(value);
    }
    get value() {
        return this._value;
    }
    constructor(iconReg) {
        super();
        this.iconReg = iconReg;
        /**
         * Event triggered when the toggle button is clicked.
         */
        this.valueChange = new EventEmitter();
        this._value = false;
        /** @ignore */
        this.preloading$ = new BehaviorSubject(true);
        this.iconReg.register(SieIcon.Information);
    }
    /** @ignore */
    ngAfterViewInit() {
        this.preloading$.next(false);
    }
    /** @ignore */
    onCheck(toggleState) {
        this.valueChange.emit(toggleState);
        this.onChange(toggleState);
        this.markAsTouched();
    }
    /** @ignore */
    validateInternal() {
        return null;
    }
    /** @ignore */
    writeValue(checked) {
        this.value = checked;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiToggleButtonComponent, deps: [{ token: i1.SieIconRegistryService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiToggleButtonComponent, selector: "sie-ui-toggle-button", inputs: { labelUnchecked: "labelUnchecked", labelChecked: "labelChecked", tooltipChecked: "tooltipChecked", tooltipUnchecked: "tooltipUnchecked", value: "value" }, outputs: { valueChange: "valueChange" }, providers: [
            {
                provide: NG_VALUE_ACCESSOR,
                multi: true,
                useExisting: UiToggleButtonComponent
            }
        ], usesInheritance: true, ngImport: i0, template: "<label class=\"toggle-button\" [for]=\"name + '_' + id\">\n  <input\n    [id]=\"name + '_' + id\"\n    [name]=\"name\"\n    [disabled]=\"disabled\"\n    [(ngModel)]=\"value\"\n    (ngModelChange)=\"onCheck($event)\"\n    type=\"checkbox\"\n    role=\"switch\"\n  />\n\n  <span *ngIf=\"labelUnchecked\" class=\"toggle-button__label\" aria-hidden=\"true\" sieCoreAddTruncationAndTooltip>{{\n    labelUnchecked\n  }}</span>\n\n  <span\n    class=\"toggle-button__slider\"\n    [ngClass]=\"{ preload: preloading$ | async }\"\n    sieUiPopover\n    [content]=\"value ? tooltipChecked : tooltipUnchecked\"\n    popoverSize=\"s\"\n  ></span>\n\n  <span *ngIf=\"labelChecked\" class=\"toggle-button__label\" aria-hidden=\"true\" sieCoreAddTruncationAndTooltip>{{\n    labelChecked\n  }}</span>\n\n  <sie-icon\n    *ngIf=\"hint?.type === 'tooltip' && hint?.content\"\n    class=\"toggle-button__hint-tooltip\"\n    sieUiPopover\n    [popoverSize]=\"hint.size || 's'\"\n    [content]=\"hint.content\"\n    [name]=\"iconReg.sieIcon.Information\"\n  ></sie-icon>\n</label>\n\n<sie-ui-richtext\n  class=\"toggle-button__hint-inline\"\n  *ngIf=\"hint?.type === 'inline' && hint?.content\"\n  [content]=\"hint.content\"\n></sie-ui-richtext>\n", styles: [".toggle-button input[role=switch]:focus-visible~.toggle-button__slider:focus,.toggle-button input[role=switch]:focus-visible~.toggle-button__slider:focus-visible{outline:0}:host{display:block}.toggle-button{display:flex;align-items:center;gap:12px}.toggle-button__label{max-width:160px}.toggle-button__hint-tooltip{margin:-2px 0 0 -3px}.toggle-button__hint-inline{font-size:.875rem;font-weight:400;line-height:1.25rem;margin-top:2px;color:#4c4c68}.toggle-button input[role=switch]{position:absolute;width:1px;height:1px;opacity:0}.toggle-button input[role=switch]~.toggle-button__slider{position:relative;width:48px;height:18px;border-radius:10px;background-color:#ccccd4;cursor:pointer}.toggle-button input[role=switch]~.toggle-button__slider:after{content:\"\";position:absolute;display:block;top:-3px;left:0;width:24px;height:24px;border-radius:50%;background-color:#007993}.toggle-button input[role=switch]~.toggle-button__slider:not(.preload){transition:background-color 60ms cubic-bezier(0,0,.58,1)}.toggle-button input[role=switch]~.toggle-button__slider:not(.preload):after{transition:all .11s cubic-bezier(.35,0,1,.9)}.toggle-button input[role=switch]~.toggle-button__slider:hover:after{background-color:#00646e}.toggle-button input[role=switch]:focus-visible~.toggle-button__slider:before{content:\"\";position:absolute;inset:-7px -2px;z-index:1;border:1px solid #1491eb;border-radius:0}.toggle-button input[role=switch]:disabled~.toggle-button__slider{cursor:not-allowed;background-color:#e5e5e9}.toggle-button input[role=switch]:disabled~.toggle-button__slider:after{background-color:#b3b3be}.toggle-button input[role=switch]:disabled~.toggle-button__label{color:#9999a9}.toggle-button input[role=switch]:checked~.toggle-button__slider:after{left:24px}.toggle-button input[role=switch]:checked~.toggle-button__slider:not(.preload){transition:background-color 60ms cubic-bezier(.42,0,1,1)}.toggle-button input[role=switch]:checked~.toggle-button__slider:not(.preload):after{transition:all .11s cubic-bezier(0,0,.38,.9)}.toggle-button input[role=switch]:checked:not(:disabled)~.toggle-button__slider{background-color:#00ffb9}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1$1.AddTruncationAndTooltipDirective, selector: "[sieCoreAddTruncationAndTooltip]", inputs: ["maxNumberOfLinesToShow"] }, { kind: "directive", type: UiPopoverDirective, selector: "[sieUiPopover]", inputs: ["content", "popoverTemplate", "popoverSize", "popoverPlacement", "popoverAnimation", "popoverPlayAnimation", "popoverAnimationHideAfterTimeoutMS", "popoverLightTheme"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "directive", type: i3.CheckboxControlValueAccessor, selector: "input[type=checkbox][formControlName],input[type=checkbox][formControl],input[type=checkbox][ngModel]" }, { kind: "directive", type: i3.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i3.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "component", type: UiRichtextComponent, selector: "sie-ui-richtext", inputs: ["content", "theme", "whiteListedTags"] }, { kind: "pipe", type: i2.AsyncPipe, name: "async" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiToggleButtonComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-toggle-button', changeDetection: ChangeDetectionStrategy.OnPush, providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            multi: true,
                            useExisting: UiToggleButtonComponent
                        }
                    ], template: "<label class=\"toggle-button\" [for]=\"name + '_' + id\">\n  <input\n    [id]=\"name + '_' + id\"\n    [name]=\"name\"\n    [disabled]=\"disabled\"\n    [(ngModel)]=\"value\"\n    (ngModelChange)=\"onCheck($event)\"\n    type=\"checkbox\"\n    role=\"switch\"\n  />\n\n  <span *ngIf=\"labelUnchecked\" class=\"toggle-button__label\" aria-hidden=\"true\" sieCoreAddTruncationAndTooltip>{{\n    labelUnchecked\n  }}</span>\n\n  <span\n    class=\"toggle-button__slider\"\n    [ngClass]=\"{ preload: preloading$ | async }\"\n    sieUiPopover\n    [content]=\"value ? tooltipChecked : tooltipUnchecked\"\n    popoverSize=\"s\"\n  ></span>\n\n  <span *ngIf=\"labelChecked\" class=\"toggle-button__label\" aria-hidden=\"true\" sieCoreAddTruncationAndTooltip>{{\n    labelChecked\n  }}</span>\n\n  <sie-icon\n    *ngIf=\"hint?.type === 'tooltip' && hint?.content\"\n    class=\"toggle-button__hint-tooltip\"\n    sieUiPopover\n    [popoverSize]=\"hint.size || 's'\"\n    [content]=\"hint.content\"\n    [name]=\"iconReg.sieIcon.Information\"\n  ></sie-icon>\n</label>\n\n<sie-ui-richtext\n  class=\"toggle-button__hint-inline\"\n  *ngIf=\"hint?.type === 'inline' && hint?.content\"\n  [content]=\"hint.content\"\n></sie-ui-richtext>\n", styles: [".toggle-button input[role=switch]:focus-visible~.toggle-button__slider:focus,.toggle-button input[role=switch]:focus-visible~.toggle-button__slider:focus-visible{outline:0}:host{display:block}.toggle-button{display:flex;align-items:center;gap:12px}.toggle-button__label{max-width:160px}.toggle-button__hint-tooltip{margin:-2px 0 0 -3px}.toggle-button__hint-inline{font-size:.875rem;font-weight:400;line-height:1.25rem;margin-top:2px;color:#4c4c68}.toggle-button input[role=switch]{position:absolute;width:1px;height:1px;opacity:0}.toggle-button input[role=switch]~.toggle-button__slider{position:relative;width:48px;height:18px;border-radius:10px;background-color:#ccccd4;cursor:pointer}.toggle-button input[role=switch]~.toggle-button__slider:after{content:\"\";position:absolute;display:block;top:-3px;left:0;width:24px;height:24px;border-radius:50%;background-color:#007993}.toggle-button input[role=switch]~.toggle-button__slider:not(.preload){transition:background-color 60ms cubic-bezier(0,0,.58,1)}.toggle-button input[role=switch]~.toggle-button__slider:not(.preload):after{transition:all .11s cubic-bezier(.35,0,1,.9)}.toggle-button input[role=switch]~.toggle-button__slider:hover:after{background-color:#00646e}.toggle-button input[role=switch]:focus-visible~.toggle-button__slider:before{content:\"\";position:absolute;inset:-7px -2px;z-index:1;border:1px solid #1491eb;border-radius:0}.toggle-button input[role=switch]:disabled~.toggle-button__slider{cursor:not-allowed;background-color:#e5e5e9}.toggle-button input[role=switch]:disabled~.toggle-button__slider:after{background-color:#b3b3be}.toggle-button input[role=switch]:disabled~.toggle-button__label{color:#9999a9}.toggle-button input[role=switch]:checked~.toggle-button__slider:after{left:24px}.toggle-button input[role=switch]:checked~.toggle-button__slider:not(.preload){transition:background-color 60ms cubic-bezier(.42,0,1,1)}.toggle-button input[role=switch]:checked~.toggle-button__slider:not(.preload):after{transition:all .11s cubic-bezier(0,0,.38,.9)}.toggle-button input[role=switch]:checked:not(:disabled)~.toggle-button__slider{background-color:#00ffb9}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }]; }, propDecorators: { labelUnchecked: [{
                type: Input
            }], labelChecked: [{
                type: Input
            }], tooltipChecked: [{
                type: Input
            }], tooltipUnchecked: [{
                type: Input
            }], valueChange: [{
                type: Output
            }], value: [{
                type: Input
            }] } });

/**
 * # Toggle Button Module
 * - {@link UiToggleButtonComponent}
 *
 * ## Module peer dependencies
 * - {@link SieIconsModule}
 * - `@angular/platform-browser/animations/BrowserAnimationsModule`: This module is needed to run the animations on the toggle button
 * - `@angular/forms/FormsModule`: Enables data binding for Angular forms
 */
class UiToggleButtonModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiToggleButtonModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiToggleButtonModule, declarations: [UiToggleButtonComponent], imports: [CommonModule,
            AddTruncationAndTooltipModule,
            UiPopoverModule,
            SieIconsModule,
            FormsModule,
            UiRichtextModule], exports: [UiToggleButtonComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiToggleButtonModule, imports: [CommonModule,
            AddTruncationAndTooltipModule,
            UiPopoverModule,
            SieIconsModule,
            FormsModule,
            UiRichtextModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiToggleButtonModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiToggleButtonComponent],
                    imports: [
                        CommonModule,
                        AddTruncationAndTooltipModule,
                        UiPopoverModule,
                        SieIconsModule,
                        FormsModule,
                        UiRichtextModule
                    ],
                    exports: [UiToggleButtonComponent]
                }]
        }] });

const SIDE_PANEL_CLASS = '.side-panel';
const ADDITIONAL_PADDING = 4;
const SIDE_PANEL_XL = {
    closed: 40 + ADDITIONAL_PADDING,
    default: 400 + ADDITIONAL_PADDING,
    min: 188 + ADDITIONAL_PADDING,
    max: 506 + ADDITIONAL_PADDING
};
const SIDE_PANEL_L = {
    closed: 40 + ADDITIONAL_PADDING,
    default: 288 + ADDITIONAL_PADDING,
    min: 132 + ADDITIONAL_PADDING,
    max: 332 + ADDITIONAL_PADDING
};

class UiSidePanelResizableWidthDirective {
    constructor(elementRef, document) {
        this.elementRef = elementRef;
        this.document = document;
        this.dragDirection = 'right';
        this.widthChange = new EventEmitter();
        this.dragging = false;
        this.onMouseMoveBound = this.onMouseMove.bind(this);
        this.onMouseUpBound = this.onMouseUp.bind(this);
    }
    ngOnDestroy() {
        this.document.removeEventListener('mousemove', this.onMouseMoveBound);
        this.document.removeEventListener('mouseup', this.onMouseUpBound);
    }
    onMouseDown(event) {
        event.preventDefault();
        if (this.resizeEnabled && event.target.classList.contains('dragholder')) {
            this.dragging = true;
            this.startX = event.clientX;
            this.getStartingPosition();
            this.initialWidth = this.elementRef.nativeElement.offsetWidth - this.getStartingPosition();
            this.document.addEventListener('mousemove', this.onMouseMoveBound);
            this.document.addEventListener('mouseup', this.onMouseUpBound);
        }
    }
    onMouseMove(event) {
        event.preventDefault();
        if (!this.dragging) {
            return;
        }
        const offsetX = event.clientX - this.startX;
        let newWidth;
        if (this.dragDirection === 'left') {
            newWidth = this.initialWidth - offsetX;
        }
        else {
            newWidth = this.initialWidth + offsetX;
        }
        this.elementRef.nativeElement.style.width = `${newWidth}px`;
        this.widthChange.emit(newWidth);
    }
    onMouseUp() {
        if (this.dragging) {
            this.dragging = false;
        }
        this.elementRef.nativeElement.style.removeProperty('width');
        this.document.removeEventListener('mousemove', this.onMouseMoveBound);
        this.document.removeEventListener('mouseup', this.onMouseUpBound);
    }
    getStartingPosition() {
        const sidePanel = this.document.querySelector('.side-panel');
        const computedStyle = getComputedStyle(sidePanel);
        return parseFloat(computedStyle.getPropertyValue('--sp-padding'));
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiSidePanelResizableWidthDirective, deps: [{ token: i0.ElementRef }, { token: DOCUMENT }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: UiSidePanelResizableWidthDirective, selector: "[sieUiSidePanelResizableWidth]", inputs: { resizeEnabled: "resizeEnabled", dragDirection: "dragDirection" }, outputs: { widthChange: "widthChange" }, host: { listeners: { "mousedown": "onMouseDown($event)" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiSidePanelResizableWidthDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[sieUiSidePanelResizableWidth]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: Document, decorators: [{
                    type: Inject,
                    args: [DOCUMENT]
                }] }]; }, propDecorators: { resizeEnabled: [{
                type: Input
            }], dragDirection: [{
                type: Input
            }], widthChange: [{
                type: Output
            }], onMouseDown: [{
                type: HostListener,
                args: ['mousedown', ['$event']]
            }] } });

class UiSidePanelWrapperComponent {
    set sidePanelOpenedIcon(value) {
        this._sidePanelOpenedIcon = value;
        this.iconReg.register(value);
    }
    set sidePanelClosedIcon(value) {
        this._sidePanelClosedIcon = value;
        this.iconReg.register(value);
    }
    get openLeft() {
        return this._openLeft;
    }
    set openLeft(value) {
        this._openLeft = coerceBooleanProperty(value);
    }
    get openRight() {
        return this._openRight;
    }
    set openRight(value) {
        this._openRight = coerceBooleanProperty(value);
    }
    get disabled() {
        return this._disabled;
    }
    set disabled(value) {
        this._disabled = coerceBooleanProperty(value);
    }
    get hidden() {
        return this._hidden;
    }
    set hidden(value) {
        this._hidden = coerceBooleanProperty(value);
    }
    constructor(iconReg, layoutService, cdr, document, elementRef) {
        this.iconReg = iconReg;
        this.layoutService = layoutService;
        this.cdr = cdr;
        this.document = document;
        this.elementRef = elementRef;
        this.toggleSidePanelScreenReaderText = '';
        this.position = 'left';
        this.toggled = new EventEmitter();
        this._openLeft = false;
        this._openRight = false;
        this._disabled = false;
        this._hidden = false;
        this.smallViewport = false;
        this.subscriptions = new Subscription();
        this.sidePanelOpenedIcon = SieIcon.NavigationLeft;
        this.sidePanelClosedIcon = SieIcon.NavigationLeft;
    }
    ngAfterViewInit() {
        this._wrapper = this.document.querySelector(SIDE_PANEL_CLASS);
        this.subscriptions.add(this.layoutService.currentViewPort$.subscribe(cv => {
            this.smallViewport = ['M', 'S', 'XS'].includes(cv);
            this.getPaddingValues();
            this.setSidePanelValues();
            this.toggleDisableScrolling(true);
            this.cdr.detectChanges();
        }));
        this.subscriptions.add(this.layoutService.headerHeight$.pipe(distinctUntilChanged()).subscribe(h => {
            this._wrapper.style.setProperty('--header-height-dynamic', `${h}px`);
        }));
    }
    ngOnDestroy() {
        this.subscriptions.unsubscribe();
    }
    toggleSidePanelLeft() {
        if (this.smallViewport && this.openRight) {
            this.openRight = false;
        }
        this.openLeft = !this.openLeft;
        this.toggled.emit(this.openLeft);
        this.toggleDisableScrolling();
    }
    toggleSidePanelRight() {
        if (this.smallViewport && this.openLeft) {
            this.openLeft = false;
        }
        this.openRight = !this.openRight;
        this.toggled.emit(this.openRight);
        this.toggleDisableScrolling();
    }
    onWidthChangeLeft(newWidth) {
        this._wrapper.style.setProperty('--sp-resize-width-left', `${newWidth}px`);
    }
    onWidthChangeRight(newWidth) {
        this._wrapper.style.setProperty('--sp-resize-width-right', `${newWidth}px`);
    }
    toggleDisableScrolling(resize = false) {
        this.layoutService.enableScroll();
        if (this.smallViewport && resize) {
            this.closeSidePanelOnResizeSmallViewport();
        }
        const dialogOpen = this.openLeft || this.openRight;
        if (this.smallViewport && dialogOpen) {
            this.layoutService.disableScroll();
        }
    }
    closeSidePanelOnResizeSmallViewport() {
        if (this.openLeft || this.openRight) {
            if (this.openLeft) {
                this.openLeft = false;
            }
            if (this.openRight) {
                this.openRight = false;
            }
            this.toggled.emit(false);
        }
    }
    setSidePanelValues() {
        this.subscriptions.add(this.layoutService.currentViewPort$
            .pipe(filter$1(cv => !['XS', 'S', 'M'].includes(cv)))
            .subscribe(currentViewport => {
            if (currentViewport === 'L') {
                this.updateSidePanelCssVars(SIDE_PANEL_L);
            }
            else {
                this.updateSidePanelCssVars(SIDE_PANEL_XL);
            }
        }));
    }
    updateSidePanelCssVars(sidePanel) {
        this._wrapper.style.setProperty('--sp-max-width', `${sidePanel.max}px`);
        this._wrapper.style.setProperty('--sp-min-width', `${sidePanel.min}px`);
        this._wrapper.style.setProperty('--sp-closed-width', `${sidePanel.closed}px`);
        this._wrapper.style.setProperty('--sp-resize-width-left', `${sidePanel.default}px`);
        this._wrapper.style.setProperty('--sp-resize-width-right', `${sidePanel.default}px`);
        this.cdr.detectChanges();
    }
    getPaddingValues() {
        const panelRight = this.elementRef.nativeElement.querySelector('.side-panel__resize.right');
        const panelLeft = this.elementRef.nativeElement.querySelector('.side-panel__resize.left');
        const paddingRight = panelRight ? getComputedStyle(panelRight).paddingRight : '0';
        const paddingLeft = panelLeft ? getComputedStyle(panelLeft).paddingLeft : '0';
        const padding = panelLeft ? paddingLeft : paddingRight;
        this._wrapper.style.setProperty('--sp-padding', padding);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiSidePanelWrapperComponent, deps: [{ token: i1.SieIconRegistryService }, { token: i1$1.LayoutService }, { token: i0.ChangeDetectorRef }, { token: DOCUMENT }, { token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiSidePanelWrapperComponent, selector: "sie-ui-side-panel-wrapper", inputs: { toggleSidePanelScreenReaderText: "toggleSidePanelScreenReaderText", position: "position", sidePanelOpenedIcon: "sidePanelOpenedIcon", sidePanelClosedIcon: "sidePanelClosedIcon", openLeft: "openLeft", openRight: "openRight", disabled: "disabled", hidden: "hidden" }, outputs: { toggled: "toggled" }, ngImport: i0, template: "<div class=\"side-panel\" [hidden]=\"hidden\">\n  <ng-container *ngIf=\"position !== 'right' && !hidden\">\n    <div\n      class=\"side-panel__resize left container\"\n      sieUiSidePanelResizableWidth\n      [ngClass]=\"{ open: openLeft }\"\n      [resizeEnabled]=\"openLeft\"\n      (widthChange)=\"onWidthChangeLeft($event)\"\n    >\n      <div class=\"side-panel__content\">\n        <button class=\"side-panel__toggle-btn\" type=\"button\" [disabled]=\"disabled\" (click)=\"toggleSidePanelLeft()\">\n          <sie-icon\n            class=\"side-panel__toggle-btn-icon\"\n            [name]=\"openLeft ? _sidePanelOpenedIcon : _sidePanelClosedIcon\"\n          ></sie-icon>\n          <span class=\"visually-hidden\">{{ toggleSidePanelScreenReaderText }}</span>\n        </button>\n        <div class=\"side-panel__scrollbar\">\n          <div class=\"side-panel__panel\" [ngClass]=\"openLeft ? 'side-panel--open' : ''\">\n            <ng-container *ngTemplateOutlet=\"sidePanelContent\"></ng-container>\n          </div>\n        </div>\n      </div>\n      <div class=\"dragholder\" [ngClass]=\"{ active: openLeft }\"></div>\n    </div>\n  </ng-container>\n\n  <ng-container>\n    <div class=\"side-panel__main\" [ngClass]=\"{ open: openLeft || openRight || (openLeft && openRight) }\">\n      <ng-container *ngTemplateOutlet=\"mainContent\"></ng-container>\n    </div>\n  </ng-container>\n\n  <ng-container *ngIf=\"position !== 'left' && !hidden\">\n    <div\n      class=\"side-panel__resize right container\"\n      sieUiSidePanelResizableWidth\n      [ngClass]=\"{ open: openRight }\"\n      [resizeEnabled]=\"openRight\"\n      [dragDirection]=\"'left'\"\n      (widthChange)=\"onWidthChangeRight($event)\"\n    >\n      <div class=\"dragholder\" [ngClass]=\"{ active: openRight }\"></div>\n      <div class=\"side-panel__content\">\n        <button class=\"side-panel__toggle-btn\" type=\"button\" [disabled]=\"disabled\" (click)=\"toggleSidePanelRight()\">\n          <sie-icon\n            class=\"side-panel__toggle-btn-icon\"\n            [name]=\"openRight ? _sidePanelOpenedIcon : _sidePanelClosedIcon\"\n          ></sie-icon>\n          <span class=\"visually-hidden\">{{ toggleSidePanelScreenReaderText }}</span>\n        </button>\n        <div class=\"side-panel__scrollbar\">\n          <div class=\"side-panel__panel\" [ngClass]=\"openRight ? 'side-panel--open' : ''\">\n            <ng-container *ngTemplateOutlet=\"sidePanelRightContent\"></ng-container>\n          </div>\n        </div>\n      </div>\n    </div>\n  </ng-container>\n</div>\n\n<ng-template #sidePanelContent>\n  <ng-content select=\"[sidePanel]\"></ng-content>\n</ng-template>\n\n<ng-template #mainContent>\n  <ng-content select=\"[content]\"></ng-content>\n</ng-template>\n\n<ng-template #sidePanelRightContent>\n  <ng-content select=\"[sidePanelRight]\"></ng-content>\n</ng-template>\n", styles: [".side-panel__toggle-btn{outline:none;outline-offset:0}@media (pointer: fine){.side-panel__toggle-btn{position:relative}.side-panel__toggle-btn:focus{outline:1px solid #1491eb;outline-offset:2px}.side-panel__toggle-btn:focus:not(:focus-visible){outline:0}.side-panel__toggle-btn:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}::-webkit-scrollbar-thumb{background-clip:padding-box;background-color:#737389}::-webkit-scrollbar-button{display:none}::-webkit-scrollbar-corner{background-color:transparent}::-webkit-scrollbar{width:24px;height:20px}:host{scrollbar-color:#737389 #fff}:host .dark,:host.dark{scrollbar-color:#ccccd4 #000028}::-webkit-scrollbar-thumb:vertical{border-left:16px solid transparent;border-right:4px solid transparent}::-webkit-scrollbar-thumb:horizontal{border-top:16px solid transparent}::-webkit-scrollbar-track:vertical{border-left:16px solid #fff;background:#ccccd4;border-right:4px solid #fff}::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #ccccd4}.dark::-webkit-scrollbar-thumb,.dark ::-webkit-scrollbar-thumb{background-color:#ccccd4}.dark::-webkit-scrollbar-track:vertical,.dark ::-webkit-scrollbar-track:vertical{background:#737389;border-right:4px solid #000028;border-left:8px solid #000028}.dark::-webkit-scrollbar-track:horizontal,.dark ::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #737389}.side-panel{display:flex}@media (min-width: 1920px){.side-panel{max-width:1920px;margin-left:auto;margin-right:auto}}@media (min-width: 1024px){.side-panel__content{flex-grow:1}.side-panel__resize{height:calc(100vh - var(--header-height-dynamic));min-width:calc(var(--sp-closed-width) + var(--sp-padding));max-width:calc(var(--sp-closed-width) + var(--sp-padding))}.side-panel__resize .dragholder{position:relative}.side-panel__resize .dragholder:before{content:\"\";position:absolute;top:0;left:0;width:100%;height:100%}.side-panel__resize .dragholder.active:hover:before{cursor:col-resize}.side-panel__resize.left.container{padding-right:0}.side-panel__resize.left .dragholder{padding-left:4px}.side-panel__resize.left .dragholder:before{border-right:2px solid #ccccd4}.side-panel__resize.right.container{padding-left:0}.side-panel__resize.right .side-panel__content{display:flex;justify-content:flex-end;align-items:flex-start}.side-panel__resize.right .dragholder{padding-right:4px}.side-panel__resize.right .dragholder:before{border-left:2px solid #ccccd4}.side-panel__resize.open{min-width:calc(var(--sp-min-width) + var(--sp-padding));max-width:calc(var(--sp-max-width) + var(--sp-padding))}.side-panel__resize.open .side-panel__content{max-width:calc(var(--sp-max-width) - 4px)}.side-panel__resize.open.left{flex:0 0 calc(var(--sp-resize-width-left) + var(--sp-padding))}.side-panel__resize.open.left .side-panel__content{width:calc(var(--sp-resize-width-left) - 4px)}.side-panel__resize.open.right{flex:0 0 calc(var(--sp-resize-width-right) + var(--sp-padding))}.side-panel__resize.open.right .side-panel__toggle-btn{display:flex;justify-content:flex-end}.side-panel__resize.open.right .side-panel__content{align-items:unset;flex-direction:column;width:calc(var(--sp-resize-width-right) - 4px)}.side-panel__resize,.side-panel__main{margin-bottom:16px}.side-panel__main{flex-grow:1}.side-panel__main:only-child{width:100%}.side-panel__main:nth-child(2):nth-last-child(2){width:calc(100% - 2 * (var(--sp-closed-width) + var(--sp-padding)))}.side-panel__main:nth-child(2):nth-last-child(2).open{width:calc(100% - (var(--sp-resize-width-left) + var(--sp-padding)) - (var(--sp-resize-width-right) + var(--sp-padding)));min-width:calc(100% - 2 * (var(--sp-max-width) + var(--sp-padding)))}.side-panel__main:first-child:nth-last-child(2),.side-panel__main:nth-child(2):last-child{width:calc(100% - (var(--sp-closed-width) + var(--sp-padding)))}.side-panel__main:first-child:nth-last-child(2).open,.side-panel__main:nth-child(2):last-child.open{min-width:calc(100% - (var(--sp-max-width) + var(--sp-padding)))}.side-panel__main:first-child:nth-last-child(2).open{width:calc(100% - (var(--sp-resize-width-right) + var(--sp-padding)))}.side-panel__main:nth-child(2):last-child.open{width:calc(100% - (var(--sp-resize-width-left) + var(--sp-padding)))}.side-panel__scrollbar{height:calc(100% - 65px);overflow:auto}}@media (max-width: 1023.78px){.side-panel{position:relative;align-items:flex-start;flex-wrap:wrap}.side-panel__scrollbar{width:100%;overflow:auto;height:100%}.side-panel__resize{height:65px;width:100%;border-bottom:2px solid #ccccd4;z-index:2}.side-panel__resize.open{background:#fff;border-bottom:unset;position:fixed;top:var(--header-height-dynamic);z-index:10;left:0;right:0;bottom:0;width:100%;height:calc(100vh - var(--header-height-dynamic));margin-bottom:0}.side-panel__resize.open .side-panel__content{position:absolute;inset:0;display:flex;flex-direction:column;width:100%;padding:0 16px 24px}}@media (max-width: 1023.78px) and (min-width: 1024px){.side-panel__resize.open .side-panel__content{padding:0 24px 24px}}@media (max-width: 1023.78px){.side-panel__resize.open.right .side-panel__toggle-btn{display:flex;justify-content:flex-end}.side-panel__resize:first-child:nth-last-child(3),.side-panel__resize:first-child:nth-last-child(3)~.side-panel__resize{width:50%}.side-panel__resize:first-child:nth-last-child(3).open,.side-panel__resize:first-child:nth-last-child(3)~.side-panel__resize.open{width:100%}.side-panel__resize.left{order:1}.side-panel__resize.right{order:2;justify-content:flex-end}.side-panel__main{order:3;width:100%;padding-bottom:80px;z-index:1}.side-panel .dragholder{visibility:hidden}}.side-panel__resize{position:sticky;display:flex;top:var(--header-height-dynamic);background-color:#fff}.side-panel__panel{display:none}.side-panel--open{display:block}.side-panel__toggle-btn{--btn-color: var(--btn-color-custom, #007993);color:var(--btn-color);fill:var(--btn-color);margin:16px 0;border:0;background-color:transparent;cursor:pointer;outline:none;padding:0}@media (min-width: 1024px){.side-panel__toggle-btn{margin:24px 0 16px}}.side-panel__toggle-btn:disabled{--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color);cursor:not-allowed}.side-panel__toggle-btn-icon{width:25px;height:25px;display:flex;align-items:center;fill:currentColor}.side-panel__toggle-btn-icon svg{fill:currentColor;width:inherit;height:inherit}.side-panel__toggle-btn-icon svg g{fill:currentColor;width:inherit;height:inherit}.side-panel__toggle-btn-icon svg text{font-family:Siemens Sans,sans-serif}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "directive", type: UiSidePanelResizableWidthDirective, selector: "[sieUiSidePanelResizableWidth]", inputs: ["resizeEnabled", "dragDirection"], outputs: ["widthChange"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiSidePanelWrapperComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-side-panel-wrapper', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"side-panel\" [hidden]=\"hidden\">\n  <ng-container *ngIf=\"position !== 'right' && !hidden\">\n    <div\n      class=\"side-panel__resize left container\"\n      sieUiSidePanelResizableWidth\n      [ngClass]=\"{ open: openLeft }\"\n      [resizeEnabled]=\"openLeft\"\n      (widthChange)=\"onWidthChangeLeft($event)\"\n    >\n      <div class=\"side-panel__content\">\n        <button class=\"side-panel__toggle-btn\" type=\"button\" [disabled]=\"disabled\" (click)=\"toggleSidePanelLeft()\">\n          <sie-icon\n            class=\"side-panel__toggle-btn-icon\"\n            [name]=\"openLeft ? _sidePanelOpenedIcon : _sidePanelClosedIcon\"\n          ></sie-icon>\n          <span class=\"visually-hidden\">{{ toggleSidePanelScreenReaderText }}</span>\n        </button>\n        <div class=\"side-panel__scrollbar\">\n          <div class=\"side-panel__panel\" [ngClass]=\"openLeft ? 'side-panel--open' : ''\">\n            <ng-container *ngTemplateOutlet=\"sidePanelContent\"></ng-container>\n          </div>\n        </div>\n      </div>\n      <div class=\"dragholder\" [ngClass]=\"{ active: openLeft }\"></div>\n    </div>\n  </ng-container>\n\n  <ng-container>\n    <div class=\"side-panel__main\" [ngClass]=\"{ open: openLeft || openRight || (openLeft && openRight) }\">\n      <ng-container *ngTemplateOutlet=\"mainContent\"></ng-container>\n    </div>\n  </ng-container>\n\n  <ng-container *ngIf=\"position !== 'left' && !hidden\">\n    <div\n      class=\"side-panel__resize right container\"\n      sieUiSidePanelResizableWidth\n      [ngClass]=\"{ open: openRight }\"\n      [resizeEnabled]=\"openRight\"\n      [dragDirection]=\"'left'\"\n      (widthChange)=\"onWidthChangeRight($event)\"\n    >\n      <div class=\"dragholder\" [ngClass]=\"{ active: openRight }\"></div>\n      <div class=\"side-panel__content\">\n        <button class=\"side-panel__toggle-btn\" type=\"button\" [disabled]=\"disabled\" (click)=\"toggleSidePanelRight()\">\n          <sie-icon\n            class=\"side-panel__toggle-btn-icon\"\n            [name]=\"openRight ? _sidePanelOpenedIcon : _sidePanelClosedIcon\"\n          ></sie-icon>\n          <span class=\"visually-hidden\">{{ toggleSidePanelScreenReaderText }}</span>\n        </button>\n        <div class=\"side-panel__scrollbar\">\n          <div class=\"side-panel__panel\" [ngClass]=\"openRight ? 'side-panel--open' : ''\">\n            <ng-container *ngTemplateOutlet=\"sidePanelRightContent\"></ng-container>\n          </div>\n        </div>\n      </div>\n    </div>\n  </ng-container>\n</div>\n\n<ng-template #sidePanelContent>\n  <ng-content select=\"[sidePanel]\"></ng-content>\n</ng-template>\n\n<ng-template #mainContent>\n  <ng-content select=\"[content]\"></ng-content>\n</ng-template>\n\n<ng-template #sidePanelRightContent>\n  <ng-content select=\"[sidePanelRight]\"></ng-content>\n</ng-template>\n", styles: [".side-panel__toggle-btn{outline:none;outline-offset:0}@media (pointer: fine){.side-panel__toggle-btn{position:relative}.side-panel__toggle-btn:focus{outline:1px solid #1491eb;outline-offset:2px}.side-panel__toggle-btn:focus:not(:focus-visible){outline:0}.side-panel__toggle-btn:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}::-webkit-scrollbar-thumb{background-clip:padding-box;background-color:#737389}::-webkit-scrollbar-button{display:none}::-webkit-scrollbar-corner{background-color:transparent}::-webkit-scrollbar{width:24px;height:20px}:host{scrollbar-color:#737389 #fff}:host .dark,:host.dark{scrollbar-color:#ccccd4 #000028}::-webkit-scrollbar-thumb:vertical{border-left:16px solid transparent;border-right:4px solid transparent}::-webkit-scrollbar-thumb:horizontal{border-top:16px solid transparent}::-webkit-scrollbar-track:vertical{border-left:16px solid #fff;background:#ccccd4;border-right:4px solid #fff}::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #ccccd4}.dark::-webkit-scrollbar-thumb,.dark ::-webkit-scrollbar-thumb{background-color:#ccccd4}.dark::-webkit-scrollbar-track:vertical,.dark ::-webkit-scrollbar-track:vertical{background:#737389;border-right:4px solid #000028;border-left:8px solid #000028}.dark::-webkit-scrollbar-track:horizontal,.dark ::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #737389}.side-panel{display:flex}@media (min-width: 1920px){.side-panel{max-width:1920px;margin-left:auto;margin-right:auto}}@media (min-width: 1024px){.side-panel__content{flex-grow:1}.side-panel__resize{height:calc(100vh - var(--header-height-dynamic));min-width:calc(var(--sp-closed-width) + var(--sp-padding));max-width:calc(var(--sp-closed-width) + var(--sp-padding))}.side-panel__resize .dragholder{position:relative}.side-panel__resize .dragholder:before{content:\"\";position:absolute;top:0;left:0;width:100%;height:100%}.side-panel__resize .dragholder.active:hover:before{cursor:col-resize}.side-panel__resize.left.container{padding-right:0}.side-panel__resize.left .dragholder{padding-left:4px}.side-panel__resize.left .dragholder:before{border-right:2px solid #ccccd4}.side-panel__resize.right.container{padding-left:0}.side-panel__resize.right .side-panel__content{display:flex;justify-content:flex-end;align-items:flex-start}.side-panel__resize.right .dragholder{padding-right:4px}.side-panel__resize.right .dragholder:before{border-left:2px solid #ccccd4}.side-panel__resize.open{min-width:calc(var(--sp-min-width) + var(--sp-padding));max-width:calc(var(--sp-max-width) + var(--sp-padding))}.side-panel__resize.open .side-panel__content{max-width:calc(var(--sp-max-width) - 4px)}.side-panel__resize.open.left{flex:0 0 calc(var(--sp-resize-width-left) + var(--sp-padding))}.side-panel__resize.open.left .side-panel__content{width:calc(var(--sp-resize-width-left) - 4px)}.side-panel__resize.open.right{flex:0 0 calc(var(--sp-resize-width-right) + var(--sp-padding))}.side-panel__resize.open.right .side-panel__toggle-btn{display:flex;justify-content:flex-end}.side-panel__resize.open.right .side-panel__content{align-items:unset;flex-direction:column;width:calc(var(--sp-resize-width-right) - 4px)}.side-panel__resize,.side-panel__main{margin-bottom:16px}.side-panel__main{flex-grow:1}.side-panel__main:only-child{width:100%}.side-panel__main:nth-child(2):nth-last-child(2){width:calc(100% - 2 * (var(--sp-closed-width) + var(--sp-padding)))}.side-panel__main:nth-child(2):nth-last-child(2).open{width:calc(100% - (var(--sp-resize-width-left) + var(--sp-padding)) - (var(--sp-resize-width-right) + var(--sp-padding)));min-width:calc(100% - 2 * (var(--sp-max-width) + var(--sp-padding)))}.side-panel__main:first-child:nth-last-child(2),.side-panel__main:nth-child(2):last-child{width:calc(100% - (var(--sp-closed-width) + var(--sp-padding)))}.side-panel__main:first-child:nth-last-child(2).open,.side-panel__main:nth-child(2):last-child.open{min-width:calc(100% - (var(--sp-max-width) + var(--sp-padding)))}.side-panel__main:first-child:nth-last-child(2).open{width:calc(100% - (var(--sp-resize-width-right) + var(--sp-padding)))}.side-panel__main:nth-child(2):last-child.open{width:calc(100% - (var(--sp-resize-width-left) + var(--sp-padding)))}.side-panel__scrollbar{height:calc(100% - 65px);overflow:auto}}@media (max-width: 1023.78px){.side-panel{position:relative;align-items:flex-start;flex-wrap:wrap}.side-panel__scrollbar{width:100%;overflow:auto;height:100%}.side-panel__resize{height:65px;width:100%;border-bottom:2px solid #ccccd4;z-index:2}.side-panel__resize.open{background:#fff;border-bottom:unset;position:fixed;top:var(--header-height-dynamic);z-index:10;left:0;right:0;bottom:0;width:100%;height:calc(100vh - var(--header-height-dynamic));margin-bottom:0}.side-panel__resize.open .side-panel__content{position:absolute;inset:0;display:flex;flex-direction:column;width:100%;padding:0 16px 24px}}@media (max-width: 1023.78px) and (min-width: 1024px){.side-panel__resize.open .side-panel__content{padding:0 24px 24px}}@media (max-width: 1023.78px){.side-panel__resize.open.right .side-panel__toggle-btn{display:flex;justify-content:flex-end}.side-panel__resize:first-child:nth-last-child(3),.side-panel__resize:first-child:nth-last-child(3)~.side-panel__resize{width:50%}.side-panel__resize:first-child:nth-last-child(3).open,.side-panel__resize:first-child:nth-last-child(3)~.side-panel__resize.open{width:100%}.side-panel__resize.left{order:1}.side-panel__resize.right{order:2;justify-content:flex-end}.side-panel__main{order:3;width:100%;padding-bottom:80px;z-index:1}.side-panel .dragholder{visibility:hidden}}.side-panel__resize{position:sticky;display:flex;top:var(--header-height-dynamic);background-color:#fff}.side-panel__panel{display:none}.side-panel--open{display:block}.side-panel__toggle-btn{--btn-color: var(--btn-color-custom, #007993);color:var(--btn-color);fill:var(--btn-color);margin:16px 0;border:0;background-color:transparent;cursor:pointer;outline:none;padding:0}@media (min-width: 1024px){.side-panel__toggle-btn{margin:24px 0 16px}}.side-panel__toggle-btn:disabled{--btn-color: var(--btn-color-custom, #b3b3be);color:var(--btn-color);fill:var(--btn-color);cursor:not-allowed}.side-panel__toggle-btn-icon{width:25px;height:25px;display:flex;align-items:center;fill:currentColor}.side-panel__toggle-btn-icon svg{fill:currentColor;width:inherit;height:inherit}.side-panel__toggle-btn-icon svg g{fill:currentColor;width:inherit;height:inherit}.side-panel__toggle-btn-icon svg text{font-family:Siemens Sans,sans-serif}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }, { type: i1$1.LayoutService }, { type: i0.ChangeDetectorRef }, { type: Document, decorators: [{
                    type: Inject,
                    args: [DOCUMENT]
                }] }, { type: i0.ElementRef }]; }, propDecorators: { toggleSidePanelScreenReaderText: [{
                type: Input
            }], position: [{
                type: Input
            }], sidePanelOpenedIcon: [{
                type: Input
            }], sidePanelClosedIcon: [{
                type: Input
            }], openLeft: [{
                type: Input
            }], openRight: [{
                type: Input
            }], disabled: [{
                type: Input
            }], hidden: [{
                type: Input
            }], toggled: [{
                type: Output
            }] } });

class UiSidePanelWrapperModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiSidePanelWrapperModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiSidePanelWrapperModule, declarations: [UiSidePanelWrapperComponent, UiSidePanelResizableWidthDirective], imports: [CommonModule, SieIconsModule], exports: [UiSidePanelWrapperComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiSidePanelWrapperModule, imports: [CommonModule, SieIconsModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiSidePanelWrapperModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiSidePanelWrapperComponent, UiSidePanelResizableWidthDirective],
                    imports: [CommonModule, SieIconsModule],
                    exports: [UiSidePanelWrapperComponent]
                }]
        }] });

/** @ignore */
const RICH_SNIPPET_PRIMARY_META_TRUNCATION_LINES_DEFAULT = 2;
/** @ignore */
const RICH_SNIPPET_PRIMARY_META_TRUNCATION_LINES = {
    standard: RICH_SNIPPET_PRIMARY_META_TRUNCATION_LINES_DEFAULT,
    'no-border': 3
};

class UiRichSnippetSkeletonComponent {
    constructor() {
        this.skeletonSize = 'normal';
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiRichSnippetSkeletonComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiRichSnippetSkeletonComponent, selector: "sie-ui-rich-snippet-skeleton", inputs: { skeletonSize: "skeletonSize" }, ngImport: i0, template: "<sie-ui-skeleton\n  *ngIf=\"skeletonSize === 'normal'; else smallSkeleton\"\n  class=\"rich-snippet-skeleton__normal\"\n></sie-ui-skeleton>\n\n<ng-template #smallSkeleton>\n  <sie-ui-skeleton class=\"rich-snippet-skeleton__small\"></sie-ui-skeleton>\n</ng-template>\n", styles: [".rich-snippet-skeleton__small{width:294px;height:56px}.rich-snippet-skeleton__normal{width:504px;height:96px}\n"], dependencies: [{ kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: UiSkeletonComponent, selector: "sie-ui-skeleton", inputs: ["shape", "loadingText", "ariaLabel", "count"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiRichSnippetSkeletonComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-rich-snippet-skeleton', changeDetection: ChangeDetectionStrategy.OnPush, template: "<sie-ui-skeleton\n  *ngIf=\"skeletonSize === 'normal'; else smallSkeleton\"\n  class=\"rich-snippet-skeleton__normal\"\n></sie-ui-skeleton>\n\n<ng-template #smallSkeleton>\n  <sie-ui-skeleton class=\"rich-snippet-skeleton__small\"></sie-ui-skeleton>\n</ng-template>\n", styles: [".rich-snippet-skeleton__small{width:294px;height:56px}.rich-snippet-skeleton__normal{width:504px;height:96px}\n"] }]
        }], propDecorators: { skeletonSize: [{
                type: Input
            }] } });

/**
 * # Rich Snippet Component
 * Rich snippet is used as a preview and a trigger to the detailed information.
 *
 * ## Component types
 *
 * - Content
 * - Link
 *
 * ## Component variations
 *
 * - Standard
 * - No border
 *
 * ## Content
 *
 * The Rich Snippet component does not accept any content.
 *
 * ## Code example
 * @example
 * Template:
 * ```html
 *  <sie-ui-rich-snippet [item]="richSnippetData" [type]="'link'" [closeable]="true" [secondaryMetaPosition]="'top'" [showThumbnail]="false"></sie-ui-rich-snippet>
 * ```
 *  ```ts
 * const richSnippetData: = {
 *   title: 'Lorem ipsum dolor sit amet',
 *   primaryMeta: '<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit</p>',
 *   secondaryMeta: 'Something',
 *   secondaryMetaIcon: SieIcon.Support,
 *   url: 'https://sieportaldev.siemens.com/en-ww/home',
 *   target: '_blank'
 * };
 * ```
 */
class UiRichSnippetComponent extends UiAutoDestroyableComponent {
    /**
     * The main source of {@link UiRichSnippetModel component data}
     */
    set item(value) {
        if (value && Object.keys(value).length) {
            Object.keys(value).forEach(key => {
                if (key === 'placeholderIcon' || key === 'secondaryMetaIcon') {
                    this.iconReg.register(value[key]);
                }
            });
            this._item = value;
        }
    }
    get item() {
        return this._item;
    }
    /**
     * Defines whether the component can be closed
     * @default false
     */
    set closeable(value) {
        this._closeable = coerceBooleanProperty(value);
    }
    get closeable() {
        return this._closeable;
    }
    /**
     * Defines if the thumbnail should be shown
     * @default true
     */
    set showThumbnail(value) {
        this._showThumbnail = coerceBooleanProperty(value);
    }
    get showThumbnail() {
        return this._showThumbnail;
    }
    /**
     * Defines the component {@link UiRichSnippetVariant variance}
     * @default 'standard'
     */
    set variant(value) {
        this._variant = value;
        this.primaryMetaTruncationLines = RICH_SNIPPET_PRIMARY_META_TRUNCATION_LINES[this._variant];
    }
    get variant() {
        return this._variant;
    }
    constructor(iconReg, vcr) {
        super(vcr);
        this.iconReg = iconReg;
        this.vcr = vcr;
        /**
         * Defines the component {@link UiRichSnippetType type}
         * @default 'content'
         */
        this.type = 'content';
        /**
         * {@link UiRichSnippetSecondaryMetaPosition Position} of the secondary metadata
         * @default 'bottom'
         */
        this.secondaryMetaPosition = 'bottom';
        /**
         * Screen reader label for close icon when component is closeable
         * @default ''
         */
        this.screenReaderCloseIcon = '';
        /**
         * Defines {@link UiRichSnippetSkeletonSize size} of the skeleton
         * @default 'normal'
         */
        this.skeletonSize = 'normal';
        /**
         * Event triggered when the component is closed
         */
        this.closed = new EventEmitter();
        /** @ignore */
        this.imgFailedToLoad = false;
        /** @ignore */
        this.primaryMetaTruncationLines = RICH_SNIPPET_PRIMARY_META_TRUNCATION_LINES_DEFAULT;
        this._closeable = false;
        this._showThumbnail = true;
        this._item = null;
        this._variant = 'standard';
        iconReg.register(SieIcon.Close);
        iconReg.register(SieIcon.Link);
        iconReg.register(SieIcon.Image);
    }
    /** @ignore */
    // eslint-disable-next-line @angular-eslint/no-empty-lifecycle-method
    ngOnDestroy() {
        // must be implemented according to UiAutoDestroyableComponent
    }
    /** @ignore */
    loadPlaceholder(imageLoaded) {
        this.imgFailedToLoad = imageLoaded;
    }
    /** @ignore */
    navigateLink(href, target = '_self') {
        if (!href) {
            return;
        }
        window.open(href, target);
    }
    /** @ignore */
    destroy(event) {
        super.destroy(event);
        this.closed.emit(event);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiRichSnippetComponent, deps: [{ token: i1.SieIconRegistryService }, { token: i0.ViewContainerRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiRichSnippetComponent, selector: "sie-ui-rich-snippet", inputs: { item: "item", closeable: "closeable", showThumbnail: "showThumbnail", variant: "variant", type: "type", secondaryMetaPosition: "secondaryMetaPosition", screenReaderCloseIcon: "screenReaderCloseIcon", skeletonSize: "skeletonSize" }, outputs: { closed: "closed" }, usesInheritance: true, ngImport: i0, template: "<sie-ui-rich-snippet-skeleton\n  [skeletonSize]=\"skeletonSize\"\n  *ngIf=\"!item; else richSnippet\"\n></sie-ui-rich-snippet-skeleton>\n\n<ng-template #richSnippet>\n  <div\n    class=\"rich-snippet__wrapper\"\n    [ngClass]=\"['variant-' + variant]\"\n    [attr.role]=\"'link'\"\n    (keydown.enter)=\"navigateLink(item.url, item.target)\"\n    (click)=\"navigateLink(item.url, item.target)\"\n    tabindex=\"0\"\n  >\n    <article class=\"rich-snippet\">\n      <div\n        *ngIf=\"showThumbnail\"\n        class=\"rich-snippet__image\"\n        [ngClass]=\"{\n          'placeholder-icon': !item.image || imgFailedToLoad,\n          'content-placeholder': type === 'content' && !item.placeholderIcon\n        }\"\n      >\n        <sie-ui-picture\n          *ngIf=\"item.image && !imgFailedToLoad\"\n          [model]=\"{ urlLarge: item.image, altText: item.imageAltText, mode: 'cover' }\"\n          (failedToLoadImg)=\"loadPlaceholder($event)\"\n        ></sie-ui-picture>\n        <ng-container\n          [ngTemplateOutlet]=\"placeholderIcon\"\n          [ngTemplateOutletContext]=\"{\n            condition: (!item.image || imgFailedToLoad) && !item.placeholderIcon,\n            name: type === 'link' ? iconReg.sieIcon.Link : iconReg.sieIcon.Image\n          }\"\n        ></ng-container>\n        <ng-container\n          [ngTemplateOutlet]=\"placeholderIcon\"\n          [ngTemplateOutletContext]=\"{\n            condition: (!item.image || imgFailedToLoad) && item.placeholderIcon,\n            name: item.placeholderIcon\n          }\"\n        ></ng-container>\n      </div>\n      <div class=\"rich-snippet__content\">\n        <ng-container\n          *ngIf=\"item.secondaryMeta && secondaryMetaPosition === 'top'\"\n          [ngTemplateOutlet]=\"secondaryMetaData\"\n        ></ng-container>\n        <p class=\"rich-snippet__title\">{{ item.title }}</p>\n        <div sieCoreAddTruncationAndTooltip [maxNumberOfLinesToShow]=\"primaryMetaTruncationLines\">\n          <sie-ui-richtext [content]=\"item.primaryMeta\" class=\"rich-snippet__primary-meta\"></sie-ui-richtext>\n        </div>\n        <ng-container\n          *ngIf=\"item.secondaryMeta && secondaryMetaPosition === 'bottom'\"\n          [ngTemplateOutlet]=\"secondaryMetaData\"\n        ></ng-container>\n      </div>\n      <sie-ui-button\n        *ngIf=\"closeable\"\n        class=\"rich-snippet__close-icon\"\n        buttonType=\"button\"\n        themeType=\"icon\"\n        variant=\"icon-un-contained\"\n        [iconScreenReaderText]=\"screenReaderCloseIcon\"\n        (clicked)=\"$event.stopPropagation(); destroy($event)\"\n        (keydown.enter)=\"$event.stopPropagation()\"\n      >\n        <sie-icon class=\"icon\" [name]=\"iconReg.sieIcon.Close\"></sie-icon>\n      </sie-ui-button>\n    </article>\n  </div>\n</ng-template>\n\n<ng-template #secondaryMetaData>\n  <div class=\"rich-snippet__secondary-meta\" [class.meta-top]=\"secondaryMetaPosition === 'top'\">\n    <sie-icon *ngIf=\"item.secondaryMetaIcon\" class=\"icon\" [name]=\"item.secondaryMetaIcon\"></sie-icon>\n    <sie-ui-richtext class=\"rich-snippet__secondary-meta__text\" [content]=\"item.secondaryMeta\"></sie-ui-richtext>\n  </div>\n</ng-template>\n\n<ng-template #placeholderIcon let-condition=\"condition\" let-name=\"name\">\n  <sie-icon *ngIf=\"condition\" class=\"icon\" [name]=\"name\"></sie-icon>\n</ng-template>\n", styles: [".rich-snippet__wrapper{outline:none;outline-offset:0}@media (pointer: fine){.rich-snippet__wrapper{position:relative}.rich-snippet__wrapper:focus{outline:1px solid #1491eb;outline-offset:2px}.rich-snippet__wrapper:focus:not(:focus-visible){outline:0}.rich-snippet__wrapper:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}:host{display:flex}.rich-snippet{display:flex;position:relative;flex:1}.rich-snippet__content{padding:8px 16px 8px 12px}.rich-snippet__content .meta-top{padding-bottom:8px}.rich-snippet__title{font-size:.875rem;font-weight:700;line-height:1.25rem;display:-webkit-box;-webkit-box-orient:vertical;-webkit-line-clamp:1;overflow:hidden;line-height:20px;color:#007993}.rich-snippet__primary-meta,.rich-snippet__secondary-meta{font-size:.75rem;line-height:1rem;color:#4c4c68}.rich-snippet__secondary-meta{display:flex;gap:7px;align-items:center}.rich-snippet__secondary-meta__text{display:-webkit-box;-webkit-box-orient:vertical;-webkit-line-clamp:1;overflow:hidden}.rich-snippet__secondary-meta .icon{width:18px;height:18px;display:flex;align-items:center;fill:currentColor;fill:#4c4c68}.rich-snippet__secondary-meta .icon svg{fill:currentColor;width:inherit;height:inherit}.rich-snippet__secondary-meta .icon svg g{fill:currentColor;width:inherit;height:inherit}.rich-snippet__secondary-meta .icon svg text{font-family:Siemens Sans,sans-serif}.rich-snippet__secondary-meta:not(.meta-top){padding-top:12px}.rich-snippet__close-icon{position:absolute;right:-8px;top:-8px}.rich-snippet__close-icon .icon{width:16px;height:16px;display:flex;align-items:center;fill:currentColor}.rich-snippet__close-icon .icon svg{fill:currentColor;width:inherit;height:inherit}.rich-snippet__close-icon .icon svg g{fill:currentColor;width:inherit;height:inherit}.rich-snippet__close-icon .icon svg text{font-family:Siemens Sans,sans-serif}.rich-snippet__image{height:100%;aspect-ratio:1/1;min-height:54px;max-width:94px;max-height:94px;display:flex;flex:0 1 54px}.rich-snippet__image.placeholder-icon{background-color:#00557c;display:flex;justify-content:center;align-items:center}.rich-snippet__image.placeholder-icon .icon{width:30px;height:30px;display:flex;align-items:center;fill:currentColor;color:#fff}.rich-snippet__image.placeholder-icon .icon svg{fill:currentColor;width:inherit;height:inherit}.rich-snippet__image.placeholder-icon .icon svg g{fill:currentColor;width:inherit;height:inherit}.rich-snippet__image.placeholder-icon .icon svg text{font-family:Siemens Sans,sans-serif}.rich-snippet__image.content-placeholder{background-color:#e5e5e9}.rich-snippet__wrapper{min-width:272px;max-width:504px;min-height:56px;max-height:96px;border:1px solid #ccccd4;border-radius:4px;cursor:pointer;display:flex;flex:1 1}.rich-snippet__wrapper.variant-no-border{border:none;border-radius:0}.rich-snippet__wrapper.variant-no-border .rich-snippet__content{padding-top:0;padding-bottom:0}.rich-snippet__wrapper.variant-no-border .rich-snippet__image{border-radius:3px 0 0 3px;align-self:center}.rich-snippet__wrapper:hover .rich-snippet__title{color:#005159;text-decoration:underline}.rich-snippet__wrapper:hover .placeholder-icon:not(.content-placeholder){background-color:#00646e}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "component", type: UiPictureComponent, selector: "sie-ui-picture", inputs: ["model", "size", "ratio", "notLoadedLabel", "theme", "context", "caption", "shouldHaveOutline"], outputs: ["failedToLoadImg"] }, { kind: "component", type: UiButtonComponent, selector: "sie-ui-button" }, { kind: "directive", type: i1$1.AddTruncationAndTooltipDirective, selector: "[sieCoreAddTruncationAndTooltip]", inputs: ["maxNumberOfLinesToShow"] }, { kind: "component", type: UiRichtextComponent, selector: "sie-ui-richtext", inputs: ["content", "theme", "whiteListedTags"] }, { kind: "component", type: UiRichSnippetSkeletonComponent, selector: "sie-ui-rich-snippet-skeleton", inputs: ["skeletonSize"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiRichSnippetComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-rich-snippet', changeDetection: ChangeDetectionStrategy.OnPush, template: "<sie-ui-rich-snippet-skeleton\n  [skeletonSize]=\"skeletonSize\"\n  *ngIf=\"!item; else richSnippet\"\n></sie-ui-rich-snippet-skeleton>\n\n<ng-template #richSnippet>\n  <div\n    class=\"rich-snippet__wrapper\"\n    [ngClass]=\"['variant-' + variant]\"\n    [attr.role]=\"'link'\"\n    (keydown.enter)=\"navigateLink(item.url, item.target)\"\n    (click)=\"navigateLink(item.url, item.target)\"\n    tabindex=\"0\"\n  >\n    <article class=\"rich-snippet\">\n      <div\n        *ngIf=\"showThumbnail\"\n        class=\"rich-snippet__image\"\n        [ngClass]=\"{\n          'placeholder-icon': !item.image || imgFailedToLoad,\n          'content-placeholder': type === 'content' && !item.placeholderIcon\n        }\"\n      >\n        <sie-ui-picture\n          *ngIf=\"item.image && !imgFailedToLoad\"\n          [model]=\"{ urlLarge: item.image, altText: item.imageAltText, mode: 'cover' }\"\n          (failedToLoadImg)=\"loadPlaceholder($event)\"\n        ></sie-ui-picture>\n        <ng-container\n          [ngTemplateOutlet]=\"placeholderIcon\"\n          [ngTemplateOutletContext]=\"{\n            condition: (!item.image || imgFailedToLoad) && !item.placeholderIcon,\n            name: type === 'link' ? iconReg.sieIcon.Link : iconReg.sieIcon.Image\n          }\"\n        ></ng-container>\n        <ng-container\n          [ngTemplateOutlet]=\"placeholderIcon\"\n          [ngTemplateOutletContext]=\"{\n            condition: (!item.image || imgFailedToLoad) && item.placeholderIcon,\n            name: item.placeholderIcon\n          }\"\n        ></ng-container>\n      </div>\n      <div class=\"rich-snippet__content\">\n        <ng-container\n          *ngIf=\"item.secondaryMeta && secondaryMetaPosition === 'top'\"\n          [ngTemplateOutlet]=\"secondaryMetaData\"\n        ></ng-container>\n        <p class=\"rich-snippet__title\">{{ item.title }}</p>\n        <div sieCoreAddTruncationAndTooltip [maxNumberOfLinesToShow]=\"primaryMetaTruncationLines\">\n          <sie-ui-richtext [content]=\"item.primaryMeta\" class=\"rich-snippet__primary-meta\"></sie-ui-richtext>\n        </div>\n        <ng-container\n          *ngIf=\"item.secondaryMeta && secondaryMetaPosition === 'bottom'\"\n          [ngTemplateOutlet]=\"secondaryMetaData\"\n        ></ng-container>\n      </div>\n      <sie-ui-button\n        *ngIf=\"closeable\"\n        class=\"rich-snippet__close-icon\"\n        buttonType=\"button\"\n        themeType=\"icon\"\n        variant=\"icon-un-contained\"\n        [iconScreenReaderText]=\"screenReaderCloseIcon\"\n        (clicked)=\"$event.stopPropagation(); destroy($event)\"\n        (keydown.enter)=\"$event.stopPropagation()\"\n      >\n        <sie-icon class=\"icon\" [name]=\"iconReg.sieIcon.Close\"></sie-icon>\n      </sie-ui-button>\n    </article>\n  </div>\n</ng-template>\n\n<ng-template #secondaryMetaData>\n  <div class=\"rich-snippet__secondary-meta\" [class.meta-top]=\"secondaryMetaPosition === 'top'\">\n    <sie-icon *ngIf=\"item.secondaryMetaIcon\" class=\"icon\" [name]=\"item.secondaryMetaIcon\"></sie-icon>\n    <sie-ui-richtext class=\"rich-snippet__secondary-meta__text\" [content]=\"item.secondaryMeta\"></sie-ui-richtext>\n  </div>\n</ng-template>\n\n<ng-template #placeholderIcon let-condition=\"condition\" let-name=\"name\">\n  <sie-icon *ngIf=\"condition\" class=\"icon\" [name]=\"name\"></sie-icon>\n</ng-template>\n", styles: [".rich-snippet__wrapper{outline:none;outline-offset:0}@media (pointer: fine){.rich-snippet__wrapper{position:relative}.rich-snippet__wrapper:focus{outline:1px solid #1491eb;outline-offset:2px}.rich-snippet__wrapper:focus:not(:focus-visible){outline:0}.rich-snippet__wrapper:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}:host{display:flex}.rich-snippet{display:flex;position:relative;flex:1}.rich-snippet__content{padding:8px 16px 8px 12px}.rich-snippet__content .meta-top{padding-bottom:8px}.rich-snippet__title{font-size:.875rem;font-weight:700;line-height:1.25rem;display:-webkit-box;-webkit-box-orient:vertical;-webkit-line-clamp:1;overflow:hidden;line-height:20px;color:#007993}.rich-snippet__primary-meta,.rich-snippet__secondary-meta{font-size:.75rem;line-height:1rem;color:#4c4c68}.rich-snippet__secondary-meta{display:flex;gap:7px;align-items:center}.rich-snippet__secondary-meta__text{display:-webkit-box;-webkit-box-orient:vertical;-webkit-line-clamp:1;overflow:hidden}.rich-snippet__secondary-meta .icon{width:18px;height:18px;display:flex;align-items:center;fill:currentColor;fill:#4c4c68}.rich-snippet__secondary-meta .icon svg{fill:currentColor;width:inherit;height:inherit}.rich-snippet__secondary-meta .icon svg g{fill:currentColor;width:inherit;height:inherit}.rich-snippet__secondary-meta .icon svg text{font-family:Siemens Sans,sans-serif}.rich-snippet__secondary-meta:not(.meta-top){padding-top:12px}.rich-snippet__close-icon{position:absolute;right:-8px;top:-8px}.rich-snippet__close-icon .icon{width:16px;height:16px;display:flex;align-items:center;fill:currentColor}.rich-snippet__close-icon .icon svg{fill:currentColor;width:inherit;height:inherit}.rich-snippet__close-icon .icon svg g{fill:currentColor;width:inherit;height:inherit}.rich-snippet__close-icon .icon svg text{font-family:Siemens Sans,sans-serif}.rich-snippet__image{height:100%;aspect-ratio:1/1;min-height:54px;max-width:94px;max-height:94px;display:flex;flex:0 1 54px}.rich-snippet__image.placeholder-icon{background-color:#00557c;display:flex;justify-content:center;align-items:center}.rich-snippet__image.placeholder-icon .icon{width:30px;height:30px;display:flex;align-items:center;fill:currentColor;color:#fff}.rich-snippet__image.placeholder-icon .icon svg{fill:currentColor;width:inherit;height:inherit}.rich-snippet__image.placeholder-icon .icon svg g{fill:currentColor;width:inherit;height:inherit}.rich-snippet__image.placeholder-icon .icon svg text{font-family:Siemens Sans,sans-serif}.rich-snippet__image.content-placeholder{background-color:#e5e5e9}.rich-snippet__wrapper{min-width:272px;max-width:504px;min-height:56px;max-height:96px;border:1px solid #ccccd4;border-radius:4px;cursor:pointer;display:flex;flex:1 1}.rich-snippet__wrapper.variant-no-border{border:none;border-radius:0}.rich-snippet__wrapper.variant-no-border .rich-snippet__content{padding-top:0;padding-bottom:0}.rich-snippet__wrapper.variant-no-border .rich-snippet__image{border-radius:3px 0 0 3px;align-self:center}.rich-snippet__wrapper:hover .rich-snippet__title{color:#005159;text-decoration:underline}.rich-snippet__wrapper:hover .placeholder-icon:not(.content-placeholder){background-color:#00646e}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }, { type: i0.ViewContainerRef }]; }, propDecorators: { item: [{
                type: Input
            }], closeable: [{
                type: Input
            }], showThumbnail: [{
                type: Input
            }], variant: [{
                type: Input
            }], type: [{
                type: Input
            }], secondaryMetaPosition: [{
                type: Input
            }], screenReaderCloseIcon: [{
                type: Input
            }], skeletonSize: [{
                type: Input
            }], closed: [{
                type: Output
            }] } });

/**
 * # Rich snippet Module
 * - {@link UiRichSnippetComponent}
 *
 * ## Module peer dependencies
 * - {@link SieIconsModule}
 */
class UiRichSnippetModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiRichSnippetModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiRichSnippetModule, declarations: [UiRichSnippetComponent, UiRichSnippetSkeletonComponent], imports: [CommonModule,
            SieIconsModule,
            UiPictureModule,
            UiButtonModule,
            AddTruncationAndTooltipModule,
            UiRichtextModule,
            UiSkeletonModule], exports: [UiRichSnippetComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiRichSnippetModule, imports: [CommonModule,
            SieIconsModule,
            UiPictureModule,
            UiButtonModule,
            AddTruncationAndTooltipModule,
            UiRichtextModule,
            UiSkeletonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiRichSnippetModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiRichSnippetComponent, UiRichSnippetSkeletonComponent],
                    imports: [
                        CommonModule,
                        SieIconsModule,
                        UiPictureModule,
                        UiButtonModule,
                        AddTruncationAndTooltipModule,
                        UiRichtextModule,
                        UiSkeletonModule
                    ],
                    exports: [UiRichSnippetComponent]
                }]
        }] });

class UiTreeNavigationItemComponent {
    constructor(iconReg) {
        this.iconReg = iconReg;
        this.itemLevel = 0;
        this.truncateLabels = true;
        this.itemExpanded = new Subject();
        this.itemSelected = new Subject();
    }
    toggleItemSelection(event, item) {
        event.stopPropagation();
        this.itemSelected.next(item);
    }
    toggleSublist(event, item) {
        event.stopPropagation();
        item.expanded = !item.expanded;
        if (item.expanded) {
            this.itemExpanded.next(item);
        }
    }
    toggleSublistAndItemSelection(event, item) {
        event.preventDefault();
        this.toggleItemSelection(event, item);
        if (item.expandable && !item.expanded) {
            this.toggleSublist(event, item);
        }
    }
    onLinkItemClicked(event, item) {
        event.preventDefault();
        this.itemSelected.next(item);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTreeNavigationItemComponent, deps: [{ token: i1.SieIconRegistryService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiTreeNavigationItemComponent, selector: "sie-ui-tree-navigation-item", inputs: { item: "item", itemLevel: "itemLevel", selected: "selected", truncateLabels: "truncateLabels" }, outputs: { itemExpanded: "itemExpanded", itemSelected: "itemSelected" }, ngImport: i0, template: "<li class=\"tree-item\" *ngIf=\"!!item\" [ngClass]=\"{ truncate: truncateLabels }\" [style.--item-level]=\"itemLevel - 1\">\n  <ng-container *ngIf=\"item.expandable; else linkItem\">\n    <div class=\"tree-item__node-wrapper\" [ngClass]=\"[truncateLabels ? 'truncate' : '']\">\n      <div\n        class=\"tree-item__node--selectable\"\n        [ngClass]=\"{ truncate: truncateLabels }\"\n        [tabindex]=\"item.textOnly ? 0 : -1\"\n        (keydown.enter)=\"toggleSublist($event, item)\"\n      >\n        <div\n          class=\"tree-item__dropdown-icon-wrapper\"\n          [ngClass]=\"{ expanded: item.expanded }\"\n          [tabindex]=\"item.textOnly ? -1 : 0\"\n          (click)=\"toggleSublist($event, item)\"\n          (keydown.enter)=\"toggleSublist($event, item)\"\n        >\n          <sie-icon class=\"tree-item__dropdown-icon\" [name]=\"iconReg.sieIcon.Dropdown\"></sie-icon>\n        </div>\n        <div class=\"tree-item__dropdown-label-wrapper\">\n          <div\n            *ngIf=\"item.textOnly; else collapsableLinkItem\"\n            class=\"tree-item__dropdown-label\"\n            [ngClass]=\"{ truncate: truncateLabels, 'expanded-label': item.expanded }\"\n            (click)=\"toggleSublist($event, item)\"\n            (keydown.enter)=\"toggleSublist($event, item)\"\n          >\n            <ng-template [ngTemplateOutlet]=\"labelAndIcons\"></ng-template>\n          </div>\n        </div>\n      </div>\n    </div>\n  </ng-container>\n</li>\n\n<ng-template #linkItem>\n  <div\n    *ngIf=\"!item.textOnly; else textOnly\"\n    class=\"tree-item__link-wrapper\"\n    [ngClass]=\"[truncateLabels ? 'truncate' : '']\"\n  >\n    <sie-ui-link\n      [truncate]=\"truncateLabels\"\n      type=\"link\"\n      (clicked)=\"onLinkItemClicked($event, item)\"\n      [cssClass]=\"'no-padding tree-link ' + (selected ? 'bold' : '')\"\n      >{{ item?.itemTitle }}</sie-ui-link\n    >\n  </div>\n</ng-template>\n\n<ng-template #textOnly>\n  <div class=\"tree-item__node-wrapper\">\n    <div class=\"tree-item__node--selectable\" [ngClass]=\"{ truncate: truncateLabels }\">\n      <div class=\"tree-item__title-wrapper\">\n        <span\n          class=\"tree-item__title\"\n          [ngClass]=\"{\n            truncate: truncateLabels,\n            bold: selected\n          }\"\n          >{{ item.itemTitle }}</span\n        >\n      </div>\n    </div>\n  </div>\n</ng-template>\n\n<ng-template #collapsableLinkItem>\n  <a\n    rel=\"noopener\"\n    tabindex=\"0\"\n    class=\"tree-item__dropdown-label link\"\n    [ngClass]=\"{ truncate: truncateLabels, 'expanded-label': item.expanded }\"\n    (mousedown)=\"toggleSublistAndItemSelection($event, item)\"\n    (keydown.enter)=\"toggleSublistAndItemSelection($event, item)\"\n  >\n    <ng-template [ngTemplateOutlet]=\"labelAndIcons\"></ng-template>\n  </a>\n</ng-template>\n\n<ng-template #labelAndIcons>\n  <div class=\"tree-item__title-wrapper\">\n    <span\n      class=\"tree-item__title\"\n      [ngClass]=\"{\n        truncate: truncateLabels,\n        bold: selected\n      }\"\n      >{{ item.itemTitle }}</span\n    >\n  </div>\n</ng-template>\n", styles: [".tree-item__node-wrapper .tree-item__node--selectable,.tree-item__node-wrapper .tree-item__dropdown-label,.tree-item__dropdown-icon-wrapper{outline:none;outline-offset:0}@media (pointer: fine){.tree-item__node-wrapper .tree-item__node--selectable,.tree-item__node-wrapper .tree-item__dropdown-label,.tree-item__dropdown-icon-wrapper{position:relative}.tree-item__node-wrapper .tree-item__node--selectable:focus,.tree-item__node-wrapper .tree-item__dropdown-label:focus,.tree-item__dropdown-icon-wrapper:focus{outline:1px solid #1491eb;outline-offset:2px}.tree-item__node-wrapper .tree-item__node--selectable:focus:not(:focus-visible),.tree-item__node-wrapper .tree-item__dropdown-label:focus:not(:focus-visible),.tree-item__dropdown-icon-wrapper:focus:not(:focus-visible){outline:0}.tree-item__node-wrapper .tree-item__node--selectable:focus-visible,.tree-item__node-wrapper .tree-item__dropdown-label:focus-visible,.tree-item__dropdown-icon-wrapper:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}.tree-item{display:flex;box-sizing:border-box;align-items:center;min-width:120px;padding-left:calc(12px * var(--item-level))}.tree-item__link-wrapper{width:100%}.tree-item__dropdown-icon-wrapper{display:inline;position:relative;margin-top:2px;margin-left:1px}.tree-item__dropdown-icon-wrapper:focus-visible{outline-offset:0}.tree-item__dropdown-icon-wrapper .tree-item__dropdown-icon{width:16px;height:16px;display:flex;align-items:center;fill:currentColor;position:relative;transition:transform .12s cubic-bezier(.4,0,.3,1);transform:translateZ(0) rotate(-90deg)}.tree-item__dropdown-icon-wrapper .tree-item__dropdown-icon svg{fill:currentColor;width:inherit;height:inherit}.tree-item__dropdown-icon-wrapper .tree-item__dropdown-icon svg g{fill:currentColor;width:inherit;height:inherit}.tree-item__dropdown-icon-wrapper .tree-item__dropdown-icon svg text{font-family:Siemens Sans,sans-serif}.tree-item__dropdown-icon-wrapper.expanded{color:#000028}.tree-item__dropdown-icon-wrapper.expanded .tree-item__dropdown-icon{transform:translateZ(0) rotate(0)}.tree-item__dropdown-icon-wrapper:hover{cursor:pointer;color:#00646e}.tree-item__dropdown-label.link{color:inherit}.tree-item__node-wrapper{box-sizing:border-box;padding-right:5px;display:flex}.tree-item__node-wrapper.truncate{align-items:center}.tree-item__node-wrapper .tree-item__dropdown-label{display:flex;align-items:center}.tree-item__node-wrapper .tree-item__dropdown-label:hover{text-decoration:underline;cursor:pointer;color:#005159}.tree-item__node-wrapper .tree-item__dropdown-icon-wrapper{outline-offset:0}.tree-item__node-wrapper .tree-item__title{font-size:.875rem;font-weight:400;line-height:1.25rem;margin-left:4px}.tree-item__node-wrapper .tree-item__title.bold{font-weight:700}.tree-item__node-wrapper .tree-item__node{position:relative;min-width:100%;-webkit-user-select:none;user-select:none;display:flex;align-items:flex-start}.tree-item__node-wrapper .tree-item__node.truncate{white-space:nowrap;overflow:hidden;text-overflow:ellipsis;display:block}.tree-item__node-wrapper .tree-item__node:hover{cursor:pointer}.tree-item__node-wrapper .tree-item__node--selectable{display:flex}.tree-item__node-wrapper .tree-item__node--selectable .tree-item__title{min-width:0}.tree-item__node-wrapper .tree-item__node--selectable .tree-item__title-wrapper{display:inline-grid;width:100%}.tree-item__node-wrapper .tree-item__node--selectable .tree-item__title.truncate{white-space:nowrap;overflow:hidden;text-overflow:ellipsis}.tree-item__node-wrapper .tree-item__dropdown-icon-wrapper:has(+.tree-item__dropdown-label-wrapper:hover){color:#005159;fill:#00646e}@media (pointer: coarse){.tree-item .tree-item__dropdown-icon-wrapper .tree-item__dropdown-icon{width:20px;height:20px;display:flex;align-items:center;fill:currentColor}.tree-item .tree-item__dropdown-icon-wrapper .tree-item__dropdown-icon svg{fill:currentColor;width:inherit;height:inherit}.tree-item .tree-item__dropdown-icon-wrapper .tree-item__dropdown-icon svg g{fill:currentColor;width:inherit;height:inherit}.tree-item .tree-item__dropdown-icon-wrapper .tree-item__dropdown-icon svg text{font-family:Siemens Sans,sans-serif}.tree-item .tree-item__link-wrapper{line-height:24px}.tree-item .tree-item__title{font-size:1rem;font-weight:400;line-height:1.5rem;margin-left:6px}}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "component", type: UiLinkComponent, selector: "sie-ui-link", inputs: ["disabled", "disableVisitedStyle", "hasMarginTop", "offsetIcon", "truncate", "inLinkList", "trailingIcon", "icon", "cssClass", "href", "size", "target", "variant", "background", "type", "reference", "screenReaderText", "secondaryLabel", "download", "dataAttributes", "tooltip", "buttonType"], outputs: ["clicked"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTreeNavigationItemComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-tree-navigation-item', changeDetection: ChangeDetectionStrategy.OnPush, template: "<li class=\"tree-item\" *ngIf=\"!!item\" [ngClass]=\"{ truncate: truncateLabels }\" [style.--item-level]=\"itemLevel - 1\">\n  <ng-container *ngIf=\"item.expandable; else linkItem\">\n    <div class=\"tree-item__node-wrapper\" [ngClass]=\"[truncateLabels ? 'truncate' : '']\">\n      <div\n        class=\"tree-item__node--selectable\"\n        [ngClass]=\"{ truncate: truncateLabels }\"\n        [tabindex]=\"item.textOnly ? 0 : -1\"\n        (keydown.enter)=\"toggleSublist($event, item)\"\n      >\n        <div\n          class=\"tree-item__dropdown-icon-wrapper\"\n          [ngClass]=\"{ expanded: item.expanded }\"\n          [tabindex]=\"item.textOnly ? -1 : 0\"\n          (click)=\"toggleSublist($event, item)\"\n          (keydown.enter)=\"toggleSublist($event, item)\"\n        >\n          <sie-icon class=\"tree-item__dropdown-icon\" [name]=\"iconReg.sieIcon.Dropdown\"></sie-icon>\n        </div>\n        <div class=\"tree-item__dropdown-label-wrapper\">\n          <div\n            *ngIf=\"item.textOnly; else collapsableLinkItem\"\n            class=\"tree-item__dropdown-label\"\n            [ngClass]=\"{ truncate: truncateLabels, 'expanded-label': item.expanded }\"\n            (click)=\"toggleSublist($event, item)\"\n            (keydown.enter)=\"toggleSublist($event, item)\"\n          >\n            <ng-template [ngTemplateOutlet]=\"labelAndIcons\"></ng-template>\n          </div>\n        </div>\n      </div>\n    </div>\n  </ng-container>\n</li>\n\n<ng-template #linkItem>\n  <div\n    *ngIf=\"!item.textOnly; else textOnly\"\n    class=\"tree-item__link-wrapper\"\n    [ngClass]=\"[truncateLabels ? 'truncate' : '']\"\n  >\n    <sie-ui-link\n      [truncate]=\"truncateLabels\"\n      type=\"link\"\n      (clicked)=\"onLinkItemClicked($event, item)\"\n      [cssClass]=\"'no-padding tree-link ' + (selected ? 'bold' : '')\"\n      >{{ item?.itemTitle }}</sie-ui-link\n    >\n  </div>\n</ng-template>\n\n<ng-template #textOnly>\n  <div class=\"tree-item__node-wrapper\">\n    <div class=\"tree-item__node--selectable\" [ngClass]=\"{ truncate: truncateLabels }\">\n      <div class=\"tree-item__title-wrapper\">\n        <span\n          class=\"tree-item__title\"\n          [ngClass]=\"{\n            truncate: truncateLabels,\n            bold: selected\n          }\"\n          >{{ item.itemTitle }}</span\n        >\n      </div>\n    </div>\n  </div>\n</ng-template>\n\n<ng-template #collapsableLinkItem>\n  <a\n    rel=\"noopener\"\n    tabindex=\"0\"\n    class=\"tree-item__dropdown-label link\"\n    [ngClass]=\"{ truncate: truncateLabels, 'expanded-label': item.expanded }\"\n    (mousedown)=\"toggleSublistAndItemSelection($event, item)\"\n    (keydown.enter)=\"toggleSublistAndItemSelection($event, item)\"\n  >\n    <ng-template [ngTemplateOutlet]=\"labelAndIcons\"></ng-template>\n  </a>\n</ng-template>\n\n<ng-template #labelAndIcons>\n  <div class=\"tree-item__title-wrapper\">\n    <span\n      class=\"tree-item__title\"\n      [ngClass]=\"{\n        truncate: truncateLabels,\n        bold: selected\n      }\"\n      >{{ item.itemTitle }}</span\n    >\n  </div>\n</ng-template>\n", styles: [".tree-item__node-wrapper .tree-item__node--selectable,.tree-item__node-wrapper .tree-item__dropdown-label,.tree-item__dropdown-icon-wrapper{outline:none;outline-offset:0}@media (pointer: fine){.tree-item__node-wrapper .tree-item__node--selectable,.tree-item__node-wrapper .tree-item__dropdown-label,.tree-item__dropdown-icon-wrapper{position:relative}.tree-item__node-wrapper .tree-item__node--selectable:focus,.tree-item__node-wrapper .tree-item__dropdown-label:focus,.tree-item__dropdown-icon-wrapper:focus{outline:1px solid #1491eb;outline-offset:2px}.tree-item__node-wrapper .tree-item__node--selectable:focus:not(:focus-visible),.tree-item__node-wrapper .tree-item__dropdown-label:focus:not(:focus-visible),.tree-item__dropdown-icon-wrapper:focus:not(:focus-visible){outline:0}.tree-item__node-wrapper .tree-item__node--selectable:focus-visible,.tree-item__node-wrapper .tree-item__dropdown-label:focus-visible,.tree-item__dropdown-icon-wrapper:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}.tree-item{display:flex;box-sizing:border-box;align-items:center;min-width:120px;padding-left:calc(12px * var(--item-level))}.tree-item__link-wrapper{width:100%}.tree-item__dropdown-icon-wrapper{display:inline;position:relative;margin-top:2px;margin-left:1px}.tree-item__dropdown-icon-wrapper:focus-visible{outline-offset:0}.tree-item__dropdown-icon-wrapper .tree-item__dropdown-icon{width:16px;height:16px;display:flex;align-items:center;fill:currentColor;position:relative;transition:transform .12s cubic-bezier(.4,0,.3,1);transform:translateZ(0) rotate(-90deg)}.tree-item__dropdown-icon-wrapper .tree-item__dropdown-icon svg{fill:currentColor;width:inherit;height:inherit}.tree-item__dropdown-icon-wrapper .tree-item__dropdown-icon svg g{fill:currentColor;width:inherit;height:inherit}.tree-item__dropdown-icon-wrapper .tree-item__dropdown-icon svg text{font-family:Siemens Sans,sans-serif}.tree-item__dropdown-icon-wrapper.expanded{color:#000028}.tree-item__dropdown-icon-wrapper.expanded .tree-item__dropdown-icon{transform:translateZ(0) rotate(0)}.tree-item__dropdown-icon-wrapper:hover{cursor:pointer;color:#00646e}.tree-item__dropdown-label.link{color:inherit}.tree-item__node-wrapper{box-sizing:border-box;padding-right:5px;display:flex}.tree-item__node-wrapper.truncate{align-items:center}.tree-item__node-wrapper .tree-item__dropdown-label{display:flex;align-items:center}.tree-item__node-wrapper .tree-item__dropdown-label:hover{text-decoration:underline;cursor:pointer;color:#005159}.tree-item__node-wrapper .tree-item__dropdown-icon-wrapper{outline-offset:0}.tree-item__node-wrapper .tree-item__title{font-size:.875rem;font-weight:400;line-height:1.25rem;margin-left:4px}.tree-item__node-wrapper .tree-item__title.bold{font-weight:700}.tree-item__node-wrapper .tree-item__node{position:relative;min-width:100%;-webkit-user-select:none;user-select:none;display:flex;align-items:flex-start}.tree-item__node-wrapper .tree-item__node.truncate{white-space:nowrap;overflow:hidden;text-overflow:ellipsis;display:block}.tree-item__node-wrapper .tree-item__node:hover{cursor:pointer}.tree-item__node-wrapper .tree-item__node--selectable{display:flex}.tree-item__node-wrapper .tree-item__node--selectable .tree-item__title{min-width:0}.tree-item__node-wrapper .tree-item__node--selectable .tree-item__title-wrapper{display:inline-grid;width:100%}.tree-item__node-wrapper .tree-item__node--selectable .tree-item__title.truncate{white-space:nowrap;overflow:hidden;text-overflow:ellipsis}.tree-item__node-wrapper .tree-item__dropdown-icon-wrapper:has(+.tree-item__dropdown-label-wrapper:hover){color:#005159;fill:#00646e}@media (pointer: coarse){.tree-item .tree-item__dropdown-icon-wrapper .tree-item__dropdown-icon{width:20px;height:20px;display:flex;align-items:center;fill:currentColor}.tree-item .tree-item__dropdown-icon-wrapper .tree-item__dropdown-icon svg{fill:currentColor;width:inherit;height:inherit}.tree-item .tree-item__dropdown-icon-wrapper .tree-item__dropdown-icon svg g{fill:currentColor;width:inherit;height:inherit}.tree-item .tree-item__dropdown-icon-wrapper .tree-item__dropdown-icon svg text{font-family:Siemens Sans,sans-serif}.tree-item .tree-item__link-wrapper{line-height:24px}.tree-item .tree-item__title{font-size:1rem;font-weight:400;line-height:1.5rem;margin-left:6px}}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }]; }, propDecorators: { item: [{
                type: Input
            }], itemLevel: [{
                type: Input
            }], selected: [{
                type: Input
            }], truncateLabels: [{
                type: Input
            }], itemExpanded: [{
                type: Output
            }], itemSelected: [{
                type: Output
            }] } });

class UiTreeNavigationSkeletonComponent {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTreeNavigationSkeletonComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiTreeNavigationSkeletonComponent, selector: "sie-ui-tree-navigation-skeleton", ngImport: i0, template: "<div class=\"tree-navigation-skeleton\" *ngFor=\"let level of [0, 1, 1, 1, 1, 2]\">\n  <ng-container [ngTemplateOutlet]=\"skeleton\" [ngTemplateOutletContext]=\"{ nestedLevel: level }\"> </ng-container>\n</div>\n\n<ng-template #skeleton let-nestedLevel=\"nestedLevel\">\n  <div class=\"tree-navigation-skeleton--inner\" [ngClass]=\"'tree-navigation-skeleton--level' + nestedLevel\">\n    <div class=\"tree-navigation-skeleton__content\">\n      <sie-ui-skeleton class=\"tree-navigation-skeleton__icon\"></sie-ui-skeleton>\n      <sie-ui-skeleton class=\"tree-navigation-skeleton__text\"></sie-ui-skeleton>\n    </div>\n  </div>\n</ng-template>\n", styles: [".tree-navigation-skeleton{width:300px;padding-left:8px}.tree-navigation-skeleton--inner{display:flex;align-items:center;margin-top:4px;margin-bottom:8px}.tree-navigation-skeleton__content,.tree-navigation-skeleton__icon,.tree-navigation-skeleton__text{display:inline-block}.tree-navigation-skeleton__content{height:20px;width:300px}.tree-navigation-skeleton__icon{--ui-skeleton-marginRight: 4px;--ui-skeleton-heigth: 20px;--ui-skeleton-width: 20px;--ui-skeleton-display: inline-block;height:20px}.tree-navigation-skeleton__text{width:calc(100% - 50px);padding-right:16px;margin-left:2px;height:20px}.tree-navigation-skeleton--level1{padding-left:24px}.tree-navigation-skeleton--level2{padding-left:48px}@media (pointer: fine){.tree-navigation-skeleton--inner{margin-bottom:4px}}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "component", type: UiSkeletonComponent, selector: "sie-ui-skeleton", inputs: ["shape", "loadingText", "ariaLabel", "count"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTreeNavigationSkeletonComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-tree-navigation-skeleton', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"tree-navigation-skeleton\" *ngFor=\"let level of [0, 1, 1, 1, 1, 2]\">\n  <ng-container [ngTemplateOutlet]=\"skeleton\" [ngTemplateOutletContext]=\"{ nestedLevel: level }\"> </ng-container>\n</div>\n\n<ng-template #skeleton let-nestedLevel=\"nestedLevel\">\n  <div class=\"tree-navigation-skeleton--inner\" [ngClass]=\"'tree-navigation-skeleton--level' + nestedLevel\">\n    <div class=\"tree-navigation-skeleton__content\">\n      <sie-ui-skeleton class=\"tree-navigation-skeleton__icon\"></sie-ui-skeleton>\n      <sie-ui-skeleton class=\"tree-navigation-skeleton__text\"></sie-ui-skeleton>\n    </div>\n  </div>\n</ng-template>\n", styles: [".tree-navigation-skeleton{width:300px;padding-left:8px}.tree-navigation-skeleton--inner{display:flex;align-items:center;margin-top:4px;margin-bottom:8px}.tree-navigation-skeleton__content,.tree-navigation-skeleton__icon,.tree-navigation-skeleton__text{display:inline-block}.tree-navigation-skeleton__content{height:20px;width:300px}.tree-navigation-skeleton__icon{--ui-skeleton-marginRight: 4px;--ui-skeleton-heigth: 20px;--ui-skeleton-width: 20px;--ui-skeleton-display: inline-block;height:20px}.tree-navigation-skeleton__text{width:calc(100% - 50px);padding-right:16px;margin-left:2px;height:20px}.tree-navigation-skeleton--level1{padding-left:24px}.tree-navigation-skeleton--level2{padding-left:48px}@media (pointer: fine){.tree-navigation-skeleton--inner{margin-bottom:4px}}\n"] }]
        }] });

class UiTreeNavigationItemSkeletonComponent {
    constructor() {
        this.itemLevel = 0;
        this.NUMBER_OF_SKELETONS = 3;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTreeNavigationItemSkeletonComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiTreeNavigationItemSkeletonComponent, selector: "sie-ui-tree-navigation-item-skeleton", inputs: { itemLevel: "itemLevel" }, ngImport: i0, template: "<div class=\"tree-navigation-item-skeleton\" *sieCoreRepeat=\"NUMBER_OF_SKELETONS\">\n  <div class=\"tree-navigation-item-skeleton--inner\">\n    <div class=\"tree-navigation-item-skeleton__content\" [style.--item-level]=\"itemLevel - 1\">\n      <sie-ui-skeleton class=\"tree-navigation-item-skeleton__icon\"></sie-ui-skeleton>\n      <sie-ui-skeleton class=\"tree-navigation-item-skeleton__text\"></sie-ui-skeleton>\n    </div>\n  </div>\n</div>\n", styles: [".tree-navigation-item-skeleton{width:100%;padding-left:8px}.tree-navigation-item-skeleton--inner{display:flex;align-items:center;margin-top:4px;margin-bottom:8px}.tree-navigation-item-skeleton__content,.tree-navigation-item-skeleton__icon,.tree-navigation-item-skeleton__text{display:inline-block}.tree-navigation-item-skeleton__content{height:20px;width:60%;padding-left:calc(12px * var(--item-level))}.tree-navigation-item-skeleton__icon{--ui-skeleton-marginRight: 4px;--ui-skeleton-heigth: 20px;--ui-skeleton-width: 20px;--ui-skeleton-display: inline-block;height:20px}.tree-navigation-item-skeleton__text{width:calc(100% - 50px);padding-right:16px;margin-left:2px;height:20px}@media (pointer: fine){.tree-navigation-item-skeleton--inner{margin-bottom:4px}}\n"], dependencies: [{ kind: "component", type: UiSkeletonComponent, selector: "sie-ui-skeleton", inputs: ["shape", "loadingText", "ariaLabel", "count"] }, { kind: "directive", type: i1$1.RepeatDirective, selector: "[sieCoreRepeat]", inputs: ["sieCoreRepeat"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTreeNavigationItemSkeletonComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-tree-navigation-item-skeleton', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"tree-navigation-item-skeleton\" *sieCoreRepeat=\"NUMBER_OF_SKELETONS\">\n  <div class=\"tree-navigation-item-skeleton--inner\">\n    <div class=\"tree-navigation-item-skeleton__content\" [style.--item-level]=\"itemLevel - 1\">\n      <sie-ui-skeleton class=\"tree-navigation-item-skeleton__icon\"></sie-ui-skeleton>\n      <sie-ui-skeleton class=\"tree-navigation-item-skeleton__text\"></sie-ui-skeleton>\n    </div>\n  </div>\n</div>\n", styles: [".tree-navigation-item-skeleton{width:100%;padding-left:8px}.tree-navigation-item-skeleton--inner{display:flex;align-items:center;margin-top:4px;margin-bottom:8px}.tree-navigation-item-skeleton__content,.tree-navigation-item-skeleton__icon,.tree-navigation-item-skeleton__text{display:inline-block}.tree-navigation-item-skeleton__content{height:20px;width:60%;padding-left:calc(12px * var(--item-level))}.tree-navigation-item-skeleton__icon{--ui-skeleton-marginRight: 4px;--ui-skeleton-heigth: 20px;--ui-skeleton-width: 20px;--ui-skeleton-display: inline-block;height:20px}.tree-navigation-item-skeleton__text{width:calc(100% - 50px);padding-right:16px;margin-left:2px;height:20px}@media (pointer: fine){.tree-navigation-item-skeleton--inner{margin-bottom:4px}}\n"] }]
        }], propDecorators: { itemLevel: [{
                type: Input
            }] } });

class UiTreeNavigationComponent {
    constructor(iconReg, hostElement, cdr) {
        this.iconReg = iconReg;
        this.hostElement = hostElement;
        this.cdr = cdr;
        /**
         * Indicates that the tree is loading and skeletons are shown
         * @default false
         */
        this.treeLoading = false;
        /**
         * Defines whether node labels should be truncated or not
         * @default true
         */
        this.truncateLabels = true;
        /** @ignore internal use only */
        this.root = true;
        /** @ignore internal use only */
        this.hierarchyLevel = 0;
        /**
         * Emits when an expandable node gets expanded
         */
        this.itemExpanded = new EventEmitter();
        /**
         * Emits when an interactable node gets selected
         */
        this.itemSelected = new EventEmitter();
        iconReg.register(SieIcon.Dropdown);
    }
    /** @ignore */
    onItemExpanded(nestedListItem) {
        this.itemExpanded.next(nestedListItem);
    }
    /** @ignore */
    onItemSelectionChanged(treeItem) {
        if (this.root) {
            this.selectedNodeId = treeItem.itemId;
            this.cdr.detectChanges(); // web components don't react to markForCheck ...
        }
        this.itemSelected.next(treeItem);
    }
    /**
     * Allows tree navigation web component to be reloaded from outside component
     */
    reloadComponent() {
        this.cdr.detectChanges();
    }
    /**
     * Allows setting a selected node id, making the node bold and expanding the parent nodes
     * @param nodeId to be selected
     */
    selectNode(nodeId, treeItems) {
        this.selectedNodeId = nodeId;
        this.expandTree(treeItems || this.treeItems);
        this.cdr.detectChanges();
    }
    expandTree(items) {
        for (const item of items) {
            if (item.itemId === this.selectedNodeId) {
                item.expanded = item.expandable;
                return true;
            }
            const children = item.children$?.value;
            const found = !!children && this.expandTree(children);
            if (found) {
                item.expanded = true;
                return true;
            }
        }
        return false;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTreeNavigationComponent, deps: [{ token: i1.SieIconRegistryService }, { token: i0.ElementRef }, { token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiTreeNavigationComponent, selector: "sie-ui-tree-navigation", inputs: { treeLoading: ["treeLoading", "treeLoading", booleanAttribute], truncateLabels: ["truncateLabels", "truncateLabels", booleanAttribute], root: "root", treeItems: "treeItems", selectedNodeId: "selectedNodeId", hierarchyLevel: "hierarchyLevel" }, outputs: { itemExpanded: "itemExpanded", itemSelected: "itemSelected" }, ngImport: i0, template: "<div class=\"tree--outer-wrapper\" [ngClass]=\"{ root: root }\">\n  <div class=\"tree\">\n    <ul class=\"tree-list\">\n      <ng-container *ngIf=\"treeLoading\" [ngTemplateOutlet]=\"loadingSkeleton\"></ng-container>\n      <ng-container *ngFor=\"let item of treeItems; let index = index\">\n        <sie-ui-tree-navigation-item\n          [item]=\"item\"\n          [itemLevel]=\"hierarchyLevel + 1\"\n          (itemExpanded)=\"onItemExpanded($event)\"\n          (itemSelected)=\"onItemSelectionChanged($event)\"\n          [truncateLabels]=\"truncateLabels\"\n          [selected]=\"!!selectedNodeId && selectedNodeId === item?.itemId\"\n        ></sie-ui-tree-navigation-item>\n\n        <ul class=\"tree-list\" *ngIf=\"item.expanded && !!(item.children$ | async)?.length\">\n          <sie-ui-tree-navigation\n            [root]=\"false\"\n            [treeItems]=\"item.children$ | async\"\n            [hierarchyLevel]=\"hierarchyLevel + 1\"\n            (itemExpanded)=\"onItemExpanded($event)\"\n            (itemSelected)=\"onItemSelectionChanged($event)\"\n            [truncateLabels]=\"truncateLabels\"\n            [selectedNodeId]=\"selectedNodeId\"\n          ></sie-ui-tree-navigation>\n        </ul>\n\n        <ng-container\n          *ngIf=\"item.expanded && item.childrenLoading$ | async\"\n          [ngTemplateOutlet]=\"loadingItemsSkeleton\"\n          [ngTemplateOutletContext]=\"{ nestedLevel: 2 }\"\n        >\n        </ng-container>\n      </ng-container>\n    </ul>\n  </div>\n</div>\n\n<ng-template #loadingSkeleton>\n  <sie-ui-tree-navigation-skeleton></sie-ui-tree-navigation-skeleton>\n</ng-template>\n\n<ng-template #loadingItemsSkeleton let-nestedLevel=\"nestedLevel\">\n  <sie-ui-tree-navigation-item-skeleton\n    [itemLevel]=\"hierarchyLevel + nestedLevel\"\n  ></sie-ui-tree-navigation-item-skeleton>\n</ng-template>\n", styles: ["::-webkit-scrollbar-thumb{background-clip:padding-box;background-color:#737389}::-webkit-scrollbar-button{display:none}::-webkit-scrollbar-corner{background-color:transparent}::-webkit-scrollbar{width:16px;height:8px}:host{scrollbar-color:#737389 #fff}:host .dark,:host.dark{scrollbar-color:#ccccd4 #000028}::-webkit-scrollbar-thumb:vertical{border-left:8px solid transparent;border-right:4px solid transparent}::-webkit-scrollbar-thumb:horizontal{border-top:4px solid transparent}::-webkit-scrollbar-track:vertical{border-left:8px solid #fff;background:#ccccd4;border-right:4px solid #fff}::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #ccccd4}.dark::-webkit-scrollbar-thumb,.dark ::-webkit-scrollbar-thumb{background-color:#ccccd4}.dark::-webkit-scrollbar-track:vertical,.dark ::-webkit-scrollbar-track:vertical{background:#737389;border-right:4px solid #000028;border-left:8px solid #000028}.dark::-webkit-scrollbar-track:horizontal,.dark ::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #737389}.tree{min-width:120px}.tree .tree-list{list-style:none;margin:0;display:flex;flex-direction:column;gap:4px;padding:0}@media (pointer: coarse){.tree .tree-list{gap:8px}}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "component", type: UiTreeNavigationComponent, selector: "sie-ui-tree-navigation", inputs: ["treeLoading", "truncateLabels", "root", "treeItems", "selectedNodeId", "hierarchyLevel"], outputs: ["itemExpanded", "itemSelected"] }, { kind: "component", type: UiTreeNavigationItemComponent, selector: "sie-ui-tree-navigation-item", inputs: ["item", "itemLevel", "selected", "truncateLabels"], outputs: ["itemExpanded", "itemSelected"] }, { kind: "component", type: UiTreeNavigationSkeletonComponent, selector: "sie-ui-tree-navigation-skeleton" }, { kind: "component", type: UiTreeNavigationItemSkeletonComponent, selector: "sie-ui-tree-navigation-item-skeleton", inputs: ["itemLevel"] }, { kind: "pipe", type: i2.AsyncPipe, name: "async" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTreeNavigationComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-tree-navigation', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"tree--outer-wrapper\" [ngClass]=\"{ root: root }\">\n  <div class=\"tree\">\n    <ul class=\"tree-list\">\n      <ng-container *ngIf=\"treeLoading\" [ngTemplateOutlet]=\"loadingSkeleton\"></ng-container>\n      <ng-container *ngFor=\"let item of treeItems; let index = index\">\n        <sie-ui-tree-navigation-item\n          [item]=\"item\"\n          [itemLevel]=\"hierarchyLevel + 1\"\n          (itemExpanded)=\"onItemExpanded($event)\"\n          (itemSelected)=\"onItemSelectionChanged($event)\"\n          [truncateLabels]=\"truncateLabels\"\n          [selected]=\"!!selectedNodeId && selectedNodeId === item?.itemId\"\n        ></sie-ui-tree-navigation-item>\n\n        <ul class=\"tree-list\" *ngIf=\"item.expanded && !!(item.children$ | async)?.length\">\n          <sie-ui-tree-navigation\n            [root]=\"false\"\n            [treeItems]=\"item.children$ | async\"\n            [hierarchyLevel]=\"hierarchyLevel + 1\"\n            (itemExpanded)=\"onItemExpanded($event)\"\n            (itemSelected)=\"onItemSelectionChanged($event)\"\n            [truncateLabels]=\"truncateLabels\"\n            [selectedNodeId]=\"selectedNodeId\"\n          ></sie-ui-tree-navigation>\n        </ul>\n\n        <ng-container\n          *ngIf=\"item.expanded && item.childrenLoading$ | async\"\n          [ngTemplateOutlet]=\"loadingItemsSkeleton\"\n          [ngTemplateOutletContext]=\"{ nestedLevel: 2 }\"\n        >\n        </ng-container>\n      </ng-container>\n    </ul>\n  </div>\n</div>\n\n<ng-template #loadingSkeleton>\n  <sie-ui-tree-navigation-skeleton></sie-ui-tree-navigation-skeleton>\n</ng-template>\n\n<ng-template #loadingItemsSkeleton let-nestedLevel=\"nestedLevel\">\n  <sie-ui-tree-navigation-item-skeleton\n    [itemLevel]=\"hierarchyLevel + nestedLevel\"\n  ></sie-ui-tree-navigation-item-skeleton>\n</ng-template>\n", styles: ["::-webkit-scrollbar-thumb{background-clip:padding-box;background-color:#737389}::-webkit-scrollbar-button{display:none}::-webkit-scrollbar-corner{background-color:transparent}::-webkit-scrollbar{width:16px;height:8px}:host{scrollbar-color:#737389 #fff}:host .dark,:host.dark{scrollbar-color:#ccccd4 #000028}::-webkit-scrollbar-thumb:vertical{border-left:8px solid transparent;border-right:4px solid transparent}::-webkit-scrollbar-thumb:horizontal{border-top:4px solid transparent}::-webkit-scrollbar-track:vertical{border-left:8px solid #fff;background:#ccccd4;border-right:4px solid #fff}::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #ccccd4}.dark::-webkit-scrollbar-thumb,.dark ::-webkit-scrollbar-thumb{background-color:#ccccd4}.dark::-webkit-scrollbar-track:vertical,.dark ::-webkit-scrollbar-track:vertical{background:#737389;border-right:4px solid #000028;border-left:8px solid #000028}.dark::-webkit-scrollbar-track:horizontal,.dark ::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #737389}.tree{min-width:120px}.tree .tree-list{list-style:none;margin:0;display:flex;flex-direction:column;gap:4px;padding:0}@media (pointer: coarse){.tree .tree-list{gap:8px}}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }, { type: i0.ElementRef }, { type: i0.ChangeDetectorRef }]; }, propDecorators: { treeLoading: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], truncateLabels: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], root: [{
                type: Input
            }], treeItems: [{
                type: Input
            }], selectedNodeId: [{
                type: Input
            }], hierarchyLevel: [{
                type: Input
            }], itemExpanded: [{
                type: Output
            }], itemSelected: [{
                type: Output
            }] } });

/**
 * # Tree List Module
 * - {@link UiTreeNavigationComponent}
 *
 * ## Module peer dependencies
 * - {@link SieIconsModule}
 * - `@angular/platform-browser/animations/BrowserAnimationsModule`: This module is needed to run the animations
 */
class UiTreeNavigationModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTreeNavigationModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiTreeNavigationModule, declarations: [UiTreeNavigationComponent,
            UiTreeNavigationItemComponent,
            UiTreeNavigationSkeletonComponent,
            UiTreeNavigationItemSkeletonComponent], imports: [CommonModule, SieIconsModule, UiLinkModule, UiSkeletonModule, SieCorePipesModule, RepeatDirective], exports: [UiTreeNavigationComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTreeNavigationModule, imports: [CommonModule, SieIconsModule, UiLinkModule, UiSkeletonModule, SieCorePipesModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTreeNavigationModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        UiTreeNavigationComponent,
                        UiTreeNavigationItemComponent,
                        UiTreeNavigationSkeletonComponent,
                        UiTreeNavigationItemSkeletonComponent
                    ],
                    imports: [CommonModule, SieIconsModule, UiLinkModule, UiSkeletonModule, SieCorePipesModule, RepeatDirective],
                    exports: [UiTreeNavigationComponent]
                }]
        }] });

class UiPeopleListSkeletonComponent {
    constructor() {
        this.skeletonSize = 'small';
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiPeopleListSkeletonComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiPeopleListSkeletonComponent, selector: "sie-ui-people-list-skeleton", inputs: { skeletonSize: "skeletonSize" }, ngImport: i0, template: "<sie-ui-skeleton class=\"people-list-skeleton\" [ngClass]=\"'people-list-skeleton--' + skeletonSize\"></sie-ui-skeleton>\n", styles: [".people-list-skeleton{--skeleton-w: 166px;--skeleton-h: 32px;width:var(--skeleton-w);height:var(--skeleton-h)}.people-list-skeleton--large{--skeleton-w: 242px;--skeleton-h: 48px}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "component", type: UiSkeletonComponent, selector: "sie-ui-skeleton", inputs: ["shape", "loadingText", "ariaLabel", "count"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiPeopleListSkeletonComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-people-list-skeleton', changeDetection: ChangeDetectionStrategy.OnPush, template: "<sie-ui-skeleton class=\"people-list-skeleton\" [ngClass]=\"'people-list-skeleton--' + skeletonSize\"></sie-ui-skeleton>\n", styles: [".people-list-skeleton{--skeleton-w: 166px;--skeleton-h: 32px;width:var(--skeleton-w);height:var(--skeleton-h)}.people-list-skeleton--large{--skeleton-w: 242px;--skeleton-h: 48px}\n"] }]
        }], propDecorators: { skeletonSize: [{
                type: Input
            }] } });

const MAX_ACCOUNTS_TO_DISPLAY = 5;
const NUMBER_OF_ACCOUNTS_TO_DISPLAY_IF_OVERFLOW = 4;
const MAX_NUMBER_TO_DISPLAY_IN_OVERFLOW_BUBBLE = 999;
/**
 * # People List Component
 *
 * People List is used as an optimized experience when interacting with the "People Bubbles".
 *
 * ## Component variations
 *
 * The People List component has no variations.
 *
 * ## Content
 *
 * The People List component does not accept any content.
 *
 * ## Code example
 * @example
 * Template:
 * ```html
 *  <sie-ui-people-list
 *    [accounts]="accountsData"
 *    [size]="'small'"
 *    [forHashing]="'name'"
 *    [count]="'2'"
 *    [countTooltip]="'Anna Adams\nPeter Fox'"
 *    [loading]="false"
 *   ></sie-ui-rich-snippet>
 * ```
 *  ```ts
 * const accountsData = [
 *  {
 *    initials: 'BZ',
 *    name: 'Benno Zerr',
 *    status: 'online'
 *  },
 *  {
 *    initials: 'HH',
 *    name: 'Herbie Hancock',
 *    status: 'neutral',
 *    avatarImage: 'https://sieportaldev.siemens.com/images-support-page/avatar_2.jpg',
 *  }
 * ];
 * ```
 */
class UiPeopleListComponent {
    constructor() {
        /**
         * Defines the {@link UiPeopleListSize size} of People List component.
         * @default 'small'
         */
        this.size = 'small';
        /**
         * Defines if UiPeopleListSkeleton should be displayed.
         * @default false
         */
        this.loading = false;
        /**
         * @param value Defines which {@link UiAccountIdHashingOption attribute} should be used for color hashing to determine the background color of UiAccountIdentifierComponent.
         * @default 'name'
         */
        this.forHashing = 'name';
        /** @ignore */
        this.accountIdSize = 's';
        /** @ignore */
        this.skeletonSize = 'small';
        /** @ignore */
        this.displayOverflowBubble = false;
        this._count = '';
        this._allAccounts = [];
    }
    /**
     * Defines the count number that will be displayed in "Overflow bubble".
     */
    set count(value) {
        if (+value > MAX_NUMBER_TO_DISPLAY_IN_OVERFLOW_BUBBLE) {
            this._count = MAX_NUMBER_TO_DISPLAY_IN_OVERFLOW_BUBBLE.toString();
        }
        else {
            this._count = value;
        }
        this.updateDisplayedAccounts();
    }
    get count() {
        return this._count;
    }
    /**
     * List of {@link UiPeopleListAccount possible items (accounts)} to display.
     * @default []
     */
    set accounts(value) {
        this._allAccounts = value;
        this.updateDisplayedAccounts();
    }
    get accountsDisplay() {
        return this._allAccounts;
    }
    /** @ignore */
    ngOnChanges(changes) {
        if (changes.size) {
            this.accountIdSize = this.mapSizeToAccountIdSize(this.size);
        }
        this.setOverflowBubbleDisplay();
    }
    mapSizeToAccountIdSize(size) {
        switch (size) {
            case 'small':
                return 's';
            case 'large':
                return 'm';
            default:
                return 's';
        }
    }
    updateDisplayedAccounts() {
        const accounts = this._allAccounts;
        if (accounts.length >= MAX_ACCOUNTS_TO_DISPLAY) {
            if (this.count) {
                this._allAccounts = accounts.slice(0, NUMBER_OF_ACCOUNTS_TO_DISPLAY_IF_OVERFLOW);
            }
            else {
                this._allAccounts = accounts.slice(0, MAX_ACCOUNTS_TO_DISPLAY);
            }
        }
        else {
            this._allAccounts = accounts;
        }
    }
    setOverflowBubbleDisplay() {
        this.displayOverflowBubble = this.count && this.accountsDisplay.length >= NUMBER_OF_ACCOUNTS_TO_DISPLAY_IF_OVERFLOW;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiPeopleListComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiPeopleListComponent, selector: "sie-ui-people-list", inputs: { count: ["count", "count", numberAttribute], accounts: "accounts", size: "size", countTooltip: "countTooltip", loading: ["loading", "loading", booleanAttribute], forHashing: "forHashing" }, usesOnChanges: true, ngImport: i0, template: "<sie-ui-people-list-skeleton *ngIf=\"loading; else peopleList\" [skeletonSize]=\"size\"></sie-ui-people-list-skeleton>\n\n<ng-template #peopleList>\n  <div class=\"people-list\" [ngClass]=\"'people-list--' + size\">\n    <div *ngFor=\"let account of accountsDisplay\" class=\"people-list__item people-list__item--account\">\n      <sie-ui-account-identifier\n        [size]=\"accountIdSize\"\n        [forHashing]=\"forHashing\"\n        [initials]=\"account.initials\"\n        [name]=\"account.name\"\n        [avatarImage]=\"account.avatarImage\"\n        [status]=\"account.status\"\n        [variant]=\"'avatar'\"\n        sieUiPopover\n        [popoverPlacement]=\"'bottom-start'\"\n        [popoverSize]=\"'s'\"\n        [content]=\"account.name\"\n      ></sie-ui-account-identifier>\n    </div>\n    <div\n      class=\"people-list__item people-list__item--overflow-bubble\"\n      [ngClass]=\"+count > 9 ? 'small-text' : ''\"\n      *ngIf=\"displayOverflowBubble\"\n      sieUiPopover\n      [popoverPlacement]=\"'bottom-start'\"\n      [popoverSize]=\"'s'\"\n      [content]=\"countTooltip\"\n    >\n      <span>+{{ count }}</span>\n    </div>\n  </div>\n</ng-template>\n", styles: [".people-list{--item-negative-margin: -6px;--item-border-light: #fff;--overflow-bubble-size: 36px;--overflow-bubble-font-size: .75rem;--overflow-bubble-font-size-small: 10px;display:flex}.people-list__item{position:relative;border:2px solid var(--item-border-light);border-radius:50%}.people-list__item:nth-child(0){z-index:6}.people-list__item:nth-child(1){z-index:5}.people-list__item:nth-child(2){z-index:4}.people-list__item:nth-child(3){z-index:3}.people-list__item:nth-child(4){z-index:2}.people-list__item:nth-child(5){z-index:1}.people-list__item:not(:first-child){margin-left:var(--item-negative-margin)}.people-list__item--overflow-bubble{width:var(--overflow-bubble-size);height:var(--overflow-bubble-size);display:flex;flex-shrink:0;justify-content:center;align-items:center;color:#fff;background-color:#7d8099;font-weight:700;font-size:var(--overflow-bubble-font-size)}.people-list__item--overflow-bubble.small-text{font-size:var(--overflow-bubble-font-size-small)}.people-list--large{--item-negative-margin: -10px;--overflow-bubble-size: 52px;--overflow-bubble-font-size: 1rem;--overflow-bubble-font-size-small: .875rem}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: UiAccountIdentifierComponent, selector: "sie-ui-account-identifier", inputs: ["size", "mode", "variant", "status", "name", "initials", "primaryMetaData", "secondaryMetaData", "linkText", "greetings", "searchHighlight", "avatarImage", "badgeData", "networkIcon", "forHashing", "disabled", "interactable"], outputs: ["actionLinkClicked"] }, { kind: "directive", type: UiPopoverDirective, selector: "[sieUiPopover]", inputs: ["content", "popoverTemplate", "popoverSize", "popoverPlacement", "popoverAnimation", "popoverPlayAnimation", "popoverAnimationHideAfterTimeoutMS", "popoverLightTheme"] }, { kind: "component", type: UiPeopleListSkeletonComponent, selector: "sie-ui-people-list-skeleton", inputs: ["skeletonSize"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiPeopleListComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-people-list', changeDetection: ChangeDetectionStrategy.OnPush, template: "<sie-ui-people-list-skeleton *ngIf=\"loading; else peopleList\" [skeletonSize]=\"size\"></sie-ui-people-list-skeleton>\n\n<ng-template #peopleList>\n  <div class=\"people-list\" [ngClass]=\"'people-list--' + size\">\n    <div *ngFor=\"let account of accountsDisplay\" class=\"people-list__item people-list__item--account\">\n      <sie-ui-account-identifier\n        [size]=\"accountIdSize\"\n        [forHashing]=\"forHashing\"\n        [initials]=\"account.initials\"\n        [name]=\"account.name\"\n        [avatarImage]=\"account.avatarImage\"\n        [status]=\"account.status\"\n        [variant]=\"'avatar'\"\n        sieUiPopover\n        [popoverPlacement]=\"'bottom-start'\"\n        [popoverSize]=\"'s'\"\n        [content]=\"account.name\"\n      ></sie-ui-account-identifier>\n    </div>\n    <div\n      class=\"people-list__item people-list__item--overflow-bubble\"\n      [ngClass]=\"+count > 9 ? 'small-text' : ''\"\n      *ngIf=\"displayOverflowBubble\"\n      sieUiPopover\n      [popoverPlacement]=\"'bottom-start'\"\n      [popoverSize]=\"'s'\"\n      [content]=\"countTooltip\"\n    >\n      <span>+{{ count }}</span>\n    </div>\n  </div>\n</ng-template>\n", styles: [".people-list{--item-negative-margin: -6px;--item-border-light: #fff;--overflow-bubble-size: 36px;--overflow-bubble-font-size: .75rem;--overflow-bubble-font-size-small: 10px;display:flex}.people-list__item{position:relative;border:2px solid var(--item-border-light);border-radius:50%}.people-list__item:nth-child(0){z-index:6}.people-list__item:nth-child(1){z-index:5}.people-list__item:nth-child(2){z-index:4}.people-list__item:nth-child(3){z-index:3}.people-list__item:nth-child(4){z-index:2}.people-list__item:nth-child(5){z-index:1}.people-list__item:not(:first-child){margin-left:var(--item-negative-margin)}.people-list__item--overflow-bubble{width:var(--overflow-bubble-size);height:var(--overflow-bubble-size);display:flex;flex-shrink:0;justify-content:center;align-items:center;color:#fff;background-color:#7d8099;font-weight:700;font-size:var(--overflow-bubble-font-size)}.people-list__item--overflow-bubble.small-text{font-size:var(--overflow-bubble-font-size-small)}.people-list--large{--item-negative-margin: -10px;--overflow-bubble-size: 52px;--overflow-bubble-font-size: 1rem;--overflow-bubble-font-size-small: .875rem}\n"] }]
        }], propDecorators: { count: [{
                type: Input,
                args: [{ transform: numberAttribute }]
            }], accounts: [{
                type: Input
            }], size: [{
                type: Input
            }], countTooltip: [{
                type: Input
            }], loading: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], forHashing: [{
                type: Input
            }] } });

/**
 * # PeopleList Module
 * - {@link UiPeopleListComponent}
 *
 * ## Module peer dependencies
 * - {@link SieIconsModule}
 */
class UiPeopleListModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiPeopleListModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiPeopleListModule, declarations: [UiPeopleListComponent, UiPeopleListSkeletonComponent], imports: [CommonModule,
            UiAccountIdentifierModule,
            UiPopoverModule,
            UiSkeletonModule], exports: [UiPeopleListComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiPeopleListModule, imports: [CommonModule,
            UiAccountIdentifierModule,
            UiPopoverModule,
            UiSkeletonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiPeopleListModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiPeopleListComponent, UiPeopleListSkeletonComponent],
                    imports: [
                        CommonModule,
                        UiAccountIdentifierModule,
                        UiPopoverModule,
                        UiSkeletonModule
                    ],
                    exports: [UiPeopleListComponent]
                }]
        }] });

class SieUiModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: SieUiModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: SieUiModule, imports: [UiAccordionModule,
            UiAccountIdentifierModule,
            UiBadgeModule,
            UiButtonGroupModule,
            UiRouteButtonModule,
            UiModalButtonModule, UiButtonModule, UiBypassLinkModule,
            UiCarouselModule,
            UiCheckboxModule,
            UiContactModule,
            UiDrawerModule,
            UiDropdownModule,
            UiEmptyStateModule,
            UiExpandableModule,
            UiExternalHtmlModule,
            UiInterstitialModule,
            UiLinkModule,
            UiListModule,
            UiListNavigatorModule,
            UiListNavigatorHeaderModule,
            UiModalModule,
            UiNumericInputModule,
            UiPaginationModule,
            UiProfileMenuModule,
            UiRadioButtonGroupModule,
            UiRatingStarsModule,
            UiReadonlyModule,
            UiRichtextModule,
            UiUnderlineTooltipModule,
            UiScrollableModule,
            UiSpinnerModule,
            UiProgressSpinnerModule,
            UiTableModule,
            UiTeaserModule,
            UiTreeListModule,
            UiTreeNavigationModule,
            UiOverflowModule,
            UiVideoModalModule,
            UiConfirmationModalModule,
            UiVideoPlayerModule,
            UiActionBarModule,
            UiPopoverModule,
            UiFilterHeaderModule,
            UiCardLandscapeModule,
            UiCardPortraitModule,
            UiCardsArrangementModule,
            UiCardsContainerModule,
            UiBreadcrumbModule,
            UiPromotionExpandableModule,
            UiFeedbackFormModule,
            UiLanguageSelectorModule,
            UiTextInputModule,
            UiPasswordInputModule,
            UiBaseInputModule,
            UiChatBubbleModule,
            UiInfoBoxModule,
            UiChartLegendModule,
            UiStatusBarModule,
            UiNestedListModule,
            UiComplexDropdownModule,
            UiDropdownOptionsModule,
            UiTextareaModule,
            UiComboboxModule,
            UiThumbnailModule,
            UiProgressTrackerModule,
            UiDropZoneModule,
            UiLoadingModule,
            UiProductRecommendationModule,
            UiReplyFormModule,
            UiInfinitePaginationModule,
            UiBarChartModule,
            UiWizardModule,
            UiSwitchButtonGroupModule,
            UiVerticalProgressTrackerModule,
            UiToggleButtonModule,
            UiSidePanelWrapperModule,
            UiIconButtonModule,
            UiLabelBadgeModule,
            UiRichSnippetModule,
            UiPeopleListModule] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: SieUiModule, imports: [UiAccordionModule,
            UiAccountIdentifierModule,
            UiBadgeModule,
            UiButtonGroupModule,
            UiRouteButtonModule,
            UiModalButtonModule,
            UiButtonModule.withWrapperConfig({ route: UiRouteButtonComponent, modal: UiModalButtonComponent }),
            UiBypassLinkModule,
            UiCarouselModule,
            UiCheckboxModule,
            UiContactModule,
            UiDrawerModule,
            UiDropdownModule,
            UiEmptyStateModule,
            UiExpandableModule,
            UiExternalHtmlModule,
            UiInterstitialModule,
            UiLinkModule,
            UiListModule,
            UiListNavigatorModule,
            UiListNavigatorHeaderModule,
            UiModalModule,
            UiNumericInputModule,
            UiPaginationModule,
            UiProfileMenuModule,
            UiRadioButtonGroupModule,
            UiRatingStarsModule,
            UiReadonlyModule,
            UiRichtextModule,
            UiUnderlineTooltipModule,
            UiScrollableModule,
            UiSpinnerModule,
            UiProgressSpinnerModule,
            UiTableModule,
            UiTeaserModule,
            UiTreeListModule,
            UiTreeNavigationModule,
            UiOverflowModule,
            UiVideoModalModule,
            UiConfirmationModalModule,
            UiVideoPlayerModule,
            UiActionBarModule,
            UiPopoverModule,
            UiFilterHeaderModule,
            UiCardLandscapeModule,
            UiCardPortraitModule,
            UiCardsArrangementModule,
            UiCardsContainerModule,
            UiBreadcrumbModule,
            UiPromotionExpandableModule,
            UiFeedbackFormModule,
            UiLanguageSelectorModule,
            UiTextInputModule,
            UiPasswordInputModule,
            UiBaseInputModule,
            UiChatBubbleModule,
            UiInfoBoxModule,
            UiChartLegendModule,
            UiStatusBarModule,
            UiNestedListModule,
            UiComplexDropdownModule,
            UiDropdownOptionsModule,
            UiTextareaModule,
            UiComboboxModule,
            UiThumbnailModule,
            UiProgressTrackerModule,
            UiDropZoneModule,
            UiLoadingModule,
            UiProductRecommendationModule,
            UiReplyFormModule,
            UiInfinitePaginationModule,
            UiBarChartModule,
            UiWizardModule,
            UiSwitchButtonGroupModule,
            UiVerticalProgressTrackerModule,
            UiToggleButtonModule,
            UiSidePanelWrapperModule,
            UiIconButtonModule,
            UiLabelBadgeModule,
            UiRichSnippetModule,
            UiPeopleListModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: SieUiModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        UiAccordionModule,
                        UiAccountIdentifierModule,
                        UiBadgeModule,
                        UiButtonGroupModule,
                        UiRouteButtonModule,
                        UiModalButtonModule,
                        UiButtonModule.withWrapperConfig({ route: UiRouteButtonComponent, modal: UiModalButtonComponent }),
                        UiBypassLinkModule,
                        UiCarouselModule,
                        UiCheckboxModule,
                        UiContactModule,
                        UiDrawerModule,
                        UiDropdownModule,
                        UiEmptyStateModule,
                        UiExpandableModule,
                        UiExternalHtmlModule,
                        UiInterstitialModule,
                        UiLinkModule,
                        UiListModule,
                        UiListNavigatorModule,
                        UiListNavigatorHeaderModule,
                        UiModalModule,
                        UiNumericInputModule,
                        UiPaginationModule,
                        UiProfileMenuModule,
                        UiRadioButtonGroupModule,
                        UiRatingStarsModule,
                        UiReadonlyModule,
                        UiRichtextModule,
                        UiUnderlineTooltipModule,
                        UiScrollableModule,
                        UiSpinnerModule,
                        UiProgressSpinnerModule,
                        UiTableModule,
                        UiTeaserModule,
                        UiTreeListModule,
                        UiTreeNavigationModule,
                        UiOverflowModule,
                        UiVideoModalModule,
                        UiConfirmationModalModule,
                        UiVideoPlayerModule,
                        UiActionBarModule,
                        UiPopoverModule,
                        UiFilterHeaderModule,
                        UiCardLandscapeModule,
                        UiCardPortraitModule,
                        UiCardsArrangementModule,
                        UiCardsContainerModule,
                        UiBreadcrumbModule,
                        UiPromotionExpandableModule,
                        UiFeedbackFormModule,
                        UiLanguageSelectorModule,
                        UiTextInputModule,
                        UiPasswordInputModule,
                        UiBaseInputModule,
                        UiChatBubbleModule,
                        UiInfoBoxModule,
                        UiChartLegendModule,
                        UiStatusBarModule,
                        UiNestedListModule,
                        UiComplexDropdownModule,
                        UiDropdownOptionsModule,
                        UiTextareaModule,
                        UiComboboxModule,
                        UiThumbnailModule,
                        UiProgressTrackerModule,
                        UiDropZoneModule,
                        UiLoadingModule,
                        UiProductRecommendationModule,
                        UiReplyFormModule,
                        UiInfinitePaginationModule,
                        UiBarChartModule,
                        UiWizardModule,
                        UiSwitchButtonGroupModule,
                        UiVerticalProgressTrackerModule,
                        UiToggleButtonModule,
                        UiSidePanelWrapperModule,
                        UiIconButtonModule,
                        UiLabelBadgeModule,
                        UiRichSnippetModule,
                        UiPeopleListModule
                    ],
                    declarations: []
                }]
        }] });

const toggleAnimationTiming1 = `${AnimationDurationFast} ${EasingStandardProductive}`;
function expand(collapsed, expanded) {
    return trigger('expand', [
        state('collapsed', style({ height: collapsed })),
        state('expanded', style({ height: expanded })),
        transition('collapsed <=> expanded', animate(toggleAnimationTiming1))
    ]);
}

// hint: please keep these animations as they're also used outside of SiePortal

var StatusBar;
(function (StatusBar) {
    StatusBar["None"] = "none";
    StatusBar["Int"] = "int";
    StatusBar["Ext"] = "ext";
    StatusBar["IntExt"] = "int-ext";
})(StatusBar || (StatusBar = {}));

class UiBaseRouterDirective {
    constructor(component, router, event) {
        this.component = component;
        this.router = router;
        this.event = event;
        this.subscription = new Subscription();
    }
    preventDefault(event) {
        if (event instanceof Event) {
            event.preventDefault();
        }
    }
    ngOnInit() {
        this.subscription.add(this.event.subscribe((event) => {
            this.preventDefault(event);
            const route = this.extractRoute(event);
            if (route) {
                this.router.navigateByUrl(route);
            }
        }));
    }
    ngOnDestroy() {
        this.subscription.unsubscribe();
        this.subscription = new Subscription();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiBaseRouterDirective, deps: "invalid", target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: UiBaseRouterDirective, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiBaseRouterDirective, decorators: [{
            type: Directive
        }], ctorParameters: function () { return [{ type: undefined }, { type: i2$1.Router }, { type: i2$2.Observable }]; } });

class UiOnPageBreadcrumbComponent {
    constructor(layoutService, cd) {
        this.layoutService = layoutService;
        this.cd = cd;
        this.screenReaderTextHomeButton = '';
        this.clicked = new Subject();
        this.subscriptions = new Subscription();
    }
    ngOnInit() {
        this.updateBreadCrumbVariant();
    }
    ngAfterViewInit() {
        this.subscriptions.add(this.layoutService.resizeEvent.subscribe(() => this.breadcrumbComponent?.rerender()));
        this.subscriptions.add(this.layoutService.breakPointChangedEvent.subscribe(() => this.onBreakpointChange()));
    }
    ngOnDestroy() {
        this.subscriptions.unsubscribe();
    }
    onBreakpointChange() {
        this.updateBreadCrumbVariant();
        this.cd.detectChanges();
    }
    updateBreadCrumbVariant() {
        const currentBreakpoint = this.layoutService.currentBreakpoint;
        this.breadcrumbVariant = 'onlyOneLevel';
        if (Breakpoints.S !== currentBreakpoint && Breakpoints.XS !== currentBreakpoint) {
            this.breadcrumbVariant = 'allWithRoot';
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiOnPageBreadcrumbComponent, deps: [{ token: i1$1.LayoutService }, { token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiOnPageBreadcrumbComponent, selector: "sie-ui-on-page-breadcrumb", inputs: { breadcrumbs: "breadcrumbs", screenReaderTextHomeButton: "screenReaderTextHomeButton" }, outputs: { clicked: "clicked" }, viewQueries: [{ propertyName: "breadcrumbComponent", first: true, predicate: ["breadcrumbComponent"], descendants: true }], ngImport: i0, template: "<sie-ui-breadcrumb\n  #breadcrumbComponent\n  [pageBreadcrumbs]=\"true\"\n  [breadcrumbs]=\"breadcrumbs\"\n  [variant]=\"breadcrumbVariant\"\n  (clicked)=\"clicked.next($event)\"\n  [screenReaderHomeButton]=\"screenReaderTextHomeButton\"\n></sie-ui-breadcrumb>\n", dependencies: [{ kind: "component", type: UiBreadcrumbComponent, selector: "sie-ui-breadcrumb", inputs: ["screenReaderMenuTitle", "screenReaderBackButton", "screenReaderHomeButton", "pageBreadcrumbs", "breadcrumbs", "variant"], outputs: ["clicked"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiOnPageBreadcrumbComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-on-page-breadcrumb', changeDetection: ChangeDetectionStrategy.OnPush, template: "<sie-ui-breadcrumb\n  #breadcrumbComponent\n  [pageBreadcrumbs]=\"true\"\n  [breadcrumbs]=\"breadcrumbs\"\n  [variant]=\"breadcrumbVariant\"\n  (clicked)=\"clicked.next($event)\"\n  [screenReaderHomeButton]=\"screenReaderTextHomeButton\"\n></sie-ui-breadcrumb>\n" }]
        }], ctorParameters: function () { return [{ type: i1$1.LayoutService }, { type: i0.ChangeDetectorRef }]; }, propDecorators: { breadcrumbs: [{
                type: Input
            }], screenReaderTextHomeButton: [{
                type: Input
            }], clicked: [{
                type: Output
            }], breadcrumbComponent: [{
                type: ViewChild,
                args: ['breadcrumbComponent']
            }] } });

/**
 * # Breadcrumb Router Directive
 *
 * Extends {@link UiOnPageBreadcrumbComponent} to provide routing functionality
 *
 * When clicking an item the corresponding `href` attribute is used from the corresponding object
 * {@link UiBreadcrumbModel item}.
 *
 * ## Code example
 * @example ```html
 * <sie-ui-on-page-breadcrumb
 *   sieUiRouted
 *   [breadcrumbs]="breadcrumbs"
 * ></sie-ui-on-page-breadcrumb>
 * ```
 */
class UiOnPageBreadcrumbComponentRouterDirective extends UiBaseRouterDirective {
    constructor(component, router) {
        super(component, router, component.clicked);
        this.component = component;
        this.router = router;
    }
    extractRoute(event) {
        return event.href;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiOnPageBreadcrumbComponentRouterDirective, deps: [{ token: UiOnPageBreadcrumbComponent }, { token: i2$1.Router }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: UiOnPageBreadcrumbComponentRouterDirective, selector: "sie-ui-on-page-breadcrumb[sieUiRouted]", usesInheritance: true, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiOnPageBreadcrumbComponentRouterDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: 'sie-ui-on-page-breadcrumb[sieUiRouted]'
                }]
        }], ctorParameters: function () { return [{ type: UiOnPageBreadcrumbComponent }, { type: i2$1.Router }]; } });

/**
 * # Button Router Directive
 *
 * Extends {@link UiButtonComponent} to provide routing functionality
 *
 * ## Code example
 * @example ```html
 * <sie-ui-button sieUiRouted link="home">Home</sie-ui-button>
 * ```
 */
class UiButtonComponentRouterDirective extends UiBaseRouterDirective {
    constructor(component, router) {
        super(component, router, component.clicked);
        this.component = component;
        this.router = router;
    }
    extractRoute() {
        return this.component.link;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiButtonComponentRouterDirective, deps: [{ token: UiButtonComponent }, { token: i2$1.Router }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: UiButtonComponentRouterDirective, selector: "sie-ui-button[sieUiRouted]", usesInheritance: true, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiButtonComponentRouterDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: 'sie-ui-button[sieUiRouted]'
                }]
        }], ctorParameters: function () { return [{ type: UiButtonComponent }, { type: i2$1.Router }]; } });

/**
 * # Link Router Directive
 *
 * Extends {@link UiLinkComponent} to provide routing functionality
 *
 * ## Code example
 * @example ```html
 * <sie-ui-link sieUiRouted href="home">Home</sie-ui-link>
 * ```
 */
class UiLinkComponentRouterDirective extends UiBaseRouterDirective {
    constructor(component, router) {
        super(component, router, component.clicked);
        this.component = component;
        this.router = router;
    }
    extractRoute() {
        return this.component.href;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiLinkComponentRouterDirective, deps: [{ token: UiLinkComponent }, { token: i2$1.Router }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: UiLinkComponentRouterDirective, selector: "sie-ui-link[sieUiRouted]", usesInheritance: true, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiLinkComponentRouterDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: 'sie-ui-link[sieUiRouted]'
                }]
        }], ctorParameters: function () { return [{ type: UiLinkComponent }, { type: i2$1.Router }]; } });

/**
 * # Nested List Router Directive
 *
 * Extends {@link UiNestedListComponent} to provide routing functionality
 *
 * When clicking an item the corresponding `item.itemLink` attribute is used from the corresponding object
 * {@link UiNestedListLinkItemClicked item}.
 *
 * ## Code example
 * @example ```html
 * <sie-ui-nested-list
 *   sieUiRouted
 *   [nestedListItems]="nestedListItems"
 *   ...
 * ></sie-ui-nested-list>
 * ```
 */
class UiNestedListComponentRouterDirective extends UiBaseRouterDirective {
    constructor(component, router) {
        super(component, router, component.linkItemClicked);
        this.component = component;
        this.router = router;
    }
    preventDefault(event) {
        event.event.preventDefault();
    }
    extractRoute(event) {
        return event.item.itemLink;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiNestedListComponentRouterDirective, deps: [{ token: UiNestedListComponent }, { token: i2$1.Router }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: UiNestedListComponentRouterDirective, selector: "sie-ui-nested-list[sieUiRouted]", usesInheritance: true, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiNestedListComponentRouterDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: 'sie-ui-nested-list[sieUiRouted]'
                }]
        }], ctorParameters: function () { return [{ type: UiNestedListComponent }, { type: i2$1.Router }]; } });

/**
 * # UI Routing Module
 * - {@link UiButtonComponentRouterDirective}
 * - {@link UiLinkComponentRouterDirective}
 * - {@link UiNestedListComponentRouterDirective}
 * - {@link UiOnPageBreadcrumbComponentRouterDirective}
 *
 * ## Module peer dependencies
 * - `@angular/router/RouterModule`: This module is needed for executing the route
 */
class UiRoutingDirectivesModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiRoutingDirectivesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiRoutingDirectivesModule, declarations: [UiOnPageBreadcrumbComponentRouterDirective,
            UiButtonComponentRouterDirective,
            UiLinkComponentRouterDirective,
            UiNestedListComponentRouterDirective], exports: [UiOnPageBreadcrumbComponentRouterDirective,
            UiButtonComponentRouterDirective,
            UiLinkComponentRouterDirective,
            UiNestedListComponentRouterDirective] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiRoutingDirectivesModule }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiRoutingDirectivesModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        UiOnPageBreadcrumbComponentRouterDirective,
                        UiButtonComponentRouterDirective,
                        UiLinkComponentRouterDirective,
                        UiNestedListComponentRouterDirective
                    ],
                    exports: [
                        UiOnPageBreadcrumbComponentRouterDirective,
                        UiButtonComponentRouterDirective,
                        UiLinkComponentRouterDirective,
                        UiNestedListComponentRouterDirective
                    ]
                }]
        }] });

class UiCheckboxMultiOptionComponent {
    constructor() {
        this.value = '';
        this.valueChange = new EventEmitter();
        this.disabled = false;
        this.radios = [];
        this.previousValue = '';
    }
    onCheckboxChange(state) {
        let value = '';
        if (state) {
            value = this.previousValue || this.radios[0].id;
        }
        this.value = value;
        this.valueChange.emit(value);
    }
    onRadioChange(id) {
        this.previousValue = id;
        this.value = id;
        this.valueChange.emit(id);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCheckboxMultiOptionComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiCheckboxMultiOptionComponent, isStandalone: true, selector: "sie-ui-checkbox-multi-option", inputs: { value: "value", id: "id", label: "label", disabled: "disabled", radios: "radios" }, outputs: { valueChange: "valueChange" }, host: { properties: { "class.open": "this.value" } }, ngImport: i0, template: "<sie-ui-checkbox [id]=\"id\" [label]=\"label\" [value]=\"!!value\" (valueChange)=\"onCheckboxChange($event)\"></sie-ui-checkbox>\n\n<sie-ui-radio-button-group\n  class=\"radios\"\n  [radioButtons]=\"radios\"\n  [selectedId]=\"value\"\n  (selectedIdChange)=\"onRadioChange($event)\"\n  [name]=\"\"\n></sie-ui-radio-button-group>\n", styles: [".radios{display:none;transition:height .5s;overflow:hidden;padding:12px 0 12px 31px}:host(.open) .radios{display:block}\n"], dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "ngmodule", type: UiCheckboxModule }, { kind: "component", type: UiCheckboxComponent, selector: "sie-ui-checkbox", inputs: ["id", "checkboxIdToFocus", "indeterminate", "value", "active", "required", "icons", "labelAppendix$"], outputs: ["valueChange"] }, { kind: "ngmodule", type: UiRadioButtonGroupModule }, { kind: "component", type: UiRadioButtonGroupComponent, selector: "sie-ui-radio-button-group", inputs: ["disabled", "selectedId", "radioButtons", "focusRadioButton", "required"], outputs: ["selectedIdChange"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiCheckboxMultiOptionComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-checkbox-multi-option', standalone: true, imports: [CommonModule, UiCheckboxModule, UiRadioButtonGroupModule], changeDetection: ChangeDetectionStrategy.OnPush, template: "<sie-ui-checkbox [id]=\"id\" [label]=\"label\" [value]=\"!!value\" (valueChange)=\"onCheckboxChange($event)\"></sie-ui-checkbox>\n\n<sie-ui-radio-button-group\n  class=\"radios\"\n  [radioButtons]=\"radios\"\n  [selectedId]=\"value\"\n  (selectedIdChange)=\"onRadioChange($event)\"\n  [name]=\"\"\n></sie-ui-radio-button-group>\n", styles: [".radios{display:none;transition:height .5s;overflow:hidden;padding:12px 0 12px 31px}:host(.open) .radios{display:block}\n"] }]
        }], propDecorators: { value: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['class.open']
            }], valueChange: [{
                type: Output
            }], id: [{
                type: Input
            }], label: [{
                type: Input
            }], disabled: [{
                type: Input
            }], radios: [{
                type: Input
            }] } });

const SAVE_BUTTON_ID = 'save';
const CANCEL_BUTTON_ID = 'cancel';
class UiFormModalComponent {
    set hasFooter(value) {
        this._hasFooter = coerceBooleanProperty(value);
    }
    get hasFooter() {
        return this._hasFooter;
    }
    constructor(cdr, layoutService) {
        this.cdr = cdr;
        this.layoutService = layoutService;
        this.size = 'medium';
        this.enableSaveButtonOnUnchangedForm = false;
        this.saveButtonIcon = SieIcon.SieportalSave;
        this.hasFooterContent = false;
        this.stickyFooter = false;
        this.disabled = false;
        this.closable = true;
        this.errorSpacing = 'm';
        this.preventCloseOnSave = false;
        this.preventingCloseOnSave$ = new BehaviorSubject(false);
        this.loading = false;
        this.errorState = false;
        this.customLoadingTemplate = false;
        this._hasFooter = true;
        this.subscriptions = new Subscription();
        this.save = new EventEmitter();
        this.closed = new EventEmitter();
        this.closedFinished = new EventEmitter();
    }
    ngOnDestroy() {
        this.subscriptions.unsubscribe();
    }
    openModal(initialFormValue) {
        this.buttonGroup.buttons = [
            {
                id: SAVE_BUTTON_ID,
                label: this.saveButtonLabel,
                buttonType: 'button',
                icon: this.saveButtonIcon,
                variant: 'secondary',
                disabled: !this.enableSaveButtonOnUnchangedForm,
                withSpinner: true
            },
            {
                id: CANCEL_BUTTON_ID,
                label: this.cancelButtonLabel,
                buttonType: 'button',
                variant: 'tertiary',
                withSpinner: true
            }
        ];
        this.buttonGroup.updateView();
        this.errorState = false;
        this.loading = true;
        this.modal.open();
        this.cdr.detectChanges();
        this.initializeForm(initialFormValue);
    }
    initializeForm(initialFormValue) {
        if (initialFormValue) {
            this.form.resetForm(initialFormValue);
        }
    }
    openModalWithCustomLoading(initialFormValue) {
        this.customLoadingTemplate = true;
        this.openModal(initialFormValue);
    }
    onButtonClick(event) {
        if (event.button.id === CANCEL_BUTTON_ID) {
            this.modal.close();
        }
        else if (event.button.id === SAVE_BUTTON_ID) {
            this.save.next(event);
        }
    }
    setSaveButtonState(data) {
        this.buttonGroup.buttons[0] = { ...this.buttonGroup.buttons[0], ...data };
        this.buttonGroup.updateView();
    }
    formReady() {
        this.loading = false;
        this.customLoadingTemplate = false;
        this.cdr.detectChanges();
        this.subscriptions.unsubscribe();
        this.subscriptions = new Subscription();
        this.subscriptions.add(this.form.statusChanges.subscribe(() => {
            this.onFormChanged();
        }));
    }
    onFormChanged() {
        this.setSaveButtonState({
            disabled: !this.form.dirty || this.form.invalid
        });
        this.cdr.detectChanges();
    }
    startSave() {
        if (this.preventCloseOnSave) {
            this.preventingCloseOnSave$.next(true);
        }
        this.setSaveButtonState({ disabled: true, showSpinner: true });
        this.errorState = false;
        this.cdr.detectChanges();
    }
    cancelSave() {
        if (this.preventCloseOnSave) {
            this.preventingCloseOnSave$.next(false);
        }
        this.setSaveButtonState({ disabled: false, showSpinner: false });
        this.errorState = false;
        this.cdr.detectChanges();
    }
    saveSuccessful() {
        if (this.preventCloseOnSave) {
            this.preventingCloseOnSave$.next(false);
        }
        this.modal.close();
        this.cdr.detectChanges();
    }
    saveUnsuccessful(disabled = false, errorState = true) {
        if (this.preventCloseOnSave) {
            this.preventingCloseOnSave$.next(false);
        }
        this.setSaveButtonState({ disabled, showSpinner: false });
        this.errorState = errorState;
        this.cdr.detectChanges();
    }
    showLoadingState(customLoading) {
        this.loading = true;
        this.customLoadingTemplate = customLoading;
        this.cdr.detectChanges();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiFormModalComponent, deps: [{ token: i0.ChangeDetectorRef }, { token: i1$1.LayoutService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiFormModalComponent, selector: "sie-ui-form-modal", inputs: { size: "size", form: "form", modalId: "modalId", headline: "headline", errorHeadline: "errorHeadline", errorContent: "errorContent", saveButtonLabel: "saveButtonLabel", enableSaveButtonOnUnchangedForm: "enableSaveButtonOnUnchangedForm", saveButtonIcon: "saveButtonIcon", hasAdditionalButton: "hasAdditionalButton", hasFooterContent: "hasFooterContent", stickyFooter: "stickyFooter", disabled: "disabled", cancelButtonLabel: "cancelButtonLabel", closable: "closable", errorSpacing: "errorSpacing", hasFooter: "hasFooter", preventCloseOnSave: "preventCloseOnSave" }, outputs: { save: "save", closed: "closed", closedFinished: "closedFinished" }, viewQueries: [{ propertyName: "modal", first: true, predicate: ["modal"], descendants: true }, { propertyName: "buttonGroup", first: true, predicate: ["buttonGroup"], descendants: true }], ngImport: i0, template: "<sie-ui-modal\n  [identifier]=\"modalId || 'form-modal'\"\n  [headline]=\"headline\"\n  [closable]=\"closable && !loading\"\n  [modalEscapable]=\"!loading && (preventingCloseOnSave$ | async) === false\"\n  [escapable]=\"!loading && (preventingCloseOnSave$ | async) === false\"\n  [dismissable]=\"!loading && (preventingCloseOnSave$ | async) === false\"\n  [closeButtonDisabled]=\"preventingCloseOnSave$ | async\"\n  [hasHeaderContent]=\"errorState\"\n  [size]=\"size\"\n  [hasFooter]=\"hasFooter\"\n  (onAnyCloseEvent)=\"closed.next()\"\n  (onAnyCloseEventFinished)=\"closedFinished.next()\"\n  [screenReaderCloseIcon]=\"cancelButtonLabel\"\n  [stickyFooter]=\"stickyFooter\"\n  #modal\n>\n  <div header-content>\n    <sie-ui-message-box\n      [ngClass]=\"['form-modal__error-box__spacing', 'form-modal__error-box__spacing--' + errorSpacing]\"\n      [headline]=\"errorHeadline\"\n      [closeable]=\"false\"\n      [variant]=\"'error'\"\n      [message]=\"errorContent\"\n    >\n    </sie-ui-message-box>\n  </div>\n  <div content class=\"content\">\n    <ng-container *ngIf=\"loading; else content\">\n      <ng-container *ngIf=\"customLoadingTemplate\">\n        <ng-content select=\"[loading-content]\"></ng-content>\n      </ng-container>\n      <div class=\"spinner-container\" *ngIf=\"!customLoadingTemplate\">\n        <sie-ui-spinner [active]=\"true\"></sie-ui-spinner>\n      </div>\n    </ng-container>\n    <ng-template #content>\n      <ng-content></ng-content>\n    </ng-template>\n  </div>\n  <div footer class=\"form-modal__footer\" [ngClass]=\"{ 'form-modal__footer--has-footer-content': hasFooterContent }\">\n    <ng-container *ngIf=\"hasFooterContent\">\n      <ng-content select=\"[slot=footer-content]\"></ng-content>\n    </ng-container>\n\n    <ng-container *ngIf=\"hasAdditionalButton\">\n      <ng-content select=\"[slot=single-button]\"></ng-content>\n    </ng-container>\n    <sie-ui-button-group\n      class=\"form-modal__buttons\"\n      [buttonAlignmentClass]=\"'right'\"\n      [fullWidthOnViewportS]=\"true\"\n      [wrapButtons]=\"true\"\n      (buttonClick)=\"onButtonClick($event)\"\n      [flexDirection]=\"\n        hasAdditionalButton && (layoutService.currentViewportObj$ | async | viewport : 'is' : 'S') ? 'column' : 'row'\n      \"\n      #buttonGroup\n    >\n    </sie-ui-button-group>\n  </div>\n</sie-ui-modal>\n", styles: [".spinner-container{display:flex;align-items:center;justify-content:center;min-height:300px;width:100%}.form-modal__error-box__spacing{display:flex}.form-modal__error-box__spacing--l{margin-top:15px}.form-modal__footer{display:flex}@media (max-width: 639.78px){.form-modal__footer{flex-direction:column-reverse}}.form-modal__footer--has-footer-content{flex-direction:column}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: UiModalComponent, selector: "sie-ui-modal", inputs: ["size", "headline", "headlineVariant", "screenReaderCloseIcon", "hasHeaderContent", "hasFooter", "closeButtonDisabled", "fullWidth", "fullScreenMobile", "stickyFooter"], outputs: ["scrolled"] }, { kind: "component", type: UiButtonGroupComponent, selector: "sie-ui-button-group", inputs: ["buttons", "fullWidthOnViewportS", "wrapButtons", "direction", "flexDirection", "fullWidth", "buttonAlignmentClass"], outputs: ["buttonClick"] }, { kind: "component", type: UiSpinnerComponent, selector: "sie-ui-spinner", inputs: ["size", "message", "overlayOnTop", "overlay", "active"], outputs: ["animationEnded"] }, { kind: "component", type: UiMessageBoxComponent, selector: "sie-ui-message-box", inputs: ["type", "headline", "message", "headlineCollapsed", "headlineExpanded", "limit", "link", "playAnimation", "screenReaderCloseIcon", "elementsLayout", "fadeInAnimation", "actionButtonLabel", "actionButtonLink", "secondaryActionButtonLabel", "variant", "closeable", "containerStyled"], outputs: ["actionTriggered", "messageClosed", "messageClosing", "messageLinkTriggered"] }, { kind: "pipe", type: i2.AsyncPipe, name: "async" }, { kind: "pipe", type: i1$1.ViewportPipe, name: "viewport" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiFormModalComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-form-modal', changeDetection: ChangeDetectionStrategy.OnPush, template: "<sie-ui-modal\n  [identifier]=\"modalId || 'form-modal'\"\n  [headline]=\"headline\"\n  [closable]=\"closable && !loading\"\n  [modalEscapable]=\"!loading && (preventingCloseOnSave$ | async) === false\"\n  [escapable]=\"!loading && (preventingCloseOnSave$ | async) === false\"\n  [dismissable]=\"!loading && (preventingCloseOnSave$ | async) === false\"\n  [closeButtonDisabled]=\"preventingCloseOnSave$ | async\"\n  [hasHeaderContent]=\"errorState\"\n  [size]=\"size\"\n  [hasFooter]=\"hasFooter\"\n  (onAnyCloseEvent)=\"closed.next()\"\n  (onAnyCloseEventFinished)=\"closedFinished.next()\"\n  [screenReaderCloseIcon]=\"cancelButtonLabel\"\n  [stickyFooter]=\"stickyFooter\"\n  #modal\n>\n  <div header-content>\n    <sie-ui-message-box\n      [ngClass]=\"['form-modal__error-box__spacing', 'form-modal__error-box__spacing--' + errorSpacing]\"\n      [headline]=\"errorHeadline\"\n      [closeable]=\"false\"\n      [variant]=\"'error'\"\n      [message]=\"errorContent\"\n    >\n    </sie-ui-message-box>\n  </div>\n  <div content class=\"content\">\n    <ng-container *ngIf=\"loading; else content\">\n      <ng-container *ngIf=\"customLoadingTemplate\">\n        <ng-content select=\"[loading-content]\"></ng-content>\n      </ng-container>\n      <div class=\"spinner-container\" *ngIf=\"!customLoadingTemplate\">\n        <sie-ui-spinner [active]=\"true\"></sie-ui-spinner>\n      </div>\n    </ng-container>\n    <ng-template #content>\n      <ng-content></ng-content>\n    </ng-template>\n  </div>\n  <div footer class=\"form-modal__footer\" [ngClass]=\"{ 'form-modal__footer--has-footer-content': hasFooterContent }\">\n    <ng-container *ngIf=\"hasFooterContent\">\n      <ng-content select=\"[slot=footer-content]\"></ng-content>\n    </ng-container>\n\n    <ng-container *ngIf=\"hasAdditionalButton\">\n      <ng-content select=\"[slot=single-button]\"></ng-content>\n    </ng-container>\n    <sie-ui-button-group\n      class=\"form-modal__buttons\"\n      [buttonAlignmentClass]=\"'right'\"\n      [fullWidthOnViewportS]=\"true\"\n      [wrapButtons]=\"true\"\n      (buttonClick)=\"onButtonClick($event)\"\n      [flexDirection]=\"\n        hasAdditionalButton && (layoutService.currentViewportObj$ | async | viewport : 'is' : 'S') ? 'column' : 'row'\n      \"\n      #buttonGroup\n    >\n    </sie-ui-button-group>\n  </div>\n</sie-ui-modal>\n", styles: [".spinner-container{display:flex;align-items:center;justify-content:center;min-height:300px;width:100%}.form-modal__error-box__spacing{display:flex}.form-modal__error-box__spacing--l{margin-top:15px}.form-modal__footer{display:flex}@media (max-width: 639.78px){.form-modal__footer{flex-direction:column-reverse}}.form-modal__footer--has-footer-content{flex-direction:column}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i1$1.LayoutService }]; }, propDecorators: { modal: [{
                type: ViewChild,
                args: ['modal']
            }], buttonGroup: [{
                type: ViewChild,
                args: ['buttonGroup']
            }], size: [{
                type: Input
            }], form: [{
                type: Input
            }], modalId: [{
                type: Input
            }], headline: [{
                type: Input
            }], errorHeadline: [{
                type: Input
            }], errorContent: [{
                type: Input
            }], saveButtonLabel: [{
                type: Input
            }], enableSaveButtonOnUnchangedForm: [{
                type: Input
            }], saveButtonIcon: [{
                type: Input
            }], hasAdditionalButton: [{
                type: Input
            }], hasFooterContent: [{
                type: Input
            }], stickyFooter: [{
                type: Input
            }], disabled: [{
                type: Input
            }], cancelButtonLabel: [{
                type: Input
            }], closable: [{
                type: Input
            }], errorSpacing: [{
                type: Input
            }], hasFooter: [{
                type: Input
            }], preventCloseOnSave: [{
                type: Input
            }], save: [{
                type: Output
            }], closed: [{
                type: Output
            }], closedFinished: [{
                type: Output
            }] } });

class UiFormModalModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiFormModalModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiFormModalModule, declarations: [UiFormModalComponent], imports: [CommonModule,
            UiModalModule,
            UiButtonGroupModule,
            UiSpinnerModule,
            UiMessageBoxModule,
            UiButtonModule,
            SieCorePipesModule], exports: [UiFormModalComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiFormModalModule, imports: [CommonModule,
            UiModalModule,
            UiButtonGroupModule,
            UiSpinnerModule,
            UiMessageBoxModule,
            UiButtonModule,
            SieCorePipesModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiFormModalModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiFormModalComponent],
                    imports: [
                        CommonModule,
                        UiModalModule,
                        UiButtonGroupModule,
                        UiSpinnerModule,
                        UiMessageBoxModule,
                        UiButtonModule,
                        SieCorePipesModule
                    ],
                    exports: [UiFormModalComponent]
                }]
        }] });

const toggleAnimationTiming = AnimationDurationNormal + ' ' + EasingStandardExpressive;
const minheight = ComponentHeaderHeightMin;
const toggleHeaderAnimation = trigger('toggleHeader', [
    transition('false => true', [
        animate(toggleAnimationTiming, keyframes([style({ height: '{{height}}' }), style({ height: minheight })]))
    ]),
    transition('true => false', [
        group([
            animate(toggleAnimationTiming, keyframes([style({ height: minheight }), style({ height: '{{height}}' })])),
            query('.header__bottom, .header__top', [
                animate(AnimationDurationSlow, keyframes([style({ opacity: 0 }), style({ opacity: 1 })]))
            ])
        ])
    ])
]);

class UiHeaderComponent {
    constructor(cdr, layoutService, iconReg, localeService) {
        this.cdr = cdr;
        this.layoutService = layoutService;
        this.iconReg = iconReg;
        this.localeService = localeService;
        this.isMinimized = false;
        this.isNavigationOverlayOpen = false;
        this.shouldScrollInOverlay = false;
        this.isLoggedIn = false;
        this.screenReaderCloseIcon = '';
        this.quoteModeDismiss = new EventEmitter();
        this.regionalMessageClosed = new EventEmitter();
        this.contentHeight$ = new BehaviorSubject(ComponentHeaderHeightS);
        this.messageBoxHeight$ = new BehaviorSubject('0px');
        this.isMinimizedAfterAnimation = false;
    }
    ngOnInit() {
        this.breakpointChangeSub = this.layoutService.breakPointChangedEvent.subscribe(() => {
            this.calculateHeaderHeight();
            this.cdr.detectChanges();
        });
        this.calculateHeaderHeight();
    }
    ngOnDestroy() {
        this.breakpointChangeSub?.unsubscribe();
    }
    ngAfterViewInit() {
        const observer = new ResizeObserver(() => {
            this.debouncedCheckNavigationPosition();
        });
        observer.observe(this.messageBoxComponentContainer.nativeElement);
    }
    ngOnChanges(changes) {
        if (changes.isNavigationOverlayOpen || changes.shouldScrollInOverlay) {
            this.checkNavigationPosition();
        }
    }
    onAnimationEvent() {
        this.isMinimizedAfterAnimation = this.isMinimized;
    }
    calculateHeaderHeight() {
        if (this.layoutService.isBreakpoint(Breakpoints.XS, Breakpoints.S, Breakpoints.M)) {
            this.headerHeightValue = ComponentHeaderHeightS;
        }
        else {
            this.headerHeightValue = ComponentHeaderHeightL;
        }
        this.checkNavigationPosition();
    }
    onMaintenanceMessageClose() {
        sessionStorage.setItem(UIConstants.SESSION_NAME_MAINTENANCE_BOX, 'true');
        this.maintenanceMessage = '';
    }
    onRegionalMessageClose() {
        this.regionalMessageClosed.emit();
    }
    onQuotesMessageDismiss() {
        sessionStorage.setItem(UIConstants.SESSION_NAME_QUOTES_BOX, 'true');
        this.quoteModeDismiss.emit();
    }
    debouncedCheckNavigationPosition() {
        this.checkNavigationPosition();
    }
    checkNavigationPosition() {
        if (this.messageBoxComponentContainer) {
            const headerHeight = parseInt(this.headerHeightValue.replace('px', ''), 10);
            const messageBoxHeight = this.messageBoxComponentContainer.nativeElement.offsetHeight;
            if (!this.shouldScrollInOverlay && this.isNavigationOverlayOpen) {
                this.messageBoxHeight$.next('0px');
                this.contentHeight$.next('0px');
            }
            else {
                this.messageBoxHeight$.next(`${this.messageBoxComponentContainer.nativeElement.offsetHeight}px`);
                this.contentHeight$.next(`${headerHeight + messageBoxHeight}px`);
            }
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiHeaderComponent, deps: [{ token: i0.ChangeDetectorRef }, { token: i1$1.LayoutService }, { token: i1.SieIconRegistryService }, { token: i1$1.LocaleService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiHeaderComponent, selector: "sie-ui-header", inputs: { homeUrl: "homeUrl", isMinimized: "isMinimized", isNavigationOverlayOpen: "isNavigationOverlayOpen", shouldScrollInOverlay: "shouldScrollInOverlay", isLoggedIn: "isLoggedIn", platformName: "platformName", logoNameSR: "logoNameSR", maintenanceMessage: "maintenanceMessage", regionalMessage: "regionalMessage", screenReaderCloseIcon: "screenReaderCloseIcon", quoteMode: "quoteMode" }, outputs: { quoteModeDismiss: "quoteModeDismiss", regionalMessageClosed: "regionalMessageClosed" }, viewQueries: [{ propertyName: "messageBoxComponentContainer", first: true, predicate: ["messageBoxComponentContainer"], descendants: true }], usesOnChanges: true, ngImport: i0, template: "<div\n  class=\"header-background\"\n  [ngClass]=\"!shouldScrollInOverlay && isNavigationOverlayOpen ? 'not-sticky' : ''\"\n  [ngStyle]=\"{ height: contentHeight$ | async }\"\n></div>\n<div class=\"message-box-container\" [ngClass]=\"[!shouldScrollInOverlay && isNavigationOverlayOpen ? 'not-sticky' : '']\">\n  <div class=\"message-box\" #messageBoxComponentContainer>\n    <div class=\"message-box-warning\">\n      <div class=\"container\">\n        <sie-ui-message-box\n          *ngIf=\"maintenanceMessage\"\n          (messageClosed)=\"onMaintenanceMessageClose()\"\n          [variant]=\"'warning'\"\n          [message]=\"maintenanceMessage\"\n          [screenReaderCloseIcon]=\"screenReaderCloseIcon\"\n        >\n        </sie-ui-message-box>\n      </div>\n    </div>\n    <div class=\"message-box-warning\">\n      <div class=\"container\">\n        <sie-ui-message-box\n          *ngIf=\"regionalMessage && !maintenanceMessage\"\n          (messageClosed)=\"onRegionalMessageClose()\"\n          [variant]=\"'warning'\"\n          [message]=\"regionalMessage\"\n          [screenReaderCloseIcon]=\"screenReaderCloseIcon\"\n        >\n        </sie-ui-message-box>\n      </div>\n    </div>\n    <div class=\"message-box-info\">\n      <div class=\"container\">\n        <sie-ui-message-box\n          *ngIf=\"quoteMode?.active\"\n          (actionTriggered)=\"onQuotesMessageDismiss()\"\n          [message]=\"quoteMode?.message\"\n          [actionButtonLabel]=\"quoteMode?.button\"\n          [type]=\"'condensed'\"\n          [closeable]=\"false\"\n          [variant]=\"'info'\"\n          [screenReaderCloseIcon]=\"screenReaderCloseIcon\"\n        >\n        </sie-ui-message-box>\n      </div>\n    </div>\n  </div>\n</div>\n<div\n  class=\"header\"\n  [ngClass]=\"[\n    isMinimizedAfterAnimation ? 'mini-header' : 'max-header',\n    !shouldScrollInOverlay && isNavigationOverlayOpen ? 'not-sticky' : ''\n  ]\"\n  [ngStyle]=\"{ top: messageBoxHeight$ | async }\"\n  [@toggleHeader]=\"{ value: isMinimized, params: { height: headerHeightValue } }\"\n  (@toggleHeader.start)=\"onAnimationEvent()\"\n  data-ste-section=\"header\"\n>\n  <div class=\"container header__content\">\n    <div class=\"header__top\">\n      <div class=\"header__logo\" data-ste-component=\"logo\">\n        <a class=\"header__link\" [routerLink]=\"localeService.homeLink\">\n          <sie-icon class=\"header__logo__icon\" [name]=\"iconReg.sieIcon.SieLogoWhiteRgb\" aria-hidden=\"true\"></sie-icon>\n          <span class=\"visually-hidden\">{{ logoNameSR }}</span>\n        </a>\n      </div>\n      <h1 class=\"header__platform-name\" data-ste-component=\"platform-link\">\n        <a class=\"header__link\" [routerLink]=\"localeService.homeLink\">{{ platformName }}</a>\n      </h1>\n      <div\n        class=\"header__search\"\n        *ngIf=\"layoutService.isViewport('L', 'XL', 'XXL') && !isMinimized\"\n        data-ste-component=\"search\"\n      >\n        <ng-container *ngTemplateOutlet=\"headerSearch\"></ng-container>\n      </div>\n      <div\n        class=\"header__quick-access\"\n        *ngIf=\"!isMinimized\"\n        [ngClass]=\"{ login: !isLoggedIn }\"\n        data-ste-component=\"quick-access\"\n      >\n        <ng-container *ngTemplateOutlet=\"headerQuickAccess\"></ng-container>\n      </div>\n    </div>\n\n    <div class=\"header__bottom\">\n      <div class=\"header__main-navigation\">\n        <ng-content select=\"[main-navigation]\"></ng-content>\n      </div>\n      <div class=\"header__search\" *ngIf=\"layoutService.isViewport('S', 'M') || isMinimized\">\n        <ng-container *ngTemplateOutlet=\"headerSearch\"></ng-container>\n      </div>\n      <div class=\"header__quick-access\" *ngIf=\"isMinimized\" [ngClass]=\"{ login: !isLoggedIn }\">\n        <ng-container *ngTemplateOutlet=\"headerQuickAccess\"></ng-container>\n      </div>\n    </div>\n  </div>\n</div>\n<ng-template #headerSearch>\n  <ng-content select=\"[header-search]\"></ng-content>\n</ng-template>\n\n<ng-template #headerQuickAccess>\n  <ng-content select=\"[header-quick-access]\"></ng-content>\n</ng-template>\n", styles: [".header__link{outline:none;outline-offset:0}@media (pointer: fine){.header__link{position:relative}.header__link:focus{outline:1px solid #1491eb;outline-offset:2px}.header__link:focus:not(:focus-visible){outline:0}.header__link:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}.header-background{display:block}@media print{.header-background{display:none}}.header-background.not-sticky{display:none}.message-box-container{position:fixed;top:0;left:0;right:0;z-index:998}@media print{.message-box-container{display:none}}.message-box-container.not-sticky{position:relative}.message-box{display:flex;flex-direction:column}.message-box-warning{background:#fff7d2}.message-box-info{background:#e0f1f4}.header{display:flex;justify-content:space-between;position:fixed;left:0;right:0;z-index:998;padding:8px 0 12px;background-color:#000028}@media (min-width: 1024px){.header{padding:22px 0}}@media print{.header{top:0!important}}.header.not-sticky{position:relative}@media screen{.header.mini-header{height:50px;padding:0}}@media print{.header.mini-header{height:-moz-fit-content;height:fit-content;margin-top:22px;margin-bottom:16px;position:relative}}.header__top,.header__bottom{width:100%;display:flex;flex-direction:row;justify-content:space-between}@media print{.header__top,.header__bottom{width:215px}}@media print{.header__bottom{display:none}}.header__content{display:flex;flex-direction:column}@media screen{.mini-header .header__content{height:100%;align-items:center;justify-content:center}.mini-header .header__content .header__bottom{align-items:center}}.header.max-header{height:119px}@media (min-width: 1024px){.header.max-header{height:129px}}@media print{.header.max-header{height:-moz-fit-content;height:fit-content;margin-top:22px;position:relative}}.header.max-header .header__content .header__top{margin-bottom:11px}.header__link,.header__link:hover,.header__link:active{text-decoration:none;color:#fff;display:block}.header__logo{height:21px;width:120px;margin-top:12px}@media (min-width: 640px){.header__logo{margin-top:10px}}@media (min-width: 1024px){.header__logo{margin-top:8px}}.header__logo__icon{width:120px;height:21px;display:flex;align-items:center;fill:currentColor}.header__logo__icon svg{fill:currentColor;width:inherit;height:inherit}.header__logo__icon svg g{fill:currentColor;width:inherit;height:inherit}.header__logo__icon svg text{font-family:Siemens Sans,sans-serif}.max-header .header__logo{display:block}@media screen{.mini-header .header__logo{display:none}}.header__logo .header__link{line-height:0}.header__quick-access{z-index:3;display:flex;flex-direction:row;align-items:center;justify-content:center;height:44px;margin-left:auto}@media print{.header__quick-access{display:none}}@media (min-width: 1024px){.header__quick-access{margin-left:40px;margin-bottom:0}.mini-header .header__quick-access{display:flex;flex-direction:row;align-items:center;justify-content:center;margin-left:2px}.mini-header .header__quick-access sie-ui-button{margin-top:2px}}@media (min-width: 1440px){.header__quick-access{margin-left:54px}}.header__quick-access:active:not(:disabled):not(.hover-disabled),.header__quick-access:hover:not(:disabled):not(.hover-disabled){cursor:pointer}.header__quick-access.login{margin-right:-8px}.header__quick-access sie-ui-button{height:44px}.header__platform-name{font-size:1.125rem;font-weight:400;line-height:1.5rem;margin:13px 0 0 14px;color:#fff;letter-spacing:normal}@media (min-width: 640px){.header__platform-name{margin:13px 24px 0 40px}}@media (min-width: 1024px){.header__platform-name{margin:10px 64px 0}}@media (min-width: 1440px){.header__platform-name{margin:10px 80px 0 64px}}@media screen{.max-header .header__platform-name{display:none}}@media screen and (min-width: 640px){.max-header .header__platform-name{display:block}}@media screen{.mini-header .header__platform-name{display:none}}.header__platform-name+.header__quick-access{margin-left:auto}.header__group{display:flex}.header__search{flex:1 1 280px;margin-left:auto;max-width:640px;width:100%}@media (min-width: 640px) and (max-width: 1023.8px){.header__search{max-width:calc(50% - 8px)}}@media (min-width: 1024px){.header__search{margin-top:2px}}@media all and (-ms-high-contrast: none),(-ms-high-contrast: active){.header__search{flex-grow:0}}@media print{.header__search{display:none}}.mini-header .header__search{display:flex;flex-direction:row;align-items:center;justify-content:center;justify-content:flex-end}.header__main-navigation{display:flex;align-items:center;margin:0 22px 0 -8px}@media (min-width: 640px){.header__main-navigation{flex:1}}@media (min-width: 1024px){.header__main-navigation{margin:0}}.header__main-navigation app-navigation{display:block;width:100%}.max-header .header__main-navigation{height:38px}@media (min-width: 1024px){.max-header .header__main-navigation{margin-top:auto}}.mini-header .header__main-navigation{height:100%}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: i2.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "directive", type: i2$1.RouterLink, selector: "[routerLink]", inputs: ["target", "queryParams", "fragment", "queryParamsHandling", "state", "relativeTo", "preserveFragment", "skipLocationChange", "replaceUrl", "routerLink"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "component", type: UiMessageBoxComponent, selector: "sie-ui-message-box", inputs: ["type", "headline", "message", "headlineCollapsed", "headlineExpanded", "limit", "link", "playAnimation", "screenReaderCloseIcon", "elementsLayout", "fadeInAnimation", "actionButtonLabel", "actionButtonLink", "secondaryActionButtonLabel", "variant", "closeable", "containerStyled"], outputs: ["actionTriggered", "messageClosed", "messageClosing", "messageLinkTriggered"] }, { kind: "pipe", type: i2.AsyncPipe, name: "async" }], animations: [toggleHeaderAnimation], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
__decorate([
    Debounce(50)
], UiHeaderComponent.prototype, "debouncedCheckNavigationPosition", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiHeaderComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-header', animations: [toggleHeaderAnimation], changeDetection: ChangeDetectionStrategy.OnPush, template: "<div\n  class=\"header-background\"\n  [ngClass]=\"!shouldScrollInOverlay && isNavigationOverlayOpen ? 'not-sticky' : ''\"\n  [ngStyle]=\"{ height: contentHeight$ | async }\"\n></div>\n<div class=\"message-box-container\" [ngClass]=\"[!shouldScrollInOverlay && isNavigationOverlayOpen ? 'not-sticky' : '']\">\n  <div class=\"message-box\" #messageBoxComponentContainer>\n    <div class=\"message-box-warning\">\n      <div class=\"container\">\n        <sie-ui-message-box\n          *ngIf=\"maintenanceMessage\"\n          (messageClosed)=\"onMaintenanceMessageClose()\"\n          [variant]=\"'warning'\"\n          [message]=\"maintenanceMessage\"\n          [screenReaderCloseIcon]=\"screenReaderCloseIcon\"\n        >\n        </sie-ui-message-box>\n      </div>\n    </div>\n    <div class=\"message-box-warning\">\n      <div class=\"container\">\n        <sie-ui-message-box\n          *ngIf=\"regionalMessage && !maintenanceMessage\"\n          (messageClosed)=\"onRegionalMessageClose()\"\n          [variant]=\"'warning'\"\n          [message]=\"regionalMessage\"\n          [screenReaderCloseIcon]=\"screenReaderCloseIcon\"\n        >\n        </sie-ui-message-box>\n      </div>\n    </div>\n    <div class=\"message-box-info\">\n      <div class=\"container\">\n        <sie-ui-message-box\n          *ngIf=\"quoteMode?.active\"\n          (actionTriggered)=\"onQuotesMessageDismiss()\"\n          [message]=\"quoteMode?.message\"\n          [actionButtonLabel]=\"quoteMode?.button\"\n          [type]=\"'condensed'\"\n          [closeable]=\"false\"\n          [variant]=\"'info'\"\n          [screenReaderCloseIcon]=\"screenReaderCloseIcon\"\n        >\n        </sie-ui-message-box>\n      </div>\n    </div>\n  </div>\n</div>\n<div\n  class=\"header\"\n  [ngClass]=\"[\n    isMinimizedAfterAnimation ? 'mini-header' : 'max-header',\n    !shouldScrollInOverlay && isNavigationOverlayOpen ? 'not-sticky' : ''\n  ]\"\n  [ngStyle]=\"{ top: messageBoxHeight$ | async }\"\n  [@toggleHeader]=\"{ value: isMinimized, params: { height: headerHeightValue } }\"\n  (@toggleHeader.start)=\"onAnimationEvent()\"\n  data-ste-section=\"header\"\n>\n  <div class=\"container header__content\">\n    <div class=\"header__top\">\n      <div class=\"header__logo\" data-ste-component=\"logo\">\n        <a class=\"header__link\" [routerLink]=\"localeService.homeLink\">\n          <sie-icon class=\"header__logo__icon\" [name]=\"iconReg.sieIcon.SieLogoWhiteRgb\" aria-hidden=\"true\"></sie-icon>\n          <span class=\"visually-hidden\">{{ logoNameSR }}</span>\n        </a>\n      </div>\n      <h1 class=\"header__platform-name\" data-ste-component=\"platform-link\">\n        <a class=\"header__link\" [routerLink]=\"localeService.homeLink\">{{ platformName }}</a>\n      </h1>\n      <div\n        class=\"header__search\"\n        *ngIf=\"layoutService.isViewport('L', 'XL', 'XXL') && !isMinimized\"\n        data-ste-component=\"search\"\n      >\n        <ng-container *ngTemplateOutlet=\"headerSearch\"></ng-container>\n      </div>\n      <div\n        class=\"header__quick-access\"\n        *ngIf=\"!isMinimized\"\n        [ngClass]=\"{ login: !isLoggedIn }\"\n        data-ste-component=\"quick-access\"\n      >\n        <ng-container *ngTemplateOutlet=\"headerQuickAccess\"></ng-container>\n      </div>\n    </div>\n\n    <div class=\"header__bottom\">\n      <div class=\"header__main-navigation\">\n        <ng-content select=\"[main-navigation]\"></ng-content>\n      </div>\n      <div class=\"header__search\" *ngIf=\"layoutService.isViewport('S', 'M') || isMinimized\">\n        <ng-container *ngTemplateOutlet=\"headerSearch\"></ng-container>\n      </div>\n      <div class=\"header__quick-access\" *ngIf=\"isMinimized\" [ngClass]=\"{ login: !isLoggedIn }\">\n        <ng-container *ngTemplateOutlet=\"headerQuickAccess\"></ng-container>\n      </div>\n    </div>\n  </div>\n</div>\n<ng-template #headerSearch>\n  <ng-content select=\"[header-search]\"></ng-content>\n</ng-template>\n\n<ng-template #headerQuickAccess>\n  <ng-content select=\"[header-quick-access]\"></ng-content>\n</ng-template>\n", styles: [".header__link{outline:none;outline-offset:0}@media (pointer: fine){.header__link{position:relative}.header__link:focus{outline:1px solid #1491eb;outline-offset:2px}.header__link:focus:not(:focus-visible){outline:0}.header__link:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}.header-background{display:block}@media print{.header-background{display:none}}.header-background.not-sticky{display:none}.message-box-container{position:fixed;top:0;left:0;right:0;z-index:998}@media print{.message-box-container{display:none}}.message-box-container.not-sticky{position:relative}.message-box{display:flex;flex-direction:column}.message-box-warning{background:#fff7d2}.message-box-info{background:#e0f1f4}.header{display:flex;justify-content:space-between;position:fixed;left:0;right:0;z-index:998;padding:8px 0 12px;background-color:#000028}@media (min-width: 1024px){.header{padding:22px 0}}@media print{.header{top:0!important}}.header.not-sticky{position:relative}@media screen{.header.mini-header{height:50px;padding:0}}@media print{.header.mini-header{height:-moz-fit-content;height:fit-content;margin-top:22px;margin-bottom:16px;position:relative}}.header__top,.header__bottom{width:100%;display:flex;flex-direction:row;justify-content:space-between}@media print{.header__top,.header__bottom{width:215px}}@media print{.header__bottom{display:none}}.header__content{display:flex;flex-direction:column}@media screen{.mini-header .header__content{height:100%;align-items:center;justify-content:center}.mini-header .header__content .header__bottom{align-items:center}}.header.max-header{height:119px}@media (min-width: 1024px){.header.max-header{height:129px}}@media print{.header.max-header{height:-moz-fit-content;height:fit-content;margin-top:22px;position:relative}}.header.max-header .header__content .header__top{margin-bottom:11px}.header__link,.header__link:hover,.header__link:active{text-decoration:none;color:#fff;display:block}.header__logo{height:21px;width:120px;margin-top:12px}@media (min-width: 640px){.header__logo{margin-top:10px}}@media (min-width: 1024px){.header__logo{margin-top:8px}}.header__logo__icon{width:120px;height:21px;display:flex;align-items:center;fill:currentColor}.header__logo__icon svg{fill:currentColor;width:inherit;height:inherit}.header__logo__icon svg g{fill:currentColor;width:inherit;height:inherit}.header__logo__icon svg text{font-family:Siemens Sans,sans-serif}.max-header .header__logo{display:block}@media screen{.mini-header .header__logo{display:none}}.header__logo .header__link{line-height:0}.header__quick-access{z-index:3;display:flex;flex-direction:row;align-items:center;justify-content:center;height:44px;margin-left:auto}@media print{.header__quick-access{display:none}}@media (min-width: 1024px){.header__quick-access{margin-left:40px;margin-bottom:0}.mini-header .header__quick-access{display:flex;flex-direction:row;align-items:center;justify-content:center;margin-left:2px}.mini-header .header__quick-access sie-ui-button{margin-top:2px}}@media (min-width: 1440px){.header__quick-access{margin-left:54px}}.header__quick-access:active:not(:disabled):not(.hover-disabled),.header__quick-access:hover:not(:disabled):not(.hover-disabled){cursor:pointer}.header__quick-access.login{margin-right:-8px}.header__quick-access sie-ui-button{height:44px}.header__platform-name{font-size:1.125rem;font-weight:400;line-height:1.5rem;margin:13px 0 0 14px;color:#fff;letter-spacing:normal}@media (min-width: 640px){.header__platform-name{margin:13px 24px 0 40px}}@media (min-width: 1024px){.header__platform-name{margin:10px 64px 0}}@media (min-width: 1440px){.header__platform-name{margin:10px 80px 0 64px}}@media screen{.max-header .header__platform-name{display:none}}@media screen and (min-width: 640px){.max-header .header__platform-name{display:block}}@media screen{.mini-header .header__platform-name{display:none}}.header__platform-name+.header__quick-access{margin-left:auto}.header__group{display:flex}.header__search{flex:1 1 280px;margin-left:auto;max-width:640px;width:100%}@media (min-width: 640px) and (max-width: 1023.8px){.header__search{max-width:calc(50% - 8px)}}@media (min-width: 1024px){.header__search{margin-top:2px}}@media all and (-ms-high-contrast: none),(-ms-high-contrast: active){.header__search{flex-grow:0}}@media print{.header__search{display:none}}.mini-header .header__search{display:flex;flex-direction:row;align-items:center;justify-content:center;justify-content:flex-end}.header__main-navigation{display:flex;align-items:center;margin:0 22px 0 -8px}@media (min-width: 640px){.header__main-navigation{flex:1}}@media (min-width: 1024px){.header__main-navigation{margin:0}}.header__main-navigation app-navigation{display:block;width:100%}.max-header .header__main-navigation{height:38px}@media (min-width: 1024px){.max-header .header__main-navigation{margin-top:auto}}.mini-header .header__main-navigation{height:100%}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i1$1.LayoutService }, { type: i1.SieIconRegistryService }, { type: i1$1.LocaleService }]; }, propDecorators: { messageBoxComponentContainer: [{
                type: ViewChild,
                args: ['messageBoxComponentContainer']
            }], homeUrl: [{
                type: Input
            }], isMinimized: [{
                type: Input
            }], isNavigationOverlayOpen: [{
                type: Input
            }], shouldScrollInOverlay: [{
                type: Input
            }], isLoggedIn: [{
                type: Input
            }], platformName: [{
                type: Input
            }], logoNameSR: [{
                type: Input
            }], maintenanceMessage: [{
                type: Input
            }], regionalMessage: [{
                type: Input
            }], screenReaderCloseIcon: [{
                type: Input
            }], quoteMode: [{
                type: Input
            }], quoteModeDismiss: [{
                type: Output
            }], regionalMessageClosed: [{
                type: Output
            }], debouncedCheckNavigationPosition: [] } });

class UiHeaderModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiHeaderModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiHeaderModule, declarations: [UiHeaderComponent], imports: [CommonModule, RouterModule, SieIconsModule, UiMessageBoxModule], exports: [UiHeaderComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiHeaderModule, imports: [CommonModule, RouterModule, SieIconsModule, UiMessageBoxModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiHeaderModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiHeaderComponent],
                    imports: [CommonModule, RouterModule, SieIconsModule, UiMessageBoxModule],
                    exports: [UiHeaderComponent]
                }]
        }] });

/**
 * @enum {string}
 * Entrance animation possibilities of the toast
 */
var UiToastEntranceAnimation;
(function (UiToastEntranceAnimation) {
    UiToastEntranceAnimation["SlideIn"] = "slideIn";
    UiToastEntranceAnimation["SlideMobileIn"] = "slideMobileIn";
    UiToastEntranceAnimation["FadeIn"] = "fadeIn";
    UiToastEntranceAnimation["Idle"] = "idle";
})(UiToastEntranceAnimation || (UiToastEntranceAnimation = {}));
/**
 * @enum {string}
 * Exit animation possibilities of the toast
 */
var UiToastExitAnimation;
(function (UiToastExitAnimation) {
    UiToastExitAnimation["SlideOut"] = "slideOut";
    UiToastExitAnimation["SlideMobileOut"] = "slideMobileOut";
    UiToastExitAnimation["FadeOut"] = "fadeOut";
    UiToastExitAnimation["Idle"] = "idle";
})(UiToastExitAnimation || (UiToastExitAnimation = {}));
/**
 * Animations types of the toast
 */
var UiToastAnimationType;
(function (UiToastAnimationType) {
    UiToastAnimationType[UiToastAnimationType["Entrance"] = 0] = "Entrance";
    UiToastAnimationType[UiToastAnimationType["Exit"] = 1] = "Exit";
})(UiToastAnimationType || (UiToastAnimationType = {}));
/**
 * Element targets that can get animated
 */
var UiToastAnimationTarget;
(function (UiToastAnimationTarget) {
    UiToastAnimationTarget[UiToastAnimationTarget["Height"] = 0] = "Height";
    UiToastAnimationTarget[UiToastAnimationTarget["Opacity"] = 1] = "Opacity";
})(UiToastAnimationTarget || (UiToastAnimationTarget = {}));
/** @ignore */
const UI_TOAST_ANIMATIONS = {
    mobile: {
        initialHeight: UiToastExitAnimation.SlideMobileOut,
        initialOpacity: UiToastEntranceAnimation.FadeIn,
        entrance: [UiToastEntranceAnimation.SlideMobileIn],
        exit: [UiToastExitAnimation.FadeOut, UiToastExitAnimation.SlideOut]
    },
    desktop: {
        initialHeight: UiToastExitAnimation.SlideOut,
        initialOpacity: UiToastEntranceAnimation.FadeIn,
        entrance: [UiToastEntranceAnimation.SlideIn],
        exit: [UiToastExitAnimation.FadeOut, UiToastExitAnimation.SlideOut]
    }
};

const entranceTiming = `.4s ${EasingEntranceExpressive}`;
const exitTiming = `.4s ${EasingExitExpressive}`;
/** @ignore */
const uiToastAnimations = [
    trigger('heightChange', [
        state(UiToastExitAnimation.SlideOut, style({
            height: '0',
            marginBottom: '0'
        })),
        state(UiToastEntranceAnimation.SlideIn, style({
            height: '{{height}}px',
            marginBottom: '8px'
        }), { params: { height: 0 } }),
        state(UiToastExitAnimation.SlideMobileOut, style({
            height: '0',
            marginBottom: '0',
            transform: 'translateY(calc(-{{height}}px - 16px))' /* stylelint-disable-line */,
            overflow: 'visible'
        }), { params: { height: 0 } }),
        state(UiToastEntranceAnimation.SlideMobileIn, style({
            height: '{{height}}px',
            marginBottom: '8px',
            transform: 'translateY(0)',
            overflow: 'visible'
        }), { params: { height: 0 } }),
        transition(`${UiToastExitAnimation.SlideOut} => ${UiToastEntranceAnimation.SlideIn}`, animate(entranceTiming)),
        transition(`${UiToastExitAnimation.SlideMobileOut} => ${UiToastEntranceAnimation.SlideMobileIn}`, animate(entranceTiming)),
        transition(`${UiToastEntranceAnimation.SlideIn} => ${UiToastExitAnimation.SlideOut}`, animate(exitTiming)),
        transition(`${UiToastEntranceAnimation.SlideMobileIn} => ${UiToastExitAnimation.SlideOut}`, animate(exitTiming))
    ]),
    trigger('opacityChange', [
        state(UiToastEntranceAnimation.FadeIn, style({
            opacity: 1
        })),
        state(UiToastExitAnimation.FadeOut, style({
            opacity: 0
        })),
        transition(`${UiToastEntranceAnimation.FadeIn} => ${UiToastExitAnimation.FadeOut}`, animate(exitTiming)),
        transition(`${UiToastExitAnimation.FadeOut} => ${UiToastEntranceAnimation.FadeIn}`, animate(entranceTiming))
    ])
];

const UI_TOAST_COMPONENT_SERVICE = 'UI_TOAST_COMPONENT_SERVICE';

/** @ignore */
const TOAST_TYPE_ICONS = {
    neutral: SieIcon.InformationFilled,
    success: SieIcon.SuccessFilled,
    warning: SieIcon.WarningFilled,
    error: SieIcon.ErrorFilled
};
/**
 * # Toast component
 *
 * Toast messages are notifications used to inform a user about e.g. outcome status of the action the user has taken.
 * Toast message itself has usage only inside the Toast List component.
 *
 * ## Component variations
 *
 * There are no variations.
 *
 * ## Content
 *
 * The toast component does not accept any content.
 *
 * ## Code example
 * @example ```html
 * <sie-ui-toast
 *  type="neutral"
 *  headline="Toast headline"
 *  message='Toast message'
 *  messageAfterLink="Message that comes after link"
 *  [autoDismissible]="false"
 *  [autoDismissDelay]="0"
 *  linkLabel="Link label"
 *  linkHref="Link href"
 *  primaryActionLabel="Primary action"
 *  secondaryActionLabel="Secondary action"
 * ></sie-ui-toast>
 * ```
 */
class UiToastComponent {
    /** @ignore */
    get heightChangeAnimation() {
        return { value: this._heightChangeAnimation, params: { height: this._contentHeight } };
    }
    /** @ignore */
    get opacityChangeAnimation() {
        return this._opacityChangeAnimation;
    }
    /**
     * Determines whether the link is inline or not
     * @default true
     */
    set inlineLink(value) {
        this._inlineLink = coerceBooleanProperty(value);
    }
    get inlineLink() {
        return this._inlineLink;
    }
    /**
     * @param type Determines the {@link UiToastType type} of the toast message
     * @default 'neutral'
     */
    set type(type) {
        this._type = type || 'neutral';
        this._headlineIcon = TOAST_TYPE_ICONS[type];
        this.iconReg.register(this._headlineIcon);
    }
    get type() {
        return this._type;
    }
    /**
     * @param value Determines the delay of the automatic dismissal (in milliseconds)
     */
    set autoDismissDelay(value) {
        this._autoDismissDelay = coerceNumberProperty(value);
    }
    get autoDismissDelay() {
        return this._autoDismissDelay;
    }
    /**
     * @param value Determines if the toast is automatically dismissible or not
     * @default false
     */
    set autoDismissible(value) {
        this._autoDismissible = coerceBooleanProperty(value);
    }
    get autoDismissible() {
        return this._autoDismissible;
    }
    /**
     * @param value Determines {@link UiToastEntranceAnimation entrance animation} of the toast message
     */
    set entranceAnimation(value) {
        this._entranceAnimation = coerceStringArray(value);
    }
    get entranceAnimation() {
        return this._entranceAnimation;
    }
    /**
     * @param value Determines {@link UiToastExitAnimation exit animation} of the toast message
     */
    set exitAnimation(value) {
        this._exitAnimation = coerceStringArray(value);
    }
    get exitAnimation() {
        return this._exitAnimation;
    }
    /** @ignore */
    get headlineIcon() {
        return this._headlineIcon;
    }
    /** @ignore */
    get contentHeight() {
        return this._contentHeight;
    }
    constructor(iconReg, cdr, layoutService, uiToastComponentService) {
        this.iconReg = iconReg;
        this.cdr = cdr;
        this.layoutService = layoutService;
        this.uiToastComponentService = uiToastComponentService;
        /** @ignore */
        this.role = 'alert';
        /**
         * Determines in which {@link UiBasicNavigationTarget tab} the link should open
         * @default '_blank'
         */
        this.linkTarget = '_blank';
        /**
         * Event triggered when the toast message is displayed
         */
        this.displayed = new Subject();
        /**
         * Event triggered when the toast message is dismissed {@link ToastMessageActionItem}
         */
        this.dismissed = new Subject();
        /**
         * Event triggered when the primary action button inside the toast is clicked {@link ToastMessageActionItem}
         */
        this.primaryActionClicked = new Subject();
        /**
         * Event triggered when the secondary action button inside the toast is clicked {@link ToastMessageActionItem}
         */
        this.secondaryActionClicked = new Subject();
        /**
         * Event triggered when the link inside the toast message is clicked {@link UiToastLinkClickedModel}
         */
        this.linkClicked = new Subject();
        /**
         * Event triggered when the toast changes the animation
         */
        this.animationChange = new Subject();
        this._contentHeight = 0;
        this._inlineLink = true;
        this._autoDismissible = false;
        this._type = 'neutral';
        this._headlineIcon = TOAST_TYPE_ICONS[this._type];
        this.animationQueue = [];
        this.rendered = new BehaviorSubject(false);
        iconReg.register(SieIcon.Close);
        iconReg.register(this._headlineIcon);
    }
    static getAnimationType(animation) {
        return animation.endsWith('In') ? UiToastAnimationType.Entrance : UiToastAnimationType.Exit;
    }
    static getAnimationTarget(animation) {
        return animation.startsWith('fade') ? UiToastAnimationTarget.Opacity : UiToastAnimationTarget.Height;
    }
    /** @ignore */
    ngOnInit() {
        this.breakpointSubscription = this.layoutService.resizeEvent.subscribe(() => {
            this._contentHeight = this.contentRef?.nativeElement.offsetHeight;
            this.cdr?.detectChanges();
            this.animationChange.next();
        });
    }
    /** @ignore */
    ngOnDestroy() {
        this.autoDismissTimer?.clear();
        this.breakpointSubscription?.unsubscribe();
    }
    /** @ignore */
    ngAfterViewInit() {
        this._heightChangeAnimation = this.initialHeightAnimationState;
        this._opacityChangeAnimation = this.initialOpacityAnimationState;
        this.cdr?.detectChanges();
        this.rendered.next(true);
    }
    /** @ignore */
    enter() {
        if (!this.entranceAnimation) {
            return;
        }
        this.renderedSubscription = this.rendered.subscribe(isRendered => {
            if (isRendered) {
                this.animationQueue = deepCopy(this.entranceAnimation);
                if (this.animationQueue.length) {
                    this.doAnimations();
                }
                else {
                    this.handleAnimationEnd(UiToastAnimationType.Entrance);
                }
                this.renderedSubscription?.unsubscribe();
            }
        });
    }
    /** @ignore */
    exit(closeButtonClicked) {
        this.autoDismissTimer?.clear();
        if (!this.exitAnimation) {
            this.dismissed.next({ toastId: this.id, additionalData: this.additionalData });
            return;
        }
        if (this.closeActionCallback && closeButtonClicked) {
            this.closeActionCallback();
        }
        this.animationQueue = deepCopy(this.exitAnimation);
        if (this.animationQueue.length) {
            this.doAnimations();
        }
        else {
            this.handleAnimationEnd(UiToastAnimationType.Exit);
        }
    }
    /** @ignore */
    pauseAutoDismissTimer() {
        this.autoDismissTimer?.pause();
    }
    /** @ignore */
    resumeAutoDismissTimer() {
        this.autoDismissTimer?.resume();
    }
    /** @ignore */
    onPrimaryAction() {
        this.primaryActionClicked.next({ toastId: this.id, additionalData: this.additionalData });
        if (this.primaryActionCallback) {
            this.primaryActionCallback();
        }
        this.exit();
    }
    /** @ignore */
    onSecondaryAction() {
        this.secondaryActionClicked.next({ toastId: this.id, additionalData: this.additionalData });
        if (this.secondaryActionCallback) {
            this.secondaryActionCallback();
        }
        this.exit();
    }
    /** @ignore */
    onLinkClicked(linkClicked) {
        this.linkClicked.next(linkClicked);
        if (this.linkActionCallback) {
            this.linkActionCallback(linkClicked);
        }
        if (this.linkHref) {
            return;
        }
        linkClicked.event.preventDefault();
        if (this.routerHref) {
            this.uiToastComponentService.navigate(this.routerHref);
        }
        this.exit();
    }
    doAnimations() {
        const animation = this.animationQueue.shift();
        if (UiToastComponent.getAnimationTarget(animation) === UiToastAnimationTarget.Height) {
            this._contentHeight = this.contentRef?.nativeElement.offsetHeight;
            this._heightChangeAnimation = animation;
        }
        else {
            this._opacityChangeAnimation = animation;
        }
        this.animationChange.next();
    }
    animationDone(event) {
        if (event.fromState === 'void' || event.fromState === null || event.toState === null) {
            return;
        }
        if (this.animationQueue.length) {
            this.doAnimations();
        }
        else {
            this.handleAnimationEnd(UiToastComponent.getAnimationType(event.toState));
        }
    }
    handleAnimationEnd(animationType) {
        if (animationType === UiToastAnimationType.Entrance) {
            this.displayed.next();
            this.createDismissTimer();
        }
        else {
            this.dismissed.next({ toastId: this.id, additionalData: this.additionalData });
        }
    }
    createDismissTimer() {
        if (this.autoDismissible) {
            this.autoDismissTimer = new Timer(() => {
                this.exit();
                this.cdr?.detectChanges();
            }, this.autoDismissDelay);
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiToastComponent, deps: [{ token: i1.SieIconRegistryService }, { token: i0.ChangeDetectorRef, optional: true, skipSelf: true }, { token: i1$1.LayoutService }, { token: UI_TOAST_COMPONENT_SERVICE }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiToastComponent, selector: "sie-ui-toast", inputs: { id: "id", headline: "headline", message: "message", messageAfterLink: "messageAfterLink", closeButtonScreenReaderText: "closeButtonScreenReaderText", inlineLink: "inlineLink", linkLabel: "linkLabel", linkHref: "linkHref", linkTarget: "linkTarget", routerHref: "routerHref", additionalData: "additionalData", primaryActionLabel: "primaryActionLabel", secondaryActionLabel: "secondaryActionLabel", primaryActionCallback: "primaryActionCallback", secondaryActionCallback: "secondaryActionCallback", closeActionCallback: "closeActionCallback", linkActionCallback: "linkActionCallback", type: "type", autoDismissDelay: "autoDismissDelay", autoDismissible: "autoDismissible", entranceAnimation: "entranceAnimation", exitAnimation: "exitAnimation", initialHeightAnimationState: "initialHeightAnimationState", initialOpacityAnimationState: "initialOpacityAnimationState" }, outputs: { displayed: "displayed", dismissed: "dismissed", primaryActionClicked: "primaryActionClicked", secondaryActionClicked: "secondaryActionClicked", linkClicked: "linkClicked", animationChange: "animationChange" }, host: { listeners: { "@opacityChange.done": "animationDone($event)", "@heightChange.done": "animationDone($event)" }, properties: { "attr.role": "this.role", "@heightChange": "this.heightChangeAnimation", "@opacityChange": "this.opacityChangeAnimation" } }, viewQueries: [{ propertyName: "contentRef", first: true, predicate: ["content"], descendants: true }], ngImport: i0, template: "<div class=\"toast\" #content>\n  <div class=\"toast__header\">\n    <sie-icon [name]=\"headlineIcon\" class=\"toast__header-icon\" [ngClass]=\"'toast__header-icon--' + type\"></sie-icon>\n    <h5 class=\"toast__headline\">{{ headline }}</h5>\n    <sie-ui-button\n      themeType=\"icon\"\n      variant=\"icon-un-contained\"\n      [icon]=\"iconReg.sieIcon.Close\"\n      class=\"toast__close-btn\"\n      (clicked)=\"exit($event)\"\n      [iconScreenReaderText]=\"closeButtonScreenReaderText\"\n    ></sie-ui-button>\n  </div>\n  <p *ngIf=\"message\" class=\"toast__message\">\n    <span>{{ message }}</span>\n    <sie-ui-link\n      *ngIf=\"linkLabel\"\n      class=\"toast__link\"\n      [ngClass]=\"{ 'icon-link': !inlineLink }\"\n      (clicked)=\"onLinkClicked({ event: $event, id })\"\n      [href]=\"linkHref\"\n      [target]=\"linkTarget\"\n      [variant]=\"inlineLink ? 'inline' : 'icon-link'\"\n      disableVisitedStyle\n      >{{ linkLabel }}</sie-ui-link\n    >\n    <span *ngIf=\"messageAfterLink\">{{ messageAfterLink }}</span>\n  </p>\n\n  <div *ngIf=\"primaryActionLabel || secondaryActionLabel\" class=\"toast__actions\">\n    <sie-ui-button\n      *ngIf=\"primaryActionLabel\"\n      class=\"toast__action-btn\"\n      variant=\"secondary\"\n      (clicked)=\"onPrimaryAction()\"\n      [fullWidth]=\"layoutService.isViewport('S')\"\n      >{{ primaryActionLabel }}</sie-ui-button\n    >\n    <sie-ui-button\n      *ngIf=\"secondaryActionLabel\"\n      class=\"toast__action-btn\"\n      variant=\"tertiary\"\n      (clicked)=\"onSecondaryAction()\"\n      [fullWidth]=\"layoutService.isViewport('S')\"\n      >{{ secondaryActionLabel }}</sie-ui-button\n    >\n  </div>\n</div>\n", styles: [":host{display:block;position:relative;max-width:480px;box-shadow:0 2px 4px #0000001a,0 10px 16px #00000029}:host.animate{overflow:hidden}:host.collapsed{height:0}.toast{border:1px solid #ccccd4;padding:16px 16px 13px;background-color:#fff}.toast__header-icon{position:absolute;top:16px;width:24px;height:24px;display:flex;align-items:center;fill:currentColor}.toast__header-icon svg{fill:currentColor;width:inherit;height:inherit}.toast__header-icon svg g{fill:currentColor;width:inherit;height:inherit}.toast__header-icon svg text{font-family:Siemens Sans,sans-serif}.toast__header-icon--neutral{color:#00557c}.toast__header-icon--success{color:#00af52}.toast__header-icon--warning{color:#ff9000}.toast__header-icon--error{color:#ef0137}.toast__headline{padding-right:26px;padding-left:30px;max-height:48px;overflow:hidden}.toast__close-btn{position:absolute;width:44px;height:44px;top:5px;right:4px}.toast__message{font-size:.875rem;font-weight:400;line-height:1.25rem;padding-top:8px}.toast__message>span{display:inline;max-height:60px;overflow:hidden}.toast__message>span:after,.toast__message>span:before{content:\" \";display:inline}.toast__link.icon-link{margin-bottom:-6px}.toast__actions{display:flex;flex-direction:column;padding:23px 0 2px}@media (min-width: 640px){.toast__actions{flex-direction:row;justify-content:flex-end}}.toast__action-btn+.toast__action-btn{margin-top:8px}@media (min-width: 640px){.toast__action-btn+.toast__action-btn{margin-top:0;margin-left:8px}}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: UiButtonComponent, selector: "sie-ui-button" }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "component", type: UiLinkComponent, selector: "sie-ui-link", inputs: ["disabled", "disableVisitedStyle", "hasMarginTop", "offsetIcon", "truncate", "inLinkList", "trailingIcon", "icon", "cssClass", "href", "size", "target", "variant", "background", "type", "reference", "screenReaderText", "secondaryLabel", "download", "dataAttributes", "tooltip", "buttonType"], outputs: ["clicked"] }], animations: uiToastAnimations, changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiToastComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-toast', changeDetection: ChangeDetectionStrategy.OnPush, animations: uiToastAnimations, template: "<div class=\"toast\" #content>\n  <div class=\"toast__header\">\n    <sie-icon [name]=\"headlineIcon\" class=\"toast__header-icon\" [ngClass]=\"'toast__header-icon--' + type\"></sie-icon>\n    <h5 class=\"toast__headline\">{{ headline }}</h5>\n    <sie-ui-button\n      themeType=\"icon\"\n      variant=\"icon-un-contained\"\n      [icon]=\"iconReg.sieIcon.Close\"\n      class=\"toast__close-btn\"\n      (clicked)=\"exit($event)\"\n      [iconScreenReaderText]=\"closeButtonScreenReaderText\"\n    ></sie-ui-button>\n  </div>\n  <p *ngIf=\"message\" class=\"toast__message\">\n    <span>{{ message }}</span>\n    <sie-ui-link\n      *ngIf=\"linkLabel\"\n      class=\"toast__link\"\n      [ngClass]=\"{ 'icon-link': !inlineLink }\"\n      (clicked)=\"onLinkClicked({ event: $event, id })\"\n      [href]=\"linkHref\"\n      [target]=\"linkTarget\"\n      [variant]=\"inlineLink ? 'inline' : 'icon-link'\"\n      disableVisitedStyle\n      >{{ linkLabel }}</sie-ui-link\n    >\n    <span *ngIf=\"messageAfterLink\">{{ messageAfterLink }}</span>\n  </p>\n\n  <div *ngIf=\"primaryActionLabel || secondaryActionLabel\" class=\"toast__actions\">\n    <sie-ui-button\n      *ngIf=\"primaryActionLabel\"\n      class=\"toast__action-btn\"\n      variant=\"secondary\"\n      (clicked)=\"onPrimaryAction()\"\n      [fullWidth]=\"layoutService.isViewport('S')\"\n      >{{ primaryActionLabel }}</sie-ui-button\n    >\n    <sie-ui-button\n      *ngIf=\"secondaryActionLabel\"\n      class=\"toast__action-btn\"\n      variant=\"tertiary\"\n      (clicked)=\"onSecondaryAction()\"\n      [fullWidth]=\"layoutService.isViewport('S')\"\n      >{{ secondaryActionLabel }}</sie-ui-button\n    >\n  </div>\n</div>\n", styles: [":host{display:block;position:relative;max-width:480px;box-shadow:0 2px 4px #0000001a,0 10px 16px #00000029}:host.animate{overflow:hidden}:host.collapsed{height:0}.toast{border:1px solid #ccccd4;padding:16px 16px 13px;background-color:#fff}.toast__header-icon{position:absolute;top:16px;width:24px;height:24px;display:flex;align-items:center;fill:currentColor}.toast__header-icon svg{fill:currentColor;width:inherit;height:inherit}.toast__header-icon svg g{fill:currentColor;width:inherit;height:inherit}.toast__header-icon svg text{font-family:Siemens Sans,sans-serif}.toast__header-icon--neutral{color:#00557c}.toast__header-icon--success{color:#00af52}.toast__header-icon--warning{color:#ff9000}.toast__header-icon--error{color:#ef0137}.toast__headline{padding-right:26px;padding-left:30px;max-height:48px;overflow:hidden}.toast__close-btn{position:absolute;width:44px;height:44px;top:5px;right:4px}.toast__message{font-size:.875rem;font-weight:400;line-height:1.25rem;padding-top:8px}.toast__message>span{display:inline;max-height:60px;overflow:hidden}.toast__message>span:after,.toast__message>span:before{content:\" \";display:inline}.toast__link.icon-link{margin-bottom:-6px}.toast__actions{display:flex;flex-direction:column;padding:23px 0 2px}@media (min-width: 640px){.toast__actions{flex-direction:row;justify-content:flex-end}}.toast__action-btn+.toast__action-btn{margin-top:8px}@media (min-width: 640px){.toast__action-btn+.toast__action-btn{margin-top:0;margin-left:8px}}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }, { type: i0.ChangeDetectorRef, decorators: [{
                    type: SkipSelf
                }, {
                    type: Optional
                }] }, { type: i1$1.LayoutService }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [UI_TOAST_COMPONENT_SERVICE]
                }] }]; }, propDecorators: { role: [{
                type: HostBinding,
                args: ['attr.role']
            }], heightChangeAnimation: [{
                type: HostBinding,
                args: ['@heightChange']
            }], opacityChangeAnimation: [{
                type: HostBinding,
                args: ['@opacityChange']
            }], contentRef: [{
                type: ViewChild,
                args: ['content']
            }], id: [{
                type: Input
            }], headline: [{
                type: Input
            }], message: [{
                type: Input
            }], messageAfterLink: [{
                type: Input
            }], closeButtonScreenReaderText: [{
                type: Input
            }], inlineLink: [{
                type: Input
            }], linkLabel: [{
                type: Input
            }], linkHref: [{
                type: Input
            }], linkTarget: [{
                type: Input
            }], routerHref: [{
                type: Input
            }], additionalData: [{
                type: Input
            }], primaryActionLabel: [{
                type: Input
            }], secondaryActionLabel: [{
                type: Input
            }], primaryActionCallback: [{
                type: Input
            }], secondaryActionCallback: [{
                type: Input
            }], closeActionCallback: [{
                type: Input
            }], linkActionCallback: [{
                type: Input
            }], type: [{
                type: Input
            }], autoDismissDelay: [{
                type: Input
            }], autoDismissible: [{
                type: Input
            }], entranceAnimation: [{
                type: Input
            }], exitAnimation: [{
                type: Input
            }], initialHeightAnimationState: [{
                type: Input
            }], initialOpacityAnimationState: [{
                type: Input
            }], displayed: [{
                type: Output
            }], dismissed: [{
                type: Output
            }], primaryActionClicked: [{
                type: Output
            }], secondaryActionClicked: [{
                type: Output
            }], linkClicked: [{
                type: Output
            }], animationChange: [{
                type: Output
            }], animationDone: [{
                type: HostListener,
                args: ['@opacityChange.done', ['$event']]
            }, {
                type: HostListener,
                args: ['@heightChange.done', ['$event']]
            }] } });

/**
 * # Toast Module
 * - {@link UiToastComponent}
 *
 * ## Module peer dependencies
 * - `@angular/platform-browser/animations/BrowserAnimationsModule`: This module is needed for the animation of
 * displaying and showing the toast message.
 * - {@link SieIconsModule}
 */
class UiToastModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiToastModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiToastModule, declarations: [UiToastComponent], imports: [CommonModule, UiButtonModule, SieIconsModule, UiLinkModule], exports: [UiToastComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiToastModule, imports: [CommonModule, UiButtonModule, SieIconsModule, UiLinkModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiToastModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiToastComponent],
                    imports: [CommonModule, UiButtonModule, SieIconsModule, UiLinkModule],
                    exports: [UiToastComponent]
                }]
        }] });

class UiToastComponentElementService {
    constructor(document) {
        this.document = document;
    }
    navigate(href) {
        this.document.defaultView.location.href = href;
        return Promise.resolve(true);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiToastComponentElementService, deps: [{ token: DOCUMENT }], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiToastComponentElementService }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiToastComponentElementService, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return [{ type: Document, decorators: [{
                    type: Inject,
                    args: [DOCUMENT]
                }] }]; } });

/**
 * Implementation for Angular environment that is handling router navigation
 */
class UiToastComponentNgService {
    constructor(router) {
        this.router = router;
    }
    navigate(href) {
        return this.router.navigateByUrl(href);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiToastComponentNgService, deps: [{ token: i2$1.Router }], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiToastComponentNgService }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiToastComponentNgService, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return [{ type: i2$1.Router }]; } });

/**
 * # Toast list component
 *
 * Toast list is the component that holds the toast messages inside, allowing us, e.g., to be notified about more than one action at the time.
 * Toast message itself has usage only inside the Toast List component
 *
 * ## Component variations
 *
 * Toast list doesn't have any variations
 *
 * ## Content
 *
 * The toast list can contain toasts managed by the exported functions
 *
 * ## Code example (Static Toast List)
 * @example
 * ```html
 * <sie-ui-toast-list
 *  [toasts]="toasts"
 *  [closeButtonScreenReaderText]="'Close button screen reader text'"
 * ></sie-ui-toast-list>
 * ```
 *
 * ```ts
 * const toasts = [
 *  {
 *    type: 'neutral',
 *    headline: 'Toast headline',
 *    message: 'Toast message lorem ipsum',
 *    messageAfterLink: ' Lorem ipsum dolor sit.',
 *    autoDismissible: false,
 *    autoDismissDelay: 0,
 *    inlineLink: true,
 *    linkLabel: 'link label.',
 *    linkHref: 'link href',
 *    primaryActionLabel: 'Primary action',
 *    secondaryActionLabel: 'Secondary action',
 *    additionalData: {
 *      action: 'RELOAD_ATTRIBUTES',
 *      item: 'itemId'
 *    },
 *    primaryActionCallback: () => {
 *      console.log('primary action done!');
 *    },
 *    secondaryActionCallback: () => {
 *      console.log('secondary action done!');
 *    },
 *    closeActionCallback: () => {
 *      console.log('close action done!');
 *    },
 *    linkActionCallback: () => {
 *      console.log('link action done!');
 *    }
 *  }
 * ];
 * ```
 *
 * # Code Example (Dynamic Toasts)
 * ```html
 * <sie-ui-toast-list
 *   class="toast-list"
 *   (primaryActionClicked)="onToastAction('primary', $event)"
 *   (secondaryActionClicked)="onToastAction('secondary', $event)"
 *   (dismissed)="onToastAction('dismiss', $event)"
 *   #toastListComponent
 * ></sie-ui-toast-list>
 *
 * <button (click)="toastListComponent.add({ headline: 'test' })">Add Toast</button>
 * ```
 */
class UiToastListComponent {
    get toasts() {
        return this._toasts.slice().reverse();
    }
    /**
     * @param value {@link UiToastModel Toasts} to be displayed inside the list
     */
    set toasts(value) {
        this._toasts = value;
    }
    constructor(cdr, hostElement, layoutService) {
        this.cdr = cdr;
        this.hostElement = hostElement;
        this.layoutService = layoutService;
        /**
         * Determines the delay of the automatic dismissal (in milliseconds)
         * @default 6000
         */
        this.autoDismissDelay = 6000;
        /**
         * Defines the close button screen reader text
         * @default ''
         */
        this.closeButtonScreenReaderText = '';
        this._toasts = [];
        this.subscription = new Subscription();
        /** @ignore */
        this.entranceAnimations = UI_TOAST_ANIMATIONS.mobile.entrance;
        /** @ignore */
        this.exitAnimations = UI_TOAST_ANIMATIONS.mobile.exit;
        /** @ignore */
        this.initialHeightAnimationState = UI_TOAST_ANIMATIONS.mobile.initialHeight;
        /** @ignore */
        this.initialOpacityAnimationState = UI_TOAST_ANIMATIONS.mobile.initialOpacity;
        /**
         * Event triggered when the primary action button inside the toast is clicked {@link ToastMessageActionItem}
         */
        this.primaryActionClicked = new Subject();
        /**
         * Event triggered when the primary action button inside the toast is clicked {@link ToastMessageActionItem}
         */
        this.secondaryActionClicked = new Subject();
        /**
         * Event triggered when the secondary action button inside the toast is clicked {@link UiToastLinkClickedModel}
         */
        this.linkClicked = new Subject();
        /**
         * Event triggered when the link inside the toast message is clicked {@link ToastMessageActionItem}
         */
        this.dismissed = new Subject();
    }
    /** @ignore */
    ngOnInit() {
        this.subscription.add(this.layoutService.breakPointChangedEvent.subscribe(() => {
            this.setAnimations();
        }));
        this.setAnimations();
    }
    /** @ignore */
    ngOnDestroy() {
        this.subscription.unsubscribe();
    }
    /** @ignore */
    trackByFn(_index, model) {
        return model.id;
    }
    /**
     * Adds another Toast into the Toast list
     *
     * @param toastModel
     */
    add(toastModel) {
        if (!toastModel.id) {
            toastModel.id = this.toastComponents.length + '_' + Date.now();
        }
        if (this._toasts.findIndex(toast => toast.id === toastModel.id) === -1) {
            toastModel.autoDismissDelay = this.autoDismissDelay;
            this._toasts.push(toastModel);
            this.cdr.detectChanges();
            this.toastComponents.first.enter();
            this.cdr.detectChanges();
        }
    }
    /** @ignore */
    slideInListItem(item) {
        item.classList.add('slide-in');
    }
    /** @ignore */
    dismissToast(toastId) {
        const toastToBeDismissed = this.toastComponents.find(c => c.id === toastId);
        if (toastToBeDismissed) {
            toastToBeDismissed.exit();
        }
    }
    /** @ignore */
    removeToast(toastActionData) {
        this.onDismissAction(toastActionData);
        const toastIndex = this._toasts.findIndex(toast => toast.id === toastActionData.toastId);
        this._toasts.splice(toastIndex, 1);
        this.cdr.detectChanges();
    }
    /** @ignore */
    onPrimaryAction(toastActionData) {
        this.primaryActionClicked.next(toastActionData);
    }
    /** @ignore */
    onSecondaryAction(toastActionData) {
        this.secondaryActionClicked.next(toastActionData);
    }
    /** @ignore */
    onLinkClick(linkClicked) {
        this.linkClicked.next(linkClicked);
    }
    /** @ignore */
    onDismissAction(toastActionData) {
        this.dismissed.next(toastActionData);
    }
    pauseToastAutoDismiss() {
        this.toastComponents.forEach(toastComponent => {
            toastComponent.pauseAutoDismissTimer();
        });
    }
    resumeToastAutoDismiss() {
        this.toastComponents.forEach(toastComponent => {
            toastComponent.resumeAutoDismissTimer();
        });
    }
    /** @ignore */
    animationChanged() {
        this.cdr.detectChanges();
    }
    setAnimations() {
        const deviceKey = this.layoutService.isViewport('S') ? 'mobile' : 'desktop';
        this.entranceAnimations = UI_TOAST_ANIMATIONS[deviceKey].entrance;
        this.exitAnimations = UI_TOAST_ANIMATIONS[deviceKey].exit;
        this.initialHeightAnimationState = UI_TOAST_ANIMATIONS[deviceKey].initialHeight;
        this.initialOpacityAnimationState = UI_TOAST_ANIMATIONS[deviceKey].initialOpacity;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiToastListComponent, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i1$1.LayoutService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiToastListComponent, selector: "sie-ui-toast-list", inputs: { autoDismissDelay: "autoDismissDelay", closeButtonScreenReaderText: "closeButtonScreenReaderText", toasts: "toasts" }, outputs: { primaryActionClicked: "primaryActionClicked", secondaryActionClicked: "secondaryActionClicked", linkClicked: "linkClicked", dismissed: "dismissed" }, host: { listeners: { "mouseenter": "pauseToastAutoDismiss()", "mouseleave": "resumeToastAutoDismiss()" } }, viewQueries: [{ propertyName: "listElement", first: true, predicate: ["listElement"], descendants: true }, { propertyName: "toastComponents", predicate: UiToastComponent, descendants: true }], ngImport: i0, template: "<ul class=\"toast-list\" #listElement>\n  <li class=\"toast-item\" *ngFor=\"let toast of toasts; let index = index; trackBy: trackByFn\" #listElement>\n    <sie-ui-toast\n      *ngIf=\"toast\"\n      class=\"toast\"\n      [type]=\"toast.type\"\n      [id]=\"toast.id\"\n      [headline]=\"toast.headline\"\n      [message]=\"toast.message\"\n      [messageAfterLink]=\"toast.messageAfterLink\"\n      [additionalData]=\"toast.additionalData\"\n      [inlineLink]=\"toast.inlineLink\"\n      [linkLabel]=\"toast.linkLabel\"\n      [linkHref]=\"toast.linkHref\"\n      [linkTarget]=\"toast.linkTarget ? toast.linkTarget : '_blank'\"\n      [routerHref]=\"toast.routerHref\"\n      [primaryActionLabel]=\"toast.primaryActionLabel\"\n      [secondaryActionLabel]=\"toast.secondaryActionLabel\"\n      [autoDismissDelay]=\"toast.autoDismissDelay\"\n      [autoDismissible]=\"toast.autoDismissible\"\n      [entranceAnimation]=\"entranceAnimations\"\n      [exitAnimation]=\"exitAnimations\"\n      [initialHeightAnimationState]=\"initialHeightAnimationState\"\n      [initialOpacityAnimationState]=\"initialOpacityAnimationState\"\n      [closeButtonScreenReaderText]=\"closeButtonScreenReaderText\"\n      [primaryActionCallback]=\"toast.primaryActionCallback\"\n      [secondaryActionCallback]=\"toast.secondaryActionCallback\"\n      [closeActionCallback]=\"toast.closeActionCallback\"\n      [linkActionCallback]=\"toast.linkActionCallback\"\n      (displayed)=\"slideInListItem(listElement)\"\n      (dismissed)=\"removeToast($event)\"\n      (primaryActionClicked)=\"onPrimaryAction($event)\"\n      (secondaryActionClicked)=\"onSecondaryAction($event)\"\n      (linkClicked)=\"onLinkClick({ event: $event, id: toast.id })\"\n      (animationChange)=\"animationChanged()\"\n    ></sie-ui-toast>\n  </li>\n</ul>\n", styles: [":host{display:block;max-width:512px}.toast-list{list-style:none;margin:0;padding:0;position:relative;transition:padding-top .3s}@media print{.toast-list{display:none}}.toast-list:not(:empty){padding-bottom:16px}@media (min-width: 640px){.toast-list>.toast-item{transform:translate(100%)}.toast-list>.toast-item.slide-in{animation-name:slidein;animation-duration:.4s;animation-timing-function:cubic-bezier(0,0,.3,1);animation-fill-mode:forwards}@keyframes slidein{0%{transform:translate(100%)}to{transform:translate(0)}}}.toast-list>.toast-item:first-child{margin-top:16px}.toast-list>.toast-item .toast{margin:0 auto}\n"], dependencies: [{ kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: UiToastComponent, selector: "sie-ui-toast", inputs: ["id", "headline", "message", "messageAfterLink", "closeButtonScreenReaderText", "inlineLink", "linkLabel", "linkHref", "linkTarget", "routerHref", "additionalData", "primaryActionLabel", "secondaryActionLabel", "primaryActionCallback", "secondaryActionCallback", "closeActionCallback", "linkActionCallback", "type", "autoDismissDelay", "autoDismissible", "entranceAnimation", "exitAnimation", "initialHeightAnimationState", "initialOpacityAnimationState"], outputs: ["displayed", "dismissed", "primaryActionClicked", "secondaryActionClicked", "linkClicked", "animationChange"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
__decorate([
    Native()
], UiToastListComponent.prototype, "add", null);
__decorate([
    Native()
], UiToastListComponent.prototype, "dismissToast", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiToastListComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-toast-list', changeDetection: ChangeDetectionStrategy.OnPush, template: "<ul class=\"toast-list\" #listElement>\n  <li class=\"toast-item\" *ngFor=\"let toast of toasts; let index = index; trackBy: trackByFn\" #listElement>\n    <sie-ui-toast\n      *ngIf=\"toast\"\n      class=\"toast\"\n      [type]=\"toast.type\"\n      [id]=\"toast.id\"\n      [headline]=\"toast.headline\"\n      [message]=\"toast.message\"\n      [messageAfterLink]=\"toast.messageAfterLink\"\n      [additionalData]=\"toast.additionalData\"\n      [inlineLink]=\"toast.inlineLink\"\n      [linkLabel]=\"toast.linkLabel\"\n      [linkHref]=\"toast.linkHref\"\n      [linkTarget]=\"toast.linkTarget ? toast.linkTarget : '_blank'\"\n      [routerHref]=\"toast.routerHref\"\n      [primaryActionLabel]=\"toast.primaryActionLabel\"\n      [secondaryActionLabel]=\"toast.secondaryActionLabel\"\n      [autoDismissDelay]=\"toast.autoDismissDelay\"\n      [autoDismissible]=\"toast.autoDismissible\"\n      [entranceAnimation]=\"entranceAnimations\"\n      [exitAnimation]=\"exitAnimations\"\n      [initialHeightAnimationState]=\"initialHeightAnimationState\"\n      [initialOpacityAnimationState]=\"initialOpacityAnimationState\"\n      [closeButtonScreenReaderText]=\"closeButtonScreenReaderText\"\n      [primaryActionCallback]=\"toast.primaryActionCallback\"\n      [secondaryActionCallback]=\"toast.secondaryActionCallback\"\n      [closeActionCallback]=\"toast.closeActionCallback\"\n      [linkActionCallback]=\"toast.linkActionCallback\"\n      (displayed)=\"slideInListItem(listElement)\"\n      (dismissed)=\"removeToast($event)\"\n      (primaryActionClicked)=\"onPrimaryAction($event)\"\n      (secondaryActionClicked)=\"onSecondaryAction($event)\"\n      (linkClicked)=\"onLinkClick({ event: $event, id: toast.id })\"\n      (animationChange)=\"animationChanged()\"\n    ></sie-ui-toast>\n  </li>\n</ul>\n", styles: [":host{display:block;max-width:512px}.toast-list{list-style:none;margin:0;padding:0;position:relative;transition:padding-top .3s}@media print{.toast-list{display:none}}.toast-list:not(:empty){padding-bottom:16px}@media (min-width: 640px){.toast-list>.toast-item{transform:translate(100%)}.toast-list>.toast-item.slide-in{animation-name:slidein;animation-duration:.4s;animation-timing-function:cubic-bezier(0,0,.3,1);animation-fill-mode:forwards}@keyframes slidein{0%{transform:translate(100%)}to{transform:translate(0)}}}.toast-list>.toast-item:first-child{margin-top:16px}.toast-list>.toast-item .toast{margin:0 auto}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i1$1.LayoutService }]; }, propDecorators: { listElement: [{
                type: ViewChild,
                args: ['listElement']
            }], toastComponents: [{
                type: ViewChildren,
                args: [UiToastComponent]
            }], autoDismissDelay: [{
                type: Input
            }], closeButtonScreenReaderText: [{
                type: Input
            }], toasts: [{
                type: Input
            }], primaryActionClicked: [{
                type: Output
            }], secondaryActionClicked: [{
                type: Output
            }], linkClicked: [{
                type: Output
            }], dismissed: [{
                type: Output
            }], add: [], dismissToast: [], pauseToastAutoDismiss: [{
                type: HostListener,
                args: ['mouseenter']
            }], resumeToastAutoDismiss: [{
                type: HostListener,
                args: ['mouseleave']
            }] } });

/**
 * # Toast List Module
 * - {@link UiToastListComponent}
 *
 * ## Module peer dependencies
 * - `@angular/platform-browser/animations/BrowserAnimationsModule`: This module is needed for the animation of
 * displaying and showing toast messages.
 * - {@link SieIconsModule}
 */
/** @ignore */
class UiToastListModule {
    static forWebComponent() {
        const providers = [
            {
                provide: UI_TOAST_COMPONENT_SERVICE,
                useClass: UiToastComponentElementService
            }
        ];
        return {
            ngModule: UiToastListModule,
            providers
        };
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiToastListModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiToastListModule, declarations: [UiToastListComponent], imports: [CommonModule, UiToastModule], exports: [UiToastListComponent, UiToastModule] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiToastListModule, providers: [
            {
                provide: UI_TOAST_COMPONENT_SERVICE,
                useClass: UiToastComponentNgService
            }
        ], imports: [CommonModule, UiToastModule, UiToastModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiToastListModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiToastListComponent],
                    imports: [CommonModule, UiToastModule],
                    providers: [
                        {
                            provide: UI_TOAST_COMPONENT_SERVICE,
                            useClass: UiToastComponentNgService
                        }
                    ],
                    exports: [UiToastListComponent, UiToastModule]
                }]
        }] });

const DATE_PICKER_FORMATS = {
    parse: { dateInput: null },
    display: {
        dateInput: { year: 'numeric', month: 'numeric', day: 'numeric' },
        monthYearLabel: { year: 'numeric', month: 'long' },
        dateA11yLabel: { year: 'numeric', month: 'long', day: 'numeric' },
        monthYearA11yLabel: { year: 'numeric', month: 'long' }
    }
};
const DATE_PICKER_UNCONTAINED_OVERLAY_MAX_WIDTH = 260;

var DatePickerValidity;
(function (DatePickerValidity) {
    DatePickerValidity[DatePickerValidity["Valid"] = 0] = "Valid";
    DatePickerValidity[DatePickerValidity["RequiredError"] = 1] = "RequiredError";
    DatePickerValidity[DatePickerValidity["InvalidDateError"] = 2] = "InvalidDateError";
    DatePickerValidity[DatePickerValidity["RangeError"] = 3] = "RangeError";
    DatePickerValidity[DatePickerValidity["EndDateError"] = 4] = "EndDateError";
    DatePickerValidity[DatePickerValidity["CustomFilterError"] = 5] = "CustomFilterError";
    DatePickerValidity[DatePickerValidity["CustomFilterStartDateError"] = 6] = "CustomFilterStartDateError";
    DatePickerValidity[DatePickerValidity["CustomFilterEndDateError"] = 7] = "CustomFilterEndDateError";
    DatePickerValidity[DatePickerValidity["CustomFilterRangeError"] = 8] = "CustomFilterRangeError";
})(DatePickerValidity || (DatePickerValidity = {}));
class UiDatePickerBaseDirective extends NgFormControlDirective {
    get locale() {
        return this._locale;
    }
    set locale(value) {
        this._locale = value;
        this.onLocaleUpdatedBase();
    }
    get required() {
        return this._required;
    }
    set required(value) {
        this._required = coerceBooleanProperty(value);
    }
    set minDate(minDate) {
        this._minDate = minDate ?? DateUtil.getTodayAddingYears(-100);
    }
    get minDate() {
        return this._minDate;
    }
    set maxDate(maxDate) {
        this._maxDate = maxDate ?? DateUtil.getTodayAddingYears(100);
    }
    get maxDate() {
        return this._maxDate;
    }
    get disabled() {
        return this._disabled;
    }
    set disabled(value) {
        this._disabled = coerceBooleanProperty(value);
    }
    get inputFieldFocused() {
        return this._inputFieldFocused;
    }
    get isInvalid() {
        return this.validityState !== DatePickerValidity.Valid;
    }
    get defaultMinDate() {
        return DateUtil.getStartOfDay(this.minDate);
    }
    get defaultMaxDate() {
        return DateUtil.getEndOfDay(this.maxDate);
    }
    get error() {
        return this._error;
    }
    constructor(dateParser, dateFormatService, layoutService, cdr, dateAdapter, eventPropagationService) {
        super();
        this.dateParser = dateParser;
        this.dateFormatService = dateFormatService;
        this.layoutService = layoutService;
        this.cdr = cdr;
        this.dateAdapter = dateAdapter;
        this.eventPropagationService = eventPropagationService;
        this._required = false;
        this.touchUiModeActive = false;
        this._disabled = false;
        this._minDate = DateUtil.getTodayAddingYears(-100);
        this._maxDate = DateUtil.getTodayAddingYears(100);
        this.allowedFormats = [];
        this.validityState = DatePickerValidity.Valid;
        this.errorMessages = [''];
        this.keyboardNavActive = false;
        this._inputFieldFocused = false;
        DateUtil.enableCustomParseFormatForDayJs();
    }
    ngAfterViewInit() {
        this.datepicker?.openedStream.subscribe(() => {
            this.outsideClickSub = this.subscribeToBackdropClick();
            this.assignCssWidthVariable();
            this.onCalendarOpen();
            this.eventPropagationService.startPrevention();
        });
        this.datepicker?.closedStream.subscribe(() => {
            this.outsideClickSub?.unsubscribe();
            this.onCalendarClose();
        });
        this.layoutService.resizeEvent.subscribe(() => {
            this.cdr.detectChanges();
        });
    }
    ngOnInit() {
        this.initializeDateFormat();
    }
    ngOnChanges(changes) {
        const messagePopulationTriggers = ['ErrorMessage'];
        const populateMessages = Object.keys(changes).some(change => {
            return messagePopulationTriggers.some(trigger => change.includes(trigger));
        });
        if (populateMessages) {
            this.populateErrorMessages();
            this.setValidity(this.validityState);
        }
    }
    onInputFieldKeyup(event) {
        const target = event.target;
        const fieldValue = target.value;
        this.validateDate();
        if (KeyboardEventUtil.is(event.key).equalToKey(KeyboardKey.ArrowDown)) {
            this.datepicker.open();
            this.activateKeyboardNav();
            return;
        }
        if (KeyboardEventUtil.is(event.key).equalToKey(KeyboardKey.ArrowUp) && event.altKey) {
            this.deactivateKeyboardNav();
            return;
        }
        if (KeyboardEventUtil.is(event.key).equalToKey(KeyboardKey.Enter)) {
            this.onFieldBlur(event);
            this.onCalendarClose();
            return;
        }
        if (!KeyboardEventUtil.is(event.key).equalToKey(KeyboardKey.Backspace) &&
            this.dateParser.canAppendSeparator(fieldValue, this.locale)) {
            target.value += this.dateFormat.separator;
        }
    }
    validateDate() {
        let validity = DatePickerValidity.Valid;
        validity ||= this.condition(!this.isValidRequired(), DatePickerValidity.RequiredError);
        validity ||= this.condition(!this.hasValidValue(), DatePickerValidity.InvalidDateError);
        validity ||= this.condition(!this.isValidRange(), DatePickerValidity.RangeError);
        this.setValidity(validity);
    }
    onLocaleUpdatedBase() {
        this.initializeDateFormat();
        this.dateAdapter.setLocale(LocaleUtil.convertLocale(this.locale));
        this.onLocaleUpdated();
        this.cdr.detectChanges();
    }
    setValidity(validity) {
        this.validityState = validity;
        this._error = this.errorMessages[validity];
    }
    condition(testCondition, error) {
        return testCondition ? error : DatePickerValidity.Valid;
    }
    activateKeyboardNav() {
        this.getCalendar().focusActiveCell();
        this.getOverlay().activateKeyboardNav();
        this.keyboardNavActive = true;
    }
    deactivateKeyboardNav() {
        this.keyboardNavActive = false;
        this.getOverlay().deactivateKeyboardNav();
    }
    getOverlay() {
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        return this.datepicker._overlay;
    }
    getCalendar() {
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        return this.datepicker._popupComponentRef.instance._calendar;
    }
    subscribeToBackdropClick() {
        return this.getOverlay().backdropClick.subscribe(() => {
            this.focusTimeout = setTimeout(() => {
                this._inputFieldFocused = false;
                this.datepicker.close();
            }, 0);
        });
    }
    focusField(fieldRef) {
        setTimeout(() => {
            fieldRef.nativeElement.focus();
        }, 0);
    }
    populateErrorMessages() {
        ArrayUtil.fromEnum(DatePickerValidity).forEach((validityState) => {
            const errorMessageInput = `${StringUtil.unCapitalize(validityState)}Message`;
            if (this[errorMessageInput]) {
                this.errorMessages[DatePickerValidity[validityState]] = this[errorMessageInput];
            }
        });
    }
    formatDate(date) {
        if (date) {
            return this.dateFormatService.formatDate(date, this.locale);
        }
        return '';
    }
    initializeDateFormat() {
        this.dateFormat = this.dateParser.getDateFormatForLocale(this.locale);
        this.allowedFormats = [
            this.dateFormat.value,
            'YYYY-M-D',
            'M/D/YYYY',
            'D.M.YYYY',
            'DD.MM.YYYY',
            'D. M. YYYY',
            'D M YYYY',
            'D MMM YYYY',
            'MMM D YYYY'
        ];
    }
    assignCssWidthVariable() {
        let datepickerWidth = `${this.pickerWrapper.nativeElement.offsetWidth - 2}px`;
        // In case the datepicker field is below the defined width, fall back to default material styles for datepicker overlay.
        if (this.pickerWrapper.nativeElement.offsetWidth < DATE_PICKER_UNCONTAINED_OVERLAY_MAX_WIDTH) {
            datepickerWidth = 'unset';
        }
        document.documentElement.style.setProperty(ComponentDatepickerWidthVarName, datepickerWidth);
    }
    validateInternal(control) {
        if (control.value) {
            this.validateDate();
        }
        if (this.validityState !== DatePickerValidity.Valid) {
            return { invalid: this.validityState };
        }
        return null;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDatePickerBaseDirective, deps: [{ token: i1$1.DateParserService }, { token: i1$1.DateFormatService }, { token: i1$1.LayoutService }, { token: i0.ChangeDetectorRef }, { token: i3$1.DateAdapter }, { token: UiEventPropagationService }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.9", type: UiDatePickerBaseDirective, selector: "[sieUiDatePickerBase]", inputs: { locale: "locale", label: "label", required: "required", minDate: "minDate", maxDate: "maxDate", customDateFilter: "customDateFilter", requiredErrorMessage: "requiredErrorMessage", invalidDateErrorMessage: "invalidDateErrorMessage", rangeErrorMessage: "rangeErrorMessage", disabled: "disabled" }, host: { properties: { "class.is-disabled": "this.disabled", "class.is-focused": "this.inputFieldFocused", "class.is-invalid": "this.isInvalid" } }, viewQueries: [{ propertyName: "pickerWrapper", first: true, predicate: ["pickerWrapper"], descendants: true }], usesInheritance: true, usesOnChanges: true, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDatePickerBaseDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[sieUiDatePickerBase]'
                }]
        }], ctorParameters: function () { return [{ type: i1$1.DateParserService }, { type: i1$1.DateFormatService }, { type: i1$1.LayoutService }, { type: i0.ChangeDetectorRef }, { type: i3$1.DateAdapter }, { type: UiEventPropagationService }]; }, propDecorators: { locale: [{
                type: Input
            }], label: [{
                type: Input
            }], required: [{
                type: Input
            }], minDate: [{
                type: Input
            }], maxDate: [{
                type: Input
            }], customDateFilter: [{
                type: Input
            }], requiredErrorMessage: [{
                type: Input
            }], invalidDateErrorMessage: [{
                type: Input
            }], rangeErrorMessage: [{
                type: Input
            }], disabled: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['class.is-disabled']
            }], inputFieldFocused: [{
                type: HostBinding,
                args: ['class.is-focused']
            }], isInvalid: [{
                type: HostBinding,
                args: ['class.is-invalid']
            }], pickerWrapper: [{
                type: ViewChild,
                args: ['pickerWrapper']
            }] } });

class UiDatePickerComponent extends UiDatePickerBaseDirective {
    set date(value) {
        this.fieldValue = this.formatDate(value);
        this.currentDateSelection = value;
        this._currentCalendarSelection = value;
    }
    get date() {
        return this.currentDateSelection;
    }
    get hasValue() {
        return !!this._fieldValue;
    }
    get fieldValue() {
        return this._fieldValue;
    }
    set fieldValue(value) {
        this._fieldValue = value;
        this.updatePlaceholder();
    }
    get currentCalendarSelection() {
        return this._currentCalendarSelection;
    }
    // Not unused, used in the ngModel
    set currentCalendarSelection(date) {
        this._currentCalendarSelection = date;
    }
    constructor(iconReg, layoutService, dateParser, dateFormatService, cdr, dateAdapter, eventPropagationService) {
        super(dateParser, dateFormatService, layoutService, cdr, dateAdapter, eventPropagationService);
        this.iconReg = iconReg;
        this.layoutService = layoutService;
        this.dateParser = dateParser;
        this.dateFormatService = dateFormatService;
        this.cdr = cdr;
        this.dateAdapter = dateAdapter;
        this.eventPropagationService = eventPropagationService;
        this.dateChange = new EventEmitter();
        this._fieldValue = '';
        iconReg.register(SieIcon.Calendar);
    }
    dateChanged(event) {
        if (document.activeElement !== this.inputField.nativeElement) {
            this._currentCalendarSelection = event.value;
            this.updateField();
            this.validateDate();
        }
    }
    ngAfterViewInit() {
        super.ngAfterViewInit();
    }
    ngOnChanges(changes) {
        super.ngOnChanges(changes);
    }
    onCalendarOpen() {
        this.focusInputField();
    }
    onCalendarClose() {
        this.touchUiModeActive = false;
        this._inputFieldFocused = false;
        this.currentDateSelection = this._currentCalendarSelection;
        this.validateDate();
        this.dateChange.emit(this.currentDateSelection);
    }
    focusOverlay() {
        this.getCalendar().focusActiveCell();
    }
    onFocus() {
        if (this.disabled) {
            return;
        }
        clearTimeout(this.focusTimeout);
        this._inputFieldFocused = true;
        if (!this.layoutService.isTouchDevice) {
            this.datepicker.open();
            this.focusInputField();
        }
    }
    onKeyup(event) {
        if (KeyboardEventUtil.is(event.key).equalToKey(KeyboardKey.Tab)) {
            const fieldFocused = this.inputField && document.activeElement === this.inputField.nativeElement;
            if (!fieldFocused) {
                this.focusTimeout = setTimeout(() => {
                    if (this.datepicker) {
                        this.datepicker.close();
                    }
                    this._inputFieldFocused = false;
                }, 100);
            }
        }
    }
    onFieldBlur(event) {
        const target = event.target;
        const parsedDate = DateUtil.parseDate(target.value, this.allowedFormats);
        if (parsedDate) {
            this.fieldValue = this.formatDate(parsedDate);
        }
    }
    onInputFieldKeyup(event) {
        super.onInputFieldKeyup(event);
        this._currentCalendarSelection = this.getFieldDate();
    }
    onIconClick() {
        if (this.layoutService.isTouchDevice) {
            this.touchUiModeActive = true;
            this.datepicker.open();
        }
        else {
            this.touchUiModeActive = false;
            this.onFocus();
        }
    }
    focusInputField() {
        this.focusField(this.inputField);
    }
    updatePlaceholder() {
        this.placeholder = this.dateParser.getPlaceholderForValue(this._fieldValue, this.locale);
    }
    updateField() {
        this.fieldValue = this.formatDate(this._currentCalendarSelection);
    }
    isValidRequired() {
        return !this.required || this._fieldValue !== '';
    }
    isValidRange() {
        if (this.currentDateSelection === null || this.currentDateSelection === undefined) {
            return true;
        }
        const selectedTime = this.getFieldDate()?.getTime();
        const pastLimit = Math.max(selectedTime, this.defaultMinDate.getTime());
        const futureLimit = Math.min(selectedTime, this.defaultMaxDate.getTime());
        return selectedTime >= pastLimit && selectedTime <= futureLimit;
    }
    onLocaleUpdated() {
        this.fieldValue = this.formatDate(this.date);
        this.updatePlaceholder();
    }
    hasValidValue() {
        return this._fieldValue === '' || this.getFieldDate() !== null;
    }
    validateDate() {
        super.validateDate();
        let validity = this.validityState;
        validity ||= this.condition(!this.customFilter(), DatePickerValidity.CustomFilterError);
        this.setValidity(validity);
    }
    customFilter() {
        const parsedDate = this.getFieldDate();
        if (this.customDateFilter && parsedDate) {
            return this.customDateFilter(parsedDate);
        }
        return true;
    }
    getFieldDate() {
        return DateUtil.parseDate(this._fieldValue, this.allowedFormats);
    }
    writeValue(value) {
        this.date = value;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDatePickerComponent, deps: [{ token: i1.SieIconRegistryService }, { token: i1$1.LayoutService }, { token: i1$1.DateParserService }, { token: i1$1.DateFormatService }, { token: i0.ChangeDetectorRef }, { token: i3$1.DateAdapter }, { token: UiEventPropagationService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiDatePickerComponent, selector: "sie-ui-date-picker", inputs: { date: "date", customFilterErrorMessage: "customFilterErrorMessage" }, outputs: { dateChange: "dateChange" }, host: { listeners: { "focusin": "onFocus()", "window:keyup": "onKeyup($event)" }, properties: { "class.has-value": "this.hasValue" } }, providers: [DateParserService, MAT_SINGLE_DATE_SELECTION_MODEL_PROVIDER, UiEventPropagationService], viewQueries: [{ propertyName: "datepicker", first: true, predicate: MatDatepicker, descendants: true }, { propertyName: "inputField", first: true, predicate: ["inputField"], descendants: true }], usesInheritance: true, usesOnChanges: true, ngImport: i0, template: "<div class=\"date-picker\" #pickerWrapper *ngIf=\"!readonly; else readOnly\">\n  <mat-form-field appearance=\"fill\" (click)=\"onFocus()\">\n    <mat-label>{{ label }}<span *ngIf=\"required\">*</span></mat-label>\n    <div class=\"date-picker__fields\">\n      <input\n        type=\"text\"\n        class=\"date-picker__placeholder\"\n        [disabled]=\"disabled\"\n        readonly\n        [placeholder]=\"placeholder\"\n        tabindex=\"-1\"\n      />\n      <input\n        matInput\n        class=\"date-picker__input\"\n        [(ngModel)]=\"fieldValue\"\n        (keyup)=\"onInputFieldKeyup($event)\"\n        (keyup.escape)=\"eventPropagationService.handleEvent($event)\"\n        (blur)=\"onFieldBlur($event)\"\n        (focusin)=\"onFocus()\"\n        [disabled]=\"disabled\"\n        [readonly]=\"touchUiModeActive\"\n        [attr.aria-label]=\"label\"\n        #inputField\n      />\n    </div>\n  </mat-form-field>\n  <sie-icon [name]=\"iconReg.sieIcon.Calendar\" class=\"date-picker__icon\" (click)=\"onIconClick()\"></sie-icon>\n  <input\n    matInput\n    type=\"text\"\n    class=\"date-picker__input-hidden\"\n    [value]=\"currentCalendarSelection\"\n    (dateChange)=\"dateChanged($event)\"\n    [matDatepicker]=\"picker\"\n    [matDatepickerFilter]=\"customDateFilter\"\n    [min]=\"minDate\"\n    [max]=\"maxDate\"\n    [disabled]=\"disabled\"\n  />\n  <mat-datepicker\n    panelClass=\"date-picker__calendar\"\n    #picker\n    (focusin)=\"focusOverlay()\"\n    (click)=\"focusOverlay()\"\n    [restoreFocus]=\"false\"\n    [disabled]=\"disabled\"\n    [touchUi]=\"layoutService.isViewport('S') && layoutService.isTouchDevice\"\n  ></mat-datepicker>\n</div>\n<span class=\"date-picker__error\" *ngIf=\"error\">{{ error }}</span>\n\n<ng-template #readOnly>\n  <sie-ui-readonly [value]=\"currentCalendarSelection\" [label]=\"label\" [displayValue]=\"fieldValue\"></sie-ui-readonly>\n</ng-template>\n", styles: [".mat-calendar{font-family:Siemens Sans}.mat-calendar-body{font-size:13px}.mat-calendar-body-label,.mat-calendar-period-button{font-size:14px;font-weight:500}.mat-calendar-table-header th{font-size:11px;font-weight:400}.mat-ripple{overflow:hidden;position:relative}.mat-ripple:not(:empty){transform:translateZ(0)}.mat-ripple.mat-ripple-unbounded{overflow:visible}.mat-ripple-element{position:absolute;border-radius:50%;pointer-events:none;transition:opacity,transform 0ms cubic-bezier(0,0,.2,1);transform:scale3d(0,0,0)}.cdk-high-contrast-active .mat-ripple-element{display:none}.cdk-visually-hidden{border:0;clip:rect(0 0 0 0);height:1px;margin:-1px;overflow:hidden;padding:0;position:absolute;width:1px;white-space:nowrap;outline:0;-webkit-appearance:none;-moz-appearance:none;left:0}[dir=rtl] .cdk-visually-hidden{left:auto;right:0}.cdk-overlay-container,.cdk-global-overlay-wrapper{pointer-events:none;top:0;left:0;height:100%;width:100%}.cdk-overlay-container{position:fixed;z-index:1000}.cdk-overlay-container:empty{display:none}.cdk-global-overlay-wrapper{display:flex;position:absolute;z-index:1000}.cdk-overlay-pane{position:absolute;pointer-events:auto;box-sizing:border-box;z-index:1000;display:flex;max-width:100%;max-height:100%}.cdk-overlay-backdrop{position:absolute;inset:0;z-index:1000;pointer-events:auto;-webkit-tap-highlight-color:transparent;transition:opacity .4s cubic-bezier(.25,.8,.25,1);opacity:0}.cdk-overlay-backdrop.cdk-overlay-backdrop-showing{opacity:1}.cdk-high-contrast-active .cdk-overlay-backdrop.cdk-overlay-backdrop-showing{opacity:.6}.cdk-overlay-dark-backdrop{background:rgba(0,0,0,.32)}.cdk-overlay-transparent-backdrop{transition:visibility 1ms linear,opacity 1ms linear;visibility:hidden;opacity:1}.cdk-overlay-transparent-backdrop.cdk-overlay-backdrop-showing{opacity:0;visibility:visible}.cdk-overlay-backdrop-noop-animation{transition:none}.cdk-overlay-connected-position-bounding-box{position:absolute;z-index:1000;display:flex;flex-direction:column;min-width:1px;min-height:1px}.cdk-global-scrollblock{position:fixed;width:100%;overflow-y:scroll}textarea.cdk-textarea-autosize{resize:none}textarea.cdk-textarea-autosize-measuring{padding:2px 0!important;box-sizing:content-box!important;height:auto!important;overflow:hidden!important}textarea.cdk-textarea-autosize-measuring-firefox{padding:2px 0!important;box-sizing:content-box!important;height:0!important}@keyframes cdk-text-field-autofill-start{}@keyframes cdk-text-field-autofill-end{}.cdk-text-field-autofill-monitored:-webkit-autofill{animation:cdk-text-field-autofill-start 0s 1ms}.cdk-text-field-autofill-monitored:not(:-webkit-autofill){animation:cdk-text-field-autofill-end 0s 1ms}.mat-focus-indicator{position:relative}.mat-focus-indicator:before{inset:0;position:absolute;box-sizing:border-box;pointer-events:none;display:var(--mat-focus-indicator-display, none);border:var(--mat-focus-indicator-border-width, 3px) var(--mat-focus-indicator-border-style, solid) var(--mat-focus-indicator-border-color, transparent);border-radius:var(--mat-focus-indicator-border-radius, 4px)}.mat-focus-indicator:focus:before{content:\"\"}.cdk-high-contrast-active{--mat-focus-indicator-display: block}.mat-mdc-focus-indicator{position:relative}.mat-mdc-focus-indicator:before{inset:0;position:absolute;box-sizing:border-box;pointer-events:none;display:var(--mat-mdc-focus-indicator-display, none);border:var(--mat-mdc-focus-indicator-border-width, 3px) var(--mat-mdc-focus-indicator-border-style, solid) var(--mat-mdc-focus-indicator-border-color, transparent);border-radius:var(--mat-mdc-focus-indicator-border-radius, 4px)}.mat-mdc-focus-indicator:focus:before{content:\"\"}.cdk-high-contrast-active{--mat-mdc-focus-indicator-display: block}.date-picker{container:datepicker/size;height:56px;display:block;position:relative;width:100%;border-bottom:1px solid #4c4c68;background-color:#ebf7f8;color:#000028;font-family:Siemens Sans,sans-serif}.is-focused .date-picker,.date-picker:hover{background-color:#d1fff2;border-bottom-color:#00d7a0;z-index:1201}.is-disabled .date-picker{background-color:#ebf7f8;color:#b3b3be;pointer-events:none;border-bottom-color:transparent}.is-invalid .date-picker{color:#4c4c68;background-color:#fcccd7;border-bottom-color:#ef0137}.date-picker .mat-mdc-text-field-wrapper,.date-picker .mat-mdc-form-field-infix,.date-picker .mat-mdc-form-field-flex{height:100%}.date-picker .mdc-line-ripple{display:none}.date-picker__field-wrapper{position:relative}.date-picker__fields{position:relative;height:12px;top:20px}@container datepicker (width < 142px){.date-picker__fields{font-size:.875rem}}.date-picker__input{position:absolute;top:1px}.is-disabled .date-picker__input{color:#b3b3be}.date-picker__input-hidden{visibility:hidden;pointer-events:none;position:absolute;top:0;left:0;height:100%}.date-picker__placeholder{font-size:1rem;font-weight:400;line-height:1.5rem;opacity:0;position:absolute;left:0;font:inherit;background:transparent;color:#9999a9;font-family:Siemens Sans,sans-serif;border:none;outline:none;padding:0;margin:0;width:100%;max-width:100%;vertical-align:bottom;text-align:inherit;box-sizing:content-box;pointer-events:none;top:1px;letter-spacing:inherit}.date-picker__placeholder::placeholder{color:#9999a9}.is-focused .date-picker__placeholder,.has-value .date-picker__placeholder{opacity:1}.date-picker__overlay-input{position:absolute;top:0;bottom:0;left:0;width:100%}.date-picker__icon{width:20px;height:20px;display:flex;align-items:center;fill:currentColor;position:absolute;top:18px;right:14px;bottom:18px;cursor:pointer;color:#4c4c68}.date-picker__icon svg{fill:currentColor;width:inherit;height:inherit}.date-picker__icon svg g{fill:currentColor;width:inherit;height:inherit}.date-picker__icon svg text{font-family:Siemens Sans,sans-serif}.is-disabled .date-picker__icon{cursor:not-allowed;color:#b3b3be!important}.is-focused .date-picker__icon,.date-picker:hover .date-picker__icon{color:#00646e}.date-picker__error{font-size:.875rem;font-weight:400;line-height:1.25rem;display:block;padding:4px 16px;color:#ef0137}.date-picker .mat-mdc-form-field-wrapper{padding-bottom:0}.date-picker .mat-mdc-form-field-infix{border-top-width:10px}.date-picker .mat-mdc-form-field-label,.date-picker .mdc-floating-label{font-size:1rem;font-weight:400;line-height:1.5rem;font-family:Siemens Sans,sans-serif;color:#4c4c68}@container datepicker (width < 142px){.date-picker .mat-mdc-form-field-label,.date-picker .mdc-floating-label{font-size:.875rem}}.is-focused .date-picker .mat-mdc-form-field-label,.date-picker .mat-mdc-form-field-should-float .mat-mdc-form-field-label,.date-picker .mat-focused .mat-mdc-form-field-label{transform:translateY(-.59375em) scale(.75);transition:transform .4s cubic-bezier(.2,0,.38,.9)}.is-focused .date-picker .mat-mdc-form-field-should-float .date-picker__placeholder{opacity:1}.date-picker .mat-mdc-form-field{display:block;font-family:Siemens Sans;height:100%}.date-picker .mat-mdc-form-field-appearance-fill .mat-mdc-form-field-flex{padding-left:1rem}.mat-calendar,.mat-mdc-button,.mdc-button,.mat-mdc-raised-button,.mat-mdc-icon-button,.mat-mdc-outlined-button,.mat-mdc-unelevated-button,.mat-mdc-fab,.mat-mdc-mini-fab,.mat-mdc-input-element.date-picker__input,.mat-datepicker-content .mdc-button{font-family:Siemens Sans,sans-serif}.mat-datepicker-popup{border:1px solid #ccccd4;box-shadow:0 2px 2px #0000000f,0 4px 8px #0000001f;background-color:#fff}.mat-datepicker-dialog{background-color:#fff}.date-picker__calendar .mat-calendar-table-header-divider:after{background:#ccccd4}.date-picker__calendar .mat-calendar-body-cell-content{border:0}.date-picker__calendar .mat-calendar-body-cell-content:hover{background-color:#e5e5e9}.keyboard-nav-active .date-picker__calendar .mat-calendar-body-active .mat-calendar-body-cell-content{background-color:#e5e5e9;color:#000028}.date-picker__calendar .mat-calendar-body-today{border:1px solid #ccccd4}.date-picker__calendar .mat-calendar-body-selected{background-color:#00646e;color:#fff}.date-picker__calendar .mat-calendar-body-selected:hover{background-color:#00646e}.date-picker__calendar .mat-calendar-body-disabled{color:#b3b3be}.date-picker__calendar .mat-calendar-body-disabled .mat-calendar-body-cell-content:hover{background:none}.date-picker__calendar .mat-calendar-body-in-preview .mat-calendar-body-cell-preview{background-color:#e5e5e9;border:0}.date-picker__calendar .mat-calendar-body-in-range .mat-calendar-body-cell-preview{background-color:#c5ffef}.date-picker__calendar .mat-calendar-body-in-range.mat-calendar-body-range-start .mat-calendar-body-cell-preview{background:linear-gradient(to right,rgba(255,255,255,0) 0,rgba(255,255,255,0) 50%,#c5ffef 50%);border-top-left-radius:50%;border-bottom-left-radius:50%}.date-picker__calendar .mat-calendar-body-in-range.mat-calendar-body-range-end .mat-calendar-body-cell-preview{background:linear-gradient(to right,#c5ffef 0,#c5ffef 50%,rgba(255,255,255,0) 50%);border-top-right-radius:50%;border-bottom-right-radius:50%}.date-picker__calendar .mat-calendar-period-button{font-size:1rem;font-weight:400;line-height:1.5rem;font-family:Siemens Sans;background:transparent;color:#4c4c68}.date-picker__calendar .mat-calendar-period-button:hover{background-color:#e5e5e9}.date-picker__calendar .mat-calendar-next-button,.date-picker__calendar .mat-calendar-previous-button{background:transparent;height:40px!important;width:40px!important}.date-picker__calendar .mat-calendar-next-button:not(.mat-mdc-button-disabled):hover,.date-picker__calendar .mat-calendar-previous-button:not(.mat-mdc-button-disabled):hover{background-color:#e5e5e9}.mat-datepicker-content .mat-calendar.date-picker__calendar{width:var(--active-datepicker-width, 296px);height:auto}.mat-datepicker-content-touch.mat-datepicker-content .mat-calendar.date-picker__calendar{width:100%;height:auto}.cdk-overlay-container{z-index:1200}@media (hover: none) and (pointer: coarse) and (max-width: 639.78px){.cdk-overlay-container{background-color:#00000040}}\n"], dependencies: [{ kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "directive", type: i3.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i3.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i3.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "component", type: i7.MatFormField, selector: "mat-form-field", inputs: ["hideRequiredMarker", "color", "floatLabel", "appearance", "subscriptSizing", "hintLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i7.MatLabel, selector: "mat-label" }, { kind: "directive", type: i8.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly"], exportAs: ["matInput"] }, { kind: "component", type: i7$1.MatDatepicker, selector: "mat-datepicker", exportAs: ["matDatepicker"] }, { kind: "directive", type: i7$1.MatDatepickerInput, selector: "input[matDatepicker]", inputs: ["matDatepicker", "min", "max", "matDatepickerFilter"], exportAs: ["matDatepickerInput"] }, { kind: "component", type: UiReadonlyComponent, selector: "sie-ui-readonly", inputs: ["value", "label", "displayValue", "name", "theme", "icons"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDatePickerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-date-picker', changeDetection: ChangeDetectionStrategy.OnPush, encapsulation: ViewEncapsulation.None, providers: [DateParserService, MAT_SINGLE_DATE_SELECTION_MODEL_PROVIDER, UiEventPropagationService], template: "<div class=\"date-picker\" #pickerWrapper *ngIf=\"!readonly; else readOnly\">\n  <mat-form-field appearance=\"fill\" (click)=\"onFocus()\">\n    <mat-label>{{ label }}<span *ngIf=\"required\">*</span></mat-label>\n    <div class=\"date-picker__fields\">\n      <input\n        type=\"text\"\n        class=\"date-picker__placeholder\"\n        [disabled]=\"disabled\"\n        readonly\n        [placeholder]=\"placeholder\"\n        tabindex=\"-1\"\n      />\n      <input\n        matInput\n        class=\"date-picker__input\"\n        [(ngModel)]=\"fieldValue\"\n        (keyup)=\"onInputFieldKeyup($event)\"\n        (keyup.escape)=\"eventPropagationService.handleEvent($event)\"\n        (blur)=\"onFieldBlur($event)\"\n        (focusin)=\"onFocus()\"\n        [disabled]=\"disabled\"\n        [readonly]=\"touchUiModeActive\"\n        [attr.aria-label]=\"label\"\n        #inputField\n      />\n    </div>\n  </mat-form-field>\n  <sie-icon [name]=\"iconReg.sieIcon.Calendar\" class=\"date-picker__icon\" (click)=\"onIconClick()\"></sie-icon>\n  <input\n    matInput\n    type=\"text\"\n    class=\"date-picker__input-hidden\"\n    [value]=\"currentCalendarSelection\"\n    (dateChange)=\"dateChanged($event)\"\n    [matDatepicker]=\"picker\"\n    [matDatepickerFilter]=\"customDateFilter\"\n    [min]=\"minDate\"\n    [max]=\"maxDate\"\n    [disabled]=\"disabled\"\n  />\n  <mat-datepicker\n    panelClass=\"date-picker__calendar\"\n    #picker\n    (focusin)=\"focusOverlay()\"\n    (click)=\"focusOverlay()\"\n    [restoreFocus]=\"false\"\n    [disabled]=\"disabled\"\n    [touchUi]=\"layoutService.isViewport('S') && layoutService.isTouchDevice\"\n  ></mat-datepicker>\n</div>\n<span class=\"date-picker__error\" *ngIf=\"error\">{{ error }}</span>\n\n<ng-template #readOnly>\n  <sie-ui-readonly [value]=\"currentCalendarSelection\" [label]=\"label\" [displayValue]=\"fieldValue\"></sie-ui-readonly>\n</ng-template>\n", styles: [".mat-calendar{font-family:Siemens Sans}.mat-calendar-body{font-size:13px}.mat-calendar-body-label,.mat-calendar-period-button{font-size:14px;font-weight:500}.mat-calendar-table-header th{font-size:11px;font-weight:400}.mat-ripple{overflow:hidden;position:relative}.mat-ripple:not(:empty){transform:translateZ(0)}.mat-ripple.mat-ripple-unbounded{overflow:visible}.mat-ripple-element{position:absolute;border-radius:50%;pointer-events:none;transition:opacity,transform 0ms cubic-bezier(0,0,.2,1);transform:scale3d(0,0,0)}.cdk-high-contrast-active .mat-ripple-element{display:none}.cdk-visually-hidden{border:0;clip:rect(0 0 0 0);height:1px;margin:-1px;overflow:hidden;padding:0;position:absolute;width:1px;white-space:nowrap;outline:0;-webkit-appearance:none;-moz-appearance:none;left:0}[dir=rtl] .cdk-visually-hidden{left:auto;right:0}.cdk-overlay-container,.cdk-global-overlay-wrapper{pointer-events:none;top:0;left:0;height:100%;width:100%}.cdk-overlay-container{position:fixed;z-index:1000}.cdk-overlay-container:empty{display:none}.cdk-global-overlay-wrapper{display:flex;position:absolute;z-index:1000}.cdk-overlay-pane{position:absolute;pointer-events:auto;box-sizing:border-box;z-index:1000;display:flex;max-width:100%;max-height:100%}.cdk-overlay-backdrop{position:absolute;inset:0;z-index:1000;pointer-events:auto;-webkit-tap-highlight-color:transparent;transition:opacity .4s cubic-bezier(.25,.8,.25,1);opacity:0}.cdk-overlay-backdrop.cdk-overlay-backdrop-showing{opacity:1}.cdk-high-contrast-active .cdk-overlay-backdrop.cdk-overlay-backdrop-showing{opacity:.6}.cdk-overlay-dark-backdrop{background:rgba(0,0,0,.32)}.cdk-overlay-transparent-backdrop{transition:visibility 1ms linear,opacity 1ms linear;visibility:hidden;opacity:1}.cdk-overlay-transparent-backdrop.cdk-overlay-backdrop-showing{opacity:0;visibility:visible}.cdk-overlay-backdrop-noop-animation{transition:none}.cdk-overlay-connected-position-bounding-box{position:absolute;z-index:1000;display:flex;flex-direction:column;min-width:1px;min-height:1px}.cdk-global-scrollblock{position:fixed;width:100%;overflow-y:scroll}textarea.cdk-textarea-autosize{resize:none}textarea.cdk-textarea-autosize-measuring{padding:2px 0!important;box-sizing:content-box!important;height:auto!important;overflow:hidden!important}textarea.cdk-textarea-autosize-measuring-firefox{padding:2px 0!important;box-sizing:content-box!important;height:0!important}@keyframes cdk-text-field-autofill-start{}@keyframes cdk-text-field-autofill-end{}.cdk-text-field-autofill-monitored:-webkit-autofill{animation:cdk-text-field-autofill-start 0s 1ms}.cdk-text-field-autofill-monitored:not(:-webkit-autofill){animation:cdk-text-field-autofill-end 0s 1ms}.mat-focus-indicator{position:relative}.mat-focus-indicator:before{inset:0;position:absolute;box-sizing:border-box;pointer-events:none;display:var(--mat-focus-indicator-display, none);border:var(--mat-focus-indicator-border-width, 3px) var(--mat-focus-indicator-border-style, solid) var(--mat-focus-indicator-border-color, transparent);border-radius:var(--mat-focus-indicator-border-radius, 4px)}.mat-focus-indicator:focus:before{content:\"\"}.cdk-high-contrast-active{--mat-focus-indicator-display: block}.mat-mdc-focus-indicator{position:relative}.mat-mdc-focus-indicator:before{inset:0;position:absolute;box-sizing:border-box;pointer-events:none;display:var(--mat-mdc-focus-indicator-display, none);border:var(--mat-mdc-focus-indicator-border-width, 3px) var(--mat-mdc-focus-indicator-border-style, solid) var(--mat-mdc-focus-indicator-border-color, transparent);border-radius:var(--mat-mdc-focus-indicator-border-radius, 4px)}.mat-mdc-focus-indicator:focus:before{content:\"\"}.cdk-high-contrast-active{--mat-mdc-focus-indicator-display: block}.date-picker{container:datepicker/size;height:56px;display:block;position:relative;width:100%;border-bottom:1px solid #4c4c68;background-color:#ebf7f8;color:#000028;font-family:Siemens Sans,sans-serif}.is-focused .date-picker,.date-picker:hover{background-color:#d1fff2;border-bottom-color:#00d7a0;z-index:1201}.is-disabled .date-picker{background-color:#ebf7f8;color:#b3b3be;pointer-events:none;border-bottom-color:transparent}.is-invalid .date-picker{color:#4c4c68;background-color:#fcccd7;border-bottom-color:#ef0137}.date-picker .mat-mdc-text-field-wrapper,.date-picker .mat-mdc-form-field-infix,.date-picker .mat-mdc-form-field-flex{height:100%}.date-picker .mdc-line-ripple{display:none}.date-picker__field-wrapper{position:relative}.date-picker__fields{position:relative;height:12px;top:20px}@container datepicker (width < 142px){.date-picker__fields{font-size:.875rem}}.date-picker__input{position:absolute;top:1px}.is-disabled .date-picker__input{color:#b3b3be}.date-picker__input-hidden{visibility:hidden;pointer-events:none;position:absolute;top:0;left:0;height:100%}.date-picker__placeholder{font-size:1rem;font-weight:400;line-height:1.5rem;opacity:0;position:absolute;left:0;font:inherit;background:transparent;color:#9999a9;font-family:Siemens Sans,sans-serif;border:none;outline:none;padding:0;margin:0;width:100%;max-width:100%;vertical-align:bottom;text-align:inherit;box-sizing:content-box;pointer-events:none;top:1px;letter-spacing:inherit}.date-picker__placeholder::placeholder{color:#9999a9}.is-focused .date-picker__placeholder,.has-value .date-picker__placeholder{opacity:1}.date-picker__overlay-input{position:absolute;top:0;bottom:0;left:0;width:100%}.date-picker__icon{width:20px;height:20px;display:flex;align-items:center;fill:currentColor;position:absolute;top:18px;right:14px;bottom:18px;cursor:pointer;color:#4c4c68}.date-picker__icon svg{fill:currentColor;width:inherit;height:inherit}.date-picker__icon svg g{fill:currentColor;width:inherit;height:inherit}.date-picker__icon svg text{font-family:Siemens Sans,sans-serif}.is-disabled .date-picker__icon{cursor:not-allowed;color:#b3b3be!important}.is-focused .date-picker__icon,.date-picker:hover .date-picker__icon{color:#00646e}.date-picker__error{font-size:.875rem;font-weight:400;line-height:1.25rem;display:block;padding:4px 16px;color:#ef0137}.date-picker .mat-mdc-form-field-wrapper{padding-bottom:0}.date-picker .mat-mdc-form-field-infix{border-top-width:10px}.date-picker .mat-mdc-form-field-label,.date-picker .mdc-floating-label{font-size:1rem;font-weight:400;line-height:1.5rem;font-family:Siemens Sans,sans-serif;color:#4c4c68}@container datepicker (width < 142px){.date-picker .mat-mdc-form-field-label,.date-picker .mdc-floating-label{font-size:.875rem}}.is-focused .date-picker .mat-mdc-form-field-label,.date-picker .mat-mdc-form-field-should-float .mat-mdc-form-field-label,.date-picker .mat-focused .mat-mdc-form-field-label{transform:translateY(-.59375em) scale(.75);transition:transform .4s cubic-bezier(.2,0,.38,.9)}.is-focused .date-picker .mat-mdc-form-field-should-float .date-picker__placeholder{opacity:1}.date-picker .mat-mdc-form-field{display:block;font-family:Siemens Sans;height:100%}.date-picker .mat-mdc-form-field-appearance-fill .mat-mdc-form-field-flex{padding-left:1rem}.mat-calendar,.mat-mdc-button,.mdc-button,.mat-mdc-raised-button,.mat-mdc-icon-button,.mat-mdc-outlined-button,.mat-mdc-unelevated-button,.mat-mdc-fab,.mat-mdc-mini-fab,.mat-mdc-input-element.date-picker__input,.mat-datepicker-content .mdc-button{font-family:Siemens Sans,sans-serif}.mat-datepicker-popup{border:1px solid #ccccd4;box-shadow:0 2px 2px #0000000f,0 4px 8px #0000001f;background-color:#fff}.mat-datepicker-dialog{background-color:#fff}.date-picker__calendar .mat-calendar-table-header-divider:after{background:#ccccd4}.date-picker__calendar .mat-calendar-body-cell-content{border:0}.date-picker__calendar .mat-calendar-body-cell-content:hover{background-color:#e5e5e9}.keyboard-nav-active .date-picker__calendar .mat-calendar-body-active .mat-calendar-body-cell-content{background-color:#e5e5e9;color:#000028}.date-picker__calendar .mat-calendar-body-today{border:1px solid #ccccd4}.date-picker__calendar .mat-calendar-body-selected{background-color:#00646e;color:#fff}.date-picker__calendar .mat-calendar-body-selected:hover{background-color:#00646e}.date-picker__calendar .mat-calendar-body-disabled{color:#b3b3be}.date-picker__calendar .mat-calendar-body-disabled .mat-calendar-body-cell-content:hover{background:none}.date-picker__calendar .mat-calendar-body-in-preview .mat-calendar-body-cell-preview{background-color:#e5e5e9;border:0}.date-picker__calendar .mat-calendar-body-in-range .mat-calendar-body-cell-preview{background-color:#c5ffef}.date-picker__calendar .mat-calendar-body-in-range.mat-calendar-body-range-start .mat-calendar-body-cell-preview{background:linear-gradient(to right,rgba(255,255,255,0) 0,rgba(255,255,255,0) 50%,#c5ffef 50%);border-top-left-radius:50%;border-bottom-left-radius:50%}.date-picker__calendar .mat-calendar-body-in-range.mat-calendar-body-range-end .mat-calendar-body-cell-preview{background:linear-gradient(to right,#c5ffef 0,#c5ffef 50%,rgba(255,255,255,0) 50%);border-top-right-radius:50%;border-bottom-right-radius:50%}.date-picker__calendar .mat-calendar-period-button{font-size:1rem;font-weight:400;line-height:1.5rem;font-family:Siemens Sans;background:transparent;color:#4c4c68}.date-picker__calendar .mat-calendar-period-button:hover{background-color:#e5e5e9}.date-picker__calendar .mat-calendar-next-button,.date-picker__calendar .mat-calendar-previous-button{background:transparent;height:40px!important;width:40px!important}.date-picker__calendar .mat-calendar-next-button:not(.mat-mdc-button-disabled):hover,.date-picker__calendar .mat-calendar-previous-button:not(.mat-mdc-button-disabled):hover{background-color:#e5e5e9}.mat-datepicker-content .mat-calendar.date-picker__calendar{width:var(--active-datepicker-width, 296px);height:auto}.mat-datepicker-content-touch.mat-datepicker-content .mat-calendar.date-picker__calendar{width:100%;height:auto}.cdk-overlay-container{z-index:1200}@media (hover: none) and (pointer: coarse) and (max-width: 639.78px){.cdk-overlay-container{background-color:#00000040}}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }, { type: i1$1.LayoutService }, { type: i1$1.DateParserService }, { type: i1$1.DateFormatService }, { type: i0.ChangeDetectorRef }, { type: i3$1.DateAdapter }, { type: UiEventPropagationService }]; }, propDecorators: { date: [{
                type: Input
            }], customFilterErrorMessage: [{
                type: Input
            }], dateChange: [{
                type: Output
            }], datepicker: [{
                type: ViewChild,
                args: [MatDatepicker]
            }], inputField: [{
                type: ViewChild,
                args: ['inputField']
            }], hasValue: [{
                type: HostBinding,
                args: ['class.has-value']
            }], onFocus: [{
                type: HostListener,
                args: ['focusin']
            }], onKeyup: [{
                type: HostListener,
                args: ['window:keyup', ['$event']]
            }] } });

class UiDatePickerOverlay extends Overlay {
    constructor() {
        super(...arguments);
        this._backdropClick = new Subject();
    }
    get backdropClick() {
        return this._backdropClick;
    }
    get hostElement() {
        return this._hostElement;
    }
    create(config) {
        const overlayRef = super.create({
            ...config,
            hasBackdrop: true
        });
        overlayRef.backdropClick().subscribe(e => {
            this._backdropClick.next(e);
        });
        this._hostElement = overlayRef.hostElement;
        return overlayRef;
    }
    activateKeyboardNav() {
        this._hostElement.classList.add(ComponentDatepickerKeyboardNavClassName);
    }
    deactivateKeyboardNav() {
        this._hostElement.classList.remove(ComponentDatepickerKeyboardNavClassName);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDatePickerOverlay, deps: null, target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDatePickerOverlay }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDatePickerOverlay, decorators: [{
            type: Injectable
        }], propDecorators: { _calendar: [{
                type: ContentChild,
                args: [MatCalendar]
            }] } });

const SUNDAY = 0;
const MONDAY = 1;
class UiDatePickerDateAdapter extends NativeDateAdapter {
    constructor(matDateLocale, platform) {
        super(matDateLocale, platform);
    }
    getDayOfWeekNames() {
        return DateUtil.getWeekdayNames('short', this.locale).map(dayName => dayName.slice(0, 2).toUpperCase());
    }
    getMonthNames(style) {
        return DateUtil.getMonthNames(style, this.locale);
    }
    isValid(date) {
        return !isNaN(date?.getTime());
    }
    getFirstDayOfWeek() {
        const locale = this.locale;
        if (locale.startsWith('en')) {
            return SUNDAY;
        }
        return MONDAY;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDatePickerDateAdapter, deps: [{ token: MAT_DATE_LOCALE, optional: true }, { token: i1$3.Platform }], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDatePickerDateAdapter }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDatePickerDateAdapter, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return [{ type: undefined, decorators: [{
                    type: Optional
                }, {
                    type: Inject,
                    args: [MAT_DATE_LOCALE]
                }] }, { type: i1$3.Platform }]; } });

const DATE_PICKER_OVERLAY_PROVIDER = {
    provide: Overlay,
    useClass: UiDatePickerOverlay
};
const DATE_PICKER_DATE_ADAPTER_PROVIDER = {
    provide: DateAdapter,
    useClass: UiDatePickerDateAdapter
};
const DATE_PICKER_DATE_FORMATS_PROVIDER = {
    provide: MAT_DATE_FORMATS,
    useValue: DATE_PICKER_FORMATS
};

class UiDatePickerBaseModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDatePickerBaseModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiDatePickerBaseModule, imports: [SieCorePipesModule,
            SieIconsModule,
            FormsModule,
            MatNativeDateModule,
            MatFormFieldModule,
            MatInputModule,
            MatDatepickerModule], exports: [SieCorePipesModule,
            SieIconsModule,
            FormsModule,
            MatNativeDateModule,
            MatFormFieldModule,
            MatInputModule,
            MatDatepickerModule] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDatePickerBaseModule, providers: [
            DateFormatService,
            DATE_PICKER_OVERLAY_PROVIDER,
            DATE_PICKER_DATE_ADAPTER_PROVIDER,
            DATE_PICKER_DATE_FORMATS_PROVIDER
        ], imports: [SieCorePipesModule,
            SieIconsModule,
            FormsModule,
            MatNativeDateModule,
            MatFormFieldModule,
            MatInputModule,
            MatDatepickerModule, SieCorePipesModule,
            SieIconsModule,
            FormsModule,
            MatNativeDateModule,
            MatFormFieldModule,
            MatInputModule,
            MatDatepickerModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDatePickerBaseModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [],
                    imports: [
                        SieCorePipesModule,
                        SieIconsModule,
                        FormsModule,
                        MatNativeDateModule,
                        MatFormFieldModule,
                        MatInputModule,
                        MatDatepickerModule
                    ],
                    exports: [
                        SieCorePipesModule,
                        SieIconsModule,
                        FormsModule,
                        MatNativeDateModule,
                        MatFormFieldModule,
                        MatInputModule,
                        MatDatepickerModule
                    ],
                    providers: [
                        DateFormatService,
                        DATE_PICKER_OVERLAY_PROVIDER,
                        DATE_PICKER_DATE_ADAPTER_PROVIDER,
                        DATE_PICKER_DATE_FORMATS_PROVIDER
                    ]
                }]
        }] });

class UiDatePickerModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDatePickerModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiDatePickerModule, declarations: [UiDatePickerComponent], imports: [CommonModule, UiDatePickerBaseModule, MatDatepickerModule, UiReadonlyModule], exports: [UiDatePickerComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDatePickerModule, imports: [CommonModule, UiDatePickerBaseModule, MatDatepickerModule, UiReadonlyModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDatePickerModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiDatePickerComponent],
                    imports: [CommonModule, UiDatePickerBaseModule, MatDatepickerModule, UiReadonlyModule],
                    exports: [UiDatePickerComponent]
                }]
        }] });

class UiDateRangePickerComponent extends UiDatePickerBaseDirective {
    set startDate(value) {
        this.startDateFieldValue = this.formatDate(value);
        this.currentStartDateSelection = value;
        this._currentCalendarStartDateSelection = value;
        if (this.additionalValidationRequired && !value) {
            this.validateDate();
        }
    }
    get startDate() {
        return this.currentStartDateSelection;
    }
    set endDate(value) {
        this.endDateFieldValue = this.formatDate(value);
        this.currentEndDateSelection = value;
        this._currentCalendarEndDateSelection = value;
        if (this.additionalValidationRequired && !value) {
            this.validateDate();
        }
    }
    get endDate() {
        return this.currentEndDateSelection;
    }
    get hasValue() {
        return !!this._startDateFieldValue || !!this._endDateFieldValue;
    }
    get startDateFieldValue() {
        return this._startDateFieldValue;
    }
    set startDateFieldValue(value) {
        this._startDateFieldValue = value;
        this.updatePlaceholder();
    }
    get endDateFieldValue() {
        return this._endDateFieldValue;
    }
    set endDateFieldValue(value) {
        this._endDateFieldValue = value;
        this.updatePlaceholder();
    }
    get startDatePlaceholder() {
        return this._startDatePlaceholder;
    }
    set startDatePlaceholder(value) {
        this._startDatePlaceholder = value;
    }
    get endDatePlaceholder() {
        return this._endDatePlaceholder;
    }
    set endDatePlaceholder(value) {
        this._endDatePlaceholder = value;
    }
    get currentCalendarStartDateSelection() {
        return this._currentCalendarStartDateSelection;
    }
    get currentCalendarEndDateSelection() {
        return this._currentCalendarEndDateSelection;
    }
    constructor(iconReg, layoutService, dateParser, dateFormatService, cdr, dateAdapter, eventPropagationService) {
        super(dateParser, dateFormatService, layoutService, cdr, dateAdapter, eventPropagationService);
        this.iconReg = iconReg;
        this.layoutService = layoutService;
        this.dateParser = dateParser;
        this.dateFormatService = dateFormatService;
        this.cdr = cdr;
        this.dateAdapter = dateAdapter;
        this.eventPropagationService = eventPropagationService;
        this.endDateChange = new EventEmitter();
        this.startDateChange = new EventEmitter();
        this.dateRangeSelected = new EventEmitter();
        this._startDateFieldValue = '';
        this._endDateFieldValue = '';
        this._startDatePlaceholder = '';
        this._endDatePlaceholder = '';
        this.additionalValidationRequired = false;
        this.currentCalendarRange = new UntypedFormGroup({
            start: new UntypedFormControl(),
            end: new UntypedFormControl()
        });
        this.dateRangeSelectionChangeSubscription = new Subscription();
        iconReg.register(SieIcon.Calendar);
    }
    ngOnInit() {
        super.ngOnInit();
        this.dateRangeSelectionChangeSubscription.add(this.dateRangeSelected.subscribe(range => {
            this.markAsTouched();
            this.onChange(range);
        }));
    }
    ngOnDestroy() {
        this.dateRangeSelectionChangeSubscription.unsubscribe();
    }
    ngAfterViewInit() {
        super.ngAfterViewInit();
    }
    ngOnChanges(changes) {
        super.ngOnChanges(changes);
    }
    onCalendarClose() {
        this.touchUiModeActive = false;
        this._inputFieldFocused = false;
        this.currentStartDateSelection = this.currentCalendarStartDateSelection;
        this.currentEndDateSelection = this.currentCalendarEndDateSelection;
        this.inputTabbed = false;
        this.validateDate();
        if (this.validityState === DatePickerValidity.Valid) {
            this.dateRangeSelected.emit({ dateFrom: this.currentStartDateSelection, dateTo: this.currentEndDateSelection });
        }
        else {
            this.dateRangeSelected.emit({ dateFrom: null, dateTo: null });
        }
        this.startDateChange.emit(this.currentStartDateSelection);
        this.endDateChange.emit(this.currentEndDateSelection);
    }
    onCalendarOpen() {
        if (!this.touchUiModeActive) {
            this.focusInputField();
        }
    }
    dateChanged(event) {
        if (document.activeElement !== this.startInputField.nativeElement &&
            document.activeElement !== this.endInputField.nativeElement) {
            if (event.target instanceof MatStartDate) {
                this._currentCalendarStartDateSelection = event.value;
            }
            if (event.target instanceof MatEndDate) {
                this._currentCalendarEndDateSelection = event.value;
            }
            this.updateField(event);
            this.validateDate();
        }
        this.additionalValidationRequired = true;
    }
    onFocus() {
        clearTimeout(this.focusTimeout);
        this._inputFieldFocused = true;
        // Don't open datepicker on touch devices
        if (!this.layoutService.isTouchDevice && !this.inputTabbed) {
            this.datepicker.open();
            this.focusInputField();
        }
    }
    onTab(event) {
        if (KeyboardEventUtil.is(event.key).equalToKey(KeyboardKey.Tab)) {
            const startFieldFocused = this.startInputField && document.activeElement === this.startInputField.nativeElement;
            const endFieldFocused = this.endInputField && document.activeElement === this.endInputField.nativeElement;
            this.inputTabbed = true;
            if (!startFieldFocused && !endFieldFocused) {
                this.focusTimeout = setTimeout(() => {
                    if (this.datepicker) {
                        this.datepicker.close();
                    }
                    this._inputFieldFocused = false;
                }, 100);
                this.inputTabbed = false;
            }
        }
    }
    onInputFieldKeyup(event) {
        super.onInputFieldKeyup(event);
        const fieldDate = this.getFieldDate(event.target);
        if (event.target === this.startInputField.nativeElement) {
            this._currentCalendarStartDateSelection = fieldDate;
        }
        if (event.target === this.endInputField.nativeElement) {
            this._currentCalendarEndDateSelection = fieldDate;
        }
    }
    onFieldBlur(event) {
        const target = event.target;
        const parsedDate = DateUtil.parseDate(target.value, this.allowedFormats);
        if (parsedDate) {
            if (target === this.startInputField.nativeElement) {
                this.startDateFieldValue = this.formatDate(parsedDate);
            }
            if (target === this.endInputField.nativeElement) {
                this.endDateFieldValue = this.formatDate(parsedDate);
                this.inputTabbed = false;
            }
        }
    }
    onIconClick() {
        if (this.layoutService.isTouchDevice) {
            this.touchUiModeActive = true;
            this.datepicker.open();
        }
        else {
            this.onFocus();
        }
    }
    focusInputField() {
        let field;
        if (!this.startDateFieldValue || !this.endDateFieldValue) {
            field = this.startInputField;
        }
        else {
            field = this.endInputField;
        }
        this.focusField(field);
    }
    validateDate() {
        super.validateDate();
        let validity = this.validityState;
        validity ||= this.condition(!this.isValidEndDate(), DatePickerValidity.EndDateError);
        const selectedStartTime = this.getFieldDate(this.startInputField.nativeElement);
        const selectedEndTime = this.getFieldDate(this.endInputField.nativeElement);
        if (this.customDateFilter && (selectedStartTime || selectedEndTime)) {
            validity ||= this.condition(!this.validateCustomFilterStart(selectedStartTime, selectedEndTime), DatePickerValidity.CustomFilterStartDateError);
            validity ||= this.condition(!this.validateCustomFilterEnd(selectedStartTime, selectedEndTime), DatePickerValidity.CustomFilterEndDateError);
            validity ||= this.condition(!this.validateCustomFilterRange(selectedStartTime, selectedEndTime), DatePickerValidity.CustomFilterRangeError);
        }
        this.setValidity(validity);
    }
    isValidRequired() {
        return !this.required || (this._startDateFieldValue !== '' && this._endDateFieldValue !== '');
    }
    isValidRange() {
        if (!this.currentStartDateSelection && !this.currentEndDateSelection) {
            return true;
        }
        const selectedStartTime = this.getFieldDate(this.startInputField.nativeElement)?.getTime();
        const selectedEndTime = this.getFieldDate(this.endInputField.nativeElement)?.getTime();
        const isInRange = (selectedTime) => {
            const pastLimit = Math.max(selectedTime, this.defaultMinDate.getTime());
            const futureLimit = Math.min(selectedTime, this.defaultMaxDate.getTime());
            return selectedTime >= pastLimit && selectedTime <= futureLimit;
        };
        return isInRange(selectedStartTime) && isInRange(selectedEndTime);
    }
    isValidEndDate() {
        const selectedStartTime = this.getFieldDate(this.startInputField.nativeElement)?.getTime();
        const selectedEndTime = this.getFieldDate(this.endInputField.nativeElement)?.getTime();
        if (selectedEndTime && selectedStartTime) {
            return selectedEndTime >= selectedStartTime;
        }
        else {
            return true;
        }
    }
    validateCustomFilterStart(start, end) {
        return this.customDateFilter(start) || !this.customDateFilter(end);
    }
    validateCustomFilterEnd(start, end) {
        return !this.customDateFilter(start) || this.customDateFilter(end);
    }
    validateCustomFilterRange(start, end) {
        return this.customDateFilter(start) && this.customDateFilter(end);
    }
    hasValidValue() {
        return ((this._startDateFieldValue === '' || this.getFieldDate(this.startInputField.nativeElement) !== null) &&
            (this._endDateFieldValue === '' || this.getFieldDate(this.endInputField.nativeElement) !== null));
    }
    updateField(event) {
        if (event.target instanceof MatStartDate) {
            this.startDateFieldValue = this.formatDate(this._currentCalendarStartDateSelection);
        }
        if (event.target instanceof MatEndDate) {
            this.endDateFieldValue = this.formatDate(this._currentCalendarEndDateSelection);
        }
    }
    updatePlaceholder() {
        this._startDatePlaceholder =
            this.dateParser.getPlaceholderForValue(this._startDateFieldValue, this.locale) ||
                this._startDateFieldValue.split(' ').join('&nbsp;');
        this._endDatePlaceholder =
            this.dateParser.getPlaceholderForValue(this._endDateFieldValue, this.locale) ||
                this._endDateFieldValue.split(' ').join('&nbsp;');
    }
    getFieldDate(field) {
        let fieldValue;
        if (field === this.startInputField.nativeElement) {
            fieldValue = this._startDateFieldValue;
        }
        if (field === this.endInputField.nativeElement) {
            fieldValue = this._endDateFieldValue;
        }
        return DateUtil.parseDate(fieldValue, this.allowedFormats);
    }
    onLocaleUpdated() {
        this.startDateFieldValue = this.formatDate(this.startDate);
        this.endDateFieldValue = this.formatDate(this.endDate);
        this.updatePlaceholder();
    }
    writeValue(obj) {
        this.startDate = obj?.dateFrom;
        this.endDate = obj?.dateTo;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDateRangePickerComponent, deps: [{ token: i1.SieIconRegistryService }, { token: i1$1.LayoutService }, { token: i1$1.DateParserService }, { token: i1$1.DateFormatService }, { token: i0.ChangeDetectorRef }, { token: i3$1.DateAdapter }, { token: UiEventPropagationService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiDateRangePickerComponent, selector: "sie-ui-date-range-picker", inputs: { startDate: "startDate", endDate: "endDate", endDateErrorMessage: "endDateErrorMessage", customFilterStartDateErrorMessage: "customFilterStartDateErrorMessage", customFilterEndDateErrorMessage: "customFilterEndDateErrorMessage", customFilterRangeErrorMessage: "customFilterRangeErrorMessage" }, outputs: { endDateChange: "endDateChange", startDateChange: "startDateChange", dateRangeSelected: "dateRangeSelected" }, host: { listeners: { "focusin": "onFocus()", "window:keyup": "onTab($event)" }, properties: { "class.has-value": "this.hasValue" } }, providers: [
            DateParserService,
            MAT_RANGE_DATE_SELECTION_MODEL_PROVIDER,
            {
                provide: NG_VALUE_ACCESSOR,
                multi: true,
                useExisting: UiDateRangePickerComponent
            },
            {
                provide: NG_VALIDATORS,
                multi: true,
                useExisting: UiDateRangePickerComponent
            },
            UiEventPropagationService
        ], viewQueries: [{ propertyName: "startInputField", first: true, predicate: ["startInputField"], descendants: true }, { propertyName: "endInputField", first: true, predicate: ["endInputField"], descendants: true }, { propertyName: "datepicker", first: true, predicate: MatDateRangePicker, descendants: true }, { propertyName: "formField", first: true, predicate: MatFormField, descendants: true }], usesInheritance: true, usesOnChanges: true, ngImport: i0, template: "<div class=\"date-picker date-range-picker\" #pickerWrapper *ngIf=\"!readonly; else readOnly\" (click)=\"onFocus()\">\n  <label class=\"date-range-picker__label\">{{ label }}<span *ngIf=\"required\">*</span></label>\n  <div class=\"date-range-picker__fields\">\n    <div class=\"date-range-picker__start-field-wrapper\">\n      <span class=\"date-range-picker__field-mirror\" [innerHTML]=\"startDatePlaceholder\"></span>\n      <span class=\"date-picker__placeholder\" [innerHTML]=\"startDatePlaceholder\"></span>\n      <input\n        type=\"text\"\n        class=\"date-range-picker__field\"\n        [(ngModel)]=\"startDateFieldValue\"\n        [disabled]=\"disabled\"\n        (keyup)=\"onInputFieldKeyup($event)\"\n        (keyup.escape)=\"eventPropagationService.handleEvent($event)\"\n        (blur)=\"onFieldBlur($event)\"\n        (focus)=\"onFocus()\"\n        (keyup.tab)=\"onTab($event)\"\n        [readonly]=\"touchUiModeActive\"\n        [attr.aria-label]=\"label\"\n        #startInputField\n      />\n    </div>\n    <span class=\"date-range-picker__separator\">-</span>\n    <div class=\"date-range-picker__end-field-wrapper\">\n      <span class=\"date-range-picker__field-mirror\" [innerHTML]=\"endDatePlaceholder\"></span>\n      <span class=\"date-picker__placeholder\" [innerHTML]=\"endDatePlaceholder\"></span>\n      <input\n        type=\"text\"\n        class=\"date-range-picker__field\"\n        [disabled]=\"disabled\"\n        [(ngModel)]=\"endDateFieldValue\"\n        (keyup)=\"onInputFieldKeyup($event)\"\n        (keyup.escape)=\"eventPropagationService.handleEvent($event)\"\n        (blur)=\"onFieldBlur($event)\"\n        [readonly]=\"touchUiModeActive\"\n        [attr.aria-label]=\"label\"\n        #endInputField\n      />\n    </div>\n  </div>\n\n  <sie-icon [name]=\"iconReg.sieIcon.Calendar\" class=\"date-picker__icon\" (click)=\"onIconClick()\"></sie-icon>\n  <mat-date-range-input\n    [rangePicker]=\"picker\"\n    [min]=\"minDate\"\n    [max]=\"maxDate\"\n    [dateFilter]=\"customDateFilter\"\n    class=\"date-range-picker__hidden-range-input\"\n  >\n    <input\n      matStartDate\n      [value]=\"currentCalendarStartDateSelection\"\n      (dateChange)=\"dateChanged($event)\"\n      [disabled]=\"disabled\"\n      tabindex=\"-1\"\n    />\n    <input\n      matEndDate\n      [value]=\"currentCalendarEndDateSelection\"\n      (dateChange)=\"dateChanged($event)\"\n      [disabled]=\"disabled\"\n      tabindex=\"-1\"\n    />\n  </mat-date-range-input>\n  <mat-date-range-picker\n    panelClass=\"date-picker__calendar\"\n    [restoreFocus]=\"false\"\n    [touchUi]=\"layoutService.isViewport('S') && layoutService.isTouchDevice\"\n    #picker\n  ></mat-date-range-picker>\n</div>\n<span class=\"date-picker__error\" *ngIf=\"error\">{{ error }}</span>\n\n<ng-template #readOnly>\n  <sie-ui-readonly [label]=\"label\" [displayValue]=\"startDateFieldValue + ' - ' + endDateFieldValue\"></sie-ui-readonly>\n</ng-template>\n", styles: [".date-range-picker__field:focus{outline:0}.date-range-picker{height:56px;padding-left:16px}.is-disabled .date-range-picker{pointer-events:none;color:#b3b3be}.date-range-picker__label{font-size:.75rem;font-weight:400;line-height:1rem;display:inline-block;transform:scale(1.34) translateY(10px);transform-origin:top left;transition:transform .4s cubic-bezier(.2,0,.38,.9);color:#4c4c68}.is-focused .date-range-picker__label,.has-value .date-range-picker__label{transform:scale(1) translateY(4px)}.date-range-picker__hidden-range-input{visibility:hidden;position:absolute;bottom:0;left:0;height:100%}.date-range-picker__fields{display:flex;position:relative;opacity:0}.is-focused .date-range-picker__fields,.has-value .date-range-picker__fields{opacity:1}.date-range-picker__start-field-wrapper,.date-range-picker__end-field-wrapper{position:relative;max-width:calc(50% - 4px)}.date-range-picker__end-field-wrapper{flex:1}.date-range-picker__field{font-size:1rem;font-weight:400;line-height:1.5rem;font-family:inherit;position:absolute;top:1px;left:0;margin:0;border:0;padding:0;background:transparent}.is-disabled .date-range-picker__field{color:#b3b3be}.date-range-picker__separator{margin:0 4px}.date-range-picker__field-mirror{font-size:1rem;font-weight:400;line-height:1.5rem;-webkit-user-select:none;user-select:none;visibility:hidden;white-space:nowrap;display:inline-block;min-width:2px}\n", ".mat-calendar{font-family:Siemens Sans}.mat-calendar-body{font-size:13px}.mat-calendar-body-label,.mat-calendar-period-button{font-size:14px;font-weight:500}.mat-calendar-table-header th{font-size:11px;font-weight:400}.mat-ripple{overflow:hidden;position:relative}.mat-ripple:not(:empty){transform:translateZ(0)}.mat-ripple.mat-ripple-unbounded{overflow:visible}.mat-ripple-element{position:absolute;border-radius:50%;pointer-events:none;transition:opacity,transform 0ms cubic-bezier(0,0,.2,1);transform:scale3d(0,0,0)}.cdk-high-contrast-active .mat-ripple-element{display:none}.cdk-visually-hidden{border:0;clip:rect(0 0 0 0);height:1px;margin:-1px;overflow:hidden;padding:0;position:absolute;width:1px;white-space:nowrap;outline:0;-webkit-appearance:none;-moz-appearance:none;left:0}[dir=rtl] .cdk-visually-hidden{left:auto;right:0}.cdk-overlay-container,.cdk-global-overlay-wrapper{pointer-events:none;top:0;left:0;height:100%;width:100%}.cdk-overlay-container{position:fixed;z-index:1000}.cdk-overlay-container:empty{display:none}.cdk-global-overlay-wrapper{display:flex;position:absolute;z-index:1000}.cdk-overlay-pane{position:absolute;pointer-events:auto;box-sizing:border-box;z-index:1000;display:flex;max-width:100%;max-height:100%}.cdk-overlay-backdrop{position:absolute;inset:0;z-index:1000;pointer-events:auto;-webkit-tap-highlight-color:transparent;transition:opacity .4s cubic-bezier(.25,.8,.25,1);opacity:0}.cdk-overlay-backdrop.cdk-overlay-backdrop-showing{opacity:1}.cdk-high-contrast-active .cdk-overlay-backdrop.cdk-overlay-backdrop-showing{opacity:.6}.cdk-overlay-dark-backdrop{background:rgba(0,0,0,.32)}.cdk-overlay-transparent-backdrop{transition:visibility 1ms linear,opacity 1ms linear;visibility:hidden;opacity:1}.cdk-overlay-transparent-backdrop.cdk-overlay-backdrop-showing{opacity:0;visibility:visible}.cdk-overlay-backdrop-noop-animation{transition:none}.cdk-overlay-connected-position-bounding-box{position:absolute;z-index:1000;display:flex;flex-direction:column;min-width:1px;min-height:1px}.cdk-global-scrollblock{position:fixed;width:100%;overflow-y:scroll}textarea.cdk-textarea-autosize{resize:none}textarea.cdk-textarea-autosize-measuring{padding:2px 0!important;box-sizing:content-box!important;height:auto!important;overflow:hidden!important}textarea.cdk-textarea-autosize-measuring-firefox{padding:2px 0!important;box-sizing:content-box!important;height:0!important}@keyframes cdk-text-field-autofill-start{}@keyframes cdk-text-field-autofill-end{}.cdk-text-field-autofill-monitored:-webkit-autofill{animation:cdk-text-field-autofill-start 0s 1ms}.cdk-text-field-autofill-monitored:not(:-webkit-autofill){animation:cdk-text-field-autofill-end 0s 1ms}.mat-focus-indicator{position:relative}.mat-focus-indicator:before{inset:0;position:absolute;box-sizing:border-box;pointer-events:none;display:var(--mat-focus-indicator-display, none);border:var(--mat-focus-indicator-border-width, 3px) var(--mat-focus-indicator-border-style, solid) var(--mat-focus-indicator-border-color, transparent);border-radius:var(--mat-focus-indicator-border-radius, 4px)}.mat-focus-indicator:focus:before{content:\"\"}.cdk-high-contrast-active{--mat-focus-indicator-display: block}.mat-mdc-focus-indicator{position:relative}.mat-mdc-focus-indicator:before{inset:0;position:absolute;box-sizing:border-box;pointer-events:none;display:var(--mat-mdc-focus-indicator-display, none);border:var(--mat-mdc-focus-indicator-border-width, 3px) var(--mat-mdc-focus-indicator-border-style, solid) var(--mat-mdc-focus-indicator-border-color, transparent);border-radius:var(--mat-mdc-focus-indicator-border-radius, 4px)}.mat-mdc-focus-indicator:focus:before{content:\"\"}.cdk-high-contrast-active{--mat-mdc-focus-indicator-display: block}.date-picker{container:datepicker/size;height:56px;display:block;position:relative;width:100%;border-bottom:1px solid #4c4c68;background-color:#ebf7f8;color:#000028;font-family:Siemens Sans,sans-serif}.is-focused .date-picker,.date-picker:hover{background-color:#d1fff2;border-bottom-color:#00d7a0;z-index:1201}.is-disabled .date-picker{background-color:#ebf7f8;color:#b3b3be;pointer-events:none;border-bottom-color:transparent}.is-invalid .date-picker{color:#4c4c68;background-color:#fcccd7;border-bottom-color:#ef0137}.date-picker .mat-mdc-text-field-wrapper,.date-picker .mat-mdc-form-field-infix,.date-picker .mat-mdc-form-field-flex{height:100%}.date-picker .mdc-line-ripple{display:none}.date-picker__field-wrapper{position:relative}.date-picker__fields{position:relative;height:12px;top:20px}@container datepicker (width < 142px){.date-picker__fields{font-size:.875rem}}.date-picker__input{position:absolute;top:1px}.is-disabled .date-picker__input{color:#b3b3be}.date-picker__input-hidden{visibility:hidden;pointer-events:none;position:absolute;top:0;left:0;height:100%}.date-picker__placeholder{font-size:1rem;font-weight:400;line-height:1.5rem;opacity:0;position:absolute;left:0;font:inherit;background:transparent;color:#9999a9;font-family:Siemens Sans,sans-serif;border:none;outline:none;padding:0;margin:0;width:100%;max-width:100%;vertical-align:bottom;text-align:inherit;box-sizing:content-box;pointer-events:none;top:1px;letter-spacing:inherit}.date-picker__placeholder::placeholder{color:#9999a9}.is-focused .date-picker__placeholder,.has-value .date-picker__placeholder{opacity:1}.date-picker__overlay-input{position:absolute;top:0;bottom:0;left:0;width:100%}.date-picker__icon{width:20px;height:20px;display:flex;align-items:center;fill:currentColor;position:absolute;top:18px;right:14px;bottom:18px;cursor:pointer;color:#4c4c68}.date-picker__icon svg{fill:currentColor;width:inherit;height:inherit}.date-picker__icon svg g{fill:currentColor;width:inherit;height:inherit}.date-picker__icon svg text{font-family:Siemens Sans,sans-serif}.is-disabled .date-picker__icon{cursor:not-allowed;color:#b3b3be!important}.is-focused .date-picker__icon,.date-picker:hover .date-picker__icon{color:#00646e}.date-picker__error{font-size:.875rem;font-weight:400;line-height:1.25rem;display:block;padding:4px 16px;color:#ef0137}.date-picker .mat-mdc-form-field-wrapper{padding-bottom:0}.date-picker .mat-mdc-form-field-infix{border-top-width:10px}.date-picker .mat-mdc-form-field-label,.date-picker .mdc-floating-label{font-size:1rem;font-weight:400;line-height:1.5rem;font-family:Siemens Sans,sans-serif;color:#4c4c68}@container datepicker (width < 142px){.date-picker .mat-mdc-form-field-label,.date-picker .mdc-floating-label{font-size:.875rem}}.is-focused .date-picker .mat-mdc-form-field-label,.date-picker .mat-mdc-form-field-should-float .mat-mdc-form-field-label,.date-picker .mat-focused .mat-mdc-form-field-label{transform:translateY(-.59375em) scale(.75);transition:transform .4s cubic-bezier(.2,0,.38,.9)}.is-focused .date-picker .mat-mdc-form-field-should-float .date-picker__placeholder{opacity:1}.date-picker .mat-mdc-form-field{display:block;font-family:Siemens Sans;height:100%}.date-picker .mat-mdc-form-field-appearance-fill .mat-mdc-form-field-flex{padding-left:1rem}.mat-calendar,.mat-mdc-button,.mdc-button,.mat-mdc-raised-button,.mat-mdc-icon-button,.mat-mdc-outlined-button,.mat-mdc-unelevated-button,.mat-mdc-fab,.mat-mdc-mini-fab,.mat-mdc-input-element.date-picker__input,.mat-datepicker-content .mdc-button{font-family:Siemens Sans,sans-serif}.mat-datepicker-popup{border:1px solid #ccccd4;box-shadow:0 2px 2px #0000000f,0 4px 8px #0000001f;background-color:#fff}.mat-datepicker-dialog{background-color:#fff}.date-picker__calendar .mat-calendar-table-header-divider:after{background:#ccccd4}.date-picker__calendar .mat-calendar-body-cell-content{border:0}.date-picker__calendar .mat-calendar-body-cell-content:hover{background-color:#e5e5e9}.keyboard-nav-active .date-picker__calendar .mat-calendar-body-active .mat-calendar-body-cell-content{background-color:#e5e5e9;color:#000028}.date-picker__calendar .mat-calendar-body-today{border:1px solid #ccccd4}.date-picker__calendar .mat-calendar-body-selected{background-color:#00646e;color:#fff}.date-picker__calendar .mat-calendar-body-selected:hover{background-color:#00646e}.date-picker__calendar .mat-calendar-body-disabled{color:#b3b3be}.date-picker__calendar .mat-calendar-body-disabled .mat-calendar-body-cell-content:hover{background:none}.date-picker__calendar .mat-calendar-body-in-preview .mat-calendar-body-cell-preview{background-color:#e5e5e9;border:0}.date-picker__calendar .mat-calendar-body-in-range .mat-calendar-body-cell-preview{background-color:#c5ffef}.date-picker__calendar .mat-calendar-body-in-range.mat-calendar-body-range-start .mat-calendar-body-cell-preview{background:linear-gradient(to right,rgba(255,255,255,0) 0,rgba(255,255,255,0) 50%,#c5ffef 50%);border-top-left-radius:50%;border-bottom-left-radius:50%}.date-picker__calendar .mat-calendar-body-in-range.mat-calendar-body-range-end .mat-calendar-body-cell-preview{background:linear-gradient(to right,#c5ffef 0,#c5ffef 50%,rgba(255,255,255,0) 50%);border-top-right-radius:50%;border-bottom-right-radius:50%}.date-picker__calendar .mat-calendar-period-button{font-size:1rem;font-weight:400;line-height:1.5rem;font-family:Siemens Sans;background:transparent;color:#4c4c68}.date-picker__calendar .mat-calendar-period-button:hover{background-color:#e5e5e9}.date-picker__calendar .mat-calendar-next-button,.date-picker__calendar .mat-calendar-previous-button{background:transparent;height:40px!important;width:40px!important}.date-picker__calendar .mat-calendar-next-button:not(.mat-mdc-button-disabled):hover,.date-picker__calendar .mat-calendar-previous-button:not(.mat-mdc-button-disabled):hover{background-color:#e5e5e9}.mat-datepicker-content .mat-calendar.date-picker__calendar{width:var(--active-datepicker-width, 296px);height:auto}.mat-datepicker-content-touch.mat-datepicker-content .mat-calendar.date-picker__calendar{width:100%;height:auto}.cdk-overlay-container{z-index:1200}@media (hover: none) and (pointer: coarse) and (max-width: 639.78px){.cdk-overlay-container{background-color:#00000040}}\n"], dependencies: [{ kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "directive", type: i3.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i3.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i3.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "component", type: i7$1.MatDateRangeInput, selector: "mat-date-range-input", inputs: ["rangePicker", "required", "dateFilter", "min", "max", "disabled", "separator", "comparisonStart", "comparisonEnd"], exportAs: ["matDateRangeInput"] }, { kind: "directive", type: i7$1.MatStartDate, selector: "input[matStartDate]", inputs: ["errorStateMatcher"], outputs: ["dateChange", "dateInput"] }, { kind: "directive", type: i7$1.MatEndDate, selector: "input[matEndDate]", inputs: ["errorStateMatcher"], outputs: ["dateChange", "dateInput"] }, { kind: "component", type: i7$1.MatDateRangePicker, selector: "mat-date-range-picker", exportAs: ["matDateRangePicker"] }, { kind: "component", type: UiReadonlyComponent, selector: "sie-ui-readonly", inputs: ["value", "label", "displayValue", "name", "theme", "icons"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDateRangePickerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-date-range-picker', changeDetection: ChangeDetectionStrategy.OnPush, encapsulation: ViewEncapsulation.None, providers: [
                        DateParserService,
                        MAT_RANGE_DATE_SELECTION_MODEL_PROVIDER,
                        {
                            provide: NG_VALUE_ACCESSOR,
                            multi: true,
                            useExisting: UiDateRangePickerComponent
                        },
                        {
                            provide: NG_VALIDATORS,
                            multi: true,
                            useExisting: UiDateRangePickerComponent
                        },
                        UiEventPropagationService
                    ], template: "<div class=\"date-picker date-range-picker\" #pickerWrapper *ngIf=\"!readonly; else readOnly\" (click)=\"onFocus()\">\n  <label class=\"date-range-picker__label\">{{ label }}<span *ngIf=\"required\">*</span></label>\n  <div class=\"date-range-picker__fields\">\n    <div class=\"date-range-picker__start-field-wrapper\">\n      <span class=\"date-range-picker__field-mirror\" [innerHTML]=\"startDatePlaceholder\"></span>\n      <span class=\"date-picker__placeholder\" [innerHTML]=\"startDatePlaceholder\"></span>\n      <input\n        type=\"text\"\n        class=\"date-range-picker__field\"\n        [(ngModel)]=\"startDateFieldValue\"\n        [disabled]=\"disabled\"\n        (keyup)=\"onInputFieldKeyup($event)\"\n        (keyup.escape)=\"eventPropagationService.handleEvent($event)\"\n        (blur)=\"onFieldBlur($event)\"\n        (focus)=\"onFocus()\"\n        (keyup.tab)=\"onTab($event)\"\n        [readonly]=\"touchUiModeActive\"\n        [attr.aria-label]=\"label\"\n        #startInputField\n      />\n    </div>\n    <span class=\"date-range-picker__separator\">-</span>\n    <div class=\"date-range-picker__end-field-wrapper\">\n      <span class=\"date-range-picker__field-mirror\" [innerHTML]=\"endDatePlaceholder\"></span>\n      <span class=\"date-picker__placeholder\" [innerHTML]=\"endDatePlaceholder\"></span>\n      <input\n        type=\"text\"\n        class=\"date-range-picker__field\"\n        [disabled]=\"disabled\"\n        [(ngModel)]=\"endDateFieldValue\"\n        (keyup)=\"onInputFieldKeyup($event)\"\n        (keyup.escape)=\"eventPropagationService.handleEvent($event)\"\n        (blur)=\"onFieldBlur($event)\"\n        [readonly]=\"touchUiModeActive\"\n        [attr.aria-label]=\"label\"\n        #endInputField\n      />\n    </div>\n  </div>\n\n  <sie-icon [name]=\"iconReg.sieIcon.Calendar\" class=\"date-picker__icon\" (click)=\"onIconClick()\"></sie-icon>\n  <mat-date-range-input\n    [rangePicker]=\"picker\"\n    [min]=\"minDate\"\n    [max]=\"maxDate\"\n    [dateFilter]=\"customDateFilter\"\n    class=\"date-range-picker__hidden-range-input\"\n  >\n    <input\n      matStartDate\n      [value]=\"currentCalendarStartDateSelection\"\n      (dateChange)=\"dateChanged($event)\"\n      [disabled]=\"disabled\"\n      tabindex=\"-1\"\n    />\n    <input\n      matEndDate\n      [value]=\"currentCalendarEndDateSelection\"\n      (dateChange)=\"dateChanged($event)\"\n      [disabled]=\"disabled\"\n      tabindex=\"-1\"\n    />\n  </mat-date-range-input>\n  <mat-date-range-picker\n    panelClass=\"date-picker__calendar\"\n    [restoreFocus]=\"false\"\n    [touchUi]=\"layoutService.isViewport('S') && layoutService.isTouchDevice\"\n    #picker\n  ></mat-date-range-picker>\n</div>\n<span class=\"date-picker__error\" *ngIf=\"error\">{{ error }}</span>\n\n<ng-template #readOnly>\n  <sie-ui-readonly [label]=\"label\" [displayValue]=\"startDateFieldValue + ' - ' + endDateFieldValue\"></sie-ui-readonly>\n</ng-template>\n", styles: [".date-range-picker__field:focus{outline:0}.date-range-picker{height:56px;padding-left:16px}.is-disabled .date-range-picker{pointer-events:none;color:#b3b3be}.date-range-picker__label{font-size:.75rem;font-weight:400;line-height:1rem;display:inline-block;transform:scale(1.34) translateY(10px);transform-origin:top left;transition:transform .4s cubic-bezier(.2,0,.38,.9);color:#4c4c68}.is-focused .date-range-picker__label,.has-value .date-range-picker__label{transform:scale(1) translateY(4px)}.date-range-picker__hidden-range-input{visibility:hidden;position:absolute;bottom:0;left:0;height:100%}.date-range-picker__fields{display:flex;position:relative;opacity:0}.is-focused .date-range-picker__fields,.has-value .date-range-picker__fields{opacity:1}.date-range-picker__start-field-wrapper,.date-range-picker__end-field-wrapper{position:relative;max-width:calc(50% - 4px)}.date-range-picker__end-field-wrapper{flex:1}.date-range-picker__field{font-size:1rem;font-weight:400;line-height:1.5rem;font-family:inherit;position:absolute;top:1px;left:0;margin:0;border:0;padding:0;background:transparent}.is-disabled .date-range-picker__field{color:#b3b3be}.date-range-picker__separator{margin:0 4px}.date-range-picker__field-mirror{font-size:1rem;font-weight:400;line-height:1.5rem;-webkit-user-select:none;user-select:none;visibility:hidden;white-space:nowrap;display:inline-block;min-width:2px}\n", ".mat-calendar{font-family:Siemens Sans}.mat-calendar-body{font-size:13px}.mat-calendar-body-label,.mat-calendar-period-button{font-size:14px;font-weight:500}.mat-calendar-table-header th{font-size:11px;font-weight:400}.mat-ripple{overflow:hidden;position:relative}.mat-ripple:not(:empty){transform:translateZ(0)}.mat-ripple.mat-ripple-unbounded{overflow:visible}.mat-ripple-element{position:absolute;border-radius:50%;pointer-events:none;transition:opacity,transform 0ms cubic-bezier(0,0,.2,1);transform:scale3d(0,0,0)}.cdk-high-contrast-active .mat-ripple-element{display:none}.cdk-visually-hidden{border:0;clip:rect(0 0 0 0);height:1px;margin:-1px;overflow:hidden;padding:0;position:absolute;width:1px;white-space:nowrap;outline:0;-webkit-appearance:none;-moz-appearance:none;left:0}[dir=rtl] .cdk-visually-hidden{left:auto;right:0}.cdk-overlay-container,.cdk-global-overlay-wrapper{pointer-events:none;top:0;left:0;height:100%;width:100%}.cdk-overlay-container{position:fixed;z-index:1000}.cdk-overlay-container:empty{display:none}.cdk-global-overlay-wrapper{display:flex;position:absolute;z-index:1000}.cdk-overlay-pane{position:absolute;pointer-events:auto;box-sizing:border-box;z-index:1000;display:flex;max-width:100%;max-height:100%}.cdk-overlay-backdrop{position:absolute;inset:0;z-index:1000;pointer-events:auto;-webkit-tap-highlight-color:transparent;transition:opacity .4s cubic-bezier(.25,.8,.25,1);opacity:0}.cdk-overlay-backdrop.cdk-overlay-backdrop-showing{opacity:1}.cdk-high-contrast-active .cdk-overlay-backdrop.cdk-overlay-backdrop-showing{opacity:.6}.cdk-overlay-dark-backdrop{background:rgba(0,0,0,.32)}.cdk-overlay-transparent-backdrop{transition:visibility 1ms linear,opacity 1ms linear;visibility:hidden;opacity:1}.cdk-overlay-transparent-backdrop.cdk-overlay-backdrop-showing{opacity:0;visibility:visible}.cdk-overlay-backdrop-noop-animation{transition:none}.cdk-overlay-connected-position-bounding-box{position:absolute;z-index:1000;display:flex;flex-direction:column;min-width:1px;min-height:1px}.cdk-global-scrollblock{position:fixed;width:100%;overflow-y:scroll}textarea.cdk-textarea-autosize{resize:none}textarea.cdk-textarea-autosize-measuring{padding:2px 0!important;box-sizing:content-box!important;height:auto!important;overflow:hidden!important}textarea.cdk-textarea-autosize-measuring-firefox{padding:2px 0!important;box-sizing:content-box!important;height:0!important}@keyframes cdk-text-field-autofill-start{}@keyframes cdk-text-field-autofill-end{}.cdk-text-field-autofill-monitored:-webkit-autofill{animation:cdk-text-field-autofill-start 0s 1ms}.cdk-text-field-autofill-monitored:not(:-webkit-autofill){animation:cdk-text-field-autofill-end 0s 1ms}.mat-focus-indicator{position:relative}.mat-focus-indicator:before{inset:0;position:absolute;box-sizing:border-box;pointer-events:none;display:var(--mat-focus-indicator-display, none);border:var(--mat-focus-indicator-border-width, 3px) var(--mat-focus-indicator-border-style, solid) var(--mat-focus-indicator-border-color, transparent);border-radius:var(--mat-focus-indicator-border-radius, 4px)}.mat-focus-indicator:focus:before{content:\"\"}.cdk-high-contrast-active{--mat-focus-indicator-display: block}.mat-mdc-focus-indicator{position:relative}.mat-mdc-focus-indicator:before{inset:0;position:absolute;box-sizing:border-box;pointer-events:none;display:var(--mat-mdc-focus-indicator-display, none);border:var(--mat-mdc-focus-indicator-border-width, 3px) var(--mat-mdc-focus-indicator-border-style, solid) var(--mat-mdc-focus-indicator-border-color, transparent);border-radius:var(--mat-mdc-focus-indicator-border-radius, 4px)}.mat-mdc-focus-indicator:focus:before{content:\"\"}.cdk-high-contrast-active{--mat-mdc-focus-indicator-display: block}.date-picker{container:datepicker/size;height:56px;display:block;position:relative;width:100%;border-bottom:1px solid #4c4c68;background-color:#ebf7f8;color:#000028;font-family:Siemens Sans,sans-serif}.is-focused .date-picker,.date-picker:hover{background-color:#d1fff2;border-bottom-color:#00d7a0;z-index:1201}.is-disabled .date-picker{background-color:#ebf7f8;color:#b3b3be;pointer-events:none;border-bottom-color:transparent}.is-invalid .date-picker{color:#4c4c68;background-color:#fcccd7;border-bottom-color:#ef0137}.date-picker .mat-mdc-text-field-wrapper,.date-picker .mat-mdc-form-field-infix,.date-picker .mat-mdc-form-field-flex{height:100%}.date-picker .mdc-line-ripple{display:none}.date-picker__field-wrapper{position:relative}.date-picker__fields{position:relative;height:12px;top:20px}@container datepicker (width < 142px){.date-picker__fields{font-size:.875rem}}.date-picker__input{position:absolute;top:1px}.is-disabled .date-picker__input{color:#b3b3be}.date-picker__input-hidden{visibility:hidden;pointer-events:none;position:absolute;top:0;left:0;height:100%}.date-picker__placeholder{font-size:1rem;font-weight:400;line-height:1.5rem;opacity:0;position:absolute;left:0;font:inherit;background:transparent;color:#9999a9;font-family:Siemens Sans,sans-serif;border:none;outline:none;padding:0;margin:0;width:100%;max-width:100%;vertical-align:bottom;text-align:inherit;box-sizing:content-box;pointer-events:none;top:1px;letter-spacing:inherit}.date-picker__placeholder::placeholder{color:#9999a9}.is-focused .date-picker__placeholder,.has-value .date-picker__placeholder{opacity:1}.date-picker__overlay-input{position:absolute;top:0;bottom:0;left:0;width:100%}.date-picker__icon{width:20px;height:20px;display:flex;align-items:center;fill:currentColor;position:absolute;top:18px;right:14px;bottom:18px;cursor:pointer;color:#4c4c68}.date-picker__icon svg{fill:currentColor;width:inherit;height:inherit}.date-picker__icon svg g{fill:currentColor;width:inherit;height:inherit}.date-picker__icon svg text{font-family:Siemens Sans,sans-serif}.is-disabled .date-picker__icon{cursor:not-allowed;color:#b3b3be!important}.is-focused .date-picker__icon,.date-picker:hover .date-picker__icon{color:#00646e}.date-picker__error{font-size:.875rem;font-weight:400;line-height:1.25rem;display:block;padding:4px 16px;color:#ef0137}.date-picker .mat-mdc-form-field-wrapper{padding-bottom:0}.date-picker .mat-mdc-form-field-infix{border-top-width:10px}.date-picker .mat-mdc-form-field-label,.date-picker .mdc-floating-label{font-size:1rem;font-weight:400;line-height:1.5rem;font-family:Siemens Sans,sans-serif;color:#4c4c68}@container datepicker (width < 142px){.date-picker .mat-mdc-form-field-label,.date-picker .mdc-floating-label{font-size:.875rem}}.is-focused .date-picker .mat-mdc-form-field-label,.date-picker .mat-mdc-form-field-should-float .mat-mdc-form-field-label,.date-picker .mat-focused .mat-mdc-form-field-label{transform:translateY(-.59375em) scale(.75);transition:transform .4s cubic-bezier(.2,0,.38,.9)}.is-focused .date-picker .mat-mdc-form-field-should-float .date-picker__placeholder{opacity:1}.date-picker .mat-mdc-form-field{display:block;font-family:Siemens Sans;height:100%}.date-picker .mat-mdc-form-field-appearance-fill .mat-mdc-form-field-flex{padding-left:1rem}.mat-calendar,.mat-mdc-button,.mdc-button,.mat-mdc-raised-button,.mat-mdc-icon-button,.mat-mdc-outlined-button,.mat-mdc-unelevated-button,.mat-mdc-fab,.mat-mdc-mini-fab,.mat-mdc-input-element.date-picker__input,.mat-datepicker-content .mdc-button{font-family:Siemens Sans,sans-serif}.mat-datepicker-popup{border:1px solid #ccccd4;box-shadow:0 2px 2px #0000000f,0 4px 8px #0000001f;background-color:#fff}.mat-datepicker-dialog{background-color:#fff}.date-picker__calendar .mat-calendar-table-header-divider:after{background:#ccccd4}.date-picker__calendar .mat-calendar-body-cell-content{border:0}.date-picker__calendar .mat-calendar-body-cell-content:hover{background-color:#e5e5e9}.keyboard-nav-active .date-picker__calendar .mat-calendar-body-active .mat-calendar-body-cell-content{background-color:#e5e5e9;color:#000028}.date-picker__calendar .mat-calendar-body-today{border:1px solid #ccccd4}.date-picker__calendar .mat-calendar-body-selected{background-color:#00646e;color:#fff}.date-picker__calendar .mat-calendar-body-selected:hover{background-color:#00646e}.date-picker__calendar .mat-calendar-body-disabled{color:#b3b3be}.date-picker__calendar .mat-calendar-body-disabled .mat-calendar-body-cell-content:hover{background:none}.date-picker__calendar .mat-calendar-body-in-preview .mat-calendar-body-cell-preview{background-color:#e5e5e9;border:0}.date-picker__calendar .mat-calendar-body-in-range .mat-calendar-body-cell-preview{background-color:#c5ffef}.date-picker__calendar .mat-calendar-body-in-range.mat-calendar-body-range-start .mat-calendar-body-cell-preview{background:linear-gradient(to right,rgba(255,255,255,0) 0,rgba(255,255,255,0) 50%,#c5ffef 50%);border-top-left-radius:50%;border-bottom-left-radius:50%}.date-picker__calendar .mat-calendar-body-in-range.mat-calendar-body-range-end .mat-calendar-body-cell-preview{background:linear-gradient(to right,#c5ffef 0,#c5ffef 50%,rgba(255,255,255,0) 50%);border-top-right-radius:50%;border-bottom-right-radius:50%}.date-picker__calendar .mat-calendar-period-button{font-size:1rem;font-weight:400;line-height:1.5rem;font-family:Siemens Sans;background:transparent;color:#4c4c68}.date-picker__calendar .mat-calendar-period-button:hover{background-color:#e5e5e9}.date-picker__calendar .mat-calendar-next-button,.date-picker__calendar .mat-calendar-previous-button{background:transparent;height:40px!important;width:40px!important}.date-picker__calendar .mat-calendar-next-button:not(.mat-mdc-button-disabled):hover,.date-picker__calendar .mat-calendar-previous-button:not(.mat-mdc-button-disabled):hover{background-color:#e5e5e9}.mat-datepicker-content .mat-calendar.date-picker__calendar{width:var(--active-datepicker-width, 296px);height:auto}.mat-datepicker-content-touch.mat-datepicker-content .mat-calendar.date-picker__calendar{width:100%;height:auto}.cdk-overlay-container{z-index:1200}@media (hover: none) and (pointer: coarse) and (max-width: 639.78px){.cdk-overlay-container{background-color:#00000040}}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }, { type: i1$1.LayoutService }, { type: i1$1.DateParserService }, { type: i1$1.DateFormatService }, { type: i0.ChangeDetectorRef }, { type: i3$1.DateAdapter }, { type: UiEventPropagationService }]; }, propDecorators: { startDate: [{
                type: Input
            }], endDate: [{
                type: Input
            }], endDateChange: [{
                type: Output
            }], startDateChange: [{
                type: Output
            }], dateRangeSelected: [{
                type: Output
            }], hasValue: [{
                type: HostBinding,
                args: ['class.has-value']
            }], endDateErrorMessage: [{
                type: Input
            }], customFilterStartDateErrorMessage: [{
                type: Input
            }], customFilterEndDateErrorMessage: [{
                type: Input
            }], customFilterRangeErrorMessage: [{
                type: Input
            }], startInputField: [{
                type: ViewChild,
                args: ['startInputField']
            }], endInputField: [{
                type: ViewChild,
                args: ['endInputField']
            }], datepicker: [{
                type: ViewChild,
                args: [MatDateRangePicker]
            }], formField: [{
                type: ViewChild,
                args: [MatFormField]
            }], onFocus: [{
                type: HostListener,
                args: ['focusin']
            }], onTab: [{
                type: HostListener,
                args: ['window:keyup', ['$event']]
            }] } });

class UiDateRangePickerModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDateRangePickerModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiDateRangePickerModule, declarations: [UiDateRangePickerComponent], imports: [CommonModule, UiDatePickerBaseModule, UiReadonlyModule], exports: [UiDateRangePickerComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDateRangePickerModule, imports: [CommonModule, UiDatePickerBaseModule, UiReadonlyModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDateRangePickerModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiDateRangePickerComponent],
                    imports: [CommonModule, UiDatePickerBaseModule, UiReadonlyModule],
                    exports: [UiDateRangePickerComponent]
                }]
        }] });

class UiOnPageBreadcrumbModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiOnPageBreadcrumbModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiOnPageBreadcrumbModule, declarations: [UiOnPageBreadcrumbComponent], imports: [CommonModule, UiBreadcrumbModule], exports: [UiOnPageBreadcrumbComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiOnPageBreadcrumbModule, imports: [CommonModule, UiBreadcrumbModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiOnPageBreadcrumbModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiOnPageBreadcrumbComponent],
                    imports: [CommonModule, UiBreadcrumbModule],
                    exports: [UiOnPageBreadcrumbComponent]
                }]
        }] });

class UiPromotionAlertComponent {
    set promotionAlertData(promotionAlertData) {
        if (promotionAlertData?.buttons.length > 0) {
            this.iconReg.register(promotionAlertData?.buttons[0]?.icon ? promotionAlertData?.buttons[0]?.icon : this.iconReg.sieIcon.ArrowRight);
        }
        this._promotionAlertData = promotionAlertData;
    }
    get promotionAlertData() {
        return this._promotionAlertData;
    }
    constructor(cdr, iconReg, uiGlobalModalHandlingEventService) {
        this.cdr = cdr;
        this.iconReg = iconReg;
        this.uiGlobalModalHandlingEventService = uiGlobalModalHandlingEventService;
    }
    onButtonClick(event, button) {
        event.preventDefault();
        this.uiGlobalModalHandlingEventService.openModalEvent.next(button.modalInformation);
    }
    getToolTipTitle() {
        return [
            this._promotionAlertData.leftTagText,
            this._promotionAlertData.taggedText,
            this._promotionAlertData.rightTagText
        ].join(' ');
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiPromotionAlertComponent, deps: [{ token: i0.ChangeDetectorRef }, { token: i1.SieIconRegistryService }, { token: UiGlobalModalHandlingEventService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiPromotionAlertComponent, selector: "sie-ui-promotion-alert", inputs: { promotionAlertData: "promotionAlertData" }, ngImport: i0, template: "<div data-ste-section=\"promotion-alert\" class=\"promotion-alert\" *ngIf=\"promotionAlertData\">\n  <div class=\"container\">\n    <span\n      *ngIf=\"promotionAlertData.title && promotionAlertData.title !== ''\"\n      class=\"promotion-alert__content promotion-alert__title\"\n    >\n      {{ promotionAlertData.title }}\n    </span>\n\n    <div\n      *ngIf=\"\n        (promotionAlertData.leftTagText || promotionAlertData.rightTagText || promotionAlertData.taggedText) !== ''\n      \"\n      class=\"promotion-alert__content promotion-alert__description\"\n      [attr.title]=\"getToolTipTitle()\"\n    >\n      <span *ngIf=\"promotionAlertData.leftTagText !== ''\" class=\"promotion-alert__description--left\">{{\n        promotionAlertData.leftTagText\n      }}</span>\n      <span *ngIf=\"promotionAlertData.taggedText !== ''\" class=\"promotion-alert__description--tag\">{{\n        promotionAlertData.taggedText\n      }}</span>\n      <span *ngIf=\"promotionAlertData.rightTagText !== ''\" class=\"promotion-alert__description--right\"\n        >{{ promotionAlertData.rightTagText }}\n      </span>\n    </div>\n    <div *ngIf=\"promotionAlertData.buttons.length > 0\" class=\"promotion-alert__content promotion-alert__ctaLink\">\n      <ng-container>\n        <a\n          *ngIf=\"promotionAlertData.buttons[0].buttonType === 'link'; else button\"\n          [href]=\"promotionAlertData.buttons[0].link\"\n          class=\"promotion-alert__content--link\"\n          [target]=\"promotionAlertData.buttons[0].target\"\n        >\n          <sie-icon\n            [name]=\"promotionAlertData.buttons[0].icon || iconReg.sieIcon.ArrowRight\"\n            class=\"promotion-alert__ctaLink--icon\"\n          ></sie-icon>\n          <span class=\"promotion-alert__ctaLink--text\">\n            {{ promotionAlertData.buttons[0].label }}\n          </span>\n        </a>\n      </ng-container>\n      <ng-template #button>\n        <a\n          class=\"promotion-alert__content--link\"\n          href=\"#\"\n          (click)=\"onButtonClick($event, promotionAlertData.buttons[0])\"\n        >\n          <sie-icon\n            [name]=\"promotionAlertData.buttons[0].icon || iconReg.sieIcon.ArrowRight\"\n            class=\"promotion-alert__ctaLink--icon\"\n          ></sie-icon>\n          <span class=\"promotion-alert__ctaLink--text\">\n            {{ promotionAlertData.buttons[0].label }}\n          </span>\n        </a>\n      </ng-template>\n    </div>\n  </div>\n</div>\n", styles: [".promotion-alert__ctaLink a{outline:none;outline-offset:0}@media (pointer: fine){.promotion-alert__ctaLink a{position:relative}.promotion-alert__ctaLink a:focus{outline:1px solid #1491eb;outline-offset:2px}.promotion-alert__ctaLink a:focus:not(:focus-visible){outline:0}.promotion-alert__ctaLink a:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}.promotion-alert{background:linear-gradient(90deg,#500078,#aa32be)}.promotion-alert>.container{display:flex;flex-direction:row;align-items:center;height:56px}.promotion-alert__content{white-space:nowrap}.promotion-alert__content--link{display:inline-block;max-width:360px;overflow:hidden;text-overflow:ellipsis;color:#fff}.promotion-alert__title{white-space:nowrap;overflow:hidden;text-overflow:ellipsis;flex:0 1 auto;max-width:400px;margin-right:16px;color:#fff;font-size:1.25rem;font-weight:900;line-height:1.625rem}@media (max-width: 359.78px){.promotion-alert__title{max-width:250px}}.promotion-alert__description{white-space:nowrap;overflow:hidden;text-overflow:ellipsis;flex:0 10000 auto;flex-basis:auto;max-width:540px;color:#fff}@media (max-width: 1919.78px){.promotion-alert__description{margin-right:144px}}@media (max-width: 1023.78px){.promotion-alert__description{margin-right:64px}}@media (max-width: 639.78px){.promotion-alert__description{margin-right:32px}}@media (max-width: 359.78px){.promotion-alert__description{display:none}}.promotion-alert__description--tag{margin-left:8px;margin-right:8px}@media (min-width: 1024px){.promotion-alert__description--tag{background-color:#ff9000;border-radius:16px;padding:4px 12px;font-size:14px;line-height:25px}}@media (max-width: 1023.78px){.promotion-alert__description--tag{color:#ff9000;font-weight:700}}.promotion-alert__ctaLink{flex:1 0 auto;flex-basis:auto;text-align:right}.promotion-alert__ctaLink a{cursor:pointer;padding:9px 0 11px;display:inline-block;vertical-align:top}.promotion-alert__ctaLink--text{color:#fff;display:inline-block;padding:2px 0 0 4px}@media (max-width: 639.78px){.promotion-alert__ctaLink--text{display:none}}.promotion-alert__ctaLink--icon{fill:#fff;vertical-align:top}\n"], dependencies: [{ kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiPromotionAlertComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-promotion-alert', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div data-ste-section=\"promotion-alert\" class=\"promotion-alert\" *ngIf=\"promotionAlertData\">\n  <div class=\"container\">\n    <span\n      *ngIf=\"promotionAlertData.title && promotionAlertData.title !== ''\"\n      class=\"promotion-alert__content promotion-alert__title\"\n    >\n      {{ promotionAlertData.title }}\n    </span>\n\n    <div\n      *ngIf=\"\n        (promotionAlertData.leftTagText || promotionAlertData.rightTagText || promotionAlertData.taggedText) !== ''\n      \"\n      class=\"promotion-alert__content promotion-alert__description\"\n      [attr.title]=\"getToolTipTitle()\"\n    >\n      <span *ngIf=\"promotionAlertData.leftTagText !== ''\" class=\"promotion-alert__description--left\">{{\n        promotionAlertData.leftTagText\n      }}</span>\n      <span *ngIf=\"promotionAlertData.taggedText !== ''\" class=\"promotion-alert__description--tag\">{{\n        promotionAlertData.taggedText\n      }}</span>\n      <span *ngIf=\"promotionAlertData.rightTagText !== ''\" class=\"promotion-alert__description--right\"\n        >{{ promotionAlertData.rightTagText }}\n      </span>\n    </div>\n    <div *ngIf=\"promotionAlertData.buttons.length > 0\" class=\"promotion-alert__content promotion-alert__ctaLink\">\n      <ng-container>\n        <a\n          *ngIf=\"promotionAlertData.buttons[0].buttonType === 'link'; else button\"\n          [href]=\"promotionAlertData.buttons[0].link\"\n          class=\"promotion-alert__content--link\"\n          [target]=\"promotionAlertData.buttons[0].target\"\n        >\n          <sie-icon\n            [name]=\"promotionAlertData.buttons[0].icon || iconReg.sieIcon.ArrowRight\"\n            class=\"promotion-alert__ctaLink--icon\"\n          ></sie-icon>\n          <span class=\"promotion-alert__ctaLink--text\">\n            {{ promotionAlertData.buttons[0].label }}\n          </span>\n        </a>\n      </ng-container>\n      <ng-template #button>\n        <a\n          class=\"promotion-alert__content--link\"\n          href=\"#\"\n          (click)=\"onButtonClick($event, promotionAlertData.buttons[0])\"\n        >\n          <sie-icon\n            [name]=\"promotionAlertData.buttons[0].icon || iconReg.sieIcon.ArrowRight\"\n            class=\"promotion-alert__ctaLink--icon\"\n          ></sie-icon>\n          <span class=\"promotion-alert__ctaLink--text\">\n            {{ promotionAlertData.buttons[0].label }}\n          </span>\n        </a>\n      </ng-template>\n    </div>\n  </div>\n</div>\n", styles: [".promotion-alert__ctaLink a{outline:none;outline-offset:0}@media (pointer: fine){.promotion-alert__ctaLink a{position:relative}.promotion-alert__ctaLink a:focus{outline:1px solid #1491eb;outline-offset:2px}.promotion-alert__ctaLink a:focus:not(:focus-visible){outline:0}.promotion-alert__ctaLink a:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}.promotion-alert{background:linear-gradient(90deg,#500078,#aa32be)}.promotion-alert>.container{display:flex;flex-direction:row;align-items:center;height:56px}.promotion-alert__content{white-space:nowrap}.promotion-alert__content--link{display:inline-block;max-width:360px;overflow:hidden;text-overflow:ellipsis;color:#fff}.promotion-alert__title{white-space:nowrap;overflow:hidden;text-overflow:ellipsis;flex:0 1 auto;max-width:400px;margin-right:16px;color:#fff;font-size:1.25rem;font-weight:900;line-height:1.625rem}@media (max-width: 359.78px){.promotion-alert__title{max-width:250px}}.promotion-alert__description{white-space:nowrap;overflow:hidden;text-overflow:ellipsis;flex:0 10000 auto;flex-basis:auto;max-width:540px;color:#fff}@media (max-width: 1919.78px){.promotion-alert__description{margin-right:144px}}@media (max-width: 1023.78px){.promotion-alert__description{margin-right:64px}}@media (max-width: 639.78px){.promotion-alert__description{margin-right:32px}}@media (max-width: 359.78px){.promotion-alert__description{display:none}}.promotion-alert__description--tag{margin-left:8px;margin-right:8px}@media (min-width: 1024px){.promotion-alert__description--tag{background-color:#ff9000;border-radius:16px;padding:4px 12px;font-size:14px;line-height:25px}}@media (max-width: 1023.78px){.promotion-alert__description--tag{color:#ff9000;font-weight:700}}.promotion-alert__ctaLink{flex:1 0 auto;flex-basis:auto;text-align:right}.promotion-alert__ctaLink a{cursor:pointer;padding:9px 0 11px;display:inline-block;vertical-align:top}.promotion-alert__ctaLink--text{color:#fff;display:inline-block;padding:2px 0 0 4px}@media (max-width: 639.78px){.promotion-alert__ctaLink--text{display:none}}.promotion-alert__ctaLink--icon{fill:#fff;vertical-align:top}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i1.SieIconRegistryService }, { type: UiGlobalModalHandlingEventService }]; }, propDecorators: { promotionAlertData: [{
                type: Input
            }] } });

class UiPromotionAlertModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiPromotionAlertModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiPromotionAlertModule, declarations: [UiPromotionAlertComponent], imports: [CommonModule, SieIconsModule], exports: [UiPromotionAlertComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiPromotionAlertModule, imports: [CommonModule, SieIconsModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiPromotionAlertModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiPromotionAlertComponent],
                    imports: [CommonModule, SieIconsModule],
                    exports: [UiPromotionAlertComponent]
                }]
        }] });

var UiStatusVariantEnum;
(function (UiStatusVariantEnum) {
    UiStatusVariantEnum["Success"] = "success";
    UiStatusVariantEnum["Error"] = "error";
    UiStatusVariantEnum["Warning"] = "warning";
    UiStatusVariantEnum["Information"] = "information";
})(UiStatusVariantEnum || (UiStatusVariantEnum = {}));

/**
 * # Donut Chart Component
 *
 * The Donut Chart component is used to visualize proportions of categorical data.
 *
 * ## Component variations
 *
 * - distribution (displays only secondary label)
 * - progress (displays primary and secondary label)
 *
 * ## Content
 *
 * The Donut Chart component does not accept any content.
 *
 * ## Code example
 * @example
 * Template:
 * ```html
 * <sie-ui-donut-chart
 *    variant="progress"
 *    [primaryLabel]="2000/4000"
 *    [secondaryLabel]="Parts used"
 *    [partials]="partialsData">
 *</sie-ui-donut-chart>
 * <sie-ui-donut-chart
 *    variant="distribution"
 *    [secondaryLabel]="Article availability"
 *    [partials]="partialsData">
 * </sie-ui-donut-chart>
 * <sie-ui-donut-chart
 *    variant="distribution"
 *    size="200px"
 *    strokeWidth="30px"
 *    [secondaryLabel]="Article availability"
 *    [partials]="partialsData">
 * </sie-ui-donut-chart>
 * ```
 *
 * Partials data example:
 * ``` js
 * const partialsData = [
 *  {
 *    percentage: 50,
 *    color: 'orange'
 *  }
 * ];
 * ```
 */
let UiDonutChartComponent = class UiDonutChartComponent {
    constructor() {
        /** @ignore */
        this.MIN_NUMBER_OF_LINES_TO_SHOW = 2;
        /** @ignore */
        this.MAX_NUMBER_OF_LINES_TO_SHOW = 3;
        /** @ignore */
        this.showPrimaryLabel = false;
        /**
         * Defines {@link UiDonutChartVariant variant} in which variant the Donut Chart component will be shown.
         * @default 'distribution'
         */
        this.variant = 'distribution';
        /**
         * Defines text used as primary label in Donut Chart component.
         * @default ''
         */
        this.primaryLabel = '';
        /**
         * Defines text used as secondary label in Donut Chart component.
         * @default ''
         */
        this.secondaryLabel = '';
        /**
         * Defines the size of Donut Chart component.
         * @default '180px'
         */
        this.size = '180px';
        /**
         * Defines the stroke width of Donut Chart component.
         * @default '24px'
         */
        this.strokeWidth = '24px';
    }
    /** @ignore */
    get segments() {
        return this._segments;
    }
    /** @ignore */
    get radiusAttribute() {
        return this._radiusAttribute;
    }
    /** @ignore */
    ngOnInit() {
        this.updateSizes();
        this.mapSegments();
    }
    updateSizes() {
        this.radius = parseInt(this.size, 10) / 2 - parseInt(this.strokeWidth, 10) / 2;
        this._radiusAttribute = `calc(50% - ${this.strokeWidth} / 2)`;
        this.circumference = this.radius * 2 * Math.PI;
        this.svgPercent = this.circumference / 100;
    }
    mapSegments() {
        let currentOffset = 0;
        this._segments = this.partials.map(partial => {
            const percentage = this.getSvgPercentage(partial.percentage);
            const offset = currentOffset + percentage;
            currentOffset = offset;
            return {
                strokeDashArray: `${percentage} ${this.circumference - percentage}`,
                strokeDashOffset: offset.toString(),
                color: partial.color
            };
        });
    }
    getSvgPercentage(percentage) {
        return percentage * this.svgPercent;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDonutChartComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiDonutChartComponent, selector: "sie-ui-donut-chart", inputs: { variant: "variant", primaryLabel: "primaryLabel", secondaryLabel: "secondaryLabel", partials: "partials", size: "size", strokeWidth: "strokeWidth" }, host: { properties: { "style.--size": "this.size", "style.--strokeWidth": "this.strokeWidth" } }, viewQueries: [{ propertyName: "donutChart", first: true, predicate: ["donutChart"], descendants: true }], ngImport: i0, template: "<svg class=\"donut-chart__svg\">\n  <circle cx=\"50%\" cy=\"50%\" class=\"background\" [attr.r]=\"radiusAttribute\"></circle>\n\n  <circle\n    *ngFor=\"let segment of segments\"\n    cx=\"50%\"\n    cy=\"50%\"\n    [attr.r]=\"radiusAttribute\"\n    [attr.stroke]=\"segment.color\"\n    [attr.stroke-dasharray]=\"segment.strokeDashArray\"\n    [attr.stroke-dashoffset]=\"segment.strokeDashOffset\"\n  ></circle>\n</svg>\n\n<div class=\"donut-chart__content\">\n  <p\n    *ngIf=\"variant === 'progress' && !!primaryLabel?.length\"\n    class=\"donut-chart__primary-label\"\n    sieCoreAddTruncationAndTooltip\n  >\n    {{ primaryLabel }}\n  </p>\n  <p\n    *ngIf=\"secondaryLabel\"\n    class=\"donut-chart__secondary-label\"\n    sieCoreAddTruncationAndTooltip\n    [maxNumberOfLinesToShow]=\"showPrimaryLabel ? MIN_NUMBER_OF_LINES_TO_SHOW : MAX_NUMBER_OF_LINES_TO_SHOW\"\n  >\n    {{ secondaryLabel }}\n  </p>\n</div>\n", styles: [":host{display:block;position:relative;width:var(--size);height:var(--size)}.donut-chart__svg{width:100%;height:100%;transform:rotate(-90deg) scaleY(-1)}.donut-chart__content{position:absolute;inset:0;display:flex;flex-direction:column;align-items:center;justify-content:center;padding:0 calc(var(--strokeWidth) + 16px)}.donut-chart__primary-label{font-size:1.625rem;font-weight:700;line-height:2.25rem;max-width:100%}.donut-chart__secondary-label{font-size:.875rem;font-weight:700;line-height:1.25rem;overflow-wrap:anywhere}.donut-chart__primary-label,.donut-chart__secondary-label{text-align:center}circle{stroke-width:var(--strokeWidth);fill:transparent}circle.background{stroke:#ccccd4}\n"], dependencies: [{ kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1$1.AddTruncationAndTooltipDirective, selector: "[sieCoreAddTruncationAndTooltip]", inputs: ["maxNumberOfLinesToShow"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
};
__decorate([
    OnChangesGroup('segments')
], UiDonutChartComponent.prototype, "partials", void 0);
__decorate([
    OnChangesGroup('size')
], UiDonutChartComponent.prototype, "size", void 0);
__decorate([
    OnChangesGroup('size')
], UiDonutChartComponent.prototype, "strokeWidth", void 0);
__decorate([
    OnChangesGroupHandler('size')
], UiDonutChartComponent.prototype, "updateSizes", null);
__decorate([
    OnChangesGroupHandler('size', 'segments')
], UiDonutChartComponent.prototype, "mapSegments", null);
UiDonutChartComponent = __decorate([
    OnChange({
        groupHandlerExecutionPriority: ['updateSizes']
    })
], UiDonutChartComponent);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDonutChartComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-donut-chart', changeDetection: ChangeDetectionStrategy.OnPush, template: "<svg class=\"donut-chart__svg\">\n  <circle cx=\"50%\" cy=\"50%\" class=\"background\" [attr.r]=\"radiusAttribute\"></circle>\n\n  <circle\n    *ngFor=\"let segment of segments\"\n    cx=\"50%\"\n    cy=\"50%\"\n    [attr.r]=\"radiusAttribute\"\n    [attr.stroke]=\"segment.color\"\n    [attr.stroke-dasharray]=\"segment.strokeDashArray\"\n    [attr.stroke-dashoffset]=\"segment.strokeDashOffset\"\n  ></circle>\n</svg>\n\n<div class=\"donut-chart__content\">\n  <p\n    *ngIf=\"variant === 'progress' && !!primaryLabel?.length\"\n    class=\"donut-chart__primary-label\"\n    sieCoreAddTruncationAndTooltip\n  >\n    {{ primaryLabel }}\n  </p>\n  <p\n    *ngIf=\"secondaryLabel\"\n    class=\"donut-chart__secondary-label\"\n    sieCoreAddTruncationAndTooltip\n    [maxNumberOfLinesToShow]=\"showPrimaryLabel ? MIN_NUMBER_OF_LINES_TO_SHOW : MAX_NUMBER_OF_LINES_TO_SHOW\"\n  >\n    {{ secondaryLabel }}\n  </p>\n</div>\n", styles: [":host{display:block;position:relative;width:var(--size);height:var(--size)}.donut-chart__svg{width:100%;height:100%;transform:rotate(-90deg) scaleY(-1)}.donut-chart__content{position:absolute;inset:0;display:flex;flex-direction:column;align-items:center;justify-content:center;padding:0 calc(var(--strokeWidth) + 16px)}.donut-chart__primary-label{font-size:1.625rem;font-weight:700;line-height:2.25rem;max-width:100%}.donut-chart__secondary-label{font-size:.875rem;font-weight:700;line-height:1.25rem;overflow-wrap:anywhere}.donut-chart__primary-label,.donut-chart__secondary-label{text-align:center}circle{stroke-width:var(--strokeWidth);fill:transparent}circle.background{stroke:#ccccd4}\n"] }]
        }], propDecorators: { donutChart: [{
                type: ViewChild,
                args: ['donutChart']
            }], variant: [{
                type: Input
            }], primaryLabel: [{
                type: Input
            }], secondaryLabel: [{
                type: Input
            }], partials: [{
                type: Input
            }], size: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['style.--size']
            }], strokeWidth: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['style.--strokeWidth']
            }], updateSizes: [], mapSegments: [] } });

class UiDonutChartModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDonutChartModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiDonutChartModule, declarations: [UiDonutChartComponent], imports: [CommonModule, AddTruncationAndTooltipModule], exports: [UiDonutChartComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDonutChartModule, imports: [CommonModule, AddTruncationAndTooltipModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiDonutChartModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiDonutChartComponent],
                    imports: [CommonModule, AddTruncationAndTooltipModule],
                    exports: [UiDonutChartComponent]
                }]
        }] });

class UiSaasLandingPageLayoutComponent {
    constructor() {
        /**
         * Switches between a header with grey background and without one.
         */
        this.headerVariant = 'transparent';
        /**
         * Show skeleton for all sections.
         */
        this.loading = false;
        /**
         * Show skeleton only for the breadcrumbs.
         */
        this.breadCrumbsLoading = false;
        /**
         * Show skeleton only for the headline.
         */
        this.headlineLoading = false;
        /**
         * Show skeleton only for the sub-headline.
         */
        this.subHeadlineLoading = false;
        /**
         * Use container class to prevent content going out of bounds on XXL+ screens
         */
        this.contentContainerClass = false;
        /**
         * Text used for screen reader when encountering the home icon in breadcrumbs
         */
        this.screenReaderBreadcrumbHomeButton = '';
        /**
         * checking the heading size
         */
        this.headlineFontSize = 'h1';
        /**
         * Emitted when a breadcrumb is clicked.
         */
        this.breadcrumbClicked = new Subject();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiSaasLandingPageLayoutComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiSaasLandingPageLayoutComponent, selector: "sie-ui-saas-landing-page-layout", inputs: { headerVariant: "headerVariant", breadCrumbs: "breadCrumbs", headline: "headline", subHeadline: "subHeadline", loading: "loading", breadCrumbsLoading: "breadCrumbsLoading", headlineLoading: "headlineLoading", subHeadlineLoading: "subHeadlineLoading", dataAttributes: "dataAttributes", contentContainerClass: "contentContainerClass", screenReaderBreadcrumbHomeButton: "screenReaderBreadcrumbHomeButton", headlineFontSize: "headlineFontSize" }, outputs: { breadcrumbClicked: "breadcrumbClicked" }, ngImport: i0, template: "<section>\n  <header class=\"landing-page-layout__header variant-{{ headerVariant }}\" [sieCoreAttributes]=\"dataAttributes?.header\">\n    <div class=\"container\">\n      <div class=\"landing-page-layout__heading\">\n        <div class=\"landing-page-layout__breadcrumbs\" data-ste-component=\"breadcrumb\">\n          <ng-container *ngIf=\"!loading && !breadCrumbsLoading; else breadcrumbSkeleton\">\n            <sie-ui-on-page-breadcrumb\n              [breadcrumbs]=\"breadCrumbs\"\n              (clicked)=\"breadcrumbClicked.next($event)\"\n              [screenReaderTextHomeButton]=\"screenReaderBreadcrumbHomeButton\"\n            ></sie-ui-on-page-breadcrumb>\n          </ng-container>\n        </div>\n        <div class=\"landing-page-layout__heading-content\">\n          <div class=\"row\">\n            <div class=\"col\">\n              <ng-container *ngIf=\"!loading && !headlineLoading; else headlineSkeleton\">\n                <h1\n                  class=\"landing-page-layout__headline {{ headlineFontSize }}\"\n                  sieCoreAddTruncationAndTooltip\n                  [title]=\"headline\"\n                >\n                  {{ headline }}\n                </h1>\n              </ng-container>\n            </div>\n          </div>\n          <div *ngIf=\"subHeadline\" class=\"row\">\n            <div class=\"col-xl-9\">\n              <ng-container *ngIf=\"!loading && !subHeadlineLoading; else subHeadlineSkeleton\"\n                >{{ subHeadline }}\n              </ng-container>\n            </div>\n          </div>\n\n          <ng-content select=\"[header]\"></ng-content>\n        </div>\n      </div>\n    </div>\n  </header>\n\n  <div\n    class=\"landing-page-layout__content\"\n    [ngClass]=\"{ container: contentContainerClass }\"\n    [sieCoreAttributes]=\"dataAttributes?.content\"\n  >\n    <ng-content select=\"[content]\"></ng-content>\n  </div>\n</section>\n\n<ng-template #breadcrumbSkeleton>\n  <sie-ui-skeleton class=\"landing-page-layout__breadcrumbs-skeleton\"></sie-ui-skeleton>\n</ng-template>\n\n<ng-template #headlineSkeleton>\n  <sie-ui-skeleton class=\"landing-page-layout__headline-skeleton\"></sie-ui-skeleton>\n</ng-template>\n\n<ng-template #subHeadlineSkeleton>\n  <sie-ui-skeleton class=\"landing-page-layout__sub-headline-skeleton\"></sie-ui-skeleton>\n</ng-template>\n", styles: [":host{--width-m: 395px;--height-m: 26px;--width-s: 218px;--height-s: 31px}.landing-page-layout__header{padding:24px 0}.landing-page-layout__header.variant-grey{background-color:#f3f3f0}.landing-page-layout__breadcrumbs{margin-bottom:30px}@media print{.landing-page-layout__breadcrumbs{display:none}}@media (min-width: 1024px){.landing-page-layout__headline{margin-bottom:16px;max-width:714px}}@media print{.landing-page-layout__headline{font-size:28.5px;margin-top:27px}}@media (max-width: 1023.78px){.landing-page-layout__headline{font-size:1.25rem;margin-bottom:8px}}.landing-page-layout__heading-content{position:relative}.landing-page-layout__breadcrumbs-skeleton{width:500px;height:30px;display:block}@media (max-width: 639.78px){.landing-page-layout__breadcrumbs-skeleton{width:var(--width-s);height:var(--height-s);margin-top:-2px}}.landing-page-layout__headline-skeleton{width:269px;height:31px}@media (min-width: 640px){.landing-page-layout__headline-skeleton{width:218px;height:31px}}@media (min-width: 1024px){.landing-page-layout__headline-skeleton{width:738px;height:60px}}.landing-page-layout__sub-headline-skeleton{width:100%;height:31px;display:block;margin-top:8px}@media (min-width: 640px){.landing-page-layout__sub-headline-skeleton{width:433px;height:22px}}@media (min-width: 1024px){.landing-page-layout__sub-headline-skeleton{width:493px;height:26px}}@media (min-width: 1440px){.landing-page-layout__sub-headline-skeleton{width:288px;height:26px}}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: UiOnPageBreadcrumbComponent, selector: "sie-ui-on-page-breadcrumb", inputs: ["breadcrumbs", "screenReaderTextHomeButton"], outputs: ["clicked"] }, { kind: "directive", type: i1$1.AttributeDirective, selector: "[sieCoreAttributes]", inputs: ["sieCoreAttributes"] }, { kind: "directive", type: i1$1.AddTruncationAndTooltipDirective, selector: "[sieCoreAddTruncationAndTooltip]", inputs: ["maxNumberOfLinesToShow"] }, { kind: "component", type: UiSkeletonComponent, selector: "sie-ui-skeleton", inputs: ["shape", "loadingText", "ariaLabel", "count"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiSaasLandingPageLayoutComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-saas-landing-page-layout', changeDetection: ChangeDetectionStrategy.OnPush, template: "<section>\n  <header class=\"landing-page-layout__header variant-{{ headerVariant }}\" [sieCoreAttributes]=\"dataAttributes?.header\">\n    <div class=\"container\">\n      <div class=\"landing-page-layout__heading\">\n        <div class=\"landing-page-layout__breadcrumbs\" data-ste-component=\"breadcrumb\">\n          <ng-container *ngIf=\"!loading && !breadCrumbsLoading; else breadcrumbSkeleton\">\n            <sie-ui-on-page-breadcrumb\n              [breadcrumbs]=\"breadCrumbs\"\n              (clicked)=\"breadcrumbClicked.next($event)\"\n              [screenReaderTextHomeButton]=\"screenReaderBreadcrumbHomeButton\"\n            ></sie-ui-on-page-breadcrumb>\n          </ng-container>\n        </div>\n        <div class=\"landing-page-layout__heading-content\">\n          <div class=\"row\">\n            <div class=\"col\">\n              <ng-container *ngIf=\"!loading && !headlineLoading; else headlineSkeleton\">\n                <h1\n                  class=\"landing-page-layout__headline {{ headlineFontSize }}\"\n                  sieCoreAddTruncationAndTooltip\n                  [title]=\"headline\"\n                >\n                  {{ headline }}\n                </h1>\n              </ng-container>\n            </div>\n          </div>\n          <div *ngIf=\"subHeadline\" class=\"row\">\n            <div class=\"col-xl-9\">\n              <ng-container *ngIf=\"!loading && !subHeadlineLoading; else subHeadlineSkeleton\"\n                >{{ subHeadline }}\n              </ng-container>\n            </div>\n          </div>\n\n          <ng-content select=\"[header]\"></ng-content>\n        </div>\n      </div>\n    </div>\n  </header>\n\n  <div\n    class=\"landing-page-layout__content\"\n    [ngClass]=\"{ container: contentContainerClass }\"\n    [sieCoreAttributes]=\"dataAttributes?.content\"\n  >\n    <ng-content select=\"[content]\"></ng-content>\n  </div>\n</section>\n\n<ng-template #breadcrumbSkeleton>\n  <sie-ui-skeleton class=\"landing-page-layout__breadcrumbs-skeleton\"></sie-ui-skeleton>\n</ng-template>\n\n<ng-template #headlineSkeleton>\n  <sie-ui-skeleton class=\"landing-page-layout__headline-skeleton\"></sie-ui-skeleton>\n</ng-template>\n\n<ng-template #subHeadlineSkeleton>\n  <sie-ui-skeleton class=\"landing-page-layout__sub-headline-skeleton\"></sie-ui-skeleton>\n</ng-template>\n", styles: [":host{--width-m: 395px;--height-m: 26px;--width-s: 218px;--height-s: 31px}.landing-page-layout__header{padding:24px 0}.landing-page-layout__header.variant-grey{background-color:#f3f3f0}.landing-page-layout__breadcrumbs{margin-bottom:30px}@media print{.landing-page-layout__breadcrumbs{display:none}}@media (min-width: 1024px){.landing-page-layout__headline{margin-bottom:16px;max-width:714px}}@media print{.landing-page-layout__headline{font-size:28.5px;margin-top:27px}}@media (max-width: 1023.78px){.landing-page-layout__headline{font-size:1.25rem;margin-bottom:8px}}.landing-page-layout__heading-content{position:relative}.landing-page-layout__breadcrumbs-skeleton{width:500px;height:30px;display:block}@media (max-width: 639.78px){.landing-page-layout__breadcrumbs-skeleton{width:var(--width-s);height:var(--height-s);margin-top:-2px}}.landing-page-layout__headline-skeleton{width:269px;height:31px}@media (min-width: 640px){.landing-page-layout__headline-skeleton{width:218px;height:31px}}@media (min-width: 1024px){.landing-page-layout__headline-skeleton{width:738px;height:60px}}.landing-page-layout__sub-headline-skeleton{width:100%;height:31px;display:block;margin-top:8px}@media (min-width: 640px){.landing-page-layout__sub-headline-skeleton{width:433px;height:22px}}@media (min-width: 1024px){.landing-page-layout__sub-headline-skeleton{width:493px;height:26px}}@media (min-width: 1440px){.landing-page-layout__sub-headline-skeleton{width:288px;height:26px}}\n"] }]
        }], propDecorators: { headerVariant: [{
                type: Input
            }], breadCrumbs: [{
                type: Input
            }], headline: [{
                type: Input
            }], subHeadline: [{
                type: Input
            }], loading: [{
                type: Input
            }], breadCrumbsLoading: [{
                type: Input
            }], headlineLoading: [{
                type: Input
            }], subHeadlineLoading: [{
                type: Input
            }], dataAttributes: [{
                type: Input
            }], contentContainerClass: [{
                type: Input
            }], screenReaderBreadcrumbHomeButton: [{
                type: Input
            }], headlineFontSize: [{
                type: Input
            }], breadcrumbClicked: [{
                type: Output
            }] } });

class UiSaasLandingPageLayoutModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiSaasLandingPageLayoutModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiSaasLandingPageLayoutModule, declarations: [UiSaasLandingPageLayoutComponent], imports: [CommonModule,
            UiOnPageBreadcrumbModule,
            AttributeModule,
            AddTruncationAndTooltipModule,
            UiSkeletonModule], exports: [UiSaasLandingPageLayoutComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiSaasLandingPageLayoutModule, imports: [CommonModule,
            UiOnPageBreadcrumbModule,
            AttributeModule,
            AddTruncationAndTooltipModule,
            UiSkeletonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiSaasLandingPageLayoutModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiSaasLandingPageLayoutComponent],
                    imports: [
                        CommonModule,
                        UiOnPageBreadcrumbModule,
                        AttributeModule,
                        AddTruncationAndTooltipModule,
                        UiSkeletonModule
                    ],
                    exports: [UiSaasLandingPageLayoutComponent]
                }]
        }] });

class UiSupportSearchComboboxComponent extends UiComboboxComponent {
    constructor(iconReg, cdr, elementRef, eventPropagationService, cdkOverlayService) {
        super(iconReg, cdr, elementRef, eventPropagationService, cdkOverlayService);
        this.iconReg = iconReg;
        this.cdr = cdr;
        this.elementRef = elementRef;
        this.eventPropagationService = eventPropagationService;
        this.cdkOverlayService = cdkOverlayService;
    }
    onValueChange(value) {
        if (!value) {
            this.menuOpen = false;
        }
        super.onValueChange(value);
    }
    onResetButtonClicked() {
        super.closeOverlay();
        super.onResetButtonClicked();
    }
    openOverlay() {
        if (this.value && !this.disabled) {
            super.openOverlay();
        }
    }
    itemSelected(selectedItem) {
        this.selectedItem = selectedItem;
        if (super.validate()) {
            const selectedItemCopy = selectedItem ? deepCopy(selectedItem) : null;
            this.optionSelected.next(selectedItemCopy);
        }
        if (selectedItem) {
            this.value = this.selectedItem.metaInformation ? selectedItem.metaInformation : selectedItem.label;
        }
        super.updateDisplayedOptions();
    }
    onArrowIconMouseDown(e) {
        if (!this.value) {
            e.preventDefault();
        }
    }
    selectValueAndValidate() {
        if (this._options) {
            const foundOption = this._options.find(option => this.value && option.metaInformation?.toLocaleLowerCase() === this.value?.toLowerCase());
            this.itemSelected(foundOption);
        }
    }
    sortOptions() {
        return 0;
    }
    filterOptions() {
        if (this.originalOptions) {
            return this.originalOptions;
        }
        else {
            return null;
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiSupportSearchComboboxComponent, deps: [{ token: i1.SieIconRegistryService }, { token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: UiEventPropagationService }, { token: CdkOverlayService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiSupportSearchComboboxComponent, selector: "sie-ui-support-search-combobox", providers: [UiEventPropagationService], usesInheritance: true, ngImport: i0, template: "<div\n  class=\"combobox\"\n  (focusin)=\"focusIn()\"\n  (focusout)=\"focusOut()\"\n  #dropDownRendering\n  cdkOverlayOrigin\n  #trigger=\"cdkOverlayOrigin\"\n>\n  <sie-ui-text-input\n    class=\"combobox__input\"\n    [ngClass]=\"{ 'has-value': dropDownElement.value }\"\n    [id]=\"id\"\n    [combobox]=\"true\"\n    [placeholder]=\"placeholder\"\n    [autocomplete]=\"autocomplete\"\n    [disabled]=\"disabled\"\n    [label]=\"label\"\n    [value]=\"value\"\n    [invalid]=\"invalid\"\n    [errorMessage]=\"invalidErrorMessage\"\n    [required]=\"required\"\n    [requiredErrorMessage]=\"requiredErrorMessage\"\n    [validationPattern]=\"validationPattern\"\n    [patternValidationErrorMessage]=\"patternValidationErrorMessage\"\n    [cssErrorClass]=\"menuOpen ? 'combobox-cdk-overlay-error' : ''\"\n    (valueChange)=\"onValueChange($event)\"\n    (click)=\"onInputClick()\"\n    (focused)=\"onInputFocus()\"\n    (keydown.arrowDown)=\"onInputArrowDown($event)\"\n    (keydown.escape)=\"onInputEscape()\"\n    (keydown.enter)=\"onInputKeyEnter()\"\n    (keydown.tab)=\"onInputKeyTab()\"\n    (resetInput)=\"onResetButtonClicked()\"\n    #dropDownElement\n  >\n  </sie-ui-text-input>\n  <sie-icon\n    class=\"combobox__dropdown__icon\"\n    aria-hidden=\"true\"\n    [ngClass]=\"{\n      open: menuOpen,\n      disabled: disabled\n    }\"\n    [name]=\"iconReg.sieIcon.Dropdown\"\n    (click)=\"!menuOpen ? onArrowIconClicked($event) : ''\"\n    (dblclick)=\"onArrowIconClicked($event)\"\n    (mousedown)=\"onArrowIconMouseDown($event)\"\n  ></sie-icon>\n\n  <ng-template\n    cdkConnectedOverlay\n    cdkConnectedOverlayBackdropClass=\"cdk-overlay-hidden-backdrop\"\n    [cdkConnectedOverlayHasBackdrop]=\"false\"\n    [cdkConnectedOverlayOrigin]=\"trigger\"\n    [cdkConnectedOverlayOpen]=\"menuOpen\"\n    [cdkConnectedOverlayPositions]=\"positions\"\n    (backdropClick)=\"focusOut(true)\"\n  >\n    <sie-ui-dropdown-menu\n      cdkTrapFocus\n      *ngIf=\"menuOpen\"\n      class=\"combobox__menu\"\n      [@openClose]=\"menuOpen\"\n      [ngClass]=\"[leftAligned ? 'left-aligned' : '']\"\n      [ngStyle]=\"{ width: dropdownWidth + 'px' }\"\n      [menuPositionedBottom]=\"menuPositionedBottom\"\n    >\n      <div class=\"combobox__content\" content>\n        <ng-container\n          [ngTemplateOutlet]=\"loading ? loadingSpinner : error ? errorEmptyState : mainContent\"\n        ></ng-container>\n      </div>\n    </sie-ui-dropdown-menu>\n  </ng-template>\n</div>\n\n<ng-template #emptySuggestion>\n  <div *ngIf=\"!addCustomValue && !loading && !error\" class=\"combobox__no-results-message\" footer>\n    <p class=\"combobox__no-results-message-title\" [innerHTML]=\"noResultsMessageTitle\"></p>\n    <p class=\"combobox__no-results-message-copy\">{{ noResultsMessageCopy }}</p>\n  </div>\n</ng-template>\n\n<ng-template #loadingSpinner>\n  <div class=\"combobox__loading\">\n    <sie-ui-spinner [message]=\"loadingMessage\" active></sie-ui-spinner>\n  </div>\n</ng-template>\n\n<ng-template #errorEmptyState>\n  <div class=\"combobox__error\">\n    <sie-ui-empty-state\n      [customIcon]=\"iconReg.sieIcon.ErrorFilled\"\n      iconPosition=\"inFrontOfHeadline\"\n      [headline]=\"emptyStateMessageTitle\"\n      [text]=\"emptyStateMessageCopy\"\n    ></sie-ui-empty-state>\n  </div>\n</ng-template>\n\n<ng-template #mainContent>\n  <div *ngIf=\"options?.length || addCustomValue; else emptySuggestion\" class=\"combobox__suggestions\">\n    <ul *ngIf=\"options.length\" class=\"combobox__suggestions-list\">\n      <ng-container *ngFor=\"let option of options; let i = index\">\n        <li\n          *ngIf=\"!option.customValue\"\n          [tabindex]=\"-1\"\n          class=\"combobox__suggestions-item\"\n          role=\"option\"\n          [attr.data-index]=\"i\"\n          (keydown.arrowDown)=\"onOverlayArrowHandler($event)\"\n          (keydown.arrowUp)=\"onOverlayArrowHandler($event)\"\n          (keydown.tab)=\"onOverlayKeyTab()\"\n          (keydown.enter)=\"onOverlayKeyEnter($event, option)\"\n          (keydown.escape)=\"onOverlayKeyEscape()\"\n        >\n          <button\n            [tabindex]=\"-1\"\n            class=\"combobox__suggestions-btn\"\n            [ngClass]=\"{\n              'is-selected': option.id ? highlightedItem?.id === option.id : highlightedItem?.value === option.value,\n              'no-hover': !hover\n            }\"\n            (click)=\"onOverlayClick(option)\"\n            (mouseover)=\"onOverlayMouseOver(i)\"\n            (mouseout)=\"onOverlayMouseOut()\"\n          >\n            <p sieCoreHighlight [reference]=\"value\" [highlightStartOnly]=\"false\">{{ option.label }}</p>\n            <span *ngIf=\"option.metaInformation\" [title]=\"option.metaInformation\" class=\"combobox__meta-information\">{{\n              option.metaInformation\n            }}</span>\n          </button>\n        </li>\n      </ng-container>\n    </ul>\n    <ul\n      *ngIf=\"addCustomValue && customOption\"\n      class=\"combobox__add-option\"\n      [ngClass]=\"{ 'show-line': options.length > 1 }\"\n    >\n      <li\n        [tabindex]=\"-1\"\n        class=\"combobox__suggestions-item\"\n        role=\"option\"\n        [attr.data-index]=\"options.length - 1\"\n        (keydown.arrowDown)=\"onOverlayArrowHandler($event)\"\n        (keydown.arrowUp)=\"onOverlayArrowHandler($event)\"\n        (keydown.tab)=\"onOverlayKeyTab()\"\n        (keydown.enter)=\"onOverlayKeyEnter($event, customOption)\"\n        (keydown.escape)=\"onOverlayKeyEscape()\"\n      >\n        <div footer class=\"combobox__footer\">\n          <button\n            [tabindex]=\"-1\"\n            class=\"combobox__add-option-btn\"\n            (click)=\"onOverlayClick(customOption)\"\n            [ngClass]=\"{\n              'is-selected': highlightedItem?.value === customOption.value,\n              'no-hover': !hover\n            }\"\n            (mouseover)=\"onOverlayMouseOver(options.length - 1)\"\n            (mouseout)=\"onOverlayMouseOut()\"\n          >\n            <p class=\"combobox__add-option-value\">{{ customOption.label }}</p>\n            <p class=\"combobox__add-option-text\">{{ addCustomValueCopy }}</p>\n          </button>\n        </div>\n      </li>\n    </ul>\n  </div>\n</ng-template>\n", styles: [".combobox__dropdown__icon{outline:none;outline-offset:0}@media (pointer: fine){.combobox__dropdown__icon{position:relative}.combobox__dropdown__icon:focus{outline:1px solid #1491eb;outline-offset:2px}.combobox__dropdown__icon:focus:not(:focus-visible){outline:0}.combobox__dropdown__icon:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}:host{display:block}.combobox__add-option-btn,.combobox__suggestions-btn{display:flex;flex-direction:column;width:100%;border:0;background-color:transparent;text-align:left}.is-selected.combobox__add-option-btn,.is-selected.combobox__suggestions-btn,.combobox__add-option-btn:not(.no-hover):hover,.combobox__suggestions-btn:not(.no-hover):hover{background-color:#62eec7;cursor:pointer}.combobox{position:relative;width:100%}.combobox__label{display:flex;align-items:center;width:100%;height:100%}.combobox__menu{width:100%}.combobox__menu ::-webkit-scrollbar-thumb{background-clip:padding-box;background-color:#737389}.combobox__menu ::-webkit-scrollbar-button{display:none}.combobox__menu ::-webkit-scrollbar-corner{background-color:transparent}.combobox__menu ::-webkit-scrollbar{width:16px;height:8px}:host{scrollbar-color:#737389 #fff}:host .dark,:host.dark{scrollbar-color:#ccccd4 #001f39}.combobox__menu ::-webkit-scrollbar-thumb:vertical{border-left:8px solid transparent;border-right:4px solid transparent}.combobox__menu ::-webkit-scrollbar-thumb:horizontal{border-top:4px solid transparent}.combobox__menu ::-webkit-scrollbar-track:vertical{border-left:8px solid #fff;background:#ccccd4;border-right:4px solid #fff}.combobox__menu ::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #ccccd4}.combobox__menu .dark::-webkit-scrollbar-thumb,.combobox__menu .dark ::-webkit-scrollbar-thumb{background-color:#ccccd4}.combobox__menu .dark::-webkit-scrollbar-track:vertical,.combobox__menu .dark ::-webkit-scrollbar-track:vertical{background:#737389;border-right:4px solid #001f39;border-left:8px solid #001f39}.combobox__menu .dark::-webkit-scrollbar-track:horizontal,.combobox__menu .dark ::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #737389}.combobox__dropdown__icon{width:24px;height:24px;display:flex;align-items:center;fill:currentColor;position:absolute;top:16px;right:8px;margin-left:4px;z-index:1;-webkit-user-select:inherit;user-select:inherit;appearance:inherit;cursor:pointer}.combobox__dropdown__icon svg{fill:currentColor;width:inherit;height:inherit}.combobox__dropdown__icon svg g{fill:currentColor;width:inherit;height:inherit}.combobox__dropdown__icon svg text{font-family:Siemens Sans,sans-serif}.combobox__dropdown__icon svg{transition:transform .12s cubic-bezier(.4,0,.3,1)}.combobox__dropdown__icon.open svg{transform:translateZ(0) rotate(180deg)}.combobox__dropdown__icon.disabled{color:#b3b3be}.combobox__loading{height:270px;display:flex;justify-content:center;align-items:center}.combobox__suggestions-list{list-style:none;margin:0;padding:0;max-height:256px;overflow-y:auto}.combobox__suggestions-item:focus{outline:0}.combobox__suggestions-btn{padding:4px 16px}.combobox__meta-information{font-size:.75rem;font-weight:400;line-height:1rem;display:-webkit-box;-webkit-box-orient:vertical;-webkit-line-clamp:1;color:#4c4c68;text-overflow:ellipsis;overflow:hidden}.combobox__no-results-message{width:100%;display:inline-block;padding:4px 16px 6px;text-align:left}.combobox__no-results-message-copy,.combobox__add-option-text{font-size:.75rem;font-weight:400;line-height:1rem;color:#4c4c68}.combobox__add-option{list-style:none;padding:0;margin:0}.combobox__add-option.show-line:before{content:\"\";margin:8px 16px 4px;width:calc(100% - 32px);height:1px;display:block;background:#ccccd4}.combobox__add-option-btn{padding:0 16px 4px}.combobox__add-option-value{font-size:1rem;font-weight:700;line-height:1.5rem;padding-top:4px}.combobox__no-results-message-title,.combobox__add-option-value{white-space:nowrap;overflow:hidden;text-overflow:ellipsis;color:#000028;display:block;width:100%;vertical-align:top}.combobox__error{width:100%}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: i2.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "directive", type: i1$1.HighlightDirective, selector: "[sieCoreHighlight]", inputs: ["reference", "inverted", "highlightStartOnly", "highlightBackgroundColor"] }, { kind: "component", type: UiDropdownMenuComponent, selector: "sie-ui-dropdown-menu", inputs: ["theme", "type", "menuPositionedBottom"] }, { kind: "component", type: UiTextInputComponent, selector: "sie-ui-text-input", inputs: ["inputType", "placeholderIcon"] }, { kind: "component", type: UiSpinnerComponent, selector: "sie-ui-spinner", inputs: ["size", "message", "overlayOnTop", "overlay", "active"], outputs: ["animationEnded"] }, { kind: "component", type: UiEmptyStateComponent, selector: "sie-ui-empty-state", inputs: ["theme", "headline", "text", "link", "button", "iconPosition", "padding", "customIcon"], outputs: ["buttonClicked"] }, { kind: "directive", type: i10.CdkConnectedOverlay, selector: "[cdk-connected-overlay], [connected-overlay], [cdkConnectedOverlay]", inputs: ["cdkConnectedOverlayOrigin", "cdkConnectedOverlayPositions", "cdkConnectedOverlayPositionStrategy", "cdkConnectedOverlayOffsetX", "cdkConnectedOverlayOffsetY", "cdkConnectedOverlayWidth", "cdkConnectedOverlayHeight", "cdkConnectedOverlayMinWidth", "cdkConnectedOverlayMinHeight", "cdkConnectedOverlayBackdropClass", "cdkConnectedOverlayPanelClass", "cdkConnectedOverlayViewportMargin", "cdkConnectedOverlayScrollStrategy", "cdkConnectedOverlayOpen", "cdkConnectedOverlayDisableClose", "cdkConnectedOverlayTransformOriginOn", "cdkConnectedOverlayHasBackdrop", "cdkConnectedOverlayLockPosition", "cdkConnectedOverlayFlexibleDimensions", "cdkConnectedOverlayGrowAfterOpen", "cdkConnectedOverlayPush"], outputs: ["backdropClick", "positionChange", "attach", "detach", "overlayKeydown", "overlayOutsideClick"], exportAs: ["cdkConnectedOverlay"] }, { kind: "directive", type: i10.CdkOverlayOrigin, selector: "[cdk-overlay-origin], [overlay-origin], [cdkOverlayOrigin]", exportAs: ["cdkOverlayOrigin"] }, { kind: "directive", type: i6.CdkTrapFocus, selector: "[cdkTrapFocus]", inputs: ["cdkTrapFocus", "cdkTrapFocusAutoCapture"], exportAs: ["cdkTrapFocus"] }], animations: [createDropdownAnimation()], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiSupportSearchComboboxComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-support-search-combobox', animations: [createDropdownAnimation()], providers: [UiEventPropagationService], changeDetection: ChangeDetectionStrategy.OnPush, template: "<div\n  class=\"combobox\"\n  (focusin)=\"focusIn()\"\n  (focusout)=\"focusOut()\"\n  #dropDownRendering\n  cdkOverlayOrigin\n  #trigger=\"cdkOverlayOrigin\"\n>\n  <sie-ui-text-input\n    class=\"combobox__input\"\n    [ngClass]=\"{ 'has-value': dropDownElement.value }\"\n    [id]=\"id\"\n    [combobox]=\"true\"\n    [placeholder]=\"placeholder\"\n    [autocomplete]=\"autocomplete\"\n    [disabled]=\"disabled\"\n    [label]=\"label\"\n    [value]=\"value\"\n    [invalid]=\"invalid\"\n    [errorMessage]=\"invalidErrorMessage\"\n    [required]=\"required\"\n    [requiredErrorMessage]=\"requiredErrorMessage\"\n    [validationPattern]=\"validationPattern\"\n    [patternValidationErrorMessage]=\"patternValidationErrorMessage\"\n    [cssErrorClass]=\"menuOpen ? 'combobox-cdk-overlay-error' : ''\"\n    (valueChange)=\"onValueChange($event)\"\n    (click)=\"onInputClick()\"\n    (focused)=\"onInputFocus()\"\n    (keydown.arrowDown)=\"onInputArrowDown($event)\"\n    (keydown.escape)=\"onInputEscape()\"\n    (keydown.enter)=\"onInputKeyEnter()\"\n    (keydown.tab)=\"onInputKeyTab()\"\n    (resetInput)=\"onResetButtonClicked()\"\n    #dropDownElement\n  >\n  </sie-ui-text-input>\n  <sie-icon\n    class=\"combobox__dropdown__icon\"\n    aria-hidden=\"true\"\n    [ngClass]=\"{\n      open: menuOpen,\n      disabled: disabled\n    }\"\n    [name]=\"iconReg.sieIcon.Dropdown\"\n    (click)=\"!menuOpen ? onArrowIconClicked($event) : ''\"\n    (dblclick)=\"onArrowIconClicked($event)\"\n    (mousedown)=\"onArrowIconMouseDown($event)\"\n  ></sie-icon>\n\n  <ng-template\n    cdkConnectedOverlay\n    cdkConnectedOverlayBackdropClass=\"cdk-overlay-hidden-backdrop\"\n    [cdkConnectedOverlayHasBackdrop]=\"false\"\n    [cdkConnectedOverlayOrigin]=\"trigger\"\n    [cdkConnectedOverlayOpen]=\"menuOpen\"\n    [cdkConnectedOverlayPositions]=\"positions\"\n    (backdropClick)=\"focusOut(true)\"\n  >\n    <sie-ui-dropdown-menu\n      cdkTrapFocus\n      *ngIf=\"menuOpen\"\n      class=\"combobox__menu\"\n      [@openClose]=\"menuOpen\"\n      [ngClass]=\"[leftAligned ? 'left-aligned' : '']\"\n      [ngStyle]=\"{ width: dropdownWidth + 'px' }\"\n      [menuPositionedBottom]=\"menuPositionedBottom\"\n    >\n      <div class=\"combobox__content\" content>\n        <ng-container\n          [ngTemplateOutlet]=\"loading ? loadingSpinner : error ? errorEmptyState : mainContent\"\n        ></ng-container>\n      </div>\n    </sie-ui-dropdown-menu>\n  </ng-template>\n</div>\n\n<ng-template #emptySuggestion>\n  <div *ngIf=\"!addCustomValue && !loading && !error\" class=\"combobox__no-results-message\" footer>\n    <p class=\"combobox__no-results-message-title\" [innerHTML]=\"noResultsMessageTitle\"></p>\n    <p class=\"combobox__no-results-message-copy\">{{ noResultsMessageCopy }}</p>\n  </div>\n</ng-template>\n\n<ng-template #loadingSpinner>\n  <div class=\"combobox__loading\">\n    <sie-ui-spinner [message]=\"loadingMessage\" active></sie-ui-spinner>\n  </div>\n</ng-template>\n\n<ng-template #errorEmptyState>\n  <div class=\"combobox__error\">\n    <sie-ui-empty-state\n      [customIcon]=\"iconReg.sieIcon.ErrorFilled\"\n      iconPosition=\"inFrontOfHeadline\"\n      [headline]=\"emptyStateMessageTitle\"\n      [text]=\"emptyStateMessageCopy\"\n    ></sie-ui-empty-state>\n  </div>\n</ng-template>\n\n<ng-template #mainContent>\n  <div *ngIf=\"options?.length || addCustomValue; else emptySuggestion\" class=\"combobox__suggestions\">\n    <ul *ngIf=\"options.length\" class=\"combobox__suggestions-list\">\n      <ng-container *ngFor=\"let option of options; let i = index\">\n        <li\n          *ngIf=\"!option.customValue\"\n          [tabindex]=\"-1\"\n          class=\"combobox__suggestions-item\"\n          role=\"option\"\n          [attr.data-index]=\"i\"\n          (keydown.arrowDown)=\"onOverlayArrowHandler($event)\"\n          (keydown.arrowUp)=\"onOverlayArrowHandler($event)\"\n          (keydown.tab)=\"onOverlayKeyTab()\"\n          (keydown.enter)=\"onOverlayKeyEnter($event, option)\"\n          (keydown.escape)=\"onOverlayKeyEscape()\"\n        >\n          <button\n            [tabindex]=\"-1\"\n            class=\"combobox__suggestions-btn\"\n            [ngClass]=\"{\n              'is-selected': option.id ? highlightedItem?.id === option.id : highlightedItem?.value === option.value,\n              'no-hover': !hover\n            }\"\n            (click)=\"onOverlayClick(option)\"\n            (mouseover)=\"onOverlayMouseOver(i)\"\n            (mouseout)=\"onOverlayMouseOut()\"\n          >\n            <p sieCoreHighlight [reference]=\"value\" [highlightStartOnly]=\"false\">{{ option.label }}</p>\n            <span *ngIf=\"option.metaInformation\" [title]=\"option.metaInformation\" class=\"combobox__meta-information\">{{\n              option.metaInformation\n            }}</span>\n          </button>\n        </li>\n      </ng-container>\n    </ul>\n    <ul\n      *ngIf=\"addCustomValue && customOption\"\n      class=\"combobox__add-option\"\n      [ngClass]=\"{ 'show-line': options.length > 1 }\"\n    >\n      <li\n        [tabindex]=\"-1\"\n        class=\"combobox__suggestions-item\"\n        role=\"option\"\n        [attr.data-index]=\"options.length - 1\"\n        (keydown.arrowDown)=\"onOverlayArrowHandler($event)\"\n        (keydown.arrowUp)=\"onOverlayArrowHandler($event)\"\n        (keydown.tab)=\"onOverlayKeyTab()\"\n        (keydown.enter)=\"onOverlayKeyEnter($event, customOption)\"\n        (keydown.escape)=\"onOverlayKeyEscape()\"\n      >\n        <div footer class=\"combobox__footer\">\n          <button\n            [tabindex]=\"-1\"\n            class=\"combobox__add-option-btn\"\n            (click)=\"onOverlayClick(customOption)\"\n            [ngClass]=\"{\n              'is-selected': highlightedItem?.value === customOption.value,\n              'no-hover': !hover\n            }\"\n            (mouseover)=\"onOverlayMouseOver(options.length - 1)\"\n            (mouseout)=\"onOverlayMouseOut()\"\n          >\n            <p class=\"combobox__add-option-value\">{{ customOption.label }}</p>\n            <p class=\"combobox__add-option-text\">{{ addCustomValueCopy }}</p>\n          </button>\n        </div>\n      </li>\n    </ul>\n  </div>\n</ng-template>\n", styles: [".combobox__dropdown__icon{outline:none;outline-offset:0}@media (pointer: fine){.combobox__dropdown__icon{position:relative}.combobox__dropdown__icon:focus{outline:1px solid #1491eb;outline-offset:2px}.combobox__dropdown__icon:focus:not(:focus-visible){outline:0}.combobox__dropdown__icon:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}:host{display:block}.combobox__add-option-btn,.combobox__suggestions-btn{display:flex;flex-direction:column;width:100%;border:0;background-color:transparent;text-align:left}.is-selected.combobox__add-option-btn,.is-selected.combobox__suggestions-btn,.combobox__add-option-btn:not(.no-hover):hover,.combobox__suggestions-btn:not(.no-hover):hover{background-color:#62eec7;cursor:pointer}.combobox{position:relative;width:100%}.combobox__label{display:flex;align-items:center;width:100%;height:100%}.combobox__menu{width:100%}.combobox__menu ::-webkit-scrollbar-thumb{background-clip:padding-box;background-color:#737389}.combobox__menu ::-webkit-scrollbar-button{display:none}.combobox__menu ::-webkit-scrollbar-corner{background-color:transparent}.combobox__menu ::-webkit-scrollbar{width:16px;height:8px}:host{scrollbar-color:#737389 #fff}:host .dark,:host.dark{scrollbar-color:#ccccd4 #001f39}.combobox__menu ::-webkit-scrollbar-thumb:vertical{border-left:8px solid transparent;border-right:4px solid transparent}.combobox__menu ::-webkit-scrollbar-thumb:horizontal{border-top:4px solid transparent}.combobox__menu ::-webkit-scrollbar-track:vertical{border-left:8px solid #fff;background:#ccccd4;border-right:4px solid #fff}.combobox__menu ::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #ccccd4}.combobox__menu .dark::-webkit-scrollbar-thumb,.combobox__menu .dark ::-webkit-scrollbar-thumb{background-color:#ccccd4}.combobox__menu .dark::-webkit-scrollbar-track:vertical,.combobox__menu .dark ::-webkit-scrollbar-track:vertical{background:#737389;border-right:4px solid #001f39;border-left:8px solid #001f39}.combobox__menu .dark::-webkit-scrollbar-track:horizontal,.combobox__menu .dark ::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #737389}.combobox__dropdown__icon{width:24px;height:24px;display:flex;align-items:center;fill:currentColor;position:absolute;top:16px;right:8px;margin-left:4px;z-index:1;-webkit-user-select:inherit;user-select:inherit;appearance:inherit;cursor:pointer}.combobox__dropdown__icon svg{fill:currentColor;width:inherit;height:inherit}.combobox__dropdown__icon svg g{fill:currentColor;width:inherit;height:inherit}.combobox__dropdown__icon svg text{font-family:Siemens Sans,sans-serif}.combobox__dropdown__icon svg{transition:transform .12s cubic-bezier(.4,0,.3,1)}.combobox__dropdown__icon.open svg{transform:translateZ(0) rotate(180deg)}.combobox__dropdown__icon.disabled{color:#b3b3be}.combobox__loading{height:270px;display:flex;justify-content:center;align-items:center}.combobox__suggestions-list{list-style:none;margin:0;padding:0;max-height:256px;overflow-y:auto}.combobox__suggestions-item:focus{outline:0}.combobox__suggestions-btn{padding:4px 16px}.combobox__meta-information{font-size:.75rem;font-weight:400;line-height:1rem;display:-webkit-box;-webkit-box-orient:vertical;-webkit-line-clamp:1;color:#4c4c68;text-overflow:ellipsis;overflow:hidden}.combobox__no-results-message{width:100%;display:inline-block;padding:4px 16px 6px;text-align:left}.combobox__no-results-message-copy,.combobox__add-option-text{font-size:.75rem;font-weight:400;line-height:1rem;color:#4c4c68}.combobox__add-option{list-style:none;padding:0;margin:0}.combobox__add-option.show-line:before{content:\"\";margin:8px 16px 4px;width:calc(100% - 32px);height:1px;display:block;background:#ccccd4}.combobox__add-option-btn{padding:0 16px 4px}.combobox__add-option-value{font-size:1rem;font-weight:700;line-height:1.5rem;padding-top:4px}.combobox__no-results-message-title,.combobox__add-option-value{white-space:nowrap;overflow:hidden;text-overflow:ellipsis;color:#000028;display:block;width:100%;vertical-align:top}.combobox__error{width:100%}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }, { type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: UiEventPropagationService }, { type: CdkOverlayService }]; } });

class UiSupportSearchComboboxModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiSupportSearchComboboxModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiSupportSearchComboboxModule, declarations: [UiSupportSearchComboboxComponent], imports: [CommonModule,
            UiComboboxModule,
            UiButtonModule,
            SieIconsModule,
            HighlightModule,
            FormsModule,
            UiDropdownMenuModule,
            UiTextInputModule,
            UiSpinnerModule,
            UiEmptyStateModule,
            OverlayModule,
            A11yModule], exports: [UiSupportSearchComboboxComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiSupportSearchComboboxModule, imports: [CommonModule,
            UiComboboxModule,
            UiButtonModule,
            SieIconsModule,
            HighlightModule,
            FormsModule,
            UiDropdownMenuModule,
            UiTextInputModule,
            UiSpinnerModule,
            UiEmptyStateModule,
            OverlayModule,
            A11yModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiSupportSearchComboboxModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiSupportSearchComboboxComponent],
                    imports: [
                        CommonModule,
                        UiComboboxModule,
                        UiButtonModule,
                        SieIconsModule,
                        HighlightModule,
                        FormsModule,
                        UiDropdownMenuModule,
                        UiTextInputModule,
                        UiSpinnerModule,
                        UiEmptyStateModule,
                        OverlayModule,
                        A11yModule
                    ],
                    exports: [UiSupportSearchComboboxComponent]
                }]
        }] });

class UiFloatingActionsComponent {
    constructor() {
        this.defaultWidth = '0';
        this.defaultHeight = '0';
        this.defaultJustify = 'flex-end';
        this.defaultAlignment = 'flex-end';
        this.defaultTop = 'auto';
        this.defaultRight = '8px';
        this.defaultBottom = '8px';
        this.defaultLeft = 'auto';
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiFloatingActionsComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiFloatingActionsComponent, selector: "sie-ui-floating-actions", inputs: { defaultWidth: "defaultWidth", defaultHeight: "defaultHeight", defaultJustify: "defaultJustify", defaultAlignment: "defaultAlignment", defaultTop: "defaultTop", defaultRight: "defaultRight", defaultBottom: "defaultBottom", defaultLeft: "defaultLeft" }, host: { properties: { "style.--default-floating-actions-width": "this.defaultWidth", "style.--default-floating-actions-height": "this.defaultHeight", "style.--default-floating-actions-justify": "this.defaultJustify", "style.--default-floating-actions-alignment": "this.defaultAlignment", "style.--default-floating-actions-top": "this.defaultTop", "style.--default-floating-actions-right": "this.defaultRight", "style.--default-floating-actions-bottom": "this.defaultBottom", "style.--default-floating-actions-left": "this.defaultLeft" } }, ngImport: i0, template: "<ng-content></ng-content>\n", styles: [":host{display:flex;position:fixed;width:var(--floating-actions-width, var(--default-floating-actions-width));height:var(--floating-actions-height, var(--default-floating-actions-height));justify-content:var(--floating-actions-justify, var(--default-floating-actions-justify));align-items:var(--floating-actions-alignment, var(--default-floating-actions-alignment));top:var(--floating-actions-top, var(--default-floating-actions-top));right:var(--floating-actions-right, var(--default-floating-actions-right));bottom:var(--floating-actions-bottom, var(--default-floating-actions-bottom));left:var(--floating-actions-left, var(--default-floating-actions-left));z-index:998;transition:opacity cubic-bezier(.2,0,.38,.9) .25s}:host.hidden{opacity:0;pointer-events:none}\n"], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiFloatingActionsComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-floating-actions', changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>\n", styles: [":host{display:flex;position:fixed;width:var(--floating-actions-width, var(--default-floating-actions-width));height:var(--floating-actions-height, var(--default-floating-actions-height));justify-content:var(--floating-actions-justify, var(--default-floating-actions-justify));align-items:var(--floating-actions-alignment, var(--default-floating-actions-alignment));top:var(--floating-actions-top, var(--default-floating-actions-top));right:var(--floating-actions-right, var(--default-floating-actions-right));bottom:var(--floating-actions-bottom, var(--default-floating-actions-bottom));left:var(--floating-actions-left, var(--default-floating-actions-left));z-index:998;transition:opacity cubic-bezier(.2,0,.38,.9) .25s}:host.hidden{opacity:0;pointer-events:none}\n"] }]
        }], propDecorators: { defaultWidth: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['style.--default-floating-actions-width']
            }], defaultHeight: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['style.--default-floating-actions-height']
            }], defaultJustify: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['style.--default-floating-actions-justify']
            }], defaultAlignment: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['style.--default-floating-actions-alignment']
            }], defaultTop: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['style.--default-floating-actions-top']
            }], defaultRight: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['style.--default-floating-actions-right']
            }], defaultBottom: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['style.--default-floating-actions-bottom']
            }], defaultLeft: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['style.--default-floating-actions-left']
            }] } });

class UiFloatingActionsModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiFloatingActionsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiFloatingActionsModule, declarations: [UiFloatingActionsComponent], imports: [CommonModule], exports: [UiFloatingActionsComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiFloatingActionsModule, imports: [CommonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiFloatingActionsModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiFloatingActionsComponent],
                    imports: [CommonModule],
                    exports: [UiFloatingActionsComponent]
                }]
        }] });

const DEFAULT_DROP_ZONE_TYPES = {
    ...DEFAULT_DROP_ZONE,
    allowedFileExtensions: ['.JPEG', '.PNG', '.PDF']
};
const DEFAULT_REPLY_FORM = {
    title: 'MyConversation#ReplyForm#Title',
    textarea: {
        label: 'MyConversation#ReplyForm#Textarea#Label',
        maxCharacters: 3000
    },
    dropzone: DEFAULT_DROP_ZONE_TYPES,
    loadingMessages: ['MyConversation#ReplyForm#Loading'],
    buttonText: {
        send: 'MyConversation#ReplyForm#Button#Send',
        cancel: 'MyConversation#ReplyForm#Button#Cancel'
    },
    messageBoxes: {
        success: {
            headline: 'MyConversation#ReplyForm#MessageBox#Success#Headline',
            description: 'MyConversation#ReplyForm#MessageBox#Success#Desc'
        },
        error: {
            headline: 'MyConversation#ReplyForm#MessageBox#Error#Headline',
            description: 'MyConversation#ReplyForm#MessageBox#Error#Desc'
        },
        draft: {
            headline: 'MyConversation#ReplyForm#MessageBox#Draft#Headline',
            description: 'MyConversation#ReplyForm#MessageBox#Draft#Desc',
            buttonText: 'MyConversation#ReplyForm#MessageBox#Draft#ButtonText'
        }
    },
    cancelModal: {
        headline: 'MyConversation#ReplyForm#CancelModal#Headline',
        text: 'MyConversation#ReplyForm#CancelModal#Text',
        okButton: {
            text: 'MyConversation#ReplyForm#CancelModal#OkButtonText'
        },
        cancelButton: {
            text: 'MyConversation#ReplyForm#CancelModal#CancelButtonText'
        },
        size: 'small',
        screenReaderCloseIcon: 'Global#Close'
    },
    validationMessages: {
        invalidCharacters: 'MyConversation#ReplyForm#TextareaValidation#InvalidCharacters',
        characterLimit: 'MyConversation#ReplyForm#TextareaValidation#CharacterLimit'
    },
    disclaimer: 'MyConversation#ReplyForm#Disclaimer'
};
const FILE_EXTENSION_SEPARATOR = '.';
const FILE_BODY_BASE64_SEPARATOR = 'base64,';

const DEFAULT_NUMBER_OF_SKELETONS = 7;
class UiTileButtonGroupSkeletonComponent {
    constructor() {
        this.NUMBER_OF_SKELETONS = DEFAULT_NUMBER_OF_SKELETONS;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTileButtonGroupSkeletonComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiTileButtonGroupSkeletonComponent, selector: "sie-ui-tile-button-group-skeleton", ngImport: i0, template: "<div class=\"tile-button-group-skeleton\">\n  <sie-ui-skeleton *sieCoreRepeat=\"NUMBER_OF_SKELETONS\" class=\"skeleton\"></sie-ui-skeleton>\n</div>\n", styles: [".tile-button-group-skeleton{display:grid;grid-gap:2px;grid-template-columns:repeat(7,minmax(144px,320px))}@media (max-width: 1439.78px){.tile-button-group-skeleton{grid-template-columns:repeat(4,minmax(144px,320px))}}@media (max-width: 639.78px){.tile-button-group-skeleton{grid-template-columns:repeat(2,minmax(144px,320px))}}.tile-button-group-skeleton .skeleton{height:102px}\n"], dependencies: [{ kind: "component", type: UiSkeletonComponent, selector: "sie-ui-skeleton", inputs: ["shape", "loadingText", "ariaLabel", "count"] }, { kind: "directive", type: i1$1.RepeatDirective, selector: "[sieCoreRepeat]", inputs: ["sieCoreRepeat"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTileButtonGroupSkeletonComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-tile-button-group-skeleton', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"tile-button-group-skeleton\">\n  <sie-ui-skeleton *sieCoreRepeat=\"NUMBER_OF_SKELETONS\" class=\"skeleton\"></sie-ui-skeleton>\n</div>\n", styles: [".tile-button-group-skeleton{display:grid;grid-gap:2px;grid-template-columns:repeat(7,minmax(144px,320px))}@media (max-width: 1439.78px){.tile-button-group-skeleton{grid-template-columns:repeat(4,minmax(144px,320px))}}@media (max-width: 639.78px){.tile-button-group-skeleton{grid-template-columns:repeat(2,minmax(144px,320px))}}.tile-button-group-skeleton .skeleton{height:102px}\n"] }]
        }] });

/**
 * # Tile button group component
 *
 * Tile button group is a component that acts as a list of highlighted actions or links that allow user to perform actions or to jump from one context to the other.
 *
 * ## Component variations
 *
 * There are no variations.
 *
 * ## Content
 *
 * Tile button group does not accept any content.
 *
 * ## Code example
 * @example
 * Template:
 * ```html
 * <sie-ui-tile-button-group [tileButtonGroupData]="data"></sie-ui-tile-button-group-data>
 * ```
 *
 * Data example:
 * ``` js
 * const data = [
 *  {
 *    title: 'Tile button with two lines of text',
 *    icon: 'Newton_productCatalogue',
 *    link: {
 *      type: 'url',
 *      href: 'https://www.siemens.com',
 *      target: '_blank'
 *    }
 *  },
 *  {
 *    title: 'Services',
 *    icon: 'Service',
 *    link: {
 *      type: 'url',
 *      href: 'https://www.siemens.com',
 *      target: '_self'
 *    }
 *  },
 *  {
 *    title: 'Support requests',
 *    icon: 'Support',
 *    link: {
 *      type: 'url',
 *      href: 'https://www.siemens.com'
 *    }
 *  }
 * ];
 * ```
 */
class UiTileButtonGroupComponent {
    /**
     * The main source of {@link UiTileButtonGroupModel Tile button group data}.
     */
    set tileButtonGroupData(value) {
        if (value?.length >= UIConstants.TILE_BUTTONS_MIN) {
            this._tileButtonGroupData = value.slice(0, UIConstants.TILE_BUTTONS_MAX);
            this.loadIcons();
        }
    }
    get tileButtonGroupData() {
        return this._tileButtonGroupData;
    }
    constructor(iconReg) {
        this.iconReg = iconReg;
        /** @ignore */
        this.tileButtonGroupViewports = new Map([
            ['S', 328],
            ['M', 608],
            ['L', 912],
            ['XL', 1248]
        ]);
        /** @ignore */
        this.minNumberOfTiles = UIConstants.TILE_BUTTONS_MIN;
        /** @ignore */
        this.maxNumberOfTiles = UIConstants.TILE_BUTTONS_MAX;
    }
    loadIcons() {
        if (this.tileButtonGroupData) {
            this.tileButtonGroupData.forEach(tileButton => this.iconReg.register(tileButton.icon));
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTileButtonGroupComponent, deps: [{ token: i1.SieIconRegistryService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiTileButtonGroupComponent, selector: "sie-ui-tile-button-group", inputs: { tileButtonGroupData: "tileButtonGroupData" }, ngImport: i0, template: "<sie-ui-tile-button-group-skeleton\n  *ngIf=\"!tileButtonGroupData?.length; else tileButtonGroup\"\n></sie-ui-tile-button-group-skeleton>\n\n<ng-template #tileButtonGroup>\n  <ul\n    *ngIf=\"tileButtonGroupData\"\n    class=\"tile-button-group\"\n    [ngClass]=\"'number-of-tiles--' + tileButtonGroupData.length\"\n    [sieCoreComponentBreakpoints]=\"tileButtonGroupViewports\"\n  >\n    <ng-container *ngFor=\"let item of tileButtonGroupData\">\n      <li class=\"tile-button-group__item\">\n        <a\n          href=\"{{ item.link.href }}\"\n          class=\"tile-button-group__link\"\n          [target]=\"item.link.target\"\n          [title]=\"item.toolTipValue\"\n          rel=\"noopener\"\n          [sieCoreAttributes]=\"item.dataAttributes\"\n        >\n          <sie-icon class=\"tile-button-group__link__icon\" [name]=\"item.icon\"></sie-icon>\n          <span class=\"tile-button-group__link__text\">{{ item.title }}</span>\n        </a>\n      </li>\n    </ng-container>\n  </ul>\n</ng-template>\n", styles: [".tile-button-group__item .tile-button-group__link{outline:none;outline-offset:0}@media (pointer: fine){.tile-button-group__item .tile-button-group__link{position:relative}.tile-button-group__item .tile-button-group__link:focus{outline:1px solid #1491eb;outline-offset:2px}.tile-button-group__item .tile-button-group__link:focus:not(:focus-visible){outline:0}.tile-button-group__item .tile-button-group__link:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}.tile-button-group{list-style:none;margin:0;padding:0;width:100%;display:grid;grid-gap:2px;grid-auto-rows:1fr}.tile-button-group.component-viewport--S{grid-template-columns:repeat(2,minmax(144px,320px))}.tile-button-group.component-viewport--M{grid-template-columns:repeat(4,minmax(144px,320px))}.tile-button-group.component-viewport--M.number-of-tiles--3,.tile-button-group.component-viewport--M.number-of-tiles--5,.tile-button-group.component-viewport--M.number-of-tiles--6{grid-template-columns:repeat(3,minmax(144px,320px))}.tile-button-group.component-viewport--M.number-of-tiles--2{grid-template-columns:repeat(2,minmax(144px,320px))}.tile-button-group.component-viewport--L{grid-template-columns:repeat(4,minmax(144px,320px))}.tile-button-group.component-viewport--L.number-of-tiles--6{grid-template-columns:repeat(6,minmax(144px,320px))}.tile-button-group.component-viewport--L.number-of-tiles--5{grid-template-columns:repeat(5,minmax(144px,320px))}.tile-button-group.component-viewport--L.number-of-tiles--4{grid-template-columns:repeat(4,minmax(144px,320px))}.tile-button-group.component-viewport--L.number-of-tiles--3{grid-template-columns:repeat(3,minmax(144px,320px))}.tile-button-group.component-viewport--L.number-of-tiles--2{grid-template-columns:repeat(2,minmax(144px,320px))}.tile-button-group.component-viewport--XL.number-of-tiles--8{grid-template-columns:repeat(8,minmax(144px,320px))}.tile-button-group.component-viewport--XL.number-of-tiles--7{grid-template-columns:repeat(7,minmax(144px,320px))}.tile-button-group.component-viewport--XL.number-of-tiles--6{grid-template-columns:repeat(6,minmax(144px,320px))}.tile-button-group.component-viewport--XL.number-of-tiles--5{grid-template-columns:repeat(5,minmax(144px,320px))}.tile-button-group.component-viewport--XL.number-of-tiles--4{grid-template-columns:repeat(4,minmax(144px,320px))}.tile-button-group.component-viewport--XL.number-of-tiles--3{grid-template-columns:repeat(3,minmax(144px,320px))}.tile-button-group.component-viewport--XL.number-of-tiles--2{grid-template-columns:repeat(2,minmax(144px,320px))}.tile-button-group__item{display:inline-flex;position:relative;min-width:144px;max-width:320px;min-height:102px;max-height:120px;background-color:#007993;box-shadow:0 2px 2px #0000000f,0 6px 8px #00000014}.tile-button-group__item:hover,.tile-button-group__item:active{background:#00646e}.tile-button-group__link{display:flex;flex-direction:column;justify-content:flex-start;align-items:center;width:100%;padding:24px 8px}.tile-button-group__link__text{font-size:1rem;font-weight:700;line-height:1.5rem;display:-webkit-box;-webkit-box-orient:vertical;-webkit-line-clamp:2;line-height:20px;max-width:100%;color:#fff;text-align:center;text-overflow:ellipsis;overflow:hidden}.tile-button-group__link__icon{width:24px;height:24px;display:flex;align-items:center;fill:currentColor;margin-bottom:10px;color:#fff}.tile-button-group__link__icon svg{fill:currentColor;width:inherit;height:inherit}.tile-button-group__link__icon svg g{fill:currentColor;width:inherit;height:inherit}.tile-button-group__link__icon svg text{font-family:Siemens Sans,sans-serif}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "directive", type: i1$1.ComponentBreakpointsDirective, selector: "[sieCoreComponentBreakpoints]", inputs: ["sieCoreComponentBreakpoints"], outputs: ["componentViewportChanged"] }, { kind: "directive", type: i1$1.AttributeDirective, selector: "[sieCoreAttributes]", inputs: ["sieCoreAttributes"] }, { kind: "component", type: UiTileButtonGroupSkeletonComponent, selector: "sie-ui-tile-button-group-skeleton" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTileButtonGroupComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-tile-button-group', changeDetection: ChangeDetectionStrategy.OnPush, template: "<sie-ui-tile-button-group-skeleton\n  *ngIf=\"!tileButtonGroupData?.length; else tileButtonGroup\"\n></sie-ui-tile-button-group-skeleton>\n\n<ng-template #tileButtonGroup>\n  <ul\n    *ngIf=\"tileButtonGroupData\"\n    class=\"tile-button-group\"\n    [ngClass]=\"'number-of-tiles--' + tileButtonGroupData.length\"\n    [sieCoreComponentBreakpoints]=\"tileButtonGroupViewports\"\n  >\n    <ng-container *ngFor=\"let item of tileButtonGroupData\">\n      <li class=\"tile-button-group__item\">\n        <a\n          href=\"{{ item.link.href }}\"\n          class=\"tile-button-group__link\"\n          [target]=\"item.link.target\"\n          [title]=\"item.toolTipValue\"\n          rel=\"noopener\"\n          [sieCoreAttributes]=\"item.dataAttributes\"\n        >\n          <sie-icon class=\"tile-button-group__link__icon\" [name]=\"item.icon\"></sie-icon>\n          <span class=\"tile-button-group__link__text\">{{ item.title }}</span>\n        </a>\n      </li>\n    </ng-container>\n  </ul>\n</ng-template>\n", styles: [".tile-button-group__item .tile-button-group__link{outline:none;outline-offset:0}@media (pointer: fine){.tile-button-group__item .tile-button-group__link{position:relative}.tile-button-group__item .tile-button-group__link:focus{outline:1px solid #1491eb;outline-offset:2px}.tile-button-group__item .tile-button-group__link:focus:not(:focus-visible){outline:0}.tile-button-group__item .tile-button-group__link:focus-visible{outline:1px solid #1491eb;outline-offset:2px}}.tile-button-group{list-style:none;margin:0;padding:0;width:100%;display:grid;grid-gap:2px;grid-auto-rows:1fr}.tile-button-group.component-viewport--S{grid-template-columns:repeat(2,minmax(144px,320px))}.tile-button-group.component-viewport--M{grid-template-columns:repeat(4,minmax(144px,320px))}.tile-button-group.component-viewport--M.number-of-tiles--3,.tile-button-group.component-viewport--M.number-of-tiles--5,.tile-button-group.component-viewport--M.number-of-tiles--6{grid-template-columns:repeat(3,minmax(144px,320px))}.tile-button-group.component-viewport--M.number-of-tiles--2{grid-template-columns:repeat(2,minmax(144px,320px))}.tile-button-group.component-viewport--L{grid-template-columns:repeat(4,minmax(144px,320px))}.tile-button-group.component-viewport--L.number-of-tiles--6{grid-template-columns:repeat(6,minmax(144px,320px))}.tile-button-group.component-viewport--L.number-of-tiles--5{grid-template-columns:repeat(5,minmax(144px,320px))}.tile-button-group.component-viewport--L.number-of-tiles--4{grid-template-columns:repeat(4,minmax(144px,320px))}.tile-button-group.component-viewport--L.number-of-tiles--3{grid-template-columns:repeat(3,minmax(144px,320px))}.tile-button-group.component-viewport--L.number-of-tiles--2{grid-template-columns:repeat(2,minmax(144px,320px))}.tile-button-group.component-viewport--XL.number-of-tiles--8{grid-template-columns:repeat(8,minmax(144px,320px))}.tile-button-group.component-viewport--XL.number-of-tiles--7{grid-template-columns:repeat(7,minmax(144px,320px))}.tile-button-group.component-viewport--XL.number-of-tiles--6{grid-template-columns:repeat(6,minmax(144px,320px))}.tile-button-group.component-viewport--XL.number-of-tiles--5{grid-template-columns:repeat(5,minmax(144px,320px))}.tile-button-group.component-viewport--XL.number-of-tiles--4{grid-template-columns:repeat(4,minmax(144px,320px))}.tile-button-group.component-viewport--XL.number-of-tiles--3{grid-template-columns:repeat(3,minmax(144px,320px))}.tile-button-group.component-viewport--XL.number-of-tiles--2{grid-template-columns:repeat(2,minmax(144px,320px))}.tile-button-group__item{display:inline-flex;position:relative;min-width:144px;max-width:320px;min-height:102px;max-height:120px;background-color:#007993;box-shadow:0 2px 2px #0000000f,0 6px 8px #00000014}.tile-button-group__item:hover,.tile-button-group__item:active{background:#00646e}.tile-button-group__link{display:flex;flex-direction:column;justify-content:flex-start;align-items:center;width:100%;padding:24px 8px}.tile-button-group__link__text{font-size:1rem;font-weight:700;line-height:1.5rem;display:-webkit-box;-webkit-box-orient:vertical;-webkit-line-clamp:2;line-height:20px;max-width:100%;color:#fff;text-align:center;text-overflow:ellipsis;overflow:hidden}.tile-button-group__link__icon{width:24px;height:24px;display:flex;align-items:center;fill:currentColor;margin-bottom:10px;color:#fff}.tile-button-group__link__icon svg{fill:currentColor;width:inherit;height:inherit}.tile-button-group__link__icon svg g{fill:currentColor;width:inherit;height:inherit}.tile-button-group__link__icon svg text{font-family:Siemens Sans,sans-serif}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }]; }, propDecorators: { tileButtonGroupData: [{
                type: Input
            }] } });

/**
 * # Tile Button Group Module
 * - {@link UiTileButtonGroupComponent}
 *
 * ## Module peer dependencies
 * - {@link SieIconsModule}
 */
class UiTileButtonGroupModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTileButtonGroupModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiTileButtonGroupModule, declarations: [UiTileButtonGroupComponent, UiTileButtonGroupSkeletonComponent], imports: [CommonModule,
            SieIconsModule,
            ComponentBreakpointsModule,
            AttributeModule,
            UiSkeletonModule,
            RepeatDirective], exports: [UiTileButtonGroupComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTileButtonGroupModule, imports: [CommonModule,
            SieIconsModule,
            ComponentBreakpointsModule,
            AttributeModule,
            UiSkeletonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiTileButtonGroupModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiTileButtonGroupComponent, UiTileButtonGroupSkeletonComponent],
                    imports: [
                        CommonModule,
                        SieIconsModule,
                        ComponentBreakpointsModule,
                        AttributeModule,
                        UiSkeletonModule,
                        RepeatDirective
                    ],
                    exports: [UiTileButtonGroupComponent]
                }]
        }] });

/**
 * # Filter tag component
 *
 * Filter tags signalize the state or category of an item. As a selectable tag, it is interactive for the user and enables content filtering.
 *
 * ## Component variations
 *
 * - Single select
 * - Multiple select
 *
 * ## Content
 *
 * The filter tag component does not accept any content.
 *
 * ## Code examples
 * @example ```html
 * <sie-ui-filter-tag
 *   [options]="options"
 *   selectionType="single"
 *   placeholder="select"
 *   selectedPrefix="selected"
 *   (selectionChanged)="onSelectionChanged($event)"
 *   (clearInput)="onClearInput()"
 *   (dropdownMenuOpened)="onDropdownMenuOpened($event)"
 * ></sie-ui-filter-tag>
 *
 * <sie-ui-filter-tag
 *   selectionType="boolean"
 *   placeholder="select"
 *   selectedPrefix="unselect"
 *   (selectionChanged)="onSelectionChanged($event)"
 * ></sie-ui-filter-tag>
 *
 * <sie-ui-filter-tag
 *   placeholder="event only"
 *   [screenReader]="screenReader"
 *   [openOverlayOnClick]="false"
 *   (dropdownMenuOpened)="onDropdownMenuOpened($event)"
 * ></sie-ui-filter-tag>
 * ```
 */
class UiFilterTagComponent extends UiDropdownBaseDirective {
    get options() {
        return super.options;
    }
    /**
     * @param value defines dropdown content {@link UiDropdownMenuModel}. This will also reset the selection, make sure to call 'selectedValues' to restore selection
     * if selectionType = 'boolean' options should be omitted
     */
    set options(value) {
        this.selectedValues = [];
        super.options = value;
        this.updateItemDisplay();
    }
    get selectedValues() {
        return this._selectedValues;
    }
    /**
     * @param values Defines which options of the component are selected by default (controlled through `value` set in `options` input)
     */
    set selectedValues(values) {
        if (typeof values === 'boolean') {
            this._selectedValues = values;
            this.selected = values;
            this.setButtonLabel();
        }
        else if (Array.isArray(values)) {
            this._selectedValues = this.options?.map(option => option.value).filter(value => values?.includes(value)) || [];
            this.selected = !!this._selectedValues.length;
            this.updateItemDisplay();
        }
    }
    /**
     * @param value defines if overlay should open on click or just trigger the dropdownMenuOpened without opening
     * @default true
     */
    set openOverlayOnClick(value) {
        this._openOverlayOnClick = coerceBooleanProperty(value);
    }
    get openOverlayOnClick() {
        return this._openOverlayOnClick;
    }
    /**
     * @param icon {@link SieIcon Icon} Defines optional icon before the text
     */
    set icon(icon) {
        if (icon) {
            this.iconReg.register(icon);
            this._icon = icon;
        }
    }
    get icon() {
        return this._icon;
    }
    constructor(iconReg, elementRef, cdr, layoutService, eventPropagationService, cdkOverlayService) {
        super(cdr, elementRef, eventPropagationService, cdkOverlayService);
        this.iconReg = iconReg;
        this.elementRef = elementRef;
        this.cdr = cdr;
        this.layoutService = layoutService;
        this.eventPropagationService = eventPropagationService;
        this.cdkOverlayService = cdkOverlayService;
        /**
         * Defines the style of the menu {@link UiFilterTagSelectionType selectionType}
         * @default 'single'
         */
        this.selectionType = 'single';
        /**
         * Event triggered when a different option in dropdown is selected
         * or when selectionType = 'boolean' and button is being clicked
         */
        this.selectionChanged = new EventEmitter();
        this.computedLabel = '';
        this.selectionDisplay = '';
        this.selected = false;
        this._selectedValues = false;
        this._openOverlayOnClick = true;
        iconReg.register(SieIcon.Dropdown);
        iconReg.register(SieIcon.CheckMark); // used in ui-dropdown-options.component.html
        iconReg.register(SieIcon.CloseSmall);
    }
    /** @ignore */
    ngOnInit() {
        this.breakpointSubscription = this.layoutService.breakPointChangedEvent.subscribe(() => {
            if (this.menuOpen) {
                this.recalculatePositions();
            }
        });
    }
    ngOnChanges() {
        this.setButtonLabel();
    }
    /** @ignore */
    ngOnDestroy() {
        this.closeOverlay();
        this.breakpointSubscription?.unsubscribe();
    }
    /** @ignore */
    determineHorizontalMenuAlignment() {
        // nothing special needed
    }
    /** @ignore */
    toggleDropDown() {
        if (this.selectionType === 'boolean' && !this.disabled) {
            this.selectedValues = !this.selectedValues;
            this.selectionChanged.emit(this.selectedValues);
            return;
        }
        super.toggleDropDown();
    }
    /** @ignore */
    focusOut() {
        if (this.optionsComponent?.isElementFocused()) {
            return;
        }
        super.focusOut();
    }
    /** @ignore */
    resetSelection(clickEvent) {
        clickEvent.preventDefault();
        if (!this.disabled) {
            this.selectedValues = [];
            this.clearInput.emit();
            this.selectionChanged.emit([]);
        }
    }
    /** @ignore */
    itemSelected(selectedItem) {
        if (!selectedItem.disabled) {
            this.updateSelection(selectedItem);
            this.selectionChanged.emit(this.selectedValues);
            if (this.selectionType === 'single') {
                this.closeOverlay(true);
                this.eventPropagationService.stopPrevention();
            }
        }
    }
    setButtonLabel() {
        if (this.selectionType !== 'boolean' && Array.isArray(this.selectedValues) && !!this.selectedValues.length) {
            this.computedLabel = `${this.selectedPrefix} (${this.selectionDisplay})`;
        }
        else if (this.selected) {
            this.computedLabel = this.selectedPrefix;
        }
        else {
            this.computedLabel = this.placeholder;
        }
    }
    updateSelection(selectedItem) {
        if (this.selectionType === 'multiple' && Array.isArray(this.selectedValues)) {
            const selectedValues = this.selectedValues.slice();
            const index = selectedValues.indexOf(selectedItem.value);
            if (index >= 0) {
                selectedValues.splice(index, 1);
            }
            else {
                selectedValues.push(selectedItem.value);
            }
            this.selectedValues = selectedValues;
        }
        else {
            this.selectedValues = [selectedItem.value];
        }
    }
    updateItemDisplay() {
        const selection = this.selectedValues;
        if (Array.isArray(selection)) {
            this.selectionDisplay = this.options
                .filter(option => selection.includes(option.value))
                .map(option => option.label)
                .join(', ');
        }
        this.setButtonLabel();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiFilterTagComponent, deps: [{ token: i1.SieIconRegistryService }, { token: i0.ElementRef }, { token: i0.ChangeDetectorRef }, { token: i1$1.LayoutService }, { token: UiEventPropagationService }, { token: CdkOverlayService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiFilterTagComponent, selector: "sie-ui-filter-tag", inputs: { selectionType: "selectionType", placeholder: "placeholder", selectedPrefix: "selectedPrefix", screenReader: "screenReader", options: "options", selectedValues: "selectedValues", openOverlayOnClick: "openOverlayOnClick", icon: "icon" }, outputs: { selectionChanged: "selectionChanged" }, providers: [UiEventPropagationService], viewQueries: [{ propertyName: "optionsComponent", first: true, predicate: UiDropdownOptionsComponent, descendants: true }], usesInheritance: true, usesOnChanges: true, ngImport: i0, template: "<div class=\"filter-tag\" [class.selected]=\"selected\">\n  <div\n    class=\"filter-tag__button-wrapper\"\n    [class.disabled]=\"disabled\"\n    (focusin)=\"focusIn()\"\n    (focusout)=\"focusOut()\"\n    #dropDownRendering\n  >\n    <div\n      class=\"filter-tag__expand-button button\"\n      type=\"button\"\n      [attr.aria-haspopup]=\"selectionType === 'boolean' ? null : 'listbox'\"\n      [attr.tabindex]=\"disabled ? -1 : 0\"\n      (keydown.enter)=\"toggleDropDown()\"\n      (keydown.space)=\"toggleDropDown()\"\n      (keydown.arrowDown)=\"onArrowDownOnButton($event)\"\n      (keydown.escape)=\"handleEscape($event)\"\n      (keyup.escape)=\"eventPropagationService.handleEvent($event)\"\n      [ngClass]=\"{\n        disabled: disabled,\n        open: menuOpen && openOverlayOnClick,\n        dark: theme === 'dark',\n        light: theme === 'light',\n        boolean: selectionType === 'boolean',\n        'with-icon': icon\n      }\"\n      #dropDownElement\n      (click)=\"toggleDropDown()\"\n      cdkOverlayOrigin\n      #trigger=\"cdkOverlayOrigin\"\n    >\n      <sie-icon *ngIf=\"icon\" class=\"filter-tag__expand-button__custom-icon\" [name]=\"icon\" aria-hidden=\"true\"></sie-icon>\n      <div sieCoreAddTruncationAndTooltip class=\"selected-label\">\n        <span [innerText]=\"computedLabel\"></span>\n      </div>\n      <sie-icon\n        *ngIf=\"selectionType !== 'boolean' || selected\"\n        class=\"filter-tag__expand-button__icon\"\n        aria-hidden=\"true\"\n        [name]=\"selectionType === 'boolean' ? iconReg.sieIcon.CloseSmall : iconReg.sieIcon.Dropdown\"\n      ></sie-icon>\n    </div>\n    <button\n      *ngIf=\"selectionType !== 'boolean' && selected\"\n      class=\"filter-tag__reset-button button\"\n      [ngClass]=\"{ disabled: disabled }\"\n      [attr.tabindex]=\"disabled ? -1 : 0\"\n      (click)=\"resetSelection($event)\"\n      type=\"button\"\n    >\n      <span *ngIf=\"!!screenReader?.reset\" class=\"visually-hidden\">{{ screenReader.reset }}</span>\n      <sie-icon class=\"filter-tag__reset-button__icon\" [name]=\"iconReg.sieIcon.CloseSmall\"></sie-icon>\n    </button>\n  </div>\n  <ng-template\n    *ngIf=\"openOverlayOnClick\"\n    cdkConnectedOverlay\n    cdkConnectedOverlayHasBackdrop\n    cdkConnectedOverlayBackdropClass=\"cdk-overlay-transparent-backdrop\"\n    [cdkConnectedOverlayOrigin]=\"trigger\"\n    [cdkConnectedOverlayOpen]=\"menuOpen\"\n    (overlayKeydown)=\"optionsComponent.onArrowHandler($event)\"\n    (backdropClick)=\"menuOpen = false\"\n    [cdkConnectedOverlayMinHeight]=\"overlayPaneHeight\"\n  >\n    <sie-ui-dropdown-menu\n      cdkTrapFocus\n      class=\"filter-tag__dropdown-menu\"\n      [@openClose]=\"menuOpen\"\n      [theme]=\"theme\"\n      [ngClass]=\"theme\"\n      [style.width]=\"dropdownWidth + 'px'\"\n      [menuPositionedBottom]=\"menuPositionedBottom\"\n    >\n      <sie-ui-dropdown-options\n        content\n        [selectionType]=\"selectionType\"\n        [open]=\"menuOpen\"\n        [ariaLabel]=\"screenReader?.options\"\n        [options]=\"options\"\n        [theme]=\"theme\"\n        [ngClass]=\"theme\"\n        [selectedValues]=\"selectedValues\"\n        [displayIconSpace]=\"displayIconSpace\"\n        (optionDiscarded)=\"closeOverlay(true)\"\n        (optionSelected)=\"itemSelected($event)\"\n      ></sie-ui-dropdown-options>\n    </sie-ui-dropdown-menu>\n  </ng-template>\n</div>\n", styles: [".selected .filter-tag__reset-button:focus-visible:not(.disabled),.selected .filter-tag__expand-button:focus-visible:not(.boolean):not(.disabled),.button:focus-visible{outline:0}:host{display:block;max-width:328px}.button{padding:0;margin:0;background-color:initial;color:#007993;height:40px;border-radius:4px;display:flex;border:1px solid #007993}.button.disabled{color:#b3b3be;border-color:#b3b3be;cursor:not-allowed}.button:focus-visible{position:relative}.button:focus-visible:before{content:\"\";position:absolute;inset:-3px;z-index:1;border:1px solid #1491eb;border-radius:4px}.selected .button{color:#fff;background-color:#33747a;border-color:#33747a}.selected .button.disabled{color:#ebebee;background-color:#b3b3be;border-color:#b3b3be}.button:hover:not(.disabled){color:#33747a;background-color:#c2ffee;border-color:#33747a;cursor:pointer}.filter-tag__button-wrapper{display:flex;width:100%}.filter-tag__dropdown-menu{padding-top:4px}.filter-tag__expand-button{max-width:100%;padding:0 6px 0 12px;align-items:center}.filter-tag__expand-button.with-icon{padding-left:8px}.filter-tag__expand-button.boolean{padding-right:12px}.filter-tag__expand-button .selected-label{margin:auto 0;display:block}.filter-tag__expand-button__custom-icon{width:20px;height:20px;display:flex;align-items:center;fill:currentColor;margin-right:8px}.filter-tag__expand-button__custom-icon svg{fill:currentColor;width:inherit;height:inherit}.filter-tag__expand-button__custom-icon svg g{fill:currentColor;width:inherit;height:inherit}.filter-tag__expand-button__custom-icon svg text{font-family:Siemens Sans,sans-serif}.filter-tag__expand-button__icon{width:24px;height:24px;display:flex;align-items:center;fill:currentColor;margin:auto auto auto 8px}.filter-tag__expand-button__icon svg{fill:currentColor;width:inherit;height:inherit}.filter-tag__expand-button__icon svg g{fill:currentColor;width:inherit;height:inherit}.filter-tag__expand-button__icon svg text{font-family:Siemens Sans,sans-serif}.filter-tag__expand-button__icon svg{transition:transform .12s cubic-bezier(.4,0,.3,1)}.open .filter-tag__expand-button__icon svg{transform:translateZ(0) rotate(180deg)}.boolean .filter-tag__expand-button__icon{width:20px;height:20px;display:flex;align-items:center;fill:currentColor}.boolean .filter-tag__expand-button__icon svg{fill:currentColor;width:inherit;height:inherit}.boolean .filter-tag__expand-button__icon svg g{fill:currentColor;width:inherit;height:inherit}.boolean .filter-tag__expand-button__icon svg text{font-family:Siemens Sans,sans-serif}.selected .filter-tag__expand-button:not(.boolean){max-width:calc(100% - 36px);border-right:none;border-radius:4px 0 0 4px}.selected .filter-tag__expand-button:not(.boolean):focus-visible:not(.disabled){position:relative}.selected .filter-tag__expand-button:not(.boolean):focus-visible:not(.disabled):before{content:\"\";position:absolute;inset:-3px -1px -3px -3px;z-index:1;border:1px solid #1491eb;border-radius:4px 0 0 4px}.filter-tag__reset-button__icon{width:20px;height:20px;display:flex;align-items:center;fill:currentColor;margin:auto}.filter-tag__reset-button__icon svg{fill:currentColor;width:inherit;height:inherit}.filter-tag__reset-button__icon svg g{fill:currentColor;width:inherit;height:inherit}.filter-tag__reset-button__icon svg text{font-family:Siemens Sans,sans-serif}.selected .filter-tag__reset-button{border-left-color:#fff;width:36px;border-radius:0 4px 4px 0}.selected .filter-tag__reset-button.disabled{border-left-color:#fff}.selected .filter-tag__reset-button:hover:not(.disabled){border-left-color:#33747a}.selected .filter-tag__reset-button:focus-visible:not(.disabled){position:relative}.selected .filter-tag__reset-button:focus-visible:not(.disabled):before{content:\"\";position:absolute;inset:-3px -3px -3px -1px;z-index:1;border:1px solid #1491eb;border-radius:0 4px 4px 0}.filter-tag__expand-button:hover:not(.disabled)+.filter-tag__reset-button{border-left-color:#33747a}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i6.CdkTrapFocus, selector: "[cdkTrapFocus]", inputs: ["cdkTrapFocus", "cdkTrapFocusAutoCapture"], exportAs: ["cdkTrapFocus"] }, { kind: "directive", type: i1$1.AddTruncationAndTooltipDirective, selector: "[sieCoreAddTruncationAndTooltip]", inputs: ["maxNumberOfLinesToShow"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "directive", type: i10.CdkConnectedOverlay, selector: "[cdk-connected-overlay], [connected-overlay], [cdkConnectedOverlay]", inputs: ["cdkConnectedOverlayOrigin", "cdkConnectedOverlayPositions", "cdkConnectedOverlayPositionStrategy", "cdkConnectedOverlayOffsetX", "cdkConnectedOverlayOffsetY", "cdkConnectedOverlayWidth", "cdkConnectedOverlayHeight", "cdkConnectedOverlayMinWidth", "cdkConnectedOverlayMinHeight", "cdkConnectedOverlayBackdropClass", "cdkConnectedOverlayPanelClass", "cdkConnectedOverlayViewportMargin", "cdkConnectedOverlayScrollStrategy", "cdkConnectedOverlayOpen", "cdkConnectedOverlayDisableClose", "cdkConnectedOverlayTransformOriginOn", "cdkConnectedOverlayHasBackdrop", "cdkConnectedOverlayLockPosition", "cdkConnectedOverlayFlexibleDimensions", "cdkConnectedOverlayGrowAfterOpen", "cdkConnectedOverlayPush"], outputs: ["backdropClick", "positionChange", "attach", "detach", "overlayKeydown", "overlayOutsideClick"], exportAs: ["cdkConnectedOverlay"] }, { kind: "directive", type: i10.CdkOverlayOrigin, selector: "[cdk-overlay-origin], [overlay-origin], [cdkOverlayOrigin]", exportAs: ["cdkOverlayOrigin"] }, { kind: "component", type: UiDropdownMenuComponent, selector: "sie-ui-dropdown-menu", inputs: ["theme", "type", "menuPositionedBottom"] }, { kind: "component", type: UiDropdownOptionsComponent, selector: "sie-ui-dropdown-options", inputs: ["options", "theme", "selectionType", "selectedValues", "displayIconSpace", "type", "checkmarkDisabled", "open", "ariaLabel"], outputs: ["optionSelected", "optionDiscarded"] }], animations: [createDropdownAnimation()], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiFilterTagComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-filter-tag', changeDetection: ChangeDetectionStrategy.OnPush, animations: [createDropdownAnimation()], providers: [UiEventPropagationService], template: "<div class=\"filter-tag\" [class.selected]=\"selected\">\n  <div\n    class=\"filter-tag__button-wrapper\"\n    [class.disabled]=\"disabled\"\n    (focusin)=\"focusIn()\"\n    (focusout)=\"focusOut()\"\n    #dropDownRendering\n  >\n    <div\n      class=\"filter-tag__expand-button button\"\n      type=\"button\"\n      [attr.aria-haspopup]=\"selectionType === 'boolean' ? null : 'listbox'\"\n      [attr.tabindex]=\"disabled ? -1 : 0\"\n      (keydown.enter)=\"toggleDropDown()\"\n      (keydown.space)=\"toggleDropDown()\"\n      (keydown.arrowDown)=\"onArrowDownOnButton($event)\"\n      (keydown.escape)=\"handleEscape($event)\"\n      (keyup.escape)=\"eventPropagationService.handleEvent($event)\"\n      [ngClass]=\"{\n        disabled: disabled,\n        open: menuOpen && openOverlayOnClick,\n        dark: theme === 'dark',\n        light: theme === 'light',\n        boolean: selectionType === 'boolean',\n        'with-icon': icon\n      }\"\n      #dropDownElement\n      (click)=\"toggleDropDown()\"\n      cdkOverlayOrigin\n      #trigger=\"cdkOverlayOrigin\"\n    >\n      <sie-icon *ngIf=\"icon\" class=\"filter-tag__expand-button__custom-icon\" [name]=\"icon\" aria-hidden=\"true\"></sie-icon>\n      <div sieCoreAddTruncationAndTooltip class=\"selected-label\">\n        <span [innerText]=\"computedLabel\"></span>\n      </div>\n      <sie-icon\n        *ngIf=\"selectionType !== 'boolean' || selected\"\n        class=\"filter-tag__expand-button__icon\"\n        aria-hidden=\"true\"\n        [name]=\"selectionType === 'boolean' ? iconReg.sieIcon.CloseSmall : iconReg.sieIcon.Dropdown\"\n      ></sie-icon>\n    </div>\n    <button\n      *ngIf=\"selectionType !== 'boolean' && selected\"\n      class=\"filter-tag__reset-button button\"\n      [ngClass]=\"{ disabled: disabled }\"\n      [attr.tabindex]=\"disabled ? -1 : 0\"\n      (click)=\"resetSelection($event)\"\n      type=\"button\"\n    >\n      <span *ngIf=\"!!screenReader?.reset\" class=\"visually-hidden\">{{ screenReader.reset }}</span>\n      <sie-icon class=\"filter-tag__reset-button__icon\" [name]=\"iconReg.sieIcon.CloseSmall\"></sie-icon>\n    </button>\n  </div>\n  <ng-template\n    *ngIf=\"openOverlayOnClick\"\n    cdkConnectedOverlay\n    cdkConnectedOverlayHasBackdrop\n    cdkConnectedOverlayBackdropClass=\"cdk-overlay-transparent-backdrop\"\n    [cdkConnectedOverlayOrigin]=\"trigger\"\n    [cdkConnectedOverlayOpen]=\"menuOpen\"\n    (overlayKeydown)=\"optionsComponent.onArrowHandler($event)\"\n    (backdropClick)=\"menuOpen = false\"\n    [cdkConnectedOverlayMinHeight]=\"overlayPaneHeight\"\n  >\n    <sie-ui-dropdown-menu\n      cdkTrapFocus\n      class=\"filter-tag__dropdown-menu\"\n      [@openClose]=\"menuOpen\"\n      [theme]=\"theme\"\n      [ngClass]=\"theme\"\n      [style.width]=\"dropdownWidth + 'px'\"\n      [menuPositionedBottom]=\"menuPositionedBottom\"\n    >\n      <sie-ui-dropdown-options\n        content\n        [selectionType]=\"selectionType\"\n        [open]=\"menuOpen\"\n        [ariaLabel]=\"screenReader?.options\"\n        [options]=\"options\"\n        [theme]=\"theme\"\n        [ngClass]=\"theme\"\n        [selectedValues]=\"selectedValues\"\n        [displayIconSpace]=\"displayIconSpace\"\n        (optionDiscarded)=\"closeOverlay(true)\"\n        (optionSelected)=\"itemSelected($event)\"\n      ></sie-ui-dropdown-options>\n    </sie-ui-dropdown-menu>\n  </ng-template>\n</div>\n", styles: [".selected .filter-tag__reset-button:focus-visible:not(.disabled),.selected .filter-tag__expand-button:focus-visible:not(.boolean):not(.disabled),.button:focus-visible{outline:0}:host{display:block;max-width:328px}.button{padding:0;margin:0;background-color:initial;color:#007993;height:40px;border-radius:4px;display:flex;border:1px solid #007993}.button.disabled{color:#b3b3be;border-color:#b3b3be;cursor:not-allowed}.button:focus-visible{position:relative}.button:focus-visible:before{content:\"\";position:absolute;inset:-3px;z-index:1;border:1px solid #1491eb;border-radius:4px}.selected .button{color:#fff;background-color:#33747a;border-color:#33747a}.selected .button.disabled{color:#ebebee;background-color:#b3b3be;border-color:#b3b3be}.button:hover:not(.disabled){color:#33747a;background-color:#c2ffee;border-color:#33747a;cursor:pointer}.filter-tag__button-wrapper{display:flex;width:100%}.filter-tag__dropdown-menu{padding-top:4px}.filter-tag__expand-button{max-width:100%;padding:0 6px 0 12px;align-items:center}.filter-tag__expand-button.with-icon{padding-left:8px}.filter-tag__expand-button.boolean{padding-right:12px}.filter-tag__expand-button .selected-label{margin:auto 0;display:block}.filter-tag__expand-button__custom-icon{width:20px;height:20px;display:flex;align-items:center;fill:currentColor;margin-right:8px}.filter-tag__expand-button__custom-icon svg{fill:currentColor;width:inherit;height:inherit}.filter-tag__expand-button__custom-icon svg g{fill:currentColor;width:inherit;height:inherit}.filter-tag__expand-button__custom-icon svg text{font-family:Siemens Sans,sans-serif}.filter-tag__expand-button__icon{width:24px;height:24px;display:flex;align-items:center;fill:currentColor;margin:auto auto auto 8px}.filter-tag__expand-button__icon svg{fill:currentColor;width:inherit;height:inherit}.filter-tag__expand-button__icon svg g{fill:currentColor;width:inherit;height:inherit}.filter-tag__expand-button__icon svg text{font-family:Siemens Sans,sans-serif}.filter-tag__expand-button__icon svg{transition:transform .12s cubic-bezier(.4,0,.3,1)}.open .filter-tag__expand-button__icon svg{transform:translateZ(0) rotate(180deg)}.boolean .filter-tag__expand-button__icon{width:20px;height:20px;display:flex;align-items:center;fill:currentColor}.boolean .filter-tag__expand-button__icon svg{fill:currentColor;width:inherit;height:inherit}.boolean .filter-tag__expand-button__icon svg g{fill:currentColor;width:inherit;height:inherit}.boolean .filter-tag__expand-button__icon svg text{font-family:Siemens Sans,sans-serif}.selected .filter-tag__expand-button:not(.boolean){max-width:calc(100% - 36px);border-right:none;border-radius:4px 0 0 4px}.selected .filter-tag__expand-button:not(.boolean):focus-visible:not(.disabled){position:relative}.selected .filter-tag__expand-button:not(.boolean):focus-visible:not(.disabled):before{content:\"\";position:absolute;inset:-3px -1px -3px -3px;z-index:1;border:1px solid #1491eb;border-radius:4px 0 0 4px}.filter-tag__reset-button__icon{width:20px;height:20px;display:flex;align-items:center;fill:currentColor;margin:auto}.filter-tag__reset-button__icon svg{fill:currentColor;width:inherit;height:inherit}.filter-tag__reset-button__icon svg g{fill:currentColor;width:inherit;height:inherit}.filter-tag__reset-button__icon svg text{font-family:Siemens Sans,sans-serif}.selected .filter-tag__reset-button{border-left-color:#fff;width:36px;border-radius:0 4px 4px 0}.selected .filter-tag__reset-button.disabled{border-left-color:#fff}.selected .filter-tag__reset-button:hover:not(.disabled){border-left-color:#33747a}.selected .filter-tag__reset-button:focus-visible:not(.disabled){position:relative}.selected .filter-tag__reset-button:focus-visible:not(.disabled):before{content:\"\";position:absolute;inset:-3px -3px -3px -1px;z-index:1;border:1px solid #1491eb;border-radius:0 4px 4px 0}.filter-tag__expand-button:hover:not(.disabled)+.filter-tag__reset-button{border-left-color:#33747a}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.SieIconRegistryService }, { type: i0.ElementRef }, { type: i0.ChangeDetectorRef }, { type: i1$1.LayoutService }, { type: UiEventPropagationService }, { type: CdkOverlayService }]; }, propDecorators: { optionsComponent: [{
                type: ViewChild,
                args: [UiDropdownOptionsComponent]
            }], selectionType: [{
                type: Input
            }], placeholder: [{
                type: Input
            }], selectedPrefix: [{
                type: Input
            }], screenReader: [{
                type: Input
            }], options: [{
                type: Input
            }], selectedValues: [{
                type: Input
            }], openOverlayOnClick: [{
                type: Input
            }], icon: [{
                type: Input
            }], selectionChanged: [{
                type: Output
            }] } });

/**
 * # Filter Tag Module
 * - {@link UiFilterTagComponent}
 *
 * ## Module peer dependencies
 * - {@link SieIconsModule}
 */
class UiFilterTagModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiFilterTagModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiFilterTagModule, declarations: [UiFilterTagComponent], imports: [CommonModule,
            A11yModule,
            AddTruncationAndTooltipModule,
            SieIconsModule,
            OverlayModule,
            UiDropdownMenuModule,
            UiDropdownOptionsModule], exports: [UiFilterTagComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiFilterTagModule, imports: [CommonModule,
            A11yModule,
            AddTruncationAndTooltipModule,
            SieIconsModule,
            OverlayModule,
            UiDropdownMenuModule,
            UiDropdownOptionsModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiFilterTagModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiFilterTagComponent],
                    imports: [
                        CommonModule,
                        A11yModule,
                        AddTruncationAndTooltipModule,
                        SieIconsModule,
                        OverlayModule,
                        UiDropdownMenuModule,
                        UiDropdownOptionsModule
                    ],
                    exports: [UiFilterTagComponent]
                }]
        }] });

const CDK_OVERLAY_POSITIONS = [
    { originX: 'start', originY: 'bottom', overlayX: 'start', overlayY: 'top' }
];
/**
 * # People Picker Component
 * The people picker is used to allow selection of individuals for various processes or administrative tasks.
 *
 * ## Component variations
 *
 * The people picker component has no variations.
 *
 * ## Content
 * The people picker component does not accept any content.
 *
 * ## Code example
 * @example
 *  ```html
 * <sie-ui-people-picker
 *   label="Invite colleagues"
 *   placeholder="Name, email or company"
 *   loadingMessage="Fetching the options..."
 *   [loading]=false
 *   [emptyState]="emptyState"
 *   [people]="people"
 *   (personSelected)="onPersonSelection($event)"
 * ></sie-ui-people-picker>
 * ```
 *
 * ```ts
 * const emptyState: EmptyStateModel = {
 *   headline: 'No match found',
 *   text: "Sorry, we couldn't find any user with a matching search. Please check the search query and try again.",
 *   customIcon: SieIcon.SieportalEmptyStateJointControllerAgreementNotAllowed
 * };
 * const people: PeoplePickerPerson[] = [
 *   {
 *     id: '1',
 *     name: 'Anna Adams',
 *     initials: 'AA',
 *     email: 'anna.adams@companyname.com',
 *     company: 'Company name'
 *   },
 *   {
 *     id: '2',
 *     name: 'Herbie Hancock',
 *     initials: 'HH',
 *     email: 'herbie.hancock@companynameabc.com',
 *     company: 'Company name ABC'
 *   }
 * ];
 * ```
 */
class UiPeoplePickerComponent {
    /**
     * Defines whether filtering by name is possible
     * @default true
     */
    set filterByName(value) {
        this._filterByName = coerceBooleanProperty(value);
    }
    get filterByName() {
        return this._filterByName;
    }
    /**
     * Defines whether filtering by email is possible
     * @default true
     */
    set filterByEmail(value) {
        this._filterByEmail = coerceBooleanProperty(value);
    }
    get filterByEmail() {
        return this._filterByEmail;
    }
    /**
     * Defines whether filtering by company name is possible
     * @default true
     */
    set filterByCompany(value) {
        this._filterByCompany = coerceBooleanProperty(value);
    }
    get filterByCompany() {
        return this._filterByCompany;
    }
    /**
     * List of {@link UiPeoplePickerPerson possible items (persons)} to filter and select from
     * @default []
     */
    set people(value) {
        this.people$.next(value);
        this.selectionArray.set(value);
    }
    get people() {
        return this.people$.value;
    }
    /**
     * Sets disabled state of people picker component
     * @default false
     */
    set disabled(value) {
        this._disabled = coerceBooleanProperty(value);
    }
    get disabled() {
        return this._disabled;
    }
    /**
     * Defines whether overlay is currently opened
     */
    set overlayOpen(value) {
        this._overlayOpen = value;
        this.hasValueOrIsOverlayOpen = value || !!this.inputText;
    }
    get overlayOpen() {
        return this._overlayOpen;
    }
    /**
     * Specifies the currently entered input text
     */
    set inputText(value) {
        this.inputText$.next(value);
        this.inputValueChanged.next(value);
        this.hasValueOrIsOverlayOpen = !!value || this.overlayOpen;
        this.overlayOpen || this.openOverlay();
    }
    get inputText() {
        return this.inputText$.value;
    }
    constructor(elementRef, resizeDirective, iconRegistry, cdkOverlayService) {
        this.elementRef = elementRef;
        this.resizeDirective = resizeDirective;
        this.iconRegistry = iconRegistry;
        this.cdkOverlayService = cdkOverlayService;
        /** @ignore */
        this.id = getUniqueID('people-picker');
        /** @ignore */
        this.hasValueOrIsOverlayOpen = false;
        /**
         * Placeholder text shown in the input when user has not entered a value yet
         * @default ''
         */
        this.placeholder = '';
        /**
         * Displays loading state of people picker options if set to true
         * @default false
         */
        this.loading = false;
        /**
         * Defines the message shown when component is loading (e.g. fetching data from the API)
         */
        this.loadingMessage = '';
        /**
         * {@link UiPeoplePickerPerson Event} is triggered when an item (person) is selected by the user
         */
        this.personSelected = new EventEmitter();
        /**
         * Event triggered when the people picker overlay is opened
         */
        this.overlayOpened = new EventEmitter();
        /**
         * Event triggered when the people picker input value is changed
         */
        this.inputValueChanged = new EventEmitter();
        /**
         * Event triggered when the people picker empty state action button is clicked
         */
        this.emptyStateButtonClicked = new EventEmitter();
        this._overlayOpen = false;
        this.people$ = new BehaviorSubject([]);
        this.inputText$ = new BehaviorSubject('');
        /** @ignore */
        this.positions = CDK_OVERLAY_POSITIONS;
        /** @ignore */
        this.filteredPeople$ = combineLatest([this.people$, this.inputText$]).pipe(map$1(([people, inputText]) => {
            if (!inputText?.trim()) {
                return people;
            }
            const filterKeys = this.getFilterKeys();
            const filteredAndSorted = people
                ?.filter(person => searchInObject(inputText, person, filterKeys))
                .sort((a, b) => this.sortOptions(a, b, filterKeys));
            this.selectionArray.set(filteredAndSorted);
            return filteredAndSorted;
        }));
        /** @ignore */
        this.selectionArray = new CircularArray();
        this._filterByName = true;
        this._filterByEmail = true;
        this._filterByCompany = true;
        this._disabled = false;
        iconRegistry.register(SieIcon.UserAccount);
    }
    /** @ignore */
    selectPerson(person) {
        this.personSelected.emit(person);
        this.inputText = '';
        this.overlayOpen = false;
    }
    /** @ignore */
    backdropClicked() {
        this.overlayOpen = false;
    }
    /** @ignore */
    openOverlay() {
        if (this.disabled) {
            return;
        }
        this.selectionArray.reset();
        this.overlayOpen = true;
        requestAnimationFrame(() => {
            this.cdkOverlayService.addOverlayOnTopModifier();
        });
    }
    /** @ignore */
    closeOverlay() {
        this.selectionArray.reset();
        this.overlayOpen = false;
    }
    /** @ignore */
    onInputFocused() {
        this.openOverlay();
        this.overlayOpened.next();
    }
    /** @ignore */
    handleKey(e) {
        if (e.key === KeyboardKey.ArrowUp) {
            e.preventDefault();
            this.focusElement(this.selectionArray.previousIndex());
        }
        else if (e.key === KeyboardKey.ArrowDown) {
            e.preventDefault();
            this.focusElement(this.selectionArray.nextIndex());
        }
        else if (e.key === KeyboardKey.Escape) {
            e.preventDefault();
            this.input.nativeElement.focus();
            this.selectionArray.reset();
        }
        else if (e.key === KeyboardKey.Tab) {
            this.input.nativeElement.focus();
            this.closeOverlay();
        }
        else {
            return;
        }
    }
    focusElement(index) {
        this.buttons.toArray()[index].nativeElement.focus();
    }
    sortOptions(a, b, filterKeys) {
        const value = this.inputText.toLowerCase();
        if (value && Object.keys(a).some(k => a[k].toLowerCase().startsWith(value))) {
            return -1;
        }
        else if (value && Object.keys(b).some(k => b[k].toLowerCase().startsWith(value))) {
            return 1;
        }
        else {
            return a[filterKeys[0]].localeCompare(b[filterKeys[0]]);
        }
    }
    getFilterKeys() {
        const keys = [];
        if (this.filterByName) {
            keys.push('name');
        }
        if (this.filterByEmail) {
            keys.push('email');
        }
        if (this.filterByCompany) {
            keys.push('company');
        }
        return keys;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiPeoplePickerComponent, deps: [{ token: i0.ElementRef }, { token: i1$1.ElementResizeDirective }, { token: i1.SieIconRegistryService }, { token: CdkOverlayService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.9", type: UiPeoplePickerComponent, selector: "sie-ui-people-picker", inputs: { label: "label", placeholder: "placeholder", emptyState: "emptyState", loading: "loading", loadingMessage: "loadingMessage", filterByName: "filterByName", filterByEmail: "filterByEmail", filterByCompany: "filterByCompany", people: "people", disabled: "disabled" }, outputs: { personSelected: "personSelected", overlayOpened: "overlayOpened", inputValueChanged: "inputValueChanged", emptyStateButtonClicked: "emptyStateButtonClicked" }, host: { properties: { "class.has-value": "this.hasValueOrIsOverlayOpen" } }, viewQueries: [{ propertyName: "input", first: true, predicate: ["input"], descendants: true }, { propertyName: "buttons", predicate: ["personButton"], descendants: true }], hostDirectives: [{ directive: i1$1.ElementResizeDirective }], ngImport: i0, template: "<label class=\"people-picker__label\" [for]=\"id\" sieCoreAddTruncationAndTooltip>{{ label }}</label\n><input\n  [id]=\"id\"\n  type=\"text\"\n  class=\"people-picker__input\"\n  [(ngModel)]=\"inputText\"\n  [placeholder]=\"placeholder\"\n  [disabled]=\"disabled\"\n  (focus)=\"onInputFocused()\"\n  #input\n/>\n<sie-icon class=\"people-picker__icon\" [name]=\"iconRegistry.sieIcon.UserAccount\"></sie-icon>\n\n<ng-template\n  cdkConnectedOverlay\n  [cdkConnectedOverlayHasBackdrop]=\"true\"\n  cdkConnectedOverlayBackdropClass=\"cdk-overlay-transparent-backdrop\"\n  [cdkConnectedOverlayOrigin]=\"elementRef\"\n  [cdkConnectedOverlayOpen]=\"overlayOpen\"\n  (backdropClick)=\"closeOverlay()\"\n  (detach)=\"closeOverlay()\"\n  (overlayKeydown)=\"handleKey($event)\"\n>\n  <sie-ui-dropdown-menu class=\"menu\" cdkTrapFocus [ngStyle]=\"{ width: resizeDirective.widthPx | async }\">\n    <div content class=\"menu__content\">\n      <ng-container *ngIf=\"!loading; else loadingSpinner\">\n        <ul *ngIf=\"!!(filteredPeople$ | async)?.length; else emptyStateRef\" class=\"people-list\" role=\"listbox\">\n          <li *ngFor=\"let person of filteredPeople$ | async; let i = index\" class=\"people-list__person\" role=\"option\">\n            <button\n              class=\"person-select-button\"\n              [attr.data-index]=\"i\"\n              (click)=\"selectPerson(person)\"\n              (mouseover)=\"selectionArray.select(i); personButton.focus()\"\n              #personButton\n            >\n              <sie-ui-account-identifier\n                size=\"m\"\n                variant=\"name-primary-secondary\"\n                [name]=\"person.name\"\n                [initials]=\"person.initials\"\n                [primaryMetaData]=\"person.email\"\n                [secondaryMetaData]=\"person.company\"\n                [forHashing]=\"'name'\"\n              ></sie-ui-account-identifier>\n            </button>\n          </li>\n        </ul>\n      </ng-container>\n    </div>\n  </sie-ui-dropdown-menu>\n</ng-template>\n\n<ng-template #loadingSpinner>\n  <div class=\"loading-spinner\">\n    <sie-ui-spinner [message]=\"loadingMessage\" active></sie-ui-spinner>\n  </div>\n</ng-template>\n\n<ng-template #emptyStateRef>\n  <sie-ui-empty-state\n    class=\"empty-state\"\n    [ngClass]=\"['empty-state--icon-' + emptyState.iconPosition]\"\n    [ngStyle]=\"{ width: (resizeDirective.width | async) - 2 + 'px' }\"\n    [iconPosition]=\"emptyState.iconPosition\"\n    [customIcon]=\"emptyState.customIcon\"\n    [headline]=\"emptyState.headline\"\n    [text]=\"emptyState.text\"\n    [button]=\"emptyState.button\"\n    (buttonClicked)=\"emptyStateButtonClicked.next()\"\n  ></sie-ui-empty-state>\n</ng-template>\n", styles: [".people-picker__label{position:absolute;top:0;display:block;min-height:55px;width:calc(100% - 16px);padding:14px 56px 17px 0;transition:all .15s,color 0ms,background-color 0ms;background-color:#ebf7f8}.people-picker__input{font-size:1rem;font-weight:400;line-height:1.5rem;flex:1;height:1.5rem;outline:none;border:0;padding:0 40px 0 0;background-color:transparent;font-family:Siemens Sans;color:#000028}.people-picker__icon{color:#4c4c68;fill:#4c4c68;position:absolute;right:16px;top:50%;transform:translateY(-50%);pointer-events:none}:host{position:relative;display:flex;flex-wrap:wrap;gap:8px;min-height:56px;min-width:328px;background-color:#ebf7f8;border-bottom-width:1px;border-bottom-style:solid;border-bottom-color:#9999a9;padding:21px 16px 9px;color:#4c4c68;overflow:hidden}:host.has-value,:host:focus-within,:host:hover{background-color:#d1fff2;cursor:pointer;border-bottom-color:#00d7a0}:host.has-value .people-picker__label,:host:focus-within .people-picker__label,:host:hover .people-picker__label{background-color:#d1fff2;cursor:pointer}:host.has-value .people-picker__icon,:host:focus-within .people-picker__icon,:host:hover .people-picker__icon{color:#000028;fill:#000028}:host.has-value .people-picker__label,:host:focus-within .people-picker__label{font-size:.75rem;font-weight:400;line-height:1rem;min-height:unset;padding-top:6px;padding-bottom:0;background-color:#d1fff2}.menu{width:100%;max-height:440px;--ui-dropdown-menu-padding: 10px 0}.menu ::-webkit-scrollbar-thumb{background-clip:padding-box;background-color:#737389}.menu ::-webkit-scrollbar-button{display:none}.menu ::-webkit-scrollbar-corner{background-color:transparent}.menu ::-webkit-scrollbar{width:16px;height:8px}:host{scrollbar-color:#737389 #fff}:host .dark,:host.dark{scrollbar-color:#ccccd4 #001f39}.menu ::-webkit-scrollbar-thumb:vertical{border-left:8px solid transparent;border-right:4px solid transparent}.menu ::-webkit-scrollbar-thumb:horizontal{border-top:4px solid transparent}.menu ::-webkit-scrollbar-track:vertical{border-left:8px solid #fff;background:#ccccd4;border-right:4px solid #fff}.menu ::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #ccccd4}.menu .dark::-webkit-scrollbar-thumb,.menu .dark ::-webkit-scrollbar-thumb{background-color:#ccccd4}.menu .dark::-webkit-scrollbar-track:vertical,.menu .dark ::-webkit-scrollbar-track:vertical{background:#737389;border-right:4px solid #001f39;border-left:8px solid #001f39}.menu .dark::-webkit-scrollbar-track:horizontal,.menu .dark ::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #737389}.menu__content{overflow-y:auto;max-height:100%}.people-list{list-style:none;margin:0;padding:0}.person-select-button{display:block;width:100%;border:0;background-color:transparent;padding:13px 16px 8px;text-align:left}.person-select-button:focus,.person-select-button:hover{background-color:#62eec7;cursor:pointer;outline:none}.empty-state{margin:64px auto 70px}.empty-state--icon-onTop{margin:14px auto 30px}.loading-spinner{display:flex;justify-content:center;margin:166px auto}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "directive", type: i3.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i3.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i3.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "directive", type: i6.CdkTrapFocus, selector: "[cdkTrapFocus]", inputs: ["cdkTrapFocus", "cdkTrapFocusAutoCapture"], exportAs: ["cdkTrapFocus"] }, { kind: "directive", type: i10.CdkConnectedOverlay, selector: "[cdk-connected-overlay], [connected-overlay], [cdkConnectedOverlay]", inputs: ["cdkConnectedOverlayOrigin", "cdkConnectedOverlayPositions", "cdkConnectedOverlayPositionStrategy", "cdkConnectedOverlayOffsetX", "cdkConnectedOverlayOffsetY", "cdkConnectedOverlayWidth", "cdkConnectedOverlayHeight", "cdkConnectedOverlayMinWidth", "cdkConnectedOverlayMinHeight", "cdkConnectedOverlayBackdropClass", "cdkConnectedOverlayPanelClass", "cdkConnectedOverlayViewportMargin", "cdkConnectedOverlayScrollStrategy", "cdkConnectedOverlayOpen", "cdkConnectedOverlayDisableClose", "cdkConnectedOverlayTransformOriginOn", "cdkConnectedOverlayHasBackdrop", "cdkConnectedOverlayLockPosition", "cdkConnectedOverlayFlexibleDimensions", "cdkConnectedOverlayGrowAfterOpen", "cdkConnectedOverlayPush"], outputs: ["backdropClick", "positionChange", "attach", "detach", "overlayKeydown", "overlayOutsideClick"], exportAs: ["cdkConnectedOverlay"] }, { kind: "component", type: UiDropdownMenuComponent, selector: "sie-ui-dropdown-menu", inputs: ["theme", "type", "menuPositionedBottom"] }, { kind: "component", type: UiAccountIdentifierComponent, selector: "sie-ui-account-identifier", inputs: ["size", "mode", "variant", "status", "name", "initials", "primaryMetaData", "secondaryMetaData", "linkText", "greetings", "searchHighlight", "avatarImage", "badgeData", "networkIcon", "forHashing", "disabled", "interactable"], outputs: ["actionLinkClicked"] }, { kind: "component", type: UiEmptyStateComponent, selector: "sie-ui-empty-state", inputs: ["theme", "headline", "text", "link", "button", "iconPosition", "padding", "customIcon"], outputs: ["buttonClicked"] }, { kind: "component", type: i1.SieIconsComponent, selector: "sie-icon", inputs: ["name", "svgClass", "inheritSize"], outputs: ["iconChanged"] }, { kind: "directive", type: i1$1.AddTruncationAndTooltipDirective, selector: "[sieCoreAddTruncationAndTooltip]", inputs: ["maxNumberOfLinesToShow"] }, { kind: "component", type: UiSpinnerComponent, selector: "sie-ui-spinner", inputs: ["size", "message", "overlayOnTop", "overlay", "active"], outputs: ["animationEnded"] }, { kind: "pipe", type: i2.AsyncPipe, name: "async" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiPeoplePickerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sie-ui-people-picker', changeDetection: ChangeDetectionStrategy.OnPush, hostDirectives: [
                        {
                            directive: ElementResizeDirective
                        }
                    ], template: "<label class=\"people-picker__label\" [for]=\"id\" sieCoreAddTruncationAndTooltip>{{ label }}</label\n><input\n  [id]=\"id\"\n  type=\"text\"\n  class=\"people-picker__input\"\n  [(ngModel)]=\"inputText\"\n  [placeholder]=\"placeholder\"\n  [disabled]=\"disabled\"\n  (focus)=\"onInputFocused()\"\n  #input\n/>\n<sie-icon class=\"people-picker__icon\" [name]=\"iconRegistry.sieIcon.UserAccount\"></sie-icon>\n\n<ng-template\n  cdkConnectedOverlay\n  [cdkConnectedOverlayHasBackdrop]=\"true\"\n  cdkConnectedOverlayBackdropClass=\"cdk-overlay-transparent-backdrop\"\n  [cdkConnectedOverlayOrigin]=\"elementRef\"\n  [cdkConnectedOverlayOpen]=\"overlayOpen\"\n  (backdropClick)=\"closeOverlay()\"\n  (detach)=\"closeOverlay()\"\n  (overlayKeydown)=\"handleKey($event)\"\n>\n  <sie-ui-dropdown-menu class=\"menu\" cdkTrapFocus [ngStyle]=\"{ width: resizeDirective.widthPx | async }\">\n    <div content class=\"menu__content\">\n      <ng-container *ngIf=\"!loading; else loadingSpinner\">\n        <ul *ngIf=\"!!(filteredPeople$ | async)?.length; else emptyStateRef\" class=\"people-list\" role=\"listbox\">\n          <li *ngFor=\"let person of filteredPeople$ | async; let i = index\" class=\"people-list__person\" role=\"option\">\n            <button\n              class=\"person-select-button\"\n              [attr.data-index]=\"i\"\n              (click)=\"selectPerson(person)\"\n              (mouseover)=\"selectionArray.select(i); personButton.focus()\"\n              #personButton\n            >\n              <sie-ui-account-identifier\n                size=\"m\"\n                variant=\"name-primary-secondary\"\n                [name]=\"person.name\"\n                [initials]=\"person.initials\"\n                [primaryMetaData]=\"person.email\"\n                [secondaryMetaData]=\"person.company\"\n                [forHashing]=\"'name'\"\n              ></sie-ui-account-identifier>\n            </button>\n          </li>\n        </ul>\n      </ng-container>\n    </div>\n  </sie-ui-dropdown-menu>\n</ng-template>\n\n<ng-template #loadingSpinner>\n  <div class=\"loading-spinner\">\n    <sie-ui-spinner [message]=\"loadingMessage\" active></sie-ui-spinner>\n  </div>\n</ng-template>\n\n<ng-template #emptyStateRef>\n  <sie-ui-empty-state\n    class=\"empty-state\"\n    [ngClass]=\"['empty-state--icon-' + emptyState.iconPosition]\"\n    [ngStyle]=\"{ width: (resizeDirective.width | async) - 2 + 'px' }\"\n    [iconPosition]=\"emptyState.iconPosition\"\n    [customIcon]=\"emptyState.customIcon\"\n    [headline]=\"emptyState.headline\"\n    [text]=\"emptyState.text\"\n    [button]=\"emptyState.button\"\n    (buttonClicked)=\"emptyStateButtonClicked.next()\"\n  ></sie-ui-empty-state>\n</ng-template>\n", styles: [".people-picker__label{position:absolute;top:0;display:block;min-height:55px;width:calc(100% - 16px);padding:14px 56px 17px 0;transition:all .15s,color 0ms,background-color 0ms;background-color:#ebf7f8}.people-picker__input{font-size:1rem;font-weight:400;line-height:1.5rem;flex:1;height:1.5rem;outline:none;border:0;padding:0 40px 0 0;background-color:transparent;font-family:Siemens Sans;color:#000028}.people-picker__icon{color:#4c4c68;fill:#4c4c68;position:absolute;right:16px;top:50%;transform:translateY(-50%);pointer-events:none}:host{position:relative;display:flex;flex-wrap:wrap;gap:8px;min-height:56px;min-width:328px;background-color:#ebf7f8;border-bottom-width:1px;border-bottom-style:solid;border-bottom-color:#9999a9;padding:21px 16px 9px;color:#4c4c68;overflow:hidden}:host.has-value,:host:focus-within,:host:hover{background-color:#d1fff2;cursor:pointer;border-bottom-color:#00d7a0}:host.has-value .people-picker__label,:host:focus-within .people-picker__label,:host:hover .people-picker__label{background-color:#d1fff2;cursor:pointer}:host.has-value .people-picker__icon,:host:focus-within .people-picker__icon,:host:hover .people-picker__icon{color:#000028;fill:#000028}:host.has-value .people-picker__label,:host:focus-within .people-picker__label{font-size:.75rem;font-weight:400;line-height:1rem;min-height:unset;padding-top:6px;padding-bottom:0;background-color:#d1fff2}.menu{width:100%;max-height:440px;--ui-dropdown-menu-padding: 10px 0}.menu ::-webkit-scrollbar-thumb{background-clip:padding-box;background-color:#737389}.menu ::-webkit-scrollbar-button{display:none}.menu ::-webkit-scrollbar-corner{background-color:transparent}.menu ::-webkit-scrollbar{width:16px;height:8px}:host{scrollbar-color:#737389 #fff}:host .dark,:host.dark{scrollbar-color:#ccccd4 #001f39}.menu ::-webkit-scrollbar-thumb:vertical{border-left:8px solid transparent;border-right:4px solid transparent}.menu ::-webkit-scrollbar-thumb:horizontal{border-top:4px solid transparent}.menu ::-webkit-scrollbar-track:vertical{border-left:8px solid #fff;background:#ccccd4;border-right:4px solid #fff}.menu ::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #ccccd4}.menu .dark::-webkit-scrollbar-thumb,.menu .dark ::-webkit-scrollbar-thumb{background-color:#ccccd4}.menu .dark::-webkit-scrollbar-track:vertical,.menu .dark ::-webkit-scrollbar-track:vertical{background:#737389;border-right:4px solid #001f39;border-left:8px solid #001f39}.menu .dark::-webkit-scrollbar-track:horizontal,.menu .dark ::-webkit-scrollbar-track:horizontal{border-bottom:4px solid #737389}.menu__content{overflow-y:auto;max-height:100%}.people-list{list-style:none;margin:0;padding:0}.person-select-button{display:block;width:100%;border:0;background-color:transparent;padding:13px 16px 8px;text-align:left}.person-select-button:focus,.person-select-button:hover{background-color:#62eec7;cursor:pointer;outline:none}.empty-state{margin:64px auto 70px}.empty-state--icon-onTop{margin:14px auto 30px}.loading-spinner{display:flex;justify-content:center;margin:166px auto}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: i1$1.ElementResizeDirective }, { type: i1.SieIconRegistryService }, { type: CdkOverlayService }]; }, propDecorators: { hasValueOrIsOverlayOpen: [{
                type: HostBinding,
                args: ['class.has-value']
            }], buttons: [{
                type: ViewChildren,
                args: ['personButton']
            }], input: [{
                type: ViewChild,
                args: ['input']
            }], label: [{
                type: Input
            }], placeholder: [{
                type: Input
            }], emptyState: [{
                type: Input
            }], loading: [{
                type: Input
            }], loadingMessage: [{
                type: Input
            }], filterByName: [{
                type: Input
            }], filterByEmail: [{
                type: Input
            }], filterByCompany: [{
                type: Input
            }], people: [{
                type: Input
            }], disabled: [{
                type: Input
            }], personSelected: [{
                type: Output
            }], overlayOpened: [{
                type: Output
            }], inputValueChanged: [{
                type: Output
            }], emptyStateButtonClicked: [{
                type: Output
            }] } });

/**
 * # PeoplePicker Module
 * - {@link UiPeoplePickerComponent}
 *
 * ## Module peer dependencies
 * Requires the following to work properly:
 * - {@link SieIconsModule}
 */
class UiPeoplePickerModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiPeoplePickerModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.9", ngImport: i0, type: UiPeoplePickerModule, declarations: [UiPeoplePickerComponent], imports: [CommonModule,
            FormsModule,
            A11yModule,
            CdkConnectedOverlay,
            UiDropdownMenuModule,
            CdkOverlayOrigin,
            ElementResizeDirective,
            UiAccountIdentifierModule,
            UiEmptyStateModule,
            SieIconsModule,
            AddTruncationAndTooltipModule,
            UiSpinnerModule], exports: [UiPeoplePickerComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiPeoplePickerModule, imports: [CommonModule,
            FormsModule,
            A11yModule,
            UiDropdownMenuModule,
            UiAccountIdentifierModule,
            UiEmptyStateModule,
            SieIconsModule,
            AddTruncationAndTooltipModule,
            UiSpinnerModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.9", ngImport: i0, type: UiPeoplePickerModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UiPeoplePickerComponent],
                    imports: [
                        CommonModule,
                        FormsModule,
                        A11yModule,
                        CdkConnectedOverlay,
                        UiDropdownMenuModule,
                        CdkOverlayOrigin,
                        ElementResizeDirective,
                        UiAccountIdentifierModule,
                        UiEmptyStateModule,
                        SieIconsModule,
                        AddTruncationAndTooltipModule,
                        UiSpinnerModule
                    ],
                    exports: [UiPeoplePickerComponent]
                }]
        }] });

/*
 * Public API Surface of sie-ui
 */

/**
 * Generated bundle index. Do not edit.
 */

export { CANCEL_BUTTON_ID$1 as CANCEL_BUTTON_ID, CdkOverlayService, DEFAULT_DROP_ZONE, DEFAULT_DROP_ZONE_TYPES, DEFAULT_REPLY_FORM, FILE_BODY_BASE64_SEPARATOR, FILE_EXTENSION_SEPARATOR, FORM_COMPONENT_ACCESSOR, InputValidity$1 as InputValidity, MODAL_HEADLINE_ICON_MAPPING, MSG_BOX_GRADIENT_COLOR, MSG_BOX_ICON_MAPPING, MSG_BOX_TRUNCATION_LINES, MockFilterDataService, MockTreeListService, OK_BUTTON_ID, PROGRESS_SPINNER_DEFAULT_STROKE, PROGRESS_SPINNER_MAX_PERCENTAGE, PROGRESS_SPINNER_SIZE, PROGRESS_SPINNER_STROKE_SIZE, PointerDeviceService, RICH_SNIPPET_PRIMARY_META_TRUNCATION_LINES, RICH_SNIPPET_PRIMARY_META_TRUNCATION_LINES_DEFAULT, RunInZone, RunInZoneModule, SIDE_PANEL_CLASS, SIDE_PANEL_L, SIDE_PANEL_XL, SINGLE_FILE_DROP_ZONE, SieUiModule, StatusBar, UIConstants, UI_BASE_LIST_CONTEXT_MENU_SERVICE, UI_BUTTON_WRAPPER_EXTENSIONS, UI_MODAL_COMPONENT_SERVICE, UI_TOAST_ANIMATIONS, UiAccordionComponent, UiAccordionItemComponent, UiAccordionItemDirective, UiAccordionItemHeaderDirective, UiAccordionModule, UiAccountIdentifierComponent, UiAccountIdentifierModule, UiActionBarComponent, UiActionBarModule, UiAdTeaserComponent, UiAddToCartComponent, UiAddToCartModule, UiBadgeComponent, UiBadgeModule, UiBarChartComponent, UiBarChartModule, UiBenefitsComponent, UiBenefitsModule, UiBreadcrumbComponent, UiBreadcrumbModule, UiButtonComponent, UiButtonComponentRouterDirective, UiButtonGroupComponent, UiButtonGroupModule, UiButtonModule, UiButtonTypes, UiButtonWrapperComponent, UiBypassLinkComponent, UiBypassLinkModule, UiCardLandscapeComponent, UiCardLandscapeModule, UiCardPortraitComponent, UiCardPortraitModule, UiCardsArrangementComponent, UiCardsArrangementModule, UiCardsContainerComponent, UiCardsContainerModule, UiCarouselComponent, UiCarouselModule, UiCarouselSlideDirective, UiCarouselWebComponent, UiCatalogCategoryListItemComponent, UiCatalogDocumentListItemComponent, UiCatalogServicesListItemComponent, UiChartLegendComponent, UiChartLegendModule, UiChatBubbleComponent, UiChatBubbleModule, UiCheckboxComponent, UiCheckboxGroupComponent, UiCheckboxModule, UiCheckboxMultiOptionComponent, UiColorHashService, UiComboboxComponent, UiComboboxModule, UiComplexDropdownComponent, UiComplexDropdownModule, UiConfirmationModalComponent, UiConfirmationModalModule, UiContactComponent, UiContactModule, UiDatePickerComponent, UiDatePickerModule, UiDateRangePickerComponent, UiDateRangePickerModule, UiDonutChartComponent, UiDonutChartModule, UiDotPaginationComponent, UiDrawerComponent, UiDrawerModule, UiDropZoneComponent, UiDropZoneModule, UiDropZoneStatus, UiDropdownComponent, UiDropdownMenuComponent, UiDropdownMenuModule, UiDropdownModule, UiEmptyStateComponent, UiEmptyStateModule, UiEventPropagationService, UiExpandButtonComponent, UiExpandableComponent, UiExpandableModule, UiExternalHtmlComponent, UiExternalHtmlModule, UiFeedbackFormComponent, UiFeedbackFormModule, UiFilterHeaderComponent, UiFilterHeaderModule, UiFilterTagComponent, UiFilterTagModule, UiFloatingActionsComponent, UiFloatingActionsModule, UiFormModalComponent, UiFormModalModule, UiForumListItemComponent, UiForumListItemSkeletonComponent, UiGlobalModalHandlingEventService, UiHeaderComponent, UiHeaderModule, UiIconListItemComponent, UiInfinitePaginationComponent, UiInfinitePaginationModule, UiInfoBoxComponent, UiInfoBoxModule, UiInlineSearchComponent, UiInlineSearchModule, UiInterstitialComponent, UiInterstitialModule, UiLabelBadgeComponent, UiLabelBadgeModule, UiLanguageChangeModalComponent, UiLanguageChangeModalModule, UiLanguageSelectorComponent, UiLanguageSelectorModule, UiLanguageSelectorService, UiLinkComponent, UiLinkComponentRouterDirective, UiLinkListComponent, UiLinkListModule, UiLinkModule, UiListComponent, UiListItemDirective, UiListModule, UiListNavigatorComponent, UiListNavigatorHeaderComponent, UiListNavigatorHeaderModule, UiListNavigatorModule, UiLoadingComponent, UiLoadingModule, UiMenuButtonComponent, UiMenuButtonModule, UiMessageBoxComponent, UiMessageBoxModule, UiModalButtonComponent, UiModalButtonModule, UiModalComponent, UiModalComponentElementService, UiModalComponentNgService, UiModalModule, UiModalService, UiNestedListComponent, UiNestedListComponentRouterDirective, UiNestedListModule, UiNumericInputComponent, UiNumericInputModule, UiNumericInputValidityChange, UiOnPageBreadcrumbComponent, UiOnPageBreadcrumbComponentRouterDirective, UiOnPageBreadcrumbModule, UiOverflowButtonComponent, UiOverflowButtonModule, UiOverflowComponent, UiOverflowModule, UiPaginationComponent, UiPaginationModule, UiPasswordInputComponent, UiPasswordInputModule, UiPeopleListModule, UiPeoplePickerComponent, UiPeoplePickerModule, UiPictureComponent, UiPictureModule, UiPopoverComponent, UiPopoverDirective, UiPopoverModule, UiProductRecommendationComponent, UiProductRecommendationModule, UiProfileMenuComponent, UiProfileMenuModule, UiProgressSpinnerComponent, UiProgressSpinnerModule, UiProgressTrackerComponent, UiProgressTrackerModule, UiPromotionAlertComponent, UiPromotionAlertModule, UiPromotionExpandableComponent, UiPromotionExpandableModule, UiRadioButtonComponent, UiRadioButtonGroupComponent, UiRadioButtonGroupModule, UiRadioButtonModule, UiRatingStarsComponent, UiRatingStarsModule, UiReadonlyComponent, UiReadonlyModule, UiReplyFormComponent, UiReplyFormModule, UiReplyFormStatus, UiRichSnippetComponent, UiRichSnippetModule, UiRichtextComponent, UiRichtextModule, UiRouteButtonComponent, UiRouteButtonModule, UiRoutingDirectivesModule, UiSaasLandingPageLayoutComponent, UiSaasLandingPageLayoutModule, UiSeparatorListItemComponent, UiServicesListItemComponent, UiSidePanelWrapperComponent, UiSidePanelWrapperModule, UiSkeletonComponent, UiSkeletonModule, UiSpinnerComponent, UiSpinnerModule, UiSpinnerSize, UiStatusBarComponent, UiStatusBarModule, UiStatusComponent, UiStatusModule, UiStatusVariantEnum, UiSupportSearchComboboxComponent, UiSupportSearchComboboxModule, UiSwitchButtonGroupComponent, UiSwitchButtonGroupModule, UiTabDirective, UiTableBuilder, UiTableCell, UiTableComponent, UiTableModule, UiTableRow, UiTableSection, UiTabsContainerComponent, UiTabsControlsComponent, UiTabsModule, UiTagComponent, UiTagModule, UiTeaserComponent, UiTeaserModule, UiTextInputComponent, UiTextInputModule, UiTextareaComponent, UiTextareaModule, UiThermometerComponent, UiThumbnailComponent, UiThumbnailModule, UiThumbnailStatus, UiThumbnailType, UiTileButtonGroupComponent, UiTileButtonGroupModule, UiToastAnimationTarget, UiToastAnimationType, UiToastComponent, UiToastEntranceAnimation, UiToastExitAnimation, UiToastListComponent, UiToastListModule, UiToastModule, UiToggleButtonComponent, UiToggleButtonModule, UiTreeListComponent, UiTreeListModule, UiTreeListService, UiTreeNavigationComponent, UiTreeNavigationModule, UiUnderlineTooltipComponent, UiUnderlineTooltipModule, UiVerticalProgressTrackerComponent, UiVerticalProgressTrackerItemDirective, UiVerticalProgressTrackerModule, UiVideoModalComponent, UiVideoModalModule, UiVideoPlayerComponent, UiVideoPlayerModule, UiWizardComponent, UiWizardModule, UiWizardStepDirective, createDropdownAnimation, expand, fadeInFadeOutAnimation, toggleItemAnimation };
//# sourceMappingURL=siemens-ui.mjs.map
